--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2017/11/22
-- author 
-- brief  ش
--]]
local util 		= require("wnd.core.util")
local b_ui 		= require("wnd.core.b_ui")
local b_wnd 	= require("wnd.core.b_wnd")
local r_str 	= require("wnd.core.r_res.r_str")
local r_color	= require("wnd.core.r_res.r_color")
local r_font	= require("wnd.core.r_res.r_font")
local r_size	= require("wnd.core.r_res.r_size")
local r_img 	= require("wnd.core.r_res.r_img")
local r_t_img 	= require("wnd.core.r_res.r_t_img")
local STR 		= r_str.get_str
local COLOR 	= r_color.get_color
local IMG 		= r_img.get_img
local T_IMG 	= r_t_img.get_img
local FONT 		= r_font.get_fontsize
local SIZE 	= r_size.get_size

local to_number = function(n)
	if type(n) ~= 'number' then
		return nil
	end
	
	return n
end

local to_rect = function(rect)
	if not util.is_array(rect) then
		return nil, nil, nil, nil
	end

	if #rect < 4 then
		return nil, nil, nil, nil
	end

	-- x, y, w, h
	return rect[1], rect[2], rect[3], rect[4]
end

local mk_param = function(body)
	-- ֻtableһ, Ҳ÷ʽ
	-- ų t, id, xywh Щ
	local param = {}
	
	for k, v in pairs(body) do
		if (type(k) == 'string') and
			('t' ~= k) and
			('id' ~= k) and
			('xywh' ~= k) then
			if('text' == k) then
				if(body.trans~= nil and (body.trans == false) ) then --ʹܷ	
					param[k] = v
				else
					param[k] = STR(v)
				end		
--[[			elseif('texts' == k) then
				if(body.trans~= nil and (body.trans == false) ) then --ʹܷ	
					for i=1, #v do
						param[k] = v[i]
					end	
				else
					param[k] = {}
					for i=1, #v do
						param[k][i] = STR(v[i])
					end	
				end	--]]
			elseif('tip' == k) then
				if(body.trans~= nil and (body.trans == false) ) then --ʹܷ	
					param[k] = v
				else
					param[k] = STR(v)
				end		
			elseif('items' == k) then
				if(body.trans~= nil and (body.trans == false) ) then --ʹܷ			
					param[k] = v
				else
					local trans_v = {}		
					for i=1,#v do
						trans_v[i] = STR(v[i])
					end
					param[k] = trans_v
				end
			elseif('color' == k or 'color_f' == k or 'color_d' == k or 'color_c' == k or 'b_color' == k) then --ɫת
				assert(type(v) == 'table')
				assert(type(v[1]) == 'string' and type(v[2]) == 'string' and type(v[3]) == 'string')
				local color_v = {}		
				for i=1,#v do
					color_v[i] = COLOR(v[i])
				end
				param[k] = color_v
			elseif('img' == k) then	--ͼƬת
				assert(type(v) == 'string')
				local img_v = IMG(v)
				param[k] = img_v
			elseif('t_img' == k) then	--ʸͼƬת
				assert(type(v) == 'table')
				assert(type(v[1]) == 'number')
				assert(type(v[2]) == 'string')
				assert(type(v[3]) == 'string')	
				assert(type(v[4]) == 'string')			
				local img_v = {}
				img_v[1] = v[1]		
				img_v[2] = COLOR(v[2])	
				img_v[3] = FONT(v[3])
				img_v[4] = T_IMG(v[4])			
				param[k] = img_v;
			elseif('imgs' == k) then --ͼƬת
				assert(type(v) == 'table')
				assert(type(v[1]) == 'number')
				assert(type(v[2]) == 'string' and type(v[3]) == 'string' and type(v[4]) == 'string')
				local img_v = {}
				img_v[1] = v[1]
				for i=2,#v do
					img_v[i] = IMG(v[i])
				end
				param[k] = img_v;
			elseif('t_imgs' == k or 't_opt_imgs' == k) then --ʸͼƬת
				assert(type(v) == 'table')
				assert(type(v[1]) == 'number')
				assert(type(v[2]) == 'string')
				assert(type(v[3]) == 'string' and type(v[4]) == 'string' and type(v[5]) == 'string')		
				local t_img_v = {}
				t_img_v[1] = v[1]
				t_img_v[2] = FONT(v[2])
				for i=3,#v do
					t_img_v[i] = T_IMG(v[i])
				end
				param[k] = t_img_v;		
			elseif('font' == k) then	--Сת
				assert(type(v) == 'string')
				param[k] = FONT(v);
			elseif('guide_text' == k) then
				if(body.guide_trans~= nil and (body.guide_trans == false) ) then --ʹܷ	
					param[k] = v
				else
					param[k] = STR(v)
				end		
			else	
				param[k] = v;
			end
		end	
	end
	return param
end


local parser_self = function(top, body, wnd_id)
	local t = b_ui.to_ctrl_type(body.t)		-- number
	local id = to_number(body.id) 			-- number
	
	
	local x, y, w, h

	if(type(body.xywh) == 'string') then	
		local xywh = {}
		xywh = SIZE(body.xywh)
		x, y, w, h = to_rect(xywh)	-- number
	elseif(type(body.xywh) == 'table') then	
		x, y, w, h = to_rect(body.xywh)	-- number
	end

	if (0 == t) or 
	(nil == id) or (0 == id) or 
	(nil == x) or (nil == y) or (nil == w) or (nil == h) then
		return 0 -- ӴڴID, 0Ч
	end

	--
	--print("new wnd:", t, id, x, y, w, h)
	b_wnd.new_sub_wnd(top, t, wnd_id, id, x, y, w, h)


	--չ
	local param = mk_param(body)

	if util.is_not_empty(param) then
		b_wnd.set_sub(top, id, false, param)
	end
	
	return id
end

local parser_wnd = nil
parser_wnd = function(top, body, wnd_id)
	local id = parser_self(top, body, wnd_id)

	if 0 == id then
		-- ЧӴ
		return false
	end
	
	-- Ӵ
	if util.is_array(body.sub) then
		for i = 1, #(body.sub) do
			local name = body.sub[i]			
			if type(body[name]) == 'table' then
				parser_wnd(top, body[name], id)
			end				
		end		
	end
	
	return true
end

local parser_dlg = function(top, body, wnd_id)
	-- Ի
	if (type(body.attr) == 'table') and (not util.is_empty(body.attr)) then
		local xywh = {}
		
		if(type(body.attr.xywh) == 'string') then
			xywh = SIZE(body.attr.xywh)
		elseif(type(body.attr.xywh) == 'table') then
			xywh = body.attr.xywh
		end

		local  bodyattr = {}
		bodyattr = bodyattr
		bodyattr.xywh = xywh
		bodyattr.cmd = body.attr.cmd
		bodyattr.timer = body.attr.timer
		b_wnd.set_attr(top, wnd_id, false, bodyattr);
	end
	
	-- Ӵ
	if util.is_array(body.sub) then
		for i = 1, #(body.sub) do
			local name = body.sub[i]			
			if type(body[name]) == 'table' then
				parser_wnd(top, body[name], wnd_id)
			end				
		end		
	end
	
	return true
end

local b_parser = function(top, page, wnd_id)
	if type(page) == 'table' then
		if (wnd_id ~= nil) then
			return parser_dlg(top, page, wnd_id)
		else
			return parser_dlg(top, page, 0)
		end	
	end
	
	assert(false)
	return false
end

return b_parser
