--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2017/11/17
-- author lsl
-- brief  UI׼
--]]

local b_ui = {

WINDOW = 1,
WND_BG = 2,
STATIC = 3,
BUTTON = 4,
BUTTON_EX = 5,
EDIT = 6,
EDIT_NUM = 7,
CHECK = 8,
RADIO = 9,
COMBOX = 10,
SLIDER = 12,
IP_ADDR = 13,
QR_CODE = 15,
CHECKTXT = 16,
CHECKIMGTXT = 17,

BUTTONTEXT = 19,
SLIDER_V    = 20,
HLINE    = 21,
VLINE    = 22,
CHECKBUTTON = 23,
TIME_12 = 24,
TIME_24 = 25,
DATE = 26,
COMBOX_IN = 27,
TT_BUTTON = 28,
TT_PICTURE = 29,
IMAGE_PARAM =30,
DATEEDIT = 31,
TT_CHECK = 32,
TIMEEDIT = 33,
DWELL = 34,
TIMEPLAN = 35,
PRIAREA = 36,
MOTIONAREA = 37,
OSDAREA = 38,
STATIC_B = 39,
CHMANAGE = 40,
CHITEM = 41,
VDROP = 43,
HDROP = 44,
LIST = 45,
LISTTITLE = 46,
LISTITEM = 47,
CHECKBTNTEXT  = 48,
DISK  = 50,
NAVIGATION = 51,
EDIT_IP = 52,
HSLIDER = 53,
PASSWORD = 54,
CHMANAGE_B = 55,
CHN_COPY = 66,
INTAREA = 68,
VIRTUALFENCE = 69,
DVIRTUALFENCE = 70,
ADVAREA = 71,
RADIOTEXT=72,
CHNTYPE_LIST = 73,
PATTERN = 76,
PATTERN_LOGO = 77,
GRID = 78,
FRAME = 79,
CHECKBOX = 64,
CONVERSEAREA = 80,
ROI = 81,
MAP_POINT = 82,
NET_LINE = 83,
DOTTED_LINE = 84,
MANUAL_A_LIST = 85,
PERSON_COUNT = 87,
CHECKTEXTIMG_BTN = 88,
JIGSAW_PUZZLE = 89,
LINE_CHART = 92,
TIMEPLAN_RECORD = 93,
CHECKCOLOREDBTN = 94,
NET_PACKET_LIST = 95,
CUSTOM_LIST = 97,
HELP_BUTTON = 99,
DWELL_WND = 101,
LINKAGE_EVENT = 103,
LIST_SOUND = 105,
ADAM_MANAGE = 108,
FIRE_SPOT_AREA = 110,

CONTAINER = 400,

DIALOG = 500,
MENU = 505,

DLG_USER = 2000,
MSG_BOX = 2001,




HOME0 = 65527,
HOME1 = 65528,


MOUSEMOVE = 512,
LBUTTONDOWN =513,
LBUTTOUP =514,
LBUTTONDBLCLK =515,
LBUTTONCLK = 527,
LBUTTONDRAG = 528,
RBUTTONCLK = 529,
RBUTTONDRAG = 530,
MBUTTONCLK = 531,
MBUTTONDRAG = 532,
MOUSEWHEELUP = 533,
MOUSEWHEELDOWN = 534,
TIMER = 576,
LOST_FOCUS = 561,

WM_USER_UPDATE_PARAM = 0x0401,
WM_USER_UPDATE_LANGUAGE= 0x0430,
WM_USER_CHANGE_RESOLUTION= 0x0431,
WM_USER_MSGBOX_RUN= 0x0549,
WM_USER_MSGBOX_RUN_START= 0x054a,
WM_CLICKED_AUDITION	= 0x0464,
WM_CLICKED_EXPORT	= 0x0465,


WM_USER_POST_WIZARD = 0x432,
WM_USER_SKIP_WIZARD	= 0x433,
WM_USER_UPDATE_LOGIN_LANGUARE = 0x041b,
WM_USER_JUMP2CFG = 0x456,

WM_USER_NET_PACKET = 0x460,
}

b_ui.ALIGN = {
	LEFT = 0x0002,					-- [align] 
	TOP = 0x0004,					-- [align] 
	RIGHT = 0x0008,					-- [align] Ҷ
	BOTTON = 0x0010,				-- [align] ׶
	CENTER = 0x0020,				-- [align] Ķ
}

b_ui.TIME = {	
	TIME_24 	= 0,				--24Сʱ
	TIME_12AM 	= 1,				--12Сʱ
	TIME_12PM 	= 2,				--12Сʱ
}

b_ui.LISTATTR = {	
	FIRST_WIDGET_STATIC 	= 0,	--listĵһؼΪstatic
	FIRST_WIDGET_CHECK 		= 1,	--listĵһؼΪcheck
	
	END_WIDGET_STATIC 		= 0,	--listһؼΪstatic
	END_WIDGET_EDIT         = 1,
	END_WIDGET_ADDDEL 		= 2,
	END_WIDGET_EDITDEL 		= 3,	--listһؼΪ༭ɾ
	END_WIDGET_CHECK		= 4, 	--listһؼΪcheck
	
}

b_ui.CURSOR = {	

    JY_CURSOR_POINT = 0,
    JY_CURSOR_HAND = 1,
    JY_CURSOR_WAIT = 2,
    JY_CURSOR_ZOOM = 3,
	JY_CURSOR_DRAG = 4,
	JY_CURSOR_3D = 5,
	JY_CURSOR_HIDE = 6,
}

b_ui.to_ctrl_type = function(str)
	if type(str) ~= 'string' then
		return 0
	end

	if 'window' == str then
		return b_ui.WINDOW
	elseif 'wnd_bg' == str then
		return b_ui.WND_BG
	elseif 'static' == str then
		return b_ui.STATIC
	elseif 'button' == str then
		return b_ui.BUTTON
	elseif 'edit' == str then
		return b_ui.EDIT
	elseif 'edit_num' == str then
		return b_ui.EDIT_NUM
	elseif 'check' == str then
		return b_ui.CHECK
	elseif 'radio' == str then
		return b_ui.RADIO
	elseif 'combox' == str then
		return b_ui.COMBOX
	elseif 'slider' == str then
		return b_ui.SLIDER
	elseif 'slider_v' == str then
		return b_ui.SLIDER_V
	elseif 'ip_addr' == str then
		return b_ui.IP_ADDR
	elseif 'qr_code' == str then
		return b_ui.QR_CODE
	elseif 'checktxt' == str then
		return b_ui.CHECKTXT	
	elseif 'checkimgtxt' == str then
		return b_ui.CHECKIMGTXT	
	elseif 'container' == str then
		return b_ui.CONTAINER
	elseif 'buttontext' == str then
		return b_ui.BUTTONTEXT	
	elseif 'hline' == str then
		return b_ui.HLINE	
	elseif 'checkbutton' == str then
		return b_ui.CHECKBUTTON
	elseif 'date' == str then
		return b_ui.DATE
	elseif 'time_12' == str then
		return b_ui.TIME_12
	elseif 'time_24' == str then
		return b_ui.TIME_24	
	elseif 'combox_in' == str then
		return b_ui.COMBOX_IN
	elseif 'tt_button' == str then
		return b_ui.TT_BUTTON
	elseif 'tt_picture' == str then
		return b_ui.TT_PICTURE
	elseif 'image_param' == str then
		return b_ui.IMAGE_PARAM	
	elseif 'date_edit' == str then
		return b_ui.DATEEDIT	
	elseif 'tt_check' == str then
		return b_ui.TT_CHECK
	elseif 'time_edit' == str then
		return b_ui.TIMEEDIT
	elseif 'dwell' == str then
		return b_ui.DWELL
	elseif 'dwell_wnd' == str then
		return b_ui.DWELL_WND	
	elseif 'timeplan' == str then
		return b_ui.TIMEPLAN
	elseif 'priarea' == str then
		return b_ui.PRIAREA	
	elseif 'motionarea' == str then
		return b_ui.MOTIONAREA	
	elseif 'osdarea' == str then
		return b_ui.OSDAREA
	elseif 'static_b' == str then
		return b_ui.STATIC_B
	elseif 'chmanage' == str then
		return b_ui.CHMANAGE
	elseif 'chmanage_b' == str then
		return b_ui.CHMANAGE_B
	elseif 'chitem' == str then
		return b_ui.CHITEM
	elseif 'vdrop' == str then
		return b_ui.VDROP
	elseif 'hdrop' == str then
		return b_ui.HDROP	
	elseif 'list' == str then
		return b_ui.LIST
	elseif 'listtitle' == str then
		return b_ui.LISTTITLE 
	elseif 'listitem' == str then
		return b_ui.LISTITEM
	elseif 'checkbtntext' == str then	
		return b_ui.CHECKBTNTEXT
	elseif 'disk' == str then	
		return b_ui.DISK
	elseif 'navigation' == str then	
		return b_ui.NAVIGATION
	elseif 'edit_ip' == str then	
		return b_ui.EDIT_IP
	elseif 'hslider' == str then	
		return b_ui.HSLIDER
	elseif 'password' == str then	
		return b_ui.PASSWORD
	elseif 'intelarea' == str then
		return b_ui.INTAREA
	elseif 'converse_area' == str then
		return b_ui.CONVERSEAREA	
	elseif 'virtualfence' == str then
		return b_ui.VIRTUALFENCE
	elseif 'dvirtualfence' == str then
		return b_ui.DVIRTUALFENCE
	elseif 'advarea' == str then
		return b_ui.ADVAREA
	elseif 'chn_type_mgr' ==  str then
		return b_ui.CHNTYPE_LIST		
	elseif 'pattern' == str then
		return b_ui.PATTERN
	elseif 'pattern_logo' == str then
		return b_ui.PATTERN_LOGO
	elseif 'chn_copy' == str then
		return b_ui.CHN_COPY
	elseif 'grid' == str then
		return b_ui.GRID
	elseif 'frame' == str then
		return b_ui.FRAME
	elseif 'radio_text' == str then
		return b_ui.RADIOTEXT
	elseif 'checkbox' == str then
		return b_ui.CHECKBOX
	elseif 'roi' == str then
		return b_ui.ROI
	elseif 'map_point' == str then
		return b_ui.MAP_POINT	
	elseif 'net_line' == str then
		return b_ui.NET_LINE
	elseif 'dotted_line' == str then
		return b_ui.DOTTED_LINE
	elseif 'person_count' == str then
		return b_ui.PERSON_COUNT	
	elseif 'manual_list' == str then
		return b_ui.MANUAL_A_LIST
	elseif 'checktextimgbtn' == str then
		return b_ui.CHECKTEXTIMG_BTN
	elseif 'jigsaw_puzzle' == str then
		return b_ui.JIGSAW_PUZZLE
	elseif 'line_chart' == str then
		return b_ui.LINE_CHART
	elseif 'timeplan_record' == str then
		return b_ui.TIMEPLAN_RECORD
	elseif 'checkcoloredbtn' == str then
		return b_ui.CHECKCOLOREDBTN
	elseif 'packet_list' == str then
		return b_ui.NET_PACKET_LIST
	elseif 'custom_list' == str then
		return b_ui.CUSTOM_LIST
	elseif 'help_btn' == str then
		return b_ui.HELP_BUTTON
	elseif 'linkage_event' == str then
		return b_ui.LINKAGE_EVENT
	elseif 'list_sound' == str then		
		return b_ui.LIST_SOUND	
	elseif 'adammanage' == str then
		return b_ui.ADAM_MANAGE
	elseif 'firespot_area' == str then
		return b_ui.FIRE_SPOT_AREA;	
	end
	
	return 0
end


return b_ui
