--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2017/11/17
-- author lsl
-- brief  ׹
--]]
local util = {}


-- жǷΪ
-- t : table / nil
util.is_array = function(t)
	if type(t) ~= "table" then 
		return false
	end
	
	local n = #t
	for i,v in pairs(t) do
		if type(i) ~= "number" then
			return false  
		end
		
		if i > n then
			return false
		end
	end
	
	return true
end

-- жtableΪ
-- t : Ϊtable / {}
util.is_empty = function(t)
	assert(type(t) == 'table')

	if nil ~= next(t) then
		return false
	end
	
	return true
end

-- жtableΪ
-- t : table / nil / {}
util.is_not_empty = function(t)
	if type(t) == 'table' then
		if nil ~= next(t) then
			return true
		end
	end
	
	return false
end

-- һtable
util.copy_tab = function(src)
	assert(type(src) == 'table')
	local dst = {}
	for k, v in pairs(src) do
		if (type(src[k]) == "table") then
			dst[k] = util.copy_tab(v)
		elseif (type(src[k]) == "number" or type(src[k]) == "string" or type(src[k]) == "boolean") then
			dst[k] = v
		else
			
		end
	end
	return dst
end

util.clear_tab = function(tab)
	assert(type(tab) == 'table')
	for k, v in pairs(tab) do
		if (type(tab[k]) == "table") then
			util.clear_tab(tab[k]);
			tab[k] = nil;
		elseif (type(tab[k]) == "number" or type(tab[k]) == "string" or type(tab[k]) == "boolean") then
			tab[k] = nil;		
		end		
	end
end

-- һtable
util.copy_tab_b = function(dst, src)
	assert(type(dst) == 'table')
	assert(type(src) == 'table')
	util.clear_tab(dst);
	for k, v in pairs(src) do
		if (type(src[k]) == "table") then
			if(dst[k] == nil) then
				dst[k] = {};
			end
			util.copy_tab_b(dst[k], v)
		elseif (type(src[k]) == "number" or type(src[k]) == "string" or type(src[k]) == "boolean") then
			dst[k] = v
		else
			
		end
	end
	return 0;
end

--Աtable,ȷ0,ȷ1
--жtab1еԪtab2жֵ,tab2еԪtab1жֵ
util.compare_tab = function(tab1, tab2)
	assert(type(tab1) == 'table')
	assert(type(tab2) == 'table')
	for k, v in pairs(tab1) do
		if (type(tab1[k]) == "table") then
			if(tab2[k] ~= nil and type(tab2[k]) == "table" ) then
				if(util.compare_tab(tab1[k], tab2[k]) == 1) then
					return 1;
				end
			elseif(tab2[k] == nil and next(tab1[k]) == nil) then --ձnilͬ
				
			else
				return 1;
			end
		elseif (type(tab1[k]) == "number" or type(tab1[k]) == "string" or type(tab1[k]) == "boolean") then
			if(tab2[k] ~= nil) then
				if(v ~= tab2[k]) then
					return 1
				end
			else
				return 1
			end
		end
	end
	for k, v in pairs(tab2) do
		if (type(tab2[k]) == "table") then
			if(tab1[k] ~= nil and type(tab1[k]) == "table" ) then
				if(util.compare_tab(tab2[k], tab1[k]) == 1) then
					return 1;
				end
			elseif(tab1[k] == nil and next(tab2[k]) == nil) then --ձnilͬ
			
			else
				return 1;
			end
		elseif (type(tab1[k]) == "number" or type(tab1[k]) == "string" or type(tab1[k]) == "boolean") then
			if(tab1[k] ~= nil) then
				if(v ~= tab1[k]) then
					return 1
				end
			else
				return 1
			end
		end
	end
	return 0
end


util.to_function = function(func)
	if type(func) == "function" then
		return func
	end
	
	return nil
end

util.pt_in_xywh = function(x, y, xywh)
	if util.is_array(xywh) then
		if xywh[1] <= x and x < xywh[1] + xywh[3] and
			xywh[2] <= y and y < xywh[2] + xywh[4] then
		
			return true
		end
	end
	
	return false
end

return util
