local global_val	= require("wnd.global_val")
local b_wnd 	= require("wnd.core.b_wnd")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")

local w1_key 	= require("wnd.w1_util.w1_key")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local r_img		= require("wnd.core.r_res.r_img")
local IMG 		= r_img.get_img
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_setting.id
local util 		= require("wnd.core.util")
local r_t_img 	= require("wnd.core.r_res.r_t_img")
local T_IMG 	= r_t_img.get_img
local r_font	= require("wnd.core.r_res.r_font")
local FONT 		= r_font.get_fontsize
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local w1_cfg_settings = {
	t = w1_key.DLG_CFG_SETTINGS,
	top = nil,
	dlg = nil,
	old_bankidx = 0,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_cfg_settings.s_768 =
{
	s_nav_xywh = {128,177,768,413},
	s_nav_title_xywh = {62,21,0,0},
		
	s_nav_channel_xywh = {0,0,260,204},
	s_nav_ch_xywh_1 = {62,78,98,24},
	s_nav_ch_xywh_2 = {164,78,93,24},
	s_nav_ch_xywh_3 = {62,103,98,24},
	s_nav_ch_xywh_4 = {164,103,93,24},
	s_nav_ch_xywh_5 = {62,128,98,24},
	s_nav_ch_xywh_6 = {164,128,93,24},
	s_nav_ch_xywh_7 = {62,152,98,24},
	s_nav_ch_xywh_8 = {164,152,93,24},
	s_nav_ch_xywh_9 = {62,177,98,24},
	s_nav_ch_xywh_10 = {164,177,93,24},
		
	s_nav_storage_xywh = {263,0,250,204},
	s_nav_sto_xywh_1 = {62,78,106,24},
	s_nav_sto_xywh_2 = {173,78,75,24},
	s_nav_sto_xywh_3 = {62,103,106,24},
	s_nav_sto_xywh_4 = {173,103,75,24},
	s_nav_sto_xywh_5 = {62,128,106,24},
	s_nav_sto_xywh_6 = {173,128,75,24},
	s_nav_sto_xywh_7 = {62,152,106,24},
	s_nav_sto_xywh_8 = {173,152,75,24},
	s_nav_sto_xywh_9 = {62,177,106,24},
	s_nav_sto_xywh_10 = {173,177,75,24},
	
	s_nav_channel_exp_xywh = {0,0,373,204},
	s_nav_ch_exp_xywh_1 = {62,78,128,24},
	s_nav_ch_exp_xywh_2 = {197,78,170,24},
	s_nav_ch_exp_xywh_3 = {62,103,128,24},
	s_nav_ch_exp_xywh_4 = {197,103,170,24},
	s_nav_ch_exp_xywh_5 = {62,128,128,24},
	s_nav_ch_exp_xywh_6 = {197,128,170,24},
	s_nav_ch_exp_xywh_7 = {62,152,128,24},
	s_nav_ch_exp_xywh_8 = {197,152,170,24},
	s_nav_ch_exp_xywh_9 = {62,177,128,24},
	s_nav_ch_exp_xywh_10 = {197,177,170,24},	
			
	s_nav_netword_xywh = {517,0,250,204},
	s_nav_net_xywh_1 = {62,78,101,24},
	s_nav_net_xywh_2 = {168,78,80,24},
	s_nav_net_xywh_3 = {62,103,101,24},
	s_nav_net_xywh_4 = {168,103,80,24},
	s_nav_net_xywh_5 = {62,128,101,24},
	s_nav_net_xywh_6 = {168,128,80,24},
	s_nav_net_xywh_7 = {62,152,101,24},
	s_nav_net_xywh_8 = {168,152,80,24},
	s_nav_net_xywh_9 = {62,177,101,24},
	s_nav_net_xywh_10 = {168,177,80,24},
	
	s_nav_netword_exp_xywh = {377,0,390,204},
	s_nav_net_exp_xywh_1 = {62,78,128,24},
	s_nav_net_exp_xywh_2 = {197,78,193,24},
	s_nav_net_exp_xywh_3 = {62,103,128,24},
	s_nav_net_exp_xywh_4 = {197,103,193,24},
	s_nav_net_exp_xywh_5 = {62,128,128,24},
	s_nav_net_exp_xywh_6 = {197,128,193,24},
	s_nav_net_exp_xywh_7 = {62,152,128,24},
	s_nav_net_exp_xywh_8 = {197,152,193,24},
	s_nav_net_exp_xywh_9 = {62,177,128,24},
	s_nav_net_exp_xywh_10 = {197,177,193,24},
	
		
	s_nav_ala_xywh = {0,209,363,204},
	s_nav_ala_xywh_1 = {62,78,128,28},
	s_nav_ala_xywh_2 = {197,78,164,28},
	s_nav_ala_xywh_3 = {62,106,128,28},
	s_nav_ala_xywh_4 = {197,106,164,28},
	s_nav_ala_xywh_5 = {62,135,128,28},
	s_nav_ala_xywh_6 = {197,135,164,28},
	s_nav_ala_xywh_7 = {62,163,128,28},
	s_nav_ala_xywh_8 = {197,163,164,28},
		
	s_nav_system_xywh = {368,209,400,204},
	s_nav_sys_xywh_1 = {62,78,106,28},
	s_nav_sys_xywh_2 = {172,78,117,28},
	s_nav_sys_xywh_3 = {293,78,104,28},
	s_nav_sys_xywh_4 = {62,106,106,28},
	s_nav_sys_xywh_5 = {172,106,117,28},
	s_nav_sys_xywh_6 = {293,106,104,28},
	s_nav_sys_xywh_7 = {62,135,106,28},
	s_nav_sys_xywh_8 = {172,135,117,28},
	s_nav_sys_xywh_9 = {293,135,104,28},
	s_nav_sys_xywh_10 = {62,163,106,28},
};

w1_cfg_settings.s_1280 = 
{
	s_nav_xywh = {162,221,955,582},
	s_nav_title_xywh = {118,30,0,0},
	
	s_nav_channel_xywh = {0,0,316,288},
	s_nav_ch_xywh_1 = {118,110,125,35},
	s_nav_ch_xywh_2 = {250,110,64,35},
	s_nav_ch_xywh_3 = {118,145,125,35},
	s_nav_ch_xywh_4 = {250,145,64,35},
	s_nav_ch_xywh_5 = {118,180,125,35},
	s_nav_ch_xywh_7 = {118, 215,125, 35},
	s_nav_ch_xywh_6 = {250,180,64,35},
	s_nav_ch_xywh_8 = {250,215,64,35},
	s_nav_ch_xywh_9 = {118,250,125,35},
	s_nav_ch_xywh_10 = {250,250,64,35},
	
	s_nav_channel_exp_xywh = {0,0,507,288},
	s_nav_ch_exp_xywh_1 = {118,110,210,35},
	s_nav_ch_exp_xywh_2 = {300,110,200,35},
	s_nav_ch_exp_xywh_3 = {118,145,210,35},
	s_nav_ch_exp_xywh_4 = {300,145,200,35},
	s_nav_ch_exp_xywh_5 = {118,180,210,35},
	s_nav_ch_exp_xywh_7 = {118, 215,210, 35},
	s_nav_ch_exp_xywh_6 = {300,180,200,35},
	s_nav_ch_exp_xywh_8 = {300,215,200,35},
	s_nav_ch_exp_xywh_9 = {118,250,210,35},
	s_nav_ch_exp_xywh_10 = {300,250,200,35},	
	
	s_nav_storage_xywh = {320,0,315,288},
	s_nav_sto_xywh_1 = {118,110,125,35},
	s_nav_sto_xywh_2 = {250,110,63,35},
	s_nav_sto_xywh_3 = {118,145,125,35},
	s_nav_sto_xywh_4 = {250,145,63,35},
	s_nav_sto_xywh_5 = {118,180,125,35},
	s_nav_sto_xywh_6 = {250,180,63,35},
	s_nav_sto_xywh_7 = {118,215,125,35},
	s_nav_sto_xywh_8 = {250,215,63,35},
	s_nav_sto_xywh_9 = {118,250,125,35},
	
	s_nav_netword_xywh = {639,0,316,288},
	s_nav_net_xywh_1 = {98,110,125,35},
	s_nav_net_xywh_2 = {230,110,84,35},
	s_nav_net_xywh_3 = {98,145,125,35},
	s_nav_net_xywh_4 = {230,145,84,35},
	s_nav_net_xywh_5 = {98,180,125,35},
	s_nav_net_xywh_6 = {230,180,84,35},
	s_nav_net_xywh_7 = {98,215,125,35},
	s_nav_net_xywh_8 = {230,215,84,35},
	s_nav_net_xywh_9 = {98,250,125,35},
	s_nav_net_xywh_10 = {230,250,84,35},
	
	s_nav_netword_exp_xywh = {512,0,444,288},
	s_nav_net_exp_xywh_1 = {98,110,125,35},
	s_nav_net_exp_xywh_2 = {230,110,200,35},
	s_nav_net_exp_xywh_3 = {98,145,125,35},
	s_nav_net_exp_xywh_4 = {230,145,200,35},
	s_nav_net_exp_xywh_5 = {98,180,125,35},
	s_nav_net_exp_xywh_6 = {230,180,200,35},
	s_nav_net_exp_xywh_7 = {98,215,125,35},
	s_nav_net_exp_xywh_8 = {230,215,200,35},
	s_nav_net_exp_xywh_9 = {98,250,125,35},
	s_nav_net_exp_xywh_10 = {230,250,200,35},
	
	s_nav_ala_xywh = {0,294,455,288},
	s_nav_ala_xywh_1 = {118,110,170,40},
	s_nav_ala_xywh_2 = {300,110,150,40},
	s_nav_ala_xywh_3 = {118,150,170,40},
	s_nav_ala_xywh_4 = {300,150,150,40},
	s_nav_ala_xywh_5 = {118,190,170,40},
	s_nav_ala_xywh_6 = {300,190,150,40},
	s_nav_ala_xywh_7 = {118,230,170,40},
	s_nav_ala_xywh_8 = {300,230,150,40},
	
	
	s_nav_system_xywh = {459,294,497,288},
	s_nav_sys_xywh_1 = {118,110,140,40},
	s_nav_sys_xywh_2 = {260,110,140,40},
	s_nav_sys_xywh_3 = {402,110,90,40},
	s_nav_sys_xywh_4 = {118,150,140,40},
	s_nav_sys_xywh_5 = {260,150,140,40},
--[[	s_nav_sys_log_xywh = {400,150,90,40},
	s_nav_sys_main_xywh = {118,190,150,40},
	s_nav_sys_restart_xywh =  {280,190,120,40},--]]
	
	s_nav_sys_xywh_6 =  {402,150,90,40},
	s_nav_sys_xywh_7 = {118,190,140,40},
	s_nav_sys_xywh_8 =  {260,190,140,40},
	s_nav_sys_xywh_9 = {402,190,90,40},
	s_nav_sys_xywh_10= {118,230,140,40},
};
w1_cfg_settings.s_1440 = 
{
	s_nav_xywh = {146,159,1148,582},
	s_nav_title_xywh = {118,30,0,0},
	s_nav_channel_xywh = {0,0,380,288},
	s_nav_ch_xywh_1 = {118,110,145,35},
	s_nav_ch_xywh_2 = {270,110,105,35},
	s_nav_ch_xywh_3 = {118,145,145,35},
	s_nav_ch_xywh_4 = {270,145,105,35},
	s_nav_ch_xywh_5 = {118,180,145,35},
	s_nav_ch_xywh_7 = {118, 215, 145, 35},		
	s_nav_ch_xywh_6 = {270,180,105,35},
	s_nav_ch_xywh_8 = {270,215,108,35},
	s_nav_ch_xywh_9 = {118,250,145,35},
	s_nav_ch_xywh_10 = {270,250,108,35},
	
	s_nav_channel_exp_xywh = {0,0,640,288},
	s_nav_ch_exp_xywh_1 = {118,110,145,35},
	s_nav_ch_exp_xywh_2 = {380,110,240,35},
	s_nav_ch_exp_xywh_3 = {118,145,145,35},
	s_nav_ch_exp_xywh_4 = {380,145,240,35},
	s_nav_ch_exp_xywh_5 = {118,180,145,35},
	s_nav_ch_exp_xywh_7 = {118, 215, 145, 35},		
	s_nav_ch_exp_xywh_6 = {380,180,240,35},
	s_nav_ch_exp_xywh_8 = {380,215,240,35},
	s_nav_ch_exp_xywh_9 = {118,250,145,35},
	s_nav_ch_exp_xywh_10 = {380,250,240,35},	
	
	s_nav_storage_xywh = {386,0,378,288},
	s_nav_sto_xywh_1 = {118,110,160,35},
	s_nav_sto_xywh_2 = {285,110,90,35},
	s_nav_sto_xywh_3 = {118,145,160,35},
	s_nav_sto_xywh_4 = {285,145,90,35},
	s_nav_sto_xywh_5 = {118,180,160,35},
	s_nav_sto_xywh_6 = {285,180,90,35},
	s_nav_sto_xywh_7 = {118,215,160,35},
	s_nav_sto_xywh_8 = {285,215,90,35},
	s_nav_sto_xywh_9 = {118,250,160,35},
	
	s_nav_netword_xywh = {770,0,378,288},
	s_nav_net_xywh_1 =	{118,110,145,35},
	s_nav_net_xywh_2 = 		{270,110,105,35},
	s_nav_net_xywh_3 = 	{118,145,145,35},
	s_nav_net_xywh_4 = 	{270,145,105,35},
	s_nav_net_xywh_5 = 	{118,180,145,35},
	s_nav_net_xywh_6 = 	{270,180,105,35},
	s_nav_net_xywh_7 = {118,215,145,35},
	s_nav_net_xywh_8 = {270,215,105,35},
	s_nav_net_xywh_9 = {118,250,145,35},
	s_nav_net_xywh_10 = {270,250,105,35},
	
	s_nav_netword_exp_xywh = {646,0,502,288},
	s_nav_net_exp_xywh_1 =	{118,110,145,35},
	s_nav_net_exp_xywh_2 = 	{270,110,200,35},
	s_nav_net_exp_xywh_3 = 	{118,145,145,35},
	s_nav_net_exp_xywh_4 = 	{270,145,200,35},
	s_nav_net_exp_xywh_5 = 	{118,180,145,35},
	s_nav_net_exp_xywh_6 = 	{270,180,200,35},
	s_nav_net_exp_xywh_7 = {118,215,145,35},
	s_nav_net_exp_xywh_8 = {270,215,200,35},
	s_nav_net_exp_xywh_9 = {118,250,145,35},
	s_nav_net_exp_xywh_10 = {270,250,200,35},
	
	s_nav_ala_xywh = {0,294,546,288},
	s_nav_ala_xywh_1 = {118,110,190,40},
	s_nav_ala_xywh_2 = {320,110,220,40},
	s_nav_ala_xywh_3 = {118,150,190,40},
	s_nav_ala_xywh_4 = {320,150,220,40},
	s_nav_ala_xywh_5 = {118,190,190,40},
	s_nav_ala_xywh_6 = {320,190,220,40},
	s_nav_ala_xywh_7 = {118,230,190,40},
	s_nav_ala_xywh_8 = {320,230,220,40},
	
	s_nav_system_xywh = {554,294,596,288},
	s_nav_sys_xywh_1 = {118,110,150,40},
	s_nav_sys_xywh_2 = {280,110,162,40},
	s_nav_sys_xywh_3 = {450,110,140,40},
	s_nav_sys_xywh_4 = {118,150,150,40},
	s_nav_sys_xywh_5 = {280,150,162,40},
	s_nav_sys_xywh_6 =  {450,150,140,40},
	s_nav_sys_xywh_7 = {118,190,150,40},
	s_nav_sys_xywh_8 =  {280,190,162,40},
	s_nav_sys_xywh_9 = {450,190,140,40},
	s_nav_sys_xywh_10= {118,230,150,40},
};

w1_cfg_settings.s_1080p = 
{
	s_nav_xywh = {240,249,1440,582},
	s_nav_title_xywh = {118,30,0,0},
	
	s_nav_channel_xywh = {0,0,488,288},
	s_nav_ch_xywh_1 = {118,110,184,35},
	s_nav_ch_xywh_2 = {308,110,176,35},
	s_nav_ch_xywh_3 = {118,145,184,35},
	s_nav_ch_xywh_4 = {308,145,176,35},
	s_nav_ch_xywh_5 = {118,180,184,35},
	s_nav_ch_xywh_6 = {308,180,176,35},
	s_nav_ch_xywh_7 = {118, 215, 184, 35},		
	s_nav_ch_xywh_8	 = {308,215,176,35},
	s_nav_ch_xywh_9 = {118,250,184,35},
	s_nav_ch_xywh_10 = {308,250,176,35},
	
	s_nav_channel_exp_xywh = {0,0,700,288},	
	s_nav_ch_exp_xywh_1 = {118,110,240,35},
	s_nav_ch_exp_xywh_2 = {370,110,320,35},
	s_nav_ch_exp_xywh_3 = {118,145,240,35},
	s_nav_ch_exp_xywh_4 = {370,145,320,35},
	s_nav_ch_exp_xywh_5 = {118,180,240,35},
	s_nav_ch_exp_xywh_6 = {370,180,320,35},
	s_nav_ch_exp_xywh_7 = {118,215,240,35},		
	s_nav_ch_exp_xywh_8	= {370,215,320,35},
	s_nav_ch_exp_xywh_9 = {118,250,240,35},
	s_nav_ch_exp_xywh_10 = {370,250,320,35},	
	
	s_nav_storage_xywh = {494,0,470,288},
	s_nav_sto_xywh_1 = {118,110,200,35},
	s_nav_sto_xywh_2 = {325,110,141,35},
	s_nav_sto_xywh_3 = {118,145,200,35},
	s_nav_sto_xywh_4= {325,145,141,35},
	s_nav_sto_xywh_5 = {118,180,200,35},
	s_nav_sto_xywh_6 = {325,180,141,35},
	s_nav_sto_xywh_7 = {118,215,200,35},
	s_nav_sto_xywh_8 = {325,215,141,35},
	s_nav_sto_xywh_9 = {118,250,200,35},
	s_nav_sto_xywh_10 = {325,250,141,35},
	
	s_nav_netword_xywh = {970,0,470,288},
	s_nav_net_xywh_1 =	{118,110,190,35},
	s_nav_net_xywh_2 = 	{315,110,151,35},
	s_nav_net_xywh_3 = 	{118,145,190,35},
	s_nav_net_xywh_4 = 	{315,145,151,35},
	s_nav_net_xywh_5 = 	{118,180,190,35},
	s_nav_net_xywh_6 = 	{315,180,151,35},
	s_nav_net_xywh_7 = {118,215,190,35},
	s_nav_net_xywh_8 = {315,215,151,35},
	s_nav_net_xywh_9 = {118,250,190,35},
	s_nav_net_xywh_10 = {315,250,151,35},
	
	s_nav_netword_exp_xywh = {708,0,732,288},
	s_nav_net_exp_xywh_1 =	{118,110,240,35},
	s_nav_net_exp_xywh_2 = 	{370,110,362,35},
	s_nav_net_exp_xywh_3 = 	{118,145,240,35},
	s_nav_net_exp_xywh_4 = 	{370,145,362,35},
	s_nav_net_exp_xywh_5 = 	{118,180,240,35},
	s_nav_net_exp_xywh_6 = 	{370,180,362,35},
	s_nav_net_exp_xywh_7 = {118,215,240,35},
	s_nav_net_exp_xywh_8 = {370,215,362,35},
	s_nav_net_exp_xywh_9 = {118,250,240,35},
	s_nav_net_exp_xywh_10 = {370,250,362,35},	
	
	s_nav_ala_xywh = {0,294,682,288},
	s_nav_ala_xywh_1 = {118,110,240,40},
	s_nav_ala_xywh_2 = {370,110,308,40},
	s_nav_ala_xywh_3 = {118,150,240,40},
	s_nav_ala_xywh_4 = {370,150,308,40},
	s_nav_ala_xywh_5 = {118,190,240,40},
	s_nav_ala_xywh_6 = {370,190,308,40},
	s_nav_ala_xywh_7 = {118,230,240,40},
	s_nav_ala_xywh_8 = {370,230,308,40},
	
	s_nav_system_xywh = {690,294,750,288},
	s_nav_sys_xywh_1 = {118,110,200,40},
	s_nav_sys_xywh_2 = {324,110,220,40},
	s_nav_sys_xywh_3 = {550,110,196,40},
	s_nav_sys_xywh_4 = {118,150,200,40},
	s_nav_sys_xywh_5 = {324,150,220,40},
	s_nav_sys_xywh_6 =  {550,150,196,40},
	s_nav_sys_xywh_7 = {118,190,200,40},
	s_nav_sys_xywh_8 =  {324,190,220,40},
	s_nav_sys_xywh_9 = {550,190,196,40},
	s_nav_sys_xywh_10= {118,230,200,40},
};

w1_cfg_settings.s_2k = 
{
	s_nav_xywh = {320,332,1920,776},
	s_nav_title_xywh = {157,40,0,0},

	s_nav_channel_xywh = {0,0,651,384},
	s_nav_ch_xywh_1 = {157,147,245,47},
	s_nav_ch_xywh_2 = {411,147,235,47},
	s_nav_ch_xywh_3 = {157,193,245,47},
	s_nav_ch_xywh_4 = {411,193,235,47},
	s_nav_ch_xywh_5 = {157,240,245,47},
	s_nav_ch_xywh_6 = {411,240,235,47},
	s_nav_ch_xywh_7 = {157,287,245,47},
	s_nav_ch_xywh_8 = {411,287,235,47},
	s_nav_ch_xywh_9 = {157,333,245,47},
	s_nav_ch_xywh_10 = {411,333,235,47},

	s_nav_channel_exp_xywh = {0,0,933,383},
	s_nav_ch_exp_xywh_1 = {157,146,319,46},
	s_nav_ch_exp_xywh_2 = {493,146,426,46},
	s_nav_ch_exp_xywh_3 = {157,193,319,46},
	s_nav_ch_exp_xywh_4 = {493,193,426,46},
	s_nav_ch_exp_xywh_5 = {157,239,319,46},
	s_nav_ch_exp_xywh_6 = {493,239,426,46},
	s_nav_ch_exp_xywh_7 = {157,286,319,46},
	s_nav_ch_exp_xywh_8 = {493,286,426,46},
	s_nav_ch_exp_xywh_9 = {157,333,319,46},
	s_nav_ch_exp_xywh_10 = {493,333,426,46},
		
	s_nav_storage_xywh = {659,0,627,384},
	s_nav_sto_xywh_1 = {157,147,267,47},
	s_nav_sto_xywh_2 = {433,147,188,47},
	s_nav_sto_xywh_3 = {157,193,267,47},
	s_nav_sto_xywh_4 = {433,193,188,47},
	s_nav_sto_xywh_5 = {157,240,267,47},
	s_nav_sto_xywh_6 = {433,240,188,47},
	s_nav_sto_xywh_7 = {157,287,267,47},
	s_nav_sto_xywh_8 = {433,287,188,47},
	s_nav_sto_xywh_9 = {157,333,267,47},
	s_nav_sto_xywh_10 = {433,333,188,47},

	s_nav_netword_xywh = {1293,0,627,384},
	s_nav_net_xywh_1 = {157,147,253,47},
	s_nav_net_xywh_2 = {420,147,201,47},
	s_nav_net_xywh_3 = {157,193,253,47},
	s_nav_net_xywh_4 = {420,193,201,47},
	s_nav_net_xywh_5 = {157,240,253,47},
	s_nav_net_xywh_6 = {420,240,201,47},
	s_nav_net_xywh_7 = {157,287,253,47},
	s_nav_net_xywh_8 = {420,287,201,47},
	s_nav_net_xywh_9 = {157,333,253,47},
	s_nav_net_xywh_10 = {420,333,201,47},
	
	s_nav_netword_exp_xywh = {943,0,975,383},
	s_nav_net_exp_xywh_1 = {157,146,319,46},
	s_nav_net_exp_xywh_2 = {493,146,482,46},
	s_nav_net_exp_xywh_3 = {157,193,319,46},
	s_nav_net_exp_xywh_4 = {493,193,482,46},
	s_nav_net_exp_xywh_5 = {157,239,319,46},
	s_nav_net_exp_xywh_6 = {493,239,482,46},
	s_nav_net_exp_xywh_7 = {157,286,319,46},
	s_nav_net_exp_xywh_8 = {493,286,482,46},
	s_nav_net_exp_xywh_9 = {157,333,319,46},
	s_nav_net_exp_xywh_10 = {493,333,482,46},	

	s_nav_ala_xywh = {0,392,909,384},
	s_nav_ala_xywh_1 = {157,147,320,53},
	s_nav_ala_xywh_2 = {493,147,411,53},
	s_nav_ala_xywh_3 = {157,200,320,53},
	s_nav_ala_xywh_4 = {493,200,411,53},
	s_nav_ala_xywh_5 = {157,253,320,53},
	s_nav_ala_xywh_6 = {493,253,411,53},
	s_nav_ala_xywh_7 = {157,307,320,53},
	s_nav_ala_xywh_8 = {493,307,411,53},

	s_nav_system_xywh = {920,392,1000,384},
	s_nav_sys_xywh_1 = {157,147,267,53},
	s_nav_sys_xywh_2 = {432,147,293,53},
	s_nav_sys_xywh_3 = {733,147,261,53},
	s_nav_sys_xywh_4 = {157,200,267,53},
	s_nav_sys_xywh_5 = {432,200,293,53},
	s_nav_sys_xywh_6 = {733,200,261,53},
	s_nav_sys_xywh_7 = {157,253,267,53},
	s_nav_sys_xywh_8 = {432,253,293,53},
	s_nav_sys_xywh_9 = {733,253,261,53},
	s_nav_sys_xywh_10= {157,307,267,53},
};
w1_cfg_settings.s_4k = 
{
	s_nav_xywh = {480,498,2880,1164},
	s_nav_title_xywh = {236,60,0,0},

	s_nav_channel_xywh = {0,0,976,576},
	s_nav_ch_xywh_1 = {236,220,368,70},
	s_nav_ch_xywh_2 = {616,220,352,70},
	s_nav_ch_xywh_3 = {236,290,368,70},
	s_nav_ch_xywh_4 = {616,290,352,70},
	s_nav_ch_xywh_5 = {236,360,368,70},
	s_nav_ch_xywh_6 = {616,360,352,70},
	s_nav_ch_xywh_7 = {236,430,368,70},
	s_nav_ch_xywh_8 = {616,430,352,70},
	s_nav_ch_xywh_9 = {236,500,368,70},
	s_nav_ch_xywh_10 = {616,500,352,70},
	
	s_nav_channel_exp_xywh = {0,0,1400,576},
	s_nav_ch_exp_xywh_1 = {236,220,480,70},
	s_nav_ch_exp_xywh_2 = {740,220,640,70},
	s_nav_ch_exp_xywh_3 = {236,290,480,70},
	s_nav_ch_exp_xywh_4 = {740,290,640,70},
	s_nav_ch_exp_xywh_5 = {236,360,480,70},
	s_nav_ch_exp_xywh_6 = {740,360,640,70},
	s_nav_ch_exp_xywh_7 = {236,430,480,70},
	s_nav_ch_exp_xywh_8 = {740,430,640,70},
	s_nav_ch_exp_xywh_9 = {236,500,480,70},
	s_nav_ch_exp_xywh_10 = {740,500,640,70},
		
	s_nav_storage_xywh = {988,0,940,576},
	s_nav_sto_xywh_1 = {236,220,400,70},
	s_nav_sto_xywh_2 = {650,220,282,70},
	s_nav_sto_xywh_3 = {236,290,400,70},
	s_nav_sto_xywh_4 = {650,290,282,70},
	s_nav_sto_xywh_5 = {236,360,400,70},
	s_nav_sto_xywh_6 = {650,360,282,70},
	s_nav_sto_xywh_7 = {236,430,400,70},
	s_nav_sto_xywh_8 = {650,430,282,70},
	s_nav_sto_xywh_9 = {236,500,400,70},
	s_nav_sto_xywh_10 = {650,500,282,70},

	s_nav_netword_xywh = {1940,0,940,576},
	s_nav_net_xywh_1 = {236,220,380,70},
	s_nav_net_xywh_2 = {630,220,302,70},
	s_nav_net_xywh_3 = {236,290,380,70},
	s_nav_net_xywh_4 = {630,290,302,70},
	s_nav_net_xywh_5 = {236,360,380,70},
	s_nav_net_xywh_6 = {630,360,302,70},
	s_nav_net_xywh_7 = {236,430,380,70},
	s_nav_net_xywh_8 = {630,430,302,70},
	s_nav_net_xywh_9 = {236,500,380,70},
	s_nav_net_xywh_10 = {630,500,302,70},
	
	s_nav_netword_exp_xywh = {1416,0,1464,576},
	s_nav_net_exp_xywh_1 = {236,220,480,70},
	s_nav_net_exp_xywh_2 = {740,220,724,70},
	s_nav_net_exp_xywh_3 = {236,290,480,70},
	s_nav_net_exp_xywh_4 = {740,290,724,70},
	s_nav_net_exp_xywh_5 = {236,360,480,70},
	s_nav_net_exp_xywh_6 = {740,360,724,70},
	s_nav_net_exp_xywh_7 = {236,430,480,70},
	s_nav_net_exp_xywh_8 = {740,430,724,70},
	s_nav_net_exp_xywh_9 = {236,500,480,70},
	s_nav_net_exp_xywh_10 = {740,500,724,70},	

	s_nav_ala_xywh = {0,588,1364,576},
	s_nav_ala_xywh_1 = {236,220,480,80},
	s_nav_ala_xywh_2 = {740,220,616,80},
	s_nav_ala_xywh_3 = {236,300,480,80},
	s_nav_ala_xywh_4 = {740,300,616,80},
	s_nav_ala_xywh_5 = {236,380,480,80},
	s_nav_ala_xywh_6 = {740,380,616,80},
	s_nav_ala_xywh_7 = {236,460,480,80},
	s_nav_ala_xywh_8 = {740,460,616,80},

	s_nav_system_xywh = {1380,588,1500,576},
	s_nav_sys_xywh_1 = {236,220,400,80},
	s_nav_sys_xywh_2 = {648,220,440,80},
	s_nav_sys_xywh_3 = {1100,220,392,80},
	s_nav_sys_xywh_4 = {236,300,400,80},
	s_nav_sys_xywh_5 = {648,300,440,80},
	s_nav_sys_xywh_6 = {1100,300,392,80},
	s_nav_sys_xywh_7 = {236,380,400,80},
	s_nav_sys_xywh_8 = {648,380,440,80},
	s_nav_sys_xywh_9 = {1100,380,392,80},
	s_nav_sys_xywh_10= {236,460,400,80},
};

local dlg = {
	attr = {xywh='s_nav_xywh',cmd=on_dlg},
	
	sub = {'channel', 
			'storage',
			'netword',
			'ala', 'surve', 'motion', 'tamper', 'loss', 'exception',
			'system', 'dev_info','basic', 'user','modify_pw','out_device', 'app', 'dev_manage', 'log_manage', 'auxiliary'
			},
		channel = {t='navigation',id=id+1,xywh='s_nav_channel_xywh', 		sel =1,
				},
		storage = {t='navigation',id=id+2,xywh='s_nav_storage_xywh', 	sel =2,
				},
		netword = {t='navigation',id=id+3,xywh='s_nav_netword_xywh', 	sel =3,
				},
		ala 	= {t='navigation',id=id+4,xywh='s_nav_ala_xywh', 	sel =4,
				},
		system 	= {t='navigation',id=id+5,xywh='s_nav_system_xywh', 	sel =5,
				},
}

local do_noprivilege = function(top)
	w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_NO_PRIVILEGE'), true, false,false);
	w1_msgbox.set_func(nil, nil, nil, nil);
end

local refreshbank_bg = function(top, bankidx)
	local bankid = 0;
	local old_bankidx = 0;
	if(bankidx == 0) then

	elseif(bankidx == 1) then
		bankid = dlg.channel.id;
	elseif(bankidx == 2) then
		bankid = dlg.storage.id;
	elseif(bankidx == 3) then
		bankid = dlg.netword.id;
	elseif(bankidx == 4) then
		bankid = dlg.ala.id;
	elseif(bankidx == 5) then
		bankid = dlg.system.id;
	end
	if(w1_cfg_settings.old_bankidx ~= bankidx) then
		if(w1_cfg_settings.old_bankidx == 0) then
				
		elseif(w1_cfg_settings.old_bankidx == 1) then
			old_bankidx = dlg.channel.id;
		elseif(w1_cfg_settings.old_bankidx == 2) then
			old_bankidx = dlg.storage.id;
		elseif(w1_cfg_settings.old_bankidx == 3) then
			old_bankidx = dlg.netword.id;
		elseif(w1_cfg_settings.old_bankidx == 4) then	
			old_bankidx = dlg.ala.id;
		elseif(w1_cfg_settings.old_bankidx == 5) then
			old_bankidx = dlg.system.id;
		end
			if( old_bankidx ~= 0) then
				b_wnd_ex.set_color(top, old_bankidx, 
						{COLOR('c_nav_bg_n'), COLOR('c_nav_border_n'), COLOR('c_nav_text_n')}, true);
			end
			if( bankid ~= 0) then
				b_wnd_ex.set_color(top, bankid, 
						{COLOR('c_nav_bg_f'), COLOR('c_nav_border_f'), COLOR('c_nav_text_f')}, true);
			end
			
		w1_cfg_settings.old_bankidx = bankidx
	end
end

local set_disp_channel = function(top, privilege)
	local CAMERA 		= 1;
	local ENCODE 		= 2;
	local IMAGE 		= 3;
	local OSD 			= 4;
	local PRIZONE 		= 5;
	local CHN_TYPE 		= 6;
	local ROI 			= 7;
	local MICROPHONE	= 8;
	local HUMANTHERMOMETER = 9;
	local AI			= 10;
	local TRACK			= 11;
	local cwnd = w1_cfg_settings.dlg;
	local chtab = {false, false, false, false, false,false, false, false, false,false};
	local pritab = {true, true, true, true, true, true, true, true, true, true};
	local pb_flag = global_val.get_playback_support();
	local nav_size = SIZE('s_nav_title_xywh');
	local param = 
	{
		title ={nav_size[1],nav_size[2],STR('LA_CHANNEL'), FONT('f_navtitle'), false, 1},
		t_imgs = {b_ui.ALIGN.CENTER,FONT('f_navimg'),T_IMG('it_channel'),T_IMG('it_channel'), T_IMG('it_channel')},
		items = {},
		pritable = {};
	};
	local chn_type_support = global_val.get_chn_type_support();
	local idx = 0;
	local idx_table = 
	{
		{true,CAMERA,STR('LA_CAMERA')},
		{true,ENCODE,STR('LA_ENCODE_PARAMETER')},
		{true,IMAGE,STR('LA_SENSOR_SETTING')},
		{true,OSD,STR('LA_OSD')},
		{true,PRIZONE,STR('LA_PRIVACY_MASK')},
		{chn_type_support,CHN_TYPE,STR('LA_CHANNEL_TYPE')},
		{true,ROI,STR('LA_ROI')},
		{true,MICROPHONE,STR('LA_MICRO_PHONE')},
		{true,HUMANTHERMOMETER,STR('LA_HUMAN_THERMOMETER')},
		{true,AI,STR('LA_AI')},
		{true,TRACK,STR('LA_INTELLIGENT_TRACK')},
	}
	
	local add_title_item = function (idx,str,id)
		if (pb_flag == true) then
			nav_size = SIZE('s_nav_ch_xywh_'..idx);
		else
			nav_size = SIZE('s_nav_ch_exp_xywh_'..idx);
		end
		param.items[id] = {nav_size[1], nav_size[2], nav_size[3], nav_size[4], str, FONT('f_navitem')};
	end
	local more_title = 0;
	for i,v in ipairs(idx_table) do
		if v[1] then
			idx = idx + 1
			if idx == 10 then
				more_title = i
			end
			if idx >10 then
				param.items[more_title] = {nav_size[1], nav_size[2], nav_size[3], nav_size[4], " . . .", FONT('f_navitem')};
				break;
			else
				add_title_item(idx,v[3],v[2])
			end
		else
			param.items[v[2]] =  {0,0, 0, 0, '', 0};			
		end
	end
	--õؼÿһʧ
	if(privilege.channel_manager) then
		chtab[ENCODE] = false;chtab[IMAGE] = false;chtab[OSD] = false;
		chtab[PRIZONE] = false; chtab[ROI] = false;chtab[MICROPHONE] = false;
		chtab[HUMANTHERMOMETER] = false;chtab[AI] = false;chtab[TRACK] = false;
	else
		chtab[ENCODE] = true;chtab[IMAGE] = true;chtab[OSD] = true;
		chtab[PRIZONE] = true; chtab[ROI] = true;chtab[MICROPHONE] = true;
		chtab[HUMANTHERMOMETER] = true;chtab[AI] = true;chtab[TRACK] = true;
	end
	if(privilege.device_manager) then
		chtab[CAMERA] = false; chtab[CHN_TYPE] = false;
	else
		chtab[CAMERA] = true; chtab[CHN_TYPE] = true;
	end
	--ͨȨޣͨȨͨȨ.
	if(global_val.get_isallprizero(privilege.channel_manager_list)) then		
		pritab[ENCODE] = false;pritab[IMAGE] = false;pritab[OSD] = false;
		pritab[PRIZONE] = false; pritab[ROI] = false;pritab[MICROPHONE] = false;
		pritab[HUMANTHERMOMETER] = false;pritab[AI] = false;pritab[TRACK] = false;
		do_noprivilege(top);--Ȩ޶Իʾַ
	else
		pritab[ENCODE] = true;pritab[IMAGE] = true;pritab[OSD] = true;
		pritab[PRIZONE] = true;	pritab[ROI] = true;pritab[MICROPHONE] = true;
		pritab[HUMANTHERMOMETER] = true;pritab[AI] = true;pritab[TRACK] = true;
	end

	--ñǷʧ
	if(privilege.channel_manager == false and privilege.device_manager == false) then
		param.title[5] = true;	
	else
		param.title[5] = false;
	end
	--õ֮תҳ.
	--(ChannelµCameraȨ,EncodeȨޣʱӦתEncodeҳ)
	if(privilege.channel_manager == true and privilege.device_manager == false) then
		param.title[6] = 2; 
	else
		param.title[6] = 1; 
	end
	
	param.disabletable = chtab;
	param.pritable = pritab;
	b_wnd_ex.set_nav_attr(top, cwnd.channel.id, param, false);
end

local set_disp_record = function(top, privilege)
	local RECORD 	= 1;
	local DISK 		= 2;
	local SMART     = 3;
	local RAID 		= 4;
	local BAD		= 5;
	local GROUP		= 6;
	local CLOUD		= 7;
	local DIS_CAL	= 8;
	local FTP		= 9;
	local cwnd = w1_cfg_settings.dlg;
	
	local recordtab = {false, false, false};
	local nav_size = SIZE('s_nav_title_xywh');
	local param = 
	{
		title ={nav_size[1],nav_size[2],STR('LA_STORAGE'), FONT('f_navtitle'), false, 1},
		t_imgs = {b_ui.ALIGN.CENTER,FONT('f_navimg'),T_IMG('it_disk'),T_IMG('it_disk'), T_IMG('it_disk')},
		items = {},
	};
	local raid_support_flag = global_val.get_raid_support();
	local smart_support_flag = global_val.get_smart_support();
	local bad_detection_flag = global_val.get_bad_detection_attr();
	local cloud_support_flag = global_val.get_cloud_support();
	
	local idx_table = 
	{
		{true,RECORD,STR('LA_RECORD_POLICY')},
		{true,DISK,STR('LA_DISK_CONFIG')},
		{true,GROUP,STR('LA_STORAGE_MODE')},
		{smart_support_flag,SMART,STR('LA_SMART')},
		{raid_support_flag,RAID,STR('LA_RAID')},
		{bad_detection_flag,BAD,STR('LA_BAD_SECTOR')},
		{cloud_support_flag,CLOUD,STR('LA_CLOUD_STORAGE')},
		{true,DIS_CAL,STR('LA_DIS_CAL')},
		{true,FTP,STR('LA_FTP')}
	}
	local idx = 0;

	local add_title_item = function (idx,str,id)
		nav_size = SIZE('s_nav_sto_xywh_'..idx);
		param.items[id] = {nav_size[1], nav_size[2], nav_size[3], nav_size[4], str, FONT('f_navitem')};
	end
	local more_title = 0;
	for i,v in ipairs(idx_table) do
		if v[1] then
			idx = idx + 1
			if idx == 10 then
				more_title = i
			end
			if idx >10 then
				param.items[more_title] = {nav_size[1], nav_size[2], nav_size[3], nav_size[4], " . . .", FONT('f_navitem')};
				break;
			else
				add_title_item(idx,v[3],v[2])
			end
		else
			param.items[v[2]] =  {0,0, 0, 0, '', 0};			
		end
	end
	
	if(privilege.systerm_config) then
		param.title[5] = false;
		recordtab[RECORD] = false;
		recordtab[DISK] = false;
		recordtab[SMART] = false;
		recordtab[RAID] = false;
		recordtab[BAD] = false;
		recordtab[GROUP] = false;
		recordtab[CLOUD] = false;
		recordtab[DIS_CAL] = false;
		recordtab[FTP] = false;
	else
		param.title[5] = true;
		recordtab[RECORD] = true;
		recordtab[DISK] = true;
		recordtab[SMART] = true;
		recordtab[RAID] = true;
		recordtab[BAD] = true;
		recordtab[GROUP] = true;
		recordtab[CLOUD] = true;
		recordtab[DIS_CAL] = true;
		recordtab[FTP] = true;
	end
	param.disabletable = recordtab;
	b_wnd_ex.set_nav_attr(top, cwnd.storage.id, param, false);
end

local set_disp_net = function(top, privilege,snmp_support)
	local NETWORK 	= 1;
	local N8021X	= 2;
	local DDNS 		= 3;
	local EMAIL 	= 4;
	local UPNP 		= 5;
	local PP 		= 6;
	local IPFILTER 	= 7;
	local SNMP 		= 8;
	local N3G_4G	= 9;
	local PPPOE		= 10;
	local POE 		= 11;
	local LAN_INFO	= 12;
	local ALARM_CENTER = 13;
	local PLATFORM_ACCESS = 14;

	local num		= {};
	local idx		= 0;
	local cwnd = w1_cfg_settings.dlg;
	local nettab = {false, false, false, false, false, false};
	local nav_size = SIZE('s_nav_title_xywh');
	local param = 
	{
		title ={nav_size[1],nav_size[2],STR('LA_NETWORK'), FONT('f_navtitle'), false, 1},
		t_imgs = {b_ui.ALIGN.CENTER,FONT('f_navimg'),T_IMG('it_netword'),T_IMG('it_netword'), T_IMG('it_netword')},
		items = {},
	};
	local mobile_3g_flag = global_val.get_support_mobile_3g_attr();
	local pppoe_flag = global_val.get_support_pppoe_attr();
	local poe_flag = global_val.get_network_map_support()
	local pb_flag = global_val.get_playback_support();
	local p2p_flag = global_val.get_p2p_support();
	local alarm_center_support = global_val.get_alarm_center_support();
	local platform_access_support = global_val.get_platform_access_support();
	
	local idx_table = 
	{
		{true,NETWORK,STR('LA_NETWORK')},--{ҳתidⷭ}
		{true,N8021X,STR('LA_8021X')},
		{true,DDNS,STR('LA_DDNS')},
		{true,UPNP,STR('LA_PORT_MAP')},
		{true,EMAIL,STR('LA_SMTP')},		
		{p2p_flag,PP,STR('LA_PTWOP')},
		{true,IPFILTER,STR('LA_IP_FILTER')},
		{snmp_support,SNMP,STR('LA_SNMP')},
		{mobile_3g_flag,N3G_4G,STR('LA_3G_4G')},
		{pppoe_flag,PPPOE,STR('LA_PPPOE')},
		{poe_flag,POE,STR('LA_POE_STATE')},
		{true,LAN_INFO,STR('LA_NETOWRK_TRAFFIC')},
		{alarm_center_support, ALARM_CENTER, STR('LA_ALARM_SER_CENTER')},
		{platform_access_support, PLATFORM_ACCESS, STR('LA_PLATFORM_ACCESS')}
	}
	
	local add_title_item = function (idx,str,id)
		if (pb_flag == true) then
			nav_size = SIZE('s_nav_net_xywh_'..idx);
		else
			nav_size = SIZE('s_nav_net_exp_xywh_'..idx);
		end		
		param.items[id] = {nav_size[1], nav_size[2], nav_size[3], nav_size[4], str, FONT('f_navitem')};
	end
	local more_title = 0;
	for i,v in ipairs(idx_table) do
		if v[1] then
			idx = idx + 1
			if idx == 10 then
				more_title = i
			end
			if idx >10 then
				param.items[more_title] = {nav_size[1], nav_size[2], nav_size[3], nav_size[4], " . . .", FONT('f_navitem')};
				break;
			else
				add_title_item(idx,v[3],v[2])
			end
		else
			param.items[v[2]] =  {0,0, 0, 0, '', 0};		
		end
	end

	if(privilege.systerm_config) then
		param.title[5] = false;
		nettab[NETWORK] = false;nettab[N8021X] = false;nettab[DDNS] = false;nettab[EMAIL] = false;
		nettab[UPNP] = false;nettab[PP] = false;nettab[IPFILTER] = false;nettab[SNMP] = false;
		nettab[N3G_4G] = false;nettab[PPPOE] = false;nettab[POE] =false;nettab[LAN_INFO] =false;nettab[ALARM_CENTER] =false;
	else
		param.title[5] = true;
		nettab[NETWORK] = true;nettab[N8021X] = true;nettab[DDNS] = true;nettab[EMAIL] = true;
		nettab[UPNP] = true;nettab[PP] = true;nettab[IPFILTER] = true;nettab[SNMP] = true;
		nettab[N3G_4G] = true;nettab[PPPOE] = true;nettab[POE] =true;nettab[LAN_INFO] = true;nettab[ALARM_CENTER] =true;
	end
	param.disabletable = nettab;
	b_wnd_ex.set_nav_attr(top, cwnd.netword.id, param, false);
end

local set_disp_alarm = function(top, privilege, ai_num, dev_type)
	local GENERAL 		= 1;
	local MOTION 		= 2;
	local TAMPER 		= 3;
	local LOSS 			= 4;
	local ADV_INSIGHT 	= 5;
	local INSIGHT 		= 6;
	local ALARMIN 		= 7;
	local ABNORMAL  	= 8;
	local ALARMOUT  	= 9;
	local ADAM  		= 10; 	--ADAM
	local NVR_INSIGHT  	= 11; 	--NVRܷ
	local cwnd = w1_cfg_settings.dlg;

	local alarmttab = {false, false, false, false, false,false, false, false, false, false};
	local pritable = {true, true, true, true, true, true, true,true, true, true};
	local nav_size = SIZE('s_nav_title_xywh');
	local param = {
			title ={nav_size[1],nav_size[2],STR('LA_ALARM'), FONT('f_navtitle'), false, 1},
			t_imgs = {b_ui.ALIGN.CENTER,FONT('f_navimg'),T_IMG('it_alarm'),T_IMG('it_alarm'), T_IMG('it_alarm')},
			items = {},
			pritable = {};		
		};
	local dev_flag = false
	if dev_type == 2 then
		dev_flag = true;
	end
	
	local svp_support;
	if (global_val.get_support_svp() == 0) then
		svp_support = false;
	else
		svp_support = true;
	end

	local adam_support = global_val.get_adam_support();
	
	local idx = 0;
	local idx_table = 
	{
		{true,GENERAL,STR('LA_SURVEILLANCE')},--{ҳתidⷭ}
		{true,MOTION,STR('LA_MOTION_DETECTION')},
		{dev_flag,TAMPER,STR('LA_TAMPER_ALARM')},
		{true,LOSS,STR('LA_VIDEO_LOST')},
		{true,ADV_INSIGHT,STR('LA_ADVANCED_INTELLIGENCE_ANALYSIS')},		
		{true,INSIGHT,STR('LA_INSIGHT')},		
		{true,ALARMIN,STR('LA_ALARM_IN')},
		{true,ABNORMAL,STR('LA_ABNORMAL_ALARM')},
		{true,ALARMOUT,STR('LA_ALARM_OUT')},
		{adam_support,ADAM,STR('LA_ADAM')},
		{svp_support,NVR_INSIGHT,STR('LA_LOCAL_INSIGHT')},		
	}
	
	local add_title_item = function (idx,str,id)
		nav_size = SIZE('s_nav_ala_xywh_'..idx);
		param.items[id] = {nav_size[1], nav_size[2], nav_size[3], nav_size[4], str, FONT('f_navitem')};
	end
	local more_title = 0;
	for i,v in ipairs(idx_table) do
		if v[1] then
			idx = idx + 1
			if idx == 8 then
				more_title = i
			end
			if idx >8 then
				param.items[more_title] = {nav_size[1], nav_size[2], nav_size[3], nav_size[4], " . . .", FONT('f_navitem')};
				break;
			else
				add_title_item(idx,v[3],v[2])
			end
		else
			param.items[v[2]] =  {0,0, 0, 0, '', 0};			
		end
	end
	
	if(privilege.systerm_config == false and privilege.channel_manager == false) then
		param.title[5] = true; 
	else
		param.title[5] = false; 
	end
	
	if(privilege.systerm_config) then
		alarmttab[ABNORMAL] = false;
		param.title[6] = 1; 
		alarmttab[GENERAL] = false;
	else
		alarmttab[ABNORMAL] = true;
		param.title[6] = 2; 
		alarmttab[GENERAL] = true;
	end
	
	if(privilege.channel_manager) then
		alarmttab[MOTION] = false;alarmttab[TAMPER] = false;alarmttab[LOSS] = false; 
		alarmttab[ADV_INSIGHT] = false; alarmttab[INSIGHT] = false; alarmttab[NVR_INSIGHT] = false;--alarmttab[ABNORMAL] = false;
	else
		alarmttab[MOTION] = true;alarmttab[TAMPER] = true;alarmttab[LOSS] = true;
		alarmttab[ADV_INSIGHT] = true; alarmttab[INSIGHT] = true; alarmttab[NVR_INSIGHT] = true --alarmttab[ABNORMAL] = true;
	end	
	local ai_num = global_val.get_sinum()
	local ro_num = global_val.get_ronum()
	if (privilege.systerm_config and ai_num>0)  or privilege.channel_manager then
		alarmttab[ALARMIN] = false;
	else
		alarmttab[ALARMIN] = true;
	end
	
	if (privilege.systerm_config and ro_num>0)  or privilege.channel_manager then
		alarmttab[ALARMOUT] = false;
	else
		alarmttab[ALARMOUT] = true;
	end
	
	param.disabletable = alarmttab;
	param.pritable = pritable;
	b_wnd_ex.set_nav_attr(top, cwnd.ala.id, param, false);
end

local set_disp_sys = function(top, privilege)
	local INFORMATION 	= 1;
	local GENERAL 		= 2;
	local USER 			= 3;
	local PASSWORD 		= 4;
	local DISPLAY 		= 5;
	local AUXILIARY		= 6;
	local LOG 			= 7;
	local MAINTENANCE 	= 8;
	local RESTART		= 9;
	local auxi_attr = global_val.get_support_auxiliary_attr();
	local cwnd = w1_cfg_settings.dlg;
	local systab = {false, false, false, false, false, false, false,false, false, false};
	local nav_size = SIZE('s_nav_title_xywh');
	local param = 
	{
		title ={nav_size[1],nav_size[2],STR('LA_SYSTEM'), FONT('f_navtitle'), false, 1},
		t_imgs = {b_ui.ALIGN.CENTER,FONT('f_navimg'),T_IMG('it_system'),T_IMG('it_system'), T_IMG('it_system')},
		items = {},
	}
	
	local idx = 0;
	local idx_table = 
	{
		{true,INFORMATION,STR('LA_DEVICE_INFOR')},--{ҳתidⷭ}
		{true,GENERAL,STR('LA_BASIC_SETTING')},
		{true,USER,STR('LA_USER_ACCOUNT')},
		{true,PASSWORD,STR('LA_SEC_CENTER')},
		{true,DISPLAY,STR('LA_LAYOUT')},		
		{auxi_attr,AUXILIARY,STR('LA_AUXILIARY')},
		{true,LOG,STR('LA_LOG_MANAGEMENT')},
		{true,MAINTENANCE,STR('LA_MAINTENANCE')},
		{true,RESTART,STR('LA_AUTOMATIC_RESTART')},
	}
	
	local add_title_item = function (idx,str,id)
		nav_size = SIZE('s_nav_sys_xywh_'..idx);
		param.items[id] = {nav_size[1], nav_size[2], nav_size[3], nav_size[4], str, FONT('f_navitem')};
	end
	local more_title = 0;
	for i,v in ipairs(idx_table) do
		if v[1] then
			idx = idx + 1
			if idx == 12 then
				more_title = i
			end
			if idx >12 then
				param.items[more_title] = {nav_size[1], nav_size[2], nav_size[3], nav_size[4], " . . .", FONT('f_navitem')};
				break;
			else
				add_title_item(idx,v[3],v[2])
			end
		else
			param.items[v[2]] =  {0,0, 0, 0, '', 0};			
		end
	end
	
	if(privilege.systerm_config) then
		systab[GENERAL] = false;systab[USER] = false;systab[DISPLAY] = false;	
		systab[AUXILIARY] = false;
	else
		systab[GENERAL] = true;systab[USER] = true;systab[DISPLAY] = true;
		systab[AUXILIARY] = true;
	end
	
	--adminûû
	local user_info	= global_val.get_user_info()
	local root_name = global_val.get_root_user_name();
	if(user_info.m_strUsername == root_name) then
		systab[USER] = false;
	else
		systab[USER] = true;
	end
	if(privilege.system_maintenance) then
		systab[RESTART] = false;
	else
		systab[RESTART] = true;
	end		
	
	param.disabletable = systab;
	b_wnd_ex.set_nav_attr(top, cwnd.system.id, param, false);
end


w1_cfg_settings.on_create = function(top)
	w1_cfg_settings.top = top
	w1_cfg_settings.dlg = dlg
	
	b_parser(top, w1_cfg_settings.dlg)
	
	--ֳʱ
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_chcek_login)	
	
	return 0;
end

w1_cfg_settings.on_pre_show = function(top)
	local ai_num = global_val.get_sinum()
	local privilege = global_val.get_allprivilege();--ȡȨ
	local dev_type = global_val.get_dev_type()	
	local  snmp_support = global_val.get_snmp_support()	
	local cwnd = w1_cfg_settings.dlg;
	local pb_flag = global_val.get_playback_support();
	
	if (pb_flag ~= true) then
		local pos = SIZE('s_nav_channel_exp_xywh');
		b_wnd_ex.move_ex(top, w1_cfg_settings.dlg.channel.id, pos, false);
		pos = SIZE('s_nav_netword_exp_xywh');
		b_wnd_ex.move_ex(top, w1_cfg_settings.dlg.netword.id, pos, false);
	end	
	
	
	--ͨ
	set_disp_channel(top, privilege);
	--洢
	set_disp_record(top, privilege);	
	--
	set_disp_net(top, privilege,snmp_support);
	--
	set_disp_alarm(top, privilege, ai_num , dev_type);
	--ϵͳ
	set_disp_sys(top, privilege);
	
	if (pb_flag ~= true) then
		b_wnd_ex.set_hide(top, cwnd.storage.id, true, false);
	end	
	
	return 0;
end

w1_cfg_settings.on_destroy = function(top)
	w1_cfg_settings.top = nil;
	w1_cfg_settings.dlg = nil;
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)	
	return 0;
end

w1_cfg_settings.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top);
	local dlgsize = SIZE(dlg.attr.xywh);
	b_wnd.draw_fill(top, dlgsize[1], dlgsize[2], dlgsize[3], dlgsize[4], COLOR('c_nav_bg'));
	b_wnd.end_job(top);
	return 0;
end

w1_cfg_settings.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if  b_ui.RBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	elseif  (b_ui.MOUSEMOVE == vmsg )then
		local pb_flag = global_val.get_playback_support();
		local banksize = nil
		if (pb_flag == true) then
			banksize = {dlg.channel.id, dlg.storage.id, dlg.netword.id,dlg.ala.id, dlg.system.id};
 		else
			banksize = {dlg.channel.id, dlg.netword.id,dlg.ala.id, dlg.system.id};
		end
		
		local dlgsize = b_wnd.get_dlg_a_rect(top);
		local cur_bank = 0;
		local cursize;
		for i = 1, #banksize do	
			cursize	 = b_wnd.get_wnd_a_rect(top, banksize[i]);
			cursize[1] = cursize[1] + dlgsize[1];
			cursize[2] = cursize[2] + dlgsize[2];
			if(x >= cursize[1] and x <= cursize[1] + cursize[3] and
				y >= cursize[2] and y <= cursize[2] + cursize[4]) then
				cur_bank = i;
				break;
			end
		end
			
		if (pb_flag ~= true and cur_bank > 1) then
			cur_bank = cur_bank + 1;
		end
		refreshbank_bg(top, cur_bank);
		return 0;
	end
	return 0;
end

return w1_cfg_settings;
