--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/4
-- author lsl
-- brief  öԻ
--]]
local global_val			= require("wnd.global_val")
local b_wnd 				= require("wnd.core.b_wnd")
local b_wnd_ex 				= require("wnd.core.b_wnd_ex")
local b_dlg 				= require("wnd.core.b_dlg")
local b_parser 				= require("wnd.core.b_parser")
local b_ui					= require("wnd.core.b_ui")
local w1_key 				= require("wnd.w1_util.w1_key")
local w1_id 				= require("wnd.w1_util.w1_id")
local id 					= w1_id.cfg_setup.id
local r_color				= require("wnd.core.r_res.r_color")
local COLOR 				= r_color.get_color
local r_str					= require("wnd.core.r_res.r_str")
local w1_wnd_jump			= require("wnd.w1_cfg.w1_wnd_jump")
local b_ui_msg  			= require("wnd.w1_util.w1_ui_msg") 
local w1_cfg_setup_title 	= require("wnd.w1_cfg.w1_cfg_setup_title")
local b_app_cfg				= require("wnd.core.b_app_cfg")
local b_app_api 			= require("wnd.core.command.b_app_api")
local w1_wnd_util			= require("wnd.w1_cfg.w1_wnd_util")

local cfg_setup = {
	t = w1_key.DLG_CFG_SETUP,
	top = nil,
	dlg = nil,
	cur_page,
	phone_open_ch,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	last_home_type = 0,	--¼ýʱֳʱ ˳ʱָ
}

--ͨ
cfg_setup.page_channel = 
{
	w1_col_channel 			= require("wnd.w1_cfg.w1_col_channel"),
	w1_row_camera			= require("wnd.w1_cfg.w1_row_camera"),
	w1_row_encode			= require("wnd.w1_cfg.w1_row_encode"),
	w1_row_image			= require("wnd.w1_cfg.w1_row_image"),
	w1_row_privacyarea		= require("wnd.w1_cfg.w1_row_privacyarea"),
	w1_row_osd				= require("wnd.w1_cfg.w1_row_osd"),
	w1_row_channel_type 	= require("wnd.w1_cfg.w1_row_channel_type"),
	w1_row_roi				= require("wnd.w1_cfg.w1_row_roi"),
	w1_row_microphone 		= require("wnd.w1_cfg.w1_row_microphone"),
	w1_row_human_thermometer= require("wnd.w1_cfg.w1_row_human_thermometer"),
	w1_row_ai				= require("wnd.w1_cfg.w1_row_ai"),
	w1_row_track			= require("wnd.w1_cfg.w1_row_track"),
	w1_page_camera			= require("wnd.w1_cfg.w1_page_camera"),
	w1_page_pro_man			= require("wnd.w1_cfg.w1_page_pro_man"),
	w1_page_encode			= require("wnd.w1_cfg.w1_page_encode"),
	w1_page_image			= require("wnd.w1_cfg.w1_page_image"),
	w1_page_privacyarea		= require("wnd.w1_cfg.w1_page_privacyarea"),
	w1_page_osd				= require("wnd.w1_cfg.w1_page_osd"),
	w1_page_roi 			= require("wnd.w1_cfg.w1_page_roi"),
	w1_page_track 			= require("wnd.w1_cfg.w1_page_track"),
	w1_page_channel_type 	= require("wnd.w1_cfg.w1_page_channel_type"),
	w1_page_analog_audio_in = require("wnd.w1_cfg.w1_page_analog_audio_in"),	
	w1_page_microphone 		= require("wnd.w1_cfg.w1_page_microphone"),
	w1_page_param_conf		= require("wnd.w1_cfg.w1_page_param_conf"),
	w1_page_thermal_map		= require("wnd.w1_cfg.w1_page_thermal_map"),
	w1_page_thermal_cal		= require("wnd.w1_cfg.w1_page_thermal_cal"),
	w1_page_multi_obj		= require("wnd.w1_cfg.w1_page_multi_obj"),
	w1_page_plate			= require("wnd.w1_cfg.w1_page_plate"),
	w1_page_face			= require("wnd.w1_cfg.w1_page_face"),
	w1_page_imagetime 		= require("wnd.w1_cfg.w1_page_imagetime"),--ǰ
	w1_page_imageadjust		= require("wnd.w1_cfg.w1_page_imageadjust"),
	w1_page_imagescenes		= require("wnd.w1_cfg.w1_page_imagescenes"),
	w1_page_imageexposure	= require("wnd.w1_cfg.w1_page_imageexposure"),
	w1_page_imagebalance 	= require("wnd.w1_cfg.w1_page_imagebalance"),
	w1_page_imagedaynight 	= require("wnd.w1_cfg.w1_page_imagedaynight"),
	w1_page_imagenoise		= require("wnd.w1_cfg.w1_page_imagenoise"),
	w1_page_imageenhance  	= require("wnd.w1_cfg.w1_page_imageenhance"),
	w1_page_imagefocus		= require("wnd.w1_cfg.w1_page_imagefocus"),
	w1_page_imagepcolor		= require("wnd.w1_cfg.w1_page_imagepcolor"),
	w1_page_imageffc		= require("wnd.w1_cfg.w1_page_imageffc"),
	w1_page_param_confface_detect	= require("wnd.w1_cfg.w1_page_param_confface_detect"),
	w1_page_param_conftemp_param	= require("wnd.w1_cfg.w1_page_param_conftemp_param"),
	w1_page_param_conf_levent		= require("wnd.w1_cfg.w1_page_param_conf_levent"),
	w1_page_param_conf_nevent		= require("wnd.w1_cfg.w1_page_param_conf_nevent"),
	w1_page_param_conf_hevent		= require("wnd.w1_cfg.w1_page_param_conf_hevent"),
	w1_page_param_conftimeplan		= require("wnd.w1_cfg.w1_page_param_conftimeplan"),
	w1_page_multi_objparam			= require("wnd.w1_cfg.w1_page_multi_objparam"),
	w1_page_multi_objtimeplan		= require("wnd.w1_cfg.w1_page_multi_objtimeplan"),
	w1_page_plateparam				= require("wnd.w1_cfg.w1_page_plateparam"),
	w1_page_plateblackwhite			= require("wnd.w1_cfg.w1_page_plateblackwhite"),	
	w1_page_plateledcfg				= require("wnd.w1_cfg.w1_page_plateledcfg"),
	w1_page_platetimeplan		= require("wnd.w1_cfg.w1_page_platetimeplan"),
	w1_page_faceparam			= require("wnd.w1_cfg.w1_page_faceparam");
	w1_page_facetimeplan		= require("wnd.w1_cfg.w1_page_facetimeplan"),
	w1_row_imagerow			= require("wnd.w1_cfg.w1_row_imagerow"),
	w1_row_param_confrow	= require("wnd.w1_cfg.w1_row_param_confrow"),
	w1_row_multi_objrow		= require("wnd.w1_cfg.w1_row_multi_objrow"),
	w1_row_platerow			= require("wnd.w1_cfg.w1_row_platerow"),
	w1_row_facerow			= require("wnd.w1_cfg.w1_row_facerow"),
};

--洢
cfg_setup.page_record =
{
	w1_col_storage 			= require("wnd.w1_cfg.w1_col_storage"),
	w1_row_record			= require("wnd.w1_cfg.w1_row_record"),
	w1_row_diskcfg			= require("wnd.w1_cfg.w1_row_diskcfg"),
	w1_row_raid				= require("wnd.w1_cfg.w1_row_raid"),
	w1_row_smart			= require("wnd.w1_cfg.w1_row_smart"),
	w1_row_bad_detection  	= require("wnd.w1_cfg.w1_row_bad_detection"),
	w1_row_disk_group		= require("wnd.w1_cfg.w1_row_group"),
	w1_row_cloud			= require("wnd.w1_cfg.w1_row_cloud"),
	w1_row_dis_cal			= require("wnd.w1_cfg.w1_row_dis_cal"),
	w1_row_ftp				= require("wnd.w1_cfg.w1_row_ftp"),
	w1_page_record			= require("wnd.w1_cfg.w1_page_record"),
	w1_page_diskcfg			= require("wnd.w1_cfg.w1_page_diskcfg"),
	w1_page_raid			= require("wnd.w1_cfg.w1_page_raid"),
	w1_page_smart			= require("wnd.w1_cfg.w1_page_smart"),
	w1_page_wdda			= require("wnd.w1_cfg.w1_page_wdda"),
	w1_page_bad_detection 	= require("wnd.w1_cfg.w1_page_bad_detection"),
	w1_page_disk_group		= require("wnd.w1_cfg.w1_page_group"),
	w1_page_cloud			= require("wnd.w1_cfg.w1_page_cloud"),
	w1_page_dis_cal			= require("wnd.w1_cfg.w1_page_dis_cal"),
	w1_page_ftp				= require("wnd.w1_cfg.w1_page_ftp"),
};

--
cfg_setup.page_network =
{
	w1_col_net 				= require("wnd.w1_cfg.w1_col_net"),
	w1_row_net				= require("wnd.w1_cfg.w1_row_net"),
	w1_row_8021x 			= require("wnd.w1_cfg.w1_row_8021x"),
	w1_row_ddns				= require("wnd.w1_cfg.w1_row_ddns"),
	w1_row_smtp				= require("wnd.w1_cfg.w1_row_smtp"),
	w1_row_upnp				= require("wnd.w1_cfg.w1_row_upnp"),
	w1_row_pp				= require("wnd.w1_cfg.w1_row_pp"),
	w1_row_filter			= require("wnd.w1_cfg.w1_row_filter"),
	w1_row_snmp				= require("wnd.w1_cfg.w1_row_snmp"),
	w1_row_3g_4g			= require("wnd.w1_cfg.w1_row_3g_4g"),
	w1_row_pppoe	   		= require("wnd.w1_cfg.w1_row_pppoe"),
	w1_row_net_stat	   		= require("wnd.w1_cfg.w1_row_net_stat"),
	w1_row_lan_info			= require("wnd.w1_cfg.w1_row_lan_info"),
	w1_row_alarm_service_center  = require("wnd.w1_cfg.w1_row_alarm_service_center"),
	w1_row_platform_access	= require("wnd.w1_cfg.w1_row_platform_access"),
	w1_page_ip				= require("wnd.w1_cfg.w1_page_ip"),
	w1_page_port 			= require("wnd.w1_cfg.w1_page_port"),
	w1_page_poe 			= require("wnd.w1_cfg.w1_page_poe"),
	w1_page_ipv4_cctv 		= require("wnd.w1_cfg.w1_page_ipv4_cctv"),
	w1_page_eth_route		= require("wnd.w1_cfg.w1_page_eth_route"),
	w1_page_8021x			= require("wnd.w1_cfg.w1_page_8021x"),
	w1_page_ddns			= require("wnd.w1_cfg.w1_page_ddns"),
	w1_page_smtp			= require("wnd.w1_cfg.w1_page_smtp"),
	w1_page_smtp2			= require("wnd.w1_cfg.w1_page_smtp2"),
	w1_page_immix			= require("wnd.w1_cfg.w1_page_immix"),
	w1_page_upnp			= require("wnd.w1_cfg.w1_page_upnp"),
	w1_page_nat_port		= require("wnd.w1_cfg.w1_page_nat_port"),
	w1_page_pp				= require("wnd.w1_cfg.w1_page_pp"),
	w1_page_ipfilter		= require("wnd.w1_cfg.w1_page_ipfilter"),
	w1_page_snmp			= require("wnd.w1_cfg.w1_page_snmp"),
	w1_page_snmp12			= require("wnd.w1_cfg.w1_page_snmp12"),
	w1_page_snmp_port		= require("wnd.w1_cfg.w1_page_snmp_port"),
	w1_page_wifi_cfg		= require("wnd.w1_cfg.w1_page_wifi_cfg"),
	w1_page_wifi_network	= require("wnd.w1_cfg.w1_page_wifi_network"),
	w1_page_3g_4g			= require("wnd.w1_cfg.w1_page_3g_4g"),
	w1_page_pppoe 			= require("wnd.w1_cfg.w1_page_pppoe"),
	w1_page_net_stat		= require("wnd.w1_cfg.w1_page_net_stat"),
	w1_page_lan_info		= require("wnd.w1_cfg.w1_page_lan_info"),
	w1_page_alarm_service_center 	= require("wnd.w1_cfg.w1_page_alarm_service_center"),
	w1_page_platform_access 	= require("wnd.w1_cfg.w1_page_platform_access"),

};

--
cfg_setup.page_alarm =
{
	w1_col_alarm 								= require("wnd.w1_cfg.w1_col_alarm"),
	w1_row_surve								= require("wnd.w1_cfg.w1_row_surve"),
	w1_row_motion								= require("wnd.w1_cfg.w1_row_motion"),
	w1_row_tamper								= require("wnd.w1_cfg.w1_row_tamper"),
	w1_row_loss									= require("wnd.w1_cfg.w1_row_loss"),
	w1_row_alarmin								= require("wnd.w1_cfg.w1_row_alarmin"),
	w1_row_alarmout								= require("wnd.w1_cfg.w1_row_alarmout"),
	w1_row_nvr_noopsyche						= require("wnd.w1_cfg.w1_row_nvr_noopsyche"),
	w1_row_adam									= require("wnd.w1_cfg.w1_row_adam"),	
	

	w1_row_noopsyche							= require("wnd.w1_cfg.w1_row_noopsyche"),
	w1_row_abnormal								= require("wnd.w1_cfg.w1_row_abnormal"),
	w1_page_surve								= require("wnd.w1_cfg.w1_page_surve"),
	w1_page_motion								= require("wnd.w1_cfg.w1_page_motion"),
	w1_page_tamper								= require("wnd.w1_cfg.w1_page_tamper"),
	w1_page_loss								= require("wnd.w1_cfg.w1_page_loss"),
	w1_page_alarmin								= require("wnd.w1_cfg.w1_page_alarmin"),
	w1_page_ioalarm								= require("wnd.w1_cfg.w1_page_ioalarm"),
	w1_page_adam								= require("wnd.w1_cfg.w1_page_adam"),	
	w1_page_alarmout							= require("wnd.w1_cfg.w1_page_alarmout"),
	w1_page_alarmout_c							= require("wnd.w1_cfg.w1_page_alarmout_c"),
	w1_page_audio_out							= require("wnd.w1_cfg.w1_page_audio_out"),
	w1_page_flash_light_alarm					= require("wnd.w1_cfg.w1_page_flash_light_alarm"),	
	w1_page_alarm_advance 					    = require("wnd.w1_cfg.w1_page_alarmin_advance"),
	w1_page_noopsyche_advance					= require("wnd.w1_cfg.w1_page_noopsyche_advance"),
	w1_page_noopsyche_badsignal					= require("wnd.w1_cfg.w1_page_noopsyche_badsignal"),
	w1_page_noopsyche_cordon					= require("wnd.w1_cfg.w1_page_noopsyche_cordon"),
	w1_page_noopsyche_dcordon					= require("wnd.w1_cfg.w1_page_noopsyche_dcordon"),
	w1_page_noopsyche_enter_area				= require("wnd.w1_cfg.w1_page_noopsyche_enter_area"),
	w1_page_noopsyche_leave_area				= require("wnd.w1_cfg.w1_page_noopsyche_leave_area"),
	w1_page_noopsyche_perimeter					= require("wnd.w1_cfg.w1_page_noopsyche_perimeter"),
	w1_page_noopsyche_objectleft				= require("wnd.w1_cfg.w1_page_noopsyche_objectleft"),
	w1_page_noopsyche_objectremove				= require("wnd.w1_cfg.w1_page_noopsyche_objectremove"),
	w1_page_noopsyche_abnormal_speed			= require("wnd.w1_cfg.w1_page_noopsyche_abnormal_speed"),
	w1_page_noopsyche_fence						= require("wnd.w1_cfg.w1_page_noopsyche_fence"),	
	w1_page_noopsyche_converse					= require("wnd.w1_cfg.w1_page_noopsyche_converse"),
	w1_page_noopsyche_illegal_packing			= require("wnd.w1_cfg.w1_page_noopsyche_illegal_packing"),
	w1_page_noopsyche_loiter					= require("wnd.w1_cfg.w1_page_noopsyche_loiter"),
	w1_page_noopsyche_multiloiter				= require("wnd.w1_cfg.w1_page_noopsyche_multiloiter"),
	w1_page_noopsyche_person_count				= require("wnd.w1_cfg.w1_page_noopsyche_person_count");	
	w1_page_abnormal							= require("wnd.w1_cfg.w1_page_abnormal"),
	w1_page_motionevent 						= require("wnd.w1_cfg.w1_page_motionevent"),
	w1_page_motionarea 							= require("wnd.w1_cfg.w1_page_motionarea"),
	w1_page_motiontimeplan 						= require("wnd.w1_cfg.w1_page_motiontimeplan"),
	w1_page_tamperevent 						= require("wnd.w1_cfg.w1_page_tamperevent"),
	w1_page_tampertimeplan 						= require("wnd.w1_cfg.w1_page_tampertimeplan"),
	w1_page_lossevent 							= require("wnd.w1_cfg.w1_page_lossevent"),
	w1_page_losstimeplan 						= require("wnd.w1_cfg.w1_page_losstimeplan"),
	w1_page_noopsycheevent_badsignal 			= require("wnd.w1_cfg.w1_page_noopsycheevent_badsignal"),
	w1_page_noopsycheevent_cordon 				= require("wnd.w1_cfg.w1_page_noopsycheevent_cordon"),
	w1_page_noopsycheevent_dcordon 				= require("wnd.w1_cfg.w1_page_noopsycheevent_dcordon"),
	w1_page_noopsycheevent_enter_area 			= require("wnd.w1_cfg.w1_page_noopsycheevent_enter_area"),
	w1_page_noopsycheevent_leave_area 			= require("wnd.w1_cfg.w1_page_noopsycheevent_leave_area"),
	w1_page_noopsycheevent_perimeter 			= require("wnd.w1_cfg.w1_page_noopsycheevent_perimeter"),
	w1_page_noopsycheevent_objectleft 			= require("wnd.w1_cfg.w1_page_noopsycheevent_objectleft"),
	w1_page_noopsycheevent_objectremove			= require("wnd.w1_cfg.w1_page_noopsycheevent_objectremove"),
	w1_page_noopsycheevent_abnormal_speed		= require("wnd.w1_cfg.w1_page_noopsycheevent_abnormal_speed"),
	w1_page_noopsycheevent_fence				= require("wnd.w1_cfg.w1_page_noopsycheevent_fence"),
	w1_page_noopsycheevent_loiter				= require("wnd.w1_cfg.w1_page_noopsycheevent_loiter"),
	w1_page_noopsycheevent_multiloiter			= require("wnd.w1_cfg.w1_page_noopsycheevent_multiloiter"),
	w1_page_noopsycheevent_converse				= require("wnd.w1_cfg.w1_page_noopsycheevent_converse"),
	w1_page_noopsycheevent_illegal_packing		= require("wnd.w1_cfg.w1_page_noopsycheevent_illegal_packing"),
	w1_page_noopsychearea_advance 				= require("wnd.w1_cfg.w1_page_noopsychearea_advance"),
	w1_page_noopsychearea_badsignal 			= require("wnd.w1_cfg.w1_page_noopsychearea_badsignal"),
	w1_page_noopsychearea_cordon 				= require("wnd.w1_cfg.w1_page_noopsychearea_cordon"),
	w1_page_noopsychearea_dcordon 				= require("wnd.w1_cfg.w1_page_noopsychearea_dcordon"),
	w1_page_noopsychearea_perimeter 			= require("wnd.w1_cfg.w1_page_noopsychearea_perimeter"),
	w1_page_noopsychearea_enter_area 			= require("wnd.w1_cfg.w1_page_noopsychearea_enter_area"),
	w1_page_noopsychearea_leave_area 			= require("wnd.w1_cfg.w1_page_noopsychearea_leave_area"),
	w1_page_noopsychearea_objectleft			= require("wnd.w1_cfg.w1_page_noopsychearea_objectleft"),
	w1_page_noopsychearea_objectremove			= require("wnd.w1_cfg.w1_page_noopsychearea_objectremove"),
	w1_page_noopsychearea_abnormal_speed		= require("wnd.w1_cfg.w1_page_noopsychearea_abnormal_speed"),
	w1_page_noopsychearea_loiter				= require("wnd.w1_cfg.w1_page_noopsychearea_loiter"),
	w1_page_noopsychearea_multiloiter			= require("wnd.w1_cfg.w1_page_noopsychearea_multiloiter"),
	w1_page_noopsychearea_converse				= require("wnd.w1_cfg.w1_page_noopsychearea_converse"),
	w1_page_noopsychearea_person_count			= require("wnd.w1_cfg.w1_page_noopsychearea_person_count"),	
	w1_page_noopsychearea_fence					= require("wnd.w1_cfg.w1_page_noopsychearea_fence"),	
	w1_page_noopsychearea_illegal_packing		= require("wnd.w1_cfg.w1_page_noopsychearea_illegal_packing"),
	w1_page_noopsychetimeplan_badsignal			= require("wnd.w1_cfg.w1_page_noopsychetimeplan_badsignal"),
	w1_page_noopsychetimeplan_cordon 			= require("wnd.w1_cfg.w1_page_noopsychetimeplan_cordon"),
	w1_page_noopsychetimeplan_dcordon			= require("wnd.w1_cfg.w1_page_noopsychetimeplan_dcordon"),
	w1_page_noopsychetimeplan_perimeter			= require("wnd.w1_cfg.w1_page_noopsychetimeplan_perimeter"),
	w1_page_noopsychetimeplan_enter_area		= require("wnd.w1_cfg.w1_page_noopsychetimeplan_enter_area"),
	w1_page_noopsychetimeplan_leave_area		= require("wnd.w1_cfg.w1_page_noopsychetimeplan_leave_area"),
	w1_page_noopsychetimeplan_objectleft		= require("wnd.w1_cfg.w1_page_noopsychetimeplan_objectleft"),
	w1_page_noopsychetimeplan_objectremove		= require("wnd.w1_cfg.w1_page_noopsychetimeplan_objectremove"),
	w1_page_noopsychetimeplan_abnormal_speed	= require("wnd.w1_cfg.w1_page_noopsychetimeplan_abnormal_speed"),
	w1_page_noopsychetimeplan_loiter			= require("wnd.w1_cfg.w1_page_noopsychetimeplan_loiter"),
	w1_page_noopsychetimeplan_multiloiter		= require("wnd.w1_cfg.w1_page_noopsychetimeplan_multiloiter"),
	w1_page_noopsychetimeplan_converse			= require("wnd.w1_cfg.w1_page_noopsychetimeplan_converse"),
	w1_page_noopsychetimeplan_illegal_packing	= require("wnd.w1_cfg.w1_page_noopsychetimeplan_illegal_packing"),
	w1_page_alarminevent 						= require("wnd.w1_cfg.w1_page_alarminevent"),
	w1_page_alarmintimeplan 					= require("wnd.w1_cfg.w1_page_alarmintimeplan"),
	w1_page_ioalarmevent 						= require("wnd.w1_cfg.w1_page_ioalarmevent"),
	w1_page_ioalarmtimeplan 					= require("wnd.w1_cfg.w1_page_ioalarmtimeplan"),
	w1_page_abnormalevent						= require("wnd.w1_cfg.w1_page_abnormalevent"),
	
	w1_page_nvr_noopsyche_general				= require("wnd.w1_cfg.w1_page_nvr_noopsyche_general"),
	w1_page_nvr_noopsyche_perimeter				= require("wnd.w1_cfg.w1_page_nvr_noopsyche_perimeter"),
	w1_page_nvr_noopsycheevent_perimeter 		= require("wnd.w1_cfg.w1_page_nvr_noopsycheevent_perimeter"),
	w1_page_nvr_noopsychearea_perimeter 		= require("wnd.w1_cfg.w1_page_nvr_noopsychearea_perimeter"),
	w1_page_nvr_noopsychetimeplan_perimeter		= require("wnd.w1_cfg.w1_page_nvr_noopsychetimeplan_perimeter"),

	w1_row_adv_insight							= require("wnd.w1_cfg.w1_row_adv_insight"),
	w1_page_adv_insight_smoker_dec				= require("wnd.w1_cfg.w1_page_adv_insight_smoker_dec"),
	w1_page_adv_insightarea_smoker_dec			= require("wnd.w1_cfg.w1_page_adv_insightarea_smoker_dec"),		
	w1_page_adv_insightevent_smoker_dec			= require("wnd.w1_cfg.w1_page_adv_insightevent_smoker_dec"),
	w1_page_adv_insighttimeplan_smoker_dec		= require("wnd.w1_cfg.w1_page_adv_insighttimeplan_smoker_dec"),	
	w1_page_adv_insight_smoker_flame			= require("wnd.w1_cfg.w1_page_adv_insight_smoker_flame"),
	w1_page_adv_insightarea_smoker_flame		= require("wnd.w1_cfg.w1_page_adv_insightarea_smoker_flame"),		
	w1_page_adv_insightevent_smoker_flame		= require("wnd.w1_cfg.w1_page_adv_insightevent_smoker_flame"),
	w1_page_adv_insighttimeplan_smoker_flame	= require("wnd.w1_cfg.w1_page_adv_insighttimeplan_smoker_flame"),	
	w1_page_adv_insight_fire_spot				= require("wnd.w1_cfg.w1_page_adv_insight_fire_spot"),
	w1_page_adv_insightarea_fire_spot			= require("wnd.w1_cfg.w1_page_adv_insightarea_fire_spot"),		
	w1_page_adv_insightevent_fire_spot			= require("wnd.w1_cfg.w1_page_adv_insightevent_fire_spot"),
	w1_page_adv_insighttimeplan_fire_spot		= require("wnd.w1_cfg.w1_page_adv_insighttimeplan_fire_spot"),	
};

--ϵͳ
cfg_setup.page_system =
{
	w1_col_sys 					= require("wnd.w1_cfg.w1_col_sys"),
	w1_row_info 				= require("wnd.w1_cfg.w1_row_info"),
	w1_row_basic 				= require("wnd.w1_cfg.w1_row_basic"),
	w1_row_user					= require("wnd.w1_cfg.w1_row_user"),
	w1_row_modify				= require("wnd.w1_cfg.w1_row_modify"),
	w1_row_out					= require("wnd.w1_cfg.w1_row_out"),
	w1_row_logman				= require("wnd.w1_cfg.w1_row_logman"),
	w1_row_devman				= require("wnd.w1_cfg.w1_row_devman"),
	w1_row_restart				= require("wnd.w1_cfg.w1_row_restart"),
	w1_row_ai_resource			= require("wnd.w1_cfg.w1_row_ai_resource"),
	w1_page_info				= require("wnd.w1_cfg.w1_page_info"),
	w1_page_info_chn			= require("wnd.w1_cfg.w1_page_info_chn"),
	w1_page_info_net			= require("wnd.w1_cfg.w1_page_info_net"),
	w1_page_info_disk			= require("wnd.w1_cfg.w1_page_info_disk"),
	w1_page_info_alarm			= require("wnd.w1_cfg.w1_page_info_alarm"),
	w1_page_sys					= require("wnd.w1_cfg.w1_page_sys"),
	w1_page_time				= require("wnd.w1_cfg.w1_page_time"),
	w1_page_tzone				= require("wnd.w1_cfg.w1_page_tzone"),
	w1_page_dst					= require("wnd.w1_cfg.w1_page_dst"),
	w1_page_ipctime				= require("wnd.w1_cfg.w1_page_ipctime"),
	w1_page_privacy				= require("wnd.w1_cfg.w1_page_privacy"),
	w1_page_pri					= require("wnd.w1_cfg.w1_page_pri"),
	w1_page_phone_filter		= require("wnd.w1_cfg.w1_page_phone_filter"),
	w1_page_modify				= require("wnd.w1_cfg.w1_page_modify"),
	w1_page_modify_g			= require("wnd.w1_cfg.w1_page_modify_g"),
	w1_page_securitymail		= require("wnd.w1_cfg.w1_page_securitymail"),
	w1_page_securityquestion	= require("wnd.w1_cfg.w1_page_securityquestion"),
	w1_page_dwell				= require("wnd.w1_cfg.w1_page_dwell"),
	w1_page_cvbsoffset			= require("wnd.w1_cfg.w1_page_cvbsoffset"),
	w1_page_cvbscolor			= require("wnd.w1_cfg.w1_page_cvbscolor"),
	w1_row_auxiliary			= require("wnd.w1_cfg.w1_row_auxiliary"),
	w1_page_auxiliary_cfg 		= require("wnd.w1_cfg.w1_page_auxiliary_cfg"),
	w1_page_auxiliary_dsp 		= require("wnd.w1_cfg.w1_page_auxiliary_dsp"),
	w1_page_devm				= require("wnd.w1_cfg.w1_page_devm"),
	w1_page_logm				= require("wnd.w1_cfg.w1_page_logm"),
	w1_page_events				= require("wnd.w1_cfg.w1_page_events"),
	w1_page_restart				= require("wnd.w1_cfg.w1_page_restart"),
	w1_page_ai_resource			= require("wnd.w1_cfg.w1_page_ai_resource"),

};

cfg_setup.audio_chn = 0;

cfg_setup.s_768 =
{
	s_cfg_xywh = {0,0,1024,768},
	s_cfg_title_xywh = {0,0,981,56},
	s_cfg_close_xywh = {992,17,12,17},
};

cfg_setup.s_1280 = 
{
	s_cfg_xywh = {0,0,1280,1024},
	s_cfg_title_xywh = {0,0,1200,79},
	s_cfg_close_xywh = {1220,25,24,24},
};
cfg_setup.s_1440 = 
{
	s_cfg_xywh = {0,0,1440,900},
	s_cfg_title_xywh = {0,0,1360,79},
	s_cfg_close_xywh = {1380,25,24,24},
};
cfg_setup.s_1080p = 
{
	s_cfg_xywh = {0,0,1920,1080},
	s_cfg_title_xywh = {0,0,1840,79},
	s_cfg_close_xywh = {1860,25,24,24},
};
cfg_setup.s_2k = 
{
	s_cfg_xywh = {0,0,2559,1440},
	s_cfg_title_xywh = {0,0,2453,105},
	s_cfg_close_xywh = {2479,33,32,32},
};
cfg_setup.s_4k = 
{
	s_cfg_xywh = {0,0,3840,2160},
	s_cfg_title_xywh = {0,0,3680,158},
	s_cfg_close_xywh = {3720,50,48,48},
};

cfg_setup.CFGPAGE = 
{
	--ͨ
	CAMERA 				= 1,
	ENCODE				= 2,
	IMAGE_PARAM			= 3,
	OSDAREA			 	= 4,
	PRIVACYAREA			= 5,
	CHANNEL_TYPE		= 6,
	ROIAREA				= 7,
	MICROPHONE			= 8,
	HUMANTHERMOMETER	= 9,
	AI					= 10,
	TRACK				= 11,
	--洢
	RECORD_POLICY		= 101,
	DISK				= 102,
	SMART				= 103,
	RAID				= 104,
	BAD_DETECTION		= 105,
	DISK_GROUP			= 106,
	CLOUD				= 107,
	DIS_CAL				= 108,
	FTP					= 109,
	--ҳ
	IPV4				= 201,
	NET8021X			= 202,
	DDNS				= 203,
	SMTP				= 204,
	UPNP				= 205,
	P2P					= 206,
	IPFILTER			= 207,
	SNMP				= 208,
	NET3G4G				= 209,
	PPPOE				= 210, 
	NET_STAT			= 211,
	LAN_INFO			= 212,
	ALARM_CENTER		= 213,	
	PLATFORM_ACCESS     = 214,
	
	--ҳ
	SURVEILLANCE		= 301,	
	MOTIONAREA		 	= 302,
	TAMPER				= 303,
	VIDEO_LOSS			= 304,
	ADV_INSIGHT			= 305,
	NOOPSYCHE			= 306,
	ALARM_IN			= 307,
	ABNORMAL			= 308,
	ALARM_OUT			= 309,
	ADAM				= 310,
	LOCAL_NOOPSYCHE		= 311,
	

	--ϵͳҳ
	INFO				= 401,
	SYSTEM				= 402,
	USER				= 403,
	MODIFYPASS			= 404,
	DWELL				= 405,
	AUXILIARY			= 406,
	LOG					= 407,
	MAINTAIN			= 408,
	RESTART				= 409,
	AI_RESOURCE			= 410,
}

local set_layout = function(top)
	--лΪҳĬϷ֣ĿΪ˹رֳ룬ʡcpu
	local param = {
		chn_id = 1,
		wnd_id = 1,
		x = 0,
		y = 0,
		cx = 640,
		cy = 360,
	}
	b_app_api.set_custom_layout_wnd(param);
end

local check_set_layout = function(top)
	local ret = true;
	local jumppage = cfg_setup.CFGPAGE
	if (cfg_setup.cur_page == jumppage.IMAGE_PARAM) then
		ret = false;
	elseif (cfg_setup.cur_page == jumppage.OSDAREA) then
		ret = false;
	elseif(cfg_setup.cur_page == jumppage.PRIVACYAREA) then
		ret = false;
	elseif(cfg_setup.cur_page == jumppage.MOTIONAREA) then
		ret = false;
	elseif(cfg_setup.cur_page == jumppage.ADV_INSIGHT) then
		ret = false;		
	elseif(cfg_setup.cur_page == jumppage.NOOPSYCHE) then
		ret = false;	
	elseif(cfg_setup.cur_page == jumppage.ROIAREA) then
		ret = false;
	elseif(cfg_setup.cur_page == jumppage.HUMANTHERMOMETER) then	
		ret = false
	elseif(cfg_setup.cur_page == jumppage.AI) then	
		ret = false
	end
	
	return ret;
end

local on_dlg = function(top, id, vmsg, x, y)
	if b_ui.TIMER == vmsg then
		local tc = b_wnd.tick_count(top);
		--ͨ
		cfg_setup.page_channel.w1_page_camera.timerenevt(top);
		cfg_setup.page_channel.w1_page_pro_man.timerenevt(top);
		cfg_setup.page_channel.w1_page_encode.timerenevt(top);
		cfg_setup.page_channel.w1_page_image.timerenevt(top);
		cfg_setup.page_channel.w1_page_privacyarea.timerenevt(top);
		cfg_setup.page_channel.w1_page_osd.timerenevt(top);
		cfg_setup.page_channel.w1_page_channel_type.timerenevt(top);
		cfg_setup.page_channel.w1_page_analog_audio_in.timerenevt(top);
		cfg_setup.page_channel.w1_page_roi.timerenevt(top);
		cfg_setup.page_channel.w1_page_track.timerenevt(top);
		cfg_setup.page_channel.w1_page_microphone.timerenevt(top);
		cfg_setup.page_channel.w1_page_param_conf.timerenevt(top);
		cfg_setup.page_channel.w1_page_thermal_map.timerenevt(top);
		cfg_setup.page_channel.w1_page_thermal_cal.timerenevt(top);
		cfg_setup.page_channel.w1_page_multi_obj.timerenevt(top);
		cfg_setup.page_channel.w1_page_plate.timerenevt(top);
		cfg_setup.page_channel.w1_page_face.timerenevt(top);
		--洢
		cfg_setup.page_record.w1_page_record.timerenevt(top);
		cfg_setup.page_record.w1_page_diskcfg.timerenevt(top);
		cfg_setup.page_record.w1_page_bad_detection.timerenevt(top);
		cfg_setup.page_record.w1_page_disk_group.timerenevt(top);
		cfg_setup.page_record.w1_page_cloud.timerenevt(top);
		cfg_setup.page_record.w1_page_dis_cal.timerenevt(top);
		cfg_setup.page_record.w1_page_ftp.timerenevt(top);
	--	cfg_setup.page_record.w1_page_raid.timerevent(top);
	--  	cfg_setup.page_record.w1_page_smart.timerevent(top);
		--
		cfg_setup.page_alarm.w1_page_surve.timerenevt(top);
		cfg_setup.page_alarm.w1_page_motion.timerenevt(top);
		cfg_setup.page_alarm.w1_page_tamper.timerenevt(top);
		cfg_setup.page_alarm.w1_page_loss.timerenevt(top);
		cfg_setup.page_alarm.w1_page_alarmin.timerenevt(top);
		cfg_setup.page_alarm.w1_page_ioalarm.timerenevt(top);
		cfg_setup.page_alarm.w1_page_alarmout.timerenevt(top);
		cfg_setup.page_alarm.w1_page_adam.timerenevt(top);
		cfg_setup.page_alarm.w1_page_alarmout_c.timerenevt(top);
		cfg_setup.page_alarm.w1_page_audio_out.timerenevt(top);
		cfg_setup.page_alarm.w1_page_flash_light_alarm.timerenevt(top);		
		cfg_setup.page_alarm.w1_page_alarm_advance.timerenevt(top);
		cfg_setup.page_alarm.w1_page_noopsyche_advance.timerenevt(top);
		cfg_setup.page_alarm.w1_page_noopsyche_badsignal.timerenevt(top);
		cfg_setup.page_alarm.w1_page_noopsyche_cordon.timerenevt(top);
		cfg_setup.page_alarm.w1_page_noopsyche_dcordon.timerenevt(top);
		cfg_setup.page_alarm.w1_page_noopsyche_perimeter.timerenevt(top);
		cfg_setup.page_alarm.w1_page_noopsyche_enter_area.timerenevt(top);
		cfg_setup.page_alarm.w1_page_noopsyche_leave_area.timerenevt(top);
		cfg_setup.page_alarm.w1_page_noopsyche_objectleft.timerenevt(top);
		cfg_setup.page_alarm.w1_page_noopsyche_objectremove.timerenevt(top);
		cfg_setup.page_alarm.w1_page_noopsyche_fence.timerenevt(top);
		cfg_setup.page_alarm.w1_page_noopsyche_abnormal_speed.timerenevt(top);
		cfg_setup.page_alarm.w1_page_noopsyche_converse.timerenevt(top);
		cfg_setup.page_alarm.w1_page_noopsyche_illegal_packing.timerenevt(top);
		cfg_setup.page_alarm.w1_page_noopsyche_loiter.timerenevt(top);
		cfg_setup.page_alarm.w1_page_noopsyche_multiloiter.timerenevt(top);
		cfg_setup.page_alarm.w1_page_noopsyche_person_count.timerenevt(top);

		cfg_setup.page_alarm.w1_page_adv_insight_smoker_dec.timerenevt(top);
		cfg_setup.page_alarm.w1_page_adv_insight_smoker_flame.timerenevt(top);
		cfg_setup.page_alarm.w1_page_adv_insight_fire_spot.timerenevt(top);

		cfg_setup.page_alarm.w1_page_nvr_noopsyche_general.timerenevt(top);
		cfg_setup.page_alarm.w1_page_nvr_noopsyche_perimeter.timerenevt(top);

		cfg_setup.page_alarm.w1_page_abnormal.timerenevt(top);
		
		--
		cfg_setup.page_network.w1_page_ip.timerenevt(top);
		cfg_setup.page_network.w1_page_eth_route.timerenevt(top);
		cfg_setup.page_network.w1_page_port.timerenevt(top);
		cfg_setup.page_network.w1_page_poe.timerenevt(top);
		cfg_setup.page_network.w1_page_ipv4_cctv.timerenevt(top);
		cfg_setup.page_network.w1_page_8021x.timerenevt(top);
		cfg_setup.page_network.w1_page_ddns.timerenevt(top);
		cfg_setup.page_network.w1_page_smtp.timerenevt(top);
		cfg_setup.page_network.w1_page_smtp2.timerenevt(top);
		cfg_setup.page_network.w1_page_immix.timerenevt(top);
		cfg_setup.page_network.w1_page_upnp.timerenevt(top);
		cfg_setup.page_network.w1_page_nat_port.timerenevt(top);
		cfg_setup.page_network.w1_page_pp.timerenevt(top);
		cfg_setup.page_network.w1_page_ipfilter.timerenevt(top);
		cfg_setup.page_network.w1_page_snmp.timerenevt(top);
		cfg_setup.page_network.w1_page_snmp12.timerenevt(top);
		cfg_setup.page_network.w1_page_snmp_port.timerenevt(top);
		cfg_setup.page_network.w1_page_wifi_cfg.timerenevt(top);
		cfg_setup.page_network.w1_page_wifi_network.timerenevt(top);
		cfg_setup.page_network.w1_page_3g_4g.timerenevt(top);
		cfg_setup.page_network.w1_page_pppoe.timerenevt(top);
		cfg_setup.page_network.w1_page_net_stat.timerenevt(top);
		cfg_setup.page_network.w1_page_lan_info.timerenevt(top);
		cfg_setup.page_network.w1_page_alarm_service_center.timerenevt(top);
		cfg_setup.page_network.w1_page_platform_access.timerenevt(top);

		--ϵͳ
		cfg_setup.page_system.w1_page_sys.timerenevt(top);
		cfg_setup.page_system.w1_page_time.timerenevt(top);
		cfg_setup.page_system.w1_page_tzone.timerenevt(top);
		cfg_setup.page_system.w1_page_dst.timerenevt(top);
		cfg_setup.page_system.w1_page_ipctime.timerenevt(top);
		cfg_setup.page_system.w1_page_modify.timerenevt(top);
		cfg_setup.page_system.w1_page_modify_g.timerenevt(top);
		cfg_setup.page_system.w1_page_securitymail.timerenevt(top);
		cfg_setup.page_system.w1_page_securityquestion.timerenevt(top);
		cfg_setup.page_system.w1_page_dwell.timerenevt(top);
		cfg_setup.page_system.w1_page_cvbsoffset.timerenevt(top);
		cfg_setup.page_system.w1_page_cvbscolor.timerenevt(top);
		cfg_setup.page_system.w1_page_pri.timerenevt(top);
		cfg_setup.page_system.w1_page_auxiliary_cfg.timerenevt(top);
		cfg_setup.page_system.w1_page_auxiliary_dsp.timerenevt(top);
		cfg_setup.page_system.w1_page_restart.timerenevt(top);
		cfg_setup.page_system.w1_page_ai_resource.timerenevt(top);
		cfg_setup.page_system.w1_page_phone_filter.timerenevt(top);
		cfg_setup.page_system.w1_page_info_net.timerenevt(top);
	end
	return 0
end

local cfg_exit = function(top)
	local ret = w1_wnd_jump.save_check(top, cfg_setup.cur_page)
	if (0 == ret) then
		b_app_api.restore_layout();	--رֶ
		b_dlg.end_modal(top);
	end	
end

local on_close = function(top, id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		if cfg_setup.page_record.w1_page_bad_detection.timestart then
			cfg_setup.page_record.w1_page_bad_detection.stop_block_detect(top);
			if cfg_setup.page_record.w1_page_bad_detection.flag == 0 then
				return 0;
			end
		end
		b_app_api.restore_layout();	--رֶ
		b_dlg.end_modal(top);
	end
	return 0;
end

cfg_setup.jumppage = function(top, curpage)
	if (nil == curpage) then
		return 0;	
	end
		
	local click_title = function(child_id)
		w1_wnd_jump.click_title_ex(top, w1_cfg_setup_title.wnd, child_id, false);
	end
	
	local click_col = function(wnd, child_id)
		w1_wnd_jump.click_col_ex(top, wnd, child_id, false);
	end
	
	local click_row = function(wnd, child_id)
		w1_wnd_jump.click_row(top, wnd, child_id, false);
	end
	local jumppage = cfg_setup.CFGPAGE;
	
	--ͨ
	if(curpage == jumppage.CAMERA) then
		click_title(w1_id.cfg_setup_title_id + 1);
		click_col(cfg_setup.page_channel.w1_col_channel.wnd, w1_id.col_channel_id + 1);
		click_row(cfg_setup.page_channel.w1_row_camera.wnd, w1_id.cfg_camera.row_id + 1);
	elseif(curpage == jumppage.ENCODE) then
		click_title(w1_id.cfg_setup_title_id + 1);
		click_col(cfg_setup.page_channel.w1_col_channel.wnd, w1_id.col_channel_id + 2);
		click_row(cfg_setup.page_channel.w1_row_encode.wnd, w1_id.cfg_encode.row_id + 1);
	elseif(curpage == jumppage.IMAGE_PARAM) then
		click_title(w1_id.cfg_setup_title_id + 1);
		click_col(cfg_setup.page_channel.w1_col_channel.wnd, w1_id.col_channel_id + 3);
		click_row(cfg_setup.page_channel.w1_row_image.wnd, w1_id.cfg_image.row_id + 1);
	elseif(curpage == jumppage.OSDAREA) then
		click_title(w1_id.cfg_setup_title_id + 1);
		click_col(cfg_setup.page_channel.w1_col_channel.wnd, w1_id.col_channel_id + 4);
		click_row(cfg_setup.page_channel.w1_row_osd.wnd, w1_id.cfg_osd.row_id + 1);		
	elseif(curpage == jumppage.PRIVACYAREA) then
		click_title(w1_id.cfg_setup_title_id + 1);
		click_col(cfg_setup.page_channel.w1_col_channel.wnd, w1_id.col_channel_id + 5);
		click_row(cfg_setup.page_channel.w1_row_privacyarea.wnd, w1_id.cfg_privacyarea.row_id + 1);
	elseif (curpage == jumppage.CHANNEL_TYPE) then
		click_title(w1_id.cfg_setup_title_id + 1);
		click_col(cfg_setup.page_channel.w1_col_channel.wnd, w1_id.col_channel_id + 6);
		click_row(cfg_setup.page_channel.w1_row_channel_type.wnd, w1_id.cfg_channel_type.row_id + 1);
	elseif(curpage == jumppage.ROIAREA) then
		click_title(w1_id.cfg_setup_title_id + 1);
		click_col(cfg_setup.page_channel.w1_col_channel.wnd, w1_id.col_channel_id + 7);
		click_row(cfg_setup.page_channel.w1_row_roi.wnd, w1_id.cfg_roi.row_id + 1);	
	elseif (curpage == jumppage.MICROPHONE) then
		click_title(w1_id.cfg_setup_title_id + 1);
		click_col(cfg_setup.page_channel.w1_col_channel.wnd, w1_id.col_channel_id + 8);
		click_row(cfg_setup.page_channel.w1_row_microphone.wnd, w1_id.cfg_microphone.row_id + 1);
	elseif (curpage == jumppage.HUMANTHERMOMETER) then
		click_title(w1_id.cfg_setup_title_id + 1);
		click_col(cfg_setup.page_channel.w1_col_channel.wnd, w1_id.col_channel_id + 9);
		click_row(cfg_setup.page_channel.w1_row_human_thermometer.wnd, w1_id.cfg_humanthermometer.row_id + 1);
	elseif (curpage == jumppage.AI) then
		click_title(w1_id.cfg_setup_title_id + 1);
		click_col(cfg_setup.page_channel.w1_col_channel.wnd, w1_id.col_channel_id + 10);
		click_row(cfg_setup.page_channel.w1_row_ai.wnd, w1_id.cfg_ai.row_id + 1);
	elseif (curpage == jumppage.TRACK) then
		click_title(w1_id.cfg_setup_title_id + 1);
		click_col(cfg_setup.page_channel.w1_col_channel.wnd, w1_id.col_channel_id + 11);
		click_row(cfg_setup.page_channel.w1_row_track.wnd, w1_id.cfg_track.row_id + 1);
	--洢
	elseif(curpage == jumppage.RECORD_POLICY) then
		click_title(w1_id.cfg_setup_title_id + 2);
		click_col(cfg_setup.page_record.w1_col_storage.wnd, w1_id.col_storage_id + 1);
		click_row(cfg_setup.page_record.w1_row_record.wnd, w1_id.cfg_record.row_id + 1);
	elseif(curpage == jumppage.DISK) then
		click_title(w1_id.cfg_setup_title_id + 2);
		click_col(cfg_setup.page_record.w1_col_storage.wnd, w1_id.col_storage_id + 2);
		click_row(cfg_setup.page_record.w1_row_diskcfg.wnd, w1_id.cfg_diskcfg.row_id + 1);
	elseif(curpage == jumppage.SMART) then
		click_title(w1_id.cfg_setup_title_id + 2);
		click_col(cfg_setup.page_record.w1_col_storage.wnd, w1_id.col_storage_id + 3);
		click_row(cfg_setup.page_record.w1_row_smart.wnd, w1_id.cfg_smart.row_id + 1);
	elseif(curpage == jumppage.RAID) then
		click_title(w1_id.cfg_setup_title_id + 2);
		click_col(cfg_setup.page_record.w1_col_storage.wnd, w1_id.col_storage_id + 4);
		click_row(cfg_setup.page_record.w1_row_raid.wnd, w1_id.cfg_raid.row_id + 1);		
	elseif(curpage == jumppage.BAD_DETECTION) then
		click_title(w1_id.cfg_setup_title_id + 2);
		click_col(cfg_setup.page_record.w1_col_storage.wnd, w1_id.col_storage_id + 5);
		click_row(cfg_setup.page_record.w1_row_bad_detection.wnd, w1_id.cfg_bad_detection.row_id + 1);	
	elseif(curpage == jumppage.DISK_GROUP) then
		click_title(w1_id.cfg_setup_title_id + 2);
		click_col(cfg_setup.page_record.w1_col_storage.wnd, w1_id.col_storage_id + 6);
		click_row(cfg_setup.page_record.w1_row_disk_group.wnd, w1_id.cfg_disk_group.row_id + 1);
	elseif(curpage == jumppage.CLOUD) then
		click_title(w1_id.cfg_setup_title_id + 2);
		click_col(cfg_setup.page_record.w1_col_storage.wnd, w1_id.col_storage_id + 7);
		click_row(cfg_setup.page_record.w1_row_cloud.wnd, w1_id.cfg_cloud.row_id + 1);
	elseif(curpage == jumppage.DIS_CAL) then
		click_title(w1_id.cfg_setup_title_id + 2);
		click_col(cfg_setup.page_record.w1_col_storage.wnd, w1_id.col_storage_id + 8);
		click_row(cfg_setup.page_record.w1_row_dis_cal.wnd, w1_id.cfg_dis_cal.row_id + 1);
	elseif(curpage == jumppage.FTP) then
		click_title(w1_id.cfg_setup_title_id + 2);
		click_col(cfg_setup.page_record.w1_col_storage.wnd, w1_id.col_storage_id + 9);
		click_row(cfg_setup.page_record.w1_row_ftp.wnd, w1_id.cfg_ftp.row_id + 1);	
	--
	elseif(curpage == jumppage.SURVEILLANCE) then
		click_title(w1_id.cfg_setup_title_id + 3);
		click_col(cfg_setup.page_alarm.w1_col_alarm.wnd, w1_id.col_alarm_id + 1);
		click_row(cfg_setup.page_alarm.w1_row_surve.wnd, w1_id.cfg_surve.row_id + 1);
	elseif(curpage == jumppage.MOTIONAREA) then
		click_title(w1_id.cfg_setup_title_id + 3);
		click_col(cfg_setup.page_alarm.w1_col_alarm.wnd, w1_id.col_alarm_id + 2);
		click_row(cfg_setup.page_alarm.w1_row_motion.wnd, w1_id.cfg_motion.row_id + 1);
	elseif(curpage == jumppage.TAMPER) then
		click_title(w1_id.cfg_setup_title_id + 3);
		click_col(cfg_setup.page_alarm.w1_col_alarm.wnd, w1_id.col_alarm_id + 3);
		click_row(cfg_setup.page_alarm.w1_row_tamper.wnd, w1_id.cfg_tamper.row_id + 1);
	elseif(curpage == jumppage.VIDEO_LOSS) then
		click_title(w1_id.cfg_setup_title_id + 3);
		click_col(cfg_setup.page_alarm.w1_col_alarm.wnd, w1_id.col_alarm_id + 4);
		click_row(cfg_setup.page_alarm.w1_row_loss.wnd, w1_id.cfg_loss.row_id + 1);
	elseif(curpage == jumppage.ADV_INSIGHT) then
		click_title(w1_id.cfg_setup_title_id + 3);
		click_col(cfg_setup.page_alarm.w1_col_alarm.wnd, w1_id.col_alarm_id + 5);
		click_row(cfg_setup.page_alarm.w1_row_adv_insight.wnd, w1_id.cfg_adv_insight.row_id + 1);			
	elseif(curpage == jumppage.NOOPSYCHE) then
		click_title(w1_id.cfg_setup_title_id + 3);
		click_col(cfg_setup.page_alarm.w1_col_alarm.wnd, w1_id.col_alarm_id + 6);
		click_row(cfg_setup.page_alarm.w1_row_noopsyche.wnd, w1_id.cfg_noopsyche.row_id + 1);	
	elseif(curpage == jumppage.ALARM_IN) then	
		click_title(w1_id.cfg_setup_title_id + 3);
		click_col(cfg_setup.page_alarm.w1_col_alarm.wnd, w1_id.col_alarm_id + 7);
		click_row(cfg_setup.page_alarm.w1_row_alarmin.wnd, w1_id.cfg_alarmin.row_id + 1);	
	elseif(curpage == jumppage.ABNORMAL) then	
		click_title(w1_id.cfg_setup_title_id + 3);
		click_col(cfg_setup.page_alarm.w1_col_alarm.wnd, w1_id.col_alarm_id + 8);
		click_row(cfg_setup.page_alarm.w1_row_abnormal.wnd, w1_id.cfg_abnormal.row_id + 1);	
	elseif(curpage == jumppage.ALARM_OUT) then	
		click_title(w1_id.cfg_setup_title_id + 3);
		click_col(cfg_setup.page_alarm.w1_col_alarm.wnd, w1_id.col_alarm_id + 9);
		click_row(cfg_setup.page_alarm.w1_row_alarmout.wnd, w1_id.cfg_alarmout.row_id + 1);
	elseif(curpage == jumppage.ADAM) then	
		click_title(w1_id.cfg_setup_title_id + 3);
		click_col(cfg_setup.page_alarm.w1_col_alarm.wnd, w1_id.col_alarm_id + 10);
		click_row(cfg_setup.page_alarm.w1_row_adam.wnd, w1_id.cfg_adam.row_id + 1);
	elseif(curpage == jumppage.LOCAL_NOOPSYCHE) then	
		click_title(w1_id.cfg_setup_title_id + 3);
		click_col(cfg_setup.page_alarm.w1_col_alarm.wnd, w1_id.col_alarm_id + 11);
		click_row(cfg_setup.page_alarm.w1_row_nvr_noopsyche.wnd, w1_id.cfg_nvr_noopsyche.row_id + 1);
		
	--
	elseif(curpage == jumppage.IPV4) then
		click_title(w1_id.cfg_setup_title_id + 4);
		click_col(cfg_setup.page_network.w1_col_net.wnd, w1_id.col_net_id + 1);
		click_row(cfg_setup.page_network.w1_row_net.wnd, w1_id.cfg_net.row_id + 1);
	elseif(curpage == jumppage.NET8021X) then
		click_title(w1_id.cfg_setup_title_id + 4);
		click_col(cfg_setup.page_network.w1_col_net.wnd, w1_id.col_net_id + 2);
		click_row(cfg_setup.page_network.w1_row_8021x.wnd, w1_id.cfg_8021x.row_id + 1);	
	elseif(curpage == jumppage.DDNS) then
		click_title(w1_id.cfg_setup_title_id + 4);
		click_col(cfg_setup.page_network.w1_col_net.wnd, w1_id.col_net_id + 3);
		click_row(cfg_setup.page_network.w1_row_ddns.wnd, w1_id.cfg_ddns.row_id + 1);	
	elseif(curpage == jumppage.SMTP) then
		click_title(w1_id.cfg_setup_title_id + 4);
		click_col(cfg_setup.page_network.w1_col_net.wnd, w1_id.col_net_id + 4);
		click_row(cfg_setup.page_network.w1_row_smtp.wnd, w1_id.cfg_smtp.row_id + 1);
	elseif(curpage == jumppage.UPNP) then
		click_title(w1_id.cfg_setup_title_id + 4);
		click_col(cfg_setup.page_network.w1_col_net.wnd, w1_id.col_net_id + 5);
		click_row(cfg_setup.page_network.w1_row_upnp.wnd, w1_id.cfg_upnp.row_id + 1);
	elseif(curpage == jumppage.P2P) then
		click_title(w1_id.cfg_setup_title_id + 4);
		click_col(cfg_setup.page_network.w1_col_net.wnd, w1_id.col_net_id + 6);
		click_row(cfg_setup.page_network.w1_row_pp.wnd, w1_id.cfg_pp.row_id + 1);
	elseif(curpage == jumppage.IPFILTER) then
		click_title(w1_id.cfg_setup_title_id + 4);
		click_col(cfg_setup.page_network.w1_col_net.wnd, w1_id.col_net_id + 7);
		click_row(cfg_setup.page_network.w1_row_filter.wnd, w1_id.cfg_filter.row_id + 1);
	elseif(curpage == jumppage.SNMP) then
		click_title(w1_id.cfg_setup_title_id + 4);
		click_col(cfg_setup.page_network.w1_col_net.wnd, w1_id.col_net_id + 8);
		click_row(cfg_setup.page_network.w1_row_snmp.wnd, w1_id.cfg_snmp.row_id + 1);
	elseif(curpage == jumppage.NET3G4G) then
		click_title(w1_id.cfg_setup_title_id + 4);
		click_col(cfg_setup.page_network.w1_col_net.wnd, w1_id.col_net_id + 9);
		click_row(cfg_setup.page_network.w1_row_3g_4g.wnd, w1_id.cfg_3g_4g.row_id + 1);	
	elseif(curpage == jumppage.PPPOE) then
		click_title(w1_id.cfg_setup_title_id + 4);
		click_col(cfg_setup.page_network.w1_col_net.wnd, w1_id.col_net_id + 10);
		click_row(cfg_setup.page_network.w1_row_pppoe.wnd, w1_id.cfg_pppoe.row_id + 1);
	elseif(curpage == jumppage.NET_STAT) then
		click_title(w1_id.cfg_setup_title_id + 4);
		click_col(cfg_setup.page_network.w1_col_net.wnd, w1_id.col_net_id + 11);
		click_row(cfg_setup.page_network.w1_row_net_stat.wnd, w1_id.cfg_net_stat.row_id + 1);
	elseif(curpage == jumppage.LAN_INFO) then
		click_title(w1_id.cfg_setup_title_id + 4);
		click_col(cfg_setup.page_network.w1_col_net.wnd, w1_id.col_net_id + 12);
		click_row(cfg_setup.page_network.w1_row_lan_info.wnd, w1_id.cfg_lan_info.row_id + 1);
	elseif(curpage == jumppage.ALARM_CENTER) then
		click_title(w1_id.cfg_setup_title_id + 4);
		click_col(cfg_setup.page_network.w1_col_net.wnd, w1_id.col_net_id + 13);
		click_row(cfg_setup.page_network.w1_row_alarm_service_center.wnd, w1_id.cfg_alarm_service_center.row_id + 1);		
	elseif(curpage == jumppage.PLATFORM_ACCESS) then
		click_title(w1_id.cfg_setup_title_id + 4);
		click_col(cfg_setup.page_network.w1_col_net.wnd, w1_id.col_net_id + 14);
		click_row(cfg_setup.page_network.w1_row_platform_access.wnd, w1_id.cfg_platform_access.row_id + 1);		
		
	--ϵͳ
	elseif(curpage == jumppage.INFO) then
		click_title(w1_id.cfg_setup_title_id + 5);
		click_col(cfg_setup.page_system.w1_col_sys.wnd, w1_id.col_sys_id + 1);
		click_row(cfg_setup.page_system.w1_row_info.wnd, w1_id.cfg_devinfo.row_id + 1);
	elseif(curpage == jumppage.SYSTEM) then
		click_title(w1_id.cfg_setup_title_id + 5);
		click_col(cfg_setup.page_system.w1_col_sys.wnd, w1_id.col_sys_id + 2);
		click_row(cfg_setup.page_system.w1_row_basic.wnd, w1_id.cfg_basic.row_id + 1);
	elseif(curpage == jumppage.USER) then
		click_title(w1_id.cfg_setup_title_id + 5);
		click_col(cfg_setup.page_system.w1_col_sys.wnd, w1_id.col_sys_id + 3);
		click_row(cfg_setup.page_system.w1_row_user.wnd, w1_id.cfg_privacy.row_id + 1);		
	elseif(curpage == jumppage.MODIFYPASS) then
		click_title(w1_id.cfg_setup_title_id + 5);
		click_col(cfg_setup.page_system.w1_col_sys.wnd, w1_id.col_sys_id + 4);
		click_row(cfg_setup.page_system.w1_row_modify.wnd, w1_id.cfg_modify.row_id + 1);
	elseif(curpage == jumppage.DWELL) then
		click_title(w1_id.cfg_setup_title_id + 5);
		click_col(cfg_setup.page_system.w1_col_sys.wnd, w1_id.col_sys_id + 5);
		click_row(cfg_setup.page_system.w1_row_out.wnd, w1_id.cfg_out.row_id + 1);	
	elseif(curpage == jumppage.AUXILIARY) then
		click_title(w1_id.cfg_setup_title_id + 5);
		click_col(cfg_setup.page_system.w1_col_sys.wnd, w1_id.col_sys_id + 6);
		click_row(cfg_setup.page_system.w1_row_auxiliary.wnd, w1_id.cfg_auxiliary.row_id + 1);
	elseif(curpage == jumppage.LOG) then
		click_title(w1_id.cfg_setup_title_id + 5);
		click_col(cfg_setup.page_system.w1_col_sys.wnd, w1_id.col_sys_id + 7);
		click_row(cfg_setup.page_system.w1_row_logman.wnd, w1_id.cfg_logm.row_id + 1);
	elseif(curpage == jumppage.MAINTAIN) then
		click_title(w1_id.cfg_setup_title_id + 5);
		click_col(cfg_setup.page_system.w1_col_sys.wnd, w1_id.col_sys_id + 8);
		click_row(cfg_setup.page_system.w1_row_devman.wnd, w1_id.cfg_devm.row_id + 1);
	elseif(curpage == jumppage.RESTART) then
		click_title(w1_id.cfg_setup_title_id + 5);
		click_col(cfg_setup.page_system.w1_col_sys.wnd, w1_id.col_sys_id + 9);
		click_row(cfg_setup.page_system.w1_row_restart.wnd, w1_id.cfg_restart.row_id + 1);
	elseif(curpage == jumppage.AI_RESOURCE) then
		click_title(w1_id.cfg_setup_title_id + 5);
		click_col(cfg_setup.page_system.w1_col_sys.wnd, w1_id.col_sys_id + 10);
		click_row(cfg_setup.page_system.w1_row_ai_resource.wnd, w1_id.cfg_ai_resource.row_id + 1);
	end
end

local dlg = {
	attr = {xywh='s_cfg_xywh',cmd=on_dlg,timer={-1, 1000}},
	
	sub = {	'containerColumn', 'containerRow', 'containerItem','close', 'cfg_setup_title_wnd','line',
			
			--ͨ
			'w1_col_channel_wnd',
			'w1_row_camera_wnd','w1_row_encode_wnd','w1_row_image_wnd','w1_row_osd_wnd','w1_row_channel_type_wnd','w1_row_roi_wnd','w1_row_track_wnd','w1_row_microphone_wnd','w1_row_human_thermometer_wnd','w1_row_ai_wnd',
			'w1_page_camera_wnd','w1_page_pro_man_wnd','w1_page_encode_wnd','w1_page_image_wnd', 'w1_page_osd_wnd','w1_page_channel_type_wnd', 'w1_page_analog_audio_in_wnd', 'w1_page_roi_wnd','w1_page_track_wnd','w1_page_microphone_wnd',
			'w1_page_param_conf_wnd','w1_page_thermal_map_wnd','w1_page_thermal_cal_wnd','w1_page_multi_obj_wnd','w1_page_plate_wnd','w1_page_face_wnd',
			
			--洢
			'w1_col_storage_wnd',
			'w1_row_record_wnd', 'w1_row_diskcfg_wnd', 'w1_row_raid_wnd','w1_row_smart_wnd','w1_row_bad_detection_wnd','w1_row_disk_group_wnd','w1_row_cloud_wnd','w1_row_dis_cal_wnd','w1_row_ftp_wnd',
			'w1_page_record_wnd', 'w1_page_diskcfg_wnd','w1_page_raid_wnd','w1_page_smart_wnd','w1_page_wdda_wnd','w1_page_bad_detection_wnd','w1_page_disk_group_wnd','w1_page_cloud_wnd','w1_page_dis_cal_wnd','w1_page_ftp_wnd',

			--
			'w1_col_alarm_wnd',
			'w1_row_surve_wnd', 'w1_row_privacyarea_wnd', 'w1_row_motion_wnd','w1_row_tamper_wnd','w1_row_loss_wnd','w1_row_alarmin_wnd','w1_row_alarmout_wnd','w1_row_nvr_noopsyche_wnd','w1_row_noopsyche_wnd','w1_row_abnormal_wnd','w1_row_adam_wnd','w1_row_adv_insight_wnd',
			'w1_page_surve_wnd', 'w1_page_privacyarea_wnd', 'w1_page_motion_wnd','w1_page_tamper_wnd','w1_page_loss_wnd','w1_page_alarmin_wnd','w1_page_ioalarm_wnd','w1_page_alarmout_wnd','w1_page_adam_wnd', 'w1_page_alarmout_c_wnd','w1_page_audio_out_wnd','w1_page_flash_light_alarm_wnd', 'w1_page_alarm_advance', 'w1_page_noopsyche_advance_wnd',
			'w1_page_noopsyche_badsignal_wnd','w1_page_noopsyche_cordon_wnd','w1_page_noopsyche_dcordon_wnd','w1_page_noopsyche_perimeter_wnd','w1_page_noopsyche_objectleft_wnd',
			'w1_page_noopsyche_objectremove_wnd', 'w1_page_noopsyche_abnormal_speed_wnd', 'w1_page_noopsyche_fence_wnd', 'w1_page_noopsyche_converse_wnd','w1_page_noopsyche_illegal_packing_wnd','w1_page_noopsyche_loiter_wnd',        
			'w1_page_noopsyche_multiloiter_wnd','w1_page_abnormal_wnd','w1_page_noopsyche_person_count_wnd','w1_page_noopsyche_enter_area_wnd','w1_page_noopsyche_leave_area_wnd', 'w1_page_adv_insight_smoker_dec_wnd', 'w1_page_adv_insight_smoker_flame_wnd', 'w1_page_adv_insight_fire_spot_wnd', 
			'w1_page_nvr_noopsyche_general_wnd','w1_page_nvr_noopsyche_perimeter_wnd',	
			
			--ϵͳ
			'w1_col_sys_wnd',
			'w1_row_info_wnd','w1_row_basic_wnd','w1_row_user_wnd','w1_row_modify_wnd',
			'w1_row_out_wnd','w1_row_devman_wnd','w1_row_logman_wnd','w1_row_restart_wnd','w1_row_3g_4g','w1_row_ai_resource_wnd',
			'w1_page_devinfo_wnd','w1_page_chninfo_wnd','w1_page_netinfo_wnd','w1_page_alarminfo_wnd','w1_page_diskinfo_wnd','w1_page_system_wnd','w1_page_time_wnd','w1_page_tzone_wnd','w1_page_dst_wnd','w1_page_ipctime_wnd','w1_page_privacy_wnd','w1_page_pri_wnd','w1_page_phone_filter_wnd',
			'w1_page_modify_wnd','w1_page_modify_g_wnd', 'w1_page_securitymail_wnd', 'w1_page_securityquestion_wnd','w1_page_dwell_wnd','w1_page_cvbsoffset_wnd','w1_page_cvbscolor_wnd','w1_page_devm_wnd','w1_page_logm_wnd','w1_page_events_wnd','w1_row_auxiliary_wnd', 'w1_page_auxiliary_cfg_wnd','w1_page_auxiliary_dsp_wnd',
			'w1_page_restart_wnd','w1_page_ai_resource_wnd',
			--
			'w1_col_net_wnd',
			'w1_row_net_wnd','w1_row_8021x_wnd','w1_row_ddns_wnd','w1_row_smtp_wnd','w1_row_upnp_wnd','w1_row_pp_wnd','w1_row_filter_wnd','w1_row_snmp_wnd','w1_row_3g_4g_wnd','w1_row_pppoe_wnd','w1_row_net_stat_wnd','w1_row_lan_info_wnd','w1_row_alarm_center_wnd','w1_row_platform_access_wnd',
			'w1_page_ip_wnd','w1_page_eth_route_wnd', 'w1_page_port_wnd', 'w1_page_poe_wnd','w1_page_ipv4_cctv_wnd', 'w1_page_8021x_wnd','w1_page_ddns_wnd','w1_page_smtp_wnd','w1_page_smtp2_wnd','w1_page_immix_wnd','w1_page_wifi_network_wnd','w1_page_wifi_cfg_wnd',
			'w1_page_upnp_wnd','w1_page_nat_port_wnd', 'w1_page_pp_wnd','w1_page_ipfilter_wnd',	'w1_page_snmp_wnd', 'w1_page_snmp12_wnd','w1_page_snmp_port_wnd','w1_page_3g_4g_wnd','w1_page_pppoe_wnd','w1_page_net_stat_wnd','w1_page_lan_info_wnd','w1_page_alarm_center_wnd','w1_page_platform_access_wnd',
		},
	containerColumn		= {t='container',id=w1_id.cfg_setup.conCol_id,	xywh='s_cfg_con_xywh'},
	containerRow		= {t='container',id=w1_id.cfg_setup.conRow_id,	xywh='s_cfg_con_xywh'},
	containerItem 		= {t='container',id=w1_id.cfg_setup.conItem_id,	xywh='s_cfg_con_xywh'},

	cfg_setup_title_wnd = w1_cfg_setup_title.wnd,
	
	--ͨ
	w1_col_channel_wnd	= cfg_setup.page_channel.w1_col_channel.wnd,
	w1_row_camera_wnd	= cfg_setup.page_channel.w1_row_camera.wnd,
	w1_row_encode_wnd 	= cfg_setup.page_channel.w1_row_encode.wnd,
	w1_row_image_wnd 	= cfg_setup.page_channel.w1_row_image.wnd,
	w1_row_osd_wnd 		= cfg_setup.page_channel.w1_row_osd.wnd,
	w1_row_channel_type_wnd	= cfg_setup.page_channel.w1_row_channel_type.wnd,
	w1_row_roi_wnd		= cfg_setup.page_channel.w1_row_roi.wnd,
	w1_row_track_wnd		= cfg_setup.page_channel.w1_row_track.wnd,
	w1_row_microphone_wnd	= cfg_setup.page_channel.w1_row_microphone.wnd,
	w1_row_human_thermometer_wnd = cfg_setup.page_channel.w1_row_human_thermometer.wnd,
	w1_row_ai_wnd = cfg_setup.page_channel.w1_row_ai.wnd,
	w1_page_camera_wnd	= cfg_setup.page_channel.w1_page_camera.wnd,
	w1_page_pro_man_wnd = cfg_setup.page_channel.w1_page_pro_man.wnd,
	w1_page_encode_wnd 	= cfg_setup.page_channel.w1_page_encode.wnd,
	w1_page_image_wnd 	= cfg_setup.page_channel.w1_page_image.wnd,	
	w1_page_osd_wnd 	= cfg_setup.page_channel.w1_page_osd.wnd,	
	w1_page_privacyarea_wnd = cfg_setup.page_channel.w1_page_privacyarea.wnd,	
	w1_page_channel_type_wnd	= cfg_setup.page_channel.w1_page_channel_type.wnd,
	w1_page_analog_audio_in_wnd = cfg_setup.page_channel.w1_page_analog_audio_in.wnd,
	w1_page_roi_wnd 	= cfg_setup.page_channel.w1_page_roi.wnd,
	w1_page_track_wnd 	= cfg_setup.page_channel.w1_page_track.wnd,
	w1_page_microphone_wnd	= cfg_setup.page_channel.w1_page_microphone.wnd,
	w1_page_param_conf_wnd	= cfg_setup.page_channel.w1_page_param_conf.wnd,
	w1_page_thermal_map_wnd	= cfg_setup.page_channel.w1_page_thermal_map.wnd,
	w1_page_thermal_cal_wnd	= cfg_setup.page_channel.w1_page_thermal_cal.wnd,
	w1_page_multi_obj_wnd	= cfg_setup.page_channel.w1_page_multi_obj.wnd,
	w1_page_plate_wnd	= cfg_setup.page_channel.w1_page_plate.wnd,
	w1_page_face_wnd	= cfg_setup.page_channel.w1_page_face.wnd,
	--洢
	w1_col_storage_wnd 	= cfg_setup.page_record.w1_col_storage.wnd, 
	w1_row_record_wnd 	= cfg_setup.page_record.w1_row_record.wnd,	
	w1_row_diskcfg_wnd 	= cfg_setup.page_record.w1_row_diskcfg.wnd,
	w1_row_raid_wnd		= cfg_setup.page_record.w1_row_raid.wnd,
	w1_row_smart_wnd    = cfg_setup.page_record.w1_row_smart.wnd,
	w1_row_bad_detection_wnd = cfg_setup.page_record.w1_row_bad_detection.wnd,
	w1_row_disk_group_wnd = cfg_setup.page_record.w1_row_disk_group.wnd,
	w1_row_cloud_wnd    = cfg_setup.page_record.w1_row_cloud.wnd,
	w1_row_dis_cal_wnd    = cfg_setup.page_record.w1_row_dis_cal.wnd,
	w1_row_ftp_wnd    = cfg_setup.page_record.w1_row_ftp.wnd,
	w1_page_record_wnd 	= cfg_setup.page_record.w1_page_record.wnd,
	w1_page_diskcfg_wnd = cfg_setup.page_record.w1_page_diskcfg.wnd,
	w1_page_raid_wnd	= cfg_setup.page_record.w1_page_raid.wnd,
	w1_page_smart_wnd	= cfg_setup.page_record.w1_page_smart.wnd,
	w1_page_wdda_wnd	= cfg_setup.page_record.w1_page_wdda.wnd,
	w1_page_bad_detection_wnd = cfg_setup.page_record.w1_page_bad_detection.wnd,
	w1_page_disk_group_wnd = cfg_setup.page_record.w1_page_disk_group.wnd,
	w1_page_cloud_wnd	= cfg_setup.page_record.w1_page_cloud.wnd,
	w1_page_dis_cal_wnd	= cfg_setup.page_record.w1_page_dis_cal.wnd,
	w1_page_ftp_wnd = cfg_setup.page_record.w1_page_ftp.wnd,
	--
	w1_col_alarm_wnd		= cfg_setup.page_alarm.w1_col_alarm.wnd,
	
	w1_row_surve_wnd 		= cfg_setup.page_alarm.w1_row_surve.wnd,	
	w1_row_privacyarea_wnd 	= cfg_setup.page_channel.w1_row_privacyarea.wnd,	
	w1_row_motion_wnd 		= cfg_setup.page_alarm.w1_row_motion.wnd,	
	w1_row_tamper_wnd 		= cfg_setup.page_alarm.w1_row_tamper.wnd,		
	w1_row_loss_wnd 		= cfg_setup.page_alarm.w1_row_loss.wnd,	
	w1_row_alarmin_wnd		= cfg_setup.page_alarm.w1_row_alarmin.wnd,	
	w1_row_alarmout_wnd		= cfg_setup.page_alarm.w1_row_alarmout.wnd,	
	w1_row_nvr_noopsyche_wnd	= cfg_setup.page_alarm.w1_row_nvr_noopsyche.wnd,
	w1_row_noopsyche_wnd	= cfg_setup.page_alarm.w1_row_noopsyche.wnd,
	w1_row_abnormal_wnd 	= cfg_setup.page_alarm.w1_row_abnormal.wnd,
	w1_row_adam_wnd			= cfg_setup.page_alarm.w1_row_adam.wnd,
	w1_row_adv_insight_wnd	= cfg_setup.page_alarm.w1_row_adv_insight.wnd,
	
	
	w1_page_surve_wnd 		= cfg_setup.page_alarm.w1_page_surve.wnd,	
	w1_page_motion_wnd 		= cfg_setup.page_alarm.w1_page_motion.wnd,	
	w1_page_tamper_wnd 		= cfg_setup.page_alarm.w1_page_tamper.wnd,	
	w1_page_alarmin_wnd		= cfg_setup.page_alarm.w1_page_alarmin.wnd,	
	w1_page_ioalarm_wnd		= cfg_setup.page_alarm.w1_page_ioalarm.wnd,	
	w1_page_alarmout_wnd		= cfg_setup.page_alarm.w1_page_alarmout.wnd,	
	w1_page_alarmout_c_wnd		= cfg_setup.page_alarm.w1_page_alarmout_c.wnd,	
	w1_page_audio_out_wnd		= cfg_setup.page_alarm.w1_page_audio_out.wnd,	
	w1_page_flash_light_alarm_wnd	= cfg_setup.page_alarm.w1_page_flash_light_alarm.wnd,		
	w1_page_alarm_advance 	= cfg_setup.page_alarm.w1_page_alarm_advance.wnd,	
	w1_page_loss_wnd 		= cfg_setup.page_alarm.w1_page_loss.wnd,		
	w1_page_noopsyche_advance_wnd 	 = cfg_setup.page_alarm.w1_page_noopsyche_advance.wnd,
	w1_page_noopsyche_badsignal_wnd  = cfg_setup.page_alarm.w1_page_noopsyche_badsignal.wnd,
	w1_page_noopsyche_cordon_wnd 	 = cfg_setup.page_alarm.w1_page_noopsyche_cordon.wnd,
	w1_page_noopsyche_dcordon_wnd 	 = cfg_setup.page_alarm.w1_page_noopsyche_dcordon.wnd,
	w1_page_noopsyche_perimeter_wnd  = cfg_setup.page_alarm.w1_page_noopsyche_perimeter.wnd,
	w1_page_noopsyche_enter_area_wnd  = cfg_setup.page_alarm.w1_page_noopsyche_enter_area.wnd,
	w1_page_noopsyche_leave_area_wnd  = cfg_setup.page_alarm.w1_page_noopsyche_leave_area.wnd,
	w1_page_noopsyche_objectleft_wnd = cfg_setup.page_alarm.w1_page_noopsyche_objectleft.wnd,
	w1_page_noopsyche_objectremove_wnd	  = cfg_setup.page_alarm.w1_page_noopsyche_objectremove.wnd,					
	w1_page_noopsyche_abnormal_speed_wnd  = cfg_setup.page_alarm.w1_page_noopsyche_abnormal_speed.wnd,
	w1_page_noopsyche_fence_wnd  = cfg_setup.page_alarm.w1_page_noopsyche_fence.wnd,
	w1_page_noopsyche_converse_wnd        = cfg_setup.page_alarm.w1_page_noopsyche_converse.wnd,
	w1_page_noopsyche_illegal_packing_wnd = cfg_setup.page_alarm.w1_page_noopsyche_illegal_packing.wnd,	
	w1_page_noopsyche_loiter_wnd          = cfg_setup.page_alarm.w1_page_noopsyche_loiter.wnd,
	w1_page_noopsyche_multiloiter_wnd     = cfg_setup.page_alarm.w1_page_noopsyche_multiloiter.wnd,
	w1_page_noopsyche_person_count_wnd	  = cfg_setup.page_alarm.w1_page_noopsyche_person_count.wnd,	 	
	w1_page_abnormal_wnd 	= cfg_setup.page_alarm.w1_page_abnormal.wnd,
	w1_page_adam_wnd	= cfg_setup.page_alarm.w1_page_adam.wnd,		
	

	w1_page_adv_insight_smoker_dec_wnd        = cfg_setup.page_alarm.w1_page_adv_insight_smoker_dec.wnd,
	w1_page_adv_insight_smoker_flame_wnd      = cfg_setup.page_alarm.w1_page_adv_insight_smoker_flame.wnd,
	w1_page_adv_insight_fire_spot_wnd         = cfg_setup.page_alarm.w1_page_adv_insight_fire_spot.wnd,	


	w1_page_nvr_noopsyche_general_wnd 	 = cfg_setup.page_alarm.w1_page_nvr_noopsyche_general.wnd,
	w1_page_nvr_noopsyche_perimeter_wnd  = cfg_setup.page_alarm.w1_page_nvr_noopsyche_perimeter.wnd,

	--
	w1_col_net_wnd		= cfg_setup.page_network.w1_col_net.wnd,
	w1_row_net_wnd		= cfg_setup.page_network.w1_row_net.wnd,
	w1_row_8021x_wnd	= cfg_setup.page_network.w1_row_8021x.wnd,
	w1_row_ddns_wnd		= cfg_setup.page_network.w1_row_ddns.wnd,
	w1_row_smtp_wnd		= cfg_setup.page_network.w1_row_smtp.wnd,
	w1_row_upnp_wnd		= cfg_setup.page_network.w1_row_upnp.wnd,
	w1_row_pp_wnd 		= cfg_setup.page_network.w1_row_pp.wnd,
	w1_row_filter_wnd	= cfg_setup.page_network.w1_row_filter.wnd,
	w1_row_snmp_wnd		= cfg_setup.page_network.w1_row_snmp.wnd,
	w1_row_3g_4g_wnd	= cfg_setup.page_network.w1_row_3g_4g.wnd,
	w1_row_pppoe_wnd	= cfg_setup.page_network.w1_row_pppoe.wnd,
	w1_row_net_stat_wnd	= cfg_setup.page_network.w1_row_net_stat.wnd,
	w1_row_lan_info_wnd = cfg_setup.page_network.w1_row_lan_info.wnd,
	w1_row_alarm_center_wnd = cfg_setup.page_network.w1_row_alarm_service_center.wnd,	
	w1_row_platform_access_wnd = cfg_setup.page_network.w1_row_platform_access.wnd,	
	
	w1_page_eth_route_wnd = cfg_setup.page_network.w1_page_eth_route.wnd,
	w1_page_ip_wnd		= cfg_setup.page_network.w1_page_ip.wnd,
	w1_page_port_wnd 	= cfg_setup.page_network.w1_page_port.wnd,
	w1_page_poe_wnd		= cfg_setup.page_network.w1_page_poe.wnd,
	w1_page_ipv4_cctv_wnd = cfg_setup.page_network.w1_page_ipv4_cctv.wnd,
	w1_page_8021x_wnd 	= cfg_setup.page_network.w1_page_8021x.wnd,
	w1_page_ddns_wnd 	= cfg_setup.page_network.w1_page_ddns.wnd,
	w1_page_smtp_wnd 	= cfg_setup.page_network.w1_page_smtp.wnd,
	w1_page_smtp2_wnd 	= cfg_setup.page_network.w1_page_smtp2.wnd,
	w1_page_immix_wnd 	= cfg_setup.page_network.w1_page_immix.wnd,
	w1_page_upnp_wnd 	= cfg_setup.page_network.w1_page_upnp.wnd,
	w1_page_nat_port_wnd 	= cfg_setup.page_network.w1_page_nat_port.wnd,
	w1_page_pp_wnd 		= cfg_setup.page_network.w1_page_pp.wnd,
	w1_page_ipfilter_wnd= cfg_setup.page_network.w1_page_ipfilter.wnd,
	w1_page_snmp_wnd	= cfg_setup.page_network.w1_page_snmp.wnd,
	w1_page_snmp12_wnd	= cfg_setup.page_network.w1_page_snmp12.wnd,
	w1_page_snmp_port_wnd = cfg_setup.page_network.w1_page_snmp_port.wnd,
	w1_page_wifi_cfg_wnd= cfg_setup.page_network.w1_page_wifi_cfg.wnd,
	w1_page_wifi_network_wnd= cfg_setup.page_network.w1_page_wifi_network.wnd,
	w1_page_3g_4g_wnd	= cfg_setup.page_network.w1_page_3g_4g.wnd,
	w1_page_pppoe_wnd   = cfg_setup.page_network.w1_page_pppoe.wnd,
	w1_page_net_stat_wnd   = cfg_setup.page_network.w1_page_net_stat.wnd,
	w1_page_lan_info_wnd = cfg_setup.page_network.w1_page_lan_info.wnd,
	w1_page_alarm_center_wnd = cfg_setup.page_network.w1_page_alarm_service_center.wnd,
	w1_page_platform_access_wnd = cfg_setup.page_network.w1_page_platform_access.wnd,
	
	--ϵͳ
	w1_col_sys_wnd 		= cfg_setup.page_system.w1_col_sys.wnd,
	w1_row_info_wnd		= cfg_setup.page_system.w1_row_info.wnd,
	w1_row_basic_wnd	= cfg_setup.page_system.w1_row_basic.wnd,
	w1_row_user_wnd	= cfg_setup.page_system.w1_row_user.wnd,
	w1_row_modify_wnd	= cfg_setup.page_system.w1_row_modify.wnd,
	w1_row_out_wnd 		= cfg_setup.page_system.w1_row_out.wnd,
	w1_row_devman_wnd 	= cfg_setup.page_system.w1_row_devman.wnd,
	w1_row_logman_wnd 	= cfg_setup.page_system.w1_row_logman.wnd,
	w1_row_restart_wnd	= cfg_setup.page_system.w1_row_restart.wnd,
	w1_row_ai_resource_wnd	= cfg_setup.page_system.w1_row_ai_resource.wnd,
	w1_page_system_wnd	=	cfg_setup.page_system.w1_page_sys.wnd,
	w1_page_time_wnd	=	cfg_setup.page_system.w1_page_time.wnd,
	w1_page_tzone_wnd	=	cfg_setup.page_system.w1_page_tzone.wnd,
	w1_page_dst_wnd		=	cfg_setup.page_system.w1_page_dst.wnd,
	w1_page_ipctime_wnd	=	cfg_setup.page_system.w1_page_ipctime.wnd,
	w1_page_devinfo_wnd	=	cfg_setup.page_system.w1_page_info.wnd,
	w1_page_chninfo_wnd	=	cfg_setup.page_system.w1_page_info_chn.wnd,
	w1_page_netinfo_wnd	=	cfg_setup.page_system.w1_page_info_net.wnd,
	w1_page_alarminfo_wnd	=	cfg_setup.page_system.w1_page_info_alarm.wnd,
	w1_page_diskinfo_wnd	=	cfg_setup.page_system.w1_page_info_disk.wnd,
	w1_page_privacy_wnd	=	cfg_setup.page_system.w1_page_privacy.wnd,
	w1_page_pri_wnd		=	cfg_setup.page_system.w1_page_pri.wnd,
	w1_page_phone_filter_wnd = cfg_setup.page_system.w1_page_phone_filter.wnd,
	
	w1_page_modify_wnd	=	cfg_setup.page_system.w1_page_modify.wnd,
	w1_page_modify_g_wnd	=	cfg_setup.page_system.w1_page_modify_g.wnd,
	w1_page_securitymail_wnd = cfg_setup.page_system.w1_page_securitymail.wnd,
	w1_page_securityquestion_wnd = cfg_setup.page_system.w1_page_securityquestion.wnd,
	w1_page_dwell_wnd 		= cfg_setup.page_system.w1_page_dwell.wnd,		
	w1_page_cvbsoffset_wnd 	= cfg_setup.page_system.w1_page_cvbsoffset.wnd,
	w1_page_cvbscolor_wnd 	= cfg_setup.page_system.w1_page_cvbscolor.wnd,
	w1_page_auxiliary_cfg_wnd = cfg_setup.page_system.w1_page_auxiliary_cfg.wnd,
	w1_row_auxiliary_wnd = cfg_setup.page_system.w1_row_auxiliary.wnd,
	w1_page_auxiliary_dsp_wnd = cfg_setup.page_system.w1_page_auxiliary_dsp.wnd,
	w1_page_devm_wnd	=	cfg_setup.page_system.w1_page_devm.wnd,
	w1_page_logm_wnd	=	cfg_setup.page_system.w1_page_logm.wnd,
	w1_page_events_wnd	=	cfg_setup.page_system.w1_page_events.wnd,
	w1_page_restart_wnd =	cfg_setup.page_system.w1_page_restart.wnd,
	w1_page_ai_resource_wnd =	cfg_setup.page_system.w1_page_ai_resource.wnd,
	
	close = {t='tt_button',id=id+4,xywh='s_cfg_close_xywh',
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade6','it_close','it_close', 'it_close'},
			cmd=on_close,
			color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_txt_f'},
			color_f= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'}},
	line = {t='hline',id=id+5,xywh='s_cfg_title_hline',
			color= {'c_cfg_hline', 'c_cfg_hline','c_cfg_hline'}, 
			},
}

cfg_setup.on_create = function(top)
	cfg_setup.top = top;
	cfg_setup.dlg = dlg;

	--UIڳʼ
	b_parser(top, cfg_setup.dlg);
	
	local column_id = cfg_setup.dlg.containerColumn.id;
	local row_id = cfg_setup.dlg.containerRow.id;
	local item_id = cfg_setup.dlg.containerItem.id;
	local cfgdlg = cfg_setup.dlg;
	
	local add_page = function(child_id, w_id)
		b_wnd_ex.set_add_page(top, child_id, w_id);
	end
	
	local show_page = function(child_id, w_id)
		b_wnd_ex.set_show_page(top, child_id, w_id, false);
	end
	
	--ͨ
	add_page(column_id, cfgdlg.w1_col_channel_wnd.id);
	add_page(row_id, cfgdlg.w1_row_camera_wnd.id);
	add_page(row_id, cfgdlg.w1_row_encode_wnd.id);
	add_page(row_id, cfgdlg.w1_row_image_wnd.id);
	add_page(row_id, cfgdlg.w1_row_osd_wnd.id);
	add_page(row_id, cfgdlg.w1_row_privacyarea_wnd.id)	
	add_page(row_id, cfgdlg.w1_row_channel_type_wnd.id)
	add_page(row_id, cfgdlg.w1_row_roi_wnd.id);
	add_page(row_id, cfgdlg.w1_row_microphone_wnd.id)
	add_page(row_id, cfgdlg.w1_row_human_thermometer_wnd.id)
	add_page(row_id, cfgdlg.w1_row_ai_wnd.id)
	add_page(row_id, cfgdlg.w1_row_track_wnd.id);
	add_page(item_id, cfgdlg.w1_page_camera_wnd.id);
	add_page(item_id, cfgdlg.w1_page_pro_man_wnd.id);
	add_page(item_id, cfgdlg.w1_page_encode_wnd.id);
	add_page(item_id, cfgdlg.w1_page_image_wnd.id);
	add_page(item_id, cfgdlg.w1_page_osd_wnd.id);
	add_page(item_id, cfgdlg.w1_page_track_wnd.id);
	add_page(item_id, cfgdlg.w1_page_privacyarea_wnd.id);	
	add_page(item_id, cfgdlg.w1_page_channel_type_wnd.id);
	add_page(item_id, cfgdlg.w1_page_analog_audio_in_wnd.id);
	add_page(item_id, cfgdlg.w1_page_roi_wnd.id);
	add_page(item_id, cfgdlg.w1_page_microphone_wnd.id);
	add_page(item_id, cfgdlg.w1_page_param_conf_wnd.id);
	add_page(item_id, cfgdlg.w1_page_thermal_map_wnd.id);
	add_page(item_id, cfgdlg.w1_page_thermal_cal_wnd.id);
	add_page(item_id, cfgdlg.w1_page_multi_obj_wnd.id);
	add_page(item_id, cfgdlg.w1_page_plate_wnd.id);
	add_page(item_id, cfgdlg.w1_page_face_wnd.id);
	--洢
	add_page(column_id, cfgdlg.w1_col_storage_wnd.id);
	add_page(row_id, cfgdlg.w1_row_record_wnd.id);
	add_page(row_id, cfgdlg.w1_row_diskcfg_wnd.id);
	add_page(row_id,   cfgdlg.w1_row_raid_wnd.id);
	add_page(row_id,   cfgdlg.w1_row_smart_wnd.id);
	add_page(row_id, cfgdlg.w1_row_bad_detection_wnd.id);
	add_page(row_id, cfgdlg.w1_row_disk_group_wnd.id);
	add_page(row_id,   cfgdlg.w1_row_cloud_wnd.id);
	add_page(row_id,   cfgdlg.w1_row_dis_cal_wnd.id);
	add_page(row_id,   cfgdlg.w1_row_ftp_wnd.id);
	add_page(item_id, cfgdlg.w1_page_record_wnd.id);
	add_page(item_id, cfgdlg.w1_page_diskcfg_wnd.id);
	add_page(item_id, cfgdlg.w1_page_raid_wnd.id);
	add_page(item_id, cfgdlg.w1_page_smart_wnd.id);
	add_page(item_id, cfgdlg.w1_page_wdda_wnd.id);
	add_page(item_id, cfgdlg.w1_page_bad_detection_wnd.id);
	add_page(item_id, cfgdlg.w1_page_disk_group_wnd.id);
	add_page(item_id, cfgdlg.w1_page_cloud_wnd.id);
	add_page(item_id, cfgdlg.w1_page_dis_cal_wnd.id);
	add_page(item_id, cfgdlg.w1_page_ftp_wnd.id);
	--
	add_page(column_id, cfgdlg.w1_col_alarm_wnd.id);
	add_page(row_id, cfgdlg.w1_row_surve_wnd.id);
	add_page(row_id, cfgdlg.w1_row_motion_wnd.id);
	add_page(row_id, cfgdlg.w1_row_tamper_wnd.id);
	add_page(row_id, cfgdlg.w1_row_loss_wnd.id);
	add_page(row_id, cfgdlg.w1_row_alarmin_wnd.id);
	
	add_page(row_id, cfgdlg.w1_row_nvr_noopsyche_wnd.id);
	add_page(row_id, cfgdlg.w1_row_noopsyche_wnd.id);
	add_page(row_id, cfgdlg.w1_row_abnormal_wnd.id);
	add_page(row_id, cfgdlg.w1_row_alarmout_wnd.id);
	add_page(row_id, cfgdlg.w1_row_adam_wnd.id);
	add_page(row_id, cfgdlg.w1_row_adv_insight_wnd.id);
	
	add_page(item_id, cfgdlg.w1_page_surve_wnd.id);
	
	
	
	add_page(item_id, cfgdlg.w1_page_motion_wnd.id);
	add_page(item_id, cfgdlg.w1_page_tamper_wnd.id);
	add_page(item_id, cfgdlg.w1_page_loss_wnd.id);
	add_page(item_id, cfgdlg.w1_page_alarmin_wnd.id);
	add_page(item_id, cfgdlg.w1_page_ioalarm_wnd.id);
	add_page(item_id, cfgdlg.w1_page_alarmout_wnd.id);
	add_page(item_id, cfgdlg.w1_page_adam_wnd.id);
	add_page(item_id, cfgdlg.w1_page_alarmout_c_wnd.id);
	add_page(item_id, cfgdlg.w1_page_audio_out_wnd.id);
	add_page(item_id, cfgdlg.w1_page_flash_light_alarm_wnd.id);	
	add_page(item_id, cfgdlg.w1_page_alarm_advance.id);
	add_page(item_id, cfgdlg.w1_page_noopsyche_advance_wnd.id);
	add_page(item_id, cfgdlg.w1_page_noopsyche_badsignal_wnd.id);
	add_page(item_id, cfgdlg.w1_page_noopsyche_cordon_wnd.id);
	add_page(item_id, cfgdlg.w1_page_noopsyche_dcordon_wnd.id);
	add_page(item_id, cfgdlg.w1_page_noopsyche_perimeter_wnd.id);
	add_page(item_id, cfgdlg.w1_page_noopsyche_enter_area_wnd.id);
	add_page(item_id, cfgdlg.w1_page_noopsyche_leave_area_wnd.id);
	add_page(item_id, cfgdlg.w1_page_noopsyche_objectleft_wnd.id);
	add_page(item_id, cfgdlg.w1_page_noopsyche_illegal_packing_wnd.id);
	add_page(item_id, cfgdlg.w1_page_noopsyche_abnormal_speed_wnd.id);
	add_page(item_id, cfgdlg.w1_page_noopsyche_fence_wnd.id);
	add_page(item_id, cfgdlg.w1_page_noopsyche_converse_wnd.id);
	add_page(item_id, cfgdlg.w1_page_noopsyche_multiloiter_wnd.id);
	add_page(item_id, cfgdlg.w1_page_noopsyche_loiter_wnd.id);
	add_page(item_id, cfgdlg.w1_page_noopsyche_objectremove_wnd.id);
	add_page(item_id, cfgdlg.w1_page_noopsyche_person_count_wnd.id);
	add_page(item_id, cfgdlg.w1_page_abnormal_wnd.id);
	
	add_page(item_id, cfgdlg.w1_page_adv_insight_smoker_dec_wnd.id);
	add_page(item_id, cfgdlg.w1_page_adv_insight_smoker_flame_wnd.id);
	add_page(item_id, cfgdlg.w1_page_adv_insight_fire_spot_wnd.id);
	
	add_page(item_id, cfgdlg.w1_page_nvr_noopsyche_general_wnd.id);
	add_page(item_id, cfgdlg.w1_page_nvr_noopsyche_perimeter_wnd.id);

	
	--
	add_page(column_id, cfgdlg.w1_col_net_wnd.id);
	add_page(row_id, cfgdlg.w1_row_net_wnd.id);
	add_page(row_id, cfgdlg.w1_row_8021x_wnd.id);
	add_page(row_id, cfgdlg.w1_row_ddns_wnd.id);
	add_page(row_id, cfgdlg.w1_row_smtp_wnd.id);
	add_page(row_id, cfgdlg.w1_row_upnp_wnd.id);
	add_page(row_id, cfgdlg.w1_row_pp_wnd.id);
	add_page(row_id, cfgdlg.w1_row_filter_wnd.id);
	add_page(row_id, cfgdlg.w1_row_snmp_wnd.id);
	add_page(row_id, cfgdlg.w1_row_3g_4g_wnd.id);
	add_page(row_id, cfgdlg.w1_row_pppoe_wnd.id);
	add_page(row_id, cfgdlg.w1_row_net_stat_wnd.id);
	add_page(row_id, cfgdlg.w1_row_lan_info_wnd.id);
	add_page(row_id, cfgdlg.w1_row_alarm_center_wnd.id);
	add_page(row_id, cfgdlg.w1_row_platform_access_wnd.id);
	add_page(item_id, cfgdlg.w1_page_ip_wnd.id);
	add_page(item_id, cfgdlg.w1_page_port_wnd.id);
	add_page(item_id, cfgdlg.w1_page_poe_wnd.id);
	add_page(item_id, cfgdlg.w1_page_ipv4_cctv_wnd.id);
	add_page(item_id, cfgdlg.w1_page_eth_route_wnd.id);
	add_page(item_id, cfgdlg.w1_page_8021x_wnd.id);
	add_page(item_id, cfgdlg.w1_page_ddns_wnd.id);
	add_page(item_id, cfgdlg.w1_page_smtp_wnd.id);
	add_page(item_id, cfgdlg.w1_page_smtp2_wnd.id);
	add_page(item_id, cfgdlg.w1_page_immix_wnd.id);
	add_page(item_id, cfgdlg.w1_page_upnp_wnd.id);
	add_page(item_id, cfgdlg.w1_page_nat_port_wnd.id);
	add_page(item_id, cfgdlg.w1_page_pp_wnd.id);
	add_page(item_id, cfgdlg.w1_page_ipfilter_wnd.id);
	add_page(item_id, cfgdlg.w1_page_snmp_wnd.id);
	add_page(item_id, cfgdlg.w1_page_snmp12_wnd.id);
	add_page(item_id, cfgdlg.w1_page_snmp_port_wnd.id);
	add_page(item_id, cfgdlg.w1_page_wifi_cfg_wnd.id);
	add_page(item_id, cfgdlg.w1_page_wifi_network_wnd.id);
	add_page(item_id, cfgdlg.w1_page_3g_4g_wnd.id);
	add_page(item_id, cfgdlg.w1_page_pppoe_wnd.id);
	add_page(item_id, cfgdlg.w1_page_net_stat_wnd.id);
	add_page(item_id, cfgdlg.w1_page_lan_info_wnd.id);
	add_page(item_id, cfgdlg.w1_page_alarm_center_wnd.id);
	add_page(item_id, cfgdlg.w1_page_platform_access_wnd.id);
	
	--ϵͳ
	add_page(column_id, cfgdlg.w1_col_sys_wnd.id);
	add_page(row_id, cfgdlg.w1_row_info_wnd.id);
	add_page(row_id, cfgdlg.w1_row_basic_wnd.id);
	add_page(row_id, cfgdlg.w1_row_user_wnd.id);
	add_page(row_id, cfgdlg.w1_row_modify_wnd.id);
	add_page(row_id, cfgdlg.w1_row_restart_wnd.id);
	add_page(row_id, cfgdlg.w1_row_out_wnd.id);
	add_page(row_id, cfgdlg.w1_row_devman_wnd.id);
	add_page(row_id, cfgdlg.w1_row_logman_wnd.id);
	add_page(row_id, cfgdlg.w1_row_auxiliary_wnd.id);
	add_page(row_id, cfgdlg.w1_row_ai_resource_wnd.id);

	add_page(item_id, cfgdlg.w1_page_system_wnd.id);
	add_page(item_id, cfgdlg.w1_page_time_wnd.id);
	add_page(item_id, cfgdlg.w1_page_tzone_wnd.id);
	add_page(item_id, cfgdlg.w1_page_dst_wnd.id);
	add_page(item_id, cfgdlg.w1_page_ipctime_wnd.id);
	add_page(item_id, cfgdlg.w1_page_devinfo_wnd.id);
	add_page(item_id, cfgdlg.w1_page_chninfo_wnd.id);
	add_page(item_id, cfgdlg.w1_page_netinfo_wnd.id);
	add_page(item_id, cfgdlg.w1_page_diskinfo_wnd.id);
	add_page(item_id, cfgdlg.w1_page_alarminfo_wnd.id);
	add_page(item_id, cfgdlg.w1_page_privacy_wnd.id);
	add_page(item_id, cfgdlg.w1_page_pri_wnd.id);
	add_page(item_id, cfgdlg.w1_page_phone_filter_wnd.id);
	add_page(item_id, cfgdlg.w1_page_modify_wnd.id);
	add_page(item_id, cfgdlg.w1_page_modify_g_wnd.id);
	add_page(item_id, cfgdlg.w1_page_securitymail_wnd.id);
	add_page(item_id, cfgdlg.w1_page_securityquestion_wnd.id);
	add_page(item_id, cfgdlg.w1_page_dwell_wnd.id);
	add_page(item_id, cfgdlg.w1_page_cvbsoffset_wnd.id);
	add_page(item_id, cfgdlg.w1_page_cvbscolor_wnd.id);
	add_page(item_id, cfgdlg.w1_page_devm_wnd.id);
	add_page(item_id, cfgdlg.w1_page_logm_wnd.id);
	add_page(item_id, cfgdlg.w1_page_events_wnd.id);
	add_page(item_id, cfgdlg.w1_page_auxiliary_cfg_wnd.id);	
	add_page(item_id, cfgdlg.w1_page_auxiliary_dsp_wnd.id);
	add_page(item_id, cfgdlg.w1_page_restart_wnd.id);
	add_page(item_id, cfgdlg.w1_page_ai_resource_wnd.id);
	--
	--motion
	local alarm_con_id = cfgdlg.w1_page_motion_wnd.con_motionarea.id;
	
	add_page(alarm_con_id, cfgdlg.w1_page_motion_wnd.motionevent_wnd.id);
	add_page(alarm_con_id, cfgdlg.w1_page_motion_wnd.motionarea_wnd.id);
	add_page(alarm_con_id, cfgdlg.w1_page_motion_wnd.motiontimeplan_wnd.id);
	
	--Tamper
	alarm_con_id = cfgdlg.w1_page_tamper_wnd.con_tamper.id
	add_page(alarm_con_id, cfgdlg.w1_page_tamper_wnd.tamperevent_wnd.id);
	add_page(alarm_con_id, cfgdlg.w1_page_tamper_wnd.tampertimeplan_wnd.id);
	
	--alarm in
	alarm_con_id = cfgdlg.w1_page_alarmin_wnd.con_alarmin.id;
	add_page(alarm_con_id, cfgdlg.w1_page_alarmin_wnd.alarminevent_wnd.id);
	add_page(alarm_con_id, cfgdlg.w1_page_alarmin_wnd.alarmintimeplan_wnd.id);
	
	--io alarm in
	alarm_con_id = cfgdlg.w1_page_ioalarm_wnd.con_ioalarm.id;
	add_page(alarm_con_id, cfgdlg.w1_page_ioalarm_wnd.ioalarmevent_wnd.id);
	add_page(alarm_con_id, cfgdlg.w1_page_ioalarm_wnd.ioalarmtimeplan_wnd.id);	
	
	alarm_con_id = cfgdlg.w1_page_flash_light_alarm_wnd.con_flash_light.id;
	add_page(alarm_con_id, cfgdlg.w1_page_flash_light_alarm_wnd.flashtimeplan_wnd.id);	
	
	--video loss
	alarm_con_id = cfgdlg.w1_page_loss_wnd.con_loss.id
	add_page(alarm_con_id, cfgdlg.w1_page_loss_wnd.lossevent_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_loss_wnd.losstimeplan_wnd.id)
	
	--inteligent(page_noopsyche)
	alarm_con_id = cfgdlg.w1_page_noopsyche_advance_wnd.con_noopsyche.id
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_advance_wnd.noopsychearea_wnd.id)
	alarm_con_id = cfgdlg.w1_page_noopsyche_person_count_wnd.con_noopsyche.id
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_person_count_wnd.noopsycheevent_wnd.id)	
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_person_count_wnd.noopsychearea_wnd.id)	
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_person_count_wnd.noopsychetimeplan_wnd.id)	
	alarm_con_id = cfgdlg.w1_page_noopsyche_badsignal_wnd.con_noopsyche.id
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_badsignal_wnd.noopsycheevent_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_badsignal_wnd.noopsychearea_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_badsignal_wnd.noopsychetimeplan_wnd.id)
	alarm_con_id = cfgdlg.w1_page_noopsyche_cordon_wnd.con_noopsyche.id
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_cordon_wnd.noopsycheevent_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_cordon_wnd.noopsychearea_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_cordon_wnd.noopsychetimeplan_wnd.id)
	alarm_con_id = cfgdlg.w1_page_noopsyche_dcordon_wnd.con_noopsyche.id
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_dcordon_wnd.noopsycheevent_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_dcordon_wnd.noopsychearea_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_dcordon_wnd.noopsychetimeplan_wnd.id)
	alarm_con_id = cfgdlg.w1_page_noopsyche_perimeter_wnd.con_noopsyche.id
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_perimeter_wnd.noopsycheevent_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_perimeter_wnd.noopsychearea_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_perimeter_wnd.noopsychetimeplan_wnd.id)
	alarm_con_id = cfgdlg.w1_page_noopsyche_enter_area_wnd.con_noopsyche.id
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_enter_area_wnd.noopsycheevent_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_enter_area_wnd.noopsychearea_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_enter_area_wnd.noopsychetimeplan_wnd.id)
	alarm_con_id = cfgdlg.w1_page_noopsyche_leave_area_wnd.con_noopsyche.id
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_leave_area_wnd.noopsycheevent_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_leave_area_wnd.noopsychearea_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_leave_area_wnd.noopsychetimeplan_wnd.id)
	alarm_con_id = cfgdlg.w1_page_noopsyche_objectleft_wnd.con_noopsyche.id
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_objectleft_wnd.noopsycheevent_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_objectleft_wnd.noopsychearea_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_objectleft_wnd.noopsychetimeplan_wnd.id)
	alarm_con_id = cfgdlg.w1_page_noopsyche_objectremove_wnd.con_noopsyche.id
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_objectremove_wnd.noopsycheevent_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_objectremove_wnd.noopsychearea_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_objectremove_wnd.noopsychetimeplan_wnd.id)
	alarm_con_id = cfgdlg.w1_page_noopsyche_converse_wnd.con_noopsyche.id
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_converse_wnd.noopsycheevent_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_converse_wnd.noopsychearea_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_converse_wnd.noopsychetimeplan_wnd.id)
	alarm_con_id = cfgdlg.w1_page_noopsyche_abnormal_speed_wnd.con_noopsyche.id
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_abnormal_speed_wnd.noopsycheevent_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_abnormal_speed_wnd.noopsychearea_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_abnormal_speed_wnd.noopsychetimeplan_wnd.id)
	alarm_con_id = cfgdlg.w1_page_noopsyche_illegal_packing_wnd.con_noopsyche.id
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_illegal_packing_wnd.noopsycheevent_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_illegal_packing_wnd.noopsychearea_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_illegal_packing_wnd.noopsychetimeplan_wnd.id)
	alarm_con_id = cfgdlg.w1_page_noopsyche_loiter_wnd.con_noopsyche.id
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_loiter_wnd.noopsycheevent_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_loiter_wnd.noopsychearea_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_loiter_wnd.noopsychetimeplan_wnd.id)
	alarm_con_id = cfgdlg.w1_page_noopsyche_multiloiter_wnd.con_noopsyche.id
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_multiloiter_wnd.noopsycheevent_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_multiloiter_wnd.noopsychearea_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_multiloiter_wnd.noopsychetimeplan_wnd.id)
	alarm_con_id = cfgdlg.w1_page_noopsyche_fence_wnd.con_noopsyche.id
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_fence_wnd.noopsycheevent_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_fence_wnd.noopsychearea_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_noopsyche_fence_wnd.noopsychetimeplan_wnd.id)

	--NVR Insight
	alarm_con_id = cfgdlg.w1_page_nvr_noopsyche_perimeter_wnd.con_noopsyche.id
	add_page(alarm_con_id, cfgdlg.w1_page_nvr_noopsyche_perimeter_wnd.noopsycheevent_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_nvr_noopsyche_perimeter_wnd.noopsychearea_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_nvr_noopsyche_perimeter_wnd.noopsychetimeplan_wnd.id)
	
	--ADV insight
	alarm_con_id = cfgdlg.w1_page_adv_insight_smoker_dec_wnd.con_noopsyche.id
	add_page(alarm_con_id, cfgdlg.w1_page_adv_insight_smoker_dec_wnd.noopsycheevent_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_adv_insight_smoker_dec_wnd.noopsychearea_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_adv_insight_smoker_dec_wnd.noopsychetimeplan_wnd.id)
	alarm_con_id = cfgdlg.w1_page_adv_insight_smoker_flame_wnd.con_noopsyche.id
	add_page(alarm_con_id, cfgdlg.w1_page_adv_insight_smoker_flame_wnd.noopsycheevent_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_adv_insight_smoker_flame_wnd.noopsychearea_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_adv_insight_smoker_flame_wnd.noopsychetimeplan_wnd.id)
	alarm_con_id = cfgdlg.w1_page_adv_insight_fire_spot_wnd.con_noopsyche.id
	add_page(alarm_con_id, cfgdlg.w1_page_adv_insight_fire_spot_wnd.noopsycheevent_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_adv_insight_fire_spot_wnd.noopsychearea_wnd.id)
	add_page(alarm_con_id, cfgdlg.w1_page_adv_insight_fire_spot_wnd.noopsychetimeplan_wnd.id)
	
	--abnormal alarm
	alarm_con_id = cfgdlg.w1_page_abnormal_wnd.con_abnormal.id
	add_page(alarm_con_id, cfgdlg.w1_page_abnormal_wnd.abnormalevent_wnd.id)
	
	
	--ͨãǰ
	--image
	local image_con_id = cfgdlg.w1_page_image_wnd.con_image.id;
	
--	add_page(image_con_id, cfgdlg.w1_page_image_wnd.imagetime_wnd.id);
	add_page(image_con_id, cfgdlg.w1_page_image_wnd.imageadjust_wnd.id);
	add_page(image_con_id, cfgdlg.w1_page_image_wnd.imagescenes_wnd.id);
	add_page(image_con_id, cfgdlg.w1_page_image_wnd.imageexposure_wnd.id);
	add_page(image_con_id, cfgdlg.w1_page_image_wnd.imagebalance_wnd.id);
	add_page(image_con_id, cfgdlg.w1_page_image_wnd.imagedaynight_wnd.id);
	add_page(image_con_id, cfgdlg.w1_page_image_wnd.imagenoise_wnd.id);
	add_page(image_con_id, cfgdlg.w1_page_image_wnd.imageenhance_wnd.id);
	add_page(image_con_id, cfgdlg.w1_page_image_wnd.imagefocus_wnd.id);
	add_page(image_con_id, cfgdlg.w1_page_image_wnd.imagepcolor_wnd.id);
	add_page(image_con_id, cfgdlg.w1_page_image_wnd.imageffc_wnd.id);


	
	local con_param_id = cfgdlg.w1_page_param_conf_wnd.con_param.id;
	add_page(con_param_id, cfgdlg.w1_page_param_conf_wnd.face_wnd.id);
	add_page(con_param_id, cfgdlg.w1_page_param_conf_wnd.temp_param_wnd.id);
	add_page(con_param_id, cfgdlg.w1_page_param_conf_wnd.levent_wnd.id);
	add_page(con_param_id, cfgdlg.w1_page_param_conf_wnd.nevent_wnd.id);
	add_page(con_param_id, cfgdlg.w1_page_param_conf_wnd.hevent_wnd.id);
	add_page(con_param_id, cfgdlg.w1_page_param_conf_wnd.timeplan_wnd.id);
	
	local con_multi_obj_id = cfgdlg.w1_page_multi_obj_wnd.con_param.id;
	add_page(con_multi_obj_id, cfgdlg.w1_page_multi_obj_wnd.param_wnd.id);
	add_page(con_multi_obj_id, cfgdlg.w1_page_multi_obj_wnd.timeplan_wnd.id);
	local con_plate_id = cfgdlg.w1_page_plate_wnd.con_param.id;
	add_page(con_plate_id, cfgdlg.w1_page_plate_wnd.param_wnd.id);
	add_page(con_plate_id, cfgdlg.w1_page_plate_wnd.blackwhite_wnd.id);
	add_page(con_plate_id, cfgdlg.w1_page_plate_wnd.ledcfg_wnd.id);
	add_page(con_plate_id, cfgdlg.w1_page_plate_wnd.timeplan_wnd.id);
	
	local con_face_id = cfgdlg.w1_page_face_wnd.con_param.id;
	add_page(con_face_id, cfgdlg.w1_page_face_wnd.param_wnd.id);
	add_page(con_face_id, cfgdlg.w1_page_face_wnd.timeplan_wnd.id);
	return 0
end

cfg_setup.on_pre_show = function(top)
	local wnd_data = b_wnd.get_wnd_data(top);
	if(wnd_data ~= nil)then
		assert('string' == type(wnd_data));
		wnd_data = cjson.decode(wnd_data);
		cfg_setup.cur_page = wnd_data.page_id;
	end
	local privilege = global_val.get_allprivilege();--ȡȨ
	--ȨϢʾҳ
	w1_cfg_setup_title.set_disable(top, privilege, false);
	cfg_setup.page_channel.w1_col_channel.set_disable(top, privilege, false);
	cfg_setup.page_alarm.w1_col_alarm.set_disable(top, privilege, false);
	cfg_setup.page_system.w1_col_sys.set_disable(top, privilege, false);	
	cfg_setup.page_system.w1_page_devm.set_disable(top, privilege, false);

	
	--ʾǰ豸мأͨȡ
	--COLʼ
	cfg_setup.page_alarm.w1_col_alarm.on_pre_show(top);
	cfg_setup.page_system.w1_col_sys.on_pre_show(top);
	cfg_setup.page_record.w1_col_storage.on_pre_show(top);
	cfg_setup.page_network.w1_col_net.on_pre_show(top);
	--ԱӦִСԶּྡʾȫ
	w1_cfg_setup_title.on_pre_show(top);
	cfg_setup.page_system.w1_row_basic.on_pre_show(top);
	cfg_setup.page_system.w1_row_info.on_pre_show(top);
	cfg_setup.page_system.w1_page_info_net.on_pre_show(top);
	cfg_setup.page_system.w1_page_info_chn.on_pre_show(top);
	cfg_setup.page_system.w1_page_info_disk.on_pre_show(top);
	cfg_setup.page_system.w1_page_info_alarm.on_pre_show(top);
	--ͨ
	cfg_setup.page_channel.w1_page_camera.on_pre_show(top);
	cfg_setup.page_channel.w1_page_encode.on_pre_show(top);
	cfg_setup.page_channel.w1_page_image.on_pre_show(top);
	cfg_setup.page_channel.w1_page_osd.on_pre_show(top);	
	cfg_setup.page_channel.w1_page_microphone.on_pre_show(top);	
	cfg_setup.page_channel.w1_row_channel_type.on_pre_show(top);	
	cfg_setup.page_channel.w1_page_channel_type.on_pre_show(top);
	cfg_setup.page_channel.w1_page_roi.on_pre_show(top);
	cfg_setup.page_channel.w1_page_track.on_pre_show(top);
	cfg_setup.page_channel.w1_page_param_conf.on_pre_show(top);	
	cfg_setup.page_channel.w1_page_multi_obj.on_pre_show(top);	
	cfg_setup.page_channel.w1_page_plate.on_pre_show(top);
	cfg_setup.page_channel.w1_page_face.on_pre_show(top);
	cfg_setup.page_channel.w1_page_thermal_map.on_pre_show(top);
	cfg_setup.page_channel.w1_page_thermal_cal.on_pre_show(top);
	cfg_setup.page_channel.w1_col_channel.on_pre_show(top);
	cfg_setup.page_channel.w1_row_human_thermometer.on_pre_show(top);
	cfg_setup.page_channel.w1_row_ai.on_pre_show(top);
	cfg_setup.page_channel.w1_row_imagerow.on_pre_show(top);
	cfg_setup.page_channel.w1_row_param_confrow.on_pre_show(top);
	cfg_setup.page_channel.w1_row_multi_objrow.on_pre_show(top);
	cfg_setup.page_channel.w1_row_platerow.on_pre_show(top);
	cfg_setup.page_channel.w1_row_facerow.on_pre_show(top);
	cfg_setup.page_channel.w1_row_camera.on_pre_show(top);
	cfg_setup.page_channel.w1_row_human_thermometer.on_pre_show(top);
	cfg_setup.page_system.w1_page_pri.on_pre_show(top);
	--洢
	cfg_setup.page_record.w1_page_record.on_pre_show(top);
	cfg_setup.page_record.w1_page_diskcfg.on_pre_show(top);
	cfg_setup.page_record.w1_page_raid.on_pre_show(top);
	cfg_setup.page_record.w1_page_smart.on_pre_show(top);
	cfg_setup.page_record.w1_page_wdda.on_pre_show(top);
	cfg_setup.page_record.w1_page_bad_detection.on_pre_show(top);
	cfg_setup.page_record.w1_page_disk_group.on_pre_show(top);
	cfg_setup.page_record.w1_page_cloud.on_pre_show(top);
	cfg_setup.page_record.w1_page_dis_cal.on_pre_show(top);
	cfg_setup.page_record.w1_page_ftp.on_pre_show(top);
	cfg_setup.page_record.w1_row_smart.on_pre_show(top);
	--
	cfg_setup.page_channel.w1_page_privacyarea.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_motion.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_tamper.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_loss.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_alarmin.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_ioalarm.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_alarmout.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_alarmout_c.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_audio_out.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_flash_light_alarm.on_pre_show(top);	
	cfg_setup.page_alarm.w1_page_alarm_advance.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_noopsyche_advance.on_pre_show(top);	
	cfg_setup.page_alarm.w1_page_noopsyche_person_count.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_noopsyche_badsignal.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_noopsyche_cordon.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_noopsyche_dcordon.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_noopsyche_perimeter.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_noopsyche_enter_area.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_noopsyche_leave_area.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_noopsyche_objectleft.on_pre_show(top);	
	cfg_setup.page_alarm.w1_page_noopsychearea_fence.on_pre_show(top);	
	cfg_setup.page_alarm.w1_page_noopsychearea_person_count.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_noopsychearea_cordon.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_noopsychearea_dcordon.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_noopsychearea_perimeter.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_noopsychearea_enter_area.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_noopsychearea_leave_area.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_noopsychearea_objectleft.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_noopsychearea_badsignal.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_noopsychearea_advance.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_noopsyche_objectremove.on_pre_show(top);	
	cfg_setup.page_alarm.w1_page_noopsyche_abnormal_speed.on_pre_show(top);	
	cfg_setup.page_alarm.w1_page_noopsyche_fence.on_pre_show(top);	
	cfg_setup.page_alarm.w1_page_noopsyche_converse.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_noopsyche_illegal_packing.on_pre_show(top);	
	cfg_setup.page_alarm.w1_page_noopsyche_loiter.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_noopsyche_multiloiter.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_adam.on_pre_show(top);

	cfg_setup.page_alarm.w1_page_nvr_noopsyche_general.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_nvr_noopsyche_perimeter.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_nvr_noopsychearea_perimeter.on_pre_show(top);

	cfg_setup.page_alarm.w1_page_surve.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_abnormal.on_pre_show(top);
	cfg_setup.page_alarm.w1_row_nvr_noopsyche.on_pre_show(top);
	cfg_setup.page_alarm.w1_row_noopsyche.on_pre_show(top);
	cfg_setup.page_alarm.w1_row_alarmin.on_pre_show(top);
	cfg_setup.page_alarm.w1_row_alarmout.on_pre_show(top);
	cfg_setup.page_alarm.w1_row_surve.on_pre_show(top);
	cfg_setup.page_alarm.w1_row_adam.on_pre_show(top);
	
	cfg_setup.page_alarm.w1_row_adv_insight.on_pre_show(top);
	cfg_setup.page_alarm.w1_page_adv_insight_smoker_dec.on_pre_show(top);	
	cfg_setup.page_alarm.w1_page_adv_insight_smoker_flame.on_pre_show(top);	
	cfg_setup.page_alarm.w1_page_adv_insight_fire_spot.on_pre_show(top);	

	
	--
	cfg_setup.page_network.w1_page_eth_route.on_pre_show(top);
	cfg_setup.page_network.w1_page_ipfilter.on_pre_show(top);
	cfg_setup.page_network.w1_row_net.on_pre_show(top);
	cfg_setup.page_network.w1_row_snmp.on_pre_show(top);
	cfg_setup.page_network.w1_page_net_stat.on_pre_show(top);
	cfg_setup.page_network.w1_page_lan_info.on_pre_show(top);
	cfg_setup.page_network.w1_row_upnp.on_pre_show(top);	
	cfg_setup.page_network.w1_row_smtp.on_pre_show(top)
	
	--ϵͳ
	cfg_setup.page_system.w1_page_sys.on_pre_show(top);
	cfg_setup.page_system.w1_page_dwell.on_pre_show(top);
	cfg_setup.page_system.w1_page_logm.on_pre_show(top);
	cfg_setup.page_system.w1_page_events.on_pre_show(top);
	cfg_setup.page_system.w1_page_pri.on_pre_show(top);
	cfg_setup.page_system.w1_page_phone_filter.on_pre_show(top);
	cfg_setup.page_system.w1_row_out.on_pre_show(top);
	cfg_setup.page_system.w1_page_privacy.on_pre_show(top);
	cfg_setup.page_system.w1_row_user.on_pre_show(top);
	cfg_setup.page_system.w1_row_auxiliary.on_pre_show(top);	
	cfg_setup.page_system.w1_page_auxiliary_cfg.on_pre_show(top);	
	cfg_setup.page_system.w1_page_auxiliary_dsp.on_pre_show(top);
	cfg_setup.page_system.w1_row_modify.on_pre_show(top);
	cfg_setup.page_system.w1_page_securityquestion.on_pre_show(top);
	cfg_setup.page_system.w1_page_ai_resource.on_pre_show(top);
	cfg_setup.jumppage(top, cfg_setup.cur_page);
	
	cfg_setup.last_home_type = 0;
	if (nil ~= cfg_setup.cur_page) then --ҳŹرղ	 
		--رƵ
		cfg_setup.audio_chn = b_app_api.get_audio_channel()
		if (0 < cfg_setup.audio_chn) then
			b_app_api.set_enable_audio(cfg_setup.audio_chn, 0);
		end
			
			--رնԽ
		cfg_setup.phone_open_ch =  b_app_api.get_phone_open_ch().channel;
		if(cfg_setup.phone_open_ch ~= 0 and cfg_setup.phone_open_ch ~=nil)then
			b_app_api.set_phone_open_status(cfg_setup.phone_open_ch,0)	
		end

		if (true == check_set_layout(top)) then
			set_layout(top);
		end			
		
		cfg_setup.last_home_type = b_dlg.get_home_timer_type(top);
		
		--homeڶʱǳ
		b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_chcek_login);		
	end		
	
	return 0
end

local cfg_pagedata_clear = function(top)
	cfg_setup.page_alarm.w1_page_alarmin.clear_data();
	cfg_setup.page_alarm.w1_page_ioalarm.clear_data();
	cfg_setup.page_alarm.w1_page_alarmout.clear_data();
	cfg_setup.page_alarm.w1_page_alarmout_c.clear_data();
	cfg_setup.page_alarm.w1_page_audio_out.clear_data();
	cfg_setup.page_alarm.w1_page_flash_light_alarm.clear_data();	
	cfg_setup.page_alarm.w1_page_alarm_advance.clear_data();
	cfg_setup.page_network.w1_page_ddns.clear_data();
	cfg_setup.page_record.w1_page_diskcfg.clear_data();
	cfg_setup.page_record.w1_page_ftp.clear_data();
	cfg_setup.page_record.w1_page_raid.clear_data();
	cfg_setup.page_record.w1_page_smart.clear_data();
	cfg_setup.page_record.w1_page_wdda.clear_data();
	cfg_setup.page_record.w1_page_cloud.clear_data();
	cfg_setup.page_record.w1_page_bad_detection.clear_data();
	cfg_setup.page_record.w1_page_disk_group.clear_data();
	cfg_setup.page_record.w1_page_dis_cal.clear_data();
	cfg_setup.page_system.w1_page_dwell.clear_data();
	cfg_setup.page_system.w1_page_auxiliary_cfg.clear_data();
	cfg_setup.page_system.w1_page_auxiliary_dsp.clear_data();
	cfg_setup.page_channel.w1_page_encode.clear_data();
	cfg_setup.page_channel.w1_page_image.clear_data();
	cfg_setup.page_network.w1_page_ip.clear_data();
	cfg_setup.page_network.w1_page_eth_route.clear_data();
	cfg_setup.page_network.w1_page_ipv4_cctv.clear_data();
	cfg_setup.page_system.w1_page_logm.clear_data();
	cfg_setup.page_system.w1_page_events.clear_data();
	cfg_setup.page_alarm.w1_page_loss.clear_data();
	cfg_setup.page_system.w1_page_modify.clear_data();
	cfg_setup.page_system.w1_page_modify_g.clear_data();
	cfg_setup.page_system.w1_page_securitymail.clear_data();
	cfg_setup.page_system.w1_page_securityquestion.clear_data();
	cfg_setup.page_system.w1_page_restart.clear_data();
	cfg_setup.page_system.w1_page_ai_resource.clear_data();
	cfg_setup.page_alarm.w1_page_motion.clear_data();
	cfg_setup.page_alarm.w1_page_noopsyche_person_count.clear_data();	
	cfg_setup.page_alarm.w1_page_noopsyche_advance.clear_data();
	cfg_setup.page_alarm.w1_page_noopsyche_badsignal.clear_data();
	cfg_setup.page_alarm.w1_page_noopsyche_cordon.clear_data();
	cfg_setup.page_alarm.w1_page_noopsyche_dcordon.clear_data();
	cfg_setup.page_alarm.w1_page_noopsyche_perimeter.clear_data();
	cfg_setup.page_alarm.w1_page_noopsyche_enter_area.clear_data();
	cfg_setup.page_alarm.w1_page_noopsyche_leave_area.clear_data();
	cfg_setup.page_alarm.w1_page_noopsyche_objectleft.clear_data();
	cfg_setup.page_alarm.w1_page_noopsyche_objectremove.clear_data();	
	cfg_setup.page_alarm.w1_page_noopsyche_abnormal_speed.clear_data();		
	cfg_setup.page_alarm.w1_page_noopsyche_fence.clear_data();	
	cfg_setup.page_alarm.w1_page_noopsyche_converse.clear_data();
	cfg_setup.page_alarm.w1_page_noopsyche_illegal_packing.clear_data();	
	cfg_setup.page_alarm.w1_page_noopsyche_loiter.clear_data();
	cfg_setup.page_alarm.w1_page_noopsyche_multiloiter.clear_data();	
	cfg_setup.page_alarm.w1_page_abnormal.clear_data();
	cfg_setup.page_alarm.w1_page_adam.clear_data(top);

	cfg_setup.page_alarm.w1_row_nvr_noopsyche.clear_data();
	cfg_setup.page_alarm.w1_page_nvr_noopsyche_perimeter.clear_data();

	cfg_setup.page_alarm.w1_page_nvr_noopsycheevent_perimeter.clear_data();
	cfg_setup.page_alarm.w1_page_nvr_noopsychearea_perimeter.clear_data();
	cfg_setup.page_alarm.w1_page_nvr_noopsychetimeplan_perimeter.clear_data();


	cfg_setup.page_alarm.w1_row_adv_insight.clear_data();
	cfg_setup.page_alarm.w1_page_adv_insight_smoker_dec.clear_data();
	cfg_setup.page_alarm.w1_page_adv_insight_smoker_flame.clear_data();
	cfg_setup.page_alarm.w1_page_adv_insight_fire_spot.clear_data();
	cfg_setup.page_alarm.w1_page_adv_insightarea_smoker_dec.clear_data();
	cfg_setup.page_alarm.w1_page_adv_insightevent_smoker_dec.clear_data();
	cfg_setup.page_alarm.w1_page_adv_insighttimeplan_smoker_dec.clear_data();
	cfg_setup.page_alarm.w1_page_adv_insightarea_smoker_flame.clear_data();
	cfg_setup.page_alarm.w1_page_adv_insightevent_smoker_flame.clear_data();
	cfg_setup.page_alarm.w1_page_adv_insighttimeplan_smoker_flame.clear_data();
	cfg_setup.page_alarm.w1_page_adv_insightarea_fire_spot.clear_data();
	cfg_setup.page_alarm.w1_page_adv_insightevent_fire_spot.clear_data();
	cfg_setup.page_alarm.w1_page_adv_insighttimeplan_fire_spot.clear_data();

	cfg_setup.page_alarm.w1_row_noopsyche.clear_data();
	cfg_setup.page_channel.w1_page_osd.clear_data();
	cfg_setup.page_channel.w1_page_microphone.clear_data();	
	cfg_setup.page_network.w1_page_poe.clear_data();
	cfg_setup.page_channel.w1_page_roi.clear_data();
	cfg_setup.page_channel.w1_page_track.clear_data();
	cfg_setup.page_channel.w1_page_param_conf.clear_data();	
	cfg_setup.page_channel.w1_page_thermal_map.clear_data();
	cfg_setup.page_channel.w1_page_thermal_cal.clear_data();
	cfg_setup.page_channel.w1_page_privacyarea.clear_data();
	cfg_setup.page_system.w1_page_phone_filter.clear_data(top);
	cfg_setup.page_channel.w1_page_multi_obj.clear_data();
	cfg_setup.page_channel.w1_page_plate.clear_data();
	cfg_setup.page_channel.w1_page_face.clear_data();
	cfg_setup.page_record.w1_page_record.clear_data();
	cfg_setup.page_network.w1_page_smtp.clear_data();
	cfg_setup.page_network.w1_page_smtp2.clear_data();
	cfg_setup.page_network.w1_page_immix.clear_data();
	cfg_setup.page_system.w1_page_sys.clear_data();
	cfg_setup.page_alarm.w1_page_tamper.clear_data();
	cfg_setup.page_network.w1_page_nat_port.clear_data();
	cfg_setup.page_system.w1_page_time.clear_data();
	cfg_setup.page_network.w1_page_wifi_cfg.clear_data();
	cfg_setup.page_network.w1_page_wifi_network.clear_data();
	cfg_setup.page_network.w1_page_3g_4g.clear_data();
	cfg_setup.page_alarm.w1_page_motionevent.clear_data();
	cfg_setup.page_alarm.w1_page_motionarea.clear_data();
	cfg_setup.page_alarm.w1_page_motiontimeplan.clear_data();
	cfg_setup.page_alarm.w1_page_tamperevent.clear_data();
	cfg_setup.page_alarm.w1_page_tampertimeplan.clear_data();
	cfg_setup.page_alarm.w1_page_lossevent.clear_data();
	cfg_setup.page_alarm.w1_page_losstimeplan.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychearea_advance.clear_data();
	cfg_setup.page_alarm.w1_page_noopsycheevent_badsignal.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychearea_badsignal.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychetimeplan_badsignal.clear_data();
	cfg_setup.page_alarm.w1_page_noopsycheevent_cordon.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychearea_cordon.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychetimeplan_cordon.clear_data();
	cfg_setup.page_alarm.w1_page_noopsycheevent_dcordon.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychearea_dcordon.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychetimeplan_dcordon.clear_data();
	cfg_setup.page_alarm.w1_page_noopsycheevent_perimeter.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychearea_perimeter.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychetimeplan_perimeter.clear_data();
	cfg_setup.page_alarm.w1_page_noopsycheevent_objectleft.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychearea_objectleft.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychetimeplan_objectleft.clear_data();
	cfg_setup.page_alarm.w1_page_alarminevent.clear_data();
	cfg_setup.page_alarm.w1_page_alarmintimeplan.clear_data();
	cfg_setup.page_alarm.w1_page_ioalarmevent.clear_data();
	cfg_setup.page_alarm.w1_page_ioalarmtimeplan.clear_data();
	cfg_setup.page_alarm.w1_page_abnormalevent.clear_data();
	cfg_setup.page_alarm.w1_page_noopsycheevent_objectremove.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychearea_objectremove.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychetimeplan_objectremove.clear_data();
	cfg_setup.page_alarm.w1_page_noopsycheevent_loiter.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychearea_loiter.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychetimeplan_loiter.clear_data();
	cfg_setup.page_alarm.w1_page_noopsycheevent_multiloiter.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychearea_multiloiter.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychetimeplan_multiloiter.clear_data();
	cfg_setup.page_alarm.w1_page_noopsycheevent_converse.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychearea_converse.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychearea_fence.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychearea_person_count.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychetimeplan_converse.clear_data();
	cfg_setup.page_alarm.w1_page_noopsycheevent_illegal_packing.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychearea_illegal_packing.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychetimeplan_illegal_packing.clear_data();
	cfg_setup.page_alarm.w1_page_noopsycheevent_fence.clear_data();
	cfg_setup.page_alarm.w1_page_noopsycheevent_abnormal_speed.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychearea_abnormal_speed.clear_data();
	cfg_setup.page_alarm.w1_page_noopsychetimeplan_abnormal_speed.clear_data();
	cfg_setup.page_channel.w1_page_imagetime.clear_data();
	cfg_setup.page_channel.w1_page_imageadjust.clear_data();
	cfg_setup.page_channel.w1_page_imagescenes.clear_data();
	cfg_setup.page_channel.w1_page_imageexposure.clear_data();
	cfg_setup.page_channel.w1_page_imagebalance.clear_data();
	cfg_setup.page_channel.w1_page_imagedaynight.clear_data();
	cfg_setup.page_channel.w1_page_imagenoise.clear_data();
	cfg_setup.page_channel.w1_page_imageenhance.clear_data();
	cfg_setup.page_channel.w1_page_imagefocus.clear_data();
	cfg_setup.page_channel.w1_page_imagepcolor.clear_data();
	cfg_setup.page_channel.w1_page_imageffc.clear_data();
	cfg_setup.page_channel.w1_page_pro_man.clear_data();
	cfg_setup.page_channel.w1_page_camera.clear_data(top);
	cfg_setup.page_channel.w1_page_param_confface_detect.clear_data(top);
	cfg_setup.page_channel.w1_page_param_conftemp_param.clear_data(top);
	cfg_setup.page_channel.w1_page_param_conf_levent.clear_data(top);
	cfg_setup.page_channel.w1_page_param_conf_nevent.clear_data(top);
	cfg_setup.page_channel.w1_page_param_conf_hevent.clear_data(top);
	cfg_setup.page_channel.w1_page_param_conftimeplan.clear_data(top);
	cfg_setup.page_channel.w1_page_multi_objparam.clear_data(top);
	cfg_setup.page_channel.w1_page_multi_objtimeplan.clear_data(top);
	cfg_setup.page_channel.w1_page_plateparam.clear_data(top);
	cfg_setup.page_channel.w1_page_platetimeplan.clear_data(top);
	cfg_setup.page_channel.w1_page_faceparam.clear_data(top);
	cfg_setup.page_channel.w1_page_facetimeplan.clear_data(top);
	cfg_setup.page_network.w1_page_ipfilter.clear_data();
	cfg_setup.page_system.w1_page_privacy.clear_data();
	cfg_setup.page_channel.w1_page_analog_audio_in.clear_data(top);

	return 0;
end

cfg_setup.on_destroy = function(top)
	--Զǳٴʱԭǰ
	if cfg_setup.page_record.w1_page_bad_detection.timestart  then
		cfg_setup.page_record.w1_page_bad_detection.okfunc_diskdetect({top})
	end
	cfg_setup.page_channel.w1_page_image.cancel (top);
	cfg_setup.top = nil;
	cfg_setup.dlg = nil;
	if (nil ~= cfg_setup.cur_page) then	 --ҳŻָ
		--ָƵ
		if (0 < cfg_setup.audio_chn) then
			b_app_api.set_enable_audio(cfg_setup.audio_chn, 1);
		end
		--ָԽ
		if( cfg_setup.phone_open_ch > 0)then
			b_app_api.set_phone_open_status(cfg_setup.phone_open_ch,1)	
		end
		b_dlg.set_home_timer_type(top, cfg_setup.last_home_type);
	end	
	cfg_setup.cur_page = nil;
	cfg_pagedata_clear(top);
	b_app_cfg.cfgdataclear(); 
	w1_wnd_util.tipdispoff();
	
	return 0;
end

cfg_setup.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top);
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_title_bk'));
	b_wnd.end_job(top);
	return 0;
end

cfg_setup.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
 	if( b_ui.WM_USER_UPDATE_LANGUAGE == vmsg
		or b_ui.WM_USER_CHANGE_RESOLUTION == vmsg)then
		return vmsg;
	elseif( b_ui.RBUTTONCLK == vmsg)then
		if cfg_setup.page_record.w1_page_bad_detection.timestart then
		cfg_setup.page_record.w1_page_bad_detection.stop_block_detect(top);
			if cfg_setup.page_record.w1_page_bad_detection.flag == 0 then
				return 0;
			end
		end
		cfg_exit(top);
	elseif (b_ui_msg.msg_on_exit_system == vmsg) then
		return vmsg
	elseif( b_ui.LBUTTONCLK == vmsg)then
		local cur_page = w1_wnd_jump.get_cur_page()
		if cur_page ~= nil and cur_page.dwell_updata_f ~= nil then
			cur_page.dwell_updata_f(top);
		end
	elseif(b_ui.MOUSEWHEELUP == vmsg) then
		local cur_page = w1_wnd_jump.get_cur_page()
		if ((cur_page ~= nil) and (cur_page.dwell_mouse_up ~= nil)) then
			cur_page.dwell_mouse_up(top);
		end
	elseif(b_ui.MOUSEWHEELDOWN == vmsg) then
		local cur_page = w1_wnd_jump.get_cur_page()
		if ((cur_page ~= nil) and (cur_page.dwell_mouse_down ~= nil)) then
			cur_page.dwell_mouse_down(top);
		end	
	elseif(b_ui.LBUTTONDRAG == vmsg) then
		local cur_page = w1_wnd_jump.get_cur_page()
		if ((cur_page ~= nil) and (cur_page.dwell_drop_drag ~= nil)) then
			cur_page.dwell_drop_drag(top);
		end
	elseif (b_ui.WM_USER_UPDATE_PARAM == vmsg) then
		local cur_page = w1_wnd_jump.get_cur_page()	
		if ((cur_page ~= nil) and (cur_page.wnd.id == w1_id.cfg_channel_type.channeltype_id)) then
			cur_page.get_chn_data(top);
		elseif (((cur_page ~= nil)) and (cur_page.on_data_change ~= nil)) then
			cur_page.on_data_change(top);
		end 
	elseif  vmsg == b_ui.WM_CLICKED_EXPORT	 then
		local cur_page = w1_wnd_jump.get_cur_page()	
		if ((cur_page ~= nil) and (cur_page.on_clicked_export ~= nil)) then
			cur_page.on_clicked_export(top, x, y);
		end	
	elseif  vmsg == b_ui.WM_CLICKED_AUDITION	 then
		local cur_page = w1_wnd_jump.get_cur_page()	
		if ((cur_page ~= nil) and (cur_page.on_clicked_audition ~= nil)) then
			cur_page.on_clicked_audition(top, x, y);
		end	
	elseif (b_ui.WM_USER_JUMP2CFG == vmsg ) then
		return vmsg;	
	end
	
	return 0
end

return cfg_setup
