--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_setup_title_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local b_dlg 		= require("wnd.core.b_dlg")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local w1_col_alarm 	= require("wnd.w1_cfg.w1_col_alarm")
local w1_col_channel = require("wnd.w1_cfg.w1_col_channel")
local w1_cfg_setup_title = {}

local on_channel = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local nret = w1_wnd_jump.click_title(top, w1_cfg_setup_title.wnd, win_id, false)
		if(nret ~= 0)then
			b_wnd_ex.set_check(top, win_id, false, true);
			return 0;
		end	
		
		local privilege = global_val.get_allprivilege();--ȡȨ
		if(privilege.device_manager) then
			
		else--û豸ȨޣôͨĬ2
			w1_wnd_jump.click_col(top, w1_col_channel.wnd, w1_id.col_channel_id + 2, false);
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_storage = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local nret = w1_wnd_jump.click_title(top, w1_cfg_setup_title.wnd, win_id, false)
		if(nret ~= 0)then
			b_wnd_ex.set_check(top, win_id, false, true);
			return 0;
		end			
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_alarm = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local cwnd = w1_cfg_setup_title.wnd;
		local nret = w1_wnd_jump.click_title(top, cwnd, win_id, false)
		if(nret ~= 0)then
			b_wnd_ex.set_check(top, win_id, false, true);
			return 0;
		end			
			
		local privilege = global_val.get_allprivilege();--ȡȨ
		if(privilege.systerm_config) then
			
		else--ûϵͳȨޣôĬ2
			w1_wnd_jump.click_col(top, w1_col_alarm.wnd, w1_id.col_alarm_id + 2, false);
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_network = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local nret = w1_wnd_jump.click_title(top, w1_cfg_setup_title.wnd, win_id, false)
		if(nret ~= 0)then
			b_wnd_ex.set_check(top, win_id, false, true);
			return 0;
		end	
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_device = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local nret = w1_wnd_jump.click_title(top, w1_cfg_setup_title.wnd, win_id, false)
		if(nret ~= 0)then
			b_wnd_ex.set_check(top, win_id, false, true);
			return 0;
		end	
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_system = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local nret = w1_wnd_jump.click_title(top, w1_cfg_setup_title.wnd, win_id, false)
		if(nret ~= 0)then
			b_wnd_ex.set_check(top, win_id, false, true);
			return 0;
		end			
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

w1_cfg_setup_title.set_disable = function(top, privilege, redraw)
	local cwnd = w1_cfg_setup_title.wnd;
	local idtab = {cwnd.channel.id, cwnd.storage.id, cwnd.alarm.id,
					cwnd.network.id, cwnd.system.id};				
	local param = {false, false, false, false, false};
	if(privilege.systerm_config) then
		param[2] = false; param[4] = false;
	else
		param[2] = true; param[4] = true;
	end
	if(privilege.device_manager == false and privilege.channel_manager == false) then
		param[1] = true;
	else
		param[1] = false;
	end
	if(privilege.systerm_config == false and privilege.channel_manager == false) then
		param[3] = true;
	else
		param[3] = false;
	end		
		
	for i=1, #param do
		b_wnd_ex.set_disable(top, idtab[i], param[i], redraw);
	end
end

w1_cfg_setup_title.move_title_show= function(top)
	local pb_flag = global_val.get_playback_support();
	local cwnd = w1_cfg_setup_title.wnd;
	local pos = SIZE('s_cfg_title_xywh');
	local left_off  = SIZE('s_cfg_column_xywh')
	local title_w =pos[3]-left_off[3]
	
	local size1 = b_wnd_ex.get_textsize(top, cwnd.channel.id).w;
	local size2 = b_wnd_ex.get_textsize(top, cwnd.storage.id).w;
	local size3 = b_wnd_ex.get_textsize(top, cwnd.alarm.id).w;
	local size4 = b_wnd_ex.get_textsize(top, cwnd.network.id).w;
	local size5 = b_wnd_ex.get_textsize(top, cwnd.system.id).w;
	local sum_size = size1 + size2 + size3 + size4 + size5 
	local space = b_wnd_ex.get_textsize(top, cwnd.system.id).border * 60 ;--
	local total_w = sum_size+space *5
	
	local space2 = b_wnd_ex.get_textsize(top, cwnd.system.id).border * 40 ;--
	local total_w2 = sum_size+space2 *5
	
	local space3 = b_wnd_ex.get_textsize(top, cwnd.system.id).border * 30 ;--
	local total_w3 = sum_size+space3 *5
	
	local space4 = b_wnd_ex.get_textsize(top, cwnd.system.id).border * 25 ;--
	local total_w4 = sum_size +space4 *5
		
	if (pb_flag ~= true) then --Ʒ
		total_w = 	total_w - size2 - space;
		total_w2 = total_w2 - size2 - space2;
		total_w3 = total_w3 - size2 - space3;
		total_w4 = total_w4 - size2 - space4;
	end
	
	
	local title_1 = SIZE('s_cfg_title_1')
	local move_title = function (top,space)
		if (pb_flag ~= true) then --Ʒ
			b_wnd_ex.set_hide(top, cwnd.storage.id, true, false);
			
			local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
			b_wnd_ex.move_ex(top, cwnd.channel.id, movepos1, false);
			local movepos3 = {title_1[1]+size1+space,title_1[2],size3,title_1[4]};
			b_wnd_ex.move_ex(top, cwnd.alarm.id, movepos3, false);
			local movepos4 = {title_1[1]+size1+size3+2*space,title_1[2],size4,title_1[4]};
			b_wnd_ex.move_ex(top, cwnd.network.id, movepos4, false);
			local movepos5 = {title_1[1]+size1+size3+size4+3*space,title_1[2],size5,title_1[4]};
			b_wnd_ex.move_ex(top, cwnd.system.id, movepos5, false);	
		else
			local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
			b_wnd_ex.move_ex(top, cwnd.channel.id, movepos1, false);
			local movepos2 = {title_1[1]+size1+space,title_1[2],size2,title_1[4]};
			b_wnd_ex.move_ex(top, cwnd.storage.id, movepos2, false);
			local movepos3 = {title_1[1]+size1+size2+2*space,title_1[2],size3,title_1[4]};
			b_wnd_ex.move_ex(top, cwnd.alarm.id, movepos3, false);
			local movepos4 = {title_1[1]+size1+size2+size3+3*space,title_1[2],size4,title_1[4]};
			b_wnd_ex.move_ex(top, cwnd.network.id, movepos4, false);
			local movepos5 = {title_1[1]+size1+size2+size3+size4+4*space,title_1[2],size5,title_1[4]};
			b_wnd_ex.move_ex(top, cwnd.system.id, movepos5, false);
		end
	end
	if(title_w > total_w)then
		move_title(top,space)
	elseif (title_w > total_w2)then					--ӦܳͨС
		move_title(top,space2)
	elseif (title_w > total_w3)then
		move_title(top,space3)
	elseif (title_w > total_w4)then
		move_title(top,space4)
	end

end

w1_cfg_setup_title.on_pre_show =function(top)
	w1_cfg_setup_title.move_title_show(top);

end


w1_cfg_setup_title.wnd = {
	t='wnd_bg',id=id,xywh = 's_cfg_title_xywh',
	color_d= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfg_title_bk'}, 
	sub = {'settingimg','settingtxt', 'channel', 'storage', 'alarm', 'network', 'system'},
	
	channel 	= {t='checktxt',	id=id+1,xywh='s_cfg_title_1', 		
					text='LA_CHANNEL',	font = 'f_grade3',
					align = b_ui.ALIGN.LEFT,
					color = {'c_cfg_title_bk', 'c_cfg_title_bk', 'c_cfg_title_txt_n'},
					color_c = {'c_cfg_title_bk', 'c_cfg_title_bk', 'c_cfg_title_txt_c'},
					color_f = {'c_cfg_title_bk', 'c_cfg_title_bk', 'c_cfg_title_txt_f'},
					cmd = on_channel, check = true},
	storage 	= {t='checktxt',	id=id+2,xywh='s_cfg_title_2', 		
					text='LA_STORAGE',	font = 'f_grade3',
					align = b_ui.ALIGN.LEFT,
					color = {'c_cfg_title_bk', 'c_cfg_title_bk', 'c_cfg_title_txt_n'},
					color_c = {'c_cfg_title_bk', 'c_cfg_title_bk', 'c_cfg_title_txt_c'},
					color_f = {'c_cfg_title_bk', 'c_cfg_title_bk', 'c_cfg_title_txt_f'},
					cmd = on_storage},
	alarm 		= {t='checktxt',	id=id+3,xywh='s_cfg_title_3',		
					text='LA_ALARM_MANAGER',	font = 'f_grade3',
					align = b_ui.ALIGN.LEFT,
					color = {'c_cfg_title_bk', 'c_cfg_title_bk', 'c_cfg_title_txt_n'},
					color_c = {'c_cfg_title_bk', 'c_cfg_title_bk', 'c_cfg_title_txt_c'},
					color_f = {'c_cfg_title_bk', 'c_cfg_title_bk', 'c_cfg_title_txt_f'},
					cmd = on_alarm},
	network 	= {t='checktxt',	id=id+4,xywh='s_cfg_title_4',		
					text='LA_NETWORK',	font = 'f_grade3',
					align = b_ui.ALIGN.LEFT,
					color = {'c_cfg_title_bk', 'c_cfg_title_bk', 'c_cfg_title_txt_n'},
					color_c = {'c_cfg_title_bk', 'c_cfg_title_bk', 'c_cfg_title_txt_c'},
					color_f = {'c_cfg_title_bk', 'c_cfg_title_bk', 'c_cfg_title_txt_f'},
					cmd = on_network},
	system 		= {t='checktxt',	id=id+5,xywh='s_cfg_title_5',		
					text='LA_SYSTEM',	font = 'f_grade3',
					align = b_ui.ALIGN.LEFT,
					color = {'c_cfg_title_bk', 'c_cfg_title_bk', 'c_cfg_title_txt_n'},
					color_c = {'c_cfg_title_bk', 'c_cfg_title_bk', 'c_cfg_title_txt_c'},
					color_f = {'c_cfg_title_bk', 'c_cfg_title_bk', 'c_cfg_title_txt_f'},
					cmd = on_system},
	
	settingimg 	= {t='tt_picture',	id=id+6,xywh='s_cfg_setimg_xywh', 
					align = b_ui.ALIGN.LEFT,
					t_img ={b_ui.ALIGN.LEFT,'c_set_bank2_bg','f_setimg','it_settingimg'}},
	
	settingtxt 	= {t='static', 	id=id+7,xywh='s_cfg_settxt_xywh', 
					text='LA_SYSTEM',	font = 'f_grade1',
					align = b_ui.ALIGN.LEFT,
					color = {'c_cfg_title_bk', 'c_cfg_title_bk', 'c_txt_f'},
					},

}

return w1_cfg_setup_title
