--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 	 		= w1_id.col_alarm_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local r_size		= require("wnd.core.r_res.r_size")
local b_dlg 		= require("wnd.core.b_dlg")
local SIZE			= r_size.get_size;

local ai_num;
local w1_col_alarm = {}
local dev_type;

local on_upate_param = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local nret = w1_wnd_jump.click_col(top, w1_col_alarm.wnd, win_id, true)
		if(nret ~= 0)then
			b_wnd_ex.set_check(top, win_id, false, true);
		end
	end
	return 0;
end

w1_col_alarm.on_pre_show = function(top, chnum)
	dev_type = global_val.get_dev_type();
	local cwnd = w1_col_alarm.wnd;
	local dev_flag = true;
	local GENERAL 		= 1;
	local MOTION 		= 2;
	local TAMPER 		= 3;
	local LOSS 			= 4;
	local ADV_INSIGHT 	= 5;
	local INSIGHT 		= 6;
	local ALARMIN 		= 7;
	local ABNORMAL		= 8;
	local ALARMOUT  	= 9;
	local ADAM 			= 10;
	local NVR_INSIGHT 	= 11;
 
	if dev_type ~= 2 then
		dev_flag = false
	end
	
	local svp_support;
	if (global_val.get_support_svp() == 0) then
		svp_support = false;
	else
		svp_support = true;
	end
	
	local adam_support = global_val.get_adam_support();
	local num = 1;
	local idx_table = 
	{
		{true,GENERAL},--{ҳתidⷭ}
		{true,MOTION},
		{dev_flag,TAMPER},
		{true,LOSS},
		{true,ADV_INSIGHT},		
		{true,INSIGHT},		
		{true,ALARMIN},
		{true,ABNORMAL},
		{true,ALARMOUT},
		{adam_support,ADAM},
		{svp_support,NVR_INSIGHT},
	
	}
	for i,v in ipairs(idx_table) do
		if v[1] then
			b_wnd_ex.set_hide(top,v[2]+id,false,false);
			local pos =SIZE('s_cfg_col_'..tostring(num))
			b_wnd_ex.move_ex(top,v[2]+id,pos,false)
			num = num + 1 
		else
			b_wnd_ex.set_hide(top,v[2]+id,true,false);
		end
	end
	
	
	return 0;
end

w1_col_alarm.set_disable = function(top, privilege, redraw)
	local GENERAL 		= 1;
	local MOTION 		= 2;
	local TAMPER 		= 3;
	local LOSS 			= 4;
	local ADV_INSIGHT 	= 5;
	local INSIGHT 		= 6;
	local ALARMIN 		= 7;
	local ABNORMAL		= 8;
	local ALARMOUT  	= 9; 
	local ADAM 			= 10;	
	local NVR_INSIGHT 	= 11;

	local cwnd = w1_col_alarm.wnd;
	local idtab = {cwnd.surve.id, cwnd.motion.id, cwnd.tamper.id,
					cwnd.loss.id,cwnd.adv_insight.id,  cwnd.insight.id, cwnd.alarm_in.id,
					cwnd.abnormal.id,cwnd.alarm_out.id,cwnd.adam.id, cwnd.nvr_insight.id};
	local param = {false, false, false, false, false, false,false,false, false, false, false};				
				
	if(privilege.channel_manager) then
		param[MOTION] = false; param[TAMPER] = false; param[LOSS] = false;
		param[ADV_INSIGHT] = false;param[INSIGHT] = false;param[NVR_INSIGHT] = false;
	else
		param[MOTION] = true; param[TAMPER] = true; param[LOSS] = true;
		param[ADV_INSIGHT] = true; param[INSIGHT] = true;param[NVR_INSIGHT] = true;
	end
	
	if(privilege.systerm_config) then
		param[ABNORMAL] = false;
		param[GENERAL] = false;
	else
		param[ABNORMAL] = true;
		param[GENERAL] = true;
	end
	
	local ai_num = global_val.get_sinum()
	local ro_num = global_val.get_ronum()
	if (privilege.systerm_config and ai_num>0)  or privilege.channel_manager then
		param[ALARMIN] = false;
	else
		param[ALARMIN] = true;
	end
	
	if (privilege.systerm_config and ro_num>0)  or privilege.channel_manager then
		param[ALARMOUT] = false;
	else
		param[ALARMOUT] = true;
	end
	
	for i=1, #param do
		b_wnd_ex.set_disable(top, idtab[i], param[i], redraw);
	end
end


w1_col_alarm.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_column_xywh',
	color_d= {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_cfg_col_bk'}, 
	sub = {'surve', 'motion', 'tamper', 'loss', 'adv_insight', 'insight', 'alarm_in','abnormal','alarm_out', 'adam', 'nvr_insight'},
	
	surve 	= {t='checkimgtxt',id=id+1,xywh='s_cfg_col_1', 	text='LA_SURVEILLANCE',		
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',	
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_upate_param, check = true},
			
	motion 	= {t='checkimgtxt',id=id+2,xywh='s_cfg_col_2', 	text='LA_MOTION_DETECTION',
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_upate_param},			
	tamper 	= {t='checkimgtxt',id=id+3,xywh='s_cfg_col_3', 	text='LA_TAMPER_ALARM',		
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',	
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_upate_param},			
	loss 	= {t='checkimgtxt',id=id+4,xywh='s_cfg_col_4', 	text='LA_VIDEO_LOST',	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',	
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_upate_param},
	adv_insight	= {t='checkimgtxt',id=id+5,xywh='s_cfg_col_5', 	text='LA_ADVANCED_INTELLIGENCE_ANALYSIS',	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',	
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_upate_param},			
	insight	= {t='checkimgtxt',id=id+6,xywh='s_cfg_col_6', 	text='LA_INSIGHT',	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',	
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_upate_param},			
	alarm_in = {t='checkimgtxt',id=id+7,xywh='s_cfg_col_7', 	text='LA_ALARM_IN',	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',	
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_upate_param},
	abnormal = {t='checkimgtxt',id=id+8,xywh='s_cfg_col_8', 	text='LA_ABNORMAL_ALARM',	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',	
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_upate_param},
	alarm_out = {t='checkimgtxt',id=id+9,xywh='s_cfg_col_9', 	text='LA_ALARM_OUT',	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',	
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_upate_param},
	adam = {t='checkimgtxt',id=id+10,xywh='s_cfg_col_10', 	text='LA_ADAM',	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',	
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_upate_param},				
	nvr_insight	= {t='checkimgtxt',id=id+11,xywh='s_cfg_col_11', 	text='LA_LOCAL_INSIGHT',	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',	
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_upate_param},							
				
}

return w1_col_alarm
