--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 	 		= w1_id.col_channel_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_msgbox 	= require("wnd.w1_util.w1_msgbox")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;

local w1_col_channel = {}

--Ȩʾ
local do_noprivilege = function(top)
	w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_NO_PRIVILEGE'), true, false,false);
	w1_msgbox.set_func(nil, nil, nil, nil);
	b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);	
end

local on_camera = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local nret = w1_wnd_jump.click_col(top, w1_col_channel.wnd, win_id, true)
		if(nret ~= 0)then
			b_wnd_ex.set_check(top, win_id, false, true);
		end
	end
	return 0;
end

local on_click = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local privilege = global_val.get_allprivilege();--ȡȨ
		if(global_val.get_isallprizero(privilege.channel_manager_list)) then	
			do_noprivilege(top);
			b_wnd_ex.set_check(top, win_id, false, true);
			return 0;
		end	
		local nret = w1_wnd_jump.click_col(top, w1_col_channel.wnd, win_id, true)
		if(nret ~= 0)then
			b_wnd_ex.set_check(top, win_id, false, true);
		end
	end
	return 0;
end

local on_chn_type = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local nret = w1_wnd_jump.click_col(top, w1_col_channel.wnd, win_id, true)
		if(nret ~= 0)then
			b_wnd_ex.set_check(top, win_id, false, true);
		end			
	end
	return 0;
end

w1_col_channel.set_disable = function(top, privilege, redraw)
	local CAMERA 		= 1;
	local ENCODE 		= 2;
	local IMAGE 		= 3;
	local OSD 			= 4;
	local PRIZONE 		= 5;	
	local CHNTYPE 		= 6;
	local ROI			= 7;	
	local MICROPHONE	= 8;
	local HUMANTHERMOMETER = 9;
	local AI			= 10;
	local TRACT 		= 11;
	local cwnd = w1_col_channel.wnd;
	local idtab = {cwnd.camera.id, cwnd.encode.id, cwnd.image.id,cwnd.privacy_area.id, 
					cwnd.osd.id, cwnd.channel_type.id, cwnd.roi.id, cwnd.microphone.id,
					cwnd.humanthermometer.id,cwnd.ai.id,cwnd.track.id};
	local param = {false, false, false, false, false, false, false, false, false, false};				
				
	if(privilege.channel_manager) then
		param[ENCODE] = false; param[IMAGE] = false;param[OSD] = false;
		param[PRIZONE] = false;param[ROI] = false;param[MICROPHONE] = false;
		param[HUMANTHERMOMETER] = false;param[AI] = false; param[TRACT]=false;
	else
		param[ENCODE] = true; param[IMAGE] = true;param[OSD] = true;
		param[PRIZONE] = true;param[ROI] = true;param[MICROPHONE] = true;
		param[HUMANTHERMOMETER] = true;param[AI] = true;param[TRACT]=true;
	end
	if(privilege.device_manager) then
		param[CAMERA] = false; param[CHNTYPE] = false;
	else	
		param[CAMERA] = true; param[CHNTYPE] = true;
	end
	
	for i=1, #param do
		b_wnd_ex.set_disable(top, idtab[i], param[i], redraw);
	end
end

w1_col_channel.on_pre_show = function(top)
	local cwnd = w1_col_channel.wnd
	local CAMERA 		= 1;
	local ENCODE 		= 2;
	local IMAGE 		= 3;
	local OSD 			= 4;
	local PRIZONE 		= 5;
	local CHN_TYPE 		= 6;
	local ROI 			= 7;
	local MICROPHONE	= 8;
	local HUMANTHERMOMETER = 9;
	local AI			= 10;
	local TRACK			= 11;
	local chn_type_support = global_val.get_chn_type_support();
	local num = 1;
	local idx_table = 
	{
		{true,CAMERA},
		{true,ENCODE},
		{true,IMAGE},
		{true,OSD},
		{true,PRIZONE},
		{chn_type_support,CHN_TYPE},
		{true,ROI},
		{true,MICROPHONE},
		{true,HUMANTHERMOMETER},
		{true,AI},
		{true,TRACK},
	}
	local hide_line = 0;
	for i,v in ipairs(idx_table) do
		if v[1] then
			b_wnd_ex.set_hide(top,v[2]+id,false,false);
			local pos =SIZE('s_cfg_col_'..tostring(num))
			b_wnd_ex.move_ex(top,v[2]+id,pos,false)
			num = num + 1 
		else
			b_wnd_ex.set_hide(top,v[2]+id,true,false);
		end
	end
end

w1_col_channel.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_column_xywh',
	color_d= {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_cfg_col_bk'}, 
	sub = {'camera', 'encode', 'image','privacy_area', 'osd', 'channel_type','roi', 'microphone', 
			'humanthermometer','ai','track'},
	
	camera 	= {t='checkimgtxt',id=id+1,xywh='s_cfg_col_1', 	text='LA_CAMERA',		
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',	
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_camera, check = true},			
	encode 	= {t='checkimgtxt',id=id+2,xywh='s_cfg_col_2', 	text='LA_ENCODE_PARAMETER',
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_click},			
	image 	= {t='checkimgtxt',id=id+3,xywh='s_cfg_col_3', 	text='LA_SENSOR_SETTING',		
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',	
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_click},
	osd 	= {t='checkimgtxt',id=id+4,xywh='s_cfg_col_4', 		text='LA_OSD',	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',	
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_click},	
	privacy_area= {t='checkimgtxt',id=id+5,xywh='s_cfg_col_5', 	text='LA_PRIVACY_MASK',
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_click},			
	channel_type= {t='checkimgtxt',id=id+6,xywh='s_cfg_col_6', 	text='LA_CHANNEL_TYPE',
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_chn_type},
	roi		= {t='checkimgtxt',id=id+7,xywh='s_cfg_col_7', 	text='LA_ROI',		
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',	
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_click},
	microphone= {t='checkimgtxt',id=id+8,xywh='s_cfg_col_8', 	text='LA_MICRO_PHONE',
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_click},	
	humanthermometer= {t='checkimgtxt',id=id+9,xywh='s_cfg_col_9', 	text='LA_HUMAN_THERMOMETER',
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_click},
	ai		= {t='checkimgtxt',id=id+10,xywh='s_cfg_col_10', 	text='LA_AI',
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_click},
	track		= {t='checkimgtxt',id=id+11,xywh='s_cfg_col_11', 	text='LA_INTELLIGENT_TRACK',
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_click},
}

return w1_col_channel
