--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/3/13
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 	 	= w1_id.col_net_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local b_dlg 		= require("wnd.core.b_dlg")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local global_val	= require("wnd.global_val")
local w1_col_net = {}
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local on_update_param = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local nret = w1_wnd_jump.click_col(top, w1_col_net.wnd, win_id, true)
		if(nret ~= 0)then
			b_wnd_ex.set_check(top, win_id, false, true);
		end
	end
	return 0
end

w1_col_net.on_pre_show = function(top)
	local cwnd = w1_col_net.wnd
	local NETWORK 	= 1;
	local N8021X	= 2;
	local DDNS 		= 3;
	local EMAIL 	= 4;
	local UPNP 		= 5;
	local PP 		= 6;
	local IPFILTER 	= 7;
	local SNMP 		= 8;
	local N3G_4G	= 9;
	local PPPOE		= 10;
	local POE 		= 11;
	local LAN_INFO	= 12;
	local ALARM_CENTER = 13;
	local PLATFORM_ACCESS = 14;	
	
	local p2p_flag = global_val.get_p2p_support();
	local snmp_support = G.get_snmp_support()
	local moblie_3g_support = G.get_support_mobile_3g_attr()
	local pppoe_support = G.get_support_pppoe_attr()
	local poe_net_support = G.get_network_map_support()
	local alarm_center_support = global_val.get_alarm_center_support();
	local platform_access_support = global_val.get_platform_access_support();
		
	local num = 1;
	local idx_table = 
	{
		{true,NETWORK},
		{true,N8021X},
		{true,DDNS},
		{true,UPNP},
		{true,EMAIL},		
		{p2p_flag,PP},
		{true,IPFILTER},
		{snmp_support,SNMP},
		{moblie_3g_support,N3G_4G},
		{pppoe_support,PPPOE},
		{poe_net_support,POE},
		{true,LAN_INFO},
		{alarm_center_support,ALARM_CENTER},
		{platform_access_support, PLATFORM_ACCESS}
	}
	local hide_line = 0;
	for i,v in ipairs(idx_table) do
		if v[1] then
			b_wnd_ex.set_hide(top,v[2]+id,false,false);
			local pos =SIZE('s_cfg_col_'..tostring(num))
			b_wnd_ex.move_ex(top,v[2]+id,pos,false)
			num = num + 1 
		else
			b_wnd_ex.set_hide(top,v[2]+id,true,false);
		end
	end
end

w1_col_net.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_column_xywh',
	color_d= {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_cfg_col_bk'}, 
	sub = {'net', 'n8021x','ddns','smtp','upnp','pp','ipfilter','snmp','net_3g_4g','pppoe','net_stat','lan_info', 'alarm_center', 'platform_access'},
	
	net		= {t='checkimgtxt',	id=id+1,xywh='s_cfg_col_1',	text='LA_NETWORK',		
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_update_param, check = true},
	n8021x	= {t='checkimgtxt',	id=id+2,xywh='s_cfg_col_2',	text='LA_8021X',			
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_update_param},
	ddns	= {t='checkimgtxt',	id=id+3,xywh='s_cfg_col_3',	text='LA_DDNS',			
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_update_param},
	smtp	= {t='checkimgtxt',	id=id+4,xywh='s_cfg_col_4',	text='LA_SMTP',			
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_update_param},
	upnp	= {t='checkimgtxt',	id=id+5,xywh='s_cfg_col_5',	text='LA_PORT_MAP',	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_update_param},
	pp		= {t='checkimgtxt',	id=id+6,xywh='s_cfg_col_6',	text='LA_PTWOP',
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_update_param},
	ipfilter= {t='checkimgtxt',	id=id+7,xywh='s_cfg_col_7',	text='LA_IP_FILTER',	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_update_param},
	snmp = {t='checkimgtxt',	id=id+8,xywh='s_cfg_col_8',	text='LA_SNMP',	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_update_param},
	net_3g_4g = {t='checkimgtxt',	id=id+9,xywh='s_cfg_col_9',	text='LA_3G_4G',	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_update_param},			
	pppoe 	 = {t='checkimgtxt',	id=id+10,xywh='s_cfg_col_10',	text='LA_PPPOE',	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_update_param},
	net_stat = {t='checkimgtxt',	id=id+11,xywh='s_cfg_col_11',	text='LA_POE_STATE',	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_update_param},	
	lan_info = {t='checkimgtxt',	id=id+12,xywh='s_cfg_col_12',	text='LA_NETOWRK_TRAFFIC',	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_update_param},	
	alarm_center = {t='checkimgtxt',	id=id+13,xywh='s_cfg_col_13',	text='LA_ALARM_SER_CENTER',	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_update_param},			
	platform_access = {t='checkimgtxt',	id=id+14,xywh='s_cfg_col_14',	text='LA_PLATFORM_ACCESS',	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_update_param},			
}

return w1_col_net
