--[[
-- Copyright(c) 2018-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/3/29
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 	 	= w1_id.col_storage_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local b_dlg 		= require("wnd.core.b_dlg")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local global_val	= require("wnd.global_val")
local w1_col_storage = {}
local r_size		= require("wnd.core.r_res.r_size")
local SIZE			= r_size.get_size;
local on_record = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local nret = w1_wnd_jump.click_col(top, w1_col_storage.wnd, win_id, true)
		if(nret ~= 0)then
			b_wnd_ex.set_check(top, win_id, false, true);
		end			
	end
	return 0;
end

local on_change_title = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local nret = w1_wnd_jump.click_col(top, w1_col_storage.wnd, win_id, true)
		if(nret ~= 0)then
			b_wnd_ex.set_check(top, win_id, false, true);
		end
	end
	return 0;
end

w1_col_storage.on_pre_show= function(top)
	local show_col_id = {};
	local cwnd = w1_col_storage.wnd;
	local index = 1;
	local RECORD 	= 1;
	local DISK 		= 2;
	local SMART     = 3;
	local RAID 		= 4;
	local BAD		= 5;
	local GROUP		= 6;
	local CLOUD		= 7;
	local DIS_CAL	= 8;
	local FTP	= 9;
	local raid_support_flag = G.get_raid_support();
	local smart_support_flag = G.get_smart_support();
	local bad_detection_flag = G.get_bad_detection_attr();
	local cloud_storage_flag = G.get_cloud_support();
	local idx_table = 
	{
		{true,RECORD},
		{true,DISK},
		{true,GROUP},
		{smart_support_flag,SMART},
		{raid_support_flag,RAID},
		{bad_detection_flag,BAD},
		{cloud_storage_flag,CLOUD},
		{true,DIS_CAL},
		{true,FTP},
	}
	local hide_line = 0;
	for i,v in pairs(idx_table) do
		if v[1] then
			b_wnd_ex.set_hide(top,id+v[2],false,false)
			local excepos = SIZE('s_cfg_col_'..index);
			b_wnd_ex.move_ex(top,id+v[2], excepos, false)
			index = index+1
		else
			b_wnd_ex.set_hide(top,id+v[2],true,false)
		end
	end
end

w1_col_storage.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_column_xywh',
	color_d= {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_cfg_col_bk'}, 
	sub = {'record', 'diskcfg','raid','smart','bad_detection','disk_group','cloud','dis_cap','ftp'},
	
	record 	= {t='checkimgtxt',id=id+1,xywh='s_cfg_col_1', 	text='LA_RECORD_POLICY',		
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',	
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_change_title, check = true},			
	diskcfg 	= {t='checkimgtxt',id=id+2,xywh='s_cfg_col_2', 	text='LA_DISK_CONFIG',
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_change_title},
	smart 	= {t='checkimgtxt',id=id+3,xywh='s_cfg_col_5', 	text='S.M.A.R.T',trans = false,
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_change_title},	
	raid 	= {t='checkimgtxt',id=id+4,xywh='s_cfg_col_4', 	text='LA_RAID',
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_change_title},		
	bad_detection = {t='checkimgtxt',id=id+5,xywh='s_cfg_col_6', text='LA_BAD_SECTOR',
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_change_title},
	disk_group   = {t='checkimgtxt',id=id+6,xywh='s_cfg_col_3', text='LA_STORAGE_MODE',
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_change_title},
	cloud= {t='checkimgtxt',id=id+7,xywh='s_cfg_col_7', 	text='LA_CLOUD_STORAGE',
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_change_title},
	dis_cap = {t='checkimgtxt',id=id+8,xywh='s_cfg_col_8', 	text='LA_DIS_CAL',
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_change_title},
	ftp	 = {t='checkimgtxt',id=id+9,xywh='s_cfg_col_9', 	text='LA_FTP',
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
				cmd=on_change_title},
}

return w1_col_storage
