--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local global_val 	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 	 		= w1_id.col_sys_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local b_dlg 		= require("wnd.core.b_dlg")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;

local w1_page_sys			= require("wnd.w1_cfg.w1_page_sys")
local w1_page_info_dev		= require("wnd.w1_cfg.w1_page_info")
local w1_page_privacy_pri	= require("wnd.w1_cfg.w1_page_privacy")

local w1_col_sys = {}

local on_sys_col = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local nret = w1_wnd_jump.click_col(top, w1_col_sys.wnd, win_id, true)
		if(nret ~= 0)then
			b_wnd_ex.set_check(top, win_id, false, true);
		end
	end
	return 0;
end

w1_col_sys.set_disable = function(top, privilege, redraw)
	local INFORMATION 	= 1;
	local GENERAL 		= 2;
	local USER 			= 3;
	local PASSWORD 		= 4;
	local DISPLAY 		= 5;
	local LOG 			= 6;
	local MAINTENANCE 	= 7;
	local RESTART       = 8;
	local AUXILIARY		= 9;
	
	local cwnd = w1_col_sys.wnd;
	local idtab = {cwnd.dev_info.id, cwnd.basic.id, cwnd.user.id,
					cwnd.modify_pw.id, cwnd.out_device.id,
					cwnd.log_manage.id, cwnd.dev_manage.id,cwnd.restart.id, cwnd.auxiliary.id};
	local param = {false, false, false, false, false, false, false, false, false};				
				
	if(privilege.systerm_config) then
		param[GENERAL] = false; param[USER] = false;param[DISPLAY] = false;
		param[AUXILIARY] = false;
	else
		param[GENERAL] = true; param[USER] = true;param[DISPLAY] = true;
		param[AUXILIARY] = true;
	end

	--adminûû
	local user_info	= global_val.get_user_info()
	local root_name = global_val.get_root_user_name();
	if(user_info.m_strUsername == root_name) then
		param[USER] = false;
	else
		param[USER] = true;
	end
	
	if(privilege.system_maintenance) then
		param[RESTART] = false;
	else
		param[RESTART] = true;
	end	
	
	for i=1, #param do
		b_wnd_ex.set_disable(top, idtab[i], param[i], redraw);
	end
end

w1_col_sys.on_pre_show = function(top)
	local auxi_attr = global_val.get_support_auxiliary_attr();
	local cwnd = w1_col_sys.wnd;
	local index = 1;
	local INFORMATION 	= 1;
	local GENERAL 		= 2;
	local USER 			= 3;
	local PASSWORD 		= 4;
	local DISPLAY 		= 5;
	local AUXILIARY		= 6;
	local LOG 			= 7;
	local MAINTENANCE 	= 8;
	local RESTART		= 9;
	
	local idx_table = 
	{
		{true,INFORMATION},--{ҳתidⷭ}
		{true,GENERAL},
		{true,USER},
		{true,PASSWORD},
		{true,DISPLAY},		
		{auxi_attr,AUXILIARY},
		{true,LOG},
		{true,MAINTENANCE},
		{true,RESTART},
	}
	local hide_line = 0;
	for i,v in pairs(idx_table) do
		if v[1] then
			b_wnd_ex.set_hide(top,id+v[2],false,false)
			local excepos = SIZE('s_cfg_col_'..index);
			b_wnd_ex.move_ex(top,id+v[2], excepos, false)
			index = index+1
		else
			b_wnd_ex.set_hide(top,id+v[2],true,false)
		end
	end
end

w1_col_sys.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_column_xywh',
	color_d= {'c_cfg_col_bk', 'c_cfg_col_bk', 'c_cfg_col_bk'}, 
	sub = {'dev_info','basic', 'user','modify_pw','out_device', 'auxiliary','log_manage', 'dev_manage',  'restart'},
	
	dev_info 	= {t='checkimgtxt',id=id+1,xywh='s_cfg_col_1', 	text='LA_DEVICE_INFOR', 	align = b_ui.ALIGN.LEFT,font = 'f_grade4',	
					t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
					cmd=on_sys_col, check = true},			
	basic 		= {t='checkimgtxt',id=id+2,xywh='s_cfg_col_2', 	text='LA_BASIC_SETTING', 		align = b_ui.ALIGN.LEFT,font = 'f_grade4',
					t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
					cmd=on_sys_col},
	user 		= {t='checkimgtxt',id=id+3,xywh='s_cfg_col_3',		text='LA_USER_ACCOUNT', 	align = b_ui.ALIGN.LEFT,font = 'f_grade4',	
					t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
					cmd=on_sys_col},
	modify_pw	= {t='checkimgtxt',id=id+4,xywh='s_cfg_col_4',	text='LA_SEC_CENTER', 	align = b_ui.ALIGN.LEFT,font = 'f_grade4',
					t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
					cmd=on_sys_col},
	out_device	= {t='checkimgtxt',id=id+5,xywh='s_cfg_col_5',	text='LA_LAYOUT',	align = b_ui.ALIGN.LEFT,font = 'f_grade4',	
					t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
					cmd=on_sys_col},
	auxiliary   = {t='checkimgtxt',id=id+6,xywh='s_cfg_col_6',	text='LA_AUXILIARY',	align = b_ui.ALIGN.LEFT,font = 'f_grade4',	
					t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
					cmd=on_sys_col},
	log_manage	= {t='checkimgtxt',id=id+7,xywh='s_cfg_col_7',	text='LA_LOG_MANAGEMENT',			align = b_ui.ALIGN.LEFT,font = 'f_grade4',
					t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
					cmd=on_sys_col},
	dev_manage	= {t='checkimgtxt',id=id+8,xywh='s_cfg_col_8',	text='LA_MAINTENANCE',	align = b_ui.ALIGN.LEFT,font = 'f_grade4',		
					t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
					cmd=on_sys_col},
	restart	= {t='checkimgtxt',id=id+9,xywh='s_cfg_col_9',	text='LA_AUTOMATIC_RESTART',	align = b_ui.ALIGN.LEFT,font = 'f_grade4',		
					t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_column','it_column_f', 'it_column'},
					cmd=on_sys_col},					
}

return w1_col_sys
