--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2019/3/14
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_createraid_id
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_parser 	= require("wnd.core.b_parser")
local b_wnd 	= require("wnd.core.b_wnd")
local b_app_api = require("wnd.core.command.b_app_api")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local r_size		= require("wnd.core.r_res.r_size")
local util 			= require("wnd.core.util")
local SIZE 			= r_size.get_size
local w1_msgbox = require("wnd.w1_util.w1_msgbox")

local w1_create_raid = 
{
	t = w1_key.DLG_MSG_RAID,
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_create_raid.s_768 =
{
	s_create_raid_xywh = {282,117,458,497},
	s_create_titlestr_xywh = {10,7,266,35},
	s_create_c_raid_type_xywh = {24,64,106,35},
	s_create_t_raid_type_xywh = {133,64,106,32},
	s_create_raid_list_xywh = {24,106,406,320},
	s_create_raid_save_xywh = {290,448,64,28},
	s_create_raid_cancel_xywh = {365,448,64,28},
	s_create_raid_close_xywh = {416,7,26,35},
	s_create_raidlist_w1 = {42,0,0,0},
	s_create_raidlist_w2 = {126,0,0,0},
	s_create_raidlist_w3 = {126,0,0,0},
	s_create_raidlist_w4 = {100,0,0,0},
};

w1_create_raid.s_1280 = 
{
	s_create_raid_xywh		= {210,162,860,700},
	s_create_titlestr_xywh	= {20,10,500,50},
	s_create_c_raid_type_xywh	= {45,90,200,50},
	s_create_t_raid_type_xywh	= {250,90,200,45},
	s_create_raid_list_xywh = {45,160,760,450},
	s_create_raid_save_xywh = {545,630,120,40},
	s_create_raid_cancel_xywh = {685,630,120,40},
	s_create_raid_close_xywh	= {780,10,50,50},
	s_create_raidlist_w1 = {80,0,0,0},
	s_create_raidlist_w2 = {240,0,0,0},
	s_create_raidlist_w3 = {240,0,0,0},
	s_create_raidlist_w4 = {190,0,0,0},
}
w1_create_raid.s_1440 = 
{
	s_create_raid_xywh		= {290,90,860,700},
	s_create_titlestr_xywh	= {20,10,500,50},
	s_create_c_raid_type_xywh	= {45,90,200,50},
	s_create_t_raid_type_xywh	= {250,90,200,45},
	s_create_raid_list_xywh = {45,160,760,450},
	s_create_raid_save_xywh = {545,630,120,40},
	s_create_raid_cancel_xywh = {685,630,120,40},
	s_create_raid_close_xywh	= {780,10,50,50},
	s_create_raidlist_w1 = {80,0,0,0},
	s_create_raidlist_w2 = {240,0,0,0},
	s_create_raidlist_w3 = {240,0,0,0},
	s_create_raidlist_w4 = {190,0,0,0},
	
}

w1_create_raid.s_1080p = 
{
	s_create_raid_xywh		= {530,165,860,700},
	s_create_titlestr_xywh	= {20,10,500,50},
	s_create_c_raid_type_xywh	= {45,90,200,50},
	s_create_t_raid_type_xywh	= {250,90,200,45},
	s_create_raid_list_xywh = {45,150,760,450},
	s_create_raid_save_xywh = {545,630,120,40},
	s_create_raid_cancel_xywh = {685,630,120,40},
	s_create_raid_close_xywh	= {780,10,50,50},
	s_create_raidlist_w1 = {80,0,0,0},
	s_create_raidlist_w2 = {240,0,0,0},
	s_create_raidlist_w3 = {240,0,0,0},
	s_create_raidlist_w4 = {190,0,0,0},
	
}

w1_create_raid.s_2k = 
{
	
	s_create_raid_xywh= {706,221,1146,933},
	s_create_titlestr_xywh={27,13,667,67},
	s_create_c_raid_type_xywh={60,120,267,67},
	s_create_t_raid_type_xywh={333,120,267,60},
	s_create_raid_list_xywh={60,200,1013,600},
	s_create_raid_save_xywh={726,840,160,53},
	s_create_raid_cancel_xywh={913,840,160,53},
	s_create_raid_close_xywh={1040,13,67,67},
	s_create_raidlist_w1={107,0,0,0},
	s_create_raidlist_w2={320,0,0,0},
	s_create_raidlist_w3={320,0,0,0},
	s_create_raidlist_w4={253,0,0,0},


}

w1_create_raid.s_4k = 
{

	s_create_raid_xywh= {1060,530,1720,1400},
	s_create_titlestr_xywh={40,20,1000,100},
	s_create_c_raid_type_xywh={90,180,400,100},
	s_create_t_raid_type_xywh={500,180,400,90},
	s_create_raid_list_xywh={90,300,1520,900},
	s_create_raid_save_xywh={1090,1260,240,80},
	s_create_raid_cancel_xywh={1375,1260,240,80},
	s_create_raid_close_xywh={1560,20,100,100},
	s_create_raidlist_w1={160,0,0,0},
	s_create_raidlist_w2={480,0,0,0},
	s_create_raidlist_w3={480,0,0,0},
	s_create_raidlist_w4={380,0,0,0},



}

w1_create_raid.init = function()
	w1_create_raid.ok_func = nil;				--okťص	
	w1_create_raid.okfunc_param = nil;			--okťص
end

w1_create_raid.set_func  = function(ok_func, okfunc_param, cannel_func, cancelfunc_param)
	assert(ok_func == nil or type(ok_func) == 'function')
	assert(okfunc_param == nil or type(okfunc_param) == 'table')

	w1_create_raid.ok_func = ok_func;
	w1_create_raid.okfunc_param = okfunc_param;
end

local refresh_list = function(top, redraw)

	
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)

	return 0;
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil;
end	

local on_close =  function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0;
end

local ok_func = function(param)
	--¶ȡ,ˢб
		b_dlg.end_modal(param[1]);	
	return 0;
end

local on_raidtype =  function(top, win_id, vmsg, x, y)
	if vmsg == b_ui_msg.msg_user_update_parent then
		
	end
	return 0;
end

local on_addraid = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_create_raid.dlg;
		local data = w1_create_raid.data.disk
		local raid_data = w1_create_raid.data
		local selecelist = b_wnd_ex.get_selecelist(top, cwnd.disk_list.id);	
		local end_selecelist = b_wnd_ex.get_end_selecelist(top, cwnd.disk_list.id);	
		local test =0;
		local list = {};
		local raid ={};
		
		local type_sel = b_wnd_ex.get_sel(top, cwnd.t_raid_type.id)
		if(0 == type_sel)then
			raid.raid_type = 5;
		elseif(1 == type_sel)then
			raid.raid_type = 6;
		elseif(2 == type_sel)then
			raid.raid_type = 10;
		else
			raid.raid_type = 0;
			
		end
		

		local add_disk_num = 0;
		local add_spare_num = 0;
		local test =0;
		for i =1, data.disk_num do
			if(selecelist['r'..i] == 1) then
				test =test+1;
			end
		end
		
		local sel = 0;
		local nidx = 0;
		for i =1, data.disk_num do
			local is_raid = string.find(data['disk'..i].name,"md")
			if( nil ~= data['disk'..i].name and "" ~= data['disk'..i].name and nil ~= is_raid)then --ӿڻȡRaid Disk  UIʾDISKhostid chn_id
				local test =0;
			else
				local is_raid_disk = false;
				for j=1,raid_data.raid.raid_num do
					local raid_disk = raid_data.raid["raid"..j]
					for k=1,raid_disk.disk_num do
						if(data['disk'..i].host_id == raid_disk['disk'..k].host_id and data['disk'..i].chn_id == raid_disk['disk'..k].chn_id)then
							is_raid_disk = true;
						end
								
					end
				end
				if(false == is_raid_disk)then
					sel = sel + 1;
					if(selecelist['r'..sel] == 1) then
						--[[if(nil == list['disk'..i] or nil == list['disk'..i].disk_enable)then
							local test= 0;
						end--]]
						nidx = nidx + 1;
						list['disk'..nidx] ={};
						list['disk'..nidx].disk_enable = 1;
						list['disk'..nidx].disk_type = end_selecelist['r'..sel]	
						list['disk'..nidx].disk_name = data['disk'..i].name;--"Disk"..tostring(data['disk'..i].host_id).."-"..tostring(data['disk'..i].chn_id);
						list['disk'..nidx].size = data['disk'..i].size;
						list['disk'..nidx].host_id = data['disk'..i].host_id;
						list['disk'..nidx].chn_id = data['disk'..i].chn_id;
	
						add_disk_num = add_disk_num + 1;
						if(1 == end_selecelist['r'..sel])then
							add_spare_num = add_spare_num + 1;
						end
						if data['disk'..i].smr_statu ~= 0 then
							w1_msgbox.set_dlgattr(STR('LA_TIP'),list['disk'..nidx].disk_name.." "..STR('LA_RAID_NOT_SUPPORT'), true, false,false);
							w1_msgbox.set_func(okfunc, {top}, nil, nil);
							b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
							return 0;
						end
						
					else
					--	list['disk'..i].disk_type = 2
					end
				end
			end
		end
	
		if(5 == raid.raid_type)then
			local basic_disk_num = add_disk_num - add_spare_num;
			if(basic_disk_num < 3)then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_DISK_NUM3'), true, false,false);
				w1_msgbox.set_func(okfunc, {top}, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
				return 0;
			end
		elseif(6 == raid.raid_type)then
			local basic_disk_num = add_disk_num - add_spare_num;
			if(basic_disk_num < 4)then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_DISK_NUM4'), true, false,false);
				w1_msgbox.set_func(okfunc, {top}, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
				return 0;
			end
		elseif(10 == raid.raid_type)then
			local basic_disk_num = add_disk_num - add_spare_num;
			local t1 = math.floor(basic_disk_num%2);
			if(basic_disk_num < 4 or t1 ~= 0)then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_DISK_NUM5'), true, false,false);
				w1_msgbox.set_func(okfunc, {top}, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
				return 0;
			end
		end
			
		raid.enable_flag = 1;	
		raid.raid_size = 64;
		
		local idx =0;
		local raid_data = w1_create_raid.data.raid
		if(nil ~= raid_data and nil ~= raid_data.raid_num)then
			idx = raid_data.raid_num
		end
		local raidname = ""
		local raidname_exit_flag =0;
		for i=1, idx do
			local str = "md"..tostring(i-1)
			if(str == raid_data['raid'..i].raid_name)then
				local test =0;
			else
			--	raidname = "md "..tostring(i-1);
				for j=1, idx do
					if(str == raid_data['raid'..j].raid_name)then
						raidname_exit_flag =1;			
					end
				end
				if(1 == raidname_exit_flag)then
					raidname_exit_flag =0;
				else
					raidname = "md"..tostring(i-1);
					break;
				end
				
			end
		end
		
		if("" ~= raidname)then
			raid.raid_name = raidname
		else
			raid.raid_name = "md"..tostring(idx)
		end
		
		local raid_disk_num =0;
		for i=1, data.disk_num  do
			if(nil ~= list['disk'..i])then
				if(list['disk'..i].host_id <0 or list['disk'..i].chn_id <0)then
				
				else
					raid['disk'..i] = list['disk'..i];
					raid_disk_num = raid_disk_num+1;
				end
			else
				local test = 0;
			end
		end
		raid.disk_num = raid_disk_num;--data.disk_num;
		local ret = b_app_api.add_raid(raid).add_raid;
		
		if('table' == type(ret) and (0 == ret.errornum))then
			b_dlg.end_modal(top);
			w1_create_raid.okfunc_param[2] = w1_create_raid.edit_type;
			w1_create_raid.ok_func(w1_create_raid.okfunc_param);
		elseif('table' == type(ret) and (1 == ret.errornum))then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_RAID_EXIST'), true, false,false);
			w1_msgbox.set_func(okfunc, {top}, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
		elseif('table' == type(ret) and (2 == ret.errornum))then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_RAID_NOT_EXIST'), true, false,false);
			w1_msgbox.set_func(okfunc, {top}, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
		elseif('table' == type(ret) and (3 == ret.errornum))then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_DISK_NAME_ERROR'), true, false,false);
			w1_msgbox.set_func(okfunc, {top}, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
		elseif('table' == type(ret) and (4 == ret.errornum))then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_RAID_NOT_SUPPORT'), true, false,false);
			w1_msgbox.set_func(okfunc, {top}, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
		elseif('table' == type(ret) and (5 == ret.errornum))then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_PARAM_INVALID'), true, false,false);
			w1_msgbox.set_func(okfunc, {top}, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
		elseif('table' == type(ret) and (8 == ret.errornum))then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_DISK_SIZE_SMALL'), true, false,false);
			w1_msgbox.set_func(okfunc, {top}, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
		elseif('table' == type(ret) and (9 == ret.errornum))then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_DISK_NUM5'), true, false,false);
			w1_msgbox.set_func(okfunc, {top}, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
		else--ʧ
			print("---ret.errornum:"..ret.errornum);
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_CREATE_RAID_FAIL'), true, false,false);
			w1_msgbox.set_func(okfunc, {top}, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
		end
		return 0;
	end
	return 0;
end

local on_cancel= function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0;
end

w1_create_raid.clear_data =function ()
	w1_create_raid.ok_func=nil;
	w1_create_raid.okfunc_param=nil;
	w1_create_raid.data = nil;
end

local dlg = 
{
	attr 	= {xywh='s_create_raid_xywh',},
	--t='wnd_bg',id=id,xywh = 's_create_raid_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = { 'titlestr','c_raid_type','t_raid_type','disk_list', 'save','cancel','close'},
	titlestr	= {t='static', 	id=id+2,xywh='s_create_titlestr_xywh', 
					text='LA_CREATE_RAID',	font = 'f_grade5',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_titlestr'},
					},
					
	c_raid_type = {t='static', 	id=id+3,xywh='s_create_c_raid_type_xywh', 
					text='LA_RAID_TYPE',	font = 'f_grade6',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
					
	t_raid_type = {t='combox', id=id+4,xywh='s_create_t_raid_type_xywh', 
					items={'RAID 5','RAID 6','RAID 10'},trans = false,
					cmd = on_raidtype,
					color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'},							
	},
					
	disk_list	= {t='list',	id=id+5,	xywh='s_create_raid_list_xywh', font = 'f_grade4',
					listattr = {8,4,b_ui.LISTATTR.FIRST_WIDGET_CHECK,b_ui.LISTATTR.END_WIDGET_CHECK},
					dlg_key = {w1_key.DLG_MSG_RAID},
				--	title_texts = {STR('LA_ID'), "Name","Capicity","Hotspare Disk"},
					columns_w = {80,240,240,190},
					},

	close = {t='tt_button',id=id+6,xywh='s_create_raid_close_xywh',
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade6','it_close','it_close', 'it_close'},
			cmd=on_close,
			color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_txt_f'},
			color_f= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'}},	
						
	save 		= {t='button',	id=id+7,	xywh='s_create_raid_save_xywh', text='LA_OK',cmd=on_addraid},
	
	cancel 		= {t='button',	id=id+8,	xywh='s_create_raid_cancel_xywh', text='LA_CANCEL',cmd=on_cancel},

}

w1_create_raid.set_data =function (data)
	w1_create_raid.data = data;
end

w1_create_raid.on_create = function(top)
	w1_create_raid.top = top;
	return 0;
end

w1_create_raid.on_destroy = function(top)
	w1_create_raid.top = nil;
	w1_create_raid.dlg = nil;
	return 0;
end

w1_create_raid.on_pre_show = function(top)
	w1_create_raid.dlg = dlg;
	b_parser(top, w1_create_raid.dlg);	
	local cwnd = w1_create_raid.dlg;
	local param = {
			STR('LA_ID'), STR('LA_NAME'),STR('LA_CAPACITY'),STR('LA_HOTSPARE_DISK')
		};
	b_wnd_ex.set_title_texts(top, cwnd.disk_list.id, param, false)
	
	local list_w = {};
	for i=1,4 do
		local str = 's_create_raidlist_w'..math.floor(i/1);
		list_w[i] = SIZE(str)[1];
	end
	b_wnd_ex.columns_w(top, cwnd.disk_list.id, list_w, false);
	
	local data = w1_create_raid.data.disk
	local raid_data = w1_create_raid.data

	local disklist = {};
	local raidnum = 0;
	local idx = 1;
	for i=1, data.disk_num do
		local is_raid = string.find(data['disk'..i].name,"md")
		if( nil ~= data['disk'..i].name and "" ~= data['disk'..i].name and nil ~= is_raid)then --ӿڻȡRaid Disk  UIʾDISKhostid chn_id
			local test =0;
			raidnum = raidnum + 1;
		else
			local is_raid_disk = false;
			for j=1,raid_data.raid.raid_num do
				local raid_disk = raid_data.raid["raid"..j]
				for k=1,raid_disk.disk_num do
					if(data['disk'..i].host_id == raid_disk['disk'..k].host_id and data['disk'..i].chn_id == raid_disk['disk'..k].chn_id)then
						is_raid_disk = true;
					end
							
				end
			end
			if(false == is_raid_disk)then
				local disk = data['disk'..i]
				local size;
				--ȡӲ
				size = disk.size/1000;
				if(size < 1000)then
					size = math.floor(size / 1)..'GB';
				else
					size = size/1000
					size = math.floor(size / 1)..'TB';
				end

				disklist['idx'..idx] = {idx-1, false, '', data['disk'..i].name, size,''};
					idx = idx + 1;
			end
		end
		
	end
	
	disklist.item_total = idx -1;--data.disk_num -raidnum;
	if(0 == disklist.item_total or 0> disklist.item_total)then
		return 0;
	end

	b_wnd_ex.set_listdata(top, cwnd.disk_list.id, disklist, false);
	
	
	return 0;
end

w1_create_raid.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top);
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_popdlg_bk'));
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_popdlg_border'),1);
	b_wnd.end_job(top);
	return 0;
end

w1_create_raid.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if(b_ui.RBUTTONCLK == vmsg) then
	
		b_dlg.end_modal(top);
	end
	return 0;
end


return w1_create_raid;
