--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2019/3/14
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_editraid_id
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local b_wnd 	= require("wnd.core.b_wnd")
local b_app_api = require("wnd.core.command.b_app_api")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local r_size		= require("wnd.core.r_res.r_size")
local util 			= require("wnd.core.util")
local SIZE 			= r_size.get_size
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local w1_edit_raid_msgbox	= require("wnd.w1_cfg.w1_edit_raid_msgbox")
local w1_edit_raid = 
{
	t = w1_key.DLG_EDIT_RAID,
	data,
	data_disk,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_edit_raid.s_768 =
{
	s_edit_raid_xywh = {182,152,664,497},
	s_edit_titlestr_xywh = {10,7,266,35},
	s_edit_c_raid_name_xywh = {24,64,106,35},
	s_edit_t_raid_name_xywh = {133,64,106,32},
	s_edit_c_type_xywh = {266,64,106,35},
	s_edit_t_type_xywh = {376,64,106,32},
	s_edit_c_capacity_xywh = {24,99,106,35},
	s_edit_t_capacity_xywh = {133,99,106,32},
	s_edit_c_members_xywh = {266,99,106,35},
	s_edit_t_members_xywh = {376,99,106,32},
	s_edit_raid_list_xywh = {24,142,611,320},
	s_edit_raid_close_xywh = {629,7,26,35},
	s_edit_raidlist_w1 = {42,0,0,0},
	s_edit_raidlist_w2 = {101,0,0,0},
	s_edit_raidlist_w3 = {101,0,0,0},
	s_edit_raidlist_w4 = {106,0,0,0},
	s_edit_raidlist_w5 = {80,0,0,0},
	s_edit_raidlist_w6 = {90,0,0,0},
	s_edit_raidlist_w7 = {80,0,0,0},
};

w1_edit_raid.s_1280 = 
{
	s_edit_raid_xywh		= {151,162,978,700},
	s_edit_titlestr_xywh	= {20,10,500,45},
	s_edit_c_raid_name_xywh	= {45,80,170,45},
	s_edit_t_raid_name_xywh	= {220,80,170,45},
	s_edit_c_type_xywh	= {430,80,170,45},
	s_edit_t_type_xywh	= {605,80,170,45},
	s_edit_c_capacity_xywh	= {45,140,180,45},
	s_edit_t_capacity_xywh	= {220,140,180,45},
	s_edit_c_members_xywh	= {430,140,180,45},
	s_edit_t_members_xywh	= {605,140,180,45},
	s_edit_raid_list_xywh = {40,200,898,450},
	s_edit_raid_close_xywh	= {910,10,50,45},
	
	s_edit_raidlist_w1 = {53,0,0,0},
	s_edit_raidlist_w2 = {125,0,0,0},
	s_edit_raidlist_w3 = {125,0,0,0},
	s_edit_raidlist_w4 = {180,0,0,0},
	s_edit_raidlist_w5 = {120,0,0,0},
	s_edit_raidlist_w6 = {160,0,0,0},
	s_edit_raidlist_w7 = {110,0,0,0},
	
}

w1_edit_raid.s_1440 = 
{
	s_edit_raid_xywh		= {226,100,988,700},
	s_edit_titlestr_xywh	= {20,10,500,45},
	s_edit_c_raid_name_xywh	= {45,80,180,45},
	s_edit_t_raid_name_xywh	= {230,80,180,45},
	s_edit_c_type_xywh	= {450,80,180,50},
	s_edit_t_type_xywh	= {635,80,180,45},
	s_edit_c_capacity_xywh	= {45,140,180,45},
	s_edit_t_capacity_xywh	= {230,140,180,45},
	s_edit_c_members_xywh	= {450,140,180,45},
	s_edit_t_members_xywh	= {635,140,180,45},
	s_edit_raid_list_xywh = {45,200,898,450},
	s_edit_raid_close_xywh	= {920,10,50,45},
	s_edit_raidlist_w1 = {53,0,0,0},
	s_edit_raidlist_w2 = {125,0,0,0},
	s_edit_raidlist_w3 = {125,0,0,0},
	s_edit_raidlist_w4 = {180,0,0,0},
	s_edit_raidlist_w5 = {120,0,0,0},
	s_edit_raidlist_w6 = {160,0,0,0},
	s_edit_raidlist_w7 = {110,0,0,0},
	
}

w1_edit_raid.s_1080p = 
{
	s_edit_raid_xywh		= {342,215,1246,700},
	s_edit_titlestr_xywh	= {20,10,500,50},
	s_edit_c_raid_name_xywh	= {45,90,200,50},
	s_edit_t_raid_name_xywh	= {250,90,200,45},
	s_edit_c_type_xywh	= {500,90,200,50},
	s_edit_t_type_xywh	= {705,90,200,45},
	s_edit_c_capacity_xywh	= {45,140,200,50},
	s_edit_t_capacity_xywh	= {250,140,200,45},
	s_edit_c_members_xywh	= {500,140,200,50},
	s_edit_t_members_xywh	= {705,140,200,45},
	s_edit_raid_list_xywh = {45,200,1146,450},
	s_edit_raid_close_xywh	= {1180,10,50,50},
	s_edit_raidlist_w1 = {80,0,0,0},
	s_edit_raidlist_w2 = {190,0,0,0},
	s_edit_raidlist_w3 = {190,0,0,0},
	s_edit_raidlist_w4 = {200,0,0,0},
	s_edit_raidlist_w5 = {150,0,0,0},
	s_edit_raidlist_w6 = {170,0,0,0},
	s_edit_raidlist_w7 = {150,0,0,0},
	
}

w1_edit_raid.s_2k = 
{
	s_edit_raid_xywh={456,287,1661,933},
	s_edit_titlestr_xywh={27,13,667,67},
	s_edit_c_raid_name_xywh={60,120,267,67},
	s_edit_t_raid_name_xywh={333,120,267,60},
	s_edit_c_type_xywh={667,120,267,67},
	s_edit_t_type_xywh={940,120,267,60},
	s_edit_c_capacity_xywh={60,187,267,67},
	s_edit_t_capacity_xywh={333,187,267,60},
	s_edit_c_members_xywh={667,187,267,67},
	s_edit_t_members_xywh={940,187,267,60},
	s_edit_raid_list_xywh={60,267,1528,600},
	s_edit_raid_close_xywh={1573,13,67,67},
	s_edit_raidlist_w1={107,0,0,0},
	s_edit_raidlist_w2={253,0,0,0},
	s_edit_raidlist_w3={253,0,0,0},
	s_edit_raidlist_w4={267,0,0,0},
	s_edit_raidlist_w5={200,0,0,0},
	s_edit_raidlist_w6={227,0,0,0},
	s_edit_raidlist_w7={200,0,0,0},


}

w1_edit_raid.s_4k = 
{
	s_edit_raid_xywh={684,430,2492,1400},
	s_edit_titlestr_xywh={40,20,1000,100},
	s_edit_c_raid_name_xywh={90,180,400,100},
	s_edit_t_raid_name_xywh={500,180,400,90},
	s_edit_c_type_xywh={1000,180,400,100},
	s_edit_t_type_xywh={1410,180,400,90},
	s_edit_c_capacity_xywh={90,280,400,100},
	s_edit_t_capacity_xywh={500,280,400,90},
	s_edit_c_members_xywh={1000,280,400,100},
	s_edit_t_members_xywh={1410,280,400,90},
	s_edit_raid_list_xywh={90,400,2292,900},
	s_edit_raid_close_xywh={2360,20,100,100},
	s_edit_raidlist_w1={160,0,0,0},
	s_edit_raidlist_w2={380,0,0,0},
	s_edit_raidlist_w3={380,0,0,0},
	s_edit_raidlist_w4={400,0,0,0},
	s_edit_raidlist_w5={300,0,0,0},
	s_edit_raidlist_w6={340,0,0,0},
	s_edit_raidlist_w7={300,0,0,0},



}

w1_edit_raid.init = function()
	w1_edit_raid.ok_func = nil;				--okťص	
	w1_edit_raid.okfunc_param = nil;			--okťص
end

w1_edit_raid.set_func  = function(ok_func, okfunc_param, cannel_func, cancelfunc_param)
	assert(ok_func == nil or type(ok_func) == 'function')
	assert(okfunc_param == nil or type(okfunc_param) == 'table')

	w1_edit_raid.ok_func = ok_func;
	w1_edit_raid.okfunc_param = okfunc_param;
end

local refresh_list = function(top, redraw)
	local data = w1_edit_raid.data;
	local cwnd = w1_edit_raid.dlg;	
		local param = {
				STR('LA_ID'), STR('LA_NAME'),STR('LA_CAPACITY'),STR('LA_STATUS'),STR('LA_TYPE'),STR('LA_HOTSPARE_DISK'),STR('LA_OPERATE')
			};
		b_wnd_ex.set_title_texts(top, cwnd.disk_list.id, param, false)
		
		local list_w = {};
		for i=1,7 do
			local str = 's_edit_raidlist_w'..math.floor(i/1);
			list_w[i] = SIZE(str)[1];
		end
		b_wnd_ex.columns_w(top, cwnd.disk_list.id, list_w, false);
		
		
		local disklist = {};
	--	disklist.item_total = data.disk.disk_num
		local disk_data = data.raid["raid"..w1_edit_raid.sel]  
		disklist.item_total = disk_data.disk_num
		local raid_type = disk_data.raid_type;
		
		local titlestr ="RAID-"..disk_data.raid_name
		b_wnd_ex.set_text(top,cwnd.titlestr.id, titlestr, false);
		b_wnd_ex.set_text(top,cwnd.t_raid_name.id, titlestr, false);
		local raidtype = "RAID 5";
		if(5 == disk_data.raid_type)then
			raidtype = "RAID 5";
			b_wnd_ex.set_text(top,cwnd.t_type.id, raidtype, false);
		elseif(6 == disk_data.raid_type)then
			raidtype = "RAID 6"
			b_wnd_ex.set_text(top,cwnd.t_type.id, raidtype, false);
		elseif(10 == disk_data.raid_type)then
			raidtype = "RAID 10"
			b_wnd_ex.set_text(top,cwnd.t_type.id, raidtype, false);
		end	
		
		
		local raid_size;
		raid_size = disk_data.raid_size/1000;
		if(raid_size < 1000)then
			raid_size = math.floor(raid_size / 1)..'GB';
		else
			raid_size = raid_size/1000
			raid_size = math.floor(raid_size / 1)..'TB';
		end	
		b_wnd_ex.set_text(top,cwnd.t_capacity.id, raid_size, false);
		
		local str ="";
		for i=1,disk_data.disk_num do
			local disk = disk_data["disk"..i]
			if(1 == disk.disk_enable)then
				local diskname = disk.disk_name;
				local ts = "k"
				local param1, pos = string.find(diskname, ts) 
				local dst_str = string.sub(diskname, pos+1, string.len(diskname))   
				if(str ~= "")then
					str = str..","..dst_str			
				else
					str = diskname;
				end
			end
		end
		b_wnd_ex.set_text(top,cwnd.t_members.id, str, false);
		
		local end_typetab = {};

		local disk_list = {};
		local liatdata = w1_edit_raid.data_disk
		for i =1, liatdata.disk_num do
			local size;
			size = liatdata['disk'..i].size/1000;
			if(size < 1000)then
				size = math.floor(size / 1)..'GB';
			else
				size = size/1000
				size = math.floor(size / 1)..'TB';
			end
				 	
			local raid_disk_status	= liatdata['disk'..i].status
			local disk_status = "--"
			if(0 == raid_disk_status)then
				disk_status = "--"
			elseif(1 == raid_disk_status)then
				disk_status = STR('LA_ACTIVE')
			elseif(2 == raid_disk_status)then
				disk_status = STR('LA_REBUILDING')
			elseif(3 == raid_disk_status)then
				disk_status = STR('LA_SPARE')
			elseif(4 == raid_disk_status)then
				disk_status = STR('LA_FAULTY')
			elseif(5 == raid_disk_status)then
				disk_status = STR('LA_REMOVED')
			elseif(6 == raid_disk_status)then
				disk_status = STR('LA_BASIC_DISK_LOST')
			else
			
			end
			
			local hostpare = STR('LA_BAD')
			if(0 == liatdata['disk'..i].disk_type)then
				hostpare = STR('LA_BAD')
			elseif(1 == liatdata['disk'..i].disk_type)then
				hostpare = STR('LA_YES')
			elseif(2 == liatdata['disk'..i].disk_type)then
			    hostpare = "--"
			end
					
			if(disk_data.disk_num < i)then
				disk_list['idx'..i] = {i-1, false, i, liatdata['disk'..i].disk_name, size, disk_status, "HDD", hostpare, ''};
			else
				disk_list['idx'..i] = {i-1, false, i, liatdata['disk'..i].disk_name, size, disk_status, raidtype, hostpare, ''};	
			end
			
			end_typetab[i] = liatdata['disk'..i].disk_type
		end
		disk_list.item_total = liatdata.disk_num
		b_wnd_ex.set_listdata(top, cwnd.disk_list.id, disk_list, false);
		b_wnd_ex.set_listtype(top, cwnd.disk_list.id, end_typetab, false);
		if true == redraw then
			b_dlg.dlg_set_redraw(top)
		end
end

local updata_raid_disk = function(top)
	local data = w1_edit_raid.data;
	local disk_data = data.raid["raid"..w1_edit_raid.sel]  
	local idx = disk_data.disk_num
	w1_edit_raid.data_disk ={};
	w1_edit_raid.data_disk.raid_size = disk_data.raid_size
	w1_edit_raid.data_disk.raid_type = disk_data.raid_type 
	w1_edit_raid.data_disk.disk_num = disk_data.disk_num
	w1_edit_raid.data_disk.enable_flag = disk_data.enable_flag
	w1_edit_raid.data_disk.raid_name = disk_data.raid_name
	local idx = 1;
	for i=1,disk_data.disk_num do	
		if(0 == disk_data['disk'..i].disk_type)then
			w1_edit_raid.data_disk['disk'..idx] = {};
			w1_edit_raid.data_disk['disk'..idx].host_id = disk_data['disk'..i].host_id
			w1_edit_raid.data_disk['disk'..idx].chn_id = disk_data['disk'..i].chn_id
			w1_edit_raid.data_disk['disk'..idx].size = disk_data['disk'..i].size
			w1_edit_raid.data_disk['disk'..idx].disk_name = disk_data['disk'..i].disk_name
			w1_edit_raid.data_disk['disk'..idx].disk_type = disk_data['disk'..i].disk_type
			w1_edit_raid.data_disk['disk'..idx].disk_enable = disk_data['disk'..i].disk_enable
			w1_edit_raid.data_disk['disk'..idx].status = disk_data['disk'..i].status
			w1_edit_raid.data_disk['disk'..idx].smr_statu = disk_data['disk'..i].smr_statu
			idx = idx + 1;
		end
	end
	
	for i=1,disk_data.disk_num do	
		if(1 == disk_data['disk'..i].disk_type)then
			w1_edit_raid.data_disk['disk'..idx] = {};
			w1_edit_raid.data_disk['disk'..idx].host_id = disk_data['disk'..i].host_id
			w1_edit_raid.data_disk['disk'..idx].chn_id = disk_data['disk'..i].chn_id
			w1_edit_raid.data_disk['disk'..idx].size = disk_data['disk'..i].size
			w1_edit_raid.data_disk['disk'..idx].disk_name = disk_data['disk'..i].disk_name
			w1_edit_raid.data_disk['disk'..idx].disk_type = disk_data['disk'..i].disk_type
			w1_edit_raid.data_disk['disk'..idx].disk_enable = disk_data['disk'..i].disk_enable
			w1_edit_raid.data_disk['disk'..idx].status = disk_data['disk'..i].status
			w1_edit_raid.data_disk['disk'..idx].smr_statu = disk_data['disk'..i].smr_statu
			idx = idx + 1;
		end
	end
	
	for i=1,data.disk.disk_num do	
		local is_raid = string.find(data.disk['disk'..i].name,"md")
		if( nil ~= data.disk['disk'..i].name and "" ~= data.disk['disk'..i].name and nil ~= is_raid)then 
			local test = 0;
		else
			--ҪųӲѱRAIDռ(RAIDβӲ̣¼⵽Ȼ)
			local is_raid_disk = false;
			for j=1,data.raid.raid_num do
				local raid_disk = data.raid["raid"..j]
				if(disk_data.raid_name ~=raid_disk.raid_name)then
					for k=1,raid_disk.disk_num do
						if(data.disk['disk'..i].host_id == raid_disk['disk'..k].host_id and data.disk['disk'..i].chn_id == raid_disk['disk'..k].chn_id)then
							is_raid_disk = true;
						--	print("--is_raid_disk--name:"..raid_disk['disk'..k].disk_name);
						end
								
					end
				end
			end
			
			if(false == is_raid_disk)then
				w1_edit_raid.data_disk['disk'..idx] = {};
				w1_edit_raid.data_disk['disk'..idx].host_id = data.disk['disk'..i].host_id
				w1_edit_raid.data_disk['disk'..idx].chn_id = data.disk['disk'..i].chn_id
				w1_edit_raid.data_disk['disk'..idx].size = data.disk['disk'..i].size
				w1_edit_raid.data_disk['disk'..idx].disk_name = data.disk['disk'..i].name;--"Disk"..tostring(data.disk['disk'..i].host_id).."-"..tostring(data.disk['disk'..i].chn_id);
				w1_edit_raid.data_disk['disk'..idx].disk_type = 2
				w1_edit_raid.data_disk['disk'..idx].disk_enable = 0
				w1_edit_raid.data_disk['disk'..idx].status = "--";--disk_data['disk'..i].status
				w1_edit_raid.data_disk['disk'..idx].smr_statu = data.disk['disk'..i].smr_statu
				idx = idx + 1;
			end
			
		end
	end
	w1_edit_raid.data_disk.disk_num = idx -1;
end

local ok_add_delete_fun = function(param)
	--¶ȡ,ˢб
	b_app_cfg.init({'raid','disk'});
	w1_edit_raid.data = b_app_cfg.origin_cfg;
	--[[local data = w1_edit_raid.data;
	local disk_data = data.raid["raid"..w1_edit_raid.sel]  
	local idx = disk_data.disk_num
	w1_edit_raid.data_disk ={};
	w1_edit_raid.data_disk.raid_size = disk_data.raid_size
	w1_edit_raid.data_disk.raid_type = disk_data.raid_type 
	w1_edit_raid.data_disk.disk_num = disk_data.disk_num
	w1_edit_raid.data_disk.enable_flag = disk_data.enable_flag
	w1_edit_raid.data_disk.raid_name = disk_data.raid_name
	
	local idx = 1;
	for i=1,disk_data.disk_num do	
		if(0 == disk_data['disk'..i].disk_type)then
			w1_edit_raid.data_disk['disk'..idx] = {};
			w1_edit_raid.data_disk['disk'..idx].host_id = disk_data['disk'..i].host_id
			w1_edit_raid.data_disk['disk'..idx].chn_id = disk_data['disk'..i].chn_id
			w1_edit_raid.data_disk['disk'..idx].size = disk_data['disk'..i].size
			w1_edit_raid.data_disk['disk'..idx].disk_name = disk_data['disk'..i].disk_name
			w1_edit_raid.data_disk['disk'..idx].disk_type = disk_data['disk'..i].disk_type
			w1_edit_raid.data_disk['disk'..idx].disk_enable = disk_data['disk'..i].disk_enable
			w1_edit_raid.data_disk['disk'..idx].status = disk_data['disk'..i].status
			idx = idx + 1;
		end
	end
	
	for i=1,disk_data.disk_num do	
		if(1 == disk_data['disk'..i].disk_type)then
			w1_edit_raid.data_disk['disk'..idx] = {};
			w1_edit_raid.data_disk['disk'..idx].host_id = disk_data['disk'..i].host_id
			w1_edit_raid.data_disk['disk'..idx].chn_id = disk_data['disk'..i].chn_id
			w1_edit_raid.data_disk['disk'..idx].size = disk_data['disk'..i].size
			w1_edit_raid.data_disk['disk'..idx].disk_name = disk_data['disk'..i].disk_name
			w1_edit_raid.data_disk['disk'..idx].disk_type = disk_data['disk'..i].disk_type
			w1_edit_raid.data_disk['disk'..idx].disk_enable = disk_data['disk'..i].disk_enable
			w1_edit_raid.data_disk['disk'..idx].status = disk_data['disk'..i].status
			idx = idx + 1;
		end
	end

	for i=1,data.disk.disk_num do	
		local is_raid = string.find(data.disk['disk'..i].name,"md")
		if( nil ~= data.disk['disk'..i].name and "" ~= data.disk['disk'..i].name and nil ~= is_raid)then 
			local test = 0;
		else
			--ҪųӲѱRAIDռ(RAIDβӲ̣¼⵽Ȼ)
			local is_raid_disk = false;
			for j=1,data.raid.raid_num do
				local raid_disk = data.raid["raid"..j]
				for k=1,raid_disk.disk_num do
					if(data.disk['disk'..i].host_id == raid_disk['disk'..k].host_id and data.disk['disk'..i].chn_id == raid_disk['disk'..k].chn_id)then
						print("--is_raid_disk--name:"..raid_disk['disk'..k].disk_name);
						is_raid_disk = true;
					end
							
				end
			end
			if(false == is_raid_disk)then
				w1_edit_raid.data_disk['disk'..idx] = {};
				w1_edit_raid.data_disk['disk'..idx].host_id = data.disk['disk'..i].host_id
				w1_edit_raid.data_disk['disk'..idx].chn_id = data.disk['disk'..i].chn_id
				w1_edit_raid.data_disk['disk'..idx].size = data.disk['disk'..i].size
				w1_edit_raid.data_disk['disk'..idx].disk_name = data.disk['disk'..i].name;--"Disk"..tostring(data.disk['disk'..i].host_id).."-"..tostring(data.disk['disk'..i].chn_id);
				w1_edit_raid.data_disk['disk'..idx].disk_type = 2
				w1_edit_raid.data_disk['disk'..idx].disk_enable = 0
				w1_edit_raid.data_disk['disk'..idx].status = "--"
				idx = idx + 1;
			end
			
		end
	end
	w1_edit_raid.data_disk.disk_num = idx -1;--]]
	updata_raid_disk(param[1]);
	refresh_list(param[1], false);
	w1_edit_raid_msgbox.set_data(w1_edit_raid.data_disk);
	
	return 0;
end

local on_ok_del = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local data = w1_edit_raid.data;
		local disk_data = data.raid["raid"..w1_edit_raid.sel] 
		local raidname = disk_data.raid_name;

		local ret = b_app_api.delete_raid({cur_raid = raidname}).del_raid;
		if('table' == type(ret) and (0 == ret.errornum))then
			b_dlg.end_modal(top);
			w1_edit_raid.okfunc_param[2] = w1_edit_raid.edit_type;
			w1_edit_raid.ok_func(w1_edit_raid.okfunc_param);
		elseif('table' == type(ret) and (2 == ret.errornum))then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_RAID_NOT_EXIST'), true, false,false);
			w1_msgbox.set_func(okfunc, {top}, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
		else
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_DEL_RAID_FAIL'), true, false,false);
			w1_msgbox.set_func(nil, nil, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
			b_dlg.end_modal(top);
		end
		
	end
	return 0;
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)

	return 0;
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil;
end	

local on_close =  function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
		w1_edit_raid.okfunc_param[2] = w1_edit_raid.edit_type;
		w1_edit_raid.ok_func(w1_edit_raid.okfunc_param);
	end
	return 0;
end

local on_raidtype =  function(top, win_id, vmsg, x, y)
	if vmsg == b_ui_msg.msg_user_update_parent then
		
	end
	return 0;
end

local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_edit_raid.dlg;
		b_dlg.do_modal(top, w1_key.DLG_MSG_RAID, 0, 0, nil)
	end
	return 0;
end

w1_edit_raid.clear_data = function ()
	w1_edit_raid.ok_func=nil;
	w1_edit_raid.okfunc_param=nil;
	w1_edit_raid.data = nil;
	w1_edit_raid.data_disk=nil;
	w1_edit_raid_msgbox.clear_data()
end

local dlg = 
{
	attr 	= {xywh='s_edit_raid_xywh',},
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = { 'titlestr','c_raid_name','t_raid_name','c_type','t_type','c_capacity','t_capacity','c_members','t_members','disk_list', 'close'},
	titlestr	= {t='static', 	id=id+2,xywh='s_edit_titlestr_xywh', 
					text='RAID md0',	font = 'f_grade5',trans = false,
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_titlestr'},
					},
					
	c_raid_name = {t='static', 	id=id+3,xywh='s_edit_c_raid_name_xywh', 
					text='LA_RAID_NAME',  
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
					
	t_raid_name = {t='static', id=id+4,xywh='s_edit_t_raid_name_xywh', trans = false,text='Disk_1',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},							
	},
	
	c_type = {t='static', 	id=id+5,xywh='s_edit_c_type_xywh', 
					text='Type', trans = false, 
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
					
	t_type = {t='static', id=id+6,xywh='s_edit_t_type_xywh', trans = false,text='RADI 5',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},							
	},
	
	c_capacity = {t='static', 	id=id+7,xywh='s_edit_c_capacity_xywh', 
					text='LA_CAPACITY', 
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
					
	t_capacity = {t='static', id=id+8,xywh='s_edit_t_capacity_xywh', trans = false,text='1000 GB',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},							
	},
	
	c_members = {t='static', 	id=id+9,xywh='s_edit_c_members_xywh', 
					text='LA_MEMBERS',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},	
					
	t_members = {t='static', id=id+10,xywh='s_edit_t_members_xywh', trans = false,text='1,2,3,4',
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},							
	},
					
	disk_list	= {t='list',	id=id+11,	xywh='s_edit_raid_list_xywh', font = 'f_grade6',
					listattr = {8,7,b_ui.LISTATTR.FIRST_WIDGET_STATIC,b_ui.LISTATTR.END_WIDGET_ADDDEL},
					dlg_key = {w1_key.DLG_EDIT_RAID_MSG,w1_key.DLG_EDIT_RAID_MSG},
					columns_w = {80,190,190,200,150,170,150},
					},

	close = {t='tt_button',id=id+12,xywh='s_edit_raid_close_xywh',
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade6','it_close','it_close', 'it_close'},
			cmd=on_close,
			color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_txt_f'},
			color_f= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'}},	


}

local dlg_del = {
	attr 	= {xywh='s_msgbox_xywh',},
	sub 	= {'msg', 'tipinfo','ok', 'cancel'},
	
	msg	 	= {t='static',	id=id+2,	xywh='s_msgbox_msg_xywh',	
			text='LA_RAID_DEL_TIP',align = b_ui.ALIGN.LEFT, font = 'f_grade4',
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},

	tipinfo	= {t='static',id=id+3,	xywh='s_msgbox_tipinfo_xywh',	text='', 
			font='f_grade7', trans = false,
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_tip_text'},
			},
			
	hline	= {t='hline',	id=id+4,	xywh='s_msgbox_hline_xywh'},
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_hline'},
			
	ok		= {t='button',	id=id+5,	xywh='s_msgbox_ok_xywh',	text='LA_YES',	font='f_grade6',	
				color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
				cmd=on_ok_del},
	cancel	= {t='button',	id=id+6,	xywh='s_msgbox_cancel_xywh',text='LA_BAD',font='f_grade6',
				color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f', 'c_popdlg_ok_text_f'},
				cmd=on_close},		
}

w1_edit_raid.set_data =function (data)
	w1_edit_raid.data = data;
end

w1_edit_raid.on_create = function(top)
	w1_edit_raid.top = top;
	return 0;
end

w1_edit_raid.on_destroy = function(top)
	w1_edit_raid.top = nil;
	w1_edit_raid.dlg = nil;
	return 0;
end

w1_edit_raid.on_pre_show = function(top)
	local param = b_wnd.get_wnd_data(top);
	local paramdata;
	if(param ~= nil)then
		paramdata = cjson.decode(param);
	--	assert(paramdata.opera == 1 or paramdata.opera == 2);
		if(paramdata.opera == 1) then
			w1_edit_raid.edit_type = 1;--ǵǰǱ༭
		elseif(paramdata.opera == 2) then
			w1_edit_raid.edit_type = 2;--ǵǰɾ
		elseif(paramdata.opera == 0) then
			w1_edit_raid.edit_type = 0;--ǵǰ
		end
			
		local sel = math.modf((paramdata.sel + 1) / 1)
		w1_edit_raid.sel = sel;--¼һҳǰк
	
		
		
	else
		w1_edit_raid.edit_type = 0;--ǵǰ
	end
	
	local data = w1_edit_raid.data;
	updata_raid_disk(top);
	if(1 == w1_edit_raid.edit_type)then	
		w1_edit_raid.dlg = dlg;
		b_parser(top, w1_edit_raid.dlg);
		local cwnd = w1_edit_raid.dlg;	
		local param = {
			STR('LA_NAME'), STR('LA_CAPACITY'),STR('LA_STATUS'), STR('LA_TYPE'), STR('LA_HOTSPARE_DISK'),STR('LA_OPERATE')
		};
		b_wnd_ex.set_title_texts(top, cwnd.disk_list.id, param, false)
		w1_edit_raid_msgbox.init();
		w1_edit_raid_msgbox.set_func(ok_add_delete_fun, {top});
		local disk_data = data.raid["raid"..w1_edit_raid.sel]  
		w1_edit_raid_msgbox.set_data(w1_edit_raid.data_disk);
		refresh_list(top ,false);

	elseif(0 == w1_edit_raid.edit_type)then
		w1_edit_raid.dlg = dlg_del;
		b_parser(top, w1_edit_raid.dlg);
		local cwnd = w1_edit_raid.dlg;	
		local param = {
			STR('LA_NAME'), STR('LA_CAPACITY'),STR('LA_STATUS'), STR('LA_TYPE'), STR('LA_HOTSPARE_DISK'),STR('LA_OPERATE')
		};
		b_wnd_ex.set_title_texts(top, cwnd.disk_list.id, param, false)
		
		
		w1_edit_raid_msgbox.init();
		w1_edit_raid_msgbox.set_func(ok_add_delete_fun, {top});
		local disk_data = data.raid["raid"..w1_edit_raid.sel]  
		w1_edit_raid_msgbox.set_data(w1_edit_raid.data_disk);
		
	elseif(2 == w1_edit_raid.edit_type )then
		w1_edit_raid.dlg = dlg_del;
		b_parser(top, w1_edit_raid.dlg);
		local disk_data = data.raid["raid"..w1_edit_raid.sel]  
		local raidname = "RAID-"..disk_data.raid_name
		local str =STR('LA_RAID_DEL_TIP')
		local str1 = string.gsub(str, "RAID_MD" ,raidname) 
		b_wnd_ex.set_text(top, w1_edit_raid.dlg.msg.id, str1, false);
	else
		print("--error--w1_edit_raid.edit_type---"..w1_edit_raid.edit_type)
	end
	
	
	return 0;
end

w1_edit_raid.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top);
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_popdlg_bk'));
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_popdlg_border'),1);
	b_wnd.end_job(top);
	return 0;
end

w1_edit_raid.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if(b_ui.RBUTTONCLK == vmsg) then
		b_dlg.end_modal(top);
		w1_edit_raid.okfunc_param[2] = w1_edit_raid.edit_type;
		w1_edit_raid.ok_func(w1_edit_raid.okfunc_param);
	end
	return 0;
end


return w1_edit_raid;
