--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2019/3/14
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_raid_msgbox_id
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local b_wnd 	= require("wnd.core.b_wnd")
local b_app_api = require("wnd.core.command.b_app_api")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local r_size		= require("wnd.core.r_res.r_size")
local util 			= require("wnd.core.util")
local SIZE 			= r_size.get_size
local w1_msgbox = require("wnd.w1_util.w1_msgbox")

local w1_edit_raid_msgbox = 
{
	t = w1_key.DLG_EDIT_RAID_MSG,
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_edit_raid_msgbox.s_768 =
{
};

w1_edit_raid_msgbox.s_1280 = 
{

	
}

w1_edit_raid_msgbox.s_1440 = 
{

}

w1_edit_raid_msgbox.s_1080p = 
{

}

w1_edit_raid_msgbox.s_2k = 
{

}

w1_edit_raid_msgbox.s_4k = 
{

}

w1_edit_raid_msgbox.init = function()
	w1_edit_raid_msgbox.ok_func = nil;				--okťص	
	w1_edit_raid_msgbox.okfunc_param = nil;			--okťص
end

w1_edit_raid_msgbox.set_func  = function(ok_func, okfunc_param, cannel_func, cancelfunc_param)
	assert(ok_func == nil or type(ok_func) == 'function')
	assert(okfunc_param == nil or type(okfunc_param) == 'table')

	w1_edit_raid_msgbox.ok_func = ok_func;
	w1_edit_raid_msgbox.okfunc_param = okfunc_param;
end

local on_ok_del = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local disk_data = w1_edit_raid_msgbox.data;--data.raid["raid"..w1_edit_raid_msgbox.sel] 
		local raidname = disk_data.raid_name;
		
		local disk_info = disk_data['disk'..w1_edit_raid_msgbox.sel]
		
		local diskname = disk_info.disk_name;
		local disktype = disk_info.disk_type;
		local hostid = disk_info.host_id;
		local chnid = disk_info.chn_id;
		local smr_flag = disk_info.smr_statu;
		if(1 == disktype)then
			local ret = b_app_api.delete_raid_disk ({cur_raid = raidname, cur_disk =diskname }).del_disk;
			if('table' == type(ret) and (0 == ret.errornum))then
				w1_edit_raid_msgbox.okfunc_param[2] = w1_edit_raid_msgbox.edit_type;
				w1_edit_raid_msgbox.ok_func(w1_edit_raid_msgbox.okfunc_param);
			else
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_DEL_DISK_FAIL'), true, false,false);
				w1_msgbox.set_func(okfunc, {top}, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);			
			end
		else
			if smr_flag~=0 then
				w1_msgbox.set_dlgattr(STR('LA_TIP'),diskname.." "..STR('LA_RAID_NOT_SUPPORT'), true, false,false);
				w1_msgbox.set_func(okfunc, {top}, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
				b_dlg.end_modal(top);
				return 0;
			end
		
			local ret = b_app_api.add_raid_disk ({cur_raid = raidname, disk_info = disk_info}).add_disk;
			if('table' == type(ret) and (0 == ret.errornum))then
				w1_edit_raid_msgbox.okfunc_param[2] = w1_edit_raid_msgbox.edit_type;
				w1_edit_raid_msgbox.ok_func(w1_edit_raid_msgbox.okfunc_param);
			elseif('table' == type(ret) and (1 == ret.errornum))then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_RAID_EXIST'), true, false,false);
				w1_msgbox.set_func(okfunc, {top}, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
			elseif('table' == type(ret) and (2 == ret.errornum))then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_RAID_NOT_EXIST'), true, false,false);
				w1_msgbox.set_func(okfunc, {top}, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
			elseif('table' == type(ret) and (3 == ret.errornum))then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_DISK_NAME_ERROR'), true, false,false);
				w1_msgbox.set_func(okfunc, {top}, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
			elseif('table' == type(ret) and (4 == ret.errornum))then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_RAID_NOT_SUPPORT'), true, false,false);
				w1_msgbox.set_func(okfunc, {top}, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
			elseif('table' == type(ret) and (5 == ret.errornum))then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_PARAM_INVALID'), true, false,false);
				w1_msgbox.set_func(okfunc, {top}, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
			elseif('table' == type(ret) and (8 == ret.errornum))then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_DISK_SIZE_SMALL'), true, false,false);
				w1_msgbox.set_func(okfunc, {top}, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
			elseif('table' == type(ret) and (10 == ret.errornum))then
				local raid_name = "RAID-"..raidname
				local str =STR('LA_RAID_ISDESTROYED')
				local str1 = string.gsub(str, "RAID_MD" ,raid_name) 
				w1_msgbox.set_dlgattr(STR('LA_TIP'), str1, true, false,false);
				w1_msgbox.set_func(okfunc, {top}, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
			else
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_ADD_DISK_FAIL'), true, false,false);
				w1_msgbox.set_func(okfunc, {top}, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
			end
		end
		b_dlg.end_modal(top);
		local test =0;
	end
	return 0;
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)

	return 0;
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil;
end	

local on_close =  function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0;
end

local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_edit_raid_msgbox.dlg;
		b_dlg.do_modal(top, w1_key.DLG_MSG_RAID, 0, 0, nil)
	end
	return 0;
end

local dlg = {
	attr 	= {xywh='s_msgbox_xywh',},
	sub 	= {'msg', 'tipinfo','ok', 'cancel'},
	
	msg	 	= {t='static',	id=id+2,	xywh='s_msgbox_msg_xywh',	
			text='LA_CONFIRM_DELETE',align = b_ui.ALIGN.LEFT, font = 'f_grade4',
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},

	tipinfo	= {t='static',id=id+3,	xywh='s_msgbox_tipinfo_xywh',	text='', 
			font='f_grade7', trans = false,
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_tip_text'},
			},
			
	hline	= {t='hline',	id=id+4,	xywh='s_msgbox_hline_xywh'},
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_hline'},
			
	ok		= {t='button',	id=id+5,	xywh='s_msgbox_ok_xywh',	text='LA_YES',	font='f_grade6',	
				color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
				cmd=on_ok_del},
	cancel	= {t='button',	id=id+6,	xywh='s_msgbox_cancel_xywh',text='LA_BAD',font='f_grade6',
				color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f', 'c_popdlg_ok_text_f'},
				cmd=on_close},		
}

w1_edit_raid_msgbox.set_data =function (data)
	w1_edit_raid_msgbox.data = data;
end

w1_edit_raid_msgbox.on_create = function(top)
	w1_edit_raid_msgbox.top = top;
	return 0;
end

w1_edit_raid_msgbox.on_destroy = function(top)
	w1_edit_raid_msgbox.top = nil;
	w1_edit_raid_msgbox.dlg = nil;
	return 0;
end

w1_edit_raid_msgbox.clear_data = function()
	w1_edit_raid_msgbox.okfunc_param = nil;
	w1_edit_raid_msgbox.data = nil;
	return 0;
end

w1_edit_raid_msgbox.on_pre_show = function(top)
	local param = b_wnd.get_wnd_data(top);
	local paramdata;
	if(param ~= nil)then
		paramdata = cjson.decode(param);
		if(paramdata.opera == 1) then
			w1_edit_raid_msgbox.edit_type = 1;--ǵǰǱ༭
		elseif(paramdata.opera == 2) then
			w1_edit_raid_msgbox.edit_type = 2;--ǵǰɾ
		elseif(paramdata.opera == 0) then
			w1_edit_raid_msgbox.edit_type = 0;--ǵǰ
		end
		
		local sel = math.modf((paramdata.sel + 1) / 1)
		w1_edit_raid_msgbox.sel = sel;--¼һҳǰк
	else
		w1_edit_raid_msgbox.edit_type = 0;--ǵǰ
	end
	
	local data = w1_edit_raid_msgbox.data;
	if(1 == w1_edit_raid_msgbox.edit_type)then	
		w1_edit_raid_msgbox.dlg = dlg;
		b_parser(top, w1_edit_raid_msgbox.dlg);
	elseif(0 == w1_edit_raid_msgbox.edit_type)then
		w1_edit_raid_msgbox.dlg = dlg;
		b_parser(top, w1_edit_raid_msgbox.dlg);
		local raidname = "RAID-"..data.raid_name
		local diskname = data['disk'..w1_edit_raid_msgbox.sel].disk_name--"disk"..tostring(data['disk'..w1_edit_raid_msgbox.sel].host_id).."-"..tostring(data['disk'..w1_edit_raid_msgbox.sel].chn_id)
		local str = STR('LA_DISK_ADD_TIP')
		local str1 = string.gsub(str, "DISK_N" , diskname) 
		local str2 = string.gsub(str1, "RAID_MD" ,raidname) 
			
		b_wnd_ex.set_text(top, w1_edit_raid_msgbox.dlg.msg.id, str2, false);
		
	elseif(2 == w1_edit_raid_msgbox.edit_type )then
		w1_edit_raid_msgbox.dlg = dlg;
		b_parser(top, w1_edit_raid_msgbox.dlg);
		local raidname = "RAID-"..data.raid_name
		local diskname = data['disk'..w1_edit_raid_msgbox.sel].disk_name--"disk"..tostring(data['disk'..w1_edit_raid_msgbox.sel].host_id).."-"..tostring(data['disk'..w1_edit_raid_msgbox.sel].chn_id)
		local str = STR('LA_DISK_DEL_TIP')
		local str1 = string.gsub(str, "DISK_N" , diskname) 
		local str2 = string.gsub(str1, "RAID_MD" ,raidname) 
		b_wnd_ex.set_text(top, w1_edit_raid_msgbox.dlg.msg.id, str2, false);
	else
		print("--error--w1_edit_raid_msgbox.edit_type---"..w1_edit_raid_msgbox.edit_type)
	end
	
	
	return 0;
end

w1_edit_raid_msgbox.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top);
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_popdlg_bk'));
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_popdlg_border'),1);
	b_wnd.end_job(top);
	return 0;
end

w1_edit_raid_msgbox.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if(b_ui.RBUTTONCLK == vmsg) then
		b_dlg.end_modal(top);
	end
	return 0;
end


return w1_edit_raid_msgbox;
