
--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/10/31
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local w1_id 		= require("wnd.w1_util.w1_id")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local id 			= w1_id.cfg_3g_4g.net_3g_4g_id
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_msgbox 	= require("wnd.w1_util.w1_msgbox")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local util 			= require("wnd.core.util")
local b_app_api		= require("wnd.core.command.b_app_api")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color

local state_flag    = 0;
local update_flag   = true
local w1_page_3g_4g = 
{
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_3g_4g.s_768 =
{
	s_3g_4g_t_enable_xywh = {277,25,25,21},
	s_3g_4g_tipinfo_xywh = {53,391,373,35},
	s_3g_4g_tipsame_xywh = {53,355,373,32},
};

w1_page_3g_4g.s_1280 = 
{
	s_3g_4g_t_enable_xywh ={455,36,48,30},
	s_3g_4g_tipinfo_xywh = {100,550,700,50},
	s_3g_4g_tipsame_xywh = {100,500,700,45},
}

w1_page_3g_4g.s_1440 = 
{
	s_3g_4g_t_enable_xywh = {520,30,48,30},
	s_3g_4g_tipinfo_xywh = {100,470,700,50},
	s_3g_4g_tipsame_xywh = {100,420,700,45},
}

w1_page_3g_4g.s_1080p = 
{
	s_3g_4g_t_enable_xywh = {520,36,48,30},
	s_3g_4g_tipinfo_xywh = {100,550,700,50},
	s_3g_4g_tipsame_xywh = {100,500,700,45},
}

w1_page_3g_4g.s_2k = 
{
	s_3g_4g_t_enable_xywh = {693,48,64,40},
	s_3g_4g_tipinfo_xywh = {133,732,933,67},
	s_3g_4g_tipsame_xywh = {133,660,933,67},
}

w1_page_3g_4g.s_4k = 
{
	s_3g_4g_t_enable_xywh = {1040,72,96,60},
	s_3g_4g_tipinfo_xywh = {200,1100,1400,100},
	s_3g_4g_tipsame_xywh = {200,1000,1400,90},
}

w1_page_3g_4g.clear_data = function()
	w1_page_3g_4g.data = nil;
end	


--ˢUI
local cfgdatatoui = function(top, cfgdata)
	local cwnd = w1_page_3g_4g.wnd
	w1_page_3g_4g.data = cfgdata.net_3g4g
	b_wnd_ex.set_hide(top,cwnd.tipsame.id,true,false)
	b_wnd_ex.set_disable(top,cwnd.t_enable.id,false,false)
	local check_pppoe = b_app_api.get_cfg({'pppoe'}).pppoe;
	if check_pppoe.enable then
		b_wnd_ex.set_hide(top,cwnd.tipsame.id,false,false)
		b_wnd_ex.set_disable(top,cwnd.t_enable.id,true,false)
	end	
	b_wnd_ex.set_disable(top,cwnd.t_ip.id,true,false);
	b_wnd_ex.set_color_d(top, cwnd.t_ip.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_bg_n'),COLOR('c_txt_d')},false);
	b_wnd_ex.set_text(top,cwnd.t_name.id,w1_page_3g_4g.data.user,false)
	b_wnd_ex.set_password(top,cwnd.t_password.id,w1_page_3g_4g.data.password,false)
	b_wnd_ex.set_text(top,cwnd.t_point.id,w1_page_3g_4g.data.apn,false)
	b_wnd_ex.set_text(top,cwnd.t_number.id,w1_page_3g_4g.data.dial_number,false)
	b_wnd_ex.set_check(top,cwnd.t_enable.id,w1_page_3g_4g.data.enable,false)
	local state = w1_page_3g_4g.data.state;

	b_wnd_ex.set_text(top,cwnd.t_status.id,STR('LA_DISCONNECTED'),false)
	local check = w1_page_3g_4g.data.enable
	b_wnd_ex.set_disable(top,cwnd.t_type.id,check,false)
	b_wnd_ex.set_disable(top,cwnd.t_point.id,check,false)
	b_wnd_ex.set_disable(top,cwnd.t_number.id,check,false)
	b_wnd_ex.set_disable(top,cwnd.t_name.id,check,false)
	b_wnd_ex.set_disable(top,cwnd.t_password.id,check,false)
	if state == 0 then
		b_wnd_ex.set_text(top,cwnd.t_status.id,STR('LA_DISCONNECTED'),false)
		b_wnd_ex.set_text(top,cwnd.t_ip.id,w1_page_3g_4g.data.ip,false)
	elseif state == 1 then
		b_wnd_ex.set_text(top,cwnd.t_status.id,STR('LA_CONNECTING_T'),false)
		b_wnd_ex.set_text(top,cwnd.t_ip.id,w1_page_3g_4g.data.ip,false)
	elseif state == 2 then
		b_wnd_ex.set_text(top,cwnd.t_status.id,STR('LA_CONNECTED'),false)
		b_wnd_ex.set_text(top,cwnd.t_ip.id,w1_page_3g_4g.data.ip,false)
	end
	local mode = w1_page_3g_4g.data.access_mode;
	if mode == 6 then
		b_wnd_ex.set_sel(top,cwnd.t_type.id,4,false)
		b_wnd_ex.set_disable(top,cwnd.t_type.id,true,false)
	elseif(mode>0 and mode <6) then
		b_wnd_ex.set_sel(top,cwnd.t_type.id,mode-1,false)
		if mode==4 then
			b_wnd_ex.set_disable(top,cwnd.t_number.id,true,false)
			b_wnd_ex.set_disable(top,cwnd.t_name.id,true,false)
			b_wnd_ex.set_disable(top,cwnd.t_password.id,true,false)
		end
	elseif mode == 0 then
		b_wnd_ex.set_sel(top,cwnd.t_type.id,4,false)
	end
	update_flag = true;
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck = function(top)
	return true,nil
end	

local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_3g_4g.wnd
	local enable = b_wnd_ex.get_check(top,cwnd.t_enable.id)
	local mode = b_wnd_ex.get_sel(top,cwnd.t_type.id)
	local apn = b_wnd_ex.get_text(top,cwnd.t_point.id)
	local number = b_wnd_ex.get_text(top,cwnd.t_number.id)
	local user = b_wnd_ex.get_text(top,cwnd.t_name.id)
	local password = b_wnd_ex.get_password(top,cwnd.t_password.id)
	local data = cfgdata.net_3g4g
	data['enable'] = enable;
	data['apn'] = apn;
	data['access_mode'] = mode+1;
	data['user'] = user
	data.password = password;
	data['dial_number'] = number; 
	
	return 0;
end

local on_enable = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd= w1_page_3g_4g.wnd
		local check = b_wnd_ex.get_check(top,cwnd.t_enable.id)
		local type_name = b_wnd_ex.get_text(top,cwnd.t_type.id)
		if type_name~="LTE" then
			b_wnd_ex.set_disable(top,cwnd.t_number.id,check,false)
			b_wnd_ex.set_disable(top,cwnd.t_name.id,check,false)
			b_wnd_ex.set_disable(top,cwnd.t_password.id,check,false)
		end
		b_wnd_ex.set_disable(top,cwnd.t_type.id,check,false)
		b_wnd_ex.set_disable(top,cwnd.t_point.id,check,false)
		
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck;
		local cwnd = w1_page_3g_4g.wnd
		w1_wnd_util.page_onapply(top);
		update_flag = true;
		w1_wnd_util.tipdispon();		--ʾ
	end
	return 0;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
		update_flag = false;
	end
	return 0
end

w1_page_3g_4g.timer_start = function()
	w1_page_3g_4g.timestart = true;
end

w1_page_3g_4g.timer_stop = function(top)
	w1_page_3g_4g.timestart = false;
	w1_wnd_util.tipclear(top, w1_page_3g_4g.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
	w1_wnd_util.tipdispoff();
end

w1_page_3g_4g.timerenevt = function(top)
	if(w1_page_3g_4g.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_3g_4g.wnd.tipinfo.id);
		local cwnd = w1_page_3g_4g.wnd;
		local data_3g = b_app_api.get_cfg({'net_3g4g'}).net_3g4g
		local state = data_3g.state;
		local enable = b_wnd_ex.get_check(top,cwnd.t_enable.id)
		local mode = data_3g.access_mode
		local mode_name = b_wnd_ex.get_text(top,cwnd.t_type.id)
		if state == 0 then
			b_wnd_ex.set_text(top,cwnd.t_status.id,STR('LA_DISCONNECTED'),false)
			b_wnd_ex.set_text(top,cwnd.t_ip.id,"",false)
		elseif state == 1 then
			b_wnd_ex.set_text(top,cwnd.t_status.id,STR('LA_CONNECTING_T'),false)
			b_wnd_ex.set_text(top,cwnd.t_ip.id,"",false)
		elseif state == 2 then
			b_wnd_ex.set_text(top,cwnd.t_status.id,STR('LA_CONNECTED'),false)
			b_wnd_ex.set_text(top,cwnd.t_ip.id,data_3g.ip,false)
		end
		if enable and update_flag then
			b_wnd_ex.set_text(top,cwnd.t_name.id,data_3g.user,false)
			b_wnd_ex.set_password(top,cwnd.t_password.id,data_3g.password,false)
			b_wnd_ex.set_text(top,cwnd.t_point.id,data_3g.apn,false)
			b_wnd_ex.set_text(top,cwnd.t_number.id,data_3g.dial_number,false)
			if (mode>0 and mode <6)then
				b_wnd_ex.set_sel(top,cwnd.t_type.id,mode-1,false)
			else
				b_wnd_ex.set_sel(top,cwnd.t_type.id,4,false)
			end
		end
		
		if mode_name=="LTE" then
			b_wnd_ex.set_disable(top,cwnd.t_number.id,true,false)
			b_wnd_ex.set_disable(top,cwnd.t_name.id,true,false)
			b_wnd_ex.set_disable(top,cwnd.t_password.id,true,false)
		elseif mode == 6  then
			b_wnd_ex.set_disable(top,cwnd.t_type.id,true,false)
		end
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

--ҳʼʱٶȡҳҪ
w1_page_3g_4g.init = function(top)
	w1_wnd_util.cfgtab = {'net_3g4g'};
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);
	return 0
end

local on_type = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cwnd = w1_page_3g_4g.wnd
		local change_type= b_wnd_ex.get_text(top,cwnd.t_type.id)
		if change_type == "LTE" then
			b_wnd_ex.set_disable(top,cwnd.t_number.id,true,false)
			b_wnd_ex.set_disable(top,cwnd.t_name.id,true,false)
			b_wnd_ex.set_disable(top,cwnd.t_password.id,true,false)
		else
			b_wnd_ex.set_disable(top,cwnd.t_number.id,false,false)
			b_wnd_ex.set_disable(top,cwnd.t_name.id,false,false)
			b_wnd_ex.set_disable(top,cwnd.t_password.id,false,false)
		end
		uitousercfg(top,b_app_cfg.user_cfg);
		update_flag = false;
		b_dlg.dlg_set_redraw(top)
	end
	return 0
end

w1_page_3g_4g.apply =function(top)
	local ret = nil;
	local cwnd = w1_page_3g_4g.wnd
	w1_wnd_util.uidatacheckfunc = uidatacheck
	uitousercfg(top,b_app_cfg.user_cfg);
		
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_3g_4g.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_enable','t_enable','cap_status','t_status','cap_type',
			't_type','cap_point','t_point','cap_number','t_number',
			'cap_name','t_name','cap_password','t_password','cap_ip','t_ip', 'tipinfo','tipsame','apply', },
		
	cap_enable 	= {t='static',id=id+1,xywh='s_cfg_page_1_1',text='LA_ENABLE_3G4G'},
	t_enable 	= {t='tt_check', id=id+2,xywh='s_3g_4g_t_enable_xywh',
				t_imgs ={b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
				cmd = on_enable},
	
	cap_status  = {t='static',id=id+3,xywh='s_cfg_page_2_1',text='LA_STATUS'},
	t_status		= {t='static',id=id+4,xywh='s_cfg_page_2_2',text='LA_DISCONNECTED'},
	
	cap_type    = {t='static',id=id+5,xywh='s_cfg_page_3_1',text='LA_ACCESS_MODE'},
	t_type		= {t='combox',id=id+6,xywh='s_cfg_ip_3_2',items={'GSM/GPRS','WCDMA','TD-SCDMA','LTE','AUTO'},trans=false,cmd=on_type},
	
	cap_point   = {t='static',id=id+7,xywh='s_cfg_page_4_1',text='LA_ACCESS_POINT'},
	t_point		= {t='edit',id=id+8,xywh='s_cfg_ip_4_2',cmd = on_update_param},
	
	cap_number  = {t='static',id=id+9,xywh='s_cfg_page_5_1',text='LA_DIAL_NUMBER'},
	t_number	= {t='edit',id=id+10,xywh='s_cfg_ip_5_2',cmd = on_update_param},
	
	cap_name    = {t='static',id=id+11,xywh='s_cfg_page_6_1',text='LA_USER_NAME'},
	t_name   	= {t='edit',id=id+12,xywh='s_cfg_ip_6_2',cmd = on_update_param},
	
	cap_password = {t='static',id=id+13,xywh='s_cfg_page_7_1',text='LA_PASSWORD'},
	t_password   = {t='password',id=id+14,xywh='s_cfg_ip_7_2',cmd = on_update_param},
	cap_ip = {t='static',id=id+15,xywh='s_cfg_page_8_1',text='LA_IP_ADDRESS'},
	t_ip   = {t='edit_ip',id=id+16,xywh='s_cfg_ip_8_2',cmd = on_update_param},

	tipinfo		= {t='static',id=id+17,	xywh='s_3g_4g_tipinfo_xywh',text='',trans = false},		
	tipsame		= {t='static',id=id+20,	xywh='s_3g_4g_tipsame_xywh',text='LA_NOT_SAME_TIME',color = {'c_hint_bk', 'c_hint_border', 'c_hint_text'}},	
	apply 		= {t='button',	id=id+18,	xywh='s_cfg_apply_xywh', 		text='LA_APPLY',cmd=on_apply},
}

return w1_page_3g_4g