
--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/10/31
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local w1_id 		= require("wnd.w1_util.w1_id")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local id 			= w1_id.cfg_8021x.net_8021x_id
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_msgbox 	= require("wnd.w1_util.w1_msgbox")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local util 			= require("wnd.core.util")

local w1_page_8021x = 
{
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_8021x.s_768 =
{
	s_8201x_t_enable_xywh = {277,25,25,21},
	s_8201x_tipinfo_xywh = {53,334,373,35},
};

w1_page_8021x.s_1280 = 
{
	s_8201x_t_enable_xywh ={455,36,48,30},
	s_8201x_tipinfo_xywh = {100,470,700,50},
}

w1_page_8021x.s_1440 = 
{
	s_8201x_t_enable_xywh = {520,30,48,30},
	s_8201x_tipinfo_xywh = {100,470,700,50},
}

w1_page_8021x.s_1080p = 
{
	s_8201x_t_enable_xywh = {520,36,48,30},
	s_8201x_tipinfo_xywh = {100,470,700,50},
}

w1_page_8021x.s_2k = 
{
	s_8201x_t_enable_xywh = {693,48,64,40},
	s_8201x_tipinfo_xywh = {133,627,933,67},
}

w1_page_8021x.s_4k = 
{
	s_8201x_t_enable_xywh = {1040,72,96,60},
	s_8201x_tipinfo_xywh = {200,940,1400,100},
}

local refresh_hide = function(top, bool_flag, redraw)
	local cwnd = w1_page_8021x.wnd;	
	b_wnd_ex.set_hide(top, cwnd.cap_account.id, bool_flag, false);
	b_wnd_ex.set_hide(top, cwnd.t_account.id, bool_flag, false);
	b_wnd_ex.set_hide(top, cwnd.cap_pass.id, bool_flag, false);
	b_wnd_ex.set_hide(top, cwnd.t_pass.id, bool_flag, false);
	if true == redraw then
		b_dlg.dlg_set_redraw(top)
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local cwnd = w1_page_8021x.wnd;
	local data = cfgdata.net_802x;
	if(0 == data.enable)then
		b_wnd_ex.set_check(top, cwnd.t_enable.id,false,false);
		refresh_hide(top, true ,false);
	else
		b_wnd_ex.set_check(top, cwnd.t_enable.id,true,false);
		refresh_hide(top, false ,false);
	end
	b_wnd_ex.set_text(top, cwnd.t_account.id,data.account,false);
	b_wnd_ex.set_password(top, cwnd.t_pass.id,data.password,false);
--	b_wnd_ex.set_password(top, cwnd.t_conpass.id,data.password,false);
	
	--Ĭϲʾ 
	b_wnd_ex.set_disp(top, cwnd.t_pass.id, false, false);
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck = function(top)
	local cwnd = w1_page_8021x.wnd;
	local legalflag = true;
	local nlegalid = {};
	
	local check = b_wnd_ex.get_check(top, cwnd.t_enable.id);
	local account = b_wnd_ex.get_text(top, cwnd.t_account.id);
	local pass = b_wnd_ex.get_password(top, cwnd.t_pass.id);
--	local conpass = b_wnd_ex.get_password(top, cwnd.t_conpass.id);
	if(check == true)then
		if("" == account)then
			legalflag = false;
			table.insert(nlegalid, cwnd.t_account.id);
			w1_wnd_util.setparamerr_str(STR('LA_ACCOUNT_EMPTY'));
			return legalflag, nlegalid;
		end
		--Ϊ
		if("" == pass)then
			legalflag = false;
			table.insert(nlegalid, cwnd.t_pass.id);
			w1_wnd_util.setparamerr_str(STR('LA_PASSWORD_EMPTY'));
			return legalflag, nlegalid;
		end
	end

	if(legalflag) then
		return legalflag, nil;
	else
		return legalflag, nlegalid;
	end
	return 0;
end	

local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_8021x.wnd;
	local data = cfgdata.net_802x;
	local check =  b_wnd_ex.get_check(top, cwnd.t_enable.id);
	if(check == true)then
		data.enable = 1;
	else
		data.enable = 0;
	end
	data.account = b_wnd_ex.get_text(top, cwnd.t_account.id);
	data.password = b_wnd_ex.get_password(top, cwnd.t_pass.id);
	return 0;
end

local on_enable = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local check = b_wnd_ex.get_check(top, win_id);
		if(check == true)then
			refresh_hide(top, false ,false);
		else
			refresh_hide(top, true ,false);
		end
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	b_dlg.dlg_set_redraw(top);
	return 0;
end

local on_account = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck;
		w1_wnd_util.page_onapply(top);
		w1_wnd_util.tipdispon();		--ʾ
	end
	return 0;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

w1_page_8021x.timer_start = function()
	w1_page_8021x.timestart = true;
end

w1_page_8021x.timer_stop = function(top)
	w1_page_8021x.timestart = false;
	w1_wnd_util.tipclear(top, w1_page_8021x.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
	w1_wnd_util.tipdispoff();
end

w1_page_8021x.timerenevt = function(top)
	if(w1_page_8021x.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_8021x.wnd.tipinfo.id);
	end
	return 0;
end

--ҳʼʱٶȡҳҪ
w1_page_8021x.init = function(top)
	w1_wnd_util.cfgtab = {'net_802x'};
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);
	return 0
end

w1_page_8021x.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	uitousercfg(top,b_app_cfg.user_cfg);
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_8021x.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_enable','t_enable','cap_account','t_account',
			'cap_pass','t_pass','cap_conpass','t_conpass','tipinfo','apply' },
		
		
	cap_enable 	= {t='static',id=id+1,xywh='s_cfg_page_1_1',text='LA_ENABLE_8021_X'},
	t_enable 	= {t='tt_check', id=id+2,xywh='s_8201x_t_enable_xywh',
				t_imgs ={b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
				cmd = on_enable},				
	cap_account 	= {t='static',	id=id+3,	xywh='s_cfg_page_2_1',text='LA_ACCOUNT'},		
	t_account 		= {t='edit',id=id+4,xywh='s_cfg_page_2_2',text='',guide_text='LA_USER_NAME',cmd = on_account},
	
	cap_pass = {t='static',	id=id+5,	xywh='s_cfg_page_3_1',text='LA_PASSWORD'},		
	t_pass 	= {t='password',id=id+6,	xywh='s_cfg_page_3_2',password='',guide_text='LA_PASSWORD',disp = false,cmd = on_update_param},	

	tipinfo		= {t='static',id=id+7,	xywh='s_ip_tipinfo_xywh',text='',trans = false},		
	apply 		= {t='button',	id=id+8,	xywh='s_cfg_apply_xywh', 		text='LA_APPLY',cmd=on_apply},
}

return w1_page_8021x



