local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_ai_resource.ai_resource_id
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg 		= require("wnd.w1_util.w1_ui_msg") 
local r_str			= require("wnd.core.r_res.r_str")
local b_app_api		= require("wnd.core.command.b_app_api")
local STR 			= r_str.get_str
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size

local channel_num;
local w1_page_ai_resource={
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_ai_resource.s_768 =
{
	s_ai_resource_t_channel_table_xywh = {280,64,202,106},
	s_ai_resource_t_tab_btn_size = {0,0,21,28},
	s_ai_resource_tipinfo_xywh = {53,604,320,42},
};

w1_page_ai_resource.s_1280={
	s_ai_resource_t_channel_table_xywh ={458,90,380,150},
	s_ai_resource_t_tab_btn_size = {0,0, 40, 40},
	s_ai_resource_tipinfo_xywh = {100,800,600,60},
}

w1_page_ai_resource.s_1440={
	s_ai_resource_t_channel_table_xywh ={528,75,380,150},
	s_ai_resource_t_tab_btn_size = {0,0, 40, 40},
	s_ai_resource_tipinfo_xywh = {100,670,600,50},
}

w1_page_ai_resource.s_1080p={
	s_ai_resource_t_channel_table_xywh ={525,90,380,150},
	s_ai_resource_t_tab_btn_size = {0,0, 40, 40},
	s_ai_resource_tipinfo_xywh = {100,850,600,60},
}

w1_page_ai_resource.s_2k={
	s_ai_resource_t_channel_table_xywh ={700,120,482,186},
	s_ai_resource_t_tab_btn_size = {0,0, 53, 53},
	s_ai_resource_tipinfo_xywh = {80,1100,800,60},
}

w1_page_ai_resource.s_4k={
	s_ai_resource_t_channel_table_xywh ={1050,180,760,300},
	s_ai_resource_t_tab_btn_size = {0,0, 80, 80},
	s_ai_resource_tipinfo_xywh = {200,1600,1200,120},
}

w1_page_ai_resource.clear_data = function()
	w1_page_ai_resource.data = nil;
end	

local cfgdatatoui =function (top,cfgdata)
	assert(type(cfgdata)=='table')
	w1_page_ai_resource.data=cfgdata;
	local data = cfgdata.ai_resource;
	local cwnd=w1_page_ai_resource.wnd;
	b_wnd_ex.set_sel(top, cwnd.t_mode.id, data.mode, false);
	local chn_table= {};
	for i=1,data.channel_num do
		table.insert(chn_table,data.chn_cfg[i])
	end
	b_wnd_ex.set_chcopy_data(top,cwnd.channel_table.id,chn_table,false)
end

local uitousercfg = function (top,cfgdata)
	local data = cfgdata.ai_resource;
	local cwnd = w1_page_ai_resource.wnd;
	local chn_data = b_wnd_ex.get_chcopy_data(top,cwnd.channel_table.id)
	data.mode = b_wnd_ex.get_sel(top,cwnd.t_mode.id)
	data.channel_num = #chn_data;
	data.chn_cfg = chn_data;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if b_ui_msg.msg_user_update_parent == vmsg then
		uitousercfg(top,w1_page_ai_resource.data)
	end
	return 0
end

w1_page_ai_resource.on_data_change=function (top)
	uitousercfg(top,w1_page_ai_resource.data)
end

w1_page_ai_resource.on_pre_show= function(top)
	local channel_num = global_val.get_channelnum();
	local cwnd = w1_page_ai_resource.wnd;
	b_wnd_ex.set_chcopy_chn_num(top, cwnd.channel_table.id, channel_num, false)
	local rect_size = SIZE('s_ai_resource_t_tab_btn_size');
	b_wnd_ex.set_chn_type_size(top, cwnd.channel_table.id, rect_size, false);	
end

w1_page_ai_resource.init = function(top)
	w1_wnd_util.cfgtab = {'ai_resource'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

local uidatacheck =function(top)
	local data = w1_page_ai_resource.data.ai_resource;
	local mode = data.mode
	if mode ~= 3 and data.channel_num > 4 then
		w1_wnd_util.setparamerr_str(string.gsub(STR('LA_OUT_CHN_SELECT'), '*' ,4))
		return false, nil
	elseif mode == 3 and data.channel_num > 1 then
		w1_wnd_util.setparamerr_str(string.gsub(STR('LA_OUT_CHN_SELECT'), '*' ,1))
		return false, nil; 
	end
	return true, nil
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_mode = function (top, win_id, vmsg, x, y)
	if b_ui_msg.msg_user_update_parent == vmsg then
		local cwnd = w1_page_ai_resource.wnd
		local chn_table= {};
		b_wnd_ex.set_chcopy_data(top,cwnd.channel_table.id,chn_table,false)
		uitousercfg(top,w1_page_ai_resource.data)
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

w1_page_ai_resource.timer_start = function()
	w1_page_ai_resource.timestart = true
end

w1_page_ai_resource.timer_stop = function(top)
	w1_page_ai_resource.timestart = false
	w1_wnd_util.tipclear(top, w1_page_ai_resource.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_ai_resource.timerenevt = function(top)
	if(w1_page_ai_resource.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_ai_resource.wnd.tipinfo.id)
	end
	return 0
end

w1_page_ai_resource.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	w1_wnd_util.page_onapply(top)
	return ret;
end

w1_page_ai_resource.wnd = {
	t='wnd_bg',id=id,xywh='s_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'},
	sub={'cap_mode','t_mode','cap_channel','channel_table','apply','tipinfo'},
	
	cap_mode= {t='static',id=id+1,xywh='s_cfg_page_1_1',text='LA_MODE_SELECTION'},
	t_mode = {t='combox',id=id+2, xywh='s_cfg_page_1_2',items={'LA_NONE','LA_MODE_SNAPSHOT','LA_MODE_DETECTION','LA_MODE_SNAP_DET'},cmd=on_mode},
	
	cap_channel = {t='static',id=id+3 ,xywh='s_cfg_page_2_1', text='LA_CHANNEL'},
	
	channel_table = {t='chn_copy', id=id+4,	xywh='s_ai_resource_t_channel_table_xywh',
					color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n'}, cmd = on_update_param},	

	tipinfo		= {t='static',id=id+5,	xywh='s_ai_resource_tipinfo_xywh',	text='',trans = false},	
	
	apply =	{t='button',id=id+6,xywh='s_cfg_apply_xywh',text='LA_APPLY',cmd=on_apply},
}

return w1_page_ai_resource