--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/6/7
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_alarmin.alarmin_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  	= require("wnd.w1_util.w1_ui_msg") 
local w1_row_alarminrow 		= require("wnd.w1_cfg.w1_row_alarminrow")
local w1_page_alarminevent 		= require("wnd.w1_cfg.w1_page_alarminevent")
local w1_page_alarmintimeplan 	= require("wnd.w1_cfg.w1_page_alarmintimeplan")
local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local util 		= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")

local ai_num;
local channel_num;
local w1_page_alarmin = 
{
	data,
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_alarmin.s_768 =
{
	s_alarmin_t_enable_xywh = {277,67,25,21},
	s_alarmin_tipinfo_xywh = {58,586,160,28},
};

w1_page_alarmin.s_1280 = 
{
	s_alarmin_t_enable_xywh = {455,95,48,30};
	s_alarmin_tipinfo_xywh = {110,810,260,40};
}

w1_page_alarmin.s_1440 = 
{
	s_alarmin_t_enable_xywh = {520,82,48,30},
	s_alarmin_tipinfo_xywh = {110,693,300,30},
}


w1_page_alarmin.s_1080p = 
{
	s_alarmin_t_enable_xywh = {520,95,48,30};
	s_alarmin_tipinfo_xywh = {110,825,300,40};
}

w1_page_alarmin.s_2k = 
{
	s_alarmin_t_enable_xywh = {693,127,64,40},
	s_alarmin_tipinfo_xywh = {147,1100,390,53},

}
w1_page_alarmin.s_4k = 
{
	s_alarmin_t_enable_xywh = {1040,190,96,60},
	s_alarmin_tipinfo_xywh = {220,1650,600,80},
}


w1_page_alarmin.clear_data = function()
	w1_page_alarmin.data = nil;
end	

local refresh_chdata = function(top, chid, redraw)
	local c_wnd = w1_page_alarmin.wnd
	local channeldata = w1_page_alarmin.data.alarm_in['sensor'..chid]
	local ro_num = w1_page_alarmin.data.device_info['ro_num']
	local buzz_support = w1_page_alarmin.data.device_info['buzzer_support']
	b_wnd_ex.set_check(top, c_wnd.t_enable.id, channeldata.enable, redraw);
	assert(channeldata.nc == 0 or channeldata.nc == 1);
	if(channeldata.nc == 0 )then
		b_wnd_ex.set_sel(top, c_wnd.t_type.id, 1, redraw);
	else
		b_wnd_ex.set_sel(top, c_wnd.t_type.id, 0, redraw);
	end
	b_wnd_ex.set_text(top, c_wnd.t_name.id, channeldata.name, redraw)

	local checkidx = w1_row_alarminrow.get_checkidx(top);
	if(checkidx == 0) then
		w1_page_alarminevent.setstatus(top, channeldata, 0, ro_num, buzz_support,redraw)
		w1_page_alarmintimeplan.settimeplan(top, channeldata, false);
	else
		w1_page_alarminevent.setstatus(top, channeldata, 0, ro_num, buzz_support,false)
		w1_page_alarmintimeplan.settimeplan(top, channeldata, redraw);
	end
end


--ˢUI
local cfgdatatoui = function(top, cfgdata)
	local c_wnd = w1_page_alarmin.wnd
	w1_page_alarmin.data = cfgdata
	local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_alarmin.id));
	refresh_chdata(top, chid, false);
	
	return 0;
end


local uidatacheck =function(top)
	return true, nil
end

w1_page_alarmin.timer_start = function()
	w1_page_alarmin.timestart = true
end

w1_page_alarmin.timer_stop = function(top)
	w1_page_alarmin.timestart = false
	w1_wnd_util.tipclear(top, w1_page_alarmin.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_alarmin.timerenevt = function(top)
	if(w1_page_alarmin.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_alarmin.wnd.tipinfo.id)
	end
	return 0
end
--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_alarmin.wnd
	
	local enable = b_wnd_ex.get_check(top,cwnd.t_enable.id);
	local nc = b_wnd_ex.get_sel(top,cwnd.t_type.id);
	local name = b_wnd_ex.get_text(top,cwnd.t_name.id);
	local timeplan = w1_page_alarmintimeplan.gettimeplan(top);
	
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_alarmin.id))
	
	local data = cfgdata.alarm_in['sensor'..chid]
	data.enable = enable;
	if(0 == nc) then
		data.nc = 1
	else
		data.nc = 0
	end
	data.name = name;
	data.timeplan = timeplan;
	data.change_flag = true;
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_alarmin.init = function(top)
	w1_wnd_util.cfgtab = {'alarm_in','device_info'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

local on_alarmin= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local c_wnd = w1_page_alarmin.wnd
		local chid = tonumber(b_wnd_ex.get_text(top, win_id));
		refresh_chdata(top, chid, false);
		b_dlg.dlg_set_redraw(top);
--		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_enable = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_type = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_name =  function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

--UIָĬֵ
local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end


w1_page_alarmin.on_data_change = function(top)
	if w1_row_alarminrow.get_checkidx(top)==0 then
		w1_page_alarminevent.on_channel_check(top);
	end
	
end

w1_page_alarmin.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_alarmin.on_pre_show = function(top)
	ai_num = global_val.get_sinum();
	channel_num = global_val.get_channelnum();
	local cwnd = w1_page_alarmin.wnd;
	local param={};
	for i=1,ai_num do
		param[i] = tostring(i);
	end
	b_wnd_ex.set_items(top, cwnd.t_alarmin.id, param, false);
	
	w1_page_alarminevent.on_pre_show(top, channel_num)
	local con_id = cwnd.con_alarmin.id;

--	b_wnd_ex.set_show_page(top,con_id, cwnd.alarminevent_wnd.id, false);
	w1_row_alarminrow.changecheck(top, w1_row_alarminrow.wnd, w1_id.cfg_alarmin.alarminrow_id + 1, false)
end

w1_page_alarmin.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
			
	sub = {'cap_alarmin', 't_alarmin','cap_enable','t_enable',	
			'cap_type', 't_type', 'cap_name', 't_name',
			'con_alarmin','alarmin_row_wnd',
			'alarminevent_wnd', 'alarmintimeplan_wnd',	
			'tipinfo','default', 'apply'},
			
	cap_alarmin	= {t='static',	id=id+1,xywh='s_cfg_page_1_1',text='LA_ALARM_IN'},
	t_alarmin 	= {t='combox',	id=id+2,xywh='s_cfg_page_1_2',items={},trans = false,cmd =on_alarmin,
					},	
	
	cap_enable 	= {t='static',	id=id+3,xywh='s_cfg_page_2_1',text='LA_ENABLE_DI_ALA'},
	t_enable 	= {t='tt_check',id=id+4,xywh='s_alarmin_t_enable_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_enable},
	
	cap_type	= {t='static',	id=id+5,xywh='s_cfg_page_3_1',text='LA_TRIGGER_MODE'},
	t_type 		= {t='combox',	id=id+6,xywh='s_cfg_page_3_2',items={'LA_NC', 'LA_NO'},cmd =on_type},	
	
	cap_name 	= {t='static',	id=id+7,xywh='s_cfg_page_4_1',text='LA_PORT_NAME'},
	t_name 		= {t='edit', 	id=id+8,xywh='s_cfg_page_4_2',guide_text='LA_NAME',cmd = on_name},
	
	con_alarmin			= {t='container',id=w1_id.cfg_alarmin.con_alarmin_id,	xywh={0,0,10,10}},
	alarmin_row_wnd 	= w1_row_alarminrow.wnd,
	alarminevent_wnd 	= w1_page_alarminevent.wnd,	
	alarmintimeplan_wnd = w1_page_alarmintimeplan.wnd,

	tipinfo		= {t='static',id=id+9,	xywh='s_alarmin_tipinfo_xywh',	text='',trans = false},

	apply 	= {t='button',id=id+11,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_alarmin
