--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/6/7
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_surve.alarmin_advance_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  	= require("wnd.w1_util.w1_ui_msg") 
local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local util 		= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")

local ai_num;
local channel_num;
local w1_page_alarmin_advance = 
{
	data,
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_alarmin_advance.s_768 =
{
	s_arm_advance_t_enable_xywh = {277,24,25,21},
	s_arm_advance_t_push_xywh = {281,152,160,21},
	s_arm_advance_t_email_xywh = {281,181,160,21},
	s_arm_advance_tipinfo_xywh = {58,586,160,28},
};

w1_page_alarmin_advance.s_1280 = 
{
	s_arm_advance_t_enable_xywh = {455,35,48,30};
	s_arm_advance_t_push_xywh	= {460, 215, 300, 30},
	s_arm_advance_t_email_xywh	= {460, 255, 300, 30},
	s_arm_advance_tipinfo_xywh = {110,810,260,40};
}

w1_page_alarmin_advance.s_1440 = 
{
	s_arm_advance_t_enable_xywh = {520,32,48,30},
	s_arm_advance_t_push_xywh	= {530, 180, 300, 30},
	s_arm_advance_t_email_xywh	= {530, 220, 300, 30},		
	s_arm_advance_tipinfo_xywh = {110,693,300,30},
}


w1_page_alarmin_advance.s_1080p = 
{
	s_arm_advance_t_enable_xywh = {520,35,48,30};
	s_arm_advance_t_push_xywh	= {527, 215, 300, 30},
	s_arm_advance_t_email_xywh	= {527, 255, 300, 30},	
	s_arm_advance_tipinfo_xywh = {110,825,300,40};
}

w1_page_alarmin_advance.s_2k = 
{
	s_arm_advance_t_enable_xywh = {693,47,64,40},
	s_arm_advance_t_push_xywh	= {703, 290, 400, 40},
	s_arm_advance_t_email_xywh	= {703, 343, 400, 40},	
	s_arm_advance_tipinfo_xywh = {147,1100,390,53},

}
w1_page_alarmin_advance.s_4k = 
{
	s_arm_advance_t_enable_xywh = {1040,70,96,60},
	s_arm_advance_t_push_xywh	= {1055, 430, 600, 60},
	s_arm_advance_t_email_xywh	= {1055, 510, 600, 60},		
	s_arm_advance_tipinfo_xywh = {220,1650,600,80},
}


w1_page_alarmin_advance.clear_data = function()
	w1_page_alarmin_advance.data = nil;
end	

local set_hide = function(top, status, redraw)
	local cwnd = w1_page_alarmin_advance.wnd
	local s_id = id + 3;	
	local e_id = id + 9;
	for i = s_id, e_id do
		b_wnd_ex.set_hide(top, i, not status, redraw);
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	local c_wnd = w1_page_alarmin_advance.wnd
	w1_page_alarmin_advance.data = cfgdata.alarm_advance;
	local data = cfgdata.alarm_advance;
	b_wnd_ex.set_check(top, c_wnd.t_enable.id, data.enable, false);
	b_wnd_ex.set_sel(top, c_wnd.t_alarmin.id, data.alarm_in - 1, false);
	b_wnd_ex.set_sel(top, c_wnd.t_type.id, data.nc, false);
	b_wnd_ex.set_check(top, c_wnd.push_app.id, data.push, false)
	b_wnd_ex.set_check(top, c_wnd.email.id, data.email, false)
	
	set_hide(top,  data.enable, false);
	
	return 0;
end

local uidatacheck =function(top)
	return true, nil
end

w1_page_alarmin_advance.timer_start = function()
	w1_page_alarmin_advance.timestart = true
end

w1_page_alarmin_advance.timer_stop = function(top)
	w1_page_alarmin_advance.timestart = false
	w1_wnd_util.tipclear(top, w1_page_alarmin_advance.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_alarmin_advance.timerenevt = function(top)
	if(w1_page_alarmin_advance.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_alarmin_advance.wnd.tipinfo.id)
	end
	return 0
end
--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_alarmin_advance.wnd
	local data = w1_page_alarmin_advance.data
	data.alarm_in = tonumber(b_wnd_ex.get_text(top, cwnd.t_alarmin.id))
	data.enable = b_wnd_ex.get_check(top,cwnd.t_enable.id);
	data.nc = b_wnd_ex.get_sel(top,cwnd.t_type.id);
	data.push = b_wnd_ex.get_check(top, cwnd.push_app.id);
	data.email = b_wnd_ex.get_check(top, cwnd.email.id);	
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_alarmin_advance.init = function(top)
	w1_wnd_util.cfgtab = {'alarm_advance'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

local on_alarmin= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_enable = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
		local cwnd = w1_page_alarmin_advance.wnd
		local enable = b_wnd_ex.get_check(top,cwnd.t_enable.id);
		set_hide(top, enable, false);
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_type = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_update_param =  function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg or b_ui.LBUTTONCLK == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

--UIָĬֵ
local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_alarmin_advance.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_alarmin_advance.on_pre_show = function(top)
	ai_num = global_val.get_sinum();
	channel_num = global_val.get_channelnum();
	local cwnd = w1_page_alarmin_advance.wnd;
	local param={};
	for i=1,ai_num do
		param[i] = tostring(i);
	end
	b_wnd_ex.set_items(top, cwnd.t_alarmin.id, param, false);
end

w1_page_alarmin_advance.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
			
	sub = {'cap_enable','t_enable',	'cap_alarmin', 't_alarmin',
			'cap_type', 't_type', 'cap_forbid_item', 'push_app', 'email',
			'tipinfo','apply'},
			
	cap_enable 	= {t='static',	id=id+1,xywh='s_cfg_page_1_1',text='LA_ENABLE_IO_CONTROL'},
	t_enable 	= {t='tt_check',id=id+2,xywh='s_arm_advance_t_enable_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_enable},

		
	cap_alarmin	= {t='static',	id=id+3,xywh='s_cfg_page_2_1',text='LA_ALARM_IN'},
	t_alarmin 	= {t='combox',	id=id+4,xywh='s_cfg_page_2_2',items={},trans = false,cmd =on_alarmin,
					},		
	cap_type	= {t='static',	id=id+5,xywh='s_cfg_page_3_1',text='LA_TRIGGER_MODE'},
	t_type 		= {t='combox',	id=id+6,xywh='s_cfg_page_3_2',items={'LA_NC', 'LA_NO'},cmd =on_type},	
	
	cap_forbid_item 	= {t='static',	id=id+7,xywh='s_cfg_page_4_1',text='LA_DISABLED_ITEM'},
	push_app	= {t='checkbox', id=id+8,	xywh='s_arm_advance_t_push_xywh',text='LA_PUSH_MESSAGE', check = false, color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_static_text'}, cmd = on_update_param},	
	email	= {t='checkbox', id=id+9,	xywh='s_arm_advance_t_email_xywh',text='LA_EMAIL_PUSH', check = false, color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_static_text'}, cmd = on_update_param},	
	
	tipinfo		= {t='static',id=id+10,	xywh='s_arm_advance_tipinfo_xywh',	text='',trans = false},

	apply 	= {t='button',id=id+11,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}
	
return w1_page_alarmin_advance
