--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_alarmin.timeplan_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local util 		= require("wnd.core.util")
local w1_page_alarmintimeplan =
{
	cfg_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_alarmintimeplan.s_768 =
{
	s_alarmintimeplan_xywh = {53,248,586,248},
};

w1_page_alarmintimeplan.s_1280 = 
{
	s_alarmintimeplan_xywh = {100,350,850,350},
}
w1_page_alarmintimeplan.s_1440 = 
{
	s_alarmintimeplan_xywh = {100,300,1000,350},
}
w1_page_alarmintimeplan.s_1080p = 
{
	s_alarmintimeplan_xywh = {100,350,1100,350},
}
w1_page_alarmintimeplan.s_2k = 
{
	s_alarmintimeplan_xywh = {133,467,1466,467},

}
w1_page_alarmintimeplan.s_4k = 
{
	s_alarmintimeplan_xywh = {200,700,2200,700},
}

w1_page_alarmintimeplan.clear_data=function ()
	w1_page_alarmintimeplan.cfg_data=nil;
end

local uitousercfg = function(top, cfgdata)
	local data = b_wnd_ex.get_timeplan (top, w1_page_alarmintimeplan.wnd.policy.id);
	util.copy_tab_b(cfgdata.timeplan,data); 
	cfgdata.change_flag = true;
	return 0;
end

--ҳʼʱٶȡҳҪ
w1_page_alarmintimeplan.settimeplan =function(top, param, redraw)
	b_wnd_ex.set_timeplan (top, w1_page_alarmintimeplan.wnd.policy.id, param.timeplan, redraw)
	w1_page_alarmintimeplan.cfg_data = param
	return 0
end

w1_page_alarmintimeplan.gettimeplan =function(top)
	return b_wnd_ex.get_timeplan (top, w1_page_alarmintimeplan.wnd.policy.id);
end

local on_select = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_alarmintimeplan.wnd;
		local data = b_wnd_ex.get_timeplan (top, cwnd.policy.id);
		
		local allselect = true;
		local plannum;
		if(win_id == cwnd.t_all.id) then
			for i=1,7 do
				for j=1,4 do
					if(data['weekday'..i][j] ~= 16777215) then
						allselect = false;
						break;
					end
				end
				if(allselect == false) then
					break;
				end
			end			
			
			if(allselect) then
				plannum = 0;
			else
				plannum = 16777215;
			end
			for i=1,7 do
				for j=1,4 do
					data['weekday'..i][j] = plannum;
				end
			end
		else
			local weekday;
			if(win_id == cwnd.t_sun.id) then
				weekday = 1;
			elseif(win_id == cwnd.t_mon.id) then
				weekday = 2;
			elseif(win_id == cwnd.t_tue.id) then
				weekday = 3;
			elseif(win_id == cwnd.t_wed.id) then
				weekday = 4;
			elseif(win_id == cwnd.t_thu.id) then
				weekday = 5;
			elseif(win_id == cwnd.t_fri.id) then
				weekday = 6;
			elseif(win_id == cwnd.t_sat.id) then
				weekday = 7;
			end
				
			allselect = true;
			for j=1,4 do
				if(data['weekday'..weekday][j] ~= 16777215) then
					allselect = false;
					break;
				end
			end
			if(allselect) then
				plannum = 0;
			else
				plannum = 16777215;
			end
			
			for j=1,4 do
				data['weekday'..weekday][j] = plannum;
			end
		end
		b_wnd_ex.set_timeplan (top, cwnd.policy.id, data, true);
	end
	uitousercfg(top,w1_page_alarmintimeplan.cfg_data)
	return 0
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if (b_ui.WM_USER_UPDATE_PARAM == vmsg) then
		uitousercfg(top,w1_page_alarmintimeplan.cfg_data)
	end
	return 0
end

w1_page_alarmintimeplan.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_alarmintimeplan.wnd;
	local sid = cwnd.cap_sun.id;
	local eid = cwnd.cap_all.id;
	for i=sid, eid do
		b_wnd_ex.set_hide(top, i, bool_hide, redraw)
	end
end

w1_page_alarmintimeplan.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_alarmintimeplan_xywh',	
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_all','t_all','t_h2','t_h4','t_h6','t_h8','t_h10','t_h12',
		't_h14','t_h16','t_h18','t_h20','t_h22','t_h24',
		'cap_sun','t_sun','cap_mon','t_mon','cap_tue', 't_tue', 
		'cap_wed', 't_wed', 'cap_thu', 't_thu','cap_fri','t_fri',	
		'cap_sat','t_sat',
		'policy',
		},
	cap_sun		= {t='static',	id=id+1,	xywh='s_timeplan_cap_sun_xywh',	text='LA_WEEK_SUNDAY'},
	t_sun 		= {t='tt_button',id=id+2,	xywh='s_timeplan_t_sun_xywh', 	align = b_ui.ALIGN.LEFT, cmd=on_select,
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_timeplan_s','it_timeplan_s', 'it_timeplan_s'},
				},
	cap_mon		= {t='static',	id=id+3,	xywh='s_timeplan_cap_mon_xywh',	text='LA_WEEK_MONDAY'},
	t_mon 		= {t='tt_button',id=id+4,	xywh='s_timeplan_t_mon_xywh', 	align = b_ui.ALIGN.LEFT, cmd=on_select,
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_timeplan_s','it_timeplan_s', 'it_timeplan_s'},
				},
	cap_tue		= {t='static',	id=id+5,	xywh='s_timeplan_cap_tue_xywh',	text='LA_WEEK_TUESDAY'},
	t_tue 		= {t='tt_button',id=id+6,	xywh='s_timeplan_t_tue_xywh', 	align = b_ui.ALIGN.LEFT, cmd=on_select,
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_timeplan_s','it_timeplan_s', 'it_timeplan_s'},
				},
	cap_wed		= {t='static',	id=id+7,	xywh='s_timeplan_cap_wed_xywh',	text='LA_WEEK_WEDNESDAY'},
	t_wed 		= {t='tt_button',id=id+8,	xywh='s_timeplan_t_wed_xywh', 	align = b_ui.ALIGN.LEFT, cmd=on_select,
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_timeplan_s','it_timeplan_s', 'it_timeplan_s'},
				},
	cap_thu		= {t='static',	id=id+9,	xywh='s_timeplan_cap_thu_xywh',	text='LA_WEEK_THURSDAY'},
	t_thu 		= {t='tt_button',id=id+10,	xywh='s_timeplan_t_thu_xywh', 	align = b_ui.ALIGN.LEFT, cmd=on_select,
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_timeplan_s','it_timeplan_s', 'it_timeplan_s'},
				},
	cap_fri		= {t='static',	id=id+11,	xywh='s_timeplan_cap_fri_xywh',	text='LA_WEEK_FRIDAY'},
	t_fri 		= {t='tt_button',id=id+12,	xywh='s_timeplan_t_fri_xywh', 	align = b_ui.ALIGN.LEFT, cmd=on_select,
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_timeplan_s','it_timeplan_s', 'it_timeplan_s'},
				},
	cap_sat		= {t='static',	id=id+13,	xywh='s_timeplan_cap_sat_xywh',	text='LA_WEEK_SATURDAY'},
	t_sat 		= {t='tt_button',id=id+14,	xywh='s_timeplan_t_sat_xywh', 	align = b_ui.ALIGN.LEFT, cmd=on_select,
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_timeplan_s','it_timeplan_s', 'it_timeplan_s'},
				},		
	cap_all		= {t='static',	id=id+29,	xywh='s_timeplan_cap_all_xywh',	text='LA_ALL'},
	t_all		= {t='tt_button',id=id+15,	xywh='s_timeplan_t_all_xywh', 	align = b_ui.ALIGN.LEFT, cmd=on_select,
				color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_timeplan_s','it_timeplan_s', 'it_timeplan_s'},
				},
				
	t_h2		= {t='static',	id=id+16,	xywh='s_timeplan_t_h2_xywh',	text='2',	trans = false},	
	t_h4		= {t='static',	id=id+17,	xywh='s_timeplan_t_h4_xywh',	text='4',	trans = false},	
	t_h6		= {t='static',	id=id+18,	xywh='s_timeplan_t_h6_xywh',	text='6',	trans = false},	
	t_h8		= {t='static',	id=id+19,	xywh='s_timeplan_t_h8_xywh',	text='8',	trans = false},	
	t_h10		= {t='static',	id=id+20,	xywh='s_timeplan_t_h10_xywh',	text='10',	trans = false},	
	t_h12		= {t='static',	id=id+21,	xywh='s_timeplan_t_h12_xywh',	text='12',	trans = false},	
	t_h14		= {t='static',	id=id+22,	xywh='s_timeplan_t_h14_xywh',	text='14',	trans = false},	
	t_h16		= {t='static',	id=id+23,	xywh='s_timeplan_t_h16_xywh',	text='16',	trans = false},	
	t_h18		= {t='static',	id=id+24,	xywh='s_timeplan_t_h18_xywh',	text='18',	trans = false},	
	t_h20		= {t='static',	id=id+25,	xywh='s_timeplan_t_h20_xywh',	text='20',	trans = false},	
	t_h22		= {t='static',	id=id+26,	xywh='s_timeplan_t_h22_xywh',	text='22',	trans = false},	
	t_h24		= {t='static',	id=id+27,	xywh='s_timeplan_t_h24_xywh',	text='24',	trans = false},	
			
	policy 	= {t='timeplan',	id=id+28,	xywh='s_timeplan_policy_xywh',	text='policy widget',trans = false,
				color= {'c_image_bk', 'c_cfg_row_bk', 'c_txt_n'},cmd = on_update_param},
}

return w1_page_alarmintimeplan

