--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/6/7
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_alarmout.alarmout_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  	= require("wnd.w1_util.w1_ui_msg") 
local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local util 		= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")

local ro_num;
local channel_num;
local w1_page_alarmout = 
{
	data,
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_alarmout.s_768 =
{
	s_alarmout_t_enable_xywh = {277,67,25,21},
	s_alarmout_tipinfo_xywh = {58,586,160,28},
};

w1_page_alarmout.s_1280 = 
{
	s_alarmout_t_enable_xywh = {455,95,48,30};
	s_alarmout_tipinfo_xywh = {110,810,260,40};
}

w1_page_alarmout.s_1440 = 
{
	s_alarmout_t_enable_xywh = {520,82,48,30},
	s_alarmout_tipinfo_xywh = {110,693,300,30},
}


w1_page_alarmout.s_1080p = 
{
	s_alarmout_t_enable_xywh = {520,95,48,30};
	s_alarmout_tipinfo_xywh = {110,825,300,40};
}

w1_page_alarmout.s_2k = 
{
	s_alarmout_t_enable_xywh = {693,127,64,40},
	s_alarmout_tipinfo_xywh = {147,1100,390,53},

}
w1_page_alarmout.s_4k = 
{
	s_alarmout_t_enable_xywh = {1040,190,96,60},
	s_alarmout_tipinfo_xywh = {220,1650,600,80},
}


w1_page_alarmout.clear_data = function()
	w1_page_alarmout.data = nil;
end	

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	local c_wnd = w1_page_alarmout.wnd
	w1_page_alarmout.data = cfgdata
	local out_data = cfgdata.alarm_out
	local outnum = out_data.num
	local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_alarmout.id));
	local out_item = {}
	local idx = 1
	for i=1,outnum do
		if out_data['outid'..i]['src_id']==chid then
			idx = i
		end
	end
	b_wnd_ex.set_text(top,c_wnd.t_name.id,out_data['outid'..idx]['name'],false)
	b_wnd_ex.set_sel(top,c_wnd.t_signal.id,out_data['outid'..idx]['valid_level'],false)
	return 0;
end


local uidatacheck =function(top)
	return true, nil
end

w1_page_alarmout.timer_start = function()
	w1_page_alarmout.timestart = true
end

w1_page_alarmout.timer_stop = function(top)
	w1_page_alarmout.timestart = false
	w1_wnd_util.tipclear(top, w1_page_alarmout.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_alarmout.timerenevt = function(top)
	if(w1_page_alarmout.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_alarmout.wnd.tipinfo.id)
	end
	return 0
end
--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_alarmout.wnd
	local name = b_wnd_ex.get_text(top,cwnd.t_name.id);
	local outid = tonumber(b_wnd_ex.get_text(top,cwnd.t_alarmout.id))
	local signal = b_wnd_ex.get_sel(top,cwnd.t_signal.id)
	
	cfgdata['alarm_out']['outid'..outid]['name']=name;
	cfgdata['alarm_out']['outid'..outid]['valid_level']=signal;
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_alarmout.init = function(top)
	w1_wnd_util.cfgtab = {'alarm_out'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

local on_alarmout= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local c_wnd = w1_page_alarmout.wnd
		local out_data = w1_page_alarmout.data.alarm_out
		local outnum = out_data.num
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_alarmout.id));
		local out_item = {}
		local idx = 1
		for i=1,outnum do
			if out_data['outid'..i]['src_id']==chid then
				idx = i
			end
		end
		b_wnd_ex.set_text(top,c_wnd.t_name.id,out_data['outid'..idx]['name'],false)
		b_wnd_ex.set_sel(top,c_wnd.t_signal.id,out_data['outid'..idx]['valid_level'],false)
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end


w1_page_alarmout.on_data_change = function(top)
	if w1_row_alarmoutrow.get_checkidx(top)==0 then
		w1_page_alarmoutevent.on_channel_check(top);
	end
	
end

w1_page_alarmout.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_alarmout.on_pre_show = function(top)
	ro_num = global_val.get_ronum();
	channel_num = global_val.get_channelnum();
	local cwnd = w1_page_alarmout.wnd;
	local param={};
	for i=1,ro_num do
		param[i] = tostring(i);
	end
	b_wnd_ex.set_items(top, cwnd.t_alarmout.id, param, false);

end

w1_page_alarmout.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
			
	sub = {'cap_alarmout', 't_alarmout','cap_signal','t_signal',	
			 'cap_name', 't_name','cap_mode','t_mode',
			'tipinfo', 'apply'},
			
	cap_alarmout	= {t='static',	id=id+1,xywh='s_cfg_page_1_1',text='LA_NVR_DO_PORT'},
	t_alarmout 	= {t='combox',	id=id+2,xywh='s_cfg_page_1_2',items={},trans = false,cmd =on_alarmout,
					},	
	
	cap_name 	= {t='static',	id=id+3,xywh='s_cfg_page_2_1',text='LA_PORT_NAME'},
	t_name 		= {t='edit', 	id=id+4,xywh='s_cfg_page_2_2',guide_text='LA_NAME',cmd = on_update_param},
	
	cap_signal 	= {t='static',	id=id+5,xywh='s_cfg_page_3_1',text='LA_VALID_SIGNAL'},
	t_signal	= {t='combox', 	id=id+6,xywh='s_cfg_page_3_2',items={'LA_OPEN_T', 'LA_CLOSE_T'},cmd = on_update_param},
	
	cap_mode 	= {t='static',	id=id+7,xywh='s_cfg_page_4_1',text='LA_ALARM_OUT_MODE'},
	t_mode		= {t='combox', 	id=id+8,xywh='s_cfg_page_4_2',items={'LA_SWITCH_MODE'},cmd = on_update_param},
	
	tipinfo		= {t='static',id=id+9,	xywh='s_alarmout_tipinfo_xywh',	text='',trans = false},

	apply 	= {t='button',id=id+10,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_alarmout
