--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/6/7
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_alarmout.alarmout_c_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  	= require("wnd.w1_util.w1_ui_msg") 
local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local util 		= require("wnd.core.util")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local b_app_cfg  = require("wnd.core.b_app_cfg")
local b_app_api = require("wnd.core.command.b_app_api")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local r_color		= require("wnd.core.r_res.r_color")
local COLOR 		= r_color.get_color
local channel_num;
local w1_page_alarmout_c = 
{
	data,
	channel = 0,
	old_sel,
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_alarmout_c.s_768 =
{
	s_alarmout_c_t_enable_xywh = {277,152,25,21},
	s_alarmout_c_tipinfo_xywh = {58,586,373,28},
};

w1_page_alarmout_c.s_1280 = 
{
	s_alarmout_c_t_enable_xywh = {455,215,48,30};
	s_alarmout_c_tipinfo_xywh = {110,810,550,40};
}

w1_page_alarmout_c.s_1440 = 
{
	s_alarmout_c_t_enable_xywh = {520,182,48,30},
	s_alarmout_c_tipinfo_xywh = {110,693,600,30},
}


w1_page_alarmout_c.s_1080p = 
{
	s_alarmout_c_t_enable_xywh = {520,215,48,30};
	s_alarmout_c_tipinfo_xywh = {110,825,700,40};
}

w1_page_alarmout_c.s_2k = 
{
	s_alarmout_c_t_enable_xywh = {693,287,64,40},
	s_alarmout_c_tipinfo_xywh = {147,1100,900,53},

}
w1_page_alarmout_c.s_4k = 
{
	s_alarmout_c_t_enable_xywh = {1040,430,96,60},
	s_alarmout_c_tipinfo_xywh = {220,1650,1400,80},
}

w1_page_alarmout_c.clear_data = function()
	w1_page_alarmout_c.data = nil;
end	

local refresh_chdata = function(top, redraw)
	local c_wnd = w1_page_alarmout_c.wnd
	local info = w1_page_alarmout_c.data.ipc_alarm_out;
	local chn = b_wnd_ex.get_text(top,c_wnd.t_channel.id)
	local num = info['channel'..chn]['num']
	local out_id = b_wnd_ex.get_text(top,c_wnd.t_alarm_output.id)
	local name = info['channel'..chn]['out_info']['outid'..out_id]['name']
	local signal = info['channel'..chn]['out_info']['outid'..out_id]['signal']
	local time = info['channel'..chn]['out_info']['outid'..out_id]['time']
	local mode = info['channel'..chn]['out_info']['outid'..out_id]['mode']-1
	local hz = info['channel'..chn]['out_info']['outid'..out_id]['hz']
	b_wnd_ex.set_text(top,c_wnd.t_name.id,name,redraw)
	b_wnd_ex.set_sel(top,c_wnd.t_mode.id,mode,redraw)
	b_wnd_ex.set_sel(top,c_wnd.t_signal.id,signal,redraw)
	b_wnd_ex.set_value(top,c_wnd.t_alarm_out_time.id,time,redraw)
	b_wnd_ex.set_text(top,c_wnd.t_frequency.id,string.format("%.2f",tostring(hz)),redraw)
	local check = false;
	if mode==1 then
		check = false
		local pos = SIZE('s_cfg_page_6_1')
		b_wnd_ex.move_ex(top,c_wnd.cap_frequency.id,pos,false)
		 pos = SIZE('s_cfg_page_6_2')
		b_wnd_ex.move_ex(top,c_wnd.t_frequency.id,pos,false)
		pos = SIZE('s_cfg_page_7_1')
		b_wnd_ex.move_ex(top,c_wnd.cap_alarmout_time.id,pos,false)
		 pos = SIZE('s_cfg_page_7_2')
		b_wnd_ex.move_ex(top,c_wnd.t_alarm_out_time.id,pos,false)
	else
		local pos = SIZE('s_cfg_page_6_1')
		b_wnd_ex.move_ex(top,c_wnd.cap_alarmout_time.id,pos,false)
		 pos = SIZE('s_cfg_page_6_2')
		b_wnd_ex.move_ex(top,c_wnd.t_alarm_out_time.id,pos,false)
		check = true
	end
	b_wnd_ex.set_hide(top,c_wnd.cap_frequency.id,check,false)
	b_wnd_ex.set_hide(top,c_wnd.t_frequency.id,check,false)
end


--ˢUI
local cfgdatatoui = function(top, cfgdata)
	local c_wnd = w1_page_alarmout_c.wnd
	local idx = 1;
	local camreaitems = {};
	w1_page_alarmout_c.data = cfgdata
	w1_page_alarmout_c.old_sel = 1
	local channel = b_wnd_ex.get_text(top, c_wnd.t_channel.id);
	for i=1, channel_num do
		if cfgdata['ipc_alarm_out']['channel'..i] ~= nil then
			camreaitems[idx] = i;
			idx = idx + 1;
		end
	end
	b_wnd_ex.set_text(top,c_wnd.tipinfo.id,'',false);
	b_wnd_ex.set_items(top, c_wnd.t_channel.id, camreaitems, false);
	
	local s_id = c_wnd.cap_alarm_output.id;
	local e_id = c_wnd.t_frequency.id;
	if(idx ~= 1) then--˵ͨ
		for i=s_id,e_id do
			b_wnd_ex.set_hide(top,i,false,false)
		end
		for i=1,#camreaitems do
			if tonumber(channel) == camreaitems[i] then
				w1_page_alarmout_c.old_sel = i;
			end
		end
		b_wnd_ex.set_sel(top,c_wnd.t_channel.id,w1_page_alarmout_c.old_sel-1,false )
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id,false, false)
		local outid = cfgdata['ipc_alarm_out']['channel'..camreaitems[w1_page_alarmout_c.old_sel]]['num']
		local t_outid = {}
		for i=1,outid do
			t_outid[i]=i;
		end
		b_wnd_ex.set_items(top, c_wnd.t_alarm_output.id, t_outid, false);
		refresh_chdata(top,false)
	else
		for i=s_id,e_id do
			b_wnd_ex.set_hide(top,i,true,false)
		end
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id,true, false)
	end
	return 0;
end


local uidatacheck =function(top)
	local cwnd=w1_page_alarmout_c.wnd
	local nlegalid = {}
	local name = b_wnd_ex.get_text(top,cwnd.t_name.id);
	local special = {'>','<','\\','/','&','"',';',',','=','|','+',"'",'%%'};
	for i=1,#special do
		local ret = string.find(name,special[i]);
		if ret~=nil then
			w1_wnd_util.setparamerr_str(STR('LA_ROI_NOT_SUPPORT'));
			table.insert(nlegalid, cwnd.t_name.id);
			return false,nlegalid;
		end
	end
	return true, nil
end

w1_page_alarmout_c.timer_start = function()
	w1_page_alarmout_c.timestart = true
end

w1_page_alarmout_c.timer_stop = function(top)
	w1_page_alarmout_c.timestart = false
	w1_wnd_util.tipclear(top, w1_page_alarmout_c.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_alarmout_c.timerenevt = function(top)
	if(w1_page_alarmout_c.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_alarmout_c.wnd.tipinfo.id)
	end
	return 0
end
--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_alarmout_c.wnd
	local mode = b_wnd_ex.get_sel(top,cwnd.t_mode.id)+1;
	local name = b_wnd_ex.get_text(top,cwnd.t_name.id)
	local signal = b_wnd_ex.get_sel(top,cwnd.t_signal.id)
	local time = b_wnd_ex.get_value(top,cwnd.t_alarm_out_time.id)
	local hz = b_wnd_ex.get_text(top,cwnd.t_frequency.id)
	local chn = b_wnd_ex.get_text(top,cwnd.t_channel.id)
	local outid = b_wnd_ex.get_text(top,cwnd.t_alarm_output.id)
	
	cfgdata['ipc_alarm_out']['channel'..chn]['out_info']['outid'..outid]['name']=name
	cfgdata['ipc_alarm_out']['channel'..chn]['out_info']['outid'..outid]['signal']=signal
	cfgdata['ipc_alarm_out']['channel'..chn]['out_info']['outid'..outid]['time']=time
	cfgdata['ipc_alarm_out']['channel'..chn]['out_info']['outid'..outid]['hz']=hz
	cfgdata['ipc_alarm_out']['channel'..chn]['out_info']['outid'..outid]['mode']=mode
	for i=1, channel_num do
		if cfgdata['ipc_alarm_out']['channel'..i] ~= nil then
			cfgdata['ipc_alarm_out']['channel'..i]['change_chn']= tonumber(chn)	
		end
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_alarmout_c.init = function(top)
	w1_wnd_util.cfgtab = {'ipc_alarm_out'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	w1_page_alarmout_c.old_sel = 1; --Ĭ϶1ʼ 
	return 0
end

local on_channel = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local c_wnd = w1_page_alarmout_c.wnd
		local chn = b_wnd_ex.get_text(top,c_wnd.t_channel.id)
		w1_wnd_util.cfgtab = {'ipc_alarm_out'}
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_init(top)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_alarmout_c_input= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		refresh_chdata(top,false)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg or b_ui.WM_USER_UPDATE_PARAM == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

--[[
local on_name =  function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end--]]
local on_type = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local c_wnd = w1_page_alarmout_c.wnd
		local check = b_wnd_ex.get_sel(top,c_wnd.t_mode.id)
		if check==1 then
			check = false
			local pos = SIZE('s_cfg_page_6_1')
			b_wnd_ex.move_ex(top,c_wnd.cap_frequency.id,pos,false)
			 pos = SIZE('s_cfg_page_6_2')
			b_wnd_ex.move_ex(top,c_wnd.t_frequency.id,pos,false)
			pos = SIZE('s_cfg_page_7_1')
			b_wnd_ex.move_ex(top,c_wnd.cap_alarmout_time.id,pos,false)
			 pos = SIZE('s_cfg_page_7_2')
			b_wnd_ex.move_ex(top,c_wnd.t_alarm_out_time.id,pos,false)
		else
			local pos = SIZE('s_cfg_page_6_1')
			b_wnd_ex.move_ex(top,c_wnd.cap_alarmout_time.id,pos,false)
			 pos = SIZE('s_cfg_page_6_2')
			b_wnd_ex.move_ex(top,c_wnd.t_alarm_out_time.id,pos,false)
			check = true
		end
		b_wnd_ex.set_hide(top,c_wnd.cap_frequency.id,check,false)
		b_wnd_ex.set_hide(top,c_wnd.t_frequency.id,check,false)
		
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end


local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_alarmout_c.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_alarmout_c.on_pre_show = function(top)
	channel_num = global_val.get_channelnum();
--[[	local cwnd = w1_page_alarmout_c.wnd;
	local con_id = cwnd.con_alarmout_c.id;
	w1_page_alarmout_cevent.on_pre_show(top,channel_num);
	b_wnd_ex.set_show_page(top,con_id, cwnd.alarmout_cevent_wnd.id, false);
	w1_row_alarmout_crow.changecheck(top, w1_row_alarmout_crow.wnd, w1_id.cfg_alarmin.alarmout_crow_id + 1, false)--]]
end

w1_page_alarmout_c.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
			
	sub = {'cap_channel', 't_channel','cap_alarm_output','t_alarm_output','cap_name','t_name',
			'cap_signal', 't_signal', 'cap_mode','t_mode','cap_alarmout_time','cap_frequency','t_frequency',
			't_alarm_out_time',
			'tipinfo', 'apply'},
			
	cap_channel	= {t='static',	id=id+1,xywh='s_cfg_page_1_1',text='LA_CHANNEL'},
	t_channel 	= {t='combox',	id=id+2,xywh='s_cfg_page_1_2',items={},trans = false,channel_cbox = true,cmd =on_channel,},	
	cap_alarm_output	= {t='static',	id=id+3,xywh='s_cfg_page_2_1',text='LA_NVR_DO_PORT'},
	t_alarm_output	= {t='combox',	id=id+4,xywh='s_cfg_page_2_2',items={},cmd =on_alarmout_c_input},
	
	cap_name 	= {t='static',	id=id+5,xywh='s_cfg_page_3_1',text='LA_PORT_NAME'},
	t_name 		= {t='edit', 	id=id+6,xywh='s_cfg_page_3_2',guide_text='LA_NAME',cmd = on_update_param},
	
	cap_signal 	= {t='static',	id=id+7,xywh='s_cfg_page_4_1',text='LA_VALID_SIGNAL'},
	t_signal		= {t='combox', 	id=id+8,xywh='s_cfg_page_4_2',items={'LA_OPEN_T', 'LA_CLOSE_T'},cmd = on_update_param},
	
	cap_alarmout_time= {t='static',	id=id+9,	xywh='s_cfg_page_7_1',text='LA_ALARMOUT_TIME_MS', align = b_ui.ALIGN.LEFT},	
	t_alarm_out_time = {t='edit_num',id=id+10,xywh='s_cfg_page_7_2',range={0,999999},cmd = on_update_param},
	
	cap_mode 	= {t='static',	id=id+11,xywh='s_cfg_page_5_1',text='LA_ALARM_OUT_MODE'},
	t_mode		= {t='combox', 	id=id+12,xywh='s_cfg_page_5_2',items={'LA_SWITCH_MODE', 'LA_PULSE_MODE'},cmd = on_type},
	
	cap_frequency= {t='static',	id=id+13,	xywh='s_cfg_page_6_1',text='LA_FREQUENCY', align = b_ui.ALIGN.LEFT},	
	t_frequency = {t='edit_num',id=id+14,xywh='s_cfg_page_6_2',negative_num_attr={true,6,2},decimal_interval={true,0.01,999999},cmd = on_update_param},
		
	tipinfo		= {t='static',id=id+15,	xywh='s_alarmout_c_tipinfo_xywh',	text='',trans = false},

	apply 	= {t='button',id=id+16,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_alarmout_c
