--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 	= require("wnd.core.b_ui")
local w1_id = require("wnd.w1_util.w1_id")
local id 	= w1_id.cfg_channel_type.coaxial_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_dlg 	= require("wnd.core.b_dlg")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local b_app_cfg  = require("wnd.core.b_app_cfg")

local w1_page_analog_audio_in = 
{
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_analog_audio_in.s_768 =
{
	s_analog_audio_tipinfo_xywh = {53,277,373,35},
};

w1_page_analog_audio_in.s_1280 = 
{
	s_analog_audio_tipinfo_xywh = {100,390,700,50},
}

w1_page_analog_audio_in.s_1440 = 
{
	s_analog_audio_tipinfo_xywh = {100,390,700,50},
}

w1_page_analog_audio_in.s_1080p = 
{
	s_analog_audio_tipinfo_xywh = {100,390,700,50},
}

w1_page_analog_audio_in.s_2k = 
{
	s_analog_audio_tipinfo_xywh = {133,521,933,67},
}

w1_page_analog_audio_in.s_4k = 
{
	s_analog_audio_tipinfo_xywh = {200,780,1400,100},
}

local redraw =false;

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local cwnd = w1_page_analog_audio_in.wnd
	w1_page_analog_audio_in.data = cfgdata.analog_audio_in;
	local data = w1_page_analog_audio_in.data;
	b_wnd_ex.set_sel(top, cwnd.t_coaxial.id, data.type, false)	

	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_analog_audio_in.wnd
	local data = cfgdata.analog_audio_in;
	data.type = b_wnd_ex.get_sel(top, cwnd.t_coaxial.id);
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cwnd = w1_page_analog_audio_in.wnd
		local data = w1_page_analog_audio_in.data;
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top)
	end
	
	return 0;
end


local returndatacheck =function(top, ret)
	return true, nil;
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	
	return legalflag, nil;
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.returndatacheckfunc = returndatacheck;
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_analog_audio_in.timer_start = function()
	w1_page_analog_audio_in.timestart = true
end

w1_page_analog_audio_in.timer_stop = function(top)
	w1_page_analog_audio_in.timestart = false
	w1_wnd_util.tipclear(top, w1_page_analog_audio_in.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_analog_audio_in.timerenevt = function(top)
	if(w1_page_analog_audio_in.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_analog_audio_in.wnd.tipinfo.id)
	end
	return 0
end

w1_page_analog_audio_in.clear_data = function(top)
	w1_page_analog_audio_in.data = nil;
end

--ҳʼʱٶȡҳҪ
w1_page_analog_audio_in.init = function(top)
	w1_wnd_util.cfgtab = {'analog_audio_in'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

w1_page_analog_audio_in.apply =function(top)
	w1_wnd_util.uidatacheckfunc = uidatacheck
	w1_wnd_util.returndatacheckfunc = returndatacheck;
	local ret = w1_wnd_util.page_onapply(top);
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	w1_wnd_util.returndatacheckfunc = nil;	
	return ret;	
end

w1_page_analog_audio_in.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_coaxial', 't_coaxial', 'tipinfo', 'apply' },
	
	cap_coaxial 	= {t='static',	id=id+1,xywh='s_cfg_page_1_1',		text='LA_COAXIAL'},
	t_coaxial 		= {t='combox',	id=id+2,xywh='s_cfg_page_1_2',items={'LA_LINE_IN', 'LA_COAXIAL_INPUT'},cmd =on_update_param},	
	
	tipinfo		= {t='static',	id=id+3,	xywh='s_analog_audio_tipinfo_xywh',	text='',trans = false},
	apply 		= {t='button',	id=id+4,	xywh='s_cfg_apply_xywh',text='LA_APPLY',cmd=on_apply},
}

return w1_page_analog_audio_in



