--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 	= require("wnd.core.b_ui")
local w1_id = require("wnd.w1_util.w1_id")
local id 	= w1_id.cfg_app.app_id
local w1_oem = require("wnd.w1_util.w1_oem")

local t_qr_ios = w1_oem.t_qr_ios;				-- [QR code]iosά
local t_qr_android = w1_oem.t_qr_android;		-- [QR code]Androidά

local w1_page_app = 
{
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_app.s_1280 = 
{
	s_app_qr_ios_xywh = {150,150, 200, 200},
	s_app_t_ios_xywh = {150,380,200,40},
	s_app_qr_android_xywh = {500,150, 200, 200},
	s_app_t_android_xywh = {500,380,200,40},
}

w1_page_app.s_1440 = 
{
	s_app_qr_ios_xywh = {150,150, 200, 200},
	s_app_t_ios_xywh = {150,380,200,40},
	s_app_qr_android_xywh = {600,150, 200, 200},
	s_app_t_android_xywh = {600,380,200,40},
}

w1_page_app.s_1080p = 
{
	s_app_qr_ios_xywh = {200,150, 200, 200},
	s_app_t_ios_xywh = {200,380,200,40},
	s_app_qr_android_xywh = {700,150, 200, 200},
	s_app_t_android_xywh = {700,380,200,40},
}

w1_page_app.s_2k = 
{
	s_app_qr_ios_xywh = {267,200,267,267},
	s_app_t_ios_xywh = {267,507,267,53},
	s_app_qr_android_xywh = {933,200,267,267},
	s_app_t_android_xywh = {933,507,267,53},

}

w1_page_app.s_4k = 
{
	s_app_qr_ios_xywh = {400,300,400,400},
	s_app_t_ios_xywh = {400,760,400,80},
	s_app_qr_android_xywh = {1400,300,400,400},
	s_app_t_android_xywh = {1400,760,400,80},
}

w1_page_app.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {	'qr_ios', 't_ios', 'qr_android', 't_android',
			'default', 'apply' },
		
	qr_ios 		= {t='qr_code',	id=id+1,xywh='s_app_qr_ios_xywh',	text=t_qr_ios,	trans = false},
	t_ios 		= {t='static',	id=id+2,xywh='s_app_t_ios_xywh',		text='iOS',		trans = false,	align = b_ui.ALIGN.CENTER},
	
	qr_android 	= {t='qr_code',	id=id+3,xywh='s_app_qr_android_xywh',	text=t_qr_android,	trans = false},
	t_android 	= {t='static',	id=id+4,xywh='s_app_t_android_xywh',		text='Android',	trans = false,align = b_ui.ALIGN.CENTER},

	default = {t='button',	id=id+5,	xywh='s_cfg_default_xywh',		text='LA_DEFAULT',cmd=on_default,	hide = true},
	apply 	= {t='button',	id=id+6,	xywh='s_cfg_apply_xywh', 		text='LA_APPLY',cmd=on_apply,		hide = true},
}

return w1_page_app



