--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/6/7
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_alarmout.audio_out_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  	= require("wnd.w1_util.w1_ui_msg") 
local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local util 		= require("wnd.core.util")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local b_app_cfg  = require("wnd.core.b_app_cfg")
local b_app_api = require("wnd.core.command.b_app_api")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local r_color		= require("wnd.core.r_res.r_color")
local COLOR 		= r_color.get_color
local channel_num;
local w1_page_audio_out = 
{
	data,
	channel = 0,
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_audio_out.s_768 = 
{
	s_audio_out_list = {53,21,709,213},
	s_audio_out_list_w1 = {64,0,0,0},
	s_audio_out_list_w2 = {266,0,0,0},
	s_audio_out_list_w3 = {160,0,0,0},
	s_audio_out_list_w4 = {101,0,0,0},
	s_audio_out_list_w5 = {101,0,0,0},
	s_audio_out_tipinfo_xywh = {53,497,533,35},
}

w1_page_audio_out.s_1280 = 
{
	s_audio_out_list		= {100, 30, 830, 300},
	s_audio_out_list_w1		= {60, 0, 0, 0},	
	s_audio_out_list_w2		= {300, 0, 0, 0},	
	s_audio_out_list_w3		= {200, 0, 0, 0},	
	s_audio_out_list_w4		= {120, 0, 0, 0},	
	s_audio_out_list_w5		= {120, 0, 0, 0},	
	s_audio_out_tipinfo_xywh = {100,810,550,50};
}

w1_page_audio_out.s_1440 = 
{
	s_audio_out_list		= {100, 30, 940, 300},
	s_audio_out_list_w1		= {100, 0, 0, 0},	
	s_audio_out_list_w2		= {350, 0, 0, 0},	
	s_audio_out_list_w3		= {220, 0, 0, 0},	
	s_audio_out_list_w4		= {120, 0, 0, 0},	
	s_audio_out_list_w5		= {120, 0, 0, 0},	
	s_audio_out_tipinfo_xywh = {100,693,600,50},
}

w1_page_audio_out.s_1080p = 
{
	s_audio_out_list		= {100, 30, 1330, 300},
	s_audio_out_list_w1		= {120, 0, 0, 0},	
	s_audio_out_list_w2		= {500, 0, 0, 0},	
	s_audio_out_list_w3		= {300, 0, 0, 0},	
	s_audio_out_list_w4		= {190, 0, 0, 0},	
	s_audio_out_list_w5		= {190, 0, 0, 0},	
	s_audio_out_tipinfo_xywh = {100,700,1000,50},
}

w1_page_audio_out.s_2k = 
{
	s_audio_out_list = {133,39,1772,400},
	s_audio_out_list_w1 = {159,0,0,0},
	s_audio_out_list_w2 = {666,0,0,0},
	s_audio_out_list_w3 = {399,0,0,0},
	s_audio_out_list_w4 = {253,0,0,0},
	s_audio_out_list_w5 = {253,0,0,0},
	s_audio_out_tipinfo_xywh = {133,933,1333,67},
}

w1_page_audio_out.s_4k = 
{
	s_audio_out_list = {200,60,2660,600},
	s_audio_out_list_w1 = {240,0,0,0},
	s_audio_out_list_w2 = {1000,0,0,0},
	s_audio_out_list_w3 = {600,0,0,0},
	s_audio_out_list_w4 = {380,0,0,0},
	s_audio_out_list_w5 = {380,0,0,0},
	s_audio_out_tipinfo_xywh = {200,1400,2000,100},
}

w1_page_audio_out.clear_data = function()
	w1_page_audio_out.data = nil;
end	

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	w1_page_audio_out.data = cfgdata;

	local sound_list = {};
	for i = 1, 6 do
		sound_list['idx'..i] = {i-1, false, i - 1, 'Test sound' .. i, tostring(i), '', ''};
	end
	sound_list.item_total = 6;
	b_wnd_ex.set_listdata(top, w1_page_audio_out.wnd.sound_list.id, sound_list, false);

	return 0;
end

local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_audio_out.wnd;
	local data = b_wnd_ex.get_listdata(top, cwnd.sound_list.id);
	return 0	
end

w1_page_audio_out.on_data_change = function(top)
	uitousercfg(top, w1_page_audio_out.data);
end	

--
w1_page_audio_out.on_clicked_audition = function(top, x, y)
	local cwnd = w1_page_audio_out.wnd;
	local idx = b_wnd_ex.get_list_idx(top, cwnd.sound_list.id, x ,y);
	
end	

--ϴ
w1_page_audio_out.on_clicked_export = function(top, x, y)
	local cwnd = w1_page_audio_out.wnd;
	local fileName = nil;
	b_app_api.mount_dev();
	local inputPath = b_dlg.do_modal(top, w1_key.DLG_UPGRADEDECTORY, 0, 0, 1)
	if (nil ~= inputPath and '' ~= inputPath) then
		local paramdata = cjson.decode(inputPath);
		fileName = paramdata.path
	end	
	b_app_api.unmount_dev();
end	

w1_page_audio_out.timer_start = function()
	w1_page_audio_out.timestart = true
end

w1_page_audio_out.timer_stop = function(top)
	w1_page_audio_out.timestart = false
	w1_wnd_util.tipclear(top, w1_page_audio_out.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_audio_out.timerenevt = function(top)
	if(w1_page_audio_out.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_audio_out.wnd.tipinfo.id)
	end
	return 0
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg or b_ui_msg.msg_time_update == vmsg or b_ui_msg.msg_user_update_parent == vmsg) then
		uitousercfg(top,w1_page_audio_out.data)
	end

	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_audio_out.init = function(top)
	w1_wnd_util.cfgtab = {'sound_dec_alarm'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

w1_page_audio_out.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_audio_out.on_pre_show = function(top)
	local cwnd = w1_page_audio_out.wnd;
	local param = {
		STR('LA_ID'), STR('LA_FILE_NAME'),STR('LA_CYCLES'),STR('LA_AUDITION'),STR('LA_OPERATE')
	}
	b_wnd_ex.set_title_texts(top, cwnd.sound_list.id, param, false);
	
	local list_w = {};
	for i=1,5 do
		local str = 's_audio_out_list_w'..math.floor(i/1);
		list_w[i] = SIZE(str)[1];
	end
	b_wnd_ex.columns_w(top, cwnd.sound_list.id, list_w, false);
	
	return 0;
end

w1_page_audio_out.wnd = 
{
	t='wnd_bg', id=id, xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
			
	sub = {'sound_list', 'tipinfo', 'apply'},

	sound_list = {t='list_sound',	id=id+1,	xywh= 's_audio_out_list', font = 'f_grade4',
		listattr = {6,5,b_ui.LISTATTR.FIRST_WIDGET_STATIC, 0},
		title_texts = {'LA_ID', 'LA_FILE_NAME', 'LA_CYCLES', 'LA_AUDITION', 'LA_OPERATE'},
		columns_w = {150, 500, 300, 190,190}},			

	tipinfo		= {t='static',id=id+2,	xywh='s_audio_out_tipinfo_xywh',	text='',trans = false},

	apply 	= {t='button',id=id+3,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_audio_out
