--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_dlg = require("wnd.core.b_dlg")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_auxiliary.cfg_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local util 		= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local b_app_api = require("wnd.core.command.b_app_api")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local screen_id = 1; --id

local w1_page_auxiliary_cfg = 
{
	data;
	ori_cfg = nil;
	valid_layout_list = nil;
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_auxiliary_cfg.s_768 =
{
	s_aux_cfg_t_enable_xywh = {277,24,25,21},
	s_aux_cfg_t_dwell_enable_xywh = {277,234,25,21},
	s_aux_cfg_disable_tip_xywh = {53,106,650,35}, --豸4Kʱֹʾ
	s_aux_cfg_reboot_tip_xywh = {53, 285, 650, 35}, --豸/رոҪʾ
	s_axu_cfg_tipinfo_xywh = {53,321,373,35},
};

w1_page_auxiliary_cfg.s_1280 = 
{
	s_aux_cfg_t_enable_xywh = {450,35,48,30},
	s_aux_cfg_t_dwell_enable_xywh = {450,330,48,30},
	s_aux_cfg_disable_tip_xywh = {95,150,925,50}, --豸4Kʱֹʾ
	s_aux_cfg_reboot_tip_xywh = {95, 380, 925, 50}, --豸/رոҪʾ
	s_axu_cfg_tipinfo_xywh = {95,430,700,50},
}

w1_page_auxiliary_cfg.s_1440 = 
{
	s_aux_cfg_t_enable_xywh = {520,35,48,30},
	s_aux_cfg_t_dwell_enable_xywh = {520,275,48,30},
	s_aux_cfg_disable_tip_xywh = {100,125,1000,50}, --豸4Kʱֹʾ
	s_aux_cfg_reboot_tip_xywh = {100, 350, 1000, 50}, --豸/رոҪʾ
	s_axu_cfg_tipinfo_xywh = {100,410,700,50},
}

w1_page_auxiliary_cfg.s_1080p = 
{
	s_aux_cfg_t_enable_xywh = {520,35,48,30},
	s_aux_cfg_t_dwell_enable_xywh = {520,330,48,30},
	s_aux_cfg_disable_tip_xywh = {100,150,1300,50}, --豸4Kʱֹʾ
	s_aux_cfg_reboot_tip_xywh = {100, 380, 1300, 50}, --豸/رոҪʾ
	s_axu_cfg_tipinfo_xywh = {100,430,700,50},
}

w1_page_auxiliary_cfg.s_2k = 
{
	s_aux_cfg_t_enable_xywh = {693,47,64,40},
	s_aux_cfg_t_dwell_enable_xywh = {693,440,64,40},
	s_aux_cfg_disable_tip_xywh = {133,200,1600,67}, --豸4Kʱֹʾ
	s_aux_cfg_reboot_tip_xywh = {133, 493, 1600, 67}, --豸/رոҪʾ
	s_axu_cfg_tipinfo_xywh = {133,560,933,67},

}

w1_page_auxiliary_cfg.s_4k = 
{
	s_aux_cfg_t_enable_xywh = {1040,70,96,60},
	s_aux_cfg_t_dwell_enable_xywh = {1040,660,96,60},
	s_aux_cfg_disable_tip_xywh = {200,300,2600,100}, --豸4Kʱֹʾ
	s_aux_cfg_reboot_tip_xywh = {200, 760, 2600, 100}, --豸/رոҪʾ
	s_axu_cfg_tipinfo_xywh = {200,860,1400,100},

}

w1_page_auxiliary_cfg.clear_data = function()
	w1_page_auxiliary_cfg.data = nil;
	w1_page_auxiliary_cfg.ori_cfg = nil;
	w1_page_auxiliary_cfg.valid_layout_list = nil;
end	

--10תΪ2
local DecToStrBin = function(value)
	if(tonumber(value) > 1023) then
		return ;
	end
	local bintemp = {};
	local multiple = 1;
	local num = math.abs(value);
	while num > 0 do
		local decimal = num % 2;
		num = math.floor(num / 2);
		bintemp[multiple] = decimal;
		multiple = multiple + 1;
	end
	for i = 1, 10 do
		if(bintemp[i] == nil) then
			bintemp[i] = 0;
		end
	end
	return bintemp;
end

local set_vo_items = function(top, vo_supper, vo)
	local cwnd = w1_page_auxiliary_cfg.wnd;
	
	local VO_SUPPORT_SXGA = 1;
	local VO_SUPPORT_WXGA = 2;
	local VO_SUPPORT_1080P = 3;
	local VO_SUPPORT_2K = 4;
	local VO_SUPPORT_4K = 5; 
	local VO_SUPPORT_XGA = 6; 
			
	local vo_supporttable = {};	
	vo_supporttable = DecToStrBin(vo_supper);
	
	local nameitems = {};

	if(vo_supporttable[VO_SUPPORT_XGA] == 1 ) then
		table.insert(nameitems, '1024x768');
	end
	
	if(vo_supporttable[VO_SUPPORT_SXGA] == 1 ) then
		table.insert(nameitems, '1280x1024');
	end
	if(vo_supporttable[VO_SUPPORT_WXGA] == 1 ) then
		table.insert(nameitems, '1440x900');
	end
	if(vo_supporttable[VO_SUPPORT_1080P] == 1 ) then
		table.insert(nameitems, '1920x1080');
	end
	if(vo_supporttable[VO_SUPPORT_2K] == 1 ) then
		table.insert(nameitems, '2560x1440');
	end
	if(vo_supporttable[VO_SUPPORT_4K] == 1 ) then
		table.insert(nameitems, '3840x2160');
	end
	
	local cur_voname;
	if(0 == vo) then
		cur_voname = '1024x768';
	elseif(2 == vo ) then
		cur_voname = '1280x1024';
	elseif(3 == vo ) then
		cur_voname = '1440x900';
	elseif(4 == vo ) then
		cur_voname = '1920x1080';
	elseif(8 == vo ) then
		cur_voname = '2560x1440';
	elseif(7 == vo ) then
		cur_voname = '3840x2160';
	else
		assert(false);
	end
	
	b_wnd_ex.set_items(top, cwnd.t_auxiliary_vo.id, nameitems, false);	
	for i = 1, #nameitems do
		if(cur_voname == nameitems[i]) then
			b_wnd_ex.set_sel(top, cwnd.t_auxiliary_vo.id, i - 1, false);
			break;
		end
	end
end

local set_dec_ability_items = function(top, layout_mode)
	local cwnd = w1_page_auxiliary_cfg.wnd;
	local main_screen_total_chn = w1_page_auxiliary_cfg.total_disp_num / 2;
	local auxi_total_channel = w1_page_auxiliary_cfg.total_disp_num / 2;

	local nameitems = {};
	local item_1 = tostring(math.floor(main_screen_total_chn)) .. "+" .. tostring(math.floor(auxi_total_channel))	
	table.insert(nameitems, item_1);	
--[[	
	main_screen_total_chn = 1;
	auxi_total_channel = w1_page_auxiliary_cfg.total_disp_num  - 1;
	local item_2 = tostring(math.floor(main_screen_total_chn)) .. "+" .. tostring(math.floor(auxi_total_channel))	
	table.insert(nameitems, item_2);
	
	main_screen_total_chn = w1_page_auxiliary_cfg.total_disp_num  - 1;
	auxi_total_channel = 1;
	local item_3 = tostring(math.floor(main_screen_total_chn)) .. "+" .. tostring(math.floor(auxi_total_channel))	
	table.insert(nameitems, item_3);
--]]	
	b_wnd_ex.set_items(top, cwnd.t_decode_num.id, nameitems, false);	
	b_wnd_ex.set_sel(top, cwnd.t_decode_num.id, layout_mode, false);
end
	
local check_valid = function(top, layout_info)	
	local cwnd = w1_page_auxiliary_cfg.wnd;
	local valid_channel =  w1_page_auxiliary_cfg.total_disp_num;
	local dec_mode_sel = b_wnd_ex.get_sel(top, cwnd.t_decode_num.id)
	if (0 == dec_mode_sel) then
		valid_channel = w1_page_auxiliary_cfg.total_disp_num / 2;
	elseif(1 == dec_mode_sel) then
		valid_channel = w1_page_auxiliary_cfg.total_disp_num - 1;
	elseif(2 == dec_mode_sel) then	
		valid_channel = 1;
	end

	local win_num  = layout_info.win_num
	if (win_num > valid_channel) then --ǰֳ	
		return false;
	else
		return true;
	end
	
end
	
local set_layout_mode_items = function(top, layout_name)
	local cwnd = w1_page_auxiliary_cfg.wnd;
	local valid_layout = {};	
	local data = w1_page_auxiliary_cfg.data.layout_list;
	local nameitems = {};

	for i = 1, #data do
		if (check_valid(top, data[i])) then
			local layout = {};
			util.copy_tab_b(layout, data[i]);
			table.insert(valid_layout, layout);		
			table.insert(nameitems, data[i].name);
		end
	end
	
	if (w1_page_auxiliary_cfg.valid_layout_list == nil) then
		w1_page_auxiliary_cfg.valid_layout_list = valid_layout;
	else
		util.copy_tab_b(w1_page_auxiliary_cfg.valid_layout_list, valid_layout);
	end
	
	b_wnd_ex.set_items(top, cwnd.t_layout_mode.id, nameitems, false);	
	b_wnd_ex.set_sel(top, cwnd.t_layout_mode.id, 0, false);
	for i = 1, #nameitems do
		if (layout_name == nameitems[i]) then
			b_wnd_ex.set_sel(top, cwnd.t_layout_mode.id, i - 1, false);
		end	
	end	
end

local set_show_pape_items = function(top, page)
	local cwnd = w1_page_auxiliary_cfg.wnd;
	local sel = b_wnd_ex.get_sel(top, cwnd.t_layout_mode.id) 	
	local layout_info = w1_page_auxiliary_cfg.valid_layout_list[sel + 1];	
	local total_page = 	layout_info.total_page;
	local nameitems = {};
	for i = 1, total_page do
		table.insert(nameitems, tostring(i));
	end
	
	b_wnd_ex.set_items(top, cwnd.t_show_page.id, nameitems, false);	
	b_wnd_ex.set_sel(top, cwnd.t_show_page.id, page, false);
end
	
local get_vo_size = function(top)
	local cwnd = w1_page_auxiliary_cfg.wnd;
	local votext = b_wnd_ex.get_text(top, cwnd.t_auxiliary_vo.id);
	if(votext == '1280x1024') then
		return 2;
	elseif(votext == '1440x900') then
		return 3;
	elseif(votext == '1920x1080') then
		return 4;
	elseif(votext == '2560x1440') then
		return 8;
	elseif(votext == '3840x2160') then
		return 7;
	elseif(votext == '1024x768') then
		return 0;		
	else
		assert(false);
	end
end	

local refresh_enable = function(top, hide, redraw)
	local cwnd = w1_page_auxiliary_cfg.wnd
	b_wnd_ex.set_hide(top, cwnd.cap_auxiliary_vo.id, hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_auxiliary_vo.id, hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.cap_decode_num.id, hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_decode_num.id, hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.cap_dwell_enable.id, hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_dwell_enable.id, hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.cap_layout_mode.id, hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_layout_mode.id, hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.cap_show_page.id, hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_show_page.id, hide, redraw)
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local cwnd = w1_page_auxiliary_cfg.wnd
	w1_page_auxiliary_cfg.data = cfgdata.cfg_auxiliary;
	local data = cfgdata.cfg_auxiliary
	b_wnd_ex.set_check(top, cwnd.t_enable.id, data.enable, false)	
	b_wnd_ex.set_check(top, cwnd.t_dwell_enable.id, data.enable_poll, false)	
	local ret = b_app_api.get_only_4k_or_auxiliary(); 
	local reboot_flag = b_app_api.get_is_auxiliary_restart();
	if (reboot_flag == true) then
		b_wnd_ex.set_hide(top, cwnd.reboot_tip.id, false, false);
	else
		b_wnd_ex.set_hide(top, cwnd.reboot_tip.id, true, false);
	end
	
	set_vo_items(top, w1_page_auxiliary_cfg.vo_support, data.resolution);
	set_dec_ability_items(top, data.layout_mode);
	local layout_info = data.layout_list[data.curr_id + 1];		
	set_layout_mode_items(top, layout_info.name);
	set_show_pape_items(top, layout_info.page);		
	if(data.enable) then
		b_wnd_ex.set_hide(top, cwnd.disable_tip.id, true, false)
		b_wnd_ex.set_disable(top, cwnd.t_enable.id, false, false); 
		refresh_enable(top, false, false)
	else
		local device = cfgdata.device;
		if (ret == true and device.vo == 7) then --жϵǰ豸ǷΪ豸ҵǰֱǷΪ4K	
			b_wnd_ex.set_hide(top, cwnd.disable_tip.id, false, false);
			b_wnd_ex.set_disable(top, cwnd.t_enable.id, true, false); --û
		else	
			b_wnd_ex.set_hide(top, cwnd.disable_tip.id, true, false)
			b_wnd_ex.set_disable(top, cwnd.t_enable.id, false, false);
		end
		refresh_enable(top, true, false)
	end
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_auxiliary_cfg.wnd
	local data = cfgdata.cfg_auxiliary
	local enable = b_wnd_ex.get_check(top, cwnd.t_enable.id)
	local enable_poll = b_wnd_ex.get_check(top, cwnd.t_dwell_enable.id)
	local vo = get_vo_size(top)
	local layout_mode = b_wnd_ex.get_sel(top, cwnd.t_decode_num.id)
	local sel_layout = b_wnd_ex.get_sel(top, cwnd.t_layout_mode.id)	
	local page = b_wnd_ex.get_sel(top, cwnd.t_show_page.id)	
	data.enable = enable;
	data.resolution = vo;
	data.layout_mode = layout_mode;
	data.enable_poll = enable_poll;
	data.curr_id = w1_page_auxiliary_cfg.valid_layout_list[sel_layout + 1].id;
	data.layout_list[data.curr_id+1].page = page
end

local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	local c_wnd = w1_page_auxiliary_cfg.wnd

	if(legalflag) then
		return legalflag, nil
	else
		return legalflag, nlegalid
	end
end

w1_page_auxiliary_cfg.timer_start = function()
	w1_page_auxiliary_cfg.timestart = true
end

w1_page_auxiliary_cfg.timer_stop = function(top)
	w1_page_auxiliary_cfg.timestart = false
	w1_wnd_util.tipclear(top, w1_page_auxiliary_cfg.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_auxiliary_cfg.timerenevt = function(top)
	if(w1_page_auxiliary_cfg.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_auxiliary_cfg.wnd.tipinfo.id)
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_auxiliary_cfg.init = function(top)
	w1_wnd_util.cfgtab = {'cfg_auxiliary', 'device'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	
	--ԭʼδ޸ǰ
	if (w1_page_auxiliary_cfg.ori_cfg == nil) then
		w1_page_auxiliary_cfg.ori_cfg = {};
	end
	util.copy_tab_b(w1_page_auxiliary_cfg.ori_cfg, b_app_cfg.origin_cfg);
	
	return 0
end

local on_enable = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local check = b_wnd_ex.get_check(top, win_id)
		if(check) then
			refresh_enable(top, false, false)
		else
			refresh_enable(top, true, false)
		end		
	
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top)		
	end
	return 0
end

local on_enable_poll = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_change_vo = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_change_decode_num = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local cwnd = w1_page_auxiliary_cfg.wnd
		local sel = b_wnd_ex.get_sel(top, cwnd.t_decode_num.id);
		local layout_type = 0;
		local chn_num = 0;
		
		local data = w1_page_auxiliary_cfg.data;
		local layout_info = data.layout_list[1];		
		set_layout_mode_items(top, layout_info.name);
		set_show_pape_items(top, 0); 
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local on_change_layout = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local cwnd = w1_page_auxiliary_cfg.wnd
		set_show_pape_items(top, 0); --˴޸˲ ͨǱ֧1ʼ
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local on_change_page = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_setup_auxiliary = function(top)
	local cwnd = w1_page_auxiliary_cfg.wnd	
	local table1 = w1_page_auxiliary_cfg.ori_cfg;
	local table2 =  b_app_cfg.user_cfg;
	local change_data = w1_wnd_util.usercfgchange_b(table1, table2);
	if (true == change_data) then	
		local ori_cfg = w1_page_auxiliary_cfg.ori_cfg.cfg_auxiliary;
		local user_cfg = b_app_cfg.user_cfg.cfg_auxiliary;
		if(ori_cfg.enable ~= user_cfg.enable) then --״̬ı ֱӼ/жظ
			if (false ~= user_cfg.enable) then--
				b_app_api.open_auxiliary();
				
				if (ori_cfg.layout_mode ~= user_cfg.layout_mode) then	--ı
					b_app_api.change_auxiliary_dec_ability();
				end
				
				if (ori_cfg.resolution ~= user_cfg.resolution) then --ֱ״̬ı ֱ޸ķֱ
					b_app_api.change_auxiliary_vo();
				end
				
				--ǿһβ
				local page = b_wnd_ex.get_sel(top, cwnd.t_show_page.id)	;
				b_app_api.change_auxiliary_layout(user_cfg.curr_id, page);
		
				--һѯ״̬
				b_app_api.enable_poll(user_cfg.enable_poll, screen_id)
			else
				b_app_api.enable_poll(false, screen_id); --رѯ
				b_app_api.close_auxiliary(); --رո	
			end
		else
			if (ori_cfg.enable == true) then --״̬ 
				if (ori_cfg.layout_mode ~= user_cfg.layout_mode) then	--ı
					b_app_api.change_auxiliary_dec_ability();
				end
				if (ori_cfg.resolution ~= user_cfg.resolution) then --ֱ״̬ı ֱ޸ķֱ
					b_app_api.change_auxiliary_vo();
				end
				
				
				if ((ori_cfg.curr_id ~= user_cfg.curr_id)) then --л
					local page = b_wnd_ex.get_sel(top, cwnd.t_show_page.id)	;
					b_app_api.change_auxiliary_layout(user_cfg.curr_id, page);
				else
					local ori_layout_info = ori_cfg.layout_list[ori_cfg.curr_id + 1];
					local cur_layout_info = user_cfg.layout_list[user_cfg.curr_id + 1];
					if (ori_layout_info.page ~= cur_layout_info.page)then
						local page = b_wnd_ex.get_sel(top, cwnd.t_show_page.id)	;
						b_app_api.change_auxiliary_layout(user_cfg.curr_id, page);
					end
				end
			end
			
			b_app_api.enable_poll(user_cfg.enable_poll, screen_id)

		end	
		
		--ԭʼδ޸ǰ
		if (w1_page_auxiliary_cfg.ori_cfg == nil) then
			w1_page_auxiliary_cfg.ori_cfg = {};
		end
		util.copy_tab_b(w1_page_auxiliary_cfg.ori_cfg, b_app_cfg.origin_cfg);
		
	end	
end	

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	
		on_setup_auxiliary(top);
	end

	return 0
end

w1_page_auxiliary_cfg.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	
	on_setup_auxiliary(top);
	
	return ret;
end

w1_page_auxiliary_cfg.on_pre_show = function(top)
	w1_page_auxiliary_cfg.clear_data();
	w1_page_auxiliary_cfg.vo_support = global_val.get_auxiliary_vo();
	w1_page_auxiliary_cfg.total_disp_num = global_val.get_channelnum(); 
end

w1_page_auxiliary_cfg.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = { 'cap_enable', 't_enable', 'cap_auxiliary_vo', 't_auxiliary_vo','cap_decode_num', 't_decode_num',
			'cap_layout_mode','t_layout_mode','cap_show_page','t_show_page', 'cap_dwell_enable', 't_dwell_enable','disable_tip','reboot_tip',
			'tipinfo', 'apply'},
			
	cap_enable 	= {t='static',id=id+1,xywh='s_cfg_page_1_1',text='LA_OPEN_AUXILIARY'},
	t_enable 	= {t='tt_check', id=id+2,xywh='s_aux_cfg_t_enable_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_enable},
	
	cap_auxiliary_vo = {t='static',id=id+3,xywh='s_cfg_page_2_1',text='LA_OUTPUT_RESOLUTION_AUX'},
	t_auxiliary_vo 	= {t='combox',	id=id+4,	xywh='s_cfg_page_2_2', items={'1280x1024', '1440x900', '1920x1080'},trans = false,cmd = on_change_vo},		
	
	cap_decode_num = {t='static',id=id+5,xywh='s_cfg_page_3_1',text='LA_DEC_ABILITY'},
	t_decode_num 	= {t='combox',	id=id+6,	xywh='s_cfg_page_3_2', items={'8+8'},trans = false,cmd =on_change_decode_num},		
	
	cap_layout_mode = {t='static',id=id+7,xywh='s_cfg_page_4_1',text='LA_LAYOUT_MODE'},
	t_layout_mode 	= {t='combox',	id=id+8,	xywh='s_cfg_page_4_2', items={'Display1',},trans = false,cmd =on_change_layout},		

	cap_show_page = {t='static',id=id+9,xywh='s_cfg_page_5_1',text='LA_DSP_CHANNEL_PAGE'},
	t_show_page 	= {t='combox',	id=id+10,	xywh='s_cfg_page_5_2', items={'1',},trans = false,cmd =on_change_page},		
	
	cap_dwell_enable 	= {t='static',id=id+11,xywh='s_cfg_page_6_1',text='LA_OPEN_POLL'},
	t_dwell_enable 	= {t='tt_check', id=id+12,xywh='s_aux_cfg_t_dwell_enable_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_enable_poll},	
	
	disable_tip = {t='static',id=id+13,xywh='s_aux_cfg_disable_tip_xywh',text='LA_DISABLE_AUXI',
					color = {'c_hint_bk', 'c_hint_border', 'c_hint_text'}},	
	
	reboot_tip = {t='static',id=id+14,xywh='s_aux_cfg_reboot_tip_xywh',text='LA_REBOOT_TIP_AUXI',
					color = {'c_hint_bk', 'c_hint_border', 'c_hint_text'}},	
					
	tipinfo		= {t='static',id=id+15,	xywh='s_axu_cfg_tipinfo_xywh',text='',trans = false},
	apply 		= {t='button',id=id+16,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},

}

return w1_page_auxiliary_cfg

