--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_channel_type.channeltype_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local w1_copy 	= require("wnd.w1_util.w1_copy")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_key 	= require("wnd.w1_util.w1_key")
local util 		= require("wnd.core.util")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local b_app_cfg		= require("wnd.core.b_app_cfg")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size

local w1_page_channel_type = 
{
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
};

w1_page_channel_type.s_768 =
{
	s_page_chn_type_list_4_2 = {53,21,645,199},
	s_page_chn_type_opt_tips_4_2 = {53,227,773,28},
	s_page_chn_type_opt_tips1_4_2 = {53,259,773,28},
	s_page_chn_type_list_8_4 = {53,21,645,327},
	s_page_chn_type_opt_tips_8_4 = {53,355,773,28},
	s_page_chn_type_opt_tips1_8_4 = {53,387,773,28},
	s_page_chn_type_list = {53,21,645,455},
	s_page_chn_type_opt_tips = {53,487,773,28},
	s_page_chn_type_opt_tips1 = {53,519,485,28},
	s_page_chn_type_tipinfo = {53,597,550,28},

};

w1_page_channel_type.s_1280 = 
{
	s_page_chn_type_list_4_2 = {100, 30, 810, 280},
	s_page_chn_type_opt_tips_4_2 = {100, 320, 910, 40},		
	s_page_chn_type_opt_tips1_4_2 = {100, 365, 910, 40},	
	s_page_chn_type_list_8_4 = {100, 30, 810, 460},
	s_page_chn_type_opt_tips_8_4 = {100, 520, 910, 40},		
	s_page_chn_type_opt_tips1_8_4 = {100, 565, 910, 40},	
	s_page_chn_type_list = {100, 30, 810, 640},
	s_page_chn_type_opt_tips = {100, 685, 910, 40},
	s_page_chn_type_opt_tips1 = {100, 730, 910, 40},
	s_page_chn_type_tipinfo = {100,800,700,40},
}
w1_page_channel_type.s_1440 = 
{
	s_page_chn_type_list_4_2 = {100, 30, 910, 255},
	s_page_chn_type_opt_tips_4_2 = {100, 295, 1030, 40},
	s_page_chn_type_opt_tips1_4_2 = {100, 340, 1030, 40},
	s_page_chn_type_list_8_4 = {100, 30, 910, 415},
	s_page_chn_type_opt_tips_8_4 = {100, 455, 1030, 40},	
	s_page_chn_type_opt_tips1_8_4 = {100, 500, 1030, 40},	
	s_page_chn_type_list = {100, 30, 910, 575},
	s_page_chn_type_opt_tips = {100, 610, 1030, 35},
	s_page_chn_type_opt_tips1 ={100, 650, 1030, 35},
	s_page_chn_type_tipinfo = {100,695,700,40},
}

w1_page_channel_type.s_1080p = 
{
	s_page_chn_type_list_4_2 = {100, 30, 1210, 280},
	s_page_chn_type_opt_tips_4_2 = {100, 320, 1450, 40},	
	s_page_chn_type_opt_tips1_4_2 = {100, 365, 1450, 40},	
	s_page_chn_type_list_8_4 = {100, 30, 1210, 460},
	s_page_chn_type_opt_tips_8_4 = {100, 500, 1450, 40},	
	s_page_chn_type_opt_tips1_8_4 = {100, 545, 1450, 40},
	s_page_chn_type_list = {100, 30, 1210, 640},
	s_page_chn_type_opt_tips = {100, 685, 1450, 40},
	s_page_chn_type_opt_tips1 = {100, 730, 910, 40},
	s_page_chn_type_tipinfo = {100,840,1100,40},
}

w1_page_channel_type.s_2k = 
{
	s_page_chn_type_list_4_2 = {133,40,1613,373},
	s_page_chn_type_opt_tips_4_2 = {133,425,1800,53},
	s_page_chn_type_opt_tips1_4_2 = {133,490,1800,53},
	s_page_chn_type_list_8_4 = {133,40,1613,613},
	s_page_chn_type_opt_tips_8_4 = {133,665,1800,53},
	s_page_chn_type_opt_tips1_8_4 = {133,730,1800,53},
	s_page_chn_type_list = {133,40,1613,853},
	s_page_chn_type_opt_tips = {133, 905, 1800,60},
	s_page_chn_type_opt_tips1 = {133, 965, 1800,60},
	s_page_chn_type_tipinfo = {133,1120,1500,53},
}

w1_page_channel_type.s_4k = 
{
	s_page_chn_type_list_4_2 	= {200,60,2420,560},
	s_page_chn_type_opt_tips_4_2 = {200,640,2900,80},
	s_page_chn_type_opt_tips1_4_2 = {200,730,2900,80},
	s_page_chn_type_list_8_4 	= {200,60,2420,920},
	s_page_chn_type_opt_tips_8_4 = {200,1000,2900,80},
	s_page_chn_type_opt_tips1_8_4 = {200,1090,2900,80},
	s_page_chn_type_list 	= {200,60,2420,1290},
	s_page_chn_type_opt_tips= {200,1380,2900,100},
	s_page_chn_type_opt_tips1 = {200,1490,2900,100},
	s_page_chn_type_tipinfo = {200,1680,2200,80},
}

local channel_num;--豸ͨĿ
	
--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local cwnd = w1_page_channel_type.wnd;
	b_wnd_ex.list_title_txt(top, cwnd.chn_type_list.id, {STR('LA_CHANNEL'), "AUTO", "AHD", "TVI", "CVI", "IP"}, false);
	b_wnd_ex.set_chn_type_data(top, cwnd.chn_type_list.id, cfgdata.channel_type, false);	
	return 0
end

local uidatacheck =function(top)
	local legalflag = true;
	local nlegalid = {};
	local cwnd = w1_page_channel_type.wnd;
	local data = b_app_cfg.user_cfg.channel_type;
	local max_ip_num = global_val.get_max_ipc_num();
	local vi_num, dec_num = global_val.get_vi_dec_num();
	local num = 0;
	for i = 1, #data.chn_type do
		if (data.chn_type[i] == 2) then
			if (i == vi_num + 1) then
				num = num + dec_num;
			else
				num = num + 1;
			end	
		end
	end	
	
	if (num > max_ip_num) then
		legalflag = false;
		local str = string.gsub(STR('LA_MAX_IP_NUM_TIP'), '*' , max_ip_num); 
		w1_wnd_util.setparamerr_str(str);
	end
	
	return legalflag, nil
end


local returndatacheck =function(top,ret)
	if(ret ~= nil and ret.channel_type ~= 0) then--޸ʧ
		local nlegalid = {};
		--table.insert(nlegalid, w1_page_channel_type.wnd.tipinfo.id);	
		
		if (ret.channel_type == 2) then
			w1_wnd_util.setparamerr_str(STR('LA_ADJUST_DETECTION_CHANNEL_1'));
		else
			w1_wnd_util.setparamerr_str(STR('LA_APPLY_FAIL'));
		end
		--¶ȡԭʼ
		b_app_cfg.origin_init(w1_wnd_util.cfgtab);
		return false, nlegalid;
	end
	
	return true, nil;
end


--ҳʼʱٶȡҳҪ
w1_page_channel_type.init = function(top)
	w1_wnd_util.cfgtab = {'channel_type',}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

w1_page_channel_type.timer_start = function()
	w1_page_channel_type.timestart = true
end

w1_page_channel_type.timer_stop = function(top)
	w1_page_channel_type.timestart = false
	w1_wnd_util.tipclear(top, w1_page_channel_type.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_channel_type.timerenevt = function(top)
	if(w1_page_channel_type.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_channel_type.wnd.tipinfo.id)
	end
	return 0
end

local update_data_param = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg or b_ui.WM_USER_UPDATE_PARAM == vmsg)then 
		local cwnd = w1_page_channel_type.wnd;
		b_app_cfg.user_cfg.channel_type = nil;
		b_app_cfg.user_cfg.channel_type = util.copy_tab(b_wnd_ex.get_chn_type_data(top, cwnd.chn_type_list.id))
	end
	return 0;
end

w1_page_channel_type.get_chn_data = function(top)
	local cwnd = w1_page_channel_type.wnd;
	b_app_cfg.user_cfg.channel_type = nil;
	b_app_cfg.user_cfg.channel_type = util.copy_tab(b_wnd_ex.get_chn_type_data(top, cwnd.chn_type_list.id))
end
	
local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.returndatacheckfunc = returndatacheck;
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_channel_type.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	w1_wnd_util.returndatacheckfunc = returndatacheck;
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()
	end
	
	return ret;
end

w1_page_channel_type.on_pre_show = function(top)
	channel_num = global_val.get_channelnum();
	local cwnd = w1_page_channel_type.wnd;
	local vi_num, dec_num = global_val.get_vi_dec_num();
	if (vi_num == 4) then
		local rect_size = SIZE('s_page_chn_type_list_4_2');
		b_wnd_ex.set_chn_type_size(top, cwnd.chn_type_list.id, rect_size, false);
		local size = SIZE('s_page_chn_type_opt_tips_4_2');
		local movepos1 = {size[1],size[2],size[3],size[4]};
		b_wnd_ex.move_ex(top, cwnd.opt_tips.id, movepos1, false);
		local size_1= SIZE('s_page_chn_type_opt_tips1_4_2');
		local movepos_1 = {size_1[1],size_1[2],size_1[3],size_1[4]};
		b_wnd_ex.move_ex(top, cwnd.opt_tips_1.id, movepos_1, false);	
		
	elseif (vi_num == 8) then
		local rect_size = SIZE('s_page_chn_type_list_8_4');
		b_wnd_ex.set_chn_type_size(top, cwnd.chn_type_list.id, rect_size, false);	
		local size = SIZE('s_page_chn_type_opt_tips_8_4');
		local movepos1 = {size[1],size[2],size[3],size[4]};
		b_wnd_ex.move_ex(top, cwnd.opt_tips.id, movepos1, false);	
		local size_1= SIZE('s_page_chn_type_opt_tips1_8_4');
		local movepos_1 = {size_1[1],size_1[2],size_1[3],size_1[4]};
		b_wnd_ex.move_ex(top, cwnd.opt_tips_1.id, movepos_1, false);
	end
end

w1_page_channel_type.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'chn_type_list', 'opt_tips', 'opt_tips_1','tipinfo', 'apply'},
	chn_type_list = {t='chn_type_mgr', id= id+1, xywh='s_page_chn_type_list', cmd=update_data_param},	
	opt_tips = {t='static',id=id+2,	xywh='s_page_chn_type_opt_tips', text='LA_CHANNEL_INFO', 
				color = {'c_hint_bk', 'c_hint_border', 'c_hint_text'}},	
	opt_tips_1 = {t='static',id=id+3,	xywh='s_page_chn_type_opt_tips1', text='LA_CHANNEL_INFO_1', 
				color = {'c_hint_bk', 'c_hint_border', 'c_hint_text'}},				
	tipinfo	 = {t='static',id=id+4,	xywh='s_page_chn_type_tipinfo',	text='',trans = false},	
	apply 	= {t='button',id=id+5,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_channel_type

