--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/4/26
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_cloud.cloud_id
local w1_key 		= require("wnd.w1_util.w1_key")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local util 			= require("wnd.core.util")
local w1_msgbox		= require("wnd.w1_util.w1_msgbox")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local b_app_cfg  = require("wnd.core.b_app_cfg")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_app_api = require("wnd.core.command.b_app_api")
local global_val= require("wnd.global_val")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color

local tip_flag = 0;
local s_time = 0;
local time_start = 0;
local w1_page_cloud = 
{
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_cloud.s_768 =
{
	s_cloud_t_enable_xywh = {278,21,25,21},
	s_cloud_t_operate_xywh = {282,192,64,32},
	s_cloud_cap_normal_xywh = {331,320,53,32},
	s_cloud_cap_event_xywh = {385,320,53,32},
	s_cloud_t_video_check1_xywh = {278,366,25,21},
	s_cloud_t_video_check2_xywh = {331,366,25,21},
	s_cloud_t_video_check3_xywh = {385,366,25,21},
	s_cloud_t_event_check1_xywh = {278,408,25,21},
	s_cloud_t_event_check2_xywh = {331,408,25,21},
	s_cloud_t_event_check3_xywh = {385,408,25,21},
	s_cloud_tipinfo_xywh = {58,540,373,35},
	s_cfg_file_len = {281,362,160,32},
	s_cfg_file_btn = {446,362,37,32},
	s_cfg_btn_tip = {483,362,37,32},
	s_cfg_tipinfo = {53,398,320,32},
	s_cfg_apply_tipinfo = {53,590,373,35},
	s_cfg_qr_code = {281,192,142,142},
		
	col_w_1 = {37,0,0,0},
	col_w_2 = {149,0,0,0},
};

w1_page_cloud.s_1280 = 
{
	s_cloud_t_enable_xywh		= {455,30,48,30},
	s_cloud_t_operate_xywh		= {770,330,120,45},
	s_cloud_cap_normal_xywh		= {555,450,100,45},
	s_cloud_cap_event_xywh		= {655,450,100,45},
	s_cloud_t_video_check1_xywh	= {455,515,48,30},
	s_cloud_t_video_check2_xywh	= {555,515,48,30},
	s_cloud_t_video_check3_xywh	= {655,515,48,30},
	s_cloud_t_event_check1_xywh	= {455,575,48,30},
	s_cloud_t_event_check2_xywh	= {555,575,48,30},
	s_cloud_t_event_check3_xywh	= {655,575,48,30},
	s_cloud_tipinfo_xywh		= {110,760,500,50},
	s_cfg_file_len				= {460,510,235,45},
	s_cfg_file_btn				= {700,510,60,45},
	s_cfg_btn_tip				= {760,510,70,45},
	s_cfg_tipinfo				= {100,560,600,45},
	s_cfg_apply_tipinfo			= {80,800,700,50},
	s_cfg_qr_code				= {460,270,200,200},
	
	col_w_1						= {40,0,0,0},
	col_w_2						= {230,0,0,0,},									
}

w1_page_cloud.s_1440 = 
{
	s_cloud_t_enable_xywh		= {525,25,48,30},
	s_cloud_t_operate_xywh		= {920,275,120,45},	
	s_cloud_cap_normal_xywh		= {625,380,100,45},
	s_cloud_cap_event_xywh		= {725,380,100,45},
	s_cloud_t_video_check1_xywh	= {525,440,48,30},
	s_cloud_t_video_check2_xywh	= {625,440,48,30},
	s_cloud_t_video_check3_xywh	= {725,440,48,30},
	s_cloud_t_event_check1_xywh	= {525,495,48,30},
	s_cloud_t_event_check2_xywh	= {625,495,48,30},
	s_cloud_t_event_check3_xywh	= {725,495,48,30},
	s_cloud_tipinfo_xywh		= {110,680,500,50},	
	s_cfg_file_len				= {530,425,300,45},
	s_cfg_file_btn				= {835,425,75,45},
	s_cfg_btn_tip				= {910,425,70,45},
	s_cfg_tipinfo				= {100,475,600,45},
	s_cfg_apply_tipinfo			= {80,690,700,50},
	s_cfg_qr_code				= {530,225,190,190},
	
	col_w_1						= {60,0,0,0},
	col_w_2						= {290,0,0,0,},
}

w1_page_cloud.s_1080p = 
{
	s_cloud_t_enable_xywh		= {522,30,48,30},
	s_cloud_t_operate_xywh		= {530,270,120,45},
	s_cloud_cap_normal_xywh		= {622,450,100,45},
	s_cloud_cap_event_xywh		= {722,450,100,45},
	s_cloud_t_video_check1_xywh	= {522,515,48,30},
	s_cloud_t_video_check2_xywh	= {622,515,48,30},
	s_cloud_t_video_check3_xywh	= {722,515,48,30},
	s_cloud_t_event_check1_xywh	= {522,575,48,30},
	s_cloud_t_event_check2_xywh	= {622,575,48,30},
	s_cloud_t_event_check3_xywh	= {722,575,48,30},
	s_cloud_tipinfo_xywh		= {110,760,700,50},
	s_cfg_file_len				= {527,510,300,45},
	s_cfg_file_btn				= {837,510,70,45},
	s_cfg_btn_tip				= {907,510,70,45},
	s_cfg_tipinfo				= {100,560,600,45},
	s_cfg_apply_tipinfo			= {100,830,700,50},
	s_cfg_qr_code				= {527,270,200,200},
	
	col_w_1						= {70,0,0,0},
	col_w_2						= {280,0,0,0,},
}

w1_page_cloud.s_2k = 
{
	s_cloud_t_enable_xywh		= {696,40,64,40},
	s_cloud_t_operate_xywh		= {705,360,160,60},
	s_cloud_cap_normal_xywh		= {829,600,133,60},
	s_cloud_cap_event_xywh		= {962,600,133,60},
	s_cloud_t_video_check1_xywh	= {696,687,64,40},
	s_cloud_t_video_check2_xywh	= {829,687,64,40},
	s_cloud_t_video_check3_xywh	= {962,687,64,40},
	s_cloud_t_event_check1_xywh	= {696,767,64,40},
	s_cloud_t_event_check2_xywh	= {829,767,64,40},
	s_cloud_t_event_check3_xywh	= {962,767,64,40},
	s_cloud_tipinfo_xywh		= {147,1013,933,67},
	s_cfg_file_len				= {703,680,400,60},
	s_cfg_file_btn				= {1113,680,97,60},
	s_cfg_btn_tip				= {1210,680,80,60},
	s_cfg_tipinfo				= {133,750,700,60},
	s_cfg_apply_tipinfo			= {133,1100,933,67},
	s_cfg_qr_code				= {703,360,267,267},
	
	col_w_1						= {87,0,0,0},
	col_w_2						= {390,0,0,0,},
}

w1_page_cloud.s_4k = 
{
	s_cloud_t_enable_xywh		= {1045,60,96,60},
	s_cloud_t_operate_xywh		= {1055,540,240,90},	
	s_cloud_cap_normal_xywh		= {1245,900,200,90},
	s_cloud_cap_event_xywh		= {1445,900,200,90},
	s_cloud_t_video_check1_xywh	= {1045,1030,96,60},
	s_cloud_t_video_check2_xywh	= {1245,1030,96,60},
	s_cloud_t_video_check3_xywh	= {1445,1030,96,60},
	s_cloud_t_event_check1_xywh	= {1045,1230,96,60},
	s_cloud_t_event_check2_xywh	= {1245,1230,96,60},
	s_cloud_t_event_check3_xywh	= {1445,1230,96,60},
	s_cloud_tipinfo_xywh		= {220,1520,1400,100},
	s_cfg_file_len				= {1055,1020,600,90},
	s_cfg_file_btn				= {1670,1020,145,90},
	s_cfg_btn_tip				= {1815,1020,140,90},
	s_cfg_tipinfo				= {200,1120,1200,90},
	s_cfg_apply_tipinfo			= {200,1620,1400,100},
	s_cfg_qr_code				= {1055,540,400,400},
	
	col_w_1						= {100,0,0,0},
	col_w_2						= {600,0,0,0,},
}

w1_page_cloud.clear_data = function()
	w1_page_cloud.data = nil;
end	

local tipinfo_hide =function (top,hide)
	local cwnd=w1_page_cloud.wnd
	b_wnd_ex.set_hide(top,cwnd.tipinfo.id,hide,false)
	if hide then
		b_wnd_ex.set_color(top,cwnd.t_file_len.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_edit_text_n')},false)
		b_wnd_ex.set_color_f(top,cwnd.t_file_len.id,
		{COLOR('c_edit_bg_f'),COLOR('c_edit_border_f'),COLOR('c_txt_f')},false)
	else
		b_wnd_ex.set_color(top,cwnd.t_file_len.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
		b_wnd_ex.set_color_f(top,cwnd.t_file_len.id,
		{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	local cwnd = w1_page_cloud.wnd
	local gdrive = cfgdata.gdrive
	b_wnd_ex.set_value(top,cwnd.t_upload_file_len.id,gdrive.upload_file_len,false)
	if s_time > 0 then
		s_time = time_start - os.time();
		local min = math.modf(s_time/60)
		local sec = s_time % 60
		local time_str
		if sec > 9 then
			time_str = tostring(min)..":"..tostring(sec)
		else
			time_str = tostring(min)..":0"..tostring(sec)
		end
		b_wnd_ex.set_text(top,cwnd.t_btn_tip.id,time_str,false)
	end
	local status = b_app_api.check_gdrive_status()
	local check = b_wnd_ex.get_check(top,cwnd.t_enable.id)
	if status==1 then
		b_wnd_ex.set_check(top,cwnd.t_enable.id,true,false)
		b_wnd_ex.set_text(top,cwnd.t_cloud_state.id,STR('LA_AUTHEN'),false)
		local s_id = cwnd.cap_upload_dir.id; 
		local e_id = cwnd.t_btn_tip.id;
		tip_flag = 0;
		for i = s_id, e_id do
			b_wnd_ex.set_hide(top,i,true,false)
		end
	else
		if status==0 then
			b_wnd_ex.set_text(top,cwnd.t_cloud_state.id,STR('LA_NOT_AUTHEN'),false)
		elseif status==2  then
			b_wnd_ex.set_text(top,cwnd.t_cloud_state.id,STR('LA_AUTH_CODE_ING'),false)
		elseif status==3  then
			b_wnd_ex.set_text(top,cwnd.t_cloud_state.id,STR('LA_AUTH_CODE_FAIL'),false)
		end
		local s_id = cwnd.cap_upload_dir.id; 
		local e_id = cwnd.t_btn_tip.id;
		for i = s_id, e_id do
			b_wnd_ex.set_hide(top,i,not check,false)
		end
	end
	tipinfo_hide(top,true)
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_cloud.wnd
	local upload_file_len = b_wnd_ex.get_value(top,cwnd.t_upload_file_len.id)
	cfgdata['gdrive']['upload_file_len'] = upload_file_len
	return 0
end


--ҳʼʱٶȡҳҪ
w1_page_cloud.init = function(top)
	w1_wnd_util.cfgtab = {'gdrive'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

w1_page_cloud.clear_data = function()
	w1_page_cloud.data = nil;
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

w1_page_cloud.timer_start = function()
	w1_page_cloud.timestart = true
end

w1_page_cloud.timer_stop = function(top)
	w1_page_cloud.timestart = false
	w1_wnd_util.tipclear(top, w1_page_cloud.wnd.apply_tip.id, false)
	w1_wnd_util.clearerrweight(top, false)
	w1_wnd_util.tipdispoff();
end

w1_page_cloud.timerenevt = function(top)
	if(w1_page_cloud.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_cloud.wnd.apply_tip.id)
		local cwnd = w1_page_cloud.wnd
		local check = b_wnd_ex.get_check(top,cwnd.t_enable.id)
		if check then
				local status = b_app_api.check_gdrive_status()
				if status==1 then
					b_wnd_ex.set_text(top,cwnd.t_cloud_state.id,STR('LA_AUTHEN'),false)
					local s_id = cwnd.cap_upload_dir.id; 
					local e_id = cwnd.t_btn_tip.id;
					for i = s_id, e_id do
					b_wnd_ex.set_hide(top,i,true,false)
					end
					tip_flag = 0;
					b_dlg.dlg_set_redraw(top);
				elseif status==0  then
					b_wnd_ex.set_text(top,cwnd.t_cloud_state.id,STR('LA_NOT_AUTHEN'),false)
				elseif status==2  then
					b_wnd_ex.set_text(top,cwnd.t_cloud_state.id,STR('LA_AUTH_CODE_ING'),false)
				elseif status==3  then
					b_wnd_ex.set_text(top,cwnd.t_cloud_state.id,STR('LA_AUTH_CODE_FAIL'),false)
				end
		elseif (check and tip_flag==1) then
			b_wnd_ex.set_hide(top,cwnd.t_btn_tip.id,false,false)
		end
		--ʱ
		if tip_flag==1 then
			s_time = time_start - os.time();
			local min = math.modf(s_time/60)
			local sec = s_time % 60
			local time_str
			if sec > 9 then
				time_str = tostring(min)..":"..tostring(sec)
			else
				time_str = tostring(min)..":0"..tostring(sec)
			end
			if s_time>0 then
				--b_wnd_ex.set_hide(top,cwnd.t_btn_tip.id,false,true)
				b_wnd_ex.set_text(top,cwnd.t_btn_tip.id,time_str,false)
			else
				tip_flag = 0
				local s_id = cwnd.cap_upload_dir.id; 
				local e_id = cwnd.tipinfo.id;
				for i = s_id, e_id do
				b_wnd_ex.set_hide(top,i,true,false)
				end
				b_wnd_ex.set_check(top,cwnd.t_enable.id,false,false)
				b_dlg.dlg_set_redraw(top);
				b_app_api.gdrive_close();
			end
		else
			b_wnd_ex.set_hide(top,cwnd.t_btn_tip.id,true,false)
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end


local on_enable = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd=w1_page_cloud.wnd
		local check =b_wnd_ex.get_check(top,cwnd.t_enable.id)
		tip_flag = 0
		local s_id = cwnd.cap_upload_dir.id; 
		local e_id = cwnd.t_btn_tip.id;
		for i = s_id, e_id do
			b_wnd_ex.set_hide(top,i,not check,false)
		end
		time_start = 0;
		if check then
			local url = b_app_api.get_gdrive_url()
			b_wnd_ex.set_text(top,cwnd.t_upload_dir.id,url.gdrive_url,false)
			--b_wnd_ex.set_text(top,cwnd.t_upload_dir.id,'https://www.baidu.com',true)
			time_start = os.time() + 600
			b_wnd_ex.set_text(top,cwnd.t_btn_tip.id,'',false)
			tip_flag = 1;
		else
			b_app_api.gdrive_close();
			b_wnd_ex.set_text(top,cwnd.t_cloud_state.id,STR('LA_NOT_AUTHEN'),false)
		end
		b_wnd_ex.set_text(top,cwnd.t_file_len.id,'',false)
		tipinfo_hide(top,true)
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_send = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd=w1_page_cloud.wnd
		local code = b_wnd_ex.get_text(top,cwnd.t_file_len.id)
		if code == "" then
			tipinfo_hide(top,false)
			b_dlg.dlg_set_redraw(top);
			return 0;
		end
		tipinfo_hide(top,true)
		b_app_api.set_google_code(code);
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

w1_page_cloud.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()
	end
	
	return ret;
end

w1_page_cloud.on_pre_show = function(top)

end

w1_page_cloud.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_enable','t_enable','cap_cloud_type','t_cloud_type','cap_cloud_state','t_cloud_state',
			'cap_upload_dir','t_upload_dir','cap_file_len','t_file_len', 't_file_btn','t_btn_tip','tipinfo',
			'cap_upload_file_len','t_upload_file_len','apply','apply_tip',
			},
	
	cap_enable 		= {t='static',id=id+1,xywh='s_cfg_page_1_1',text='LA_ENABLE'},
	t_enable 		= {t='tt_check', id=id+2,xywh='s_cloud_t_enable_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_enable},
					
	cap_cloud_type	= {t='static',id=id+3,xywh='s_cfg_page_2_1',text='LA_CLOUD_TYPE'},
	t_cloud_type 	= {t='combox',id=id+4,xywh='s_cfg_page_2_2',items={'LA_GOOGLE_DRIVE'},},
	
	cap_cloud_state	= {t='static',id=id+5,xywh='s_cfg_page_3_1',text='LA_CERTIFICATION_STATUS'},
	t_cloud_state	= {t='static',id=id+6,xywh='s_cfg_page_3_2',text='LA_NOT_AUTHEN'},
	
	
	cap_upload_dir	= {t='static',id=id+7,xywh='s_cfg_page_5_1',text='LA_CODE_PATH'},
	t_upload_dir	= {t='qr_code',id=id+8,xywh='s_cfg_qr_code',text=''},
	
	cap_file_len	= {t='static',id=id+9,xywh='s_cfg_page_9_1',text='LA_AUTHORIZATION_CODE'},
	t_file_len		= {t='edit',id=id+10,xywh='s_cfg_file_len',max_value = 128,},
	t_file_btn		= {t='button',id=id+11,xywh='s_cfg_file_btn',text='LA_SEND',cmd=on_send},
	t_btn_tip 		= {t='static',id=id+12,xywh='s_cfg_btn_tip',text='',trans=false},
	
	tipinfo			= {t='static',id= id+13,xywh='s_cfg_tipinfo',text='LA_CODE_EMPTY',
			color = {'c_hint_bk', 'c_hint_border', 'c_hint_text'}},
	
	cap_upload_file_len	= {t='static',id=id+14,xywh='s_cfg_page_4_1',text='LA_UPLOAD_SIZE'},
	t_upload_file_len	= {t='edit_num',id=id+15,xywh='s_cfg_page_4_2',range={5,64},cmd=on_update_param},
	
	apply 			={t='button',id=id+16,xywh='s_cfg_apply_xywh',text='LA_APPLY',cmd=on_apply},
	apply_tip 		={t='static',id= id+17,xywh='s_cfg_apply_tipinfo',text='',trans=false}
	
}

return w1_page_cloud



