--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_out.cvbs_color_id
local b_app_api = require("wnd.core.command.b_app_api")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_app_cfg  = require("wnd.core.b_app_cfg")
local w1_page_cvbscolor = 
{
	data,
	timestart = false,
}

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local cwnd = w1_page_cvbscolor.wnd;
	local data = cfgdata.cvbs;
	local set_value = function(id, value)
		b_wnd_ex.set_value(top, id, value, false);
	end
	local set_text = function(id, value)
		b_wnd_ex.set_text(top, id, tostring(value), false);
	end
	
	set_value(cwnd.t_brig.id, data.bright);
	set_value(cwnd.t_hue.id, data.hue);
	set_value(cwnd.t_con.id, data.contrast);
	set_value(cwnd.t_sat.id, data.saturation);

	set_text(cwnd.brig_value.id, data.bright);
	set_text(cwnd.hue_value.id, data.hue);
	set_text(cwnd.con_value.id, data.contrast);
	set_text(cwnd.sat_value.id, data.saturation);
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_cvbscolor.wnd
	local data = cfgdata.cvbs;
	local get_value = function(id)
		return b_wnd_ex.get_value(top, id);
	end
	
	data.bright = get_value(cwnd.t_brig.id);
	data.hue = get_value(cwnd.t_hue.id);
	data.contrast = get_value(cwnd.t_con.id);
	data.saturation = get_value(cwnd.t_sat.id);
	data.change_flag = 1;
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

w1_page_cvbscolor.timer_start = function()
	w1_page_cvbscolor.timestart = true;
end

w1_page_cvbscolor.timer_stop = function(top)
	w1_page_cvbscolor.timestart = false;
	w1_wnd_util.tipclear(top, w1_page_cvbscolor.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
end

w1_page_cvbscolor.timerenevt = function(top)
	if(w1_page_cvbscolor.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_cvbscolor.wnd.tipinfo.id);
	end
	return 0;
end

local set_color_value = function(top, id, value)
	local set_text = function(id, value)
		b_wnd_ex.set_text(top, id, tostring(value), false)
	end
	local cwnd = w1_page_cvbscolor.wnd
	if(id == cwnd.t_brig.id) then
		set_text(cwnd.brig_value.id, value);
	elseif(id == cwnd.t_con.id) then
		set_text(cwnd.con_value.id, value);
	elseif(id == cwnd.t_hue.id) then
		set_text(cwnd.hue_value.id, value);
	elseif(id == cwnd.t_sat.id) then
		set_text(cwnd.sat_value.id, value);
	end
end

local on_subb = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_cvbscolor.wnd
		local opearid = nil;
		if(win_id == cwnd.brig_subb.id) then
			opearid = cwnd.t_brig.id;
		elseif(win_id == cwnd.con_subb.id) then
			opearid = cwnd.t_con.id;
		elseif(win_id == cwnd.hue_subb.id) then
			opearid = cwnd.t_hue.id;
		elseif(win_id == cwnd.sat_subb.id) then
			opearid = cwnd.t_sat.id;
		end
		local value = b_wnd_ex.get_value(top, opearid);
		if(value > 0) then
			value = value - 1;
			b_wnd_ex.set_value(top, opearid, value, false)
			set_color_value(top, opearid, value);
			b_dlg.dlg_set_redraw(top);
			w1_wnd_util.uidatacheckfunc = uidatacheck
			uitousercfg(top,b_app_cfg.user_cfg);
			w1_wnd_util.page_onapply(top)
			w1_wnd_util.tipdispon()		--ʾ
		end	
	end
	return 0
end

local on_adj = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local cwnd = w1_page_cvbscolor.wnd
		local value = b_wnd_ex.get_value(top, win_id);
		set_color_value(top, win_id, value);
		b_dlg.dlg_set_redraw(top)
		w1_wnd_util.uidatacheckfunc = uidatacheck
		uitousercfg(top,b_app_cfg.user_cfg);
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_cvbscolor.wnd
		local opearid = nil;
		if(win_id == cwnd.brig_add.id) then
			opearid = cwnd.t_brig.id;
		elseif(win_id == cwnd.con_add.id) then
			opearid = cwnd.t_con.id;
		elseif(win_id == cwnd.hue_add.id) then
			opearid = cwnd.t_hue.id;
		elseif(win_id == cwnd.sat_add.id) then
			opearid = cwnd.t_sat.id;
		end
	
		local value = b_wnd_ex.get_value(top, opearid);
		if(value < 100) then
			value = value + 1;
			b_wnd_ex.set_value(top, opearid, value, false)
			set_color_value(top, opearid, value);
			b_dlg.dlg_set_redraw(top);
			w1_wnd_util.uidatacheckfunc = uidatacheck
			uitousercfg(top,b_app_cfg.user_cfg);
			w1_wnd_util.page_onapply(top)
			w1_wnd_util.tipdispon()		--ʾ
		end
	end
	return 0
end


--ҳʼʱٶȡҳҪ
w1_page_cvbscolor.init = function(top)
	w1_wnd_util.cfgtab = {'cvbs'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

w1_page_cvbscolor.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	
	sub = {	
			'cap_brig', 'brig_subb', 't_brig', 'brig_add', 'brig_value',
			'cap_con', 'con_subb', 't_con', 'con_add', 'con_value',
			'cap_hue', 'hue_subb', 't_hue', 'hue_add', 'hue_value',
			'cap_sat', 'sat_subb', 't_sat', 'sat_add', 'sat_value',
			'tipinfo',	
			},
	--brig
	cap_brig 	= {t='static',id=id+1,xywh='s_cvbs_cap_left_xywh',
					text='LA_BRIGHT'},
	brig_subb	= {t='button',id=id+2,	xywh='s_cvbs_left_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_brig 		= {t='hslider',id=id+3,xywh='s_cvbs_t_left_xywh',font = 'f_slider',
					cmd = on_adj},
	brig_add	= {t='button',id=id+4,	xywh='s_cvbs_left_add_xywh',
					color	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},	
	brig_value	= {t='static',id=id+5,	xywh='s_cvbs_left_value_xywh',trans = false},

	--con
	cap_con 	= {t='static',id=id+6,xywh='s_cvbs_cap_up_xywh',
					text='LA_CONTRAST',},
	con_subb	= {t='button',id=id+7,	xywh='s_cvbs_up_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},	
	t_con 		= {t='hslider',id=id+8,xywh='s_cvbs_t_up_xywh',font = 'f_slider',
					cmd = on_adj},	
	con_add		= {t='button',id=id+9,	xywh='s_cvbs_up_add_xywh',
					color	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},	
	con_value	= {t='static',id=id+10,	xywh='s_cvbs_up_value_xywh',trans = false},

	
	--hue
	hue_subb	= {t='button',id=id+11,	xywh='s_cvbs_right_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},	
	cap_hue 	= {t='static',id=id+12,xywh='s_cvbs_cap_right_xywh',
					text='LA_HUE',},
	t_hue 		= {t='hslider',id=id+13,xywh='s_cvbs_t_right_xywh',font = 'f_slider',
					cmd = on_adj},	
	hue_add		= {t='button',id=id+14,	xywh='s_cvbs_right_add_xywh',
					color	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},	
	hue_value	= {t='static',id=id+15,	xywh='s_cvbs_right_value_xywh',trans = false},


	--sat
	sat_subb	= {t='button',id=id+16,	xywh='s_cvbs_down_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},	
	cap_sat 	= {t='static',id=id+17,xywh='s_cvbs_cap_down_xywh',
					text='LA_SATURATION',},
	t_sat 		= {t='hslider',id=id+18,xywh='s_cvbs_t_down_xywh',font = 'f_slider',
					cmd = on_adj},
	sat_add		= {t='button',id=id+19,	xywh='s_cvbs_down_add_xywh',
					color	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},	
	sat_value	= {t='static',id=id+20,	xywh='s_cvbs_down_value_xywh',trans = false},
	
	tipinfo		= {t='static',id=id+21,	xywh='s_cvbs_tipinfo_xywh',	text='',trans = false},	
	
}

return w1_page_cvbscolor



