--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_out.cvbs_offset_id
local b_app_api = require("wnd.core.command.b_app_api")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_app_cfg  = require("wnd.core.b_app_cfg")
local w1_page_cvbsoffset = 
{
	data,
	timestart = false,
}

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local cwnd = w1_page_cvbsoffset.wnd;
	--w1_page_cvbsoffset.data = data;
	local data = cfgdata.cvbs;
	local set_value = function(id, value)
		b_wnd_ex.set_value(top, id, value, false);
	end
	local set_text = function(id, value)
		b_wnd_ex.set_text(top, id, tostring(value), false);
	end
	
	set_value(cwnd.t_left.id, data.left);
	set_value(cwnd.t_up.id, data.up);
	set_value(cwnd.t_right.id, data.right);
	set_value(cwnd.t_down.id, data.down);

	set_text(cwnd.left_value.id, data.left);
	set_text(cwnd.up_value.id, data.up);
	set_text(cwnd.right_value.id, data.right);
	set_text(cwnd.down_value.id, data.down);
	return 0;
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_cvbsoffset.wnd;
	local data = cfgdata.cvbs;
	local get_value = function(id)
		return b_wnd_ex.get_value(top, id);
	end
	
	data.left = get_value(cwnd.t_left.id);
	data.up = get_value(cwnd.t_up.id);
	data.right = get_value(cwnd.t_right.id);
	data.down = get_value(cwnd.t_down.id);
	data.change_flag = 1;
	return 0;
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil;
end

w1_page_cvbsoffset.timer_start = function()
	w1_page_cvbsoffset.timestart = true;
end

w1_page_cvbsoffset.timer_stop = function(top)
	w1_page_cvbsoffset.timestart = false;
	w1_wnd_util.tipclear(top, w1_page_cvbsoffset.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
end

w1_page_cvbsoffset.timerenevt = function(top)
	if(w1_page_cvbsoffset.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_cvbsoffset.wnd.tipinfo.id);
	end
	return 0;
end

local set_offset_value = function(top, id, value)
	local set_text = function(id, value)
		b_wnd_ex.set_text(top, id, tostring(value), false)
	end
	local cwnd = w1_page_cvbsoffset.wnd
	if(id == cwnd.t_left.id) then
		set_text(cwnd.left_value.id, value);
	elseif(id == cwnd.t_up.id) then
		set_text(cwnd.up_value.id, value);
	elseif(id == cwnd.t_right.id) then
		set_text(cwnd.right_value.id, value);
	elseif(id == cwnd.t_down.id) then
		set_text(cwnd.down_value.id, value);
	end
end

local on_subb = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_cvbsoffset.wnd
		local opearid = nil;
		if(win_id == cwnd.left_subb.id) then
			opearid = cwnd.t_left.id;
		elseif(win_id == cwnd.up_subb.id) then
			opearid = cwnd.t_up.id;
		elseif(win_id == cwnd.right_subb.id) then
			opearid = cwnd.t_right.id;
		elseif(win_id == cwnd.down_subb.id) then
			opearid = cwnd.t_down.id;
		end
		local value = b_wnd_ex.get_value(top, opearid);
		if(value > 0) then
			value = value - 1;
			b_wnd_ex.set_value(top, opearid, value, false)
			set_offset_value(top, opearid, value);
			b_dlg.dlg_set_redraw(top)
			w1_wnd_util.uidatacheckfunc = uidatacheck
			uitousercfg(top,b_app_cfg.user_cfg);
			w1_wnd_util.page_onapply(top)
			w1_wnd_util.tipdispon()		--ʾ
		end	
	end
	return 0
end

local on_adj = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local cwnd = w1_page_cvbsoffset.wnd
		local value = b_wnd_ex.get_value(top, win_id);
		set_offset_value(top, win_id, value);
		b_dlg.dlg_set_redraw(top)
		w1_wnd_util.uidatacheckfunc = uidatacheck
		uitousercfg(top,b_app_cfg.user_cfg);
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_cvbsoffset.wnd
		local opearid = nil;
		if(win_id == cwnd.left_add.id) then
			opearid = cwnd.t_left.id;
		elseif(win_id == cwnd.up_add.id) then
			opearid = cwnd.t_up.id;
		elseif(win_id == cwnd.right_add.id) then
			opearid = cwnd.t_right.id;
		elseif(win_id == cwnd.down_add.id) then
			opearid = cwnd.t_down.id;
		end
		local value = b_wnd_ex.get_value(top, opearid);
		if(value < 100) then
			value = value + 1;
			b_wnd_ex.set_value(top, opearid, value, false)
			set_offset_value(top, opearid, value);
			b_dlg.dlg_set_redraw(top)
			w1_wnd_util.uidatacheckfunc = uidatacheck
			uitousercfg(top,b_app_cfg.user_cfg);
			w1_wnd_util.page_onapply(top)
			w1_wnd_util.tipdispon()		--ʾ
		end
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_cvbsoffset.init = function(top)
	w1_wnd_util.cfgtab = {'cvbs'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

w1_page_cvbsoffset.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	
	sub = {	
			'cap_left', 'left_subb', 't_left', 'left_add', 'left_value',
			'cap_up', 'up_subb', 't_up', 'up_add', 'up_value',
			'cap_right', 'right_subb', 't_right', 'right_add', 'right_value',
			'cap_down', 'down_subb', 't_down', 'down_add', 'down_value',
			'tipinfo',
			},
			
	--left
	cap_left 	= {t='static',id=id+1,xywh='s_cvbs_cap_left_xywh',
					text='LA_LEFT',},
	left_subb	= {t='button',id=id+2,	xywh='s_cvbs_left_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_left 		= {t='hslider',id=id+3,xywh='s_cvbs_t_left_xywh',font = 'f_slider',
					cmd = on_adj},
	left_add	= {t='button',id=id+4,	xywh='s_cvbs_left_add_xywh',
					color	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},	
	left_value	= {t='static',id=id+5,	xywh='s_cvbs_left_value_xywh',trans = false},

	--up
	cap_up 		= {t='static',id=id+6,xywh='s_cvbs_cap_up_xywh',
					text='LA_UP',},
	up_subb		= {t='button',id=id+7,	xywh='s_cvbs_up_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},	
	t_up 		= {t='hslider',id=id+8,xywh='s_cvbs_t_up_xywh',font = 'f_slider',
					cmd = on_adj},	
	up_add		= {t='button',id=id+9,	xywh='s_cvbs_up_add_xywh',
					color	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},	
	up_value	= {t='static',id=id+10,	xywh='s_cvbs_up_value_xywh',trans = false},

		
	--right	
	right_subb	= {t='button',id=id+11,	xywh='s_cvbs_right_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},	
	cap_right 	= {t='static',id=id+12,xywh='s_cvbs_cap_right_xywh',
					text='LA_RIGHT',},
	t_right 	= {t='hslider',id=id+13,xywh='s_cvbs_t_right_xywh',font = 'f_slider',
					cmd = on_adj},	
	right_add		= {t='button',id=id+14,	xywh='s_cvbs_right_add_xywh',
					color	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},	
	right_value	= {t='static',id=id+15,	xywh='s_cvbs_right_value_xywh',trans = false},


	--down
	down_subb	= {t='button',id=id+16,	xywh='s_cvbs_down_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},	
	cap_down 	= {t='static',id=id+17,xywh='s_cvbs_cap_down_xywh',
					text='LA_DOWN',},
	t_down 		= {t='hslider',id=id+18,xywh='s_cvbs_t_down_xywh',font = 'f_slider',
					cmd = on_adj},
	down_add	= {t='button',id=id+19,	xywh='s_cvbs_down_add_xywh',
					color	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},	
	down_value	= {t='static',id=id+20,	xywh='s_cvbs_down_value_xywh',trans = false},
	
	tipinfo		= {t='static',id=id+21,	xywh='s_cvbs_tipinfo_xywh',	text='',trans = false},	
}

return w1_page_cvbsoffset



