--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_ddns.ddns_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local b_app_api = require("wnd.core.command.b_app_api")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local w1_key 	= require("wnd.w1_util.w1_key")
local b_dlg 			= require("wnd.core.b_dlg")
local util 			= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local w1_page_ddns 	= 
{
	data,
	ability,
	items,
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_ddns.s_768 =
{
	s_ddns_t_enable_xywh = {277,25,25,21},
	s_ddns_t2_name_xywh = {485,106,106,32},
	s_ddns_test_xywh = {281,234,80,32},
	s_ddns_tipinfo_xywh = {53,284,373,35},
};

w1_page_ddns.s_1280 = 
{
	s_ddns_t_enable_xywh = {455,36,48,30},
	s_ddns_t2_name_xywh = {758,150,200,45},
	s_ddns_test_xywh = {460,330,150,45},
	s_ddns_tipinfo_xywh = {100,400,700,50},
}

w1_page_ddns.s_1440 = 
{
	s_ddns_t_enable_xywh = {520,30,48,30},
	s_ddns_t2_name_xywh = {910,125,200,45},
	s_ddns_test_xywh = {527,280,150,45},
	s_ddns_tipinfo_xywh = {100,350,700,50},
}


w1_page_ddns.s_1080p = 
{
	s_ddns_t_enable_xywh = {520,36,48,30},
	s_ddns_t2_name_xywh = {910,150,200,45},
	s_ddns_test_xywh = {527,330,150,45},
	s_ddns_tipinfo_xywh = {100,400,700,50},
}

w1_page_ddns.s_2k = 
{
	s_ddns_t_enable_xywh = {693,48,64,40},
	s_ddns_t2_name_xywh = {1213,200,267,60},
	s_ddns_test_xywh = {703,440,200,60},
	s_ddns_tipinfo_xywh = {133,533,933,67},
}

w1_page_ddns.s_4k = 
{
	s_ddns_t_enable_xywh = {1040,72,96,60},
	s_ddns_t2_name_xywh = {1820,300,400,90},
	s_ddns_test_xywh = {1055,660,300,90},
	s_ddns_tipinfo_xywh = {200,800,1400,100},

}


local switch_prot = function(top, protocol, redraw)
	local cwnd = w1_page_ddns.wnd;
	local set_hide = function(id, hide)
		b_wnd_ex.set_hide(top, id, hide, false);
	end
	local function settext(id, str)
		b_wnd_ex.set_text(top, id, str, false);
	end
	
	local data = w1_page_ddns.data;
	local limits = w1_page_ddns.ability;
	local num = limits.num;	
	for i =1, num do
		local str = "list"..tostring(i)
		local prot = limits.ability[str].protocol
		if(protocol == prot)then
			data.protocol = prot;
			settext(cwnd.t_name.id, limits.ability[str].domain);
		
			if("" == limits.ability[str].suffix or limits.ability[str].suffix == nil)then
				data.suffix = "";
				b_wnd_ex.set_hide(top, cwnd.t2_name.id, true, false)
			else
				data.suffix = limits.ability[str].suffix;
				b_wnd_ex.set_hide(top, cwnd.t2_name.id, false, false)			
			end
			b_wnd_ex.set_text(top, cwnd.t2_name.id, data.suffix,false);
			
			if(1 == limits.ability[str].user_enable)then
				--[[data.user = limits.ability[str].user;
				data.passwd = limits.ability[str].passwd;
				settext(cwnd.t_account.id, data.user);
				b_wnd_ex.set_password(top, cwnd.t_pass.id, data.passwd, redraw)--]]
				
				b_wnd_ex.set_hide(top, cwnd.cap_account.id, false, false)
				b_wnd_ex.set_hide(top, cwnd.t_account.id, false, false)
				b_wnd_ex.set_hide(top, cwnd.cap_pass.id, false, false)
				b_wnd_ex.set_hide(top, cwnd.t_pass.id, false, false)
			else
				--[[data.user ="";
				data.passwd = "";
				settext(cwnd.t_account.id, "");
				b_wnd_ex.set_password(top, cwnd.t_pass.id, "", redraw)--]]
				b_wnd_ex.set_hide(top, cwnd.cap_account.id,true, false)
				b_wnd_ex.set_hide(top, cwnd.t_account.id,true, false)
				b_wnd_ex.set_hide(top, cwnd.cap_pass.id,true, false)
				b_wnd_ex.set_hide(top, cwnd.t_pass.id,true, false)
			end
		end
	end
	if redraw == true then
		b_dlg.dlg_set_redraw(top);
	end
end

local switch_id = function(top, protocol)
	for i=1, #w1_page_ddns.items do
		if(protocol == w1_page_ddns.items[i]) then
			return i-1
		end
		
	end
end

local refresh_enable = function(top, enable, redraw)
	local cwnd = w1_page_ddns.wnd;
	local data = w1_page_ddns.data;
	local limits = w1_page_ddns.ability;
	local function settext(id, str)
		b_wnd_ex.set_text(top, id, str,redraw);
	end
	local set_hide = function(id, hide)
		b_wnd_ex.set_hide(top, id, hide, redraw);
	end
	--Ȱѿؼȫ
	local sid = cwnd.cap_protocol.id;
	local eid = cwnd.test.id;
	for i=sid, eid do
		b_wnd_ex.set_hide(top, i, true, redraw);
	end
	if(enable) then	
		b_wnd_ex.set_hide(top, cwnd.test.id, false, redraw);
		local sid = cwnd.cap_protocol.id;
		local eid = cwnd.t_name.id;
		for i=sid, eid do
			b_wnd_ex.set_hide(top, i, false, redraw);
		end
		
		local num = limits.num;	
		if("" ~= data.protocol and nil ~= data.protocol)then
			for i =1, num do
				local str = "list"..tostring(i)
				local prot = limits.ability[str].protocol
				if(data.protocol == prot)then
					local id = switch_id(top, data.protocol)
					b_wnd_ex.set_sel(top, cwnd.t_protocol.id, id, redraw);
					b_wnd_ex.set_align(top, cwnd.t_name.id, b_ui.ALIGN.RIGHT, redraw);
					if(data.url == '') then
					--	settext(cwnd.t_name.id, '');--'dvr'
						if("" == limits.ability[str].suffix)then
							settext(cwnd.t_name.id, limits.ability[str].domain);
						else
							settext(cwnd.t_name.id, 'dvr');	
						end 
					else
						settext(cwnd.t_name.id, data.url);
					end	
					if("" == limits.ability[str].suffix)then
						b_wnd_ex.set_text(top, cwnd.t2_name.id, "",redraw);
						b_wnd_ex.set_hide(top, cwnd.t2_name.id, true, redraw)
					else
						b_wnd_ex.set_text(top, cwnd.t2_name.id, limits.ability[str].suffix,redraw);
						b_wnd_ex.set_hide(top, cwnd.t2_name.id, false, redraw)
					end
					
					if(1 == limits.ability[str].user_enable)then
						settext(cwnd.t_account.id, data.user);
						b_wnd_ex.set_password(top, cwnd.t_pass.id, data.passwd, redraw)
						
						b_wnd_ex.set_hide(top, cwnd.cap_account.id, false, redraw)
						b_wnd_ex.set_hide(top, cwnd.t_account.id, false, redraw)
						b_wnd_ex.set_hide(top, cwnd.cap_pass.id, false, redraw)
						b_wnd_ex.set_hide(top, cwnd.t_pass.id, false, redraw)
					else
						settext(cwnd.t_account.id, "");
						b_wnd_ex.set_password(top, cwnd.t_pass.id, "", redraw)
						b_wnd_ex.set_hide(top, cwnd.cap_account.id,true, redraw)
						b_wnd_ex.set_hide(top, cwnd.t_account.id,true, redraw)
						b_wnd_ex.set_hide(top, cwnd.cap_pass.id,true, redraw)
						b_wnd_ex.set_hide(top, cwnd.t_pass.id,true, redraw)
					end
				end
			end
		else
			local str = "list1"
			local prot = limits.ability[str].protocol
			data.protocol = prot;
			local id = switch_id(top, prot)
			b_wnd_ex.set_sel(top, cwnd.t_protocol.id, id, redraw);
		--	b_wnd_ex.set_align(top, cwnd.t_name.id, b_ui.ALIGN.RIGHT, redraw);
		
			
			if(limits.ability[str].domain == "")then
				data.url = limits.ability[str].domain
				settext(cwnd.t_name.id, "dvr");
			else
				data.url = limits.ability[str].domain
				settext(cwnd.t_name.id, limits.ability[str].domain);
			end
			
			if("" == limits.ability[str].suffix)then
				data.suffix = "";
				b_wnd_ex.set_text(top, cwnd.t2_name.id, "",redraw);
				b_wnd_ex.set_hide(top, cwnd.t2_name.id, true, redraw)
			else
				
				data.suffix = limits.ability[str].suffix;
				b_wnd_ex.set_text(top, cwnd.t2_name.id, data.suffix,redraw);
				b_wnd_ex.set_hide(top, cwnd.t2_name.id, false, redraw)			
			end
			
			if(1 == limits.ability[str].user_enable)then
				data.user = limits.ability[str].user;
				data.passwd = limits.ability[str].passwd;
				settext(cwnd.t_account.id, data.user);
				b_wnd_ex.set_password(top, cwnd.t_pass.id, data.passwd, redraw)
				
				b_wnd_ex.set_hide(top, cwnd.cap_account.id, false, redraw)
				b_wnd_ex.set_hide(top, cwnd.t_account.id, false, redraw)
				b_wnd_ex.set_hide(top, cwnd.cap_pass.id, false, redraw)
				b_wnd_ex.set_hide(top, cwnd.t_pass.id, false, redraw)
			else
				data.user ="";
				data.passwd = "";
				settext(cwnd.t_account.id, "");
				b_wnd_ex.set_password(top, cwnd.t_pass.id, "", redraw)
				b_wnd_ex.set_hide(top, cwnd.cap_account.id,true, redraw)
				b_wnd_ex.set_hide(top, cwnd.t_account.id,true, redraw)
				b_wnd_ex.set_hide(top, cwnd.cap_pass.id,true, redraw)
				b_wnd_ex.set_hide(top, cwnd.t_pass.id,true, redraw)
			end
		
		end	
		
	end	
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	w1_page_ddns.data = cfgdata.ddns;
	w1_page_ddns.ability = cfgdata.ddns_ability;
	local cwnd = w1_page_ddns.wnd;
	local data = cfgdata.ddns;
	local function settext(id, str)
		b_wnd_ex.set_text(top, id, str,false);
	end
	local function setcheck(id, str)
		b_wnd_ex.set_check(top, id, str,false);
	end
	setcheck(w1_page_ddns.wnd.t_enable.id,data.enable);
	
	w1_page_ddns.items = {};
	local num = cfgdata.ddns_ability.num
	for i =1, num do
		local str = "list"..tostring(i)
		local prot = cfgdata.ddns_ability.ability[str].protocol	
		table.insert(w1_page_ddns.items,prot)
	end
	b_wnd_ex.set_items(top, w1_page_ddns.wnd.t_protocol.id, w1_page_ddns.items, false);
	refresh_enable(top, data.enable, false);
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_ddns.wnd;
	local data = cfgdata.ddns;
	local enable = b_wnd_ex.get_check(top,cwnd.t_enable.id);
	data.enable = enable;
	--if(enable) then
	local protocol = b_wnd_ex.get_text(top,cwnd.t_protocol.id);
	data.protocol = protocol;
	local name = b_wnd_ex.get_text(top,cwnd.t_name.id);
	data.url = name;
	
	local limits = w1_page_ddns.ability;
	local num = limits.num;	
	for i =1, num do
		local str = "list"..tostring(i)
		local prot = limits.ability[str].protocol
		if(protocol == prot)then
			limits.ability[str].domain = data.url;
			if(1 == limits.ability[str].user_enable)then
				local account = b_wnd_ex.get_text(top,cwnd.t_account.id);
				data.user = account;
				local pass = b_wnd_ex.get_password(top,cwnd.t_pass.id);
				data.passwd = pass;
			else
				data.user = '';
				data.passwd = '';
			end
		end
	end

	return 0;
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true;
	local nlegalid = {};
	local cwnd = w1_page_ddns.wnd;
	local enable = b_wnd_ex.get_check(top,cwnd.t_enable.id);
	if(enable) then
		local protocol = b_wnd_ex.get_text(top,cwnd.t_protocol.id);
		if(protocol == 'no_ip' or protocol == 'dyndns' or protocol == '3322') then
			local legal = w1_legal.is_passempty(top, cwnd.t_pass.id);
			if(legal) then
				legalflag =false;
				table.insert(nlegalid, cwnd.t_pass.id);
			end
			local legal = w1_legal.is_empty(top, cwnd.t_account.id);
			if(legal) then
				legalflag =false;
				table.insert(nlegalid, cwnd.t_account.id);
			end	
		elseif(protocol == 'autodns' or protocol == 'sunellddns' or protocol == 'wboxddns') then
			
		end
		local legal = w1_legal.is_empty(top, cwnd.t_name.id);
		if(legal) then
			legalflag = false;
			table.insert(nlegalid, cwnd.t_name.id);
		end
	else
		legalflag = true;
	end
	if(legalflag) then
		return true, nil;
	else
		w1_wnd_util.setparamerr_str(STR('LA_NOT_EMPTY'));
		return false, nlegalid;
	end
end

local on_test =function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_ddns.wnd;
		local data = w1_page_ddns.data;
		local limits = w1_page_ddns.ability;

		local enable = b_wnd_ex.get_check(top,cwnd.t_enable.id);
		data.enable = enable;
		if(enable) then
			
			local protocol = b_wnd_ex.get_text(top,cwnd.t_protocol.id);
			data.protocol = protocol;
			
			local num = limits.num;	
			for i =1, num do
				local str = "list"..tostring(i)
				local prot = limits.ability[str].protocol
				if(protocol == prot)then
					local name = b_wnd_ex.get_text(top,cwnd.t_name.id);
					data.url = name;
					if(1 == limits.ability[str].user_enable)then
						local account = b_wnd_ex.get_text(top,cwnd.t_account.id);
						data.user = account;
						local pass = b_wnd_ex.get_password(top,cwnd.t_pass.id);
						data.passwd = pass;
					else
						data.user = '';
						data.passwd = '';
					end	
				end
			end
		else
			data.url = '';
			data.user = '';
			data.passwd = '';
		end
		b_app_api.channge_cursor(b_ui.CURSOR.JY_CURSOR_WAIT);
		local flag = b_app_api.test_ddns(data)
		b_app_api.channge_cursor(b_ui.CURSOR.JY_CURSOR_POINT);
		if(flag ==0)then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_TEST_OK'), true, false,false);
			w1_msgbox.set_func(okfunc_isempty,{top}, nil, nil);
			b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
		elseif(flag == 6) then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_TEST_429'), true, false,false);
			w1_msgbox.set_func(okfunc_isempty,{top}, nil, nil);
			b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
		else
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_TEST_FAIL'), true, false,false);
			w1_msgbox.set_func(okfunc_isempty,{top}, nil, nil);
			b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
		end
	end	
	return 0;
end

w1_page_ddns.timer_start = function()
	w1_page_ddns.timestart = true;
end

w1_page_ddns.timer_stop = function(top)
	w1_page_ddns.timestart = false;
	w1_wnd_util.tipclear(top, w1_page_ddns.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
end

w1_page_ddns.timerenevt = function(top)
	if(w1_page_ddns.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_ddns.wnd.tipinfo.id);
	end
	return 0;
end

w1_page_ddns.clear_data =function()
	w1_page_ddns.data = nil;
	w1_page_ddns.items = nil;
	w1_page_ddns.ability = nil;
end

w1_page_ddns.init =function (top)
	w1_wnd_util.cfgtab = {'ddns','ddns_ability'};
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);
	return 0;
end

local on_enable = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local check = b_wnd_ex.get_check(top, win_id);
		refresh_enable(top, check, false);
		b_dlg.dlg_set_redraw(top);
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_prot = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local protstr = b_wnd_ex.get_text(top, win_id);
		local prot;
		if(protstr == 'no_ip')then
			prot = 0;
		elseif(protstr == 'autodns')then
			prot = 1;
		elseif(protstr == 'dyndns')then
			prot = 2;
		elseif(protstr == '3322')then
			prot = 3;
		elseif(protstr == 'sunellddns')then
			prot = 4;
		elseif(protstr == 'wboxddns')then
			prot = 5;			
		end
		switch_prot(top, protstr, true);
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_url_name = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	--	refresh_data(top);
	end
	return 0;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local ret = nil;
		w1_wnd_util.uidatacheckfunc = uidatacheck;
		uitousercfg(top,b_app_cfg.user_cfg);
		w1_wnd_util.page_onapply(top);
		w1_wnd_util.tipdispon();		--ʾ
	end
	return 0;
end

w1_page_ddns.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	uitousercfg(top,b_app_cfg.user_cfg);
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_ddns.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_enable','t_enable','cap_protocol','t_protocol',
			'cap_name','t_name','t2_name',
			'cap_account','t_account','cap_pass','t_pass','test',
			'tipinfo', 'default', 'apply' },
	
	cap_enable 	= {t='static',		id=id+1,xywh='s_cfg_page_1_1',text='LA_ENABLE_DDNS'},
	t_enable 	= {t='tt_check', 	id=id+2,xywh='s_ddns_t_enable_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_enable},
	
	cap_protocol= {t='static',id=id+3,xywh='s_cfg_page_2_1',text='LA_PROTOCOL'},
	t_protocol 	= {t='combox',id=id+4,xywh='s_cfg_page_2_2',items={'no_ip','autodns','dyndns','3322'},
					trans = false, cmd = on_prot},
		
	cap_name 	= {t='static',id=id+5,xywh='s_cfg_page_3_1',text='LA_DOMAIN_NAME'},
	t_name 		= {t='edit',  id=id+6,xywh='s_cfg_page_3_2',cmd = on_url_name},
	t2_name		= {t='static',id=id+7,xywh='s_ddns_t2_name_xywh',text='.autoddns.com', trans = false,},
	
	
	cap_account = {t='static',id=id+8,xywh='s_cfg_page_4_1',text='LA_ACCOUNT'},
	t_account 	= {t='edit',  id=id+9,xywh='s_cfg_page_4_2',guide_text='LA_USER_NAME',cmd = on_update_param},
	
	cap_pass	= {t='static',id=id+10,xywh='s_cfg_page_5_1',text='LA_PASSWORD'},
	t_pass 		= {t='password',  id=id+11,xywh='s_cfg_page_5_2',guide_text='LA_PASSWORD',cmd = on_update_param},
	test 		= {t='button',id=id+12,	xywh='s_ddns_test_xywh', 	text='LA_CHECK_EMAIL',cmd=on_test},
	tipinfo		= {t='static',id=id+13,	xywh='s_ddns_tipinfo_xywh',	text='',trans = false},

	apply 		= {t='button',id=id+14,	xywh='s_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_ddns;



