--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 			= require("wnd.core.b_dlg")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_devm.devm_id
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local b_app_api 	= require("wnd.core.command.b_app_api");
local w1_id 	= require("wnd.w1_util.w1_id")
local w1_key 	= require("wnd.w1_util.w1_key")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local global_val	= require("wnd.global_val")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local w1_reset= require("wnd.w1_cfg.w1_reset")
local ok_opt = false			--ʾʱȷ 
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;

local w1_page_devm = 
{
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_devm.s_768 =
{
	s_devm_shutdown_img_xywh = {53,21,90,128},
	s_devm_reboot_img_xywh = {160,21,90,128},
	s_devm_exit_img_xywh = {266,21,90,128},
	s_devm_reset_img_xywh = {373,21,90,128},
	s_devm_cfg_import_img_xywh = {480,21,90,128},
	s_devm_cfg_export_img_xywh = {586,21,90,128},
	s_devm_upgrade_img_xywh = {53,163,90,128},
	s_devm_upgrade_cloud_img_xywh = {160,163,90,128},
	s_devm_net_packet_img_xywh = {266,163,90,128},
	s_devm_save_log_img_xywh = {373,163,90,128},
};

w1_page_devm.s_1280 = 
{
	s_devm_shutdown_img_xywh = {100,30,168,180},
	s_devm_reboot_img_xywh = {300,30,168,180},
	s_devm_exit_img_xywh = {500,30,168,180},
	s_devm_reset_img_xywh = {700,30,168,180},
	s_devm_cfg_import_img_xywh = {100,230,168,180},
	s_devm_cfg_export_img_xywh = {300,230,168,180},
	s_devm_upgrade_img_xywh	= {500,230,168,180},
	s_devm_upgrade_cloud_img_xywh	= {700,230,168,180},
	s_devm_net_packet_img_xywh = {100,430,168,180},
	s_devm_save_log_img_xywh = {300,430,168,180}
}
w1_page_devm.s_1440 = 
{
	s_devm_shutdown_img_xywh = {100,30,168,180},
	s_devm_reboot_img_xywh = {300,30,168,180},
	s_devm_exit_img_xywh = {500,30,168,180},
	s_devm_reset_img_xywh = {700,30,168,180},
	s_devm_cfg_import_img_xywh = {900,30,168,180},
	s_devm_cfg_export_img_xywh = {100,230,168,180},
	s_devm_upgrade_img_xywh	= {300,230,168,180},
	s_devm_upgrade_cloud_img_xywh	= {500,230,168,180},
	s_devm_net_packet_img_xywh = {700,230,168,180},
	s_devm_save_log_img_xywh = {900,230,168,180}

}

w1_page_devm.s_1080p = 
{
	s_devm_shutdown_img_xywh = {100,30,168,180},
	s_devm_reboot_img_xywh = {300,30,168,180},
	s_devm_exit_img_xywh = {500,30,168,180},
	s_devm_reset_img_xywh = {700,30,168,180},
	s_devm_cfg_import_img_xywh = {900,30,168,180},
	s_devm_cfg_export_img_xywh = {1100,30,168,180},
	s_devm_upgrade_img_xywh	= {100,230,168,180},
	s_devm_upgrade_cloud_img_xywh	= {300,230,168,180},
	s_devm_net_packet_img_xywh = {500,230,168,180},
	s_devm_save_log_img_xywh = {700,230,168,180}
	
}

w1_page_devm.s_2k = 
{
	s_devm_shutdown_img_xywh = {133,40,224,240},
	s_devm_reboot_img_xywh = {400,40,224,240},
	s_devm_exit_img_xywh = {667,40,224,240},
	s_devm_reset_img_xywh = {933,40,224,240},
	s_devm_cfg_import_img_xywh = {1200,40,224,240},
	s_devm_cfg_export_img_xywh = {1466,40,224,240},
	s_devm_upgrade_img_xywh	= {133,307,224,240},
	s_devm_upgrade_cloud_img_xywh	= {400,307,224,240},
	s_devm_net_packet_img_xywh = {667,307,224,240},
	s_devm_save_log_img_xywh = {933,307,224,240}

}

w1_page_devm.s_4k = 
{
	s_devm_shutdown_img_xywh = {200,60,336,360},
	s_devm_reboot_img_xywh = {600,60,336,360},
	s_devm_exit_img_xywh = {1000,60,336,360},
	s_devm_reset_img_xywh = {1400,60,336,360},
	s_devm_cfg_import_img_xywh = {1800,60,336,360},
	s_devm_cfg_export_img_xywh = {2200,60,336,360},
	s_devm_upgrade_img_xywh	= {200,460,336,360},
	s_devm_upgrade_cloud_img_xywh	= {600,460,336,360},
	s_devm_net_packet_img_xywh = {1000,460,336,360},
	s_devm_save_log_img_xywh = {1400,460,336,360}
}

--ҳʼʱٶȡҳҪ
w1_page_devm.init = function(top)
	local device_info = b_app_api.get_device_info();
	local nic_num = device_info.nic_num
	local tcpdump_support = device_info.tcpdump_support
	local cloud_update_support = global_val.get_cloud_update_support()

	if nic_num == 0 or tcpdump_support == 0 then
		b_wnd_ex.set_hide(top,w1_page_devm.wnd.net_packet.id,true,false)
	else
		b_wnd_ex.set_hide(top,w1_page_devm.wnd.net_packet.id,false,false)
	end
	
	if (cloud_update_support == false) then
		b_wnd_ex.set_hide(top,w1_page_devm.wnd.upgrade_cloud_img.id,true,false)
		local pos = SIZE('s_devm_upgrade_cloud_img_xywh');
		b_wnd_ex.move_pos(top, w1_page_devm.wnd.save_run_log.id, {pos[1], pos[2]},false);
		local pos = SIZE('s_devm_net_packet_img_xywh');
		b_wnd_ex.move_pos(top, w1_page_devm.wnd.net_packet.id, {pos[1], pos[2]},false);
	end			
	
	local run_log_flag = b_app_api.get_run_log_status()
	local dlg_w, dlg_h = global_val.get_size();
	local font = 80;
	if (dlg_w == 1024 or dlg_h == 768) then
		font = 40;
	elseif(dlg_w == 1280 or dlg_h == 1024) then
		font = 80;
	elseif(dlg_w == 1440 or dlg_h == 900) then
		font = 72;
	elseif(dlg_w == 1920 or dlg_h == 1080) then
		font = 80;
	elseif(dlg_w == 2560 or dlg_h == 1440) then
		font = 106;
	elseif(dlg_w == 3840 or dlg_h == 2160) then
		font = 160;
	end	
	
	if run_log_flag==0 then
		local imgs = {b_ui.ALIGN.LEFT, font,61703,61703, 61703}
		b_wnd_ex.set_t_imgs(top,w1_page_devm.wnd.save_run_log.id,imgs,false)
		b_wnd_ex.set_text(top,w1_page_devm.wnd.save_run_log.id,STR('LA_SAVE_RUN_LOG'),false)
	else
		local imgs = {b_ui.ALIGN.LEFT, font,61704,61704, 61704}
		b_wnd_ex.set_t_imgs(top,w1_page_devm.wnd.save_run_log.id,imgs,false)
		b_wnd_ex.set_text(top,w1_page_devm.wnd.save_run_log.id,STR('LA_STOP_RUN_LOG'),false)
	end
	return 0
end


w1_page_devm.set_disable = function(top, privilege, redraw)
	local status = true;
	if(privilege.system_maintenance) then
		status = false		
	end
	b_wnd_ex.set_disable(top, w1_page_devm.wnd.shutdown_img.id, status, redraw);
	b_wnd_ex.set_disable(top, w1_page_devm.wnd.reboot_img.id, status, redraw);
	b_wnd_ex.set_disable(top, w1_page_devm.wnd.reset_img.id, status, redraw);
	b_wnd_ex.set_disable(top, w1_page_devm.wnd.cfg_import_img.id, status, redraw);
	b_wnd_ex.set_disable(top, w1_page_devm.wnd.cfg_export_img.id, status, redraw);
	b_wnd_ex.set_disable(top, w1_page_devm.wnd.upgrade_img.id, status, redraw);
	b_wnd_ex.set_disable(top, w1_page_devm.wnd.upgrade_cloud_img.id, status, redraw);
	b_wnd_ex.set_disable(top, w1_page_devm.wnd.exit_img.id, false, redraw);
end
	
local okfunc_shutdown = function(param)
	b_app_api.shutdown();
end

local on_shutdown = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		--ٴȷ
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_SURE_SHUTDOWN'), true, true,false);
		w1_msgbox.set_func(okfunc_shutdown,{top}, nil, nil);
		b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)	
	end
	return 0;
end

local okfunc_reboot = function(param)
	b_app_api.reboot();
end

local on_reboot = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		--ٴȷ
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_SURE_RESTART'), true, true,false);
		w1_msgbox.set_func(okfunc_reboot,{top}, nil, nil);
		b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)	
	end
	return 0;
end

local okfunc_exit_system = function(param)
	ok_opt = true
	b_app_api.exit_system();
end

local on_exit = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local user_info = global_val.get_current_user_info();
		assert(user_info ~= nil and "table" == type(user_info))
		local enable_auto_login = b_app_api.get_auto_login(user_info.m_strUsername)
		if (0 ~= enable_auto_login) then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_CLOSE_AUTO'), true, false,false);
			w1_msgbox.set_func(nil,nil, nil, nil);
			b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)	
		else		
			--ٴȷ
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_SURE_LOGOUT'), true, true,false);
			ok_opt = false
			w1_msgbox.set_func(okfunc_exit_system,{top}, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)	
			if (true == ok_opt) then
				ok_opt = false
				return b_ui_msg.msg_on_exit_system
			end
		end	
	end
	return 0;
end

local okfunc_reset = function(param)
	local reset_flag = w1_reset.get_data_info();
	b_app_api.reset(reset_flag);
end

local on_reset = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		--ٴȷ
		w1_reset.set_dlgattr(STR('LA_TIP'), STR('LA_SURE_RESTORE'), true, true,false);
		w1_reset.set_func(okfunc_reset,{top}, nil, nil);
		b_dlg.post_modal(top, w1_key.DLG_MSG_RESET, 0, 0, nil);
	end
	return 0;
end

local okfunc_cfgimport = function(param)
	local ret = b_app_api.cfgimport().ret;
	if(ret == 0) then--ɹ
		return 0;
	elseif(ret == 1) then--U̲
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_USB_DISK_NOT_EXIST'), true, false,false);
	elseif(ret == 2)then--ļ
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_CON_FILE_NOT_EXIST'), true, false,false);
	elseif(ret == 3) then--ļʽ
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_CON_FILE_FORMAT_ERR'), true, false,false);
	end
	w1_msgbox.set_func(nil,nil, nil, nil);
	b_dlg.do_modal(param[1], w1_key.DLG_MSG_BOX, 0, 0, nil);
	return 0;
end

local on_cfgimport = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		--ٴȷ
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_TIP_CONF_IMPORT'), true, true,false);
		w1_msgbox.set_func(okfunc_cfgimport,{top}, nil, nil);
		b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
	end
	return 0;
end

local okfunc_cfgexport = function(param)
	local ret = b_app_api.cfgexport().ret;
	if(ret == 0) then--ɹ
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_EXPORT_SUCCESS'), true, false,false);
		w1_msgbox.set_func(nil,nil, nil, nil);
		b_dlg.do_modal(param[1], w1_key.DLG_MSG_BOX, 0, 0, nil);
	else--ʧ
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_TIP_EXPORT_FAIL'), true, false,false);
		w1_msgbox.set_func(nil,nil, nil, nil);
		b_dlg.do_modal(param[1], w1_key.DLG_MSG_BOX, 0, 0, nil);
	end
	return 0;
end

local on_cfgexport = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		--ٴȷ
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_TIP_CONF_EXPORT'), true, true,false);
		w1_msgbox.set_func(okfunc_cfgexport,{top}, nil, nil);
		b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
	end
	return 0;
end

local on_upgrade = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local upgradecameralist = {};
		b_app_api.set_update_type(1);
		b_app_api.mount_dev();
		local upgradedata = b_dlg.do_modal(top, w1_key.DLG_UPGRADEDECTORY, 0, 0, 1)
		if (nil ~= upgradedata and '' ~= upgradedata) then
			local paramdata = cjson.decode(upgradedata);
			upgradecameralist.path = paramdata.path
			upgradecameralist.size = paramdata.size
			local ret = b_app_api.upgrade_nvr(upgradecameralist)
			if ret == nil or ret.ret ~= 0 then
				w1_msgbox.set_dlgattr(STR(''), STR('LA_UPGRADE_FAIL_T'), true, false,false);
				w1_msgbox.set_func(nil,nil, nil, nil);
				b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
			end
		end
		b_app_api.unmount_dev();
	end
	return 0;
end

local upgrade_cloud = function(top)
	b_app_api.cloud_upgrade();
end

local on_upgrade_cloud = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local upg_flag = b_app_api.cloud_version_check().ret;
		local cwnd = w1_page_devm.wnd
		if upg_flag == 0 then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_SURE_UPGRADE'), true, true,false);
			w1_msgbox.set_func(upgrade_cloud, nil, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
			w1_msgbox.set_func(nil, nil, nil, nil);
		else
			if upg_flag == -1 then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_SERVER_CON_FAIL'), true, false,false);
			elseif upg_flag == 1 then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_LATEST_VERSION'), true, false,false);
			elseif upg_flag == 2 then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_NOT_MATCH_VERSION'), true, false,false);
			elseif upg_flag == 3 then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_DETECTION_FAIL'), true, false,false);
			end
			w1_msgbox.set_func(nil, nil, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_net_packet = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_dlg.do_modal(top, w1_key.DLG_NET_PACKET, 0, 0, nil)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_run_log = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local dlg_w, dlg_h = global_val.get_size();
		local font = 80;
		if (dlg_w == 1024 or dlg_h == 768) then
			font = 40;		
		elseif(dlg_w == 1280 or dlg_h == 1024) then
			font = 80;
		elseif(dlg_w == 1440 or dlg_h == 900) then
			font = 72;
		elseif(dlg_w == 1920 or dlg_h == 1080) then
			font = 80;
		elseif(dlg_w == 2560 or dlg_h == 1440) then
			font = 106;
		elseif(dlg_w == 3840 or dlg_h == 2160) then
			font = 160;
		end	
		local imgs = {}
		local run_log_flag = b_app_api.get_run_log_status()
		if run_log_flag==0 then
			b_app_api.mount_dev();
			local ret = b_app_api.creat_run_log();
			if ret ==1 then
				imgs = {b_ui.ALIGN.LEFT, font,61704,61704, 61704}
				b_wnd_ex.set_t_imgs(top,w1_page_devm.wnd.save_run_log.id,imgs,true)
				b_wnd_ex.set_text(top,w1_page_devm.wnd.save_run_log.id,STR('LA_STOP_RUN_LOG'),true)
			else
				if ret == -1 then
					w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_SNAPSHOT_NO_DEV'), true, false,false);
				elseif ret == -2 then
					w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_SAVE_FAIL'), true, false,false);
				end
				b_app_api.unmount_dev();
				w1_msgbox.set_func(nil, nil, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
			end
		else
			b_app_api.destroy_run_log()
			imgs = {b_ui.ALIGN.LEFT, font,61703,61703, 61703}
			b_wnd_ex.set_t_imgs(top,w1_page_devm.wnd.save_run_log.id,imgs,true)
			b_wnd_ex.set_text(top,w1_page_devm.wnd.save_run_log.id,STR('LA_SAVE_RUN_LOG'),true)
			b_app_api.unmount_dev();
		end
	end
	return 0;
end

w1_page_devm.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {	'shutdown_img','reboot_img','exit_img','reset_img','cfg_import_img', 'cfg_export_img', 
			'upgrade_img','upgrade_cloud_img','net_packet','save_run_log','default', 'apply' },
		
	shutdown_img 	= {t='tt_button',id=id+1,	xywh='s_devm_shutdown_img_xywh',text='LA_POWER',arrangement=2,
						t_imgs = {b_ui.ALIGN.LEFT, 'f_devimg', 'it_dev_shutdown','it_dev_shutdown', 'it_dev_shutdown'},	
						color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
						color_f= {'c_devm_page_bk', 'c_devm_board', 'c_devm_text_f'},
						cmd=on_shutdown},					
	reboot_img 	= {t='tt_button',id=id+2,	xywh='s_devm_reboot_img_xywh',text='LA_RESTART',arrangement=2,
						t_imgs = {b_ui.ALIGN.LEFT, 'f_devimg','it_dev_reboot','it_dev_reboot', 'it_dev_reboot'},	
						color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
						color_f= {'c_devm_page_bk', 'c_devm_board', 'c_devm_text_f'},
						cmd=on_reboot},
	exit_img 	= {t='tt_button',id=id+3,	xywh='s_devm_exit_img_xywh',text='LA_EXIT_SYSTEM',arrangement=2,
						t_imgs = {b_ui.ALIGN.LEFT, 'f_devimg','it_dev_exitsystem','it_dev_exitsystem', 'it_dev_exitsystem'},	
						color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
						color_f= {'c_devm_page_bk', 'c_devm_board', 'c_devm_text_f'},
						cmd=on_exit},
	reset_img 	= {t='tt_button',id=id+4,	xywh='s_devm_reset_img_xywh',text='LA_RESET_FACTORY',arrangement=2,
						t_imgs = {b_ui.ALIGN.LEFT, 'f_devimg','it_dev_reset','it_dev_reset', 'it_dev_reset'},	
						color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
						color_f= {'c_devm_page_bk', 'c_devm_board', 'c_devm_text_f'},
						cmd=on_reset},

	cfg_import_img 	= {t='tt_button',id=id+5,	xywh='s_devm_cfg_import_img_xywh',text='LA_CONF_IMPORT',arrangement=2,
						t_imgs = {b_ui.ALIGN.LEFT, 'f_devimg','it_dev_import','it_dev_import', 'it_dev_import'},	
						color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
						color_f= {'c_devm_page_bk', 'c_devm_board', 'c_devm_text_f'},
						cmd=on_cfgimport},
						
	cfg_export_img 	= {t='tt_button',id=id+6,	xywh='s_devm_cfg_export_img_xywh',text='LA_CONF_EXPORT',arrangement=2,
						t_imgs = {b_ui.ALIGN.LEFT, 'f_devimg','it_dev_export','it_dev_export', 'it_dev_export'},	
						color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
						color_f= {'c_devm_page_bk', 'c_devm_board', 'c_devm_text_f'},
						cmd=on_cfgexport},
						
	upgrade_img 	= {t='tt_button',id=id+7,	xywh='s_devm_upgrade_img_xywh',text='LA_FW_UPDATE',arrangement=2,
						t_imgs = {b_ui.ALIGN.LEFT, 'f_devimg','it_dev_upgrade','it_dev_upgrade', 'it_dev_upgrade'},	
						color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
						color_f= {'c_devm_page_bk', 'c_devm_board', 'c_devm_text_f'},
						cmd=on_upgrade},
	upgrade_cloud_img= {t='tt_button',id=id+8,	xywh='s_devm_upgrade_cloud_img_xywh',text='LA_CLOUD_UPDATE',arrangement=2,
						t_imgs = {b_ui.ALIGN.LEFT, 'f_devimg','it_dev_upgrade_cloud','it_dev_upgrade_cloud', 'it_dev_upgrade_cloud'},	
						color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
						color_f= {'c_devm_page_bk', 'c_devm_board', 'c_devm_text_f'},
						cmd=on_upgrade_cloud},
						
	net_packet= {t='tt_button',id=id+9,	xywh='s_devm_save_log_img_xywh',text='LA_NET_PACKET',arrangement=2,
						t_imgs = {b_ui.ALIGN.LEFT, 'f_devimg','it_net_packet','it_net_packet', 'it_net_packet'},	
						color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
						color_f= {'c_devm_page_bk', 'c_devm_board', 'c_devm_text_f'},
						cmd=on_net_packet},
	
	save_run_log = {t='tt_button',id=id+10,	xywh='s_devm_net_packet_img_xywh',text='LA_SAVE_RUN_LOG',arrangement=2,
						t_imgs = {b_ui.ALIGN.LEFT, 'f_devimg','it_dev_save_run_log','it_dev_save_run_log', 'it_dev_save_run_log'},	
						color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
						color_f= {'c_devm_page_bk', 'c_devm_board', 'c_devm_text_f'},
						cmd=on_run_log},

	default = {t='button',	id=id+11,	xywh='s_cfg_default_xywh',		text='LA_DEFAULT',cmd=on_default,	hide = true},
	apply 	= {t='button',	id=id+12,	xywh='s_cfg_apply_xywh', 		text='LA_APPLY',cmd=on_apply,		hide = true},
}

return w1_page_devm



