--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/4/26
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_dis_cal.dis_cal_id
local w1_key 		= require("wnd.w1_util.w1_key")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local util 			= require("wnd.core.util")
local w1_msgbox		= require("wnd.w1_util.w1_msgbox")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local b_app_cfg  = require("wnd.core.b_app_cfg")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_app_api = require("wnd.core.command.b_app_api")
local global_val= require("wnd.global_val")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color

local time_start = 0;
local channel_num = 0
local w1_page_dis_cal = 
{
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_dis_cal.s_768 =
{
	s_dis_cal_t_expect_time_xywh = {281,106,98,32},
	s_dis_cal_t_expect_time_u_xywh = {385,106,98,32},
	s_dis_cal_t_record_time_s_xywh = {273,149,160,32},
	s_dis_cal_t_record_time_e_xywh = {441,149,42,32},
	s_dis_cal_t_record_time_u_xywh = {489,149,10,32},
	s_dis_cal_hline_xywh = {53,206,662,1},
	s_dis_cal_t_result_u1_xywh = {361,305,42,56},
	s_dis_cal_t_result_u2_xywh = {403,305,42,56},
	s_dis_cal_t_result_u3_xywh = {446,305,42,56},
	s_dis_cal_t_result_xywh = {288,291,64,85},
	s_dis_cal_cap_result_xywh = {53,234,373,32},
};

w1_page_dis_cal.s_1280 = 
{
	s_dis_cal_t_expect_time_xywh = {460,150,145,45},
	s_dis_cal_t_expect_time_u_xywh = {615,150,145,45},
	s_dis_cal_t_record_time_s_xywh = {445,210,240,45},
	s_dis_cal_t_record_time_e_xywh = {700,210,60,45},
	s_dis_cal_t_record_time_u_xywh = {770,210,20,45},
	s_dis_cal_hline_xywh = {100,290,700,2},
	s_dis_cal_t_result_u1_xywh = {577,430,80,80},
	s_dis_cal_t_result_u2_xywh = {657,430,80,80},
	s_dis_cal_t_result_u3_xywh = {737,430,80,80},
	s_dis_cal_t_result_xywh = {440,410,120,120},
	s_dis_cal_cap_result_xywh = {100,330,500,45},
}

w1_page_dis_cal.s_1440 = 
{
	s_dis_cal_t_expect_time_xywh = {530,125,185,45},
	s_dis_cal_t_expect_time_u_xywh = {725,125,185,45},
	s_dis_cal_t_record_time_s_xywh = {515,175,300,45},
	s_dis_cal_t_record_time_e_xywh = {830,175,80,45},
	s_dis_cal_t_record_time_u_xywh = {920,175,20,45},
	s_dis_cal_hline_xywh = {100,245,850,2},
	s_dis_cal_t_result_u1_xywh = {677,370,80,80},
	s_dis_cal_t_result_u2_xywh = {757,370,80,80},
	s_dis_cal_t_result_u3_xywh = {837,370,80,80},
	s_dis_cal_t_result_xywh = {540,350,120,120},
	s_dis_cal_cap_result_xywh = {100,275,600,45},
}

w1_page_dis_cal.s_1080p = 
{
	s_dis_cal_t_expect_time_xywh = {527,150,185,45},
	s_dis_cal_t_expect_time_u_xywh = {722,150,185,45},
	s_dis_cal_t_record_time_s_xywh = {512,210,300,45},
	s_dis_cal_t_record_time_e_xywh = {827,210,80,45},
	s_dis_cal_t_record_time_u_xywh = {917,210,20,45},
	s_dis_cal_hline_xywh = {100,290,1242,2},
	s_dis_cal_t_result_u1_xywh = {677,430,80,80},
	s_dis_cal_t_result_u2_xywh = {757,430,80,80},
	s_dis_cal_t_result_u3_xywh = {837,430,80,80},
	s_dis_cal_t_result_xywh = {540,410,120,120},
	s_dis_cal_cap_result_xywh = {100,330,700,45},
}

w1_page_dis_cal.s_2k = 
{
	s_dis_cal_t_expect_time_xywh = {703,200,247,60},
	s_dis_cal_t_expect_time_u_xywh = {963,200,247,60},
	s_dis_cal_t_record_time_s_xywh = {683,280,400,60},
	s_dis_cal_t_record_time_e_xywh = {1103,280,107,60},
	s_dis_cal_t_record_time_u_xywh = {1222,280,27,60},
	s_dis_cal_hline_xywh = {133,387,1656,3},
	s_dis_cal_t_result_u1_xywh = {903,573,107,107},
	s_dis_cal_t_result_u2_xywh = {1009,573,107,107},
	s_dis_cal_t_result_u3_xywh = {1116,573,107,107},
	s_dis_cal_t_result_xywh = {720,547,160,160},
	s_dis_cal_cap_result_xywh = {133,440,900,60},
}

w1_page_dis_cal.s_4k = 
{
	s_dis_cal_t_expect_time_xywh = {1054,300,370,90},
	s_dis_cal_t_expect_time_u_xywh = {1444,300,370,90},
	s_dis_cal_t_record_time_s_xywh = {1024,420,600,90},
	s_dis_cal_t_record_time_e_xywh = {1654,420,160,90},
	s_dis_cal_t_record_time_u_xywh = {1834,420,40,90},
	s_dis_cal_hline_xywh = {200,580,2484,4},
	s_dis_cal_t_result_u1_xywh = {1354,860,160,160},
	s_dis_cal_t_result_u2_xywh = {1514,860,160,160},
	s_dis_cal_t_result_u3_xywh = {1674,860,160,160},
	s_dis_cal_t_result_xywh = {954,720,400,400},
	s_dis_cal_cap_result_xywh = {200,660,1400,90},
}

w1_page_dis_cal.clear_data = function()
	w1_page_dis_cal.data = nil;
end	

local adjust = function (value)
	local t1,t2 = math.modf(value);
	if t1 >= 1000 then
		return tostring(t1)
	elseif t1 >= 100 then
		local value = tonumber(string.format('%.1f',t2))
		if value > 0 then
			t1 = t1 + value
		end
		return tostring(t1);
	else
		local value = tonumber(string.format('%.2f',t2))
		if value > 0 then
			t1 = t1 + value
		end
		return tostring(t1);
	end
end

local calculation = function (top)
	local c_wnd = w1_page_dis_cal.wnd;
	local cfgdata = w1_page_dis_cal.data;
	local sel = b_wnd_ex.get_sel(top, c_wnd.t_mode.id);
	local total_rate = 0;
	local total_bitrates = b_app_api.get_all_bitrate();
	total_rate = total_bitrates * 1024
	local total_str = tostring(string.format("%0.2f", total_bitrates)).."  Mbps"
	b_wnd_ex.set_text(top,c_wnd.t_total_bitrates.id,total_str,false)
	if sel == 0 then
		local value = b_wnd_ex.get_value(top, c_wnd.t_expect_time.id);
		local sel_u = b_wnd_ex.get_sel(top, c_wnd.t_expect_time_u.id);
		local hour = b_wnd_ex.get_value(top, c_wnd.t_record_time_e.id);
		local time = 0;
		local space = 0;
		if sel_u == 0 then
			time = value * hour * 60 * 60;
		elseif sel_u == 1 then
			time = value * 7 * hour * 60 * 60;
		else
			time = value * 30 * hour * 60 * 60;
		end
		space = time * total_rate/8;
		space = space * 1024 / 1000 / 1000 / 1000;
		if space >= 1000 then
			space = space / 1000;
			if space < 10000 then
				b_wnd_ex.set_text(top, c_wnd.t_result.id, adjust(space), false);
			else
				b_wnd_ex.set_text(top, c_wnd.t_result.id, '0', false);
			end
			b_wnd_ex.set_text(top, c_wnd.t_result_u1.id, 'TB', false);
		else
			b_wnd_ex.set_text(top, c_wnd.t_result.id, adjust(space), false);
			b_wnd_ex.set_text(top, c_wnd.t_result_u1.id, 'GB', false);
		end
		b_wnd_ex.set_text(top, c_wnd.cap_result.id, STR('LA_REQ_DIS_SPACE'),false);
	else
		local value = b_wnd_ex.get_value(top, c_wnd.t_expect_time.id);
		local sel_u = b_wnd_ex.get_sel(top, c_wnd.t_expect_time_u.id);
		local hour = b_wnd_ex.get_value(top, c_wnd.t_record_time_e.id);
		local check_d = b_wnd_ex.get_check(top, c_wnd.t_result_u1.id);
		local sapce = 0;
		if sel_u == 0 then
			space = value * 1000 * 1000 * 1000 * 1000 * 8;
		else
			space = value * 1000 *1000 * 1000 * 8;
		end
		local unit = b_wnd_ex.get_text(top,c_wnd.t_expect_time_u.id)
		local size = b_wnd_ex.get_value(top,c_wnd.t_expect_time.id)..unit
		local str = string.gsub(STR('LA_VIDEO_SAVE_TIME'), '*' ,size); 
		b_wnd_ex.set_text(top, c_wnd.cap_result.id, str,false);
		if total_rate == 0 then
			b_wnd_ex.set_text(top, c_wnd.t_result.id, 0, false);
			return
		end
		total_rate = total_rate * 1024;
		time = space / total_rate;
		local day = time / 60 / 60 / hour;
		local week = time / 60 / 60 / hour / 7;
		local month = time / 60 / 60 /hour / 30;
		if check_d == true then
			if day < 10000 then
				b_wnd_ex.set_text(top, c_wnd.t_result.id, adjust(day), false);
			else
				b_wnd_ex.set_text(top, c_wnd.t_result.id, '0', false);
			end
		end
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	w1_page_dis_cal.data = cfgdata;
	calculation(top);
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	return 0
end

local limit_maximum = function(top)
	local c_wnd = w1_page_dis_cal.wnd;
	local value = b_wnd_ex.get_value(top, c_wnd.t_expect_time.id);
	local sel = b_wnd_ex.get_sel(top, c_wnd.t_mode.id);
	local sel_u = b_wnd_ex.get_sel(top, c_wnd.t_expect_time_u.id);
	if sel == 0 then
		if sel_u == 0 then
			b_wnd_ex.set_range(top,c_wnd.t_expect_time.id,{0,600},false);
		elseif sel_u == 1 then
			b_wnd_ex.set_range(top,c_wnd.t_expect_time.id,{0,85},false);
		else
			b_wnd_ex.set_range(top,c_wnd.t_expect_time.id,{0,20},false);
		end
	else
		if sel_u == 0 then
			b_wnd_ex.set_range(top,c_wnd.t_expect_time.id,{0,200},false);
		else
			b_wnd_ex.set_range(top,c_wnd.t_expect_time.id,{0,200000},false);
		end
	end
end

--ҳʼʱٶȡҳҪ
w1_page_dis_cal.init = function(top)
	w1_wnd_util.cfgtab = {'encode'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	limit_maximum(top)
	return 0
end

local on_change_mode = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local c_wnd = w1_page_dis_cal.wnd;
		local items = {};
		local sel = b_wnd_ex.get_sel(top, c_wnd.t_mode.id);
		if sel == 0 then
			b_wnd_ex.set_text(top, c_wnd.cap_expect_time.id,STR('LA_EXPECT_SAVE_TIME'),false);
			items[1] = STR('LA_DAY');
			items[2] = STR('LA_WEEK');
			items[3] = STR('LA_MONTH');
			b_wnd_ex.set_items(top, c_wnd.t_expect_time_u.id, items, false);
			b_wnd_ex.set_sel(top, c_wnd.t_expect_time_u.id, 0, false);
			b_wnd_ex.set_text(top, c_wnd.cap_result.id, STR('LA_REQ_DIS_SPACE'),false);
			b_wnd_ex.set_check(top, c_wnd.t_result_u1.id, true, false);
		else
			b_wnd_ex.set_text(top, c_wnd.cap_expect_time.id,STR('LA_DISK_CAPACITY_T'),false);
			items[1] = 'TB';
			items[2] = 'GB';
			b_wnd_ex.set_items(top, c_wnd.t_expect_time_u.id, items, false);
			b_wnd_ex.set_sel(top, c_wnd.t_expect_time_u.id, 0, false);
			local size = b_wnd_ex.get_value(top,c_wnd.t_expect_time.id)..'TB'
			local str = string.gsub(STR('LA_VIDEO_SAVE_TIME'), '*' ,size); 
			b_wnd_ex.set_text(top, c_wnd.cap_result.id, str,false);
			b_wnd_ex.set_text(top, c_wnd.t_result_u1.id, STR('LA_DAY'), false);
			b_wnd_ex.set_check(top, c_wnd.t_result_u1.id, true, false);
		end
		limit_maximum(top);
		calculation(top);
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_change_time = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		calculation(top);
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_change_time_unit = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		limit_maximum(top);
		calculation(top);
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_change_record_time_slider = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local c_wnd = w1_page_dis_cal.wnd;
		local value = b_wnd_ex.get_value(top, win_id);
		b_wnd_ex.set_value(top,c_wnd.t_record_time_e.id,value,false);
		calculation(top);
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_change_unit = function(top, win_id, vmsg, x, y)
	if(b_ui.LBUTTONCLK == vmsg)then
		local c_wnd = w1_page_dis_cal.wnd;
		b_wnd_ex.set_check(top, c_wnd.t_result_u1.id, false, false);
		b_wnd_ex.set_check(top, win_id, true, false);
		calculation(top);
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_change_record_time_edit = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local c_wnd = w1_page_dis_cal.wnd;
		local value = b_wnd_ex.get_value(top, win_id);
		b_wnd_ex.set_value(top,c_wnd.t_record_time_s.id,value,false);
		calculation(top);
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

w1_page_dis_cal.clear_data = function()
	w1_page_dis_cal.data = nil;
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

w1_page_dis_cal.timer_start = function()
end

w1_page_dis_cal.timer_stop = function(top)
end

w1_page_dis_cal.timerenevt = function(top)
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	return 0
end

w1_page_dis_cal.apply =function(top)
	return 0;
end

w1_page_dis_cal.on_pre_show = function(top)
	local c_wnd = w1_page_dis_cal.wnd;
	channel_num = global_val.get_channelnum();
	b_wnd_ex.set_sel(top, c_wnd.t_mode.id, 0, false);
	b_wnd_ex.set_value(top, c_wnd.t_expect_time.id, 0, false);
	b_wnd_ex.set_value(top, c_wnd.t_record_time_s.id, 24, false)
	b_wnd_ex.set_value(top, c_wnd.t_record_time_e.id, 24, false)
	b_wnd_ex.set_text(top, c_wnd.cap_expect_time.id,STR('LA_EXPECT_SAVE_TIME'),false);
	local items = {};
	items[1] = STR('LA_DAY');
	items[2] = STR('LA_WEEK');
	items[3] = STR('LA_MONTH');
	b_wnd_ex.set_items(top, c_wnd.t_expect_time_u.id, items, false);
	b_wnd_ex.set_sel(top, c_wnd.t_expect_time_u.id, 0, false);
	b_wnd_ex.set_text(top, c_wnd.cap_result.id, STR('LA_REQ_DIS_SPACE'),false);
	b_wnd_ex.set_check(top, c_wnd.t_result_u1.id, true, false);
end

w1_page_dis_cal.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_mode', 't_mode', 'cap_expect_time', 't_expect_time', 't_expect_time_u', 
	'cap_record_time', 't_record_time_s', 't_record_time_e', 't_record_time_u','cap_total_bitrates','t_total_bitrates',
	'hline','cap_result', 't_result', 't_result_u1',},
	cap_total_bitrates  = {t='static',	id=id+1,xywh='s_cfg_page_1_1',text='LA_TATOL_BITRATES'},
	t_total_bitrates = {t='static', 	id=id+2,xywh='s_cfg_page_1_2'},
	
	cap_mode	= {t='static',	id=id+3,xywh='s_cfg_page_2_1',text='LA_CAL_MODE'},
	t_mode	 	= {t='combox',	id=id+4,xywh='s_cfg_page_2_2',items={'LA_COM_CAP','LA_COM_TIME'},cmd = on_change_mode,},
	cap_expect_time = {t='static',	id=id+5,xywh='s_cfg_page_3_1',text='LA_EXPECT_SAVE_TIME'},
	t_expect_time = {t='edit_num', 	id=id+6,xywh='s_dis_cal_t_expect_time_xywh',cmd = on_change_time},
	t_expect_time_u	= {t='combox',	id=id+7,xywh='s_dis_cal_t_expect_time_u_xywh',
					items={'LA_DAY','LA_WEEK','LA_MONTH'},cmd = on_change_time_unit,},
	cap_record_time = {t='static',	id=id+8,xywh='s_cfg_page_4_1',text='LA_DAILY_TIME'},
	t_record_time_s	= {t='hslider',id=id+9,xywh='s_dis_cal_t_record_time_s_xywh',	
					font = 'f_slider', min_value = 0, max_value = 24,cmd=on_change_record_time_slider},
	t_record_time_e = {t='edit_num', 	id=id+10,range={0,24},xywh='s_dis_cal_t_record_time_e_xywh',cmd = on_change_record_time_edit},
	t_record_time_u = {t='static',	id=id+11,xywh='s_dis_cal_t_record_time_u_xywh',text='h',trans=false},
	
	hline 	= {t='hline', id=id+12,xywh='s_dis_cal_hline_xywh'},
	cap_result = {t='static',	id=id+13,xywh='s_dis_cal_cap_result_xywh',text='LA_REQ_DIS_SPACE'},
	t_result_u1 	= {t='checktextimgbtn',id=id+14,	xywh='s_dis_cal_t_result_u1_xywh',text='GB',trans = false,font = 'f_grade6',
						t_imgs = {b_ui.ALIGN.LEFT, 'f_dis_point','it_pointimg','it_pointimg', 'it_pointimg'},	
						color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
						color_c= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_disk_cal_c'}},
	t_result	 	= {t='jigsaw_puzzle',id=id+17,	xywh='s_dis_cal_t_result_xywh',text='0',trans = false,font = 'f_grade1',
						t_imgs = {b_ui.ALIGN.LEFT, 'f_dis_circle','it_circle_l','it_circle_r', 'it_circle_r'},
						color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_disk_cal_c'},
						color_f= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_disk_cal_c'}},
}

return w1_page_dis_cal



