--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_basic.dst_id
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local b_dlg 	= require("wnd.core.b_dlg")
local w1_key 	= require("wnd.w1_util.w1_key")
local b_app_cfg  = require("wnd.core.b_app_cfg")

local w1_page_dst = 
{
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_dst.s_768 =
{
	s_cfg_dst_cdstime_xywh = {53,21,213,35},
	s_cfg_dst_tdstime_xywh = {376,25,25,35},
	s_cfg_dst_cstime_xywh = {53,64,149,35},
	s_cfg_dst_tsmonth_xywh = {229,67,74,28},
	s_cfg_dst_tsorder_xywh = {304,67,74,28},
	s_cfg_dst_tsweek_xywh = {378,67,74,28},
	s_cfg_dst_tsmoment_xywh = {453,67,74,28},
	s_cfg_dst_cetime_xywh = {53,106,149,35},
	s_cfg_dst_temonth_xywh = {229,110,74,28},
	s_cfg_dst_teorder_xywh = {304,110,74,28},
	s_cfg_dst_teweek_xywh = {378,110,74,28},
	s_cfg_dst_temoment_xywh = {453,110,74,28},
	s_cfg_dst_coffsettime_xywh = {53,149,149,35},
	s_cfg_dst_toffsettime_xywh = {229,152,74,28},
	s_cfg_dst_tipinfo_xywh = {53,220,373,35},
};

w1_page_dst.s_1280 = 
{
	s_cfg_dst_cdstime_xywh = {100,30, 400, 50},
	s_cfg_dst_tdstime_xywh = {615,36, 48, 50},
	s_cfg_dst_cstime_xywh = {100,90, 240, 50},
	s_cfg_dst_tsmonth_xywh = {340,95, 140, 40},
	s_cfg_dst_tsorder_xywh = {480,95, 140, 40},
	s_cfg_dst_tsweek_xywh = {620,95, 140, 40},
	s_cfg_dst_tsmoment_xywh = {760,95, 140, 40},
	s_cfg_dst_cetime_xywh = {100,150, 240, 50},
	s_cfg_dst_temonth_xywh = {340,155, 140, 40},
	s_cfg_dst_teorder_xywh = {480,155, 140, 40},
	s_cfg_dst_teweek_xywh = {620,155, 140, 40},
	s_cfg_dst_temoment_xywh = {760,155, 140, 40},
	s_cfg_dst_coffsettime_xywh = {100,210, 240, 50},
	s_cfg_dst_toffsettime_xywh = {340,215, 140, 40},
	s_cfg_dst_tipinfo_xywh = {100,310,700,50},
	
};
w1_page_dst.s_1440 = 
{
	s_cfg_dst_cdstime_xywh = {100,30, 400, 50},
	s_cfg_dst_tdstime_xywh = {610,30, 48, 50},
	
	s_cfg_dst_cstime_xywh = {100,80, 240, 50},
	s_cfg_dst_tsmonth_xywh = {340,84, 140, 40},
	s_cfg_dst_tsorder_xywh = {480,84, 140, 40},
	s_cfg_dst_tsweek_xywh = {620,84, 140, 40},
	s_cfg_dst_tsmoment_xywh = {760,84, 140, 40},
	s_cfg_dst_cetime_xywh = {100,130, 240, 50},
	s_cfg_dst_temonth_xywh = {340,134, 140, 40},
	s_cfg_dst_teorder_xywh = {480,134, 140, 40},
	s_cfg_dst_teweek_xywh = {620,134, 140, 40},
	s_cfg_dst_temoment_xywh = {760,134, 140, 40},
	s_cfg_dst_coffsettime_xywh = {100,180, 240, 50},
	s_cfg_dst_toffsettime_xywh = {340,184, 140, 40},
	s_cfg_dst_tipinfo_xywh = {100,310,700,50},	
};
w1_page_dst.s_1080p = 
{
	s_cfg_dst_cdstime_xywh = {100,30, 400, 50},
	s_cfg_dst_tdstime_xywh = {705,36, 48, 50},
	s_cfg_dst_cstime_xywh = {100,90, 280, 50},
	s_cfg_dst_tsmonth_xywh = {430,95, 140, 40},
	s_cfg_dst_tsorder_xywh = {570,95, 140, 40},
	s_cfg_dst_tsweek_xywh = {710,95, 140, 40},
	s_cfg_dst_tsmoment_xywh = {850,95, 140, 40},
	s_cfg_dst_cetime_xywh = {100,150, 280, 50},
	s_cfg_dst_temonth_xywh = {430,155, 140, 40},
	s_cfg_dst_teorder_xywh = {570,155, 140, 40},
	s_cfg_dst_teweek_xywh = {710,155, 140, 40},
	s_cfg_dst_temoment_xywh = {850,155, 140, 40},
	s_cfg_dst_coffsettime_xywh = {100,210, 280, 50},
	s_cfg_dst_toffsettime_xywh = {430,215, 140, 40},
	s_cfg_dst_tipinfo_xywh = {100,310,700,50},
	
};
w1_page_dst.s_2k = 
{
	s_cfg_dst_cdstime_xywh = {133,40,533,67},
	s_cfg_dst_tdstime_xywh = {940,48,63,67},
	s_cfg_dst_cstime_xywh = {133,120,373,67},
	s_cfg_dst_tsmonth_xywh = {573,127,187,53},
	s_cfg_dst_tsorder_xywh = {760,127,187,53},
	s_cfg_dst_tsweek_xywh = {946,127,187,53},
	s_cfg_dst_tsmoment_xywh = {1133,127,187,53},
	s_cfg_dst_cetime_xywh = {133,200,373,67},
	s_cfg_dst_temonth_xywh = {573,207,187,53},
	s_cfg_dst_teorder_xywh = {760,207,187,53},
	s_cfg_dst_teweek_xywh = {946,207,187,53},
	s_cfg_dst_temoment_xywh = {1133,207,187,53},
	s_cfg_dst_coffsettime_xywh = {133,280,373,67},
	s_cfg_dst_toffsettime_xywh = {573,287,187,53},
	s_cfg_dst_tipinfo_xywh = {133,413,933,67},

};
w1_page_dst.s_4k = 
{
	s_cfg_dst_cdstime_xywh = {200,60,800,100},
	s_cfg_dst_tdstime_xywh = {1410,72,96,100},
	s_cfg_dst_cstime_xywh = {200,180,560,100},
	s_cfg_dst_tsmonth_xywh = {860,190,280,80},
	s_cfg_dst_tsorder_xywh = {1140,190,280,80},
	s_cfg_dst_tsweek_xywh = {1420,190,280,80},
	s_cfg_dst_tsmoment_xywh = {1700,190,280,80},
	s_cfg_dst_cetime_xywh = {200,300,560,100},
	s_cfg_dst_temonth_xywh = {860,310,280,80},
	s_cfg_dst_teorder_xywh = {1140,310,280,80},
	s_cfg_dst_teweek_xywh = {1420,310,280,80},
	s_cfg_dst_temoment_xywh = {1700,310,280,80},
	s_cfg_dst_coffsettime_xywh = {200,420,560,100},
	s_cfg_dst_toffsettime_xywh = {860,430,280,80},
	s_cfg_dst_tipinfo_xywh = {200,620,1400,100},

};

local month_str =
{
	'LA_JANUARY', 		'LA_FEBRUARY',	'LA_MARCH',		'LA_APRIL',
	'LA_MAY',			'LA_JUNE',		'LA_JULY',			'LA_AUGUST',
	'LA_SEPTEMBER',	'LA_OCTOBER',	'LA_NOVEBER',		'LA_DECEMBER',
}

local order_str =
{
	'LA_FIRST',		'LA_SECOND',		'LA_THIRD',
	'LA_FOURTH', 		'LA_LAST_ONE'
}

local week_str =
{
	'LA_MONDAY_T',		'LA_TUESDAY_T',		'LA_WEDNESDAY_T',
	'LA_THUSDAY_T',		'LA_FRIDAY_T',		'LA_SATURDAY_T',
	'LA_SUNDAY_T',
}

local time24_str =
{
	'0:00',		'0:30',		'1:00',		'1:30',		'2:00',		'2:30',		'3:00',		'3:30',	
	'4:00',		'4:30',		'5:00',		'5:30',		'6:00',		'6:30',		'7:00',		'7:30',	
	'8:00',		'8:30',		'9:00',		'9:30',		'10:00',	'10:30',	'11:00',	'11:30',	
	'12:00',	'12:30',	'13:00',	'13:30',	'14:00',	'14:30',	'15:00',	'15:30',	
	'16:00',	'16:30',	'17:00',	'17:30',	'18:00',	'18:30',	'19:00',	'19:30',	
	'20:00',	'20:30',	'21:00',	'21:30',	'22:00',	'22:30',	'23:00',	'23:30'
}

local time12_str =
{
	'12:00 AM',	'12:30 AM',	'1:00 AM',	'1:30 AM',	'2:00 AM',	'2:30 AM',	
	'3:00 AM',	'3:30 AM',	'4:00 AM',	'4:30 AM',	'5:00 AM',	'5:30 AM',
	'6:00 AM',	'6:30 AM',	'7:00 AM',	'7:30 AM',	'8:00 AM',	'8:30 AM',
	'9:00 AM',	'9:30 AM',	'10:00 AM',	'10:30 AM',	'11:00 AM',	'11:30 AM',
	'12:00 PM',	'12:30 PM',	'1:00 PM',	'1:30 PM',	'2:00 PM',	'2:30 PM',
	'3:00 PM',	'3:30 PM',	'4:00 PM',	'4:30 PM',	'5:00 PM',	'5:30 PM',
	'6:00 PM',	'6:30 PM',	'7:00 PM',	'7:30 PM',	'8:00 PM',	'8:30 PM',
	'9:00 PM',	'9:30 PM',	'10:00 PM',	'10:30 PM',	'11:00 PM',	'11:30 PM',	
}

local on_time = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		
	end
	return 0
end

local on_timezone = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		
	end
	return 0
end

local refresh_dst = function(top, synctime, redraw)
	local cwnd = w1_page_dst.wnd;
	if(synctime) then
		b_wnd_ex.set_hide (top, cwnd.c_stime.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_smonth.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_sorder.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_sweek.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_smoment.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.c_etime.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_emonth.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_eorder.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_eweek.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_emoment.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.c_offsettime.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_offsettime.id, false, false);
	else
		b_wnd_ex.set_hide (top, cwnd.c_stime.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_smonth.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_sorder.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_sweek.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_smoment.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.c_etime.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_emonth.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_eorder.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_eweek.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_emoment.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.c_offsettime.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_offsettime.id, true, false);
	end
	if redraw == true then
		b_dlg.dlg_set_redraw(top);
	end
end

local on_time_index = function(time, time_type)
	for i=1,#time24_str do
		if time == time24_str[i] then
			return i - 1
		end
	end
	for i=1,#time12_str do
		if time == time12_str[i] then
			return i - 1
		end
	end
end

local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local c_wnd = w1_page_dst.wnd
	local data = cfgdata.dst

	local dst_enable = data.enable
	if(dst_enable == true) then
		b_wnd_ex.set_check(top, c_wnd.t_dstime.id,true,false)
		refresh_dst(top, true, false);
	else
		b_wnd_ex.set_check(top, c_wnd.t_dstime.id,false,false)--Dat2?dst
		refresh_dst(top, false, false);
	end
	
	b_wnd_ex.set_sel(top, c_wnd.t_smonth.id, data.begin_mon - 1,false)
	b_wnd_ex.set_sel(top, c_wnd.t_sorder.id, data.begin_week - 1,false)
	b_wnd_ex.set_sel(top, c_wnd.t_sweek.id, data.begin_w_day - 1,false)
	
	local s_timetosel = cfgdata['dst']['s_time']	
	local h24 = cfgdata['time']['time_fmt']
	if(h24 == 1) then
		b_wnd_ex.set_items(top, c_wnd.t_smoment.id, time24_str, false);
		b_wnd_ex.set_items(top, c_wnd.t_emoment.id, time24_str, false);
	else
		b_wnd_ex.set_items(top, c_wnd.t_smoment.id, time12_str, false);
		b_wnd_ex.set_items(top, c_wnd.t_emoment.id, time12_str, false);
	end
	s_timetosel = on_time_index(s_timetosel, h24)
	assert(nil ~= s_timetosel)
	b_wnd_ex.set_sel(top, c_wnd.t_smoment.id,s_timetosel,false)
	
	b_wnd_ex.set_sel(top, c_wnd.t_emonth.id, data.end_mon - 1,false)
	b_wnd_ex.set_sel(top, c_wnd.t_eorder.id, data.end_week - 1,false)
	b_wnd_ex.set_sel(top, c_wnd.t_eweek.id, data.end_w_day - 1,false)
	
	local e_timetosel = data.e_time	
	e_timetosel = on_time_index(e_timetosel, h24)
	assert(nil ~= e_timetosel)
	b_wnd_ex.set_sel(top, c_wnd.t_emoment.id,e_timetosel,false)
	
	local offset_time = data.offset
	if(offset_time == 60) then
		b_wnd_ex.set_sel(top, c_wnd.t_offsettime.id,1,false)
	else
		b_wnd_ex.set_sel(top, c_wnd.t_offsettime.id,0,false)
	end
	
	return 0
end

local on_seltotime = function(time_id, time_type)
	time_id = time_id + 1
	return time24_str[time_id]
	--[[if(0 == time_type) then
		return time12_str[time_id]
	else
		return time24_str[time_id]
	end--]]
end

--
local uitousercfg = function(top, cfgdata)
	local c_wnd = w1_page_dst.wnd
	local data = cfgdata.dst
	
	data.enable = b_wnd_ex.get_check(top, c_wnd.t_dstime.id)
	
	local t_smonth = b_wnd_ex.get_sel(top, c_wnd.t_smonth.id)
	data.begin_mon = t_smonth + 1
	local t_sorder = b_wnd_ex.get_sel(top, c_wnd.t_sorder.id)
	data.begin_week = t_sorder + 1
	local t_sweek = b_wnd_ex.get_sel(top, c_wnd.t_sweek.id)
	data.begin_w_day = t_sweek + 1
	local t_smoment = b_wnd_ex.get_sel(top, c_wnd.t_smoment.id)
	local h24 = data.time_fmt
	data.s_time = on_seltotime(t_smoment, h24)
	
	local t_emonth = b_wnd_ex.get_sel(top, c_wnd.t_emonth.id)
	data.end_mon = t_emonth + 1
	local t_eorder = b_wnd_ex.get_sel(top, c_wnd.t_eorder.id)
	data.end_week = t_eorder + 1
	local t_eweek = b_wnd_ex.get_sel(top, c_wnd.t_eweek.id)
	data.end_w_day = t_eweek + 1
	local t_emoment = b_wnd_ex.get_sel(top, c_wnd.t_emoment.id)
	data.e_time = on_seltotime(t_emoment, h24)
	local t_offsettime = b_wnd_ex.get_sel(top, c_wnd.t_offsettime.id)
	if(t_offsettime == 1) then
		data.offset = 60
	else
		data.offset = 30
	end
	
	return 0
end

local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	
	local c_wnd = w1_page_dst.wnd
	local t_smonth = b_wnd_ex.get_sel(top, c_wnd.t_smonth.id)
	local t_sorder = b_wnd_ex.get_sel(top, c_wnd.t_sorder.id)
	local t_emonth = b_wnd_ex.get_sel(top, c_wnd.t_emonth.id)
	local t_eorder = b_wnd_ex.get_sel(top, c_wnd.t_eorder.id)
	
	if(t_smonth == t_emonth)then
		if((t_eorder - t_sorder) < 2)then
			legalflag = false		
			table.insert(nlegalid, c_wnd.t_smonth.id)	
			table.insert(nlegalid, c_wnd.t_sorder.id)	
			table.insert(nlegalid, c_wnd.t_emonth.id)	
			table.insert(nlegalid, c_wnd.t_eorder.id)
			w1_wnd_util.setparamerr_str(STR('LA_PARAMETER_ERR'))
		end
	end
	
	if(legalflag) then
		return legalflag, nil
	else
		return legalflag, nlegalid
	end
end

local on_dst = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local synctime = b_wnd_ex.get_check(top, id);
		refresh_dst(top, synctime, true);
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_update_param = function(top, id, vmsg, x, y)
	if (vmsg == b_ui.WM_USER_UPDATE_PARAM) then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()
	end
	return 0
end

w1_page_dst.timer_start = function()
	w1_page_dst.timestart = true
end

w1_page_dst.timer_stop = function(top)
	w1_page_dst.timestart = false
	w1_wnd_util.tipclear(top, w1_page_dst.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_dst.timerenevt = function(top)
	if(w1_page_dst.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_dst.wnd.tipinfo.id)
	end
	return 0
end

w1_page_dst.init = function(top)
	w1_wnd_util.cfgtab = {'dst','time'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

w1_page_dst.apply =function(top)
	w1_wnd_util.uidatacheckfunc = uidatacheck
	local ret = nil;
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_dst.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = { 'c_dstime', 't_dstime', 'c_stime', 't_smonth', 't_sorder','t_sweek',
			't_smoment','c_etime', 't_emonth', 't_eorder', 't_eweek','t_emoment',
			'c_offsettime', 't_offsettime', 'tipinfo', 'default', 'apply'},
			
	c_dstime 	= {t='static',	id=id+1,	xywh='s_cfg_dst_cdstime_xywh',text='LA_DST_ENABLE'},
	t_dstime 	= {t='tt_check',	id=id+2,	xywh='s_cfg_dst_tdstime_xywh',align = b_ui.ALIGN.LEFT,
					t_imgs = {b_ui.ALIGN.LEFT,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					check=true,cmd = on_dst},
	
	c_stime 	= {t='static',	id=id+3,	xywh='s_cfg_dst_cstime_xywh',	text='LA_START_TIME'},
	t_smonth 	= {t='combox',	id=id+4,	xywh='s_cfg_dst_tsmonth_xywh',	items=month_str,cmd = on_update_param},	
	t_sorder 	= {t='combox',	id=id+5,	xywh='s_cfg_dst_tsorder_xywh',	items=order_str,cmd = on_update_param},	
	t_sweek 	= {t='combox',	id=id+6,	xywh='s_cfg_dst_tsweek_xywh',	items=week_str,cmd = on_update_param},	
	t_smoment 	= {t='combox',	id=id+7,	xywh='s_cfg_dst_tsmoment_xywh',	items=time24_str,trans = false,cmd = on_update_param},	

	c_etime 	= {t='static',	id=id+8,	xywh='s_cfg_dst_cetime_xywh',	text='LA_END_TIME',cmd = on_update_param},
	t_emonth 	= {t='combox',	id=id+9,	xywh='s_cfg_dst_temonth_xywh',	items=month_str,cmd = on_update_param},	
	t_eorder 	= {t='combox',	id=id+10,	xywh='s_cfg_dst_teorder_xywh',	items=order_str,cmd = on_update_param},	
	t_eweek 	= {t='combox',	id=id+11,	xywh='s_cfg_dst_teweek_xywh',	items=week_str,cmd = on_update_param},	
	t_emoment 	= {t='combox',	id=id+12,	xywh='s_cfg_dst_temoment_xywh',	items=time24_str,trans = false,cmd = on_update_param},	

	c_offsettime= {t='static',	id=id+13,	xywh='s_cfg_dst_coffsettime_xywh',text='LA_OFFSET_TIME'},
	t_offsettime= {t='combox',	id=id+14,	xywh='s_cfg_dst_toffsettime_xywh',	items={'LA_HALFHOUR', 'LA_ONE_HOUR'},cmd = on_update_param},	

	tipinfo		= {t='static', 	id=id+15,	xywh='s_cfg_dst_tipinfo_xywh',			text='',trans = false},
	
	apply 		= {t='button',	id=id+17,	xywh= 's_cfg_apply_xywh', 		text='LA_APPLY',cmd=on_apply},

}

return w1_page_dst

