--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_net.eth_route_id
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local r_size		= require("wnd.core.r_res.r_size")
local util 			= require("wnd.core.util")
local SIZE 			= r_size.get_size
local w1_add_eth_route = require("wnd.w1_cfg.w1_add_eth_route");
local b_app_api 	= require("wnd.core.command.b_app_api")
local w1_msgbox 	= require("wnd.w1_util.w1_msgbox")

local w1_page_eth_route = 
{
	data,
	s_768,	
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_eth_route.s_768 = 
{
	s_eht_route_list_xywh = {53,21,768,469},
	s_eht_route_add_xywh = {634,504,90,28},
	s_eht_route_del_xywh = {730,504,90,28},
	s_eht_route_list_w1 = {69,0,0,0},
	s_eht_route_list_w2 = {160,0,0,0},
	s_eht_route_list_w3 = {138,0,0,0},
	s_eht_route_list_w4 = {138,0,0,0},
	s_eht_route_list_w5 = {138,0,0,0},
	s_eht_route_list_w6 = {106,0,0,0},
}

w1_page_eth_route.s_1280 = 
{
	s_eht_route_list_xywh = {100,30,900,660},
	s_eht_route_add_xywh = {650,710,170,40},
	s_eht_route_del_xywh= {830,710,170,40},
	s_eht_route_list_w1 = {60,0,0,0},
	s_eht_route_list_w2 = {180,0,0,0},
	s_eht_route_list_w3 = {170,0,0,0},
	s_eht_route_list_w4 = {170,0,0,0},
	s_eht_route_list_w5 = {170,0,0,0},
	s_eht_route_list_w6 = {130,0,0,0},		
}

w1_page_eth_route.s_1440 = 
{
	s_eht_route_list_xywh = {100,30,1000,660},
	s_eht_route_add_xywh = {750,700,170,40},
	s_eht_route_del_xywh= {930,700,170,40},
	s_eht_route_list_w1 = {60,0,0,0},
	s_eht_route_list_w2 = {200,0,0,0},
	s_eht_route_list_w3 = {190,0,0,0},
	s_eht_route_list_w4 = {190,0,0,0},
	s_eht_route_list_w5 = {190,0,0,0},
	s_eht_route_list_w6 = {135,0,0,0},	
}

w1_page_eth_route.s_1080p = 
{
	s_eht_route_list_xywh = {100,30,1440,660},
	s_eht_route_add_xywh = {1190,710,170,40},
	s_eht_route_del_xywh= {1370,710,170,40},	
	s_eht_route_list_w1 = {130,0,0,0},
	s_eht_route_list_w2 = {300,0,0,0},
	s_eht_route_list_w3 = {260,0,0,0},
	s_eht_route_list_w4 = {260,0,0,0},
	s_eht_route_list_w5 = {260,0,0,0},
	s_eht_route_list_w6 = {200,0,0,0},
}

w1_page_eth_route.s_2k = 
{
	s_eht_route_list_xywh = {133,40,1920,880},
	s_eht_route_add_xywh = {1586,946,226,53},
	s_eht_route_del_xywh = {1826,946,226,53},
	s_eht_route_list_w1 = {173,0,0,0},
	s_eht_route_list_w2 = {400,0,0,0},
	s_eht_route_list_w3 = {346,0,0,0},
	s_eht_route_list_w4 = {346,0,0,0},
	s_eht_route_list_w5 = {346,0,0,0},
	s_eht_route_list_w6 = {260,0,0,0},
}

w1_page_eth_route.s_4k = 
{
	s_eht_route_list_xywh = {200,60,2880,1320},
	s_eht_route_add_xywh = {2380,1420,340,80},
	s_eht_route_del_xywh = {2740,1420,340,80},
	s_eht_route_list_w1 = {260,0,0,0},
	s_eht_route_list_w2 = {600,0,0,0},
	s_eht_route_list_w3 = {520,0,0,0},
	s_eht_route_list_w4 = {520,0,0,0},
	s_eht_route_list_w5 = {520,0,0,0},
	s_eht_route_list_w6 = {400,0,0,0},
}

local refresh_list = function(top, redraw)
	local cwnd = w1_page_eth_route.wnd
	local data = w1_page_eth_route.data;
	local dispdata = {};
	local end_typetab = {};
	
	dispdata.item_total = data.num;
	local cur_data = nil;
	for i=1,dispdata.item_total do
		cur_data = data.info_list['idx'..i];
		dispdata['idx'..i] = nil;
		dispdata['idx'..i] ={};
		dispdata['idx'..i] = {i-1, false, tostring(i),  
			cur_data.nic_name, cur_data.dsp_ip, cur_data.netmask,  cur_data.gateway, ''};
		end_typetab[i] = 1;
	end
	b_wnd_ex.set_listdata(top, cwnd.route_list.id, dispdata, redraw);
	b_wnd_ex.set_listtype(top, cwnd.route_list.id, end_typetab, redraw);	
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	w1_page_eth_route.data = cfgdata.eth_route;
	w1_add_eth_route.set_data(w1_page_eth_route.data);	
	refresh_list(top, false);
	return 0;
end

w1_page_eth_route.clear_data = function()
	w1_add_eth_route.clear_data();	
	w1_page_eth_route.data = nil;
end

w1_page_eth_route.timerenevt = function(top)
	
	return 0
end

local ok_func = function(param)
	--¶ȡ,ˢб
	local cwnd = w1_page_eth_route.wnd;
	b_wnd_ex.clear_checkall(param[1], cwnd.route_list.id, false, false);		
	b_app_cfg.init({'eth_route'});
	cfgdatatoui(param[1], b_app_cfg.user_cfg)
	b_dlg.dlg_set_redraw(param[1]);
	return 0;
end

local get_listselect = function(top, win_id)
	local checklist = {};
	local param = b_wnd_ex.get_selecelist(top, win_id);
	for i=1, w1_page_eth_route.data.num do
		checklist[i] = param['r'..i];
	end
	return checklist;
end

local batch_del = function(param)
	local top = param[1];
	local selece_list = param[2];
	local cwnd = w1_page_eth_route.wnd;
	
	for i = 1, #selece_list do
		if (selece_list[i] == 1) then
			local sel_data = w1_page_eth_route.data.info_list['idx'..i];
			local ret = b_app_api.del_eth_route(sel_data);
		end
	end
	
	b_wnd_ex.clear_checkall(top, cwnd.route_list.id, false, false);		
	b_app_cfg.init({'eth_route'});
	cfgdatatoui(top, b_app_cfg.user_cfg)
	b_dlg.dlg_set_redraw(top);
end	

local on_del = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_eth_route.wnd;
		local selece_list = get_listselect(top, cwnd.route_list.id);
		local all_zero = true
		for i = 1, #selece_list do
			if (selece_list[i] ~= 0) then
				all_zero = false;
			end
		end
		
		if (all_zero == true) then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_DELETE_ITEM'), true, false,false);
			w1_msgbox.set_func(nil, nil, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)		
			return 0;
		end
		
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_SURE_DELETE'), true, true,false);
		w1_msgbox.set_func(batch_del,{top, selece_list, true}, nil, nil);
		b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)		
	end
	
	return 0;
end


--ҳʼʱٶȡҳҪ
w1_page_eth_route.init = function(top)
	w1_wnd_util.cfgtab = {'eth_route'};
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);
	w1_add_eth_route.set_func(ok_func, {top});
	return 0;
end


local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_eth_route.wnd;
		b_dlg.do_modal(top, w1_key.DLG_ADD_ETH_ROUTE, 0, 0, nil)
	end
	return 0;
end

w1_page_eth_route.on_pre_show = function(top)
	local cwnd = w1_page_eth_route.wnd;
	local param = {
			STR('LA_ID'), STR('LA_NETWORKCARD_NAME'),STR('LA_IP_ADDRESS'),STR('LA_SUBNET_MASK'), STR('LA_GATEWAY'), STR('LA_OPERATE')
		}
	b_wnd_ex.set_title_texts(top, cwnd.route_list.id, param, false)
	
	local list_w = {};
	for i=1,6 do
		local str = 's_eht_route_list_w'..math.floor(i/1);
		list_w[i] = SIZE(str)[1];
	end
	b_wnd_ex.columns_w(top, cwnd.route_list.id, list_w, false);
end

w1_page_eth_route.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'route_list', 'add','del'},
	
	route_list	= {t='list',	id=id+1,	xywh='s_eht_route_list_xywh', font = 'f_grade4',
					listattr = {14,6,b_ui.LISTATTR.FIRST_WIDGET_CHECK,b_ui.LISTATTR.END_WIDGET_ADDDEL},
					dlg_key = {w1_key.DLG_ADD_ETH_ROUTE, w1_key.DLG_ADD_ETH_ROUTE},
					title_texts = {STR('LA_ID'), STR('LA_NETWORKCARD_NAME'),STR('LA_IP_ADDRESS'),STR('LA_SUBNET_MASK'), STR('LA_GATEWAY'), STR('LA_OPERATE')},
					columns_w = {80,180, 180, 180, 300,200},
					},
	add 		= {t='button',	id=id+2,	xywh='s_eht_route_add_xywh', text='LA_ADD',cmd=on_add},
	del 		= {t='button',	id=id+3,	xywh='s_eht_route_del_xywh', text='LA_DELETE',cmd=on_del},

}

return w1_page_eth_route;
