--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val			= require("wnd.global_val")
local b_ui 					= require("wnd.core.b_ui")
local b_dlg 				= require("wnd.core.b_dlg")
local w1_id 				= require("wnd.w1_util.w1_id")
local id 					= w1_id.cfg_ai.face_id
local b_wnd_ex 				= require("wnd.core.b_wnd_ex")
local w1_wnd_util			= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  			= require("wnd.w1_util.w1_ui_msg") 
local r_size				= require("wnd.core.r_res.r_size")
local SIZE					= r_size.get_size;
local b_app_api 			= require("wnd.core.command.b_app_api")
local w1_row_facerow		= require("wnd.w1_cfg.w1_row_facerow")
local w1_page_faceparam 	= require("wnd.w1_cfg.w1_page_faceparam")
local w1_page_facetimeplan 	= require("wnd.w1_cfg.w1_page_facetimeplan")

local w1_copy 				= require("wnd.w1_util.w1_copy")
local w1_key 				= require("wnd.w1_util.w1_key")
local util 					= require("wnd.core.util")
local b_app_cfg 			= require("wnd.core.b_app_cfg")
local r_str					= require("wnd.core.r_res.r_str")
local STR 					= r_str.get_str
local r_color				= require("wnd.core.r_res.r_color")
local COLOR 				= r_color.get_color
local w1_msgbox 			= require("wnd.w1_util.w1_msgbox")

local w1_page_face = 
{
	channel = 0,
	old_sel = 0,
	data,
	timestart = false,
	copy_ch = {},
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_face.s_768 =
{
	s_face_image_xywh = {70,10,352,256},
	s_face_cap_channel_xywh = {436,35,85,35},
	s_face_t_channel_xywh = {543,39,131,28},
	s_face_clear_xywh = {435,238,64,28},
	s_face_tipinfo_xywh = {70,611,213,35},
};

w1_page_face.s_1280 = 
{
	s_face_image_xywh 		= {92,12,512,360},
	s_face_cap_channel_xywh = {630,50,160,50},
	s_face_t_channel_xywh 	= {800,50,150,40},
	s_face_clear_xywh		= {632,332,120,40},
	s_face_tipinfo_xywh 	= {110,805,300,50},
}

w1_page_face.s_1440 = 
{
	s_face_image_xywh 		= {100,12,512,250},
	s_face_cap_channel_xywh = {630,50,160,50},
	s_face_t_channel_xywh 	= {800,50,150,40},
	s_face_clear_xywh		= {632,222,120,40},
	s_face_tipinfo_xywh 	= {110,705,300,45},
}

w1_page_face.s_1080p = 
{
	s_face_image_xywh 		= {98,12,640,360},
	s_face_cap_channel_xywh = {800,50,160,50},
	s_face_t_channel_xywh 	= {1000,55,246,40},
	s_face_clear_xywh		= {760,332,120,40},
	s_face_tipinfo_xywh 	= {110,860,400,50},
}

w1_page_face.s_2k = 
{
	s_face_image_xywh		= {136,16,856,480},
	s_face_cap_channel_xywh = {1066,67,213,67},
	s_face_t_channel_xywh 	= {1333,73,328,53},
	s_face_clear_xywh		= {1013,443,160,53},
	s_face_tipinfo_xywh 	= {147,1147,533,67},
}

w1_page_face.s_4k = 
{
	s_face_image_xywh 		= {200,24,1284,720},
	s_face_cap_channel_xywh = {1600,100,320,100},
	s_face_t_channel_xywh 	= {2000,110,492,80},
	s_face_clear_xywh		= {1520,664,240,80},
	s_face_tipinfo_xywh 	= {220,1720,800,100},
}

local channel_num;--豸ͨĿ

w1_page_face.clear_data = function()
	w1_page_face.data = nil;
	w1_page_face.copy_ch = nil;
end	

local set_custom_layout = function(chid)
	local param = {
		chn_id = chid,
		wnd_id = 1,
	}
	local layoutpos = w1_page_face.layoutpos;
	param.x = layoutpos.x;
	param.y = layoutpos.y;
	param.cx = layoutpos.cx;
	param.cy = layoutpos.cy;
	param.stream = true;			--
	b_app_api.set_custom_layout_wnd(param)
end

local refresh_chdata = function(top, chid, redraw)
	local c_wnd = w1_page_face.wnd
	local channeldata = w1_page_face.data.face_param['channel'..chid]
	set_custom_layout(chid);
	b_wnd_ex.clear_intarea(top,c_wnd.image.id,false,false);
	local area = w1_page_face.data.face_param['channel'..chid].area
	local intarea = {};
	for i = 1, area.region_num do
		intarea['area'..i] = {};
		intarea['area'..i].points = {};
		intarea['area'..i].point_num = area.region_list['region'..i].point_num 
		for j = 1,  intarea['area'..i].point_num do
			intarea['area'..i].points['point'..j]= {};
			intarea['area'..i].points['point'..j].x = area.region_list['region'..i].points['point'..j].x
			intarea['area'..i].points['point'..j].y = area.region_list['region'..i].points['point'..j].y
		end
	end
	if intarea['area'..1] ~= nil and intarea['area'..1].point_num ~= nil and intarea['area'..1].point_num ~= 0 then
		b_wnd_ex.set_intarea(top,c_wnd.image.id,intarea,false);
	end
	local checkidx = w1_row_facerow.get_checkidx(top);
	if(checkidx == 0) then
		w1_page_faceparam.set_param(top,channeldata,true);
		w1_page_facetimeplan.settimeplan(top, channeldata, false);
	else
		w1_page_faceparam.set_param(top,channeldata,false);
		w1_page_facetimeplan.settimeplan(top, channeldata, true);
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)	
	assert(type(cfgdata) == 'table')
	w1_page_face.data = cfgdata;

	local c_wnd = w1_page_face.wnd
	local camreaitems = {};
	local idx = 1;
	local privilege = global_val.get_allprivilege();--ȡȨ
	local ch_prilist = privilege.channel_manager_list;
	w1_page_face.old_sel = 0
	for i=1, channel_num do
		if(cfgdata['face_param']['channel'..i] ~= nil and ch_prilist[i] == 1) then
			camreaitems[idx] = i;
			if w1_page_face.channel == i then
				w1_page_face.old_sel = idx-1
			end
			idx = idx + 1;
		end
	end
	b_wnd_ex.set_text(top,c_wnd.tipinfo.id,'',false);	
	b_wnd_ex.set_items(top, c_wnd.t_channel.id, camreaitems, false);
	b_wnd_ex.clear_intarea(top,c_wnd.image.id,false,false);
	if(idx ~= 1) then--˵ͨ
		b_wnd_ex.set_enableselect(top,c_wnd.image.id,true,false);
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id, false, false)
		local img_cap = {};
		img_cap.Region_enable = true;
		img_cap.edgeNum = 8;
		img_cap.maxRegionNum = 8;
		b_wnd_ex.set_cap(top,c_wnd.image.id,img_cap,false);
		b_wnd_ex.set_sel(top, c_wnd.t_channel.id, w1_page_face.old_sel, false);--Ĭһ
		
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		w1_page_face.channel = chid
		b_wnd_ex.set_hide(top,c_wnd.clear.id,false,false);
		b_wnd_ex.set_hide(top, w1_id.cfg_ai.facerow_id, false, false)
		w1_page_faceparam.sethide(top, false, false)
		w1_page_facetimeplan.sethide(top, false, false)
		refresh_chdata(top, chid, false);
	else--ͨ
		b_wnd_ex.set_enableselect(top,c_wnd.image.id,false,false);
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id,true, false)
		b_wnd_ex.set_hide(top,c_wnd.clear.id,true,false);
		b_wnd_ex.set_hide(top, w1_id.cfg_ai.facerow_id, true, false)
		w1_page_faceparam.sethide(top, true, false)
		w1_page_facetimeplan.sethide(top, true, false)
		for i=1, channel_num do
			if(ch_prilist[i] ~= 0) then
				set_custom_layout(i);
				break;
			end
		end	
	end
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local c_wnd = w1_page_face.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id))
	if(chid == nil) then
		return true, nil
	end
	local area = w1_page_face.data.face_param['channel'..chid].area
	local face_enable = w1_page_face.data.face_param['channel'..chid].face_enable;
	local upbody_enable = w1_page_face.data.face_param['channel'..chid].upbody_enable;
	local fullbody_enable = w1_page_face.data.face_param['channel'..chid].fullbody_enable;
	if (true == face_enable or true == upbody_enable or true == fullbody_enable) and 0 == area.region_num then
		w1_wnd_util.setparamerr_str(STR('LA_ERR_DRAW_DTE_AREA'));
		return false,nil
	end
	local flag,errstr = w1_page_faceparam.datacheck(top);
	if flag == false then
		w1_wnd_util.setparamerr_str(errstr);
		return false,nil
	end
	return true, nil
end

w1_page_face.timer_start = function()
	w1_page_face.timestart = true
end

w1_page_face.timer_stop = function(top)
	w1_page_face.timestart = false
	w1_wnd_util.tipclear(top, w1_page_face.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_face.timerenevt = function(top)
	if(w1_page_face.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_face.wnd.tipinfo.id)
	end
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_face.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id))
	if(chid == nil) then
		return 0
	end
	
	local intarea = b_wnd_ex.get_intarea(top,cwnd.image.id)
	local area = cfgdata.face_param['channel'..chid].area
	area.region_list = {}
	area.region_num = 0
	for i=1, 8 do
		if(nil ~= intarea['area'..i]) then
			area.region_num = area.region_num + 1;
			area.region_list['region'..i] = {}
			area.region_list['region'..i].point_num = 0;
			area.region_list['region'..i].points = {}
			for j = 1, 12 do
				if intarea['area'..i]['point'..j] ~= nil then
					area.region_list['region'..i].points['point'..j] = {}
					area.region_list['region'..i].points['point'..j].x = intarea['area'..i]['point'..j].x
					area.region_list['region'..i].points['point'..j].y = intarea['area'..i]['point'..j].y
					area.region_list['region'..i].point_num = area.region_list['region'..i].point_num +1;
				end
			end
		end
	end
	cfgdata.face_param['channel'..chid].change_flag = true;
	return 0
end

local on_clear = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_wnd_ex.clear_intarea(top,w1_page_face.wnd.image.id,false,false);
		uitousercfg(top,w1_page_face.data)
	end
	return 0;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.LBUTTONCLK == vmsg or b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,w1_page_face.data)
	end
	return 0;
end

w1_page_face.pageinit = function(top)
	return 0
end

w1_page_face.init= function(top)
	local c_wnd = w1_page_face.wnd
	
	w1_wnd_util.cfgtab = {'face_param','device_info'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)	
	return 0
end

w1_page_face.set_channel = function(chn)
	w1_page_face.channel = chn;
end

w1_page_face.get_channel = function()
	return w1_page_face.channel;
end

local on_channel = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then	
		local c_wnd = w1_page_face.wnd
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		local old_chn = w1_page_face.channel
		if(old_chn ~= chid) then
			local area = w1_page_face.data.face_param['channel'..old_chn].area
			local face_enable = w1_page_face.data.face_param['channel'..old_chn].face_enable;
			local upbody_enable = w1_page_face.data.face_param['channel'..old_chn].upbody_enable;
			local fullbody_enable = w1_page_face.data.face_param['channel'..old_chn].fullbody_enable;
			if (true == face_enable or true == upbody_enable or true == fullbody_enable) and 0 == area.region_num then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_ERR_DRAW_DTE_AREA'), true, false,false);
				w1_msgbox.set_func(nil, nil, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
				b_wnd_ex.set_sel(top, c_wnd.t_channel.id,w1_page_face.old_sel,false);
				b_dlg.dlg_set_redraw(top);
				return 0
			end
			local flag,errstr = w1_page_faceparam.datacheck(top);
			if flag == false then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), errstr, true, false,false);
				w1_msgbox.set_func(nil, nil, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
				b_wnd_ex.set_sel(top, c_wnd.t_channel.id,w1_page_face.old_sel,false);
				b_dlg.dlg_set_redraw(top);
				return 0
			end
			b_wnd_ex.set_text(top,c_wnd.tipinfo.id,'',false);	
			w1_page_face.old_sel = b_wnd_ex.get_sel(top, c_wnd.t_channel.id);
			refresh_chdata(top, chid, false);
			w1_page_face.channel = chid;
		end
		b_dlg.dlg_set_redraw(top);
	end
	
	return 0;
end

local returndatacheck =function(top,ret)
	if(ret ~= nil and ret.insight ~= 0) then--޸ʧ
		w1_wnd_util.setparamerr_str(STR('LA_APPLY_FAIL'));
		--¶ȡԭʼ
		b_app_cfg.origin_init(w1_wnd_util.cfgtab);
		return false, nil;
	end
	return true, nil;
end

local copy_okfunc = function(param)
	return 0;
end

local on_copy = function(top, id, vmsg, x, y)
	return 0
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.returndatacheckfunc = returndatacheck;
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
		w1_wnd_util.returndatacheckfunc = nil;
	end
	return 0
end

w1_page_face.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	w1_wnd_util.returndatacheckfunc = returndatacheck;
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	w1_wnd_util.returndatacheckfunc = nil;
	return ret;
end

w1_page_face.dwell_updata_f =function(top)
	local cwnd = w1_page_face.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	if  chid ~= nil and w1_page_face.data['face_param']['channel'..chid] ~= nil then
		local checkidx = w1_row_facerow.get_checkidx(top);
		if checkidx == 0 then
			w1_page_faceparam.dwell_updata_f(top)
		end
	end
end

w1_page_face.dwell_mouse_up =function(top)
	local cwnd = w1_page_face.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	if  chid ~= nil and w1_page_face.data['face_param']['channel'..chid] ~= nil then
		local checkidx = w1_row_facerow.get_checkidx(top);
		if checkidx == 0 then
			w1_page_faceparam.dwell_mouse_up(top)
		end
	end
end

w1_page_face.dwell_mouse_down =function(top)
	local cwnd = w1_page_face.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	if  chid ~= nil and w1_page_face.data['face_param']['channel'..chid] ~= nil then
		local checkidx = w1_row_facerow.get_checkidx(top);
		if checkidx == 0 then
			w1_page_faceparam.dwell_mouse_down(top)
		end
	end
end

w1_page_face.dwell_drop_drag =function(top)
	local cwnd = w1_page_face.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	if  chid ~= nil and w1_page_face.data['face_param']['channel'..chid] ~= nil then
		local checkidx = w1_row_facerow.get_checkidx(top);
		if checkidx == 0 then
			w1_page_faceparam.dwell_drop_drag(top)
		end
	end
end

w1_page_face.on_pre_show = function(top)
	local cwnd = w1_page_face.wnd;
	local param = {
		x = SIZE('s_face_image_xywh')[1] + SIZE('s_cfg_page_xywh')[1], 
		y = SIZE('s_face_image_xywh')[2] + SIZE('s_cfg_page_xywh')[2],
		cx = SIZE('s_face_image_xywh')[3],
		cy = SIZE('s_face_image_xywh')[4],
	}
	local oldparam_x = param.x;
	param.x = math.floor((param.x + 2) / 4) * 4;--֤4ı
	param.cx = math.floor((param.cx + 2) / 4) *4;
	local oldparam_y = param.y;
	param.y = math.floor((param.y + 2) / 4) * 4;
	param.cy = math.floor((param.cy + 2) / 4) *4;
	
	w1_page_face.layoutpos.x = param.x;
	w1_page_face.layoutpos.cx = param.cx;
	w1_page_face.layoutpos.y = param.y;
	w1_page_face.layoutpos.cy = param.cy;
	local pos = {};
	pos[1] = SIZE('s_face_image_xywh')[1] + param.x - oldparam_x;
	pos[2] = SIZE('s_face_image_xywh')[2] + param.y - oldparam_y;
	pos[3] = param.cx;
	pos[4] = param.cy;
	b_wnd_ex.move_ex(top, cwnd.image.id, pos, false);
	
	channel_num = global_val.get_channelnum();
	w1_page_faceparam.on_pre_show(top)
	local con_id = cwnd.con_param.id
	
	w1_row_facerow.changecheck(top, w1_row_facerow.wnd, w1_id.cfg_ai.facerow_id + 1, false)
end

w1_page_face.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'image','clear','cap_channel', 't_channel','con_param','face_row_wnd','param_wnd','timeplan_wnd',
			'tipinfo', 'apply'},
		
	image = {t='intelarea',id=id+1,xywh='s_face_image_xywh',text='Image widget', font = 'f_grade1', trans = false,
				color = {'c_imgae_param_bg', 'c_imgae_param_bg', 'c_imgae_param_bg'},cmd=on_update_param},
	clear = {t='tt_button',id=id+3,xywh='s_face_clear_xywh',text='LA_CLEAR',cmd = on_clear},
	cap_channel	= {t='static',id=id+4,	xywh='s_face_cap_channel_xywh',	text='LA_CHANNEL'},
	t_channel 	= {t='combox',id=id+5,	xywh='s_face_t_channel_xywh',	items={'1','2','3','4','5','6','7','8'},channel_cbox = true,trans = false,
					cmd = on_channel},		
	con_param	= {t='container',id=w1_id.cfg_ai.con_face_id,	xywh={0,0,10,10}},
	face_row_wnd 	= w1_row_facerow.wnd,
	param_wnd 		= w1_page_faceparam.wnd,
	timeplan_wnd	= w1_page_facetimeplan.wnd,
	
	tipinfo	= {t='static',id=id+6,	xywh='s_face_tipinfo_xywh',text='',trans = false},
	apply 	= {t='button',id=id+7,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_face

