
--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/10/31
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local w1_id 		= require("wnd.w1_util.w1_id")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local id 			= w1_id.cfg_ftp.ftp_id
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_msgbox 	= require("wnd.w1_util.w1_msgbox")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local util 			= require("wnd.core.util")
local b_app_api		= require("wnd.core.command.b_app_api")

local redraw  		= false
local state_flag    = 0;
local update_flag   = true
local w1_page_ftp = 
{
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_ftp.s_768 =
{
	s_ftp_t_enable_xywh = {277,25,25,21},
	s_ftp_tipinfo_xywh = {53,391,373,35},
	s_ftp_tipsame_xywh = {53,355,373,32},
	s_ftp_test_xywh = {281,320,53,35},
};

w1_page_ftp.s_1280 = 
{
	s_ftp_t_enable_xywh ={455,36,48,30},
	s_ftp_tipinfo_xywh = {100,550,700,50},
	s_ftp_tipsame_xywh = {100,500,700,45},
	s_ftp_test_xywh = {460,450,100,50},
}

w1_page_ftp.s_1440 = 
{
	s_ftp_t_enable_xywh = {520,30,48,30},
	s_ftp_tipinfo_xywh = {100,470,700,50},
	s_ftp_tipsame_xywh = {100,420,700,45},
	s_ftp_test_xywh = {530,390,100,50},
}

w1_page_ftp.s_1080p = 
{
	s_ftp_t_enable_xywh = {520,36,48,30},
	s_ftp_tipinfo_xywh = {100,550,700,50},
	s_ftp_tipsame_xywh = {100,500,700,45},
	s_ftp_test_xywh = {527,450,100,50},
}

w1_page_ftp.s_2k = 
{
	s_ftp_t_enable_xywh = {693,48,64,40},
	s_ftp_tipinfo_xywh = {133,732,933,67},
	s_ftp_tipsame_xywh = {133,660,933,67},
	s_ftp_test_xywh = {703,600,133,60},
}

w1_page_ftp.s_4k = 
{
	s_ftp_t_enable_xywh = {1040,72,96,60},
	s_ftp_tipinfo_xywh = {200,1100,1400,100},
	s_ftp_tipsame_xywh = {200,1000,1400,90},
	s_ftp_test_xywh = {1055,900,200,100},
}

w1_page_ftp.clear_data = function()
	w1_page_ftp.data = nil;
end	


--ˢUI
local cfgdatatoui = function(top, cfgdata)
	w1_page_ftp.data = cfgdata
	local cwnd = w1_page_ftp.wnd
	local data = cfgdata.ftp;
	local enable = data.enable
	if enable ==0  then
		b_wnd_ex.set_check(top,cwnd.t_enable.id,false,false)
	else
		b_wnd_ex.set_check(top,cwnd.t_enable.id,true,false)
	end
	b_wnd_ex.set_value(top,cwnd.t_number.id,data.file_size,false)
	b_wnd_ex.set_value(top,cwnd.t_ftp_port.id,data.server_port,false)
	b_wnd_ex.set_text(top,cwnd.t_name.id,data.account,false)
	b_wnd_ex.set_password(top,cwnd.t_password.id,data.pwd,false)
	b_wnd_ex.set_text(top,cwnd.t_ip.id,data.server_addr,false)
	b_wnd_ex.set_text(top,cwnd.t_path.id,data.d_path,false)
	--b_wnd_ex.set_sel(top,cwnd.t_ftp.id,mode-1,redraw)
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck = function(top)
	local legalflag = true
	local nlegalid = {}
	local cwnd = w1_page_ftp.wnd
	local legal, num= w1_legal.check_ip(top, cwnd.t_ip.id);	
	if(legal == false) then
		legalflag = false;
		table.insert(nlegalid, cwnd.t_ip.id);
		if(num == w1_legal.ip.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LA_CORRECT_IP'));
		elseif(num == w1_legal.ip.LENERR or num == w1_legal.ip.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LA_CORRECT_IP'));
		end
	end	
	local path = b_wnd_ex.get_text(top,cwnd.t_path.id)
	local err_str = string.match(path, '[^(1-9a-zA-Z~`!@#$%^&*(){}[]:?\"\'\\|;<>+=-_.-/)]');
	if(err_str ~= nil)then
		legalflag = false;
		table.insert(nlegalid, cwnd.t_path.id);
		w1_wnd_util.setparamerr_str(STR('LA_CHNNAME_RULE'));
	end
	if legalflag==false then
		return legalflag, nlegalid;
	else
		return true,nil
	end
end	

local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_ftp.wnd
	local file_size = b_wnd_ex.get_value(top,cwnd.t_number.id)
	local port = b_wnd_ex.get_value(top,cwnd.t_ftp_port.id)
	local account =  b_wnd_ex.get_text(top,cwnd.t_name.id)
	local pwd = b_wnd_ex.get_password(top,cwnd.t_password.id)
	local ip_addr = b_wnd_ex.get_text(top,cwnd.t_ip.id)
	local path = b_wnd_ex.get_text(top,cwnd.t_path.id)
	local enable = b_wnd_ex.get_check(top,cwnd.t_enable.id)
	if enable then
		cfgdata['ftp']['enable']= 1
	else
		cfgdata['ftp']['enable']= 0
	end
	cfgdata['ftp']['file_size']= file_size
	cfgdata['ftp']['server_port']= port
	cfgdata['ftp']['account']= account
	cfgdata['ftp']['pwd']= pwd
	cfgdata['ftp']['server_addr']= ip_addr
	cfgdata['ftp']['d_path']= path
	return 0;
end

local on_enable = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck;
		local cwnd = w1_page_ftp.wnd
		w1_wnd_util.page_onapply(top);
		update_flag = true;
		w1_wnd_util.tipdispon();		--ʾ
	end
	return 0;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
		update_flag = false;
	end
	return 0
end

w1_page_ftp.timer_start = function()
	w1_page_ftp.timestart = true;
end

w1_page_ftp.timer_stop = function(top)
	w1_page_ftp.timestart = false;
	w1_wnd_util.tipclear(top, w1_page_ftp.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
	w1_wnd_util.tipdispoff();
end

w1_page_ftp.timerenevt = function(top)
	if(w1_page_ftp.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_ftp.wnd.tipinfo.id);
		
	end
	return 0;
end

--ҳʼʱٶȡҳҪ
w1_page_ftp.init = function(top)
	w1_wnd_util.cfgtab = {'ftp'};
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);
	return 0
end

local on_test = function(top, win_id, vmsg, x, y)
	if(b_ui.LBUTTONCLK == vmsg)then
		local cwnd = w1_page_ftp.wnd
		local file_size = b_wnd_ex.get_value(top,cwnd.t_number.id)
		local port = b_wnd_ex.get_value(top,cwnd.t_ftp_port.id)
		local account =  b_wnd_ex.get_text(top,cwnd.t_name.id)
		local pwd = b_wnd_ex.get_password(top,cwnd.t_password.id)
		local ip_addr = b_wnd_ex.get_text(top,cwnd.t_ip.id)
		local path = b_wnd_ex.get_text(top,cwnd.t_path.id)
		local enable = b_wnd_ex.get_check(top,cwnd.t_enable.id)
		local ftp = {}
		if enable then
			ftp.enable= 1
		else
			ftp.enable= 0
		end
		ftp.file_size= file_size
		ftp.server_port= port
		ftp.account= account
		ftp.pwd= pwd
		ftp.server_addr = ip_addr
		ftp.d_path= path
		local ret = b_app_api.test_ftp(ftp)	
		if(ret ==0)then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_TEST_OK'), true, false,false);
			w1_msgbox.set_func(nil,nil, nil, nil);
			b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
		else
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_TEST_FAIL'), true, false,false);
			w1_msgbox.set_func(nil,nil, nil, nil);
			b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
		end
	end
	return 0
end

w1_page_ftp.on_pre_show = function (top)

	return 0;
end

w1_page_ftp.apply =function(top)
	local ret = nil;
	local cwnd = w1_page_ftp.wnd
	w1_wnd_util.uidatacheckfunc = uidatacheck
	uitousercfg(top,b_app_cfg.user_cfg);
		
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_ftp.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_enable','t_enable','cap_ftp_port',
			't_ftp_port','cap_path','t_path','cap_number','t_number', 't_test',
			'cap_name','t_name','cap_password','t_password','cap_ip','t_ip', 'tipinfo','tipsame','apply', },
		
	cap_enable 	= {t='static',id=id+1,xywh='s_cfg_page_1_1',text='LA_FTP_UPLOAD'},
	t_enable 	= {t='tt_check', id=id+2,xywh='s_ftp_t_enable_xywh',
				t_imgs ={b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
				cmd = on_enable},
	
	cap_ip = {t='static',id=id+3,xywh='s_cfg_page_2_1',text='LA_FTP_ADDRESS'},
	t_ip   = {t='edit_ip',id=id+4,xywh='s_cfg_ip_2_2',cmd = on_update_param},
	
	cap_ftp_port    = {t='static',id=id+5,xywh='s_cfg_page_3_1',text='LA_FTP_PORT'},
	t_ftp_port		= {t='edit_num',id=id+6,xywh='s_cfg_ip_3_2',range = {1,65534},cmd=on_update_param},
	
	cap_name    = {t='static',id=id+7,xywh='s_cfg_page_4_1',text='LA_ACCOUNT_T'},
	t_name   	= {t='edit',id=id+8,xywh='s_cfg_ip_4_2',cmd = on_update_param},
	
	cap_password = {t='static',id=id+9,xywh='s_cfg_page_5_1',text='LA_PASSWORD'},
	t_password   = {t='password',id=id+10,xywh='s_cfg_ip_5_2',cmd = on_update_param},
	
	cap_path   = {t='static',id=id+11,xywh='s_cfg_page_6_1',text='LA_FTP_PATH'},
	t_path		= {t='edit',id=id+12,xywh='s_cfg_ip_6_2',cmd = on_update_param},
	
	cap_number  = {t='static',id=id+13,xywh='s_cfg_page_7_1',text='LA_FTP_SiZE'},
	t_number	= {t='edit_num',id=id+14,xywh='s_cfg_ip_7_2',range = {0,64},cmd = on_update_param},
	
	t_test 		= {t='button',	id=id+15,	xywh='s_ftp_test_xywh', 	text='LA_TEST',cmd=on_test},

	tipinfo		= {t='static',id=id+16,	xywh='s_ftp_tipinfo_xywh',text='',trans = false},		
	apply 		= {t='button',	id=id+17,	xywh='s_cfg_apply_xywh', 		text='LA_APPLY',cmd=on_apply},
}

return w1_page_ftp