local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_disk_group.disk_group_id
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg 		= require("wnd.w1_util.w1_ui_msg") 
local r_str			= require("wnd.core.r_res.r_str")
local b_app_api		= require("wnd.core.command.b_app_api")
local STR 			= r_str.get_str
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size

local channel_num;
local w1_page_disk_group={
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_disk_group.s_768 =
{
	cap_mode_xywh = {42,28,160,42},
	t_mode_xywh = {224,28,160,42},
	cap_group_xywh = {42,78,160,42},
	t_group_xywh = {224,78,160,35},
	cap_channel_xywh = {42,135,160,42},
	t_set_all_xywh = {218,135,26,35},
	cap_check_all_xywh = {245,135,106,35},
	channel_table_xywh = {224,135,202,99},
	s_event_table_btn_xywh = {0,0,21,28},
	t_button_xywh = {720,270,64,28},
	disk_list_xywh = {42,391,758,184},
	tipinfo_xywh = {42,604,320,42},
	default_tipinfo = {42,305,426,42},
		
	columns_w_1 = {48,0,0,0},
	columns_w_2 = {163,0,0,0},
	columns_w_3 = {370,0,0,0},
	columns_w_4 = {85,0,0,0},
	columns_w_5 = {80,0,0,0},
};

w1_page_disk_group.s_1280={
	cap_mode_xywh = {60,20,300,40},
	t_mode_xywh  = {420,15,300,60},
	cap_group_xywh = {60,90,300,40},
	t_group_xywh = {420,90,300,50},
	cap_channel_xywh ={60,160,300,40},
	t_set_all_xywh  = {410,160,50,40},
	cap_check_all_xywh = {450,160,200,40},
	channel_table_xywh ={420,160,380,140},
	s_event_table_btn_xywh = {0,0, 40,40},
	t_button_xywh = {850,430,100,40},
	disk_list_xywh = {60,500,922,260},
	tipinfo_xywh = {60,800,600,60},
	default_tipinfo = {60,440,600,50},
	
	columns_w_1= {80,0,0,0},
	columns_w_2= {200,0,0,0},
	columns_w_3= {350,0,0,0},
	columns_w_4= {150,0,0,0},
	columns_w_5= {130,0,0,0},
}

w1_page_disk_group.s_1440={
	cap_mode_xywh = {60,20,300,40},
	t_mode_xywh  = {420,15,300,60},
	cap_group_xywh = {60,90,300,40},
	t_group_xywh = {420,90,300,50},
	cap_channel_xywh ={60,160,300,40},
	t_set_all_xywh  = {410,160,50,40},
	cap_check_all_xywh = {450,160,200,40},
	channel_table_xywh ={420,160,380,140},
	s_event_table_btn_xywh = {0,0, 40,40},
	t_button_xywh = {1000,400,100,40},
	disk_list_xywh = {60,470,1052,200},
	tipinfo_xywh = {60,670,600,50},
	default_tipinfo = {60,410,800,50},
	
	columns_w_1= {70,0,0,0},
	columns_w_2= {220,0,0,0},
	columns_w_3= {470,0,0,0},
	columns_w_4= {160,0,0,0},
	columns_w_5= {120,0,0,0},
}

w1_page_disk_group.s_1080p={
	cap_mode_xywh = {80,40,300,60},
	t_mode_xywh  = {420,40,300,60},
	cap_group_xywh = {80,110,300,60},
	t_group_xywh = {420,110,300,50},
	cap_channel_xywh ={80,190,300,60},
	t_set_all_xywh  = {410,190,50,50},
	cap_check_all_xywh = {460,190,200,50},
	channel_table_xywh ={420,190,380,140},
	s_event_table_btn_xywh = {0,0, 40,40},
	t_button_xywh = {1350,380,120,40},
	disk_list_xywh = {80,550,1422,260},
	tipinfo_xywh = {80,850,600,60},
	default_tipinfo = {80,430,800,60},
	
	columns_w_1= {90,0,0,0},
	columns_w_2= {310,0,0,0},
	columns_w_3= {700,0,0,0},
	columns_w_4= {160,0,0,0},
	columns_w_5= {150,0,0,0},
}

w1_page_disk_group.s_2k={
	cap_mode_xywh = {80,40,300,60},
	t_mode_xywh  = {600,40,300,60},
	cap_group_xywh = {80,110,300,60},
	t_group_xywh = {600,110,300,50},
	cap_channel_xywh ={80,190,300,60},
	t_set_all_xywh  = {580,180,70,70},
	cap_check_all_xywh = {650,190,200,50},
	channel_table_xywh ={600,190,482,186},
	s_event_table_btn_xywh = {0,0, 52,52},
	t_button_xywh = {1800,420,120,53},
	disk_list_xywh = {80,750,1952,340},
	tipinfo_xywh = {80,1100,800,60},
	default_tipinfo = {80,650,800,60},
	
	columns_w_1= {100,0,0,0},
	columns_w_2= {400,0,0,0},
	columns_w_3= {1025,0,0,0},
	columns_w_4= {215,0,0,0},
	columns_w_5= {200,0,0,0},
}

w1_page_disk_group.s_4k={
	cap_mode_xywh = {160,80,600,120},
	t_mode_xywh  = {840,80,600,120},
	cap_group_xywh = {160,220,600,120},
	t_group_xywh = {840,220,600,100},
	cap_channel_xywh ={160,380,600,120},
	t_set_all_xywh  = {820,380,100,100},
	cap_check_all_xywh = {920,380,400,100},
	channel_table_xywh ={840,380,760,280},
	s_event_table_btn_xywh = {0,0, 80,80},
	t_button_xywh = {2700,760,240,80},
	disk_list_xywh = {160,1000,2884,520},
	tipinfo_xywh = {160,1600,1200,120},
	default_tipinfo = {160,860,1600,120},
	
	columns_w_1= {150,0,0,0},
	columns_w_2= {600,0,0,0},
	columns_w_3= {1600,0,0,0},
	columns_w_4= {300,0,0,0},
	columns_w_5= {210,0,0,0},
}

w1_page_disk_group.clear_data = function()
	w1_page_disk_group.data = nil;
end	

local reflsh_list = function (top,redraw)
	local disk_info = w1_page_disk_group.data
	
	local disklist={}
	for i=1,4 do
		local disk_text ='';
		local group_num = i;
		local useplace_text=0;
		local disksize_text=0;
		local channel_text='';
		local raid_text='';

		for k=1,disk_info['disk']['disk_num'] do
			local disk_idx = string.find(disk_info['disk']['disk'..k]['name'], '%d+'); --ҵֵ
			disk_idx = tonumber(string.sub(disk_info['disk']['disk'..k]['name'], disk_idx, -1)); --ַתΪ
			if disk_info['disk']['disk'..k]['group']==i-1 then
				if ''~=disk_text then
						disk_text=disk_text..","	
				end
				
				if (string.find(disk_info['disk']['disk'..k].name,"md") ~= nil) then
					disk_text = disk_text.."RAID-md"..disk_idx
				else
					disk_text=disk_text.."Disk"..disk_idx
				end
				
				useplace_text=useplace_text+disk_info['disk']['disk'..k]['used']
				disksize_text=disksize_text+disk_info['disk']['disk'..k]['size']
			end
		end
		
		
		if useplace_text<1000 then
			useplace_text = useplace_text.."MB"
		else
			useplace_text = useplace_text / 1000;
			if math.floor(useplace_text / 1)>=1000 then
				useplace_text =(math.floor(useplace_text / 100)/10)..'TB';
			else
				useplace_text = math.floor(useplace_text / 1)..'GB';
			end
		end
		
		if disksize_text<1000 then
			disksize_text = disksize_text.."MB"
		else
			disksize_text = disksize_text / 1000;
			if math.floor(disksize_text / 1)>=1000 then
				disksize_text =(math.floor(disksize_text / 100)/10)..'TB';
			else
				disksize_text = math.floor(disksize_text / 1)..'GB';
			end
		end
		
		local flag = 1;
		local compare = {};
		for k=1,channel_num do
			if disk_info['record']['channel'..k]['group']== i-1 then
				if flag==k then
					table.insert(compare,k)
				else
					if ''~=channel_text then
						channel_text=channel_text..","
					end
					if #compare > 1 then
						channel_text=channel_text..compare[1].."-"..compare[#compare]
					elseif #compare==1 then
						channel_text=channel_text..compare[1]
					end			
					flag = k
					compare = {}
					table.insert(compare,k)
				end	
				flag = flag+1;
			end
		end
		if ''~=channel_text then
			channel_text=channel_text..","
		end
		if #compare > 1 then
			channel_text=channel_text..compare[1].."-"..compare[#compare]
		elseif #compare==1 then
			channel_text=channel_text..compare[1]
		end		
		
		disklist['idx'..i] = {i-1, false, group_num, disk_text, channel_text, useplace_text, disksize_text};
	
	end
	disklist.item_total = 4;
	b_wnd_ex.set_listdata(top, w1_page_disk_group.wnd.disk_list.id, disklist, redraw);
	return 0
end

local cfgdatatoui =function (top,cfgdata)
	assert(type(cfgdata)=='table')
	w1_page_disk_group.data=cfgdata;
	local chn_data = cfgdata.record
	local cwnd=w1_page_disk_group.wnd;
	local cur_group = b_wnd_ex.get_sel(top,cwnd.t_group.id);
	local chn_table= {};
	for i=1,channel_num do
		if chn_data['channel'..i]['group']== cur_group then
			table.insert(chn_table,i)
		end
	end
	b_wnd_ex.set_chcopy_data(top,cwnd.channel_table.id,chn_table,false)
	reflsh_list(top,false)
end

local uitousercfg = function (top,cfgdata)
	local redata = cfgdata.record;
	local cwnd = w1_page_disk_group.wnd;
	local chn_data = b_wnd_ex.get_chcopy_data(top,cwnd.channel_table.id)
	local group = b_wnd_ex.get_sel(top,cwnd.t_group.id)
	for i=1,channel_num do
		if redata['channel'..i]['group']==group then
			redata['channel'..i]['group']=0
		end
	end
	for i,v in ipairs(chn_data) do
		redata['channel'..v]['group']=group
	end
	redata.type = 2;
	reflsh_list(top,true)
end

w1_page_disk_group.on_data_change=function (top)
	uitousercfg(top,w1_page_disk_group.data)
end

w1_page_disk_group.on_pre_show= function(top)
	local cwnd= w1_page_disk_group.wnd
	channel_num = global_val.get_channelnum();
	b_wnd_ex.set_chcopy_chn_num(top, cwnd.channel_table.id, channel_num, false)	
	local rect_size = SIZE('s_event_table_btn_xywh');
	b_wnd_ex.set_chn_type_size(top, cwnd.channel_table.id, rect_size, false);
	
	local titletext ={STR('LA_GROUPS'), STR('LA_DISK'),STR('LA_CHANNEL'),STR('LA_USED_SPACE'), STR('LA_CAPACITY')}
	b_wnd_ex.set_title_texts(top, cwnd.disk_list.id, titletext, false)
	local list_w = {};
	for i=1,5 do
		local str = 'columns_w_'..math.floor(i/1);
		list_w[i] = SIZE(str)[1];
	end
	b_wnd_ex.columns_w(top, cwnd.disk_list.id, list_w, false);
end

w1_page_disk_group.init = function(top)
	w1_wnd_util.cfgtab = {'record_group','disk'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

local uidatacheck =function(top)
	return true, nil
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local redata = w1_page_disk_group.data.record
		for i=1,channel_num do
			if redata['channel'..i]['group']==-1 then
				redata['channel'..i]['group']=0
			end
		end
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_group = function (top, win_id, vmsg, x, y)
	if b_ui_msg.msg_user_update_parent == vmsg then
		local cwnd=w1_page_disk_group.wnd
		local chn_data = w1_page_disk_group.data.record
		local cur_group = b_wnd_ex.get_sel(top,cwnd.t_group.id);
		local chn_table= {};
		for i=1,channel_num do
			if chn_data['channel'..i]['group']== cur_group then
				table.insert(chn_table,i)
			end
		end
		b_wnd_ex.set_chcopy_data(top,cwnd.channel_table.id,chn_table,true)
		uitousercfg(top,w1_page_disk_group.data)
	end
	return 0
end

local on_modetype = function (top, win_id, vmsg, x, y)
	if vmsg==b_ui.WM_USER_UPDATE_PARAM then
		local cwnd = w1_page_disk_group.wnd;
		b_wnd_ex.set_check(top,cwnd.t_mode.id,true,true)
	end
	return 0
end

w1_page_disk_group.timer_start = function()
	w1_page_disk_group.timestart = true
end

w1_page_disk_group.timer_stop = function(top)
	w1_page_disk_group.timestart = false
	w1_wnd_util.tipclear(top, w1_page_disk_group.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_disk_group.timerenevt = function(top)
	if(w1_page_disk_group.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_disk_group.wnd.tipinfo.id)
	end
	return 0
end

w1_page_disk_group.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	local redata = w1_page_disk_group.data.record
		for i=1,channel_num do
			if redata['channel'..i]['group']==-1 then
				redata['channel'..i]['group']=0
			end
		end
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()
	end
	return ret;
end

w1_page_disk_group.wnd = {
	t='wnd_bg',id=id,xywh='s_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'},
	sub={'cap_mode','t_mode','cap_group','t_group','cap_channel','channel_table'
		,'disk_list','apply','tipinfo','t_tipinfo'},
	
	cap_mode= {t='static',id=id+1,xywh='cap_mode_xywh',text='LA_MODE_SELECTION'},
	t_mode = {t='radio_text',id=id+2,xywh='t_mode_xywh',text='LA_GROUPS',check=true,cmd= on_modetype,
		color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n',}},
	
	cap_group= {t='static',id=id+3, xywh='cap_group_xywh',text='LA_DISK_GROUP'},
	t_group = {t='combox',id=id+4, xywh='t_group_xywh',items={'1','2','3','4'},trans=false,cmd=on_group},
	
	cap_channel = {t='static',id=id+5 ,xywh='cap_channel_xywh', text='LA_CHANNEL'},
	
	channel_table = {t='chn_copy', id=id+8,	xywh='channel_table_xywh',
					color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n',}},
	
	disk_list	= {t='list',	id=id+10,	xywh='disk_list_xywh', font = 'f_grade4',
			listattr = {4,5,b_ui.LISTATTR.FIRST_WIDGET_STATIC},
			columns_w = {100,100,200,100,100},
			columns_align = {b_ui.ALIGN.CENTER, b_ui.ALIGN.CENTER,b_ui.ALIGN.CENTER, b_ui.ALIGN.CENTER, b_ui.ALIGN.CENTER,b_ui.ALIGN.CENTER, b_ui.ALIGN.CENTER, b_ui.ALIGN.CENTER},
					},
	t_tipinfo = {t= 'static',id=id+12,xywh='default_tipinfo',text='LA_GROUP_TIP'},
	tipinfo		= {t='static',id=id+11,	xywh='tipinfo_xywh',	text='',trans = false},	
	
	apply =	{t='button',id=id+9,xywh='t_button_xywh',text='LA_APPLY',cmd=on_apply},
}

return w1_page_disk_group