--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_image.image_id
local b_app_api = require("wnd.core.command.b_app_api")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_wnd 	= require("wnd.core.b_wnd")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local util 		= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_row_imagerow 		= require("wnd.w1_cfg.w1_row_imagerow")
local w1_page_imagetime 	= require("wnd.w1_cfg.w1_page_imagetime")
local w1_page_imageadjust	= require("wnd.w1_cfg.w1_page_imageadjust")
local w1_page_imagescenes	= require("wnd.w1_cfg.w1_page_imagescenes")
local w1_page_imageexposure	= require("wnd.w1_cfg.w1_page_imageexposure")
local w1_page_imagebalance 	= require("wnd.w1_cfg.w1_page_imagebalance")
local w1_page_imagedaynight = require("wnd.w1_cfg.w1_page_imagedaynight")
local w1_page_imagenoise	= require("wnd.w1_cfg.w1_page_imagenoise")
local w1_page_imageenhance  = require("wnd.w1_cfg.w1_page_imageenhance")
local w1_page_imagefocus	= require("wnd.w1_cfg.w1_page_imagefocus")
local w1_page_imagepcolor	= require("wnd.w1_cfg.w1_page_imagepcolor")
local w1_page_imageffc		= require("wnd.w1_cfg.w1_page_imageffc")

local w1_page_image = 
{
	old_chid,
	data,
	timestart = false,
	copy_ch = {},
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
};

w1_page_image.s_768 =
{
	s_cfg_image_image_xywh = {70,22,352,256},
	s_image_cap_channel_xywh = {436,35,85,35},
	s_image_t_channel_xywh = {543,39,131,28},
	s_image_tipinfo_xywh = {70,590,426,35},
};

w1_page_image.s_1280 = 
{	
	s_cfg_image_image_xywh = {92,32,512,288},
	s_image_cap_channel_xywh = {630,50,160,50},
	s_image_t_channel_xywh = {800,50,150,40},
	s_image_tipinfo_xywh = {92,790,500,50},
};

w1_page_image.s_1440 = 
{
	s_cfg_image_image_xywh = {100,32,512,288},
	s_image_cap_channel_xywh = {630,50,160,50},
	s_image_t_channel_xywh = {800,50,150,40},
	s_image_tipinfo_xywh = {100,690,600,50},
	
};

w1_page_image.s_1080p = 
{
	s_cfg_image_image_xywh = {98,32,640,360},
	s_image_cap_channel_xywh = {800,50,160,50},
	s_image_t_channel_xywh = {1000,55,246,40},
	s_image_tipinfo_xywh = {98,830,800,50},
};

w1_page_image.s_2k = 
{
	s_cfg_image_image_xywh = {136,43,856,480},
	s_image_cap_channel_xywh = {1066,67,213,67},
	s_image_t_channel_xywh = {1333,73,328,53},
	s_image_tipinfo_xywh = {133,1110,1200,67},

};

w1_page_image.s_4k = 
{
	s_cfg_image_image_xywh = {200,64,1284,720},
	s_image_cap_channel_xywh = {1600,100,320,100},
	s_image_t_channel_xywh = {2000,110,492,80},
	s_image_tipinfo_xywh = {200,1660,1500,100},

};
local channel_num --豸ͨĿ

w1_page_image.clear_data = function()
	w1_page_image.data = nil;
	w1_page_image.copy_ch = nil;
end	

local set_custom_layout = function(chid)
	local param = {
		chn_id = chid,
		wnd_id = 1,
	}
	local layoutpos = w1_page_image.layoutpos;
	param.x = layoutpos.x;
	param.y = layoutpos.y;
	param.cx = layoutpos.cx;
	param.cy = layoutpos.cy;
	b_app_api.set_custom_layout_wnd(param)
end

local refresh_hide = function(top, bool_hide,data, redraw)
	local hide_flag = bool_hide;
	if(false == bool_hide and 1 ~= data.other_param_enable)then
		hide_flag = true;
	end
	--[[if(data == nil or next(data) == nil)then
		hide_flag = true;
	end--]]
	
	w1_row_imagerow.sethide(top, data, hide_flag, redraw);
	w1_page_imageadjust.sethide(top, hide_flag, redraw);
	w1_page_imagescenes.sethide(top, hide_flag, redraw);
	w1_page_imageexposure.sethide(top, hide_flag, redraw);
	w1_page_imagebalance.sethide(top, hide_flag, redraw);
	w1_page_imagedaynight.sethide(top, hide_flag, redraw);
	w1_page_imagenoise.sethide(top, hide_flag, redraw);
	w1_page_imageenhance.sethide(top, hide_flag, redraw);
	w1_page_imagefocus.sethide(top, hide_flag, redraw);
	
	if(false == bool_hide and 1 ~= data.other_param_enable)then-- ͨߵ֧ǰ
		w1_page_imageadjust.sethide(top, false, redraw);
		w1_row_imagerow.changecheck(top,w1_row_imagerow.wnd, w1_id.cfg_image.imagerow_id + 1, false)
	end
end

local refresh_chdata = function(top, chid, redraw)
	local cwnd = w1_page_image.wnd;
	local channeldata = w1_page_image.data.color['channel'..chid];
	set_custom_layout(chid);
	if(-1 ~= channeldata.other_param_enable)then
		b_wnd_ex.set_hide(top, cwnd.reset.id, false, false);
		refresh_hide(top,false,channeldata,redraw);
		if(-1 == channeldata.focus.zoom_enable) and (-1 ==channeldata.focus.dn_autofocus)then	--۽佹֧
			w1_page_imagefocus.sethide(top, true, redraw);
			local cur_idx = w1_row_imagerow.get_checkidx(top)
			if(7 == cur_idx)then
				w1_row_imagerow.changecheck(top, w1_row_imagerow.wnd, w1_id.cfg_image.imagerow_id + 1,false);
			end
		else
			w1_page_imagefocus.set_param(top, channeldata, redraw);
		end
		if(-1 == channeldata.pcolor.pseudo_color and -1 == channeldata.pcolor.strip_switch ) then	--αò֧
			w1_page_imagepcolor.sethide(top, true, redraw); 
			local cur_idx = w1_row_imagerow.get_checkidx(top)
			if(8 == cur_idx)then
				w1_row_imagerow.changecheck(top, w1_row_imagerow.wnd, w1_id.cfg_image.imagerow_id + 1,false);
			end
		else
			w1_page_imagepcolor.set_param(top, channeldata, redraw);
		end
		if (-1 == channeldata.ffc.ffc_interval_min and -1 == channeldata.ffc.ffc_interval_tempr ) then	--۽佹֧
			local cur_idx = w1_row_imagerow.get_checkidx(top)
			w1_page_imageffc.sethide(top, true, redraw); 
			if(9 == cur_idx)then
				w1_row_imagerow.changecheck(top, w1_row_imagerow.wnd, w1_id.cfg_image.imagerow_id + 1,false);
			end
		else
			w1_page_imageffc.set_param(top,channeldata,redraw);
		end
	
		w1_page_imageadjust.set_param(top, channeldata, redraw);
		w1_page_imagescenes.set_param(top, channeldata, redraw);
		w1_page_imageexposure.set_param(top, channeldata, redraw);
		w1_page_imagebalance.set_param(top, channeldata, redraw);
		w1_page_imagedaynight.set_param(top, channeldata, redraw);
		w1_page_imagenoise.set_param(top, channeldata, redraw);
		w1_page_imageenhance.set_param(top, channeldata, redraw);
	else
		b_wnd_ex.set_hide(top, cwnd.reset.id, true, false);
		refresh_hide(top,false,channeldata,redraw);
		w1_page_imageadjust.set_param(top, channeldata, redraw);
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table');
	w1_page_image.data = cfgdata;
	
	local cwnd = w1_page_image.wnd;
	--local rtsp = w1_page_image.data.camera_bind
	local camreaitems = {};
	local idx = 1;
	local privilege = global_val.get_allprivilege();--ȡȨ
	local ch_prilist = privilege.channel_manager_list;
	--local camera_num = rtsp.camera_num;
	for i=1, channel_num do
		if(cfgdata['color']['channel'..i] ~= nil and ch_prilist[i] == 1) then
			camreaitems[idx] = i;
			idx = idx + 1;
		end
	end
	
	b_wnd_ex.set_items(top, cwnd.t_channel.id, camreaitems, false);
	if(idx ~= 1) then--˵ͨ
		b_wnd_ex.set_hide(top,w1_id.cfg_image.imagerow_id, 	false, false)
		b_wnd_ex.set_hide(top,cwnd.reset.id, false, false)

		local set_value = function(id, value)
			b_wnd_ex.set_value(top, id, value, false);
		end
		b_wnd_ex.set_disable(top, cwnd.t_channel.id, false, false);
		b_wnd_ex.set_sel(top, cwnd.t_channel.id, 0, false);--Ĭϵһ
		local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
		
		refresh_chdata(top, chid, false);
	else--Ȩ޵ͨ
		--һͨߣ
		--һͨߣͨȨȡ󲻴ͨ
		b_wnd_ex.set_hide(top,w1_id.cfg_image.imagerow_id, true, false)		
		b_wnd_ex.set_hide(top,cwnd.reset.id, true, false)

		local data = {};
		refresh_hide(top,true,data,false);
		b_wnd_ex.set_disable(top, cwnd.t_channel.id, true, false);
		for i=1, channel_num do
			if(ch_prilist[i] ~= 0) then
				set_custom_layout(i);
				break;
			end
		end		
	end
	return 0;
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local get_value = function(win_id)
		return b_wnd_ex.get_value(top, win_id);
	end		
	local cwnd = w1_page_image.wnd;
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	if(chid == nil) then
		return 0;
	end
	
	local data = cfgdata['color']['channel'..chid];
	data.change_flag = 1;
	return 0;
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil;
end

w1_page_image.timer_start = function()
	w1_page_image.timestart = true;
end

w1_page_image.timer_stop = function(top)
	w1_page_image.timestart = false;
	w1_wnd_util.tipclear(top, w1_page_image.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
end

w1_page_image.timerenevt = function(top)
	if(w1_page_image.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_image.wnd.tipinfo.id);
	end
	return 0;
end

local on_channel = function (top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local chid = tonumber(b_wnd_ex.get_text(top, w1_page_image.wnd.t_channel.id));
		if(w1_page_image.old_chid ~= chid) then
			refresh_chdata(top, chid, false);
			w1_page_image.old_chid = chid;
			w1_row_imagerow.changecheck(top,w1_row_imagerow.wnd, w1_id.cfg_image.imagerow_id + 1, false) --ÿлͨлimage
			b_dlg.dlg_set_redraw(top)
		end
	end
	return 0;
end

local on_program =function(top, win_id, vmsg, x, y)--ԺעлǷȡĬֵ
	if (vmsg == b_ui_msg.msg_user_update_parent) then
	
	end
	return 0;
end

local copy_okfunc = function(param)
	local cwnd = w1_page_image.wnd;
	local chid = tonumber(b_wnd_ex.get_text(param[1], cwnd.t_channel.id));
	if(chid == nil) then
		return 0;
	end
	chsrc = w1_page_image.data.color['channel'..chid];
	chdir = w1_page_image.data.color;
	
	for i=1, #param[2] do
		if(chdir['channel'..param[2][i]] == nil) then	
			chdir['channel'..param[2][i]] = util.copy_tab(chsrc);
		else
			util.copy_tab_b(chdir['channel'..param[2][i]], chsrc);
		end
		chdir['channel'..param[2][i]].channel_id = param[2][i];
	end
	return 0;
end

local okfunc_reset = function(param)
	local cwnd = w1_page_image.wnd;
	local channel = tonumber(b_wnd_ex.get_text(param[1], cwnd.t_channel.id)) ;
	if(channel ~= nil and channel > 0)then
		local ret = b_app_api.reset_color(channel)
		if(nil ==ret)then
			print("-------nil ==ret------------")
		end
		if(nil ~=ret and 0 ~= ret)then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_FACTORY_FAILED'), true, false,false);
			w1_msgbox.set_func(nil, nil, nil, nil);
			b_dlg.do_modal(param[1], w1_key.DLG_MSG_BOX, 0, 0, nil);	
			return 0;
		else
			local chnid = b_wnd_ex.get_sel(param[1], cwnd.t_channel.id) ;
			local cfg_tab = {'color'}
			local image_cfg ={}
			image_cfg = b_app_api.get_cfg(cfg_tab)
			
			local chn_str =tostring(channel) ;
			if(image_cfg['color']['channel'..chn_str] ~= nil) then
				w1_wnd_util.cfgtab = {'color'};
				w1_wnd_util.cfgtouifunc = cfgdatatoui;
				w1_wnd_util.page_init(param[1]);
				b_wnd_ex.set_sel(param[1], cwnd.t_channel.id, chnid, false);
				refresh_chdata(param[1], channel, false);
			else
				print("w1_page_image.lua: disconnect")
			end
			
			w1_page_image.old_chid = channel;
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_FACTORY_TIP'), true, false,false);
			w1_msgbox.set_func(nil, nil, nil, nil);
			b_dlg.do_modal(param[1], w1_key.DLG_MSG_BOX, 0, 0, nil);
			b_dlg.dlg_set_redraw(param[1])
		end
		
	end
	
end

local on_reset = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_RESTORE_TIP'), true, true,false);
		w1_msgbox.set_attach_dlgattr(STR('LA_SETTING_DEFAULT'));
		w1_msgbox.set_func(okfunc_reset, {top}, nil, nil);
		b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);	
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck;
		local ret = nil;	
		ret = w1_wnd_util.page_onapply(top)
		if (ret ~= nil and type(ret) == "table") then
			w1_wnd_util.tipdispon()
		end
	end
	return 0
end

w1_page_image.apply = function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()
	end
	return ret;
end

-- 1ʱЧ ˳ȡûԭ;  2Զǳԭ
w1_page_image.cancel = function(top)
	local data = b_app_cfg.origin_cfg
	local cur_data = b_app_cfg.user_cfg
	if(nil ~= cur_data) and (nil ~= cur_data['color'])then
		local camreaitems = {};
		local privilege = global_val.get_allprivilege();--ȡȨ
		local ch_prilist = privilege.channel_manager_list;
		for i=1, channel_num do
			if(cur_data['color']['channel'..i] ~= nil and ch_prilist[i] == 1) then
				local changflag = cur_data['color']['channel'..i].change_flag
				if(1 == changflag)then
					data['color']['channel'..i].change_flag = 1;
					b_app_api.set_immediate_color(data['color']['channel'..i]);
				end
				
			end
		end
	end
end
	
--ҳʼʱٶȡҳҪ
w1_page_image.init = function(top)
	w1_wnd_util.cfgtab = {'color'};
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);

	local chidstr = b_wnd_ex.get_text(top, w1_page_image.wnd.t_channel.id);
	if(chidstr == '') then
		return 0;
	end
	local chid =tonumber(chidstr);
	w1_page_image.old_chid = chid;
	return 0;
end

w1_page_image.on_pre_show = function(top)
	channel_num = global_val.get_channelnum();

	local cwnd = w1_page_image.wnd;
	local param = {
		x = SIZE('s_cfg_image_image_xywh')[1] + SIZE('s_cfg_page_xywh')[1], 
		y = SIZE('s_cfg_image_image_xywh')[2] + SIZE('s_cfg_page_xywh')[2],
		cx = SIZE('s_cfg_image_image_xywh')[3],
		cy = SIZE('s_cfg_image_image_xywh')[4],
	}
	local oldparam_x = param.x;
	param.x = math.floor((param.x + 2) / 4) * 4;--֤4ı
	param.cx = math.floor((param.cx + 2) / 4) *4;
	local oldparam_y = param.y;
	param.y = math.floor((param.y + 2) / 4) * 4;
	param.cy = math.floor((param.cy + 2) / 4) *4;
	
	w1_page_image.layoutpos.x = param.x;
	w1_page_image.layoutpos.cx = param.cx;
	w1_page_image.layoutpos.y = param.y;
	w1_page_image.layoutpos.cy = param.cy;
	
	local pos = {};
	pos[1] = SIZE('s_cfg_image_image_xywh')[1] + param.x - oldparam_x;
	pos[2] = SIZE('s_cfg_image_image_xywh')[2] + param.y - oldparam_y;
	pos[3] = param.cx;
	pos[4] = param.cy;
	b_wnd_ex.move_ex(top, cwnd.image.id, pos, false);
	local con_id = cwnd.con_image.id

	w1_row_imagerow.changecheck(top, w1_row_imagerow.wnd, w1_id.cfg_image.imagerow_id + 1 ,false);
end

w1_page_image.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = { 'image', 'cap_channel', 't_channel', 'cap_program','t_program',	
			'con_image','image_row_wnd',--[['imagetime_wnd',--]]'imageadjust_wnd','imagescenes_wnd',
			'imageexposure_wnd','imagebalance_wnd','imagedaynight_wnd','imagenoise_wnd','imageenhance_wnd',
			'imagefocus_wnd','imagepcolor_wnd', 'imageffc_wnd','tipinfo','reset','apply'},
			
	image = {t='image_param',id=id+1,xywh='s_cfg_image_image_xywh',text='Image widget', font = 'f_grade1', trans = false,
				color = {'c_imgae_param_bg', 'c_imgae_param_bg', 'c_imgae_param_bg'}},
	
	cap_channel	= {t='static',id=id+2,	xywh='s_image_cap_channel_xywh',	text='LA_CHANNEL'},
	t_channel 	= {t='combox',id=id+3,	xywh='s_image_t_channel_xywh',	items={'1','2','3','4','5','6','7','8'},trans = false,
					channel_cbox = true,cmd = on_channel},	

	con_image		= {t='container',id=w1_id.cfg_image.con_image_id,	xywh={0,0,10,10}},
	image_row_wnd 	= w1_row_imagerow.wnd,
	imageadjust_wnd = w1_page_imageadjust.wnd,
	imagescenes_wnd = w1_page_imagescenes.wnd,
	imageexposure_wnd = w1_page_imageexposure.wnd,
	imagebalance_wnd  = w1_page_imagebalance.wnd,
	imagedaynight_wnd = w1_page_imagedaynight.wnd,
	imagenoise_wnd	  =	w1_page_imagenoise.wnd,
	imageenhance_wnd  = w1_page_imageenhance.wnd,
	imagefocus_wnd  = w1_page_imagefocus.wnd,
	imagepcolor_wnd  = w1_page_imagepcolor.wnd,
	imageffc_wnd  = w1_page_imageffc.wnd,
	
	tipinfo		= {t='static',id=id+26,	xywh='s_image_tipinfo_xywh',text='',trans = false
			},	
		
	reset 		= {t='button',id=id+27,	xywh = 's_cfg_copy_xywh',	text='LA_DEFAULT',cmd=on_reset},
	apply 		= {t='button',id=id+28,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_image;
