--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/9/14
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local b_dlg 	= require("wnd.core.b_dlg")
local id 		= w1_id.cfg_image.whitebalance_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local global_val	= require("wnd.global_val")

local w1_page_imagebalance = 
{
	cfg_data;
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_imagebalance.s_768 =
{
	s_cfg_page_imagebalance_xywh = {53,366,746,220},
	s_imagebalance_cap_mode_xywh = {32,0,106,35},
	s_imagebalance_t_mode_xywh = {197,0,106,35},
	s_imagebalance_cap_redgain_xywh = {32,42,106,35},
	s_imagebalance_redgain_subb_xywh = {197,49,16,21},
	s_imagebalance_t_redgain_xywh = {213,42,123,35},
	s_imagebalance_redgain_add_xywh = {337,49,16,21},
	s_imagebalance_redgain_value_xywh = {356,49,32,21},
	s_imagebalance_cap_bluegain_xywh = {32,85,106,35},
	s_imagebalance_bluegain_subb_xywh = {197,92,16,21},
	s_imagebalance_t_bluegain_xywh = {213,85,123,35},
	s_imagebalance_bluegain_add_xywh = {337,92,16,21},
	s_imagebalance_bluegain_value_xywh = {356,92,32,21},
};

w1_page_imagebalance.s_1280 = 
{
	s_cfg_page_imagebalance_xywh = {60,475,900,310},
	s_imagebalance_cap_mode_xywh 	= {60,0,160,45},
	s_imagebalance_t_mode_xywh		= {250,0,160,45},
	s_imagebalance_cap_redgain_xywh = {60,60,160,45},
	s_imagebalance_redgain_subb_xywh = {250,70,30,30},
	s_imagebalance_t_redgain_xywh = {280,60,160,45},
	s_imagebalance_redgain_add_xywh = {440,70,30,30},
	s_imagebalance_redgain_value_xywh = {475,70,60,30},
	s_imagebalance_cap_bluegain_xywh = {60,120,160,45},
	s_imagebalance_bluegain_subb_xywh = {250,130,30,30},
	s_imagebalance_t_bluegain_xywh = {280,120,160,45},
	s_imagebalance_bluegain_add_xywh = {440,130,30,30},
	s_imagebalance_bluegain_value_xywh = {475,130,60,30},
};

w1_page_imagebalance.s_1440 = 
{
	s_cfg_page_imagebalance_xywh = {60,440,1000,245},
	s_imagebalance_cap_mode_xywh 	= {60,0,160,45},
	s_imagebalance_t_mode_xywh		= {250,0,160,45},
	s_imagebalance_cap_redgain_xywh = {60,60,160,45},
	s_imagebalance_redgain_subb_xywh = {250,70,30,30},
	s_imagebalance_t_redgain_xywh = {280,60,160,45},
	s_imagebalance_redgain_add_xywh = {440,70,30,30},
	s_imagebalance_redgain_value_xywh = {475,70,60,30},
	s_imagebalance_cap_bluegain_xywh = {60,120,160,45},
	s_imagebalance_bluegain_subb_xywh = {250,130,30,30},
	s_imagebalance_t_bluegain_xywh = {280,120,160,45},
	s_imagebalance_bluegain_add_xywh = {440,130,30,30},
	s_imagebalance_bluegain_value_xywh = {475,130,60,30},
};

w1_page_imagebalance.s_1080p = 
{
	s_cfg_page_imagebalance_xywh = {100,515,1400,310},
	s_imagebalance_cap_mode_xywh 	= {60,0,200,50},
	s_imagebalance_t_mode_xywh		= {370,0,200,50},
	s_imagebalance_cap_redgain_xywh = {60,60,200,50},
	s_imagebalance_redgain_subb_xywh = {370,70,30,30},
	s_imagebalance_t_redgain_xywh = {400,60,232,50},
	s_imagebalance_redgain_add_xywh = {632,70,30,30},
	s_imagebalance_redgain_value_xywh = {668,70,60,30},
	s_imagebalance_cap_bluegain_xywh = {60,120,200,50},
	s_imagebalance_bluegain_subb_xywh = {370,130,30,30},
	s_imagebalance_t_bluegain_xywh = {400,120,232,50},
	s_imagebalance_bluegain_add_xywh = {632,130,30,30},
	s_imagebalance_bluegain_value_xywh = {668,130,60,30},

};

w1_page_imagebalance.s_2k = 
{
	s_cfg_page_imagebalance_xywh 		= {133,686,1866,413},
	s_imagebalance_cap_mode_xywh 		= {80,0,267,67},
	s_imagebalance_t_mode_xywh			= {493,0,267,67},
	s_imagebalance_cap_redgain_xywh 	= {80,80,267,67},
	s_imagebalance_redgain_subb_xywh	= {493,93,40,40},
	s_imagebalance_t_redgain_xywh 		= {533,80,309,67},
	s_imagebalance_redgain_add_xywh 	= {842,93,40,40},
	s_imagebalance_redgain_value_xywh 	= {890,93,80,40},
	s_imagebalance_cap_bluegain_xywh 	= {80,160,267,67},
	s_imagebalance_bluegain_subb_xywh 	= {493,173,40,40},
	s_imagebalance_t_bluegain_xywh 		= {533,160,309,67},
	s_imagebalance_bluegain_add_xywh 	= {842,173,40,40},
	s_imagebalance_bluegain_value_xywh 	= {890,173,80,40},

};

w1_page_imagebalance.s_4k = 
{
	s_cfg_page_imagebalance_xywh 		= {200,1030,2800,620},
	s_imagebalance_cap_mode_xywh 		= {120,0,400,100},
	s_imagebalance_t_mode_xywh			= {740,0,400,100},
	s_imagebalance_cap_redgain_xywh 	= {120,120,400,100},
	s_imagebalance_redgain_subb_xywh	= {740,140,60,60},
	s_imagebalance_t_redgain_xywh 		= {800,120,464,100},
	s_imagebalance_redgain_add_xywh 	= {1264,140,60,60},
	s_imagebalance_redgain_value_xywh 	= {1336,140,120,60},
	s_imagebalance_cap_bluegain_xywh 	= {120,240,400,100},
	s_imagebalance_bluegain_subb_xywh 	= {740,260,60,60},
	s_imagebalance_t_bluegain_xywh 		= {800,240,464,100},
	s_imagebalance_bluegain_add_xywh 	= {1264,260,60,60},
	s_imagebalance_bluegain_value_xywh 	= {1336,260,120,60},
};

w1_page_imagebalance.clear_data=function ()
	w1_page_imagebalance.cfg_data=nil;
end
--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_imagebalance.wnd;
	local data = cfgdata.wb;
	local mode_idx = b_wnd_ex.get_sel(top,cwnd.t_mode.id);
	if(5 == mode_idx)then
		data.rgb_mode = 9;
	else
		data.rgb_mode = mode_idx;
	end
	data.red_gain = b_wnd_ex.get_value(top,cwnd.t_redgain.id);
	data.blue_gain = b_wnd_ex.get_value(top,cwnd.t_bluegain.id);
	cfgdata.change_flag = 1;
	b_app_api.set_immediate_color(cfgdata);
	return 0
end

local set_image_value = function(top, id, value)
	local set_text = function(id, value)
		b_wnd_ex.set_text(top, id, tostring(value), true);
	end
	local cwnd = w1_page_imagebalance.wnd;
	if(id == cwnd.t_redgain.id) then
		set_text(cwnd.redgain_value.id, value);
	elseif(id == cwnd.t_bluegain.id) then
		set_text(cwnd.bluegain_value.id, value);
	end
	uitousercfg(top,w1_page_imagebalance.cfg_data)
end

local on_subb = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_imagebalance.wnd;
		local opearid = nil;
		if(win_id == cwnd.redgain_subb.id) then
			opearid = cwnd.t_redgain.id;
		elseif(win_id == cwnd.bluegain_subb.id) then
			opearid = cwnd.t_bluegain.id;
		end
		local value = b_wnd_ex.get_value(top, opearid);
		if(value > 0) then
			value = value - 1;
			b_wnd_ex.set_value(top, opearid, value, true);
			set_image_value(top, opearid, value);
		end	
	end
	return 0;
end

local on_adj = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local cwnd = w1_page_imagebalance.wnd;
		local value = b_wnd_ex.get_value(top, win_id);
		set_image_value(top, win_id, value);
	end
	return 0;
end

local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_imagebalance.wnd;
		local opearid = nil;
		if(win_id == cwnd.redgain_add.id) then
			opearid = cwnd.t_redgain.id;
		elseif(win_id == cwnd.bluegain_add.id) then
			opearid = cwnd.t_bluegain.id;
		end
		local value = b_wnd_ex.get_value(top, opearid);
		if(value < 100) then
			value = value + 1;
			b_wnd_ex.set_value(top, opearid, value, true)
			set_image_value(top, opearid, value);
		end
	end
	return 0;
end

local refresh_hide = function (top,param,redraw)
	local cwnd = w1_page_imagebalance.wnd;
	local mode = param.rgb_mode;
	if(9 == param.rgb_mode)then
		mode = 5;
	end
	if(-1 == param.rgb_mode)then
		b_wnd_ex.set_hide(top, cwnd.cap_mode.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_mode.id, true, false);
	else
		b_wnd_ex.set_hide(top, cwnd.cap_mode.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.t_mode.id, false, false);
	end
	
	if(-1 == param.red_gain)then
		b_wnd_ex.set_hide(top, cwnd.cap_redgain.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.redgain_subb.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_redgain.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.redgain_add.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.redgain_value.id, true, false);
	else
		b_wnd_ex.set_hide(top, cwnd.cap_redgain.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.redgain_subb.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.t_redgain.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.redgain_add.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.redgain_value.id, false, false);
	end
	
	if(-1 == param.blue_gain)then
		b_wnd_ex.set_hide(top, cwnd.cap_bluegain.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.bluegain_subb.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_bluegain.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.bluegain_add.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.bluegain_value.id, true, false);
	else
		b_wnd_ex.set_hide(top, cwnd.cap_bluegain.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.bluegain_subb.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.t_bluegain.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.bluegain_add.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.bluegain_value.id, false, false);
	end
	
	if(5 == mode)then  --ȷϺǷҪΪû
		b_wnd_ex.set_hide(top, cwnd.cap_redgain.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.redgain_subb.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.t_redgain.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.redgain_add.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.redgain_value.id, false, false);
		
		b_wnd_ex.set_hide(top, cwnd.cap_bluegain.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.bluegain_subb.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.t_bluegain.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.bluegain_add.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.bluegain_value.id, false, false);		
	else
		b_wnd_ex.set_hide(top, cwnd.cap_redgain.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.redgain_subb.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_redgain.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.redgain_add.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.redgain_value.id, true, false);
		
		b_wnd_ex.set_hide(top, cwnd.cap_bluegain.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.bluegain_subb.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_bluegain.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.bluegain_add.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.bluegain_value.id, true, false);	
	end
	if false ~= redraw then
		b_dlg.dlg_set_redraw(top);
	end
end

local on_mode = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cwnd = w1_page_imagebalance.wnd;
		local mode = b_wnd_ex.get_sel(top, cwnd.t_mode.id);
		uitousercfg(top,w1_page_imagebalance.cfg_data)
		local data = w1_page_imagebalance.cfg_data.wb;
		refresh_hide(top,data,true)	
	end
	return 0;
end

w1_page_imagebalance.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_imagebalance.wnd;
	b_wnd_ex.set_hide(top, cwnd.cap_mode.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_mode.id, bool_hide, redraw)
	
	b_wnd_ex.set_hide(top, cwnd.cap_redgain.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.redgain_subb.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_redgain.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.redgain_add.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.redgain_value.id, bool_hide, redraw)
	
	b_wnd_ex.set_hide(top, cwnd.cap_bluegain.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.bluegain_subb.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_bluegain.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.bluegain_add.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.bluegain_value.id, bool_hide, redraw)
end

w1_page_imagebalance.set_param = function(top, param, redraw)
	local cwnd = w1_page_imagebalance.wnd;
	local data = param.wb;
	b_wnd_ex.set_value(top, cwnd.t_redgain.id, data.red_gain, redraw);
	b_wnd_ex.set_text(top, cwnd.redgain_value.id, tostring(data.red_gain), redraw);
	
	b_wnd_ex.set_value(top, cwnd.t_bluegain.id, data.blue_gain, redraw);
	b_wnd_ex.set_text(top, cwnd.bluegain_value.id, tostring(data.blue_gain), redraw);
	if(9 == data.rgb_mode)then
		b_wnd_ex.set_sel(top, cwnd.t_mode.id,5, redraw);
		refresh_hide(top,data,false)
	else
		b_wnd_ex.set_sel(top, cwnd.t_mode.id, data.rgb_mode, redraw);
		refresh_hide(top,data,false)
	end
	
	local dlg_w = global_val.get_size();
	if(dlg_w == 1440)then
		b_wnd_ex.dlg_direct_up(top, cwnd.t_mode.id, true, false);
	else
		b_wnd_ex.dlg_direct_up(top, cwnd.t_mode.id, false, false);
	end
	w1_page_imagebalance.cfg_data = param;
end

w1_page_imagebalance.get_param = function(top)
	local cwnd = w1_page_imagebalance.wnd;
	local param = {};
	local mode_idx = b_wnd_ex.get_sel(top,cwnd.t_mode.id);
	if(5 == mode_idx)then
		param.rgb_mode = 9;
	else
		param.rgb_mode = mode_idx;
	end
	param.red_gain = b_wnd_ex.get_value(top,cwnd.t_redgain.id);
	param.blue_gain = b_wnd_ex.get_value(top,cwnd.t_bluegain.id);
	return param
end

w1_page_imagebalance.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_imagebalance_xywh',
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub = {'cap_mode','t_mode','cap_redgain', 'redgain_subb', 't_redgain', 'redgain_add', 'redgain_value', 
			'cap_bluegain','bluegain_subb', 't_bluegain','bluegain_add','bluegain_value',},

	cap_mode = {t='static',id=id+1,xywh='s_imagebalance_cap_mode_xywh',text='LA_MODE',font = 'f_image',
					},	
	t_mode  	= {t='combox',id=id+2,xywh='s_imagebalance_t_mode_xywh',items={'LA_AUTO','LA_TUNGSTEN','LA_FLUORESCENT','LA_DAY_LIGHT','LA_SHADOW','LA_MANUAL'}, cmd = on_mode,
					},	
					
	--redgain		
	cap_redgain	= {t='static',id=id+3,	xywh='s_imagebalance_cap_redgain_xywh',	text='LA_RED_GAIN',font = 'f_image'},
	redgain_subb	= {t='button',id=id+4,	xywh='s_imagebalance_redgain_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_redgain		= {t='hslider',id=id+5,	xywh='s_imagebalance_t_redgain_xywh',		
					font = 'f_slider', cmd=on_adj},
	redgain_add	= {t='button',id=id+6,	xywh='s_imagebalance_redgain_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	redgain_value	= {t='static',id=id+7,	xywh='s_imagebalance_redgain_value_xywh',text='',font = 'f_image',trans = false},
	--bluegain
	cap_bluegain= {t='static',id=id+8,	xywh='s_imagebalance_cap_bluegain_xywh',text='LA_BLUE_GAIN',font = 'f_image'},
	bluegain_subb	= {t='button',id=id+9,	xywh='s_imagebalance_bluegain_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_bluegain	= {t='hslider',id=id+10,	xywh='s_imagebalance_t_bluegain_xywh',	
					font = 'f_slider', cmd=on_adj},
	bluegain_add	= {t='button',id=id+11,	xywh='s_imagebalance_bluegain_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	bluegain_value	= {t='static',id=id+12,	xywh='s_imagebalance_bluegain_value_xywh',text='',font = 'f_image',trans = false},
}

return w1_page_imagebalance

