local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_image.imagepcolor_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local b_dlg = require("wnd.core.b_dlg")
local w1_page_imagepcolor = 
{
	cfg_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_imagepcolor.s_768 =
{
	s_cfg_page_imagepcolor_xywh = {53,366,746,220},
	s_imagepcolor_cap_pseudo_xywh = {32,0,160,35},
	s_imagepcolor_t_pseudo_xywh = {216,0,106,35},
	s_imagepcolor_cap_brig_xywh = {32,42,160,35},
	s_imagepcolor_t_strip_xywh = {216,42,106,35},
};

w1_page_imagepcolor.s_1280 = 
{
	s_cfg_page_imagepcolor_xywh = {60,475,900,310},
	s_imagepcolor_cap_pseudo_xywh = {60,0,160,50},
	s_imagepcolor_t_pseudo_xywh= {260,0,160,50},
	s_imagepcolor_cap_brig_xywh = {60,60,160,50},
	s_imagepcolor_t_strip_xywh = {260,60,160,50},

};

w1_page_imagepcolor.s_1440 = 
{
	s_cfg_page_imagepcolor_xywh = {60,440,900,245},
	s_imagepcolor_cap_pseudo_xywh = {60,0,160,45},
	s_imagepcolor_t_pseudo_xywh= {255,0,160,45},
	s_imagepcolor_cap_brig_xywh = {60,50,160,40},
	s_imagepcolor_t_strip_xywh = {255,50,160,40},
};

w1_page_imagepcolor.s_1080p = 
{
	s_cfg_page_imagepcolor_xywh = {100,515,1400,310},
	s_imagepcolor_cap_pseudo_xywh = {60,0,300,50},
	s_imagepcolor_t_pseudo_xywh= {405,0,200,50},
	s_imagepcolor_cap_brig_xywh = {60,60,300,50},
	s_imagepcolor_t_strip_xywh = {405,60,200,50},
	
};

w1_page_imagepcolor.s_2k = 
{
	s_cfg_page_imagepcolor_xywh = {133,686,1866,413},
	s_imagepcolor_cap_pseudo_xywh = {80,0,213,67},
	s_imagepcolor_t_pseudo_xywh= {352,0,213,67},
	s_imagepcolor_cap_brig_xywh = {80,80,213,67},
	s_imagepcolor_t_strip_xywh = {352,80,213,67},
};

w1_page_imagepcolor.s_4k = 
{
	s_cfg_page_imagepcolor_xywh 	= {200,1030,2800,620},
	s_imagepcolor_cap_pseudo_xywh 	= {120,0,320,100},
	s_imagepcolor_t_pseudo_xywh		= {520,0,400,100},
	s_imagepcolor_cap_brig_xywh 	= {120,120,320,100},
	s_imagepcolor_t_strip_xywh 		= {520,120,400,100},

};

w1_page_imagepcolor.clear_data=function ()
	w1_page_imagepcolor.cfg_data=nil;
end

local COLOR_PARAM = {
	default = {bright = 50, contrast = 50, saturation = 50, sharpness = 50},
	indoor 	= {bright = 60, contrast = 50, saturation = 50, sharpness = 55},
	outdoor = {bright = 45, contrast = 50, saturation = 50, sharpness = 45}
};

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_imagepcolor.wnd;
	local data = cfgdata.pcolor;
	if(-1 ~= data.pseudo_color)then
		data.pseudo_color = b_wnd_ex.get_sel(top,cwnd.t_pseudo.id);
	end
	if(-1 ~= data.strip_switch)then
		data.strip_switch = b_wnd_ex.get_sel(top,cwnd.t_strip.id)+1;
	end
	cfgdata.change_flag = 1;
	
	b_app_api.set_immediate_color(cfgdata);
	return 0
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
	
		uitousercfg(top,w1_page_imagepcolor.cfg_data)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local refresh_hide = function(top, param, redraw)
	local cwnd = w1_page_imagepcolor.wnd;
	if(-1 == param.pseudo_color)then
		b_wnd_ex.set_hide(top, cwnd.cap_pseudo.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_pseudo.id, true, redraw)
	else
		b_wnd_ex.set_hide(top, cwnd.cap_pseudo.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_pseudo.id, false, redraw)
	end
	if(-1 == param.strip_switch)then
		b_wnd_ex.set_hide(top, cwnd.cap_brig.id, true, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_strip.id, true, redraw)
	else	
		b_wnd_ex.set_hide(top, cwnd.cap_brig.id, false, redraw)
		b_wnd_ex.set_hide(top, cwnd.t_strip.id, false, redraw)
	end
	
	
end

w1_page_imagepcolor.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_imagepcolor.wnd;
	b_wnd_ex.set_hide(top, cwnd.cap_pseudo.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_pseudo.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.cap_brig.id, bool_hide, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_strip.id, bool_hide, redraw)

end

w1_page_imagepcolor.set_param = function(top, param, redraw)
	local cwnd = w1_page_imagepcolor.wnd;
	local data = param.pcolor;--w1_page_image.data.color['channel'..chid];
	refresh_hide(top, data, false)

	b_wnd_ex.set_sel(top, cwnd.t_pseudo.id, data.pseudo_color, redraw);
	b_wnd_ex.set_sel(top, cwnd.t_strip.id, data.strip_switch-1, redraw);

	w1_page_imagepcolor.cfg_data = param;
end

w1_page_imagepcolor.get_param = function(top)
	local cwnd = w1_page_imagepcolor.wnd;
	local param = {};
	param.bright = b_wnd_ex.get_value(top,cwnd.t_strip.id);

	return param;
end

w1_page_imagepcolor.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_imagepcolor_xywh',
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub = {'cap_pseudo','t_pseudo','cap_brig', 't_strip', 
			},
		
	cap_pseudo = {t='static',id=id+1,xywh='s_imagepcolor_cap_pseudo_xywh',text='LA_PSEUDO_MODE',font = 'f_image',
					},	
					
	t_pseudo  = {t='combox',id=id+2,xywh='s_imagepcolor_t_pseudo_xywh',items={'LA_PSEUDO_C1','LA_PSEUDO_C2',	
				'LA_PSEUDO_C3','LA_PSEUDO_C4','LA_PSEUDO_C5','LA_PSEUDO_C6','LA_PSEUDO_C7','LA_PSEUDO_C8',
				'LA_PSEUDO_C9','LA_PSEUDO_C10','LA_PSEUDO_C11','LA_PSEUDO_C12','LA_PSEUDO_C13','LA_PSEUDO_C14',
				'LA_PSEUDO_C15','LA_PSEUDO_C16','LA_PSEUDO_C17',},  
					font = 'f_image',cmd = on_update_param
					},
	cap_brig	=  {t='static',id=id+3,xywh='s_imagepcolor_cap_brig_xywh',text='LA_TEMPERATURE_BAR',font = 'f_image',},
				
	t_strip		= {t='combox',id=id+4,xywh='s_imagepcolor_t_strip_xywh',items={'LA_ON','LA_CLOSE'},  
					font = 'f_image',cmd = on_update_param
					},
	--sharp		
	
}

return w1_page_imagepcolor

