--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_id 		= require("wnd.w1_util.w1_id")
local global_val	= require("wnd.global_val")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local id 			= w1_id.cfg_devinfo.devinfo_id

local t_qr_pp = "P2P";				-- [QR code]P2Pά

local w1_page_info = 
{
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_info.s_768 =
{
	s_cfg_page_info_5_2 = {281,192,266,32},
	s_cfg_page_info_8_2 = {277,320,42,32},
	s_cfg_page_info_9_2 = {277,362,42,32},
	s_cfg_page_info_10_2 = {277,405,42,32},
	s_cfg_page_info_11_2 = {277,448,42,32},
	s_cfg_page_info_12_2 = {277,490,42,32},
	s_cfg_page_info_13_2 = {277,533,42,32},
	s_page_info_line1 = {53,143,730,1},
	s_page_info_line2 = {53,356,730,1},
	s_page_info_qr_pp = {277,490,80,106},
};

w1_page_info.s_1280 = 
{
	s_cfg_page_info_5_2 = {460, 270, 400, 45},
	s_cfg_page_info_8_2 = {450, 450, 80, 45},
	s_cfg_page_info_9_2 = {450, 510, 80, 45},
	s_cfg_page_info_10_2 = {450, 570, 80, 45},
	s_cfg_page_info_11_2 = {450, 630, 80, 45},
	s_cfg_page_info_12_2 = {450, 690, 80, 45},
	s_cfg_page_info_13_2 = {450, 750,80, 45},
	s_page_info_line1 = {100,202,780,1},
	s_page_info_line2 = {100,502,780,1},
	s_page_info_qr_pp = {450, 690, 150, 150},
};

w1_page_info.s_1440 = 
{
	s_cfg_page_info_5_2= {530, 225, 400, 45},
	s_cfg_page_info_8_2 = {520, 375, 80, 45},
	s_cfg_page_info_9_2 = {520, 425, 80, 45},
	s_cfg_page_info_10_2= {520, 475, 80, 45},
	s_cfg_page_info_11_2= {520, 525, 80, 45},
	s_cfg_page_info_12_2 = {520, 575, 80, 45},
	s_cfg_page_info_13_2 = {520, 625,80, 45},
	s_page_info_line1 = {100,170,880,1},
	s_page_info_line2 = {100,420,880,1},
	s_page_info_qr_pp = {520, 575, 150, 150},
};

w1_page_info.s_1080p = 
{
	s_cfg_page_info_5_2 = {527, 270, 500, 45},
	s_cfg_page_info_8_2 = {520, 450, 80, 45},
	s_cfg_page_info_9_2 = {520, 510, 80, 45},
	s_cfg_page_info_10_2= {520, 570, 80, 45},
	s_cfg_page_info_11_2= {520, 630, 80, 45},
	s_cfg_page_info_12_2 = {520, 690, 80, 45},
	s_cfg_page_info_13_2 = {520, 750,80, 45},
	s_page_info_line1 = {100,202,1370,1},
	s_page_info_line2 = {100,502,1370,1},
	s_page_info_qr_pp = {520, 690, 150, 150},
};
w1_page_info.s_2k = 
{
	s_cfg_page_info_5_2 = {703,360,667,60},
	s_cfg_page_info_8_2 = {693,600,107,60},
	s_cfg_page_info_9_2 = {693,680,107,60},
	s_cfg_page_info_10_2= {693,760,107,60},
	s_cfg_page_info_11_2= {693,840,107,60},
	s_cfg_page_info_12_2 = {693,920,107,60},
	s_cfg_page_info_13_2 = {693,1000,107,60},
	s_page_info_line1 = {133,269,1826,1},
	s_page_info_line2 = {133,669,1826,1},	
	s_page_info_qr_pp = {693, 920, 200, 200},
};
w1_page_info.s_4k = 
{
	s_cfg_page_info_5_2 = {1055,540,1000,90},
	s_cfg_page_info_8_2 = {1040,900,160,90},
	s_cfg_page_info_9_2 = {1040,1020,160,90},
	s_cfg_page_info_10_2= {1040,1140,160,90},
	s_cfg_page_info_11_2= {1040,1260,160,90},
	s_cfg_page_info_12_2 = {1040,1380,160,90},
	s_cfg_page_info_13_2 = {1040,1500,160,90},
	s_page_info_line1 = {200,404,2740,2},
	s_page_info_line2 = {200,1004,2740,2},
	s_page_info_qr_pp = {1040, 1380, 300, 300},

};



--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local data = cfgdata.device_info
	local function settext(id, str)
		b_wnd_ex.set_text(top, id, str,false)
	end
	local cwnd = w1_page_info.wnd
	
	settext(cwnd.t_id.id, data.dev_id);
	if(data.dev_type == 2) then
		settext(cwnd.t_devtype.id, 'DVR');
	elseif(data.dev_type == 5) then
		settext(cwnd.t_devtype.id, 'NVR');
	else
		settext(cwnd.t_devtype.id, 'GET ERROR');
	end
	settext(cwnd.t_name.id, data.dev_name );
	settext(cwnd.t_model.id, data.dev_model );
	settext(cwnd.t_sversion.id, data.dev_fw_ver );
	settext(cwnd.t_uboot.id, data.uboot_ver );
	settext(cwnd.t_kernel.id, data.kernel_ver );
	settext(cwnd.t_hdd.id, tostring(data.hdd_num) );
	settext(cwnd.t_channel.id, tostring(data.chn_num) );
	settext(cwnd.t_alarmin.id, tostring(data.si_num) );
	settext(cwnd.t_alarmout.id, tostring(data.ro_num) );
	settext(cwnd.t_audioin.id, tostring(data.ai_num) );
	settext(cwnd.t_audioout.id, tostring(data.ao_num) );
	settext(cwnd.t_face_version.id, data.face_detect_ver );
	
	local face_support = global_val.get_support_face_attr();	
	if (false == face_support)	then
		b_wnd_ex.set_hide (top, cwnd.cap_face_version.id, true, false);		
		b_wnd_ex.set_hide (top, cwnd.t_face_version.id, true, false);
		--
		local pos1 = SIZE('s_cfg_page_1_1');
		local pos2 = SIZE('s_cfg_page_2_1');	
		local move_h = 	pos2[2] - pos1[2];
		for i = 18, 30 do
			local pos = SIZE(cwnd[cwnd.sub[i]].xywh);
			b_wnd_ex.move_pos(top, cwnd[cwnd.sub[i]].id, {pos[1], pos[2] - move_h}, false);
		end	
	end	
	
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

w1_page_info.timerenevt = function(top)
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_info.init = function(top)
	w1_wnd_util.cfgtab = {'device_info'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0;
end


--UIָĬֵ
local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
	end
	return 0
end


w1_page_info.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	
	sub = {	'cap_id','t_id', 'cap_name', 't_name', 'cap_devtype', 't_devtype','hline1',
			 'cap_model', 't_model', 'cap_sversion', 't_sversion','cap_uboot','t_uboot','cap_kernel','t_kernel','cap_face_version', 't_face_version','hline2',
			'cap_hdd', 't_hdd', 'cap_channel', 't_channel', 'cap_alarmin', 't_alarmin','cap_alarmout', 't_alarmout',
			'cap_audioin', 't_audioin','cap_audioout', 't_audioout','cap_qr_pp', 'qr_pp',
			'default', 'apply' },
			
	cap_id 		= {t='static',id=id+1,	xywh='s_cfg_page_1_1',text='LA_DEVICE_ID'},
	t_id 		= {t='static',id=id+2,	xywh='s_cfg_page_1_2',text='',trans = false},
	cap_name	= {t='static',id=id+3,	xywh='s_cfg_page_2_1',text='LA_DEVICE_NAME'},
	t_name 		= {t='static',id=id+4,	xywh='s_cfg_page_2_2',text='Device',trans = false},
	cap_devtype	= {t='static',id=id+5,	xywh='s_cfg_page_3_1',text='LA_DEVICE_TYPE'},
	t_devtype 	= {t='static',id=id+6,	xywh='s_cfg_page_3_2',text='DVR',trans = false},
	
	hline1 		= {t='hline',id=id+7,	xywh='s_page_info_line1'},
	
	cap_model	= {t='static',id=id+8,	xywh='s_cfg_page_4_1',text='LA_PRODUCT_MODEL'},
	t_model 	= {t='static',id=id+9,	xywh='s_cfg_page_4_2',text='ADR2304E1',trans = false},
	cap_sversion= {t='static',id=id+10,	xywh='s_cfg_page_5_1',text='LA_SOFTWARE_VERSION'},
	t_sversion 	= {t='static',id=id+11,	xywh='s_cfg_page_info_5_2',text='V4.2.0',trans = false},
	
	cap_uboot= {t='static',id=id+12,	xywh='s_cfg_page_6_1',text='LA_U_BOOT'},
	t_uboot 	= {t='static',id=id+13,	xywh='s_cfg_page_6_2',text='V4.2.0',trans = false},
	
	cap_kernel= {t='static',id=id+14,	xywh='s_cfg_page_7_1',text='LA_KERNEL_VERSION'},
	t_kernel 	= {t='static',id=id+15,	xywh='s_cfg_page_7_2',text='V4.2.0',trans = false},
	cap_face_version= {t='static',id=id+16,	xywh='s_cfg_page_8_1',text='LA_FD_VERSION'},
	t_face_version 	= {t='static',id=id+17,	xywh='s_cfg_page_8_2',text='1741101',trans = false},

	hline2 		= {t='hline',id=id+18,	xywh='s_page_info_line2'},

	cap_hdd		= {t='static',id=id+19,	xywh='s_cfg_page_9_1',text='LA_HDD_NUMBER'},
	t_hdd 		= {t='static',id=id+20,	xywh='s_cfg_page_9_2',text='1',trans = false},
	cap_channel	= {t='static',id=id+21,	xywh='s_cfg_page_10_1',text='LA_CAMERA_SUPPORT'},
	t_channel 	= {t='static',id=id+22,	xywh='s_cfg_page_10_2',text='4',trans = false},
	cap_alarmin	= {t='static',id=id+23,	xywh='s_cfg_page_11_1',text='LA_ALARM_IN'},
	t_alarmin 	= {t='static',id=id+24,	xywh='s_cfg_page_11_2',text='2',trans = false},
	cap_alarmout= {t='static',id=id+25,	xywh='s_cfg_page_12_1',text='LA_ALARM_OUT'},
	t_alarmout 	= {t='static',id=id+26,	xywh='s_cfg_page_12_2',text='2',trans = false},
	cap_audioin	= {t='static',id=id+27,	xywh='s_cfg_page_13_1',text='LA_AUDIO_IN'},
	t_audioin 	= {t='static',id=id+28,	xywh='s_cfg_page_13_2',text='4',trans = false},
	cap_audioout= {t='static',id=id+29,	xywh='s_cfg_page_14_1',text='LA_AUDIO_OUT'},
	t_audioout 	= {t='static',id=id+30,	xywh='s_cfg_page_14_2',text='4',trans = false},
}

return w1_page_info



