--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_id 		= require("wnd.w1_util.w1_id")
local global_val	= require("wnd.global_val")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_parser 	= require("wnd.core.b_parser")
local b_app_api = require("wnd.core.command.b_app_api");
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local util 		= require("wnd.core.util")
local id 			= w1_id.cfg_devinfo.alarminfo_id

local w1_page_info_alarm = 
{
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_info_alarm.s_768 =
{
	s_info_ala_wnd_xywh = {2,46,478,423},
	s_info_ala_alarm_list_xywh = {37,21,757,576},
	s_info_ala_page_up_xywh = {186,384,21,28},
	s_info_ala_page_xywh = {218,384,80,28},
	s_info_ala_page_down_xywh = {298,384,21,28},
	s_info_ala1 = {110,0,0,0},
	s_info_ala2 = {112,0,0,0},
	s_info_ala3 = {105,0,0,0},
	s_info_ala4 = {110,0,0,0},
	s_info_ala5 = {297,0,0,0},
};

w1_page_info_alarm.s_1280 = 
{
	s_info_ala_wnd_xywh= {5,65,898,596},
	s_info_ala_alarm_list_xywh= {70,30,880,780},
	s_info_ala_page_up_xywh= {350,540,40,40},
	s_info_ala_page_xywh= {410,540,150,40},
	s_info_ala_page_down_xywh= {560,540,40,40},
	s_info_ala1 = {148,0,0,0},
	s_info_ala2 = {172,0,0,0},
	s_info_ala3 = {108,0,0,0},
	s_info_ala4 = {118,0,0,0},
	s_info_ala5 = {312,0,0,0},


}
w1_page_info_alarm.s_1440 = 
{
	s_info_ala_wnd_xywh= {5,65,898,596},
	s_info_ala_alarm_list_xywh= {70,30,1000,670},
	s_info_ala_page_up_xywh= {350,540,40,40},
	s_info_ala_page_xywh= {410,540,150,40},
	s_info_ala_page_down_xywh= {560,540,40,40},
	s_info_ala1 = {198,0,0,0},
	s_info_ala2 = {142,0,0,0},
	s_info_ala3 = {128,0,0,0},
	s_info_ala4 = {138,0,0,0},
	s_info_ala5 = {368,0,0,0},


}	
	
w1_page_info_alarm.s_1080p = 
{
	s_info_ala_wnd_xywh= {5,65,898,596},
	s_info_ala_alarm_list_xywh= {70,30,1420,810},--880
	s_info_ala_page_up_xywh= {350,540,40,40},
	s_info_ala_page_xywh= {410,540,150,40},
	s_info_ala_page_down_xywh= {560,540,40,40},
	s_info_ala1 = {208,0,0,0},
	s_info_ala2 = {210,0,0,0},
	s_info_ala3 = {198,0,0,0},
	s_info_ala4 = {208,0,0,0},
	s_info_ala5 = {558,0,0,0},

}

w1_page_info_alarm.s_2k = 
{
--	s_info_ala_wnd_xywh= {3,83,1197,794},
	s_info_ala_wnd_xywh= {7,87,1197,794},

	s_info_ala_alarm_list_xywh= {91,40,1893,1050},--1173
	s_info_ala_page_up_xywh= {467,720,53,53},
	s_info_ala_page_xywh= {547,720,200,53},
	s_info_ala_page_down_xywh= {746,720,53,53},
	s_info_ala1 = {274,0,0,0},
	s_info_ala2 = {279,0,0,0},
	s_info_ala3 = {260,0,0,0},
	s_info_ala4 = {273,0,0,0},
	s_info_ala5 = {742,0,0,0},

}

w1_page_info_alarm.s_4k = 
{
--	s_info_ala_wnd_xywh= {4,124,1796,1192},
	s_info_ala_wnd_xywh= {10,130,1796,1192},
	s_info_ala_alarm_list_xywh= {140,60,2840,1620},--1760
	s_info_ala_page_up_xywh= {700,1080,80,80},
	s_info_ala_page_xywh= {820,1080,300,80},
	s_info_ala_page_down_xywh= {1120,1080,80,80},
	s_info_ala1 = {416,0,0,0},
	s_info_ala2 = {420,0,0,0},
	s_info_ala3 = {396,0,0,0},
	s_info_ala4 = {416,0,0,0},
	s_info_ala5 = {1116,0,0,0},

}
local channel_count;--豸ͨĿ
local IN_INFO = nil;
local OUT_INFO = nil;
local updatelist = function(top, redraw)
	num = IN_INFO.num;
	local displist = {};
	local idx = 0;
	for i=1, num do
		idx = idx + 1;
		
		local str = STR('LA_LOCAL')..'<-'..i
		
		local status = STR('LA_NO');
		if(0 == IN_INFO['sensor'..i].nc)then
			status = STR('LA_NO');
		else
			status = STR('LA_NC')
		end 
		local channel_list = ''
		local chn_idx = 1
		local chn_list = {}
		for j,v in ipairs(IN_INFO['sensor'..i].linkage.trigger_ch) do
			if chn_idx ==v then
				table.insert(chn_list,v)
			else
				if channel_list~='' then
					channel_list = channel_list..','
				end
				if #chn_list==1 then
					channel_list = channel_list..chn_list[1]
				elseif #chn_list >1 then
					channel_list = channel_list..chn_list[1]..'-'..chn_list[#chn_list]
				end
				chn_list = {}
				chn_idx = v
				table.insert(chn_list,v)
			end
			chn_idx = chn_idx+1
		end
		if channel_list~='' then
			channel_list = channel_list..','
		end
		if #chn_list==1 then
			channel_list = channel_list..chn_list[1]
		elseif #chn_list >1 then
			channel_list = channel_list..chn_list[1]..'-'..chn_list[#chn_list]
		end
		
		local enable = STR('LA_ON')--"stream1";
		if( IN_INFO['sensor'..i].enable)then
			enable = STR('LA_ON')--"stream1";
		else
			enable = STR('LA_OFF')--"stream2";
		end
		
		if (false == IN_INFO['sensor'..i].linkage.record) then
			channel_list = '';		
		end
		
		displist['idx'..idx] = {idx-1, false, 
		str,IN_INFO['sensor'..i].name,status,enable,channel_list};	
	end
	num = OUT_INFO.num;
	for i=1,num do
		idx = idx + 1;
		local str = STR('LA_LOCAL')..'->'..i
		
		local status = STR('LA_NO');
		if(0 == OUT_INFO['outid'..i].valid_level)then
			status = STR('LA_OPEN_T');
		else
			status = STR('LA_CLOSE_T')
		end 
		local channel_list = ''
	
		local enable = ''
		
		displist['idx'..idx] = {idx-1, false, 
		str,OUT_INFO['outid'..i].name,status,enable,channel_list};
	end
	displist.item_total = idx;
	b_wnd_ex.set_listdata(top, w1_page_info_alarm.wnd.alarm_list.id, displist, redraw);	
end

local cfgdatatoui = function (top,cfgdate)
	local alarm_info = b_app_api.get_cfg({'alarm_in','alarm_out'})
	if('table' ~= type(alarm_info))then
		return 0;
	end	
	
	if (IN_INFO == nil) then
		IN_INFO = alarm_info.alarm_in;
	else
		util.copy_tab_b(IN_INFO, alarm_info.alarm_in);	
	end
	if (OUT_INFO == nil) then
		OUT_INFO = alarm_info.alarm_out;
	else
		util.copy_tab_b(OUT_INFO, alarm_info.alarm_out);	
	end
	updatelist(top, true);
end

w1_page_info_alarm.init = function(top)
	w1_wnd_util.cfgtab = {''}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0;
end

w1_page_info_alarm.on_pre_show = function(top)
	local cwnd = w1_page_info_alarm.wnd;
	channel_count = global_val.get_channelnum();
	local param = {
			STR('LA_CHANNEL'), STR('LA_NAME'),STR('LA_MODE'), STR('LA_ENABLE'),STR('LA_RECORD_CHANNEL')
		}
	b_wnd_ex.set_title_texts(top, cwnd.alarm_list.id, param, false);
	local list_w = {};
		for i=1,5 do
			local str = 's_info_ala'..math.floor(i/1);
			list_w[i] = SIZE(str)[1];
		end
	b_wnd_ex.columns_w(top, cwnd.alarm_list.id, list_w, false);
		
	local alarm_info = b_app_api.get_cfg({'alarm_in','alarm_out'})
	if('table' ~= type(alarm_info))then
		return 0;
	end	
	
	if (IN_INFO == nil) then
		IN_INFO = alarm_info.alarm_in;
	else
		util.copy_tab_b(IN_INFO, alarm_info.alarm_in);	
	end
	if (OUT_INFO == nil) then
		OUT_INFO = alarm_info.alarm_out;
	else
		util.copy_tab_b(OUT_INFO, alarm_info.alarm_out);	
	end
	updatelist(top, false);
end
	
w1_page_info_alarm.clear = function()
	IN_INFO = nil
	OUT_INFO = nil
end
	
w1_page_info_alarm.wnd = 
{
	t='wnd_bg',
	id=id,
	xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'},
	sub = {'alarm_list',--[['page_up', 'page', 'page_down'--]]},
	alarm_list	= {t='list',	id=id+2,	xywh='s_info_ala_alarm_list_xywh', font = 'f_grade4',
					listattr = {12,5,b_ui.LISTATTR.FIRST_WIDGET_STATIC,0},list_tip =true,
					title_texts = {'Channel', 'Name','Status','Stream','Channel',},
					columns_w = {108,122,108,118,148,},
		},
		
	page_up 	= {t='tt_button',	id=id+3,	xywh='s_info_ala_page_up_xywh',		
					t_imgs = {b_ui.ALIGN.CENTER,'f_pageupdown','it_pageup','it_pageup', 'it_pageup'},
					color = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_f'},
					cmd = on_pageup},
					
	page 		= {t='combox',	id=id+4,	xywh='s_info_ala_page_xywh',		text='0/0',trans = false, 
					align = b_ui.ALIGN.CENTER, font = 'f_grade4',dlg_direct_up = true,
					t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_null','it_null', 'it_null'},
					color = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_f'},
					cmd = on_page},
	page_down 	= {t='tt_button',id=id+5,	xywh='s_info_ala_page_down_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_pageupdown','it_pagedown','it_pagedown', 'it_pagedown'},
					color = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_f'},
					cmd = on_pagedown},	
	
}

return w1_page_info_alarm



