--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_id 		= require("wnd.w1_util.w1_id")
local global_val	= require("wnd.global_val")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local id 			= w1_id.cfg_devinfo.chninfo_id
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_parser 	= require("wnd.core.b_parser")
local b_app_api = require("wnd.core.command.b_app_api");
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local util 		= require("wnd.core.util")

local w1_page_info_chn = 
{
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_info_chn.s_768 =
{
	s_info_ch_wnd_xywh = {2,46,478,423},
	s_info_ch_channel_list_xywh = {37,21,757,576},
	s_info_ch_page_up_xywh = {186,384,21,28},
	s_info_ch_page_xywh = {218,384,80,28},
	s_info_ch_page_down_xywh = {298,384,21,28},
	s_info_ch_chlist_w1 = {57,0,0,0},
	s_info_ch_chlist_w2 = {112,0,0,0},
	s_info_ch_chlist_w3 = {105,0,0,0},
	s_info_ch_chlist_w4 = {148,0,0,0},
	s_info_ch_chlist_w5 = {190,0,0,0},
	s_info_ch_chlist_w6 = {120,0,0,0},
};

w1_page_info_chn.s_1280 = 
{
	s_info_ch_wnd_xywh= {5,65,898,596},
	s_info_ch_channel_list_xywh= {70,30,880,780},
	s_info_ch_page_up_xywh= {350,540,40,40},
	s_info_ch_page_xywh= {410,540,150,40},
	s_info_ch_page_down_xywh= {560,540,40,40},
	s_info_ch_chlist_w1 = {98,0,0,0},
	s_info_ch_chlist_w2 = {122,0,0,0},
	s_info_ch_chlist_w3 = {108,0,0,0},
	s_info_ch_chlist_w4 = {157,0,0,0},
	s_info_ch_chlist_w5 = {248,0,0,0},
	s_info_ch_chlist_w6 = {125,0,0,0},
}
w1_page_info_chn.s_1440 = 
{
	s_info_ch_wnd_xywh= {5,65,898,596},
	s_info_ch_channel_list_xywh= {70,30,1002,670},
	s_info_ch_page_up_xywh= {350,540,40,40},
	s_info_ch_page_xywh= {410,540,150,40},
	s_info_ch_page_down_xywh= {560,540,40,40},
	s_info_ch_chlist_w1 = {98,0,0,0},
	s_info_ch_chlist_w2 = {142,0,0,0},
	s_info_ch_chlist_w3 = {128,0,0,0},
	s_info_ch_chlist_w4 = {172,0,0,0},
	s_info_ch_chlist_w5 = {300,0,0,0},
	s_info_ch_chlist_w6 = {140,0,0,0},
}	
	
w1_page_info_chn.s_1080p = 
{
	s_info_ch_wnd_xywh= {5,65,898,596},
	s_info_ch_channel_list_xywh= {70,30,1420,810},--880
	s_info_ch_page_up_xywh= {350,540,40,40},
	s_info_ch_page_xywh= {410,540,150,40},
	s_info_ch_page_down_xywh= {560,540,40,40},
	s_info_ch_chlist_w1 = {108,0,0,0},
	s_info_ch_chlist_w2 = {210,0,0,0},
	s_info_ch_chlist_w3 = {198,0,0,0},
	s_info_ch_chlist_w4 = {278,0,0,0},
	s_info_ch_chlist_w5 = {366,0,0,0},
	s_info_ch_chlist_w6 = {238,0,0,0},
}

w1_page_info_chn.s_2k = 
{
--	s_info_ch_wnd_xywh= {3,83,1197,794},
	s_info_ch_wnd_xywh= {7,87,1197,794},

	s_info_ch_channel_list_xywh= {91,40,1893,1050},--1173
	s_info_ch_page_up_xywh= {467,720,53,53},
	s_info_ch_page_xywh= {547,720,200,53},
	s_info_ch_page_down_xywh= {746,720,53,53},
	s_info_ch_chlist_w1 = {144,0,0,0},
	s_info_ch_chlist_w2 = {279,0,0,0},
	s_info_ch_chlist_w3 = {260,0,0,0},
	s_info_ch_chlist_w4 = {363,0,0,0},
	s_info_ch_chlist_w5 = {486,0,0,0},
	s_info_ch_chlist_w6 = {320,0,0,0},
}

w1_page_info_chn.s_4k = 
{
--	s_info_ch_wnd_xywh= {4,124,1796,1192},
	s_info_ch_wnd_xywh= {10,130,1796,1192},
	s_info_ch_channel_list_xywh= {140,60,2840,1620},--1760
	s_info_ch_page_up_xywh= {700,1080,80,80},
	s_info_ch_page_xywh= {820,1080,300,80},
	s_info_ch_page_down_xywh= {1120,1080,80,80},
	s_info_ch_chlist_w1 = {216,0,0,0},
	s_info_ch_chlist_w2 = {420,0,0,0},
	s_info_ch_chlist_w3 = {396,0,0,0},
	s_info_ch_chlist_w4 = {534,0,0,0},
	s_info_ch_chlist_w5 = {776,0,0,0},
	s_info_ch_chlist_w6 = {454,0,0,0},
}
local channel_count;--豸ͨĿ
local CHANNEL_INFO = nil;

local updatelist = function(top, redraw)
	num = CHANNEL_INFO.bind_chn_num;
	local displist = {};
	local idx = 0;
	for i=1, num do
		idx = idx + 1;
	
		local str = "CH"..tostring(CHANNEL_INFO.channel_id[i]);
		local status = STR('LA_OFFLINE');
		if(0 == CHANNEL_INFO.chn_status[i])then
			status = STR('LA_DISCONNECTED');
		elseif(1 == CHANNEL_INFO.chn_status[i])then
			status = STR('LA_OFFLINE');
		elseif(2 == CHANNEL_INFO.chn_status[i])then
			status = STR('LA_OFFLINE');
		elseif(3 == CHANNEL_INFO.chn_status[i])then
			status = STR('LA_OFFLINE');
		else
			status = STR('LA_ONLINE')
		end 
		local enctype="H.264/";
		if(1 == CHANNEL_INFO.stream1.enc_type[i])then
			enctype = "H.264/";
		elseif(2 == CHANNEL_INFO.stream1.enc_type[i])then
			enctype = "H.265/";
		else
			enctype = "H.264/";
		end
		if(1 == CHANNEL_INFO.stream2.enc_type[i])then
			enctype = enctype.."H.264";
		elseif(2 == CHANNEL_INFO.stream2.enc_type[i])then
			enctype = enctype.."H.265";
		else
			enctype = enctype.."H.264";
		end
		local reso = tostring(CHANNEL_INFO.stream1.with[i]).."*"..tostring(CHANNEL_INFO.stream1.height[i]).."/"
		reso = reso..tostring(CHANNEL_INFO.stream2.with[i]).."*"..tostring(CHANNEL_INFO.stream2.height[i])
		local bit = CHANNEL_INFO.stream1.bitrate[i].."/"..CHANNEL_INFO.stream2.bitrate[i]

		displist['idx'..idx] = {idx-1, false, 
		str,CHANNEL_INFO.channel_name[i],status,enctype,reso,bit
		};	
	end
	displist.item_total = idx;
	b_wnd_ex.set_listdata(top, w1_page_info_chn.wnd.channel_list.id, displist, redraw);	
end

local cfgdatatoui = function (top,cfgdate)
	local chn_info = b_app_api.get_channel_info();	
	if('table' ~= type(chn_info))then
		return 0;
	end	
	
	if (CHANNEL_INFO == nil) then
		CHANNEL_INFO = chn_info;
	else
		util.copy_tab_b(CHANNEL_INFO, chn_info);	
	end
	updatelist(top, true);
end

w1_page_info_chn.init = function(top)
	w1_wnd_util.cfgtab = {''}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0;
end

w1_page_info_chn.on_pre_show = function(top)
	local cwnd = w1_page_info_chn.wnd;
	channel_count = global_val.get_channelnum();
	local param = {
			STR('LA_CHANNEL'), STR('LA_NAME'),STR('LA_STATUS'),STR('LA_VIDEO_ENCODE_TYPE'),STR('LA_RESOLUTION'),STR('LA_BITRATE')
		}
	b_wnd_ex.set_title_texts(top, cwnd.channel_list.id, param, false);
	local list_w = {};
		for i=1,6 do
			local str = 's_info_ch_chlist_w'..math.floor(i/1);
			list_w[i] = SIZE(str)[1];
		end
	b_wnd_ex.columns_w(top, cwnd.channel_list.id, list_w, false);
		
	local chn_info = b_app_api.get_channel_info();	
	if('table' ~= type(chn_info))then
		return 0;
	end	
	
	if (CHANNEL_INFO == nil) then
		CHANNEL_INFO = chn_info;
	else
		util.copy_tab_b(CHANNEL_INFO, chn_info);	
	end
	updatelist(top, false);
end
	
w1_page_info_chn.clear = function()
	CHANNEL_INFO = nil
end
	
w1_page_info_chn.wnd = 
{
	t='wnd_bg',
	id=id,
	xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'},
	sub = {'channel_list',--[['page_up', 'page', 'page_down'--]]},
	channel_list	= {t='list',	id=id+2,	xywh='s_info_ch_channel_list_xywh', font = 'f_grade6',
					listattr = {12,6,b_ui.LISTATTR.FIRST_WIDGET_STATIC,0},list_tip =true,
					title_texts = {'Channel', 'Name','Status','Stream','Encode type', 'Resolution','Bitrate'},
					columns_w = {108,122,108,118,148,148},
		},
		
	page_up 	= {t='tt_button',	id=id+3,	xywh='s_info_ch_page_up_xywh',		
					t_imgs = {b_ui.ALIGN.CENTER,'f_pageupdown','it_pageup','it_pageup', 'it_pageup'},
					color = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_f'},
					cmd = on_pageup},
					
	page 		= {t='combox',	id=id+4,	xywh='s_info_ch_page_xywh',		text='0/0',trans = false, 
					align = b_ui.ALIGN.CENTER, font = 'f_grade4',dlg_direct_up = true,
					t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_null','it_null', 'it_null'},
					color = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_f'},
					cmd = on_page},
	page_down 	= {t='tt_button',id=id+5,	xywh='s_info_ch_page_down_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_pageupdown','it_pagedown','it_pagedown', 'it_pagedown'},
					color = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_f'},
					cmd = on_pagedown},	
	
}
return w1_page_info_chn



