--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/6/7
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_alarmin.ioalarm_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  	= require("wnd.w1_util.w1_ui_msg") 
local w1_row_ioalarmrow 		= require("wnd.w1_cfg.w1_row_ioalarmrow")
local w1_page_ioalarmevent 		= require("wnd.w1_cfg.w1_page_ioalarmevent")
local w1_page_ioalarmtimeplan 	= require("wnd.w1_cfg.w1_page_ioalarmtimeplan")
local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local util 		= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local b_app_api = require("wnd.core.command.b_app_api")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local r_color		= require("wnd.core.r_res.r_color")
local COLOR 		= r_color.get_color
local channel_num;
local w1_page_ioalarm = 
{
	data,
	channel = 0,
	old_sel,
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_ioalarm.s_768 =
{
	s_ioalarm_t_enable_xywh = {277,152,25,21},
	s_ioalarm_tipinfo_xywh = {58,586,160,28},
};

w1_page_ioalarm.s_1280 = 
{
	s_ioalarm_t_enable_xywh = {455,215,48,30};
	s_ioalarm_tipinfo_xywh = {110,810,260,40};
}

w1_page_ioalarm.s_1440 = 
{
	s_ioalarm_t_enable_xywh = {520,182,48,30},
	s_ioalarm_tipinfo_xywh = {110,693,300,30},
}


w1_page_ioalarm.s_1080p = 
{
	s_ioalarm_t_enable_xywh = {520,215,48,30};
	s_ioalarm_tipinfo_xywh = {110,825,300,40};
}

w1_page_ioalarm.s_2k = 
{
	s_ioalarm_t_enable_xywh = {693,287,64,40},
	s_ioalarm_tipinfo_xywh = {147,1100,390,53},

}
w1_page_ioalarm.s_4k = 
{
	s_ioalarm_t_enable_xywh = {1040,430,96,60},
	s_ioalarm_tipinfo_xywh = {220,1650,600,80},
}

w1_page_ioalarm.clear_data = function()
	w1_page_ioalarm.data = nil;
end	

local refresh_chdata = function(top, chid, source_id, redraw)
	local c_wnd = w1_page_ioalarm.wnd
	local cfgdata = b_app_api.get_ioalarm_cfg(chid,source_id);
	local ro_num = w1_page_ioalarm.data.device_info['ro_num']
	local buzz_support = w1_page_ioalarm.data.device_info['buzzer_support']
	b_app_cfg.origin_cfg.ioalarm = util.copy_tab(cfgdata.ioalarm);
	b_app_cfg.user_cfg.ioalarm = util.copy_tab(cfgdata.ioalarm);
	b_wnd_ex.set_check(top, c_wnd.t_enable.id, cfgdata.ioalarm.enable, redraw);
	if(cfgdata.ioalarm.valid_level == 0) then
		b_wnd_ex.set_sel(top,c_wnd.t_mode.id,1,false);
	else
		b_wnd_ex.set_sel(top,c_wnd.t_mode.id,0,false);
	end
	
	local checkidx = w1_row_ioalarmrow.get_checkidx(top);
	if(checkidx == 0) then
		w1_page_ioalarmevent.setstatus(top, b_app_cfg.user_cfg.ioalarm, chid, ro_num, buzz_support,redraw)
		w1_page_ioalarmtimeplan.settimeplan(top, b_app_cfg.user_cfg.ioalarm, false);
	else
		w1_page_ioalarmevent.setstatus(top, b_app_cfg.user_cfg.ioalarm, chid, ro_num, buzz_support,false)
		w1_page_ioalarmtimeplan.settimeplan(top, b_app_cfg.user_cfg.ioalarm, redraw);
	end
end


--ˢUI
local cfgdatatoui = function(top, cfgdata)
	local c_wnd = w1_page_ioalarm.wnd
	local idx = 1;
	local camreaitems = {};
	w1_page_ioalarm.data = cfgdata
	w1_page_ioalarm.old_sel = 0
	local privilege= global_val.get_allprivilege()
	for i=1, channel_num do
		if cfgdata['ioalarm_cap']['channel'..i] ~= nil and cfgdata['ioalarm_cap']['channel'..i].alarm_in_num > 0 
			and privilege['channel_manager_list'][i] ~= 0 then
			camreaitems[idx] = i;
			if w1_page_ioalarm.channel == i then
				w1_page_ioalarm.old_sel = idx-1
			end
			idx = idx + 1;
		end
	end
	b_wnd_ex.set_text(top,c_wnd.tipinfo.id,'',false);
	b_wnd_ex.set_items(top, c_wnd.t_channel.id, camreaitems, false);
	if(idx ~= 1) then--˵ͨ
		b_wnd_ex.set_sel(top, c_wnd.t_channel.id,w1_page_ioalarm.old_sel,false);
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		w1_page_ioalarm.channel = chid
		local source_ids = {};
		if(cfgdata['ioalarm_cap']['channel'..chid].alarm_in_num > 0) then
			for i=1, cfgdata['ioalarm_cap']['channel'..chid].alarm_in_num do
				source_ids[i]=i;
			end
			w1_page_ioalarmevent.sethide(top, false, false)
			w1_page_ioalarmtimeplan.sethide(top, false, false)
			b_wnd_ex.set_items(top,c_wnd.t_alarm_input.id,source_ids,false);
			b_wnd_ex.set_sel(top,c_wnd.t_alarm_input.id,0,false);
			refresh_chdata(top, chid, 1, false);
			b_wnd_ex.set_hide(top, c_wnd.cap_alarm_input.id, false, false);
			b_wnd_ex.set_hide(top, c_wnd.t_alarm_input.id, false, false);
			b_wnd_ex.set_hide(top, c_wnd.cap_mode.id, false, false);
			b_wnd_ex.set_hide(top, c_wnd.t_mode.id, false, false);
			b_wnd_ex.set_hide(top, c_wnd.cap_enable.id, false, false);
			b_wnd_ex.set_hide(top, c_wnd.t_enable.id, false, false);
			b_wnd_ex.set_hide(top,  w1_id.cfg_alarmin.ioalarmrow_id, false, false)
		else
			b_wnd_ex.set_hide(top, c_wnd.cap_alarm_input.id, true, false);
			b_wnd_ex.set_hide(top, c_wnd.t_alarm_input.id, true, false);
			b_wnd_ex.set_hide(top, c_wnd.cap_mode.id, true, false);
			b_wnd_ex.set_hide(top, c_wnd.t_mode.id, true, false);
			b_wnd_ex.set_hide(top, c_wnd.cap_enable.id, true, false);
			b_wnd_ex.set_hide(top, c_wnd.t_enable.id, true, false);
			b_wnd_ex.set_hide(top,  w1_id.cfg_alarmin.ioalarmrow_id, true, false)
			w1_page_ioalarmevent.sethide(top, true, false)
			w1_page_ioalarmtimeplan.sethide(top, true, false)
			b_wnd_ex.set_text(top,c_wnd.tipinfo.id,STR('LA_RAID_NOT_SUPPORT'),false);
			b_wnd_ex.set_color(top,c_wnd.tipinfo.id,
			{COLOR('c_cfg_page_bk'),COLOR('c_cfg_page_bk'),COLOR('c_hint_err_text')},false);
		end
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id,false, false)
	else
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id,true, false)
		b_wnd_ex.set_hide(top, c_wnd.cap_alarm_input.id, true, false);
		b_wnd_ex.set_hide(top, c_wnd.t_alarm_input.id, true, false);
		b_wnd_ex.set_hide(top, c_wnd.cap_mode.id, true, false);
		b_wnd_ex.set_hide(top, c_wnd.t_mode.id, true, false);
		b_wnd_ex.set_hide(top, c_wnd.cap_enable.id, true, false);
		b_wnd_ex.set_hide(top, c_wnd.t_enable.id, true, false);
		b_wnd_ex.set_hide(top,  w1_id.cfg_alarmin.ioalarmrow_id,true, false)
		w1_page_ioalarmevent.sethide(top, true, false)
		w1_page_ioalarmtimeplan.sethide(top, true, false)
	end
	b_dlg.dlg_set_redraw(top);
	return 0;
end


local uidatacheck =function(top)
	return true, nil
end

w1_page_ioalarm.timer_start = function()
	w1_page_ioalarm.timestart = true
end

w1_page_ioalarm.timer_stop = function(top)
	w1_page_ioalarm.timestart = false
	w1_wnd_util.tipclear(top, w1_page_ioalarm.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_ioalarm.timerenevt = function(top)
	if(w1_page_ioalarm.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_ioalarm.wnd.tipinfo.id)
	end
	return 0
end
--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_ioalarm.wnd
	local valid_level = b_wnd_ex.get_sel(top,cwnd.t_mode.id);
	local enable = b_wnd_ex.get_check(top,cwnd.t_enable.id);
--[[	local linkage = w1_page_ioalarmevent.getstatus(top);
	local timeplan = w1_page_ioalarmtimeplan.gettimeplan(top);--]]
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id))
	local data = cfgdata.ioalarm
	data.enable = enable;
	if valid_level == 0 then
		data.valid_level = 1;
	else
		data.valid_level = 0;
	end
	
--[[	data.linkage = linkage;
	data.timeplan = timeplan;--]]
	--data.change_flag = true;
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_ioalarm.init = function(top)
	w1_wnd_util.cfgtab = {'ioalarm','ioalarm_cap','device_info'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	w1_page_ioalarm.old_sel = 0; --Ĭ϶1ʼ 
	return 0
end

local on_channel = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local c_wnd = w1_page_ioalarm.wnd
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		local cfgdata = w1_page_ioalarm.data;
		b_wnd_ex.set_text(top,c_wnd.tipinfo.id,'',false);
		if cfgdata['ioalarm_cap']['channel'..chid].alarm_in_num < 1 then
			b_wnd_ex.set_hide(top, c_wnd.cap_alarm_input.id, true, false);
			b_wnd_ex.set_hide(top, c_wnd.t_alarm_input.id, true, false);
			b_wnd_ex.set_hide(top, c_wnd.cap_mode.id, true, false);
			b_wnd_ex.set_hide(top, c_wnd.t_mode.id, true, false);
			b_wnd_ex.set_hide(top, c_wnd.cap_enable.id, true, false);
			b_wnd_ex.set_hide(top, c_wnd.t_enable.id, true, false);
			b_wnd_ex.set_hide(top,  w1_id.cfg_alarmin.ioalarmrow_id,true, false)
			w1_page_ioalarmevent.sethide(top, true, false)
			w1_page_ioalarmtimeplan.sethide(top, true, false)
			b_wnd_ex.set_text(top,c_wnd.tipinfo.id,STR('LA_RAID_NOT_SUPPORT'),false);
			b_wnd_ex.set_color(top,c_wnd.tipinfo.id,
			{COLOR('c_cfg_page_bk'),COLOR('c_cfg_page_bk'),COLOR('c_hint_err_text')},false);
			w1_page_ioalarm.old_sel = b_wnd_ex.get_sel(top,c_wnd.t_channel.id);
		else
			b_wnd_ex.set_hide(top, c_wnd.cap_alarm_input.id, false, false);
			b_wnd_ex.set_hide(top, c_wnd.t_alarm_input.id, false, false);
			b_wnd_ex.set_hide(top, c_wnd.cap_mode.id, false, false);
			b_wnd_ex.set_hide(top, c_wnd.t_mode.id, false, false);
			b_wnd_ex.set_hide(top, c_wnd.cap_enable.id, false, false);
			b_wnd_ex.set_hide(top, c_wnd.t_enable.id, false, false);
			b_wnd_ex.set_hide(top,  w1_id.cfg_alarmin.ioalarmrow_id,false, false)
			w1_page_ioalarmevent.sethide(top, false, false)
			w1_page_ioalarmtimeplan.sethide(top, false, false)
			local ret = w1_page_ioalarm.apply(top);
			if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
				b_wnd_ex.set_sel(top,c_wnd.t_channel.id,w1_page_ioalarm.old_sel,false);
			else
				local source_ids = {};
				for i=1, cfgdata['ioalarm_cap']['channel'..chid].alarm_in_num do
					source_ids[i]=i;
				end
				b_wnd_ex.set_items(top,c_wnd.t_alarm_input.id,source_ids,false);
				b_wnd_ex.set_sel(top,c_wnd.t_alarm_input.id,0,false);
				refresh_chdata(top, chid, 1, false);
				w1_page_ioalarm.old_sel = b_wnd_ex.get_sel(top,c_wnd.t_channel.id);
			end
			w1_page_ioalarm.channel = chid
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_ioalarm_input= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local c_wnd = w1_page_ioalarm.wnd
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		local source_id = tonumber(b_wnd_ex.get_text(top,c_wnd.t_alarm_input.id));
		local ret = w1_page_ioalarm.apply(top);
		if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
			b_wnd_ex.set_sel(top,c_wnd.t_alarm_input.id,b_app_cfg.origin_cfg.ioalarm.source_id-1,false);
		else
			refresh_chdata(top, chid, source_id,false);
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg or b_ui.WM_USER_UPDATE_PARAM == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

--[[
local on_name =  function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end--]]

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_ioalarm.on_data_change = function(top)
	if w1_row_ioalarmrow.get_checkidx(top)==0 then
		w1_page_ioalarmevent.on_channel_check(top);
	end
	
end

w1_page_ioalarm.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_ioalarm.on_pre_show = function(top)
	channel_num = global_val.get_channelnum();
	local cwnd = w1_page_ioalarm.wnd;
	local con_id = cwnd.con_ioalarm.id;
	w1_page_ioalarmevent.on_pre_show(top,channel_num);
	b_wnd_ex.set_show_page(top,con_id, cwnd.ioalarmevent_wnd.id, false);
	w1_row_ioalarmrow.changecheck(top, w1_row_ioalarmrow.wnd, w1_id.cfg_alarmin.ioalarmrow_id + 1, false)
end

w1_page_ioalarm.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
			
	sub = {'cap_channel', 't_channel','cap_alarm_input','t_alarm_input',
			'cap_mode', 't_mode', 'cap_enable','t_enable',
			'con_ioalarm','ioalarm_row_wnd',
			'ioalarmevent_wnd', 'ioalarmtimeplan_wnd',	
			'tipinfo','default', 'apply'},
			
	cap_channel	= {t='static',	id=id+1,xywh='s_cfg_page_1_1',text='LA_CHANNEL'},
	t_channel 	= {t='combox',	id=id+2,xywh='s_cfg_page_1_2',items={},trans = false,channel_cbox = true,cmd =on_channel,},	
	cap_alarm_input	= {t='static',	id=id+3,xywh='s_cfg_page_2_1',text='LA_ALARM_IN'},
	t_alarm_input	= {t='combox',	id=id+4,xywh='s_cfg_page_2_2',items={},cmd =on_ioalarm_input},

	cap_mode 	= {t='static',	id=id+5,xywh='s_cfg_page_3_1',text='LA_TRIGGER_MODE'},
	t_mode		= {t='combox', 	id=id+6,xywh='s_cfg_page_3_2',items={'LA_NC', 'LA_NO'},cmd = on_update_param},
	cap_enable 	= {t='static',	id=id+7,xywh='s_cfg_page_4_1',text='LA_ENABLE_DI_ALA'},
	t_enable 	= {t='tt_check',id=id+8,xywh='s_ioalarm_t_enable_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	
	con_ioalarm			= {t='container',id=w1_id.cfg_alarmin.con_ioalarm_id,	xywh={0,0,10,10}},
	ioalarm_row_wnd 	= w1_row_ioalarmrow.wnd,
	ioalarmevent_wnd 	= w1_page_ioalarmevent.wnd,	
	ioalarmtimeplan_wnd = w1_page_ioalarmtimeplan.wnd,

	tipinfo		= {t='static',id=id+9,	xywh='s_ioalarm_tipinfo_xywh',	text='',trans = false},

	apply 	= {t='button',id=id+11,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_ioalarm
