--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_id 		= require("wnd.w1_util.w1_id")
local b_dlg 		= require("wnd.core.b_dlg")
local id 			= w1_id.cfg_net.ip_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local r_str			= require("wnd.core.r_res.r_str")
local util 			= require("wnd.core.util")
local STR 			= r_str.get_str
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_app_cfg  = require("wnd.core.b_app_cfg")
local w1_page_ip = 
{
	timestart = false,
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_ip.s_768 =
{
	s_ip_t_dhcp_xywh = {277,25,25,21},
	s_ip_t_aotudns_xywh = {277,196,25,21},
	s_ip_tippoe_xywh = {53,320,720,35},
	s_ip_tipinfo_xywh = {53,362,373,35},
};

w1_page_ip.s_1280 = 
{
	s_ip_t_dhcp_xywh = {455,36,48,30},
	s_ip_t_aotudns_xywh = {455,276,48,30},
	s_ip_tippoe_xywh = {100,450,880,50},
	s_ip_tipinfo_xywh = {100,510,700,50},
}

w1_page_ip.s_1440 = 
{
	s_ip_t_dhcp_xywh = {520,30,48,30},
	s_ip_t_aotudns_xywh = {520,230,48,30},
	s_ip_tippoe_xywh = {100,380,980,50},
	s_ip_tipinfo_xywh = {100,490,700,50},
}

w1_page_ip.s_1080p = 
{
	s_ip_t_dhcp_xywh = {520,36,48,30},
	s_ip_t_aotudns_xywh = {520,276,48,30},
	s_ip_tippoe_xywh = {100,450,1350,50},
	s_ip_tipinfo_xywh = {100,510,700,50},
}

w1_page_ip.s_2k = 
{
	s_ip_t_dhcp_xywh = {693,48,64,40},
	s_ip_t_aotudns_xywh = {693,368,64,40},
	s_ip_tippoe_xywh = {133,600,1800,67},
	s_ip_tipinfo_xywh = {133,680,933,67},

}

w1_page_ip.s_4k = 
{
	s_ip_t_dhcp_xywh = {1040,72,96,60},
	s_ip_t_aotudns_xywh = {1040,552,96,60},
	s_ip_tippoe_xywh = {200,900,2700,100},
	s_ip_tipinfo_xywh = {200,1020,1400,100},

}
local refresh_dhcp_enable = function(top, disable, redraw)
	local cwnd = w1_page_ip.wnd;
	if disable then
		b_wnd_ex.set_color_d(top, cwnd.t_ip.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_d')},false);
		b_wnd_ex.set_color_d(top, cwnd.t_netmask.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_d')},false);
		b_wnd_ex.set_color_d(top, cwnd.t_gateway.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_d')},false);
	else
		b_wnd_ex.set_color_d(top, cwnd.t_ip.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_n')},false);	
		b_wnd_ex.set_color_d(top, cwnd.t_netmask.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_n')},false);	
		b_wnd_ex.set_color_d(top, cwnd.t_gateway.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_n')},false);		
	end
	b_wnd_ex.set_disable(top, cwnd.t_ip.id, disable, false);
	b_wnd_ex.set_disable(top, cwnd.t_netmask.id, disable, false);
	b_wnd_ex.set_disable(top, cwnd.t_gateway.id, disable, false);
	if true == redraw then
		b_dlg.dlg_set_redraw(top)
	end
end

local refresh_dns_enable = function(top, disable, redraw)
	local cwnd = w1_page_ip.wnd;
	if disable then
		b_wnd_ex.set_color_d(top, cwnd.t_dns1.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_d')},false);
		b_wnd_ex.set_color_d(top, cwnd.t_dns2.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_d')},false);
	else
		b_wnd_ex.set_color_d(top, cwnd.t_dns1.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_n')},false);	
		b_wnd_ex.set_color_d(top, cwnd.t_dns2.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_n')},false);			
	end
	b_wnd_ex.set_disable(top, cwnd.t_dns1.id, disable, false);
	b_wnd_ex.set_disable(top, cwnd.t_dns2.id, disable, false);
	if true == redraw then
		b_dlg.dlg_set_redraw(top)
	end
end

w1_page_ip.clear_data = function()
	w1_page_ip.data = nil;
end	
local redraw = false;

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	w1_page_ip.data = cfgdata;
	
	local cwnd = w1_page_ip.wnd;
	local data = cfgdata.network_ipv4;
	local function settext(id, str)
		b_wnd_ex.set_text(top, id, str,redraw);
	end
	local function setcheck(id, str)
		b_wnd_ex.set_check(top, id, str,redraw);
	end
	setcheck(cwnd.t_dhcp.id, data.dhcp );
	refresh_dhcp_enable(top,  data.dhcp, redraw);
	settext(cwnd.t_ip.id,  data.ip );
	settext(cwnd.t_netmask.id, data.netmask );
	settext(cwnd.t_gateway.id, data.gateway );
	
	setcheck(cwnd.t_aotudns.id, data.auto_dns );
	refresh_dns_enable(top,  data.auto_dns, redraw);
	settext(cwnd.t_dns1.id, data.dns1 );
	settext(cwnd.t_dns2.id, data.dns2 );
	
	local get_virtual_poe = G.get_virtual_poe()
	if(get_virtual_poe == true)then
		b_wnd_ex.set_hide(top, cwnd.tippoe.id, false, false)
	else
		b_wnd_ex.set_hide(top, cwnd.tippoe.id, true, false)
	end
	
	redraw = false;
	return 0;
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_ip.wnd;
	local data = cfgdata.network_ipv4;
	local gettext = function(id)
		local iptext = b_wnd_ex.get_text(top, id);
		return iptext;
	end
	
	local dhcp = b_wnd_ex.get_check(top,cwnd.t_dhcp.id);
	data.dhcp =dhcp;
	local ip = gettext(cwnd.t_ip.id);
	data.ip = ip;
	local netmask = gettext(cwnd.t_netmask.id);
	data.netmask = netmask;
	local gateway = gettext(cwnd.t_gateway.id);
	data.gateway = gateway;
	local autodns = b_wnd_ex.get_check(top, cwnd.t_aotudns.id);
	data.auto_dns = autodns;
	local dns1 = gettext(cwnd.t_dns1.id);
	data.dns1 = dns1;
	local dns2 = gettext(cwnd.t_dns2.id);
	data.dns2 = dns2;
	
	return 0;
end


--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local gettext = function(id)
		local iptext = b_wnd_ex.get_text(top, id);
		return iptext;
	end
	
	local legalflag = true;
	local nlegalid = {};
	local cwnd = w1_page_ip.wnd;
	local data = w1_page_ip.data;

	local legal, num = w1_legal.check_dns(top, cwnd.t_dns2.id);
	if(legal == false) then
		legalflag = false;
		table.insert(nlegalid, cwnd.t_dns2.id);
		if(num == w1_legal.netmask.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LAN_DNS_SERVER2'));
		elseif(num == w1_legal.netmask.LENERR or num == w1_legal.netmask.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LAN_DNS_SERVER2'));
		end
	end
	
	legal, num = w1_legal.check_dns(top, cwnd.t_dns1.id);
	if(legal == false) then
		legalflag =false;
		table.insert(nlegalid, cwnd.t_dns1.id);
		if(num == w1_legal.netmask.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LAN_DNS_SERVER'));
		elseif(num == w1_legal.netmask.LENERR or num == w1_legal.netmask.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LAN_DNS_SERVER'));
		end
	end
	local dns2str = b_wnd_ex.get_text(top, cwnd.t_dns2.id);
	local dns1str = b_wnd_ex.get_text(top, cwnd.t_dns1.id);
	local check = b_wnd_ex.get_check(top, cwnd.t_aotudns.id);
	if(false == check)then
		if(dns1str == dns2str) then
			if(dns1str ~= "")then
				legalflag = false;
				table.insert(nlegalid, cwnd.t_dns1.id);
				table.insert(nlegalid, cwnd.t_dns2.id);
				w1_wnd_util.setparamerr_str(STR('LA_DNS_NOEQUAL'));
			end
		end 
	end
	
	legal, num = w1_legal.check_gataway(top, cwnd.t_gateway.id);
	if(legal == false) then
		legalflag =false;
		table.insert(nlegalid, cwnd.t_gateway.id);	
		if(num == w1_legal.netmask.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LAN_DEFAULT_GATEWAY'));
		elseif(num == w1_legal.netmask.LENERR or num == w1_legal.netmask.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LAN_DEFAULT_GATEWAY'));
		end
	end
	
	legal, num = w1_legal.check_netmask(top, cwnd.t_netmask.id);
	if(legal == false) then
		legalflag = false;
		table.insert(nlegalid, cwnd.t_netmask.id);	
		if(num == w1_legal.netmask.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LAN_SUBNET_MASK'));
		elseif(num == w1_legal.netmask.LENERR or num == w1_legal.netmask.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LAN_SUBNET_MASK'));
		end
	end	
	
	legal, num= w1_legal.check_ip(top, cwnd.t_ip.id);	
	if(legal == false) then
		legalflag =false;
		table.insert(nlegalid, cwnd.t_ip.id);
		if(num == w1_legal.ip.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LA_CORRECT_IP'));
		elseif(num == w1_legal.ip.LENERR or num == w1_legal.ip.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LA_CORRECT_IP'));
		end
	end	

	---ǰѾϷ ͲȥpoeȽжϺϷ ȽǰĴ
	if(false == legalflag) then
		return legalflag, nlegalid;
	end
		
	if(data.poe ~= nil) then	--ǰ豸POE豸,ҪжIPǷͻ
		--local ipdhcp = b_wnd_ex.get_check(top,cwnd.t_dhcp.id);
		--if(ipdhcp == false) then --IPֶʱŽ
			local ipv4ip = gettext(cwnd.t_ip.id);
			local ipv4netmask = gettext(cwnd.t_netmask.id);
			
			local netconflict = w1_legal.is_Ipv4PoeNetConflict(
				ipv4ip, data.poe.ip, ipv4netmask, data.poe.netmask);
				
			if(netconflict) then --ڳͻ
				legalflag =false;
				table.insert(nlegalid, cwnd.t_ip.id);
				w1_wnd_util.setparamerr_str(STR('LA_POE_LOCAL_IP_TIP'));		
			end		
		--end
	else
		
	end

	if(legalflag) then
		return legalflag, nil;
	else
		return legalflag, nlegalid;
	end
end

local returndatacheck =function(top,ret)
	if(ret ~= nil and ret.network_ipv4 ~= 0) then--޸ʧ
		local cwnd = w1_page_ip.wnd;
		local nlegalid = {};
		if(ret.network_ipv4 == -1 ) then
			w1_wnd_util.setparamerr_str(STR('LA_PARAMETER_ERR'));
		elseif(ret.network_ipv4 == -2) then
			table.insert(nlegalid, cwnd.t_ip.id);
			w1_wnd_util.setparamerr_str(STR('LA_POE_LOCAL_IP_TIP'));
		elseif(ret.network_ipv4 == -3) then
			table.insert(nlegalid, cwnd.t_ip.id);
			w1_wnd_util.setparamerr_str(STR('LA_MSG_IP_CONFLICT'));	
		elseif (ret.network_ipv4 == -543) then
			table.insert(nlegalid, cwnd.t_ip.id);
			w1_wnd_util.setparamerr_str(STR('LA_CANNOT_SAME'));
		end
		--¶ȡԭʼ
		b_app_cfg.origin_init(w1_wnd_util.cfgtab);
		return false, nlegalid;
	end
	return true, nil;
end

local on_dhcp = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local check = b_wnd_ex.get_check(top, win_id);
		refresh_dhcp_enable(top,  check, true);
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_update_param	= function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_aotudns = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local check = b_wnd_ex.get_check(top, win_id);
		refresh_dns_enable(top,  check, true);
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui;
		w1_wnd_util.page_ondefault(top);
		w1_wnd_util.tipdispon();		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck;
		w1_wnd_util.returndatacheckfunc = returndatacheck;
		w1_wnd_util.page_onapply(top);
		w1_wnd_util.tipdispon();		--ʾ
		w1_wnd_util.returndatacheckfunc = nil;
	end
	return 0;
end


w1_page_ip.timer_start = function()
	w1_page_ip.timestart = true;
end

w1_page_ip.timer_stop = function(top)
	w1_page_ip.timestart = false;
	w1_wnd_util.tipclear(top, w1_page_ip.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
	w1_wnd_util.tipdispoff();
end

w1_page_ip.timerenevt = function(top)
	if(w1_page_ip.timestart) then
		local save_flag = w1_wnd_util.timerenevt(top, w1_page_ip.wnd.tipinfo.id);
		if(save_flag ==1)then
			local enable = b_wnd_ex.get_check(top, w1_page_ip.wnd.t_dhcp.id);
			if(true == enable)then
				redraw =true;
				local poenum = global_val.get_poenum();--ȡPOE
				if(poenum > 0) then
					w1_wnd_util.cfgtab = {'network_ipv4', 'poe'};
				else
					w1_wnd_util.cfgtab = {'network_ipv4'};
				end
				w1_wnd_util.cfgtouifunc = cfgdatatoui;
				w1_wnd_util.page_init(top);
			end
		end
	end
	return 0;
end

--ҳʼʱٶȡҳҪ
w1_page_ip.init = function(top)
	local poenum = global_val.get_poenum();--ȡPOE
	if(poenum > 0) then
		w1_wnd_util.cfgtab = {'network_ipv4', 'poe'};
	else
		w1_wnd_util.cfgtab = {'network_ipv4'};
	end
	
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);
	return 0;
end

w1_page_ip.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck;
	w1_wnd_util.returndatacheckfunc = returndatacheck;
	ret = w1_wnd_util.page_onapply(top);
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	w1_wnd_util.returndatacheckfunc = nil;	
	return ret;
end

w1_page_ip.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_dhcp','t_dhcp','cap_ip','t_ip','cap_netmask','t_netmask',
			'cap_gateway','t_gateway','cap_aotudns','t_aotudns','tippoe',
			'cap_dns1','t_dns1','cap_dns2','t_dns2',
			'tipinfo', 'default', 'apply' },
	

	cap_dhcp 	= {t='static',id=id+1,xywh='s_cfg_page_1_1',text='LA_ENABLE_DHCP'},
	t_dhcp 		= {t='tt_check', id=id+2,xywh='s_ip_t_dhcp_xywh',
					t_imgs ={b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_dhcp},
	
	cap_ip 		= {t='static',id=id+3,xywh='s_cfg_page_2_1',text='LA_IP_ADDRESS'},
	t_ip 		= {t='edit_ip',  id=id+4,xywh='s_cfg_ip_2_2',cmd = on_update_param},
	
	cap_netmask = {t='static',id=id+5,xywh='s_cfg_page_3_1',text='LA_SUBNET_MASK'},
	t_netmask 	= {t='edit_ip',  id=id+6,xywh='s_cfg_ip_3_2',cmd = on_update_param},
	
	cap_gateway = {t='static',id=id+7,xywh='s_cfg_page_4_1',text='LA_GATEWAY'},
	t_gateway 	= {t='edit_ip',  id=id+8,xywh='s_cfg_ip_4_2',cmd = on_update_param},
	
	cap_aotudns = {t='static',id=id+9,xywh='s_cfg_page_5_1',text='LA_DNS_SWITCH'},
	t_aotudns 	= {t='tt_check', id=id+10,xywh='s_ip_t_aotudns_xywh',font = 'f_grade1',
						t_imgs ={b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_aotudns},
	
	cap_dns1 	= {t='static',id=id+11,xywh='s_cfg_page_6_1',text='LA_DNS1'},
	t_dns1 		= {t='edit_ip',  id=id+12,xywh='s_cfg_ip_6_2',cmd = on_update_param},
	
	cap_dns2 	= {t='static',id=id+13,xywh='s_cfg_page_7_1',text='LA_DNS2'},
	t_dns2 		= {t='edit_ip',  id=id+14,xywh='s_cfg_ip_7_2',cmd = on_update_param},

	tippoe		= {t='static',id=id+15,	xywh='s_ip_tippoe_xywh',text='LA_POE_TIP',
					color = {'c_hint_bk', 'c_hint_border', 'c_hint_text'}},
	
	tipinfo		= {t='static',id=id+16,	xywh='s_ip_tipinfo_xywh',text='',trans = false},
	
	apply 		= {t='button',id=id+17,	xywh='s_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_ip;



