--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_basic.ipc_time_id
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_wnd		= require("wnd.core.b_wnd")
local b_ui_msg	= require("wnd.w1_util.w1_ui_msg") 
local r_size	= require("wnd.core.r_res.r_size")
local util 		= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local SIZE 		= r_size.get_size
local b_dlg 	= require("wnd.core.b_dlg")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str

local w1_page_ipc_time = 
{
	data,
	timestart = false,
	update_time =true,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_ipc_time.s_768 =
{
	s_time_t_ipctime_xywh = {277,21,25,21},
	s_time_info_xywh = {53,369,453,35},
	s_time_tipinfo_xywh = {53,440,373,35},
};

w1_page_ipc_time.s_1280 = 
{
	
	s_time_t_ipctime_xywh = {450,30,48,30},
	s_time_info_xywh = {100,520,850,50},
	s_time_tipinfo_xywh = {100,620,700,50},
}
w1_page_ipc_time.s_1440 = 
{
	s_time_t_ipctime_xywh = {520,25,48,30},
	s_time_info_xywh = {100,520,850,50},
	s_time_tipinfo_xywh = {100,620,700,50},

}

w1_page_ipc_time.s_1080p = 
{

	s_time_t_ipctime_xywh = {520,30,48,30},
	s_time_info_xywh = {100,520,850,50},
	s_time_tipinfo_xywh = {100,620,700,50},

}

w1_page_ipc_time.s_2k = 
{

	s_time_t_ipctime_xywh = {693,40,64,40},
	s_time_info_xywh = {133,693,1133,67},
	s_time_tipinfo_xywh = {133,827,933,67},

}

w1_page_ipc_time.s_4k = 
{

	s_time_t_ipctime_xywh = {1040,60,96,60},
	s_time_info_xywh = {200,1040,1700,100},
	s_time_tipinfo_xywh = {200,1240,1400,100},

}

w1_page_ipc_time.clear_data = function()
	w1_page_ipc_time.data = nil;
end	

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local cwnd = w1_page_ipc_time.wnd
	local data = cfgdata.sync_ipc
	if data.sync_time == 1 then
		b_wnd_ex.set_check(top,cwnd.t_synctime.id,true,false)
		b_wnd_ex.set_hide(top,cwnd.t_waittime.id,false,false)
		b_wnd_ex.set_hide(top,cwnd.c_waittime.id,false,false)
	else
		b_wnd_ex.set_check(top,cwnd.t_synctime.id,false,false)
		b_wnd_ex.set_hide(top,cwnd.t_waittime.id,true,false)
		b_wnd_ex.set_hide(top,cwnd.c_waittime.id,true,false)
	end
	if(data.waittime <10)then
		data.waittime=10;
	end
	local waittime = tostring(data.waittime)
	b_wnd_ex.set_text(top, cwnd.t_waittime.id,waittime, false);
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_ipc_time.wnd
	local sync_enable = b_wnd_ex.get_check(top,cwnd.t_synctime.id)
	if(true == sync_enable) then
		cfgdata['sync_ipc']['sync_time'] = 1
	else
		cfgdata['sync_ipc']['sync_time'] = 0
	end
	local waittime = b_wnd_ex.get_text(top, cwnd.t_waittime.id);
	cfgdata['sync_ipc']['waittime'] = tonumber(waittime);
	return 0
end


--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	local cwnd = w1_page_ipc_time.wnd
	
	local waittime = b_wnd_ex.get_text(top, cwnd.t_waittime.id);
	local p = select(2,string.gsub(waittime,"[.]",""));
	if(p ~= 0)then 
		legalflag =false
		table.insert(nlegalid, cwnd.t_waittime.id)
		w1_wnd_util.setparamerr_str(STR('LA_PARAM_INVALID'));
		return legalflag, nlegalid
	end
		
	if(tonumber(waittime) < 10 or tonumber(waittime) > 31536000)then
		legalflag =false
		table.insert(nlegalid, cwnd.t_waittime.id)
	--	b_wnd_ex.set_text(top, cwnd.t_waittime.id,"10", false);
	end

	local sync_time = b_wnd_ex.get_check(top, cwnd.t_synctime.id)
	
	if(legalflag) then
		return legalflag, nil
	else
		w1_wnd_util.setparamerr_str("[10 ~ 31536000]");
		return legalflag, nlegalid
	end
end

w1_page_ipc_time.timer_start = function()
	w1_page_ipc_time.timestart = true
end

w1_page_ipc_time.timer_stop = function(top)
	w1_page_ipc_time.timestart = false
	w1_wnd_util.tipclear(top, w1_page_ipc_time.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_ipc_time.timerenevt = function(top)
	if(w1_page_ipc_time.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_ipc_time.wnd.tipinfo.id)
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_ipc_time.init = function(top)
	w1_wnd_util.cfgtab = {'sync_ipc'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	w1_page_ipc_time.update_time =true;
	return 0
end

local on_syncipc= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.LBUTTONCLK) then
		local cwnd = w1_page_ipc_time.wnd
		local synctime = b_wnd_ex.get_check(top, win_id);
		b_wnd_ex.set_hide(top,cwnd.t_waittime.id,not synctime,false)
		b_wnd_ex.set_hide(top,cwnd.c_waittime.id,not synctime,false)
		b_dlg.dlg_set_redraw(top);
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_waittime = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.WM_USER_UPDATE_PARAM)then
		local cwnd = w1_page_ipc_time.wnd
		local waittime = b_wnd_ex.get_text(top, cwnd.t_waittime.id); --˴ؼΪδλs

		if(waittime ~= "")then
			if(tonumber(waittime) < 10)then
				b_wnd_ex.set_text(top, cwnd.t_waittime.id,"10", false);
			elseif(tonumber(waittime) > 31536000) then
				b_wnd_ex.set_text(top, cwnd.t_waittime.id,"31536000", false);
			else
				b_wnd_ex.set_text(top, cwnd.t_waittime.id,waittime, false); 
			end
		else
			b_wnd_ex.set_text(top, cwnd.t_waittime.id,"10", false);
		end
		
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end



local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_page_ipc_time.update_time =true;
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_ipc_time.apply =function(top)
	local ret = nil;
	w1_page_ipc_time.update_time =true;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	uitousercfg(top,b_app_cfg.user_cfg);
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end
w1_page_ipc_time.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = { 'c_synctime', 't_synctime', 'c_waittime','t_waittime', 
			 'tipinfo', 'apply'},
			
	c_synctime 	= {t='static',	id=id+1,	xywh='s_cfg_page_1_1',text='LA_ENABLE_SYNC'},
	t_synctime	= {t='tt_check',id=id+2,	xywh='s_time_t_ipctime_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					check = true, cmd = on_syncipc},

	c_waittime 	= {t='static',	id=id+3,	xywh='s_cfg_page_2_1',text='LA_SCHOOL_TIME'},
	t_waittime 	= {t='edit',  id=id+4,	xywh='s_cfg_page_2_2',edit_num_str =1, cmd = on_waittime},--range ={0,2147483646},
	
	tipinfo		= {t='static',	id=id+5,	xywh='s_time_tipinfo_xywh',	text='',trans = false},

	apply 		= {t='button',	id=id+6,	xywh='s_cfg_apply_xywh', 		text='LA_APPLY',cmd=on_apply},

}

return w1_page_ipc_time







