--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_filter.filter_id
local w1_key 		= require("wnd.w1_util.w1_key")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local util 			= require("wnd.core.util")
local w1_edit_ipfilter 	= require("wnd.w1_cfg.w1_edit_ipfilter")
local w1_msgbox		= require("wnd.w1_util.w1_msgbox")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local b_app_cfg  = require("wnd.core.b_app_cfg")

local w1_page_ipfilter = 
{
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_ipfilter.s_768 =
{
	s_ipfilter_t_enable_xywh = {277,25,25,21},
	s_ipfilter_cap_listtip_xywh = {53,106,373,32},
	s_ipfilter_filterlist_xywh = {53,149,581,369},
	s_ipfilter_add_xywh = {53,526,26,35},
	s_ipfilter_del_xywh = {90,526,26,35},
	s_ipfilter_tipinfo_xywh = {53,561,373,35},
	s_ipfilter_list_w1 = {26,0,0,0},
	s_ipfilter_list_w2 = {220,0,0,0},
	s_ipfilter_list_w3 = {220,0,0,0},
	s_ipfilter_list_w4 = {105,0,0,0},
};

w1_page_ipfilter.s_1280 = 
{
	s_ipfilter_t_enable_xywh = {455,36,48,30},
	s_ipfilter_cap_listtip_xywh = {100,150,700,45},
	s_ipfilter_filterlist_xywh ={100,210,800,520},
	s_ipfilter_add_xywh = {100,740,50,50},
	s_ipfilter_del_xywh = {170,740,50,50},
	s_ipfilter_tipinfo_xywh = {100,790,700,50},
	s_ipfilter_list_w1 = {50,0,0,0},
	s_ipfilter_list_w2 = {300,0,0,0},
	s_ipfilter_list_w3 = {300,0,0,0},
	s_ipfilter_list_w4 = {130,0,0,0},
}

w1_page_ipfilter.s_1440 = 
{
	s_ipfilter_t_enable_xywh = {520,30,48,30},
	s_ipfilter_cap_listtip_xywh = {100,125,700,45},
	s_ipfilter_filterlist_xywh = {100,175,900,433},
	s_ipfilter_add_xywh = {100,620,50,45},
	s_ipfilter_del_xywh = {170,620,50,45},
	s_ipfilter_tipinfo_xywh = {100,680,700,50},
	s_ipfilter_list_w1 = {50,0,0,0},
	s_ipfilter_list_w2 = {320,0,0,0},
	s_ipfilter_list_w3 = {320,0,0,0},
	s_ipfilter_list_w4 = {130,0,0,0},
}

w1_page_ipfilter.s_1080p = 
{
	s_ipfilter_t_enable_xywh = {520,36,48,30},
	s_ipfilter_cap_listtip_xywh = {100,150,700,45},
	s_ipfilter_filterlist_xywh = {100,210,1090,520},
	s_ipfilter_add_xywh = {100,740,50,50},
	s_ipfilter_del_xywh = {170,740,50,50},
	s_ipfilter_tipinfo_xywh = {100,790,700,50},
	s_ipfilter_list_w1 = {50,0,0,0},
	s_ipfilter_list_w2 = {415,0,0,0},
	s_ipfilter_list_w3 = {415,0,0,0},
	s_ipfilter_list_w4 = {200,0,0,0},
}

w1_page_ipfilter.s_2k = 
{
	s_ipfilter_t_enable_xywh = {693,48,64,40},
	s_ipfilter_cap_listtip_xywh = {133,200,933,60},
	s_ipfilter_filterlist_xywh = {133,280,1453,693},
	s_ipfilter_add_xywh = {133,986,67,67},
	s_ipfilter_del_xywh = {227,986,67,67},
	s_ipfilter_tipinfo_xywh = {133,1053,933,67},
	s_ipfilter_list_w1 = {67,0,0,0},
	s_ipfilter_list_w2 = {553,0,0,0},
	s_ipfilter_list_w3 = {553,0,0,0},
	s_ipfilter_list_w4 = {267,0,0,0},

}

w1_page_ipfilter.s_4k = 
{
	s_ipfilter_t_enable_xywh = {1040,72,96,60},
	s_ipfilter_cap_listtip_xywh = {200,300,1400,90},
	s_ipfilter_filterlist_xywh = {200,420,2180,1040},
	s_ipfilter_add_xywh = {200,1480,100,100},
	s_ipfilter_del_xywh = {340,1480,100,100},
	s_ipfilter_tipinfo_xywh = {200,1580,1400,100},
	s_ipfilter_list_w1 = {100,0,0,0},
	s_ipfilter_list_w2 = {830,0,0,0},
	s_ipfilter_list_w3 = {830,0,0,0},
	s_ipfilter_list_w4 = {400,0,0,0},

}
		
local refresh_list = function(top, filtertype, redraw)
	local cwnd = w1_page_ipfilter.wnd
	local data = w1_page_ipfilter.data;
	local dispdata = {};
	local displist;
	if(filtertype == 0) then	--
		dispdata.item_total = data['black_num']; 
		displist = data['black']; 
		w1_edit_ipfilter.set_dlgattr(w1_page_ipfilter.data.black);
		b_wnd_ex.set_text(top, cwnd.cap_listtip.id, STR('LA_BLACK_LIST'), false);	
	elseif(filtertype == 1) then	--
		dispdata.item_total = data['white_num']; 
		displist = data['white']; 
		w1_edit_ipfilter.set_dlgattr(w1_page_ipfilter.data.white);	
		b_wnd_ex.set_text(top, cwnd.cap_listtip.id, STR('LA_WHITE_LIST'), false);
	end
	
	for i=1,dispdata.item_total do
		dispdata['idx'..i] = nil;
		dispdata['idx'..i] ={};
		
		dispdata['idx'..i] = {i-1, false, '', 
			displist['list'..i].sip, displist['list'..i].eip,''};
	end
	b_wnd_ex.set_listdata(top, cwnd.filterlist.id, dispdata, false);
	if true == redraw then
		b_dlg.dlg_set_redraw(top);
	end
end

local showwidget = function(top, show,redraw)
	local cwnd = w1_page_ipfilter.wnd
	b_wnd_ex.set_hide(top, cwnd.cap_rule.id, show, redraw);
	b_wnd_ex.set_hide(top, cwnd.t_rule.id, show, redraw);
	b_wnd_ex.set_hide(top, cwnd.cap_listtip.id, show, redraw);
	b_wnd_ex.set_hide(top, cwnd.filterlist.id, show, redraw);
	b_wnd_ex.set_hide(top, cwnd.add.id, show, redraw);
	b_wnd_ex.set_hide(top, cwnd.del.id, show, redraw);
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	w1_page_ipfilter.data = cfgdata.ipfilter;
	
	local data = w1_page_ipfilter.data;
	local cwnd = w1_page_ipfilter.wnd;
	
	local function setcheck(id, str)
		b_wnd_ex.set_check(top, id, str,false)
	end
	setcheck(cwnd.t_enable.id,data['enable'] );
	if(data['enable'] == false) then
		showwidget(top, true, false)
	else
		showwidget(top, false, false)
	end
	
	local filtertype = data['type'];
	assert(filtertype == 0 or filtertype == 1);
	b_wnd_ex.set_sel(top, cwnd.t_rule.id, filtertype, false)
	
	refresh_list(top, filtertype, false);
	
	--ѡ
	local listnum = data.white_num;
	if(listnum < data.black_num) then
		listnum	= data.black_num;
	end
	local checklist = {};
	for i=1, listnum do
		checklist[i] = false;
	end
	b_wnd_ex.set_selecelist(top, cwnd.filterlist.id, checklist, false);
	b_wnd_ex.clear_checkall(top, cwnd.filterlist.id, false, false);
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_ipfilter.wnd;
	local data = cfgdata.ipfilter;
	local enable = b_wnd_ex.get_check(top, cwnd.t_enable.id);
	data.enable = enable;
	local filtertype =b_wnd_ex.get_sel(top, cwnd.t_rule.id);
	data.type =filtertype;
	return 0
end

local get_listselect = function(top, win_id)
	local data = w1_page_ipfilter.data;
	local cwnd = w1_page_ipfilter.wnd;
	local filtertype =b_wnd_ex.get_sel(top, cwnd.t_rule.id);
	local listnum;
	if(filtertype == 0) then
		listnum = data.black_num;
	else
		listnum = data.white_num;
	end
	local checklist = {};
	local param = b_wnd_ex.get_selecelist(top, win_id);
	for i=1, listnum do
		checklist[i] = param['r'..i];
		if(checklist[i] == 0) then
			checklist[i] = false;
		else
			checklist[i] = true;			
		end
	end
	return checklist;
end

local del_list = function(data, typestr, sel)
	assert(typestr == 'black' or typestr == 'white');
	local listtotal;
	if(typestr == 'black') then
		listtotal = data.black_num
		data.black_num = data.black_num - 1;
	else
		listtotal = data.white_num
		data.white_num = data.white_num - 1;
	end
	
	--listitemǰŲһ
	for i = sel+1, listtotal do
		data[typestr]['list'..i-1] = data[typestr]['list'..i];
	end
	--listitemΪnil
	data[typestr]['list'..listtotal] = nil;
end

local ok_func = function(param)
	local data = w1_page_ipfilter.data;
	local cwnd = w1_page_ipfilter.wnd
	local sip ,eip = w1_edit_ipfilter.get_ipstr();
	
	--IPκϷԼ
	
	--ͨ
	local idx;
	if( data.type  == 0) then
		if(param[2] == w1_edit_ipfilter.PAGE_EDIT) then
			assert(type(param[3]) == 'number')
			idx = param[3];
			data.black['list'..idx].sip = sip;
			data.black['list'..idx].eip = eip;
		elseif(param[2] == w1_edit_ipfilter.PAGE_ADD) then
			idx = data.black_num + 1;
			data.black_num = data.black_num + 1;
			data.black['list'..idx] = {};
			data.black['list'..idx].sip = sip;
			data.black['list'..idx].eip = eip;
		elseif(param[2] == w1_edit_ipfilter.PAGE_DEL) then
			assert(type(param[3]) == 'number')
			idx = param[3];
			del_list(data, 'black', idx);	
			b_wnd_ex.clear_checkall(param[1], cwnd.filterlist.id, false, false);
		end	
	elseif( data.type  == 1) then
		if(param[2] == w1_edit_ipfilter.PAGE_EDIT) then
			assert(type(param[3]) == 'number')
			idx = param[3];
			data.white['list'..idx].sip = sip;
			data.white['list'..idx].eip = eip;
		elseif(param[2] == w1_edit_ipfilter.PAGE_ADD) then
			idx = data.white_num + 1;
			data.white_num = data.white_num + 1;
			data.white['list'..idx] = {};
			data.white['list'..idx].sip = sip;
			data.white['list'..idx].eip = eip;
		elseif(param[2] == w1_edit_ipfilter.PAGE_DEL) then
			assert(type(param[3]) == 'number')
			idx = param[3];
			del_list(data, 'white', idx);
			b_wnd_ex.clear_checkall(param[1], cwnd.filterlist.id, false, false);
		end	
	end
	
	refresh_list(param[1], data.type, true)	
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_ipfilter.init = function(top)
	w1_wnd_util.cfgtab = {'ipfilter'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	
	local cwnd = w1_page_ipfilter.wnd;
	w1_edit_ipfilter.init();
	w1_edit_ipfilter.set_func (ok_func, {top}, nil, nil);
	return 0
end

w1_page_ipfilter.clear_data = function()
	w1_page_ipfilter.data = nil;
	w1_edit_ipfilter.clear_data();
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

w1_page_ipfilter.timer_start = function()
	w1_page_ipfilter.timestart = true
end

w1_page_ipfilter.timer_stop = function(top)
	w1_page_ipfilter.timestart = false
	w1_wnd_util.tipclear(top, w1_page_ipfilter.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_ipfilter.timerenevt = function(top)
	if(w1_page_ipfilter.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_ipfilter.wnd.tipinfo.id)
	end
	return 0
end

local on_rule = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local cwnd = w1_page_ipfilter.wnd;
		local filtertype = b_wnd_ex.get_sel(top, win_id);
		w1_page_ipfilter.data.type = filtertype;
		
		--ѡ
		local data = w1_page_ipfilter.data;
		local listnum = data.white_num;
		if(listnum < data.black_num) then
			listnum	= data.black_num;
		end
		local checklist = {};
		for i=1, listnum do
			checklist[i] = false;
		end
		b_wnd_ex.set_selecelist(top, cwnd.filterlist.id, checklist, false);
		b_wnd_ex.clear_checkall(top, cwnd.filterlist.id,false,false);
		refresh_list(top, filtertype, true);
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_check = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then	
		local check = b_wnd_ex.get_check(top, win_id);
		if(check) then
			showwidget(top , false, false);
		else
			showwidget(top , true, false);
		end
		b_dlg.dlg_set_redraw(top);
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then	
		local cwnd = w1_page_ipfilter.wnd	
		local data = w1_page_ipfilter.data;
		if( data.type  == 0) then--
			if(data.black_num == 16) then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_IP_MAX'), true, false,false);
				w1_msgbox.set_func(nil, nil, nil, nil);
				b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
				return 0
			end
		elseif( data.type  == 1) then--
			if(data.white_num == 16) then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_IP_MAX'), true, false,false);
				w1_msgbox.set_func(nil, nil, nil, nil);
				b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
				return 0
			end
		end
		w1_edit_ipfilter.set_ipstr('', '');	
		b_dlg.post_modal(top, w1_key.DLG_IP_SEGMENT, 0, 0, nil);
	end
	return 0
end

local del_refresh_list = function()
	local del_date = {}
	local data = w1_page_ipfilter.data;		
	del_date.enable = data.enable;
	del_date.type = data.type;
	del_date.black = {};
	del_date.white = {};
	
	local idx = 1;
	for i = 1,data.black_num do
		if( data.black['list'..i] ~= nil ) then
			del_date.black['list'..idx] = {};
			if(del_date.black['list'..idx] == nil) then
				del_date.black['list'..idx] = util.copy_tab(data.black['list'..i]);
			else
				util.copy_tab_b(del_date.black['list'..idx], data.black['list'..i]);
			end
			if(data.black['list'..idx] == nil) then		
				data.black['list'..idx] = util.copy_tab(del_date.black['list'..idx]);
			else
				util.copy_tab_b(data.black['list'..idx], del_date.black['list'..idx]);
			end
			idx = idx + 1;
		end
	end
	del_date.black_num = idx - 1;
	idx = 1;
	for i = 1,data.white_num do
		if( data.white['list'..i] ~= nil ) then
			del_date.white['list'..idx] = {};
			if(del_date.white['list'..idx] == nil) then
				del_date.white['list'..idx] = util.copy_tab(data.white['list'..i]);
			else
				util.copy_tab_b(del_date.white['list'..idx], data.white['list'..i]);
			end
			if(data.white['list'..idx] == nil) then
				data.white['list'..idx] = util.copy_tab(del_date.white['list'..idx]);
			else
				util.copy_tab_b(data.white['list'..idx], del_date.white['list'..idx]);
			end
			idx = idx + 1;
		end
	end	
	del_date.white_num = idx - 1;
	
	if(del_date.black_num ~= data.black_num) then
		for i = del_date.black_num + 1,data.black_num do
			data.black['list'..i] = nil;
		end	
		data.black_num = del_date.black_num;
	elseif(del_date.white_num ~= data.white_num) then
		for i = del_date.white_num + 1,data.white_num do
			data.white['list'..i] = nil;
		end	
		data.white_num = del_date.white_num;
	end
end

local on_del_ok = function(param)
	local data = w1_page_ipfilter.data;		
	local listtotal;
	local deltable = {};
	local index = 0;
	local typestr; 
	if( data.type  == 0 ) then	--
		listtotal = data.black_num;
		typestr = 'black';
	elseif( data.type  == 1 ) then
		listtotal = data.white_num;
		typestr = 'white';
	end
	for i = 1, listtotal do
		if( param[2]['r'..i] == 1 ) then
			index = index + 1;
			data[typestr]['list'..i] = nil;		
		end
	end
	if( data.type  == 0 ) then	--
		data.black_num = data.black_num - index;
	else
		data.white_num = data.white_num - index;
	end
	local listidx = 1;
	for i = 1, listtotal do
		if(data[typestr]['list'..i] ~= nil) then
			data[typestr]['list'..listidx] = data[typestr]['list'..i];
			listidx = listidx + 1;
		end
	end
	for i = listtotal - index + 1, listtotal do
		data[typestr]['list'..i] = nil;
	end
	
	local cwnd = w1_page_ipfilter.wnd	
	local checktab = {};	
	for i=1,listtotal do
		checktab[i] = false;
	end
	b_wnd_ex.set_selecelist(param[1], cwnd.filterlist.id, checktab, false);		
	
	del_refresh_list();
	refresh_list(param[1], data.type, true);
	return 0;
end

local on_del = function(top, win_id, vmsg, x, y)
	if( b_ui.LBUTTONCLK == vmsg )then
		local selectlist = b_wnd_ex.get_selecelist(top, w1_page_ipfilter.wnd.filterlist.id);
		local data = w1_page_ipfilter.data;
		local selectflag = false;
		local num;
		if( data.type  == 0 ) then	--
			num = data.black_num;
		elseif( data.type  == 1 ) then
			num = data.white_num
		end
		for i = 1, num do
			if( selectlist['r'..i] == 1 ) then
				selectflag = true;
				break;
			end
		end
		if(selectflag) then
			w1_msgbox.set_dlgattr(STR(''), STR('LA_CONFIRM_DELETE'), true, true,false);
			w1_msgbox.set_func(on_del_ok, {top, selectlist}, nil, nil);
		else
			w1_msgbox.set_dlgattr(STR(''), STR('LA_NO_SELECT'), true, false,false);
			w1_msgbox.set_func(nil, nil, nil, nil);
		end
		b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)		
	end
	return 0
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()	--ʾ
	end
	return 0
end

w1_page_ipfilter.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_ipfilter.on_pre_show = function(top)
	local param = {
			'', STR('LA_START_ADDRESS'),STR('LA_END_ADDRESS'),STR('LA_EDIT')
		}	
	b_wnd_ex.set_title_texts(top, w1_page_ipfilter.wnd.filterlist.id, param, false)
	local list_w = {};
	for i=1,4 do
		local str = 's_ipfilter_list_w'..math.floor(i/1);
		list_w[i] = SIZE(str)[1];
	end
	b_wnd_ex.columns_w(top, w1_page_ipfilter.wnd.filterlist.id, list_w, false);
end

w1_page_ipfilter.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_enable','t_enable','cap_rule','t_rule','cap_listtip',
			'cap_add','cap_subb','filterlist',
			'add', 'del',
			'tipinfo', 'default', 'apply' },
	cap_enable 	= {t='static',id=id+1,xywh='s_cfg_page_1_1',text='LA_ENABLE_IP_FILTER'},
	t_enable 	= {t='tt_check', id=id+2,xywh='s_ipfilter_t_enable_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_check},
	
	cap_rule 	= {t='static',id=id+3,xywh='s_cfg_page_2_1',text='LA_RULE_TYPE'},
	t_rule 		= {t='combox',id=id+4,xywh='s_cfg_page_2_2',items={'LA_RULE_BLACK','LA_RULE_WHITE'},
					cmd = on_rule},	

	cap_listtip = {t='static',id=id+5,xywh='s_ipfilter_cap_listtip_xywh',text='LA_BLACK_LIST'},

	filterlist	= {t='list',	id=id+6,	xywh='s_ipfilter_filterlist_xywh', font = 'f_grade4',
					listattr = {12,4,b_ui.LISTATTR.FIRST_WIDGET_CHECK, b_ui.LISTATTR.END_WIDGET_EDITDEL},
					columns_w = {50,300,300,130},
					dlg_key = {w1_key.DLG_IP_SEGMENT, w1_key.DLG_IP_SEGMENT};
					},

	add 		= {t='tt_button',	id=id+7,	xywh='s_ipfilter_add_xywh',		
					t_imgs = {b_ui.ALIGN.CENTER,'f_grade1','it_add','it_add', 'it_add'},
					color = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_f'},
					cmd = on_add},
	del			= {t='tt_button',id=id+8,	xywh='s_ipfilter_del_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_grade1','it_del','it_del', 'it_del'},
					color = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_f'},
					cmd = on_del},
	
	tipinfo		= {t='static',	id=id+9,	xywh='s_ipfilter_tipinfo_xywh',		text='',		trans = false},
				
	apply 		= {t='button',	id=id+11,	xywh='s_cfg_apply_xywh', 	text='LA_APPLY',	cmd=on_apply},
}

return w1_page_ipfilter



