--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_net.cctv_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local util 			= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local w1_page_ipv4_cctv = 
{
	timestart = false,
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_ipv4_cctv.s_768 =
{
	s_ipv4_cctv_t_dhcp_xywh = {277,25,25,21},
	s_ipv4_cctv_t_aotudns_xywh = {277,196,25,21},
	s_ipv4_cctv_tipinfo_xywh = {53,334,373,35},
};

w1_page_ipv4_cctv.s_1280 = 
{
	s_ipv4_cctv_t_dhcp_xywh = {450,36,48,30},
	s_ipv4_cctv_t_aotudns_xywh = {450,276,48,30},
	s_ipv4_cctv_tipinfo_xywh = {100,470,700,50},
}

w1_page_ipv4_cctv.s_1440 = 
{
	s_ipv4_cctv_t_dhcp_xywh = {520,30,48,30},
	s_ipv4_cctv_t_aotudns_xywh = {520,230,48,30},
	s_ipv4_cctv_tipinfo_xywh = {100,470,700,50},
}

w1_page_ipv4_cctv.s_1080p = 
{
	s_ipv4_cctv_t_dhcp_xywh = {520,36,48,30},
	s_ipv4_cctv_t_aotudns_xywh = {520,276,48,30},
	s_ipv4_cctv_tipinfo_xywh = {100,470,700,50},
}

w1_page_ipv4_cctv.s_2k = 
{
	s_ipv4_cctv_t_dhcp_xywh = {693,48,64,40},
	s_ipv4_cctv_t_aotudns_xywh = {693,368,64,40},
	s_ipv4_cctv_tipinfo_xywh = {133,627,933,67},

}

w1_page_ipv4_cctv.s_4k = 
{
	s_ipv4_cctv_t_dhcp_xywh = {1040,72,96,60},
	s_ipv4_cctv_t_aotudns_xywh = {1040,552,96,60},
	s_ipv4_cctv_tipinfo_xywh = {200,940,1400,100},

}
local redraw = false;

w1_page_ipv4_cctv.clear_data = function()
	w1_page_ipv4_cctv.data = nil;
end	

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	w1_page_ipv4_cctv.data = cfgdata;
	
	local cwnd = w1_page_ipv4_cctv.wnd;
	local data = cfgdata.network_cctv;
	local function settext(id, str)
		b_wnd_ex.set_text(top, id, str,redraw);
	end

	settext(cwnd.t_ip.id,  data.ip );
	settext(cwnd.t_netmask.id, data.netmask );
	settext(cwnd.t_gateway.id, data.gateway );
--	local mac = global_val.get_dev_mac1();
--	settext(cwnd.t_mac1.id, mac );
	
	redraw = false;
	return 0;
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_ipv4_cctv.wnd;
	local data = cfgdata.network_cctv;
	local gettext = function(id)
		local iptext = b_wnd_ex.get_text(top, id);
		return iptext;
	end
	
	local ip = gettext(cwnd.t_ip.id);
	data.ip = ip;
	local netmask = gettext(cwnd.t_netmask.id);
	data.netmask = netmask;
	local gateway = gettext(cwnd.t_gateway.id);
	data.gateway = gateway;
	
	return 0;
end


--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local gettext = function(id)
		local iptext = b_wnd_ex.get_text(top, id);
		return iptext;
	end
	
	local legalflag = true;
	local nlegalid = {};
	local cwnd = w1_page_ipv4_cctv.wnd;
	local data = w1_page_ipv4_cctv.data;	
	legal, num = w1_legal.check_gataway(top, cwnd.t_gateway.id);
	if(legal == false) then
		legalflag =false;
		table.insert(nlegalid, cwnd.t_gateway.id);	
		if(num == w1_legal.netmask.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LAN_DEFAULT_GATEWAY'));
		elseif(num == w1_legal.netmask.LENERR or num == w1_legal.netmask.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LAN_DEFAULT_GATEWAY'));
		end
	end
	
	legal, num = w1_legal.check_netmask(top, cwnd.t_netmask.id);
	if(legal == false) then
		legalflag = false;
		table.insert(nlegalid, cwnd.t_netmask.id);	
		if(num == w1_legal.netmask.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LAN_SUBNET_MASK'));
		elseif(num == w1_legal.netmask.LENERR or num == w1_legal.netmask.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LAN_SUBNET_MASK'));
		end
	end	
	
	legal, num= w1_legal.check_ip(top, cwnd.t_ip.id);	
	if(legal == false) then
		legalflag =false;
		table.insert(nlegalid, cwnd.t_ip.id);
		if(num == w1_legal.ip.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LA_CORRECT_IP'));
		elseif(num == w1_legal.ip.LENERR or num == w1_legal.ip.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LA_CORRECT_IP'));
		end
	end

	if(legalflag) then
		return legalflag, nil;
	else
		return legalflag, nlegalid;
	end
end

local returndatacheck =function(top,ret)
	if(ret ~= nil and ret.network_cctv ~= 0) then--޸ʧ
		local cwnd = w1_page_ipv4_cctv.wnd;
		local nlegalid = {};
		table.insert(nlegalid, cwnd.t_ip.id);
		if(ret.network_cctv == -1 ) then
			w1_wnd_util.setparamerr_str(STR('LA_PARAMETER_ERR'));
		elseif(ret.network_cctv == -2) then
			w1_wnd_util.setparamerr_str(STR('LA_POE_LOCAL_IP_TIP'));
		elseif(ret.network_cctv == -3) then
			w1_wnd_util.setparamerr_str(STR('LA_MSG_IP_CONFLICT'));	
		elseif (ret.network_cctv == -543) then
			w1_wnd_util.setparamerr_str(STR('LA_CANNOT_SAME'));
		end			
		return false, nlegalid;
	end
	return true, nil;
end

local on_update_param	= function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui;
		w1_wnd_util.page_ondefault(top);
		w1_wnd_util.tipdispon();		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck;
		w1_wnd_util.returndatacheckfunc = returndatacheck;
		w1_wnd_util.page_onapply(top);
		w1_wnd_util.tipdispon();		--ʾ
		w1_wnd_util.returndatacheckfunc = nil;	
	end
	return 0;
end

w1_page_ipv4_cctv.timer_start = function()
	w1_page_ipv4_cctv.timestart = true;
end

w1_page_ipv4_cctv.timer_stop = function(top)
	w1_page_ipv4_cctv.timestart = false;
	w1_wnd_util.tipclear(top, w1_page_ipv4_cctv.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
	w1_wnd_util.tipdispoff();
end

w1_page_ipv4_cctv.timerenevt = function(top)
	if(w1_page_ipv4_cctv.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_ipv4_cctv.wnd.tipinfo.id);
	end
	return 0;
end

--ҳʼʱٶȡҳҪ
w1_page_ipv4_cctv.init = function(top)
	--[[local poenum = global_val.get_poenum();--ȡPOE
	if(poenum > 0) then
		w1_wnd_util.cfgtab = {'network_cctv', 'poe'};
	else
		w1_wnd_util.cfgtab = {'network_cctv'};
	end--]]
	w1_wnd_util.cfgtab = {'network_cctv'};
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);
	return 0;
end

w1_page_ipv4_cctv.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck;
	w1_wnd_util.returndatacheckfunc = returndatacheck;
	ret = w1_wnd_util.page_onapply(top);
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	w1_wnd_util.returndatacheckfunc = nil;	
	return ret;
end

w1_page_ipv4_cctv.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_dhcp','t_dhcp','cap_ip','t_ip','cap_netmask','t_netmask',
			'cap_gateway','t_gateway','cap_mac1','t_mac1','tipinfo', 'default', 'apply' },
	

	cap_ip 	= {t='static',id=id+1,xywh='s_cfg_page_1_1',text='LA_IP_ADDRESS'},
	t_ip 		= {t='edit_ip',  id=id+2,xywh='s_cfg_ip_1_2',cmd = on_update_param},
	
	cap_netmask 		= {t='static',id=id+3,xywh='s_cfg_page_2_1',text='LA_SUBNET_MASK'},
	t_netmask 		= {t='edit_ip',  id=id+4,xywh='s_cfg_ip_2_2',cmd = on_update_param},
	
	cap_gateway = {t='static',id=id+5,xywh='s_cfg_page_3_1',text='LA_GATEWAY'},
	t_gateway 	= {t='edit_ip',  id=id+6,xywh='s_cfg_ip_3_2',cmd = on_update_param},
	
--	cap_mac1 = {t='static',id=id+7,xywh='s_cfg_page_4_1',text='LA_MAC_ADDRESS'},
--	t_mac1 	= {t='static',  id=id+8,xywh='s_cfg_page_4_2',cmd = on_update_param},
	
	tipinfo		= {t='static',id=id+15,	xywh='s_ipv4_cctv_tipinfo_xywh',text='',trans = false},
	
	apply 		= {t='button',id=id+17,	xywh='s_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_ipv4_cctv;



