--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_api 	= require("wnd.core.command.b_app_api");
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_logm.logm_id
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_msgbox 	= require("wnd.w1_util.w1_msgbox")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local r_size		= require("wnd.core.r_res.r_size")
local util 			= require("wnd.core.util")
local SIZE			= r_size.get_size;

local w1_page_logm = 
{
	cur_page = 0,
	total_page = 0,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_logm.s_768 =
{
	s_logm_cap_sdate_xywh = {53,21,80,32},
	s_logm_t_sdate_xywh = {133,22,213,28},
	s_logm_cap_stime_xywh = {421,21,80,32},
	s_logm_t_stime_xywh = {501,22,213,28},
	s_logm_cap_edate_xywh = {53,56,80,32},
	s_logm_t_edate_xywh = {133,58,213,28},
	s_logm_cap_etime_xywh = {421,56,80,32},
	s_logm_t_etime_xywh = {501,58,213,28},
	s_logm_cap_type_xywh = {53,92,80,32},
	s_logm_t_type_xywh = {133,92,213,28},
	s_logm_search_xywh = {421,92,117,28},
	s_logm_exportlog_xywh = {597,92,117,28},
	s_logm_log_list_xywh = {53,135,725,462},
	s_logm_page_up_xywh = {341,604,21,28},
	s_logm_page_xywh = {362,604,80,28},
	s_logm_page_down_xywh = {442,604,21,28},
	s_logm_loglist_w1 = {42,0,0,0},
	s_logm_loglist_w2 = {153,0,0,0},
	s_logm_loglist_w3 = {122,0,0,0},
	s_logm_loglist_w4 = {143,0,0,0},
	s_logm_loglist_w5 = {253,0,0,0},
};

w1_page_logm.s_1280 = 
{
	s_logm_cap_sdate_xywh = {67,30,130,45},
	s_logm_t_sdate_xywh = {197,32,266,40},
	s_logm_cap_stime_xywh = {526,30,130,45},
	s_logm_t_stime_xywh = {656,32,266,40},
	s_logm_cap_edate_xywh = {67,80,130,45},
	s_logm_t_edate_xywh = {197,82,266,40},
	s_logm_cap_etime_xywh = {526,80,130,45},
	s_logm_t_etime_xywh = {656,82,266,40},
	s_logm_cap_type_xywh = {67,130,130,45},
	s_logm_t_type_xywh = {197,130,266,40},
	s_logm_search_xywh = {526,130,147,40},
	s_logm_exportlog_xywh = {776,130,147,40},
	s_logm_log_list_xywh = {67,190,906,610},
	s_logm_page_up_xywh = {426,800,27,40},
	s_logm_page_xywh = {453,800,100,40},
	s_logm_page_down_xywh = {553,800,27,40},
	
	s_logm_loglist_w1 = {53,0,0,0},
	s_logm_loglist_w2 = {273,0,0,0},
	s_logm_loglist_w3 = {153,0,0,0},
	s_logm_loglist_w4 = {200,0,0,0},
	s_logm_loglist_w5 = {215,0,0,0},

}


w1_page_logm.s_1440 = 
{
	s_logm_cap_sdate_xywh = {90,30,150,45},
	s_logm_t_sdate_xywh = {240,32,266,40},
	s_logm_cap_stime_xywh = {530,30,150,45},
	s_logm_t_stime_xywh = {680,32,266,40},
	s_logm_cap_edate_xywh = {90,80,150,45},
	s_logm_t_edate_xywh = {240,82,266,40},
	s_logm_cap_etime_xywh = {530,80,150,45},
	s_logm_t_etime_xywh = {680,82,266,40},
	s_logm_cap_type_xywh = {90,130,150,45},
	s_logm_t_type_xywh = {240,130,266,40},
	s_logm_search_xywh = {530,130,190,40},
	s_logm_exportlog_xywh = {756,130,190,40},
	s_logm_log_list_xywh = {90,190,906,508},

	s_logm_page_up_xywh = {446,710,27,40},
	s_logm_page_xywh = {473,710,100,40},
	s_logm_page_down_xywh = {573,710,27,40},
	
	s_logm_loglist_w1 = {53,0,0,0},
	s_logm_loglist_w2 = {273,0,0,0},
	s_logm_loglist_w3 = {153,0,0,0},
	s_logm_loglist_w4 = {200,0,0,0},
	s_logm_loglist_w5 = {215,0,0,0},
}


w1_page_logm.s_1080p = 
{
	s_logm_cap_sdate_xywh = {100,30,150,45},
	s_logm_t_sdate_xywh = {250,32,400,40},
	s_logm_cap_stime_xywh = {790,30,150,45},
	s_logm_t_stime_xywh = {940,32,400,40},
	s_logm_cap_edate_xywh = {100,80,150,45},
	s_logm_t_edate_xywh = {250,82,400,40},
	s_logm_cap_etime_xywh = {790,80,150,45},
	s_logm_t_etime_xywh = {940,82,400,40}, 
	s_logm_cap_type_xywh = {100,130,150,45},
	s_logm_t_type_xywh = {250,130,400,40},
	s_logm_search_xywh = {790,130,220,40},
	s_logm_exportlog_xywh = {1120,130,220,40},
	s_logm_log_list_xywh = {100,190,1360,650},
	s_logm_page_up_xywh = {640,850,40,40},
	s_logm_page_xywh = {680,850,150,40},
	s_logm_page_down_xywh = {830,850,40,40},
	s_logm_loglist_w1 = {80,0,0,0},
	s_logm_loglist_w2 = {290,0,0,0},
	s_logm_loglist_w3 = {230,0,0,0},
	s_logm_loglist_w4 = {270,0,0,0},
	s_logm_loglist_w5 = {478,0,0,0},
}

w1_page_logm.s_2k = 
{
	s_logm_cap_sdate_xywh = {133,40,200,60},
	s_logm_t_sdate_xywh = {333,43,533,53},
	s_logm_cap_stime_xywh = {1053,40,200,60},
	s_logm_t_stime_xywh = {1253,43,533,53},
	s_logm_cap_edate_xywh = {133,107,200,60},
	s_logm_t_edate_xywh = {333,109,533,53},
	s_logm_cap_etime_xywh = {1053,107,200,60},
	s_logm_t_etime_xywh = {1253,109,533,53},
	s_logm_cap_type_xywh = {133,173,200,60},
	s_logm_t_type_xywh = {333,173,533,53},
	s_logm_search_xywh = {1053,173,293,53},
	s_logm_exportlog_xywh = {1493,173,293,53},
	s_logm_log_list_xywh = {133,253,1813,866},
	s_logm_page_up_xywh = {853,1133,53,53},
	s_logm_page_xywh = {906,1133,200,53},
	s_logm_page_down_xywh = {1106,1133,53,53},
	s_logm_loglist_w1 = {107,0,0,0},
	s_logm_loglist_w2 = {387,0,0,0},
	s_logm_loglist_w3 = {307,0,0,0},
	s_logm_loglist_w4 = {360,0,0,0},
	s_logm_loglist_w5 = {637,0,0,0},
}

w1_page_logm.s_4k = 
{
	s_logm_cap_sdate_xywh = {200,60,300,90},
	s_logm_t_sdate_xywh = {500,64,800,80},
	s_logm_cap_stime_xywh = {1580,60,300,90},
	s_logm_t_stime_xywh = {1880,64,800,80},
	s_logm_cap_edate_xywh = {200,160,300,90},
	s_logm_t_edate_xywh = {500,164,800,80},
	s_logm_cap_etime_xywh = {1580,160,300,90},
	s_logm_t_etime_xywh = {1880,164,800,80},
	s_logm_cap_type_xywh = {200,260,300,90},
	s_logm_t_type_xywh = {500,260,800,80},
	s_logm_search_xywh = {1580,260,440,80},
	s_logm_exportlog_xywh = {2240,260,440,80},
	s_logm_log_list_xywh = {200,380,2720,1300},
	s_logm_page_up_xywh = {1280,1700,80,80},
	s_logm_page_xywh = {1360,1700,300,80},
	s_logm_page_down_xywh = {1660,1700,80,80},
	s_logm_loglist_w1 = {160,0,0,0},
	s_logm_loglist_w2 = {580,0,0,0},
	s_logm_loglist_w3 = {460,0,0,0},
	s_logm_loglist_w4 = {540,0,0,0},
	s_logm_loglist_w5 = {956,0,0,0},
}

w1_page_logm.logdata = {};		--ȡ־
w1_page_logm.dispdata = {};		--ʾ־

w1_page_logm.clear_data = function()
	w1_page_logm.logdata = nil;
	w1_page_logm.dispdata = nil;
end	

local convertypestr = function(str, ch_id)
	if (str == 'reset') then
		return STR('LA_RESET_FACTORY');
    elseif (str == 'clear_log') then
		return STR('LA_CLEAR_LOG');
    elseif (str == 'clear_event') then
		return STR('LA_CLEAR_EVENT');
    elseif (str == 'boot') then
		return STR('LA_POWER_ON');
    elseif (str == 'shutdown') then
		return STR('LA_SHUTDOWN');	
    elseif (str == 'reboot') then
		return STR('LA_RESTART');
    elseif (str == 'login') then
		return STR('LA_LOGIN');
    elseif (str == 'logout') then
		return STR('LA_LOGOUT');
    elseif (str == 'add_cam') then
		return STR('LA_ADD_CAMERA');
    elseif (str == 'del_cam') then
		return STR('LA_DELETE_CAMERA');
    elseif (str == 'pb_start') then	
		return STR('LA_START_PLAYBACK');
    elseif (str == 'pb_stop') then
		return STR('LA_CLOSE_PLAYBACK');
    elseif (str == 'bk_start') then
		return STR('LA_START_BACKUP');
    elseif (str == 'bk_stop') then
		return STR('LA_END_BACKUP');
    elseif (str == 'search') then
		return STR('LA_TIME_SEARCH');
    elseif (str == 'picgird') then
		return STR('LA_PICTURE_SEARCH');
    elseif (str == 'timeline') then
		return STR('LA_CHECK_TIMELINE');	
    elseif (str == 'check_event') then
		return STR('LA_CHECK_EVENT');
    elseif (str == 'set_language') then
		return STR('LA_SET_LANGUAGE');
    elseif (str == 'set_tz') then
		return STR('LA_SET_TIMEZONE');
    elseif (str == 'set_time') then
		return STR('LA_MODIFY_TIME');
    elseif (str == 'on_alarm') then
		return STR('LA_OPEN_SURVEILLANCE');
    elseif (str == 'off_alarm') then
		return STR('LA_CLOSE_SURVEILLANCE');
    elseif (str == 'set_alarm') then
		return STR('LA_SETUP_ALARM');
    elseif (str == 'on_pw') then
		return STR('LA_ENABLE_PWD_PROTECT');	
    elseif (str == 'off_pw') then
		return STR('LA_DISABLE_PWD_PROTECT');
    elseif (str == 'modify_pw') then
		return STR('LA_MODIFY_PWD');	
    elseif (str == 'set_network') then
		return STR('LA_SETUP_NETWORK');
    elseif (str == 'clear_disk') then
		return STR('LA_FORMAT_DISK');	
    elseif (str == 'set_color') then
		return STR('LA_SET_COLOR_PARAMETERS');	
    elseif (str == 'set_encode') then
		return STR('LA_SET_ENCODE_PARAMETERS');	
    elseif (str == 'set_privacy') then
		return STR('LA_SET_PRIVACY');	
    elseif (str == 'set_osd') then
		return STR('LA_SETUP_OSD');
    elseif (str == 'set_record') then
		return STR('LA_SET_RECORD_PARAM');
    elseif (str == 'online') then
		return STR('LA_ONLINE');
    elseif (str == 'offline') then
		return STR('LA_OFFLINE');	
    elseif (str == 'ptz_set') then
		return STR('LA_PTZ_SET');
    elseif (str == 'ptz_ctrl') then
		return STR('LA_PTZ_CONTROL');
    elseif (str == 'audio') then
		return STR('LA_AUDIO');		
    elseif (str == 'talk') then
		return STR('LA_TWO_WAY_AUDIO');
    elseif (str == 'bind') then
		return STR('LA_BIND_ACCOUNT');	
	elseif (str == 'motion') then
		return STR('LA_MOTION_DETECTION');
	elseif (str == 'disconnected') then
		return STR('LA_VIDEO_LOST');
	elseif (str == 'no_cable') then
		return STR('LA_NET_DISCONNECT');
	elseif (str == 'disk_error') then
		return STR('LA_DISK_ERROR');
	elseif (str == 'disk_dropped') then
		return STR('LA_DISK_DROPPED');
	elseif (str == 'disk_attenuation') then
		return STR('LA_DISK_ATTENUATION');
	elseif (str == 'disk_full') then
		return STR('LA_FULL_DISK');
	elseif (str == 'ip_conflict') then
		return STR('LA_IP_CONFLICT');
	elseif (str == 'illegal') then
		return STR('LA_ILLEGAL_ALARM');	
	elseif (str == 'sensor') then
		return STR('LA_ALARM_IN');
	elseif (str == 'camera_sensor') then
		return STR('LA_IOALAEM_L');
	elseif (str == 'shelter') then
		return STR('LA_TAMPER_ALARM');	
	elseif (str == 'intell_analyse') then
		return STR('LA_INSIGHT');	
	elseif (str == 'perimeter') then
		return STR('LA_PERIMETER');
	elseif (str == 'single_virtual_fence') then
		return STR('LA_SINGLE_VIRTUAL_FRNCE');
	elseif (str == 'double_virtual_fences') then
		return STR('LA_DOUBLE_VIRTUAL_FENCES');
	elseif (str == 'loiter') then
		return STR('LA_LOITER');
	elseif (str == 'multi_loiter') then
		return STR('LA_MULTI_LOITER');
	elseif (str == 'object_left') then
		return STR('LA_OBJECT_LEFT');
	elseif (str == 'object_removed') then
		return STR('LA_OBJECT_REMOVED');
	elseif (str == 'abnormal_speed') then
		return STR('LA_ABNORNAL_SPEED');
	elseif (str == 'converse') then
		return STR('LA_CONVERSE');
	elseif (str == 'illegal_parking') then
		return STR('LA_ILLEGAL_PARKING');
	elseif (str == 'signal_bad') then
		return STR('LA_SIGNAL_BAD');
	elseif (str == 'strategy_register') then
		return STR('LA_REGISTER');
	elseif (str == 'strategy_stranger') then
		return STR('LA_STRANGER');
	elseif (str == 'temperature_alarm') then
		return STR('LA_TEMPERATURE_ALARM');
	elseif (str == 't_threshold_warming') then
		return STR('LA_THRESHOLD_WARMING');
	elseif (str == 't_threshold_alarm') then
		return STR('LA_THRESHOLD_ALARM_LINK');
	elseif (str == 't_temperature_warning') then
		return STR('LA_THRESHOLD_ALARM2');
	elseif (str == 't_temperature_alarm') then
		return STR('LA_TEMPER_DIFFEREN');	
	elseif (str == 't_temperature_section') then
		return STR('LA_TEMPER_SECTION');
	elseif (str == 'strategy_plate_register') then
		return STR('LA_REG_PLATE');
	elseif (str == 'strategy_plate_unregister') then
		return STR('LA_UNREG_PLATE');	
	elseif (str == 'face_temperature_over') then	
		return STR('LA_OVER_TEMPER');
	elseif (str == 'thermal_face_detect_low') then
		return STR('LA_THERMAL_FACE_DETECT_LOW');
	elseif (str == 'thermal_face_detect_normal') then
		return STR('LA_THERMAL_FACE_DETECT_NORMAL');
	elseif (str == 'thermal_face_detect') then
		return STR('LA_THERMAL_FACE_DETECT');
	elseif (str == 'face_temperature_low') then	
		return STR('LA_LOW_TEMPER');	
	elseif (str == 'face_temperature_abnormal') then	
		return STR('LA_ABNORMAL_TEMPER');	
	elseif (str == 'wear_mask') then	
		return STR('LA_WEAR_MASK');	
	elseif (str == 'no_mask') then	
		return STR('LA_WITHOUT_MASK');			
    elseif (str == 'unknown') then
		return STR('LA_UNKOWN_ALARM');	
	elseif (str == 'disk_num') then
		return STR('LA_DISK_NUM');
	elseif (str == 'disk_available') then
		return STR('LA_DISK_AVAILABLE');
	elseif (str == 'modify_account') then
		return STR('LA_MOD_ACCOUNT');
	elseif (str == 'modify_addr') then
		return STR('LA_MOD_ADDR');
	elseif (str == 'modify_protocol') then
		return STR('LA_MOD_PROTOCOL');
	elseif (str == 'modify_port') then
		return STR('LA_MOD_PORT');	
	elseif (str == 'modify_remote') then
		return STR('LA_MOD_REMOTE');		
	elseif (str == 'camera_human_count_alarm') then	
		return STR('LA_CAM_PERSON_COUNT_ALARM');	
	elseif (str == 'nvr_human_count_alarm') then	
		return STR('LA_PERSON_COUNT_ALARM');		
	elseif (str == 'modify_chanme') then	
		return STR('LA_MOD_CHNAME');		
	elseif (str == 't_rise_warning') then	
		return STR('LA_RISE_WARNING');	
	elseif (str == 't_rise_alarm') then	
		return STR('LA_RISE_ALARM');		
	elseif (str == 'set_ssl_cert') then
		return STR('LA_SET_HTTPS');		
	elseif(str == 'fence_human')then
		return STR('LA_FENCE_HUNMAN');		
	elseif (str == 'fence_car')then
		return STR('LA_FENCE_VEHICLE');
	elseif(str == 'fence')then
		return STR('LA_FENCE_ALARM');
	elseif(str == 'enter_regional')then
		return STR('LA_ENTER_AREA');	
	elseif(str == 'leave_regional')then
		return STR('LA_LEAVE_AREA');	
	elseif(str == 'smoking_alarm')then
		return STR('LA_SMOKING_TEST');
	elseif(str == 'fire_smoke_alarm')then
		return STR('LA_FIREWORKS_DETECTION');	
	elseif(str == 'small_fire_alarm')then
		return STR('LA_FIRE_DETECTION');		
	else
		return '--';
	end
end

local clearlist = function(top,redraw)
	local displist = {};
	for i=1, 15 do
		displist['idx'..i] = {i-1, false, '','','','',''};	
	end
	displist.item_total = 15;
	b_wnd_ex.set_listdata(top, w1_page_logm.wnd.log_list.id, displist, redraw);	
end

local updatelist = function(top, cur_page, redraw)
	if(cur_page == 0) then
		return 
	end
	local s_idx = (cur_page - 1) * 15 + 1;
	local e_idx = (cur_page - 1) * 15 + 15;
	if(w1_page_logm.logdata.logsize < e_idx) then
		e_idx = w1_page_logm.logdata.logsize;
	end
	local displist = {};
	
	local idx = 0;
	for i=s_idx, e_idx do
		idx = idx + 1;
		local cur_log = w1_page_logm.logdata.list['l'..i];
		local typestr = convertypestr(cur_log.type, cur_log.channel);
		local chstr;
		if(cur_log.channel == 0) then
			chstr = '--';
		elseif(cur_log.channel < 10) then
			chstr = STR('LA_CHANNEL')..'0'..tostring(cur_log.channel);
		else
			chstr = STR('LA_CHANNEL')..tostring(cur_log.channel);
		end
		
		--STR('LA_CHANNEL')..''..tostring(cur_log.channel)
		displist['idx'..idx] = {idx-1, false, 
		tostring(i), cur_log.time, chstr, typestr,
		cur_log.info};	

	end
	displist.item_total = idx;
	b_wnd_ex.set_listdata(top, w1_page_logm.wnd.log_list.id, displist, false);
	if true == redraw then
		b_dlg.dlg_set_redraw(top)
	end	
end

local updatepageitems = function(top, total_page, redraw)
	local jump_page_items = {}
	for i=1, total_page do
		jump_page_items[i] = tostring(i)..'/'..total_page;
	end
	b_wnd_ex.set_items(top, w1_page_logm.wnd.page.id, jump_page_items, redraw)	
end

local updatepage = function(top, cur_page, total_page, redraw)
	local cwnd = w1_page_logm.wnd;
	local page_str = tostring(cur_page)..'/'..tostring(total_page);
	b_wnd_ex.set_text(top, cwnd.page.id, page_str,redraw);
end

local clearall = function(top, redraw)
	w1_page_logm.cur_page = 0;
	w1_page_logm.total_page = 0;
	updatepageitems(top, w1_page_logm.total_page, redraw);
	updatepage(top, w1_page_logm.cur_page, w1_page_logm.total_page, redraw);		
	clearlist(top, redraw);
end

local convert_ms = function(top, date_id, time_id)
	local date = b_wnd_ex.get_date(top, date_id);
	local time = b_wnd_ex.get_time(top, time_id);
	local hour_off = 0;
	if(time.format == b_ui.TIME.TIME_12PM) then
		if(time.hour ~= 12) then
			hour_off = 12;
		end
	elseif(time.format == b_ui.TIME.TIME_12AM) then
		if(time.hour == 12) then
			hour_off = -12;
		end
	end
	local mstime = os.time({year =date.year, month = date.month, day =date.day, 
				hour =0, min =0, sec = 0})
	mstime = mstime + (time.hour + hour_off) * 3600 + time.minute * 60 + time.second;
	return mstime
end

local logtype_accord = function(cur_log, uilog_type)
	return true;
end

local on_search = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_logm.wnd;
		local s_mstime = convert_ms(top, cwnd.t_sdate.id, cwnd.t_stime.id);
		local e_mstime = convert_ms(top, cwnd.t_edate.id, cwnd.t_etime.id);
		local log_t = b_wnd_ex.get_sel(top,cwnd.t_type.id)
		if log_t == 0 then
			log_t = 1
		elseif log_t == 1 then
			log_t = 4
		end
		if(s_mstime >= e_mstime) then
			clearall(top, true);
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_BEGIN_END_TIME'), true, false,false);
			w1_msgbox.set_func(nil,nil, nil, nil);
			b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
			return 0;
		end
		
		--w1_page_logm.logdata = b_app_api.get_log({s_time = s_mstime, e_time = e_mstime, log_type = uilog_type });
		local logdata = b_app_api.get_log({s_time = s_mstime, e_time = e_mstime, log_type = log_t });
		if (w1_page_logm.logdata == nil) then
			w1_page_logm.logdata = logdata;
		else
			util.copy_tab_b(w1_page_logm.logdata, logdata);
			util.clear_tab(logdata);
			logdata = nil;
			collectgarbage("collect");
		end
		
		if(w1_page_logm.logdata.logsize == 0) then
			clearall(top, true);
			return 0;
		else		
			w1_page_logm.cur_page = 1;
			b_wnd_ex.set_disable(top, cwnd.page_up.id, true, false);
			w1_page_logm.total_page = math.modf((w1_page_logm.logdata.logsize + 14) / 15);
			if w1_page_logm.total_page == 1 then
				b_wnd_ex.set_disable(top, cwnd.page_down.id, true, false);
			else
				b_wnd_ex.set_disable(top, cwnd.page_down.id, false, false);
			end
			updatepageitems(top, w1_page_logm.total_page, false);
			updatepage(top, w1_page_logm.cur_page, w1_page_logm.total_page, false);		
			updatelist(top, w1_page_logm.cur_page, true);		
		end	
	end
	return 0
end

local on_type = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local sel = b_wnd_ex.get_sel(top, win_id);
		on_search(top, w1_page_logm.wnd.search.id, b_ui.LBUTTONCLK, 0, 0);
	end
	return 0
end

local on_pageup = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_logm.wnd;
		if(w1_page_logm.cur_page > 1) then
			w1_page_logm.cur_page = w1_page_logm.cur_page - 1;
			b_wnd_ex.set_sel(top, w1_page_logm.wnd.page.id, w1_page_logm.cur_page -1, false);
		end
		updatepage(top, w1_page_logm.cur_page, w1_page_logm.total_page, false)
		updatelist(top, w1_page_logm.cur_page, false);
		b_wnd_ex.set_disable(top, cwnd.page_down.id, false, false);
		if (w1_page_logm.cur_page == 1) then
			b_wnd_ex.set_disable(top, cwnd.page_up.id, true, false);
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_pagedown = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_logm.wnd;
		if(w1_page_logm.cur_page < w1_page_logm.total_page) then
			b_wnd_ex.set_sel(top, w1_page_logm.wnd.page.id, w1_page_logm.cur_page, false);
			w1_page_logm.cur_page = w1_page_logm.cur_page + 1;
		end
			
		updatepage(top, w1_page_logm.cur_page, w1_page_logm.total_page, false)
		updatelist(top, w1_page_logm.cur_page, false);
		b_wnd_ex.set_disable(top, cwnd.page_up.id, false, true);
		if (w1_page_logm.cur_page == w1_page_logm.total_page) then
			b_wnd_ex.set_disable(top, cwnd.page_down.id, true, false);
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_page = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local cwnd = w1_page_logm.wnd;
		local sel = b_wnd_ex.get_sel(top, win_id);	
		w1_page_logm.cur_page = sel + 1;
		updatepage(top, w1_page_logm.cur_page, w1_page_logm.total_page, false)
		updatelist(top, w1_page_logm.cur_page, false);
		if (1 == w1_page_logm.total_page) then
			b_wnd_ex.set_disable(top, cwnd.page_down.id, true, false);
			b_wnd_ex.set_disable(top, cwnd.page_up.id, true, false);
		else
			if(w1_page_logm.cur_page == 1) then
				b_wnd_ex.set_disable(top, cwnd.page_down.id, false, false);
				b_wnd_ex.set_disable(top, cwnd.page_up.id, true, true);
			elseif(w1_page_logm.cur_page == w1_page_logm.total_page) then
				b_wnd_ex.set_disable(top, cwnd.page_up.id, false, false);
				b_wnd_ex.set_disable(top, cwnd.page_down.id, true, false);
			else
				b_wnd_ex.set_disable(top, cwnd.page_up.id, false, false);
				b_wnd_ex.set_disable(top, cwnd.page_down.id, false, false);
			end		
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_exportlog = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_logm.wnd;
		local s_mstime = convert_ms(top, cwnd.t_sdate.id, cwnd.t_stime.id);
		local e_mstime = convert_ms(top, cwnd.t_edate.id, cwnd.t_etime.id);
		local log_t = b_wnd_ex.get_sel(top,cwnd.t_type.id)
		if log_t == 0 then
			log_t = 1
		elseif log_t == 1 then
			log_t = 4
		end
		if(s_mstime > e_mstime) then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_STIME_FALSE'), true, false,false);
			w1_msgbox.set_func(nil,nil, nil, nil);
			b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)	
			return 0;
		end
		
		local flag = b_app_api.export_log({s_time = s_mstime, e_time = e_mstime, log_type = log_t });
		if(flag.export_flag == 0) then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_EXPORT_SUCCESS'), true, false,false);
			w1_msgbox.set_func(nil,nil, nil, nil);
		else
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_TIP_EXPORT_FAIL'), true, false,false);
			w1_msgbox.set_func(nil,nil, nil, nil);	
		end
		b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)	
	end
	return 0
end

--ǰһ
local time_backday = function(year, month, day)
	local backtimems = os.time({year=year,month=month,day=day,hour=8}) - 86400;  
	local backtime = os.date("*t",backtimems);
	return backtime;
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	local cwnd = w1_page_logm.wnd;
	local time = os.time()
	local ui_etime = {};
	ui_etime.date = {};
	ui_etime.date[1] = cfgdata['time']['date_fmt']
	ui_etime.date[2] = tonumber(os.date("%Y", time))
	ui_etime.date[3] = tonumber(os.date("%m", time))
	ui_etime.date[4] = tonumber(os.date("%d", time))
	
	ui_etime.time = {}
	ui_etime.time[2] = tonumber(os.date("%H", time))
	if(1 == cfgdata['time']['time_fmt'])then
		ui_etime.time[1] = b_ui.TIME.TIME_24--0;--cfgdata['time']['time_fmt'];
	else
		if(ui_etime.time[2] == 12) then
			ui_etime.time[1] = b_ui.TIME.TIME_12PM
			ui_etime.time[2] = ui_etime.time[2]
		elseif(ui_etime.time[2] >= 13 and ui_etime.time[2] <= 23) then
			ui_etime.time[1] = b_ui.TIME.TIME_12PM
			ui_etime.time[2] = ui_etime.time[2] - 12
		elseif (ui_etime.time[2] == 24) then
			ui_etime.time[1] = b_ui.TIME.TIME_12AM
			ui_etime.time[2] = 12
		else
			ui_etime.time[1] = b_ui.TIME.TIME_12AM
			if(ui_etime.time[2] ==0)then
				ui_etime.time[2] = 12
			else
				ui_etime.time[2] = ui_etime.time[2]
			end
		end
	end
	
	ui_etime.time[3] = math.floor((time % 3600) / 60)
	ui_etime.time[4] = math.floor(time % 60)
	
	local backtiem = time_backday(ui_etime.date[2], ui_etime.date[3], ui_etime.date[4]);
	local ui_stime = {};
	ui_stime.date = {};
	ui_stime.date[1] = cfgdata['time']['date_fmt'];
	ui_stime.date[2] = backtiem.year;
	ui_stime.date[3] = backtiem.month
	ui_stime.date[4] = backtiem.day
	
	b_wnd_ex.set_date (top, w1_page_logm.wnd.t_sdate.id, ui_stime.date, false)
	b_wnd_ex.set_date (top, w1_page_logm.wnd.t_edate.id, ui_etime.date, false)
	b_wnd_ex.set_time (top, w1_page_logm.wnd.t_etime.id, ui_etime.time, false)
	b_wnd_ex.set_time (top, w1_page_logm.wnd.t_stime.id, ui_etime.time, false)
	clearall(top, false);
	
	local s_mstime = convert_ms(top, cwnd.t_sdate.id, cwnd.t_stime.id);
	local e_mstime = convert_ms(top, cwnd.t_edate.id, cwnd.t_etime.id);
	if(s_mstime > e_mstime) then
		clearall(top, false);
		return 0;
	end
	local log_t = b_wnd_ex.get_sel(top,cwnd.t_type.id)
	if log_t == 0 then
		log_t = 1
	elseif log_t == 1 then
		log_t = 4
	end
	
	local logdata = b_app_api.get_log({s_time = s_mstime, e_time = e_mstime, log_type = log_t });
	if (w1_page_logm.logdata == nil) then
		w1_page_logm.logdata = logdata;
	else
		util.copy_tab_b(w1_page_logm.logdata, logdata);
		util.clear_tab(logdata);
		logdata = nil;
		collectgarbage("collect");
	end
	
	if(w1_page_logm.logdata.logsize == 0) then
		clearall(top, false);
		return 0;
	else		
		w1_page_logm.cur_page = 1;
		b_wnd_ex.set_disable(top, cwnd.page_up.id, true, false);
		w1_page_logm.total_page = math.modf((w1_page_logm.logdata.logsize + 14) / 15);
		if w1_page_logm.total_page == 1 then
			b_wnd_ex.set_disable(top, cwnd.page_down.id, true, false);
		elseif w1_page_logm.total_page > 1 then
			b_wnd_ex.set_disable(top, cwnd.page_down.id, false, false);
		end
		updatepageitems(top, w1_page_logm.total_page, false);
		updatepage(top, w1_page_logm.cur_page, w1_page_logm.total_page, false);		
		updatelist(top, w1_page_logm.cur_page, false);		
	end	
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_logm.wnd;
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	
	return true, nil;
end	

--ҳʼʱٶȡҳҪ
w1_page_logm.init = function(top)
	w1_wnd_util.cfgtab = {'time'};
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);
	return 0;
end

w1_page_logm.on_pre_show = function(top)
	local cwnd = w1_page_logm.wnd
	local param = {
			STR('LA_ID'), STR('LA_START_TIME'),STR('LA_CHANNEL'),STR('LA_LOG_TYPE'), STR('LA_INFORMATION')
		}
	b_wnd_ex.set_title_texts(top, cwnd.log_list.id, param, false)
	local list_w = {};
	for i=1,5 do
		local str = 's_logm_loglist_w'..math.floor(i/1);
		list_w[i] = SIZE(str)[1];
	end
	b_wnd_ex.columns_w(top, cwnd.log_list.id, list_w, false);
end

w1_page_logm.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {	'cap_sdate', 't_sdate', 'cap_stime', 't_stime', 
			'cap_edate', 't_edate', 'cap_etime', 't_etime',
			'cap_type', 't_type', 'search','exportlog', 'log_list', 
			'page_up', 'page', 'page_down'
			},
	cap_sdate 	= {t='static',		id=id+1,	xywh='s_logm_cap_sdate_xywh',
					text='LA_START_DATE'},				
	t_sdate 	= {t='date_edit',	id=id+2,	xywh='s_logm_t_sdate_xywh',	
					date={0,2018,1,1, true}, trans = false, 
					cmd=on_date},					
	cap_stime 	= {t='static',		id=id+3,	xywh='s_logm_cap_stime_xywh',
					text='LA_START_TIME'},							
	t_stime 	= {t='time_edit',	id=id+4,	xywh='s_logm_t_stime_xywh', trans = false,	
					time = {b_ui.TIME.TIME_24,1,0,0}, 
					cmd=on_date},

	cap_edate 	= {t='static',		id=id+5,	xywh='s_logm_cap_edate_xywh',
					text='LA_END_DATE'},				
	t_edate 	= {t='date_edit',	id=id+6,	xywh='s_logm_t_edate_xywh',	
					date={0,2018,1,1, true}, trans = false, 
					cmd=on_date},					
	cap_etime 	= {t='static',		id=id+7,	xywh='s_logm_cap_etime_xywh',
					text='LA_END_TIME'},							
	t_etime 	= {t='time_edit',	id=id+8,	xywh='s_logm_t_etime_xywh', trans = false,	
					time = {b_ui.TIME.TIME_24,1,0,0}, 
					cmd=on_date},
	
	cap_type	= {t='static',		id=id+9,	xywh='s_logm_cap_type_xywh',
					text='LA_TYPE'},	
	t_type		= {t='combox',		id=id+10,	xywh='s_logm_t_type_xywh',	
					items={'LA_OPERATION_LOG','LA_SYSTEM_LOG'},
					cmd = on_type},	

	search		=  {t='tt_button', id=id+11,	xywh = 's_logm_search_xywh',
					text= 'LA_SEARCH', cmd = on_search},
					
	exportlog	=  {t='tt_button', id=id+12,	xywh = 's_logm_exportlog_xywh',
					text= 'LA_EXPORT', cmd = on_exportlog},				
		
	log_list	= {t='list',	id=id+13,	xywh='s_logm_log_list_xywh', font = 'f_grade5',
					listattr = {15,5,b_ui.LISTATTR.FIRST_WIDGET_STATIC,0},list_resort={2,5},
					columns_w = {80,290,230,270,478},
					columns_align = {b_ui.ALIGN.CENTER, b_ui.ALIGN.LEFT,b_ui.ALIGN.CENTER, b_ui.ALIGN.LEFT, b_ui.ALIGN.LEFT},
					},
	page_up 	= {t='tt_button',	id=id+14,	xywh='s_logm_page_up_xywh',		
					t_imgs = {b_ui.ALIGN.CENTER,'f_pageupdown','it_pageup','it_pageup', 'it_pageup'},
					color = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_n'},
					color_d = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_f'},
					cmd = on_pageup},
					
	page 		= {t='combox',	id=id+15,	xywh='s_logm_page_xywh',		text='0/0',trans = false, 
					align = b_ui.ALIGN.CENTER, font = 'f_grade3',dlg_direct_up = true,
					t_imgs = {b_ui.ALIGN.CENTER,'f_column','it_null','it_null', 'it_null'},
					color = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_f'},
					cmd = on_page},
	page_down 	= {t='tt_button',id=id+16,	xywh='s_logm_page_down_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_pageupdown','it_pagedown','it_pagedown', 'it_pagedown'},
					color = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_n'},
					color_d = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_d'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_f'},
					cmd = on_pagedown},			
}

return w1_page_logm
