--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_loss.loss_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local w1_row_lossrow 		= require("wnd.w1_cfg.w1_row_lossrow")
local w1_page_lossevent 	= require("wnd.w1_cfg.w1_page_lossevent")
local w1_page_losstimeplan 	= require("wnd.w1_cfg.w1_page_losstimeplan")
local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local util 		= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")

local w1_page_loss = 
{
	old_chid,
	data,
	timestart = false,
	copy_ch = {},
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_loss.s_768 =
{
	s_loss_t_enable_xywh = {277,67,25,21},
	s_loss_tipinfo_xywh = {58,540,213,35},
};

w1_page_loss.s_1280 = 
{
	s_loss_t_enable_xywh = {455,95,48,30},
	s_loss_tipinfo_xywh = {110,760,400,50},
}
w1_page_loss.s_1440 = 
{
	s_loss_t_enable_xywh = {520,95,48,30},
	s_loss_tipinfo_xywh = {110,680,400,50},
}

w1_page_loss.s_1080p = 
{
	s_loss_t_enable_xywh = {520,95,48,30},
	s_loss_tipinfo_xywh = {110,810,400,50},
}

w1_page_loss.s_2k = 
{
	s_loss_t_enable_xywh = {693,127,64,40},
	s_loss_tipinfo_xywh = {147,1013,523,67},

}

w1_page_loss.s_4k = 
{
	s_loss_t_enable_xywh = {1040,190,96,60},
	s_loss_tipinfo_xywh = {220,1620,700,100},

}

local channel_num;--豸ͨĿ

w1_page_loss.clear_data = function()
	w1_page_loss.data = nil;
	w1_page_loss.copy_ch = nil;
end	


local refresh_chdata = function(top, chid, redraw)
	local c_wnd = w1_page_loss.wnd
	local channeldata = w1_page_loss.data.video_loss['channel'..chid]
	local ro_num = w1_page_loss.data.device_info['ro_num']
	local buzz_support = w1_page_loss.data.device_info['buzzer_support']
	b_wnd_ex.set_check(top, c_wnd.t_enable.id, channeldata.enable, redraw);
	local checkidx = w1_row_lossrow.get_checkidx(top);
	if(checkidx == 0) then
		w1_page_lossevent.setstatus(top, channeldata, 0, ro_num, buzz_support, redraw) --Ƶʧͨ ͨ0
		w1_page_losstimeplan.settimeplan(top, channeldata, false);
	else
		w1_page_lossevent.setstatus(top, channeldata, 0, ro_num, buzz_support, false)
		w1_page_losstimeplan.settimeplan(top, channeldata, redraw);
	end
end


w1_page_loss.on_data_change = function(top)
	if w1_row_lossrow.get_checkidx(top)==0 then
		w1_page_lossevent.on_channel_check(top);
	end
	
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)	
	assert(type(cfgdata) == 'table')
	w1_page_loss.data = cfgdata;
	
	local c_wnd = w1_page_loss.wnd
	local camreaitems = {};
	local idx = 1;
	local privilege = global_val.get_allprivilege();--ȡȨ
	local ch_prilist = privilege.channel_manager_list;
	local old_chn = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
	local sel = 0;
	for i=1, channel_num do
		if(cfgdata['video_loss']['channel'..i] ~= nil and ch_prilist[i] == 1) then
			camreaitems[idx] = i;
			if old_chn == i then
				sel = idx-1
			end
			idx = idx + 1;
		end
	end
	b_wnd_ex.set_items(top, c_wnd.t_channel.id, camreaitems, false);
	if(idx ~= 1) then--˵ͨ
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id, false, false)
		b_wnd_ex.set_hide(top, c_wnd.cap_enable.id, false, false)
		b_wnd_ex.set_hide(top, c_wnd.t_enable.id, false, false)
		b_wnd_ex.set_hide(top, w1_id.cfg_loss.lossrow_id, false, false)
		w1_page_lossevent.sethide(top, false, false)
		w1_page_losstimeplan.sethide(top, false, false)
		
		b_wnd_ex.set_sel(top, c_wnd.t_channel.id, sel, false);--Ĭһ
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		refresh_chdata(top, chid, false);
	else--ͨ
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id,true, false)
		b_wnd_ex.set_hide(top, c_wnd.cap_enable.id, true, false)
		b_wnd_ex.set_hide(top, c_wnd.t_enable.id, true, false)
		b_wnd_ex.set_hide(top,  w1_id.cfg_loss.lossrow_id, 	true, false)
		w1_page_lossevent.sethide(top, true, false)
		w1_page_losstimeplan.sethide(top, true, false)
	end
	
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

w1_page_loss.timer_start = function()
	w1_page_loss.timestart = true
end

w1_page_loss.timer_stop = function(top)
	w1_page_loss.timestart = false
	w1_wnd_util.tipclear(top, w1_page_loss.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_loss.timerenevt = function(top)
	if(w1_page_loss.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_loss.wnd.tipinfo.id)
	end
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_loss.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id))
	if(chid == nil) then
		return 0
	end
	
	local enable = b_wnd_ex.get_check(top,cwnd.t_enable.id);
	
	local data = cfgdata.video_loss['channel'..chid]
	data.enable = enable;
	data.change_flag = true;
	
	return 0
end

w1_page_loss.pageinit = function(top)
	--b_wnd_ex.set_add_page(top, w1_page_loss.wnd.con_loss.id, w1_page_loss.wnd.lossevent_wnd.id)
	--b_wnd_ex.set_add_page(top, w1_page_loss.wnd.con_loss.id, w1_page_loss.wnd.losschannel_wnd.id)
	--b_wnd_ex.set_add_page(top, w1_page_loss.wnd.con_loss.id, w1_page_loss.wnd.losstimeplan_wnd.id)
	--b_wnd_ex.set_show_page(top,w1_page_loss.wnd.con_loss.id, w1_page_loss.wnd.lossevent_wnd.id, false)
	return 0
end

w1_page_loss.init= function(top)
	local c_wnd = w1_page_loss.wnd
	
	w1_wnd_util.cfgtab = {'video_loss','device_info'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	
	local chidstr = b_wnd_ex.get_text(top, c_wnd.t_channel.id);
	if(chidstr == '') then
		return 0
	end
	local chid =tonumber(chidstr);
	w1_page_loss.old_chid = chid;
	return 0
end

local on_channel= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local c_wnd = w1_page_loss.wnd
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		if(w1_page_loss.old_chid ~= chid) then
			refresh_chdata(top, chid, false);
			w1_page_loss.old_chid = chid;
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_enable = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end


local copy_okfunc = function(param)
	local cwnd = w1_page_loss.wnd;
	local chid = tonumber(b_wnd_ex.get_text(param[1], cwnd.t_channel.id));
	if(chid == nil) then
		return 0;
	end
	local chsrc = w1_page_loss.data.video_loss['channel'..chid];
	local chdir = w1_page_loss.data.video_loss;
	
	for i=1, #param[2] do
		if(chdir['channel'..param[2][i]] == nil) then
			chdir['channel'..param[2][i]] = util.copy_tab(chsrc)
		else
			util.copy_tab_b(chdir['channel'..param[2][i]], chsrc);
		end
		chdir['channel'..param[2][i]].change_flag = true;
		chdir['channel'..param[2][i]].channel_id = param[2][i];
	end
	
	--Դֻͨһ.Ҹͨŵͨid,
	--ĬϸƵͨ
	if(#param[2] > 0) then	
		if(#chsrc.linkage.trigger_ch == 1 and 
			chsrc.linkage.trigger_ch[1] == chsrc.channel_id) then
			
			for i=1, #param[2] do
				chdir['channel'..param[2][i]].linkage.trigger_ch = nil;
				chdir['channel'..param[2][i]].linkage.trigger_ch = {param[2][i]};
			end	
		end
	end
	
	return 0;
end

local on_copy = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_loss.wnd;
		local param = {};
		local idx = 1;
		local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	--	uitousercfg(top, w1_page_loss.data)
		
		local privilege = global_val.get_allprivilege();--ȡȨ
		local ch_prilist = privilege.channel_manager_list;	
		for i=1, channel_num do
			if( i ~= chid and w1_page_loss.data.video_loss['channel'..i] ~= nil
				 and ch_prilist[i] == 1) then
				param[idx] = i;
				idx =idx + 1;
			end
		end
		w1_copy.init();
		w1_copy.set_dlgattr(param);
		w1_copy.set_func (copy_okfunc,{top, w1_page_loss.copy_ch} );
		b_dlg.post_modal(top, w1_key.DLG_COPY, 0, 0, nil)
	end
	return 0
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_loss.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_loss.on_pre_show = function(top)
	local cwnd = w1_page_loss.wnd;
	channel_num = global_val.get_channelnum();
	
	w1_page_lossevent.on_pre_show(top, channel_num)
	local con_id = cwnd.con_loss.id
	
--	b_wnd_ex.set_show_page(top,con_id, cwnd.lossevent_wnd.id, false)
	w1_row_lossrow.changecheck(top, w1_row_lossrow.wnd, w1_id.cfg_loss.lossrow_id + 1, false)
end

w1_page_loss.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_channel', 't_channel','cap_enable','t_enable',			
			'con_loss','loss_row_wnd',
			'lossevent_wnd', 'losstimeplan_wnd',	
			'tipinfo', 'copy','default', 'apply'},
		
	cap_channel= {t='static',id=id+1,xywh='s_cfg_page_1_1',text='LA_CHANNEL'},
	t_channel 	= {t='combox',id=id+2,xywh='s_cfg_page_1_2',items={},trans = false,channel_cbox = true,cmd =on_channel},	
	
	cap_enable 	= {t='static',id=id+3,xywh='s_cfg_page_2_1',text='LA_ENABLE_LOSS_ALA'},
	t_enable 	= {t='tt_check', id=id+4,xywh='s_loss_t_enable_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_enable},
	
	
	con_loss		= {t='container',id=w1_id.cfg_loss.con_loss_id,	xywh={0,0,10,10}},
	loss_row_wnd 	= w1_row_lossrow.wnd,
	lossevent_wnd 	= w1_page_lossevent.wnd,	
	losstimeplan_wnd = w1_page_losstimeplan.wnd,
	
	tipinfo		= {t='static',id=id+5,	xywh='s_loss_tipinfo_xywh',text='',trans = false},
	
	copy 	= {t='button',id=id+6,	xywh = 's_cfg_copy_xywh',	text='LA_COPY_TO',cmd=on_copy},
	apply 	= {t='button',id=id+8,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_loss

