--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/11/7
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_microphone.microphone_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_dlg 		= require("wnd.core.b_dlg")
local w1_msgbox	 	= require("wnd.w1_util.w1_msgbox")
local w1_key 		= require("wnd.w1_util.w1_key")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local util 			= require("wnd.core.util")
local b_app_api 	= require("wnd.core.command.b_app_api")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE			= r_size.get_size;
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 

local channel_num   = 4;
local w1_page_microphone 	= 
{
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k
}	

w1_page_microphone.s_768 =
{
	s_microphone_t_mic_enable_xywh = {277,67,25,21},
	s_microphone_t_satura_subb_xywh = {281,156,16,21},
	s_microphone_t_satura_xywh = {297,149,150,32},
	s_microphone_t_satura_add_xywh = {448,156,16,21},
	s_microphone_t_satura_value_xywh = {466,156,32,21},
	s_motion_tipinfo_xywh = {58,554,213,35},
};

w1_page_microphone.s_1280 = 
{
	s_microphone_t_mic_enable_xywh = {455,95,48,30},
	s_microphone_t_satura_subb_xywh = {460,220,30,30},
	s_microphone_t_satura_xywh	  = {490,210,200,45},
	s_microphone_t_satura_add_xywh = {690,220,30,30},
	s_microphone_t_satura_value_xywh = {725,220,60,30},	
	s_motion_tipinfo_xywh = {110,800,400,50},
}

w1_page_microphone.s_1440 = 
{
	s_microphone_t_mic_enable_xywh = {520,80,48,30},
	s_microphone_t_satura_subb_xywh = {530,180,30,30},
	s_microphone_t_satura_xywh = {560,175,280,40},
	s_microphone_t_satura_add_xywh = {840,180,30,30},
	s_microphone_t_satura_value_xywh = {875,180,60,30},	
	s_motion_tipinfo_xywh = {110,700,400,50},
}

w1_page_microphone.s_1080p = 
{
	s_microphone_t_mic_enable_xywh = {520,95,48,30},
	s_microphone_t_satura_subb_xywh = {527,220,30,30},
	s_microphone_t_satura_xywh = {557,210,282,45},
	s_microphone_t_satura_add_xywh = {840,220,30,30},
	s_microphone_t_satura_value_xywh = {875,220,60,30},	
	s_motion_tipinfo_xywh = {110,780,400,50},
}

w1_page_microphone.s_2k = 
{
	s_microphone_t_mic_enable_xywh = {693,127,64,40},
	s_microphone_t_satura_subb_xywh = {703,293,40,40},
	s_microphone_t_satura_xywh = {743,280,360,67},
	s_microphone_t_satura_add_xywh = {1103,293,40,40},
	s_microphone_t_satura_value_xywh ={1150,293,80,40},	
	s_motion_tipinfo_xywh = {147,1063,523,67},
}

w1_page_microphone.s_4k = 
{
	s_microphone_t_mic_enable_xywh = {1040,190,96,60},
	s_microphone_t_satura_subb_xywh 	= {1055,440,60,60},
	s_microphone_t_satura_xywh 	= {1114,420,564,90},
	s_microphone_t_satura_add_xywh 	= {1680,440,60,60},
	s_microphone_t_satura_value_xywh = {1750,440,120,60},	
	s_motion_tipinfo_xywh = {220,1560,700,100},
}
	
w1_page_microphone.clear_data = function()
	w1_page_microphone.data = nil;
end	

local refresh_hide = function (top, status, redraw)
	local c_wnd = w1_page_microphone.wnd;
	local s_id = id + 5;
	local e_id = id + 11;
	for i = s_id, e_id do
		b_wnd_ex.set_hide(top, i, status, redraw);
	end	
end

local refresh_chdata = function(top, chid, redraw)
	local c_wnd = w1_page_microphone.wnd;
	local data = w1_page_microphone.data["channel" .. chid];
	refresh_hide(top,not data.enable,false);
	b_wnd_ex.set_check(top, c_wnd.t_mic_enable.id, data.enable, redraw)
	local mic_type = {};
	local sel = 0;
	if (data.type_attr == 1) then
		mic_type[1] =  STR('LA_INTERNAL');
	elseif (data.type_attr == 2) then	
		mic_type[1] =  STR('LA_LINE_IN');
	elseif (data.type_attr == 3 ) then
		mic_type[1] =  STR('LA_INTERNAL');
		mic_type[2] =  STR('LA_LINE_IN');	
		if (data.type == 2) then
			sel = 1;
		end
	end
	b_wnd_ex.set_items(top, c_wnd.t_mic_type.id, mic_type, redraw);	
	b_wnd_ex.set_sel(top, c_wnd.t_mic_type.id, sel, redraw);
	b_wnd_ex.set_value(top, c_wnd.t_satura.id, data.volume, redraw)
	b_wnd_ex.set_text(top, c_wnd.t_value.id, tostring(data.volume), redraw);
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	w1_page_microphone.data = cfgdata.microphone;
	local data = cfgdata.microphone;
	local c_wnd = w1_page_microphone.wnd;
	local camreaitems = {};

	local idx = 1;
	local privilege = global_val.get_allprivilege();--ȡȨ
	local ch_prilist = privilege.channel_manager_list;
	for i=1, channel_num do
		if(data['channel'..i] ~= nil and ch_prilist[i] == 1) then
			camreaitems[idx] = i;
			idx = idx + 1;
		end
	end
	b_wnd_ex.set_items(top, c_wnd.t_channel.id, camreaitems, false);
	if(idx ~= 1) then--˵ڷͨ
		b_wnd_ex.set_hide(top, c_wnd.cap_mic_enable.id, false, false);
		b_wnd_ex.set_hide(top,c_wnd.t_mic_enable.id, false, false);
		b_wnd_ex.set_disable(top, c_wnd.t_channel.id, false, false);
		b_wnd_ex.set_sel(top, c_wnd.t_channel.id, 0, false);--Ĭϵһ
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		refresh_chdata(top, chid, false);
	else
		refresh_hide(top,true,false);
		b_wnd_ex.set_hide(top, c_wnd.cap_mic_enable.id, true, false);
		b_wnd_ex.set_hide(top,c_wnd.t_mic_enable.id, true, false);
		b_wnd_ex.set_disable(top, c_wnd.t_channel.id, true, false);
	end
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local c_wnd = w1_page_microphone.wnd;
	local chid = tonumber(b_wnd_ex.get_text(top, w1_page_microphone.wnd.t_channel.id));
	local data = w1_page_microphone.data["channel" .. chid];	
	data.enable = b_wnd_ex.get_check(top, c_wnd.t_mic_enable.id);
	if (data.type_attr == 3 ) then
		data.type = b_wnd_ex.get_sel(top, c_wnd.t_mic_type.id) + 1;
	end
	data.volume = b_wnd_ex.get_value(top, c_wnd.t_satura.id);
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_enable  = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local c_wnd = w1_page_microphone.wnd;
		local enable = b_wnd_ex.get_check(top, c_wnd.t_mic_enable.id);
		refresh_hide(top, not enable, false);
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top)
	end	
	return 0;
end

local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local c_wnd = w1_page_microphone.wnd;
		local value = b_wnd_ex.get_value(top, c_wnd.t_satura.id);
		if(value < 100) then
			value = value + 1;
			b_wnd_ex.set_value(top, c_wnd.t_satura.id, value, false)
			b_wnd_ex.set_text(top, c_wnd.t_value.id, tostring(value), false);
			b_dlg.dlg_set_redraw(top);
			uitousercfg(top,b_app_cfg.user_cfg);
		end
	end

	return 0;
end	

local on_sub = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local c_wnd = w1_page_microphone.wnd;
		local value = b_wnd_ex.get_value(top, c_wnd.t_satura.id);
		if(value > 0) then
			value = value - 1;
			b_wnd_ex.set_value(top, c_wnd.t_satura.id, value, false)
			b_wnd_ex.set_text(top, c_wnd.t_value.id, tostring(value), false);
			b_dlg.dlg_set_redraw(top);
			uitousercfg(top,b_app_cfg.user_cfg);
		end
	end

	return 0;
end	

local on_channel = function (top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local chid = tonumber(b_wnd_ex.get_text(top, w1_page_microphone.wnd.t_channel.id));
		if(w1_page_microphone.old_chid ~= chid) then
			refresh_chdata(top, chid, false);
			w1_page_microphone.old_chid = chid;
			b_dlg.dlg_set_redraw(top)
		end
	end
	return 0;
end

local on_cfg_change = function(top, win_id, vmsg, x, y)
	if ((b_ui.LBUTTONCLK == vmsg) or (b_ui.WM_USER_UPDATE_PARAM == vmsg)) then
		uitousercfg(top,b_app_cfg.user_cfg);
		local c_wnd = w1_page_microphone.wnd;
		if win_id == c_wnd.t_satura.id  then
			local value = b_wnd_ex.get_value(top, c_wnd.t_satura.id);	
			b_wnd_ex.set_text(top, c_wnd.t_value.id, tostring(value), true);
		end
	end
	return 0
end

w1_page_microphone.on_pre_show = function(top)
	channel_num = global_val.get_channelnum();
end	

w1_page_microphone.timer_start = function()
	w1_page_microphone.timestart = true
end

w1_page_microphone.timer_stop = function(top)
	w1_page_microphone.timestart = false
	w1_wnd_util.tipclear(top, w1_page_microphone.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
	w1_wnd_util.tipdispoff();
end

w1_page_microphone.timerenevt = function(top)
	if(w1_page_microphone.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_microphone.wnd.tipinfo.id)
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_microphone.init = function(top)
	w1_wnd_util.cfgtab = {'microphone'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	
	local chidstr = b_wnd_ex.get_text(top, w1_page_microphone.wnd.t_channel.id);
	if(chidstr == '') then
		return 0;
	end
	local chid =tonumber(chidstr);
	w1_page_microphone.old_chid = chid;
		
	return 0
end

w1_page_microphone.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_microphone.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {	'cap_channel', 't_channel', 'cap_mic_enable','t_mic_enable','cap_mic_type','t_mic_type',
			'cap_mic_volume', 'satura_subb', 't_satura', 'satura_add', 't_value',
			'tipinfo', 'default', 'apply' },
	
	cap_channel	= {t='static',id=id+1,	xywh='s_cfg_page_1_1',	text='LA_CHANNEL'},
	t_channel 	= {t='combox',id=id+2,	xywh='s_cfg_page_1_2',	items={},trans = false,channel_cbox = true,cmd=on_channel},	

	cap_mic_enable 	= {t='static',id=id+3,xywh='s_cfg_page_2_1',text='LA_MICRO_PHONE'},
	t_mic_enable 	= {t='tt_check',  id=id+4,xywh='s_microphone_t_mic_enable_xywh',cmd = on_enable,
				t_imgs ={b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},},
					
	cap_mic_type 	= {t='static',id=id+5,xywh='s_cfg_page_3_1',text='LA_MIC_TYPE'},
	t_mic_type 	= {t='combox',id=id+6,xywh='s_cfg_page_3_2',items={},cmd = on_cfg_change,},

	cap_mic_volume	= {t='static',id=id+7,	xywh='s_cfg_page_4_1',text='LA_MIC_VOLUME',},
	satura_subb	= {t='button',id=id+8,	xywh='s_microphone_t_satura_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_sub},
	t_satura	= {t='hslider',id=id+9,xywh='s_microphone_t_satura_xywh',		
					font = 'f_slider', cmd=on_cfg_change},
	satura_add	= {t='button',id=id+10,	xywh='s_microphone_t_satura_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	t_value= {t='static',id=id+11,	xywh='s_microphone_t_satura_value_xywh',trans = false},
	
	
	tipinfo		= {t='static',id=id+12,	xywh='s_restart_tipinfo_xywh',	text='',trans = false},
	apply 		= {t='button',id=id+13,	xywh='s_cfg_apply_xywh', text='LA_APPLY',cmd=on_apply},
}

return w1_page_microphone



