
--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local w1_id 		= require("wnd.w1_util.w1_id")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local id 			= w1_id.cfg_modify.modify_id
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_msgbox 	= require("wnd.w1_util.w1_msgbox")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local b_app_api = require("wnd.core.command.b_app_api")
local util 			= require("wnd.core.util")

local w1_page_modify = 
{
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_modify.s_768 =
{
	s_modify_info1_xywh = {53,170,640,35},
	s_modify_info2_xywh = {53,206,640,35},
	s_modify_info3_xywh = {53,241,640,35},
	s_modify_tipinfo_xywh = {53,277,640,35},
};

w1_page_modify.s_1280 = 
{
	s_modify_info1_xywh = {100,240,900,50},
	s_modify_info2_xywh = {100,290,900,50},
	s_modify_info3_xywh = {100,340,900,50},
	s_modify_tipinfo_xywh = {100,390,900,50},
}

w1_page_modify.s_1440 = 
{
	s_modify_info1_xywh = {100,240,1000,50},
	s_modify_info2_xywh = {100,290,1000,50},
	s_modify_info3_xywh = {100,340,1000,50},
	s_modify_tipinfo_xywh = {100,390,1000,50},
}

w1_page_modify.s_1080p = 
{
	s_modify_info1_xywh = {100,240,1200,50},
	s_modify_info2_xywh = {100,290,1200,50},
	s_modify_info3_xywh = {100,340,1200,50},
	s_modify_tipinfo_xywh = {100,390,1200,50},
}

w1_page_modify.s_2k = 
{
	s_modify_info1_xywh = {133,320,1600,67},
	s_modify_info2_xywh = {133,387,1600,67},
	s_modify_info3_xywh = {133,453,1600,67},
	s_modify_tipinfo_xywh = {133,520,1600,67},
}

w1_page_modify.s_4k = 
{
	s_modify_info1_xywh = {200,480,2400,100},
	s_modify_info2_xywh = {200,580,2400,100},
	s_modify_info3_xywh = {200,680,2400,100},
	s_modify_tipinfo_xywh = {200,780,2400,100},
}

w1_page_modify.clear_data = function()
	
end	

-- UIʾ
local clear_uidata =function (top)
	local cwnd = w1_page_modify.wnd;
	b_wnd_ex.set_password(top, cwnd.t_pass.id, "", false);
	b_wnd_ex.set_password(top, cwnd.t_newpass.id, "", false);
	b_wnd_ex.set_password(top, cwnd.t_conpass.id, "", false);
	b_wnd_ex.set_disp(top, cwnd.t_pass.id, false, false);
	b_wnd_ex.set_disp(top, cwnd.t_newpass.id, false, false);
	b_wnd_ex.set_disp(top, cwnd.t_conpass.id, false, false);	
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true;
	local nlegalid = {};
	local cwnd = w1_page_modify.wnd;
	local uipass = b_wnd_ex.get_password(top, cwnd.t_pass.id);
	local newpass = b_wnd_ex.get_password(top, cwnd.t_newpass.id);
	local conpass = b_wnd_ex.get_password(top, cwnd.t_conpass.id);
	--Ϊ
	if("" == uipass)then
		w1_wnd_util.setparamerr_str(STR('LA_PASSWORD_EMPTY'));
		table.insert(nlegalid, cwnd.t_pass.id);
		return false,nlegalid
	end
	--Ϊ
	if("" == newpass)then
		w1_wnd_util.setparamerr_str(STR('LA_PASSWORD_EMPTY'));
		table.insert(nlegalid, cwnd.t_newpass.id);
		return false,nlegalid
	end
	--ȷΪ
	if("" == conpass)then
		w1_wnd_util.setparamerr_str(STR('LA_CON_PWD_EMPTY'));
		table.insert(nlegalid, cwnd.t_conpass.id);
		return false,nlegalid
	end
	--벻һ
	if(newpass ~= conpass)then
		w1_wnd_util.setparamerr_str(STR('LA_PWD_NO_SAME'));
		table.insert(nlegalid, cwnd.t_newpass.id);
		table.insert(nlegalid, cwnd.t_conpass.id);
		return false,nlegalid
	end
	if(uipass == newpass) then--Ƿһ
		w1_wnd_util.setparamerr_str(STR('LA_SAME_OLDPASSWORD'));
		table.insert(nlegalid, cwnd.t_pass.id);
		table.insert(nlegalid, cwnd.t_newpass.id);
		return false,nlegalid
	end	

	return true,nil
end	

local returndatacheck =function(top,ret)
	if(ret ~= nil and ret.check_password ~= 0) then--޸ʧ
		local cwnd = w1_page_modify.wnd;
		local nlegalid = {};
		local pwd_rule = b_app_api.get_cfg({'pwd_rule_info'}).pwd_rule_info
		local pwd_min_len = string.gsub(STR('LA_PWD_MIN_RULE'), '*' ,pwd_rule.pwd_min_len); 
		local pwd_max_len = string.gsub(STR('LA_PWD_MAX_RULE'), '*' ,pwd_rule.pwd_max_len); 
		if(ret.check_password == -508) then
			w1_wnd_util.setparamerr_str(STR('LA_OLDPW_ERR'));
			--¶ȡ
			table.insert(nlegalid, cwnd.t_pass.id);
		elseif(ret.check_password == -519) then
			w1_wnd_util.setparamerr_str(pwd_min_len);
			--¶ȡ
			table.insert(nlegalid, cwnd.t_newpass.id);
			table.insert(nlegalid, cwnd.t_conpass.id);
		elseif(ret.check_password == -521) then
			w1_wnd_util.setparamerr_str(STR('LA_PWD_LOW'));
			--¶ȡ
			table.insert(nlegalid, cwnd.t_newpass.id);
			table.insert(nlegalid, cwnd.t_conpass.id);
		elseif(ret.check_password == -522) then
			w1_wnd_util.setparamerr_str(STR('LA_PASSWORD_TIP'));
			--¶ȡ
			table.insert(nlegalid, cwnd.t_newpass.id);
			table.insert(nlegalid, cwnd.t_conpass.id);
		elseif(ret.check_password == -542) then -- ַ֧
			w1_wnd_util.setparamerr_str(STR('LA_PWD_INVALID'));
			--¶ȡ	
			table.insert(nlegalid, cwnd.t_newpass.id);
			table.insert(nlegalid, cwnd.t_conpass.id);
		elseif(ret.check_password == -545) then 
			w1_wnd_util.setparamerr_str(pwd_max_len);
		
			table.insert(nlegalid, cwnd.t_newpass.id);
			table.insert(nlegalid, cwnd.t_conpass.id);
		elseif(ret.check_password == -546) then -- 
			w1_wnd_util.setparamerr_str(STR('LA_PWD_RULE_TIP1'));
		
			table.insert(nlegalid, cwnd.t_newpass.id);
			table.insert(nlegalid, cwnd.t_conpass.id);
		elseif(ret.check_password == -547) then -- 
			w1_wnd_util.setparamerr_str(STR('LA_PWD_REQ_TIP'));

			table.insert(nlegalid, cwnd.t_newpass.id);
			table.insert(nlegalid, cwnd.t_conpass.id);
		else
			w1_wnd_util.setparamerr_str(STR('LA_APPLY_FAIL'));
		end
		--¶ȡԭʼ
		b_app_cfg.origin_init({'modify_selfuser'});
		return false,nlegalid
	end
	--¶ȡ	
	--b_app_cfg.origin_init({'modify_selfuser'});
	b_app_cfg.init({'modify_selfuser'});
	return true, nil;
end

local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_modify.wnd;
	local pass = b_wnd_ex.get_password(top, cwnd.t_pass.id);
	local newpass = b_wnd_ex.get_password(top, cwnd.t_newpass.id);
	cfgdata.modify_selfuser.password = pass;
	cfgdata.modify_selfuser.newpass = newpass;

end

w1_page_modify.timer_start = function()
	w1_page_modify.timestart = true;
end

w1_page_modify.timer_stop = function(top)
	w1_page_modify.timestart = false;
	w1_wnd_util.tipclear(top, w1_page_modify.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
end

w1_page_modify.timerenevt = function(top)
	if(w1_page_modify.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_modify.wnd.tipinfo.id);
		w1_wnd_util.cfgtab = {'modify_selfuser'};
	end
	return 0;
end

local on_apply = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.returndatacheckfunc = returndatacheck;
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

w1_page_modify.apply =function(top)
	--ҳ⴦۲ǷϷתҳ 
	
	w1_wnd_util.uidatacheckfunc = uidatacheck
	w1_wnd_util.returndatacheckfunc = returndatacheck;
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
		
	return ret;
end

--ҳʼʱٶȡҳҪ
w1_page_modify.init = function(top)
	b_app_cfg.init({'modify_selfuser'});
	w1_wnd_util.cfgtab = {'modify_selfuser'};
	clear_uidata(top);
	
	local pwd_rule = b_app_api.get_cfg({'pwd_rule_info'}).pwd_rule_info
	local str_info_tmp = string.gsub(STR('LA_PASSWORD_RULE2'), '*' ,pwd_rule.pwd_min_len); 
	local str_info = string.gsub(str_info_tmp, '@' ,pwd_rule.pwd_max_len); 
	b_wnd_ex.set_text(top, w1_page_modify.wnd.info1.id, str_info, false);
	
	return 0
end

w1_page_modify.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_pass','t_pass',
			'cap_newpass','t_newpass',
			'cao_conpass','t_conpass',
			'info1','info2','info3','tipinfo',
			'default', 'apply' },
		
	cap_pass 	= {t='static',	id=id+1,	xywh='s_cfg_page_1_1',text='LA_OLD_PASSWARD'},		
	t_pass 		= {t='password',id=id+2,	xywh='s_cfg_page_1_2',password='',guide_text='LA_PASSWORD', disp = false,cmd = on_update_param},		
	
	cap_newpass = {t='static',	id=id+3,	xywh='s_cfg_page_2_1',text='LA_NEW_PWD'},		
	t_newpass 	= {t='password',id=id+4,	xywh='s_cfg_page_2_2',password='', guide_text='LA_PASSWORD',disp = false,cmd = on_update_param},	
	cao_conpass = {t='static',	id=id+5,	xywh='s_cfg_page_3_1',text='LA_CONFIRM_PWD'},		
	t_conpass 	= {t='password',id=id+6,	xywh='s_cfg_page_3_2',password='', guide_text='LA_PASSWORD',disp = false},	

	info1		= {t='static',	id=id+7,	xywh='s_modify_info1_xywh',text='LA_PASSWORD_RULE2'},
	info2		= {t='static',	id=id+8,	xywh='s_modify_info2_xywh',text='LA_PWD_RULE'},
	info3		= {t='static',	id=id+9,	xywh='s_modify_info3_xywh',text='LA_INPUT_RULE1'},
	tipinfo		= {t='static',id=id+10,	xywh='s_modify_tipinfo_xywh',	text='', 
					font='f_grade4', trans = false},
	apply 		= {t='button',	id=id+11,	xywh='s_cfg_apply_xywh', 		text='LA_APPLY',cmd=on_apply},
}

return w1_page_modify



