
--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local w1_id 		= require("wnd.w1_util.w1_id")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local id 			= w1_id.cfg_modify.modify_g_id
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_msgbox 	= require("wnd.w1_util.w1_msgbox")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local util 			= require("wnd.core.util")
local w1_pattern_pop = require("wnd.w1_cfg.w1_pattern_pop");
local b_app_api 	= require("wnd.core.command.b_app_api")
local w1_page_modify_g = 
{
	timestart = false,
	pattern_pwd,
	cfg_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_modify_g.s_768 =
{
	s_modify_g_t_enable = {278,69, 25, 21},	   	
	s_modify_g_tipinfo_xywh = {53,277,640,35},
};

w1_page_modify_g.s_1280 = 
{
	s_modify_g_t_enable = {453,97, 48, 30},	   	
	s_modify_g_tipinfo_xywh = {100,390,900,50},
}

w1_page_modify_g.s_1440 = 
{
	s_modify_g_t_enable = {522,82, 48, 30},	   	
	s_modify_g_tipinfo_xywh = {100,390,1000,50},
}

w1_page_modify_g.s_1080p = 
{
	s_modify_g_t_enable = {520,97, 48, 30},	   	
	s_modify_g_tipinfo_xywh = {100,390,1200,50},
}

w1_page_modify_g.s_2k = 
{
	s_modify_g_t_enable = {695, 130, 64, 40},	   	
	s_modify_g_tipinfo_xywh = {133,520,1600,67},
}

w1_page_modify_g.s_4k = 
{
	s_modify_g_t_enable = {1040,194, 96, 60},	   	
	s_modify_g_tipinfo_xywh = {200,780,2400,100},
}

w1_page_modify_g.clear_data = function()
	w1_page_modify_g.pattern_pwd = nil;
	w1_page_modify_g.cfg_data = nil;
end	

-- UIʾ
local clear_uidata =function (top)
	local cwnd = w1_page_modify_g.wnd;
	b_wnd_ex.set_password(top,cwnd.t_pass.id,"",false);
	w1_pattern_pop.pattern_clear();
end


local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_modify_g.wnd;
	cfgdata.modify_g.password = b_wnd_ex.get_password(top,cwnd.t_pass.id);
	local pattern = w1_pattern_pop.get_pattern_number();
	local check = b_wnd_ex.get_check(top, cwnd.t_enable.id);
	w1_page_modify_g.cfg_data.pattern_unlock = check;	
	if pattern ~= nil and pattern ~= '' then
		cfgdata.modify_g.pattern_pwd = pattern
	end	
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true;
	local nlegalid = {};
	local cwnd = w1_page_modify_g.wnd;
	local uipass = b_wnd_ex.get_password(top,cwnd.t_pass.id);
	local curUserName = b_app_api.get_cur_username().user_name;
	--Ϊ
	if("" == uipass)then
		w1_wnd_util.setparamerr_str(STR('LA_PASSWORD_EMPTY'));
		table.insert(nlegalid, cwnd.t_pass.id);
		return false,nlegalid
	elseif (false == b_app_api.check_current_pwd(curUserName,uipass)) then
		w1_wnd_util.setparamerr_str(STR('LA_ERR_PASSWD'));
		table.insert(nlegalid, cwnd.t_pass.id);
		return false,nlegalid
	end
	
	local pattern = w1_pattern_pop.get_pattern_number();
	local check = b_wnd_ex.get_check(top, cwnd.t_enable.id);
	--δ ҿδ޸
	if (pattern == '' or pattern == nil) and  (w1_page_modify_g.cfg_data.pattern_unlock == b_app_cfg.origin_cfg.privacy.pattern_unlock) then
		w1_wnd_util.setparamerr_str(STR('LA_PATTERN_EMPTY'));
		return false,nlegalid;
	else
		if pattern ~= nil and pattern ~= '' then
			b_app_cfg.user_cfg.modify_g.pattern_pwd = pattern
			b_app_cfg.user_cfg.modify_g.password = uipass;
		else
			b_app_cfg.user_cfg.modify_g.pattern_pwd = ''
			b_app_cfg.user_cfg.modify_g.password = ''	
		end	
	end
	return true,nil
end	

local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	w1_page_modify_g.cfg_data = cfgdata.privacy;
	local cwnd = w1_page_modify_g.wnd
	local check = w1_page_modify_g.cfg_data.pattern_unlock;
	b_wnd_ex.set_check(top, cwnd.t_enable.id, check, false);
end		

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg or b_ui.LBUTTONCLK == vmsg )then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local returndatacheck =function(top,ret)
	if(ret ~= nil and ret.modify_g ~= 0) then--޸ʧ
		local cwnd = w1_page_modify_g.wnd;
		local nlegalid = {};
		if(ret.modify_g == -1) then
			w1_wnd_util.setparamerr_str(STR('LA_ERR_PASSWD'));
			table.insert(nlegalid, cwnd.t_pass.id);
		end
		
		return false,nlegalid
	end

	return true, nil;
end

w1_page_modify_g.timer_start = function()
	w1_page_modify_g.timestart = true;
end

w1_page_modify_g.timer_stop = function(top)
	w1_page_modify_g.timestart = false;
	w1_wnd_util.tipclear(top, w1_page_modify_g.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
end

w1_page_modify_g.timerenevt = function(top)
	if(w1_page_modify_g.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_modify_g.wnd.tipinfo.id);
		w1_wnd_util.cfgtab = {'modify_g', 'privacy'};
	end
	return 0;
end

local on_pattern_pop = function(top, win_id, vmsg, x, y)
	if(b_ui.LBUTTONCLK == vmsg)then
		w1_pattern_pop.set_pattern_type(2);
		b_dlg.do_modal(top,w1_key.DLG_MSG_PATTERN_POP,x,y,nil);
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top)
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if(b_ui.LBUTTONCLK == vmsg)then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.returndatacheckfunc = returndatacheck;
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_modify_g.apply =function(top)
	--ҳ⴦۲ǷϷתҳ 
	w1_wnd_util.uidatacheckfunc = uidatacheck
	w1_wnd_util.returndatacheckfunc = returndatacheck;
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
		
	return ret;
end

--ҳʼʱٶȡҳҪ
w1_page_modify_g.init = function(top)
	w1_wnd_util.cfgtab = {'modify_g', 'privacy'};
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	clear_uidata(top);

	return 0
end

w1_page_modify_g.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_pass','t_pass', 'cap_enable', 't_enable','cap_pattern','t_pattern', 'tipinfo','apply' },
	cap_pass 	= {t='static',	id=id+1,	xywh='s_cfg_page_1_1',text='LA_PASSWORD'},		
	t_pass 		= {t='password',id=id+2,	xywh='s_cfg_page_1_2',password='',guide_text='LA_PASSWORD', disp = false,cmd = on_update_param},		

	cap_enable	= {t='static',	id=id+3,	xywh='s_cfg_page_2_1',		text='LA_ENABLE_PLOCK'},
	t_enable	= {t='tt_check',id=id+4,	xywh='s_modify_g_t_enable', 		
					t_imgs = {b_ui.ALIGN.LEFT,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_update_param},			
				
	cap_pattern = {t='static',id=id+5,xywh='s_cfg_page_3_1',text='LA_PATTERN'},
	t_pattern	= {t='tt_button',id=id+6,xywh='s_cfg_page_3_2',text='LA_SET_PATTERN',cmd=on_pattern_pop},
	tipinfo		= {t='static',id=id+7,	xywh='s_modify_g_tipinfo_xywh',	text='', 
					font='f_grade4', trans = false},
	apply 		= {t='button',	id=id+8,	xywh='s_cfg_apply_xywh', 		text='LA_APPLY',cmd=on_apply},
}

return w1_page_modify_g