--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val 	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_motion.motion_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  	= require("wnd.w1_util.w1_ui_msg") 
local w1_row_motionrow 			= require("wnd.w1_cfg.w1_row_motionrow")
local w1_page_motionevent 		= require("wnd.w1_cfg.w1_page_motionevent")
local w1_page_motionarea 		= require("wnd.w1_cfg.w1_page_motionarea")
local w1_page_motiontimeplan 	= require("wnd.w1_cfg.w1_page_motiontimeplan")
local w1_copy 		= require("wnd.w1_util.w1_copy")
local w1_key 		= require("wnd.w1_util.w1_key")
local util 			= require("wnd.core.util")
local util_ex 		= require("wnd.core.util_ex")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local b_app_api = require("wnd.core.command.b_app_api")

local w1_page_motion = 
{
	old_chid,
	data,
	timestart = false,
	copy_ch = {},
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_motion.s_768 =
{
	s_motion_t_enable_xywh = {277,67,25,21},
	s_motion_t_motion_analysis_xywh = {277,110,25,21},
	s_motion_tipinfo_xywh = {58,554,213,35},
};

w1_page_motion.s_1280 = 
{
	s_motion_t_enable_xywh = {455,95,48,30},
	s_motion_t_motion_analysis_xywh = {455,155,48,30},
	s_motion_tipinfo_xywh = {110,800,400,50},
}

w1_page_motion.s_1440 = 
{
	s_motion_t_enable_xywh = {520,80,48,30},
	s_motion_t_motion_analysis_xywh = {520,130,48,30},
	s_motion_tipinfo_xywh = {110,700,400,50},
}

w1_page_motion.s_1080p = 
{
	s_motion_t_enable_xywh = {520,95,48,30},
	s_motion_t_motion_analysis_xywh = {520,155,48,30},
	s_motion_tipinfo_xywh = {110,780,400,50},
}

w1_page_motion.s_2k = 
{
	s_motion_t_enable_xywh = {693,127,64,40},
	s_motion_t_motion_analysis_xywh = {693,207,64,40},
	s_motion_tipinfo_xywh = {147,1063,523,67},
}

w1_page_motion.s_4k = 
{
	s_motion_t_enable_xywh = {1040,190,96,60},
	s_motion_t_motion_analysis_xywh = {1040,310,96,60},
	s_motion_tipinfo_xywh = {220,1560,700,100},
}

local channel_num;--豸ͨĿ

w1_page_motion.clear_data = function()
	w1_page_motion.data = nil;
	w1_page_motion.copy_ch = nil;	
end	

local refresh_chdata = function(top, chid, redraw)
	local c_wnd = w1_page_motion.wnd
	local channeldata = w1_page_motion.data.motion_detect['channel'..chid]
	local ro_num = w1_page_motion.data.device_info['ro_num']
	local buzz_support = w1_page_motion.data.device_info['buzzer_support']
	b_wnd_ex.set_check(top, c_wnd.t_enable.id, channeldata.enable, redraw);
	b_wnd_ex.set_check(top, c_wnd.t_motion_analysis.id, channeldata.motion_analysis, redraw);
	local checkidx = w1_row_motionrow.get_checkidx(top);
	
	if(checkidx == 0) then
		w1_page_motionevent.setstatus(top, channeldata, chid, ro_num, buzz_support, redraw);
		w1_page_motionarea.setmareaparam(top, channeldata, false);
		w1_page_motiontimeplan.settimeplan(top, channeldata, false);	
	elseif(checkidx == 1) then
		w1_page_motionevent.setstatus(top, channeldata, chid, ro_num, buzz_support,false);
		w1_page_motionarea.setmareaparam(top, channeldata, true);
		w1_page_motiontimeplan.settimeplan(top, channeldata, false);
	elseif(checkidx == 2) then
		w1_page_motionevent.setstatus(top, channeldata, chid, ro_num, buzz_support,false);
		w1_page_motionarea.setmareaparam(top, channeldata, false);
		w1_page_motiontimeplan.settimeplan(top, channeldata, redraw);
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local c_wnd = w1_page_motion.wnd
	w1_page_motion.data = cfgdata;
	
	local camreaitems = {};
	local idx = 1;
	local privilege = global_val.get_allprivilege();--ȡȨ
	local ch_prilist = privilege.channel_manager_list;
	local old_chn = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
	local sel = 0;
	for i=1, channel_num do
		if(cfgdata['motion_detect']['channel'..i] ~= nil and ch_prilist[i] == 1) then
			camreaitems[idx] = i;
			if old_chn == i then
				sel = idx-1
			end
			idx = idx + 1;
		end
	end
	b_wnd_ex.set_items(top, c_wnd.t_channel.id, camreaitems, false);	
	if(idx ~= 1) then--˵ͨ
		b_wnd_ex.set_disable(top, c_wnd.t_channel.id, false, false)
		b_wnd_ex.set_hide(top, 	c_wnd.cap_enable.id, false, false)
		b_wnd_ex.set_hide(top, 	c_wnd.t_enable.id, false, false)
		b_wnd_ex.set_hide(top, 	c_wnd.cap_motion_analysis.id, false, false)
		b_wnd_ex.set_hide(top, 	c_wnd.t_motion_analysis.id, false, false)
		b_wnd_ex.set_hide(top,  w1_id.cfg_motion.motionrow_id, 	false, false)		
		w1_page_motionevent.sethide(top, false, false)
		w1_page_motionarea.sethide(top, false, false)
		w1_page_motiontimeplan.sethide(top, false, false)
		b_wnd_ex.set_sel(top, c_wnd.t_channel.id, sel, false);--Ĭһ
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		w1_page_motionarea.setdispch(top, chid);
		refresh_chdata(top, chid, false);
	else
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id, true, false)
		b_wnd_ex.set_hide(top, 	c_wnd.cap_enable.id, true, false)
		b_wnd_ex.set_hide(top, 	c_wnd.t_enable.id, true, false)
		b_wnd_ex.set_hide(top, 	c_wnd.cap_motion_analysis.id, true, false)
		b_wnd_ex.set_hide(top, 	c_wnd.t_motion_analysis.id, true, false)
		b_wnd_ex.set_hide(top,  w1_id.cfg_motion.motionrow_id, 	true, false)
		w1_page_motionevent.sethide(top, true, false)
		w1_page_motionarea.sethide(top, true, false)
		w1_page_motiontimeplan.sethide(top, true, false)
	end
	
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

w1_page_motion.timer_start = function()
	w1_page_motion.timestart = true
end

w1_page_motion.timer_stop = function(top)
	w1_page_motion.timestart = false
	w1_wnd_util.tipclear(top, w1_page_motion.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
	local channel = tonumber(b_wnd_ex.get_text(top, w1_page_motion.wnd.t_channel.id));
	if channel ~= 0 then
		b_app_api.stop_motion_visible(channel);
	end
end

w1_page_motion.timerenevt = function(top)
	if(w1_page_motion.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_motion.wnd.tipinfo.id)
		local channel = tonumber(b_wnd_ex.get_text(top, w1_page_motion.wnd.t_channel.id));
		local page_id = w1_row_motionrow.get_checkidx(top)
		if channel ~= 0 and page_id == 1 then
			local motion = b_app_api.get_motion(channel);
			w1_page_motionarea.set_motion(top,motion,false);
			b_dlg.dlg_set_redraw(top);
		end
	end
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_motion.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id))
	if(chid == nil) then
		return 0
	end

	local enable = b_wnd_ex.get_check(top,cwnd.t_enable.id);
	local check = b_wnd_ex.get_check(top, cwnd.t_motion_analysis.id);
	local data = cfgdata.motion_detect['channel'..chid]
	data.enable = enable;
	data.motion_analysis = check
	data.change_flag = true;
	return 0
end

w1_page_motion.init = function(top)
	local cwnd = w1_page_motion.wnd;
	w1_wnd_util.cfgtab = {'motion_detect','device_info'};
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);
	local chidstr = b_wnd_ex.get_text(top, cwnd.t_channel.id);
	if(chidstr == '') then
		w1_page_motionarea.setdispch(top, 1);
		return 0;
	end
	local chid =tonumber(chidstr);
	w1_page_motion.old_chid = chid;
	b_app_api.start_motion_visible(chid);
	return 0;
end

local on_channel = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local c_wnd = w1_page_motion.wnd
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		if(w1_page_motion.old_chid ~= chid) then
			w1_page_motionarea.setdispch(top, chid);
			refresh_chdata(top, chid, false);
			if w1_page_motion.old_chid ~= nil and w1_page_motion.old_chid ~= 0 then
				b_app_api.stop_motion_visible(w1_page_motion.old_chid);
			end
			b_app_api.start_motion_visible(chid);
			w1_page_motion.old_chid = chid;
		end
		b_dlg.dlg_set_redraw(top);
	--	uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_enable  = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_motion_analysis  = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

w1_page_motion.on_data_change = function(top)
	if w1_row_motionrow.get_checkidx(top)== 0 then
		w1_page_motionevent.on_channel_check(top);
	end
end

local copy_okfunc = function(param)
	local cwnd = w1_page_motion.wnd;
	local chid = tonumber(b_wnd_ex.get_text(param[1], cwnd.t_channel.id));
	if(chid == nil) then
		return 0;
	end
	local chsrc = w1_page_motion.data.motion_detect['channel'..chid];
	local chdir = w1_page_motion.data.motion_detect;
	local src_chn_ro_num = chsrc.linkage.chn_ro_num;
	local dst_chn_ro_num = 0;
	local dst_camrea_io_enable = false;
	local dst_camera_io_list = 0;
	for i=1, #param[2] do
		if (nil ~= chdir['channel'..param[2][i]]) then
			dst_chn_ro_num = chdir['channel'..param[2][i]].linkage.chn_ro_num;
			dst_camrea_io_enable = chdir['channel'..param[2][i]].linkage.camrea_io_enable;
			dst_camera_io_list = chdir['channel'..param[2][i]].linkage.camera_io_list;
		end
		if(chdir['channel'..param[2][i]] == nil) then
			chdir['channel'..param[2][i]] = util.copy_tab(chsrc)
		else
			util.copy_tab_b(chdir['channel'..param[2][i]], chsrc)
		end	
		chdir['channel'..param[2][i]].change_flag = true;
		chdir['channel'..param[2][i]].channel_id = param[2][i];
		chdir['channel'..param[2][i]].linkage.chn_ro_num = dst_chn_ro_num;
		if (0 >= src_chn_ro_num or 0 >= dst_chn_ro_num) then 
			chdir['channel'..param[2][i]].linkage.camrea_io_enable = dst_camrea_io_enable;
			chdir['channel'..param[2][i]].linkage.camera_io_list = dst_camera_io_list;
		end
		dst_chn_ro_num = 0;
		dst_camrea_io_enable = false;
		dst_camera_io_list = 0;
	end
	
	--Դֻͨһ.Ҹͨŵͨid,
	--ĬϸƵͨ
	if(#param[2] > 0) then	
		if(#chsrc.linkage.trigger_ch == 1 and 
			chsrc.linkage.trigger_ch[1] == chsrc.channel_id) then
			
			for i=1, #param[2] do
				chdir['channel'..param[2][i]].linkage.trigger_ch = nil;
				chdir['channel'..param[2][i]].linkage.trigger_ch = {param[2][i]};
			end	
		end
	end
	
	return 0;
end

local on_copy = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_motion.wnd;
		local param = {};
		local idx = 1;
		local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	--	uitousercfg(top, w1_page_motion.data)

		local motiondata = w1_page_motion.data.motion_detect;
		local privilege = global_val.get_allprivilege();--ȡȨ
		local ch_prilist = privilege.channel_manager_list;	
		for i=1, channel_num do
			if( i ~= chid and motiondata['channel'..i] ~= nil
				and motiondata['channel'..i].channel_id ~= nil  
				and ch_prilist[i] == 1)  then
				param[idx] = i;
				idx =idx + 1;
			end
		end
		w1_copy.init();
		w1_copy.set_dlgattr(param);
		w1_copy.set_func (copy_okfunc,{top, w1_page_motion.copy_ch} );
		b_dlg.post_modal(top, w1_key.DLG_COPY, 0, 0, nil)
	end
	return 0
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ	
	end
	return 0
end

w1_page_motion.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_motion.on_pre_show = function(top)
	local cwnd = w1_page_motion.wnd;
	channel_num = global_val.get_channelnum();

	w1_page_motionevent.on_pre_show(top, channel_num);
	w1_page_motionarea.on_pre_show(top);
	
	local con_id = cwnd.con_motionarea.id
	
	--	b_wnd_ex.set_show_page(top,con_id, cwnd.motionevent_wnd.id, false)	
	w1_row_motionrow.changecheck(top, w1_row_motionrow.wnd, w1_id.cfg_motion.motionrow_id + 1 ,false);

end

w1_page_motion.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_channel', 't_channel','cap_enable','t_enable','cap_motion_analysis','t_motion_analysis',
			'con_motionarea','motion_row_wnd',
			'motionarea_wnd','motionevent_wnd','motiontimeplan_wnd',	
			'tipinfo', 'copy', 'default', 'apply'},

	cap_channel	= {t='static',id=id+1,	xywh='s_cfg_page_1_1',	text='LA_CHANNEL'},
	t_channel 	= {t='combox',id=id+2,	xywh='s_cfg_page_1_2',	items={},trans = false,channel_cbox = true,cmd=on_channel},	
	
	cap_enable 	= {t='static',id=id+3,	xywh='s_cfg_page_2_1',	text='LA_ENABLE_MOTION_DETECTION'},
	t_enable 	= {t='tt_check', id=id+4,xywh='s_motion_t_enable_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_enable},
	cap_motion_analysis	= {t='static',id=id+5,	xywh='s_cfg_page_3_1',	text='LA_MOTIONANALYSIS'},
	t_motion_analysis	= {t='tt_check', id=id+6,xywh='s_motion_t_motion_analysis_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_motion_analysis},
	
	con_motionarea		= {t='container',id=w1_id.cfg_motion.con_motionarea_id,	xywh={0,0,10,10}},
	motion_row_wnd 		= w1_row_motionrow.wnd,
	motionarea_wnd 		= w1_page_motionarea.wnd,
	motionevent_wnd 	= w1_page_motionevent.wnd,	
	motiontimeplan_wnd 	= w1_page_motiontimeplan.wnd,
	
	tipinfo		= {t='static',id=id+7,	xywh='s_motion_tipinfo_xywh',	text='',trans = false},
	
	copy 		= {t='button',id=id+8,	xywh = 's_cfg_copy_xywh',	text='LA_COPY_TO',cmd=on_copy},
	apply 		= {t='button',id=id+9,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}


return w1_page_motion

