--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 	= require("wnd.core.b_ui")
local w1_id = require("wnd.w1_util.w1_id")
local id 	= w1_id.cfg_upnp.nat_port_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_dlg 	= require("wnd.core.b_dlg")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local b_app_cfg  = require("wnd.core.b_app_cfg")

local w1_page_nat_port = 
{
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_nat_port.s_768 =
{
	s_nat_port_info_xywh = {53,120,373,32},
	s_nat_port_tipinfo_xywh = {53,277,373,35},
};

w1_page_nat_port.s_1280 = 
{
	s_nat_port_info_xywh = {100, 170, 700, 45},
	s_nat_port_tipinfo_xywh = {100,390,700,50},
}

w1_page_nat_port.s_1440 = 
{
	s_nat_port_info_xywh = {100, 140, 700, 45},
	s_nat_port_tipinfo_xywh = {100,390,700,50},
}

w1_page_nat_port.s_1080p = 
{
	s_nat_port_info_xywh = {100, 170, 700, 45},
	s_nat_port_tipinfo_xywh = {100,390,700,50},
}

w1_page_nat_port.s_2k = 
{
	s_nat_port_info_xywh = {133, 210, 800, 60},
	s_nat_port_tipinfo_xywh = {133,521,933,67},
}

w1_page_nat_port.s_4k = 
{
	s_nat_port_info_xywh = {200, 340, 1400, 90},
	s_nat_port_tipinfo_xywh = {200,780,1400,100},
}

local redraw =false;

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local cwnd = w1_page_nat_port.wnd
	w1_page_nat_port.data = cfgdata.nat_port;
	local data = w1_page_nat_port.data;
	b_wnd_ex.set_value(top, cwnd.t_s_port.id, data.s_port, false)	
	b_wnd_ex.set_value(top, cwnd.t_e_port.id, data.e_port, false);

	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_nat_port.wnd
	local data = cfgdata.nat_port;
	data.s_port = b_wnd_ex.get_value(top, cwnd.t_s_port.id);
	data.e_port = b_wnd_ex.get_value(top, cwnd.t_e_port.id);
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cwnd = w1_page_nat_port.wnd
		local data = w1_page_nat_port.data;
		local s_port = b_wnd_ex.get_value(top, cwnd.t_s_port.id);
		local e_port = s_port + data.max_port - 1;
		if (e_port > 65534) then
			e_port = 65534;
			s_port = e_port - data.max_port + 1;
			b_wnd_ex.set_value(top, cwnd.t_s_port.id, s_port, false);
		end
		b_wnd_ex.set_value(top, cwnd.t_e_port.id, e_port, false);
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top)
	end
	
	return 0;
end


local returndatacheck =function(top, ret)
	if(ret ~= nil and ret.nat_port ~= 0) then--޸ʧ
		local cwnd = w1_page_nat_port.wnd
		local nlegalid = {};
		table.insert(nlegalid, cwnd.t_s_port.id);
		w1_wnd_util.setparamerr_str(STR('LA_NAT_RANG_TIP'));
		--¶ȡԭʼ
		b_app_cfg.origin_init(w1_wnd_util.cfgtab);
		return false, nlegalid;
	end
	return true, nil;
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	
	return legalflag, nil;
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.returndatacheckfunc = returndatacheck;
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_nat_port.timer_start = function()
	w1_page_nat_port.timestart = true
end

w1_page_nat_port.timer_stop = function(top)
	w1_page_nat_port.timestart = false
	w1_wnd_util.tipclear(top, w1_page_nat_port.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_nat_port.timerenevt = function(top)
	if(w1_page_nat_port.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_nat_port.wnd.tipinfo.id)
	end
	return 0
end

w1_page_nat_port.clear_data = function(top)
	w1_page_nat_port.data = nil;
end

--ҳʼʱٶȡҳҪ
w1_page_nat_port.init = function(top)
	w1_wnd_util.cfgtab = {'nat_port'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	b_wnd_ex.set_disable(top, w1_page_nat_port.wnd.t_e_port.id, true, false);
	return 0
end

w1_page_nat_port.apply =function(top)
	w1_wnd_util.uidatacheckfunc = uidatacheck
	w1_wnd_util.returndatacheckfunc = returndatacheck;
	local ret = w1_wnd_util.page_onapply(top);
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	w1_wnd_util.returndatacheckfunc = nil;	
	return ret;	
end

w1_page_nat_port.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_s_port', 't_s_port', 'cap_e_port','t_e_port','info', 'tipinfo', 'apply' },
	
	cap_s_port 	= {t='static',	id=id+1,xywh='s_cfg_page_1_1',		text='LA_SPORT'},
	t_s_port 	= {t='edit_num',id=id+2,xywh='s_cfg_page_1_2',range={40001,65534},cmd = on_update_param},
	
	cap_e_port 	= {t='static',	id=id+3,xywh='s_cfg_page_2_1',		text='LA_EPORT'},
	t_e_port 	= {t='edit_num',id=id+4,xywh='s_cfg_page_2_2',range={40001,65534}},
	
	info		= {t='static',	id=id+11,	xywh='s_nat_port_info_xywh',  text='LA_NAT_PORT_RANGE'},	
	
	tipinfo		= {t='static',	id=id+5,	xywh='s_nat_port_tipinfo_xywh',	text='',trans = false},
	apply 		= {t='button',	id=id+6,	xywh='s_cfg_apply_xywh',text='LA_APPLY',cmd=on_apply},
}


return w1_page_nat_port



