
--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/10/31
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local w1_id 		= require("wnd.w1_util.w1_id")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local id 			= w1_id.cfg_net_stat.net_stat_id
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_msgbox 	= require("wnd.w1_util.w1_msgbox")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local util 			= require("wnd.core.util")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_wnd 	= require("wnd.core.b_wnd")
local b_app_api		= require("wnd.core.command.b_app_api")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local step_flag = 0
local time_flag = 1
local poe_net_num = 0;

local w1_page_net_stat = 
{
	data,
	timestart,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_net_stat.s_768 =
{
	s_net_internet_img_xywh = {25,199,45,85},
	s_net_gateway_img_xywh = {180,199,45,85},
	s_intogate_line_xywh = {80,241,90,2},
	s_gatetowan_line_xywh = {235,241,90,2},
	s_net_ip_conflict_xywh = {245,200,80,40},
	s_net_line_img_xywh = {377,227,100,200},
	s_net_wan_xywh = {335,228,31,28},
	s_net_lan_xywh = {366,228,22,28},
	s_net_wan_boder_xywh = {388,228,7,28},
	s_net_dev1_xywh = {381,63,38,45},
	s_net_dev2_xywh = {378,386,38,45},
	s_net_line2_img_xywh = {396,386,100,200},
	s_net_poe_err_xywh = {386,94,30,20},
	s_net_poe_err2_xywh = {384,378,30,20},
		
	s_connet_hline_xywh = {586,508,106,1},
	cap_connet_hline_xywh = {704,497,106,28},
	s_disconnet_hline_xywh = {586,536,106,1},
	cap_disconnet_hline_xywh = {704,526,106,28},
	s_err_hline_xywh = {586,565,106,1},
	cap_err_hline_xywh = {704,554,106,28},
	s_conneting_hline_xywh = {586,593,106,1},
	cap_conneting_hline_xywh = {704,583,106,28},
	s_net_poe_tip_xywh = {26,583,426,28},
		
	s4_net_internet_img_xywh = {90,280,45,75},
	s4_net_gateway_img_xywh  = {240,280,45,75},
	s4_intogate_line_xywh    = {145,320,95,3},
	s4_gatetowan_line_xywh   = {295,320,95,3},
	s4_net_ip_conflict_xywh  = {290,280,110,40},
	s4_net_line_img_xywh     = {442,310,162,200},
	s4_net_wan_xywh		= {400,310,31,28},
	s4_net_lan_xywh		= {431,310,22,28},
	s4_net_wan_boder_xywh = {519,310,7,28},
	s4_net_dev1_xywh	= {446,135,38,45},
	s4_net_poe_err_xywh = {451,168,30,20},
		
	s4_connet_hline_xywh = {560,510,120,2},
	cap4_connet_hline_xywh = {680,490,150,40},
	s4_disconnet_hline_xywh = {560,550,120,2},
	cap4_disconnet_hline_xywh = {680,530,150,40},
	s4_err_hline_xywh = {560,590,120,2},
	cap4_err_hline_xywh = {680,570,150,40},
	s4_conneting_hline_xywh = {560,630,120,2},
	cap4_conneting_hline_xywh = {680,610,150,40},
	s4_net_poe_tip_xywh = {50,610,500,40},

	s_net_margin = {130,10,2,5},
};

w1_page_net_stat.s_1280 = 
{
	s_net_internet_img_xywh = {0,280,90,120},
	s_net_gateway_img_xywh  = {120,280,100,120},
	s_intogate_line_xywh    = {90,340,30,3},
	s_gatetowan_line_xywh   = {220,340,30,3},
	s_net_ip_conflict_xywh  = {180,180,110,80},
	s_net_line_img_xywh     = {332,320,200,200},
	s_net_wan_xywh		= {250,315,61,55},
	s_net_lan_xywh		= {311,315,43,55},
	s_net_wan_boder_xywh = {354,315,13,55},
	s_net_dev1_xywh		= {337,55,76,75},
	s_net_dev2_xywh     = {337,570,76,75},
	s_net_line2_img_xywh = {375,570,200,200},
	s_net_poe_err_xywh = {361,110,30,30},
	s_net_poe_err2_xywh = {361,560,30,30},
	
	s_connet_hline_xywh = {20,705,120,2},
	cap_connet_hline_xywh = {170,690,150,40},
	s_disconnet_hline_xywh = {20,745,120,2},
	cap_disconnet_hline_xywh = {170,730,150,40},
	s_err_hline_xywh = {20,785,120,2},
	cap_err_hline_xywh = {170,770,150,40},
	s_conneting_hline_xywh = {20,825,120,2},
	cap_conneting_hline_xywh = {170,810,150,40},
	s_net_poe_tip_xywh = {400,800,580,40},
	--4poeͨʱ
	s4_net_internet_img_xywh = {100,280,90,120},
	s4_net_gateway_img_xywh  = {250,280,100,120},
	s4_intogate_line_xywh    = {190,340,60,3},
	s4_gatetowan_line_xywh   = {350,340,60,3},
	s4_net_ip_conflict_xywh  = {310,180,110,80},
	s4_net_line_img_xywh     = {491,320,200,200},
	s4_net_wan_xywh		= {410,315,61,55},
	s4_net_lan_xywh		= {471,315,43,55},
	s4_net_wan_boder_xywh = {514,315,13,55},
	s4_net_dev1_xywh		= {495,55,76,75},
	s4_net_poe_err_xywh = {520,110,30,30},

		
	s4_connet_hline_xywh = {680,705,120,2},
	cap4_connet_hline_xywh = {830,690,150,40},
	s4_disconnet_hline_xywh = {680,745,120,2},
	cap4_disconnet_hline_xywh = {830,730,150,40},
	s4_err_hline_xywh = {680,785,120,2},
	cap4_err_hline_xywh = {830,770,150,40},
	s4_conneting_hline_xywh = {680,825,120,2},
	cap4_conneting_hline_xywh = {830,810,150,40},
	s4_net_poe_tip_xywh = {100,800,500,40},

	s_net_margin 		= {200,15,5,5}, --Բֱͬ1.ܸ߶ȣ2.ߵڶ໥࣬3.ͼƬ 4.ʼƶ
}

w1_page_net_stat.s_1440 = 
{
	s_net_internet_img_xywh = {0,280,100,120},
	s_net_gateway_img_xywh  = {180,280,100,120},
	s_intogate_line_xywh    = {100,340,80,3},
	s_gatetowan_line_xywh   = {280,340,80,3},
	s_net_ip_conflict_xywh  = {270,200,100,80},
	s_net_line_img_xywh     = {442,320,200,200},
	s_net_wan_xywh		= {360,315,61,55},
	s_net_lan_xywh		= {421,315,43,55},
	s_net_wan_boder_xywh = {464,315,13,55},
	s_net_dev1_xywh		= {447,55,76,75},
	s_net_dev2_xywh     = {447,570,76,75},
	s_net_line2_img_xywh = {485,570,200,200},
	s_net_poe_err_xywh = {471,110,30,30},
	s_net_poe_err2_xywh = {471,560,30,30},
	
	s_connet_hline_xywh = {20,605,120,2},
	cap_connet_hline_xywh = {170,590,120,40},
	s_disconnet_hline_xywh = {20,645,120,2},
	cap_disconnet_hline_xywh = {170,630,150,40},
	s_err_hline_xywh = {20,685,120,2},
	cap_err_hline_xywh = {170,670,120,40},
	s_conneting_hline_xywh = {20,725,120,2},
	cap_conneting_hline_xywh = {170,710,120,40},
	
	s_net_poe_tip_xywh = {450,700,650,40},
	
	s4_net_internet_img_xywh = {100,280,100,120},
	s4_net_gateway_img_xywh  = {280,280,100,120},
	s4_intogate_line_xywh    = {200,340,80,3},
	s4_gatetowan_line_xywh   = {380,340,80,3},
	s4_net_ip_conflict_xywh  = {370,200,100,80},
	s4_net_line_img_xywh     = {542,320,200,200},
	s4_net_wan_xywh		= {460,315,61,55},
	s4_net_lan_xywh		= {521,315,43,55},
	s4_net_wan_boder_xywh = {564,315,13,55},
	s4_net_dev1_xywh		= {547,55,76,75},
	s4_net_line2_img_xywh = {583,570,200,200},
	s4_net_poe_err_xywh = {571,110,30,30},

	
	s4_connet_hline_xywh = {820,605,120,2},
	cap4_connet_hline_xywh = {970,590,120,40},
	s4_disconnet_hline_xywh = {820,645,120,2},
	cap4_disconnet_hline_xywh = {970,630,120,40},
	s4_err_hline_xywh = {820,685,120,2},
	cap4_err_hline_xywh = {970,670,120,40},
	s4_conneting_hline_xywh = {820,725,120,2},
	cap4_conneting_hline_xywh = {970,710,120,40},
	
	s4_net_poe_tip_xywh = {100,700,500,40},
	
	s_net_margin 		= {200,15,5,5}, --Բֱͬ1.ܸ߶ȣ2.ߵڶ໥࣬3.ͼƬ

}

w1_page_net_stat.s_1080p = 
{
	s_net_internet_img_xywh = {50,280,100,120},
	s_net_gateway_img_xywh  = {350,280,100,120},
	s_intogate_line_xywh    = {170,340,180,3},
	s_gatetowan_line_xywh   = {450,340,190,3},
	s_net_ip_conflict_xywh  = {480,220,150,80},
	s_net_line_img_xywh     = {732,320,200,200},
	s_net_wan_xywh		= {650,315,61,55},
	s_net_lan_xywh		= {711,315,43,55},
	s_net_wan_boder_xywh = {754,315,13,55},
	s_net_dev1_xywh		= {737,55,76,75},
	s_net_dev2_xywh     = {737,570,76,75},
	s_net_line2_img_xywh = {775,570,200,200},
	s_net_poe_err_xywh = {762,110,30,30},
	s_net_poe_err2_xywh = {762,560,30,30},
	
	s_connet_hline_xywh = {1100,715,200,2},
	cap_connet_hline_xywh = {1320,700,200,40},
	s_disconnet_hline_xywh = {1100,755,200,2},
	cap_disconnet_hline_xywh = {1320,740,200,40},
	s_err_hline_xywh = {1100,795,200,2},
	cap_err_hline_xywh = {1320,780,200,40},
	s_conneting_hline_xywh = {1100,835,200,2},
	cap_conneting_hline_xywh = {1320,820,200,40},
	s_net_poe_tip_xywh = {50,820,800,40},
	
	
	s4_net_internet_img_xywh = {100,280,100,120},
	s4_net_gateway_img_xywh  = {400,280,100,120},
	s4_intogate_line_xywh    = {220,340,180,3},
	s4_gatetowan_line_xywh   = {500,340,190,3},
	s4_net_ip_conflict_xywh  = {530,220,150,80},
	s4_net_line_img_xywh     = {782,320,200,200},
	s4_net_wan_xywh		= {700,315,61,55},
	s4_net_lan_xywh		= {761,315,43,55},
	s4_net_wan_boder_xywh = {804,315,13,55},
	s4_net_dev1_xywh		= {787,55,76,75},
	s4_net_line2_img_xywh = {825,570,200,200},
	s4_net_poe_err_xywh = {812,110,30,30},
	
	s4_connet_hline_xywh = {1100,715,200,2},
	cap4_connet_hline_xywh = {1320,700,200,40},
	s4_disconnet_hline_xywh = {1100,755,200,2},
	cap4_disconnet_hline_xywh = {1320,740,200,40},
	s4_err_hline_xywh = {1100,795,200,2},
	cap4_err_hline_xywh = {1320,780,200,40},
	s4_conneting_hline_xywh = {1100,835,200,2},
	cap4_conneting_hline_xywh = {1320,820,200,40},
	s4_net_poe_tip_xywh = {50,820,600,40},

	s_net_margin 		= {200,15,5,5}, --Բֱͬ1.ܸ߶ȣ2.ߵڶ໥࣬3.ͼƬ
}

w1_page_net_stat.s_2k = 
{
	s_net_internet_img_xywh = {100,280,150,120},
	s_net_gateway_img_xywh  = {450,280,150,120},
	s_intogate_line_xywh    = {270,340,180,3},
	s_gatetowan_line_xywh   = {600,340,190,3},
	s_net_ip_conflict_xywh  = {630,220,150,100},
	s_net_line_img_xywh     = {882,320,200,200},
	s_net_wan_xywh		= {800,315,61,55},
	s_net_lan_xywh		= {861,315,43,55},
	s_net_wan_boder_xywh = {904,315,13,55},
	s_net_dev1_xywh		= {887,55,76,75},
	s_net_dev2_xywh     = {887,570,76,75},
	s_net_line2_img_xywh = {925,570,200,200},
	s_net_poe_err_xywh = {912,110,30,30},
	s_net_poe_err2_xywh = {912,560,30,30},
	
	s_connet_hline_xywh = {1600,1015,200,2},
	cap_connet_hline_xywh = {1820,1000,200,40},
	s_disconnet_hline_xywh = {1600,1055,200,2},
	cap_disconnet_hline_xywh = {1820,1040,200,40},
	s_err_hline_xywh = {1600,1095,200,2},
	cap_err_hline_xywh = {1820,1080,200,40},
	s_conneting_hline_xywh = {1600,1135,200,2},
	cap_conneting_hline_xywh = {1820,1120,200,40},
	s_net_poe_tip_xywh = {100,1120,1200,40},
	
	s4_net_internet_img_xywh = {100,480,150,120},
	s4_net_gateway_img_xywh  = {450,480,150,120},
	s4_intogate_line_xywh    = {270,540,180,3},
	s4_gatetowan_line_xywh   = {600,540,190,3},
	s4_net_ip_conflict_xywh  = {630,420,150,100},
	s4_net_line_img_xywh     = {882,520,200,200},
	s4_net_wan_xywh		= {800,515,61,55},
	s4_net_lan_xywh		= {861,515,43,55},
	s4_net_wan_boder_xywh = {904,515,13,55},
	s4_net_dev1_xywh		= {887,255,76,75},
	s4_net_line2_img_xywh = {925,770,200,200},
	s4_net_poe_err_xywh = {912,310,30,30},

	s4_connet_hline_xywh = {1600,1015,200,2},
	cap4_connet_hline_xywh = {1820,1000,200,40},
	s4_disconnet_hline_xywh = {1600,1055,200,2},
	cap4_disconnet_hline_xywh = {1820,1040,200,40},
	s4_err_hline_xywh = {1600,1095,200,2},
	cap4_err_hline_xywh = {1820,1080,200,40},
	s4_conneting_hline_xywh = {1600,1135,200,2},
	cap4_conneting_hline_xywh = {1820,1120,200,40},
	s4_net_poe_tip_xywh = {100,1120,1200,40},
	

	s_net_margin 		= {200,15,5,6}, --Բֱͬ1.ܸ߶ȣ2.ߵڶ໥࣬3.ͼƬ 4.offset
}

w1_page_net_stat.s_4k = 
{
	s_net_internet_img_xywh = {200,572,200,159},
	s_net_gateway_img_xywh = {600,572,200,159},
	s_intogate_line_xywh = {360,652,239,3},
	s_gatetowan_line_xywh = {798,652,252,3},
	s_net_ip_conflict_xywh  = {830,400,240,150},
	s_net_line_img_xywh = {1184,625,266,266},
	s_net_wan_xywh = {1064,618,92,83},
	s_net_lan_xywh = {1156,618,63,83},
	s_net_wan_boder_xywh = {1219,618,19,82},
	s_net_dev1_xywh = {1191,200,114,80},
	s_net_dev2_xywh = {1191,1018,114,80},
	s_net_line2_img_xywh = {1250,1024,266,266},
	s_net_poe_err_xywh = {1220,320,60,60},
	s_net_poe_err2_xywh = {1220,920,60,60},

	s_connet_hline_xywh = {2363,1550,266,2},
	cap_connet_hline_xywh = {2655,1531,266,53},
	s_disconnet_hline_xywh = {2363,1604,266,2},
	cap_disconnet_hline_xywh = {2655,1584,300,53},
	s_err_hline_xywh = {2363,1657,266,2},
	cap_err_hline_xywh = {2655,1637,266,53},
	s_conneting_hline_xywh = {2363,1710,266,2},
	cap_conneting_hline_xywh = {2655,1690,266,53},
	s_net_poe_tip_xywh = {200,1690,1400,53},

	s4_net_internet_img_xywh = {266,572,200,159},
	s4_net_gateway_img_xywh = {665,572,200,159},
	s4_intogate_line_xywh = {425,652,239,3},
	s4_gatetowan_line_xywh = {865,652,252,3},
	s4_net_ip_conflict_xywh  = {897,400,240,150},
	s4_net_line_img_xywh = {1254,625,266,266},
	s4_net_wan_xywh = {1131,619,92,82},
	s4_net_lan_xywh = {1223,619,63,82},
	s4_net_wan_boder_xywh = {1269,619,19,82},
	s4_net_dev1_xywh = {1260,273,114,80},
	s4_net_line2_img_xywh = {1297,958,266,266},
	s4_net_poe_err_xywh = {1295,344,50,50},

	s4_connet_hline_xywh = {2363,1550,266,2},
	cap4_connet_hline_xywh = {2655,1531,266,53},
	s4_disconnet_hline_xywh = {2363,1604,266,2},
	cap4_disconnet_hline_xywh = {2655,1584,300,53},
	s4_err_hline_xywh = {2363,1657,266,2},
	cap4_err_hline_xywh = {2655,1637,266,53},
	s4_conneting_hline_xywh = {2363,1710,266,2},
	cap4_conneting_hline_xywh = {2655,1690,266,53},
	s4_net_poe_tip_xywh = {200,1690,1400,53},
	
	s_net_margin = {326,25,6,8},
}



local reflsh_poe = function (top,net_num)
	local cwnd = w1_page_net_stat.wnd;
	local data = b_app_api.get_poe_net_state()
	local pos = SIZE('s_net_lan_xywh')
	local d_pos = SIZE('s_net_dev1_xywh')
	local err_pos = SIZE('s_net_poe_err_xywh')
	local margin_pos = SIZE('s_net_margin')
	local net_state1 = {}
	local net_state2 = {}
	b_wnd_ex.set_hide(top,cwnd.ip_conflict.id,true,false)
	if net_num<=8 then	
		b_wnd_ex.set_poe_net_num(top,cwnd.net_line.id,net_num,false)
		for i=1,net_num do
			table.insert(net_state1,data['poe_status'][i])
		end
	elseif net_num ==16 then
		for i=1,8 do
			table.insert(net_state1,data['poe_status'][i])
		end
		for i=9,16 do
			table.insert(net_state2,data['poe_status'][i])
		end
		b_wnd_ex.set_poe_net_num(top,cwnd.net_line.id,8,false)
		b_wnd_ex.set_poe_net_num(top,cwnd.net_line2.id,8,false)
	end
	if net_num==4 then
		pos = SIZE('s4_net_lan_xywh')
		d_pos = SIZE('s4_net_dev1_xywh')
		err_pos = SIZE('s4_net_poe_err_xywh')
	end
	--ƶWANںLanͼƬλ
	local sid = cwnd.cam1.id
	local eid = cwnd.cam16.id
	local life_id = cwnd.cam1.id+net_num-1
	local num = 0;
	for i=sid,life_id do
		local place = {pos[1]+num*pos[3],pos[2],pos[3],pos[4]}
		b_wnd_ex.move_ex(top,i,place,false)
		b_wnd.set_no_find(top,i,true)
		b_wnd_ex.set_hide(top,i,false,false)
		num = num + 1
		if data['poe_status'][num] == 0 or data['poe_status'][num] == 1 or data['poe_status'][num] == 2then
			b_wnd_ex.set_disable(top,i,false,false)
		else
			b_wnd_ex.set_disable(top,i,true,false)
		end
	end
	for i=life_id+1,eid do
		b_wnd_ex.set_hide(top,i,true,false)
	end
	
	local wan_b = {pos[1]+num*pos[3],pos[2]}
	b_wnd_ex.move_pos(top,cwnd.wan_boder.id,wan_b,false)
	
	--ƶλ
	local sd_id = cwnd.dev1.id
	local ed_id = cwnd.dev16.id
	local life_d_id = cwnd.dev1.id+net_num-1
	local num = 0;
	for i=sd_id,life_d_id do
		if i==cwnd.dev9.id then
			d_pos = SIZE('s_net_dev2_xywh')
			num = 0
		end
		local place = {d_pos[1]+num*(d_pos[3]+margin_pos[3]),d_pos[2],d_pos[3],d_pos[4]}
		b_wnd_ex.move_ex(top,i,place,false)
		b_wnd_ex.set_hide(top,i,false,false)
		b_wnd.set_no_find(top,i,true)
		b_wnd_ex.set_text(top,i,string.format("%0.1f",data['poe_power'][i-sd_id+1]).."W",false)
		num = num + 1
		if data['poe_status'][i-sd_id+1] == 0 then
			b_wnd_ex.set_disable(top,i,false,false)
		else
			b_wnd_ex.set_disable(top,i,true,false)
		end
	end
	for i=life_d_id+1,ed_id do
		b_wnd_ex.set_hide(top,i,true,false)
	end
	--ƶ״̬XͼƬλ
	local er_sid = cwnd.err1.id
	local er_eid = cwnd.err16.id
	local err_id = cwnd.err1.id+net_num-1
	local num = 0;
	local net_state = net_state1
	for i=er_sid,er_eid do
		b_wnd_ex.set_hide(top,i,true,false)
	end
	for i=er_sid,err_id do
		if i==cwnd.err9.id then
			err_pos = SIZE('s_net_poe_err2_xywh')
			num = 0
			net_state = net_state2
		end
		local place = {err_pos[1]+num*(d_pos[3]+margin_pos[3]),err_pos[2],err_pos[3],err_pos[4]}
		b_wnd_ex.move_ex(top,i,place,false)
		b_wnd.set_no_find(top,i,true)
		num = num + 1
		if net_state[num]==4 then
			b_wnd_ex.set_hide(top,i,false,false)
		end
	end
	
	if data['internet_cable']==0 then
		b_wnd_ex.set_color(top,cwnd.intogate_line.id,{COLOR('c_apply_ok'),COLOR('c_apply_ok'),COLOR('c_apply_ok')},false)
	else
		b_wnd_ex.set_color(top,cwnd.intogate_line.id,{COLOR('c_txt_d'),COLOR('c_txt_d'),COLOR('c_txt_d')},false)
	end
	if data['lan_cable']==0 then
		b_wnd_ex.set_color(top,cwnd.gatetowan_line.id,{COLOR('c_apply_ok'),COLOR('c_apply_ok'),COLOR('c_apply_ok')},false)
		b_wnd_ex.set_disable(top,cwnd.wan.id,false,false)
	else
		b_wnd_ex.set_color(top,cwnd.gatetowan_line.id,{COLOR('c_txt_d'),COLOR('c_txt_d'),COLOR('c_txt_d')},false)
		if data['lan_cable']==4 then
			b_wnd_ex.set_disable(top,cwnd.wan.id,false,false)
			b_wnd_ex.set_hide(top,cwnd.ip_conflict.id,false,false)
		else
			b_wnd_ex.set_disable(top,cwnd.wan.id,true,false)
		end
	end
	
	local str = STR('LA_POE_POWER_TIP').."Sum: "..string.format("%0.1f",data['currect_power_sum']).."W / Max: "..string.format("%0.1f",data['max_power']).."W"
	b_wnd_ex.set_text(top,cwnd.poe_tip.id,str,false)
	--λ
	b_wnd.set_no_find(top,cwnd.wan.id,true)
	b_wnd.set_no_find(top,cwnd.ip_conflict.id,true)
	b_wnd.set_no_find(top,cwnd.internet_img.id,true)
	b_wnd.set_no_find(top,cwnd.gateway_img.id,true)
	b_wnd_ex.set_poe_net_point(top,cwnd.net_line.id,{0,0,pos[3],-margin_pos[1]},false)
	b_wnd_ex.set_poe_net_margin(top,cwnd.net_line.id,{pos[3],d_pos[3]+margin_pos[3],margin_pos[2]},false)
	b_wnd_ex.set_poe_net_state(top,cwnd.net_line.id,net_state1,false)
	b_wnd_ex.set_poe_net_step(top,cwnd.net_line.id,{2,0},false)
	b_wnd_ex.set_hide(top,cwnd.net_line2.id,true,false)
	
	if net_num==16 then
		b_wnd_ex.set_poe_net_point(top,cwnd.net_line2.id,{0,0,pos[3]*7,-margin_pos[1]},false)
		b_wnd_ex.set_poe_net_margin(top,cwnd.net_line2.id,{d_pos[3]+margin_pos[3],pos[3],margin_pos[2]},false)
		b_wnd_ex.set_poe_net_state(top,cwnd.net_line2.id,net_state2,false)
		b_wnd_ex.set_poe_net_step(top,cwnd.net_line2.id,{2,0},false)
		b_wnd_ex.set_hide(top,cwnd.net_line2.id,false,false)
	end	
	
end

local cfgdatatoui =function (top,cfgdata)
	local cwnd = w1_page_net_stat.wnd;
	reflsh_poe(top,poe_net_num)

end

local uitousercfg = function(top, cfgdata)
	
	return 0;
end

local uidatacheck = function(top)
	
	return 0;
end	

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck;
		w1_wnd_util.page_onapply(top);
		w1_wnd_util.tipdispon();		--ʾ
	end
	return 0;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

w1_page_net_stat.timer_start = function()
	w1_page_net_stat.timestart = true;
end

w1_page_net_stat.timer_stop = function(top)
	w1_page_net_stat.timestart = false;
	--w1_wnd_util.tipclear(top, w1_page_net_stat.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
	w1_wnd_util.tipdispoff();
end

w1_page_net_stat.timerenevt = function(top)
	if(w1_page_net_stat.timestart) then
		--w1_wnd_util.timerenevt(top, w1_page_net_stat.wnd.tipinfo.id);
		local cwnd = w1_page_net_stat.wnd;
		time_flag=time_flag+1
		if time_flag%4 == 0 then
			reflsh_poe(top,poe_net_num)
			time_flag = 0
		end
		local offset = SIZE('s_net_margin')[4]
			if step_flag ~= 0 then
				b_wnd_ex.set_poe_net_step(top,cwnd.net_line.id,{2,0},false)
				b_wnd_ex.set_poe_net_step(top,cwnd.net_line2.id,{2,0},false)
				step_flag = 0
			else
				b_wnd_ex.set_poe_net_step(top,cwnd.net_line.id,{2,offset},false)
				b_wnd_ex.set_poe_net_step(top,cwnd.net_line2.id,{2,offset},false)
				step_flag = 1
			end
			b_dlg.dlg_set_redraw(top)
		
	end
	return 0;
end

w1_page_net_stat.init = function(top)
	w1_wnd_util.cfgtab = {''};
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);
	return 0
end

w1_page_net_stat.on_pre_show = function(top)
	local cwnd = w1_page_net_stat.wnd;
	poe_net_num = global_val.get_poenum()
	local change_xywh = function (top,wnd_id,pos)
		b_wnd_ex.move_ex(top,wnd_id,pos,false)
	end
	if poe_net_num==4 then
		local change_id = {cwnd.internet_img.id,cwnd.intogate_line.id,cwnd.gateway_img.id,cwnd.gatetowan_line.id,cwnd.wan.id,
		cwnd.net_line.id,cwnd.cap_connect.id,cwnd.connect_line.id,cwnd.cap_disconnect.id,cwnd.disconnect_line.id,cwnd.err_line.id,
		cwnd.cap_err.id,cwnd.connecting_line.id,cwnd.cap_connecting.id,cwnd.poe_tip.id,cwnd.ip_conflict.id}
		local change_pos = {SIZE('s4_net_internet_img_xywh'),SIZE('s4_intogate_line_xywh'),SIZE('s4_net_gateway_img_xywh'),SIZE('s4_gatetowan_line_xywh'),
		SIZE('s4_net_wan_xywh'),SIZE('s4_net_line_img_xywh'),SIZE('cap4_connet_hline_xywh'),SIZE('s4_connet_hline_xywh'),SIZE('cap4_disconnet_hline_xywh'),
		SIZE('s4_disconnet_hline_xywh'),SIZE('s4_err_hline_xywh'),SIZE('cap4_err_hline_xywh'),SIZE('s4_conneting_hline_xywh'),SIZE('cap4_conneting_hline_xywh'),
		SIZE('s4_net_poe_tip_xywh'),SIZE('s4_net_ip_conflict_xywh'),SIZE(''),SIZE(''),}
		for i=1,#change_id do
			change_xywh(top,change_id[i],change_pos[i])
		end
	end
	return 0;
end

w1_page_net_stat.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'net_line','internet_img','gateway_img','wan','cam1','cam2','cam3',
			'cam4','cam5','cam6','cam7','cam8','cam9','cam10','cam11','cam12','cam13','cam14',
			'cam15','cam16','connect_line','disconnect_line','err_line','connecting_line','cap_disconnect',
			'cap_connect','cap_err','cap_connecting','wan_boder','intogate_line','gatetowan_line',
			'dev1','dev2','dev3','dev4','dev5','dev6','dev7','dev8','net_line2','dev9',
			'dev10','dev11','dev12','dev13','dev14','dev15','dev16','poe_tip',
			'err1','err2','err3','err4','err5','err6','err7','err8','err9','err10','err11','err12',
			'err13','err14','err15','err16','ip_conflict'},
	
	
	--cap_enable 	= {t='static',id=id+1,xywh='s_cfg_page_1_1',text='LA_ENABLE'},
	
	net_line = {t='net_line',id=id+2,xywh='s_net_line_img_xywh'},
	internet_img 	= {t='button',id=id+3,	xywh='s_net_internet_img_xywh',text='LA_INTERNET',arrangement=2,
						imgs = {b_ui.ALIGN.LEFT,'i_poe_internet','i_poe_internet', 'i_poe_internet'},	
						color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
						color_f= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'}},
	gateway_img 	= {t='button',id=id+4,	xywh='s_net_gateway_img_xywh',arrangement=2,text='LA_ROUTER',
						imgs = {b_ui.ALIGN.LEFT,'i_poe_gateway','i_poe_gateway', 'i_poe_gateway'},	
						color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},	
						color_f= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},},
						
	wan = {t='button',id=id+5,xywh='s_net_wan_xywh',arrangement=101,text='WAN',trans=false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},font ='f_wan',
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_wan_on','i_poe_wan_off','i_poe_wan_on'}, },
			
	cam1 = {t='button',id=id+6,xywh='s_net_lan_xywh',arrangement=101,text='1',trans=false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},font='f_wan',
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_lan_on','i_poe_lan_off','i_poe_lan_on'}, },
	cam2 = {t='button',id=id+7,xywh='s_net_lan_xywh',arrangement=101,text='2',trans=false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},font='f_wan',
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_lan_on','i_poe_lan_off','i_poe_lan_on'}, },
	cam3 = {t='button',id=id+8,xywh='s_net_lan_xywh',arrangement=101,text='3',trans=false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},font='f_wan',
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_lan_on','i_poe_lan_off','i_poe_lan_on'}, },
	cam4 = {t='button',id=id+9,xywh='s_net_lan_xywh',arrangement=101,text='4',trans=false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},font='f_wan',
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_lan_on','i_poe_lan_off','i_poe_lan_on'}, },
	cam5 = {t='button',id=id+10,xywh='s_net_lan_xywh',arrangement=101,text='5',trans=false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},font='f_wan',
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_lan_on','i_poe_lan_off','i_poe_lan_on'}, },
	cam6 = {t='button',id=id+11,xywh='s_net_lan_xywh',arrangement=101,text='6',trans=false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},font='f_wan',
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_lan_on','i_poe_lan_off','i_poe_lan_on'}, },
	cam7 = {t='button',id=id+12,xywh='s_net_lan_xywh',arrangement=101,text='7',trans=false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},font='f_wan',
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_lan_on','i_poe_lan_off','i_poe_lan_on'}, },
	cam8 = {t='button',id=id+13,xywh='s_net_lan_xywh',arrangement=101,text='8',trans=false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},font='f_wan',
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_lan_on','i_poe_lan_off','i_poe_lan_on'}, },
	cam9 = {t='button',id=id+14,xywh='s_net_lan_xywh',arrangement=101,text='9',trans=false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},font='f_wan',
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_lan_on','i_poe_lan_off','i_poe_lan_off'}, },
	cam10 = {t='button',id=id+15,xywh='s_net_lan_xywh',arrangement=101,text='10',trans=false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},font='f_wan',
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_lan_on','i_poe_lan_off','i_poe_lan_off'}, },
	cam11 = {t='button',id=id+16,xywh='s_net_lan_xywh',arrangement=101,text='11',trans=false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},font='f_wan',
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_lan_on','i_poe_lan_off','i_poe_lan_off'}, },
	cam12 = {t='button',id=id+17,xywh='s_net_lan_xywh',arrangement=101,text='12',trans=false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},font='f_wan',
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_lan_on','i_poe_lan_off','i_poe_lan_off'}, },
	cam13 = {t='button',id=id+18,xywh='s_net_lan_xywh',arrangement=101,text='13',trans=false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},font='f_wan',
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_lan_on','i_poe_lan_off','i_poe_lan_off'}, },
	cam14 = {t='button',id=id+19,xywh='s_net_lan_xywh',arrangement=101,text='14',trans=false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},font='f_wan',
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_lan_on','i_poe_lan_off','i_poe_lan_off'}, },
	cam15 = {t='button',id=id+20,xywh='s_net_lan_xywh',arrangement=101,text='15',trans=false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},font='f_wan',
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_lan_on','i_poe_lan_off','i_poe_lan_off'}, },
	cam16 = {t='button',id=id+21,xywh='s_net_lan_xywh',arrangement=101,text='16',trans=false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},font='f_wan',
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_cfg_page_bk'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_lan_on','i_poe_lan_off','i_poe_lan_off'}, },
	
	wan_boder = {t='button',id=id+30,xywh='s_net_wan_boder_xywh',arrangement = 2,
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_wan_boder','i_poe_wan_boder','i_poe_wan_boder'}},
	
	dev1 = {t='button',id=id+31,xywh='s_net_dev1_xywh',arrangement = 3,text='2.2W',trans= false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_device_on','i_poe_device_off','i_poe_device_on'}, },
	dev2 = {t='button',id=id+32,xywh='s_net_dev1_xywh',arrangement = 3,text='0W',trans= false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_device_on','i_poe_device_off','i_poe_device_on'}, },
	dev3 = {t='button',id=id+33,xywh='s_net_dev1_xywh',arrangement = 3,text='0W',trans= false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_device_on','i_poe_device_off','i_poe_device_on'}, },
	dev4 = {t='button',id=id+34,xywh='s_net_dev1_xywh',arrangement = 3,text='0W',trans= false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_device_on','i_poe_device_off','i_poe_device_on'}, },
	dev5 = {t='button',id=id+35,xywh='s_net_dev1_xywh',arrangement = 3,text='0W',trans= false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_device_on','i_poe_device_off','i_poe_device_on'}, },
	dev6 = {t='button',id=id+36,xywh='s_net_dev1_xywh',arrangement = 3,text='0W',trans= false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_device_on','i_poe_device_off','i_poe_device_on'}, },
	dev7 = {t='button',id=id+37,xywh='s_net_dev1_xywh',arrangement = 3,text='0W',trans= false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_device_on','i_poe_device_off','i_poe_device_on'}, },
	dev8 = {t='button',id=id+38,xywh='s_net_dev1_xywh',arrangement = 3,text='0W',trans= false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_device_on','i_poe_device_off','i_poe_device_on'}, },
	dev9 = {t='button',id=id+39,xywh='s_net_dev2_xywh',arrangement = 2,text='2.2W',trans= false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_device_on','i_poe_device_off','i_poe_device_off'}, },
	dev10 = {t='button',id=id+40,xywh='s_net_dev2_xywh',arrangement = 2,text='0W',trans= false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_device_on','i_poe_device_off','i_poe_device_off'}, },
	dev11 = {t='button',id=id+41,xywh='s_net_dev2_xywh',arrangement = 2,text='0W',trans= false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_device_on','i_poe_device_off','i_poe_device_off'}, },
	dev12 = {t='button',id=id+42,xywh='s_net_dev2_xywh',arrangement = 2,text='0W',trans= false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_device_on','i_poe_device_off','i_poe_device_off'}, },
	dev13 = {t='button',id=id+43,xywh='s_net_dev2_xywh',arrangement = 2,text='0W',trans= false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_device_on','i_poe_device_off','i_poe_device_off'}, },
	dev14 = {t='button',id=id+44,xywh='s_net_dev2_xywh',arrangement = 2,text='0W',trans= false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_device_on','i_poe_device_off','i_poe_device_off'}, },
	dev15 = {t='button',id=id+45,xywh='s_net_dev2_xywh',arrangement = 2,text='0W',trans= false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_device_on','i_poe_device_off','i_poe_device_off'}, },
	dev16 = {t='button',id=id+46,xywh='s_net_dev2_xywh',arrangement = 2,text='0W',trans= false,
			color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			color_d= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_devm_text_n'},
			 imgs = {b_ui.ALIGN.LEFT,'i_poe_device_on','i_poe_device_off','i_poe_device_off'}, },		
	
	intogate_line	= {t='hline',	id=id+47,	xywh='s_intogate_line_xywh',
			color = {'c_apply_ok', 'c_apply_ok', 'c_apply_ok'},},
	
	gatetowan_line	= {t='hline',	id=id+48,	xywh='s_gatetowan_line_xywh',
			color = {'c_apply_ok', 'c_apply_ok', 'c_apply_ok'},},
	
	net_line2 = {t='net_line',id=id+49,xywh='s_net_line2_img_xywh'},
	
	poe_tip	= {t='static',id=id+50,xywh='s_net_poe_tip_xywh',text='LA_POE_POWER_TIP'},

	err1 = {t='tt_button',id=id+51,xywh='s_net_poe_err_xywh',arrangement = 100,
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade6','it_close','it_close', 'it_close'},font='3',
			color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},},	
	err2 = {t='tt_button',id=id+52,xywh='s_net_poe_err_xywh',arrangement = 100,
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade6','it_close','it_close', 'it_close'}
			,font='3',
			color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},},
	err3 = {t='tt_button',id=id+53,xywh='s_net_poe_err_xywh',arrangement = 100,
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade6','it_close','it_close', 'it_close'}
			,font='3',
			color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},},
	err4 = {t='tt_button',id=id+54,xywh='s_net_poe_err_xywh',arrangement = 100,
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade6','it_close','it_close', 'it_close'}
			,font='3',
			color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},},
	err5 = {t='tt_button',id=id+55,xywh='s_net_poe_err_xywh',arrangement = 100,
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade6','it_close','it_close', 'it_close'}
			,font='3',
			color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},},	
	err6 = {t='tt_button',id=id+56,xywh='s_net_poe_err_xywh',arrangement = 100,
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade6','it_close','it_close', 'it_close'}
			,font='3',
			color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},},
	err7 = {t='tt_button',id=id+57,xywh='s_net_poe_err_xywh',arrangement = 100,
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade6','it_close','it_close', 'it_close'}
			,font='3',
			color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},},
	err8 = {t='tt_button',id=id+58,xywh='s_net_poe_err_xywh',arrangement = 100,
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade6','it_close','it_close', 'it_close'}
			,font='3',
			color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},},
	err9 = {t='tt_button',id=id+59,xywh='s_net_poe_err_xywh',arrangement = 100,
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade6','it_close','it_close', 'it_close'}
			,font='3',
			color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},},	
	err10= {t='tt_button',id=id+60,xywh='s_net_poe_err_xywh',arrangement = 100,
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade6','it_close','it_close', 'it_close'}
			,font='3',
			color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},},
	err11= {t='tt_button',id=id+61,xywh='s_net_poe_err_xywh',arrangement = 100,
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade6','it_close','it_close', 'it_close'}
			,font='3',
			color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},},
	err12= {t='tt_button',id=id+62,xywh='s_net_poe_err_xywh',arrangement = 100,
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade6','it_close','it_close', 'it_close'}
			,font='3',
			color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},},
	err13= {t='tt_button',id=id+63,xywh='s_net_poe_err_xywh',arrangement = 100,
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade6','it_close','it_close', 'it_close'}
			,font='3',
			color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},},	
	err14= {t='tt_button',id=id+64,xywh='s_net_poe_err_xywh',arrangement = 100,
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade6','it_close','it_close', 'it_close'}
			,font='3',
			color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},},
	err15= {t='tt_button',id=id+65,xywh='s_net_poe_err_xywh',arrangement = 100,
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade6','it_close','it_close', 'it_close'}
			,font='3',
			color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},},
	err16 = {t='tt_button',id=id+66,xywh='s_net_poe_err_xywh',arrangement = 100,
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade6','it_close','it_close', 'it_close'}
			,font='3',
			color= {'c_cfg_title_bk', 'c_cfg_title_bk','c_cfgclose_bk'},},
			
	ip_conflict = {t='tt_button',id=id+67,xywh='s_net_ip_conflict_xywh',
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade1','it_ipconflict','it_ipconflict', 'it_ipconflict'},font='f_grade4',
			arrangement = 2,text='LA_IP_CONFLICT',
			color= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfgclose_bk'},},
	
	connect_line	= {t='hline',	id=id+22,	xywh='s_connet_hline_xywh',
			color = {'c_apply_ok', 'c_apply_ok', 'c_apply_ok'},},
	cap_connect 	= {t='static',id=id+23,xywh='cap_connet_hline_xywh',text='LA_CONNECTED'},
	
	disconnect_line	= {t='hline',	id=id+24,	xywh='s_disconnet_hline_xywh',
			color = {'c_txt_d', 'c_txt_d', 'c_txt_d'},},
	cap_disconnect = {t='static',id=id+25,xywh='cap_disconnet_hline_xywh',text='LA_DISCONNECTED'},
	
	err_line	= {t='hline',	id=id+26,	xywh='s_err_hline_xywh',
			color = {'c_poe_powering', 'c_poe_powering', 'c_poe_powering'},},
	cap_err 	= {t='static',id=id+27,xywh='cap_err_hline_xywh',text='LA_POWERING'},
	
	connecting_line	= {t='dotted_line',	id=id+28,	xywh='s_conneting_hline_xywh',
			color = {'c_apply_ok', 'c_apply_ok', 'c_apply_ok'},},
	cap_connecting 	= {t='static',id=id+29,xywh='cap_conneting_hline_xywh',text='LA_CONNECTING_T'},
		
}

return w1_page_net_stat