--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_osd.osd_id
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local w1_legal 	= require("wnd.w1_util.w1_legal")
local util 		= require("wnd.core.util")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str

local w1_page_osd = 
{
	old_chid,
	data,
	timestart = false,
	copy_ch = {},
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_osd.s_768 =
{
	s_cfg_osd_image_xywh = {70,22,352,256},
	s_osd_cap_channel_xywh = {436,35,85,35},
	s_osd_t_channel_xywh = {586,39,131,28},
	s_osd_cap_time_xywh = {436,78,85,35},
	s_osd_t_time_xywh = {543,85,25,21},
	s_osd_cap_name_xywh = {436,120,85,35},
	s_osd_t_name_xywh = {543,128,25,21},
	s_osd_cap_chname_xywh = {436,163,85,35},
	s_osd_t_chname_xywh = {586,124,131,28},
	s_osd_tipinfo_xywh = {70,312,373,35},
};

w1_page_osd.s_1280 = 
{
	s_cfg_osd_image_xywh = {92,32,640,360},
	s_osd_cap_channel_xywh = {750,50,110,50},
	s_osd_t_channel_xywh = {860,55,100,40},
	s_osd_cap_time_xywh = {750,110,110,50},
	s_osd_t_time_xywh = {860,120,48,30},
	s_osd_cap_name_xywh = {750,170,110,50},
	s_osd_t_name_xywh = {860,180,48,30},
	s_osd_cap_chname_xywh = {750,230,110,50},
	s_osd_t_chname_xywh = {860,230,100,40},
	s_osd_tipinfo_xywh = {92,600,700,50},
	
	s_osd_cap_channel_1_xywh = {102,405,160,50},
	s_osd_t_channel_1_xywh = {380,410,200,40},
	s_osd_cap_time_1_xywh= {102,455,160,42},
	s_osd_t_time_1_xywh= {302,460,48,30},
	s_osd_cap_name_1_xywh= {102,510,160,42},
	s_osd_t_name_1_xywh= {302,516,48,30},
	s_osd_t_chname_1_xywh = {380,514,200,40},
	
};

w1_page_osd.s_1440 = 
{
	s_cfg_osd_image_xywh = {100,32,640,360},
	s_osd_cap_channel_xywh = {750,50,140,50},
	s_osd_t_channel_xywh = {890,55,140,40},
	s_osd_cap_time_xywh = {750,110,140,50},
	s_osd_t_time_xywh = {890,120,48,30},
	s_osd_cap_name_xywh = {750,170,140,50},
	s_osd_t_name_xywh = {890,180,48,30},
	s_osd_cap_chname_xywh = {750,230,140,50},
	s_osd_t_chname_xywh = {890,230,140,40},
	s_osd_tipinfo_xywh = {100,600,700,50},
	
	s_osd_cap_channel_1_xywh = {102,405,160,50},
	s_osd_t_channel_1_xywh = {380,410,200,40},
	s_osd_cap_time_1_xywh= {102,455,160,42},
	s_osd_t_time_1_xywh= {302,460,48,30},
	s_osd_cap_name_1_xywh= {102,510,160,42},
	s_osd_t_name_1_xywh= {302,516,48,30},
	s_osd_t_chname_1_xywh = {380,514,200,40},
	
};

w1_page_osd.s_1080p = 
{
	s_cfg_osd_image_xywh = {98,32,640,360},
	s_osd_cap_channel_xywh = {800,50,160,50},
	s_osd_t_channel_xywh = {1080,55,246,40},
	s_osd_cap_time_xywh = {800,110,160,50},
	s_osd_t_time_xywh = {1000,120,48,30},
	s_osd_cap_name_xywh = {800,170,160,50},
	s_osd_t_name_xywh = {1000,180,48,30},
	s_osd_cap_chname_xywh = {800,230,160,50},
	s_osd_t_chname_xywh = {1080,175,246,40},
	s_osd_tipinfo_xywh = {98,440,700,50},

};
w1_page_osd.s_2k = 
{
	s_cfg_osd_image_xywh = {136,43,856,480},
	s_osd_cap_channel_xywh = {1066,67,213,67},
	s_osd_t_channel_xywh = {1440,73,328,53},
	s_osd_cap_time_xywh = {1066,147,213,67},
	s_osd_t_time_xywh = {1333,160,64,40},
	s_osd_cap_name_xywh = {1066,227,213,67},
	s_osd_t_name_xywh = {1333,240,64,40},
	s_osd_cap_chname_xywh = {1066,307,213,67},
	s_osd_t_chname_xywh = {1440,235,328,53},
	s_osd_tipinfo_xywh = {133,587,933,67},

};
w1_page_osd.s_4k = 
{
	s_cfg_osd_image_xywh = {200,64,1284,720},
	s_osd_cap_channel_xywh = {1600,100,320,100},
	s_osd_t_channel_xywh = {2170,110,492,80},
	s_osd_cap_time_xywh = {1600,220,320,100},
	s_osd_t_time_xywh = {2000,240,96,60},
	s_osd_cap_name_xywh = {1600,340,320,100},
	s_osd_t_name_xywh = {2000,360,96,60},
	s_osd_cap_chname_xywh = {1600,460,320,100},
	s_osd_t_chname_xywh = {2170,350,492,80},
	s_osd_tipinfo_xywh = {200,880,1400,100},
};

local channel_num;--豸ͨĿ

w1_page_osd.clear_data = function()
	w1_page_osd.data = nil;
	w1_page_osd.copy_ch = nil;
end	

local sethide =function(top, bool_hide, redraw)
	local cwnd = w1_page_osd.wnd;
	local sid = cwnd.cap_time.id;
	local eid = cwnd.t_chname.id;
	
	for i=sid, eid do
		b_wnd_ex.set_hide(top, i, bool_hide, redraw)
	end
	b_wnd_ex.set_osdhidetime(top, cwnd.image.id, bool_hide, redraw);
	b_wnd_ex.set_osdhidename(top, cwnd.image.id, bool_hide, redraw);
end

local set_custom_layout = function(chid)
	local param = {
		chn_id = chid,
		wnd_id = 1,
	}
	local layoutpos = w1_page_osd.layoutpos;
	param.x = layoutpos.x;
	param.y = layoutpos.y;
	param.cx = layoutpos.cx;
	param.cy = layoutpos.cy;
	b_app_api.set_custom_layout_wnd(param)
end

local refresh_chdata = function(top, chid, redraw)
	local cwnd = w1_page_osd.wnd
	local data = w1_page_osd.data.osd['channel'..chid]
	
	set_custom_layout(chid);
		local osdarea = {}
		osdarea.time = {};
		osdarea.time.enable = data.time.open;
		osdarea.time.x = data.time.x;
		osdarea.time.y = data.time.y;
		osdarea.name = {};
		osdarea.name.enable = data.name.open;
		osdarea.name.x = data.name.x;
		osdarea.name.y = data.name.y;
		b_wnd_ex.set_osdarea(top, cwnd.image.id,osdarea,false);
	b_wnd_ex.set_check(top, cwnd.t_time.id, data.time.open, false)
	b_wnd_ex.set_check(top, cwnd.t_name.id, data.name.open, false)
	
	if(data.time.open) then
		b_wnd_ex.set_osdhidetime(top, cwnd.image.id, false, false);
	else
		b_wnd_ex.set_osdhidetime(top, cwnd.image.id, true, false);
	end
	if(data.name.open) then
		b_wnd_ex.set_osdhidename(top, cwnd.image.id, false, false);
	else
		b_wnd_ex.set_osdhidename(top, cwnd.image.id, true, false);
	end
	b_wnd_ex.set_text(top, cwnd.t_chname.id, data.name.customstr, false);
	if true == redraw then
		b_dlg.dlg_set_redraw(top)
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	w1_page_osd.data = cfgdata;
	
	local cwnd = w1_page_osd.wnd
	--local rtsp = w1_page_osd.data.camera_bind
	local camreaitems = {};
	local idx = 1;
	local privilege = global_val.get_allprivilege();--ȡȨ
	local ch_prilist = privilege.channel_manager_list;
	--local camera_num = rtsp.camera_num;
	for i=1, channel_num do
		if(cfgdata['osd']['channel'..i] ~= nil and ch_prilist[i] == 1) then
			camreaitems[idx] = i;
			idx = idx + 1;
		end
	end
	b_wnd_ex.set_items(top, cwnd.t_channel.id, camreaitems, false);
	
	
	if(idx ~= 1) then--˵ͨ
		local set_value = function(id, value)
			b_wnd_ex.set_value(top, id, value, false)
		end
		b_wnd_ex.set_disable(top, cwnd.t_channel.id, false, false)
		sethide(top, false, false);
		b_wnd_ex.set_sel(top, cwnd.t_channel.id, 0, false);--Ĭϵһ
		local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
		refresh_chdata(top, chid, false)
	else--ͨ
		b_wnd_ex.set_disable(top, cwnd.t_channel.id, true, false)
		sethide(top, true, false);
		for i=1, channel_num do
			if(ch_prilist[i] ~= 0) then
				set_custom_layout(i);
				break;
			end
		end	
	end
	
	local dlg_w = global_val.get_size();
	if(dlg_w == 1280 or dlg_w == 1440) then
		local pos = SIZE('s_osd_cap_channel_1_xywh');
		b_wnd_ex.move_ex(top, cwnd.cap_channel.id, pos, false);
		pos = SIZE('s_osd_t_channel_1_xywh');
		b_wnd_ex.move_ex(top, cwnd.t_channel.id, pos, false);
		pos = SIZE('s_osd_cap_time_1_xywh');
		b_wnd_ex.move_ex(top, cwnd.cap_time.id, pos, false);
		pos = SIZE('s_osd_t_time_1_xywh');
		b_wnd_ex.move_ex(top, cwnd.t_time.id, pos, false);
		pos = SIZE('s_osd_cap_name_1_xywh');
		b_wnd_ex.move_ex(top, cwnd.cap_name.id, pos, false);
		pos = SIZE('s_osd_t_name_1_xywh');
		b_wnd_ex.move_ex(top, cwnd.t_name.id, pos, false);
		pos = SIZE('s_osd_t_chname_1_xywh');
		b_wnd_ex.move_ex(top, cwnd.t_chname.id, pos, false);
		
	end
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_osd.wnd
	local osdarea  = b_wnd_ex.get_osdarea(top, cwnd.image.id)
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	if(chid == nil) then
		return 0;
	end
	local data = cfgdata['osd']['channel'..chid]
	
	data.time.type = 1
	data.time.x = osdarea.time.x;
	data.time.y = osdarea.time.y;
	data.time.open = b_wnd_ex.get_check(top, cwnd.t_time.id);
	data.time.token = "time"
	
	data.name.type = 2
	data.name.x = osdarea.name.x;
	data.name.y = osdarea.name.y;
	data.name.open = b_wnd_ex.get_check(top, cwnd.t_name.id)
	data.name.token = b_wnd_ex.get_text(top, cwnd.t_chname.id);
	data.name.customstr = b_wnd_ex.get_text(top, cwnd.t_chname.id);
	data.change_flag = true;
	return 0
end


--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	local cwnd = w1_page_osd.wnd
	if(w1_legal.is_empty(top, cwnd.t_chname.id)) then
		w1_wnd_util.setparamerr_str(STR('LA_NOT_EMPTY'));
		legalflag =false
		table.insert(nlegalid, cwnd.t_chname.id)
	else
		local chname = tostring(b_wnd_ex.get_text(top, cwnd.t_chname.id));
		local ch = string.gsub(chname, "^%s*(.-)%s*$", "%1")
		if ch == nil or ch == ''then
			legalflag = false
			table.insert(nlegalid, cwnd.t_chname.id)
		end
	end
	
	if(legalflag) then
		return legalflag, nil
	else
		return legalflag, nlegalid
	end
end

w1_page_osd.timer_start = function()
	w1_page_osd.timestart = true
end

w1_page_osd.timer_stop = function(top)
	w1_page_osd.timestart = false
	w1_wnd_util.tipclear(top, w1_page_osd.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
	w1_wnd_util.tipdispoff();
end

w1_page_osd.timerenevt = function(top)
	if(w1_page_osd.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_osd.wnd.tipinfo.id)
	end
	return 0
end

w1_page_osd.init = function(top)
	w1_wnd_util.cfgtab = {'osd'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	
	local chidstr = b_wnd_ex.get_text(top, w1_page_osd.wnd.t_channel.id);
	if(chidstr == '') then
		return 0
	end
	local chid =tonumber(chidstr);
	w1_page_osd.old_chid = chid;
	return 0
end

local on_channel= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local chid = tonumber(b_wnd_ex.get_text(top, w1_page_osd.wnd.t_channel.id));
		if(w1_page_osd.old_chid ~= chid) then
			refresh_chdata(top, chid, true)
			w1_page_osd.old_chid = chid;
		end
	end
	return 0;
end

local on_time = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local check = b_wnd_ex.get_check(top, win_id);
		if(check) then
			b_wnd_ex.set_osdhidetime(top, w1_page_osd.wnd.image.id, false, true);
		else
			b_wnd_ex.set_osdhidetime(top, w1_page_osd.wnd.image.id, true, true);
		end
		
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_name = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local check = b_wnd_ex.get_check(top, win_id);
		if(check) then
			b_wnd_ex.set_osdhidename(top, w1_page_osd.wnd.image.id, false, true);
		else
			b_wnd_ex.set_osdhidename(top, w1_page_osd.wnd.image.id, true, true);
		end	
		
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local copy_okfunc = function(param)
	local cwnd = w1_page_osd.wnd;
	local chid = tonumber(b_wnd_ex.get_text(param[1], cwnd.t_channel.id));
	if(chid == nil) then
		return 0;
	end
	local chsrc = w1_page_osd.data.osd['channel'..chid];
	local chdir = w1_page_osd.data.osd;
	
	for i=1, #param[2] do
		local customstr = chdir['channel'..param[2][i]].name.customstr
		if(chdir['channel'..param[2][i]] == nil) then
			chdir['channel'..param[2][i]] = util.copy_tab(chsrc)
		else
			util.copy_tab_b(chdir['channel'..param[2][i]], chsrc)
		end		
		chdir['channel'..param[2][i]].change_flag = true;
		chdir['channel'..param[2][i]].channel_id = param[2][i];
		chdir['channel'..param[2][i]].name.customstr = customstr;
	end
	return 0;
end

local on_copy = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_osd.wnd;
		local param = {};
		local idx = 1;
		local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	--	uitousercfg(top, w1_page_osd.data)
		
		local privilege = global_val.get_allprivilege();--ȡȨ
		local ch_prilist = privilege.channel_manager_list;	
		for i=1, channel_num do
			if( i ~= chid and w1_page_osd.data.osd['channel'..i] ~= nil and ch_prilist[i] == 1) then
				param[idx] = i;
				idx =idx + 1;
			end
		end
		w1_copy.init();
		w1_copy.set_dlgattr(param);
		w1_copy.set_func (copy_okfunc,{top, w1_page_osd.copy_ch} );
		b_dlg.post_modal(top, w1_key.DLG_COPY, 0, 0, nil)
	end
	return 0
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_update_param = function(top, id, vmsg, x, y)
	if (vmsg == b_ui.WM_USER_UPDATE_PARAM) then
		uitousercfg(top,b_app_cfg.user_cfg);
	elseif (vmsg == b_ui.RBUTTONCLK) then
		return vmsg;
	end
	return 0;
end


local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_osd.apply =function(top)
	local ret = nil; 
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()
	end
	
	return ret
end

w1_page_osd.on_pre_show = function(top)
	channel_num = global_val.get_channelnum();
	
	local cwnd = w1_page_osd.wnd;
	local param = {
		x = SIZE('s_cfg_osd_image_xywh')[1] + SIZE('s_cfg_page_xywh')[1], 
		y = SIZE('s_cfg_osd_image_xywh')[2] + SIZE('s_cfg_page_xywh')[2],
		cx = SIZE('s_cfg_osd_image_xywh')[3],
		cy = SIZE('s_cfg_osd_image_xywh')[4],
	}
	local oldparam_x = param.x;
	param.x = math.floor((param.x + 2) / 4) * 4;--֤4ı
	param.cx = math.floor((param.cx + 2) / 4) *4;
	local oldparam_y = param.y;
	param.y = math.floor((param.y + 2) / 4) * 4;
	param.cy = math.floor((param.cy + 2) / 4) *4;
	
	w1_page_osd.layoutpos.x = param.x;
	w1_page_osd.layoutpos.cx = param.cx;
	w1_page_osd.layoutpos.y = param.y;
	w1_page_osd.layoutpos.cy = param.cy;
	
	local pos = {};
	pos[1] = SIZE('s_cfg_osd_image_xywh')[1] + param.x - oldparam_x;
	pos[2] = SIZE('s_cfg_osd_image_xywh')[2] + param.y - oldparam_y;
	pos[3] = param.cx;
	pos[4] = param.cy;
	b_wnd_ex.move_ex(top, cwnd.image.id, pos, false);
end

w1_page_osd.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {	'image', 
			'cap_channel', 't_channel','cap_time', 't_time',
			'cap_name', 't_name','cap_chname', 't_chname',
			'tipinfo', 'copy', 'default', 'apply'},
			
	image = {t='osdarea',id=id+1,xywh='s_cfg_osd_image_xywh',text='Image widget', 
				font = 'f_grade1', trans = false,
				color = {'c_imgae_param_bg', 'c_imgae_param_bg','c_imgae_param_bg'},cmd = on_update_param
				},
	
	cap_channel	= {t='static',	id=id+2,	xywh='s_osd_cap_channel_xywh',		text='LA_CHANNEL'},
	t_channel 	= {t='combox',	id=id+3,	xywh='s_osd_t_channel_xywh',		items={'1','2','3','4','5','6','7','8'},trans = false,channel_cbox = true,cmd = on_channel},	

	cap_time	= {t='static',	id=id+4,	xywh='s_osd_cap_time_xywh',		text='LA_TIME'},
	t_time		= {t='tt_check',id=id+5,	xywh='s_osd_t_time_xywh', 		
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_time},
	
	cap_name	= {t='static',	id=id+6,	xywh='s_osd_cap_name_xywh',		text='LA_CHANNEL_NAME'},
	t_name		= {t='tt_check',id=id+7,	xywh='s_osd_t_name_xywh', 
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_name},
	
--	cap_chname	= {t='static',	id=id+8,	xywh='s_osd_cap_chname_xywh',		text='Channel name',trans = false},
	t_chname	= {t='edit',	id=id+9,	xywh='s_osd_t_chname_xywh',  	text='',trans = false, guide_text='channel01',guide_trans=false,cmd = on_update_param},

	tipinfo		= {t='static',	id=id+10,	xywh='s_osd_tipinfo_xywh',		text='',		trans = false},	

	copy 		= {t='button',	id=id+11,	xywh = 's_cfg_copy_xywh',	text='LA_COPY_TO',cmd=on_copy},
	apply 		= {t='button',	id=id+13,	xywh= 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_osd

