--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_humanthermometer.param_conf_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local b_app_api = require("wnd.core.command.b_app_api")
local w1_row_param_conf	= require("wnd.w1_cfg.w1_row_param_confrow")
local w1_page_param_confface_detect = require("wnd.w1_cfg.w1_page_param_confface_detect")
local w1_page_param_conftemp_param = require("wnd.w1_cfg.w1_page_param_conftemp_param")
local w1_page_param_conf_levent = require("wnd.w1_cfg.w1_page_param_conf_levent")
local w1_page_param_conf_nevent = require("wnd.w1_cfg.w1_page_param_conf_nevent")
local w1_page_param_conf_hevent = require("wnd.w1_cfg.w1_page_param_conf_hevent")
local w1_page_param_conftimeplan = require("wnd.w1_cfg.w1_page_param_conftimeplan")

local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local util 		= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local r_color		= require("wnd.core.r_res.r_color")
local COLOR 		= r_color.get_color
local w1_msgbox = require("wnd.w1_util.w1_msgbox")

local w1_page_param_conf = 
{
	channel = 0,
	old_sel = 0,
	data,
	timestart = false,
	copy_ch = {},
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_param_conf.s_768 =
{
	s_cfg_param_conf_image_xywh = {70,10,352,256},
	s_param_conf_clear_xywh = {426,234,64,28},
	s_param_conf_tipinfo_xywh = {70,611,213,35},
};

w1_page_param_conf.s_1280 = 
{
	s_cfg_param_conf_image_xywh = {92,12,512,360},
	s_param_conf_clear_xywh		= {632,332,120,40},
	s_param_conf_tipinfo_xywh = {92,805,300,50},
}

w1_page_param_conf.s_1440 = 
{
	s_cfg_param_conf_image_xywh = {100,12,512,250},
	s_param_conf_clear_xywh		= {632,222,120,40},
	s_param_conf_tipinfo_xywh = {110,705,300,45},
}

w1_page_param_conf.s_1080p = 
{
	s_cfg_param_conf_image_xywh = {98,12,640,360},
	s_param_conf_clear_xywh		= {760,332,120,40},
	s_param_conf_tipinfo_xywh = {98,860,400,50},
}

w1_page_param_conf.s_2k = 
{
	s_cfg_param_conf_image_xywh = {136,16,856,480},
	s_param_conf_clear_xywh		= {1013,443,160,53},
	s_param_conf_tipinfo_xywh = {147,1147,533,67},
}

w1_page_param_conf.s_4k = 
{
	s_cfg_param_conf_image_xywh = {200,24,1284,720},
	s_param_conf_clear_xywh		= {1520,664,240,80},
	s_param_conf_tipinfo_xywh = {220,1720,800,100},
}

local channel_num;--豸ͨĿ

w1_page_param_conf.clear_data = function()
	w1_page_param_conf.data = nil;
	w1_page_param_conf.copy_ch = nil;
end	

local set_custom_layout = function(chid)
	local param = {
		chn_id = chid,
		wnd_id = 1,
	}
	local layoutpos = w1_page_param_conf.layoutpos;
	param.x = layoutpos.x;
	param.y = layoutpos.y;
	param.cx = layoutpos.cx;
	param.cy = layoutpos.cy;
	param.stream = true;			--
	b_app_api.set_custom_layout_wnd(param)
end

local refresh_chdata = function(top, chid, redraw)
	local c_wnd = w1_page_param_conf.wnd
	local channeldata = w1_page_param_conf.data.human_param['channel'..chid]
	set_custom_layout(chid);
	local intarea = {};
	intarea['area'..1] = {};
	intarea['area'..1].points = {};
	local areaid = w1_page_param_conf.data.human_param['channel'..chid].areaid+1;
	intarea['area'..1].point_num = w1_page_param_conf.data.human_param['channel'..chid].area.region_list['region'..areaid].point_num 
	for j = 1,  intarea['area'..1].point_num do
		intarea['area'..1].points['point'..j]= {};
		intarea['area'..1].points['point'..j].x = w1_page_param_conf.data.human_param['channel'..chid].area.region_list['region'..areaid].points['point'..j].x
		intarea['area'..1].points['point'..j].y = w1_page_param_conf.data.human_param['channel'..chid].area.region_list['region'..areaid].points['point'..j].y
	end
	if intarea['area'..1].point_num ~= nil and intarea['area'..1].point_num ~= 0 then
		b_wnd_ex.set_intarea(top,c_wnd.image.id,intarea,false);
	end	
	local ro_num = w1_page_param_conf.data.device_info['ro_num']
	local buzz_support = w1_page_param_conf.data.device_info['buzzer_support']
	local checkidx = w1_row_param_conf.get_checkidx(top);
	if(checkidx == 0) then
		w1_page_param_conf_levent.setstatus(top, channeldata, chid, ro_num, buzz_support, false)
		w1_page_param_conf_nevent.setstatus(top, channeldata, chid, ro_num, buzz_support, false)
		w1_page_param_conf_hevent.setstatus(top, channeldata, chid, ro_num, buzz_support, false)
		w1_page_param_confface_detect.set_param(top,channeldata,true);
		w1_page_param_conftemp_param.set_param(top, channeldata, false)
		w1_page_param_conftimeplan.settimeplan(top, channeldata, false);
	elseif (checkidx == 1) then
		w1_page_param_conf_levent.setstatus(top, channeldata, chid, ro_num, buzz_support, false)
		w1_page_param_conf_nevent.setstatus(top, channeldata, chid, ro_num, buzz_support, false)
		w1_page_param_conf_hevent.setstatus(top, channeldata, chid, ro_num, buzz_support, false)
		w1_page_param_confface_detect.set_param(top,channeldata,false);
		w1_page_param_conftemp_param.set_param(top, channeldata, true)
		w1_page_param_conftimeplan.settimeplan(top, channeldata, false);
	elseif (checkidx == 2) then
		w1_page_param_conf_levent.setstatus(top, channeldata, chid, ro_num, buzz_support, true)
		w1_page_param_conf_nevent.setstatus(top, channeldata, chid, ro_num, buzz_support, false)
		w1_page_param_conf_hevent.setstatus(top, channeldata, chid, ro_num, buzz_support, false)
		w1_page_param_confface_detect.set_param(top,channeldata,false);
		w1_page_param_conftemp_param.set_param(top, channeldata, false)
		w1_page_param_conftimeplan.settimeplan(top, channeldata, false);
	elseif (checkidx == 3) then
		w1_page_param_conf_levent.setstatus(top, channeldata, chid, ro_num, buzz_support, false)
		w1_page_param_conf_nevent.setstatus(top, channeldata, chid, ro_num, buzz_support, true)
		w1_page_param_conf_hevent.setstatus(top, channeldata, chid, ro_num, buzz_support, false)
		w1_page_param_confface_detect.set_param(top,channeldata,false);
		w1_page_param_conftemp_param.set_param(top, channeldata, false)
		w1_page_param_conftimeplan.settimeplan(top, channeldata, false);
	elseif (checkidx == 4) then
		w1_page_param_conf_levent.setstatus(top, channeldata, chid, ro_num, buzz_support, false)
		w1_page_param_conf_nevent.setstatus(top, channeldata, chid, ro_num, buzz_support, false)
		w1_page_param_conf_hevent.setstatus(top, channeldata, chid, ro_num, buzz_support, true)
		w1_page_param_confface_detect.set_param(top,channeldata,false);
		w1_page_param_conftemp_param.set_param(top, channeldata, false)
		w1_page_param_conftimeplan.settimeplan(top, channeldata, false);
	else
		w1_page_param_conf_levent.setstatus(top, channeldata, chid, ro_num, buzz_support, false)
		w1_page_param_conf_nevent.setstatus(top, channeldata, chid, ro_num, buzz_support, false)
		w1_page_param_conf_hevent.setstatus(top, channeldata, chid, ro_num, buzz_support, false)
		w1_page_param_confface_detect.set_param(top,channeldata,false);
		w1_page_param_conftemp_param.set_param(top, channeldata, false)
		w1_page_param_conftimeplan.settimeplan(top, channeldata, true);
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)	
	assert(type(cfgdata) == 'table')
	w1_page_param_conf.data = cfgdata;

	local c_wnd = w1_page_param_conf.wnd
	local camreaitems = {};
	local idx = 1;
	local privilege = global_val.get_allprivilege();--ȡȨ
	local ch_prilist = privilege.channel_manager_list;
	w1_page_param_conf.old_sel = 0
	for i=1, channel_num do
		if(cfgdata['human_param']['channel'..i] ~= nil and ch_prilist[i] == 1) then
			camreaitems[idx] = i;
			if w1_page_param_conf.channel == i then
				w1_page_param_conf.old_sel = idx-1
			end
			idx = idx + 1;
		end
	end
	b_wnd_ex.set_text(top,c_wnd.tipinfo.id,'',false);	
	b_wnd_ex.set_items(top, c_wnd.t_channel.id, camreaitems, false);
	b_wnd_ex.clear_intarea(top,c_wnd.image.id,false,false);
	if(idx ~= 1) then--˵ͨ
		b_wnd_ex.set_enableselect(top,c_wnd.image.id,true,false);
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id, false, false)
		local img_cap = {};
		img_cap.Region_enable = true;
		img_cap.edgeNum = 16;
		img_cap.maxRegionNum = 1;
		b_wnd_ex.set_cap(top,c_wnd.image.id,img_cap,false);
		b_wnd_ex.set_sel(top, c_wnd.t_channel.id, w1_page_param_conf.old_sel, false);--Ĭһ
		
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		w1_page_param_conf.channel = chid
		b_wnd_ex.set_hide(top,c_wnd.clear.id,false,false);
		b_wnd_ex.set_hide(top, w1_id.cfg_humanthermometer.param_confrow_id, false, false)
		w1_page_param_confface_detect.sethide(top, false, false)
		w1_page_param_conftemp_param.sethide(top, false, false)
		w1_page_param_conf_levent.sethide(top, false, false)
		w1_page_param_conf_nevent.sethide(top, false, false)
		w1_page_param_conf_hevent.sethide(top, false, false)
		w1_page_param_conftimeplan.sethide(top, false, false)
		refresh_chdata(top, chid, false);
	else--ͨ
		b_wnd_ex.set_enableselect(top,c_wnd.image.id,false,false);
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id,true, false)
		b_wnd_ex.set_hide(top,c_wnd.clear.id,true,false);
		b_wnd_ex.set_hide(top, w1_id.cfg_humanthermometer.param_confrow_id, true, false)
		w1_page_param_confface_detect.sethide(top, true, false)
		w1_page_param_conftemp_param.sethide(top, true, false)
		w1_page_param_conf_levent.sethide(top, true, false)
		w1_page_param_conf_nevent.sethide(top, true, false)
		w1_page_param_conf_hevent.sethide(top, true, false)
		w1_page_param_conftimeplan.sethide(top, true, false)
		for i=1, channel_num do
			if(ch_prilist[i] ~= 0) then
				set_custom_layout(i);
				break;
			end
		end	
	end
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local c_wnd = w1_page_param_conf.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id))
	if(chid == nil) then
		return true, nil
	end
	if w1_page_param_conf.data.human_param['channel'..chid].face_enable == true then
		local area = w1_page_param_conf.data.human_param['channel'..chid].area
		for i = 1, 8 do
			if(area.region_list['region'..i].point_num ~= 0) then
				break;
			end
			if i == 8 then
				w1_wnd_util.setparamerr_str(STR('LA_DRAW_AREA'));
				return false,nil
			end
		end
	end
	local flag,errstr = w1_page_param_confface_detect.datacheck(top);
	if flag == false then
		w1_wnd_util.setparamerr_str(errstr);
		return false,nil
	end
	flag,errstr = w1_page_param_conftemp_param.datacheck(top);
	if flag == false then
		w1_wnd_util.setparamerr_str(errstr);
		return false,nil
	end
	
	return true, nil
end

w1_page_param_conf.timer_start = function()
	w1_page_param_conf.timestart = true
end

w1_page_param_conf.timer_stop = function(top)
	w1_page_param_conf.timestart = false
	w1_wnd_util.tipclear(top, w1_page_param_conf.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_param_conf.timerenevt = function(top)
	if(w1_page_param_conf.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_param_conf.wnd.tipinfo.id)
	end
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_param_conf.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id))
	if(chid == nil) then
		return 0
	end
	
	local intarea = b_wnd_ex.get_intarea(top,cwnd.image.id)
	local areaid = cfgdata.human_param['channel'..chid].areaid + 1
	local area = cfgdata.human_param['channel'..chid].area
	area.region_list['region'..areaid].point_num = 0;
	area.region_list['region'..areaid].points = {}
	if(nil ~= intarea['area'..1]) then
		for j = 1, 32 do
			if intarea['area'..1]['point'..j] ~= nil then
				area.region_list['region'..areaid].points['point'..j] = {}
				area.region_list['region'..areaid].points['point'..j].x = intarea['area'..1]['point'..j].x
				area.region_list['region'..areaid].points['point'..j].y = intarea['area'..1]['point'..j].y
				area.region_list['region'..areaid].point_num = area.region_list['region'..areaid].point_num +1;
			end
		end
	end
	return 0
end

local on_clear = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_wnd_ex.clear_intarea(top,w1_page_param_conf.wnd.image.id,false,false);
		uitousercfg(top,w1_page_param_conf.data)
	end
	return 0;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.LBUTTONCLK == vmsg or b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,w1_page_param_conf.data)
	end
	return 0;
end

w1_page_param_conf.pageinit = function(top)
	return 0
end

w1_page_param_conf.on_data_change = function(top)
	local cur_page_idx  = w1_row_param_conf.get_checkidx(top)
	if cur_page_idx == 2 then
		w1_page_param_conf_levent.on_channel_check(top);
	elseif cur_page_idx == 3 then
		w1_page_param_conf_nevent.on_channel_check(top);
	elseif cur_page_idx == 4 then
		w1_page_param_conf_hevent.on_channel_check(top);
	end
end

w1_page_param_conf.init= function(top)
	local c_wnd = w1_page_param_conf.wnd
	
	w1_wnd_util.cfgtab = {'human_param','device_info'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)	
	return 0
end

w1_page_param_conf.set_channel = function(chn)
	w1_page_param_conf.channel = chn;
end

w1_page_param_conf.get_channel = function()
	return w1_page_param_conf.channel;
end

local on_channel = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then	
		local c_wnd = w1_page_param_conf.wnd
		local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		local old_chn = w1_page_param_conf.channel
		if(old_chn ~= chid) then
			local area = w1_page_param_conf.data.human_param['channel'..old_chn].area
			for i = 1, 8 do
				if(area.region_list['region'..i].point_num ~= 0) then
					break;
				end
				if i == 8 then
					w1_msgbox.set_dlgattr(STR('LA_DRAW_AREA'), errstr, true, false,false);
					w1_msgbox.set_func(nil, nil, nil, nil);
					b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
					return 0
				end
			end
			local flag,errstr = w1_page_param_confface_detect.datacheck(top);
			if flag == false then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), errstr, true, false,false);
				w1_msgbox.set_func(nil, nil, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
				b_wnd_ex.set_sel(top, c_wnd.t_channel.id,w1_page_param_conf.old_sel,false);
				b_dlg.dlg_set_redraw(top);
				return 0
			end
			flag,errstr = w1_page_param_conftemp_param.datacheck(top);
			if flag == false then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), errstr, true, false,false);
				w1_msgbox.set_func(nil, nil, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
				b_wnd_ex.set_sel(top, c_wnd.t_channel.id,w1_page_param_conf.old_sel,false);
				b_dlg.dlg_set_redraw(top);
				return 0
			end
			if flag == false then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), errstr, true, false,false);
				w1_msgbox.set_func(nil, nil, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
				b_wnd_ex.set_sel(top, c_wnd.t_channel.id,w1_page_param_conf.old_sel,false);
				b_dlg.dlg_set_redraw(top);
				return 0
			end
			b_wnd_ex.set_text(top,c_wnd.tipinfo.id,'',false);	
			w1_page_param_conf.old_sel = b_wnd_ex.get_sel(top, c_wnd.t_channel.id);
			b_wnd_ex.clear_intarea(top,c_wnd.image.id,false,false);
			refresh_chdata(top, chid, false);
			w1_page_param_conf.channel = chid;
		end
		b_dlg.dlg_set_redraw(top);
	end
	
	return 0;
end

local returndatacheck =function(top,ret)
	if(ret ~= nil and ret.insight ~= 0) then--޸ʧ
		w1_wnd_util.setparamerr_str(STR('LA_APPLY_FAIL'));
		--¶ȡԭʼ
		b_app_cfg.origin_init(w1_wnd_util.cfgtab);
		return false, nil;
	end
	return true, nil;
end

local copy_okfunc = function(param)
	return 0;
end

local on_copy = function(top, id, vmsg, x, y)
	return 0
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.returndatacheckfunc = returndatacheck;
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
		w1_wnd_util.returndatacheckfunc = nil;
	end
	return 0
end

w1_page_param_conf.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	w1_wnd_util.returndatacheckfunc = returndatacheck;
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	w1_wnd_util.returndatacheckfunc = nil;
	return ret;
end

w1_page_param_conf.dwell_updata_f =function(top)
	local cwnd = w1_page_param_conf.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	if chid ~= nil and w1_page_param_conf.data['human_param']['channel'..chid] ~= nil then
		local checkidx = w1_row_param_conf.get_checkidx(top);
		if checkidx == 0 then
			w1_page_param_confface_detect.dwell_updata_f(top)
		end
	end
end

w1_page_param_conf.dwell_mouse_up =function(top)
	local cwnd = w1_page_param_conf.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	if chid ~= nil and w1_page_param_conf.data['human_param']['channel'..chid] ~= nil then
		local checkidx = w1_row_param_conf.get_checkidx(top);
		if checkidx == 0 then
			w1_page_param_confface_detect.dwell_mouse_up(top)
		end
	end
end

w1_page_param_conf.dwell_mouse_down =function(top)
	local cwnd = w1_page_param_conf.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	if chid ~= nil and w1_page_param_conf.data['human_param']['channel'..chid] ~= nil then
		local checkidx = w1_row_param_conf.get_checkidx(top);
		if checkidx == 0 then
			w1_page_param_confface_detect.dwell_mouse_down(top)
		end
	end
end

w1_page_param_conf.dwell_drop_drag =function(top)
	local cwnd = w1_page_param_conf.wnd
	local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	if chid ~= nil and w1_page_param_conf.data['human_param']['channel'..chid] ~= nil then
		local checkidx = w1_row_param_conf.get_checkidx(top);
		if checkidx == 0 then
			w1_page_param_confface_detect.dwell_drop_drag(top)
		end
	end
end

w1_page_param_conf.on_pre_show = function(top)
	local cwnd = w1_page_param_conf.wnd;
	local param = {
		x = SIZE('s_cfg_param_conf_image_xywh')[1] + SIZE('s_cfg_page_xywh')[1], 
		y = SIZE('s_cfg_param_conf_image_xywh')[2] + SIZE('s_cfg_page_xywh')[2],
		cx = SIZE('s_cfg_param_conf_image_xywh')[3],
		cy = SIZE('s_cfg_param_conf_image_xywh')[4],
	}
	local oldparam_x = param.x;
	param.x = math.floor((param.x + 2) / 4) * 4;--֤4ı
	param.cx = math.floor((param.cx + 2) / 4) *4;
	local oldparam_y = param.y;
	param.y = math.floor((param.y + 2) / 4) * 4;
	param.cy = math.floor((param.cy + 2) / 4) *4;
	
	w1_page_param_conf.layoutpos.x = param.x;
	w1_page_param_conf.layoutpos.cx = param.cx;
	w1_page_param_conf.layoutpos.y = param.y;
	w1_page_param_conf.layoutpos.cy = param.cy;
	local pos = {};
	pos[1] = SIZE('s_cfg_param_conf_image_xywh')[1] + param.x - oldparam_x;
	pos[2] = SIZE('s_cfg_param_conf_image_xywh')[2] + param.y - oldparam_y;
	pos[3] = param.cx;
	pos[4] = param.cy;
	b_wnd_ex.move_ex(top, cwnd.image.id, pos, false);
	
	channel_num = global_val.get_channelnum();
	w1_page_param_confface_detect.on_pre_show(top)
	w1_page_param_conf_levent.on_pre_show(top, channel_num)
	w1_page_param_conf_nevent.on_pre_show(top, channel_num)
	w1_page_param_conf_hevent.on_pre_show(top, channel_num)
	local con_id = cwnd.con_param.id
	
	w1_row_param_conf.changecheck(top, w1_row_param_conf.wnd, w1_id.cfg_humanthermometer.param_confrow_id + 1, false)

end

w1_page_param_conf.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'image','clear','cap_channel', 't_channel','con_param','param_row_wnd','face_wnd','temp_param_wnd',
			'levent_wnd','nevent_wnd','hevent_wnd','timeplan_wnd','tipinfo', 'apply'},
		
	image = {t='intelarea',id=id+1,xywh='s_cfg_param_conf_image_xywh',text='Image widget', font = 'f_grade1', trans = false,
				color = {'c_imgae_param_bg', 'c_imgae_param_bg', 'c_imgae_param_bg'},cmd=on_update_param},
	clear = {t='tt_button',id=id+3,xywh='s_param_conf_clear_xywh',text='LA_CLEAR',cmd = on_clear},
	cap_channel	= {t='static',id=id+4,	xywh='s_image_cap_channel_xywh',	text='LA_CHANNEL'},
	t_channel 	= {t='combox',id=id+5,	xywh='s_image_t_channel_xywh',	items={'1','2','3','4','5','6','7','8'},trans = false,
					channel_cbox = true,cmd = on_channel},		
	con_param	= {t='container',id=w1_id.cfg_humanthermometer.con_param_id,	xywh={0,0,10,10}},
	param_row_wnd 	= w1_row_param_conf.wnd,
	face_wnd 		= w1_page_param_confface_detect.wnd,
	temp_param_wnd 	= w1_page_param_conftemp_param.wnd,
	levent_wnd 		= w1_page_param_conf_levent.wnd,
	nevent_wnd 		= w1_page_param_conf_nevent.wnd,
	hevent_wnd 		= w1_page_param_conf_hevent.wnd,
	timeplan_wnd	= w1_page_param_conftimeplan.wnd,
	
	tipinfo	= {t='static',id=id+6,	xywh='s_param_conf_tipinfo_xywh',text='',trans = false},
	apply 	= {t='button',id=id+7,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_param_conf

