--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_humanthermometer.nevent_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local b_dlg 	= require("wnd.core.b_dlg")
local b_app_api = require("wnd.core.command.b_app_api")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg")
local b_wnd 	= require("wnd.core.b_wnd") 
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_font	= require("wnd.core.r_res.r_font")
local util 		= require("wnd.core.util")

local w1_page_param_conf_nevent = 
{
	cfg_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_param_conf_nevent.s_768 =
{
	s_event_conf_nevent_xywh 				= {53,320,576,298},
	s_conf_nevent_link_event_xywh 			= {0, 8, 576, 290},
	s_conf_nevent_link_item_xywh			= {5, 5, 550, 35},
	s_conf_nevent_link_vdor_xywh			= {560, 8, 10, 280},
};

w1_page_param_conf_nevent.s_1280 = 
{
	s_event_conf_nevent_xywh 				= {80,440,830,360},
	s_conf_nevent_link_event_xywh 			= {0, 0, 830, 360},
	s_conf_nevent_link_item_xywh			= {10, 0, 800, 50},
	s_conf_nevent_link_vdor_xywh			= {810, 5, 20, 340},
}

w1_page_param_conf_nevent.s_1440 = 
{
	s_event_conf_nevent_xywh 				= {100,332,900,350},
	s_conf_nevent_link_event_xywh 			= {0, 0, 900, 350},
	s_conf_nevent_link_item_xywh			= {5, 5, 870, 50},
	s_conf_nevent_link_vdor_xywh			= {880, 5, 20, 340},
}

w1_page_param_conf_nevent.s_1080p = 
{
	s_event_conf_nevent_xywh 				= {100,450,1080,420},
	s_conf_nevent_link_event_xywh 			= {0, 0, 1080, 420},
	s_conf_nevent_link_item_xywh			= {8, 10, 1040, 50},
	s_conf_nevent_link_vdor_xywh			= {1050, 10, 20, 380},
}

w1_page_param_conf_nevent.s_2k = 
{
	s_event_conf_nevent_xywh 				= {133,600,1440,560},
	s_conf_nevent_link_event_xywh 			= {0,0,1439,560},
	s_conf_nevent_link_item_xywh 			= {10,13,1386,66},
	s_conf_nevent_link_vdor_xywh 			= {1399,13,26,514},
}

w1_page_param_conf_nevent.s_4k = 
{
	s_event_conf_nevent_xywh 			= {200,900,2160,840},
	s_conf_nevent_link_event_xywh 		= {0,0,2160,840},
	s_conf_nevent_link_item_xywh 		= {16,20,2080,100},
	s_conf_nevent_link_vdor_xywh 		= {2100,20,40,760},
}


w1_page_param_conf_nevent.clear_data =function ()
	w1_page_param_conf_nevent.cfg_data=nil;
end

local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_param_conf_nevent.wnd;
	local ui_data = b_wnd_ex.get_link_event_data(top, cwnd.link_event.id);	
	
	local linkage 				= cfgdata.linkage3
	linkage.buzzer 				= ui_data.linkage_cfg.buzzer
	linkage.push 				= ui_data.linkage_cfg.push
	linkage.msg_pop 			= ui_data.linkage_cfg.msg_pop
	linkage.email 				= ui_data.linkage_cfg.email
	linkage.ftp_upload 			= ui_data.linkage_cfg.ftp_upload
	linkage.full_screen 		= ui_data.linkage_cfg.full_screen
	linkage.full_screen_time 	= ui_data.linkage_cfg.full_screen_time
	linkage.cloud_storage 		= ui_data.linkage_cfg.cloud_storage
	linkage.ptz 				= ui_data.linkage_cfg.ptz
	linkage.ptz_chn 			= ui_data.linkage_cfg.ptz_chn
	linkage.ptz_preset 			= ui_data.linkage_cfg.ptz_preset	
	linkage.relay 				= ui_data.linkage_cfg.relay
	linkage.relay_time 			= ui_data.linkage_cfg.relay_time
	linkage.relay_list 			= ui_data.linkage_cfg.relay_list
	linkage.camrea_io_enable 	= ui_data.linkage_cfg.camrea_io_enable
	linkage.camera_io_list 		= ui_data.linkage_cfg.camera_io_list
	linkage.record 				= ui_data.linkage_cfg.record
	linkage.record_time 		= ui_data.linkage_cfg.record_time
	linkage.adam_relay			= ui_data.linkage_cfg.adam_relay;		
	linkage.adam_channel		= ui_data.linkage_cfg.adam_channel;
	linkage.adam_relay_time		= ui_data.linkage_cfg.adam_relay_time;
	linkage.adam_relay_list		= ui_data.linkage_cfg.adam_relay_list;	
	linkage.trigger_ch 			= {};
	util.copy_tab_b(linkage.trigger_ch , ui_data.trigger_cfg)
	cfgdata.change_flag = true;
end

w1_page_param_conf_nevent.setstatus= function(top, param, ch_id, ro_num, buzz_support, redraw)
	w1_page_param_conf_nevent.cfg_data = param;
	local ch_ro_num = b_app_api.get_ch_ro_num(ch_id);
	local linkage = param.linkage3
	local cwnd = w1_page_param_conf_nevent.wnd;
	local cloud_support = global_val.get_cloud_support();
	local pb_flag = global_val.get_playback_support();

	local param_data 						= {};
	param_data.buzzer_support 				= buzz_support;		
	param_data.ftp_support 					= pb_flag;		
	param_data.cloud_support 				= cloud_support;		
	param_data.full_support 				= true;		
	param_data.record_support 				= pb_flag;
	param_data.ptz_support					= linkage.ptz_support;	
	param_data.ro_num 						= ro_num;				
	param_data.chn_ro_num 					= ch_ro_num;		
	param_data.trigger_cfg					= linkage.trigger_ch
	param_data.linkage_cfg 					=  {};
	param_data.linkage_cfg.push 			= linkage.push;
	param_data.linkage_cfg.email			= linkage.email;
	param_data.linkage_cfg.relay			= linkage.relay;
	param_data.linkage_cfg.relay_time		= linkage.relay_time;		
	param_data.linkage_cfg.relay_list		= linkage.relay_list;
	param_data.linkage_cfg.video_pop		= linkage.video_pop;
	param_data.linkage_cfg.buzzer			= linkage.buzzer;
	param_data.linkage_cfg.msg_pop			= linkage.msg_pop;
	param_data.linkage_cfg.record			= linkage.record;
	param_data.linkage_cfg.full_screen		= linkage.full_screen;
	param_data.linkage_cfg.full_screen_time	= linkage.full_screen_time;
	param_data.linkage_cfg.cloud_storage	= linkage.cloud_storage;
	param_data.linkage_cfg.resv				= linkage.resv;
	param_data.linkage_cfg.record_time		= linkage.record_time;
	param_data.linkage_cfg.camrea_io_enable	= linkage.camrea_io_enable;
	param_data.linkage_cfg.camera_io_list	= linkage.camera_io_list;
	param_data.linkage_cfg.ftp_upload		= linkage.ftp_upload;
	param_data.linkage_cfg.ptz				= linkage.ptz;
	param_data.linkage_cfg.ptz_chn			= linkage.ptz_chn;
	param_data.linkage_cfg.ptz_preset		= linkage.ptz_preset;
	param_data.adam_support					= global_val.get_adam_support();
	param_data.adam_id_num					= linkage.adam_id_num;	
	param_data.linkage_cfg.adam_relay		= linkage.adam_relay;	
	param_data.linkage_cfg.adam_channel		= linkage.adam_channel;
	param_data.linkage_cfg.adam_relay_time  = linkage.adam_relay_time;
	param_data.linkage_cfg.adam_relay_list  = linkage.adam_relay_list;
	b_wnd_ex.set_link_event_data(top, cwnd.link_event.id, param_data, redraw);

	return 0
end

w1_page_param_conf_nevent.on_channel_check = function(top)
	uitousercfg(top, w1_page_param_conf_nevent.cfg_data);
end	

w1_page_param_conf_nevent.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_param_conf_nevent.wnd;
	b_wnd_ex.set_hide(top, cwnd.link_event.id, bool_hide, redraw)		
end

w1_page_param_conf_nevent.on_pre_show = function(top, chnum)
	local cwnd 					= w1_page_param_conf_nevent.wnd;
	local param_attr 			= {};	
	param_attr.c_bg 			= COLOR('c_cfg_page_bk');
	param_attr.c_border 		= COLOR('c_cfg_page_bk');		
	param_attr.c_txt 			= COLOR('c_txt_n');		
	param_attr.txt_font 		= r_font.get_fontsize('f_grade5');		
	param_attr.channel_num 		= chnum;
	param_attr.item_xywh 		= SIZE('s_conf_nevent_link_item_xywh');
	param_attr.vdor_xywh 		= SIZE('s_conf_nevent_link_vdor_xywh');
	b_wnd_ex.set_link_event_attr(top, cwnd.link_event.id, param_attr, false);

	return 0;
end

w1_page_param_conf_nevent.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_event_conf_nevent_xywh',	
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'link_event'},
	
	link_event = {t='linkage_event', id = id + 1, xywh = 's_conf_nevent_link_event_xywh'},
};

return w1_page_param_conf_nevent

