--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/9/14
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_humanthermometer.temperature_param_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local global_val	= require("wnd.global_val")
local b_dlg 	= require("wnd.core.b_dlg")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str

local w1_page_param_conftemp_param = 
{
	cfg_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_param_conftemp_param.s_768 =
{
	s_cfg_page_param_conftemp_xywh = {53,320,746,220},
	s_temp_param_cap_enable_xywh = {32,0,186,32},
	s_temp_param_t_enable_xywh = {237,4,25,21},
	s_temp_param_cap_unit_xywh = {32,35,173,32},
	s_temp_param_t_unit_help_xywh = {205,35,24,32},
	s_temp_param_t_unit_xywh = {240,35,117,32},
	s_temp_param_cap_len_unit_xywh = {32,71,173,32},
	s_temp_param_t_len_unit_help_xywh = {205,71,24,32},
	s_temp_param_t_len_unit_xywh = {240,71,117,32},
	s_temp_param_cap_ambient_xywh = {32,106,186,32},
	s_temp_param_t_ambient_xywh = {240,106,117,32},
	s_temp_param_cap_cavity_xywh = {32,106,186,32},
	s_temp_param_t_cavity_xywh = {240,106,101,32},
	s_temp_param_t_cavity_u_xywh = {341,106,16,32},
	s_temp_param_cap_cor_coe_xywh = {32,142,186,32},
	s_temp_param_t_cor_coe_xywh = {240,142,117,32},
	s_temp_param_cap_mount_dis_xywh = {32,177,186,32},
	s_temp_param_t_mount_dis_xywh = {240,177,101,32},
	s_temp_param_t_mount_dis_u_xywh = {341,177,16,32},
	s_temp_param_hline_xywh = {368,0,1,284},
	s_temp_param_cap_face_color_xywh = {376,0,186,32},
	s_temp_param_t_face_color_xywh = {581,4,25,21},
	s_temp_param_cap_arg_temp_cor_xywh = {376,35,186,32},
	s_temp_param_t_arg_temp_cor_xywh = {581,40,25,21},
	s_temp_param_cap_abnormal_xywh = {376,71,186,32},
	s_temp_param_t_abnormal_xywh = {581,76,25,21},
	s_temp_param_cap_temp_area_xywh = {376,106,186,32},
	s_temp_param_t_temp_area_xywh = {584,106,117,32},
	s_temp_param_cap_temp_model_xywh = {376,142,186,32},
	s_temp_param_t_temp_model_xywh = {584,142,117,32},
	s_temp_param_cap_nor_range_xywh = {376,177,186,32},
	s_temp_param_t_range_min_xywh = {584,177,45,32},
	s_temp_param_t_range_con_xywh = {629,177,10,32},
	s_temp_param_t_range_max_xywh = {640,177,45,32},
	s_temp_param_t_range_u_xywh = {685,177,16,32},
};

w1_page_param_conftemp_param.s_1280 = 
{
	s_cfg_page_param_conftemp_xywh = {60,440,900,310},
	s_temp_param_cap_enable_xywh = {40,0,270,45},
	s_temp_param_t_enable_xywh = {315,7,48,30},
	s_temp_param_cap_unit_xywh = {40,50,225,45},
	s_temp_param_t_unit_help_xywh = {265,50,45,45},
	s_temp_param_t_unit_xywh = {320,50,160,45},
	s_temp_param_cap_len_unit_xywh = {40,100,225,45},
	s_temp_param_t_len_unit_help_xywh = {265,100,45,45},
	s_temp_param_t_len_unit_xywh = {320,100,160,45},
	s_temp_param_cap_ambient_xywh = {40,150,270,45},
	s_temp_param_t_ambient_xywh = {320,150,160,45},
	s_temp_param_cap_cavity_xywh = {40,150,270,45},
	s_temp_param_t_cavity_xywh = {320,150,130,45},
	s_temp_param_t_cavity_u_xywh = {450,150,30,45},
	s_temp_param_cap_cor_coe_xywh = {40,200,270,45},
	s_temp_param_t_cor_coe_xywh = {320,200,160,45},
	s_temp_param_cap_mount_dis_xywh = {40,250,270,45},
	s_temp_param_t_mount_dis_xywh = {320,250,130,45},
	s_temp_param_t_mount_dis_u_xywh = {450,250,30,45},
	s_temp_param_hline_xywh = {495,0,1,350},
	s_temp_param_cap_face_color_xywh = {505,0,270,45},
	s_temp_param_t_face_color_xywh = {775,7,48,30},
	s_temp_param_cap_arg_temp_cor_xywh = {505,50,270,45},
	s_temp_param_t_arg_temp_cor_xywh = {775,57,48,30},
	s_temp_param_cap_abnormal_xywh = {505,100,270,45},
	s_temp_param_t_abnormal_xywh = {775,107,48,30},
	s_temp_param_cap_temp_area_xywh = {505,150,270,45},
	s_temp_param_t_temp_area_xywh = {780,150,160,45},
	s_temp_param_cap_temp_model_xywh = {505,200,270,45},
	s_temp_param_t_temp_model_xywh = {780,200,160,45},
	s_temp_param_cap_nor_range_xywh = {505,250,270,45},
	s_temp_param_t_range_min_xywh = {780,250,55,45},
	s_temp_param_t_range_con_xywh = {835,250,20,45},
	s_temp_param_t_range_max_xywh = {855,250,55,45},
	s_temp_param_t_range_u_xywh = {910,250,30,45},
};

w1_page_param_conftemp_param.s_1440 = 
{
	s_cfg_page_param_conftemp_xywh = {60,332,900,245},
	s_temp_param_cap_enable_xywh = {40,0,270,45},
	s_temp_param_t_enable_xywh = {315,7,48,30},
	s_temp_param_cap_unit_xywh = {40,50,225,45},
	s_temp_param_t_unit_help_xywh = {265,50,45,45},
	s_temp_param_t_unit_xywh = {320,50,160,45},
	s_temp_param_cap_len_unit_xywh = {40,100,225,45},
	s_temp_param_t_len_unit_help_xywh = {265,100,45,45},
	s_temp_param_t_len_unit_xywh = {320,100,160,45},
	s_temp_param_cap_ambient_xywh = {40,150,270,45},
	s_temp_param_t_ambient_xywh = {320,150,160,45},
	s_temp_param_cap_cavity_xywh = {40,150,270,45},
	s_temp_param_t_cavity_xywh = {320,150,130,45},
	s_temp_param_t_cavity_u_xywh = {450,150,30,45},
	s_temp_param_cap_cor_coe_xywh = {40,200,270,45},
	s_temp_param_t_cor_coe_xywh = {320,200,160,45},
	s_temp_param_cap_mount_dis_xywh = {40,250,270,45},
	s_temp_param_t_mount_dis_xywh = {320,250,130,45},
	s_temp_param_t_mount_dis_u_xywh = {450,250,30,45},
	s_temp_param_hline_xywh = {495,0,1,350},
	s_temp_param_cap_face_color_xywh = {505,0,270,45},
	s_temp_param_t_face_color_xywh = {775,7,48,30},
	s_temp_param_cap_arg_temp_cor_xywh = {505,50,270,45},
	s_temp_param_t_arg_temp_cor_xywh = {775,57,48,30},
	s_temp_param_cap_abnormal_xywh = {505,100,270,45},
	s_temp_param_t_abnormal_xywh = {775,107,48,30},
	s_temp_param_cap_temp_area_xywh = {505,150,270,45},
	s_temp_param_t_temp_area_xywh = {780,150,160,45},
	s_temp_param_cap_temp_model_xywh = {505,200,270,45},
	s_temp_param_t_temp_model_xywh = {780,200,160,45},
	s_temp_param_cap_nor_range_xywh = {505,250,270,45},
	s_temp_param_t_range_min_xywh = {780,250,55,45},
	s_temp_param_t_range_con_xywh = {835,250,20,45},
	s_temp_param_t_range_max_xywh = {855,250,55,45},
	s_temp_param_t_range_u_xywh = {910,250,30,45},
};

w1_page_param_conftemp_param.s_1080p = 
{
	s_cfg_page_param_conftemp_xywh = {100,450,1400,310},
	s_temp_param_cap_enable_xywh = {60,0,350,45},
	s_temp_param_t_enable_xywh = {445,7,48,30},
	s_temp_param_cap_unit_xywh = {60,50,325,45},
	s_temp_param_t_unit_help_xywh = {385,50,45,45},
	s_temp_param_t_unit_xywh = {450,50,220,45},
	s_temp_param_cap_len_unit_xywh = {60,100,325,45},
	s_temp_param_t_len_unit_help_xywh = {385,100,45,45},
	s_temp_param_t_len_unit_xywh = {450,100,220,45},
	s_temp_param_cap_ambient_xywh = {60,150,350,45},
	s_temp_param_t_ambient_xywh = {450,150,220,45},
	s_temp_param_cap_cavity_xywh = {60,150,350,45},
	s_temp_param_t_cavity_xywh = {450,150,190,45},
	s_temp_param_t_cavity_u_xywh = {640,150,30,45},
	s_temp_param_cap_cor_coe_xywh = {60,200,350,45},
	s_temp_param_t_cor_coe_xywh = {450,200,220,45},
	s_temp_param_cap_mount_dis_xywh = {60,250,350,45},
	s_temp_param_t_mount_dis_xywh = {450,250,190,45},
	s_temp_param_t_mount_dis_u_xywh = {640,250,30,45},
	s_temp_param_hline_xywh = {690,0,2,400},
	s_temp_param_cap_face_color_xywh = {705,0,350,45},
	s_temp_param_t_face_color_xywh = {1090,7,48,30},
	s_temp_param_cap_arg_temp_cor_xywh = {705,50,350,45},
	s_temp_param_t_arg_temp_cor_xywh = {1090,57,48,30},
	s_temp_param_cap_abnormal_xywh = {705,100,350,45},
	s_temp_param_t_abnormal_xywh = {1090,107,48,30},
	s_temp_param_cap_temp_area_xywh = {705,150,350,45},
	s_temp_param_t_temp_area_xywh = {1095,150,220,45},
	s_temp_param_cap_temp_model_xywh = {705,200,350,45},
	s_temp_param_t_temp_model_xywh = {1095,200,220,45},
	s_temp_param_cap_nor_range_xywh = {705,250,350,45},
	s_temp_param_t_range_min_xywh = {1095,250,85,45},
	s_temp_param_t_range_con_xywh = {1180,250,20,45},
	s_temp_param_t_range_max_xywh = {1200,250,85,45},
	s_temp_param_t_range_u_xywh = {1285,250,30,45},
};

w1_page_param_conftemp_param.s_2k = 
{
	s_cfg_page_param_conftemp_xywh = {133,600,1866,413},
	s_temp_param_cap_enable_xywh = {80,0,467,60},
	s_temp_param_t_enable_xywh = {593,9,64,40},
	s_temp_param_cap_unit_xywh = {80,67,433,60},
	s_temp_param_t_unit_help_xywh = {513,67,60,60},
	s_temp_param_t_unit_xywh = {600,67,293,60},
	s_temp_param_cap_len_unit_xywh = {80,133,433,60},
	s_temp_param_t_len_unit_help_xywh = {513,133,60,60},
	s_temp_param_t_len_unit_xywh = {600,133,293,60},
	s_temp_param_cap_ambient_xywh = {80,200,467,60},
	s_temp_param_t_ambient_xywh = {600,200,293,60},
	s_temp_param_cap_cavity_xywh = {80,200,467,60},
	s_temp_param_t_cavity_xywh = {600,200,253,60},
	s_temp_param_t_cavity_u_xywh = {853,200,40,60},
	s_temp_param_cap_cor_coe_xywh = {80,267,467,60},
	s_temp_param_t_cor_coe_xywh = {600,267,293,60},
	s_temp_param_cap_mount_dis_xywh = {80,333,467,60},
	s_temp_param_t_mount_dis_xywh = {600,333,253,60},
	s_temp_param_t_mount_dis_u_xywh = {853,333,40,60},
	s_temp_param_hline_xywh = {920,0,3,533},	
	s_temp_param_cap_face_color_xywh = {940,0,467,60},
	s_temp_param_t_face_color_xywh = {1453,9,64,40},
	s_temp_param_cap_arg_temp_cor_xywh = {940,67,467,60},
	s_temp_param_t_arg_temp_cor_xywh = {1453,76,64,40},
	s_temp_param_cap_abnormal_xywh = {940,133,467,60},
	s_temp_param_t_abnormal_xywh = {1453,143,64,40},
	s_temp_param_cap_temp_area_xywh = {940,200,467,60},
	s_temp_param_t_temp_area_xywh = {1460,200,293,60},
	s_temp_param_cap_temp_model_xywh = {940,267,467,60},
	s_temp_param_t_temp_model_xywh = {1460,267,293,60},
	s_temp_param_cap_nor_range_xywh = {940,333,467,60},
	s_temp_param_t_range_min_xywh = {1460,333,113,60},
	s_temp_param_t_range_con_xywh = {1573,333,26,60},
	s_temp_param_t_range_max_xywh = {1600,333,113,60},
	s_temp_param_t_range_u_xywh = {1713,333,60,60},
};

w1_page_param_conftemp_param.s_4k = 
{
	s_cfg_page_param_conftemp_xywh = {200,900,2800,620},
	s_temp_param_cap_enable_xywh = {120,0,700,90},
	s_temp_param_t_enable_xywh = {890,14,96,60},
	s_temp_param_cap_unit_xywh = {120,100,650,90},
	s_temp_param_t_unit_help_xywh = {770, 100, 90, 90},
	s_temp_param_t_unit_xywh = {900,100,440,90},
	s_temp_param_cap_len_unit_xywh = {120,200,650,90},
	s_temp_param_t_len_unit_help_xywh = {770,200,90,90},
	s_temp_param_t_len_unit_xywh = {900,200,440,90},
	s_temp_param_cap_ambient_xywh = {120,300,700,90},
	s_temp_param_t_ambient_xywh = {900,300,440,90},
	s_temp_param_cap_cavity_xywh = {120,300,700,90},
	s_temp_param_t_cavity_xywh = {900,300,380,90},
	s_temp_param_t_cavity_u_xywh = {1280,300,60,90},
	s_temp_param_cap_cor_coe_xywh = {120,400,700,90},
	s_temp_param_t_cor_coe_xywh = {900,400,440,90},
	s_temp_param_cap_mount_dis_xywh = {120,500,700,90},
	s_temp_param_t_mount_dis_xywh = {900,500,380,90},
	s_temp_param_t_mount_dis_u_xywh = {1280,500,60,90},
	s_temp_param_hline_xywh = {1380,0,4,800},
	s_temp_param_cap_face_color_xywh = {1410,0,700,90},
	s_temp_param_t_face_color_xywh = {2180,14,96,60},
	s_temp_param_cap_arg_temp_cor_xywh = {1410,100,700,90},
	s_temp_param_t_arg_temp_cor_xywh = {2180,114,96,60},
	s_temp_param_cap_abnormal_xywh = {1410,200,700,90},
	s_temp_param_t_abnormal_xywh = {2180,214,96,60},
	s_temp_param_cap_temp_area_xywh = {1410,300,700,90},
	s_temp_param_t_temp_area_xywh = {2190,300,440,90},
	s_temp_param_cap_temp_model_xywh = {1410,400,700,90},
	s_temp_param_t_temp_model_xywh = {2190,400,440,90},
	s_temp_param_cap_nor_range_xywh = {1410,500,700,90},
	s_temp_param_t_range_min_xywh = {2190,500,170,90},
	s_temp_param_t_range_con_xywh = {2360,500,40,90},
	s_temp_param_t_range_max_xywh = {2400,500,170,90},
	s_temp_param_t_range_u_xywh = {2570,500,60,90},
};

w1_page_param_conftemp_param.clear_data=function ()
	w1_page_param_conftemp_param.cfg_data=nil;
end
--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_param_conftemp_param.wnd
	cfgdata.temp_enable = b_wnd_ex.get_check(top,cwnd.t_enable.id);
	cfgdata.temp_unit = b_wnd_ex.get_sel(top,cwnd.t_unit.id);
	cfgdata.length_unit = b_wnd_ex.get_sel(top,cwnd.t_len_unit.id);
	cfgdata.cavity = b_wnd_ex.get_text(top,cwnd.t_cavity.id);
	cfgdata.cor_coe = b_wnd_ex.get_text(top,cwnd.t_cor_coe.id);
	cfgdata.mount_distance = b_wnd_ex.get_text(top,cwnd.t_mount_dis.id);
	cfgdata.face_color = b_wnd_ex.get_check(top,cwnd.t_face_color.id);
	cfgdata.arg_temp_cor = b_wnd_ex.get_check(top,cwnd.t_arg_temp_cor.id);
	cfgdata.abnormal_temp = b_wnd_ex.get_check(top,cwnd.t_abnormal.id);
	cfgdata.area_model = b_wnd_ex.get_sel(top,cwnd.t_temp_area.id);
	cfgdata.measure_model = b_wnd_ex.get_sel(top,cwnd.t_temp_model.id);
	cfgdata.min_value = b_wnd_ex.get_text(top,cwnd.t_range_min.id);
	cfgdata.max_value = b_wnd_ex.get_text(top,cwnd.t_range_max.id);
	return 0
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.LBUTTONCLK == vmsg or b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,w1_page_param_conftemp_param.cfg_data)
	end
	return 0;
end

local on_unit_change = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cwnd = w1_page_param_conftemp_param.wnd
		local sel = b_wnd_ex.get_sel(top,cwnd.t_unit.id);
		local data = w1_page_param_conftemp_param.cfg_data;
		if sel == 0 then
			local str = string.format('%c%c%c%c',226,132,131,0);
			b_wnd_ex.set_text(top,cwnd.t_cavity_u.id,str,false);
			b_wnd_ex.set_text(top,cwnd.t_range_u.id,str,false);
			local f_temp = tonumber(b_wnd_ex.get_text(top,cwnd.t_cavity.id))
			local c_temp = 5*(f_temp-32)/9;
			b_wnd_ex.set_text(top,cwnd.t_cavity.id,string.format('%.2f',c_temp),false);
			local f_min = tonumber(b_wnd_ex.get_text(top,cwnd.t_range_min.id))
			local c_min = 5*(f_min-32)/9;
			b_wnd_ex.set_text(top,cwnd.t_range_min.id,string.format('%.2f',c_min),false);
			local f_max= tonumber(b_wnd_ex.get_text(top,cwnd.t_range_max.id))
			local c_max = 5*(f_max-32)/9;
			b_wnd_ex.set_text(top,cwnd.t_range_max.id,string.format('%.2f',c_max),false);
		else
			local str = string.format('%c%c%c%c',226,132,137,0);
			b_wnd_ex.set_text(top,cwnd.t_cavity_u.id,str,false);
			b_wnd_ex.set_text(top,cwnd.t_range_u.id,str,false);
			local c_temp = tonumber(b_wnd_ex.get_text(top,cwnd.t_cavity.id))
			local f_temp = 9*c_temp/5+32;
			b_wnd_ex.set_text(top,cwnd.t_cavity.id,string.format('%.2f',f_temp),false);
			local c_min = tonumber(b_wnd_ex.get_text(top,cwnd.t_range_min.id));
			local f_min = 9*c_min/5+32;
			b_wnd_ex.set_text(top,cwnd.t_range_min.id,string.format('%.2f',f_min),false);
			local c_max= tonumber(b_wnd_ex.get_text(top,cwnd.t_range_max.id));
			local f_max = 9*c_max/5+32;
			b_wnd_ex.set_text(top,cwnd.t_range_max.id,string.format('%.2f',f_max),false);
		end
		uitousercfg(top,w1_page_param_conftemp_param.cfg_data)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_unit_change_length = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cwnd = w1_page_param_conftemp_param.wnd
		local sel = b_wnd_ex.get_sel(top,cwnd.t_len_unit.id);
		if sel == 0 then
			b_wnd_ex.set_text(top,cwnd.t_mount_dis_u.id,'m',false);
			local ft_distance = tonumber(b_wnd_ex.get_text(top,cwnd.t_mount_dis.id));
			local m_distance = ft_distance * 0.3048;
			b_wnd_ex.set_text(top,cwnd.t_mount_dis.id,string.format('%.2f',m_distance),false);
		else
			b_wnd_ex.set_text(top,cwnd.t_mount_dis_u.id,'ft',false);
			local m_distance = tonumber(b_wnd_ex.get_text(top,cwnd.t_mount_dis.id));
			local ft_distance = m_distance * 3.2808398950131;
			b_wnd_ex.set_text(top,cwnd.t_mount_dis.id,string.format('%.2f',ft_distance),false);
		end
		uitousercfg(top,w1_page_param_conftemp_param.cfg_data)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

w1_page_param_conftemp_param.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_param_conftemp_param.wnd
	local s_id = cwnd.cap_enable.id
	local e_id = cwnd.t_range_u.id
	for i=s_id, e_id do
		b_wnd_ex.set_hide(top,i,bool_hide,false);
	end
end

w1_page_param_conftemp_param.set_param = function(top, param, redraw)
	local cwnd = w1_page_param_conftemp_param.wnd
	w1_page_param_conftemp_param.cfg_data = param
	b_wnd_ex.set_check(top,cwnd.t_enable.id,param.temp_enable,false);
	b_wnd_ex.set_sel(top,cwnd.t_unit.id,param.temp_unit,false);
	b_wnd_ex.set_sel(top,cwnd.t_len_unit.id,param.length_unit,false);
	if param.temp_unit == 0 then
		local str = string.format('%c%c%c%c',226,132,131,0);
		b_wnd_ex.set_text(top,cwnd.t_cavity_u.id,str,false);
		b_wnd_ex.set_text(top,cwnd.t_range_u.id,str,false);
	else
		local str = string.format('%c%c%c%c',226,132,137,0);
		b_wnd_ex.set_text(top,cwnd.t_cavity_u.id,str,false);
		b_wnd_ex.set_text(top,cwnd.t_range_u.id,str,false);
	end
	
	if param.length_unit == 0 then
		b_wnd_ex.set_text(top,cwnd.t_mount_dis_u.id,'m',false);
	else
		b_wnd_ex.set_text(top,cwnd.t_mount_dis_u.id,'ft',false);
	end
	b_wnd_ex.set_text(top,cwnd.t_cavity.id,param.cavity,false);
	b_wnd_ex.set_disable(top,cwnd.t_cavity.id,true,false);
	b_wnd_ex.set_text(top,cwnd.cap_cor_coe.id,STR('LA_CORRECT_COEFFICIENT')..'(-100 - 100)',false);
	b_wnd_ex.set_text(top,cwnd.t_cor_coe.id,param.cor_coe,false);
	b_wnd_ex.set_text(top,cwnd.t_mount_dis.id,param.mount_distance,false);
	b_wnd_ex.set_check(top,cwnd.t_face_color.id,param.face_color,false);
	b_wnd_ex.set_check(top,cwnd.t_arg_temp_cor.id,param.arg_temp_cor,false);
	b_wnd_ex.set_check(top,cwnd.t_abnormal.id,param.abnormal_temp,false);
	b_wnd_ex.set_text(top,cwnd.t_range_min.id,string.format('%.2f',param.min_value),false);
	b_wnd_ex.set_text(top,cwnd.t_range_max.id,string.format('%.2f',param.max_value),false);
	if param.area_model == 0 then
		b_wnd_ex.set_sel(top,cwnd.t_temp_area.id,0,false);
	else
		b_wnd_ex.set_sel(top,cwnd.t_temp_area.id,1,false);
	end
	if param.measure_model == 0 then
		b_wnd_ex.set_sel(top,cwnd.t_temp_model.id,0,false);
	else
		b_wnd_ex.set_sel(top,cwnd.t_temp_model.id,1,false);
	end
end

w1_page_param_conftemp_param.datacheck = function(top)
	local cwnd = w1_page_param_conftemp_param.wnd
	local distance = tonumber(b_wnd_ex.get_text(top,cwnd.t_mount_dis.id));
	if distance < 0 then
		return false,STR('LA_PARAMETER_ERROR')..'('..STR('LA_MOUNT_DIS')..')'
	end
	local range_min = tonumber(b_wnd_ex.get_text(top,cwnd.t_range_min.id));
	local range_max = tonumber(b_wnd_ex.get_text(top,cwnd.t_range_max.id));
	if range_min >= range_max then
		return false,STR('LA_PARAMETER_ERROR')..'('..STR('LA_NORMAL_TEMPERATURE_RANGE')..')'
	end
	
	local sel = b_wnd_ex.get_sel(top,cwnd.t_unit.id);
	if sel == 0 then
		if range_min < -273 or range_max > 500 then
			return false,STR('LA_PARAMETER_ERROR')..'('..STR('LA_NORMAL_TEMPERATURE_RANGE')..')'
		end
	else
		if range_min < -459 or range_max > 500 then
			return false,STR('LA_PARAMETER_ERROR')..'('..STR('LA_NORMAL_TEMPERATURE_RANGE')..')'
		end
	end

	local temp_cor = tonumber(b_wnd_ex.get_text(top,cwnd.t_cor_coe.id));
	if temp_cor < -100 or temp_cor > 100 then
		return false,STR('LA_PARAMETER_ERROR')..'('..STR('LA_CORRECT_COEFFICIENT')..')'
	end
	return true,nil
end

w1_page_param_conftemp_param.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_param_conftemp_xywh',
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub = {'cap_enable','t_enable','cap_unit','t_unit_help','t_unit','cap_len_unit','t_len_unit_help','t_len_unit',--[['cap_ambient','t_ambient',--]]
	'cap_cavity','t_cavity','t_cavity_u','cap_cor_coe','t_cor_coe','cap_mount_dis','t_mount_dis','t_mount_dis_u','hline','cap_face_color','t_face_color',
	'cap_arg_temp_cor','t_arg_temp_cor','cap_abnormal','t_abnormal','cap_temp_area','t_temp_area','cap_temp_model','t_temp_model','cap_nor_range','t_range_min',
	't_range_con','t_range_max','t_range_u'},
	cap_enable	= {t='static',	id=id+1,	xywh='s_temp_param_cap_enable_xywh',text='LA_ENABLE', align = b_ui.ALIGN.LEFT},
	t_enable 	= {t='tt_check',id=id+2,	xywh='s_temp_param_t_enable_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	cap_unit	= {t='static',	id=id+3,	xywh='s_temp_param_cap_unit_xywh',text='LA_TEMPER_UNIT', align = b_ui.ALIGN.LEFT},
	t_unit_help = {t='help_btn', id=id+4, xywh='s_temp_param_t_unit_help_xywh',text='LA_UNIT_TAB',
					t_imgs = {b_ui.ALIGN.CENTER,'f_grade4','it_help','it_help', 'it_help'},
					color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
					color_f= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_f'}},
	t_unit		= {t='combox',	id=id+5,	xywh='s_temp_param_t_unit_xywh' ,
					items = {'LA_CELSIUS','LA_FAHRENHEIT'},cmd = on_unit_change},
	cap_len_unit	= {t='static',	id=id+6,	xywh='s_temp_param_cap_len_unit_xywh',text='LA_LENGTH_UNIT', align = b_ui.ALIGN.LEFT},
	t_len_unit_help = {t='help_btn', id=id+7, xywh='s_temp_param_t_len_unit_help_xywh',text='LA_DISTANCE_TAB',
					t_imgs = {b_ui.ALIGN.CENTER,'f_grade4','it_help','it_help', 'it_help'},
					color= { 'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_n'},
					color_f= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_btn_text_f'}},
	t_len_unit		= {t='combox',	id=id+8,	xywh='s_temp_param_t_len_unit_xywh' ,items = {'LA_METERS','LA_FEET'},cmd = on_unit_change_length},
	cap_ambient = {t='static',	id=id+9,	xywh='s_temp_param_cap_ambient_xywh',text='LA_AMBIENT_TEMPER', align = b_ui.ALIGN.LEFT},
	t_ambient = {t='edit_num',id=id+10,xywh='s_temp_param_t_ambient_xywh',negative_num_attr={true,6,2},cmd = on_update_param},
	cap_cavity = {t='static',	id=id+11,	xywh='s_temp_param_cap_cavity_xywh',text='LA_CAVITY_TEMPER', align = b_ui.ALIGN.LEFT},
	t_cavity = {t='edit_num',id=id+12,xywh='s_temp_param_t_cavity_xywh',negative_num_attr={true,6,2},cmd = on_update_param},
	t_cavity_u = {t='static',	id=id+13,	xywh='s_temp_param_t_cavity_u_xywh',text='', trans=false,align = b_ui.ALIGN.CENTER},
	cap_cor_coe= {t='static',	id=id+14,	xywh='s_temp_param_cap_cor_coe_xywh',text='LA_CORRECT_COEFFICIENT', align = b_ui.ALIGN.LEFT},
	t_cor_coe = {t='edit_num',id=id+15,xywh='s_temp_param_t_cor_coe_xywh',negative_num_attr={true,6,2},cmd = on_update_param},
	cap_mount_dis= {t='static',	id=id+16,	xywh='s_temp_param_cap_mount_dis_xywh',text='LA_MOUNT_DIS', align = b_ui.ALIGN.LEFT},
	t_mount_dis = {t='edit_num',id=id+17,xywh='s_temp_param_t_mount_dis_xywh',negative_num_attr={true,6,2},cmd = on_update_param},
	t_mount_dis_u= {t='static',	id=id+18,	xywh='s_temp_param_t_mount_dis_u_xywh', text='', trans=false, align = b_ui.ALIGN.CENTER},
	hline 	= {t='hline',	id=id+19,xywh='s_temp_param_hline_xywh'},
	cap_face_color	= {t='static',	id=id+20,	xywh='s_temp_param_cap_face_color_xywh',text='LA_FACE_COLOR', align = b_ui.ALIGN.LEFT},
	t_face_color 	= {t='tt_check',id=id+21,	xywh='s_temp_param_t_face_color_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	cap_arg_temp_cor	= {t='static',	id=id+22,	xywh='s_temp_param_cap_arg_temp_cor_xywh',text='LA_ARG_TEMP_COR', align = b_ui.ALIGN.LEFT},
	t_arg_temp_cor 	= {t='tt_check',id=id+23,	xywh='s_temp_param_t_arg_temp_cor_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	cap_abnormal	= {t='static',	id=id+24,	xywh='s_temp_param_cap_abnormal_xywh',text='LA_ABNORMAL_TEMPERATURE_DISPLAY', align = b_ui.ALIGN.LEFT},
	t_abnormal 	= {t='tt_check',id=id+25,	xywh='s_temp_param_t_abnormal_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	cap_temp_area	= {t='static',	id=id+26,	xywh='s_temp_param_cap_temp_area_xywh',text='LA_TEMP_AREA', align = b_ui.ALIGN.LEFT},
	t_temp_area		= {t='combox',	id=id+27,	xywh='s_temp_param_t_temp_area_xywh' ,
					items = {'LA_MODE_1','LA_MODE_2'},cmd = on_update_param},
	cap_temp_model	= {t='static',	id=id+28,	xywh='s_temp_param_cap_temp_model_xywh',text='LA_TEMP_MODE', align = b_ui.ALIGN.LEFT},
	t_temp_model	= {t='combox',	id=id+29,	xywh='s_temp_param_t_temp_model_xywh' ,
					items = {'LA_MODE_1','LA_MODE_2'},cmd = on_update_param},
	cap_nor_range	= {t='static',	id=id+30,	xywh='s_temp_param_cap_nor_range_xywh',text='LA_NORMAL_TEMPERATURE_RANGE', align = b_ui.ALIGN.LEFT},
	t_range_min = {t='edit_num',id=id+31,xywh='s_temp_param_t_range_min_xywh',negative_num_attr={true,7,2},cmd = on_update_param},
	t_range_con = {t='static',	id=id+32,	xywh='s_temp_param_t_range_con_xywh',text='~', trans = false, align = b_ui.ALIGN.CENTER},
	t_range_max = {t='edit_num',id=id+33,xywh='s_temp_param_t_range_max_xywh',negative_num_attr={true,7,2},cmd = on_update_param},
	t_range_u	= {t='static',	id=id+34,	xywh='s_temp_param_t_range_u_xywh',text='', trans = false, align = b_ui.ALIGN.CENTER},
}

return w1_page_param_conftemp_param