--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_privacy.phone_filter_id
local w1_key 		= require("wnd.w1_util.w1_key")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local util 			= require("wnd.core.util")
local w1_edit_phone_filter 	= require("wnd.w1_cfg.w1_edit_phone_filter")
local w1_msgbox		= require("wnd.w1_util.w1_msgbox")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local b_app_cfg  	= require("wnd.core.b_app_cfg")
local b_app_api		= require("wnd.core.command.b_app_api")

local w1_page_phone_filter = 
{
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_phone_filter.s_768 =
{
	s_phone_filter_t_enable_xywh = {277,25,25,21},
	s_phone_filter_list_w1 = {25,0,0,0},
	s_phone_filter_list_w2 = {157,0,0,0},
	--s_phone_filter_cap_listtip_xywh = {53,106,373,32},
	s_phone_filter_filterlist_xywh = {53,64,581,450},
	s_phone_filter_list_w4 = {120,0,0,0},
	s_phone_filter_list_w3 = {157,0,0,0},
	s_phone_filter_list_w5 = {80,0,0,0},
	s_phone_filter_tipinfo_xywh = {53,561,373,35},
	s_phone_filter_del_xywh = {90,526,26,35},
	s_phone_filter_add_xywh = {53,526,26,35},
};

w1_page_phone_filter.s_1280 = 
{
	s_phone_filter_t_enable_xywh = {455,36,48,30},
	--s_phone_filter_cap_listtip_xywh = {100,150,700,45},
	s_phone_filter_filterlist_xywh ={100,90,800,620},
	s_phone_filter_add_xywh = {100,740,50,50},
	s_phone_filter_del_xywh = {170,740,50,50},
	s_phone_filter_tipinfo_xywh = {100,790,700,50},
	s_phone_filter_list_w1 = {50,0,0,0},
	s_phone_filter_list_w2 = {200,0,0,0},
	s_phone_filter_list_w3 = {200,0,0,0},
	s_phone_filter_list_w4 = {200,0,0,0},
	s_phone_filter_list_w5 = {130,0,0,0},
}

w1_page_phone_filter.s_1440 = 
{
	s_phone_filter_t_enable_xywh = {520,30,48,30},
	--s_phone_filter_cap_listtip_xywh = {100,125,700,45},
	s_phone_filter_filterlist_xywh = {100,75,900,533},
	s_phone_filter_add_xywh = {100,620,50,45},
	s_phone_filter_del_xywh = {170,620,50,45},
	s_phone_filter_tipinfo_xywh = {100,680,700,50},
	s_phone_filter_list_w1 = {50,0,0,0},
	s_phone_filter_list_w2 = {218,0,0,0},
	s_phone_filter_list_w3 = {218,0,0,0},
	s_phone_filter_list_w4 = {218,0,0,0},
	s_phone_filter_list_w5 = {90,0,0,0},
}

w1_page_phone_filter.s_1080p = 
{
	s_phone_filter_t_enable_xywh = {520,36,48,30},
	--s_phone_filter_cap_listtip_xywh = {100,150,700,45},
	s_phone_filter_filterlist_xywh = {100,90,1090,620},
	s_phone_filter_add_xywh = {100,740,50,50},
	s_phone_filter_del_xywh = {170,740,50,50},
	s_phone_filter_tipinfo_xywh = {100,790,700,50},
	s_phone_filter_list_w1 = {50,0,0,0},
	s_phone_filter_list_w2 = {315,0,0,0},
	s_phone_filter_list_w3 = {315,0,0,0},
	s_phone_filter_list_w4 = {258,0,0,0},
	s_phone_filter_list_w5 = {130,0,0,0},
}

w1_page_phone_filter.s_2k = 
{
	s_phone_filter_t_enable_xywh = {693,48,64,40},
	--s_phone_filter_cap_listtip_xywh = {133,200,933,60},
	s_phone_filter_filterlist_xywh = {133,120,1453,850},
	s_phone_filter_add_xywh = {133,986,67,67},
	s_phone_filter_del_xywh = {227,986,67,67},
	s_phone_filter_tipinfo_xywh = {133,1053,933,67},
	s_phone_filter_list_w1 = {67,0,0,0},
	s_phone_filter_list_w2 = {403,0,0,0},
	s_phone_filter_list_w3 = {403,0,0,0},
	s_phone_filter_list_w4 = {300,0,0,0},
	s_phone_filter_list_w5 = {267,0,0,0},

}

w1_page_phone_filter.s_4k = 
{
	s_phone_filter_t_enable_xywh = {1040,72,96,60},
	--s_phone_filter_cap_listtip_xywh = {200,300,1400,90},
	s_phone_filter_filterlist_xywh = {200,180,2180,1240},
	s_phone_filter_add_xywh = {200,1480,100,100},
	s_phone_filter_del_xywh = {340,1480,100,100},
	s_phone_filter_tipinfo_xywh = {200,1580,1400,100},
	s_phone_filter_list_w1 = {100,0,0,0},
	s_phone_filter_list_w2 = {600,0,0,0},
	s_phone_filter_list_w3 = {600,0,0,0},
	s_phone_filter_list_w4 = {530,0,0,0},
	s_phone_filter_list_w5 = {280,0,0,0},

}
		
local refresh_list = function(top, redraw)
	local cwnd = w1_page_phone_filter.wnd
	local data = w1_page_phone_filter.data;
	local dispdata = {};
	dispdata.item_total = data.count;
	w1_edit_phone_filter.set_dlgattr(w1_page_phone_filter.data);
	
	for i=1,dispdata.item_total do
		dispdata['idx'..i] = nil;
		dispdata['idx'..i] ={};
		
		local status_str = nil;
		if (data['idx'..i].state == 1) then
			status_str = STR('LA_OFFLINE');
		elseif (data['idx'..i].state == 2) then
			status_str = STR('LA_ONLINE');
		else
			status_str = STR('LA_NOT_ACTIVED');
		end
		
		dispdata['idx'..i] = {i-1, false, '', 
			data['idx'..i].number, status_str, 
			data['idx'..i].remark,''};
	end
	b_wnd_ex.set_listdata(top, cwnd.filterlist.id, dispdata, false);
	
	if true == redraw then
		b_dlg.dlg_set_redraw(top);
	end
end

local showwidget = function(top, show,redraw)
	local cwnd = w1_page_phone_filter.wnd
	--b_wnd_ex.set_hide(top, cwnd.cap_rule.id, show, redraw);
	--b_wnd_ex.set_hide(top, cwnd.cap_listtip.id, show, redraw);
	b_wnd_ex.set_hide(top, cwnd.filterlist.id, show, redraw);
	b_wnd_ex.set_hide(top, cwnd.add.id, show, redraw);
	b_wnd_ex.set_hide(top, cwnd.del.id, show, redraw);
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')

	w1_page_phone_filter.data = cfgdata.phone_filter;

	
	local data = w1_page_phone_filter.data;
	local cwnd = w1_page_phone_filter.wnd;
	
	local function setcheck(id, str)
		b_wnd_ex.set_check(top, id, str,false)
	end
	setcheck(cwnd.t_enable.id,data['enable'] );
	if(data['enable'] == false) then
		showwidget(top, true, false)
	else
		showwidget(top, false, false)
	end
	
	refresh_list(top, false);
	
	--ѡ
	local listnum = data.count;

	local checklist = {};
	for i=1, listnum do
		checklist[i] = false;
	end
	
	b_wnd_ex.set_selecelist(top, cwnd.filterlist.id, checklist, false);
	b_wnd_ex.clear_checkall(top, cwnd.filterlist.id, false, false);
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_phone_filter.wnd;
	local cfg_data = cfgdata.phone_filter;
	local enable = b_wnd_ex.get_check(top, cwnd.t_enable.id);
	cfg_data.enable = enable;

	return 0
end

local get_listselect = function(top, win_id)
	local data = w1_page_phone_filter.data;
	local cwnd = w1_page_phone_filter.wnd;

	local checklist = {};	
	local listnum = data.count;
	local param = b_wnd_ex.get_selecelist(top, win_id);
	for i=1, listnum do
		checklist[i] = param['r'..i];
		if(checklist[i] == 0) then
			checklist[i] = false;
		else
			checklist[i] = true;			
		end
	end
	return checklist;
end

local del_list = function(data, sel)
	local listtotal = data.count;
	data.count = data.count - 1;
	
	--listitemǰŲһ
	for i = sel+1, listtotal do
		data['idx'..i-1] = data['idx'..i];
	end
	--listitemΪnil
	data['idx'..listtotal] = nil;
end

local ok_func = function(param)
	local data = w1_page_phone_filter.data;
	local cwnd = w1_page_phone_filter.wnd
	local number ,state ,remark = w1_edit_phone_filter.get_number_state();
	
	--ͨ
	local idx;
	if(param[2] == w1_edit_phone_filter.PAGE_EDIT) then
		assert(type(param[3]) == 'number')
		idx = param[3];
--[[		local phone_num = {};
		phone_num.phone_num = data['idx'..idx].number;
		b_app_api.del_phone_num(phone_num);
		
		phone_num.phone_num = number;
		phone_num.state = state;
		phone_num.remark = remark;
		b_app_api.add_phone_num(phone_num);--]]
		for k, v in pairs(data) do
			if (k ~= 'count' and k ~= 'enable') then
				if (v.number == number) then
					v.remark = remark;
					break;
				end
			end
		end	
		
--[[		data['idx'..idx].number = number;
		data['idx'..idx].state = state;
		data['idx'..idx].remark = remark;--]]
	elseif(param[2] == w1_edit_phone_filter.PAGE_ADD) then	
		idx = data.count + 1;
		data.count = data.count + 1;
		data['idx'..idx] = {};
		data['idx'..idx].number = number;
		data['idx'..idx].state = state;
		data['idx'..idx].remark = remark;
		
--[[		local phone_num = {};
		phone_num.phone_num = number;
		phone_num.state = state;
		phone_num.remark = remark;
		b_app_api.add_phone_num(phone_num);--]]
	elseif(param[2] == w1_edit_phone_filter.PAGE_DEL) then
		assert(type(param[3]) == 'number')
		idx = param[3];

--[[		local phone_num = {};
		phone_num.phone_num = data['idx'..idx].number;
		b_app_api.del_phone_num(phone_num);--]]
		
		del_list(data, idx);	
		b_wnd_ex.clear_checkall(param[1], cwnd.filterlist.id, false, false);
	end	
	
	refresh_list(param[1], true)	
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_phone_filter.init = function(top)
	w1_wnd_util.cfgtab = {'phone_filter'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	
	local cwnd = w1_page_phone_filter.wnd;
	w1_edit_phone_filter.init();
	w1_edit_phone_filter.set_func (ok_func, {top}, nil, nil);
	return 0
end

w1_page_phone_filter.clear_data = function()
	w1_page_phone_filter.data = nil;
	w1_edit_phone_filter.clear_data();
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

w1_page_phone_filter.timer_start = function()
	w1_page_phone_filter.timestart = true
end

w1_page_phone_filter.timer_stop = function(top)
	w1_page_phone_filter.timestart = false
	w1_wnd_util.tipclear(top, w1_page_phone_filter.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_phone_filter.timerenevt = function(top)
	if(w1_page_phone_filter.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_phone_filter.wnd.tipinfo.id)
	end
	return 0
end

local on_check = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then	
		local check = b_wnd_ex.get_check(top, win_id);
		if(check) then
			showwidget(top , false, false);
		else
			showwidget(top , true, false);
		end
		b_dlg.dlg_set_redraw(top);
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then	
		local cwnd = w1_page_phone_filter.wnd	
		local data = w1_page_phone_filter.data;

		if(data.count == 20) then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_EXCEED_MAX_NUM'), true, false,false);
			w1_msgbox.set_func(nil, nil, nil, nil);
			b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
			return 0
		end

		w1_edit_phone_filter.set_phonenum_state('', '');	
		b_dlg.post_modal(top, w1_key.DLG_MSG_EDIT_PHONE_FILTER, 0, 0, nil);
	end
	return 0
end

local del_refresh_list = function()
	local del_date = {}
	local data = w1_page_phone_filter.data;		
	del_date.enable = data.enable;
	
	local idx = 1;
	for i = 1,data.count do
		if( data['idx'..i] ~= nil ) then
			del_date['idx'..idx] = {};
			if(del_date['idx'..idx] == nil) then
				del_date['idx'..idx] = util.copy_tab(data['idx'..i]);
			else
				util.copy_tab_b(del_date['idx'..idx], data['idx'..i]);
			end
			
			if(data['idx'..idx] == nil) then		
				data['idx'..idx] = util.copy_tab(del_date['idx'..idx]);
			else
				util.copy_tab_b(data['idx'..idx], del_date['idx'..idx]);
			end
			idx = idx + 1;
		end
	end
	del_date.count = idx - 1;
	
	if(del_date.count ~= data.count) then
		for i = del_date.count + 1,data.count do
			data['idx'..i] = nil;
		end	
		data.count = del_date.count;
	end
end

local on_del_ok = function(param)
	local data = w1_page_phone_filter.data;		
	local listtotal = data.count;
	local deltable = {};
	local index = 0;

	for i = 1, listtotal do
		if( param[2]['r'..i] == 1 ) then
			index = index + 1;
			
--[[			local phone_num = {};
			phone_num.phone_num = data['idx'..i].number;
			b_app_api.del_phone_num(phone_num);--]]
			
			data['idx'..i] = nil;		
		end
	end
	
	data.count = data.count - index;

	local listidx = 1;
	for i = 1, listtotal do
		if(data['idx'..i] ~= nil) then
			data['idx'..listidx] = data['idx'..i];
			listidx = listidx + 1;
		end
	end
	
	for i = listtotal - index + 1, listtotal do
		data['idx'..i] = nil;
	end
	
	local cwnd = w1_page_phone_filter.wnd	
	local checktab = {};	
	for i=1,listtotal do
		checktab[i] = false;
	end
	b_wnd_ex.set_selecelist(param[1], cwnd.filterlist.id, checktab, false);		
	
	del_refresh_list();
	refresh_list(param[1], true);
	return 0;
end

local on_del = function(top, win_id, vmsg, x, y)
	if( b_ui.LBUTTONCLK == vmsg )then
		local selectlist = b_wnd_ex.get_selecelist(top, w1_page_phone_filter.wnd.filterlist.id);
		local data = w1_page_phone_filter.data;
		local selectflag = false;
		local num = data.count;

		for i = 1, num do
			if( selectlist['r'..i] == 1 ) then
				selectflag = true;
				break;
			end
		end
		if(selectflag) then
			w1_msgbox.set_dlgattr(STR(''), STR('LA_CONFIRM_DELETE'), true, true,false);
			w1_msgbox.set_func(on_del_ok, {top, selectlist}, nil, nil);
		else
			w1_msgbox.set_dlgattr(STR(''), STR('LA_NO_SELECT'), true, false,false);
			w1_msgbox.set_func(nil, nil, nil, nil);
		end
		b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)		
	end
	return 0
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()	--ʾ
	end
	return 0
end

w1_page_phone_filter.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_phone_filter.on_pre_show = function(top)
	local param = {
			'', STR('LA_PHONE_NUMBER'),STR('LA_STATUS'),STR('LA_REMARK'),STR('LA_EDIT')
		}	
	b_wnd_ex.set_title_texts(top, w1_page_phone_filter.wnd.filterlist.id, param, false)
	local list_w = {};
	for i=1,5 do
		local str = 's_phone_filter_list_w'..math.floor(i/1);
		list_w[i] = SIZE(str)[1];
	end
	b_wnd_ex.columns_w(top, w1_page_phone_filter.wnd.filterlist.id, list_w, false);
end

w1_page_phone_filter.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_enable','t_enable',	'filterlist',
			'add', 'del',
			'tipinfo', 'default', 'apply' },
	cap_enable 	= {t='static',id=id+1,xywh='s_cfg_page_1_1',text='LA_ENABLE_WHITE_LIST'},
	t_enable 	= {t='tt_check', id=id+2,xywh='s_phone_filter_t_enable_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_check},

	filterlist	= {t='list',	id=id+3,	xywh='s_phone_filter_filterlist_xywh', font = 'f_grade4',
					listattr = {16,5,b_ui.LISTATTR.FIRST_WIDGET_CHECK, b_ui.LISTATTR.END_WIDGET_EDITDEL},
					columns_w = {50,300,300,130},
					dlg_key = {w1_key.DLG_MSG_EDIT_PHONE_FILTER, w1_key.DLG_MSG_EDIT_PHONE_FILTER};
					},

	add 		= {t='tt_button',	id=id+4,	xywh='s_phone_filter_add_xywh',		
					t_imgs = {b_ui.ALIGN.CENTER,'f_grade1','it_add','it_add', 'it_add'},
					color = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_f'},
					cmd = on_add},
	del			= {t='tt_button',id=id+5,	xywh='s_phone_filter_del_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_grade1','it_del','it_del', 'it_del'},
					color = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_f'},
					cmd = on_del},
	
	tipinfo		= {t='static',	id=id+6,	xywh='s_phone_filter_tipinfo_xywh',		text='',		trans = false},
				
	apply 		= {t='button',	id=id+7,	xywh='s_cfg_apply_xywh', 	text='LA_APPLY',	cmd=on_apply},
}

return w1_page_phone_filter



