--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/9/14
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_ai.plate_ledcfg_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_legal 		= require("wnd.w1_util.w1_legal")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local global_val	= require("wnd.global_val")
local b_dlg 	= require("wnd.core.b_dlg")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str

local vdor_max_value = 11;
local vdor_cap_value = 7;

local w1_page_plateledcfg = 
{
	cfg_data,
	vdor_cur_idx = nil;
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_plateledcfg.s_768 = 
{
	s_cfg_page_plate_led_cfg_xywh = {53,320,746,248},
	s_ledcfg_cap_enable_led_xywh = {32,0,229,32},
	s_ledcfg_t_enable_led_xywh = {277,4,25,21},
	s_ledcfg_item_cap_xywh = {32,0,229,32},
	s_ledcfg_item_t_xywh = {281,0,133,32},
	s_ledcfg_item_xywh = {0,0,0,35},
	s_ledcfg_vdrop_xywh = {586,0,10,248},
};


w1_page_plateledcfg.s_1280 = 
{
	s_cfg_page_plate_led_cfg_xywh		 = {60,440,950,310},
	s_ledcfg_cap_enable_led_xywh		 = {60, 0,430,40},
	s_ledcfg_t_enable_led_xywh           = {520, 5,48,30},
	s_ledcfg_item_cap_xywh           	 = {60, 0,430,40},	
	s_ledcfg_item_t_xywh           		 = {527, 0,250,40},	
	s_ledcfg_item_xywh           		 = {0, 0,0,45},	
	s_ledcfg_vdrop_xywh 				 = {850,0,20,310},
};

w1_page_plateledcfg.s_1440 = 
{
	s_cfg_page_plate_led_cfg_xywh		 = {60,332,950,310},
	s_ledcfg_cap_enable_led_xywh		 = {60, 0,430,40},
	s_ledcfg_t_enable_led_xywh           = {520, 5,48,30},
	s_ledcfg_item_cap_xywh           	 = {60, 0,430,40},	
	s_ledcfg_item_t_xywh           		 = {527, 0,250,40},	
	s_ledcfg_item_xywh           		 = {0, 0,0,45},	
	s_ledcfg_vdrop_xywh 				 = {850,0,20,310},
};

w1_page_plateledcfg.s_1080p = 
{
	s_cfg_page_plate_led_cfg_xywh 		 = {100,450,1400,350},
	s_ledcfg_cap_enable_led_xywh		 = {60, 0,430,45},
	s_ledcfg_t_enable_led_xywh           = {520, 7,48,30},
	s_ledcfg_item_cap_xywh           	 = {60, 0,430,45},	
	s_ledcfg_item_t_xywh           		 = {527, 0,250,45},	
	s_ledcfg_item_xywh           		 = {0, 0,0,50},	
	s_ledcfg_vdrop_xywh 				 = {1100,0,20,350},
};

w1_page_plateledcfg.s_2k = 
{
	s_cfg_page_plate_led_cfg_xywh = {133,600,1866,500},
	s_ledcfg_cap_enable_led_xywh		 = {80, 0,520,60},
	s_ledcfg_t_enable_led_xywh           = {693, 10,48,40},
	s_ledcfg_item_cap_xywh           	 = {80, 0,520,60},	
	s_ledcfg_item_t_xywh           		 = {703, 0,333,60},	
	s_ledcfg_item_xywh           		 = {0, 0,0,70},	
	s_ledcfg_vdrop_xywh 				 = {1500,0,30,500},
};

w1_page_plateledcfg.s_4k = 
{
	s_cfg_page_plate_led_cfg_xywh 		 = {200,900,2800,700},
	s_ledcfg_cap_enable_led_xywh		 = {120, 0,860,90},
	s_ledcfg_t_enable_led_xywh           = {1040, 15,96,60},
	s_ledcfg_item_cap_xywh           	 = {120, 0,860,90},	
	s_ledcfg_item_t_xywh           		 = {1054, 0,500,90},	
	s_ledcfg_item_xywh           		 = {0, 0,0,100},	
	s_ledcfg_vdrop_xywh 				 = {2200,0,40,700},
};

w1_page_plateledcfg.clear_data=function ()
	w1_page_plateledcfg.cfg_data = nil;
end
--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local data = w1_page_plateledcfg.cfg_data;
	local cwnd = w1_page_plateledcfg.wnd;		
		
	local check = b_wnd_ex.get_check(top, cwnd.t_enable_led.id);
	if (check == true) then
		data.DisplayEnable = 1;
	else
		data.DisplayEnable = 0;
	end	
	data.ID = b_wnd_ex.get_text(top, cwnd.t_screen_id.id);
	data.IP = b_wnd_ex.get_text(top, cwnd.t_screen_ip.id);	
	data.AudioEnable = b_wnd_ex.get_value(top, cwnd.t_volumn.id);	
	data.Brightness = b_wnd_ex.get_value(top, cwnd.t_light.id);	
	data.RollSpeed = b_wnd_ex.get_value(top, cwnd.t_speed.id);	
	data.PlateStayTime = b_wnd_ex.get_value(top, cwnd.t_dsp_time.id);	
	data.IdleText = b_wnd_ex.get_text(top, cwnd.t_idle_dsp.id);	
	data.WhiteListText = b_wnd_ex.get_text(top, cwnd.t_white_dsp.id);	
	data.BlackListText = b_wnd_ex.get_text(top, cwnd.t_black_dsp.id);	
	data.NoListText = b_wnd_ex.get_text(top, cwnd.t_not_login.id);	
	data.change_flag = true;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.LBUTTONCLK == vmsg or b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,w1_page_plateledcfg.cfg_data)
	end
	return 0;
end

local update_layout_info = function(top, redraw)
	local item = SIZE('s_ledcfg_item_xywh');
	local row_move_h = item[4];
	local cur_idx = w1_page_plateledcfg.vdor_cur_idx;
	
	local cap_pos = SIZE('s_ledcfg_item_cap_xywh');	
	local t_pos = SIZE('s_ledcfg_item_t_xywh');

	--ȫ
	local cwnd = w1_page_plateledcfg.wnd;
	local s_id = cwnd.cap_enable_led.id;
	local e_id = cwnd.t_not_login.id;
	for i = s_id, e_id do
		b_wnd_ex.set_hide(top, i, true, false);
	end	
	
	local vdrop = {};
	vdrop.set_cur = w1_page_plateledcfg.vdor_cur_idx;
	vdrop.set_cap = vdor_cap_value;
	vdrop.set_max = vdor_max_value;
	b_wnd_ex.set_drop(top,w1_page_plateledcfg.wnd.t_vdrop.id,vdrop,false);		
	b_wnd_ex.set_hide(top, cwnd.t_vdrop.id, false, false);	
	
	s_id = id + 1 + 2 * cur_idx;
	e_id = s_id  - 1 + 2 * vdor_cap_value;
	for i = s_id, e_id, 2 do
		b_wnd_ex.set_hide(top, i, false, false);
		b_wnd_ex.set_hide(top, i + 1, false, false);
		local row = math.floor((i - s_id)/2);	
		if (i ~= id + 1) then --ǵһУ һвҪƶλ
			b_wnd_ex.move_ex(top, i, {cap_pos[1], cap_pos[2] + row * row_move_h, cap_pos[3], cap_pos[4]}, false);
			b_wnd_ex.move_ex(top, i + 1, {t_pos[1], t_pos[2] + row * row_move_h, t_pos[3], t_pos[4]}, false);
		end
	end
	
	if (redraw) then
		b_dlg.dlg_set_redraw(top);		
	end
end

w1_page_plateledcfg.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_plateledcfg.wnd;
	if bool_hide == false then
		update_layout_info(top, redraw)
	else
		local cwnd = w1_page_plateledcfg.wnd;
		local s_id = cwnd.cap_screen_id.id;
		local e_id = cwnd.t_vdrop.id;
		for i = s_id, e_id do
			b_wnd_ex.set_hide(top, i, true, false);
		end	
		b_dlg.dlg_set_redraw(top);		
	end
end

local on_enable = function(top, win_id, vmsg, x, y)
	if(b_ui.LBUTTONCLK == vmsg) then
		local check = b_wnd_ex.get_check(top, w1_page_plateledcfg.wnd.t_enable_led.id);
		if (check == true) then
			vdor_max_value = 11;
			update_layout_info(top, true);
		else
			local cwnd = w1_page_plateledcfg.wnd;
			local s_id = cwnd.cap_screen_id.id;
			local e_id = cwnd.t_vdrop.id;
			for i = s_id, e_id do
				b_wnd_ex.set_hide(top, i, true, false);
			end	
			
			vdor_max_value = 1;
			local vdrop = {};
			vdrop.set_cur = w1_page_plateledcfg.vdor_cur_idx;
			vdrop.set_cap = vdor_cap_value;
			vdrop.set_max = vdor_max_value;
			b_wnd_ex.set_drop(top,w1_page_plateledcfg.wnd.t_vdrop.id,vdrop,false);					
			b_dlg.dlg_set_redraw(top);		
		end
		uitousercfg(top,w1_page_plateledcfg.cfg_data)
	end
	
	return 0;
end

w1_page_plateledcfg.set_param = function(top, param, redraw)
	w1_page_plateledcfg.cfg_data = param;
	w1_page_plateledcfg.vdor_cur_idx = 0;
	local cwnd = w1_page_plateledcfg.wnd;		
		
	if (param.DisplayEnable == 1) then	
		b_wnd_ex.set_check(top, cwnd.t_enable_led.id, true, false);
	else
		b_wnd_ex.set_check(top, cwnd.t_enable_led.id, false, false);
	end
	b_wnd_ex.set_text(top, cwnd.t_screen_id.id, param.ID, false);
	b_wnd_ex.set_text(top, cwnd.t_screen_ip.id, param.IP, false);	
	b_wnd_ex.set_value(top, cwnd.t_volumn.id, param.AudioEnable, false);	
	b_wnd_ex.set_value(top, cwnd.t_light.id, param.Brightness, false);	
	b_wnd_ex.set_value(top, cwnd.t_speed.id, param.RollSpeed, false);	
	b_wnd_ex.set_value(top, cwnd.t_dsp_time.id, param.PlateStayTime, false);	
	b_wnd_ex.set_text(top, cwnd.t_idle_dsp.id, param.IdleText, false);	
	b_wnd_ex.set_text(top, cwnd.t_white_dsp.id, param.WhiteListText, false);	
	b_wnd_ex.set_text(top, cwnd.t_black_dsp.id, param.BlackListText, false);	
	b_wnd_ex.set_text(top, cwnd.t_not_login.id, param.NoListText, false);	

	local check = b_wnd_ex.get_check(top, w1_page_plateledcfg.wnd.t_enable_led.id);
	if (true == check) then
		vdor_max_value = 11;
		update_layout_info(top, false);
	else
		local cwnd = w1_page_plateledcfg.wnd;
		local s_id = cwnd.cap_screen_id.id;
		local e_id = cwnd.t_vdrop.id;
		for i = s_id, e_id do
			b_wnd_ex.set_hide(top, i, true, false);
		end	
		
		vdor_max_value = 1;
		local vdrop = {};
		vdrop.set_cur = w1_page_plateledcfg.vdor_cur_idx;
		vdrop.set_cap = vdor_cap_value;
		vdrop.set_max = vdor_max_value;
		b_wnd_ex.set_drop(top,w1_page_plateledcfg.wnd.t_vdrop.id,vdrop,false);					
	end
	
	if (redraw) then
		b_dlg.dlg_set_redraw(top);		
	end
end

w1_page_plateledcfg.datacheck = function(top)
	local cwnd = w1_page_plateledcfg.wnd;		
	local nlegalid = {};
	local legal = true;
	local check = b_wnd_ex.get_check(top, w1_page_plateledcfg.wnd.t_enable_led.id);
	if(check == true) then
		local num;
		legal, num= w1_legal.check_ip(top, cwnd.t_screen_ip.id);	
		if(legal == false) then
			table.insert(nlegalid, cwnd.t_screen_ip.id);
			if(num == w1_legal.ip.EMPTY) then
				w1_wnd_util.setparamerr_str(STR('LA_CORRECT_IP'));
			elseif(num == w1_legal.ip.LENERR or num == w1_legal.ip.PRARMERR) then
				w1_wnd_util.setparamerr_str(STR('LA_CORRECT_IP'));
			end
		end	
	
		local err_str = string.match(w1_page_plateledcfg.cfg_data.ID, "(%W)");
		if (w1_page_plateledcfg.cfg_data.ID == "" or err_str ~= nil) then
			legal = false;
			table.insert(nlegalid, cwnd.t_screen_id.id);
			w1_wnd_util.setparamerr_str(STR('LA_SCREEN_ID_ERR'));
		end
	end
	
	return legal,nlegalid
end

w1_page_plateledcfg.dwell_updata_f =function(top)
	if vdor_max_value > vdor_cap_value then
		w1_page_plateledcfg.vdor_cur_idx = b_wnd_ex.get_drop(top,w1_page_plateledcfg.wnd.t_vdrop.id);
		update_layout_info(top, false);
		b_dlg.dlg_set_redraw(top);
	end
end

w1_page_plateledcfg.dwell_mouse_up =function(top)
	if vdor_max_value > vdor_cap_value then
		if w1_page_plateledcfg.vdor_cur_idx > 0 then
			w1_page_plateledcfg.vdor_cur_idx = w1_page_plateledcfg.vdor_cur_idx - 1
		else
			return 0;			
		end
		local vdrop = {};
		vdrop.set_cur = w1_page_plateledcfg.vdor_cur_idx;
		vdrop.set_cap = vdor_cap_value;
		vdrop.set_max = vdor_max_value;
		b_wnd_ex.set_drop(top,w1_page_plateledcfg.wnd.t_vdrop.id,vdrop,false);
		update_layout_info(top, false);
		b_dlg.dlg_set_redraw(top);		
	end
end

w1_page_plateledcfg.dwell_mouse_down =function(top)
	if vdor_max_value > vdor_cap_value then
		if w1_page_plateledcfg.vdor_cur_idx < vdor_max_value - vdor_cap_value then
			w1_page_plateledcfg.vdor_cur_idx = w1_page_plateledcfg.vdor_cur_idx+1
		else
			return 0;
		end
		local vdrop = {};
		vdrop.set_cur = w1_page_plateledcfg.vdor_cur_idx;
		vdrop.set_cap = vdor_cap_value;
		vdrop.set_max = vdor_max_value;
		b_wnd_ex.set_drop(top,w1_page_plateledcfg.wnd.t_vdrop.id,vdrop,false);
		update_layout_info(top, false);
		b_dlg.dlg_set_redraw(top);		
	end
end

w1_page_plateledcfg.dwell_drop_drag =function(top)
	if vdor_max_value > vdor_cap_value then
		w1_page_plateledcfg.vdor_cur_idx = b_wnd_ex.get_drop(top,w1_page_plateledcfg.wnd.t_vdrop.id);
		update_layout_info(top, true);
	end
end

w1_page_plateledcfg.on_pre_show = function(top)
	w1_page_plateledcfg.vdor_cur_idx = 0;
	update_layout_info(top, false);
end

w1_page_plateledcfg.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_plate_led_cfg_xywh',
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub = {'cap_enable_led','t_enable_led','cap_screen_id','t_screen_id', 'cap_screen_ip','t_screen_ip', 'cap_volumn', 't_volumn','cap_light', 't_light',
			'cap_speed', 't_speed', 'cap_dsp_time', 't_dsp_time', 'cap_idle_dsp', 't_idle_dsp',
			'cap_white_dsp', 't_white_dsp', 'cap_black_dsp', 't_black_dsp', 'cap_not_login', 't_not_login', 't_vdrop'},

	cap_enable_led= {t='static',	id=id+1,	xywh='s_ledcfg_cap_enable_led_xywh',text='LA_LED_SWITCH', align = b_ui.ALIGN.LEFT},
	t_enable_led = {t='tt_check',id=id+2,	xywh='s_ledcfg_t_enable_led_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_enable},
	
	cap_screen_id= {t='static',	id=id+3,	xywh='s_ledcfg_item_cap_xywh',text='LA_LED_ID', align = b_ui.ALIGN.LEFT},
	t_screen_id 	= {t='edit', id=id+4,	xywh = 's_ledcfg_item_t_xywh', max_value = 12,text = '',trans = false, cmd = on_update_param},	

	cap_screen_ip 	= {t='static',id=id+5,xywh='s_ledcfg_item_cap_xywh',text='LA_LED_IP'},
	t_screen_ip 	= {t='edit_ip',  id=id+6,xywh='s_ledcfg_item_t_xywh',cmd = on_update_param},

	cap_volumn= {t='static',	id=id+7,	xywh='s_ledcfg_item_cap_xywh',text='LA_Volume', align = b_ui.ALIGN.LEFT},
	t_volumn = {t='edit_num',id=id+8,xywh='s_ledcfg_item_t_xywh',range={0,9},cmd = on_update_param},

	cap_light= {t='static',	id=id+9,	xywh='s_ledcfg_item_cap_xywh',text='LA_BRIGHTNESS', align = b_ui.ALIGN.LEFT},
	t_light = {t='edit_num',id=id+10,xywh='s_ledcfg_item_t_xywh',range={0,15},cmd = on_update_param},

	cap_speed= {t='static',	id=id+11,	xywh='s_ledcfg_item_cap_xywh',text='LA_SCROLL_SPEED', align = b_ui.ALIGN.LEFT},
	t_speed = {t='edit_num',id=id+12,xywh='s_ledcfg_item_t_xywh',range={1,100},cmd = on_update_param},

	cap_dsp_time= {t='static',	id=id+13,	xywh='s_ledcfg_item_cap_xywh',text='LA_LED_SHOW_TIME', align = b_ui.ALIGN.LEFT},
	t_dsp_time = {t='edit_num',id=id+14,xywh='s_ledcfg_item_t_xywh',range={0,999999},cmd = on_update_param},

	cap_idle_dsp= {t='static',	id=id+15,	xywh='s_ledcfg_item_cap_xywh',text='LA_IDLE_DISPLAY', align = b_ui.ALIGN.LEFT},
	t_idle_dsp 	= {t='edit',  	id=id+16,	xywh = 's_ledcfg_item_t_xywh', text = '',trans = false, cmd = on_update_param},	

	cap_white_dsp= {t='static',	id=id+17,	xywh='s_ledcfg_item_cap_xywh',text='LA_WHITELIST_OVERLAY_DISPLAY', align = b_ui.ALIGN.LEFT},
	t_white_dsp 	= {t='edit', id=id+18,	xywh = 's_ledcfg_item_t_xywh', text = '',trans = false, cmd = on_update_param},	
	
	cap_black_dsp= {t='static',	id=id+19,	xywh='s_ledcfg_item_cap_xywh',text='LA_BLACKLIST_OVERLAY_DISPLAY', align = b_ui.ALIGN.LEFT},
	t_black_dsp 	= {t='edit', id=id+20,	xywh = 's_ledcfg_item_t_xywh', text = '',trans = false, cmd = on_update_param},	
	
	cap_not_login= {t='static',	id=id+21,	xywh='s_ledcfg_item_cap_xywh',text='LA_LICENSE_SHOW', align = b_ui.ALIGN.LEFT},
	t_not_login 	= {t='edit', id=id+22,	xywh = 's_ledcfg_item_t_xywh', text = '',trans = false, cmd = on_update_param},	

	t_vdrop = {t='vdrop', id=id+23,xywh='s_ledcfg_vdrop_xywh'};

}

return w1_page_plateledcfg

