--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/9/14
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_ai.plate_param_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local global_val	= require("wnd.global_val")
local b_dlg 	= require("wnd.core.b_dlg")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local w1_page_plateparam = 
{
	cfg_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_plateparam.s_768 =
{
	s_cfg_page_plate_param_xywh = {53,320,746,220},
	s_plate_cap_plate_detect_xywh = {32,0,149,32},
	s_plate_t_plate_detect_xywh = {237,4,25,21},
	s_plate_cap_vehicle_detect_xywh = {32,35,149,32},
	s_plate_t_vehicle_detect_xywh = {237,40,25,21},
	s_plate_cap_trace_info_xywh = {32,106,149,32},
	s_plate_t_trace_info_xywh = {237,111,25,21},
	s_plate_cap_con_coe_xywh = {32,142,149,32},
	s_plate_t_con_coe_xywh = {240,142,117,32},
	s_plate_cap_pix_min_xywh = {32,177,149,32},
	s_plate_t_pix_min_xywh = {237,182,25,21},
	s_plate_cap_mat_qua_xywh = {32,213,149,32},
	s_plate_t_mat_qua_xywh = {240,213,117,32},

	s_plate_cap_snap_mode_xywh = {376,0,149,32},
	s_plate_t_snap_mode_xywh = {584,0,117,32},
	s_plate_cap_img_int_xywh = {376,35,154,32},
	s_plate_t_img_int_xywh = {584,35,117,32},
	s_plate_cap_ftp_img_mat_xywh = {376,142,149,32},
	s_plate_t_ftp_img_mat_xywh = {581,147,25,21},
	s_plate_cap_ftp_whole_img_xywh = {376,177,149,32},
	s_plate_t_ftp_whole_img_xywh = {581,182,25,21},
	s_plate_cap_alg_lib_ver_xywh = {376,213,149,32},
	s_plate_t_alg_lib_ver_xywh = {584,213,117,32},
	s_plate_hline_xywh = {368,0,1,142},
	s_plate_vdrop_xywh = {706,0,10,277},
	s_plate_l_cap_line = {32,0,170,32},
	s_plate_l_t_line = {240,0,117,32},
	s_plate_r_cap_line = {376,0,170,32},
	s_plate_r_t_line = {584,0,117,32},
	s_plate_tt_check_xywh = {2,4,25,21},
	s_plate_int_xywh = {0,0,35,0},
};

w1_page_plateparam.s_1280 = 
{
	s_cfg_page_plate_param_xywh = {60,440,900,310},
	s_plate_cap_plate_detect_xywh = {40,0,270,45},
	s_plate_t_plate_detect_xywh = {315,7,48,30},
	s_plate_cap_vehicle_detect_xywh = {40,50,270,45},
	s_plate_t_vehicle_detect_xywh = {315,57,48,30},
	s_plate_cap_trace_info_xywh = {40,150,270,45},
	s_plate_t_trace_info_xywh = {320,157,48,30},
	s_plate_cap_con_coe_xywh = {40,200,270,45},
	s_plate_t_con_coe_xywh = {320,200,160,45},
	s_plate_cap_pix_min_xywh = {40,250,270,45},
	s_plate_t_pix_min_xywh = {320,250,160,45},
	s_plate_cap_mat_qua_xywh = {40,300,270,45},
	s_plate_t_mat_qua_xywh = {320,300,160,45},

	s_plate_cap_snap_mode_xywh = {505,0,270,45},
	s_plate_t_snap_mode_xywh = {780,0,160,45},
	s_plate_cap_img_int_xywh = {505,50,270,45},
	s_plate_t_img_int_xywh = {775,50,160,45},
	s_plate_cap_ftp_img_mat_xywh = {505,200,270,45},
	s_plate_t_ftp_img_mat_xywh = {775,207,48,30},
	s_plate_cap_ftp_whole_img_xywh = {505,250,270,45},
	s_plate_t_ftp_whole_img_xywh = {775,257,48,30},
	s_plate_cap_alg_lib_ver_xywh = {505,300,270,45},
	s_plate_t_alg_lib_ver_xywh = {780,300,160,45},
	s_plate_hline_xywh = {495,0,1,200},
	s_plate_vdrop_xywh = {940,0,20,350},
	s_plate_l_cap_line = {40,0,270,45},
	s_plate_l_t_line = {320,0,160,45},
	s_plate_r_cap_line = {505,0,270,45},
	s_plate_r_t_line = {780,0,160,45},
	s_plate_tt_check_xywh = {5,7,48,30},
	s_plate_int_xywh = {0,0,50,0}
};

w1_page_plateparam.s_1440 = 
{
	s_cfg_page_plate_param_xywh = {60,332,900,245},
	s_plate_cap_plate_detect_xywh = {40,0,270,45},
	s_plate_t_plate_detect_xywh = {315,7,48,30},
	s_plate_cap_vehicle_detect_xywh = {40,50,270,45},
	s_plate_t_vehicle_detect_xywh = {315,57,48,30},
	s_plate_cap_trace_info_xywh = {40,150,270,45},
	s_plate_t_trace_info_xywh = {320,157,48,30},
	s_plate_cap_con_coe_xywh = {40,200,270,45},
	s_plate_t_con_coe_xywh = {320,200,160,45},
	s_plate_cap_pix_min_xywh = {40,250,270,45},
	s_plate_t_pix_min_xywh = {320,250,160,45},
	s_plate_cap_mat_qua_xywh = {40,300,270,45},
	s_plate_t_mat_qua_xywh = {320,300,160,45},

	s_plate_cap_snap_mode_xywh = {505,0,270,45},
	s_plate_t_snap_mode_xywh = {780,0,160,45},
	s_plate_cap_img_int_xywh = {505,50,270,45},
	s_plate_t_img_int_xywh = {775,50,160,45},
	s_plate_cap_ftp_img_mat_xywh = {505,200,270,45},
	s_plate_t_ftp_img_mat_xywh = {775,207,48,30},
	s_plate_cap_ftp_whole_img_xywh = {505,250,270,45},
	s_plate_t_ftp_whole_img_xywh = {775,257,48,30},
	s_plate_cap_alg_lib_ver_xywh = {505,300,270,45},
	s_plate_t_alg_lib_ver_xywh = {780,300,160,45},
	s_plate_hline_xywh = {495,0,1,200},
	s_plate_vdrop_xywh = {950,0,20,350},
	s_plate_l_cap_line = {40,0,270,45},
	s_plate_l_t_line = {320,0,160,45},
	s_plate_r_cap_line = {505,0,270,45},
	s_plate_r_t_line = {780,0,160,45},
	s_plate_tt_check_xywh = {5,7,48,30},
	s_plate_int_xywh = {0,0,50,0}
};

w1_page_plateparam.s_1080p = 
{
	s_cfg_page_plate_param_xywh = {100,450,1400,310},
	s_plate_cap_plate_detect_xywh = {60,0,280,45},
	s_plate_t_plate_detect_xywh = {445,7,48,30},
	s_plate_cap_vehicle_detect_xywh = {60,50,280,45},
	s_plate_t_vehicle_detect_xywh = {445,57,48,30},
	s_plate_cap_trace_info_xywh = {60,150,280,45},
	s_plate_t_trace_info_xywh = {445,157,48,30},
	s_plate_cap_con_coe_xywh = {60,200,280,45},
	s_plate_t_con_coe_xywh = {450,200,220,45},
	s_plate_cap_pix_min_xywh = {60,250,280,45},
	s_plate_t_pix_min_xywh = {445,257,48,30},
	s_plate_cap_mat_qua_xywh = {60,300,280,45},
	s_plate_t_mat_qua_xywh = {450,300,220,45},

	s_plate_cap_snap_mode_xywh = {705,0,280,45},
	s_plate_t_snap_mode_xywh = {1095,0,220,45},
	s_plate_cap_img_int_xywh = {705,50,290,45},
	s_plate_t_img_int_xywh = {1095,50,220,45},
	s_plate_cap_ftp_img_mat_xywh = {705,200,280,45},
	s_plate_t_ftp_img_mat_xywh = {1090,207,48,30},
	s_plate_cap_ftp_whole_img_xywh = {705,250,280,45},
	s_plate_t_ftp_whole_img_xywh = {1090,257,48,30},
	s_plate_cap_alg_lib_ver_xywh = {705,300,280,45},
	s_plate_t_alg_lib_ver_xywh = {1095,300,220,45},
	s_plate_hline_xywh = {690,0,2,200},
	s_plate_vdrop_xywh = {1325,0,20,390},
	s_plate_l_cap_line = {60,0,320,45},
	s_plate_l_t_line = {450,0,220,45},
	s_plate_r_cap_line = {705,0,320,45},
	s_plate_r_t_line = {1095,0,220,45},
	s_plate_tt_check_xywh = {5,7,48,30},
	s_plate_int_xywh = {0,0,50,0}
};

w1_page_plateparam.s_2k = 
{
	s_cfg_page_plate_param_xywh = {133,600,1866,413},
	s_plate_cap_plate_detect_xywh = {80,0,373,60},
	s_plate_t_plate_detect_xywh = {593,9,64,40},
	s_plate_cap_vehicle_detect_xywh = {80,67,373,60},
	s_plate_t_vehicle_detect_xywh = {593,76,64,40},
	s_plate_cap_trace_info_xywh = {80,200,373,60},
	s_plate_t_trace_info_xywh = {593,209,64,40},
	s_plate_cap_con_coe_xywh = {80,267,373,60},
	s_plate_t_con_coe_xywh = {600,267,293,60},
	s_plate_cap_pix_min_xywh = {80,333,373,60},
	s_plate_t_pix_min_xywh = {600,333,293,60},
	s_plate_cap_mat_qua_xywh = {80,400,373,60},
	s_plate_t_mat_qua_xywh = {600,400,293,60},

	s_plate_cap_snap_mode_xywh = {940,0,373,60},
	s_plate_t_snap_mode_xywh = {1460,0,293,60},
	s_plate_cap_img_int_xywh = {940,67,387,60},
	s_plate_t_img_int_xywh = {1460,67,293,60},
	s_plate_cap_ftp_img_mat_xywh = {940,267,373,60},
	s_plate_t_ftp_img_mat_xywh = {1453,276,64,40},
	s_plate_cap_ftp_whole_img_xywh = {940,333,373,60},
	s_plate_t_ftp_whole_img_xywh = {1453,343,64,40},
	s_plate_cap_alg_lib_ver_xywh = {940,400,373,60},
	s_plate_t_alg_lib_ver_xywh = {1460,400,293,60},
	s_plate_hline_xywh = {920,0,3,267},
	s_plate_vdrop_xywh = {1767,0,27,520},
	s_plate_l_cap_line = {80,0,427,60},
	s_plate_l_t_line = {600,0,293,60},
	s_plate_r_cap_line = {940,0,427,60},
	s_plate_r_t_line = {1460,0,293,60},
	s_plate_tt_check_xywh = {7,9,64,40},
	s_plate_int_xywh = {0,0,67,0}
};

w1_page_plateparam.s_4k = 
{
	s_cfg_page_plate_param_xywh = {200,900,2800,620},
	s_plate_cap_plate_detect_xywh = {120,0,560,90},
	s_plate_t_plate_detect_xywh = {120,0,560,90},
	s_plate_cap_vehicle_detect_xywh = {890,14,96,60},
	s_plate_t_vehicle_detect_xywh = {120,100,560,90},
	s_plate_cap_trace_info_xywh = {890,214,96,60},
	s_plate_t_trace_info_xywh = {120,300,560,90},
	s_plate_cap_con_coe_xywh = {890,314,96,60},
	s_plate_t_con_coe_xywh = {120,400,560,90},
	s_plate_cap_pix_min_xywh = {900,400,440,90},
	s_plate_t_pix_min_xywh = {120,500,560,90},
	s_plate_cap_mat_qua_xywh = {890,514,96,60},
	s_plate_t_mat_qua_xywh = {120,600,560,90},

	s_plate_cap_snap_mode_xywh = {1410,0,560,90},
	s_plate_t_snap_mode_xywh = {2190,0,440,90},
	s_plate_cap_img_int_xywh = {1410,100,580,90},
	s_plate_t_img_int_xywh = {2190,100,440,90},
	s_plate_cap_ftp_img_mat_xywh = {1410,400,560,90},
	s_plate_t_ftp_img_mat_xywh = {2180,414,96,60},
	s_plate_cap_ftp_whole_img_xywh = {1410,500,560,90},
	s_plate_t_ftp_whole_img_xywh = {2180,514,96,60},
	s_plate_cap_alg_lib_ver_xywh = {1410,600,560,60},
	s_plate_t_alg_lib_ver_xywh = {2190,600,440,60},
	s_plate_hline_xywh = {1380,0,4,400},
	s_plate_vdrop_xywh = {2650,0,40,780},
	s_plate_l_cap_line = {120,0,640,90},
	s_plate_l_t_line = {900,0,440,90},
	s_plate_r_cap_line = {1410,0,640,90},
	s_plate_r_t_line = {2190,0,440,90},
	s_plate_tt_check_xywh = {10,14,96,60},
	s_plate_int_xywh = {0,0,100,0}
};

local show_line = 8;
local display_off = 0;
local total_show = 0;
local show_list_l = {};
local index_l = 1;
local show_list_r = {};
local index_r = 1;
local tt_check_list_id = {};
local tt_check_count = nil;
w1_page_plateparam.clear_data=function ()
	w1_page_plateparam.cfg_data=nil;
end
--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_plateparam.wnd;
	cfgdata.plate_enable = b_wnd_ex.get_check(top,cwnd.t_plate_detect.id);
	cfgdata.vehicle_enable = b_wnd_ex.get_check(top,cwnd.t_vehicle_detect.id);
	cfgdata.trace_enable = b_wnd_ex.get_check(top,cwnd.t_trace_info.id);
	local sel = b_wnd_ex.get_sel(top,cwnd.t_con_coe.id);
	if sel == 0 then
		cfgdata.reliability = 30
	elseif sel == 1 then
		cfgdata.reliability = 60
	else
		cfgdata.reliability = 90
	end
	cfgdata.pix_min = b_wnd_ex.get_value(top,cwnd.t_pix_min.id);
	sel = b_wnd_ex.get_sel(top,cwnd.t_mat_qua.id);
	if sel == 0 then
		cfgdata.pic_quality = 30
	elseif sel == 1 then
		cfgdata.pic_quality = 60
	else
		cfgdata.pic_quality = 80
	end
	cfgdata.snap_pic_mode = b_wnd_ex.get_sel(top,cwnd.t_snap_mode.id);
	if cfgdata.snap_pic_mode == 0 then
		cfgdata.upload_inteval = b_wnd_ex.get_value(top,cwnd.t_img_int.id);
	else
		cfgdata.snap_count = b_wnd_ex.get_value(top,cwnd.t_img_int.id);
	end
	cfgdata.ftpupload_enable = b_wnd_ex.get_check(top,cwnd.t_ftp_img_mat.id);
	cfgdata.fuleview_enable = b_wnd_ex.get_check(top,cwnd.t_ftp_whole_img.id);
	cfgdata.change_flag = true;
	return 0
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.LBUTTONCLK == vmsg or b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,w1_page_plateparam.cfg_data)
	end
	return 0;
end

local move_ex = function (top)
	local cwnd = w1_page_plateparam.wnd;
	local is_tt_check = function (id)
		for i = 1, tt_check_count do
			if(tt_check_list_id[i] == id) then
				return true
			end
			if i == tt_check_count then
				return false
			end
		end
	end
	--------------------------------------------
	local s_id = cwnd.cap_plate_detect.id;
	local e_id = cwnd.t_alg_lib_ver.id;
	for i = s_id, e_id do
		b_wnd_ex.set_hide(top,i,true,false);
	end
	--------------------------------------------
	local size_cap_l = SIZE('s_plate_l_cap_line');
	local size_t_l = SIZE('s_plate_l_t_line');
	local size_cap_r = SIZE('s_plate_r_cap_line');
	local size_t_r = SIZE('s_plate_r_t_line');
	local size_int = SIZE('s_plate_int_xywh');
	local size_tt_check = SIZE('s_plate_tt_check_xywh');
	for i = 1, show_line do
		if show_list_l[2*i+display_off*2-1] ~= nil then
			local pos = {size_cap_l[1],size_cap_l[2]+size_int[3]*(i-1),size_cap_l[3],size_cap_l[4]};
			b_wnd_ex.move_ex(top,show_list_l[2*i+display_off*2-1],pos,false);
			b_wnd_ex.set_hide(top, show_list_l[2*i+display_off*2-1],false,false);
			local flag = is_tt_check(show_list_l[2*i+display_off*2])
			if flag == true then
				local pos = {size_t_l[1]-size_tt_check[1],size_t_l[2]+size_int[3]*(i-1)+size_tt_check[2],size_tt_check[3],size_tt_check[4]};
				b_wnd_ex.move_ex(top,show_list_l[2*i+display_off*2],pos,false);
			else
				local pos = {size_t_l[1],size_t_l[2]+size_int[3]*(i-1),size_t_l[3],size_t_l[4]};
				b_wnd_ex.move_ex(top,show_list_l[2*i+display_off*2],pos,false);
			end
			b_wnd_ex.set_hide(top, show_list_l[2*i+display_off*2],false,false);
		end
		if show_list_r[2*i+display_off*2-1] ~= nil then
			local pos = {size_cap_r[1],size_cap_r[2]+size_int[3]*(i-1),size_cap_r[3],size_cap_r[4]};
			b_wnd_ex.move_ex(top,show_list_r[2*i+display_off*2-1],pos,false);
			b_wnd_ex.set_hide(top, show_list_r[2*i+display_off*2-1],false,false);
			local flag = is_tt_check(show_list_r[2*i+display_off*2])
			if flag == true then
				local pos = {size_t_r[1]-size_tt_check[1],size_t_r[2]+size_int[3]*(i-1)+size_tt_check[2],size_tt_check[3],size_tt_check[4]};
				b_wnd_ex.move_ex(top,show_list_r[2*i+display_off*2],pos,false);
			else
				local pos = {size_t_r[1],size_t_r[2]+size_int[3]*(i-1),size_t_r[3],size_t_r[4]};
				b_wnd_ex.move_ex(top,show_list_r[2*i+display_off*2],pos,false);
			end
			b_wnd_ex.set_hide(top, show_list_r[2*i+display_off*2],false,false);
		end
	end
end

local on_snap_mode = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cwnd = w1_page_plateparam.wnd
		local sel = b_wnd_ex.get_sel(top,cwnd.t_snap_mode.id)
		if sel == 0 then
			b_wnd_ex.set_text(top,cwnd.cap_img_int.id,STR('LA_UPLOAD_IMAGE_INTERVAL'),false);
			b_wnd_ex.set_value(top,cwnd.t_img_int.id,w1_page_plateparam.cfg_data.upload_inteval,false);
		else
			b_wnd_ex.set_text(top,cwnd.cap_img_int.id,STR('LA_SNAP_COUNT_1'),false);
			b_wnd_ex.set_value(top,cwnd.t_img_int.id,w1_page_plateparam.cfg_data.snap_count,false);
		end
		uitousercfg(top,w1_page_plateparam.cfg_data)
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

w1_page_plateparam.sethide = function(top, bool_hide, redraw)
	local cwnd = w1_page_plateparam.wnd;
	if bool_hide == false then
		b_wnd_ex.set_hide(top,cwnd.hline.id,bool_hide,false);
	else
		local s_id_l = cwnd.cap_plate_detect.id
		local e_id_l = cwnd.t_vdrop.id
		for i = s_id_l, e_id_l do
			b_wnd_ex.set_hide(top,i,bool_hide,false);
		end
	end
end

w1_page_plateparam.set_param = function(top, param, redraw)
	w1_page_plateparam.cfg_data = param
	local cwnd = w1_page_plateparam.wnd;
	index_l = 1;
	b_wnd_ex.set_check(top,cwnd.t_plate_detect.id,param.plate_enable,false);
	show_list_l = {}
	show_list_r = {}
	show_list_l[index_l] = cwnd.cap_plate_detect.id;
	index_l = index_l + 1;
	show_list_l[index_l] = cwnd.t_plate_detect.id
	index_l = index_l + 1;
	b_wnd_ex.set_check(top,cwnd.t_vehicle_detect.id,param.vehicle_enable,false);
	--[[show_list_l[index_l] = cwnd.cap_vehicle_detect.id;
	index_l = index_l + 1;
	show_list_l[index_l] = cwnd.t_vehicle_detect.id
	index_l = index_l + 1;--]]
	b_wnd_ex.set_check(top,cwnd.t_trace_info.id,param.trace_enable,false);
	--[[show_list_l[index_l] = cwnd.cap_trace_info.id;
	index_l = index_l + 1;
	show_list_l[index_l] = cwnd.t_trace_info.id
	index_l = index_l + 1;--]]
	if param.reliability == 30 then
		b_wnd_ex.set_sel(top,cwnd.t_con_coe.id,0,false);
	elseif param.reliability == 60 then
		b_wnd_ex.set_sel(top,cwnd.t_con_coe.id,1,false);
	else
		b_wnd_ex.set_sel(top,cwnd.t_con_coe.id,2,false);
	end
	show_list_l[index_l] = cwnd.cap_con_coe.id;
	index_l = index_l + 1;
	show_list_l[index_l] = cwnd.t_con_coe.id
	index_l = index_l + 1;
	b_wnd_ex.set_value(top,cwnd.t_pix_min.id,param.pix_min,false);
	show_list_l[index_l] = cwnd.cap_pix_min.id;
	index_l = index_l + 1;
	show_list_l[index_l] = cwnd.t_pix_min.id
	index_l = index_l + 1;
	if param.pic_quality == 30 then
		b_wnd_ex.set_sel(top,cwnd.t_mat_qua.id,0,false);
	elseif param.pic_quality == 60 then
		b_wnd_ex.set_sel(top,cwnd.t_mat_qua.id,1,false);
	else
		b_wnd_ex.set_sel(top,cwnd.t_mat_qua.id,2,false);
	end
	show_list_l[index_l] = cwnd.cap_mat_qua.id;
	index_l = index_l + 1;
	show_list_l[index_l] = cwnd.t_mat_qua.id
	
	index_r = 1
	b_wnd_ex.set_sel(top,cwnd.t_snap_mode.id,param.snap_pic_mode,false);
	show_list_r[index_r] = cwnd.cap_snap_mode.id;
	index_r = index_r + 1;
	show_list_r[index_r] = cwnd.t_snap_mode.id
	index_r = index_r + 1;
	if param.snap_pic_mode == 1 then
		b_wnd_ex.set_value(top,cwnd.t_img_int.id,param.snap_count,false);
		b_wnd_ex.set_text(top,cwnd.cap_img_int.id,STR('LA_SNAP_COUNT_1'),false);
	else
		b_wnd_ex.set_value(top,cwnd.t_img_int.id,param.upload_inteval,false);
		b_wnd_ex.set_text(top,cwnd.cap_img_int.id,STR('LA_UPLOAD_IMAGE_INTERVAL'),false);
	end
	show_list_r[index_r] = cwnd.cap_img_int.id;
	index_r = index_r + 1;
	show_list_r[index_r] = cwnd.t_img_int.id
	index_r = index_r + 1;
	b_wnd_ex.set_check(top,cwnd.t_ftp_img_mat.id,param.ftpupload_enable,false);
	show_list_r[index_r] = cwnd.cap_ftp_img_mat.id;
	index_r = index_r + 1;
	show_list_r[index_r] = cwnd.t_ftp_img_mat.id
	index_r = index_r + 1;
	b_wnd_ex.set_check(top,cwnd.t_ftp_whole_img.id,param.fuleview_enable,false);
	show_list_r[index_r] = cwnd.cap_ftp_whole_img.id;
	index_r = index_r + 1;
	show_list_r[index_r] = cwnd.t_ftp_whole_img.id
	index_r = index_r + 1;
	b_wnd_ex.set_text(top,cwnd.t_alg_lib_ver.id,param.algoversion,false)
	--[[show_list_r[index_r] = cwnd.cap_alg_lib_ver.id;
	index_r = index_r + 1;
	show_list_r[index_r] = cwnd.t_alg_lib_ver.id--]]
	index_r = index_r - 1;
	if index_l > index_r then
		total_show = index_l/2
	else
		total_show = index_r/2
	end
	if display_off + show_line > total_show then
		if show_line < total_show then
			display_off = total_show - show_line;
		else
			display_off = 0;
		end
	end
	if total_show > show_line then
		local v_drop = {};
		v_drop.set_cur = display_off;
		v_drop.set_cap = show_line;
		v_drop.set_max = total_show
		b_wnd_ex.set_drop(top,cwnd.t_vdrop.id,v_drop,false);
		b_wnd_ex.set_hide(top,cwnd.t_vdrop.id,false,false);
	else
		b_wnd_ex.set_hide(top,cwnd.t_vdrop.id,true,false);
	end
	move_ex(top);
end

w1_page_plateparam.datacheck = function(top)
	local cwnd = w1_page_plateparam.wnd;
	local mix_pix = b_wnd_ex.get_value(top,cwnd.t_pix_min.id);
	if mix_pix < 60 or mix_pix > 100 then
		w1_wnd_util.setparamerr_str(STR('LA_OUT_RANGE')..'('..STR('LA_PLATE_WIDTH_MIN')..')');
		return false,nil
	end
	local sel = b_wnd_ex.get_sel(top,cwnd.t_snap_mode.id);
	if sel == 0 then
		local time = b_wnd_ex.get_value(top,cwnd.t_img_int.id);
		if time < 1 then
			w1_wnd_util.setparamerr_str(STR('LA_OUT_RANGE')..'('..STR('LA_UPLOAD_IMAGE_INTERVAL')..')')
			return false,nil
		end
	else
		local time = b_wnd_ex.get_value(top,cwnd.t_img_int.id);
		if time ~= 1 then
			w1_wnd_util.setparamerr_str(STR('LA_OUT_RANGE')..'('..STR('LA_SNAP_COUNT_1')..')')
			return false,nil
		end
	end
	return true,nil
end

w1_page_plateparam.dwell_updata_f =function(top)
	if total_show > show_line then
		display_off = b_wnd_ex.get_drop(top,w1_page_plateparam.wnd.t_vdrop.id);
		move_ex(top);
		b_dlg.dlg_set_redraw(top);
	end
end

w1_page_plateparam.dwell_mouse_up =function(top)
	if total_show > show_line then
		if display_off > 0 then
			display_off = display_off-1
		end
		local vdrop = {};
		vdrop.set_cur = display_off;
		vdrop.set_cap = show_line;
		vdrop.set_max = total_show;
		b_wnd_ex.set_drop(top,w1_page_plateparam.wnd.t_vdrop.id,vdrop,false);
		move_ex(top)
		b_dlg.dlg_set_redraw(top);		
	end
end

w1_page_plateparam.dwell_mouse_down =function(top)
	if total_show > show_line then
		if display_off < total_show - show_line then
			display_off = display_off+1
		end
		local vdrop = {};
		vdrop.set_cur = display_off;
		vdrop.set_cap = show_line;
		vdrop.set_max = total_show;
		b_wnd_ex.set_drop(top,w1_page_plateparam.wnd.t_vdrop.id,vdrop,false);
		move_ex(top);
		b_dlg.dlg_set_redraw(top);		
	end
end

w1_page_plateparam.dwell_drop_drag =function(top)
	if total_show > show_line then
		display_off = b_wnd_ex.get_drop(top,w1_page_plateparam.wnd.t_vdrop.id);
		move_ex(top);
		b_dlg.dlg_set_redraw(top);	
	end
end

w1_page_plateparam.on_pre_show = function(top)
	local dlg_w, dlg_h = global_val.get_size();
	local cwnd = w1_page_plateparam.wnd;
	tt_check_list_id[1] = cwnd.t_plate_detect.id;
	tt_check_list_id[2] = cwnd.t_vehicle_detect.id;
	tt_check_list_id[3] = cwnd.t_trace_info.id;
	tt_check_list_id[4] = cwnd.t_ftp_img_mat.id;
	tt_check_list_id[5] = cwnd.t_ftp_whole_img.id;
	tt_check_count = 5;
	if(dlg_w == 1280 or dlg_h == 1024) then
		show_line = 7;
	elseif(dlg_w == 1440 or dlg_h == 900) then
		show_line = 7;
	else
		show_line = 8;
	end
	local s_id_l = cwnd.cap_plate_detect.id
	local e_id_l = cwnd.t_mat_qua.id
	for i = s_id_l, e_id_l do
		if i >= s_id_l + show_line * 2 then
			b_wnd_ex.set_hide(top,i,true,false);
		end
	end
	local s_id_r = cwnd.cap_snap_mode.id
	local e_id_r = cwnd.t_alg_lib_ver.id
	for i = s_id_r, e_id_r do
		if i >= s_id_r + show_line * 2 then
			b_wnd_ex.set_hide(top,i,true,false);
		end
	end
	b_wnd_ex.set_hide(top,cwnd.t_vdrop.id,true,false);
end

w1_page_plateparam.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_plate_param_xywh',
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub = {'cap_plate_detect','t_plate_detect','cap_vehicle_detect','t_vehicle_detect',	'cap_trace_info','t_trace_info',
	'cap_con_coe','t_con_coe','cap_pix_min','t_pix_min','cap_mat_qua','t_mat_qua','cap_snap_mode','t_snap_mode','cap_img_int','t_img_int',
	'cap_ftp_img_mat','t_ftp_img_mat','cap_ftp_whole_img','t_ftp_whole_img','cap_alg_lib_ver','t_alg_lib_ver','hline','t_vdrop'},
	cap_plate_detect= {t='static',	id=id+1,	xywh='s_plate_cap_plate_detect_xywh',text='LA_LIC_PLATE_REC', align = b_ui.ALIGN.LEFT},
	t_plate_detect = {t='tt_check',id=id+2,	xywh='s_plate_t_plate_detect_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	cap_vehicle_detect= {t='static',	id=id+3,	xywh='s_plate_cap_vehicle_detect_xywh',text='LA_CAR_DET', align = b_ui.ALIGN.LEFT},
	t_vehicle_detect = {t='tt_check',id=id+4,	xywh='s_plate_t_vehicle_detect_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	cap_trace_info= {t='static',	id=id+5,	xywh='s_plate_cap_trace_info_xywh',text='LA_TRACE_INFO', align = b_ui.ALIGN.LEFT},
	t_trace_info = {t='tt_check',id=id+6,	xywh='s_plate_t_trace_info_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	cap_con_coe= {t='static',	id=id+7,	xywh='s_plate_cap_con_coe_xywh',text='LA_CONFIDENCE_DEGREE', align = b_ui.ALIGN.LEFT},
	t_con_coe = {t='combox',	id=id+8,	xywh='s_plate_t_con_coe_xywh' ,
					items = {'LA_LOW','LA_MEDIUM','LA_HIGH'},cmd = on_update_param},
	cap_pix_min= {t='static',	id=id+9,	xywh='s_plate_cap_pix_min_xywh',text='LA_PLATE_WIDTH_MIN', align = b_ui.ALIGN.LEFT},
	t_pix_min = {t='edit_num',id=id+10,xywh='s_plate_t_pix_min_xywh',range={0,100},cmd = on_update_param},
	cap_mat_qua= {t='static',	id=id+11,	xywh='s_plate_cap_mat_qua_xywh',text='LA_MAT_QUA', align = b_ui.ALIGN.LEFT},
	t_mat_qua = {t='combox',	id=id+12,	xywh='s_plate_t_mat_qua_xywh' ,
				items = {'LA_LOW','LA_MEDIUM','LA_HIGH'},cmd = on_update_param},
				
	cap_snap_mode= {t='static',	id=id+13,	xywh='s_plate_cap_snap_mode_xywh',text='LA_SNAPSHOT_MODE', align = b_ui.ALIGN.LEFT},
	t_snap_mode = {t='combox',	id=id+14,	xywh='s_plate_t_snap_mode_xywh',
				items = {'LA_TIMING','LA_OPTIMAL'},cmd = on_snap_mode},
	cap_img_int= {t='static',	id=id+15,	xywh='s_plate_cap_img_int_xywh',text='LA_UPLOAD_IMAGE_INTERVAL', align = b_ui.ALIGN.LEFT},
	t_img_int = {t='edit_num',id=id+16,xywh='s_plate_t_img_int_xywh',range={1,10},cmd = on_update_param},
	cap_ftp_img_mat= {t='static',	id=id+21,	xywh='s_plate_cap_ftp_img_mat_xywh',text='LA_FTP_UPLOAD_IMAGE_MATTING', align = b_ui.ALIGN.LEFT},
	t_ftp_img_mat = {t='tt_check',id=id+22,	xywh='s_plate_t_ftp_img_mat_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	cap_ftp_whole_img = {t='static',	id=id+23,	xywh='s_plate_cap_ftp_whole_img_xywh',text='LA_FTP_UPLOAD_WHOLE_IMAGE', align = b_ui.ALIGN.LEFT},
	t_ftp_whole_img = {t='tt_check',id=id+24,	xywh='s_plate_t_ftp_whole_img_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param},
	cap_alg_lib_ver = {t='static',	id=id+25,	xywh='s_plate_cap_alg_lib_ver_xywh',text='LA_ALG_LIB_VER', align = b_ui.ALIGN.LEFT},
	t_alg_lib_ver = {t='static',	id=id+26,	xywh='s_plate_t_alg_lib_ver_xywh',text='', trans=false, align = b_ui.ALIGN.LEFT},
	hline 	= {t='hline',	id=id+27,xywh='s_plate_hline_xywh'},
	t_vdrop = {t='vdrop', id=id+28,xywh='s_plate_vdrop_xywh'};
}

return w1_page_plateparam

