--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_net.poe_id
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local util 			= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local w1_page_poe = 
{
	timestart = false,
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_poe.s_768 =
{
	s_poe_enable_xywh = {277,25,25,21},
	s_poe_reboot_tip_xywh = {53,192,640,32},
	s_poe_tipinfo_xywh = {53,256,373,35},
};

w1_page_poe.s_1280 = 
{
	s_poe_enable_xywh = {455,36,48,30},
	s_poe_reboot_tip_xywh = {100,270,900,45},
	s_poe_tipinfo_xywh = {100,360,700,50},

}

w1_page_poe.s_1440 = 
{
	s_poe_enable_xywh = {520,30,48,30},
	s_poe_reboot_tip_xywh = {100,270,1000,45},
	s_poe_tipinfo_xywh = {100,360,700,50},

}

w1_page_poe.s_1080p = 
{
	s_poe_enable_xywh = {520,36,48,30},
	s_poe_reboot_tip_xywh = {100,270,1200,45},
	s_poe_tipinfo_xywh = {100,360,700,50},

}
w1_page_poe.s_2k = 
{
	s_poe_enable_xywh = {693,48,64,40},
	s_poe_reboot_tip_xywh = {133,360,1600,60},
	s_poe_tipinfo_xywh = {133,480,933,67},

}
w1_page_poe.s_4k = 
{
	s_poe_enable_xywh = {1040,72,96,60},
	s_poe_reboot_tip_xywh = {200,540,2400,90},
	s_poe_tipinfo_xywh = {200,720,1400,100},

}

w1_page_poe.clear_data = function()
	w1_page_poe.data = nil;
end	

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	w1_page_poe.data = cfgdata;
	
	local cwnd = w1_page_poe.wnd;
	local data = cfgdata.poe;
	local function settext(id, str)
		b_wnd_ex.set_text(top, id, str,false)
	end
	b_wnd_ex.set_check(top,cwnd.t_enable.id,data.enable,false);
	settext(cwnd.t_ip.id,  data.ip );
	settext(cwnd.t_netmask.id, data.netmask );
	settext(cwnd.t_gateway.id, data.gateway );
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_poe.wnd;
	local data = cfgdata.poe;
	local gettext = function(id)
		local iptext = b_wnd_ex.get_text(top, id)
		return iptext;
	end
	local check = b_wnd_ex.get_check(top,cwnd.t_enable.id)
	data.enable = check;
	local ip = gettext(cwnd.t_ip.id);
	data.ip = ip;
	local netmask = gettext(cwnd.t_netmask.id);
	data.netmask = netmask;
	local gateway = gettext(cwnd.t_gateway.id);
	data.gateway = gateway;
	return 0;
end


--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local gettext = function(id)
		local iptext = b_wnd_ex.get_text(top, id);
		return iptext;
	end
	local legalflag = true
	local nlegalid = {}
	local cwnd = w1_page_poe.wnd;
	local data = w1_page_poe.data;

	legal, num = w1_legal.check_gataway(top, cwnd.t_gateway.id);
	if(legal == false) then
		legalflag =false;
		table.insert(nlegalid, cwnd.t_gateway.id);
		if(num == w1_legal.netmask.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LAN_DEFAULT_GATEWAY'));
		elseif(num == w1_legal.netmask.LENERR or num == w1_legal.netmask.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LAN_DEFAULT_GATEWAY'));
		end
	end
	
	legal, num = w1_legal.check_netmask(top, cwnd.t_netmask.id);
	if(legal == false) then
		legalflag =false;
		table.insert(nlegalid, cwnd.t_netmask.id);
		if(num == w1_legal.netmask.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LAN_SUBNET_MASK'));
		elseif(num == w1_legal.netmask.LENERR or num == w1_legal.netmask.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LAN_SUBNET_MASK'));
		end
	end	
	
	legal, num= w1_legal.check_ip(top, cwnd.t_ip.id);	
	if(legal == false) then
		legalflag =false;
		table.insert(nlegalid, cwnd.t_ip.id);
		if(num == w1_legal.ip.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LA_CORRECT_IP'));
		elseif(num == w1_legal.ip.LENERR or num == w1_legal.ip.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LA_CORRECT_IP'));
		end
	end

	--ǰѾϷ ͲȥipȽжϺϷ ȽǰĴ
	if(false == legalflag) then
		return legalflag, nlegalid;
	end
	
	--if(data.network_ipv4.dhcp == false) then --IPֶʱŽ
		local poeip = gettext(cwnd.t_ip.id);
		local poenetmask = gettext(cwnd.t_netmask.id);
		
		local netconflict = w1_legal.is_Ipv4PoeNetConflict(
			data.network_ipv4.ip, poeip, data.network_ipv4.netmask, poenetmask);
		if(netconflict) then --ڳͻ
			legalflag =false;
			table.insert(nlegalid, cwnd.t_ip.id);
			w1_wnd_util.setparamerr_str(STR('LA_POE_LOCAL_IP_TIP'));		
		end		
	--end
	
	if(legalflag) then
		return legalflag, nil;
	else
		return legalflag, nlegalid;
	end
end

local returndatacheck =function(top,ret)
	if(ret ~= nil and ret.poe ~= 0) then--޸ʧ
		local cwnd = w1_page_poe.wnd;
		local nlegalid = {};
		table.insert(nlegalid, cwnd.t_ip.id);
		if(ret.poe == -1 ) then
			w1_wnd_util.setparamerr_str(STR('LA_PARAMETER_ERR'));
		elseif(ret.poe == -2) then
			w1_wnd_util.setparamerr_str(STR('LA_POE_LOCAL_IP_TIP'));
		elseif(ret.poe == -3) then
			w1_wnd_util.setparamerr_str(STR('LA_MSG_IP_CONFLICT'));	
		elseif (ret.poe == -543) then
			w1_wnd_util.setparamerr_str(STR('LA_CANNOT_SAME'));
		end		
		return false, nlegalid;
	end
	return true, nil;
end

local on_update_param	= function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_enable	= function(top, win_id, vmsg, x, y)
	if(b_ui.LBUTTONCLK == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck;
		w1_wnd_util.returndatacheckfunc = returndatacheck;
		w1_wnd_util.page_onapply(top);
		w1_wnd_util.tipdispon();		--ʾ
		w1_wnd_util.returndatacheckfunc = nil;	
	end
	return 0
end

w1_page_poe.timer_start = function()
	w1_page_poe.timestart = true;
end

w1_page_poe.timer_stop = function(top)
	w1_page_poe.timestart = false;
	w1_wnd_util.tipclear(top, w1_page_poe.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
	w1_wnd_util.tipdispoff();
end

w1_page_poe.timerenevt = function(top)
	if(w1_page_poe.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_poe.wnd.tipinfo.id);
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_poe.init = function(top)
	w1_wnd_util.cfgtab = {'network_ipv4', 'poe'};
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);
	return 0
end

w1_page_poe.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck;
	w1_wnd_util.returndatacheckfunc = returndatacheck;
	ret = w1_wnd_util.page_onapply(top);
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	w1_wnd_util.returndatacheckfunc = nil;	
	return ret;
end
w1_page_poe.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_enable','t_enable','cap_ip','t_ip','cap_netmask','t_netmask',
			'cap_gateway','t_gateway','t_reboot_tip',
			'tipinfo', 'apply' },
	cap_enable	= {t='static',	id=id+1,	xywh='s_cfg_page_1_1',text='LA_AUTO_MANAGE_POE'},
	t_enable	= {t='tt_check', id=id+2,xywh='s_poe_enable_xywh',
					t_imgs ={b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_enable},
	cap_ip 		= {t='static',	id=id+3,	xywh='s_cfg_page_2_1',text='LA_IP_ADDRESS'},
	t_ip 		= {t='edit_ip', id=id+4,	xywh='s_cfg_ip_2_2',cmd = on_update_param},
	
	cap_netmask = {t='static',	id=id+5,	xywh='s_cfg_page_3_1',text='LA_SUBNET_MASK'},
	t_netmask 	= {t='edit_ip', id=id+6,	xywh='s_cfg_ip_3_2',cmd = on_update_param},
	
	cap_gateway = {t='static',	id=id+7,	xywh='s_cfg_page_4_1',text='LA_GATEWAY'},
	t_gateway 	= {t='edit_ip', id=id+8,	xywh='s_cfg_ip_4_2',cmd = on_update_param},
	
	t_reboot_tip ={t='static', id=id+9,	xywh='s_poe_reboot_tip_xywh',text='LA_POE_NOTE_RESTART',color = {'c_hint_bk', 'c_hint_border', 'c_hint_text'}},
	
	tipinfo		= {t='static',	id=id+10,	xywh='s_poe_tipinfo_xywh',text='',trans = false},
	
	apply 		= {t='button',	id=id+11,	xywh='s_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_poe



