--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_net.port_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local b_app_cfg  = require("wnd.core.b_app_cfg")
local w1_page_port = 
{
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_port.s_768 =
{
	s_port_reboottip_xywh = {53,192,426,32},
	s_port_info1_xywh = {53,227,480,35},
	s_port_tipinfo_xywh = {53,263,373,35},
};

w1_page_port.s_1280 = 
{
	s_port_reboottip_xywh = {100,270,800, 45},
	s_port_info1_xywh = {100,310,880,50},
	s_port_tipinfo_xywh = {100,370,700,50},
}

w1_page_port.s_1440 = 
{
	s_port_reboottip_xywh = {100,240,800, 45},
	s_port_info1_xywh = {100,350,900,50},
	s_port_tipinfo_xywh = {100,400,700,50},
}

w1_page_port.s_1080p = 
{
	s_port_reboottip_xywh = {100,270,800, 45},
	s_port_info1_xywh = {100,320,900,50},
	s_port_tipinfo_xywh = {100,370,700,50},
}

w1_page_port.s_2k = 
{
	s_port_reboottip_xywh = {133,360,1066,60},
	s_port_info1_xywh = {133,427,1200,67},
	s_port_tipinfo_xywh = {133,493,933,67},
}

w1_page_port.s_4k = 
{
	s_port_reboottip_xywh = {200,540,1600,90},
	s_port_info1_xywh = {200,640,1800,100},
	s_port_tipinfo_xywh = {200,740,1400,100},

}

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local c_wnd = w1_page_port.wnd
	local data = cfgdata.network_ipv4
	local function setvalue(id, value)
		b_wnd_ex.set_value(top, id, value, false)
	end
	setvalue(c_wnd.t_http.id, data.http_port );
	setvalue(c_wnd.t_https.id, data.https_port );
	setvalue(c_wnd.t_data1.id, data.data_port );
	setvalue(c_wnd.t_data2.id, data.jy_data_port );
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local c_wnd = w1_page_port.wnd
	local data = cfgdata.network_ipv4
	local http_port =b_wnd_ex.get_value(top, c_wnd.t_http.id);
	data.http_port = http_port;
	local https_port =b_wnd_ex.get_value(top, c_wnd.t_https.id);
	data.https_port = https_port;
	local data1 =b_wnd_ex.get_value(top, c_wnd.t_data1.id);
	data.data_port = data1;
	local data2 =b_wnd_ex.get_value(top, c_wnd.t_data2.id);
	data.jy_data_port = data2;
	return 0
end


--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	local cwnd = w1_page_port.wnd
	
	if(legalflag) then	
		local httpport =  b_wnd_ex.get_value(top, cwnd.t_http.id)
		local httpsport =  b_wnd_ex.get_value(top, cwnd.t_https.id)
		local data1port =  b_wnd_ex.get_value(top, cwnd.t_data1.id)
		local data2port =  b_wnd_ex.get_value(top, cwnd.t_data2.id)
		
		if(httpport == httpsport) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_http.id)	
			table.insert(nlegalid, cwnd.t_https.id)	
		elseif(httpport == data1port ) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_http.id)	
			table.insert(nlegalid, cwnd.t_data1.id)	
		elseif(httpport == data2port) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_http.id)	
			table.insert(nlegalid, cwnd.t_data2.id)
		elseif(httpsport == data1port) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_https.id)	
			table.insert(nlegalid, cwnd.t_data1.id)
		elseif(httpsport == data2port) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_https.id)	
			table.insert(nlegalid, cwnd.t_data2.id)	
		elseif(data1port == data2port) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_data1.id)	
			table.insert(nlegalid, cwnd.t_data2.id)	
		end
	
		if(legalflag == false) then
			w1_wnd_util.setparamerr_str(STR('LA_PORT_SAME'))
		end
	end
	
	if(legalflag) then
		return legalflag, nil
	else
		return legalflag, nlegalid
	end
end

local on_update_param  = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local returndatacheck =function(top,ret)
	if(ret ~= nil and ret.network_ipv4 ~= 0) then--޸ʧ
		local cwnd = w1_page_port.wnd;
		local nlegalid = {};
		if(ret.network_ipv4 == 2 ) then
			table.insert(nlegalid, cwnd.t_http.id);
			w1_wnd_util.setparamerr_str(STR('LA_SPECIAL_PORT'));
		elseif(ret.network_ipv4 == 3 ) then
			table.insert(nlegalid, cwnd.t_https.id);
			w1_wnd_util.setparamerr_str(STR('LA_SPECIAL_PORT'));
		elseif(ret.network_ipv4 == 4 ) then
			table.insert(nlegalid, cwnd.t_data1.id);
			w1_wnd_util.setparamerr_str(STR('LA_SPECIAL_PORT'));
		elseif(ret.network_ipv4 == 5 ) then
			table.insert(nlegalid, cwnd.t_data2.id);
			w1_wnd_util.setparamerr_str(STR('LA_SPECIAL_PORT'));			
		end
		return false, nlegalid;
	end
	return true, nil;
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.returndatacheckfunc = returndatacheck;
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_port.timer_start = function()
	w1_page_port.timestart = true
end

w1_page_port.timer_stop = function(top)
	w1_page_port.timestart = false
	w1_wnd_util.tipclear(top, w1_page_port.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
	w1_wnd_util.tipdispoff();
end

w1_page_port.timerenevt = function(top)
	if(w1_page_port.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_port.wnd.tipinfo.id)
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_port.init = function(top)
	w1_wnd_util.cfgtab = {'network_ipv4'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

w1_page_port.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	w1_wnd_util.returndatacheckfunc = returndatacheck;
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	w1_wnd_util.returndatacheckfunc = nil;	
	return ret;
end

w1_page_port.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_http','t_http','cap_https','t_https','cap_data1','t_data1','cap_data2','t_data2','reboottip','info1',
			'tipinfo', 'default', 'apply' },
	
	cap_http 	= {t='static',	id=id+1,	xywh='s_cfg_page_1_1',		text='LA_HTTP_PORT'},
	t_http 		= {t='edit_num',id=id+2,	xywh='s_cfg_page_1_2',range={1,65534},cmd = on_update_param},
	
	cap_https 	= {t='static',	id=id+3,	xywh='s_cfg_page_2_1',		text='LA_HTTPS_PORT'},
	t_https 	= {t='edit_num',id=id+4,	xywh='s_cfg_page_2_2',range={1,65534},cmd = on_update_param},
	
	cap_data1 	= {t='static',	id=id+5,	xywh='s_cfg_page_3_1',		text='LA_DATA_PORT1'},
	t_data1 	= {t='edit_num',id=id+6,	xywh='s_cfg_page_3_2',range={1,65534},cmd = on_update_param},
	
	cap_data2 	= {t='static',	id=id+7,	xywh='s_cfg_page_4_1',		text='LA_DATA_PORT2'},
	t_data2 	= {t='edit_num',id=id+8,	xywh='s_cfg_page_4_2',range={1,65534},cmd = on_update_param},
	
	
	reboottip	= {t='static',	id=id+9,	xywh='s_port_reboottip_xywh',		text='LA_NOTE_RESTART',
				color = {'c_hint_bk', 'c_hint_border', 'c_hint_text'}},
--	info1		= {t='static',	id=id+8,	xywh='s_port_info1_xywh',      text='LA_RANGE_RECOMMEND'},
	tipinfo		= {t='static',	id=id+11,	xywh='s_port_tipinfo_xywh',		text='',	trans = false,
					},
	
	apply 		= {t='button',	id=id+12,	xywh='s_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}


return w1_page_port



