--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local global_val 	=  require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_pp.pp_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_app_api = require("wnd.core.command.b_app_api");
local t_qr_pp = "P2P";				-- [QR code]P2Pά
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local b_app_cfg  = require("wnd.core.b_app_cfg")
local w1_page_pp = 
{
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_pp.s_768 =
{
	s_pp_t_enable_xywh = {277,25,25,21},
	s_pp_qr_pp_xywh = {277,149,142,142},
	s_pp_t_pp_xywh = {26,270,266,28},
	s_pp_hline_xywh = {32,312,773,1},
	s_pp_cap_ppname_xywh = {53,320,202,32},
	s_pp_t_ppname_xywh = {277,320,202,32},
	s_pp_app_tip_xywh = {53,355,533,35},
	s_pp_tipinfo_xywh = {53,398,373,35},
};

w1_page_pp.s_1280 = 
{
	s_pp_t_enable_xywh = {455,36,48,30},--{520,36,48,30},
	s_pp_qr_pp_xywh = {450,220, 200, 200},
	s_pp_t_pp_xywh = {50,380,500,40},
	s_pp_hline_xywh	= {60,440,900,2},
	s_pp_cap_ppname_xywh = {100, 450,380,45},
	s_pp_t_ppname_xywh = {455, 450,380,45},
	s_pp_app_tip_xywh = {100,500,800,50},
	s_pp_tipinfo_xywh = {100,560,700,50},
}

w1_page_pp.s_1440 = 
{
	s_pp_t_enable_xywh = {520,30,48,30},
	s_pp_qr_pp_xywh = {520,190, 200, 200},
	s_pp_t_pp_xywh = {50,380,500,40},
	s_pp_hline_xywh	= {60,430,970,2},
	s_pp_cap_ppname_xywh = {100, 450,380,45},
	s_pp_t_ppname_xywh = {520, 450,380,45},
	s_pp_app_tip_xywh = {100,500,900,50},
	s_pp_tipinfo_xywh = {100,560,700,50},
}

w1_page_pp.s_1080p = 
{
	s_pp_t_enable_xywh = {520,36,48,30},
	s_pp_qr_pp_xywh = {520,210, 200, 200},
	s_pp_t_pp_xywh = {50,380,500,40},
	s_pp_hline_xywh	= {60,440,1450,2},
	s_pp_cap_ppname_xywh = {100, 450,380,45},
	s_pp_t_ppname_xywh = {520, 450,380,45},
	s_pp_app_tip_xywh = {100,500,1000,50},
	s_pp_tipinfo_xywh = {100,560,700,50},
}

w1_page_pp.s_2k = 
{
	s_pp_t_enable_xywh = {693,48,64,40},
	s_pp_qr_pp_xywh = {693,283,267,267},
	s_pp_t_pp_xywh = {67,507,667,53},
	s_pp_hline_xywh = {80,587,1933,3},
	s_pp_cap_ppname_xywh = {133, 600,507,60},
	s_pp_t_ppname_xywh = {693, 600,507,60},
	s_pp_app_tip_xywh = {133,667,1333,67},
	s_pp_tipinfo_xywh = {133,746,933,67},
}

w1_page_pp.s_4k = 
{
	s_pp_t_enable_xywh = {1040,72,96,60},
	s_pp_qr_pp_xywh = {1040,425,400,400},
	s_pp_t_pp_xywh = {100,760,1000,80},
	s_pp_hline_xywh = {120,880,2900,4},
	s_pp_cap_ppname_xywh = {200, 900,760,90},
	s_pp_t_ppname_xywh = {1040, 900,760,90},
	s_pp_app_tip_xywh = {200,1000,2000,100},
	s_pp_tipinfo_xywh = {200,1120,1400,100},
}



--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local c_wnd = w1_page_pp.wnd
	local function setcheck(id, str)
		b_wnd_ex.set_check(top, id, str,false)
	end
	setcheck(c_wnd.t_enable.id,cfgdata['p2p']['enable'] );
	b_wnd_ex.set_text(top, c_wnd.qr_pp.id, G.dev_sn,false);
	local str =nil;
	local device_info = b_app_api.get_device_info();
	
	if(1 == cfgdata['p2p']['resv'])then
		b_wnd_ex.set_text(top, c_wnd.t_status.id, STR('LA_ONLINE'),false);
		str =device_info.dev_sn.."   "..STR('LA_ONLINE');
	else
		b_wnd_ex.set_text(top, c_wnd.t_status.id, STR('LA_OFFLINE'),false);
		str =device_info.dev_sn.."   "..STR('LA_OFFLINE');
	end
	local app_name = cfgdata['oem_info']['app_name']
	b_wnd_ex.set_text(top, c_wnd.t_ppname.id, app_name,false);
	b_wnd_ex.set_text(top, c_wnd.t_pp.id, device_info.dev_sn,false);
	
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local flag = b_wnd_ex.get_check(top, w1_page_pp.wnd.t_enable.id)
	cfgdata['p2p']['enable'] =flag;
	return 0
end

local on_enable = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_pp.timer_start = function()
	w1_page_pp.timestart = true
end

w1_page_pp.timer_stop = function(top)
	w1_page_pp.timestart = false
	w1_wnd_util.tipclear(top, w1_page_pp.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_pp.timerenevt = function(top)
	if(w1_page_pp.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_pp.wnd.tipinfo.id)
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_pp.init = function(top)
	w1_wnd_util.cfgtab = {'p2p','oem_info'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

w1_page_pp.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_pp.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_enable','t_enable','cap_status','t_status','cap_pp','qr_pp','t_pp','hline','cap_ppname','t_ppname',
			't_download_tip','tipinfo', 'default', 'apply' },
	
	cap_enable 	= {t='static',	id=id+1,	xywh='s_cfg_page_1_1',		text='LA_ENABLE_P2P'},
	t_enable 	= {t='tt_check',id=id+2,	xywh='s_pp_t_enable_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_enable},
	
	cap_status	= {t='static',	id=id+3,	xywh='s_cfg_page_2_1',		text='LA_STATUS'},
	t_status	= {t='static',	id=id+4,	xywh='s_cfg_page_2_2',		text='',trans = false},
	
	cap_pp	= {t='static',	id=id+5,	xywh='s_cfg_page_3_1',		text='LA_P2P_ID'},
	t_pp 		= {t='static',	id=id+7,	xywh='s_cfg_page_3_2',		text='DVR8016134C04027',		
					trans = false,	},--align = b_ui.ALIGN.CENTER
	qr_pp 		= {t='qr_code',	id=id+8,	xywh='s_pp_qr_pp_xywh',	text=t_qr_pp,	trans = false},
	
	hline		= {t='hline', 	id=id+9,	xywh =	's_pp_hline_xywh',	color = {'c_camear_line', 'c_camear_line', 'c_camear_line'}},
	cap_ppname 	= {t='static',	id=id+10,	xywh='s_pp_cap_ppname_xywh',		text='LA_APP_NAME'},
	t_ppname 	= {t='static',	id=id+11,	xywh='s_pp_t_ppname_xywh',		text='InView Pro 4',trans = false},
	
	t_download_tip 	= {t='static',	id=id+12,	xywh='s_pp_app_tip_xywh',	text='LA_DOWNLOAD_TIP'},
	
	tipinfo		= {t='static',	id=id+13,	xywh='s_pp_tipinfo_xywh',text='',trans = false},
	
	apply 		= {t='button',	id=id+14,	xywh='s_cfg_apply_xywh', 	text='LA_APPLY',	cmd=on_apply},
}


return w1_page_pp



