
--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/10/31
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local w1_id 		= require("wnd.w1_util.w1_id")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local id 			= w1_id.cfg_pppoe.pppoe_id
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_msgbox 	= require("wnd.w1_util.w1_msgbox")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local util 			= require("wnd.core.util")
local b_app_api		= require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color

local redraw  		= false
local state_flag    = 0;
local time_flag     = 3;
local w1_page_pppoe = 
{
	data,
	timestart,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_pppoe.s_768 =
{
	s_pppoe_t_enable_xywh = {277,25,25,21},
	s_pppoe_tipinfo_xywh = {53,391,373,35},
	s_pppoe_tipsame_xywh = {53,106,373,35},
};

w1_page_pppoe.s_1280 = 
{
	s_pppoe_t_enable_xywh ={455,36,48,30},
	s_pppoe_tipinfo_xywh = {100,550,700,50},
	s_pppoe_tipsame_xywh = {100,150,700,50},
}

w1_page_pppoe.s_1440 = 
{
	s_pppoe_t_enable_xywh = {520,30,48,30},
	s_pppoe_tipinfo_xywh = {100,470,700,50},
	s_pppoe_tipsame_xywh = {100,125,700,50},
}

w1_page_pppoe.s_1080p = 
{
	s_pppoe_t_enable_xywh = {520,36,48,30},
	s_pppoe_tipinfo_xywh = {100,550,700,50},
	s_pppoe_tipsame_xywh = {100,150,700,50},
}

w1_page_pppoe.s_2k = 
{
	s_pppoe_t_enable_xywh = {693,48,64,40},
	s_pppoe_tipinfo_xywh = {133,732,933,67},
	s_pppoe_tipsame_xywh = {133,200,700,67},
}

w1_page_pppoe.s_4k = 
{
	s_pppoe_t_enable_xywh = {1040,72,96,60},
	s_pppoe_tipinfo_xywh = {200,1100,1400,100},
	s_pppoe_tipsame_xywh = {200,300,1400,100},
}

local cfgdatatoui =function (top,cfgdata)
	w1_page_pppoe.data= cfgdata;
	local cwnd = w1_page_pppoe.wnd
	b_wnd_ex.set_hide(top,cwnd.tipsame.id,true,false)
	b_wnd_ex.set_disable(top,cwnd.t_enable.id,false,false)
	local check_3g = b_app_api.get_cfg({'net_3g4g'}).net_3g4g;
	if check_3g.enable then
		b_wnd_ex.set_hide(top,cwnd.tipsame.id,false,false)
		b_wnd_ex.set_disable(top,cwnd.t_enable.id,true,false)
	end	
	b_wnd_ex.set_check(top,cwnd.t_enable.id,cfgdata['pppoe']['enable'],false)
	b_wnd_ex.set_text(top,cwnd.t_name.id,cfgdata['pppoe']['user'],false)
	b_wnd_ex.set_password(top,cwnd.t_password.id,cfgdata['pppoe']['password'],false)
	b_wnd_ex.set_disable(top,cwnd.t_ip.id,true,false)
	b_wnd_ex.set_color_d(top, cwnd.t_ip.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_bg_n'),COLOR('c_txt_d')},false);

	local check = cfgdata['pppoe']['enable']
	b_wnd_ex.set_hide(top,cwnd.cap_name.id,not check,false)
	b_wnd_ex.set_hide(top,cwnd.cap_password.id,not check,false)
	b_wnd_ex.set_hide(top,cwnd.t_name.id,not check,false)
	b_wnd_ex.set_hide(top,cwnd.t_password.id,not check,false)
	if not check then
		local wnd_size = SIZE('s_cfg_page_2_1')
		b_wnd_ex.move_ex(top, cwnd.cap_ip.id,wnd_size, false)
		wnd_size = SIZE('s_cfg_ip_2_2')
		b_wnd_ex.move_ex(top, cwnd.t_ip.id,wnd_size, false)
	else
		local wnd_size = SIZE('s_cfg_page_4_1')
		b_wnd_ex.move_ex(top, cwnd.cap_ip.id,wnd_size, false)
		wnd_size = SIZE('s_cfg_ip_4_2')
		b_wnd_ex.move_ex(top, cwnd.t_ip.id,wnd_size, false)
	end
	time_flag = 0
end

local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_pppoe.wnd
	local enable = b_wnd_ex.get_check(top,cwnd.t_enable.id)
	local user = b_wnd_ex.get_text(top,cwnd.t_name.id)
	local password = b_wnd_ex.get_password(top,cwnd.t_password.id)
	local data = cfgdata.pppoe
	data['enable'] = enable;
	data['user'] = user
	data['password']= password;
	return 0;
end

local on_enable = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd= w1_page_pppoe.wnd
		local check = b_wnd_ex.get_check(top,cwnd.t_enable.id)
		b_wnd_ex.set_hide(top,cwnd.cap_name.id,not check,false)
		b_wnd_ex.set_hide(top,cwnd.cap_password.id,not check,false)
		b_wnd_ex.set_hide(top,cwnd.t_name.id,not check,false)
		b_wnd_ex.set_hide(top,cwnd.t_password.id,not check,false)
		if check then
			local wnd_size = SIZE('s_cfg_page_4_1')
			b_wnd_ex.move_ex(top, cwnd.cap_ip.id,wnd_size, false)
			wnd_size = SIZE('s_cfg_ip_4_2')
			b_wnd_ex.move_ex(top, cwnd.t_ip.id,wnd_size, false)
		else
			local wnd_size = SIZE('s_cfg_page_2_1')
			b_wnd_ex.move_ex(top, cwnd.cap_ip.id,wnd_size, false)
			wnd_size = SIZE('s_cfg_ip_2_2')
			b_wnd_ex.move_ex(top, cwnd.t_ip.id,wnd_size, false)
		end
		b_dlg.dlg_set_redraw(top);
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local uidatacheck = function(top)
	local cwnd = w1_page_pppoe.wnd;
	local legalflag = true;
	local nlegalid = {};
	local check = b_wnd_ex.get_check(top,cwnd.t_enable.id);
	local username = b_wnd_ex.get_text(top,cwnd.t_name.id);
	local password = b_wnd_ex.get_text(top,cwnd.t_password.id);
	if check then
		if("" == username)then
			legalflag = false;
			table.insert(nlegalid, cwnd.t_name.id);
			w1_wnd_util.setparamerr_str(STR('LA_USERNAME_EMPTY'));
			return legalflag, nlegalid;
		end
		if("" == password)then
			legalflag = false;
			table.insert(nlegalid, cwnd.t_password.id);
			w1_wnd_util.setparamerr_str(STR('LA_PASSWORD_EMPTY'));
			return legalflag, nlegalid;
		end
	end
	if(legalflag) then
		return legalflag, nil;
	else
		return legalflag, nlegalid;
	end
	return 0;
end	

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck;
		w1_wnd_util.page_onapply(top);
		w1_wnd_util.tipdispon();		--ʾ
	end
	return 0;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

w1_page_pppoe.timer_start = function()
	w1_page_pppoe.timestart = true;
end

w1_page_pppoe.timer_stop = function(top)
	w1_page_pppoe.timestart = false;
	w1_wnd_util.tipclear(top, w1_page_pppoe.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
	w1_wnd_util.tipdispoff();
end

w1_page_pppoe.timerenevt = function(top)
	if(w1_page_pppoe.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_pppoe.wnd.tipinfo.id);
		local cwnd = w1_page_pppoe.wnd;
		if time_flag%3 == 0 then
			local check = b_app_api.get_cfg({'pppoe'}).pppoe;
			if check.enable then
				local ip = b_app_api.get_pppoe_ip()
				b_wnd_ex.set_text(top,cwnd.t_ip.id,ip,true)
			else
				b_wnd_ex.set_text(top,cwnd.t_ip.id,'',true)
			end
			if time_flag == 1000 then
				time_flag = 1
			end
		end
		time_flag = time_flag+1
	end
	return 0;
end

w1_page_pppoe.init = function(top)
	w1_wnd_util.cfgtab = {'pppoe'};
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);
	return 0
end

w1_page_pppoe.apply =function(top)
	local ret = nil;
	local cwnd = w1_page_pppoe.wnd
	w1_wnd_util.uidatacheckfunc = uidatacheck
	uitousercfg(top,b_app_cfg.user_cfg);
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_pppoe.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_enable','t_enable','cap_name','t_name','cap_password','t_password','cap_ip','t_ip', 'tipinfo','apply','tipsame' },
		
	cap_enable 	= {t='static',id=id+1,xywh='s_cfg_page_1_1',text='LA_ENABLE_PPPOE'},
	t_enable 	= {t='tt_check', id=id+2,xywh='s_pppoe_t_enable_xywh',
				t_imgs ={b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
				cmd = on_enable},
	
	cap_name    = {t='static',id=id+3,xywh='s_cfg_page_2_1',text='LA_USER_NAME'},
	t_name   	= {t='edit',id=id+4,xywh='s_cfg_ip_2_2',cmd = on_update_param},
	
	cap_password = {t='static',id=id+5,xywh='s_cfg_page_3_1',text='LA_PASSWORD'},
	t_password   = {t='password',id=id+6,xywh='s_cfg_ip_3_2',cmd = on_update_param},
	
	cap_ip = {t='static',id=id+7,xywh='s_cfg_page_4_1',text='LA_IP_ADDRESS'},
	t_ip   = {t='edit_ip',id=id+8,xywh='s_cfg_ip_4_2',},

	tipinfo		= {t='static',id=id+9,	xywh='s_pppoe_tipinfo_xywh',text='',trans = false},		
	tipsame		= {t='static',id=id+10,	xywh='s_pppoe_tipsame_xywh',text='LA_NOT_SAME_TIME',color = {'c_hint_bk', 'c_hint_border', 'c_hint_text'}},	
	apply 		= {t='button',	id=id+11,xywh='s_cfg_apply_xywh', text='LA_APPLY',cmd=on_apply},
}

return w1_page_pppoe