--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_privacy.pri_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local b_dlg 			= require("wnd.core.b_dlg")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg")
local b_wnd 	= require("wnd.core.b_wnd")
local w1_page_pri = 
{
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_pri.s_768 =
{
	s_pri_t_passdouble_xywh = {277,25,25,21},
	s_pri_t_wizard_xywh = {277,68,25,21},
	s_pri_t_autologin_xywh = {277,110,25,21},
	s_pri_t_other_xywh = {277,153,25,21},
	s_pri_t_tab_btn_size = {0,0,21,28},
	s_pri_t_chn_tab = {280,196,202,106},
	s_pri_t_tip_xywh = {53, 310, 500, 35}, 
	s_pri_tipinfo_xywh = {53,355,373,35},
};

w1_page_pri.s_1280 = 
{
	s_pri_t_passdouble_xywh 	= {455,36,48,30},
	s_pri_t_wizard_xywh		 	= {455,96,48,30},
	s_pri_t_autologin_xywh 		= {455,156,48,30},
	s_pri_t_other_xywh 			= {455,216,48,30},
	s_pri_t_tab_btn_size		= {0,0, 40, 40},
	s_pri_t_chn_tab				= {458,276, 380, 150},
	s_pri_t_tip_xywh 			= {100, 450, 700, 50}, 
	s_pri_tipinfo_xywh 			= {100,510,700,50},
}

w1_page_pri.s_1440 = 
{
	s_pri_t_passdouble_xywh 		= {520,25,48,30},
	s_pri_t_wizard_xywh				= {520,75,48,30},
	s_pri_t_autologin_xywh 			= {520,125,48,30},
	s_pri_t_other_xywh 				= {520,175,48,30},
	s_pri_t_tab_btn_size			= {0,0, 40, 40},
	s_pri_t_chn_tab					= {528,240, 380, 150},
	s_pri_t_tip_xywh 				= {100,430, 700, 50}, 
	s_pri_tipinfo_xywh 				= {100,500,700,50},
}

w1_page_pri.s_1080p = 
{
	s_pri_t_passdouble_xywh 		 = {520,36,48,30},
	s_pri_t_wizard_xywh				 = {520,96,48,30},
	s_pri_t_autologin_xywh 			 = {520,156,48,30},
	s_pri_t_other_xywh 				 = {520,216,48,30},
	s_pri_t_tab_btn_size			 = {0,0, 40, 40},
	s_pri_t_chn_tab					 = {525,276, 380, 150},	
	s_pri_t_tip_xywh 				= {100, 450, 700, 50}, 
	s_pri_tipinfo_xywh 				 = {100,510,700,50},
}

w1_page_pri.s_2k = 
{
	s_pri_t_passdouble_xywh 		= {693,48,64,40},
	s_pri_t_wizard_xywh				= {693,128,64,40},
	s_pri_t_autologin_xywh 			= {693,208,64,40},
	s_pri_t_other_xywh 				= {693,288,64,40},
	s_pri_t_tab_btn_size			= {0,0, 53, 53},
	s_pri_t_chn_tab					= {700,368, 490, 200},		
	s_pri_t_tip_xywh 				= {133,600, 933, 67}, 
	s_pri_tipinfo_xywh 				= {133,680,933, 67},
}

w1_page_pri.s_4k = 
{
	s_pri_t_passdouble_xywh 		 = {1040,72,96,60},
	s_pri_t_wizard_xywh				 = {1040,192,96,60},
	s_pri_t_autologin_xywh 			 = {1040,312,96,60},
	s_pri_t_other_xywh 				 = {1040,432,96,60},
	s_pri_t_tab_btn_size			 = {0,0, 80, 80},
	s_pri_t_chn_tab					 = {1050,552, 760, 300},	
	s_pri_t_tip_xywh 				 = {200, 900, 1400, 100}, 
	s_pri_tipinfo_xywh 				 = {200,1020,1400,100},
}

local refresh_enable = function(top, hide_flag, redraw)
	local cwnd = w1_page_pri.wnd;
		b_wnd_ex.set_hide(top, cwnd.cap_loginout_time.id,hide_flag, redraw); 		
		b_wnd_ex.set_hide(top, cwnd.t_loginout_time.id,hide_flag, redraw); 
		b_wnd_ex.set_hide(top, cwnd.cap_channel.id,hide_flag, redraw); 		
		b_wnd_ex.set_hide(top, cwnd.t_channel_tab.id,hide_flag, redraw); 
		b_wnd_ex.set_hide(top, cwnd.cap_expired_tip.id,hide_flag, redraw); 
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	local setcheck = function(id, check)
		b_wnd_ex.set_check(top, id, check, false);
	end
	local cwnd = w1_page_pri.wnd;
	local data = cfgdata.privacy;
	if(data.autologin == false) then
		setcheck(cwnd.t_autologin.id, true);
	else
		setcheck(cwnd.t_autologin.id, false);
	end
	
	setcheck(cwnd.t_passdouble.id, data.record_auth);

	if(data.guide == 1) then
		setcheck(cwnd.t_wizard.id, true);
	else
		setcheck(cwnd.t_wizard.id, false);
	end
	
	if(nil == data.keep_login_time)then
		data.keep_login_time = 300000
	end
	if(data.keep_login_time < 60000)then
		b_wnd_ex.set_value(top, cwnd.t_loginout_time.id,0,false); 
	else
		local time = math.floor(data.keep_login_time/60000)
		b_wnd_ex.set_value(top, cwnd.t_loginout_time.id, tonumber(time),false); 
	end
	
	if(data.autologin == false)then
		refresh_enable(top, true, false);
	else
		refresh_enable(top, false, false);
	end
	
	b_wnd_ex.set_chcopy_data(top,cwnd.t_channel_tab.id,data.logout_live_chn,false)
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local getcheck = function(id)
		return b_wnd_ex.get_check(top, id);
	end
	local cwnd = w1_page_pri.wnd
	local data = cfgdata.privacy
	if(getcheck(cwnd.t_autologin.id)) then
		data.autologin = false;
	else
		data.autologin = true;
	end
	
	data.record_auth = getcheck(cwnd.t_passdouble.id);
	
	if(getcheck(cwnd.t_wizard.id)) then
		data.guide = 1;
	else
		data.guide = 0;
	end
	
	local loginout_time = b_wnd_ex.get_value(top, cwnd.t_loginout_time.id); 

	local keep_login_time = tonumber(loginout_time)*60000;
	data.keep_login_time = keep_login_time;
	
	data.logout_live_chn = b_wnd_ex.get_chcopy_data(top, cwnd.t_channel_tab.id);	
end

local uidatacheck =function(top)
	local cwnd = w1_page_pri.wnd
	local legalflag = true
	local nlegalid = {}
	local c_wnd = w1_page_pri.wnd
	local loginout_time = b_wnd_ex.get_value(top, cwnd.t_loginout_time.id); 
--	loginout_time = string.sub(loginout_time, 1, -2); --ȥλ
	local p = select(2,string.gsub(loginout_time,"[.]",""));
	if(p ~= 0)then 
		legalflag =false
		table.insert(nlegalid, cwnd.t_loginout_time.id)
		w1_wnd_util.setparamerr_str(STR('LA_PARAM_INVALID'));
		return legalflag, nlegalid
	end
	if(legalflag) then
		return legalflag, nil
	else
		return legalflag, nlegalid
	end
end

local on_enable = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local check = b_wnd_ex.get_check(top, win_id)
		if(check)then
			refresh_enable(top, true, false);
		else
			refresh_enable(top, false, false);
		end
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

--UIָĬֵ
local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_update_param  = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg or  b_ui_msg.msg_user_update_parent == vmsg) then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_loginout_time = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.WM_USER_UPDATE_PARAM)then
		local cwnd = w1_page_pri.wnd
		local keep_login_time = b_wnd_ex.get_value(top, cwnd.t_loginout_time.id); 
		if(nil ~= keep_login_time and 0 ~= tonumber(keep_login_time))then
			if(tonumber(keep_login_time) > 10080 )then
				b_wnd_ex.set_value(top, cwnd.t_loginout_time.id,10080, false); 
			end
		else
			b_wnd_ex.set_value(top, cwnd.t_loginout_time.id,0, false); 
		end
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

w1_page_pri.apply =function(top)
	w1_wnd_util.uidatacheckfunc = uidatacheck
	local ret = nil;
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_pri.timer_start = function()
	w1_page_pri.timestart = true
end

w1_page_pri.timer_stop = function(top)
	w1_page_pri.timestart = false
	w1_wnd_util.tipclear(top, w1_page_pri.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_pri.timerenevt = function(top)
	if(w1_page_pri.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_pri.wnd.tipinfo.id)
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_pri.init = function(top)
	w1_wnd_util.cfgtab = {'privacy'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

w1_page_pri.on_pre_show = function(top)
	local channel_num = global_val.get_channelnum();
	local cwnd = w1_page_pri.wnd;
	b_wnd_ex.set_chcopy_chn_num(top, cwnd.t_channel_tab.id, channel_num, false)	
	local rect_size = SIZE('s_pri_t_tab_btn_size');
	b_wnd_ex.set_chn_type_size(top, cwnd.t_channel_tab.id, rect_size, false);
	
	local pb_flag = global_val.get_playback_support();
	if (pb_flag ~= true) then
		b_wnd_ex.set_hide(top, cwnd.cap_passdouble.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_passdouble.id, true, false);
		local move_h = 	SIZE('s_cfg_page_2_1')[2] - SIZE('s_cfg_page_1_1')[2];
		local s_id = cwnd.cap_wizard.id;
		local e_id = cwnd.t_channel_tab.id;
		for i = s_id, e_id do
			for k = 1, #cwnd.sub do
				if (cwnd[cwnd.sub[k]].id == i) then
					local pos = SIZE(cwnd[cwnd.sub[k]].xywh)
					b_wnd_ex.move_pos(top, i, {pos[1], pos[2] - move_h}, false);
					break;
				end
			end
		end
	end
end

w1_page_pri.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = { 'cap_passdouble', 't_passdouble', 'cap_wizard', 't_wizard','cap_autologin', 't_autologin','cap_loginout_time','t_loginout_time',
			'cap_channel', 't_channel_tab', 'cap_expired_tip', 'tipinfo', 'default', 'apply'},
			
	cap_passdouble 	= {t='static',		id=id+1,xywh='s_cfg_page_1_1',text='LA_DOUBLE_AUTHENTICATION'},
	t_passdouble 	= {t='tt_check', 	id=id+2,xywh='s_pri_t_passdouble_xywh',
						t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param
						},
	
	cap_wizard		= {t='static',		id=id+3,xywh='s_cfg_page_2_1',text='LA_ENABLE_SET_WIZARD'},
	t_wizard 		= {t='tt_check',	id=id+4,xywh='s_pri_t_wizard_xywh',
						t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_update_param
						},	
	
	cap_autologin 	= {t='static',		id=id+5,xywh='s_cfg_page_3_1',text='LA_ENABLE_AUTO_LOGIN'},
	t_autologin 	= {t='tt_check', 	id=id+6,xywh='s_pri_t_autologin_xywh',
						t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},cmd = on_enable
						},
						
	cap_loginout_time 	= {t='static',		id=id+7,xywh='s_cfg_page_4_1',text='LA_LOGOUT_TIME'},
	t_loginout_time 	= {t='edit_num', 	id=id+8,range={0,10080},xywh='s_cfg_page_4_2',cmd = on_loginout_time},
						
	cap_channel 	= {t='static',	id=id+9,xywh='s_cfg_page_5_1',text='LA_CH_LOGOUT'},
	t_channel_tab = {t='chn_copy', id=id+10,	xywh='s_pri_t_chn_tab',
					color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n',}, cmd = on_update_param},	

	cap_expired_tip = {t='static',id=id+11,xywh='s_pri_t_tip_xywh',text='LA_AUTO_LOGIN_TIME_TIP',
					color = {'c_hint_bk', 'c_hint_border', 'c_hint_text'}},

	tipinfo		= {t='static',id=id+12,	xywh='s_pri_tipinfo_xywh',text='',trans = false},
	
	apply 		= {t='button',id=id+13,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},

}

return w1_page_pri
