--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_privacy.privacy_id
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local w1_add_user	= require("wnd.w1_cfg.w1_add_user")
local r_size		= require("wnd.core.r_res.r_size")
local util 			= require("wnd.core.util")
local SIZE 			= r_size.get_size


local w1_page_privacy = 
{
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_privacy.s_768 =
{
	s_privacy_userlist_xywh = {53,21,609,426},
	s_privacy_add_xywh = {571,462,90,28},
	s_privacy_list_w1 = {42,0,0,0},
	s_privacy_list_w2 = {226,0,0,0},
	s_privacy_list_w3 = {226,0,0,0},
	s_privacy_list_w4 = {105,0,0,0},
};

w1_page_privacy.s_1280 = 
{
	s_privacy_userlist_xywh = {100,30,761,600},
	s_privacy_add_xywh = {691,650,170,40},
	s_privacy_list_w1 = {53,0,0,0},
	s_privacy_list_w2 = {283,0,0,0},
	s_privacy_list_w3 = {283,0,0,0},
	s_privacy_list_w4 = {130,0,0,0},
}
w1_page_privacy.s_1440 = 
{
	s_privacy_userlist_xywh = {100,30,900,500},
	s_privacy_add_xywh = {830,540,170,40},
	s_privacy_list_w1 = {54,0,0,0},
	s_privacy_list_w2 = {353,0,0,0},
	s_privacy_list_w3 = {353,0,0,0},
	s_privacy_list_w4 = {130,0,0,0},
}

w1_page_privacy.s_1080p = 
{
	s_privacy_userlist_xywh = {100,30,1142,600},
	s_privacy_add_xywh = {1072,650,170,40},
	s_privacy_list_w1 = {80,0,0,0},
	s_privacy_list_w2 = {425,0,0,0},
	s_privacy_list_w3 = {425,0,0,0},
	s_privacy_list_w4 = {200,0,0,0},
}

w1_page_privacy.s_2k = 
{
	s_privacy_userlist_xywh = {133,40,1522,800},
	s_privacy_add_xywh = {1429,866,227,53},
	s_privacy_list_w1 = {107,0,0,0},
	s_privacy_list_w2 = {567,0,0,0},
	s_privacy_list_w3 = {567,0,0,0},
	s_privacy_list_w4 = {267,0,0,0},

}

w1_page_privacy.s_4k = 
{
	s_privacy_userlist_xywh = {200,60,2284,1200},
	s_privacy_add_xywh = {2144,1300,340,80},
	s_privacy_list_w1 = {160,0,0,0},
	s_privacy_list_w2 = {850,0,0,0},
	s_privacy_list_w3 = {850,0,0,0},
	s_privacy_list_w4 = {400,0,0,0},


}

local refresh_list = function(top, redraw)
	local cwnd = w1_page_privacy.wnd
	local data = w1_page_privacy.data;
	local dispdata = {};
	
	dispdata.item_total = data.usercount;
	
	local cur_userdata;
	local hide_opera = {};
	for i=1,dispdata.item_total do
		cur_userdata = data['user'..i];
		dispdata['idx'..i] = nil;
		dispdata['idx'..i] ={};
		dispdata['idx'..i] = {i-1, false, tostring(i), 
			cur_userdata.username, cur_userdata.groupname,''};
		if i == 1 then
			hide_opera[1] = true
		else
			hide_opera[i] = false
		end
	end
	b_wnd_ex.set_listdata(top, cwnd.userlist.id, dispdata, redraw);
	b_wnd_ex.set_hide_opera2(top,cwnd.userlist.id,hide_opera,redraw);
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	w1_page_privacy.data = cfgdata.user;
	local date_fmt = cfgdata.time.date_fmt
	w1_add_user.set_data(w1_page_privacy.data,date_fmt);
	local cwnd = w1_page_privacy.wnd;
	
	refresh_list(top, false);
	return 0;
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)

	return 0;
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil;
end	

w1_page_privacy.clear_data = function()
	w1_add_user.clear_data();
	w1_page_privacy.data = nil;
end

local ok_func = function(param)
	--¶ȡ,ˢб
	b_app_cfg.init({'user','time'});
	cfgdatatoui(param[1], b_app_cfg.origin_cfg)
	
	return 0;
end

--ҳʼʱٶȡҳҪ
w1_page_privacy.init = function(top)
	w1_wnd_util.cfgtab = {'user','time'};
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);
	
	w1_add_user.init();
	w1_add_user.set_func(ok_func, {top});
	return 0;
end


local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_privacy.wnd;
		b_dlg.do_modal(top, w1_key.DLG_MSG_ADDUSER, 0, 0, nil)
	end
	return 0;
end

w1_page_privacy.on_pre_show = function(top)
	local cwnd = w1_page_privacy.wnd;
	local param = {
			STR('LA_ID'), STR('LA_USER_NAME'),STR('LA_GROUPS'),STR('LA_OPERATE'), STR('LA_INFORMATION')
		}
	b_wnd_ex.set_title_texts(top, cwnd.userlist.id, param, false)
	
	local list_w = {};
	for i=1,4 do
		local str = 's_privacy_list_w'..math.floor(i/1);
		list_w[i] = SIZE(str)[1];
	end
	b_wnd_ex.columns_w(top, cwnd.userlist.id, list_w, false);
end

w1_page_privacy.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'userlist', 'add',
			'default', 'apply' },
	
	userlist	= {t='list',	id=id+1,	xywh='s_privacy_userlist_xywh', font = 'f_grade4',
					listattr = {14,4,b_ui.LISTATTR.FIRST_WIDGET_STATIC,b_ui.LISTATTR.END_WIDGET_EDITDEL},
					dlg_key = {w1_key.DLG_MSG_ADDUSER, w1_key.DLG_MSG_ADDUSER},
					title_texts = {STR('LA_ID'), STR('LA_USER_NAME'),STR('LA_GROUPS'),STR('LA_OPERATE'), STR('LA_INFORMATION')},
					columns_w = {80,425,425,200},
					},
	add 		= {t='button',	id=id+2,	xywh='s_privacy_add_xywh', text='LA_ADD',cmd=on_add},

}

return w1_page_privacy;
