--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_privacyarea.privacyarea_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local SIZE		= r_size.get_size;
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local util 		= require("wnd.core.util")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local b_app_cfg		= require("wnd.core.b_app_cfg")
local w1_page_privacyarea = 
{
	old_chid,
	data,
	sel,
	timestart = false,
	copy_ch = {},
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_privacyarea.s_768 =
{
	s_cfg_priimg_xywh = {70,22,352,256},
	s_privacyarea_cap_channel_xywh = {436,35,85,35},
	s_privacyarea_t_channel_xywh = {543,39,131,28},
	s_privacyarea_info1_xywh = {70,312,533,35},
	s_privacyarea_info2_xywh = {70,341,533,35},
	s_privacyarea_info3_xywh = {70,369,533,35},
	s_privacyarea_tipinfo_xywh = {70,398,373,35},
};

w1_page_privacyarea.s_1280 = 
{
	s_cfg_priimg_xywh = {92,32,640,360},
	s_privacyarea_cap_channel_xywh = {750,50,110,50},
	s_privacyarea_t_channel_xywh = {860,55,100,40},
	s_privacyarea_info1_xywh = {92,440,860,50},
	s_privacyarea_info2_xywh = {92,480,800,50},
	s_privacyarea_info3_xywh = {92,520,800,50},
	s_privacyarea_tipinfo_xywh = {92,560,700,50},
};

w1_page_privacyarea.s_1440 = 
{
	s_cfg_priimg_xywh = {100,32,640,360},
	s_privacyarea_cap_channel_xywh = {750,50,140,50},
	s_privacyarea_t_channel_xywh = {880,55,140,40},
	s_privacyarea_info1_xywh = {100,440,1000,50},
	s_privacyarea_info2_xywh = {100,480,1000,50},
	s_privacyarea_info3_xywh = {100,520,1000,50},
	s_privacyarea_tipinfo_xywh = {100,560,700,50},
	
};

w1_page_privacyarea.s_1080p = 
{
	s_cfg_priimg_xywh = {98,32,640,360},
	s_privacyarea_cap_channel_xywh = {800,50,160,50},
	s_privacyarea_t_channel_xywh = {1000,55,246,40},
	s_privacyarea_info1_xywh = {98,440,1000,50},
	s_privacyarea_info2_xywh = {98,480,1000,50},
	s_privacyarea_info3_xywh = {98,520,1000,50},
	s_privacyarea_tipinfo_xywh = {98,560,700,50},
};
w1_page_privacyarea.s_2k = 
{
	s_cfg_priimg_xywh = {136,43,856,480},
	s_privacyarea_cap_channel_xywh = {1066,67,213,67},
	s_privacyarea_t_channel_xywh = {1333,73,328,53},
	s_privacyarea_info1_xywh = {133,587,1333,67},
	s_privacyarea_info2_xywh = {133,640,1333,67},
	s_privacyarea_info3_xywh = {133,693,1333,67},
	s_privacyarea_tipinfo_xywh = {133,746,933,67},

};
w1_page_privacyarea.s_4k = 
{
	s_cfg_priimg_xywh = {200,64,1284,720},
	s_privacyarea_cap_channel_xywh = {1600,100,320,100},
	s_privacyarea_t_channel_xywh = {2000,110,492,80},
	s_privacyarea_info1_xywh = {200,880,2000,100},
	s_privacyarea_info2_xywh = {200,960,2000,100},
	s_privacyarea_info3_xywh = {200,1040,2000,100},
	s_privacyarea_tipinfo_xywh = {200,1120,1400,100},

};

local channel_num;--豸ͨĿ

w1_page_privacyarea.clear_data = function()
	w1_page_privacyarea.data = nil;
	w1_page_privacyarea.copy_ch = nil;
end	

local set_priarea = function(top, chid, redraw)
	local cfgdata = w1_page_privacyarea.data;
	local c_wnd = w1_page_privacyarea.wnd
	
	local areadata = cfgdata['privacy_area']['channel'..chid]
	local areas ={};
	for i=1,4 do
		areas['area'..i] = nil;
		areas['area'..i] = {};
		areas['area'..i].area_id = i;
		if(areadata['area'..i] ~= nil) then	
			local posdata = areadata['area'..i];
			areas['area'..i].x 	= areadata['area'..i].x;
			areas['area'..i].y 	= areadata['area'..i].y;
			areas['area'..i].cx = areadata['area'..i].cx;
			areas['area'..i].cy = areadata['area'..i].cy;
			if(posdata.x ==0 and posdata.y >=0 and posdata.cx ==0 and posdata.cy == 0) then
				areas['area'..i].leisure = true;
			else
				areas['area'..i].leisure = false;
			end
		else
			areas['area'..i].x 	= 0;
			areas['area'..i].y 	= 0;
			areas['area'..i].cx = 0;
			areas['area'..i].cy = 0;
			areas['area'..i].leisure = true;
		end	
	end
	b_wnd_ex.set_areas(top, c_wnd.image.id, areas, redraw)	
end

local set_custom_layout = function(chid)
	local param = {
		chn_id = chid,
		wnd_id = 1,
	}
	local layoutpos = w1_page_privacyarea.layoutpos;
	param.x = layoutpos.x;
	param.y = layoutpos.y;
	param.cx = layoutpos.cx;
	param.cy = layoutpos.cy;
	b_app_api.set_custom_layout_wnd(param);
end


--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	w1_page_privacyarea.data = cfgdata;
	
	local c_wnd = w1_page_privacyarea.wnd
	local camreaitems = {};
	local idx = 1;
	local privilege = global_val.get_allprivilege();--ȡȨ
	local ch_prilist = privilege.channel_manager_list;
	for i=1, channel_num do
		if(cfgdata['privacy_area']['channel'..i] ~= nil and ch_prilist[i] == 1 ) then
			camreaitems[idx] = i;
			idx = idx + 1;
		end
	end
	
	b_wnd_ex.set_items(top, c_wnd.t_channel.id, camreaitems, false);
	if(0 == w1_page_privacyarea.sel) then
		b_wnd_ex.set_sel(top, c_wnd.t_channel.id, 0, false);--Ĭϵһ
	else
		b_wnd_ex.set_sel(top, c_wnd.t_channel.id, w1_page_privacyarea.sel,false)
	end
	if(idx ~= 1) then--˵ͨ
		b_wnd_ex.set_enableselect(top, c_wnd.image.id, true, false);--˽ؼ
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id,false, false)
	--	b_wnd_ex.set_sel(top, c_wnd.t_channel.id, 0, false);--Ĭϵһ
		
		local chid =tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
		set_priarea(top, chid, false)
		b_wnd_ex.set_areas(top, c_wnd.image.id, areas, false)	
	else--ͨ
		b_wnd_ex.set_enableselect(top, c_wnd.image.id, false, false);--˽ؼ
		b_wnd_ex.set_disable (top, c_wnd.t_channel.id,true, false);
		for i=1, channel_num do
			if(ch_prilist[i] ~= 0) then
				set_custom_layout(i);
				break;
			end
		end	
	end
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local c_wnd = w1_page_privacyarea.wnd;
	local chid = tonumber(b_wnd_ex.get_text(top, c_wnd.t_channel.id));
	if(chid == nil) then
		return 0
	end
	
	local data = cfgdata['privacy_area']['channel'..chid]
	local areas =b_wnd_ex.get_areas(top, c_wnd.image.id)
	local area_num = 0;
	for i=1,4 do
		if(data['area'..i] == nil) then
			data['area'..i] = {}
		end
		if(areas['area'..i].leisure == false) then		
			local pos = areas['area'..i];
			assert(pos.x >= 0 and pos.y >= 0 and pos.cx >=0 and pos.cy >=0);
			area_num = area_num + 1;
			data['area'..area_num].area_id = areas['area'..i].area_id
			data['area'..area_num].x = areas['area'..i].x
			data['area'..area_num].y = areas['area'..i].y
			data['area'..area_num].cx = areas['area'..i].cx
			data['area'..area_num].cy = areas['area'..i].cy	
		else
			data['area'..i].area_id = areas['area'..i].area_id
			data['area'..i].x = 0
			data['area'..i].y = 0
			data['area'..i].cx = 0
			data['area'..i].cy = 0
		end
	end
	data.area_num = area_num;
	data.change_flag = true;
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

--ж
local returndatacheck =function(top,ret)
	if(ret ~= nil and ret.network_ipv4 ~= 0) then--޸ʧ
		local cwnd = w1_page_privacyarea.wnd;
		local nlegalid = {};
--		table.insert(nlegalid, cwnd.t_ip.id);
--		table.insert(nlegalid, cwnd.t_ip.id);
		
		if(ret.privacy_area ~= 1) then
			w1_wnd_util.setparamerr_str(STR('LA_APPLY_FAIL'));	
			return false, nlegalid;
		end
		
	end
	return true, nil;
end

local clear_change_flag =function (top,cfgdata)
	for i=1, channel_num do
		if(nil ~= cfgdata['privacy_area'] and nil ~= cfgdata['privacy_area']['channel'..i])then
			local data = cfgdata['privacy_area']['channel'..i]
			data.change_flag = false;
		end
	end
end

w1_page_privacyarea.timer_start = function()
	w1_page_privacyarea.timestart = true
end

w1_page_privacyarea.timer_stop = function(top)
	w1_page_privacyarea.timestart = false
	w1_wnd_util.tipclear(top, w1_page_privacyarea.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_privacyarea.timerenevt = function(top)
	if(w1_page_privacyarea.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_privacyarea.wnd.tipinfo.id)
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_privacyarea.init = function(top)
	local c_wnd = w1_page_privacyarea.wnd;
	w1_page_privacyarea.sel = 0;
	w1_wnd_util.cfgtab = {'privacy_area'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	
	local chidstr = b_wnd_ex.get_text(top, c_wnd.t_channel.id);
	if(chidstr == '') then
		return 0
	end
	local chid =tonumber(chidstr);
	w1_page_privacyarea.old_chid = chid;
	set_custom_layout(chid);
	return 0
end

local on_channel= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local chid =tonumber(b_wnd_ex.get_text(top, w1_page_privacyarea.wnd.t_channel.id));
		if(w1_page_privacyarea.old_chid ~= chid) then
			set_custom_layout(chid);
			set_priarea(top, chid, true);
			w1_page_privacyarea.old_chid = chid;
		end
	end
	return 0;
end

local copy_okfunc = function(param)
	local cwnd = w1_page_privacyarea.wnd;
	local chid = tonumber(b_wnd_ex.get_text(param[1], cwnd.t_channel.id));
	if(chid == nil) then
		return 0;
	end
	local chsrc = w1_page_privacyarea.data.privacy_area['channel'..chid];
	local chdir = w1_page_privacyarea.data.privacy_area;
	
	for i=1, #param[2] do
	--	if(chdir['channel'..param[2][i]] == nil) then
			chdir['channel'..param[2][i]] = nil
			chdir['channel'..param[2][i]] = util.copy_tab(chsrc)
	--	else
		--	util.copy_tab_b(chdir['channel'..param[2][i]], chsrc)
	--	end
		chdir['channel'..param[2][i]].change_flag = true;
	--	chdir['channel'..param[2][i]].channel_id = param[2][i];
	end
	return 0;
end

local on_copy = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_privacyarea.wnd;
		local param = {};
		local idx = 1;
		local cameralist = b_app_api.get_cfg({'camera'}).camera;
		local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
	--	uitousercfg(top, w1_page_privacyarea.data)
		local privilege = global_val.get_allprivilege();--ȡȨ
		local ch_prilist = privilege.channel_manager_list;	
		for i=1, channel_num do
			if( i ~= chid and  nil ~= chid and cameralist['idx'..chid].protocol ~= 1 and w1_page_privacyarea.data.privacy_area['channel'..i] ~= nil
				 and ch_prilist[i] == 1) and cameralist['idx'..i].protocol ~= 1 then
				param[idx] = i;
				idx =idx + 1;
			end
		end
		w1_copy.init();
		w1_copy.set_dlgattr(param);
		w1_copy.set_func (copy_okfunc,{top, w1_page_privacyarea.copy_ch} );
		b_dlg.post_modal(top, w1_key.DLG_COPY, 0, 0, nil)
	end
	return 0
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_update_param = function(top, id, vmsg, x, y)
	if (vmsg == b_ui.WM_USER_UPDATE_PARAM) then
		uitousercfg(top,b_app_cfg.user_cfg);
	elseif (vmsg == b_ui.RBUTTONCLK) then
		return vmsg;
	end
	return 0;
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.returndatacheckfunc = returndatacheck;
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
		local data_key = {'privacy_area'}
		b_app_cfg.init(data_key)
		w1_page_privacyarea.sel = b_wnd_ex.get_sel(top, w1_page_privacyarea.wnd.t_channel.id);
		cfgdatatoui(top, b_app_cfg.user_cfg)
	--	clear_change_flag(top,b_app_cfg.user_cfg);
	end
	return 0
end

w1_page_privacyarea.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	w1_wnd_util.returndatacheckfunc = returndatacheck;
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()
	end
	
	return ret;
end

w1_page_privacyarea.on_pre_show = function(top)
	channel_num = global_val.get_channelnum();
	
	
	local cwnd = w1_page_privacyarea.wnd;
	local param = {
		x = SIZE('s_cfg_priimg_xywh')[1] + SIZE('s_cfg_page_xywh')[1], 
		y = SIZE('s_cfg_priimg_xywh')[2] + SIZE('s_cfg_page_xywh')[2],
		cx = SIZE('s_cfg_priimg_xywh')[3],
		cy = SIZE('s_cfg_priimg_xywh')[4],
	}
	local oldparam_x = param.x;
	param.x = math.floor((param.x + 2) / 4) * 4;--֤4ı
	param.cx = math.floor((param.cx + 2) / 4) *4;
	local oldparam_y = param.y;
	param.y = math.floor((param.y + 2) / 4) * 4;
	param.cy = math.floor((param.cy + 2) / 4) *4;
	
	w1_page_privacyarea.layoutpos.x = param.x;
	w1_page_privacyarea.layoutpos.cx = param.cx;
	w1_page_privacyarea.layoutpos.y = param.y;
	w1_page_privacyarea.layoutpos.cy = param.cy;
	
	local pos = {};
	pos[1] = SIZE('s_cfg_priimg_xywh')[1] + param.x - oldparam_x;
	pos[2] = SIZE('s_cfg_priimg_xywh')[2] + param.y - oldparam_y;
	pos[3] = param.cx;
	pos[4] = param.cy;
	b_wnd_ex.move_ex(top, cwnd.image.id, pos, false);
end

w1_page_privacyarea.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	
	sub = { 'image', 'cap_channel', 't_channel','info1','info2','info3',
			'tipinfo',--[[ 'copy',--]] 'default', 'apply'},
		
	
	cap_channel	= {t='static',	id=id+1,	xywh='s_privacyarea_cap_channel_xywh',		text='LA_CHANNEL'},
	t_channel 	= {t='combox',	id=id+2,	xywh='s_privacyarea_t_channel_xywh',		items={},		trans = false,channel_cbox = true,cmd = on_channel},	
		
	image 		= {t='priarea',	id=id+3,	xywh='s_cfg_priimg_xywh',	text='Image widget', 
					font = 'f_grade1', trans = false,
					color = {'c_imgae_param_bg', 'c_imgae_param_bg', 'c_imgae_param_bg'}, cmd = on_update_param},
	info1		= {t='static',	id=id+4,	xywh='s_privacyarea_info1_xywh',      text='LA_HELP_AREA'},
	info2		= {t='static',	id=id+5,	xywh='s_privacyarea_info2_xywh',      text='LA_HELP_AREA_DEL'},
	info3		= {t='static',	id=id+6,	xywh='s_privacyarea_info3_xywh',      text='LA_LIMIT_SET_MASKED'},
	tipinfo		= {t='static',	id=id+7,	xywh='s_privacyarea_tipinfo_xywh',		text='',		trans = false},	
	
	copy 		= {t='button',	id=id+8,	xywh = 's_cfg_copy_xywh',	text='LA_COPY_TO',	cmd=on_copy},
	apply 		= {t='button',	id=id+10,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',	cmd=on_apply},
}


return w1_page_privacyarea

