--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created:  2019/3/14
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_raid.raid_id
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local w1_create_raid	= require("wnd.w1_cfg.w1_create_raid")
local w1_edit_raid	= require("wnd.w1_cfg.w1_edit_raid")	
local r_size		= require("wnd.core.r_res.r_size")
local util 			= require("wnd.core.util")
local SIZE 			= r_size.get_size
local global_val= require("wnd.global_val")

local w1_page_raid = 
{
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_raid.s_768 =
{
	s_raid_raidlist_xywh = {42,21,752,426},
	s_raid_add_xywh = {704,462,90,28},
	s_raid_list_w1 = {42,0,0,0},
	s_raid_list_w2 = {106,0,0,0},
	s_raid_list_w3 = {106,0,0,0},
	s_raid_list_w4 = {106,0,0,0},
	s_raid_list_w5 = {106,0,0,0},
	s_raid_list_w6 = {186,0,0,0},
	s_raid_list_w7 = {69,0,0,0},
};

w1_page_raid.s_1280 = 
{
	s_raid_raidlist_xywh = {80,30,860,600},
	s_raid_add_xywh = {770,650,170,40},
	s_raid_list_w1 = {50,0,0,0},
	s_raid_list_w2 = {125,0,0,0},
	s_raid_list_w3 = {135,0,0,0},
	s_raid_list_w4 = {125,0,0,0},
	s_raid_list_w5 = {100,0,0,0},
	s_raid_list_w6 = {180,0,0,0},
	s_raid_list_w7 = {125,0,0,0},
}
w1_page_raid.s_1440 = 
{
	s_raid_raidlist_xywh = {80,30,910,500},
	s_raid_add_xywh = {820,540,170,40},
	s_raid_list_w1 = {60,0,0,0},
	s_raid_list_w2 = {130,0,0,0},
	s_raid_list_w3 = {140,0,0,0},
	s_raid_list_w4 = {135,0,0,0},
	s_raid_list_w5 = {120,0,0,0},
	s_raid_list_w6 = {190,0,0,0},
	s_raid_list_w7 = {100,0,0,0},
}

w1_page_raid.s_1080p = 
{
	s_raid_raidlist_xywh = {80,30,1410,600},--1142
	s_raid_add_xywh = {1320,650,170,40},
	s_raid_list_w1 = {80,0,0,0},
	s_raid_list_w2 = {200,0,0,0},
	s_raid_list_w3 = {200,0,0,0},
	s_raid_list_w4 = {200,0,0,0},
	s_raid_list_w5 = {200,0,0,0},
	s_raid_list_w6 = {350,0,0,0},
	s_raid_list_w7 = {130,0,0,0},
}

w1_page_raid.s_2k = 
{
	s_raid_raidlist_xywh = {107,40,1880,800},
	s_raid_add_xywh = {1760,866,227,53},
	s_raid_list_w1 = {107,0,0,0},
	s_raid_list_w2 = {267,0,0,0},
	s_raid_list_w3 = {267,0,0,0},
	s_raid_list_w4 = {267,0,0,0},
	s_raid_list_w5 = {267,0,0,0},
	s_raid_list_w6 = {467,0,0,0},
	s_raid_list_w7 = {173,0,0,0},


}

w1_page_raid.s_4k = 
{
	s_raid_raidlist_xywh = {200,60,2820,1200},
	s_raid_add_xywh = {2678,1300,340,80},
	s_raid_list_w1 = {160,0,0,0},
	s_raid_list_w2 = {400,0,0,0},
	s_raid_list_w3 = {400,0,0,0},
	s_raid_list_w4 = {400,0,0,0},
	s_raid_list_w5 = {400,0,0,0},
	s_raid_list_w6 = {700,0,0,0},
	s_raid_list_w7 = {260,0,0,0},



}

w1_page_raid.clear_data = function()
	w1_page_raid.data = nil;
	w1_edit_raid.clear_data();	
	w1_create_raid.clear_data();
end	

local update_list = function(top, redraw)
	local cwnd = w1_page_raid.wnd;
	local data =w1_page_raid.data.raid
	local privilege = G.get_allprivilege()
	
	local raid;
	local raidlist = {};
	raidlist.item_total = data.raid_num
	local hide_opera1 = {};
	local hide_opera2 = {};
	for i=1, raidlist.item_total do
		raid = data['raid'..i]
		--Capicity
		local temp = math.floor(raid.raid_size/1000);
		local capcity = nil;
		if(temp > 1000)then
			temp = math.floor(temp/1000);
			capcity = tostring(temp).." TB";
		else
			capcity = tostring(temp).." GB";
		end
		
		-- status
		local status = STR('LA_NORMAL')
		if(raid.status == 65)then
			status = STR('LA_NORMAL')
			hide_opera1[i] = false
		elseif(raid.status == 66)then
			status = STR('LA_WARNING')
			hide_opera1[i] = false
		elseif(raid.status == 67)then 
			status = STR('LA_DESTROYED')
			hide_opera1[i] = true
		elseif(raid.status == 68)then 
			status = STR('LA_RECOVER')
			hide_opera1[i] = false
		elseif(raid.status == 69)then 
			status = STR('LA_LOAD_FAIL')
			hide_opera1[i] = true
		else
			print("raid status:"..status)
			status = STR('LA_UNKNOWN_MISTAKE')
			hide_opera1[i] = false
		end
		if false == privilege.system_maintenance then
			hide_opera1[i] = true;
			hide_opera2[i] = true;
		end
		--Type
		local raidtype ="";
		if(5 == raid.raid_type)then
			raidtype ="RAID 5";
		elseif(6 == raid.raid_type)then
			raidtype ="RAID 6";
		elseif(10 == raid.raid_type)then
			raidtype ="RAID 10";
		else
			print("--------Raid Type:"..raid.raid_type);
		end
		
		--HDD Members
		local str = "";
		for j=1, data['raid'..i].disk_num do
			if(nil == data['raid'..i]['disk'..j])then
				break;
			end
			
			if(nil == data['raid'..i]['disk'..j].disk_enable)then
				break;
			end
			
			
			if(0 ~= data['raid'..i]['disk'..j].disk_enable)then
				--[[if("" == str)then
					str = tostring(data['raid'..i]['disk'..j].host_id).."-"..tostring(data['raid'..i]['disk'..j].chn_id)
				else
					str = str..","..tostring(data['raid'..i]['disk'..j].host_id).."-"..tostring(data['raid'..i]['disk'..j].chn_id)
				end--]]
				local diskname = data['raid'..i]['disk'..j].disk_name;
				
				local ts = "k"
				local param1, pos = string.find(diskname, ts) 
				if(nil == pos)then
					pos = 0;
				end
				local dst_str = string.sub(diskname, pos+1, string.len(diskname))   
				if("" == str)then
					str = diskname;
				else
					str = str..","..dst_str		
				end
			end
			
		end

		local raidname = "RAID-"..raid.raid_name;
		raidlist['idx'..i] = {i-1, false, tostring(i), raidname,capcity, status,raidtype,str,''};
		
	end
	b_wnd_ex.set_listdata(top, cwnd.raidlist.id, raidlist, false);
	b_wnd_ex.set_hide_opera1(top,cwnd.raidlist.id, hide_opera1,false);
	if false == privilege.system_maintenance then
		b_wnd_ex.set_hide_opera2(top,cwnd.raidlist.id, hide_opera2,false);
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	w1_page_raid.data = cfgdata;
	
	w1_create_raid.set_data(w1_page_raid.data);
	w1_edit_raid.set_data(w1_page_raid.data);
	--local cwnd = w1_page_raid.wnd;
	
	update_list(top, false);
	return 0;
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)

	return 0;
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil;
end	


local ok_func = function(param)
	--¶ȡ,ˢб
	b_app_cfg.init({'raid','disk'});
	cfgdatatoui(param[1], b_app_cfg.origin_cfg)
	
	return 0;
end

--ҳʼʱٶȡҳҪ
w1_page_raid.init = function(top)
	w1_wnd_util.cfgtab = {'raid','disk'};
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);

	w1_create_raid.init();
	w1_create_raid.set_func(ok_func, {top});
	
	w1_edit_raid.init();
	w1_edit_raid.set_func(ok_func, {top});
	return 0;
end


local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_raid.wnd;
		b_dlg.do_modal(top, w1_key.DLG_MSG_RAID, 0, 0, nil)	
	end
	return 0;
end

w1_page_raid.on_pre_show = function(top)
	local cwnd = w1_page_raid.wnd;
	local param = {
			STR('LA_ID'), STR('LA_RAID_NAME'),STR('LA_CAPACITY'),STR('LA_STATUS'),STR('LA_TYPE'), STR('LA_HDD_MEMBER'), STR('LA_OPERATE')
		};
	b_wnd_ex.set_title_texts(top, cwnd.raidlist.id, param, false)
	
	local list_w = {};
	for i=1,7 do
		local str = 's_raid_list_w'..math.floor(i/1);
		list_w[i] = SIZE(str)[1];
	end
	b_wnd_ex.columns_w(top, cwnd.raidlist.id, list_w, false);
	local privilege = G.get_allprivilege()
	if false == privilege.system_maintenance then
		b_wnd_ex.set_hide(top,cwnd.add.id,true,false);
	else
		b_wnd_ex.set_hide(top,cwnd.add.id,false,false);
	end

end

w1_page_raid.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'raidlist', 'add',
			'default', 'apply' },
	
	raidlist	= {t='list',	id=id+1,	xywh='s_raid_raidlist_xywh', font = 'f_grade4',
					listattr = {14,7,b_ui.LISTATTR.FIRST_WIDGET_STATIC,b_ui.LISTATTR.END_WIDGET_EDITDEL},
					dlg_key = {w1_key.DLG_EDIT_RAID, w1_key.DLG_EDIT_RAID},
					title_texts = {STR('LA_ID'), "RAID Name","Capicity","Type", "HDD Members", "Working MOde", "Operation"},
					columns_w = {80,200,200,150,200,300,130},
					},
	add 		= {t='button',	id=id+2,	xywh='s_raid_add_xywh', text='LA_CREATE',cmd=on_add},

}

return w1_page_raid;
