--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/11/7
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_restart.restart_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_dlg 		= require("wnd.core.b_dlg")
local w1_msgbox	 	= require("wnd.w1_util.w1_msgbox")
local w1_key 		= require("wnd.w1_util.w1_key")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local util 			= require("wnd.core.util")
local b_app_api 	= require("wnd.core.command.b_app_api")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE			= r_size.get_size;
local w1_page_restart 	= 
{
	data,
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_restart.s_768 =
{
	s_restart_cap_enable_xywh = {53,21,149,32},
	s_restart_t_enable_xywh = {237,21,25,21},
	s_restart_cap_time_xywh = {53,64,106,32},
	s_restart_t_interval_xywh = {240,64,106,32},
	s_restart_t_week_xywh = {352,64,106,32},
	s_restart_t_time_xywh = {464,64,106,32},
	s_restart_tipinfo_xywh = {53,490,373,35},
};

w1_page_restart.s_1280 = 
{	
	s_restart_cap_enable_xywh= {100, 30,200,45},
	s_restart_t_enable_xywh = {335, 30,48,30},
	s_restart_cap_time_xywh = {100, 90,200,45},
	s_restart_t_interval_xywh = {340, 90,200,45},
	s_restart_t_week_xywh = {545, 90,200,45},
	s_restart_t_time_xywh = {750, 90,200,45},
	s_restart_tipinfo_xywh = {100,690,700,50},	
}

w1_page_restart.s_1440 = 
{
	s_restart_cap_enable_xywh= {100, 30,280,45},
	s_restart_t_enable_xywh = {390, 30,48,30},
	s_restart_cap_time_xywh = {100, 90,200,45},
	s_restart_t_interval_xywh = {395, 90,200,45},
	s_restart_t_week_xywh = {605, 90,200,45},
	s_restart_t_time_xywh = {815, 90,200,45},
	s_restart_tipinfo_xywh = {100,690,700,50},	
}

w1_page_restart.s_1080p = 
{
	s_restart_cap_enable_xywh= {100, 30,280,45},
	s_restart_t_enable_xywh = {445, 30,48,30},
	s_restart_cap_time_xywh = {100, 90,200,45},
	s_restart_t_interval_xywh = {450, 90,200,45},
	s_restart_t_week_xywh = {660, 90,200,45},
	s_restart_t_time_xywh = {870, 90,200,45},
	s_restart_tipinfo_xywh = {100,690,700,50},	
}

w1_page_restart.s_2k = 
{	
	s_restart_cap_enable_xywh= {133,40,373,60},
	s_restart_t_enable_xywh = {595,40,64,40},
	s_restart_cap_time_xywh = {133,120,267,60},
	s_restart_t_interval_xywh = {600,120,267,60},
	s_restart_t_week_xywh = {880,120,267,60},
	s_restart_t_time_xywh = {1160,120,267,60},
	s_restart_tipinfo_xywh = {133,920,933,67},	
}

w1_page_restart.s_4k = 
{
	s_restart_cap_enable_xywh= {200,60,560,90},
    s_restart_t_enable_xywh = {890,60,96,60},
    s_restart_cap_time_xywh = {200,180,400,90},
    s_restart_t_interval_xywh = {900,180,400,90},
    s_restart_t_week_xywh = {1320,180,400,90},
    s_restart_t_time_xywh = {1740,180,400,90},
    s_restart_tipinfo_xywh = {200,1380,1400,100},
}

local week_str =
{
	'LA_MONDAY_T',		'LA_TUESDAY_T',		'LA_WEDNESDAY_T',
	'LA_THUSDAY_T',		'LA_FRIDAY_T',		'LA_SATURDAY_T',
	'LA_SUNDAY_T',
}

local time24_str =
{
	'0:00',		'0:30',		'1:00',		'1:30',		'2:00',		'2:30',		'3:00',		'3:30',	
	'4:00',		'4:30',		'5:00',		'5:30',		'6:00',		'6:30',		'7:00',		'7:30',	
	'8:00',		'8:30',		'9:00',		'9:30',		'10:00',	'10:30',	'11:00',	'11:30',	
	'12:00',	'12:30',	'13:00',	'13:30',	'14:00',	'14:30',	'15:00',	'15:30',	
	'16:00',	'16:30',	'17:00',	'17:30',	'18:00',	'18:30',	'19:00',	'19:30',	
	'20:00',	'20:30',	'21:00',	'21:30',	'22:00',	'22:30',	'23:00',	'23:30'
}

local time12_str =
{
	'12:00 AM',	'12:30 AM',	'1:00 AM',	'1:30 AM',	'2:00 AM',	'2:30 AM',	
	'3:00 AM',	'3:30 AM',	'4:00 AM',	'4:30 AM',	'5:00 AM',	'5:30 AM',
	'6:00 AM',	'6:30 AM',	'7:00 AM',	'7:30 AM',	'8:00 AM',	'8:30 AM',
	'9:00 AM',	'9:30 AM',	'10:00 AM',	'10:30 AM',	'11:00 AM',	'11:30 AM',
	'12:00 PM',	'12:30 PM',	'1:00 PM',	'1:30 PM',	'2:00 PM',	'2:30 PM',
	'3:00 PM',	'3:30 PM',	'4:00 PM',	'4:30 PM',	'5:00 PM',	'5:30 PM',
	'6:00 PM',	'6:30 PM',	'7:00 PM',	'7:30 PM',	'8:00 PM',	'8:30 PM',
	'9:00 PM',	'9:30 PM',	'10:00 PM',	'10:30 PM',	'11:00 PM',	'11:30 PM',	
}

w1_page_restart.clear_data = function()
	w1_page_restart.data = nil;
end	

local refresh_hide = function (top, bool_flag, interval_idx, redraw)
	local c_wnd = w1_page_restart.wnd;
	b_wnd_ex.set_hide(top, c_wnd.cap_restart_time.id, bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.t_interval.id, bool_flag, redraw);
	if((1 > interval_idx) or (bool_flag == true))then 
		b_wnd_ex.set_hide(top, c_wnd.t_week.id, true, redraw);
	else
		b_wnd_ex.set_hide(top, c_wnd.t_week.id, bool_flag, redraw);
	end
	b_wnd_ex.set_hide(top, c_wnd.t_time.id, bool_flag, redraw);
end

local refresh_day = function (top, interval_idx, week_idx, enable, redraw)
	local c_wnd = w1_page_restart.wnd;
	if(0 == interval_idx or 0 > interval_idx)then -- 0 ÿ / 0 > 쳣   
		local day_list ={'No results found'};
		b_wnd_ex.set_items(top,  c_wnd.t_week.id, day_list, redraw);
		b_wnd_ex.set_sel(top, c_wnd.t_week.id, 0, redraw)
		b_wnd_ex.set_hide(top,  c_wnd.t_week.id, true, redraw);
		local pos = SIZE('s_restart_t_week_xywh');
		b_wnd_ex.move_ex(top, c_wnd.t_time.id, pos, redraw);
	elseif(1 == interval_idx)then
		local str_week ={}
		table.insert(str_week,STR('LA_MONDAY'));
		table.insert(str_week,STR('LA_TUESDAY'));
		table.insert(str_week,STR('LA_WEDNESDAY'));
		table.insert(str_week,STR('LA_THURSDAY'));
		table.insert(str_week,STR('LA_FRIDAY'));
		table.insert(str_week,STR('LA_SATURDAY'));
		table.insert(str_week,STR('LA_SUNDAY'));
		b_wnd_ex.set_items(top,  c_wnd.t_week.id, str_week, redraw);
		if(0 > week_idx or week_idx > 6)then --	쳣жϴ  л
			b_wnd_ex.set_sel(top, c_wnd.t_week.id, 0, redraw)
		else
		--	b_wnd_ex.set_sel(top, c_wnd.t_week.id, 0, redraw)
			b_wnd_ex.set_sel(top, c_wnd.t_week.id, week_idx, redraw)
		end
		if(true == enable)then
			b_wnd_ex.set_hide(top,  c_wnd.t_week.id, false, redraw);
		end
		local pos = SIZE('s_restart_t_time_xywh');
		b_wnd_ex.move_ex(top, c_wnd.t_time.id, pos, redraw);
	elseif(2 == interval_idx)then
		local day_list = {};
		for i=1, 30 do
			day_list[i] = i;
		end
		b_wnd_ex.set_items(top,  c_wnd.t_week.id, day_list, redraw);
		b_wnd_ex.set_sel(top, c_wnd.t_week.id, week_idx, redraw)
		
		if(true == enable)then
			b_wnd_ex.set_hide(top,  c_wnd.t_week.id, false, redraw);
		end
		
		local pos = SIZE('s_restart_t_time_xywh');
		b_wnd_ex.move_ex(top, c_wnd.t_time.id, pos, redraw);
	end
end

local on_time_index = function(time, time_type)
	for i=1,#time24_str do
		if time == time24_str[i] then
			return i - 1
		end
	end
	for i=1,#time12_str do
		if time == time12_str[i] then
			return i - 1
		end
	end
	if(time == "")then --쳣
		return 0;
	end
end

local on_seltotime = function(time_id)
	time_id = time_id + 1
	return time24_str[time_id]
	--[[if(0 == time_type) then
		return time12_str[time_id]
	else
		return time24_str[time_id]
	end--]]
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	local c_wnd = w1_page_restart.wnd;
	assert(type(cfgdata) == 'table')

	w1_page_restart.data = cfgdata.restart;
	local function setsel(id,idx)
		b_wnd_ex.set_sel(top, id, idx, false)
	end
	
	local enable = cfgdata['restart']['enable']
	local interval_idx = cfgdata['restart']['interval_time'] -1
	local week_idx = cfgdata['restart']['week_day'] - 1
	
	if(0 > interval_idx )then
		print("----error----lua---w1_page_restart---interval_idx == 0-----");
	else
		setsel(c_wnd.t_interval.id, interval_idx);
	end
	
	if(1 == enable)then
		b_wnd_ex.set_check(top, c_wnd.t_enable.id, true, false)
		refresh_hide(top, false, interval_idx, false)
		refresh_day(top ,interval_idx, week_idx, true, false)
	else
		b_wnd_ex.set_check(top, c_wnd.t_enable.id, false, false)
		refresh_hide(top, true, interval_idx, false)
		refresh_day(top ,interval_idx, week_idx, false, false)
	end
	
	local str_time = cfgdata['restart']['time']	
	local h24 = cfgdata['time']['time_fmt']
	if(h24 == 1) then
		b_wnd_ex.set_items(top, c_wnd.t_time.id, time24_str, false);
	else
		b_wnd_ex.set_items(top, c_wnd.t_time.id, time12_str, false);
	end
	local timetosel = on_time_index(str_time, h24)
	assert(nil ~= timetosel)
	b_wnd_ex.set_sel(top, c_wnd.t_time.id,timetosel,false)
		
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local c_wnd = w1_page_restart.wnd;
	local data = cfgdata.restart
	local enable = b_wnd_ex.get_check(top, c_wnd.t_enable.id)
	if(enable)then
		data.enable = 1;
	else
		data.enable = 0;
	end
	
	local interval_time = b_wnd_ex.get_sel(top, c_wnd.t_interval.id)
	data.interval_time = interval_time + 1;
	
	local week_sel  = b_wnd_ex.get_sel(top, c_wnd.t_week.id)
	data.week_day = week_sel + 1;
	
	local time_sel = b_wnd_ex.get_sel(top, c_wnd.t_time.id)
	data.time = on_seltotime(time_sel)
--	local str_time = b_wnd_ex.get_text(top, c_wnd.t_time.id)
--	data.time = 
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	local c_wnd = w1_page_restart.wnd;
	
	if(legalflag) then
		return legalflag, nil
	else
		return legalflag, nlegalid
	end
--	return true, nil
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_enable  = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local c_wnd = w1_page_restart.wnd;
		local enable = b_wnd_ex.get_check(top, c_wnd.t_enable.id);
		local interval_sel = b_wnd_ex.get_sel(top, c_wnd.t_interval.id)
		if(true == enable)then
			refresh_hide(top, false, interval_sel, false);
		else
			refresh_hide(top, true, interval_sel, false);
		end
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top)
	end	
	return 0;
end

local on_interval = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local c_wnd = w1_page_restart.wnd;
		local enable = b_wnd_ex.get_check(top, c_wnd.t_enable.id);
		local interval_sel = b_wnd_ex.get_sel(top, win_id)
		local week_sel  = b_wnd_ex.get_sel(top, c_wnd.t_week.id)
		refresh_day(top ,interval_sel, week_sel, enable, false);
		b_dlg.dlg_set_redraw(top)
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_week = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_time = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end
w1_page_restart.timer_start = function()
	w1_page_restart.timestart = true
end

w1_page_restart.timer_stop = function(top)
	w1_page_restart.timestart = false
	w1_wnd_util.tipclear(top, w1_page_restart.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
	w1_wnd_util.tipdispoff();
end

w1_page_restart.timerenevt = function(top)
	if(w1_page_restart.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_restart.wnd.tipinfo.id)
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_restart.init = function(top)
	w1_wnd_util.cfgtab = {'restart','time'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

w1_page_restart.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_restart.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_server','t_server','cap_port','t_port',
			'cap_enable','t_enable','cap_restart_time','t_interval','t_week','t_time',
			'tipinfo', 'default', 'apply' },
	
	cap_enable 	= {t='static',id=id+1,xywh='s_restart_cap_enable_xywh',text='LA_ENABLE_AUTO_REBOOT'},
	t_enable 	= {t='tt_check',  id=id+2,xywh='s_restart_t_enable_xywh',cmd = on_enable,
				t_imgs ={b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},},
					
	cap_restart_time 	= {t='static',id=id+3,xywh='s_restart_cap_time_xywh',text='LA_RESTART_TIME'},
	t_interval 	= {t='combox',id=id+4,xywh='s_restart_t_interval_xywh',items={'LA_PER_DAY','LA_PER_WEEK','LA_PER_MONTH'},cmd = on_interval,},
	t_week 	= {t='combox',id=id+5,xywh='s_restart_t_week_xywh',items={},cmd = on_week},
	t_time  	= {t='combox',  id=id+6,xywh='s_restart_t_time_xywh',items={},cmd = on_time},
	
	tipinfo		= {t='static',id=id+17,	xywh='s_restart_tipinfo_xywh',	text='',trans = false},
	apply 		= {t='button',id=id+18,	xywh='s_cfg_apply_xywh', text='LA_APPLY',cmd=on_apply},
}

return w1_page_restart



