
--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local w1_id 		= require("wnd.w1_util.w1_id")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local id 			= w1_id.cfg_modify.mail_id
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_msgbox 	= require("wnd.w1_util.w1_msgbox")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local util 			= require("wnd.core.util")

local w1_page_securitymail = 
{
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}
w1_page_securitymail.s_768 =
{
	s_securitymail_tipinfo_xywh = {53,277,640,35},
};

w1_page_securitymail.s_1280 = 
{
	s_securitymail_tipinfo_xywh = {100,390,900,50},
}

w1_page_securitymail.s_1440 = 
{
	s_securitymail_tipinfo_xywh = {100,390,1000,50},
}

w1_page_securitymail.s_1080p = 
{
	s_securitymail_tipinfo_xywh = {100,390,1200,50},
}

w1_page_securitymail.s_2k = 
{
	s_securitymail_tipinfo_xywh = {133,520,1600,67},
}

w1_page_securitymail.s_4k = 
{
	s_securitymail_tipinfo_xywh = {200,780,2400,100},
}

w1_page_securitymail.clear_data = function()
	
end	

-- UIʾ
local clear_uidata =function (top)
	local cwnd = w1_page_securitymail.wnd;
	b_wnd_ex.set_password(top,cwnd.t_pass.id,"",false);
	b_wnd_ex.set_text(top,cwnd.t_email.id,"",false);
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true;
	local nlegalid = {};
	local cwnd = w1_page_securitymail.wnd;
	local uipass = b_wnd_ex.get_password(top,cwnd.t_pass.id);
	--Ϊ
	if("" == uipass)then
		w1_wnd_util.setparamerr_str(STR('LA_PASSWORD_EMPTY'));
		table.insert(nlegalid, cwnd.t_pass.id);
		return false,nlegalid
	end
	local email = b_wnd_ex.get_text(top, cwnd.t_email.id);
	if email == '' then
		w1_wnd_util.setparamerr_str(STR('LA_EMAIL_EMPTY'));
		table.insert(nlegalid, cwnd.t_email.id);
		return false,nlegalid;
	end

	local p1,p2 = string.find(email,".+(@).+(%.).+");
	if p1 == nil or p2 == nil then
		w1_wnd_util.setparamerr_str(STR('LA_EMAIL_FORMAT'));
		table.insert(nlegalid, cwnd.t_email.id);
		return false,nlegalid;
	end
	return true,nil
end	

local returndatacheck =function(top,ret)
	if(ret ~= nil and ret.security_email ~= 0) then--޸ʧ
		local cwnd = w1_page_securitymail.wnd;
		local nlegalid = {};
		if(ret.security_email == -1) then
			w1_wnd_util.setparamerr_str(STR('LA_ERR_PASSWD'));
			table.insert(nlegalid, cwnd.t_pass.id);
		end
		
		return false,nlegalid
	end

	return true, nil;
end

local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_securitymail.wnd;
	cfgdata.security_email.password = b_wnd_ex.get_password(top,cwnd.t_pass.id);
	cfgdata.security_email.email = b_wnd_ex.get_text(top, cwnd.t_email.id);
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

w1_page_securitymail.timer_start = function()
	w1_page_securitymail.timestart = true;
end

w1_page_securitymail.timer_stop = function(top)
	w1_page_securitymail.timestart = false;
	w1_wnd_util.tipclear(top, w1_page_securitymail.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
end

w1_page_securitymail.timerenevt = function(top)
	if(w1_page_securitymail.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_securitymail.wnd.tipinfo.id);
		w1_wnd_util.cfgtab = {'security_email'};
	end
	return 0;
end

local on_apply = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.returndatacheckfunc = returndatacheck;
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_securitymail.apply =function(top)
	--ҳ⴦۲ǷϷתҳ 
	
	w1_wnd_util.uidatacheckfunc = uidatacheck
	w1_wnd_util.returndatacheckfunc = returndatacheck;
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
		
	return ret;
end

--ҳʼʱٶȡҳҪ
w1_page_securitymail.init = function(top)
	b_app_cfg.init({'security_email'});
	w1_wnd_util.cfgtab = {'security_email'};
	clear_uidata(top);
	return 0
end

w1_page_securitymail.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_pass','t_pass','cap_email','t_email', 'tipinfo','apply' },
	cap_pass 	= {t='static',	id=id+1,	xywh='s_cfg_page_1_1',text='LA_VERIFY_PWD'},		
	t_pass 		= {t='password',id=id+2,	xywh='s_cfg_page_1_2',password='',guide_text='LA_PASSWORD', disp = false,cmd = on_update_param},		

	cap_email 	= {t='static',id=id+3,xywh='s_cfg_page_2_1',text='LA_EMAIL_ADDR'},
	t_email 	= {t='edit',  id=id+4,xywh='s_cfg_page_2_2',guide_text='******@gmail.com',guide_trans=false,max_value = 64,cmd = on_update_param},
	tipinfo		= {t='static',id=id+5,	xywh='s_securitymail_tipinfo_xywh',	text='', 
					font='f_grade4', trans = false},
	apply 		= {t='button',	id=id+6,	xywh='s_cfg_apply_xywh', 		text='LA_APPLY',cmd=on_apply},
}

return w1_page_securitymail



