
--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_app_api = require("wnd.core.command.b_app_api")
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local w1_id 		= require("wnd.w1_util.w1_id")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local id 			= w1_id.cfg_modify.question_id
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_msgbox 	= require("wnd.w1_util.w1_msgbox")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local util 			= require("wnd.core.util")

local w1_page_securityquestion = 
{
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

local all_security_question_str ={
	[1]='',	[2]='',	[3]='',	[4]='',	[5]='',	[6]='',	[7]='',	[8]='',
}

local all_guide_answer_str = {
	[1]='',	[2]='',	[3]='',	[4]='',	[5]='',	[6]='',	[7]='',	[8]='',
}

local question1_str = {
	[1]='',	[2]='',	[3]='',	[4]='',	[5]='',	[6]='',
};

local question2_str = {
	[1]='',	[2]='',	[3]='',	[4]='',	[5]='',	[6]='',
};

local question3_str = {
	[1]='',	[2]='',	[3]='',	[4]='',	[5]='',	[6]='',
};

w1_page_securityquestion.s_768 =
{
	s_securityquestion_tipinfo_xywh = {53,497,373,35},
	s_securityquestion_info1_xywh = {53,320,480,35},
	s_securityquestion_info2_xywh = {53,362,480,35},
};

w1_page_securityquestion.s_1280 = 
{
	s_securityquestion_tipinfo_xywh = {100,700,700,50},
	s_securityquestion_info1_xywh	= {100,450,900,50},
	s_securityquestion_info2_xywh	= {100,510,900,50},
}

w1_page_securityquestion.s_1440 = 
{
	s_securityquestion_tipinfo_xywh = {100,700,700,50},
	s_securityquestion_info1_xywh = {100,375,900,50},
	s_securityquestion_info2_xywh = {100,425,900,50},
}

w1_page_securityquestion.s_1080p = 
{
	s_securityquestion_tipinfo_xywh = {100,700,700,50},
	s_securityquestion_info1_xywh = {100,450,900,50},
	s_securityquestion_info2_xywh = {100,510,900,50},
}

w1_page_securityquestion.s_2k = 
{
	s_securityquestion_tipinfo_xywh = {133,933,933,67},
	s_securityquestion_info1_xywh = {133,600,1200,67},
	s_securityquestion_info2_xywh = {133,680,1200,67},
}

w1_page_securityquestion.s_4k = 
{
	s_securityquestion_tipinfo_xywh = {200,1400,1400,100},
	s_securityquestion_info1_xywh = {200,900,1800,100},
	s_securityquestion_info2_xywh = {200,1020,1800,100},
}

w1_page_securityquestion.clear_data = function()
	
end	

-- UIʾ
local clear_uidata =function (top)
	local cwnd = w1_page_securityquestion.wnd;
	b_wnd_ex.set_password(top, cwnd.t_pass.id, "", false);
	b_wnd_ex.set_text(top,cwnd.t_answer1.id,"",false);
	b_wnd_ex.set_text(top,cwnd.t_answer2.id,"",false);
	b_wnd_ex.set_text(top,cwnd.t_answer3.id,"",false);
end


local cfgdatatoui =function (top)
	local username = global_val.get_user_name();
	local question = b_app_api.get_security_question(username);
	if question==nil then
		question = {}
		question.question1=1;
		question.question2=2;
		question.question3=3;
	end
	local idx1 = 1
	local idx2 = 1
	local idx3 = 1
	local sel1 = 0
	local sel2 = 0
	local sel3 = 0
	local cwnd = w1_page_securityquestion.wnd;
	for i=1,8 do
		if  question.question2~=i and question.question3~=i then
			question1_str[idx1] = STR('LA_SEC_QUE_'..i)
			if question.question1==i then
				sel1 = idx1-1;
			end
			idx1 = idx1 + 1 
		end	
		if question.question1~=i and question.question3~=i then
			question2_str[idx2] = STR('LA_SEC_QUE_'..i)
			if question.question2==i then
				sel2 = idx2-1;
			end
			idx2 = idx2 + 1 
		end	
		if question.question1~=i and question.question2~=i  then
			question3_str[idx3] = STR('LA_SEC_QUE_'..i)
			if question.question3==i then
				sel3 = idx3-1;
			end
			idx3 = idx3 + 1 
		end	
	end
	b_wnd_ex.set_items(top,cwnd.t_question1.id,question1_str,false);
	b_wnd_ex.set_items(top,cwnd.t_question2.id,question2_str,false);
	b_wnd_ex.set_items(top,cwnd.t_question3.id,question3_str,false);
	b_wnd_ex.set_sel(top,cwnd.t_question1.id,sel1,false);
	b_wnd_ex.set_sel(top,cwnd.t_question2.id,sel2,false);
	b_wnd_ex.set_sel(top,cwnd.t_question3.id,sel3,false);
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local cwnd = w1_page_securityquestion.wnd;
	local answer1 = b_wnd_ex.get_text(top,cwnd.t_answer1.id);
	local answer2 = b_wnd_ex.get_text(top,cwnd.t_answer2.id);
	local answer3 = b_wnd_ex.get_text(top,cwnd.t_answer3.id);
	local nlegalid = {};
	local legal = true;
	--Ϊ
	local uipass = b_wnd_ex.get_password(top,cwnd.t_pass.id);
	if("" == uipass)then
		w1_wnd_util.setparamerr_str(STR('LA_PASSWORD_EMPTY'));
		table.insert(nlegalid, cwnd.t_pass.id);
		return false,nlegalid
	end
	if answer1 == '' then
		table.insert(nlegalid, cwnd.t_answer1.id);
		legal = false
	end

	if answer2 == '' then
		table.insert(nlegalid, cwnd.t_answer2.id);
		legal = false
	end
	
	if answer3 == '' then
		table.insert(nlegalid, cwnd.t_answer3.id);
		legal = false
	end
	if legal == false then
		w1_wnd_util.setparamerr_str(STR('LA_SAFE_ANS'));
		return legal,nlegalid	
	end

--[[	if string.len(answer1) < 4 or string.len(answer1) > 32 then
		table.insert(nlegalid, cwnd.t_answer1.id);
		legal = false
	end
	
	if string.len(answer2) < 4 or string.len(answer2) > 32  then
		table.insert(nlegalid, cwnd.t_answer2.id);
		legal = false
	end	
	if string.len(answer3) < 4 or string.len(answer3) > 32  then
		table.insert(nlegalid, cwnd.t_answer3.id);
		legal = false
	end--]]
	if legal == false then
		w1_wnd_util.setparamerr_str(STR('LA_ANSWER_ILLEGAL'));
		return legal,nlegalid	
	end	
	return true,nil
end	

local returndatacheck =function(top,ret)
	if(ret ~= nil and ret.sec_que ~= 0) then--޸ʧ
		local cwnd = w1_page_securityquestion.wnd;
		local nlegalid = {};
		if(ret.sec_que == -1) then
			w1_wnd_util.setparamerr_str(STR('LA_ERR_PASSWD'));
			--¶ȡ
			table.insert(nlegalid, cwnd.t_pass.id);
		end
		
		return false,nlegalid
	end		
	
	return true, nil;
end

local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_securityquestion.wnd;
	cfgdata.sec_que.password = b_wnd_ex.get_password(top,cwnd.t_pass.id);
	local question1 = b_wnd_ex.get_text(top,cwnd.t_question1.id);
	local answer1 = b_wnd_ex.get_text(top,cwnd.t_answer1.id);
	local question2 = b_wnd_ex.get_text(top,cwnd.t_question2.id);
	local answer2 = b_wnd_ex.get_text(top,cwnd.t_answer2.id);
	local question3 = b_wnd_ex.get_text(top,cwnd.t_question3.id);
	local answer3 = b_wnd_ex.get_text(top,cwnd.t_answer3.id);
	local idx = 0;
	for i = 1,8 do
		if all_security_question_str[i] == question1 then
			cfgdata.sec_que.question1 = i;
			idx = idx + 1;
		elseif all_security_question_str[i] == question2 then
			cfgdata.sec_que.question2 = i;
			idx = idx + 1;
		elseif all_security_question_str[i] == question3 then
			cfgdata.sec_que.question3 = i;
			idx = idx + 1;
		end
		if idx == 3 then
			break;
		end
	end
	cfgdata.sec_que.answer1 = b_wnd_ex.get_text(top,cwnd.t_answer1.id);
	cfgdata.sec_que.answer2 = b_wnd_ex.get_text(top,cwnd.t_answer2.id);
	cfgdata.sec_que.answer3 = b_wnd_ex.get_text(top,cwnd.t_answer3.id);
end

local on_select_question =function(top, win_id, vmsg, x, y)
	if (b_ui.WM_USER_UPDATE_PARAM == vmsg) then
		local cwnd = w1_page_securityquestion.wnd;
		local q1 = b_wnd_ex.get_text(top,cwnd.t_question1.id);
		local q2 = b_wnd_ex.get_text(top,cwnd.t_question2.id);
		local q3 = b_wnd_ex.get_text(top,cwnd.t_question3.id);
		local sel1 = 0;
		local sel2 = 0;
		local sel3 = 0;
		local index1 = 0;
		local index2 = 0;
		local index3 = 0;
		for i = 1, 8 do
			if all_security_question_str[i] == q1 then
				sel1 = index1
				index1 = index1+1
				question1_str[index1]=all_security_question_str[i]
			elseif all_security_question_str[i] == q2 then
				sel2 = index2
				index2 = index2+1
				question2_str[index2]=all_security_question_str[i]
			elseif all_security_question_str[i] == q3 then
				sel3 = index3
				index3 = index3+1
				question3_str[index3]=all_security_question_str[i]
			else
				index1 = index1+1
				question1_str[index1]=all_security_question_str[i]
				index2 = index2+1
				question2_str[index2]=all_security_question_str[i]
				index3 = index3+1
				question3_str[index3]=all_security_question_str[i]			
			end
		end
		b_wnd_ex.set_items(top,cwnd.t_question1.id,question1_str,false);
		b_wnd_ex.set_sel(top,cwnd.t_question1.id,sel1,false);
		b_wnd_ex.set_items(top,cwnd.t_question2.id,question2_str,false);
		b_wnd_ex.set_sel(top,cwnd.t_question2.id,sel2,false);
		b_wnd_ex.set_items(top,cwnd.t_question3.id,question3_str,false);
		b_wnd_ex.set_sel(top,cwnd.t_question3.id,sel3,false);
		if win_id == cwnd.t_question1.id then
			b_wnd_ex.set_text(top,cwnd.t_answer1.id,'',false);
		elseif win_id == cwnd.t_question2.id then
			b_wnd_ex.set_text(top,cwnd.t_answer2.id,'',false);
		elseif win_id == cwnd.t_question3.id then
			b_wnd_ex.set_text(top,cwnd.t_answer3.id,'',false);
		end
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

w1_page_securityquestion.timer_start = function()
	w1_page_securityquestion.timestart = true;
end

w1_page_securityquestion.timer_stop = function(top)
	w1_page_securityquestion.timestart = false;
	w1_wnd_util.tipclear(top, w1_page_securityquestion.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
end

w1_page_securityquestion.timerenevt = function(top)
	if(w1_page_securityquestion.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_securityquestion.wnd.tipinfo.id);
		w1_wnd_util.cfgtab = {'sec_que'};
	end
	return 0;
end

local on_apply = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.returndatacheckfunc = returndatacheck;
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_securityquestion.apply =function(top)
	--ҳ⴦۲ǷϷתҳ 
	
	w1_wnd_util.uidatacheckfunc = uidatacheck
	w1_wnd_util.returndatacheckfunc = returndatacheck;
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
		
	return ret;
end

--ҳʼʱٶȡҳҪ
w1_page_securityquestion.init = function(top)
	b_app_cfg.init({'sec_que'});
	w1_wnd_util.cfgtab = {'sec_que'};
	cfgdatatoui(top);
	clear_uidata(top);
	return 0
end

w1_page_securityquestion.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_pass','t_pass', 'cap_question1','t_question1','cap_answer1','t_answer1',
			'cap_question2','t_question2','cap_answer2','t_answer2','cap_question3','t_question3',
			'cap_answer3','t_answer3','tipinfo','info1','info2','apply' },
	cap_pass 	= {t='static',	id=id+1,	xywh='s_cfg_page_1_1',text='LA_PASSWORD'},		
	t_pass 		= {t='password',id=id+2,	xywh='s_cfg_page_1_2',password='',guide_text='LA_PASSWORD', disp = false,cmd = on_update_param},		

	cap_question1= {t='static',id=id+3,xywh='s_cfg_page_2_1',text='LA_FIRST_QUESTION'},
	t_question1	= {t='combox',  id=id+4,xywh='s_cfg_page_2_2',cmd=on_select_question},
	cap_answer1	= {t='static',id=id+5,xywh='s_cfg_page_3_1',text='LA_ANSWER_ONE'},
	t_answer1	= {t='edit',  id=id+6,xywh='s_cfg_page_3_2',cmd = on_update_param},
	cap_question2= {t='static',id=id+7,xywh='s_cfg_page_4_1',text='LA_SECOND_QUESTION'},
	t_question2 = {t='combox',  id=id+8,xywh='s_cfg_page_4_2',cmd=on_select_question},
	cap_answer2	= {t='static',id=id+9,xywh='s_cfg_page_5_1',text='LA_ANSWER_TWO'},
	t_answer2 	= {t='edit',  id=id+10,xywh='s_cfg_page_5_2',cmd = on_update_param},
	cap_question3= {t='static',id=id+11,xywh='s_cfg_page_6_1',text='LA_THIRD_QUESTION'},
	t_question3	= {t='combox',  id=id+12,xywh='s_cfg_page_6_2',cmd=on_select_question},
	cap_answer3= {t='static',id=id+13,xywh='s_cfg_page_7_1',text='LA_ANSWER_THREE'},
	t_answer3	= {t='edit',  id=id+14,xywh='s_cfg_page_7_2',cmd = on_update_param},
	info1		= {t='static',	id=id+15,	xywh='s_securityquestion_info1_xywh',text='LA_ANSWER_RULE1'},
	info2		= {t='static',	id=id+16,	xywh='s_securityquestion_info2_xywh',text='LA_ANSWER_RULE2'},
	tipinfo		= {t='static',id=id+17,	xywh='s_securityquestion_tipinfo_xywh',	text='', 
					font='f_grade4', trans = false},
	apply 		= {t='button',	id=id+18,	xywh='s_cfg_apply_xywh', 		text='LA_APPLY',cmd=on_apply},
}


w1_page_securityquestion.on_pre_show  = function(top)
	local cwnd = w1_page_securityquestion.wnd;
	all_security_question_str[1]=STR('LA_SEC_QUE_1')
	all_security_question_str[2]=STR('LA_SEC_QUE_2')
	all_security_question_str[3]=STR('LA_SEC_QUE_3')
	all_security_question_str[4]=STR('LA_SEC_QUE_4')
	all_security_question_str[5]=STR('LA_SEC_QUE_5')
	all_security_question_str[6]=STR('LA_SEC_QUE_6')
	all_security_question_str[7]=STR('LA_SEC_QUE_7')
	all_security_question_str[8]=STR('LA_SEC_QUE_8')
	return 0
end

return w1_page_securityquestion



