--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/11/6
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_snmp.snmp_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local b_dlg 		= require("wnd.core.b_dlg")
local w1_msgbox	 	= require("wnd.w1_util.w1_msgbox")
local w1_key 		= require("wnd.w1_util.w1_key")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local util 			= require("wnd.core.util")
local b_app_api 	= require("wnd.core.command.b_app_api")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local b_app_cfg  = require("wnd.core.b_app_cfg")

local w1_page_snmp 	= 
{
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_snmp.s_768 =
{
	s_snmp_cfg_page_1_1 = {53,21,202,32},
	s_snmp_cfg_page_1_2 = {272,21,25,21},
	s_snmp_cfg_page_2_1 = {53,64,202,32},
	s_snmp_cfg_page_2_2 = {281,64,202,32},
	s_snmp_cfg_page_3_1 = {53,106,202,32},
	s_snmp_cfg_page_3_2 = {281,106,202,32},
	s_snmp_cfg_page_4_1 = {53,149,202,32},
	s_snmp_cfg_page_4_2 = {281,149,202,32},
	s_snmp_cfg_page_5_1 = {53,192,202,32},
	s_snmp_cfg_page_5_2 = {281,192,202,32},
	s_snmp_cfg_page_6_1 = {53,234,202,32},
	s_snmp_cfg_page_6_2 = {281,234,202,32},
	s_snmp_cfg_page_7_1 = {53,277,202,32},
	s_snmp_cfg_page_7_2 = {281,277,202,32},
	s_snmp_cfg_page_8_1 = {53,320,202,32},
	s_snmp_cfg_page_8_2 = {281,320,202,32},
	s_snmp_cfg_page_9_1 = {53,362,202,32},
	s_snmp_cfg_page_9_2 = {281,362,202,32},
	s_snmp_cfg_page_10_1 = {53,405,202,32},
	s_snmp_cfg_page_10_2 = {281,405,202,32},
	s_snmp_cfg_page_11_1 = {53,448,202,32},
	s_snmp_cfg_page_11_2 = {281,448,202,32},
	s_snmp_cfg_page_12_1 = {53,490,202,32},
	s_snmp_cfg_page_12_2 = {281,490,202,32},
	s_snmp_cfg_page_13_1 = {53,533,202,32},
	s_snmp_cfg_page_13_2 = {281,533,202,32},
	s_snmp_tipinfo_xywh = {53,572,373,28},
};

w1_page_snmp.s_1280 = 
{
	s_snmp_cfg_page_1_1= {100, 30,350,45},
	s_snmp_cfg_page_1_2 = {455, 30,48,30},
	s_snmp_cfg_page_2_1 = {100, 85,350,45},
	s_snmp_cfg_page_2_2 = {460, 85,300,45},
	s_snmp_cfg_page_3_1 = {100, 140,350,45},
	s_snmp_cfg_page_3_2 = {460, 140,300,45},
	s_snmp_cfg_page_4_1 = {100, 195,350,45},
	s_snmp_cfg_page_4_2 = {460, 195,300,45},
	s_snmp_cfg_page_5_1 = {100, 250,350,45},
	s_snmp_cfg_page_5_2 = {460, 250,300,45},
	s_snmp_cfg_page_6_1 = {100, 305,350,45},
	s_snmp_cfg_page_6_2 = {460, 305,300,45},
	s_snmp_cfg_page_7_1 = {100, 360,350,45},
	s_snmp_cfg_page_7_2 = {460, 360,300,45},
	s_snmp_cfg_page_8_1 = {100, 415,350,45},
	s_snmp_cfg_page_8_2 = {460, 415,300,45},
	s_snmp_cfg_page_9_1 = {100, 470,350,45},
	s_snmp_cfg_page_9_2 = {460, 470,300,45},
	s_snmp_cfg_page_10_1 = {100, 525,350,45},
	s_snmp_cfg_page_10_2 = {460, 525,300,45},
	s_snmp_cfg_page_11_1 = {100, 580,350,45},
	s_snmp_cfg_page_11_2 = {460, 580,300,45},
	s_snmp_cfg_page_12_1 = {100, 635,350,45},
	s_snmp_cfg_page_12_2 = {460, 635,300,45},	
	s_snmp_cfg_page_13_1 = {100, 690,350,45},
	s_snmp_cfg_page_13_2 = {460, 690,300,45},
	s_snmp_tipinfo_xywh = {100,760,700,50},
}

w1_page_snmp.s_1440 = 
{
	s_snmp_cfg_page_1_1= {100, 30,380,40},
	s_snmp_cfg_page_1_2 = {520, 30,48,30},
	s_snmp_cfg_page_2_1 = {100, 75,380,40},
	s_snmp_cfg_page_2_2 = {530, 75,380,40},
	s_snmp_cfg_page_3_1 = {100, 120,380,40},
	s_snmp_cfg_page_3_2 = {530, 120,380,40},
	s_snmp_cfg_page_4_1 = {100, 165,380,40},
	s_snmp_cfg_page_4_2 = {530, 165,380,40},
	s_snmp_cfg_page_5_1 = {100, 210,380,40},
	s_snmp_cfg_page_5_2 = {530, 210,380,40},
	s_snmp_cfg_page_6_1 = {100, 255,380,40},
	s_snmp_cfg_page_6_2 = {530, 255,380,40},
	s_snmp_cfg_page_7_1 = {100, 300,380,40},
	s_snmp_cfg_page_7_2 = {530, 300,380,40},
	s_snmp_cfg_page_8_1 = {100, 345,380,40},
	s_snmp_cfg_page_8_2 = {530, 345,380,40},
	s_snmp_cfg_page_9_1 = {100, 390,380,40},
	s_snmp_cfg_page_9_2 = {530, 390,380,40},
	s_snmp_cfg_page_10_1 = {100, 435,380,40},
	s_snmp_cfg_page_10_2 = {530, 435,380,40},
	s_snmp_cfg_page_11_1 = {100, 480,380,40},
	s_snmp_cfg_page_11_2 = {530, 480,380,40},
	s_snmp_cfg_page_12_1 = {100, 525,380,40},
	s_snmp_cfg_page_12_2 = {530, 525,380,40},	
	s_snmp_cfg_page_13_1 = {100, 570,380,40},
	s_snmp_cfg_page_13_2 = {530, 570,380,40},
	s_snmp_tipinfo_xywh = {100,620,700,50},
}

w1_page_snmp.s_1080p = 
{
	s_snmp_cfg_page_1_1= {100, 30,380,45},
	s_snmp_cfg_page_1_2 = {510, 30,48,30},
	s_snmp_cfg_page_2_1 = {100, 90,380,45},
	s_snmp_cfg_page_2_2 = {527, 90,380,45},
	s_snmp_cfg_page_3_1 = {100, 150,380,45},
	s_snmp_cfg_page_3_2 = {527, 150,380,45},
	s_snmp_cfg_page_4_1 = {100, 210,380,45},
	s_snmp_cfg_page_4_2 = {527, 210,380,45},
	s_snmp_cfg_page_5_1 = {100, 270,380,45},
	s_snmp_cfg_page_5_2 = {527, 270,380,45},
	s_snmp_cfg_page_6_1 = {100, 330,380,45},
	s_snmp_cfg_page_6_2 = {527, 330,380,45},
	s_snmp_cfg_page_7_1 = {100, 390,380,45},
	s_snmp_cfg_page_7_2 = {527, 390,380,45},
	s_snmp_cfg_page_8_1 = {100, 450,380,45},
	s_snmp_cfg_page_8_2 = {527, 450,380,45},
	s_snmp_cfg_page_9_1 = {100, 510,380,45},
	s_snmp_cfg_page_9_2 = {527, 510,380,45},
	s_snmp_cfg_page_10_1 = {100, 570,380,45},
	s_snmp_cfg_page_10_2 = {527, 570,380,45},	
	s_snmp_cfg_page_11_1 = {100, 630,380,45},
	s_snmp_cfg_page_11_2 = {527, 630,380,45},
	s_snmp_cfg_page_12_1 = {100, 690,380,45},
	s_snmp_cfg_page_12_2 = {527, 690,380,45},	
	s_snmp_cfg_page_13_1 = {100, 750,380,45},
	s_snmp_cfg_page_13_2 = {527, 750,380,45},
	s_snmp_tipinfo_xywh	 = {100,805,700,40},		
}

w1_page_snmp.s_2k = 
{
	s_snmp_cfg_page_1_1= {133,40,507,60},
	s_snmp_cfg_page_1_2 = {393,40,64,40},
	s_snmp_cfg_page_2_1 = {133,120,507,60},
	s_snmp_cfg_page_2_2 = {703,120,507,60},
	s_snmp_cfg_page_3_1 = {133,200,507,60},
	s_snmp_cfg_page_3_2 = {703,200,507,60},
	s_snmp_cfg_page_4_1 = {133,280,507,60},
	s_snmp_cfg_page_4_2 = {703,280,507,60},
	s_snmp_cfg_page_5_1 = {133,360,507,60},
	s_snmp_cfg_page_5_2 = {703,360,507,60},
	s_snmp_cfg_page_6_1 = {133,440,507,60},
	s_snmp_cfg_page_6_2 = {703,440,507,60},
	s_snmp_cfg_page_7_1 = {133,520,507,60},
	s_snmp_cfg_page_7_2 = {703,520,507,60},
	s_snmp_cfg_page_8_1 = {133,600,507,60},
	s_snmp_cfg_page_8_2 = {703,600,507,60},
	s_snmp_cfg_page_9_1 = {133,680,507,60},
	s_snmp_cfg_page_9_2 = {703,680,507,60},
	s_snmp_cfg_page_10_1 = {133,760,507,60},
	s_snmp_cfg_page_10_2 = {703,760,507,60},
	s_snmp_cfg_page_11_1 = {133,840,507,60},
	s_snmp_cfg_page_11_2 = {703,840,507,60},
	s_snmp_cfg_page_12_1 = {133,920,507,60},
	s_snmp_cfg_page_12_2 = {703,920,507,60},
	s_snmp_cfg_page_13_1 = {133,1000,507,60},
	s_snmp_cfg_page_13_2 = {703,1000,507,60},
	s_snmp_tipinfo_xywh= {133,1073,933,53},	
}

w1_page_snmp.s_4k = 
{
	s_snmp_cfg_page_1_1= {200,60,760,90},
    s_snmp_cfg_page_1_2 = {1040,60,96,60},
    s_snmp_cfg_page_2_1 = {200,180,760,90},
    s_snmp_cfg_page_2_2 = {1055,180,760,90},
    s_snmp_cfg_page_3_1 = {200,300,760,90},
    s_snmp_cfg_page_3_2 = {1055,300,760,90},
    s_snmp_cfg_page_4_1 = {200,420,760,90},
    s_snmp_cfg_page_4_2 = {1055,420,760,90},
    s_snmp_cfg_page_5_1 = {200,540,760,90},
    s_snmp_cfg_page_5_2 = {1055,540,760,90},
    s_snmp_cfg_page_6_1 = {200,660,760,90},
    s_snmp_cfg_page_6_2 = {1055,660,760,90},
    s_snmp_cfg_page_7_1 = {200,780,760,90},
    s_snmp_cfg_page_7_2 = {1055,780,760,90},
    s_snmp_cfg_page_8_1 = {200,900,760,90},
    s_snmp_cfg_page_8_2 = {1055,900,760,90},
    s_snmp_cfg_page_9_1 = {200,1020,760,90},
    s_snmp_cfg_page_9_2 = {1055,1020,760,90},
    s_snmp_cfg_page_10_1 = {200,1140,760,90},
    s_snmp_cfg_page_10_2 = {1055,1140,760,90},
    s_snmp_cfg_page_11_1 = {200,1260,760,90},
    s_snmp_cfg_page_11_2 = {1055,1260,760,90},
    s_snmp_cfg_page_12_1 = {200,1380,760,90},
    s_snmp_cfg_page_12_2 = {1055,1380,760,90},
    s_snmp_cfg_page_13_1 = {200,1500,760,90},
    s_snmp_cfg_page_13_2 = {1055,1500,760,90},
    s_snmp_tipinfo_xywh= {200,1610,1400,80},
}

local refresh_hide = function (top, bool_flag, redraw)
	local c_wnd = w1_page_snmp.wnd;
	b_wnd_ex.set_hide(top, c_wnd.cap_r_secur.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.t_r_secur.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.cap_r_secur_level.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.t_r_secur_level.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.cap_r_auth_a.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.t_r_auth_a.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.cap_r_auth_pass.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.t_r_auth_pass.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.cap_r_encry_a.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.t_r_encry_a.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.cap_r_encry_pass.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.t_r_encry_pass.id,bool_flag, redraw);
	
	b_wnd_ex.set_hide(top, c_wnd.cap_w_secur.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.t_w_secur.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.cap_w_secur_level.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.t_w_secur_level.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.cap_w_auth_a.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.t_w_auth_a.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.cap_w_auth_pass.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.t_w_auth_pass.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.cap_w_encry_a.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.t_w_encry_a.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.cap_w_encry_pass.id,bool_flag, redraw);
	b_wnd_ex.set_hide(top, c_wnd.t_w_encry_pass.id,bool_flag, redraw);
end

local refresh_disable = function (top, r_secur_level, w_secur_level, redraw)
	local c_wnd = w1_page_snmp.wnd
	if("noauth" == r_secur_level)then
		b_wnd_ex.set_disable(top, c_wnd.t_r_auth_a.id, true, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_r_auth_pass.id, true, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_r_encry_a.id, true, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_r_encry_pass.id, true, redraw);
	elseif("auth" == r_secur_level)then
		b_wnd_ex.set_disable(top, c_wnd.t_r_auth_a.id, false, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_r_auth_pass.id, false, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_r_encry_a.id, true, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_r_encry_pass.id, true, redraw);
	elseif("priv" == r_secur_level)then
		b_wnd_ex.set_disable(top, c_wnd.t_r_auth_a.id, false, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_r_auth_pass.id, false, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_r_encry_a.id, false, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_r_encry_pass.id, false, redraw);
	else
		b_wnd_ex.set_disable(top, c_wnd.t_r_auth_a.id, false, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_r_auth_pass.id, false, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_r_encry_a.id, false, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_r_encry_pass.id, false, redraw);
	end
	
	if("noauth" == w_secur_level)then
		b_wnd_ex.set_disable(top, c_wnd.t_w_auth_a.id, true, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_w_auth_pass.id, true, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_w_encry_a.id, true, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_w_encry_pass.id, true, redraw);
	elseif("auth" == w_secur_level)then
		b_wnd_ex.set_disable(top, c_wnd.t_w_auth_a.id, false, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_w_auth_pass.id, false, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_w_encry_a.id, true, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_w_encry_pass.id, true, redraw);
	elseif("priv" == w_secur_level)then
		b_wnd_ex.set_disable(top, c_wnd.t_w_auth_a.id, false, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_w_auth_pass.id, false, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_w_encry_a.id, false, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_w_encry_pass.id, false, redraw);
	else
		b_wnd_ex.set_disable(top, c_wnd.t_w_encry_a.id, false, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_w_encry_pass.id, false, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_w_auth_a.id, false, redraw);
		b_wnd_ex.set_disable(top, c_wnd.t_w_auth_pass.id, false, redraw);
	end
end
--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local c_wnd = w1_page_snmp.wnd

	local function settext(id, str)
		b_wnd_ex.set_text(top, id, str, false)
	end
	local function setcheck(id, flag)
		if(flag == true)then
			b_wnd_ex.set_check(top, id, true, false)
		else
			b_wnd_ex.set_check(top, id, false, false)
		end
	end	
	local function setsel(id,idx)
		b_wnd_ex.set_sel(top, id, idx, false)
	end
	local function set_password(id, str)
		b_wnd_ex.set_password(top, id, str, false)
	end
	
	setcheck(c_wnd.t_snmpv3.id,cfgdata['snmp']['enablev3']);

	settext(c_wnd.t_r_secur.id,cfgdata['snmp']['read_security']);
	if("noauth" == cfgdata['snmp']['read_security_level'])then
		setsel(c_wnd.t_r_secur_level.id, 0);
	elseif("auth" == cfgdata['snmp']['read_security_level'])then
		setsel(c_wnd.t_r_secur_level.id, 1);
	elseif("priv" == cfgdata['snmp']['read_security_level'])then
		setsel(c_wnd.t_r_secur_level.id, 2);
	else
		setsel(c_wnd.t_r_secur_level.id, 0);
	end

	if("DES" == cfgdata['snmp']['read_encry_algorithm'])then
		setsel(c_wnd.t_r_encry_a.id, 0);
	elseif("AES" == cfgdata['snmp']['read_encry_algorithm'])then
		setsel(c_wnd.t_r_encry_a.id, 1);
	else
		setsel(c_wnd.t_r_encry_a.id, 0);
	end
	set_password(c_wnd.t_r_encry_pass.id, cfgdata['snmp']['read_encry_passwd'])
	
	if("MD5" == cfgdata['snmp']['read_auth_algorithm'])then
		setsel(c_wnd.t_r_auth_a.id, 0);
	elseif("SHA" == cfgdata['snmp']['read_auth_algorithm'])then
		setsel(c_wnd.t_r_auth_a.id, 1);
	else
		setsel(c_wnd.t_r_auth_a.id, 0);
	end
	
	set_password(c_wnd.t_r_auth_pass.id, cfgdata['snmp']['read_auth_passwd'])
	
	
	settext(c_wnd.t_w_secur.id,cfgdata['snmp']['write_security']);
	if("noauth" == cfgdata['snmp']['write_security_level'])then
		setsel(c_wnd.t_w_secur_level.id, 0);
	elseif("auth" == cfgdata['snmp']['write_security_level'])then
		setsel(c_wnd.t_w_secur_level.id, 1);
	elseif("priv" == cfgdata['snmp']['write_security_level'])then
		setsel(c_wnd.t_w_secur_level.id, 2);
	else
		setsel(c_wnd.t_w_secur_level.id, 0);
	end

	if("DES" == cfgdata['snmp']['write_encry_algorithm'])then
		setsel(c_wnd.t_w_encry_a.id, 0);
	elseif("AES" == cfgdata['snmp']['write_encry_algorithm'])then
		setsel(c_wnd.t_w_encry_a.id, 1);
	else
		setsel(c_wnd.t_w_encry_a.id, 0);
	end

	set_password(c_wnd.t_w_encry_pass.id, cfgdata['snmp']['write_encry_passwd'])

	if("MD5" == cfgdata['snmp']['write_auth_algorithm'])then
		setsel(c_wnd.t_w_auth_a.id, 0);
	elseif("SHA" == cfgdata['snmp']['write_auth_algorithm'])then
		setsel(c_wnd.t_w_auth_a.id, 1);
	else
		setsel(c_wnd.t_w_auth_a.id, 0);
	end
	
	set_password(c_wnd.t_w_auth_pass.id, cfgdata['snmp']['write_auth_passwd'])
	
	if(true == cfgdata['snmp']['enablev3'])then
		refresh_hide(top,false,false)
	else
		refresh_hide(top,true,false)
	end
	
	
	local  r_secur_level =  b_wnd_ex.get_text(top, c_wnd.t_r_secur_level.id);
	local  w_secur_level =  b_wnd_ex.get_text(top, c_wnd.t_w_secur_level.id);
	refresh_disable(top, r_secur_level, w_secur_level, false);
	return 0
end

local on_disp = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_snmp.wnd;
		local check = b_wnd_ex.get_check(top, win_id);
		b_wnd_ex.set_disp(top, cwnd.t_pass.id, check, true);
	end
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local enablev3 = b_wnd_ex.get_check(top, w1_page_snmp.wnd.t_snmpv3.id)
	cfgdata['snmp']['enablev3'] = enablev3	
	cfgdata['snmp']['read_security'] = 		b_wnd_ex.get_text(top,w1_page_snmp.wnd.t_r_secur.id);
	cfgdata['snmp']['read_security_level'] =b_wnd_ex.get_text(top, w1_page_snmp.wnd.t_r_secur_level.id);
	cfgdata['snmp']['read_encry_algorithm']=b_wnd_ex.get_text(top, w1_page_snmp.wnd.t_r_encry_a.id)
	cfgdata['snmp']['read_encry_passwd'] = 	b_wnd_ex.get_password(top, w1_page_snmp.wnd.t_r_encry_pass.id)
	cfgdata['snmp']['read_auth_algorithm']= b_wnd_ex.get_text(top, w1_page_snmp.wnd.t_r_auth_a.id)
	cfgdata['snmp']['read_auth_passwd'] = 	b_wnd_ex.get_password(top, w1_page_snmp.wnd.t_r_auth_pass.id)
	
	cfgdata['snmp']['write_security'] = 	b_wnd_ex.get_text(top,w1_page_snmp.wnd.t_w_secur.id);
	cfgdata['snmp']['write_security_level']=b_wnd_ex.get_text(top, w1_page_snmp.wnd.t_w_secur_level.id);
	cfgdata['snmp']['write_encry_algorithm']= b_wnd_ex.get_text(top, w1_page_snmp.wnd.t_w_encry_a.id)
	cfgdata['snmp']['write_encry_passwd'] = b_wnd_ex.get_password(top, w1_page_snmp.wnd.t_w_encry_pass.id)
	cfgdata['snmp']['write_auth_algorithm']=b_wnd_ex.get_text(top, w1_page_snmp.wnd.t_w_auth_a.id)
	cfgdata['snmp']['write_auth_passwd'] = 	b_wnd_ex.get_password(top, w1_page_snmp.wnd.t_w_auth_pass.id)
	
	return 0
end

local checkpassword = function (id, pass)
	local legalflag = true
	local pass_len = string.len(pass);
	local legal, level =w1_legal.check_password(pass); 
		
	if(pass_len < 8) then	-- λ8λ̫
		legalflag =false
		w1_wnd_util.setparamerr_str(STR('LA_PASSWORD_RULE1'))
	elseif(legal == w1_legal.password.SN_ERROR_NOT_SUPPOERT_CHAR) then	-- ַ֧
		legalflag =false
		w1_wnd_util.setparamerr_str(STR('LA_ROLE_NAME2'))
	end
	return legalflag
end
--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	
	local c_wnd = w1_page_snmp.wnd;
	local enablev3 = b_wnd_ex.get_check(top, c_wnd.t_snmpv3.id)
	
	local r_secur = b_wnd_ex.get_text(top,c_wnd.t_r_secur.id);
	local r_secur_level = b_wnd_ex.get_text(top, c_wnd.t_r_secur_level.id);
	local r_auth_pass = b_wnd_ex.get_password(top, c_wnd.t_r_auth_pass.id);
	local r_encry_pass = b_wnd_ex.get_password(top, c_wnd.t_r_encry_pass.id);

	
	local w_secur = b_wnd_ex.get_text(top, c_wnd.t_w_secur.id);
	local w_secur_level = b_wnd_ex.get_text(top, c_wnd.t_w_secur_level.id);
	local w_auth_pass = b_wnd_ex.get_password(top, c_wnd.t_w_auth_pass.id);
	local w_encry_pass = b_wnd_ex.get_password(top, c_wnd.t_w_encry_pass.id);
	
	
	if(true == enablev3) then
		if("" == r_secur)then
			legalflag =false
			table.insert(nlegalid, c_wnd.t_r_secur.id)	
			w1_wnd_util.setparamerr_str(STR('LA_NOT_EMPTY'))
		end
		
		if("" == w_secur)then
			legalflag =false
			table.insert(nlegalid, c_wnd.t_w_secur.id)	
			w1_wnd_util.setparamerr_str(STR('LA_NOT_EMPTY'))
		end
		
		if(r_secur == w_secur )then
			legalflag =false
			table.insert(nlegalid, c_wnd.t_r_secur.id)	
			table.insert(nlegalid, c_wnd.t_w_secur.id)	
			w1_wnd_util.setparamerr_str(STR('LA_NOT_SAME'))
		end
		
		if(false == legalflag) then
			return legalflag, nlegalid
		end
		-----------------
		
		if("noauth" == r_secur_level)then
			
		elseif("auth" == r_secur_level)then
			local islegal = checkpassword(c_wnd.t_r_auth_pass.id, r_auth_pass)
			if(false == islegal)then	
				legalflag = false
				table.insert(nlegalid, c_wnd.t_r_auth_pass.id)	
			end
		elseif("priv" == r_secur_level)then
			local islegal = checkpassword(c_wnd.t_r_auth_pass.id, r_auth_pass)
			if(false == islegal)then	
				legalflag = false
				table.insert(nlegalid, c_wnd.t_r_auth_pass.id)	
			end
			
			islegal = checkpassword(c_wnd.t_r_encry_pass.id, r_encry_pass)
			if(false == islegal)then	
				legalflag = false
				table.insert(nlegalid, c_wnd.t_r_encry_pass.id)	
			end
	
		end
		
		if(false == legalflag) then
			return legalflag, nlegalid
		end
		------------
		
		if("noauth" == w_secur_level)then
			
		elseif("auth" == w_secur_level)then
			islegal = checkpassword(c_wnd.t_w_auth_pass.id, w_auth_pass)
			if(false == islegal)then	
				legalflag = false
				table.insert(nlegalid, c_wnd.t_w_auth_pass.id)	
			end
		elseif("priv" == w_secur_level)then
			islegal = checkpassword(c_wnd.t_w_auth_pass.id, w_auth_pass)
			if(false == islegal)then	
				legalflag = false
				table.insert(nlegalid, c_wnd.t_w_auth_pass.id)	
			end
			
			islegal = checkpassword(c_wnd.t_w_encry_pass.id, w_encry_pass)
			if(false == islegal)then	
				legalflag = false
				table.insert(nlegalid, c_wnd.t_w_encry_pass.id)	
			end		
		end
		
		if(false == legalflag) then
			return legalflag, nlegalid
		end
		
	end
	
	if(legalflag) then
		return legalflag, nil
	else
		return legalflag, nlegalid
	end
	
end

local on_read_level = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local c_wnd = w1_page_snmp.wnd;
		local  r_secur_level =  b_wnd_ex.get_text(top, c_wnd.t_r_secur_level.id);
		local  w_secur_level =  b_wnd_ex.get_text(top, c_wnd.t_w_secur_level.id);
		refresh_disable(top, r_secur_level, w_secur_level, false);
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_write_level = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local c_wnd = w1_page_snmp.wnd;
		local  r_secur_level =  b_wnd_ex.get_text(top, c_wnd.t_r_secur_level.id);
		local  w_secur_level =  b_wnd_ex.get_text(top, c_wnd.t_w_secur_level.id);
		refresh_disable(top, r_secur_level, w_secur_level, false);
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_enable = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local enable = b_wnd_ex.get_check(top, w1_page_snmp.wnd.t_snmpv3.id)
		if(true == enable)then
			refresh_hide(top,false,false)
		else
			refresh_hide(top,true,false)
		end
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_disp_1 = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local check = b_wnd_ex.get_check(top, win_id);
		b_wnd_ex.set_disp(top, w1_page_snmp.wnd.t_r_auth_pass.id, check, true);
	end
	return 0;
end

local on_disp_2 = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_snmp.dlg;
		local check = b_wnd_ex.get_check(top, win_id);
		b_wnd_ex.set_disp(top, w1_page_snmp.wnd.t_r_encry_pass.id, check, true);
	end
	return 0;
end

local on_disp_3 = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_snmp.dlg;
		local check = b_wnd_ex.get_check(top, win_id);
		b_wnd_ex.set_disp(top, w1_page_snmp.wnd.t_w_auth_pass.id, check, true);
	end
	return 0;
end

local on_disp_4 = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_page_snmp.dlg;
		local check = b_wnd_ex.get_check(top, win_id);
		b_wnd_ex.set_disp(top, w1_page_snmp.wnd.t_w_encry_pass.id, check, true);
	end
	return 0;
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_snmp.timer_start = function()
	w1_page_snmp.timestart = true
end

w1_page_snmp.timer_stop = function(top)
	w1_page_snmp.timestart = false
	w1_wnd_util.tipclear(top, w1_page_snmp.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
	w1_wnd_util.tipdispoff();
end

w1_page_snmp.timerenevt = function(top)
	if(w1_page_snmp.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_snmp.wnd.tipinfo.id)
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_snmp.init = function(top)
	w1_wnd_util.cfgtab = {'snmp'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

w1_page_snmp.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_snmp.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_snmpv3','t_snmpv3','cap_r_secur','t_r_secur',
			'cap_r_secur_level','t_r_secur_level','cap_r_auth_a','t_r_auth_a','cap_r_auth_pass','t_r_auth_pass',
			'cap_r_encry_a','t_r_encry_a','cap_r_encry_pass','t_r_encry_pass','cap_w_secur','t_w_secur','cap_w_secur_level',
			't_w_secur_level','cap_w_encry_a','t_w_encry_a','cap_w_encry_pass','t_w_encry_pass','cap_w_auth_a','t_w_auth_a',
			'cap_w_auth_pass','t_w_auth_pass','tipinfo', 'default', 'apply' },
	
	cap_snmpv3 	= {t='static',id=id+1,xywh='s_snmp_cfg_page_1_1',text='LA_SNMPV3'},
	t_snmpv3 	= {t='tt_check',  id=id+2,xywh='s_snmp_cfg_page_1_2',cmd = on_enable,
				t_imgs ={b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},},
	
	cap_r_secur 	= {t='static',id=id+3,xywh='s_snmp_cfg_page_2_1',text='LA_READ_SECURITY_NAME'},
	t_r_secur 		= {t='edit',id=id+4,xywh='s_snmp_cfg_page_2_2',cmd = on_update_param},
	
	cap_r_secur_level 	= {t='static',id=id+5,xywh='s_snmp_cfg_page_3_1',text='LA_SECURITY_LEVEL'},
	t_r_secur_level 		= {t='combox',  id=id+6,xywh='s_snmp_cfg_page_3_2',items={'noauth','auth','priv'},trans = false,trans = false,cmd = on_read_level},
	
	cap_r_auth_a	= {t='static',id=id+7,xywh='s_snmp_cfg_page_4_1',text='LA_AUTH_ALGORITHM'},
	t_r_auth_a		= {t='combox',  id=id+8,xywh='s_snmp_cfg_page_4_2',items={'MD5','SHA'},trans = false,cmd = on_update_param},

	cap_r_auth_pass	= {t='static',id=id+9,xywh='s_snmp_cfg_page_5_1',text='LA_AUTH_PASSWORD',},
	t_r_auth_pass	= {t='password',  id=id+10,xywh='s_snmp_cfg_page_5_2',guide_text='LA_PASSWORD',cmd = on_update_param},
	
	cap_r_encry_a 	= {t='static',id=id+12,xywh='s_snmp_cfg_page_6_1',text='LA_ENCRY_ALGORITHM'},
	t_r_encry_a		= {t='combox',  id=id+13,xywh='s_snmp_cfg_page_6_2',items={'DES','AES'},trans = false,cmd = on_update_param},

	cap_r_encry_pass= {t='static',id=id+14,xywh='s_snmp_cfg_page_7_1',text='LA_ENCRY_PASSWORD'},
	t_r_encry_pass 	= {t='password',  id=id+15,xywh='s_snmp_cfg_page_7_2',guide_text='LA_PASSWORD',cmd = on_update_param},
	
	cap_w_secur		= {t='static',id=id+17,xywh='s_snmp_cfg_page_8_1',text='LA_WRITE_SECURITY_NAME'},
	t_w_secur 		= {t='edit',  id=id+18,xywh='s_snmp_cfg_page_8_2',cmd = on_update_param},
	
	cap_w_secur_level= {t='static',id=id+19,xywh='s_snmp_cfg_page_9_1',text='LA_SECURITY_LEVEL'},
	t_w_secur_level 	= {t='combox',  id=id+20,xywh='s_snmp_cfg_page_9_2',items={'noauth','auth','priv'},trans = false,cmd = on_write_level},
	
	cap_w_auth_a= {t='static',id=id+21,xywh='s_snmp_cfg_page_10_1',text='LA_AUTH_ALGORITHM'},
	t_w_auth_a 	= {t='combox',  id=id+22,xywh='s_snmp_cfg_page_10_2',items={'MD5','SHA'},trans = false,cmd = on_update_param},
	
	cap_w_auth_pass= {t='static',id=id+23,xywh='s_snmp_cfg_page_11_1',text='LA_AUTH_PASSWORD'},
	t_w_auth_pass 	= {t='password',  id=id+24,xywh='s_snmp_cfg_page_11_2',guide_text='LA_PASSWORD',cmd = on_update_param},
	
	cap_w_encry_a 	= {t='static',id=id+26,xywh='s_snmp_cfg_page_12_1',text='LA_ENCRY_ALGORITHM',},
	t_w_encry_a 	= {t='combox',id=id+27,xywh='s_snmp_cfg_page_12_2',items={'DES','AES'},trans = false,cmd = on_update_param},
	
	cap_w_encry_pass= {t='static',id=id+28,xywh='s_snmp_cfg_page_13_1',text='LA_ENCRY_PASSWORD',},
	t_w_encry_pass 	= {t='password',  id=id+29,xywh='s_snmp_cfg_page_13_2',guide_text='LA_PASSWORD',cmd = on_update_param},

	
	tipinfo		= {t='static',id=id+31,	xywh='s_snmp_tipinfo_xywh',	text='',trans = false},
	apply 		= {t='button',id=id+32,	xywh='s_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_snmp



