
--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/11/28
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local w1_id 		= require("wnd.w1_util.w1_id")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local id 			= w1_id.cfg_snmp.snmp_port_id
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_msgbox 	= require("wnd.w1_util.w1_msgbox")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local util 			= require("wnd.core.util")

local w1_page_snmp_port = 
{
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_snmp_port.s_768 =
{
	s_snmp_port_cap_port_xywh = {277,25,25,21},
	s_snmp_port_t_port_xywh = {281,106,25,31},
	s_snmp_port_tipinfo_xywh = {53,334,373,35},
};

w1_page_snmp_port.s_1280 = 
{
	s_snmp_port_cap_port_xywh ={455,36,48,30},
	s_snmp_port_t_port_xywh = {460,150,48,44},
	s_snmp_port_tipinfo_xywh = {100,470,700,50},
}

w1_page_snmp_port.s_1440 = 
{
	s_snmp_port_cap_port_xywh = {520,30,48,30},
	s_snmp_port_t_port_xywh = {530,130,48,44},
	s_snmp_port_tipinfo_xywh = {100,470,700,50},
}

w1_page_snmp_port.s_1080p = 
{
	s_snmp_port_cap_port_xywh = {520,36,48,30},
	s_snmp_port_t_port_xywh = {527,150,48,44},
	s_snmp_port_tipinfo_xywh = {100,470,700,50},
}

w1_page_snmp_port.s_2k = 
{
	s_snmp_port_cap_port_xywh = {693,48,64,40},
	s_snmp_port_t_port_xywh = {703,200,64,59},
	s_snmp_port_tipinfo_xywh = {133,627,933,67},
}

w1_page_snmp_port.s_4k = 
{
	s_snmp_port_cap_port_xywh = {1040,72,96,60},
	s_snmp_port_t_port_xywh = {1055,300,96,88},
	s_snmp_port_tipinfo_xywh = {200,940,1400,100},
}

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local cwnd = w1_page_snmp_port.wnd;
	local data = cfgdata.snmp;
	local function setvalue(id, value)
		b_wnd_ex.set_value(top, id, value, false)
	end
	setvalue(cwnd.t_port.id,cfgdata['snmp']['snmp_port']);
	
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck = function(top)
	local cwnd = w1_page_snmp_port.wnd;
	local legalflag = true;
	local nlegalid = {};
	local legal, num = w1_legal.check_port2(top, cwnd.t_port.id);
	if(legal == false) then
		if(161 ~= snmp_port)then
			legalflag =false
			table.insert(nlegalid, cwnd.t_port.id)	
			if(num == w1_legal.port.OUT_RANGE) then
				w1_wnd_util.setparamerr_str(STR('LA_PORT_RANGE2'))
			elseif(num == w1_legal.port.SPECIAL) then
				w1_wnd_util.setparamerr_str(STR('LA_SPECIAL_PORT'))
			end
		end
	end
	
	if(legalflag) then
		return legalflag, nil;
	else
		return legalflag, nlegalid;
	end
	return 0;
end	

local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_snmp_port.wnd;
	local snmp_port = b_wnd_ex.get_value(top, cwnd.t_port.id)
	cfgdata['snmp']['snmp_port'] = snmp_port
	return 0;
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck;
		w1_wnd_util.page_onapply(top);
		w1_wnd_util.tipdispon();		--ʾ
	end
	return 0;
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

w1_page_snmp_port.timer_start = function()
	w1_page_snmp_port.timestart = true;
end

w1_page_snmp_port.timer_stop = function(top)
	w1_page_snmp_port.timestart = false;
	w1_wnd_util.tipclear(top, w1_page_snmp_port.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
	w1_wnd_util.tipdispoff();
end

w1_page_snmp_port.timerenevt = function(top)
	if(w1_page_snmp_port.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_snmp_port.wnd.tipinfo.id);
	end
	return 0;
end

--ҳʼʱٶȡҳҪ
w1_page_snmp_port.init = function(top)
	w1_wnd_util.cfgtab = {'snmp'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

w1_page_snmp_port.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	uitousercfg(top,b_app_cfg.user_cfg);
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_snmp_port.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_port','t_port','tipinfo','apply' },
		
	cap_port 	= {t='static',id=id+1,xywh='s_cfg_page_1_1',text='LA_SNMP_PORT'},
	t_port 	= {t='edit_num', id=id+2,xywh='s_cfg_page_1_2',range={0,65534},cmd = on_update_param},				
	
	tipinfo		= {t='static',id=id+3,	xywh='s_snmp_port_tipinfo_xywh',text='',trans = false},		
	apply 		= {t='button',	id=id+4,	xywh='s_cfg_apply_xywh', 		text='LA_APPLY',cmd=on_apply},
}

return w1_page_snmp_port



