--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_surve.surve_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local util 		= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local w1_page_surve = 
{
	timestart = false,
	buzzer_support = true,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_surve.s_768 =
{
	s_surve_t_enable_xywh = {277,24,25,21},
	s_surve_tipinfo_xywh = {53,192,373,35},
};

w1_page_surve.s_1280 = 
{
	s_surve_t_enable_xywh = {450,35,48,30},
	s_surve_tipinfo_xywh = {100,270,700,50},
}

w1_page_surve.s_1440 = 
{
	s_surve_t_enable_xywh = {520,35,48,30},
	s_surve_tipinfo_xywh = {100,270,700,50},
}

w1_page_surve.s_1080p = 
{
	s_surve_t_enable_xywh = {520,35,48,30},
	s_surve_tipinfo_xywh = {100,270,700,50},
}

w1_page_surve.s_2k = 
{
	s_surve_t_enable_xywh = {693,47,64,40},
	s_surve_tipinfo_xywh = {133,377,933,67},

}

w1_page_surve.s_4k = 
{
	s_surve_t_enable_xywh = {1040,70,96,60},
	s_surve_tipinfo_xywh = {200,540,1400,100},

}

local refresh_enable = function(top, hide, redraw)
	local cwnd = w1_page_surve.wnd
	b_wnd_ex.set_hide(top, cwnd.cap_duration.id, hide, false)
	b_wnd_ex.set_hide(top, cwnd.t_duration.id, hide, false)
	b_wnd_ex.set_hide(top, cwnd.cap_buzz_duration.id, hide, false)
	b_wnd_ex.set_hide(top, cwnd.t_buzz_duration.id, hide, false)
	
	if (not w1_page_surve.buzzer_support) then
		b_wnd_ex.set_hide(top, cwnd.cap_buzz_duration.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.t_buzz_duration.id, true, false)
	end
	
	if true == redraw then
		b_dlg.dlg_set_redraw(top);
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local get_sel_by_duration = function(duration)
		local sel = 0;
		if(5 == duration) then
			sel = 0
		elseif(10 == duration) then
			sel = 1
		elseif(20 == duration) then
			sel = 2
		elseif(30 == duration) then
			sel = 3
		elseif(40 == duration) then
			sel = 4
		elseif(50 == duration) then
			sel = 5
		elseif(60 == duration) then
			sel = 6
		end
		
		return sel
	end
	
	local get_sel_by_buzz = function(duration)
		local sel = 0;
		if(0 == duration) then
			sel = 0
		elseif(5 == duration) then
			sel = 1
		elseif(10 == duration) then
			sel = 2
		elseif(20 == duration) then
			sel = 3
		elseif(30 == duration) then
			sel = 4
		elseif(40 == duration) then
			sel = 5
		elseif(50 == duration) then
			sel = 6
		elseif(60 == duration) then
			sel = 7
		end
		
		return sel
	end		
	
	local cwnd = w1_page_surve.wnd
	local data = cfgdata.surve
	local duration_sel = get_sel_by_duration(data.duration)	
	local buzz_duration_sel = get_sel_by_buzz(data.buzz_duration);
	w1_page_surve.buzzer_support = data.buzzer_support
	
	b_wnd_ex.set_sel(top, cwnd.t_duration.id, duration_sel, false)
	b_wnd_ex.set_sel(top, cwnd.t_buzz_duration.id, buzz_duration_sel, false)

	b_wnd_ex.set_check(top, cwnd.t_enable.id, data.enable, false)	
	if(data.enable) then
		refresh_enable(top, false, false)
	else
		refresh_enable(top, true, false)
	end

end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_surve.wnd
	local data = cfgdata.surve
	local get_durtion_time = function(sel)
		local duration = 5;
		if(0 == sel) then
			duration = 5
		elseif(1 == sel) then
			duration = 10
		elseif(2 == sel) then
			duration = 20
		elseif(3 == sel) then
			duration = 30
		elseif(4 == sel) then
			duration = 40
		elseif(5 == sel) then
			duration = 50
		elseif(6 == sel) then
			duration = 60
		end
		
		return duration
	end
	
	local get_buzz_time = function(sel)
		local duration = 5;
		if(0 == sel) then
			duration = 0
		elseif(1 == sel) then
			duration = 5
		elseif(2 == sel) then
			duration = 10
		elseif(3 == sel) then
			duration = 20
		elseif(4 == sel) then
			duration = 30
		elseif(5 == sel) then
			duration = 40
		elseif(6 == sel) then
			duration = 50
		elseif(7 == sel) then
			duration = 60
		end
		
		return duration
	end	
	
	local duration = get_durtion_time(b_wnd_ex.get_sel(top, cwnd.t_duration.id))	
	local buzz_duration = get_buzz_time(b_wnd_ex.get_sel(top, cwnd.t_buzz_duration.id))

	data.duration = duration
	data.buzz_duration = buzz_duration;
	local enable = b_wnd_ex.get_check(top, cwnd.t_enable.id)
	data.enable = enable
end

local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	local c_wnd = w1_page_surve.wnd

	if(legalflag) then
		return legalflag, nil
	else
		return legalflag, nlegalid
	end
end

w1_page_surve.timer_start = function()
	w1_page_surve.timestart = true
end

w1_page_surve.timer_stop = function(top)
	w1_page_surve.timestart = false
	w1_wnd_util.tipclear(top, w1_page_surve.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_surve.timerenevt = function(top)
	if(w1_page_surve.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_surve.wnd.tipinfo.id)
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_surve.init = function(top)
	w1_wnd_util.cfgtab = {'surve'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

local on_enable = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local check = b_wnd_ex.get_check(top, win_id)
		if(check) then
			refresh_enable(top, false, true)
		else
			refresh_enable(top, true, true)
		end
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_cfg_change = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

--UIָĬֵ
local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_surve.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end

w1_page_surve.on_pre_show = function(top)
	local cwnd = w1_page_surve.wnd;
	local privilege = global_val.get_allprivilege();--ȡȨ
	if(privilege.systerm_config) then
		b_wnd_ex.set_disable(top, cwnd.t_duration.id ,false, false);		
		b_wnd_ex.set_disable(top, cwnd.t_buzz_duration.id ,false, false);
	else
		b_wnd_ex.set_disable(top, cwnd.t_duration.id ,true, false);
		b_wnd_ex.set_disable(top, cwnd.t_buzz_duration.id ,true, false);
	end
end


w1_page_surve.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = { 'cap_enable', 't_enable', 'cap_duration', 't_duration', 'cap_buzz_duration', 't_buzz_duration',
			'tipinfo', 'default', 'apply'},
			
	cap_enable 	= {t='static',id=id+1,xywh='s_cfg_page_1_1',text='LA_SURVEILLANCE_ENABLE'},
	t_enable 	= {t='tt_check', id=id+2,xywh='s_surve_t_enable_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_enable},
	
	cap_duration= {t='static',id=id+3,xywh='s_cfg_page_2_1',text='LA_ALARM_DURATIO'},
	t_duration 	= {t='combox',id=id+4,xywh='s_cfg_page_2_2',items={'5','10','20','30','40','50','60'},trans = false,cmd = on_cfg_change},
	
	cap_buzz_duration	= {t='static',id=id+5,xywh='s_cfg_page_3_1',text='LA_BUZZ_DURATION'},
	t_buzz_duration 	= {t='combox',id=id+6,xywh='s_cfg_page_3_2',items={'0','5','10','20','30','40','50','60'},trans = false,cmd = on_cfg_change},

	
	tipinfo		= {t='static',id=id+7,	xywh='s_surve_tipinfo_xywh',text='',trans = false},
	
	apply 		= {t='button',id=id+8,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},

}


return w1_page_surve
