﻿--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/9
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
--local ui_facade	= require("wnd.w1_facade.w1_ui_facade")
local w1_id 	= require("wnd.w1_util.w1_id")
local b_app_api = require("wnd.core.command.b_app_api")
local id 		= w1_id.cfg_basic.system_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_dlg 	= require("wnd.core.b_dlg")
local r_str		= require("wnd.core.r_res.r_str")
local w1_legal 	= require("wnd.w1_util.w1_legal")
local util 		= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local global_val	= require("wnd.global_val")
local LANGUAGE = {};
local LANGUAGE_LIST = {};
local language_str = {
  english 		="English",
  chinese		="简体中文",
  russian		="русский",
  french		="Français",
  japanese		="日本語",
  german		="Deutsche",
  spanish		="Español",
  portuguese	="Português",
  polish		="Polskie",
  arabic		="العربية",
  bosnian		="Bosanski",
  bulgarian		="български",
  catalan		="Català",
  chinese_t		="繁體中文",
  croatian		="Hrvatski",
  czech			="Čeština",
  danish		="Dansk",
  dutch			="Nederlands",
  estonian		="Eesti keel",
  farsi			="فارسی",
  filipino		="Filipino",
  finnish		="Suomalainen",
  greek			="Ελληνικά",
  hebrew		="עברית",
  hungarian		="Magyar",
  italian		="Italiano",
  korean		="한국어",
  latvian		="Latviešu valoda",
  lithuanian	="Lietuviškai",
  romanian		="Românesc",
  serbian		="Српски",
  slovakia		="Slovensko",
  slovenian		="Slovenščina",
  swedish		="Svenska",
  thai			="ไทย",
  turkish		="Türk dili",
  ukrainian		="Українська",
  vietnamese	="Tiếng Việt",
  norwegian		="Norsk språk",
  indonesian	="Indonesian"
}

local w1_page_sys = {
	old_vo,
	timestart = false,
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_sys.s_768 =
{
	s_sys_info1_xywh = {53,192,533,35},
	s_sys_info2_xywh = {53,234,533,35},
	s_sys_tipinfo_xywh = {53,305,373,35},
};

w1_page_sys.s_1280 = 
{
	s_sys_info1_xywh = {100,270,900,50}, 
	s_sys_info2_xywh = {100,330,900,50}, 
	s_sys_tipinfo_xywh = {100,430,700,50}, 
}

w1_page_sys.s_1440 = 
{
	s_sys_info1_xywh = {100,225,1000,50}, 
	s_sys_info2_xywh = {100,275,1000,50}, 
	s_sys_tipinfo_xywh = {100,375,700,50}, 
}

w1_page_sys.s_1080p = 
{
	s_sys_info1_xywh = {100,270,1000,50}, 
	s_sys_info2_xywh = {100,330,1000,50}, 
	s_sys_tipinfo_xywh = {100,430,700,50}, 
}

w1_page_sys.s_2k = 
{
	s_sys_info1_xywh = {133,360,1333,67},
	s_sys_info2_xywh = {133,440,1333,67},
	s_sys_tipinfo_xywh = {133,540,933,67},

}

w1_page_sys.s_4k = 
{
	s_sys_info1_xywh = {200,540,2000,100},
	s_sys_info2_xywh = {200,640,2000,100},
	s_sys_tipinfo_xywh = {200,860,1400,100},
}

w1_page_sys.clear_data = function()
	w1_page_sys.data = nil;
	LANGUAGE = nil;
	LANGUAGE_LIST = nil;
end	

--10进制转换为2进制
local DecToStrBin = function(value)
	if(tonumber(value) > 1023) then
		return ;
	end
	local bintemp = {};
	local multiple = 1;
	local num = math.abs(value);
	while num > 0 do
		local decimal = num % 2;
		num = math.floor(num / 2);
		bintemp[multiple] = decimal;
		multiple = multiple + 1;
	end
	for i = 1, 10 do
		if(bintemp[i] == nil) then
			bintemp[i] = 0;
		end
	end
	return bintemp;
end

local set_vo_items = function(top, vo_supper, vo)
	local cwnd = w1_page_sys.wnd;
	
	local VO_SUPPORT_SXGA = 1;
	local VO_SUPPORT_WXGA = 2;
	local VO_SUPPORT_1080P = 3;
	local VO_SUPPORT_2K = 4;
	local VO_SUPPORT_4K = 5; 
	local VO_SUPPORT_XGA = 6; 
			
	local vo_supporttable = {};	
	vo_supporttable = DecToStrBin(vo_supper);
	
	local nameitems = {};


	if(vo_supporttable[VO_SUPPORT_XGA] == 1 ) then
		table.insert(nameitems, '1024x768');
	end

	if(vo_supporttable[VO_SUPPORT_SXGA] == 1 ) then
		table.insert(nameitems, '1280x1024');
	end
	
	if(vo_supporttable[VO_SUPPORT_WXGA] == 1 ) then
		table.insert(nameitems, '1440x900');
	end
	
	if(vo_supporttable[VO_SUPPORT_1080P] == 1 ) then
		table.insert(nameitems, '1920x1080');
	end
	
	if(vo_supporttable[VO_SUPPORT_2K] == 1 ) then
		table.insert(nameitems, '2560x1440');
	end
	
	if(vo_supporttable[VO_SUPPORT_4K] == 1 ) then
		table.insert(nameitems, '3840x2160');
	end
	
	local cur_voname;
	if(0 == vo) then
		cur_voname = '1024x768';
	elseif(2 == vo ) then
		cur_voname = '1280x1024';
	elseif(3 == vo ) then
		cur_voname = '1440x900';
	elseif(4 == vo ) then
		cur_voname = '1920x1080';
	elseif(8 == vo ) then
		cur_voname = '2560x1440';
	elseif(7 == vo ) then
		cur_voname = '3840x2160';
	else
		assert(false);
	end
	
	b_wnd_ex.set_items(top, cwnd.t_disp.id, nameitems, false);	
	for i = 1, #nameitems do
		if(cur_voname == nameitems[i]) then
			b_wnd_ex.set_sel(top, cwnd.t_disp.id, i - 1, false);
			break;
		end
	end
end

--获取当前UI设置的分辨率值
local get_uivo = function(top)
	local cwnd = w1_page_sys.wnd;
	local votext = b_wnd_ex.get_text(top, cwnd.t_disp.id);
	if(votext == '1280x1024') then
		return 2;
	elseif(votext == '1440x900') then
		return 3;
	elseif(votext == '1920x1080') then
		return 4;
	elseif(votext == '2560x1440') then
		return 8;
	elseif(votext == '3840x2160') then
		return 7;
	elseif(votext == '1024x768') then
		return 0;		
	else
		assert(false);
	end
end	
		

--从配置数据刷到UI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local set_sel = function(winid, sel)
		b_wnd_ex.set_sel(top, winid, sel, false)
	end	
	local cwnd = w1_page_sys.wnd;
	local data = cfgdata.device;
	
	if (w1_page_sys.data ~= nil) then
		util.clear_tab(w1_page_sys.data);
		w1_page_sys.data = nil;
	end	
	
	w1_page_sys.data = data;
	w1_page_sys.old_vo = data.vo;
	
	b_wnd_ex.set_text(top, cwnd.t_name.id,data.name, false)
	set_vo_items(top, cfgdata.device_info.vo_support, data.vo);
	local laguage_data = cfgdata.language_limits
	LANGUAGE = {};
	LANGUAGE_LIST = {};
	for i =1,laguage_data.language_num do
		local language = laguage_data.language_list[i]
		table.insert(LANGUAGE_LIST,language_str[language]) 
		table.insert(LANGUAGE,language );
	end
	b_wnd_ex.set_items(top,cwnd.t_lang.id,LANGUAGE_LIST,false);
	for i=1,#LANGUAGE do
		if(data.language ==LANGUAGE[i])then
			 b_wnd_ex.set_sel(top, w1_page_sys.wnd.t_lang.id,i-1,false);
		end
	end
		
	b_wnd_ex.set_sel(top, w1_page_sys.wnd.t_unit.id,data.temperature_unit - 1,false);
	
	return 0
end

--从UI到用户数据(点击应用时使用)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_sys.wnd
	
	local devicename = b_wnd_ex.get_text(top, cwnd.t_name.id)
	cfgdata.device.name = devicename
	local idx = b_wnd_ex.get_sel(top, w1_page_sys.wnd.t_lang.id);
	cfgdata.device.language = LANGUAGE[idx+1]
	cfgdata.device.temperature_unit = b_wnd_ex.get_sel(top, w1_page_sys.wnd.t_unit.id) + 1;
	
	return 0
end

--检查UI配置数据是否合法,若合法,则返回标志位和nil,若不合法,则返回标志位和不合法控件的ID
local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	local cwnd = w1_page_sys.wnd

	if(legalflag) then
		return legalflag, nil
	else
		return legalflag, nlegalid
	end
end

w1_page_sys.timer_start = function()
	w1_page_sys.timestart = true
end

w1_page_sys.timer_stop = function(top)
	w1_page_sys.timestart = false
	w1_wnd_util.tipclear(top, w1_page_sys.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
	w1_wnd_util.tipdispoff();
end

w1_page_sys.timerenevt = function(top)
	if(w1_page_sys.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_sys.wnd.tipinfo.id)
	end
	return 0
end

--页面初始化时先清空再读取该页面所需要的配置数据
w1_page_sys.init = function(top)
	w1_wnd_util.cfgtab = {'device','guistyle', 'device_info','language_limits'};
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);
	return 0;
end

local on_display = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local data = w1_page_sys.data;
		data.vo= get_uivo(top);	
	end
	return 0
end

--UI恢复默认值
local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--获取默认参数的接口还未实现,先屏蔽下面一行
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--开启提示
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local param = {};
		local data = w1_page_sys.data;
		param.old_resolution = w1_page_sys.old_vo;
		--还原分辨率配置，应用时不保存修改后的分辨率，在分辨率弹窗点击ok时再保存！
		data.vo = w1_page_sys.old_vo; 
	
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--开启提示
		
		--	param.cur_resolution = data.vo;
		param.cur_resolution = get_uivo(top);
	

		if(param.old_resolution ~= param.cur_resolution) then
			--设置布局对应
			local w1_ui_facade	= require("wnd.w1_facade.w1_ui_facade");
			w1_ui_facade.load_layout(param.cur_resolution, 'w1', 'f_normat');
			b_app_api.channge_resolution(param);
			w1_page_sys.old_vo = param.cur_resolution;
			return b_ui.WM_USER_CHANGE_RESOLUTION;
		end	
	end
	return 0;
end

w1_page_sys.apply = function (top)
	local param = {};
	local data = w1_page_sys.data;
	param.old_resolution = w1_page_sys.old_vo;
	--还原分辨率配置，应用时不保存修改后的分辨率，在分辨率弹窗点击ok时再保存！
	data.vo = w1_page_sys.old_vo; 
	
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--开启提示
	end
	
--	param.cur_resolution = data.vo;
	param.cur_resolution = get_uivo(top);
	if(param.old_resolution ~= param.cur_resolution) then
		--设置布局对应
		local w1_ui_facade	= require("wnd.w1_facade.w1_ui_facade");
		w1_ui_facade.load_layout(param.cur_resolution, 'w1', 'f_normat');
		b_app_api.channge_resolution(param);
		w1_page_sys.old_vo = data.vo;
		return b_ui.WM_USER_CHANGE_RESOLUTION;
	end	
	
	return ret;
end

local on_name = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_language= function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		w1_wnd_util.uidatacheckfunc = uidatacheck --4.1方案切换语言先保存配置
		b_app_cfg.origintousercfg();
		uitousercfg(top,b_app_cfg.user_cfg);
		w1_wnd_util.page_onapply(top)
		
		local idx = b_wnd_ex.get_sel(top, w1_page_sys.wnd.t_lang.id);
		b_app_api.language_change(LANGUAGE[idx+1]);
		local path = "language/"..LANGUAGE[idx+1]..".json"
		r_str.load(path)	
		return b_ui.WM_USER_UPDATE_LANGUAGE;
	end

	return 0
end

local on_unit= function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	
	return 0;
end	

local on_color= function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		w1_wnd_util.uidatacheckfunc = uidatacheck --4.1方案切换语言先保存配置
		uitousercfg(top,b_app_cfg.user_cfg);
		w1_wnd_util.page_onapply(top)
		
		return b_ui.WM_USER_UPDATE_LANGUAGE;
	end

	return 0
end

w1_page_sys.on_pre_show= function(top)
	local auxi_attr = global_val.get_support_auxiliary_attr();
	if (true == auxi_attr) then --支持辅屏
		b_wnd_ex.set_text(top,w1_page_sys.wnd.info1.id,STR('LA_AUX_SCREEN1'),false);
		b_wnd_ex.set_text(top,w1_page_sys.wnd.info2.id,STR('LA_AUX_SCREEN2'),false);
	end
end

w1_page_sys.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = { 'c_name', 't_name',	'c_disp','t_disp', 'c_lang', 't_lang',
	'cap_unit','t_unit','info1','info2','tipinfo', 'default', 'apply'},

	c_name 	= {t='static',	id=id+1,	xywh='s_cfg_page_1_1',	text='LA_DEVICE_NAME'},
	t_name 	= {t='edit',	id=id+2,	xywh='s_cfg_page_1_2',	text='',trans = false,guide_text='LA_DEVICE_NAME',cmd = on_name},	
	
	c_disp 	= {t='static',	id=id+3,	xywh='s_cfg_page_2_1',	text='LA_OUTPUT_RESOLUTION'},
	t_disp 	= {t='combox',	id=id+4,	xywh='s_cfg_page_2_2',	
				items={},trans = false,cmd =on_display
				},	

	c_lang	= {t='static',	id=id+5,	xywh='s_cfg_page_3_1',	text='LA_LANGUAGE'},
	t_lang 	= {t='combox',	id=id+6,	xywh='s_cfg_page_3_2',	
			items={'English','Français','Polskie', 'Italiano', 'Español', 'Magyar', 'Pоссии', 'Tiếng Việt', 'ไทย ', 'Dansk', 'čeština',
			 'Slovensko','Indonesian','Português','Nederlands','Deutsch'},trans = false,cmd = on_language
			},	
			
	cap_unit	= {t='static',	id=id+7,	xywh='s_cfg_page_4_1',		text='LA_TEMPER_UNIT'},
	t_unit 	= {t='combox',	id=id+8,	xywh='s_cfg_page_4_2',		items={'LA_CELSIUS', 'LA_FAHRENHEIT'},cmd = on_unit},	
			
	info1 	= {t='static',	id=id+9,	xywh='s_sys_info1_xywh',	text='',trans = false},
	info2	= {t='static',	id=id+10,	xywh='s_sys_info2_xywh',	text='',trans = false},
	tipinfo	= {t='static',	id=id+13,	xywh='s_sys_tipinfo_xywh',	text='',trans = false},

	apply 	= {t='button',	id=id+15,	xywh='s_cfg_apply_xywh', 		text='LA_APPLY',cmd=on_apply},

}


return w1_page_sys

