--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_humanthermometer.thermal_cal_id
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local w1_legal 	= require("wnd.w1_util.w1_legal")
local util 		= require("wnd.core.util")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str

local w1_page_thermal_cal = 
{
	old_chid,
	data,
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}

w1_page_thermal_cal.s_768 =
{
	s_thermal_cal_image_xywh = {70,22,352,256},
	s_thermal_cal_clear_xywh = {358,284,64,28},
	s_thermal_cal_cap_channel_xywh = {436,28,85,35},
	s_thermal_cal_t_channel_xywh = {586,28,131,28},
	s_thermal_cal_cap_enable_xywh = {436,64,85,35},
	s_thermal_cal_t_enable_xywh = {582,71,25,21},
	s_thermal_cal_cap_area_xywh = {436,99,133,35},
	s_thermal_cal_t_area_xywh = {582,106,25,21},
	s_thermal_cal_cap_tmp_xywh = {436,135,133,35},
	s_thermal_cal_t_tmp_xywh = {586,138,115,28},
	s_thermal_cal_t_tmp_u_xywh = {701,138,16,35},
	s_thermal_cal_cap_rate_xywh = {436,170,133,35},
	s_thermal_cal_t_rate_xywh = {586,170,131,28},
	s_thermal_cal_cap_distance_xywh = {436,206,85,35},
	s_thermal_cal_t_distance_xywh = {586,206,115,28},
	s_thermal_cal_t_distance_u_xywh = {701,206,16,35},
	s_thermal_cal_tipinfo_xywh = {70,426,373,35},
};

w1_page_thermal_cal.s_1280 = 
{
	s_thermal_cal_image_xywh		= {92,32,512,360},
	s_thermal_cal_clear_xywh        = {492,400,120,40},
	s_thermal_cal_cap_channel_xywh 	= {630,40,200,50},
	s_thermal_cal_t_channel_xywh 	= {840,40,120,40},
	s_thermal_cal_cap_enable_xywh 	= {630,90,200,50},
	s_thermal_cal_t_enable_xywh 	= {833,100,48,30},
	s_thermal_cal_cap_area_xywh 	= {630,140,200,50},
	s_thermal_cal_t_area_xywh 		= {833,150,48,30},
	s_thermal_cal_cap_tmp_xywh 		= {630,190,200,50},
	s_thermal_cal_t_tmp_xywh 		= {840,190,90,40},	
	s_thermal_cal_t_tmp_u_xywh 		= {930,190,30,50},	
	s_thermal_cal_cap_rate_xywh 	= {630,240,205,50},
	s_thermal_cal_t_rate_xywh 		= {840,240,120,40},
	s_thermal_cal_cap_distance_xywh = {630,290,200,50},
	s_thermal_cal_t_distance_xywh	= {840,290,90,40},
	s_thermal_cal_t_distance_u_xywh	= {930,290,30,50},
	s_thermal_cal_tipinfo_xywh 		= {92,750,700,50},
};

w1_page_thermal_cal.s_1440 = 
{
	s_thermal_cal_image_xywh		= {100,32,640,360},
	s_thermal_cal_clear_xywh        = {620,400,120,40},
	s_thermal_cal_cap_channel_xywh 	= {750,40,200,50},
	s_thermal_cal_t_channel_xywh 	= {960,40,120,40},
	s_thermal_cal_cap_enable_xywh 	= {750,90,200,50},
	s_thermal_cal_t_enable_xywh 	= {953,100,48,30},
	s_thermal_cal_cap_area_xywh 	= {750,140,200,50},
	s_thermal_cal_t_area_xywh 		= {953,150,48,30},
	s_thermal_cal_cap_tmp_xywh 		= {750,190,200,50},
	s_thermal_cal_t_tmp_xywh 		= {960,190,90,40},	
	s_thermal_cal_t_tmp_u_xywh 		= {1050,190,30,50},	
	s_thermal_cal_cap_rate_xywh 	= {750,240,200,50},
	s_thermal_cal_t_rate_xywh 		= {960,240,120,40},
	s_thermal_cal_cap_distance_xywh = {750,290,200,50},
	s_thermal_cal_t_distance_xywh	= {960,290,90,40},
	s_thermal_cal_t_distance_u_xywh	= {1050,290,30,50},
	s_thermal_cal_tipinfo_xywh 	    = {100,600,700,50},
};

w1_page_thermal_cal.s_1080p = 
{
	s_thermal_cal_image_xywh = {98,32,640,360},
	s_thermal_cal_clear_xywh  = {620,400,120,40},
	s_thermal_cal_cap_channel_xywh = {800,40,160,50},
	s_thermal_cal_t_channel_xywh = {1080,40,246,40},
	s_thermal_cal_cap_enable_xywh = {800,90,160,50},
	s_thermal_cal_t_enable_xywh = {1073,100,48,30},
	s_thermal_cal_cap_area_xywh = {800,140,250,50},
	s_thermal_cal_t_area_xywh = {1073,150,48,30},
	s_thermal_cal_cap_tmp_xywh = {800,190,250,50},
	s_thermal_cal_t_tmp_xywh = {1080,195,216,40},
	s_thermal_cal_t_tmp_u_xywh = {1296,195,30,50},
	s_thermal_cal_cap_rate_xywh = {800,240,250,50},
	s_thermal_cal_t_rate_xywh = {1080,240,246,40},
	s_thermal_cal_cap_distance_xywh = {800,290,160,50},
	s_thermal_cal_t_distance_xywh = {1080,290,216,40},
	s_thermal_cal_t_distance_u_xywh = {1296,290,30,50},
	s_thermal_cal_tipinfo_xywh = {98,600,700,50},

};
w1_page_thermal_cal.s_2k = 
{
	s_thermal_cal_image_xywh = {136,43,856,480},
	s_thermal_cal_clear_xywh  = {820,540,160,52},
	s_thermal_cal_cap_channel_xywh = {1066,67,280,67},
	s_thermal_cal_t_channel_xywh = {1440,73,280,53},
	s_thermal_cal_cap_enable_xywh = {1066,147,280,67},
	s_thermal_cal_t_enable_xywh = {1433,147,64,53},
	s_thermal_cal_cap_area_xywh = {1066,227,280,67},
	s_thermal_cal_t_area_xywh = {1433,227,64,53},
	s_thermal_cal_cap_tmp_xywh = {1066,307,280,67},
	s_thermal_cal_t_tmp_xywh = {1440,307,248,53},
	s_thermal_cal_t_tmp_u_xywh = {1688,307,40,67},
	s_thermal_cal_cap_rate_xywh = {1066,387,280,67},
	s_thermal_cal_t_rate_xywh = {1440,387,280,53},
	s_thermal_cal_cap_distance_xywh = {1066,467,280,67},
	s_thermal_cal_t_distance_xywh = {1440,467,248,53},
	s_thermal_cal_t_distance_u_xywh = {1688,467,40,67},
	s_thermal_cal_tipinfo_xywh = {133,800,933,67},
};
w1_page_thermal_cal.s_4k = 
{
	s_thermal_cal_image_xywh = {200,62,1280,720},
	s_thermal_cal_clear_xywh  = {1240,800,240,80},
	s_thermal_cal_cap_channel_xywh = {1600,80,320,100},
	s_thermal_cal_t_channel_xywh = {2160,90,492,80},
	s_thermal_cal_cap_enable_xywh = {1600,180,320,100},
	s_thermal_cal_t_enable_xywh = {2146,200,96,80},
	s_thermal_cal_cap_area_xywh = {1600,280,500,100},
	s_thermal_cal_t_area_xywh = {2146,300,96,60},
	s_thermal_cal_cap_tmp_xywh = {1600,380,500,100},
	s_thermal_cal_t_tmp_xywh = {2160,380,432,80},
	s_thermal_cal_t_tmp_u_xywh = {2592,380,60,100},
	s_thermal_cal_cap_rate_xywh = {1600,480,500,100},
	s_thermal_cal_t_rate_xywh = {2160,480,492,80},
	s_thermal_cal_cap_distance_xywh = {1600,580,320,100},
	s_thermal_cal_t_distance_xywh = {2160,580,432,80},
	s_thermal_cal_t_distance_u_xywh = {2592,580,60,100},
	s_thermal_cal_tipinfo_xywh = {200,1200,1400,100},
};

local channel_num;--豸ͨĿ

-- ַβĿհַ
local str_trim = function(input)
	return (string.gsub(input, "^%s*(.-)%s*$", "%1"))
end

local fahrenheit_to_celsius = function(temper)
	return (((temper) - 32) / 1.8)
end	

local celsius_to_fahrenheit = function(temper)
	return ((temper) * 1.8 + 32);
end

local set_custom_layout = function(chid)
	local param = {
		chn_id = chid,
		wnd_id = 1,
	}
	local layoutpos = w1_page_thermal_cal.layoutpos;
	param.x = layoutpos.x;
	param.y = layoutpos.y;
	param.cx = layoutpos.cx;
	param.cy = layoutpos.cy;
	param.stream = true;			--
	b_app_api.set_custom_layout_wnd(param)
end

w1_page_thermal_cal.clear_data = function()
	w1_page_thermal_cal.data = nil;
end	

local sethide =function(top, bool_hide, redraw)
	local cwnd = w1_page_thermal_cal.wnd;
	local sid = cwnd.cap_enable.id;
	local eid = cwnd.t_distance_u.id;
	
	for i=sid, eid do
		b_wnd_ex.set_hide(top, i, bool_hide, redraw)
	end
end

local refresh_chdata = function(top, chid, redraw)
	local chn = "channel"..chid;
	set_custom_layout(chid);
	local cwnd =w1_page_thermal_cal.wnd
	local data = w1_page_thermal_cal.data.thermal_cal;
	local x = data[chn]['black_body_area']['x']
	local y = data[chn]['black_body_area']['y']
	local width = data[chn]['black_body_area']['width']
	local height = data[chn]['black_body_area']['height']
	local rect = b_wnd_ex.get_rect(top,cwnd.image.id);
	--תֵ꣬Ϊٷֱ
	x = rect['rect1']+math.floor(x*SIZE('s_thermal_cal_image_xywh')[3]/100)
	y = rect['rect2']+math.floor(y*SIZE('s_thermal_cal_image_xywh')[4]/100)
	width = math.floor(width*SIZE('s_thermal_cal_image_xywh')[3]/100)
	height =math.floor(height*SIZE('s_thermal_cal_image_xywh')[4]/100)
	b_wnd_ex.set_check(top,cwnd.t_enable.id,data[chn].enable,false)
	b_wnd_ex.set_check(top,cwnd.t_area.id,data[chn].show_obj_enable,false)
	local black_body_temper = string.format("%7.2f", data[chn].black_body_temper)
	b_wnd_ex.set_text(top,cwnd.t_tmp.id,str_trim(black_body_temper),false)
	local emissivity = string.format("%6.2f", data[chn].emissivity)
	b_wnd_ex.set_text(top,cwnd.t_rate.id,str_trim(emissivity),false)
	local target_space = string.format("%6.2f", data[chn].target_space)
	b_wnd_ex.set_text(top,cwnd.t_distance.id,str_trim(target_space),false)
	if tonumber(x) and tonumber(y) and tonumber(width)and tonumber(height) then
		b_wnd_ex.set_roi_area(top,cwnd.image.id,{x,y,width,height},false)
	end
	if data[chn].temper_unit == 0 then
		local str = string.format('%c%c%c%c',226,132,131,0);
		b_wnd_ex.set_text(top,cwnd.t_tmp_u.id,str,false);
	else
		local str = string.format('%c%c%c%c',226,132,137,0);
		b_wnd_ex.set_text(top,cwnd.t_tmp_u.id,str,false);
	end
	if data[chn].length_unit == 0 then
		b_wnd_ex.set_text(top,cwnd.t_distance_u.id, 'm', false);
	else
		b_wnd_ex.set_text(top,cwnd.t_distance_u.id, 'ft', false);
	end
	if true == redraw then
		b_dlg.dlg_set_redraw(top);
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	w1_page_thermal_cal.data = cfgdata;
	local cwnd = w1_page_thermal_cal.wnd
	local camreaitems = {};
	local idx = 1;
	local privilege = global_val.get_allprivilege();--ȡȨ
	local ch_prilist = privilege.channel_manager_list;
	
	for i=1, channel_num do
		if(cfgdata['thermal_cal']['channel'..i] ~= nil and ch_prilist[i] == 1) then
			camreaitems[idx] = i;
			idx = idx + 1;
		end
	end
	b_wnd_ex.set_items(top, cwnd.t_channel.id, camreaitems, false);
	if(idx ~= 1) then--˵ͨ
		b_wnd_ex.set_enableselect(top,cwnd.image.id,true,false);
		b_wnd_ex.set_disable(top, cwnd.t_channel.id, false, false)
		b_wnd_ex.set_disable(top, cwnd.clear.id, false, false)
		sethide(top, false, false);
		b_wnd_ex.set_sel(top, cwnd.t_channel.id, 0, false);--Ĭϵһ
		local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
		refresh_chdata(top, chid, false)
	else--ͨ
		b_wnd_ex.set_enableselect(top,cwnd.image.id,false,false);
		b_wnd_ex.set_disable(top, cwnd.t_channel.id, true, false)
		b_wnd_ex.set_disable(top, cwnd.clear.id, true, false)
		sethide(top, true, false);
		for i=1, channel_num do
			if(ch_prilist[i] ~= 0) then
				set_custom_layout(i);
				break;
			end
		end	
	end
	
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd=w1_page_thermal_cal.wnd
	local data = w1_page_thermal_cal.data.thermal_cal;
	local chn_id = b_wnd_ex.get_text(top,cwnd.t_channel.id)
	local chn = "channel"..chn_id	
	data[chn].enable = b_wnd_ex.get_check(top,cwnd.t_enable.id)
	data[chn].show_obj_enable = b_wnd_ex.get_check(top,cwnd.t_area.id)
	data[chn].black_body_temper = tonumber(b_wnd_ex.get_text(top, cwnd.t_tmp.id));	
	data[chn].emissivity = tonumber(b_wnd_ex.get_text(top, cwnd.t_rate.id));
	data[chn].target_space = tonumber(b_wnd_ex.get_text(top, cwnd.t_distance.id));
	local chn_id = b_wnd_ex.get_text(top,cwnd.t_channel.id)
	local chn = "channel"..chn_id
	local area = b_wnd_ex.get_roi_area(top,cwnd.image.id)
	local rect = b_wnd_ex.get_rect(top,cwnd.image.id);
	area[1] = math.floor((area[1] - rect['rect1'])*100)/SIZE('s_thermal_cal_image_xywh')[3]
	area[2] = math.floor((area[2] - rect['rect2'])*100)/SIZE('s_thermal_cal_image_xywh')[4]
	area[3] = math.floor(area[3]*100)/SIZE('s_thermal_cal_image_xywh')[3]
	area[4] = math.floor(area[4]*100)/SIZE('s_thermal_cal_image_xywh')[4]
	data[chn]['black_body_area']['x'] = area[1]
	data[chn]['black_body_area']['y'] = area[2]
	
	if area[1] + area[3] > 99 then
		data[chn]['black_body_area']['width'] = 99 - area[1]
	else
		data[chn]['black_body_area']['width'] = area[3]
	end
	
	if area[2] + area[4] > 99 then
		data[chn]['black_body_area']['height'] = 99 - area[2]
	else
		data[chn]['black_body_area']['height'] = area[4]
	end
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local cwnd = w1_page_thermal_cal.wnd
	local data = w1_page_thermal_cal.data.thermal_cal;
	if (data.num == 0) then -- ֱӷ
		return true, nil;	
	end	
	
	local nlegalid = {}
	local area = b_wnd_ex.get_roi_area(top,cwnd.image.id)	
	local rect = b_wnd_ex.get_rect(top,cwnd.image.id);
	local check = b_wnd_ex.get_check(top,cwnd.t_enable.id)
	area[3] = math.floor(area[3]*100)/SIZE('s_thermal_cal_image_xywh')[3]
	area[4] = math.floor(area[4]*100)/SIZE('s_thermal_cal_image_xywh')[4]
	if check == true then
		if (0 == (area[3] * area[4])) then
			w1_wnd_util.setparamerr_str(STR('LA_DRAW_AREA'));
			return false,nlegalid;
		end
		if area[3] > 60 then
			w1_wnd_util.setparamerr_str(STR('LA_ERR_LEN_LARGE'));
			return false,nlegalid;
		end
		if area[4] > 60 then
			w1_wnd_util.setparamerr_str(STR('LA_ERR_WID_LARGE'));
			return false,nlegalid;
		end
	end
	return true,nil
end

w1_page_thermal_cal.timer_start = function()
	w1_page_thermal_cal.timestart = true
end

w1_page_thermal_cal.timer_stop = function(top)
	w1_page_thermal_cal.timestart = false
	w1_wnd_util.tipclear(top, w1_page_thermal_cal.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
	w1_wnd_util.tipdispoff();
end

w1_page_thermal_cal.timerenevt = function(top)
	if(w1_page_thermal_cal.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_thermal_cal.wnd.tipinfo.id)
	end
	return 0
end

w1_page_thermal_cal.init = function(top)
	b_wnd_ex.set_roi_area(top,w1_page_thermal_cal.wnd.image.id,{0,0,0,0},false)--ٻ
	w1_wnd_util.cfgtab = {'thermal_cal'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	local chidstr = b_wnd_ex.get_text(top, w1_page_thermal_cal.wnd.t_channel.id);
	if(chidstr == '') then
		return 0
	end
	local chid =tonumber(chidstr);
	w1_page_thermal_cal.old_chid = chid;
	set_custom_layout(chid);
	return 0
end

local on_channel= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local chid = tonumber(b_wnd_ex.get_text(top, w1_page_thermal_cal.wnd.t_channel.id));
		refresh_chdata(top, chid, true)
		w1_page_thermal_cal.old_chid = chid;
	end
	return 0;
end

local on_clear = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_wnd_ex.clear_intarea(top,w1_page_thermal_cal.wnd.image.id,false,true);
		uitousercfg(top,w1_page_thermal_cal.data)
	end
	return 0
end	

local on_update_param = function(top, id, vmsg, x, y)
	if (vmsg == b_ui.WM_USER_UPDATE_PARAM or b_ui.LBUTTONCLK == vmsg) then
		uitousercfg(top,b_app_cfg.user_cfg);
	elseif (vmsg == b_ui.RBUTTONCLK) then
		return vmsg;
	end
	return 0;
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_thermal_cal.apply =function(top)
	local ret = nil; 
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()
	end
	return ret
end

w1_page_thermal_cal.on_pre_show = function(top)
	channel_num = global_val.get_channelnum();
	local cwnd = w1_page_thermal_cal.wnd;
	local param = {
		x = SIZE('s_thermal_cal_image_xywh')[1] + SIZE('s_cfg_page_xywh')[1], 
		y = SIZE('s_thermal_cal_image_xywh')[2] + SIZE('s_cfg_page_xywh')[2],
		cx = SIZE('s_thermal_cal_image_xywh')[3],
		cy = SIZE('s_thermal_cal_image_xywh')[4],
	}
	local oldparam_x = param.x;
	param.x = math.floor((param.x + 2) / 4) * 4;--֤4ı
	param.cx = math.floor((param.cx + 2) / 4) *4;
	local oldparam_y = param.y;
	param.y = math.floor((param.y + 2) / 4) * 4;
	param.cy = math.floor((param.cy + 2) / 4) *4;
	
	w1_page_thermal_cal.layoutpos.x = param.x;
	w1_page_thermal_cal.layoutpos.cx = param.cx;
	w1_page_thermal_cal.layoutpos.y = param.y;
	w1_page_thermal_cal.layoutpos.cy = param.cy;
	
	local pos = {};
	pos[1] = SIZE('s_thermal_cal_image_xywh')[1] + param.x - oldparam_x;
	pos[2] = SIZE('s_thermal_cal_image_xywh')[2] + param.y - oldparam_y;
	pos[3] = param.cx;
	pos[4] = param.cy;
	b_wnd_ex.move_ex(top, cwnd.image.id, pos, false);
	
	local negative_num_atrr = {true, 6, 2};
	b_wnd_ex.set_negative_num_atrr(top, cwnd.t_tmp.id, negative_num_atrr, false);
	b_wnd_ex.set_negative_num_atrr(top, cwnd.t_distance.id, negative_num_atrr, false);
	negative_num_atrr[2] = 4;
	b_wnd_ex.set_negative_num_atrr(top, cwnd.t_rate.id, negative_num_atrr, false);
	
	local rate_decimal_interval = {true, 0.1, 1};
	b_wnd_ex.set_decimal_interval(top, cwnd.t_rate.id, rate_decimal_interval, false);
	local distance_decimal_interval = {true , 0.01, 999999}	
	b_wnd_ex.set_decimal_interval(top, cwnd.t_distance.id, distance_decimal_interval, false);	
end

w1_page_thermal_cal.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {	'image', 'clear',
			'cap_channel', 't_channel','cap_enable', 't_enable','cap_area', 't_area',
			'cap_tmp', 't_tmp','t_tmp_u','cap_rate','t_rate',
			'cap_distance','t_distance','t_distance_u','tipinfo', 'apply'},
			
	image = {t='roi',id=id+1,xywh='s_thermal_cal_image_xywh',text='Image widget',cmd = on_update_param},
				
	clear	= {t='tt_button',id=id+2,xywh='s_thermal_cal_clear_xywh',text='LA_CLEAR',cmd = on_clear},			
	
	cap_channel	= {t='static',	id=id+3,	xywh='s_thermal_cal_cap_channel_xywh',		text='LA_CHANNEL'},
	t_channel 	= {t='combox',	id=id+4,	xywh='s_thermal_cal_t_channel_xywh',		items={'1','2','3','4','5','6','7','8'},trans = false,channel_cbox = true,cmd = on_channel},	

	cap_enable	= {t='static',	id=id+5,	xywh='s_thermal_cal_cap_enable_xywh',		text='LA_ENABLE'},
	t_enable 	= {t='tt_check',id=id+6,	xywh='s_thermal_cal_t_enable_xywh', cmd = on_update_param,		
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					},
	cap_area	= {t='static',	id=id+7,	xywh='s_thermal_cal_cap_area_xywh',		text='LA_DISPLAY_AREA_INFO'},
	t_area	= {t='tt_check',id=id+8,	xywh='s_thermal_cal_t_area_xywh', cmd = on_update_param,		
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					},
	
	cap_tmp	= {t='static',	id=id+11,	xywh='s_thermal_cal_cap_tmp_xywh',		text='LA_TARGET_TEMP'},
	t_tmp 	= {t='edit_num',	id=id+12,	xywh='s_thermal_cal_t_tmp_xywh',range = {-99999, 999999}, cmd = on_update_param},
	t_tmp_u	= {t='static',	id=id+13,	xywh='s_thermal_cal_t_tmp_u_xywh',	text='',trans=false, align = b_ui.ALIGN.CENTER},
	cap_rate	= {t='static',	id=id+14,	xywh='s_thermal_cal_cap_rate_xywh',		text='LA_EMISSION_RATE'},
	t_rate		= {t='edit_num',	id=id+15,	xywh='s_thermal_cal_t_rate_xywh', rang = {0, 1}, cmd = on_update_param},
	
	cap_distance	= {t='static',	id=id+16,xywh='s_thermal_cal_cap_distance_xywh',	text='LA_DISTANCE_NO_UNIT'},
	t_distance	= {t='edit_num',	id=id+17,	xywh='s_thermal_cal_t_distance_xywh', range = {0, 999999}, cmd = on_update_param},
	t_distance_u= {t='static',	id=id+18,xywh='s_thermal_cal_t_distance_u_xywh',	text='', trans = false, align = b_ui.ALIGN.CENTER},
	tipinfo		= {t='static',	id=id+19,	xywh='s_thermal_cal_tipinfo_xywh',		text='',		trans = false},	
	apply 		= {t='button',	id=id+20,	xywh= 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_thermal_cal

