--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_humanthermometer.thermal_map_id
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local w1_copy 	= require("wnd.w1_util.w1_copy")
local w1_key 	= require("wnd.w1_util.w1_key")
local w1_legal 	= require("wnd.w1_util.w1_legal")
local util 		= require("wnd.core.util")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str

local w1_page_thermal_map = 
{
	old_chid,
	data,
	timestart = false,
	thermal_chn,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	layoutpos = {},
}
local ptz_info = {};

w1_page_thermal_map.s_768 =
{
	s_thermal_map_cap_channel_xywh = {53,21,202,32},
	s_thermal_map_channel_xywh = {405,21,202,32},
	s_thermal_map_image_xywh = {70,66,352,256},
	s_thermal_map_image2_xywh = {454,66,352,256},
	s_zoomin_xywh = {56,355,26,28},
	s_zoomout_xywh = {88,355,26,28},
	s_near_focus_xywh = {120,355,26,28},
	s_far_focus_xywh = {152,355,26,28},
	s_lock_focus_xywh = {202,348,160,42},
	s_zoomin2_xywh = {408,355,26,28},
	s_zoomout2_xywh = {440,355,26,28},
	s_near_focus2_xywh = {472,355,26,28},
	s_far_focus2_xywh = {501,355,26,28},
	s_lock_focus2_xywh = {554,348,160,42},
	s_thermal_map_t_id_xywh = {405,405,202,32},
	s_thermal_map_t_depth_xywh = {405,448,186,32},
	s_thermal_map_t_depth_u_xywh = {592,448,16,32},
	s_thermal_map_t_point_xywh = {405,490,202,32},
	s_thermal_map_cap_id_xywh = {53,405,202,32},
	s_thermal_map_cap_depth_xywh = {53,448,202,32},
	s_thermal_map_cap_offset_x_xywh = {53,405,202,32},
	s_thermal_map_cap_offset_y_xywh = {53,448,202,32},
	s_thermal_map_t_offset_x_xywh = {405,405,202,32},
	s_thermal_map_t_offset_y_xywh = {405,448,202,32},	
	s_thermal_map_cap_point_xywh = {53,490,202,32},
	s_thermal_map_tipinfo_xywh = {70,586,160,28},
};

w1_page_thermal_map.s_1280 = 
{
	s_thermal_map_cap_channel_xywh = {60, 30,350,45},
	s_thermal_map_channel_xywh = {500,30,300,45},
	s_thermal_map_image_xywh = {60,90,416,240},
	s_thermal_map_image2_xywh = {508,90,416,240},
	s_zoomin_xywh = {65,380,32,32},
	s_zoomout_xywh = {105,380,32,32},
	s_near_focus_xywh = {145,380,32,32},
	s_far_focus_xywh = {185,380,32,32},
	s_lock_focus_xywh = {225,370,280,50},
	s_zoomin2_xywh = {505,380,32,32},
	s_zoomout2_xywh = {545,380,32,32},
	s_near_focus2_xywh = {585,380,32,32},
	s_far_focus2_xywh = {625,380,32,32},
	s_lock_focus2_xywh = {665,370,280,50},
	s_thermal_map_t_id_xywh = {500,470,300,45},
	s_thermal_map_t_depth_xywh = {500,530,270,45},
	s_thermal_map_t_depth_u_xywh = {770,530,30,45},
	s_thermal_map_t_point_xywh = {500,590,300,45},
	s_thermal_map_tipinfo_xywh ={60,750,500,40},
	s_thermal_map_cap_id_xywh = {60,470,350,45},
	s_thermal_map_cap_depth_xywh = {60,530,350,45},
	s_thermal_map_cap_offset_x_xywh = {60,470,350,45},
	s_thermal_map_cap_offset_y_xywh = {60,530,350,45},
	s_thermal_map_t_offset_x_xywh = {500,470,300,45},
	s_thermal_map_t_offset_y_xywh = {500,530,300,45},
	s_thermal_map_cap_point_xywh = {60,590,350,45},
};

w1_page_thermal_map.s_1440 = 
{
	s_thermal_map_cap_channel_xywh = {60, 30,350,45},
	s_thermal_map_channel_xywh = {500,30,300,45},
	s_thermal_map_image_xywh = {60,90,426,240},
	s_thermal_map_image2_xywh = {500,90,426,240},
	s_zoomin_xywh = {65,350,32,32},
	s_zoomout_xywh = {105,350,32,32},
	s_near_focus_xywh = {145,350,32,32},
	s_far_focus_xywh = {185,350,32,32},
	s_lock_focus_xywh = {225,340,280,50},
	s_zoomin2_xywh = {505,350,32,32},
	s_zoomout2_xywh = {545,350,32,32},
	s_near_focus2_xywh = {585,350,32,32},
	s_far_focus2_xywh = {625,350,32,32},
	s_lock_focus2_xywh = {665,340,280,50},
	s_thermal_map_t_id_xywh = {500,400,300,45},
	s_thermal_map_t_depth_xywh = {500,460,270,45},
	s_thermal_map_t_depth_u_xywh = {770,460,30,45},
	s_thermal_map_t_point_xywh = {500,520,300,45},
	s_thermal_map_tipinfo_xywh ={60,690,500,40},
	s_thermal_map_cap_id_xywh = {60,400,350,45},
	s_thermal_map_cap_depth_xywh = {60,460,350,45},
	s_thermal_map_cap_offset_x_xywh = {60,400,350,45},
	s_thermal_map_cap_offset_y_xywh = {60,460,350,45},
	s_thermal_map_t_offset_x_xywh = {500,400,300,45},
	s_thermal_map_t_offset_y_xywh = {500,460,300,45},	
	s_thermal_map_cap_point_xywh = {60,520,350,45},
};

w1_page_thermal_map.s_1080p = 
{
	s_thermal_map_cap_channel_xywh = {100,30,380,45},
	s_thermal_map_channel_xywh = {760,30,380,45},
	s_thermal_map_image_xywh = {98,90,640,360},
	s_thermal_map_image2_xywh = {770,90,640,360},
	s_zoomin_xywh = {105,500,50,40},
	s_zoomout_xywh = {165,500,50,40},
	s_near_focus_xywh = {225,500,50,40},
	s_far_focus_xywh = {285,500,50,40},
	s_lock_focus_xywh = {380,490,300,60},
	s_zoomin2_xywh = {765,500,50,40},
	s_zoomout2_xywh = {825,500,50,40},
	s_near_focus2_xywh = {885,500,50,40},
	s_far_focus2_xywh = {940,500,50,40},
	s_lock_focus2_xywh = {1040,490,300,60},
	s_thermal_map_t_id_xywh = {760,570,380,45},
	s_thermal_map_t_depth_xywh = {760,630,350,45},
	s_thermal_map_t_depth_u_xywh = {1110,630,30,45},
	s_thermal_map_t_point_xywh = {760,690,380,45},
	s_thermal_map_cap_id_xywh = {100,570,380,45},
	s_thermal_map_cap_depth_xywh = {100,630,380,45},
	s_thermal_map_cap_offset_x_xywh = {100,570,380,45},
	s_thermal_map_cap_offset_y_xywh = {100,630,380,45},
	s_thermal_map_t_offset_x_xywh = {760,570,380,45},
	s_thermal_map_t_offset_y_xywh = {760,630,380,45},
	s_thermal_map_cap_point_xywh = {100,690,380,45},
	s_thermal_map_tipinfo_xywh ={110,825,300,40},

};
w1_page_thermal_map.s_2k = 
{
	s_far_focus2_xywh = {1250,665,66,53},
	s_zoomin_xywh = {139,665,66,53},
	s_thermal_map_cap_point_xywh = {133,917,505,59},
	s_thermal_map_cap_channel_xywh = {133,39,505,59},
	s_thermal_map_image2_xywh = {1010,119,851,478},
	s_lock_focus2_xywh = {1383,651,399,79},
	s_thermal_map_tipinfo_xywh = {146,1097,399,53},
	s_lock_focus_xywh = {505,651,399,79},
	s_zoomout_xywh = {219,665,66,53},
	s_thermal_map_image_xywh = {133,119,851,478},
	s_thermal_map_cap_id_xywh = {133,758,505,59},
	s_thermal_map_t_point_xywh = {1010,917,505,59},
	s_zoomin2_xywh = {1017,665,66,53},
	s_thermal_map_cap_depth_xywh = {133,837,505,59},
	s_thermal_map_t_depth_xywh = {1013,837,467,59},
	s_thermal_map_t_depth_u_xywh = {1480,837,40,59},
	s_thermal_map_channel_xywh = {1010,39,505,59},
	s_zoomout2_xywh = {1097,665,66,53},
	s_far_focus_xywh = {379,665,66,53},
	s_near_focus2_xywh = {1177,665,66,53},
	s_thermal_map_t_id_xywh = {1010,758,505,59},
	s_thermal_map_cap_offset_x_xywh = {133,758,505,59},	
	s_thermal_map_t_offset_x_xywh = {1010,758,505,59},
	s_thermal_map_cap_offset_y_xywh = {133,837,505,59},	
	s_thermal_map_t_offset_y_xywh = {1013,837,505,59},
	s_near_focus_xywh = {299,665,66,53},
};
w1_page_thermal_map.s_4k = 
{
	s_thermal_map_cap_channel_xywh = {200,60,760,90},
	s_thermal_map_channel_xywh = {1520,60,760,90},
	s_thermal_map_image_xywh = {200,180,1280,720},
	s_thermal_map_image2_xywh = {1520,180,1280,720},
	s_zoomin_xywh = {210,1000,100,80},
	s_zoomout_xywh = {330,1000,100,80},
	s_near_focus_xywh = {450,1000,100,80},
	s_far_focus_xywh = {570,1000,100,80},
	s_lock_focus_xywh = {760,980,600,120},
	s_zoomin2_xywh = {1530,1000,100,80},
	s_zoomout2_xywh = {1650,1000,100,80},
	s_near_focus2_xywh = {1770,1000,100,80},
	s_far_focus2_xywh = {1880,1000,100,80},
	s_lock_focus2_xywh = {2080,980,600,120},
	s_thermal_map_t_id_xywh = {1520,1140,760,90},
	s_thermal_map_t_depth_xywh = {1520,1260,700,90},
	s_thermal_map_t_depth_u_xywh = {2220,1260,60,90},
	s_thermal_map_t_point_xywh = {1520,1380,760,90},
	s_thermal_map_cap_id_xywh = {200,1140,760,90},
	s_thermal_map_cap_depth_xywh = {200,1260,760,90},
	s_thermal_map_cap_offset_x_xywh = {200,1140,760,90},
	s_thermal_map_cap_offset_y_xywh = {200,1260,760,90},
	s_thermal_map_t_offset_x_xywh = {1520,1140,760,90},
	s_thermal_map_t_offset_y_xywh = {1520,1260,760,90},	
	s_thermal_map_cap_point_xywh = {200,1380,760,90},
	s_thermal_map_tipinfo_xywh ={220,1650,600,80},
};

local channel_num;--豸ͨĿ
local set_custom_layout = function(chid,nums)
	local param = {
		channs = {chid,w1_page_thermal_map.thermal_chn},
		num = nums,
		stream = true,				--
		point_1 = {},
		point_2 = {},
	}
	local layoutpos = w1_page_thermal_map.layoutpos;
	param.point_1.x = layoutpos.x;
	param.point_1.y = layoutpos.y;
	param.point_1.cx = layoutpos.cx;
	param.point_1.cy = layoutpos.cy;
	local  thermal_area2 = SIZE('s_thermal_map_image2_xywh')[1]-SIZE('s_thermal_map_image_xywh')[1]
	param.point_2.x = layoutpos.x + thermal_area2;
	param.point_2.y = layoutpos.y;
	param.point_2.cx = layoutpos.cx;
	param.point_2.cy = layoutpos.cy
	b_app_api.set_custom_multi_layout_wnd(param)
end

w1_page_thermal_map.clear_data = function()
	w1_page_thermal_map.data = nil;
end	
--reflsh_type 1-ʾͨ  2-ʾid 
local refresh_chdata = function(top, chid, redraw, reflsh_type)
	local chn = 'channel'..chid;
	local cwnd =w1_page_thermal_map.wnd
	local cur_data = w1_page_thermal_map.data['thermal_map'][chn];
	local cur_id = cur_data['current_id'] 
	w1_page_thermal_map.thermal_chn = cur_data['thermal_chn'];
	set_custom_layout(chid,2);
	if reflsh_type ~=1 then
		cur_id = b_wnd_ex.get_sel(top,cwnd.t_id.id)+1
	end
	local cur_depth = string.format("%4.2f", cur_data['post_map_rel'][tostring(cur_id)]['scene_depth'])
	local cur_offset_x = string.format("%4.2f", cur_data['post_map_rel'][tostring(cur_id)]['offset_x'])
	local cur_offset_y = string.format("%4.2f", cur_data['post_map_rel'][tostring(cur_id)]['offset_y'])
	local point_num = b_wnd_ex.get_sel(top,cwnd.t_point.id)
	local src_p1_x = cur_data['post_map_rel'][tostring(cur_id)]['region_src'][1]['x']
	local src_p1_y = cur_data['post_map_rel'][tostring(cur_id)]['region_src'][1]['y']
	local src_p2_x = cur_data['post_map_rel'][tostring(cur_id)]['region_src'][2]['x']
	local src_p2_y = cur_data['post_map_rel'][tostring(cur_id)]['region_src'][2]['y']
	local src_p3_x = cur_data['post_map_rel'][tostring(cur_id)]['region_src'][3]['x']
	local src_p3_y = cur_data['post_map_rel'][tostring(cur_id)]['region_src'][3]['y']
	local dst_p1_x = cur_data['post_map_rel'][tostring(cur_id)]['region_dst'][1]['x']
	local dst_p1_y = cur_data['post_map_rel'][tostring(cur_id)]['region_dst'][1]['y']
	local dst_p2_x = cur_data['post_map_rel'][tostring(cur_id)]['region_dst'][2]['x']
	local dst_p2_y = cur_data['post_map_rel'][tostring(cur_id)]['region_dst'][2]['y']
	local dst_p3_x = cur_data['post_map_rel'][tostring(cur_id)]['region_dst'][3]['x']
	local dst_p3_y = cur_data['post_map_rel'][tostring(cur_id)]['region_dst'][3]['y']
	b_wnd_ex.set_sel(top,cwnd.t_id.id,cur_id-1,redraw)
	b_wnd_ex.set_text(top,cwnd.t_depth.id,tostring(cur_depth),redraw)
	b_wnd_ex.set_text(top,cwnd.t_offset_x.id,tostring(cur_offset_x),redraw)
	b_wnd_ex.set_text(top,cwnd.t_offset_y.id,tostring(cur_offset_y),redraw)	
	b_wnd_ex.set_map_area(top,cwnd.image.id,{src_p1_x,src_p1_y,src_p2_x,src_p2_y,src_p3_x,src_p3_y,point_num+1},redraw)
	b_wnd_ex.set_map_area(top,cwnd.image2.id,{dst_p1_x,dst_p1_y,dst_p2_x,dst_p2_y,dst_p3_x,dst_p3_y,point_num+1},redraw)
	if cur_data.length_unit == 0 then
		b_wnd_ex.set_text(top,cwnd.t_depth_u.id,'m',false);
	else
		b_wnd_ex.set_text(top,cwnd.t_depth_u.id,'ft',false);
	end
end
local sethide =function(top, bool_hide, redraw)
	local cwnd = w1_page_thermal_map.wnd;
	local sid = cwnd.image.id;
	local eid = cwnd.t_point.id;
	
	for i=sid, eid do
		b_wnd_ex.set_hide(top, i, bool_hide, redraw)
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	w1_page_thermal_map.data = cfgdata;
	local cwnd = w1_page_thermal_map.wnd
	local camreaitems = {};
	local idx = 1;
	local privilege = global_val.get_allprivilege();--ȡȨ
	local ch_prilist = privilege.channel_manager_list;
	for i=1, channel_num do
		if(cfgdata['thermal_map']['channel'..i] ~= nil and ch_prilist[i] == 1) then
			camreaitems[idx] = i;
			idx = idx + 1;
		end
	end
	b_wnd_ex.set_items(top, cwnd.t_channel.id, camreaitems, false);
	if(idx ~= 1) then--˵ͨ
		b_wnd_ex.set_disable(top, cwnd.t_channel.id, false, false)
		sethide(top, false, false);
		b_wnd_ex.set_sel(top, cwnd.t_channel.id, 0, false);--Ĭϵһ
		local chid = tonumber(b_wnd_ex.get_text(top, cwnd.t_channel.id));
		refresh_chdata(top, chid, false,1)
	else--ͨ
		b_wnd_ex.set_disable(top, cwnd.t_channel.id, true, false)
		sethide(top, true, false);
	--[[	for i=1, channel_num do
			if(ch_prilist[i] ~= 0) then
				set_custom_layout(i);
				break;
			end
		end	--]]
	end
	
	b_wnd_ex.set_hide(top, cwnd.cap_id.id, true, false)
	b_wnd_ex.set_hide(top, cwnd.t_id.id, true, false)
	b_wnd_ex.set_hide(top, cwnd.cap_depth.id, true, false)
	b_wnd_ex.set_hide(top, cwnd.t_depth.id, true, false)

	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd=w1_page_thermal_map.wnd
	local map_data = cfgdata['thermal_map']
	local chid = b_wnd_ex.get_text(top,cwnd.t_channel.id)
	local chn = "channel"..chid
	local cur_id = b_wnd_ex.get_text(top,cwnd.t_id.id)
	local scene_dep = b_wnd_ex.get_text(top,cwnd.t_depth.id)
	local offset_x = b_wnd_ex.get_text(top,cwnd.t_offset_x.id)
	local offset_y = b_wnd_ex.get_text(top,cwnd.t_offset_y.id)	
	local point_num = b_wnd_ex.get_sel(top,cwnd.t_point.id)
	local point_src = b_wnd_ex.get_map_area(top,cwnd.image.id)
	local point_dst = b_wnd_ex.get_map_area(top,cwnd.image2.id)
	
	if(tonumber(offset_x) >= 100.00) then
		offset_x = "99.99";	
		b_wnd_ex.set_text(top,cwnd.t_offset_x.id, offset_x, true);
	elseif(tonumber(offset_x) <= -100.00) then
		offset_x = "-99.99";	
		b_wnd_ex.set_text(top,cwnd.t_offset_x.id, offset_x, true);
	end
	
	if(tonumber(offset_y) >= 100.00) then
		offset_y = "99.99";
		b_wnd_ex.set_text(top,cwnd.t_offset_y.id, offset_y, true);
	elseif(tonumber(offset_y) <= -100.00) then
		offset_y = "-99.99";
		b_wnd_ex.set_text(top,cwnd.t_offset_y.id, offset_y, true);
	end
	
	map_data[chn]['current_id']=tonumber(cur_id);
	map_data[chn]['post_map_rel'][cur_id]['scene_depth']= tonumber(scene_dep);
	map_data[chn]['post_map_rel'][cur_id]['offset_x']= tonumber(offset_x);
	map_data[chn]['post_map_rel'][cur_id]['offset_y']= tonumber(offset_y);
	map_data[chn]['post_map_rel'][cur_id]['region_src'][1]['x'] = point_src[1]
	map_data[chn]['post_map_rel'][cur_id]['region_src'][1]['y'] = point_src[2]
	map_data[chn]['post_map_rel'][cur_id]['region_src'][2]['x'] = point_src[3]
	map_data[chn]['post_map_rel'][cur_id]['region_src'][2]['y'] = point_src[4]
	map_data[chn]['post_map_rel'][cur_id]['region_src'][3]['x'] = point_src[5]
	map_data[chn]['post_map_rel'][cur_id]['region_src'][3]['y'] = point_src[6]

	map_data[chn]['post_map_rel'][cur_id]['region_dst'][1]['x'] = point_dst[1]
	map_data[chn]['post_map_rel'][cur_id]['region_dst'][1]['y'] = point_dst[2]
	map_data[chn]['post_map_rel'][cur_id]['region_dst'][2]['x'] = point_dst[3]
	map_data[chn]['post_map_rel'][cur_id]['region_dst'][2]['y'] = point_dst[4]
	map_data[chn]['post_map_rel'][cur_id]['region_dst'][3]['x'] = point_dst[5]
	map_data[chn]['post_map_rel'][cur_id]['region_dst'][3]['y'] = point_dst[6]
end


--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)	
	return true,nil
end

w1_page_thermal_map.timer_start = function()
	w1_page_thermal_map.timestart = true
end

w1_page_thermal_map.timer_stop = function(top)
	w1_page_thermal_map.timestart = false
	w1_wnd_util.tipclear(top, w1_page_thermal_map.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
	w1_wnd_util.tipdispoff();
end

w1_page_thermal_map.timerenevt = function(top)
	if(w1_page_thermal_map.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_thermal_map.wnd.tipinfo.id)
	end
	return 0
end

w1_page_thermal_map.init = function(top)
	w1_wnd_util.cfgtab = {'thermal_map'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	local chidstr = b_wnd_ex.get_text(top, w1_page_thermal_map.wnd.t_channel.id);
	if(chidstr == '') then
		return 0
	end
	local chid =tonumber(chidstr);
	w1_page_thermal_map.old_chid = chid;
	ptz_info.channel = 0;
	ptz_info.action  =0;
	ptz_info.mode =5;--
	ptz_info.speed = 6;
	ptz_info.index =1;--Ԥλ
	ptz_info.time =0;
	return 0
end

local on_channel= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local chid = tonumber(b_wnd_ex.get_text(top, w1_page_thermal_map.wnd.t_channel.id));
		refresh_chdata(top, chid, true,1)
		w1_page_thermal_map.old_chid = chid;
	end
	return 0;
end

local on_zoom_in = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		local chid = tonumber(b_wnd_ex.get_text(top, w1_page_thermal_map.wnd.t_channel.id));
		ptz_info.channel = chid;
		ptz_info.mode =5;
		ptz_info.action =12;
		b_app_api.set_ptz(ptz_info);
	end
	if(b_ui.LBUTTONCLK == vmsg)then
		local chid = tonumber(b_wnd_ex.get_text(top, w1_page_thermal_map.wnd.t_channel.id));
		ptz_info.channel = chid;
		ptz_info.mode =5;
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end 
	return 0
end

local on_zoom_out =function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		local chid = tonumber(b_wnd_ex.get_text(top, w1_page_thermal_map.wnd.t_channel.id));
		ptz_info.channel = chid;
		ptz_info.mode =4;
		ptz_info.action =12;
		b_app_api.set_ptz(ptz_info);
	end
	if b_ui.LBUTTONCLK == vmsg then
		local chid = tonumber(b_wnd_ex.get_text(top, w1_page_thermal_map.wnd.t_channel.id));
		ptz_info.channel = chid;
		ptz_info.mode =4;
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end
	return 0
end

local on_focus_near = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		local chid = tonumber(b_wnd_ex.get_text(top, w1_page_thermal_map.wnd.t_channel.id));
		ptz_info.channel = chid;
		ptz_info.mode =5;
		ptz_info.action =13;
		b_app_api.set_ptz(ptz_info);
	end
	if b_ui.LBUTTONCLK == vmsg then
		local chid = tonumber(b_wnd_ex.get_text(top, w1_page_thermal_map.wnd.t_channel.id));
		ptz_info.channel = chid;
		ptz_info.mode =5;
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end
	return 0
end

local on_focus_far = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		local chid = tonumber(b_wnd_ex.get_text(top, w1_page_thermal_map.wnd.t_channel.id));
		ptz_info.channel = chid;
		ptz_info.mode =4;
		ptz_info.action =13;
		b_app_api.set_ptz(ptz_info);
	end
	if b_ui.LBUTTONCLK == vmsg then
		local chid = tonumber(b_wnd_ex.get_text(top, w1_page_thermal_map.wnd.t_channel.id));
		ptz_info.channel = chid;
		ptz_info.mode =4;
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end
	return 0
end

local on_id= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local chid = tonumber(b_wnd_ex.get_text(top, w1_page_thermal_map.wnd.t_channel.id));
		refresh_chdata(top, chid, true,2)
		w1_page_thermal_map.old_chid = chid;
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_point= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local cwnd=w1_page_thermal_map.wnd
		local chid = tonumber(b_wnd_ex.get_text(top, w1_page_thermal_map.wnd.t_channel.id));
		local point_num = b_wnd_ex.get_sel(top,cwnd.t_point.id)
		b_wnd_ex.set_map_area(top,cwnd.image.id,{point_num+1},false)
		b_wnd_ex.set_map_area(top,cwnd.image2.id,{point_num+1},false)
		w1_page_thermal_map.old_chid = chid;
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_map_point = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_update_param = function(top, id, vmsg, x, y)
	if (vmsg == b_ui.WM_USER_UPDATE_PARAM) then
		uitousercfg(top,b_app_cfg.user_cfg);
	elseif (vmsg == b_ui.RBUTTONCLK) then
		return vmsg;
	end
	return 0;
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_thermal_map.apply =function(top)
	local ret = nil; 
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()
	end
	return ret
end

w1_page_thermal_map.on_pre_show = function(top)
	channel_num = global_val.get_channelnum();
	local cwnd = w1_page_thermal_map.wnd;
	local param = {
		x = SIZE('s_thermal_map_image_xywh')[1] + SIZE('s_cfg_page_xywh')[1], 
		y = SIZE('s_thermal_map_image_xywh')[2] + SIZE('s_cfg_page_xywh')[2],
		cx = SIZE('s_thermal_map_image_xywh')[3],
		cy = SIZE('s_thermal_map_image_xywh')[4],
	}
	local oldparam_x = param.x;
	param.x = math.floor((param.x + 2) / 4) * 4;--֤4ı
	param.cx = math.floor((param.cx + 2) / 4) *4;
	local oldparam_y = param.y;
	param.y = math.floor((param.y + 2) / 4) * 4;
	param.cy = math.floor((param.cy + 2) / 4) *4;
	
	w1_page_thermal_map.layoutpos.x = param.x;
	w1_page_thermal_map.layoutpos.cx = param.cx;
	w1_page_thermal_map.layoutpos.y = param.y;
	w1_page_thermal_map.layoutpos.cy = param.cy;
	
	local pos = {};
	pos[1] = SIZE('s_thermal_map_image_xywh')[1] + param.x - oldparam_x;
	pos[2] = SIZE('s_thermal_map_image_xywh')[2] + param.y - oldparam_y;
	pos[3] = param.cx;
	pos[4] = param.cy;
	b_wnd_ex.move_ex(top, cwnd.image.id, pos, false);
	
	local  thermal_area2 = SIZE('s_thermal_map_image2_xywh')[1]-SIZE('s_thermal_map_image_xywh')[1]
	pos[1] = pos[1]+thermal_area2;
	b_wnd_ex.move_ex(top, cwnd.image2.id, pos, false);
	local negative_num_atrr = {true, 5, 3};
	b_wnd_ex.set_negative_num_atrr(top, cwnd.t_depth.id, negative_num_atrr, false);
	b_wnd_ex.set_negative_num_atrr(top, cwnd.t_offset_x.id, negative_num_atrr, false);
	b_wnd_ex.set_negative_num_atrr(top, cwnd.t_offset_y.id, negative_num_atrr, false);
	
	return 0;
end

w1_page_thermal_map.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {	'image', 'image2','zoomin','zoomout','near_focus','far_focus',
			'cap_channel', 't_channel','cap_id','t_id','cap_depth','t_depth','t_depth_u','cap_offset_x','t_offset_x','cap_offset_y','t_offset_y','cap_point','t_point',
			'tipinfo', 'default', 'apply'},
	
	cap_channel	= {t='static',	id=id+1,	xywh='s_thermal_map_cap_channel_xywh',		text='LA_CHANNEL'},
	t_channel 	= {t='combox',	id=id+2,	xywh='s_thermal_map_channel_xywh',		items={'1','2','3','4','5','6','7','8'},trans = false,channel_cbox = true,cmd = on_channel},
	
	image = {t='map_point',id=id+3,xywh='s_thermal_map_image_xywh',text='Image widget', 
				cmd = on_update_param},
				
	image2 = {t='map_point',id=id+4,xywh='s_thermal_map_image2_xywh',text='Image widget', 
				cmd = on_update_param	},
	
	zoomin 	= {t='tt_button',id=id+5,xywh='s_zoomin_xywh',text='LA_ZOOM_IN',draw_text=0, align = b_ui.ALIGN.LEFT, 
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_zoomin','it_zoomin', 'it_zoomin'},cmd = on_zoom_in
				},	
				
	zoomout 	= {t='tt_button',id=id+6,xywh='s_zoomout_xywh',text='LA_ZOOM_OUT', draw_text=0,align = b_ui.ALIGN.LEFT,
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_zoomout','it_zoomout', 'it_zoomout'},cmd = on_zoom_out
				},	
	near_focus 	= {t='tt_button',id=id+7,xywh='s_near_focus_xywh',text='LA_NEAR_FOCUS', draw_text=0,align = b_ui.ALIGN.LEFT,
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_focusnear','it_focusnear', 'it_focusnear'},cmd = on_focus_near
				},	
	far_focus 	= {t='tt_button',id=id+8,xywh='s_far_focus_xywh',text='LA_FAR_FOCUS', draw_text=0, align = b_ui.ALIGN.LEFT, 
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_focusfar','it_focusfar', 'it_focusfar'},cmd = on_focus_far
				},	
	lock_focus 	= {t='checkbox', id=id+13,	xywh='s_lock_focus_xywh',text='LA_LOCK_MAP_POINT', check = false,	color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_static_text'},},	

	zoomin2 	= {t='tt_button',id=id+9,xywh='s_zoomin2_xywh',text='LA_ZOOM_IN', draw_text=0,align = b_ui.ALIGN.LEFT, 
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_zoomin','it_zoomin', 'it_zoomin'},
				},	
	zoomout2 	= {t='tt_button',id=id+10,xywh='s_zoomout2_xywh',text='LA_ZOOM_OUT', draw_text=0,align = b_ui.ALIGN.LEFT,
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_zoomout','it_zoomout', 'it_zoomout'},
				},	
	near_focus2 = {t='tt_button',id=id+11,xywh='s_near_focus2_xywh',text='LA_NEAR_FOCUS',draw_text=0, align = b_ui.ALIGN.LEFT,
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_focusnear','it_focusnear', 'it_focusnear'},
				},	
	far_focus2 	= {t='tt_button',id=id+12,xywh='s_far_focus2_xywh',text='LA_FAR_FOCUS',draw_text=0, align = b_ui.ALIGN.LEFT,
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_d= { 'c_btn_n', 'c_btn_n', 'c_txt_d'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_focusfar','it_focusfar', 'it_focusfar'},
				},	
	lock_focus2 = {t='checkbox', id=id+14,	xywh='s_lock_focus2_xywh',text='LA_LOCK_MAP_POINT', check = false,	color = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_static_text'},},	
	
	cap_id		= {t='static',id=id+15,xywh='s_thermal_map_cap_id_xywh',text='LA_ID'},
	t_id 		= {t='combox',id=id+16,xywh='s_thermal_map_t_id_xywh',items={'1','2','3','4','5','6','7','8'},trans=false,cmd = on_id},	
	
	cap_depth	= {t='static',id=id+17,xywh='s_thermal_map_cap_depth_xywh',text='LA_SCENE_DEPTH_NO_UNIT',},
	t_depth		= {t='edit_num',id=id+18,xywh='s_thermal_map_t_depth_xywh',range={-9999, 99999},cmd = on_update_param},
	t_depth_u	= {t='static',id=id+19,xywh='s_thermal_map_t_depth_u_xywh',text='',trans = false,align = b_ui.ALIGN.CENTER},
	
	cap_offset_x		= {t='static',id=id+20,xywh='s_thermal_map_cap_offset_x_xywh',text='LA_HORIZONTAL_SHIFT'},
	t_offset_x		= {t='edit_num',id=id+21,xywh='s_thermal_map_t_offset_x_xywh',range={-100, 100},cmd = on_update_param},
		
	
	cap_offset_y	= {t='static',id=id+22,xywh='s_thermal_map_cap_offset_y_xywh',text='LA_VERTICAL_SHIFT',},
	t_offset_y		= {t='edit_num',id=id+23,xywh='s_thermal_map_t_offset_y_xywh',range={-100, 100},cmd = on_update_param},
	
	cap_point	= {t='static',id=id+24,xywh='s_thermal_map_cap_point_xywh',text='LA_MAP_POINT'},
	t_point		= {t='combox',id=id+25,xywh='s_thermal_map_t_point_xywh',items={'LA_POINT_ONE','LA_POINT_TWO','LA_POINT_THREE'},cmd = on_point},	

	tipinfo		= {t='static',	id=id+26,	xywh='s_thermal_map_tipinfo_xywh',		text='',		trans = false},	
	apply 		= {t='button',	id=id+27,	xywh= 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_thermal_map

