--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_basic.time_id
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_wnd		= require("wnd.core.b_wnd")
local b_ui_msg	= require("wnd.w1_util.w1_ui_msg") 
local r_size	= require("wnd.core.r_res.r_size")
local util 		= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local SIZE 		= r_size.get_size
local b_dlg 	= require("wnd.core.b_dlg")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str

local w1_page_time = 
{
	data,
	timestart = false,
	update_time =true,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_time.s_768 =
{
	s_time_t_synctime_xywh = {277,110,25,21},
	s_time_info_xywh = {53,369,453,35},
	s_time_info2_xywh = {53,405,453,35},
	s_time_tipinfo_xywh = {53,440,373,35},
};

w1_page_time.s_1280 = 
{
	
	s_time_t_synctime_xywh = {450,156,48,30},
	s_time_info_xywh = {100,520,850,50},
	s_time_info2_xywh = {100,570,850,50},
	s_time_tipinfo_xywh = {100,620,700,50},
}
w1_page_time.s_1440 = 
{

	s_time_t_synctime_xywh = {520,130,48,30},
	s_time_info_xywh = {100,520,850,50},
	s_time_info2_xywh = {100,570,850,50},
	s_time_tipinfo_xywh = {100,620,700,50},

}

w1_page_time.s_1080p = 
{

	s_time_t_synctime_xywh = {520,156,48,30},
	s_time_info_xywh = {100,520,850,50},
	s_time_info2_xywh = {100,570,850,50},
	s_time_tipinfo_xywh = {100,620,700,50},

}

w1_page_time.s_2k = 
{

	s_time_t_synctime_xywh = {693,208,64,40},
	s_time_info_xywh = {133,693,1133,67},
	s_time_info2_xywh = {133,763,1133,67},
	s_time_tipinfo_xywh = {133,827,933,67},

}

w1_page_time.s_4k = 
{

	s_time_t_synctime_xywh = {1040,312,96,60},
	s_time_info_xywh = {200,1040,1700,100},
	s_time_info2_xywh = {200,1140,1700,100},
	s_time_tipinfo_xywh = {200,1240,1400,100},

}

w1_page_time.clear_data = function()
	w1_page_time.data = nil;
end	

local refresh_datefmt = function(top, date_fmt, redraw)
	local cwnd = w1_page_time.wnd
	local data = w1_page_time.data.time
	local date = {}
	assert(date_fmt >=0 and date_fmt <=6);
	local cur_date = b_wnd_ex.get_date(top, cwnd.t_date.id)
	
	date[1] = date_fmt;
	date[2] = cur_date.year;
	date[3] = cur_date.month
	date[4] = cur_date.day
	b_wnd_ex.set_date (top, cwnd.t_date.id, date, redraw)
end

local refresh_timefmt = function(top, time_fmt, redraw)
	local cwnd = w1_page_time.wnd
	local data = w1_page_time.data.time
	local time = {}
	local cur_time = b_wnd_ex.get_time(top, cwnd.t_time.id)
	
	if(time_fmt == false) then	--12Сʱ
		local apm = cur_time.hour - 12;
		if(apm >= 0) then	--磨12:00--24:00
			time[1] =  b_ui.TIME.TIME_12PM
			if(apm == 0) then
				apm = 12;
			end
			time[2] = apm;
			time[3] = cur_time.minute;
			time[4] = cur_time.second;
		else--磨0:00--12:00
			time[1] =  b_ui.TIME.TIME_12AM
			if(cur_time.hour == 0) then
				time[2] = 12;
			else
				time[2] = cur_time.hour;
			end
			time[3] = cur_time.minute;
			time[4] = cur_time.second;
		end
		
	else --24Сʱ
		time[1] =  b_ui.TIME.TIME_24
		if(cur_time.format == b_ui.TIME.TIME_12PM) then
			if(cur_time.hour == 12) then
				time[2] = cur_time.hour;		
			else
				time[2] = cur_time.hour + 12;		
			end	
		elseif(cur_time.format == b_ui.TIME.TIME_12AM) then
			if(cur_time.hour == 12) then
				time[2] = 0;
			else
				time[2] = cur_time.hour;
			end
		end
		time[3] = cur_time.minute;
		time[4] = cur_time.second;
	end
	b_wnd_ex.set_time(top, cwnd.t_time.id, time, redraw)
end

local refresh_synctime = function(top, synctime, redraw)
	local cwnd = w1_page_time.wnd;
	if(synctime) then
		b_wnd_ex.set_disable(top, cwnd.t_date.id, true, false);
		b_wnd_ex.set_disable(top, cwnd.t_time.id, true, false);
		b_wnd_ex.set_disable(top, cwnd.moditime.id, true, false);
		
		b_wnd_ex.set_hide (top, cwnd.c_ntp.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_ntp.id, false, false);
		local param1 = SIZE('s_cfg_page_4_1');
		local param2 = SIZE('s_cfg_page_4_2');
		b_wnd_ex.move_ex(top,  cwnd.c_ntp.id,param1, false)
		b_wnd_ex.move_ex(top,  cwnd.t_ntp.id,param2, false)
		
		b_wnd_ex.set_hide (top, cwnd.c_waittime.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_waittime.id, false, false);	
		param1 = SIZE('s_cfg_page_5_1');
		param2 = SIZE('s_cfg_page_5_2');
		b_wnd_ex.move_ex(top,  cwnd.c_waittime.id,param1, false)
		b_wnd_ex.move_ex(top,  cwnd.t_waittime.id,param2, false)	
		param1 = SIZE('s_cfg_page_6_1');
		param2 = SIZE('s_cfg_page_6_2');
		b_wnd_ex.move_ex(top,  cwnd.c_date.id,param1, false)
		b_wnd_ex.move_ex(top,  cwnd.t_date.id,param2, false)
		param1 = SIZE('s_cfg_page_7_1');
		param2 = SIZE('s_cfg_page_7_2');
		b_wnd_ex.move_ex(top,  cwnd.c_time.id,param1, false)
		b_wnd_ex.move_ex(top,  cwnd.t_time.id,param2, false)
		param2 = SIZE('s_cfg_page_8_2');
		b_wnd_ex.move_ex(top,  cwnd.moditime.id,param2, false)
	else
		b_wnd_ex.set_disable(top, cwnd.t_date.id, false, false);
		b_wnd_ex.set_disable(top, cwnd.t_time.id, false, false);
		b_wnd_ex.set_disable(top, cwnd.moditime.id, false, false);
		
		
		b_wnd_ex.set_hide (top, cwnd.c_ntp.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_ntp.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.c_waittime.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_waittime.id, true, false);	
		
		local param1 = SIZE('s_cfg_page_4_1');
		local param2 = SIZE('s_cfg_page_4_2');
		b_wnd_ex.move_ex(top,  cwnd.c_date.id,param1, false)
		b_wnd_ex.move_ex(top,  cwnd.t_date.id,param2, false)
		param1 = SIZE('s_cfg_page_5_1');
		param2 = SIZE('s_cfg_page_5_2');
		b_wnd_ex.move_ex(top,  cwnd.c_time.id,param1, false)
		b_wnd_ex.move_ex(top,  cwnd.t_time.id,param2, false)
		param2 = SIZE('s_cfg_page_6_2');
		b_wnd_ex.move_ex(top,  cwnd.moditime.id,param2, false)
	end
	if true == redraw then
		b_dlg.dlg_set_redraw(top);
	end
end

local refresh_time = function(top, redraw)
	local cwnd = w1_page_time.wnd
	local data = w1_page_time.data.time
	local date = {}
	local time = os.time()

	date[1] = data.date_fmt
	date[2] = tonumber(os.date("%Y", time))
	date[3] = tonumber(os.date("%m", time))
	date[4] = tonumber(os.date("%d", time))
	b_wnd_ex.set_date (top, cwnd.t_date.id, date, false)
	
	local disptime = {}
	disptime[2] = tonumber(os.date("%H", time))
	disptime[3] = math.floor((time % 3600) / 60)
	disptime[4] = math.floor(time % 60)
	
	if(1 == data.time_fmt) then
		disptime[1] = b_ui.TIME.TIME_24
	else
		if(disptime[2] == 12) then --12
			disptime[1] = b_ui.TIME.TIME_12PM
			disptime[2] = disptime[2]
		elseif(disptime[2] >= 13 and disptime[2] <= 23) then
			disptime[1] = b_ui.TIME.TIME_12PM
			disptime[2] = disptime[2] - 12
		elseif (disptime[2] == 24) then --/24㼴12㣬12Сʱ0ʾʽ
			disptime[1] = b_ui.TIME.TIME_12AM
			disptime[2] = 12
		else
			disptime[1] = b_ui.TIME.TIME_12AM
			if(disptime[2] == 0)then 
				disptime[2] = 12
			else
				disptime[2] = disptime[2]
			end
		end
	end
	
	b_wnd_ex.set_time(top, cwnd.t_time.id, disptime, false)
	if true == redraw then
		b_dlg.dlg_set_redraw(top)
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local set_check = function(winid, check)
		b_wnd_ex.set_check(top, winid, check, false)
	end
	local cwnd = w1_page_time.wnd
	local data = cfgdata.time
	
	w1_page_time.data = cfgdata;

	b_wnd_ex.set_sel(top, cwnd.t_datefmt.id, data.date_fmt, false)

	local h24 = data.time_fmt;
	if(1 == h24) then
		b_wnd_ex.set_sel(top, cwnd.t_time24h.id,1,false);
	else
		b_wnd_ex.set_sel(top, cwnd.t_time24h.id,0,false);
	end

	if(1 == data.sync_time) then
		set_check(cwnd.t_synctime.id, true);
		refresh_synctime(top, true, false);
	else
		set_check(cwnd.t_synctime.id, false);
		refresh_synctime(top, false, false);
	end

	b_wnd_ex.set_text(top, cwnd.t_ntp.id, data.ntp_addr, false);
	if(data.waittime <10)then
		data.waittime=10;
	end
--	b_wnd_ex.set_value(top, cwnd.t_waittime.id, data.waittime, false)
	local waittime = tostring(data.waittime)
	b_wnd_ex.set_text(top, cwnd.t_waittime.id,waittime, false);
	refresh_time(top, false);
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_time.wnd
	local data = cfgdata.time
	
	local date_fmt = b_wnd_ex.get_sel(top, cwnd.t_datefmt.id)
	data.date_fmt = date_fmt
	
	local h24 = b_wnd_ex.get_sel(top, cwnd.t_time24h.id)
	if(1 == h24) then
		data.time_fmt = 1
	else
		data.time_fmt = 0
	end
	
	local sync_time = b_wnd_ex.get_check(top, cwnd.t_synctime.id)
	if(true == sync_time) then
		data.sync_time = 1
	else
		data.sync_time = 0
	end
	
	local ntp_addr = b_wnd_ex.get_text(top, cwnd.t_ntp.id)
	data.ntp_addr = ntp_addr
	
--	data.waittime  = b_wnd_ex.get_value(top, cwnd.t_waittime.id);
	local waittime = b_wnd_ex.get_text(top, cwnd.t_waittime.id);
	data.waittime = tonumber(waittime);
	local time = 0
	data.time = time
	return 0
end

local settime = function(top, cfgdata)
	local cwnd = w1_page_time.wnd

	local sync_time = b_wnd_ex.get_check(top, cwnd.t_synctime.id)
	if(true == sync_time) then
		cfgdata['time']['sync_time'] = 1
	else
		cfgdata['time']['sync_time'] = 0
	end
	
	local cur_date = b_wnd_ex.get_date(top, cwnd.t_date.id)
	local cur_time = b_wnd_ex.get_time(top, cwnd.t_time.id)


	if(cur_time.format == b_ui.TIME.TIME_12PM) then
		if(cur_time.hour <= 11)then
			cur_time.hour = cur_time.hour + 12
		end
	elseif(cur_time.format == b_ui.TIME.TIME_12AM) then
		if(cur_time.hour == 12)then
			cur_time.hour = cur_time.hour - 12
		end
	end
	local time = os.time{year=cur_date.year, month=cur_date.month, day=cur_date.day, hour=cur_time.hour, min=cur_time.minute, sec=cur_time.second}
	cfgdata['time']['time'] = time
	
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	local cwnd = w1_page_time.wnd

	local ntp_addr = b_wnd_ex.get_text(top, cwnd.t_ntp.id)
	if(name == '' ) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_ntp.id)
	end
	
	local waittime = b_wnd_ex.get_text(top, cwnd.t_waittime.id);
	local p = select(2,string.gsub(waittime,"[.]",""));
	if(p ~= 0)then 
		legalflag =false
		table.insert(nlegalid, cwnd.t_waittime.id)
		w1_wnd_util.setparamerr_str(STR('LA_PARAM_INVALID'));
		return legalflag, nlegalid
	end
		
	if(tonumber(waittime) < 10 or tonumber(waittime) > 31536000)then
		legalflag =false
		table.insert(nlegalid, cwnd.t_waittime.id)
	--	b_wnd_ex.set_text(top, cwnd.t_waittime.id,"10", false);
	end

	local date_fmt = b_wnd_ex.get_sel(top, cwnd.t_datefmt.id)	
	local h24 = b_wnd_ex.get_sel(top, cwnd.t_time24h.id)
	local sync_time = b_wnd_ex.get_check(top, cwnd.t_synctime.id)
	
	if(legalflag) then
		return legalflag, nil
	else
		w1_wnd_util.setparamerr_str("[10 ~ 31536000]");
		return legalflag, nlegalid
	end
end

w1_page_time.timer_start = function()
	w1_page_time.timestart = true
end

w1_page_time.timer_stop = function(top)
	w1_page_time.timestart = false
	w1_wnd_util.tipclear(top, w1_page_time.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_time.timerenevt = function(top)
	if(w1_page_time.timestart) then
		if(w1_page_time.update_time)then
			refresh_time(top, true)
		end
		w1_wnd_util.timerenevt(top, w1_page_time.wnd.tipinfo.id)
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_time.init = function(top)
	w1_wnd_util.cfgtab = {'time'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	w1_page_time.update_time =true;
	return 0
end

local on_datefmt= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local datefmt = b_wnd_ex.get_sel(top, win_id);
		refresh_datefmt(top, datefmt, true);
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_synctime= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.LBUTTONCLK) then
		local synctime = b_wnd_ex.get_check(top, win_id);
		refresh_synctime(top, synctime, true);
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_time24h = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local h24 = b_wnd_ex.get_sel(top, win_id)
		local  is_24 = true;
		if (h24 == 0) then
			is_24 = false;
		end
		refresh_timefmt(top, is_24, true);
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_ntp = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.WM_USER_UPDATE_PARAM) then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_waittime = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.WM_USER_UPDATE_PARAM)then
		local cwnd = w1_page_time.wnd
		local waittime = b_wnd_ex.get_text(top, cwnd.t_waittime.id); --˴ؼΪδλs

		if(waittime ~= "")then
			if(tonumber(waittime) < 10)then
				b_wnd_ex.set_text(top, cwnd.t_waittime.id,"10", false);
			elseif(tonumber(waittime) > 31536000) then
				b_wnd_ex.set_text(top, cwnd.t_waittime.id,"31536000", false);
			else
				b_wnd_ex.set_text(top, cwnd.t_waittime.id,waittime , false); 
			end
		else
			b_wnd_ex.set_text(top, cwnd.t_waittime.id,"10", false);
		end
		
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

--UIָĬֵ
local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_page_time.update_time =true;
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_moditime = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		settime(top,b_app_cfg.user_cfg);
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
		w1_page_time.update_time =true;
	end
	return 0
end

local on_date = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_page_time.update_time =false;
	elseif (vmsg == b_ui.WM_USER_UPDATE_PARAM) then
		w1_page_time.update_time =false;
	--	settime(top,b_app_cfg.user_cfg)
	--	uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_time = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_time_update) then
		w1_page_time.update_time =false;
	--	settime(top,b_app_cfg.user_cfg)
	--	uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

w1_page_time.apply =function(top)
	local ret = nil;
	w1_page_time.update_time =true;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	uitousercfg(top,b_app_cfg.user_cfg);
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end
w1_page_time.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = { 'c_datefmt', 't_datefmt', 'c_time24h', 't_time24h', 
			'c_synctime', 't_synctime', 'c_ntp', 't_ntp', 'c_waittime','t_waittime', 
			'c_date', 't_date',	'c_time','t_time','moditime','info','info2', 'tipinfo', 'default', 'apply'},
			
	c_datefmt 	= {t='static',	id=id+1,	xywh='s_cfg_page_1_1',	text='LA_DATE_FORMAT'},
	t_datefmt 	= { t='combox',	id=id+2,	xywh='s_cfg_page_1_2',
					items={'YY/MM/DD hh:mm:ss','hh:mm:ss YY/MM/DD','MM/DD/YY hh:mm:ss','hh:mm:ss MM/DD/YY','DD/MM/YY hh:mm:ss','hh:mm:ss DD/MM/YY'},trans = false,
					cmd = on_datefmt},
	
	c_time24h 	= {t='static',	id=id+3,	xywh='s_cfg_page_2_1',	text='LA_TIME_FORMAT'},
	t_time24h 	= {t='combox',id=id+4,	xywh='s_cfg_page_2_2', items={'12H','24H'},
					trans = false, cmd = on_time24h},

	c_synctime 	= {t='static',	id=id+5,	xywh='s_cfg_page_3_1',text='LA_SYNC_TIME'},
	t_synctime	= {t='tt_check',id=id+6,	xywh='s_time_t_synctime_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					check = true, cmd = on_synctime},
	
	c_ntp 		= {t='static',	id=id+7,	xywh='s_cfg_page_4_1',	text='LA_NTP_IP'},
	t_ntp 		= {t='combox_in',id=id+8,	xywh='s_cfg_page_4_2',	items={'time.windows.com','1.centos.pool.ntp.org','time.nist.gov'},trans = false,cmd =on_ntp},	
	
	c_waittime 	= {t='static',	id=id+9,	xywh='s_cfg_page_5_1',text='LA_SCHOOL_TIME'},
	t_waittime 	= {t='edit',  id=id+10,	xywh='s_cfg_page_5_2',edit_num_str =1, cmd = on_waittime},--range ={0,2147483646},
	
	c_date 		= {t='static',	id=id+11,	xywh='s_cfg_page_6_1',	text='LA_CUR_DATE'},
	t_date 		= {t='date_edit',id=id+12,	xywh='s_cfg_page_6_2',	date={0,2018,4,4, true},trans = false, cmd=on_date},	
	
	c_time 		= {t='static',	id=id+13,	xywh='s_cfg_page_7_1',	text='LA_CUR_TIME'},
	t_time 		= {t='time_edit',id=id+14,	xywh='s_cfg_page_7_2',	time = {b_ui.TIME.TIME_24,12,56,04},trans = false,cmd=on_time},	
	
	moditime	= {t='button',	id=id+15,	xywh='s_cfg_page_8_2',	text='LA_UPDATE_TIME',cmd=on_moditime},

	info		= {t='static',	id=id+16,	xywh='s_time_info_xywh',	text='LA_TIME_TIP'},
	
	info2		= {t='static',	id=id+17,	xywh='s_time_info2_xywh',	text='LA_TIME_TIP_S'},

	tipinfo		= {t='static',	id=id+18,	xywh='s_time_tipinfo_xywh',	text='',trans = false},

	apply 		= {t='button',	id=id+19,	xywh='s_cfg_apply_xywh', 		text='LA_APPLY',cmd=on_apply},

}

return w1_page_time







