--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 	= require("wnd.core.b_ui")
local w1_id = require("wnd.w1_util.w1_id")
local b_dlg 	= require("wnd.core.b_dlg")
local id 	= w1_id.cfg_upnp.upnp_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local b_app_cfg  = require("wnd.core.b_app_cfg")

local w1_page_upnp = 
{
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_upnp.s_768 =
{
	s_upnp_switch_t_xywh = {277,25,25,21},
	s_upnp_info1_xywh = {53,277,480,35},
	s_upnp_tipinfo_xywh = {53,312,373,35},
};

w1_page_upnp.s_1280 = 
{
	s_upnp_switch_t_xywh = {455,36,48,30},
	s_upnp_info1_xywh = {100,390,820,50},
	s_upnp_tipinfo_xywh = {100,440,700,50},
}

w1_page_upnp.s_1440 = 
{
	s_upnp_switch_t_xywh = {520,30,48,30},
	s_upnp_info1_xywh = {100,390,900,50},
	s_upnp_tipinfo_xywh = {100,440,700,50},
}

w1_page_upnp.s_1080p = 
{
	s_upnp_switch_t_xywh = {520,36,48,30},
	s_upnp_info1_xywh = {100,390,900,50},
	s_upnp_tipinfo_xywh = {100,440,700,50},
}

w1_page_upnp.s_2k = 
{

	s_upnp_switch_t_xywh = {693,48,64,40},
	s_upnp_info1_xywh = {133,520,1200,67},
	s_upnp_tipinfo_xywh = {133,587,933,67},
}

w1_page_upnp.s_4k = 
{
	s_upnp_switch_t_xywh = {1040,72,96,60},
	s_upnp_info1_xywh = {200,780,1800,100},
	s_upnp_tipinfo_xywh = {200,880,1400,100},
}

local redraw =false;

local refresh_enable = function(top, disable, redraw)
	local cwnd = w1_page_upnp.wnd
	local status  = nil;
	if (0 == disable) then
		status = false;
	else
		status = true;	
	end
	b_wnd_ex.set_disable(top, cwnd.t_http.id, status, false)
	b_wnd_ex.set_disable(top, cwnd.t_https.id, status, false)
	b_wnd_ex.set_disable(top, cwnd.t_port1.id, status, false)
	b_wnd_ex.set_disable(top, cwnd.t_port2.id, status, false)
	if true == redraw then
		b_dlg.dlg_set_redraw(top);
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local cwnd = w1_page_upnp.wnd
	local data = cfgdata.upnp;
	local upnp_type ={}
	table.insert(upnp_type,STR('LA_MANUAL'))
	table.insert(upnp_type,STR('LA_AUTO'))
	b_wnd_ex.set_items(top, cwnd.t_enable.id, upnp_type, redraw);
	local function setvalue(id, value)
		b_wnd_ex.set_value(top, id, value, redraw)
	end
	local function setcheck(id, str)
		b_wnd_ex.set_check(top, id, str,redraw)
	end
	b_wnd_ex.set_check(top, cwnd.upnp_t_switch.id, data.enable,redraw)
	local sel = nil;
	if (0 == data.upnp_type) then
		sel = 1;
	else
		sel = 0;
	end		
	b_wnd_ex.set_sel(top, cwnd.t_enable.id, sel,redraw)
	setvalue(cwnd.t_http.id, data.http_port);
	setvalue(cwnd.t_https.id, data.https_port);
	setvalue(cwnd.t_port1.id, data.data_port);
	setvalue(cwnd.t_port2.id, data.jy_data_port);
	refresh_enable(top, sel, false)
	
	if(data.enable == true) then
		b_wnd_ex.set_hide(top, cwnd.cap_upnp.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.t_enable.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.cap_http.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.t_http.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.cap_https.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.t_https.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.cap_port1.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.t_port1.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.cap_port2.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.t_port2.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.info1.id, false, false);
	else
		b_wnd_ex.set_hide(top, cwnd.cap_upnp.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_enable.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.cap_http.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_http.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.cap_https.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_https.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.cap_port1.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_port1.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.cap_port2.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_port2.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.info1.id, true, false);
	end
	redraw =false;
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_upnp.wnd
	local data = cfgdata.upnp;
	data.enable = b_wnd_ex.get_check(top, cwnd.upnp_t_switch.id)
	local sel = b_wnd_ex.get_sel(top, cwnd.t_enable.id);
	if (0 == sel) then
		data.upnp_type = 1;
	else
		data.upnp_type = 0;	
	end
	local http_port = b_wnd_ex.get_value(top, cwnd.t_http.id);
	data.http_port =http_port
	local https_port = b_wnd_ex.get_value(top, cwnd.t_https.id);
	data.https_port =https_port
	local port1 = b_wnd_ex.get_value(top, cwnd.t_port1.id);
	data.data_port =port1
	local port2 = b_wnd_ex.get_value(top, cwnd.t_port2.id);
	data.jy_data_port =port2
	return 0
end

local on_enable = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local cwnd = w1_page_upnp.wnd
		local flag = b_wnd_ex.get_sel(top, cwnd.t_enable.id)
		refresh_enable(top, flag, true)
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0
end

local on_switch_upnp = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local cwnd = w1_page_upnp.wnd
		local flag = b_wnd_ex.get_check(top, cwnd.upnp_t_switch.id)
		if(flag == true) then
			b_wnd_ex.set_hide(top, cwnd.cap_upnp.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.t_enable.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.cap_http.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.t_http.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.cap_https.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.t_https.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.cap_port1.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.t_port1.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.cap_port2.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.t_port2.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.info1.id, false, false);
		else
			b_wnd_ex.set_hide(top, cwnd.cap_upnp.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.t_enable.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.cap_http.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.t_http.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.cap_https.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.t_https.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.cap_port1.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.t_port1.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.cap_port2.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.t_port2.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.info1.id, true, false);
		end
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top)
	end
	return 0
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	local cwnd = w1_page_upnp.wnd
	
	local enable = b_wnd_ex.get_check(top, cwnd.upnp_t_switch.id)
	if (false == enable)then --رUPNPж
		return true, nil
	end	
	
	local flag = b_wnd_ex.get_sel(top, cwnd.t_enable.id)
	if(flag ==1)then --UPnP򲻶Զ˿ںϷԽм
		return true, nil
	end

	local legal, num;
	legal, num = w1_legal.check_port2(top, cwnd.t_port2.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_port2.id)	
		if(num == w1_legal.port.OUT_RANGE) then
			w1_wnd_util.setparamerr_str(STR('LA_PORT_RANGE2'))
		elseif(num == w1_legal.port.SPECIAL) then
			w1_wnd_util.setparamerr_str(STR('LA_SPECIAL_PORT'))
		end
	end
	legal, num = w1_legal.check_port2(top, cwnd.t_port1.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_port1.id)	
		if(num == w1_legal.port.OUT_RANGE) then
			w1_wnd_util.setparamerr_str(STR('LA_PORT_RANGE2'))
		elseif(num == w1_legal.port.SPECIAL) then
			w1_wnd_util.setparamerr_str(STR('LA_SPECIAL_PORT'))
		end
	end
	legal, num = w1_legal.check_port2(top, cwnd.t_http.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_http.id)	
		if(num == w1_legal.port.OUT_RANGE) then
			w1_wnd_util.setparamerr_str(STR('LA_PORT_RANGE2'))
		elseif(num == w1_legal.port.SPECIAL) then
			w1_wnd_util.setparamerr_str(STR('LA_SPECIAL_PORT'))
		end
	end
	
	legal, num = w1_legal.check_port2(top, cwnd.t_https.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_https.id)	
		if(num == w1_legal.port.OUT_RANGE) then
			w1_wnd_util.setparamerr_str(STR('LA_PORT_RANGE2'))
		elseif(num == w1_legal.port.SPECIAL) then
			w1_wnd_util.setparamerr_str(STR('LA_SPECIAL_PORT'))
		end
	end
	
	if(legalflag) then	
		local httpport =  b_wnd_ex.get_value(top, cwnd.t_http.id)
		local httpsport =  b_wnd_ex.get_value(top, cwnd.t_https.id)
		local data1port =  b_wnd_ex.get_value(top, cwnd.t_port1.id)
		local data2port =  b_wnd_ex.get_value(top, cwnd.t_port2.id)

		if(httpport == httpsport ) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_http.id)	
			table.insert(nlegalid, cwnd.t_https.id)	
		elseif(httpport == data1port ) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_http.id)	
			table.insert(nlegalid, cwnd.t_port1.id)	
		elseif(httpport == data2port) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_http.id)	
			table.insert(nlegalid, cwnd.t_port2.id)
		elseif(httpsport == data1port ) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_https.id)	
			table.insert(nlegalid, cwnd.t_port1.id)	
		elseif(httpsport == data2port) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_https.id)	
			table.insert(nlegalid, cwnd.t_port2.id)	
		elseif(data1port == data2port) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_port1.id)	
			table.insert(nlegalid, cwnd.t_port2.id)	
		end
	
		if(legalflag == false) then
			w1_wnd_util.setparamerr_str(STR('LA_PORT_SAME'))
		end
	end
	
	if(legalflag) then
		return legalflag, nil
	else
		return legalflag, nlegalid
	end
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_page_upnp.timer_start = function()
	w1_page_upnp.timestart = true
end

w1_page_upnp.timer_stop = function(top)
	w1_page_upnp.timestart = false
	w1_wnd_util.tipclear(top, w1_page_upnp.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_upnp.timerenevt = function(top)
	if(w1_page_upnp.timestart) then
		local save_flag = w1_wnd_util.timerenevt(top, w1_page_upnp.wnd.tipinfo.id)
		if(save_flag ==1)then
			local enable = b_wnd_ex.get_check(top, w1_page_upnp.wnd.t_enable.id)
			if(true == enable)then
				redraw =true;
				w1_wnd_util.cfgtab = {'upnp'}
				w1_wnd_util.cfgtouifunc = cfgdatatoui
				w1_wnd_util.page_init(top)
			end
		end
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_upnp.init = function(top)
	w1_wnd_util.cfgtab = {'upnp'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

w1_page_upnp.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end
w1_page_upnp.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'upnp_c_switch', 'upnp_t_switch', 'cap_upnp','t_enable','cap_http','t_http','cap_https','t_https','cap_port1','t_port1',
			'cap_port2','t_port2','info1',
			'tipinfo', 'default', 'apply' },
	
	upnp_c_switch = {t='static',	id=id+1,xywh='s_cfg_page_1_1',		text='LA_UPNP_ENABLE'},
	upnp_t_switch = {t='tt_check', id=id+2,xywh='s_upnp_switch_t_xywh',
					t_imgs ={b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_switch_upnp},
	cap_upnp 	= {t='static',	id=id+3,xywh='s_cfg_page_2_1',		text='LA_PORT_MAP_MODE'},
	t_enable 	= {t='combox',id=id+4,xywh='s_cfg_page_2_2',items={'Manual','Auto'},
					trans = false, cmd = on_enable},
	cap_http 	= {t='static',	id=id+5,xywh='s_cfg_page_3_1',		text='LA_MAP_HTTP_PORT'},
	t_http 		= {t='edit_num',id=id+6,xywh='s_cfg_page_3_2',range={0,65534},cmd = on_update_param},
	
	cap_https 	= {t='static',	id=id+7,xywh='s_cfg_page_4_1',		text='LA_HTTPS_PORT'},
	t_https 	= {t='edit_num',id=id+8,xywh='s_cfg_page_4_2',range={0,65534},cmd = on_update_param},
	
	cap_port1 	= {t='static',	id=id+9,xywh='s_cfg_page_5_1',		text='LA_DATA_PORT1'},
	t_port1 	= {t='edit_num',id=id+10,xywh='s_cfg_page_5_2',range={0,65534},cmd = on_update_param},
	
	cap_port2 	= {t='static',	id=id+11,xywh='s_cfg_page_6_1',		text='LA_DATA_PORT2'},
	t_port2 	= {t='edit_num',id=id+12,xywh='s_cfg_page_6_2',range={0,65534},cmd = on_update_param},
	info1		= {t='static',	id=id+13,	xywh='s_upnp_info1_xywh',      text='LA_PORT_RANGE2'},
	tipinfo		= {t='static',	id=id+14,	xywh='s_upnp_tipinfo_xywh',	text='',trans = false},

	apply 		= {t='button',	id=id+15,	xywh='s_cfg_apply_xywh',text='LA_APPLY',cmd=on_apply},
}


return w1_page_upnp



