--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/4/26
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_smart.wdda_id
local w1_key 		= require("wnd.w1_util.w1_key")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local util 			= require("wnd.core.util")
local w1_msgbox		= require("wnd.w1_util.w1_msgbox")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local b_app_cfg  = require("wnd.core.b_app_cfg")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_app_api = require("wnd.core.command.b_app_api")
local w1_page_wdda = 
{
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_wdda.s_768 =
{
	s_wdda_cap_disk_xywh = {42,21,106,32},
	s_wdda_t_disk_xywh = {152,24,106,32},
	s_wdda_cap_disksn_xywh = {42,60,101,32},
	s_wdda_t_disksn_xywh = {149,60,144,32},
	s_wdda_cap_disk_mode_xywh = {325,60,101,32},
	s_wdda_t_disk_mode_xywh = {432,60,160,32},
	s_wdda_cap_warning_xywh = {42,96,101,32},
	s_wdda_t_warning_xywh = {149,96,144,32},
	s_wdda_cap_advisory_xywh = {325,96,101,32},
	s_wdda_t_advisory_xywh = {432,96,160,32},
	--s_wdda_cap_health_xywh = {42,132,101,32},
	--s_wdda_t_health_xywh = {149,132,144,32},
	s_wdda_disk_list_xywh = {42,170,752,284},
	s_wdda_list_w1 = {52,0,0,0},
	s_wdda_list_w2 = {300,0,0,0},
	s_wdda_list_w3 = {150,0,0,0},
	s_wdda_list_w4 = {150,0,0,0},
	s_wdda_no_diskname_xywh = {213,21,106,32},
	s_wdda_no_hline_xywh = {53,56,560,1},
};

w1_page_wdda.s_1280 = 
{
	s_wdda_cap_disk_xywh = {80,30,175,45},
	s_wdda_t_disk_xywh = {260,35,200,45},
	s_wdda_cap_disksn_xywh = {80,85,170,45},
	s_wdda_t_disksn_xywh = {255,85,250,45},
	s_wdda_cap_disk_mode_xywh ={545,85,170,45},
	s_wdda_t_disk_mode_xywh ={720,85,270,45},
	s_wdda_cap_warning_xywh = {80,136,170,45},
	s_wdda_t_warning_xywh ={255,136,270,45},
	s_wdda_cap_advisory_xywh ={545,136,170,45},
	s_wdda_t_advisory_xywh ={720,136,270,45},
	--s_wdda_cap_health_xywh ={80,186,170,45},
	--s_wdda_t_health_xywh ={255,186,300,45},
	s_wdda_disk_list_xywh ={80,240,810,400},
	s_wdda_list_w1 = {60,0,0,0},
	s_wdda_list_w2 = {300,0,0,0},
	s_wdda_list_w3 = {200,0,0,0},
	s_wdda_list_w4 = {200,0,0,0},
	s_wdda_no_diskname_xywh = {400,30,200,45},
	s_wdda_no_hline_xywh =  {80,100,800,1},
}

w1_page_wdda.s_1440 = 
{
	s_wdda_cap_disk_xywh = {80,25,175,45},
	s_wdda_t_disk_xywh = {260,35,200,45},
	s_wdda_cap_disksn_xywh = {80,85,170,45},
	s_wdda_t_disksn_xywh = {255,85,250,45},
	s_wdda_cap_disk_mode_xywh ={545,85,170,45},
	s_wdda_t_disk_mode_xywh ={720,85,300,45},
	s_wdda_cap_warning_xywh = {80,136,170,45},
	s_wdda_t_warning_xywh ={255,136,300,45},
	s_wdda_cap_advisory_xywh ={545,136,170,45},
	s_wdda_t_advisory_xywh ={720,136,300,45},
	--s_wdda_cap_health_xywh ={80,186,170,45},
	--s_wdda_t_health_xywh ={255,186,300,45},
	s_wdda_disk_list_xywh ={80,240,810,400},
	s_wdda_list_w1 = {70,0,0,0},
	s_wdda_list_w2 = {300,0,0,0},
	s_wdda_list_w3 = {200,0,0,0},
	s_wdda_list_w4 = {200,0,0,0},
	s_wdda_no_diskname_xywh = {400,30,200,45},
	s_wdda_no_hline_xywh ={80,100,850,1},
--	s_wdda_tipinfo_xywh = {100,760,700,50},
}

w1_page_wdda.s_1080p = 
{
	s_wdda_cap_disk_xywh = {80,30,200,45},
	s_wdda_t_disk_xywh = {285,35,200,45},
	s_wdda_cap_disksn_xywh = {80,85,190,45},
	s_wdda_t_disksn_xywh = {280,85,270,45},
	s_wdda_cap_disk_mode_xywh ={610,85,190,45},
	s_wdda_t_disk_mode_xywh ={810,85,300,45},
	s_wdda_cap_warning_xywh = {80,136,190,45},
	s_wdda_t_warning_xywh ={280,136,270,45},
	s_wdda_cap_advisory_xywh ={610,136,190,45},
	s_wdda_t_advisory_xywh ={810,136,300,45},
	--s_wdda_cap_health_xywh ={80,186,190,45},
	--s_wdda_t_health_xywh ={280,186,270,45},
	s_wdda_disk_list_xywh ={80,240,1300,400},
	s_wdda_list_w1 = {100,0,0,0},
	s_wdda_list_w2 = {500,0,0,0},
	s_wdda_list_w3 = {300,0,0,0},
	s_wdda_list_w4 = {300,0,0,0},
	s_wdda_no_diskname_xywh = {400,30,200,45},
	s_wdda_no_hline_xywh = {100,80,1050,1},
--	s_wdda_tipinfo_xywh = {100,760,700,50},
}

w1_page_wdda.s_2k = 
{
	s_wdda_cap_disk_xywh = {107,40,267,60},
	s_wdda_t_disk_xywh = {380,47,267,60},
	s_wdda_cap_disksn_xywh = {107,113,253,60},
	s_wdda_t_disksn_xywh = {373,113,360,60},
	s_wdda_cap_disk_mode_xywh ={813,113,253,60},
	s_wdda_t_disk_mode_xywh ={1080,113,400,60},
	s_wdda_cap_warning_xywh = {107,181,253,60},
	s_wdda_t_warning_xywh ={373,181,360,60},
	s_wdda_cap_advisory_xywh ={813,181,253,60},
	s_wdda_t_advisory_xywh ={1080,181,400,60},
	--s_wdda_cap_health_xywh ={107,248,253,60},
	--s_wdda_t_health_xywh ={373,248,360,60},
	s_wdda_disk_list_xywh ={107,320,1680,533},
	s_wdda_list_w1 = {133,0,0,0},
	s_wdda_list_w2 = {600,0,0,0},
	s_wdda_list_w3 = {400,0,0,0},
	s_wdda_list_w4 = {400,0,0,0},
	s_wdda_no_diskname_xywh = {533,40,267,60},
	s_wdda_no_hline_xywh = {133,107,1400,1},

}

w1_page_wdda.s_4k = 
{
	s_wdda_cap_disk_xywh = {160,60,400,90},
	s_wdda_t_disk_xywh = {570,70,400,90},
	s_wdda_cap_disksn_xywh = {160,170,380,90},
	s_wdda_t_disksn_xywh = {560,170,540,90},
	s_wdda_cap_disk_mode_xywh ={1220,170,380,90},
	s_wdda_t_disk_mode_xywh ={1620,170,600,90},
	s_wdda_cap_warning_xywh = {160,272,380,90},
	s_wdda_t_warning_xywh ={560,272,540,90},
	s_wdda_cap_advisory_xywh ={1220,272,380,90},
	s_wdda_t_advisory_xywh ={1620,272,600,90},
	--s_wdda_cap_health_xywh ={160,372,380,90},
	--s_wdda_t_health_xywh ={560,372,540,90},
	s_wdda_disk_list_xywh ={160,480,2600,800},
	s_wdda_list_w1 = {200,0,0,0},
	s_wdda_list_w2 = {1000,0,0,0},
	s_wdda_list_w3 = {600,0,0,0},
	s_wdda_list_w4 = {600,0,0,0},
	s_wdda_no_diskname_xywh = {800,60,400,90},
	s_wdda_no_hline_xywh = {200,160,2100,2},

}

w1_page_wdda.clear_data = function()
	w1_page_wdda.data = nil;
end	

local refresh_hide= function(top, hide_flag, redraw)
	local cwnd = w1_page_wdda.wnd;
	b_wnd_ex.set_hide(top, cwnd.cap_disk.id, hide_flag, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_disk.id, hide_flag, redraw)
	b_wnd_ex.set_hide(top, cwnd.cap_disksn.id, hide_flag, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_disksn.id, hide_flag, redraw)
	b_wnd_ex.set_hide(top, cwnd.cap_disk_mode.id, hide_flag, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_disk_mode.id, hide_flag, redraw)
	b_wnd_ex.set_hide(top, cwnd.cap_warning.id, hide_flag, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_warning.id, hide_flag, redraw)
	b_wnd_ex.set_hide(top, cwnd.cap_advisory.id, hide_flag, redraw)
	b_wnd_ex.set_hide(top, cwnd.t_advisory.id, hide_flag, redraw)
	--b_wnd_ex.set_hide(top, cwnd.cap_health.id, hide_flag, redraw)
	--b_wnd_ex.set_hide(top, cwnd.t_health.id, hide_flag, redraw)
	b_wnd_ex.set_hide(top, cwnd.disk_list.id, hide_flag, redraw)
	
	if(hide_flag)then
		b_wnd_ex.set_text(top, cwnd.no_disk.id, STR('LA_NO_DISK'), redraw);
		
		b_wnd_ex.set_hide(top, cwnd.no_disk.id, false, redraw)
--		b_wnd_ex.set_hide(top, cwnd.hline.id, false, redraw)
	else
		b_wnd_ex.set_text(top, cwnd.no_disk.id, STR('LA_NO_DISK'), redraw);
		
		b_wnd_ex.set_hide(top, cwnd.no_disk.id, true, redraw)
--		b_wnd_ex.set_hide(top, cwnd.hline.id, true, redraw)	
	end
end

local refresh_list = function(top, wdda_data)
	local cwnd = w1_page_wdda.wnd;
	local data = wdda_data;
	
	if(nil ~= data and data.count > 0)then
		b_wnd_ex.set_hide(top, cwnd.cap_warning.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.t_warning.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.cap_advisory.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.t_advisory.id, false, false);
	else
		b_wnd_ex.set_hide(top, cwnd.cap_warning.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_warning.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.cap_advisory.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_advisory.id, true, false);
		return 0;
	end
	
	--b_wnd_ex.set_text(top, cwnd.t_disksn.id, data.serial, false)
	--b_wnd_ex.set_text(top, cwnd.t_disk_mode.id, data.model, false)
	b_wnd_ex.set_text(top, cwnd.t_warning.id, data.warning, false)
	b_wnd_ex.set_text(top, cwnd.t_advisory.id, data.advisory, false)
		
	local disklist = {};
	if(nil ~= data)then
		local num = data.count

		for i=1, num do
			if( nil == data['attribute'..i])then --ӿڻȡRaid Disk  UIʾDISKhostid chn_id
				print("-----nil == data['attribute'..i]--------")
			else
				local id 		= i
				local name 		= data['attribute'..i].name
				local raw	 	= string.format("%.2f", data['attribute'..i].value);
				
				local status 	= STR('LA_NORMAL');
				if (data['attribute'..i].level > 1) then
					status = STR('LA_ADVISORY');
				elseif (data['attribute'..i].level > 0) then
					status = STR('LA_WARNING');
				end
				disklist['idx'..i] = {i-1, false, id, name, status, raw};
			end
		end
		disklist.item_total = data.count;
		if(0 == disklist.item_total or 0> disklist.item_total)then
			return 0;
		end

		b_wnd_ex.set_listdata(top, cwnd.disk_list.id, disklist, false);
	end
	
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	w1_page_wdda.data = cfgdata.wd_disk;
	
	local disk = cfgdata.wd_disk;
	local cwnd = w1_page_wdda.wnd;
	local disk_list = {};
	local idx = "disk1";

	local disk_idx = 0;
	for i =1, disk.disk_num do
		local idx ="disk"..tostring(i);
		if(nil ~= disk[idx])then
			local is_raid = string.find(disk[idx].name,"md");
			if(is_raid ~= nil)then
			
			else
				disk_idx = disk_idx + 1;
				table.insert(disk_list, disk[idx].name);
			end
		end
	end
	if(disk.disk_num < 1 or disk_idx < 1 )then
		refresh_hide(top, true, false)
		return 0;
	else
		refresh_hide(top, false, false)
	end
	
	b_wnd_ex.set_items(top, cwnd.t_disk.id, disk_list, false);
	b_wnd_ex.set_sel(top, cwnd.t_disk.id, 0, false);
	
	local diskname = b_wnd_ex.get_text(top, cwnd.t_disk.id);
	local wdda_info = {};
	for i =1, disk.disk_num do
		local idx ="disk"..tostring(i);
		if(diskname == disk[idx].name)then
			b_wnd_ex.set_text(top, cwnd.t_disksn.id, disk[idx].serial, false);
			b_wnd_ex.set_text(top, cwnd.t_disk_mode.id, disk[idx].model, false);
			wdda_info = b_app_api.get_wdda_info({cur_path = disk[idx].path, serial = disk[idx].serial, model = disk[idx].model});
		end
	end

	local data = wdda_info.wdda;
	refresh_list(top, data);
	
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
--[[	local cwnd = w1_page_wdda.wnd;
	local data = cfgdata.smart;
	local enable = b_wnd_ex.get_check(top, cwnd.t_enable.id);
	data.enable = enable;
	local filtertype =b_wnd_ex.get_sel(top, cwnd.t_rule.id);
	data.type =filtertype;--]]
	return 0
end


--ҳʼʱٶȡҳҪ
w1_page_wdda.init = function(top)
	w1_wnd_util.cfgtab = {'wd_disk'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

w1_page_wdda.timer_start = function()
	w1_page_wdda.timestart = true
end

w1_page_wdda.timer_stop = function(top)
	w1_page_wdda.timestart = false
	--w1_wnd_util.tipclear(top, w1_page_wdda.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_page_wdda.timerenevt = function(top)
	if(w1_page_wdda.timestart) then
	--	w1_wnd_util.timerenevt(top, w1_page_wdda.wnd.tipinfo.id)
	end
	return 0
end


local on_disk = function(top, win_id, vmsg, x, y)
	if vmsg == b_ui_msg.msg_user_update_parent then
		local cwnd = w1_page_wdda.wnd;
		local disk = w1_page_wdda.data

		local diskname = b_wnd_ex.get_text(top, cwnd.t_disk.id);
		for i =1, disk.disk_num do
			local idx ="disk"..tostring(i);
			if(diskname == disk[idx].name)then
				b_wnd_ex.set_text(top, cwnd.t_disksn.id, disk[idx].serial, false);
				b_wnd_ex.set_text(top, cwnd.t_disk_mode.id, disk[idx].model, false);
				
				local wdda_info = b_app_api.get_wdda_info({cur_path = disk[idx].path, serial = disk[idx].serial, model = disk[idx].model});
				local data = wdda_info.wdda;
				refresh_list(top, data);
			end
		end	
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
	--	w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

--[[local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
		
		w1_wnd_util.page_onapply(top)
		--w1_wnd_util.tipdispon()	--ʾ
	end
	return 0
end

w1_page_wdda.apply =function(top)
	local ret = nil;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	ret = w1_wnd_util.page_onapply(top)
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
	--	w1_wnd_util.tipdispon()--ʾ
	end
	return ret;
end--]]

w1_page_wdda.on_pre_show = function(top)
	local param = {
			STR('LA_ID'), STR('LA_ATTRIBUTE_NAME'),STR('LA_STATUS'),STR('LA_RAW_VALUE')
		}	
	b_wnd_ex.set_title_texts(top, w1_page_wdda.wnd.disk_list.id, param, false)
	local list_w = {};
	for i=1,4 do
		local str = 's_wdda_list_w'..math.floor(i/1);
		list_w[i] = SIZE(str)[1];
	end
	b_wnd_ex.columns_w(top, w1_page_wdda.wnd.disk_list.id, list_w, false);
end

w1_page_wdda.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_disk','t_disk','cap_disksn','t_disksn','cap_disk_mode',
			't_disk_mode','cap_warning','t_warning','cap_advisory','t_advisory',
			'disk_list','no_disk'},
	cap_disk 	= {t='static',id=id+1,xywh='s_wdda_cap_disk_xywh',text='LA_DISK_T'},
	t_disk 	= {t='combox', id=id+2,xywh='s_wdda_t_disk_xywh',cmd = on_disk},
	
	cap_disksn	= {t='static',id=id+3,xywh='s_wdda_cap_disksn_xywh',text='LA_DISK_SN'},
	t_disksn 		= {t='static',id=id+4,xywh='s_wdda_t_disksn_xywh',text=''},	

	cap_disk_mode = {t='static',id=id+5,xywh='s_wdda_cap_disk_mode_xywh',text='LA_DISK_MODEL'},
	t_disk_mode= {t='static',id=id+6,xywh='s_wdda_t_disk_mode_xywh',text=''},
	
	cap_warning = {t='static',id=id+7,xywh='s_wdda_cap_warning_xywh',text='LA_WARNING'},
	t_warning= {t='static',id=id+8,xywh='s_wdda_t_warning_xywh',text=''},
	
	cap_advisory = {t='static',id=id+9,xywh='s_wdda_cap_advisory_xywh',text='LA_ADVISORY'},
	t_advisory= {t='static',id=id+10,xywh='s_wdda_t_advisory_xywh',text=''},
	
	disk_list	= {t='list',	id=id+13,	xywh='s_wdda_disk_list_xywh', font = 'f_grade4',
					listattr = {8,4,b_ui.LISTATTR.FIRST_WIDGET_STATIC},
					columns_w = {50,400,200,200},
					columns_align = {b_ui.ALIGN.CENTER, b_ui.ALIGN.LEFT,b_ui.ALIGN.CENTER, b_ui.ALIGN.CENTER},
					},
	
	no_disk     = {t='static',id=id+14,	xywh='s_wdda_no_diskname_xywh',font = 'f_grade3'},
}

return w1_page_wdda



