--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_net.wifi_cfg_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local util 			= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local w1_page_wifi_cfg = 
{
	timestart = false,
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_wifi_cfg.s_768 =
{
	s_wifi_cfg_reboot_tip_xywh = {53,241,640,32},
	s_wifi_cfg_tipinfo_xywh = {53,312,373,35},
};

w1_page_wifi_cfg.s_1280 = 
{
	s_wifi_cfg_reboot_tip_xywh = {100,340,900,45},
	s_wifi_cfg_tipinfo_xywh = {100,440,700,50},
}

w1_page_wifi_cfg.s_1440 = 
{
	s_wifi_cfg_reboot_tip_xywh = {100,315,1000,45},
	s_wifi_cfg_tipinfo_xywh = {100,415,700,50},
}

w1_page_wifi_cfg.s_1080p = 
{
	s_wifi_cfg_reboot_tip_xywh = {100,340,1200,45},
	s_wifi_cfg_tipinfo_xywh = {100,440,700,50},
}
w1_page_wifi_cfg.s_2k = 
{
	s_wifi_cfg_reboot_tip_xywh = {133,453,1600,60},
	s_wifi_cfg_tipinfo_xywh = {133,587,933,67},
}
w1_page_wifi_cfg.s_4k = 
{
	s_wifi_cfg_reboot_tip_xywh = {200,680,2400,90},
	s_wifi_cfg_tipinfo_xywh = {200,880,1400,100},
}
local local_areas = {};

w1_page_wifi_cfg.clear_data = function()
	w1_page_wifi_cfg.data = nil;
	local_areas = nil;
end	

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	w1_page_wifi_cfg.data = cfgdata;
	
	local cwnd = w1_page_wifi_cfg.wnd;
	local param = cfgdata.wifi_param
	local area = cfgdata.wifi_area
	local function settext(id, str)
		b_wnd_ex.set_text(top, id, str,false)
	end

	--settext(cwnd.t_ver.id,  param.version );
 	settext(cwnd.t_bssid.id, string.upper(param.bssid));
	settext(cwnd.t_ssid.id, param.ssid );
	b_wnd_ex.set_password(top,cwnd.t_pass.id,param.passwd,false);
	local indx = 0;
	local names = {};
	for i = 1, area.area_num do
		local_areas['list'..i] = {};
		local_areas['list'..i].area_name = area['list'..i].area_name;
		local_areas['list'..i].channel_num = area['list'..i].channel_num;
		local_areas['list'..i].channels = {};
		local_areas['list'..i].channels = util.copy_tab(area['list'..i].channels)
		if local_areas['list'..i].channels[14] ~= nil then
			local_areas['list'..i].channels[14] = 'LA_OTHER'
		end
		names[i] = area['list'..i].area_name;
		if param.area_name == local_areas['list'..i].area_name then
			indx = i;			
		end
	end
	b_wnd_ex.set_items(top, cwnd.t_area.id, names, false);
	b_wnd_ex.set_sel(top,cwnd.t_area.id,indx-1,false);
	b_wnd_ex.set_items(top, cwnd.t_chn.id, local_areas['list'..indx].channels, false);
	for i = 1, local_areas['list'..indx].channel_num do
		if param.channel == 14 then
			b_wnd_ex.set_sel(top,cwnd.t_chn.id,13,false);
			break;
		elseif local_areas['list'..indx].channels[i] == param.channel then
			b_wnd_ex.set_sel(top,cwnd.t_chn.id,i-1,false);
			break;
		end
	end
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_page_wifi_cfg.wnd;
	local data = cfgdata.wifi_param;
	local gettext = function(id)
		local iptext = b_wnd_ex.get_text(top, id)
		return iptext;
	end

	local ssid = gettext(cwnd.t_ssid.id);
	data.ssid = ssid;
	local pwd = b_wnd_ex.get_password(top,cwnd.t_pass.id);
	data.passwd = pwd;
	local area = b_wnd_ex.get_sel(top,cwnd.t_area.id);
	data.area_name = local_areas['list'..area+1].area_name
	local chn = b_wnd_ex.get_sel(top,cwnd.t_chn.id);
	if local_areas['list'..area+1].channels[chn+1] == 'LA_OTHER' then
		data.channel = 14
	else
		data.channel = local_areas['list'..area+1].channels[chn+1]
	end	
	
	return 0;
end


--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local cwnd = w1_page_wifi_cfg.wnd;
	local legalflag = true;
	local nlegalid = {};
	local ssid = b_wnd_ex.get_text(top,cwnd.t_ssid.id);
	if ssid == '' then
		legalflag = false
		table.insert(nlegalid, cwnd.t_ssid.id);
	end
	local pwd = b_wnd_ex.get_password(top,cwnd.t_pass.id);
	if pwd == '' then
		legalflag = false
		table.insert(nlegalid, cwnd.t_pass.id);
	end

	if legalflag ~= true then
		return legalflag, nlegalid;
	end
	
	if(string.len(pwd) < 8)then
		legalflag = false;
		table.insert(nlegalid, cwnd.t_pass.id);
		w1_wnd_util.setparamerr_str(STR('LA_WIFI_PWD_LENGTH'));
		return legalflag, nlegalid;
	end
	
	return true, nil;	
end

local returndatacheck =function(top,ret)
	return true, nil;
end

local on_update_param	= function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_update_param_area	= function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local cwnd = w1_page_wifi_cfg.wnd;
		local sel = b_wnd_ex.get_sel(top,cwnd.t_area.id);
		b_wnd_ex.set_items(top, cwnd.t_chn.id, local_areas['list'..sel+1].channels, true);
		uitousercfg(top,b_app_cfg.user_cfg);
	end
	return 0;
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck;
		w1_wnd_util.returndatacheckfunc = returndatacheck;
		w1_wnd_util.page_onapply(top);
		w1_wnd_util.tipdispon();		--ʾ
		w1_wnd_util.returndatacheckfunc = nil;	
	end
	return 0
end

w1_page_wifi_cfg.timer_start = function()
	w1_page_wifi_cfg.timestart = true;
end

w1_page_wifi_cfg.timer_stop = function(top)
	w1_page_wifi_cfg.timestart = false;
	w1_wnd_util.tipclear(top, w1_page_wifi_cfg.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
	w1_wnd_util.tipdispoff();
end

w1_page_wifi_cfg.timerenevt = function(top)
	if(w1_page_wifi_cfg.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_wifi_cfg.wnd.tipinfo.id);
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_wifi_cfg.init = function(top)
	w1_wnd_util.cfgtab = {'wifi_param', 'wifi_area'};
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);
	return 0
end

w1_page_wifi_cfg.apply =function(top)
	local ret = nil;
	--w1_wnd_util.uidatacheckfunc = uidatacheck;
	--w1_wnd_util.returndatacheckfunc = returndatacheck;
	ret = w1_wnd_util.page_onapply(top);
	if (ret ~= nil and type(ret) == "table" and ret.param_illegal_falg == true) then
		w1_wnd_util.tipdispon()--ʾ
	end
	w1_wnd_util.returndatacheckfunc = nil;	
	return ret;
end
w1_page_wifi_cfg.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_bssid','t_bssid',	'cap_ssid','t_ssid','cap_pass',
			't_pass', 'cap_chn','t_chn','cap_area','t_area',
			'reboottip','tipinfo', 'apply' },
	--cap_ver		= {t='static',	id=id+1,	xywh='s_cfg_page_1_1',text='LA_VERSION'},
	--t_ver		= {t='static', id=id+2,	xywh='s_cfg_page_1_2',text='',trans = false},
	cap_bssid	= {t='static',id=id+1,	xywh='s_cfg_page_1_1',text='LA_BSSID'},
	t_bssid		= {t='static',id=id+2,	xywh='s_cfg_page_1_2',text='',trans = false},
	cap_ssid	= {t='static',id=id+3,	xywh='s_cfg_page_2_1',text='LA_SSID'},
	t_ssid	 	= {t='edit',id=id+4,	xywh='s_cfg_page_2_2',text='',trans = false,guide_text='s20190724',guide_trans=false,cmd=on_update_param},
	cap_pass 	= {t='static',id=id+5,	xywh='s_cfg_page_3_1',text='LA_PASSWORD',},	
	t_pass 		= {t='password',id=id+6,xywh='s_cfg_page_3_2', password='password',guide_text='LA_PASSWORD',disp=false,cmd=on_update_param},			

	cap_chn 	= {t='static',id=id+7,	xywh='s_cfg_page_4_1',text='LA_WIFI_CHANNEL',},
	t_chn		= {t='combox',id=id+8,xywh='s_cfg_page_4_2',items={},trans = false,cmd=on_update_param},
	cap_area 	= {t='static',id=id+9,	xywh='s_cfg_page_5_1',text='LA_AREA',},
	t_area		= {t='combox',id=id+10,xywh='s_cfg_page_5_2',items={},trans = false,cmd=on_update_param_area},
	
	reboottip	= {t='static',	id=id+11,	xywh='s_wifi_cfg_reboot_tip_xywh',		text='LA_WIFI_NOTE',
				color = {'c_hint_bk', 'c_hint_border', 'c_hint_text'}},
	tipinfo		= {t='static',	id=id+12,	xywh='s_wifi_cfg_tipinfo_xywh',text='',trans = false},
	apply 		= {t='button',	id=id+13,	xywh='s_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_page_wifi_cfg



