--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/12
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_net.wifi_network_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local util 			= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local w1_page_wifi_network = 
{
	timestart = false,
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_page_wifi_network.s_768 =
{
	s_wifi_network_tipinfo_xywh = {53,213,373,35},
};

w1_page_wifi_network.s_1280 = 
{
	--s_wifi_reboot_tip_xywh = {100,210,900,45},
	s_wifi_network_tipinfo_xywh = {100,300,700,50},

}

w1_page_wifi_network.s_1440 = 
{
	--s_wifi_reboot_tip_xywh = {100,210,1000,45},
	s_wifi_network_tipinfo_xywh = {100,300,700,50},

}

w1_page_wifi_network.s_1080p = 
{
	--s_wifi_reboot_tip_xywh = {100,210,1200,45},
	s_wifi_network_tipinfo_xywh = {100,300,700,50},

}
w1_page_wifi_network.s_2k = 
{
	--s_wifi_reboot_tip_xywh = {133,280,1600,60},
	s_wifi_network_tipinfo_xywh = {133,400,933,67},

}
w1_page_wifi_network.s_4k = 
{
	--s_wifi_reboot_tip_xywh = {200,420,2400,90},
	s_wifi_network_tipinfo_xywh = {200,600,1400,100},
}

w1_page_wifi_network.clear_data = function()
	w1_page_wifi_network.data = nil;
end	

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	w1_page_wifi_network.data = cfgdata;
	
	local cwnd = w1_page_wifi_network.wnd;
	local data = cfgdata.wifi_network;
	local function settext(id, str)
		b_wnd_ex.set_text(top, id, str,false)
	end

	settext(cwnd.t_ip.id,  data.ip );
	settext(cwnd.t_netmask.id, data.netmask );
	settext(cwnd.t_gateway.id, data.gateway );
	return 0
end

w1_page_wifi_network.timer_start = function()
	w1_page_wifi_network.timestart = true;
end

w1_page_wifi_network.timer_stop = function(top)
	w1_page_wifi_network.timestart = false;
	w1_wnd_util.tipclear(top, w1_page_wifi_network.wnd.tipinfo.id, false);
	w1_wnd_util.clearerrweight(top, false);
	w1_wnd_util.tipdispoff();
end

w1_page_wifi_network.timerenevt = function(top)
	if(w1_page_wifi_network.timestart) then
		w1_wnd_util.timerenevt(top, w1_page_wifi_network.wnd.tipinfo.id);
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_page_wifi_network.init = function(top)
	w1_wnd_util.cfgtab = {'wifi_network'};
	w1_wnd_util.cfgtouifunc = cfgdatatoui;
	w1_wnd_util.page_init(top);
	return 0
end

w1_page_wifi_network.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_cfg_page_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'cap_ip','t_ip','cap_netmask','t_netmask',
			'cap_gateway','t_gateway','t_reboot_tip',
			'tipinfo', 'apply' },
	
	cap_ip 		= {t='static',	id=id+1,	xywh='s_cfg_page_1_1',text='LA_IP_ADDRESS'},
	t_ip 		= {t='static', id=id+2,	xywh='s_cfg_page_1_2'},
	
	cap_netmask = {t='static',	id=id+3,	xywh='s_cfg_page_2_1',text='LA_SUBNET_MASK'},
	t_netmask 	= {t='static', id=id+4,		xywh='s_cfg_page_2_2'},
	
	cap_gateway = {t='static',	id=id+5,	xywh='s_cfg_page_3_1',text='LA_GATEWAY'},
	t_gateway 	= {t='static', id=id+6,		xywh='s_cfg_page_3_2'},
	
	tipinfo		= {t='static',	id=id+7,	xywh='s_wifi_network_tipinfo_xywh',text='',trans = false},
}

return w1_page_wifi_network



