--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_abnormal.abnormalrow_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")

local w1_row_abnormalrow = {	
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_row_abnormalrow.s_768 =
{
	s_row_abnormalrow_xywh = {0,160,533,57},
	s_row_abnormalrow_events_xywh = {53,0,106,39},
};

w1_row_abnormalrow.s_1280 = 
{
	s_row_abnormalrow_xywh = {0,225,1000,81},
	s_row_abnormalrow_events_xywh = {100,0,200,55},

};

w1_row_abnormalrow.s_1440 = 
{
	s_row_abnormalrow_xywh = {0,185,1000,81},
	s_row_abnormalrow_events_xywh = {100,0,180,55},

};

w1_row_abnormalrow.s_1080p = 
{
	s_row_abnormalrow_xywh = {0,225,1000,81},
	s_row_abnormalrow_events_xywh = {100,0,200,55},

};
w1_row_abnormalrow.s_2k = 
{
	s_row_abnormalrow_xywh = {0,300,1333,108},
	s_row_abnormalrow_events_xywh = {133,0,267,73},

};
w1_row_abnormalrow.s_4k = 
{
	s_row_abnormalrow_xywh = {0,450,2000,162},
	s_row_abnormalrow_events_xywh = {200,0,400,110},
};

w1_row_abnormalrow.changecheck = function(top, wnd, id, redraw)
	for k,v in pairs( wnd.sub ) do
		if(wnd[v].t == 'checkbutton') then
			b_wnd_ex.set_check(top, wnd[v].id, false, redraw)
		end
	end
	b_wnd_ex.set_check(top, id, true, redraw);
	local wnd_id = w1_row_abnormalrow.wnd
	
	if(id  == wnd_id.events.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_abnormal.con_abnormal_id, w1_id.cfg_abnormal.event_id, redraw)
	end
end

w1_row_abnormalrow.get_checkidx = function(top)
	local check = b_wnd_ex.get_check(top, w1_row_abnormalrow.wnd.events.id);
	if(check) then
		return 0
	else
		return 1
	end
end

local on_events = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_row_abnormalrow.changecheck(top, w1_row_abnormalrow.wnd, win_id, true);
	end
	return 0
end

w1_row_abnormalrow.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_row_abnormalrow_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'events','hline1'},
	
	events 		= {t='checkbutton',	id=id+1,xywh = 's_row_abnormalrow_events_xywh',	text='LA_LINK_EVENT',		check = true,	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_linkevents','it_linkevents', 'it_linkevents'},
				cmd=on_events},
	hline1 		= {t='hline',id=id+2,	xywh='s_cfg_lline1'},
}

return w1_row_abnormalrow
