--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_adv_insight.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local util 			= require("wnd.core.util")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_dlg 		= require("wnd.core.b_dlg")
local w1_page_adv_insight_smoker_dec				= require("wnd.w1_cfg.w1_page_adv_insight_smoker_dec")
local w1_page_adv_insight_smoker_flame				= require("wnd.w1_cfg.w1_page_adv_insight_smoker_flame")
local w1_page_adv_insight_fire_spot					= require("wnd.w1_cfg.w1_page_adv_insight_fire_spot")

local last_page = 1;
local w1_row_adv_insight = {
	item_width = nil,			--
	select_item_idx = 0, 		--չťѡеԪ
	dsp_item_s_id,				--ǰʾԪʼ
	dsp_item_e_id,				--ǰʾԪؽ
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,	
}

w1_row_adv_insight.s_768 =
{
	w1_row_noopsyche_total_width_xywh = {0,0,752,0},
	w1_row_noopsyche_item_space_xywh = {0,0,26,0},
	w1_row_noopsyche_exp_btn_xywh = {784,28,21,21},
};

w1_row_adv_insight.s_1280 = 
{
	w1_row_noopsyche_total_width_xywh = {0, 0, 860, 0},
	w1_row_noopsyche_item_space_xywh = {0, 0, 50, 0},
	w1_row_noopsyche_exp_btn_xywh = {920, 45, 40, 30},
};

w1_row_adv_insight.s_1440 = 
{
	w1_row_noopsyche_total_width_xywh = {0, 0, 985, 0},
	w1_row_noopsyche_item_space_xywh = {0, 0, 40, 0},
	w1_row_noopsyche_exp_btn_xywh = {1045, 40, 40, 30},
};

w1_row_adv_insight.s_1080p = 
{
	w1_row_noopsyche_total_width_xywh = {0, 0, 1410, 0},
	w1_row_noopsyche_item_space_xywh = {0, 0, 50, 0},
	w1_row_noopsyche_exp_btn_xywh = {1470, 40, 40, 30},
};

w1_row_adv_insight.s_2k = 
{
	w1_row_noopsyche_total_width_xywh = {0,0,1880,0},
	w1_row_noopsyche_item_space_xywh = {0,0,66,0},
	w1_row_noopsyche_exp_btn_xywh = {1960,53,53,40},
};

w1_row_adv_insight.s_4k = 
{
	w1_row_noopsyche_total_width_xywh = {0, 0, 2820, 0},
	w1_row_noopsyche_item_space_xywh = {0, 0, 100, 0},
	w1_row_noopsyche_exp_btn_xywh = {2940, 80, 80, 60},
};

w1_row_adv_insight.clear_data = function()
	w1_row_adv_insight.item_width = nil;			
	w1_row_adv_insight.select_item_idx = 0; 		
	w1_row_adv_insight.dsp_item_s_id = 0;				
	w1_row_adv_insight.dsp_item_e_id = 0;				
end

local move_item_position = function(top, s_id, e_id, redraw)
	--ȫ	
	for i = id + 1, id + 3 do
		b_wnd_ex.set_hide(top, i, true, false);
	end
	
	local space = SIZE('w1_row_noopsyche_item_space_xywh')[3]
	local pos = SIZE('s_cfg_row_1');
	local x = pos[1];
	local y = pos[2];
	local w = pos[3];
	local h = pos[4];
	local idx = 1;
	for i = s_id, e_id do
		idx = i - id;
		if (i > s_id) then
			x = x + w1_row_adv_insight.item_width[idx - 1] + space; 
		end	
		w = w1_row_adv_insight.item_width[idx];
		b_wnd_ex.set_hide(top, i, false, false);
		b_wnd_ex.move_ex(top, i, {x, y, w, h}, false);
	end
	
	if redraw == true then
		b_dlg.dlg_set_redraw(top);
	end
end

local get_channel = function()
	if last_page == 1 then
		return w1_page_adv_insight_smoker_dec.get_channel();
	elseif last_page == 2 then
		return w1_page_adv_insight_smoker_flame.get_channel();
	elseif last_page == 3 then
		return w1_page_adv_insight_fire_spot.get_channel();
	end
	return 0;
end

local on_item_clicked = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local chn = get_channel();
		local cwnd = w1_row_adv_insight.wnd;
		local cur_wnd = nil;
		if (win_id == cwnd.smoker_dec.id) then
			last_page = 1
			cur_wnd = w1_page_adv_insight_smoker_dec;
		elseif (win_id == cwnd.smoker_flame.id) then
			last_page = 2
			cur_wnd = w1_page_adv_insight_smoker_flame;
		elseif (win_id == cwnd.fire_spot.id) then
			last_page = 3
			cur_wnd = w1_page_adv_insight_fire_spot;
		end	
		if (cur_wnd ~= nil) then
			cur_wnd.set_channel(chn);
		end
		
		w1_wnd_jump.click_row(top, w1_row_adv_insight.wnd, win_id, true)
	end
	
	return 0;
end	

w1_row_adv_insight.set_select_intelligent_type = function(idx)
	w1_row_adv_insight.select_item_idx = idx;
end	

w1_row_adv_insight.on_pre_show = function(top)
	local item_width_ary = {};
	local cwnd = w1_row_adv_insight.wnd;
	local width = 0;
	width = b_wnd_ex.get_textsize(top, cwnd.smoker_dec.id).w; 
	table.insert(item_width_ary, width);	
	width = b_wnd_ex.get_textsize(top, cwnd.smoker_flame.id).w;
	table.insert(item_width_ary, width);	
	width = b_wnd_ex.get_textsize(top, cwnd.fire_spot.id).w;
	table.insert(item_width_ary, width);	

	if(w1_row_adv_insight.item_width == nil) then
		w1_row_adv_insight.item_width = util.copy_tab(item_width_ary);
	else
		util.copy_tab_b(w1_row_adv_insight.item_width, item_width_ary);
	end

	local total_w = SIZE('w1_row_noopsyche_total_width_xywh')[3];
	local space = SIZE('w1_row_noopsyche_item_space_xywh')[3]
	local dsp_item_cnt = 0;
	local tem_width = 0;
	for i = 1, #w1_row_adv_insight.item_width do
		tem_width = tem_width + w1_row_adv_insight.item_width[i] + space
		if (tem_width > total_w) then
			break;
		end
		dsp_item_cnt = dsp_item_cnt + 1;
	end

	w1_row_adv_insight.dsp_item_s_id = id + 1;			
	w1_row_adv_insight.dsp_item_e_id = id +dsp_item_cnt;				
	move_item_position(top, w1_row_adv_insight.dsp_item_s_id, w1_row_adv_insight.dsp_item_e_id, false);
end

w1_row_adv_insight.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'smoker_dec','smoker_flame','fire_spot','hline'},
	smoker_dec 	= {t='checktxt', id=id+1,xywh='s_cfg_row_1',
				text='LA_SMOKING_TEST',	font = 'f_noopsychearea_title',align = b_ui.ALIGN.LEFT,
				cmd=on_item_clicked,check = true},
	smoker_flame 	= {t='checktxt',	id=id+2,xywh='s_cfg_row_1',
				text='LA_FIREWORKS_DETECTION',	font = 'f_noopsychearea_title',align = b_ui.ALIGN.LEFT,
				cmd=on_item_clicked},
	fire_spot = {t='checktxt',	id=id+3,xywh='s_cfg_row_1',
				text='LA_FIRE_DETECTION',	font = 'f_noopsychearea_title',align = b_ui.ALIGN.LEFT,
				cmd=on_item_clicked},
	--[[
	exp_btn = {t='tt_button',id=id+4,xywh='w1_row_noopsyche_exp_btn_xywh', cmd=on_expand,
			color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},
			color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
			color_d= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_d'},
			t_imgs = {b_ui.ALIGN.CENTER,'f_grade4','it_down','it_down', 'it_down'}},				
	--]]			
	hline 	= {t='hline',	id=id+4,xywh='s_cfg_row_hline'},
}

return w1_row_adv_insight
