--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_ai.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size

local w1_row_ai = {}

local on_click = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_row_ai.wnd, win_id, true)
	end
	return 0
end

w1_row_ai.on_pre_show = function (top)
	local cwnd = w1_row_ai.wnd;
	local title_1 = SIZE('s_cfg_row_1')
	local space1 = b_wnd_ex.get_textsize(top, cwnd.multi_obj.id).border * 60 ;--1
	local size1 = b_wnd_ex.get_textsize(top, cwnd.multi_obj.id).w; 
	local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
	b_wnd_ex.move_ex(top, cwnd.multi_obj.id, movepos1, false);
	local size2 = b_wnd_ex.get_textsize(top, cwnd.plate.id).w; 
	local movepos2 = {title_1[1]+size1+space1,title_1[2],size2,title_1[4]};
	b_wnd_ex.move_ex(top, cwnd.plate.id, movepos2, false);
	local size3 = b_wnd_ex.get_textsize(top, cwnd.face.id).w; 
	local movepos3 = {title_1[1]+size1+space1+size2+space1,title_1[2],size3,title_1[4]};
	b_wnd_ex.move_ex(top, cwnd.face.id, movepos3, false);
	b_wnd_ex.set_hide(top, cwnd.face.id, true, false);
end

w1_row_ai.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'multi_obj', 'plate', 'face', 'hline'},

	multi_obj 	= {t='checktxt',	id=id+1,xywh='s_cfg_row_1',
				text='LA_AI_MULTIOBJ',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click,check = true},
	plate 	= {t='checktxt',	id=id+2,xywh='s_cfg_row_2',
				text='LA_LIC_PLATE_REC',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click},
	face 	= {t='checktxt',	id=id+3,xywh='s_cfg_row_3',
				text='LA_FACE_DETECT',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click},
	hline 	= {t='hline',	id=id+4,xywh='s_cfg_row_hline'}
}

return w1_row_ai
