--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_alarmin.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")

local w1_row_alarmin = {}

local on_alarm_in = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_row_alarmin.wnd, win_id, true)
	end
	return 0
end

w1_row_alarmin.on_pre_show = function(top)
	local cwnd = w1_row_alarmin.wnd;
	local pos = SIZE('s_cfg_row_2');
	local size = b_wnd_ex.get_textsize(top, cwnd.io_alarm_l.id).w; 
	local movepos = {pos[1],pos[2],size,pos[4]};
	b_wnd_ex.move_ex(top, cwnd.io_alarm_l.id, movepos, false);
	local privilege= global_val.get_allprivilege()
	local ai_num = global_val.get_sinum()
	
	if ai_num==0 or privilege.systerm_config==false then
		b_wnd_ex.set_disable(top,cwnd.alarm_in.id,true,false)
		b_wnd_ex.set_check(top,cwnd.alarm_in.id,false,false)
		b_wnd_ex.set_check(top,cwnd.io_alarm_l.id,true,false)
	else
		b_wnd_ex.set_disable(top,cwnd.alarm_in.id,false,false)
		b_wnd_ex.set_check(top,cwnd.alarm_in.id,true,false)
		b_wnd_ex.set_check(top,cwnd.io_alarm_l.id,false,false)
	end
	
	if privilege.channel_manager==false  then
		b_wnd_ex.set_disable(top,cwnd.io_alarm_l.id,true,false)
	else
		b_wnd_ex.set_disable(top,cwnd.io_alarm_l.id,false,false)	
	end
end

w1_row_alarmin.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'alarm_in','io_alarm_l', 'hline'},

	alarm_in 	= {t='checktxt',	id=id+1,xywh='s_cfg_row_1',
				text='LA_ALARM_IN',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_alarm_in,check = true},
	io_alarm_l 	= {t='checktxt',	id=id+2,xywh='s_cfg_row_2',
				text='LA_IOALAEM_L',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_alarm_in},		
	hline 	= {t='hline',	id=id+3,xywh='s_cfg_row_hline'}
}

return w1_row_alarmin
