--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_alarmout.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local global_val	= require("wnd.global_val")

local w1_row_alarmout = {}

local on_alarm_out = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_row_alarmout.wnd, win_id, true)
	end
	return 0
end

w1_row_alarmout.on_pre_show = function(top)
	local cwnd = w1_row_alarmout.wnd;
	local pos = SIZE('s_cfg_row_2');
	local size = b_wnd_ex.get_textsize(top, cwnd.io_alarm_l.id).w; 
	local movepos = {pos[1],pos[2],size,pos[4]};
	local size_1 = b_wnd_ex.get_textsize(top, cwnd.flash_alarm.id).w; 
	local movepos_1 = {pos[1] + size + 50, pos[2],size_1, pos[4]};	
	
	b_wnd_ex.move_ex(top, cwnd.io_alarm_l.id, movepos, false);
	b_wnd_ex.move_ex(top, cwnd.flash_alarm.id, movepos_1, false);
	local privilege= global_val.get_allprivilege()
	if global_val.get_ronum()==0 or privilege.systerm_config==false then
		b_wnd_ex.set_check(top,cwnd.io_alarm_l.id,true,false)
		b_wnd_ex.set_check(top,cwnd.alarm_out.id,false,false)
		b_wnd_ex.set_check(top,cwnd.flash_alarm.id,false,false)
		b_wnd_ex.set_disable(top,cwnd.alarm_out.id,true,false)
	else
		b_wnd_ex.set_check(top,cwnd.io_alarm_l.id,false,false)
		b_wnd_ex.set_check(top,cwnd.alarm_out.id,true,false)
		b_wnd_ex.set_check(top,cwnd.flash_alarm.id,false,false)
		b_wnd_ex.set_disable(top,cwnd.alarm_out.id,false,false)
	end
	
	if privilege.channel_manager==false  then
		b_wnd_ex.set_disable(top,cwnd.io_alarm_l.id,true,false)
		b_wnd_ex.set_disable(top,cwnd.flash_alarm.id,true,false)
	else
		b_wnd_ex.set_disable(top,cwnd.io_alarm_l.id,false,false)
		b_wnd_ex.set_disable(top,cwnd.flash_alarm.id,false,false)
	end
	
	b_wnd_ex.set_hide(top,cwnd.io_audio_out.id,true,false)
end

w1_row_alarmout.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'alarm_out','io_alarm_l',  'flash_alarm', 'io_audio_out', 'hline'},

	alarm_out 	= {t='checktxt',	id=id+1,xywh='s_cfg_row_1',
				text='LA_ALARM_OUT',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_alarm_out,check = true},
	io_alarm_l 	= {t='checktxt',	id=id+2,xywh='s_cfg_row_2',
				text='LA_CHANNEL_ALARM_OUT',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_alarm_out},
	flash_alarm 	= {t='checktxt',	id=id+3,xywh='s_cfg_row_3',
				text='LA_FLASH_ALARM_OUT',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_alarm_out},						
	io_audio_out 	= {t='checktxt',	id=id+4,xywh='s_cfg_row_3',
				text='LA_SOUND_DETECTION',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_alarm_out},						
	hline 	= {t='hline',	id=id+5,xywh='s_cfg_row_hline'}
}

return w1_row_alarmout
