--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_basic.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local r_size		= require("wnd.core.r_res.r_size")
local b_dlg 	= require("wnd.core.b_dlg")
local SIZE 			= r_size.get_size
local w1_row_basic = {
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_row_basic.s_768 =
{
	s_row_basic_time_xywh = {112,27,85,28},
	s_row_basic_tzone_xywh = {229,27,80,28},
	s_row_basic_dst_xywh = {320,27,80,28},
	s_row_basic_ipc_xywh = {410,27,80,28},
};

w1_row_basic.s_1280 = 
{
	s_row_basic_time_xywh= {210,38,160,40},
	s_row_basic_tzone_xywh= {430,38,150,40},
	s_row_basic_dst_xywh= {600,38,150,40},
	s_row_basic_ipc_xywh= {770,38,150,40},

};

w1_row_basic.s_1440 = 
{
	s_row_basic_time_xywh= {210,30,160,40},
	s_row_basic_tzone_xywh= {430,30,150,40},
	s_row_basic_dst_xywh= {600,30,150,40},
	s_row_basic_ipc_xywh= {770,38,150,40},
};

w1_row_basic.s_1080p = 
{
	s_row_basic_time_xywh= {210,38,160,40},
	s_row_basic_tzone_xywh= {430,38,150,40},
	s_row_basic_dst_xywh= {600,38,150,40},
	s_row_basic_ipc_xywh= {770,38,150,40},
};

w1_row_basic.s_2k = 
{
	s_row_basic_time_xywh= {280,51,213,53},
	s_row_basic_tzone_xywh= {573,51,200,53},
	s_row_basic_dst_xywh= {800,51,200,53},
	s_row_basic_ipc_xywh= {1020,51,200,53},
};

w1_row_basic.s_4k = 
{
	s_row_basic_time_xywh= {420,76,320,80},
	s_row_basic_tzone_xywh= {860,76,300,80},
	s_row_basic_dst_xywh= {1200,76,300,80},
	s_row_basic_ipc_xywh= {1540,76,300,80},

};

local on_click = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local nret = w1_wnd_jump.click_row(top, w1_row_basic.wnd, win_id, false)
		if(nret == -1)then
			b_wnd_ex.set_check(top, win_id, false, false);
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

w1_row_basic.move_title_show =function(top)
	local cwnd = w1_row_basic.wnd;
	local pos = SIZE('s_cfg_row_xywh');
	local title_w =pos[3]-pos[4] 
	local size1 = b_wnd_ex.get_textsize(top, cwnd.system.id).w;
	local size2 = b_wnd_ex.get_textsize(top, cwnd.time.id).w;
	local size3 = b_wnd_ex.get_textsize(top, cwnd.tzone.id).w;
	local size4 = b_wnd_ex.get_textsize(top, cwnd.dst.id).w;
	local size5 = b_wnd_ex.get_textsize(top, cwnd.ipc.id).w;
	local space = b_wnd_ex.get_textsize(top, cwnd.system.id).border * 60 ;--
	local total_w = size1 +size2+size3+size4 + size5 + space*4
	if title_w < total_w then
		space = b_wnd_ex.get_textsize(top, cwnd.system.id).border * 40 ;--
		total_w = size1 +size2+size3+size4 + size5 + space*4
	end
	if title_w < total_w then
		space = b_wnd_ex.get_textsize(top, cwnd.system.id).border * 20 ;--
		total_w = size1 +size2+size3+size4 + size5 + space*4
	end
	local title_1 = SIZE('s_cfg_row_1')
	if(title_w > total_w)then
		local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.system.id, movepos1, false);
		local movepos2 = {title_1[1]+size1+space,title_1[2],size2,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.time.id, movepos2, false);
		local movepos3 = {title_1[1]+size1+size2+2*space,title_1[2],size3,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.tzone.id, movepos3, false);
		local movepos4 = {title_1[1]+size1+size2+size3+3*space,title_1[2],size4,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.dst.id, movepos4, false);
		local movepos5 = {title_1[1]+size1+size2+size3+size4+4*space,title_1[2],size5,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.ipc.id, movepos5, false);
	end
end

w1_row_basic.on_pre_show= function(top)
	w1_row_basic.move_title_show(top)
end
w1_row_basic.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'system', 'time', 'tzone', 'dst','ipc', 'hline'},

	system 	= {t='checktxt',	id=id+1,xywh='s_cfg_row_1',
				text='LA_SYSTEM',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click,check = true},
	time 	= {t='checktxt',	id=id+2,xywh= 's_row_basic_time_xywh',
				text='LA_DATE_TIME',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click},
	tzone 	= {t='checktxt',	id=id+3,xywh= 's_row_basic_tzone_xywh',
				text='LA_ZONE',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click},
	dst 	= {t='checktxt',	id=id+4,xywh= 's_row_basic_dst_xywh',
				text='LA_DST',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click},
	ipc 	= {t='checktxt',	id=id+5,xywh= 's_row_basic_ipc_xywh',
				text='LA_SYNC_IPC',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click},
	hline 	= {t='hline',	id=id+6,xywh='s_cfg_row_hline'}
}

return w1_row_basic
