--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_camera.row_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local w1_row_camera = {}

local on_camera = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_row_camera.wnd, win_id, true)
	end
	return 0
end

w1_row_camera.on_pre_show = function (top)
	local cwnd = w1_row_camera.wnd;
	local title_1 = SIZE('s_cfg_row_1')
	local space1 = b_wnd_ex.get_textsize(top, cwnd.camera.id).border * 60 ;--1
	local size1 = b_wnd_ex.get_textsize(top, cwnd.camera.id).w; 
	local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
	b_wnd_ex.move_ex(top, cwnd.camera.id, movepos1, false);
	local size2 = b_wnd_ex.get_textsize(top, cwnd.pro_man.id).w; 
	local movepos2 = {title_1[1]+size1+space1,title_1[2],size2,title_1[4]};
	b_wnd_ex.move_ex(top, cwnd.pro_man.id, movepos2, false);
end

w1_row_camera.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'camera','pro_man','hline'},
	camera 	= {t='checktxt',	id=id+1,xywh='s_cfg_row_x1',
				text='LA_CAMERA',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_camera, check = true},
	pro_man	= {t='checktxt',	id=id+2,xywh='s_cfg_row_3',
				text='LA_PROTOCOL_MANAGEMENT',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_camera},
	hline 	= {t='hline',	id=id+3,xywh='s_cfg_row_hline'}
}

return w1_row_camera
