--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_channel_type.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local global_val= require("wnd.global_val")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")

local w1_row_channel_type = {}

local on_channel_type = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_row_channel_type.wnd, win_id, true)
	end
	return 0
end

w1_row_channel_type.on_pre_show = function (top)
	local cwnd = w1_row_channel_type.wnd;
	local title_1 = SIZE('s_cfg_row_1')
	local space1 = b_wnd_ex.get_textsize(top, cwnd.channel_type.id).border * 60 ;--1
	local size1 = b_wnd_ex.get_textsize(top, cwnd.channel_type.id).w; 
	local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
	b_wnd_ex.move_ex(top, cwnd.channel_type.id, movepos1, false);
	local size2 = b_wnd_ex.get_textsize(top, cwnd.analog_audio_in.id).w; 
	local movepos2 = {title_1[1]+size1+space1,title_1[2],size2,title_1[4]};
	b_wnd_ex.move_ex(top, cwnd.analog_audio_in.id, movepos2, false);
	local analog_audio_in_support = global_val.get_analog_audio_in_support()
	if (false == analog_audio_in_support) then
		b_wnd_ex.set_hide(top, cwnd.analog_audio_in.id, true, false);
	end
end
w1_row_channel_type.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'channel_type', 'analog_audio_in', 'hline'},
	channel_type = {t='checktxt',	id=id+1,xywh='s_cfg_row_x1',
				text='LA_CHANNEL_TYPE',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_channel_type, check = true},
	analog_audio_in 	= {t='checktxt',	id=id+2,xywh='s_cfg_row_2',
				text='LA_COAXIAL',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_channel_type},					
	hline 	= {t='hline',	id=id+3,xywh='s_cfg_row_hline'}
}

return w1_row_channel_type
