--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_humanthermometer.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size

local w1_row_human_thermometer = {}

local on_click = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_row_human_thermometer.wnd, win_id, true)
	end
	return 0
end

w1_row_human_thermometer.on_pre_show = function (top)
	local cwnd = w1_row_human_thermometer.wnd;
	local title_1 = SIZE('s_cfg_row_1')
	local space1 = b_wnd_ex.get_textsize(top, cwnd.param_conf.id).border * 60 ;--1
	local size1 = b_wnd_ex.get_textsize(top, cwnd.param_conf.id).w; 
	local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
	b_wnd_ex.move_ex(top, cwnd.param_conf.id, movepos1, false);
	local size2 = b_wnd_ex.get_textsize(top, cwnd.thermal_map.id).w; 
	local movepos2 = {title_1[1]+size1+space1,title_1[2],size2,title_1[4]};
	b_wnd_ex.move_ex(top, cwnd.thermal_map.id, movepos2, false);
	local size3 = b_wnd_ex.get_textsize(top, cwnd.thermal_cal.id).w; 
	local movepos3 = {title_1[1]+size1+space1+size2+space1,title_1[2],size3,title_1[4]};
	b_wnd_ex.move_ex(top, cwnd.thermal_cal.id, movepos3, false);
end

w1_row_human_thermometer.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'param_conf', 'thermal_map', 'thermal_cal', 'hline'},

	param_conf 	= {t='checktxt',	id=id+1,xywh='s_cfg_row_x1',
				text='LA_PARAM_CONF',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click,check = true},
	thermal_map 	= {t='checktxt',	id=id+2,xywh='s_cfg_row_3',
				text='LA_THER_MAP',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click},
	thermal_cal 	= {t='checktxt',	id=id+3,xywh='s_cfg_row_4',
				text='LA_THER_CAL',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click},
	hline 	= {t='hline',	id=id+4,xywh='s_cfg_row_hline'}
}

return w1_row_human_thermometer
