--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/9
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id		= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_devinfo.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local b_wnd 	= require("wnd.core.b_wnd")
local global_val= require("wnd.global_val")

local w1_row_info = {}

local on_devinfo = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_row_info.wnd, win_id, true)
	end
	return 0
end

w1_row_info.move_title_show =function(top)
	local cwnd = w1_row_info.wnd;
	local pos = SIZE('s_cfg_row_xywh');
	local title_w =pos[3]-pos[4] 
	local size1 = b_wnd_ex.get_textsize(top, cwnd.devinfo.id).w;
	local size2 = b_wnd_ex.get_textsize(top, cwnd.net_work.id).w;
	local size3 = b_wnd_ex.get_textsize(top, cwnd.channel.id).w;
	local size4 = b_wnd_ex.get_textsize(top, cwnd.disk.id).w;
	local size5 = b_wnd_ex.get_textsize(top, cwnd.alarm.id).w;
	local space = b_wnd_ex.get_textsize(top, cwnd.devinfo.id).border * 60 ;--
	local total_w = size1 +size2+size3+size4 + size5 + space*4
	if title_w < total_w then
		space = b_wnd_ex.get_textsize(top, cwnd.devinfo.id).border * 40 ;--
		total_w = size1 +size2+size3+size4 + size5 + space*4
	end
	if title_w < total_w then
		space = b_wnd_ex.get_textsize(top, cwnd.devinfo.id).border * 20 ;--
		total_w = size1 +size2+size3+size4 + size5 + space*4
	end
	local title_1 = SIZE('s_cfg_row_1')
	if(title_w > total_w)then
		local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.devinfo.id, movepos1, false);
		local movepos2 = {title_1[1]+size1+space,title_1[2],size2,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.net_work.id, movepos2, false);
		local movepos3 = {title_1[1]+size1+size2+2*space,title_1[2],size3,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.channel.id, movepos3, false);
		local movepos4 = {title_1[1]+size1+size2+size3+3*space,title_1[2],size4,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.disk.id, movepos4, false);
		local movepos5 = {title_1[1]+size1+size2+size3+size4+4*space,title_1[2],size5,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.alarm.id, movepos5, false);
	end
end

w1_row_info.on_pre_show= function(top)
	w1_row_info.move_title_show(top)
	local pb_flag = global_val.get_playback_support();	
	local cwnd = w1_row_info.wnd;
	if (pb_flag ~= true) then
		b_wnd_ex.set_hide(top, cwnd.disk.id, true, false);
		local pos = b_wnd.get_wnd_a_rect(top, cwnd.disk.id);
		b_wnd_ex.move_pos(top, cwnd.alarm.id, {pos[1], pos[2]}, false);
	end
	
	local ai_num = global_val.get_sinum();
	local ro_num = global_val.get_ronum();
	if (ai_num <= 0 and ro_num <= 0) then
		b_wnd_ex.set_hide(top, cwnd.alarm.id, true, false);
	end	
end


w1_row_info.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	
	sub 	= {'devinfo','net_work', 'channel','disk','alarm',--[['record',--]]'hline'},
	devinfo	= {t='checktxt',id=id+1,xywh='s_cfg_row_1',
				text='LA_SYSTEM',font='f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_devinfo, check=true},
	net_work	= {t='checktxt',id=id+2,xywh='s_cfg_row_2',
				text='LA_NETWORK_1',font='f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_devinfo, check=false},
	channel	= {t='checktxt',id=id+3,xywh='s_cfg_row_3',
				text='LA_CHANNEL',font='f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_devinfo, check=false},
	disk	= {t='checktxt',id=id+4,xywh='s_cfg_row_4',
				text='LA_DISK',font='f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_devinfo, check=false},
	alarm	= {t='checktxt',id=id+5,xywh='s_cfg_row_5',
				text='LA_ALARM',font='f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_devinfo, check=false},
	hline 	= {t='hline',	id=id+7,xywh='s_cfg_row_hline'}
}

return w1_row_info
