--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_loss.lossrow_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")

local w1_row_lossrow = {
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_row_lossrow.s_768 =
{
	s_row_lossrow_xywh = {0,117,533,57},
	s_row_lossrow_events_xywh = {53,0,106,39},
	s_row_lossrow_timeplan_xywh = {165,0,160,39},
};

w1_row_lossrow.s_1280 = 
{
	s_row_lossrow_xywh = {0,165,1000,81},
	s_row_lossrow_events_xywh = {100,0,200,55},
	s_row_lossrow_timeplan_xywh = {310,0,300,55},
};

w1_row_lossrow.s_1440 = 
{
	s_row_lossrow_xywh = {0,145,1000,81},
	s_row_lossrow_events_xywh = {100,0,200,55},
	s_row_lossrow_timeplan_xywh = {310,0,300,55},
	
};

w1_row_lossrow.s_1080p = 
{
	s_row_lossrow_xywh = {0,165,1000,81},
	s_row_lossrow_events_xywh = {100,0,200,55},
	s_row_lossrow_timeplan_xywh = {310,0,300,55},
};

w1_row_lossrow.s_2k = 
{
	s_row_lossrow_xywh = {0,220,1333,108},
	s_row_lossrow_events_xywh = {133,0,267,73},
	s_row_lossrow_timeplan_xywh = {413,0,400,73},

};

w1_row_lossrow.s_4k = 
{
	s_row_lossrow_xywh = {0,330,2000,162},
	s_row_lossrow_events_xywh = {200,0,400,110},
	s_row_lossrow_timeplan_xywh = {620,0,600,110},
};


w1_row_lossrow.changecheck = function(top, wnd, id, redraw)
	for k,v in pairs( wnd.sub ) do
		if(wnd[v].t == 'checkbutton') then
			b_wnd_ex.set_check(top, wnd[v].id, false, redraw)
		end
	end
	b_wnd_ex.set_check(top, id, true, redraw);
	local wnd_id = w1_row_lossrow.wnd
	
	if(id  == wnd_id.events.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_loss.con_loss_id, w1_id.cfg_loss.event_id, redraw)
	elseif(id  == wnd_id.timeplan.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_loss.con_loss_id, w1_id.cfg_loss.timeplan_id, redraw)
	end
end

w1_row_lossrow.get_checkidx = function(top)
	local check = b_wnd_ex.get_check(top, w1_row_lossrow.wnd.events.id);
	if(check) then
		return 0
	else
		return 1
	end
end

local on_click = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_row_lossrow.changecheck(top, w1_row_lossrow.wnd, win_id, true);
	end
	return 0
end

w1_row_lossrow.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_row_lossrow_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'events','timeplan','hline1'},
	
	events 		= {t='checkbutton',	id=id+1,xywh = 's_row_lossrow_events_xywh',	text='LA_LINK_EVENT',		check = true,	
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_linkevents','it_linkevents', 'it_linkevents'},
				cmd=on_click},

	timeplan 	= {t='checkbutton',	id=id+2,xywh = 's_row_lossrow_timeplan_xywh',	text='LA_DETECTION_SCHEDULE',			
				align = b_ui.ALIGN.LEFT,	font = 'f_grade4',
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade4','it_timeplan','it_timeplan', 'it_timeplan'},
				cmd=on_click},	
	hline1 		= {t='hline',id=id+3,	xywh='s_cfg_lline1'},
}

return w1_row_lossrow
