--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/9/12
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_ai.multi_objrow_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local w1_row_multi_objrow = 
{
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_row_multi_objrow.s_768 =
{
	s_row_multi_objrow_xywh = {0,270,826,57},
	s_row_multi_objrow_param_xywh = {53,0,138,39},
	s_row_multi_objrow_timeplan_xywh = {194,0,138,39},
	s_row_multi_objrow_mline1 = {53,39,725,1},
	s_row_multi_objrow_titile_w = {2,0,138,0},
};

w1_row_multi_objrow.s_1280 = 
{
	s_row_multi_objrow_xywh 			= {0,380,1000,75},
	s_row_multi_objrow_param_xywh 		= {60,0,170,50},
	s_row_multi_objrow_timeplan_xywh	= {235,0,170,50},
	s_row_multi_objrow_mline1 			= {60,51,940,1},
	s_row_multi_objrow_titile_w 		= {5,0,170,0};	
};
w1_row_multi_objrow.s_1440 = 
{
	s_row_multi_objrow_xywh 			= {0,272,1100,65},
	s_row_multi_objrow_param_xywh 		= {60,0,180,50},
	s_row_multi_objrow_timeplan_xywh	= {245,0,180,50},
	s_row_multi_objrow_mline1 			= {60,51,970,1},
	s_row_multi_objrow_titile_w 		= {5,0,180,0};
};

w1_row_multi_objrow.s_1080p = 
{
	s_row_multi_objrow_xywh 			= {0,380,1550,81},
	s_row_multi_objrow_param_xywh 		= {100,0,260,55},
	s_row_multi_objrow_timeplan_xywh	= {365,0,260,55},
	s_row_multi_objrow_mline1 			= {100,56,1360,1},
	s_row_multi_objrow_titile_w 		= {5,0,260,0};
};
w1_row_multi_objrow.s_2k = 
{
	s_row_multi_objrow_xywh 			= {0,507,2076,108},
	s_row_multi_objrow_param_xywh 		= {133,0,347,73},
	s_row_multi_objrow_timeplan_xywh	= {487,0,347,73},
	s_row_multi_objrow_mline1 			= {133,75,1880,1},
	s_row_multi_objrow_titile_w 		= {7,0,347,0};
};
w1_row_multi_objrow.s_4k = 
{
	s_row_multi_objrow_xywh 			= {0,760,3100,162},
	s_row_multi_objrow_param_xywh 		= {200,0,520,110},
	s_row_multi_objrow_timeplan_xywh	= {730,0,520,110},--+170
	s_row_multi_objrow_mline1 			= {200,112,2820,2},
	s_row_multi_objrow_titile_w 		= {10,0,520,0};
};

w1_row_multi_objrow.changecheck = function(top, wnd, id,redraw)
	for k,v in pairs( wnd.sub ) do
		if(wnd[v].t == 'checkbutton') then
			b_wnd_ex.set_check(top, wnd[v].id, false, redraw)
		end
	end
	
	b_wnd_ex.set_check(top, id, true, redraw);
	local wnd_id = w1_row_multi_objrow.wnd
	
	if(id == wnd_id.param.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_ai.con_multi_obj_id, w1_id.cfg_ai.multi_obj_param_id, redraw)
	elseif(id  == wnd_id.timeplan.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_ai.con_multi_obj_id, w1_id.cfg_ai.multi_obj_timeplan_id, redraw)
	end
end

w1_row_multi_objrow.get_checkidx = function(top)
	local param_con = b_wnd_ex.get_check(top, w1_row_multi_objrow.wnd.param.id);
	local timeplan = b_wnd_ex.get_check(top, w1_row_multi_objrow.wnd.timeplan.id);
	
	if(param_con) then
		return 0
	elseif(timeplan) then
		return 1
	else 
		return -1
	end
end

local on_click = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_row_multi_objrow.changecheck(top, w1_row_multi_objrow.wnd, win_id,true);
	end
	return 0
end

w1_row_multi_objrow.move_title_show =function(top)
	local cwnd = w1_row_multi_objrow.wnd;
	local pos = SIZE('s_row_multi_objrow_xywh');
	local title_1 = SIZE('s_row_multi_objrow_param_xywh')
	local title = SIZE('s_row_multi_objrow_titile_w')
	local title_w =pos[3]-title_1[1] 
	local size1 = title[3];
	local size2 = size1;
	local space = title[1];
	local total_w = size1 + size2 + space*3
	
	if(title_w > total_w)then
		local x = title_1[1]
		local movepos1 = {x,title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.param.id, movepos1, false);
				
		x = x + size1 + space
		local movepos2 = {x,title_1[2],size2,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.timeplan.id, movepos2, false);
	end
end

w1_row_multi_objrow.on_pre_show= function(top)
	w1_row_multi_objrow.move_title_show(top)
end

w1_row_multi_objrow.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_row_multi_objrow_xywh',

	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'param','timeplan','hline1'},

	param		= {t='checkbutton',	id=id+1,xywh = 's_row_multi_objrow_param_xywh',	text='LA_PARAM_CONF',check = true,	
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},
	timeplan	= {t='checkbutton',	id=id+2,xywh = 's_row_multi_objrow_timeplan_xywh',	text='LA_TIME_PLAN',
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},
				
	hline1 		= {t='hline',id=id+4,	xywh='s_row_multi_objrow_mline1'},
}

return w1_row_multi_objrow
