--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_net.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local poe_num =nil;
local nic_num = nil;
local wifi_support = nil;
local route_support = nil
local w1_row_net = {}

local on_click = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_row_net.wnd, win_id, true)
	end
	return 0
end

w1_row_net.move_title_show= function(top)
	local cwnd = w1_row_net.wnd;
	local pos = SIZE('s_cfg_row_xywh');
	local title_w = pos[3]-pos[4]
	local title_num = 2;
	local size1 = b_wnd_ex.get_textsize(top, cwnd.ip.id).w;
	local size2 = b_wnd_ex.get_textsize(top, cwnd.port.id).w;
	local size3 = b_wnd_ex.get_textsize(top, cwnd.poe.id).w;
	local size4 = b_wnd_ex.get_textsize(top, cwnd.cctv.id).w;
	local size5 = b_wnd_ex.get_textsize(top, cwnd.wifi_cfg.id).w;
	local size6 = b_wnd_ex.get_textsize(top, cwnd.wifi_network.id).w;
	local size7 = b_wnd_ex.get_textsize(top, cwnd.eth_route.id).w;
	local vaild_w = size1 + size2	
	local id_tab = {cwnd.ip.id,  cwnd.port.id};	
	local size_tab = {size1, size2}

	if poe_num ~= 0 then
		table.insert(id_tab, cwnd.poe.id);
		table.insert(size_tab, size3);
		title_num = title_num+1;
		vaild_w = vaild_w + size3;
	else
		b_wnd_ex.set_hide(top, cwnd.poe.id, true, false);
	end

	if nic_num == 2 then
		table.insert(id_tab, cwnd.cctv.id);
		table.insert(size_tab, size4);
		title_num = title_num+1;
		vaild_w = vaild_w + size4;
	else
		b_wnd_ex.set_hide(top, cwnd.cctv.id, true, false);		
	end
	
	if  wifi_support == true then
		table.insert(id_tab, cwnd.wifi_cfg.id);
		table.insert(id_tab, cwnd.wifi_network.id);
		table.insert(size_tab, size5);
		table.insert(size_tab, size6);		
		title_num = title_num+2;
		vaild_w = vaild_w + size5 + size6;
	else
		b_wnd_ex.set_hide(top, cwnd.wifi_cfg.id, true, false);		
		b_wnd_ex.set_hide(top, cwnd.wifi_network.id, true, false);		
	end
	
	if (route_support == true) then
		table.insert(id_tab, cwnd.eth_route.id);
		table.insert(size_tab, size7);
		title_num = title_num + 1;
		vaild_w = vaild_w + size7;
	else
		b_wnd_ex.set_hide(top, cwnd.eth_route.id, true, false);		
	end
	
	local space = nil;
	local border = b_wnd_ex.get_textsize(top, cwnd.ip.id).border;
	local space1 = border * 80 ;--1
	local space2 = border * 60 ;--2
	local space3 = border * 40 ;--3
	local space4 = border * 20 ;--4
	local space5 = border * 10 ;--5
	local space6 = border * 5 ; --6
	
	if (title_w > vaild_w + (title_num -1) * space1) then
		space = space1;
	elseif (title_w > vaild_w + (title_num -1) * space2) then
		space = space2;
	elseif (title_w > vaild_w + (title_num -1) * space3) then
		space = space3;
	elseif (title_w > vaild_w + (title_num -1) * space4) then
		space = space4;
	elseif (title_w > vaild_w + (title_num -1) * space5) then
		space = space5;		
	else
		space = space6;
	end	
	
	local title_1 = SIZE('s_cfg_row_1')
	local movepos = {title_1[1],title_1[2],title_1[3],title_1[4]};
	for i = 1, #id_tab do
		movepos[3] = size_tab[i] + space
		b_wnd_ex.move_ex(top, id_tab[i], movepos, false)
		movepos[1] = movepos[1] + movepos[3];
	end
end

w1_row_net.on_pre_show = function(top)
	poe_num = global_val.get_poenum();
	nic_num = global_val.get_nic_num();
	route_support = global_val.get_route_support();	
	wifi_support = global_val.get_wifi_support();
	w1_row_net.move_title_show(top)
	if(poe_num ~= 0 and nic_num == 2 and wifi_support == true)then
		print("--------poe_num:"..poe_num.."-------nic_num:"..nic_num.."-------wifi_support:"..wifi_support);
		assert(false);
	end
end

w1_row_net.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'ip', 'port', 'poe', 'cctv','wifi_cfg','wifi_network','eth_route', 'hline'},
	
	ip		= {t='checktxt',	id=id+1,xywh='s_cfg_row_1',	
				text='LA_IP',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click, check = true},
	port	= {t='checktxt',	id=id+2,xywh='s_cfg_row_2',	
				text='LA_PORT',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click},
	poe		= {t='checktxt',	id=id+3,xywh='s_cfg_row_3',	
				text='LA_POE',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click},
	cctv		= {t='checktxt',	id=id+4,xywh='s_cfg_row_3',	
				text='LA_IPV4_CCTV',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click},
	wifi_cfg	= {t='checktxt',	id=id+5,xywh='s_cfg_row_4',	
				text='LA_WIFI_CFG',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click},					
	wifi_network= {t='checktxt',	id=id+6,xywh='s_cfg_row_5',	
				text='LA_WIFI_NETWORK',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click},	
	eth_route= {t='checktxt',	id=id+7,xywh='s_cfg_row_6',	
				text='LA_ETH_ROUTE',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click},					
	hline 	= {t='hline',	id=id+8,xywh='s_cfg_row_hline'}
}

return w1_row_net
