--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_out.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local w1_row_out = {
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_row_out.s_768 =
{
	s_row_out_cvbs_offset_xywh = {122,27,80,28},
	s_row_out_cvbs_color_xywh = {234,27,80,28},
};

w1_row_out.s_1280 = 
{
	s_row_out_cvbs_offset_xywh = {230,38,150,40},
	s_row_out_cvbs_color_xywh = {440,38,150,40},
};

w1_row_out.s_1440 = 
{
	s_row_out_cvbs_offset_xywh = {230,30,150,40},
	s_row_out_cvbs_color_xywh = {440,30,150,40},
};

w1_row_out.s_1080p = 
{
	s_row_out_cvbs_offset_xywh = {230,38,150,40},
	s_row_out_cvbs_color_xywh = {440,38,150,40},
};

w1_row_out.s_2k = 
{
	s_row_out_cvbs_offset_xywh = {307,51,200,53},
	s_row_out_cvbs_color_xywh = {587,51,200,53},

};

w1_row_out.s_4k = 
{
	s_row_out_cvbs_offset_xywh = {460,76,300,80},
	s_row_out_cvbs_color_xywh = {880,76,300,80},
};


local on_out = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local nret = w1_wnd_jump.click_row(top, w1_row_out.wnd, win_id, false)
		if(nret ~= 0)then
			b_wnd_ex.set_check(top, win_id, false, false);
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_click = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_row_out.wnd, win_id, true)
	end
	return 0
end

w1_row_out.move_title_show= function(top)
	local cwnd = w1_row_out.wnd;
	local pos = SIZE('s_cfg_row_xywh');
	local title_1 = SIZE('s_cfg_row_dwell');
	local title_w =pos[3]-title_1[4]*2
	local size1 = b_wnd_ex.get_textsize(top, cwnd.dwell.id).w;
	local size2 = b_wnd_ex.get_textsize(top, cwnd.cvbs_offset.id).w;
	local size3 = b_wnd_ex.get_textsize(top, cwnd.cvbs_color.id).w;
	local space = b_wnd_ex.get_textsize(top, cwnd.dwell.id).border * 60 ;--
	local total_w = size1 +size2+size3+space*4
	
	local space2 = b_wnd_ex.get_textsize(top, cwnd.dwell.id).border * 50 ;--
	local total_w2 = size1 +size2+size3+space2*4
	
	local space3 = b_wnd_ex.get_textsize(top, cwnd.dwell.id).border * 40 ;--
	local total_w3 = size1 +size2+size3+space3*4
	
	if(title_w > total_w)then
		local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.dwell.id, movepos1, false);
		local movepos2 = {title_1[1]+size1+space,title_1[2],size2,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.cvbs_offset.id, movepos2, false);
		local movepos3 = {title_1[1]+size1+size2+2*space,title_1[2],size3,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.cvbs_color.id, movepos3, false);
	elseif(title_w > total_w2)then
		local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.dwell.id, movepos1, false);
		local movepos2 = {title_1[1]+size1+space2,title_1[2],size2,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.cvbs_offset.id, movepos2, false);
		local movepos3 = {title_1[1]+size1+size2+2*space2,title_1[2],size3,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.cvbs_color.id, movepos3, false);
	elseif(title_w > total_w3)then
		local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.dwell.id, movepos1, false);
		local movepos2 = {title_1[1]+size1+space3,title_1[2],size2,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.cvbs_offset.id, movepos2, false);
		local movepos3 = {title_1[1]+size1+size2+2*space3,title_1[2],size3,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.cvbs_color.id, movepos3, false);
	end
end

w1_row_out.on_pre_show = function(top)
	local cvbssup = global_val.get_cvbssup();
	local cwnd = w1_row_out.wnd;
	
	if(cvbssup) then
		w1_row_out.move_title_show(top);
	else
		local title_1 = SIZE('s_cfg_row_dwell');
		local size1 = b_wnd_ex.get_textsize(top, cwnd.dwell.id).w;
		local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.dwell.id, movepos1, false);
		b_wnd_ex.set_hide(top, cwnd.cvbs_offset.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.cvbs_color.id, true, false);
	end
	
	local dev_type_ly = G.get_dev_type_ly_support();
	if (dev_type_ly == true) then --豸cvbs color
		b_wnd_ex.set_hide(top, cwnd.cvbs_color.id, true, false);
	end
end

w1_row_out.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'dwell','cvbs_offset','cvbs_color', 'hline'},
	
	dwell 		= {t='checktxt',	id=id+1,xywh='s_cfg_row_dwell',
				text='LA_LAYOUT',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_out,check = true},
	cvbs_offset = {t='checktxt',	id=id+2,xywh = 's_row_out_cvbs_offset_xywh',
				text='LA_CVBS_OFFSET',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click},
	cvbs_color 	= {t='checktxt',	id=id+3,xywh = 's_row_out_cvbs_color_xywh',
				text='LA_CVBS_COLOR',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click},
	hline 	= {t='hline',	id=id+4,xywh='s_cfg_row_hline'}
}

return w1_row_out
