--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/9/12
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_humanthermometer.param_confrow_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local w1_row_param_confrow = 
{
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_row_param_confrow.s_768 =
{
	s_row_param_confrow_xywh = {0,270,826,57},
	s_row_param_confrow_face_xywh = {53,0,114,39},
	s_row_param_confrow_temp_xywh = {170,0,114,39},
	s_row_param_confrow_l_event_xywh = {288,0,114,39},
	s_row_param_confrow_n_event_xywh = {405,0,114,39},
	s_row_param_confrow_h_event_xywh = {522,0,114,39},
	s_row_param_confrow_timeplan_xywh = {640,0,114,39},
	s_row_param_confrow_mline1 = {53,39,725,1},
	s_row_param_confrow_titile_w = {2,0,114,0},
};

w1_row_param_confrow.s_1280 = 
{
	s_row_param_confrow_xywh 			= {0,380,1000,75},
	s_row_param_confrow_face_xywh 		= {60,0,150,50},
	s_row_param_confrow_temp_xywh 		= {215,0,150,50},
	s_row_param_confrow_l_event_xywh	= {370,0,150,50},
	s_row_param_confrow_n_event_xywh	= {525,0,150,50},
	s_row_param_confrow_h_event_xywh	= {680,0,150,50},
	s_row_param_confrow_timeplan_xywh 	= {835,0,150,50},
	s_row_param_confrow_mline1 			= {60,51,940,1},
	s_row_param_confrow_titile_w 		= {5,0,100,0};	
};
w1_row_param_confrow.s_1440 = 
{
	s_row_param_confrow_xywh 			= {0,272,1120,65},
	s_row_param_confrow_face_xywh 		= {60,0,160,50},
	s_row_param_confrow_temp_xywh 		= {225,0,160,50},
	s_row_param_confrow_l_event_xywh	= {390,0,160,50},
	s_row_param_confrow_n_event_xywh	= {555,0,160,50},
	s_row_param_confrow_h_event_xywh	= {720,0,160,50},
	s_row_param_confrow_timeplan_xywh 	= {885,0,160,50},
	s_row_param_confrow_mline1 			= {60,51,1000,1},
	s_row_param_confrow_titile_w 		= {5,0,100,0};
};

w1_row_param_confrow.s_1080p = 
{
	s_row_param_confrow_xywh 			= {0,380,1550,81},
	s_row_param_confrow_face_xywh 		= {100,0,215,55},
	s_row_param_confrow_temp_xywh 		= {320,0,215,55},
	s_row_param_confrow_l_event_xywh	= {540,0,215,55},
	s_row_param_confrow_n_event_xywh	= {760,0,215,55},
	s_row_param_confrow_h_event_xywh	= {980,0,215,55},
	s_row_param_confrow_timeplan_xywh 	= {1200,0,215,55},
	s_row_param_confrow_mline1 			= {100,56,1360,1},
	s_row_param_confrow_titile_w 		= {5,0,215,0};
};
w1_row_param_confrow.s_2k = 
{
	s_row_param_confrow_xywh 			= {0,507,2076,108},
	s_row_param_confrow_face_xywh 		= {133,0,287,73},
	s_row_param_confrow_temp_xywh 		= {427,0,287,73},
	s_row_param_confrow_l_event_xywh	= {720,0,287,73},
	s_row_param_confrow_n_event_xywh	= {1013,0,287,73},
	s_row_param_confrow_h_event_xywh	= {1306,0,287,73},
	s_row_param_confrow_timeplan_xywh 	= {1600,0,287,73},
	s_row_param_confrow_mline1 			= {133,75,1880,1},
	s_row_param_confrow_titile_w 		= {7,0,287,0};
};
w1_row_param_confrow.s_4k = 
{
	s_row_param_confrow_xywh 			= {0,760,3100,162},
	s_row_param_confrow_face_xywh 		= {200,0,430,110},
	s_row_param_confrow_temp_xywh 		= {640,0,430,110},
	s_row_param_confrow_l_event_xywh	= {1080,0,430,110},
	s_row_param_confrow_n_event_xywh	= {1520,0,430,110},
	s_row_param_confrow_h_event_xywh	= {1960,0,430,110},
	s_row_param_confrow_timeplan_xywh 	= {2400,0,430,110},
	s_row_param_confrow_mline1 			= {200,112,2820,2},
	s_row_param_confrow_titile_w 		= {10,0,430,0};
};

w1_row_param_confrow.changecheck = function(top, wnd, id,redraw)
	for k,v in pairs( wnd.sub ) do
		if(wnd[v].t == 'checkbutton') then
			b_wnd_ex.set_check(top, wnd[v].id, false, redraw)
		end
	end
	
	b_wnd_ex.set_check(top, id, true, redraw);
	local wnd_id = w1_row_param_confrow.wnd
	
	if(id == wnd_id.face.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_humanthermometer.con_param_id, w1_id.cfg_humanthermometer.face_detect_id, redraw)		
	elseif(id  == wnd_id.temperature.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_humanthermometer.con_param_id, w1_id.cfg_humanthermometer.temperature_param_id, redraw)
	elseif(id  == wnd_id.l_event.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_humanthermometer.con_param_id, w1_id.cfg_humanthermometer.levent_id, redraw)
	elseif(id  == wnd_id.n_event.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_humanthermometer.con_param_id, w1_id.cfg_humanthermometer.nevent_id, redraw)
	elseif(id  == wnd_id.h_event.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_humanthermometer.con_param_id, w1_id.cfg_humanthermometer.hevent_id, redraw)
	elseif(id  == wnd_id.timeplan.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_humanthermometer.con_param_id, w1_id.cfg_humanthermometer.timeplan_id, redraw)
	end
end

w1_row_param_confrow.get_checkidx = function(top)
	local face_detect = b_wnd_ex.get_check(top, w1_row_param_confrow.wnd.face.id);
	local temperature_param = b_wnd_ex.get_check(top, w1_row_param_confrow.wnd.temperature.id);
	local levent = b_wnd_ex.get_check(top, w1_row_param_confrow.wnd.l_event.id);
	local nevent = b_wnd_ex.get_check(top, w1_row_param_confrow.wnd.n_event.id);
	local hevent = b_wnd_ex.get_check(top, w1_row_param_confrow.wnd.h_event.id);
	local timeplan = b_wnd_ex.get_check(top, w1_row_param_confrow.wnd.timeplan.id);
	
	if(face_detect) then
		return 0
	elseif(temperature_param) then
		return 1
	elseif(levent) then
		return 2
	elseif(nevent) then
		return 3
	elseif(hevent) then
		return 4
	elseif(timeplan) then
		return 5
	else 
		return -1
	end
end

local on_click = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_row_param_confrow.changecheck(top, w1_row_param_confrow.wnd, win_id,true);
	end
	return 0
end

w1_row_param_confrow.move_title_show =function(top)
	--[[local cwnd = w1_row_param_confrow.wnd;
	local pos = SIZE('s_row_param_confrow_xywh');
	local title_1 = SIZE('s_row_param_confrow_face_xywh')
	local title = SIZE('s_row_param_confrow_titile_w')
	local title_w =pos[3]-title_1[1] 
	local size1 = title[3];
	local size2 = SIZE('s_row_param_confrow_temp_xywh')[3];
	local size3 = size1;
	local size4 = size1;
	local size5 = size1;
	local space = title[1];
	local total_w = size1 + size2 + size3 + size4 + size5 + space*5
	
	if(title_w > total_w)then
		local x = title_1[1]
		local movepos1 = {x,title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.face.id, movepos1, false);
		
		x = x + size1 + space
		local movepos2 = {x,title_1[2],size2,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.temperature.id, movepos2, false);
		
		x = x + size2 + space
		local movepos3 = {x,title_1[2],size3,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.setting.id, movepos3, false);
		
		x = x + size3 + space
		local movepos4 = {x,title_1[2],size4,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.event.id, movepos4, false);
		
		x = x + size4 + space
		local movepos5 = {x,title_1[2],size5,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.timeplan.id, movepos5, false);	
	end--]]
end

w1_row_param_confrow.on_pre_show= function(top)
	w1_row_param_confrow.move_title_show(top)
end

w1_row_param_confrow.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_row_param_confrow_xywh',

	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'face','temperature','l_event','n_event','h_event','timeplan','hline1'},

	face		= {t='checkbutton',	id=id+1,xywh = 's_row_param_confrow_face_xywh',	text='LA_FACE_DETECT',check = true,	
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},

	temperature = {t='checkbutton',	id=id+2,xywh = 's_row_param_confrow_temp_xywh',	text='LA_TIME_TEMPERATURE',
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},
	l_event		= {t='checkbutton',	id=id+3,xywh = 's_row_param_confrow_l_event_xywh',	text='LA_LOW_TEMP_LINK_EVENT',			
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},
	n_event 	= {t='checkbutton',	id=id+4,xywh = 's_row_param_confrow_n_event_xywh',	text='LA_NORMAL_TEMP_LINK_EVENT',			
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},
	h_event 	= {t='checkbutton',	id=id+5,xywh = 's_row_param_confrow_h_event_xywh',	text='LA_HIGH_TEMP_LINK_EVENT',			
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},			
	timeplan	= {t='checkbutton',	id=id+6,xywh = 's_row_param_confrow_timeplan_xywh',	text='LA_TIME_PLAN',
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},
				
	hline1 		= {t='hline',id=id+7,	xywh='s_row_param_confrow_mline1'},
}

return w1_row_param_confrow
