--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/9/12
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_ai.platerow_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local w1_row_platerow = 
{
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_row_platerow.s_768 =
{
	s_row_platerow_xywh = {0,270,826,57},
	s_row_platerow_param_xywh = {53,0,138,39},
	s_row_platerow_black_white_xywh	= {194,0,138,39},	
	s_row_platerow_led_cfg_xywh		= {339,0,138,39},		
	s_row_platerow_timeplan_xywh = {480,0,138,39},	
	s_row_platerow_mline1 = {53,39,725,1},
	s_row_platerow_titile_w = {2,0,138,0},
};

w1_row_platerow.s_1280 = 
{
	s_row_platerow_xywh 			= {0,380,1000,75},
	s_row_platerow_param_xywh 		= {60,0,170,50},
	s_row_platerow_black_white_xywh	= {235,0,170,50},	
	s_row_platerow_led_cfg_xywh		= {410,0,170,50},	
	s_row_platerow_timeplan_xywh	= {585,0,170,50},
	s_row_platerow_mline1 			= {60,51,940,1},
	s_row_platerow_titile_w 		= {5,0,170,0};	
};
w1_row_platerow.s_1440 = 
{
	s_row_platerow_xywh 			= {0,272,1100,65},
	s_row_platerow_param_xywh 		= {60,0,180,50},
	s_row_platerow_black_white_xywh	= {245,0,180,50},	
	s_row_platerow_led_cfg_xywh		= {430,0,180,50},	
	s_row_platerow_timeplan_xywh	= {615,0,180,50},
	s_row_platerow_mline1 			= {60,51,970,1},
	s_row_platerow_titile_w 		= {5,0,180,0};
};

w1_row_platerow.s_1080p = 
{
	s_row_platerow_xywh 			= {0,380,1550,81},
	s_row_platerow_param_xywh 		= {100,0,260,55},
	s_row_platerow_black_white_xywh	= {365,0,260,55},	
	s_row_platerow_led_cfg_xywh		= {630,0,260,55},
	s_row_platerow_timeplan_xywh	= {895,0,260,55},
	s_row_platerow_mline1 			= {100,56,1360,1},
	s_row_platerow_titile_w 		= {5,0,260,0};
};
w1_row_platerow.s_2k = 
{
	s_row_platerow_xywh 			= {0,507,2076,108},
	s_row_platerow_param_xywh 		= {133,0,347,73},
	s_row_platerow_black_white_xywh	= {487,0,347,73},	
	s_row_platerow_led_cfg_xywh		= {841,0,347,73},
	s_row_platerow_timeplan_xywh	= {1195,0,347,73},
	s_row_platerow_mline1 			= {133,75,1880,1},
	s_row_platerow_titile_w 		= {7,0,347,0};
};
w1_row_platerow.s_4k = 
{
	s_row_platerow_xywh 			= {0,760,3100,162},
	s_row_platerow_param_xywh 		= {200,0,520,110},
	s_row_platerow_black_white_xywh	= {730,0,520,110},	
	s_row_platerow_led_cfg_xywh		= {1260,0,520,110},	
	s_row_platerow_timeplan_xywh	= {1790,0,520,110},
	s_row_platerow_mline1 			= {200,112,2820,2},
	s_row_platerow_titile_w 		= {10,0,520,0};
};

w1_row_platerow.changecheck = function(top, wnd, id,redraw)
	for k,v in pairs( wnd.sub ) do
		if(wnd[v].t == 'checkbutton') then
			b_wnd_ex.set_check(top, wnd[v].id, false, redraw)
		end
	end
	
	b_wnd_ex.set_check(top, id, true, redraw);
	local wnd_id = w1_row_platerow.wnd
	
	if(id == wnd_id.param.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_ai.con_plate_id, w1_id.cfg_ai.plate_param_id, redraw)
	elseif(id  == wnd_id.black_white_list.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_ai.con_plate_id, w1_id.cfg_ai.plate_blackwhite_id, redraw)
	elseif(id  == wnd_id.led_cfg.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_ai.con_plate_id, w1_id.cfg_ai.plate_ledcfg_id, redraw)
	elseif(id  == wnd_id.timeplan.id) then
		b_wnd_ex.set_show_page(top, w1_id.cfg_ai.con_plate_id, w1_id.cfg_ai.plate_timeplan_id, redraw)
	end
end

w1_row_platerow.get_checkidx = function(top)
	local param_con = b_wnd_ex.get_check(top, w1_row_platerow.wnd.param.id);
	local plate_blackwhite = b_wnd_ex.get_check(top, w1_row_platerow.wnd.black_white_list.id);
	local plate_ledcfg = b_wnd_ex.get_check(top, w1_row_platerow.wnd.led_cfg.id);
	local timeplan = b_wnd_ex.get_check(top, w1_row_platerow.wnd.timeplan.id);
	
	if(param_con) then
		return 0
	elseif (plate_blackwhite) then
		return 1;
	elseif (plate_ledcfg) then
		return 2
	elseif(timeplan) then
		return 3
	else 
		return -1
	end
end

local on_click = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_row_platerow.changecheck(top, w1_row_platerow.wnd, win_id,true);
	end
	return 0
end

w1_row_platerow.on_pre_show= function(top)
end

w1_row_platerow.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_row_platerow_xywh',

	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'param','black_white_list', 'led_cfg', 'timeplan','hline1'},

	param		= {t='checkbutton',	id=id+1,xywh = 's_row_platerow_param_xywh',	text='LA_PARAM_CONF',check = true,	
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},				
	black_white_list	= {t='checkbutton',	id=id+2,xywh = 's_row_platerow_black_white_xywh',	text='LA_BLACK_WHITE_LIST',
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},
	led_cfg	= {t='checkbutton',	id=id+3,xywh = 's_row_platerow_led_cfg_xywh',	text='LA_LED_SCREEN_CONFIG',
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},
	timeplan	= {t='checkbutton',	id=id+4,xywh = 's_row_platerow_timeplan_xywh',	text='LA_TIME_PLAN',
				align = b_ui.ALIGN.CENTER,	font = 'f_image',
				cmd=on_click},
				
	hline1 		= {t='hline',id=id+5,	xywh='s_row_platerow_mline1'},
}

return w1_row_platerow
