--[[
-- Copyright(c) 2018-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2019/3/14
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_smart.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_dlg 	= require("wnd.core.b_dlg")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size

local w1_row_smart = {}

local on_click = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local nret = w1_wnd_jump.click_row(top, w1_row_smart.wnd, win_id, true)
		if(nret ~= 0)then
			b_wnd_ex.set_check(top, win_id, false, false);
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

w1_row_smart.move_title_show= function(top)
	local cwnd = w1_row_smart.wnd;
	local pos = SIZE('s_cfg_row_xywh');
	local title_w =pos[3]-pos[4]

	local size1 = b_wnd_ex.get_textsize(top, cwnd.smart.id).w;
	local size2 = b_wnd_ex.get_textsize(top, cwnd.wdda.id).w;
	local space = b_wnd_ex.get_textsize(top, cwnd.smart.id).border * 60 ;--
	
	local total_w = size1 + size2 + space*2
	local title_1 = SIZE('s_cfg_row_1')
	if(title_w > total_w)then
		local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.smart.id, movepos1, false);
		
		local movepos2 = {title_1[1]+size1+space,title_1[2],size2,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.wdda.id, movepos2, false);
	end
	
	local wdda_support = G.get_wdda_support();
	if (false == wdda_support) then
		b_wnd_ex.set_hide(top, cwnd.wdda.id, true, false);
	end
	
end

w1_row_smart.on_pre_show = function(top)
	w1_row_smart.move_title_show(top)
end

w1_row_smart.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'smart', 'wdda', 'hline'},

	smart 	= {t='checktxt',	id=id+1,xywh='s_cfg_row_1',
				text='LA_SMART', font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_click,check = true},
				
	wdda 	= {t='checktxt',	id=id+2,xywh='s_cfg_row_2',
				text='WDDA', font = 'f_grade4',align = b_ui.ALIGN.LEFT,trans=false,
				cmd=on_click},
				
	hline 	= {t='hline',	id=id+3,xywh='s_cfg_row_hline'}
}

return w1_row_smart
