--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_smtp.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local r_size		= require("wnd.core.r_res.r_size")
local global_val	= require("wnd.global_val")
local SIZE 			= r_size.get_size
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_row_smtp = {}

local on_smtp = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_row_smtp.wnd, win_id, true)
	end
	return 0
end

w1_row_smtp.on_pre_show = function(top)
	local cwnd = w1_row_smtp.wnd;
	local pos = SIZE('s_cfg_row_xywh');
	local title_w =pos[3]-pos[4]

	local size1 = b_wnd_ex.get_textsize(top, cwnd.smtp.id).w;
	local size2 = b_wnd_ex.get_textsize(top, cwnd.smtp2.id).w;
	local size3 = b_wnd_ex.get_textsize(top, cwnd.immix.id).w;
	local space = b_wnd_ex.get_textsize(top, cwnd.smtp.id).border * 60 ;--
	
	local total_w = size1 + size2 + size3 + space*3
	local title_1 = SIZE('s_cfg_row_1')
	if(title_w > total_w)then
		local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.smtp.id, movepos1, false);
		
		local movepos2 = {title_1[1]+size1+space,title_1[2],size2,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.smtp2.id, movepos2, false);
		
		local movepos3 = {title_1[1]+size1+space+size2+space,title_1[2],size3,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.immix.id, movepos3, false);
	end		
	
	local immix_support = global_val.get_immix_support();
	if (immix_support == false) then
		b_wnd_ex.set_hide(top, cwnd.immix.id, true, false);
	end
end

w1_row_smtp.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'smtp','smtp2' ,'immix', 'hline'},

	smtp 	= {t='checktxt',	id=id+1,xywh='s_cfg_row_1',
				text='LA_SMTP1',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_smtp,check = true},
	smtp2 	= {t='checktxt',	id=id+2,xywh='s_cfg_row_2',
				text='LA_SMTP2',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_smtp},
	immix 	= {t='checktxt',	id=id+3,xywh='s_cfg_row_3',
				text='Immix Server',trans=false,	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_smtp},				
			
	hline 	= {t='hline',	id=id+4,xywh='s_cfg_row_hline'}
}

return w1_row_smtp
