--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/11/6
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.cfg_snmp.row_id
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size

local w1_row_snmp = {
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_row_snmp.s_768 =
{
	s_row_snmp3_xywh = {112,27,80,28},
	s_row_snmp4_xywh = {202,27,80,28},
};

w1_row_snmp.s_1280 = 
{
--	s_row_snmp12_xywh = {60,38,150,40},
	s_row_snmp3_xywh = {210,38,150,40},
	s_row_snmp4_xywh = {370,38,150,40},

};

w1_row_snmp.s_1440 = 
{
--	s_row_snmp12_xywh = {60,30,150,40},
	s_row_snmp3_xywh  = {210,30,150,40},
	s_row_snmp4_xywh = {380,38,150,40},

};

w1_row_snmp.s_1080p = 
{
--	s_row_snmp12_xywh = {60,38,150,40},
	s_row_snmp3_xywh  = {210,38,150,40},
	s_row_snmp4_xywh = {380,38,150,40},

};

w1_row_snmp.s_2k = 
{
--	s_row_snmp12_xywh = {80,51,200,53},
	s_row_snmp3_xywh= 	{280,51,200,53},
	s_row_snmp4_xywh= 	{600,51,200,53},
};

w1_row_snmp.s_4k = 
{
--	s_row_snmp12_xywh = {120,76,300,80},
	s_row_snmp3_xywh  = {420,76,300,80},
	s_row_snmp4_xywh  = {750,76,300,80},
};
local on_snmp = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_row_snmp.wnd, win_id, true)
	end
	return 0
end

w1_row_snmp.move_title_show= function(top)
	local cwnd = w1_row_snmp.wnd;
	local pos = SIZE('s_cfg_row_xywh');
	local title_w =pos[3]-pos[4] 
	local size1 = b_wnd_ex.get_textsize(top, cwnd.snmp12.id).w;
	local size2 = b_wnd_ex.get_textsize(top, cwnd.snmp3.id).w;
	local size3 = b_wnd_ex.get_textsize(top, cwnd.snmp_port.id).w;
	local space = b_wnd_ex.get_textsize(top, cwnd.snmp12.id).border * 70 ;--
	local total_w = size1 + size2 + size3 + space * 2
	local title_1 = SIZE('s_cfg_row_1')

	if(title_w > total_w)then
		local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.snmp12.id, movepos1, false);
		local movepos2 = {title_1[1]+size1+space,title_1[2],size2,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.snmp3.id, movepos2, false);
		local movepos3 = {title_1[1]+size1+size2+space*2,title_1[2],size3,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.snmp_port.id, movepos3, false);
	end

end

w1_row_snmp.on_pre_show = function(top)
	w1_row_snmp.move_title_show(top)
	b_wnd_ex.set_hide(top, w1_row_snmp.wnd.snmp_port.id,true, false)
end

w1_row_snmp.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'snmp12', 'snmp3', 'snmp_port', 'hline'},
	
	snmp12		= {t='checktxt',	id=id+1,xywh='s_cfg_row_1',	
				text='LA_SNMPV12',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_snmp, check = true},
	snmp3	= {t='checktxt',id=id+2,xywh='s_row_snmp3_xywh',	
				text='LA_SNMPV3',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_snmp},	
	snmp_port	= {t='checktxt',id=id+3,xywh='s_row_snmp4_xywh',	
				text='LA_SNMP_PORT',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_snmp},	
	
	hline 	= {t='hline',	id=id+5,xywh='s_cfg_row_hline'}
}

return w1_row_snmp
