--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/6
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.cfg_upnp.row_id
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local global_val= require("wnd.global_val")

local w1_row_upnp = {}

local on_clicked = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_row_upnp.wnd, win_id, true)
	end
	return 0
end

w1_row_upnp.on_pre_show = function (top)
	local cwnd = w1_row_upnp.wnd;
	local title_1 = SIZE('s_cfg_row_1')
	local space1 = b_wnd_ex.get_textsize(top, cwnd.upnp.id).border * 60 ;--1
	local size1 = b_wnd_ex.get_textsize(top, cwnd.upnp.id).w; 
	local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
	b_wnd_ex.move_ex(top, cwnd.upnp.id, movepos1, false);
	local size2 = b_wnd_ex.get_textsize(top, cwnd.nat_port.id).w; 
	local movepos2 = {title_1[1]+size1+space1,title_1[2],size2,title_1[4]};
	b_wnd_ex.move_ex(top, cwnd.nat_port.id, movepos2, false);
	local channel_num = global_val.get_channelnum();	
	local vi_num, dec_num = global_val.get_vi_dec_num();
	if (dec_num ~= channel_num) then --DVRNAT Port 
		b_wnd_ex.set_hide(top, cwnd.nat_port.id, true, false);
	end	
end

w1_row_upnp.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_cfg_row_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'upnp', 'nat_port', 'hline'},

	upnp 	= {t='checktxt',	id=id+1,xywh='s_cfg_row_x1',
				text='LA_PORT_MAP',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_clicked,check = true},
	nat_port 	= {t='checktxt',	id=id+2,xywh='s_cfg_row_3',
				text='LA_NAT_PORT',font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_clicked},				
	hline 	= {t='hline',	id=id+3,xywh='s_cfg_row_hline'}
}

return w1_row_upnp
