﻿local global_val= require("wnd.global_val")
local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.activation.activation_id
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local w1_forget	= require("wnd.w1_live.w1_forget")
local b_app_cfg	= require("wnd.core.b_app_cfg")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local w1_legal 	= require("wnd.w1_util.w1_legal")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local util 		= require("wnd.core.util")
local err_login_pwd_error = -508;
local err_login_user_lock = -515;
local err_stat = 0;
local err_str;
local flag = 0;
		
local LANGUAGE = {};
local LANGUAGE_LIST = {};
local language_str = {
  english 		="English",
  chinese		="简体中文",
  russian		="русский",
  french		="Français",
  japanese		="日本語",
  german		="Deutsche",
  spanish		="Español",
  portuguese	="Português",
  polish		="Polskie",
  arabic		="العربية",
  bosnian		="Bosanski",
  bulgarian		="български",
  catalan		="Català",
  chinese_t		="繁體中文",
  croatian		="Hrvatski",
  czech			="Čeština",
  danish		="Dansk",
  dutch			="Nederlands",
  estonian		="Eesti keel",
  farsi			="فارسی",
  filipino		="Filipino",
  finnish		="Suomalainen",
  greek			="Ελληνικά",
  hebrew		="עברית",
  hungarian		="Magyar",
  italian		="Italiano",
  korean		="한국어",
  latvian		="Latviešu valoda",
  lithuanian	="Lietuviškai",
  romanian		="Românesc",
  serbian		="Српски",
  slovakia		="Slovensko",
  slovenian		="Slovenščina",
  swedish		="Svenska",
  thai			="ไทย",
  turkish		="Türk dili",
  ukrainian		="Українська",
  vietnamese	="Tiếng Việt",
  norwegian		="Norsk språk",
  indonesian	="Indonesian"
}
	

local all_security_question_str ={
	[1]='',	[2]='',	[3]='',	[4]='',	[5]='',	[6]='',	[7]='',	[8]='',
}

local all_guide_answer_str = {
	[1]='',	[2]='',	[3]='',	[4]='',	[5]='',	[6]='',	[7]='',	[8]='',
}

local question1_str = {
	[1]='',	[2]='',	[3]='',	[4]='',	[5]='',	[6]='',
};

local question2_str = {
	[1]='',	[2]='',	[3]='',	[4]='',	[5]='',	[6]='',
};

local question3_str = {
	[1]='',	[2]='',	[3]='',	[4]='',	[5]='',	[6]='',
};

local w1_activation = {
	t = w1_key.DLG_ACTIVATION,
	top = nil,
	dlg = nil,
	mouse_last_opt_time,		--鼠标上次操作时间
	err_tip_time,				--错误提示时间
	w1_page_modify_g,			--图案保留时间
	pattern_pwd,
	pattern_stat,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_activation.s_768 =
{
	s_activation_page_xywh = {330,138,362,519},
	s_activation_titlestr_xywh = {5,3,352,32},
	s_activation_cap_language_xywh = {5,71,181,32},
	s_activation_t_language_xywh = {192,71,144,32},
	s_activation_cap_user_xywh = {5,113,181,32},
	s_activation_t_user_xywh = {192,113,144,32},
	s_activation_cap_newpass_xywh = {5,156,181,32},
	s_activation_t_newpass_xywh = {192,156,144,32},
	s_activation_cap_conpass_xywh = {5,199,181,32},
	s_activation_t_conpass_xywh = {192,199,144,32},
	s_activation_cap_chn_pwd_xywh = {5,241,181,32},
	s_activation_t_chn_pwd_xywh = {192,241,144,32},
	s_activation_info1_xywh = {5,284,341,35},
	s_activation_info2_xywh = {5,320,341,35},
	s_activation_info3_xywh = {5,355,341,35},
	s_activation_info4_xywh = {5,391,341,35},
	s_activation_tipinfo_xywh = {5,426,341,32},
	s_activation_ok_xywh = {117,462,128,32},
	s_activation_draw_xywh = {1,35,1,1},
	s_activation_pattern_xywh = {98,113,165,220},
	s_activation_p_info_xywh = {98,355,165,32},
	s_activation_p_ok_xywh = {10,462,106,32},
	s_activation_p_repeat_xywh = {128,462,106,32},
	s_activation_p_skip_xywh = {245,462,106,32},
	s_activation_m_ok_xywh = {69,462,106,32},
	s_activation_m_skip_xywh = {186,462,106,32},
	s_activation_cap_answer3_xywh = {5,284,181,32},
	s_activation_t_answer3_xywh = {192,284,144,32},
};

w1_activation.s_1280 = 
{
	s_activation_page_xywh			= {300,167,680,730},
	s_activation_titlestr_xywh		= {10,5,660,45},
	s_activation_cap_language_xywh	= {10,100,340,45},
	s_activation_t_language_xywh	= {360,100,270,45},
	s_activation_cap_user_xywh		= {10,160,340,45},
	s_activation_t_user_xywh		= {360,160,270,45},
	s_activation_cap_newpass_xywh	= {10,220,340,45},
	s_activation_t_newpass_xywh		= {360,220,270,45},
	s_activation_cap_conpass_xywh	= {10,280,340,45},
	s_activation_t_conpass_xywh		= {360,280,270,45},
	s_activation_cap_chn_pwd_xywh	= {10,340,340,45},
	s_activation_t_chn_pwd_xywh		= {360,340,270,45},
	s_activation_info1_xywh			= {10,400,640,50},	
	s_activation_info2_xywh			= {10,450,640,50},	
	s_activation_info3_xywh			= {10,500,640,50},
	s_activation_info4_xywh			= {10,550,640,50},
	s_activation_tipinfo_xywh		= {10,600,640,45},
	s_activation_ok_xywh			= {220,650,240,45},
	s_activation_draw_xywh			= {1,50,2,1},
	s_activation_pattern_xywh		= {185,160,310,310},
	s_activation_p_info_xywh		= {185,500,310,45},
	s_activation_p_ok_xywh			= {20,650,200,45},
	s_activation_p_repeat_xywh		= {240,650,200,45},
	s_activation_p_skip_xywh		= {460,650,200,45},
	s_activation_m_ok_xywh			= {130,650,200,45},
	s_activation_m_skip_xywh		= {350,650,200,45},
	s_activation_cap_answer3_xywh	= {10,400,340,45},
	s_activation_t_answer3_xywh		= {360,400,270,45},
};
w1_activation.s_1440 = 
{
	s_activation_page_xywh			= {380,105,680,730},
	s_activation_titlestr_xywh		= {10,5,660,45},
	s_activation_cap_language_xywh	= {10,100,340,45},
	s_activation_t_language_xywh	= {360,100,270,45},	
	s_activation_cap_user_xywh		= {10,160,340,45},
	s_activation_t_user_xywh		= {360,160,270,45},
	s_activation_cap_newpass_xywh	= {10,220,340,45},
	s_activation_t_newpass_xywh		= {360,220,270,45},
	s_activation_cap_conpass_xywh	= {10,280,340,45},
	s_activation_t_conpass_xywh		= {360,280,270,45},
	s_activation_cap_chn_pwd_xywh	= {10,340,340,45},
	s_activation_t_chn_pwd_xywh		= {360,340,270,45},
	s_activation_info1_xywh			= {10,400,640,50},	
	s_activation_info2_xywh			= {10,450,640,50},	
	s_activation_info3_xywh			= {10,500,640,50},
	s_activation_info4_xywh			= {10,550,640,50},
	s_activation_tipinfo_xywh		= {10,600,640,45},
	s_activation_ok_xywh			= {220,650,240,45},
	s_activation_draw_xywh			= {1,50,2,1},
	s_activation_pattern_xywh		= {185,160,310,310},
	s_activation_p_info_xywh		= {185,500,310,45},
	s_activation_p_ok_xywh			= {20,650,200,45},
	s_activation_p_repeat_xywh		= {240,650,200,45},
	s_activation_p_skip_xywh		= {460,650,200,45},
	s_activation_m_ok_xywh			= {130,650,200,45},
	s_activation_m_skip_xywh		= {350,650,200,45},
	s_activation_cap_answer3_xywh	= {10,400,340,45},
	s_activation_t_answer3_xywh		= {360,400,270,45},	
};
w1_activation.s_1080p = 
{
	s_activation_page_xywh			= {620,195,680,730},
	s_activation_titlestr_xywh		= {10,5,660,45},
	s_activation_cap_language_xywh	= {10,100,340,45},
	s_activation_t_language_xywh	= {360,100,270,45},		
	s_activation_cap_user_xywh		= {10,160,340,45},
	s_activation_t_user_xywh		= {360,160,270,45},
	s_activation_cap_newpass_xywh	= {10,220,340,45},
	s_activation_t_newpass_xywh		= {360,220,270,45},
	s_activation_cap_conpass_xywh	= {10,280,340,45},
	s_activation_t_conpass_xywh		= {360,280,270,45},
	s_activation_cap_chn_pwd_xywh	= {10,340,340,45},
	s_activation_t_chn_pwd_xywh		= {360,340,270,45},
	s_activation_info1_xywh			= {10,400,640,50},
	s_activation_info2_xywh			= {10,450,640,50},
	s_activation_info3_xywh			= {10,500,640,50},
	s_activation_info4_xywh			= {10,550,640,50},
	s_activation_tipinfo_xywh		= {10,600,640,45},
	s_activation_ok_xywh			= {220,650,240,45},
	s_activation_draw_xywh			= {1,50,2,1},
	s_activation_pattern_xywh		= {185,160,310,310},
	s_activation_p_info_xywh		= {185,500,310,45},
	s_activation_p_ok_xywh			= {20,650,200,45},
	s_activation_p_repeat_xywh		= {240,650,200,45},
	s_activation_p_skip_xywh		= {460,650,200,45},
	s_activation_m_ok_xywh			= {130,650,200,45},
	s_activation_m_skip_xywh		= {350,650,200,45},
	s_activation_cap_answer3_xywh	= {10,400,340,45},
	s_activation_t_answer3_xywh		= {360,400,270,45},	
};
w1_activation.s_2k = 
{
	s_activation_page_xywh			= {826,260,906,974},
	s_activation_titlestr_xywh		= {13,7,880,60},
	s_activation_cap_language_xywh	= {13,133,453,60},
	s_activation_t_language_xywh	= {480,133,360,60},
	s_activation_cap_user_xywh		= {13,213,453,60},
	s_activation_t_user_xywh		= {480,213,360,60},
	s_activation_cap_newpass_xywh	= {13,293,453,60},
	s_activation_t_newpass_xywh		= {480,293,360,60},
	s_activation_cap_conpass_xywh	= {13,373,453,60},
	s_activation_t_conpass_xywh		= {480,373,360,60},
	s_activation_cap_chn_pwd_xywh	= {13,453,453,60},
	s_activation_t_chn_pwd_xywh		= {480,453,360,60},
	s_activation_info1_xywh			= {13,533,853,67},
	s_activation_info2_xywh			= {13,600,853,67},
	s_activation_info3_xywh			= {13,667,853,67},	
	s_activation_info4_xywh			= {13,733,853,67},
	s_activation_tipinfo_xywh		= {13,800,853,60},
	s_activation_ok_xywh			= {293,867,360,60},
	s_activation_draw_xywh			= {1,67,3,1},
	s_activation_pattern_xywh		= {247,133,413,413},
	s_activation_p_info_xywh		= {247,667,413,60},
	s_activation_p_ok_xywh			= {27,867,267,60},
	s_activation_p_repeat_xywh		= {320,867,267,60},
	s_activation_p_skip_xywh		= {613,867,267,60},	
	s_activation_m_ok_xywh			= {173,867,267,60},
	s_activation_m_skip_xywh		= {467,867,267,60},
	s_activation_cap_answer3_xywh	= {13,533,453,60},
	s_activation_t_answer3_xywh		= {480,533,360,60},	
};
w1_activation.s_4k = 
{
	s_activation_page_xywh			= {1240,390,1360,1460},
	s_activation_titlestr_xywh		= {20,10,1320,90},
	s_activation_cap_language_xywh	= {20,200,680,90},
	s_activation_t_language_xywh	= {720,200,540,90},	
	s_activation_cap_user_xywh		= {20,320,680,90},
	s_activation_t_user_xywh		= {720,320,540,90},
	s_activation_cap_newpass_xywh	= {20,440,680,90},
	s_activation_t_newpass_xywh		= {720,440,540,90},
	s_activation_cap_conpass_xywh	= {20,560,680,90},
	s_activation_t_conpass_xywh		= {720,560,540,90},
	s_activation_cap_chn_pwd_xywh	= {20,680,680,90},
	s_activation_t_chn_pwd_xywh		= {720,680,540,90},
	s_activation_info1_xywh			= {20,800,1280,100},
	s_activation_info2_xywh			= {20,900,1280,100},
	s_activation_info3_xywh			= {20,1000,1280,100},	
	s_activation_info4_xywh			= {20,1100,1280,100},
	s_activation_tipinfo_xywh		= {20,1200,1280,90},
	s_activation_ok_xywh			= {440,1300,480,90},
	s_activation_draw_xywh			= {2,100,4,2},
	s_activation_pattern_xywh		= {370,200,620,620},
	s_activation_p_info_xywh		= {370,1000,620,90},
	s_activation_p_ok_xywh			= {40,1300,400,90},
	s_activation_p_repeat_xywh		= {480,1300,400,90},
	s_activation_p_skip_xywh		= {920,1300,400,90},	
	s_activation_m_ok_xywh			= {260,1300,400,90},
	s_activation_m_skip_xywh		= {700,1300,400,90},
	s_activation_cap_answer3_xywh	= {20,800,680,90},
	s_activation_t_answer3_xywh		= {720,800,540,90},	
};
local set_hide=function(top,index)
	if index == 0 then
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_language.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_languaget.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_user.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_user.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_newpass.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_newpass.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_conpass.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_conpass.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_chn_pwd.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_chn_pwd.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.info1.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.info2.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.info3.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.info4.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.ok.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.pattern.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.p_info.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.p_ok.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.p_repeat.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.p_skip.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_email.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_email.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.m_ok.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.m_skip.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_question1.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_question1.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_answer1.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_answer1.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_question2.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_question2.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_answer2.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_answer2.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_question3.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_question3.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_answer3.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_answer3.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.q_ok.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.q_skip.id,true,false);
	elseif index == 1 then
		b_wnd_ex.set_disable(top,w1_activation.dlg.p_ok.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_language.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_languaget.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_user.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_user.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_newpass.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_newpass.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_conpass.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_conpass.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_chn_pwd.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_chn_pwd.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.info1.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.info2.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.info3.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.info4.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.ok.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.pattern.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.p_info.id,false,false);
		b_wnd_ex.set_text(top,w1_activation.dlg.p_info.id,STR('LA_DRAW_PATTERN'),false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.p_ok.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.p_repeat.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.p_skip.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_email.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_email.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.m_ok.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.m_skip.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_question1.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_question1.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_answer1.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_answer1.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_question2.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_question2.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_answer2.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_answer2.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_question3.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_question3.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_answer3.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_answer3.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.q_ok.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.q_skip.id,true,false);	
	elseif index == 2 then
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_language.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_languaget.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_user.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_user.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_newpass.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_newpass.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_conpass.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_conpass.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_chn_pwd.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_chn_pwd.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.info1.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.info2.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.info3.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.info4.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.ok.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.pattern.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.p_info.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.p_ok.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.p_repeat.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.p_skip.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_email.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_email.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.m_ok.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.m_skip.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_question1.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_question1.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_answer1.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_answer1.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_question2.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_question2.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_answer2.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_answer2.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_question3.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_question3.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_answer3.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_answer3.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.q_ok.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.q_skip.id,true,false);			
	else
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_language.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_languaget.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_user.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_user.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_newpass.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_newpass.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_conpass.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_conpass.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_chn_pwd.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_chn_pwd.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.info1.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.info2.id,true,false);
		b_wnd_ex.set_text(top,w1_activation.dlg.info3.id,STR('LA_ANSWER_RULE1'),false);
		b_wnd_ex.set_text(top,w1_activation.dlg.info4.id,STR('LA_ANSWER_RULE2'),false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.info3.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.info4.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.ok.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.pattern.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.p_info.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.p_ok.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.p_repeat.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.p_skip.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_email.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_email.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.m_ok.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.m_skip.id,true,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_question1.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_question1.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_answer1.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_answer1.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_question2.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_question2.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_answer2.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_answer2.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_question3.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_question3.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.cap_answer3.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.t_answer3.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.q_ok.id,false,false);
		b_wnd_ex.set_hide(top,w1_activation.dlg.q_skip.id,false,false);		
	end
end

local on_language= function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local idx = b_wnd_ex.get_sel(top, w1_activation.dlg.t_languaget.id);
		b_app_api.language_change(LANGUAGE[idx+1]);
		local path = "language/"..LANGUAGE[idx+1]..".json"
		r_str.load(path)	
		local pwd_rule = b_app_api.get_cfg({'pwd_rule_info'}).pwd_rule_info
		local str_info_tmp = string.gsub(STR('LA_PASSWORD_RULE2'), '*' ,pwd_rule.pwd_min_len); 
		local str_info = string.gsub(str_info_tmp, '@' ,pwd_rule.pwd_max_len); 
		b_wnd_ex.set_text(top, w1_activation.dlg.titlestr.id,STR('LA_ACTIVATE_ENABLE'),false)
		b_wnd_ex.set_text(top, w1_activation.dlg.cap_language.id,STR('LA_LANGUAGE'),false)
		b_wnd_ex.set_text(top, w1_activation.dlg.cap_user.id,STR('LA_USER_NAME'),false)
		b_wnd_ex.set_text(top, w1_activation.dlg.cap_newpass.id,STR('LA_CREATE_PWD'),false)
		b_wnd_ex.set_text(top, w1_activation.dlg.cap_conpass.id,STR('LA_NEW_CONFIRM'),false)
		b_wnd_ex.set_text(top, w1_activation.dlg.cap_chn_pwd.id,STR('LA_CHANNEL_PWD'),false)
		b_wnd_ex.set_guide_text(top,w1_activation.dlg.t_newpass.id,STR('LA_PASSWORD'),false);
		b_wnd_ex.set_guide_text(top,w1_activation.dlg.t_conpass.id,STR('LA_PASSWORD'),false);
		b_wnd_ex.set_guide_text(top,w1_activation.dlg.t_chn_pwd.id,STR('LA_PASSWORD'),false);
		b_wnd_ex.set_text(top, w1_activation.dlg.info1.id,str_info,false)
		b_wnd_ex.set_text(top, w1_activation.dlg.info2.id,STR('LA_PWD_RULE'),false)
		b_wnd_ex.set_text(top, w1_activation.dlg.info3.id,STR('LA_INPUT_RULE1'),false)
		b_wnd_ex.set_text(top, w1_activation.dlg.pattern.id,STR('LA_SET_PATTERN'),false);
		b_wnd_ex.set_text(top, w1_activation.dlg.p_repeat.id,STR('LA_REPEAT'),false);
		b_wnd_ex.set_text(top, w1_activation.dlg.p_skip.id,STR('LA_SKIP_STEP'),false);
		b_wnd_ex.set_text(top, w1_activation.dlg.cap_email.id,STR('LA_EMAIL_ADDR'),false);
		b_wnd_ex.set_text(top, w1_activation.dlg.m_skip.id,STR('LA_SKIP_STEP'),false);
		b_wnd_ex.set_text(top, w1_activation.dlg.cap_question1.id,STR('LA_FIRST_QUESTION'),false);
		b_wnd_ex.set_text(top, w1_activation.dlg.cap_answer1.id,STR('LA_ANSWER_ONE'),false);
		b_wnd_ex.set_text(top, w1_activation.dlg.cap_question2.id,STR('LA_SECOND_QUESTION'),false);
		b_wnd_ex.set_text(top, w1_activation.dlg.cap_answer2.id,STR('LA_ANSWER_TWO'),false);
		b_wnd_ex.set_text(top, w1_activation.dlg.cap_question3.id,STR('LA_THIRD_QUESTION'),false);
		b_wnd_ex.set_text(top, w1_activation.dlg.cap_answer3.id,STR('LA_ANSWER_THREE'),false);
		b_wnd_ex.set_text(top, w1_activation.dlg.q_skip.id,STR('LA_SKIP_STEP'),false);
		b_wnd_ex.set_text(top, w1_activation.dlg.ok.id,STR('LA_OK'),false);
		b_wnd_ex.set_text(top, w1_activation.dlg.p_ok.id,STR('LA_OK'),false);
		b_wnd_ex.set_text(top, w1_activation.dlg.m_ok.id,STR('LA_OK'),false);
		b_wnd_ex.set_text(top, w1_activation.dlg.q_ok.id,STR('LA_OK'),false);
		all_security_question_str[1]=STR('LA_SEC_QUE_1')
		all_security_question_str[2]=STR('LA_SEC_QUE_2')
		all_security_question_str[3]=STR('LA_SEC_QUE_3')
		all_security_question_str[4]=STR('LA_SEC_QUE_4')
		all_security_question_str[5]=STR('LA_SEC_QUE_5')
		all_security_question_str[6]=STR('LA_SEC_QUE_6')
		all_security_question_str[7]=STR('LA_SEC_QUE_7')
		all_security_question_str[8]=STR('LA_SEC_QUE_8')
		question1_str[1]=STR('LA_SEC_QUE_1')
		question1_str[2]=STR('LA_SEC_QUE_4')
		question1_str[3]=STR('LA_SEC_QUE_5')
		question1_str[4]=STR('LA_SEC_QUE_6')
		question1_str[5]=STR('LA_SEC_QUE_7')
		question1_str[6]=STR('LA_SEC_QUE_8')
		question2_str[1]=STR('LA_SEC_QUE_2')
		question2_str[2]=STR('LA_SEC_QUE_4')
		question2_str[3]=STR('LA_SEC_QUE_5')
		question2_str[4]=STR('LA_SEC_QUE_6')
		question2_str[5]=STR('LA_SEC_QUE_7')
		question2_str[6]=STR('LA_SEC_QUE_8')
		question3_str[1]=STR('LA_SEC_QUE_3')
		question3_str[2]=STR('LA_SEC_QUE_4')
		question3_str[3]=STR('LA_SEC_QUE_5')
		question3_str[4]=STR('LA_SEC_QUE_6')
		question3_str[5]=STR('LA_SEC_QUE_7')
		question3_str[6]=STR('LA_SEC_QUE_8')
		b_wnd_ex.set_items(top,w1_activation.dlg.t_question1.id,question1_str,false);
		b_wnd_ex.set_sel(top,w1_activation.dlg.t_question1.id,0,false);
		b_wnd_ex.set_items(top,w1_activation.dlg.t_question2.id,question2_str,false);
		b_wnd_ex.set_sel(top,w1_activation.dlg.t_question2.id,0,false);
		b_wnd_ex.set_items(top,w1_activation.dlg.t_question3.id,question3_str,false);
		b_wnd_ex.set_sel(top,w1_activation.dlg.t_question3.id,0,false);	
		b_dlg.dlg_set_redraw(top)
		return b_ui.WM_USER_UPDATE_LOGIN_LANGUARE;
	end
	return 0
end

local on_ok =function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local ret = b_app_api.get_act_stat();
		if ret.ret ~= -1 then
			b_dlg.end_modal(top)
			return 0;
		end			
		
		local cwnd = w1_activation.dlg;
		local newpass = b_wnd_ex.get_password(top, cwnd.t_newpass.id)		
		local conpass = b_wnd_ex.get_password(top, cwnd.t_conpass.id)		
		local chnpwd = b_wnd_ex.get_password(top, cwnd.t_chn_pwd.id)
		if("" == newpass)then
			flag = 1;
			b_wnd_ex.set_color(top,cwnd.t_newpass.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top,cwnd.t_newpass.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
		end
		--如果输入确认新密码为空
		if("" == conpass)then
			flag = 1;
			b_wnd_ex.set_color(top,cwnd.t_conpass.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top,cwnd.t_conpass.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
		end
		
		if flag == 1 then
			b_dlg.dlg_set_redraw(top)
			return 0;
		end
		--如果输入两次新密码不一致
		if(newpass ~= conpass)then
			b_wnd_ex.set_color(top,cwnd.t_newpass.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top,cwnd.t_newpass.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
			b_wnd_ex.set_color(top,cwnd.t_conpass.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top,cwnd.t_conpass.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
			b_wnd_ex.set_text(top,cwnd.tipinfo.id,STR('LA_PWD_NO_SAME'),false);
			b_dlg.dlg_set_redraw(top)
			return 0
		end	
		local pwd_rule = b_app_api.get_cfg({'pwd_rule_info'}).pwd_rule_info
		local pwd_min_len = string.gsub(STR('LA_PWD_MIN_RULE'), '*' ,pwd_rule.pwd_min_len); 
		local pwd_max_len = string.gsub(STR('LA_PWD_MAX_RULE'), '*' ,pwd_rule.pwd_max_len); 		
		local result = b_app_api.user_activation(newpass,chnpwd);
		assert(result ~= nil and "table" == type(result))
		if (result.ret == -519) then
			flag = 1;
			b_wnd_ex.set_color(top,cwnd.t_newpass.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top,cwnd.t_newpass.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
			b_wnd_ex.set_color(top,cwnd.t_conpass.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top,cwnd.t_conpass.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
			b_wnd_ex.set_text(top,cwnd.tipinfo.id,pwd_min_len,false);
			b_dlg.dlg_set_redraw(top)
			return 0;
		elseif(result.ret == -521) then
			flag = 1;
			b_wnd_ex.set_color(top,cwnd.t_newpass.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top,cwnd.t_newpass.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
			b_wnd_ex.set_color(top,cwnd.t_conpass.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top,cwnd.t_conpass.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
			b_wnd_ex.set_text(top,cwnd.tipinfo.id,STR('LA_PWD_LOW'),false);
			b_dlg.dlg_set_redraw(top)
			return 0;
		elseif(result.ret == -522) then
			flag = 1;
			b_wnd_ex.set_color(top,cwnd.t_newpass.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},true)
			b_wnd_ex.set_color_f(top,cwnd.t_newpass.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
			b_wnd_ex.set_color(top,cwnd.t_conpass.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},true)
			b_wnd_ex.set_color_f(top,cwnd.t_conpass.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
			b_wnd_ex.set_text(top,cwnd.tipinfo.id,STR('LA_PASSWORD_TIP'),false);
			b_dlg.dlg_set_redraw(top)
			return 0;
		elseif(result.ret == -542) then
			flag = 1;
			b_wnd_ex.set_color(top,cwnd.t_newpass.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top,cwnd.t_newpass.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
			b_wnd_ex.set_color(top,cwnd.t_conpass.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top,cwnd.t_conpass.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
			b_wnd_ex.set_text(top,cwnd.tipinfo.id,STR('LA_ROLE_NAME1'),false);
			b_dlg.dlg_set_redraw(top)
			return 0;
		elseif(result.ret == -545) then
			flag = 1;
			b_wnd_ex.set_color(top,cwnd.t_newpass.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top,cwnd.t_newpass.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
			b_wnd_ex.set_color(top,cwnd.t_conpass.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top,cwnd.t_conpass.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
			b_wnd_ex.set_text(top,cwnd.tipinfo.id,pwd_max_len,false);
			b_dlg.dlg_set_redraw(top)
			return 0;
		elseif(result.ret == -546) then
			flag = 1;
			b_wnd_ex.set_color(top,cwnd.t_newpass.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top,cwnd.t_newpass.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
			b_wnd_ex.set_color(top,cwnd.t_conpass.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top,cwnd.t_conpass.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
			b_wnd_ex.set_text(top,cwnd.tipinfo.id,STR('LA_PWD_RULE_TIP1'),false);
			b_dlg.dlg_set_redraw(top)
			return 0;
		elseif(result.ret == -547) then
			flag = 1;
			b_wnd_ex.set_color(top,cwnd.t_newpass.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top,cwnd.t_newpass.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
			b_wnd_ex.set_color(top,cwnd.t_conpass.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top,cwnd.t_conpass.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
			b_wnd_ex.set_text(top,cwnd.tipinfo.id,STR('LA_PWD_REQ_TIP'),false);
			b_dlg.dlg_set_redraw(top)
			return 0;
		elseif(result.ret ~= 0) then
			b_wnd_ex.set_text(top,cwnd.tipinfo.id,STR('LA_APPLY_FAIL'),false);
			b_dlg.dlg_set_redraw(top)
			return 0;
		end
		
		set_hide(top,1);
		b_wnd_ex.set_text(top,cwnd.titlestr.id,STR('LA_PATTERN'),false);
		b_dlg.dlg_set_redraw(top)
	end
	
	return 0;
end

local on_pattern =function(top, win_id, vmsg, x, y)
	if (b_ui.WM_USER_UPDATE_PARAM == vmsg) then
		local number = b_wnd_ex.get_pattern_num(top,w1_activation.dlg.pattern.id);
		local password = '';
		for i=1, number.count do
			password = password..number.num[i]
		end
		
		if(w1_activation.pattern_pwd ~= '') then
			if w1_activation.pattern_pwd == password then
				b_wnd_ex.set_disable(top,w1_activation.dlg.p_ok.id,false,false);
				b_wnd_ex.set_text(top,w1_activation.dlg.p_info.id,'',false);
				b_dlg.dlg_set_redraw(top)
			else
				flag = 1;
				w1_activation.w1_page_modify_g = os.time();
				w1_activation.pattern_pwd = ''
				b_wnd_ex.set_pattern_error(top,w1_activation.dlg.pattern.id,false);
				b_wnd_ex.set_text(top,w1_activation.dlg.tipinfo.id,STR('LA_PATTERN_SAME'),false);
				b_wnd_ex.set_text(top,w1_activation.dlg.p_info.id,'',false);
				b_wnd_ex.set_text(top,w1_activation.dlg.p_info.id,STR('LA_DRAW_PATTERN'),false);
				b_dlg.dlg_set_redraw(top)
			end
		else
			w1_activation.w1_page_modify_g = os.time();
			w1_activation.pattern_pwd = password;
			b_wnd_ex.set_text(top,w1_activation.dlg.p_info.id,STR('LA_DRAW_AGAIN'),false);
			b_dlg.dlg_set_redraw(top)
		end
	end
	return 0;
end

local check_pattern =function(top)
	local number = b_wnd_ex.get_pattern_num(top,w1_activation.dlg.pattern.id);
	local password = '';
	for i=1, number.count do
		password = password..number.num[i]
	end
	
	if(w1_activation.pattern_pwd ~= '') then
		if w1_activation.pattern_pwd == password then
			b_wnd_ex.set_disable(top,w1_activation.dlg.p_ok.id,false,false);
			b_wnd_ex.set_text(top,w1_activation.dlg.p_info.id,'',false);
			b_dlg.dlg_set_redraw(top)
		else
			flag = 1;
			w1_activation.w1_page_modify_g = os.time();
			w1_activation.pattern_pwd = ''
			b_wnd_ex.set_pattern_error(top,w1_activation.dlg.pattern.id,false);
			b_wnd_ex.set_text(top,w1_activation.dlg.tipinfo.id,STR('LA_PATTERN_SAME'),false);
			b_wnd_ex.set_text(top,w1_activation.dlg.p_info.id,'',false);
			b_wnd_ex.set_text(top,w1_activation.dlg.p_info.id,STR('LA_DRAW_PATTERN'),false);
			b_dlg.dlg_set_redraw(top)
		end
	else
		w1_activation.w1_page_modify_g = os.time();
		w1_activation.pattern_pwd = password;
		b_wnd_ex.set_text(top,w1_activation.dlg.p_info.id,STR('LA_DRAW_AGAIN'),false);
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local on_p_ok =function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local user = global_val.get_root_user_name();
		local result = b_app_api.user_activation_g(user,w1_activation.pattern_pwd);
		local cwnd = w1_activation.dlg;
		assert(result ~= nil and "table" == type(result))
		if(result.ret ~= 0) then
			b_wnd_ex.set_text(top,cwnd.tipinfo.id,STR('LA_APPLY_FAIL'),false);
			b_dlg.dlg_set_redraw(top)
			return 0;
		end
		b_wnd_ex.set_text(top,cwnd.titlestr.id,STR('LA_RECV_PWD_EMAIL'),false);
		set_hide(top,2);
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local on_repeat =function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_wnd_ex.pattern_clear(top,w1_activation.dlg.pattern.id,false);
		w1_activation.pattern_pwd = ''
		b_wnd_ex.set_disable(top,w1_activation.dlg.p_ok.id,true,false);
		b_wnd_ex.set_text(top,w1_activation.dlg.p_info.id,STR('LA_DRAW_PATTERN'),false);
		b_wnd_ex.set_text(top,w1_activation.dlg.tipinfo.id,'',false);
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local on_p_skip =function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_activation.dlg;
		b_wnd_ex.set_text(top,cwnd.titlestr.id,STR('LA_RECV_PWD_EMAIL'),false);
		b_wnd_ex.set_text(top,cwnd.tipinfo.id,'',false);
		set_hide(top,2);
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local on_m_ok =function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_activation.dlg;
		local email = b_wnd_ex.get_text(top,cwnd.t_email.id);
		if email == '' then
			flag = 1;
			b_wnd_ex.set_color(top,cwnd.t_email.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},true)
			b_wnd_ex.set_color_f(top,cwnd.t_email.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},true)
			b_wnd_ex.set_text(top,w1_activation.dlg.tipinfo.id,STR('LA_EMAIL_EMPTY'),false);
			b_dlg.dlg_set_redraw(top)
			return 0;
		end
		local p1,p2 = string.find(email,".+(@).+(%.).+");
		if p1 == nil or p2 == nil then
			flag = 1;
			b_wnd_ex.set_color(top,cwnd.t_email.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},true)
			b_wnd_ex.set_color_f(top,cwnd.t_email.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},true)
			b_wnd_ex.set_text(top,w1_activation.dlg.tipinfo.id,STR('LA_EMAIL_FORMAT'),false);
			b_dlg.dlg_set_redraw(top)
			return 0;
		end
		local admin_info = b_app_api.get_super_admin();
		local pwd = b_wnd_ex.get_password(top, cwnd.t_newpass.id)
		local ret = b_app_api.set_security_mail(admin_info.user_name,pwd,email);
		if ret.ret ~= 0 then
			flag = 1;
			b_wnd_ex.set_color(top,cwnd.t_email.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},true)
			b_wnd_ex.set_color_f(top,cwnd.t_email.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},true)
			b_wnd_ex.set_text(top,w1_activation.dlg.tipinfo.id,STR('LA_EMAIL_FORMAT'),false);
			b_dlg.dlg_set_redraw(top)
			return 0;
		end

		set_hide(top,3);
		b_wnd_ex.set_text(top,cwnd.titlestr.id,STR('LA_RECV_QUESTION'),false);
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local on_m_skip =function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_activation.dlg;
		set_hide(top,3);
		b_wnd_ex.set_text(top,cwnd.titlestr.id,STR('LA_RECV_QUESTION'),false);
		b_wnd_ex.set_text(top,cwnd.tipinfo.id,'',false);
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local on_select_question =function(top, win_id, vmsg, x, y)
	if (b_ui.WM_USER_UPDATE_PARAM == vmsg) then
		local q1 = b_wnd_ex.get_text(top,w1_activation.dlg.t_question1.id);
		local q2 = b_wnd_ex.get_text(top,w1_activation.dlg.t_question2.id);
		local q3 = b_wnd_ex.get_text(top,w1_activation.dlg.t_question3.id);
		local sel1 = 0;
		local sel2 = 0;
		local sel3 = 0;
		local index1 = 0;
		local index2 = 0;
		local index3 = 0;
		for i = 1, 8 do
			if all_security_question_str[i] == q1 then
				sel1 = index1
				index1 = index1+1
				question1_str[index1]=all_security_question_str[i]
			elseif all_security_question_str[i] == q2 then
				sel2 = index2
				index2 = index2+1
				question2_str[index2]=all_security_question_str[i]
			elseif all_security_question_str[i] == q3 then
				sel3 = index3
				index3 = index3+1
				question3_str[index3]=all_security_question_str[i]
			else
				index1 = index1+1
				question1_str[index1]=all_security_question_str[i]
				index2 = index2+1
				question2_str[index2]=all_security_question_str[i]
				index3 = index3+1
				question3_str[index3]=all_security_question_str[i]			
			end
		end
		b_wnd_ex.set_items(top,w1_activation.dlg.t_question1.id,question1_str,false);
		b_wnd_ex.set_sel(top,w1_activation.dlg.t_question1.id,sel1,false);
		b_wnd_ex.set_items(top,w1_activation.dlg.t_question2.id,question2_str,false);
		b_wnd_ex.set_sel(top,w1_activation.dlg.t_question2.id,sel2,false);
		b_wnd_ex.set_items(top,w1_activation.dlg.t_question3.id,question3_str,false);
		b_wnd_ex.set_sel(top,w1_activation.dlg.t_question3.id,sel3,false);
		if win_id == w1_activation.dlg.t_question1.id then
			b_wnd_ex.set_text(top,w1_activation.dlg.t_answer1.id,'',false);
		elseif win_id == w1_activation.dlg.t_question2.id then
			b_wnd_ex.set_text(top,w1_activation.dlg.t_answer2.id,'',false);			
		elseif win_id == w1_activation.dlg.t_question3.id then
			b_wnd_ex.set_text(top,w1_activation.dlg.t_answer3.id,'',false);		
		end		
		
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_q_ok =function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_activation.dlg;
		local question1 = b_wnd_ex.get_text(top,cwnd.t_question1.id);
		local answer1 = b_wnd_ex.get_text(top,cwnd.t_answer1.id);
		local question2 = b_wnd_ex.get_text(top,cwnd.t_question2.id);
		local answer2 = b_wnd_ex.get_text(top,cwnd.t_answer2.id);
		local question3 = b_wnd_ex.get_text(top,cwnd.t_question3.id);
		local answer3 = b_wnd_ex.get_text(top,cwnd.t_answer3.id);
		if string.len(answer1) < 1 or string.len(answer1) > 32 then
			flag = 1;
			b_wnd_ex.set_color(top,cwnd.t_answer1.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top,cwnd.t_answer1.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
		end
		
		if string.len(answer2) < 1 or string.len(answer2) > 32  then
			flag = 1;
			b_wnd_ex.set_color(top,cwnd.t_answer2.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top,cwnd.t_answer2.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
		end	
		if string.len(answer3) < 1 or string.len(answer3) > 32  then
			flag = 1;
			b_wnd_ex.set_color(top,cwnd.t_answer3.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top,cwnd.t_answer3.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)		
		end
		
		if flag ~= 0 then
			if answer1 == '' or answer2 == '' or answer3 == '' then
				b_wnd_ex.set_text(top,cwnd.tipinfo.id,STR('LA_SAFE_ANS'),false);
			else
				b_wnd_ex.set_text(top,cwnd.tipinfo.id,STR('LA_ANSWER_ILLEGAL'),false);
			end			
			
			b_dlg.dlg_set_redraw(top);
			return 0;
		end
		b_dlg.dlg_set_redraw(top);
		local param = {};
		param.question1 = nil;
		param.question2 = nil;
		param.question3 = nil;
		param.answer1 = nil;
		param.answer2 = nil;
		param.answer3 = nil;
		local idx = 0;
		for i = 1,8 do
			if all_security_question_str[i] == question1 then
				param.question1 = i;
				idx = idx + 1;
			elseif all_security_question_str[i] == question2 then
				param.question2 = i;
				idx = idx + 1;
			elseif all_security_question_str[i] == question3 then
				param.question3 = i;
				idx = idx + 1;
			end
			if idx == 3 then
				break;
			end
		end
		param.answer1 = answer1
		param.answer2 = answer2
		param.answer3 = answer3
				
		local admin_info = b_app_api.get_super_admin();
		local pwd = b_wnd_ex.get_password(top, cwnd.t_newpass.id)
		local ret = b_app_api.set_security_question(admin_info.user_name,pwd,param);
		if ret.ret ~= 0 then
			return 0;
		end
		local admin_info = b_app_api.get_super_admin();
		result = b_app_api.user_login(admin_info.user_name, pwd)
		assert(result ~= nil and "table" == type(result))
		
		local idx = b_wnd_ex.get_sel(top, w1_activation.dlg.t_languaget.id);
		if(b_app_cfg.user_cfg == nil or b_app_cfg.user_cfg.device == nil)then
			b_app_cfg.init({'device'})
		end
		if(b_app_cfg.user_cfg.device.language ~= LANGUAGE[idx+1])then
			b_app_cfg.user_cfg.device.language = LANGUAGE[idx+1]
			
			local deviceinfo ={};
			deviceinfo.device = b_app_cfg.user_cfg.device
			b_app_cfg.savechangecfg(deviceinfo) 
			b_app_cfg.saveSuccessful();
		end		
		
		assert(nil ~= admin_info and type(admin_info) == "table");

		--登录成功 更新登录用户名称
		b_app_api.update_login_user_name(admin_info.user_name);
		--获取用户自身权限
		local user_info = b_app_api.get_current_user_info(admin_info.user_name)
		assert(user_info ~= nil and "table" == type(user_info))
		global_val.set_current_user_info(user_info);
		
		
		return b_ui_msg.msg_on_skip_wizard;  --返回向导界面弹出消息 C部分判断是否弹出向导
	end
	return 0;
end

local on_q_skip =function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_activation.dlg;
		local admin_info = b_app_api.get_super_admin();
		local newpass = b_wnd_ex.get_password(top, cwnd.t_newpass.id)
		result = b_app_api.user_login(admin_info.user_name, newpass)
		assert(result ~= nil and "table" == type(result))
		
		local idx = b_wnd_ex.get_sel(top, w1_activation.dlg.t_languaget.id);
		if(b_app_cfg.user_cfg == nil or b_app_cfg.user_cfg.device == nil)then
			b_app_cfg.init({'device'})
		end
		if(b_app_cfg.user_cfg.device.language ~= LANGUAGE[idx+1])then
			b_app_cfg.user_cfg.device.language = LANGUAGE[idx+1]
			
			local deviceinfo ={};
			deviceinfo.device = b_app_cfg.user_cfg.device
			b_app_cfg.savechangecfg(deviceinfo) 
			b_app_cfg.saveSuccessful();
		end		
		
		assert(nil ~= admin_info and type(admin_info) == "table");

		--登录成功 更新登录用户名称
		b_app_api.update_login_user_name(admin_info.user_name);
		--获取用户自身权限
		local user_info = b_app_api.get_current_user_info(admin_info.user_name)
		assert(user_info ~= nil and "table" == type(user_info))
		global_val.set_current_user_info(user_info);
		return b_ui_msg.msg_on_skip_wizard;  --返回向导界面弹出消息 C部分判断是否弹出向导
	end
	return 0;
end

local init_t_languaget = function(top)
	b_wnd_ex.set_items(top,w1_activation.dlg.t_languaget.id,LANGUAGE_LIST,false);

	b_app_cfg.init({'device','language_limits'})

	local data = b_app_cfg.user_cfg.device
	local language_data = b_app_cfg.user_cfg.language_limits
	LANGUAGE = {};
	LANGUAGE_LIST ={};
	for i =1,language_data.language_num do
		local language = language_data.language_list[i]
		table.insert(LANGUAGE_LIST,language_str[language]) 
		table.insert(LANGUAGE,language );
	end
	b_wnd_ex.set_items(top,w1_activation.dlg.t_languaget.id,LANGUAGE_LIST,false);
	for i=1,#LANGUAGE do
		if(data.language ==LANGUAGE[i])then
			 b_wnd_ex.set_sel(top, w1_activation.dlg.t_languaget.id,i-1,false);
		end
	end	
end	

local on_dlg = function(top, id, vmsg, x, y)
	if b_ui.TIMER == vmsg then
		local opt_flag = b_app_api.get_mouse_operation_flag();
		if (0 ~= opt_flag) then
			b_app_api.set_mouse_operation_flag(0);
			w1_activation.mouse_last_opt_time = os.time();
		end

		local cur_tinme = os.time()
		if flag ~= 0 then
			if 5 < cur_tinme - w1_activation.err_tip_time then
				flag = 0;
				b_wnd_ex.set_color(top,w1_activation.dlg.t_newpass.id,
					{COLOR('c_modch_edit_bk'),COLOR('c_popdlg_border'),COLOR('c_popdlg_text')},false)	
				b_wnd_ex.set_color(top,w1_activation.dlg.t_conpass.id,
					{COLOR('c_modch_edit_bk'),COLOR('c_popdlg_border'),COLOR('c_popdlg_text')},false)
				b_wnd_ex.set_color(top,w1_activation.dlg.t_chn_pwd.id,
					{COLOR('c_modch_edit_bk'),COLOR('c_popdlg_border'),COLOR('c_popdlg_text')},false)
				b_wnd_ex.set_color(top,w1_activation.dlg.t_email.id,
					{COLOR('c_modch_edit_bk'),COLOR('c_popdlg_border'),COLOR('c_popdlg_text')},false)
				b_wnd_ex.set_color(top,w1_activation.dlg.t_answer1.id,
					{COLOR('c_modch_edit_bk'),COLOR('c_popdlg_border'),COLOR('c_popdlg_text')},false)	
				b_wnd_ex.set_color(top,w1_activation.dlg.t_answer2.id,
					{COLOR('c_modch_edit_bk'),COLOR('c_popdlg_border'),COLOR('c_popdlg_text')},false)
				b_wnd_ex.set_color(top,w1_activation.dlg.t_answer3.id,
					{COLOR('c_modch_edit_bk'),COLOR('c_popdlg_border'),COLOR('c_popdlg_text')},false)	
				b_wnd_ex.set_text(top,w1_activation.dlg.tipinfo.id,'',false);
				b_dlg.dlg_set_redraw(top)
			end
		else
			w1_activation.err_tip_time = cur_tinme;
		end 
		if w1_activation.w1_page_modify_g ~= 0 then
			if 1 < cur_tinme - w1_activation.w1_page_modify_g then
				w1_activation.w1_page_modify_g = 0;
				b_wnd_ex.pattern_clear(top,w1_activation.dlg.pattern.id,false);
				b_dlg.dlg_set_redraw(top)
			end
		end
	end	
	if (b_ui_msg.msg_on_skip_wizard == vmsg ) then
		return vmsg;
	end
	return 0
end	

local dlg = {
	attr 	= {xywh='s_activation_page_xywh',cmd=on_dlg,timer={-1, 500}},
	
	sub 	= {'titlestr','cap_language','t_languaget', 'cap_user','t_user','cap_newpass', 
			't_newpass',  'cap_conpass', 't_conpass','cap_chn_pwd','t_chn_pwd',
			'info1','info2','info3','info4','tipinfo','ok','pattern','p_info','p_ok','p_repeat','p_skip','cap_email','t_email','m_ok','m_skip',
			'cap_question1','t_question1','cap_answer1','t_answer1','cap_question2','t_question2',
			'cap_answer2','t_answer2','cap_question3','t_question3','cap_answer3','t_answer3','q_ok','q_skip'},
			
	titlestr	= {t='static', 	id=id+1,xywh='s_activation_titlestr_xywh', 
					text='LA_ACTIVATE_ENABLE',	font = 'f_grade3',align = b_ui.ALIGN.CENTER,},

	cap_language = {t='static',id=id+2,xywh='s_activation_cap_language_xywh',text='LA_LANGUAGE',
					color = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}},
	t_languaget = {t='combox',id=id+3,xywh='s_activation_t_language_xywh',items={'english','french','polish'},trans = false,cmd = on_language},	
					
	cap_user	= {t='static',	id=id+4,	xywh='s_activation_cap_user_xywh',text='LA_USER_NAME', 
					color = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}},				
	
	t_user	 	= {t='static',	id=id+5,	xywh='s_activation_t_user_xywh',text='', trans=false, 
					color = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}},
						
	cap_newpass = {t='static',	id=id+6,	xywh='s_activation_cap_newpass_xywh',text='LA_CREATE_PWD', 
					color = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}},	
	
	t_newpass 	= {t='password',id=id+7,	xywh='s_activation_t_newpass_xywh',password='',guide_text='LA_PASSWORD',disp = false,},
	
		
	cap_conpass = {t='static',	id=id+8,	xywh='s_activation_cap_conpass_xywh',text='LA_NEW_CONFIRM', 
					color = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}},
		
	t_conpass 	= {t='password',id=id+9,	xywh='s_activation_t_conpass_xywh',password='', guide_text='LA_PASSWORD',disp = false},	
	
	cap_chn_pwd = {t='static',	id=id+10,	xywh='s_activation_cap_chn_pwd_xywh',text='LA_CHANNEL_PWD', 
					color = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}},	
			
	
	t_chn_pwd 	= {t='password',id=id+11,	xywh='s_activation_t_chn_pwd_xywh',password='',guide_text='LA_PASSWORD', disp = false},
	
	info1		= {t='static',	id=id+12,	xywh='s_activation_info1_xywh',text='LA_PASSWORD_RULE2',
					color = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}},
	info2		= {t='static',	id=id+13,	xywh='s_activation_info2_xywh',text='LA_PWD_RULE',
					color = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}},
	info3		= {t='static',	id=id+14,	xywh='s_activation_info3_xywh',text='LA_INPUT_RULE1',
					color = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}},
	info4		= {t='static',	id=id+15,	xywh='s_activation_info4_xywh',text='', trans = false,
					color = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}},	

	tipinfo		= {t='static', id=id+16, xywh='s_activation_tipinfo_xywh',text='',trans = false,
					color = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_hint_text'}},
	
	ok			= {t='tt_button',id=id+17, xywh='s_activation_ok_xywh', text='LA_OK', cmd=on_ok},
	
	pattern = {t='pattern',id=id+18,xywh='s_activation_pattern_xywh',cmd = on_pattern},
	p_info		= {t='static', id=id+19, xywh='s_activation_p_info_xywh',text='',trans = false,align = b_ui.ALIGN.CENTER,
					color = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_apply_ok'}},
	p_ok		= {t='tt_button',id=id+20, xywh='s_activation_p_ok_xywh', text='LA_OK', cmd=on_p_ok},
	p_repeat	= {t='tt_button',id=id+21, xywh='s_activation_p_repeat_xywh', text='LA_REPEAT', cmd=on_repeat},
	p_skip		= {t='tt_button',id=id+22, xywh='s_activation_p_skip_xywh', text='LA_SKIP_STEP', cmd=on_p_skip},
	cap_email 	= {t='static',id=id+23,xywh='s_activation_cap_language_xywh',text='LA_EMAIL_ADDR'},
	t_email 	= {t='edit',  id=id+24,xywh='s_activation_t_language_xywh',guide_text='******@gmail.com',max_value = 64,guide_trans=false},
	m_ok		= {t='tt_button',id=id+25, xywh='s_activation_m_ok_xywh', text='LA_OK', cmd=on_m_ok},
	m_skip		= {t='tt_button',id=id+26, xywh='s_activation_m_skip_xywh', text='LA_SKIP_STEP', cmd=on_m_skip},
	cap_question1= {t='static',id=id+27,xywh='s_activation_cap_language_xywh',text='LA_FIRST_QUESTION'},
	t_question1	= {t='combox',  id=id+28,xywh='s_activation_t_language_xywh',cmd=on_select_question},
	cap_answer1	= {t='static',id=id+29,xywh='s_activation_cap_user_xywh',text='LA_ANSWER_ONE'},
	t_answer1	= {t='edit',  id=id+30,xywh='s_activation_t_user_xywh'--[[,guide_text='guide_answer1'--]]},
	cap_question2= {t='static',id=id+31,xywh='s_activation_cap_newpass_xywh',text='LA_SECOND_QUESTION'},
	t_question2 	= {t='combox',id=id+32,xywh='s_activation_t_newpass_xywh',cmd=on_select_question},
	cap_answer2	= {t='static',id=id+33,xywh='s_activation_cap_conpass_xywh',text='LA_ANSWER_TWO'},
	t_answer2 	= {t='edit',  id=id+34,xywh='s_activation_t_conpass_xywh'--[[,guide_text='guide_answer2'--]]},
	cap_question3= {t='static',id=id+35,xywh='s_activation_cap_chn_pwd_xywh',text='LA_THIRD_QUESTION'},
	t_question3	= {t='combox',  id=id+36,xywh='s_activation_t_chn_pwd_xywh',cmd=on_select_question},
	cap_answer3= {t='static',id=id+37,xywh='s_activation_cap_answer3_xywh',text='LA_ANSWER_THREE'},
	t_answer3	= {t='edit',  id=id+38,xywh='s_activation_t_answer3_xywh'--[[,guide_text='guide_answer3'--]]},
	q_ok		= {t='tt_button',id=id+39, xywh='s_activation_m_ok_xywh', text='LA_OK', cmd=on_q_ok},
	q_skip		= {t='tt_button',id=id+40, xywh='s_activation_m_skip_xywh', text='LA_SKIP_STEP', cmd=on_q_skip},
}

w1_activation.on_pre_show  = function(top)
	local admin_info = b_app_api.get_super_admin();
	assert(nil ~= admin_info and type(admin_info) == "table");
		--默认的用户名和密码一致 因此都是用户名
	G.set_root_user_name(admin_info.user_name);
	b_wnd_ex.set_text(top,w1_activation.dlg.t_user.id,admin_info.user_name,false);
	--设置语言下拉框
	init_t_languaget(top)
	w1_activation.pattern_pwd = '';
	w1_activation.pattern_stat = false;
	w1_activation.w1_page_modify_g = 0;
	w1_activation.mouse_last_opt_time = os.time()
	
	all_security_question_str[1]=STR('LA_SEC_QUE_1')
	all_security_question_str[2]=STR('LA_SEC_QUE_2')
	all_security_question_str[3]=STR('LA_SEC_QUE_3')
	all_security_question_str[4]=STR('LA_SEC_QUE_4')
	all_security_question_str[5]=STR('LA_SEC_QUE_5')
	all_security_question_str[6]=STR('LA_SEC_QUE_6')
	all_security_question_str[7]=STR('LA_SEC_QUE_7')
	all_security_question_str[8]=STR('LA_SEC_QUE_8')
	question1_str[1]=STR('LA_SEC_QUE_1')
	question1_str[2]=STR('LA_SEC_QUE_4')
	question1_str[3]=STR('LA_SEC_QUE_5')
	question1_str[4]=STR('LA_SEC_QUE_6')
	question1_str[5]=STR('LA_SEC_QUE_7')
	question1_str[6]=STR('LA_SEC_QUE_8')
	question2_str[1]=STR('LA_SEC_QUE_2')
	question2_str[2]=STR('LA_SEC_QUE_4')
	question2_str[3]=STR('LA_SEC_QUE_5')
	question2_str[4]=STR('LA_SEC_QUE_6')
	question2_str[5]=STR('LA_SEC_QUE_7')
	question2_str[6]=STR('LA_SEC_QUE_8')
	question3_str[1]=STR('LA_SEC_QUE_3')
	question3_str[2]=STR('LA_SEC_QUE_4')
	question3_str[3]=STR('LA_SEC_QUE_5')
	question3_str[4]=STR('LA_SEC_QUE_6')
	question3_str[5]=STR('LA_SEC_QUE_7')
	question3_str[6]=STR('LA_SEC_QUE_8')
	b_wnd_ex.set_items(top,w1_activation.dlg.t_question1.id,question1_str,false);
	b_wnd_ex.set_sel(top,w1_activation.dlg.t_question1.id,0,false);
	b_wnd_ex.set_items(top,w1_activation.dlg.t_question2.id,question2_str,false);
	b_wnd_ex.set_sel(top,w1_activation.dlg.t_question2.id,0,false);
	b_wnd_ex.set_items(top,w1_activation.dlg.t_question3.id,question3_str,false);
	b_wnd_ex.set_sel(top,w1_activation.dlg.t_question3.id,0,false);	
	set_hide(top,0);
	
	local pwd_rule = b_app_api.get_cfg({'pwd_rule_info'}).pwd_rule_info
	local str_info_tmp = string.gsub(STR('LA_PASSWORD_RULE2'), '*' ,pwd_rule.pwd_min_len); 
	local str_info = string.gsub(str_info_tmp, '@' ,pwd_rule.pwd_max_len); 
	b_wnd_ex.set_text(top, w1_activation.dlg.info1.id, str_info, false);	
	
	return 0
end

w1_activation.on_create = function(top)
	w1_activation.top = top
	w1_activation.dlg = dlg
	b_parser(top, dlg)	
	
	--关闭现场定时器
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_chcek_login)	
	
	return 0
end

w1_activation.on_destroy = function(top)
	w1_activation.top = nil
	w1_activation.dlg = nil
	LANGUAGE = nil;
	LANGUAGE_LIST = nil;
	--开启现场定时器
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)	
	
	return 0
end

w1_activation.on_paint = function(top, status, x, y, cx, cy)
	local wndsize = SIZE('s_activation_draw_xywh');
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_row_bk'))
	b_wnd.draw_fill(top, x + wndsize[1], y+wndsize[2], cx - wndsize[3], wndsize[4], COLOR('c_hline_color'))
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top)
	return 0
end

w1_activation.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.RBUTTONCLK == vmsg) then
		
	elseif (b_ui_msg.msg_on_refresh_full_screen == vmsg) then
		return vmsg
	elseif (b_ui.LBUTTOUP == vmsg) then
		local ret = b_wnd_ex.pattern_end(top,w1_activation.dlg.pattern.id)
		if ret ~= nil and ret.is_end == 1 then
			check_pattern(top);
		end
	elseif (b_ui.LBUTTONCLK == vmsg) then
		local ret = b_wnd_ex.pattern_end(top,w1_activation.dlg.pattern.id)
		if ret ~= nil and ret.is_end == 1 then
			check_pattern(top);
		end
	elseif (b_ui_msg.msg_on_login_successful == vmsg) then	
		b_dlg.end_modal(top)
		return vmsg
	elseif (b_ui_msg.msg_on_skip_wizard == vmsg) then			--开机向导
		b_dlg.end_modal(top)
		return vmsg
	elseif(b_ui.WM_USER_UPDATE_LOGIN_LANGUARE == vmsg) then
		return b_ui.WM_USER_UPDATE_LOGIN_LANGUARE;		
	elseif b_ui_msg.msg_user_update_parent == vmsg or b_ui_msg.msg_user_pwd_click == vmsg then
		flag = 0;
		b_wnd_ex.set_color(top,w1_activation.dlg.t_newpass.id,
			{COLOR('c_modch_edit_bk'),COLOR('c_popdlg_border'),COLOR('c_popdlg_text')},false)	
		b_wnd_ex.set_color(top,w1_activation.dlg.t_conpass.id,
			{COLOR('c_modch_edit_bk'),COLOR('c_popdlg_border'),COLOR('c_popdlg_text')},false)
		b_wnd_ex.set_color(top,w1_activation.dlg.t_chn_pwd.id,
			{COLOR('c_modch_edit_bk'),COLOR('c_popdlg_border'),COLOR('c_popdlg_text')},false)	
		b_wnd_ex.set_text(top,w1_activation.dlg.tipinfo.id,'',false);
		b_dlg.dlg_set_redraw(top)
	end
		
	return 0
end

return w1_activation