--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/5/30
-- author 
-- brief  ϢбϢչʾ
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_dlg 		= require("wnd.core.b_dlg")
local b_app_api 	= require("wnd.core.command.b_app_api");
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_id 		= require("wnd.w1_util.w1_id")
local b_parser 		= require("wnd.core.b_parser")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_msgbox 	= require("wnd.w1_util.w1_msgbox")
local r_str			= require("wnd.core.r_res.r_str")
local b_wnd 		= require("wnd.core.b_wnd")
local r_color		= require("wnd.core.r_res.r_color")
local b_ui_msg  	= require("wnd.w1_util.w1_ui_msg")
local util 			= require("wnd.core.util") 
local COLOR 		= r_color.get_color
local STR 			= r_str.get_str
local id 			= w1_id.live_wnd.alarm_list_id
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local max_rows 		= 12;

local w1_alarm_list = {
	t = w1_key.DLG_ALARM_LIST,
	top = nil,
	dlg = nil,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_alarm_list.s_768 =
{
	s_alarm_list_xywh = {695,262,323,473},
	s_alarm_list_title_xywh = {2,10,317,28},
	s_alarm_list_clsoe_xywh = {292,10,21,28},
	s_alarm_list_list_xywh = {1,44,320,426},
	s_alarm_list_w1 = {75,0,0,0},
	s_alarm_list_w2 = {106,0,0,0},
	s_alarm_list_w3 = {131,0,0,0},
};

w1_alarm_list.s_1280 = 
{
	s_alarm_list_xywh = {664,317,606,666},
	s_alarm_list_title_xywh = {5, 15, 596, 40},	
	s_alarm_list_clsoe_xywh = {548, 15, 40, 40},	
	s_alarm_list_list_xywh = {3, 66, 600, 600},
	s_alarm_list_w1 = {142,0,0,0},
	s_alarm_list_w2 = {200,0,0,0},
	s_alarm_list_w3 = {250,0,0,0},
};
w1_alarm_list.s_1440 = 
{
	s_alarm_list_xywh = {832,194,606,666},
	s_alarm_list_title_xywh = {5, 15, 596, 40},	
	s_alarm_list_clsoe_xywh = {548, 15, 40, 40},	
	s_alarm_list_list_xywh = {3, 66, 600, 600},
	s_alarm_list_w1 = {142,0,0,0},
	s_alarm_list_w2 = {200,0,0,0},
	s_alarm_list_w3 = {250,0,0,0},
};

w1_alarm_list.s_1080p = 
{
	s_alarm_list_xywh = {1304,369,606,666},
	s_alarm_list_title_xywh = {5, 15, 596, 40},	
	s_alarm_list_clsoe_xywh = {548, 15, 40, 40},	
	s_alarm_list_list_xywh = {3, 63, 600, 600},
	s_alarm_list_w1 = {142,0,0,0},
	s_alarm_list_w2 = {200,0,0,0},
	s_alarm_list_w3 = {250,0,0,0},
};
w1_alarm_list.s_2k = 
{
	s_alarm_list_xywh={1738,492,808,888},
	s_alarm_list_title_xywh={7,20,794,53},
	s_alarm_list_clsoe_xywh={730,20,53,53},
	s_alarm_list_list_xywh={4,84,800,800},
	s_alarm_list_w1 = {189,0,0,0},
	s_alarm_list_w2 = {267,0,0,0},
	s_alarm_list_w3 = {333,0,0,0},

};
w1_alarm_list.s_4k = 
{
	s_alarm_list_xywh={2608,738,1212,1332},
	s_alarm_list_title_xywh={10,30,1192,80},
	s_alarm_list_clsoe_xywh={1096,30,80,80},
	s_alarm_list_list_xywh={6,126,1200,1200},
	s_alarm_list_w1 = {284,0,0,0},
	s_alarm_list_w2 = {400,0,0,0},
	s_alarm_list_w3 = {500,0,0,0},

};


local convertypestr = function(str, ch_id)
	if (str == 'reset') then
		return STR('LA_RESET_FACTORY');
    elseif (str == 'clear_log') then
		return STR('LA_CLEAR_LOG');
    elseif (str == 'clear_event') then
		return STR('LA_CLEAR_EVENT');
    elseif (str == 'boot') then
		return STR('LA_POWER_ON');
    elseif (str == 'shutdown') then
		return STR('LA_SHUTDOWN');	
    elseif (str == 'reboot') then
		return STR('LA_RESTART');
    elseif (str == 'login') then
		return STR('LA_LOGIN');
    elseif (str == 'logout') then
		return STR('LA_LOGOUT');
    elseif (str == 'add_cam') then
		return STR('LA_ADD_CAMERA');
    elseif (str == 'del_cam') then
		return STR('LA_DELETE_CAMERA');
    elseif (str == 'pb_start') then	
		return STR('LA_START_PLAYBACK');
    elseif (str == 'pb_stop') then
		return STR('LA_CLOSE_PLAYBACK');
    elseif (str == 'bk_start') then
		return STR('LA_START_BACKUP');
    elseif (str == 'bk_stop') then
		return STR('LA_END_BACKUP');
    elseif (str == 'search') then
		return STR('LA_TIME_SEARCH');
    elseif (str == 'picgird') then
		return STR('LA_PICTURE_SEARCH');
    elseif (str == 'timeline') then
		return STR('LA_CHECK_TIMELINE');	
    elseif (str == 'check_event') then
		return STR('LA_CHECK_EVENT');
    elseif (str == 'set_language') then
		return STR('LA_SET_LANGUAGE');
    elseif (str == 'set_tz') then
		return STR('LA_SET_TIMEZONE');
    elseif (str == 'set_time') then
		return STR('LA_MODIFY_TIME');
    elseif (str == 'on_alarm') then
		return STR('LA_OPEN_SURVEILLANCE');
    elseif (str == 'off_alarm') then
		return STR('LA_CLOSE_SURVEILLANCE');
    elseif (str == 'set_alarm') then
		return STR('LA_SETUP_ALARM');
    elseif (str == 'on_pw') then
		return STR('LA_ENABLE_PWD_PROTECT');	
    elseif (str == 'off_pw') then
		return STR('LA_DISABLE_PWD_PROTECT');
    elseif (str == 'modify_pw') then
		return STR('LA_MODIFY_PWD');	
    elseif (str == 'set_network') then
		return STR('LA_SETUP_NETWORK');
    elseif (str == 'clear_disk') then
		return STR('LA_FORMAT_DISK');	
    elseif (str == 'set_color') then
		return STR('LA_SET_COLOR_PARAMETERS');	
    elseif (str == 'set_encode') then
		return STR('LA_SET_ENCODE_PARAMETERS');	
    elseif (str == 'set_privacy') then
		return STR('LA_SET_PRIVACY');	
    elseif (str == 'set_osd') then
		return STR('LA_SETUP_OSD');
    elseif (str == 'set_record') then
		return STR('LA_SET_RECORD_PARAM');
    elseif (str == 'online') then
		return STR('LA_ONLINE');
    elseif (str == 'offline') then
		return STR('LA_OFFLINE');	
    elseif (str == 'ptz_set') then
		return STR('LA_PTZ_SET');
    elseif (str == 'ptz_ctrl') then
		return STR('LA_PTZ_CONTROL');
    elseif (str == 'audio') then
		return STR('LA_AUDIO');		
    elseif (str == 'talk') then
		return STR('LA_TWO_WAY_AUDIO');
    elseif (str == 'bind') then
		return STR('LA_BIND_ACCOUNT');	
	elseif (str == 'motion') then
		return STR('LA_MOTION_DETECTION');
	elseif (str == 'disconnected') then
		return STR('LA_VIDEO_LOST');
	elseif (str == 'no_cable') then
		return STR('LA_NET_DISCONNECT');
	elseif (str == 'disk_error') then
		return STR('LA_DISK_ERROR');
	elseif (str == 'disk_dropped') then
		return STR('LA_DISK_DROPPED');
	elseif (str == 'disk_attenuation') then
		return STR('LA_DISK_ATTENUATION');
	elseif (str == 'disk_full') then
		return STR('LA_FULL_DISK');
	elseif (str == 'ip_conflict') then
		return STR('LA_IP_CONFLICT');
	elseif (str == 'illegal') then
		return STR('LA_ILLEGAL_ALARM');	
	elseif (str == 'sensor') then
		return STR('LA_ALARM_IN');
	elseif (str == 'camera_sensor') then
		return STR('LA_IOALAEM_L');
	elseif (str == 'shelter') then
		return STR('LA_TAMPER_ALARM');	
	 elseif (str == 'intell_analyse') then
		return STR('LA_INSIGHT');
	 elseif (str == 'perimeter') then
		return STR('LA_PERIMETER');
	 elseif (str == 'single_virtual_fence') then
		return STR('LA_SINGLE_VIRTUAL_FRNCE');
	 elseif (str == 'double_virtual_fences') then
		return STR('LA_DOUBLE_VIRTUAL_FENCES');
	 elseif (str == 'loiter') then
		return STR('LA_LOITER');
	 elseif (str == 'multi_loiter') then
		return STR('LA_MULTI_LOITER');
	 elseif (str == 'object_left') then
		return STR('LA_OBJECT_LEFT');
	 elseif (str == 'object_removed') then
		return STR('LA_OBJECT_REMOVED');
	 elseif (str == 'abnormal_speed') then
		return STR('LA_ABNORNAL_SPEED');
	 elseif (str == 'converse') then
		return STR('LA_CONVERSE');
	 elseif (str == 'illegal_parking') then
		return STR('LA_ILLEGAL_PARKING');
	 elseif (str == 'signal_bad') then
		return STR('LA_SIGNAL_BAD');	
	elseif (str == 'strategy_register') then
		return STR('LA_REGISTER');
	elseif (str == 'strategy_stranger') then
		return STR('LA_STRANGER');
	elseif (str == 'temperature_alarm') then
		return STR('LA_TEMPERATURE_ALARM');
	elseif (str == 't_threshold_warming') then
		return STR('LA_THRESHOLD_WARMING');
	elseif (str == 't_threshold_alarm') then
		return STR('LA_THRESHOLD_ALARM_LINK');
	elseif (str == 't_temperature_warning') then
		return STR('LA_THRESHOLD_ALARM2');
	elseif (str == 't_temperature_alarm') then
		return STR('LA_TEMPER_DIFFEREN');
	elseif (str == 't_temperature_section') then
		return STR('LA_TEMPER_SECTION');		
	elseif (str == 'strategy_plate_register') then
		return STR('LA_REG_PLATE');
	elseif (str == 'strategy_plate_unregister') then
		return STR('LA_UNREG_PLATE');		
	elseif (str == 'face_temperature_over') then	
		return STR('LA_OVER_TEMPER');
	elseif (str == 'thermal_face_detect_low') then
		return STR('LA_THERMAL_FACE_DETECT_LOW');
	elseif (str == 'thermal_face_detect_normal') then
		return STR('LA_THERMAL_FACE_DETECT_NORMAL');
	elseif (str == 'thermal_face_detect') then
		return STR('LA_THERMAL_FACE_DETECT');
	elseif (str == 'face_temperature_low') then	
		return STR('LA_LOW_TEMPER');	
	elseif (str == 'face_temperature_abnormal') then	
		return STR('LA_ABNORMAL_TEMPER');
	elseif (str == 'wear_mask') then	
		return STR('LA_WEAR_MASK');	
	elseif (str == 'no_mask') then	
		return STR('LA_WITHOUT_MASK');			
	elseif (str == 'camera_human_count_alarm') then	
		return STR('LA_CAM_PERSON_COUNT_ALARM');	
	elseif (str == 'nvr_human_count_alarm') then	
		return STR('LA_PERSON_COUNT_ALARM');		
	elseif (str == 't_rise_warning') then	
		return STR('LA_RISE_WARNING');	
	elseif (str == 't_rise_alarm') then	
		return STR('LA_RISE_ALARM');
	elseif (str == 'fan_alarm') then
		return STR('LA_FAN_ALARM');
	elseif (str == 'set_ssl_cert') then
		return STR('LA_SET_HTTPS');		
	elseif(str == 'fence_human')then
		return STR('LA_FENCE_HUNMAN');		
	elseif (str == 'fence_car')then
		return STR('LA_FENCE_VEHICLE');		
	elseif (str == 'unknown') then
		return STR('LA_UNKOWN_ALARM');
	elseif(str == 'fence')then
		return STR('LA_FENCE_ALARM');
	elseif(str == 'enter_regional')then
		return STR('LA_ENTER_AREA');	
	elseif(str == 'leave_regional')then
		return STR('LA_LEAVE_AREA');		
	elseif(str == 'smoking_alarm')then
		return STR('LA_SMOKING_TEST');
	elseif(str == 'fire_smoke_alarm')then
		return STR('LA_FIREWORKS_DETECTION');	
	elseif(str == 'small_fire_alarm')then
		return STR('LA_FIRE_DETECTION');	
	else
		return '--';
	end
end

local updatelist = function(top, redraw)
	local evelt_list = b_app_api.get_log({s_time = 0, e_time = os.time(), log_type = 2, log_size = max_rows });
	if (nil ~= evelt_list and (0 < evelt_list.logsize)) then
		local displist = {};
		
		local nCnt = nil;
		if (max_rows > evelt_list.logsize) then
			nCnt = evelt_list.logsize;
		else
			nCnt = max_rows;	
		end	

		local idx = 0;
		for i=1, nCnt do
			idx = idx + 1;
			local item = evelt_list.list['l' .. i];
			assert(nil ~= item)
			local alarm_type = convertypestr(item.type, item.channel);
			if (0 == item.channel) then
				displist['idx'..idx] = { i - 1, false,
					'--', alarm_type, item.time};		
			else
				displist['idx'..idx] = { i - 1, false,
					'Channel'..tostring(item.channel), alarm_type, item.time };		
			end
		end
		
		displist.item_total = idx;
		b_wnd_ex.set_listdata(top, w1_alarm_list.dlg.alarm_list.id, displist, redraw);

		util.clear_tab(evelt_list);
		evelt_list = nil;
	end	
end

local on_close = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0
end

local dlg = 
{
	attr 	= {xywh='s_alarm_list_xywh'},
	
	sub 	= {'titlestr', 'titleclose', 'alarm_list'},
	
	titlestr	= {t='static', 	id=id+1,xywh='s_alarm_list_title_xywh', 
					text='LA_RECENTLY_EVENT_L',	font = 'f_grade3', align = b_ui.ALIGN.CENTER,
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'},
					},
					
	titleclose 	= {t='tt_button',id=id+2,xywh = 's_alarm_list_clsoe_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_closebtn','it_close','it_close', 'it_close'},
					color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_txt_n'},
					color_f= {'c_popdlg_bk', 'c_popdlg_bk','c_txt_f'},
					cmd=on_close,
	},

	alarm_list = {t='list',	id=id+3,	xywh= 's_alarm_list_list_xywh', font = 'f_grade4',
		listattr = {12,3,b_ui.LISTATTR.FIRST_WIDGET_STATIC,0},
		title_texts = {'Channel', 'Type', 'Start time'},
		columns_w = {142, 200,250},
	},
}

w1_alarm_list.on_create = function(top)
	w1_alarm_list.top = top
	w1_alarm_list.dlg = dlg
	
	--UIڳʼ
	b_parser(top, w1_alarm_list.dlg)
	b_wnd.set_no_find(top, w1_alarm_list.dlg.titlestr.id, true); ---ñ⾲̬ıɱ
	updatelist(top, false);
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)	
	return 0;
end


w1_alarm_list.on_pre_show = function(top)
	local cwnd = w1_alarm_list.dlg;
	local param = {
			STR('LA_CHANNEL'), STR('LA_EVENT_TYPE'),STR('LA_START_TIME')
		}
	b_wnd_ex.set_title_texts(top, cwnd.alarm_list.id, param, false);
	
	local list_w = {};
	for i=1,3 do
		local str = 's_alarm_list_w'..math.floor(i/1);
		list_w[i] = SIZE(str)[1];
	end
	b_wnd_ex.columns_w(top, cwnd.alarm_list.id, list_w, false);
	return 0;
end

w1_alarm_list.on_destroy = function(top)
	w1_alarm_list.top = nil
	w1_alarm_list.dlg = nil
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)
	return 0;
end

w1_alarm_list.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top);
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_popdlg_bk'));
--	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_popdlg_border'),1);
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top);
	return 0;
end

w1_alarm_list.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local size = SIZE(dlg.attr.xywh);
		if(x >= size[1] and x <= (size[1] + size[3]) and y >= size[2] and y <= (size[2] + size[4]) ) then
			
		else
			b_dlg.end_modal(top);
		end
	elseif  (b_ui.RBUTTONCLK == vmsg) then
		b_dlg.end_modal(top);
	end

	return 0;
end

return w1_alarm_list
