local global_val= require("wnd.global_val")
local channel_num = G.channel_num	--豸ͨĿ,ʱȹ̶
local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.toolbar.audio_id
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_app_api = require("wnd.core.command.b_app_api");
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size

local w1_audio = {
	t = w1_key.DLG_AUDIO,
	top = nil,
	dlg = nil,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_audio.s_768 =
{
	s_audio_page_xywh = {182,514,32,224},
	s_audio_volume_xywh = {3,9,24,177},
	s_audio_audio_xywh = {3,192,24,24},
};

w1_audio.s_1280 = 
{
	s_audio_page_xywh = {342,669,60,315},
	s_audio_volume_xywh = {6,13,45,250}, 
	s_audio_audio_xywh = {5,272,45,35},
}

w1_audio.s_1440 = 
{
	s_audio_page_xywh = {342,545,60,315},
	s_audio_volume_xywh = {6,13,45,250}, 
	s_audio_audio_xywh = {5,272,45,35},
}

w1_audio.s_1080p = 
{
	s_audio_page_xywh = {342,723,60,315},
	s_audio_volume_xywh = {6,13,45,250}, 
	s_audio_audio_xywh = {6,270,45,35},
}

w1_audio.s_2k = 
{
	s_audio_page_xywh = {464,965,80,420},
	s_audio_volume_xywh = {4,17,69,340},
	s_audio_audio_xywh = {3,363,69,53},
}

w1_audio.s_4k = 
{
	s_audio_page_xywh = {684,1448,120,630},
	s_audio_volume_xywh = {6,26,104,510},
	s_audio_audio_xywh = {4,544,104,80},
}


local on_audio = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local volume = b_wnd_ex.get_value(top, id + 2);
		local mute = 0;
		if(0 ==volume)then
			b_wnd_ex.set_check(top, w1_audio.dlg.audio.id, false, true)
		else
			b_wnd_ex.set_check(top, w1_audio.dlg.audio.id, true, true)
		end
		local flag = b_wnd_ex.get_check(top, id + 3);
		if (flag==false) then
			mute = 1;
		end
		b_app_api.set_volume(volume,mute)
	end
	return 0;
end

local on_switchaudio = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local volume = b_wnd_ex.get_value(top, id + 2);
		local flag = b_wnd_ex.get_check(top, win_id)
		local mute = 0;
		if(flag)then
			b_wnd_ex.set_check(top, win_id, true, true)
		else
			mute = 1;
			b_wnd_ex.set_check(top, win_id, false, true)
		end
		b_app_api.set_volume(volume,mute);
	end
	return 0;
end

local dlg = {
	attr = {xywh='s_audio_page_xywh'},
	sub = {"num","volume","audio"};

	
	volume ={t='slider_v',id=id+2,xywh='s_audio_volume_xywh' ,align = b_ui.ALIGN.LEFT,cmd=on_audio, 
			color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_f'},
			imgs = {b_ui.ALIGN.LEFT,'i_basic', 'i_basic_f', 'i_basic'},		
	};

	audio = {t='tt_check',id=id+3,xywh='s_audio_audio_xywh', align = b_ui.ALIGN.LEFT,cmd=on_switchaudio, 
			t_imgs = {b_ui.ALIGN.LEFT,'f_menu', 'it_audio_close','it_audio_f', 'it_audio_close'},
			color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_f'}--c_cfg_row_bk
			};
}

local get_valid_cam_num = function(channel_num)
	local chn_num = channel_num;
	local vi_num, dec_num = global_val.get_vi_dec_num();
	if (0 < dec_num and 0 < vi_num) then 
		local chn_type = b_app_api.get_cfg({'channel_type'}).channel_type;
		if (0 == chn_type.chn_type[vi_num + 1]) then
			chn_num = vi_num;
		end
	end
	
	return chn_num;
end

w1_audio.on_create = function(top)
	channel_num = global_val.get_channelnum();
	channel_num = get_valid_cam_num(channel_num);		

	w1_audio.top = top
	w1_audio.dlg = dlg
	b_parser(top, dlg)
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)	
	return 0
end

w1_audio.on_destroy = function(top)
	w1_audio.top = nil
	w1_audio.dlg = nil
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)
	return 0
end

w1_audio.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top)
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_fill(top, x, y, cx, cy-pos[3], COLOR('c_cfg_row_bk'))
--	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_modch_border'), 1)
--	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),6)
--	b_wnd.draw_rect(top, x+2, y+2, cx-4, cy-4, COLOR('c_post_border2'),1)
--[[	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_cfgclose_bk'),3)
	b_wnd.draw_rect(top, x+1, y+1, cx-2, cy-2, COLOR('c_post_border2'),1)--]]
	
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top)
	local volume = b_app_api.get_volume();
	local num =volume.value
	b_wnd_ex.set_value(top, id + 2,num,false);
	if(1 ==volume.mutu_statue)then
		b_wnd_ex.set_check(top, id+3, false, false)
	else
		b_wnd_ex.set_check(top, id+3, true, false)
	end
	return 0
end

w1_audio.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.RBUTTONCLK == vmsg) then
	
		b_dlg.end_modal(top);
	end
	local wndsize = SIZE('s_audio_page_xywh');
	if (b_ui.LBUTTONCLK == vmsg) then
		if((x<wndsize[1]) or (x>wndsize[3])) or((y<wndsize[2])or (y>wndsize[4]))then
			b_dlg.end_modal(top);
		end
	end
	return 0
end

return w1_audio




