local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.live_wnd.image_id
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util		= require("wnd.core.util")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 	= r_size.get_size

local w1_image_adjust = {
	t = w1_key.DLG_IMAGE,
	top = nil,
	dlg = nil,
	cur_data = {},
	old_data = {},
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_image_adjust.s_768 =
{
	s_image_adjust_page_xywh = {344,202,336,362},
	s_image_adjust_title_xywh = {2,3,309,35},
	s_image_adjust_close_xywh = {309,7,17,22},
	s_image_adjust_c_where_xywh = {33,74,69,35},
	s_image_adjust_t_where_xywh = {139,78,117,28},
	s_image_adjust_cap_brig_xywh = {33,120,106,35},
	s_image_adjust_brig_subb_xywh = {139,128,16,21},
	s_image_adjust_t_brig_xywh = {155,120,110,35},
	s_image_adjust_brig_add_xywh = {266,128,16,21},
	s_image_adjust_brig_value_xywh = {282,128,32,21},
	s_image_adjust_cap_sharp_xywh = {33,163,106,35},
	s_image_adjust_sharp_subb_xywh = {139,170,16,21},
	s_image_adjust_t_sharp_xywh = {155,163,110,35},
	s_image_adjust_sharp_add_xywh = {266,170,16,21},
	s_image_adjust_sharp_value_xywh = {282,170,32,21},
	s_image_adjust_cap_contrast_xywh = {33,206,106,35},
	s_image_adjust_contrast_subb_xywh = {139,213,16,21},
	s_image_adjust_t_contrast_xywh = {155,206,110,35},
	s_image_adjust_contrast_add_xywh = {266,213,16,21},
	s_image_adjust_contrast_value_xywh = {282,213,32,21},
	s_image_adjust_cap_satura_xywh = {33,248,106,35},
	s_image_adjust_satura_subb_xywh = {139,256,16,21},
	s_image_adjust_t_satura_xywh = {155,248,110,35},
	s_image_adjust_satura_add_xywh = {266,256,16,21},
	s_image_adjust_satura_value_xywh = {282,256,32,21},
	s_image_adjust_apply_xywh = {133,320,80,28},
	s_image_adjust_cancel_xywh = {229,320,80,28},
	s_image_adjust_draw_xywh = {0,42,0,1},
};

w1_image_adjust.s_1280 = 
{
	s_image_adjust_page_xywh = {325,285,630,510},
	s_image_adjust_title_xywh= {5,5,580,50},
	s_image_adjust_close_xywh= {580,10,32,32},
	s_image_adjust_c_where_xywh= {62,105,130,50},
	s_image_adjust_t_where_xywh= {262,110,220,40},
	s_image_adjust_cap_brig_xywh= {62,170,200,50},
	s_image_adjust_brig_subb_xywh= {262,180,30,30},
	s_image_adjust_t_brig_xywh= {292,170,208,50},
	s_image_adjust_brig_add_xywh= {500,180,30,30},
	s_image_adjust_brig_value_xywh= {530,180,60,30},
	s_image_adjust_cap_sharp_xywh= {62,230,200,50},
	s_image_adjust_sharp_subb_xywh= {262,240,30,30},
	s_image_adjust_t_sharp_xywh= {292,230,208,50},
	s_image_adjust_sharp_add_xywh= {500,240,30,30},
	s_image_adjust_sharp_value_xywh= {530,240,60,30},
	s_image_adjust_cap_contrast_xywh= {62,290,200,50},
	s_image_adjust_contrast_subb_xywh= {262,300,30,30},
	s_image_adjust_t_contrast_xywh= {292,290,208,50},
	s_image_adjust_contrast_add_xywh= {500,300,30,30},
	s_image_adjust_contrast_value_xywh= {530,300,60,30},
	s_image_adjust_cap_satura_xywh= {62,350,200,50},
	s_image_adjust_satura_subb_xywh= {262,360,30,30},
	s_image_adjust_t_satura_xywh= {292,350,208,50},
	s_image_adjust_satura_add_xywh= {500,360,30,30},
	s_image_adjust_satura_value_xywh= {530,360,60,30},
	s_image_adjust_apply_xywh= {250,450,150,40},
	s_image_adjust_cancel_xywh= {430,450,150,40},
	s_image_adjust_draw_xywh= {0,60,0,2},
}

w1_image_adjust.s_1440 = 
{
	s_image_adjust_page_xywh = {405,195,630,510},
	s_image_adjust_title_xywh= {5,5,580,50},
	s_image_adjust_close_xywh= {580,10,32,32},
	s_image_adjust_c_where_xywh= {62,105,130,50},
	s_image_adjust_t_where_xywh= {262,110,220,40},
	s_image_adjust_cap_brig_xywh= {62,170,200,50},
	s_image_adjust_brig_subb_xywh= {262,180,30,30},
	s_image_adjust_t_brig_xywh= {292,170,208,50},
	s_image_adjust_brig_add_xywh= {500,180,30,30},
	s_image_adjust_brig_value_xywh= {530,180,60,30},
	s_image_adjust_cap_sharp_xywh= {62,230,200,50},
	s_image_adjust_sharp_subb_xywh= {262,240,30,30},
	s_image_adjust_t_sharp_xywh= {292,230,208,50},
	s_image_adjust_sharp_add_xywh= {500,240,30,30},
	s_image_adjust_sharp_value_xywh= {530,240,60,30},
	s_image_adjust_cap_contrast_xywh= {62,290,200,50},
	s_image_adjust_contrast_subb_xywh= {262,300,30,30},
	s_image_adjust_t_contrast_xywh= {292,290,208,50},
	s_image_adjust_contrast_add_xywh= {500,300,30,30},
	s_image_adjust_contrast_value_xywh= {530,300,60,30},
	s_image_adjust_cap_satura_xywh= {62,350,200,50},
	s_image_adjust_satura_subb_xywh= {262,360,30,30},
	s_image_adjust_t_satura_xywh= {292,350,208,50},
	s_image_adjust_satura_add_xywh= {500,360,30,30},
	s_image_adjust_satura_value_xywh= {530,360,60,30},
	s_image_adjust_apply_xywh= {250,450,150,40},
	s_image_adjust_cancel_xywh= {430,450,150,40},
	s_image_adjust_draw_xywh= {0,60,0,2},
}

w1_image_adjust.s_1080p = 
{
	s_image_adjust_page_xywh = {645,285,630,510},
	s_image_adjust_title_xywh= {5,5,580,50},
	s_image_adjust_close_xywh= {580,10,32,32},
	s_image_adjust_c_where_xywh= {62,105,130,50},
	s_image_adjust_t_where_xywh= {262,110,220,40},
	s_image_adjust_cap_brig_xywh= {62,170,200,50},
	s_image_adjust_brig_subb_xywh= {262,180,30,30},
	s_image_adjust_t_brig_xywh= {292,170,208,50},
	s_image_adjust_brig_add_xywh= {500,180,30,30},
	s_image_adjust_brig_value_xywh= {530,180,60,30},
	s_image_adjust_cap_sharp_xywh= {62,230,200,50},
	s_image_adjust_sharp_subb_xywh= {262,240,30,30},
	s_image_adjust_t_sharp_xywh= {292,230,208,50},
	s_image_adjust_sharp_add_xywh= {500,240,30,30},
	s_image_adjust_sharp_value_xywh= {530,240,60,30},
	s_image_adjust_cap_contrast_xywh= {62,290,200,50},
	s_image_adjust_contrast_subb_xywh= {262,300,30,30},
	s_image_adjust_t_contrast_xywh= {292,290,208,50},
	s_image_adjust_contrast_add_xywh= {500,300,30,30},
	s_image_adjust_contrast_value_xywh= {530,300,60,30},
	s_image_adjust_cap_satura_xywh= {62,350,200,50},
	s_image_adjust_satura_subb_xywh= {262,360,30,30},
	s_image_adjust_t_satura_xywh= {292,350,208,50},
	s_image_adjust_satura_add_xywh= {500,360,30,30},
	s_image_adjust_satura_value_xywh= {530,360,60,30},
	s_image_adjust_apply_xywh= {250,450,150,40},
	s_image_adjust_cancel_xywh= {430,450,150,40},
	s_image_adjust_draw_xywh= {0,60,0,2},
}

w1_image_adjust.s_2k = 
{
	s_image_adjust_page_xywh = {860,380,840,680},
	s_image_adjust_title_xywh= {7,7,773,67},
	s_image_adjust_close_xywh= {773,13,43,43},
	s_image_adjust_c_where_xywh= {83,140,173,67},
	s_image_adjust_t_where_xywh= {349,147,293,53},
	s_image_adjust_cap_brig_xywh= {83,227,267,67},
	s_image_adjust_brig_subb_xywh= {349,240,40,40},
	s_image_adjust_t_brig_xywh= {389,227,277,67},
	s_image_adjust_brig_add_xywh= {667,240,40,40},
	s_image_adjust_brig_value_xywh= {706,240,80,40},
	s_image_adjust_cap_sharp_xywh= {83,307,267,67},
	s_image_adjust_sharp_subb_xywh= {349,320,40,40},
	s_image_adjust_t_sharp_xywh= {389,307,277,67},
	s_image_adjust_sharp_add_xywh= {667,320,40,40},
	s_image_adjust_sharp_value_xywh= {706,320,80,40},
	s_image_adjust_cap_contrast_xywh= {83,387,267,67},
	s_image_adjust_contrast_subb_xywh= {349,400,40,40},
	s_image_adjust_t_contrast_xywh= {389,387,277,67},
	s_image_adjust_contrast_add_xywh= {667,400,40,40},
	s_image_adjust_contrast_value_xywh= {706,400,80,40},
	s_image_adjust_cap_satura_xywh= {83,467,267,67},
	s_image_adjust_satura_subb_xywh= {349,480,40,40},
	s_image_adjust_t_satura_xywh= {389,467,277,67},
	s_image_adjust_satura_add_xywh= {667,480,40,40},
	s_image_adjust_satura_value_xywh= {706,480,80,40},
	s_image_adjust_apply_xywh= {333,600,200,53},
	s_image_adjust_cancel_xywh= {573,600,200,53},
	s_image_adjust_draw_xywh= {0,80,0,3},
}

w1_image_adjust.s_4k = 
{
	s_image_adjust_page_xywh = {1290,570,1260,1020},
	s_image_adjust_title_xywh= {10,10,1160,100},
	s_image_adjust_close_xywh= {1160,20,64,64},
	s_image_adjust_c_where_xywh= {124,210,260,100},
	s_image_adjust_t_where_xywh= {524,220,440,80},
	s_image_adjust_cap_brig_xywh= {124,340,400,100},
	s_image_adjust_brig_subb_xywh= {524,360,60,60},
	s_image_adjust_t_brig_xywh= {584,340,416,100},
	s_image_adjust_brig_add_xywh= {1000,360,60,60},
	s_image_adjust_brig_value_xywh= {1060,360,120,60},
	s_image_adjust_cap_sharp_xywh= {124,460,400,100},
	s_image_adjust_sharp_subb_xywh= {524,480,60,60},
	s_image_adjust_t_sharp_xywh= {584,460,416,100},
	s_image_adjust_sharp_add_xywh= {1000,480,60,60},
	s_image_adjust_sharp_value_xywh= {1060,480,120,60},
	s_image_adjust_cap_contrast_xywh= {124,580,400,100},
	s_image_adjust_contrast_subb_xywh= {524,600,60,60},
	s_image_adjust_t_contrast_xywh= {584,580,416,100},
	s_image_adjust_contrast_add_xywh= {1000,600,60,60},
	s_image_adjust_contrast_value_xywh= {1060,600,120,60},
	s_image_adjust_cap_satura_xywh= {124,700,400,100},
	s_image_adjust_satura_subb_xywh= {524,720,60,60},
	s_image_adjust_t_satura_xywh= {584,700,416,100},
	s_image_adjust_satura_add_xywh= {1000,720,60,60},
	s_image_adjust_satura_value_xywh= {1060,720,120,60},
	s_image_adjust_apply_xywh= {500,900,300,80},
	s_image_adjust_cancel_xywh= {860,900,300,80},
	s_image_adjust_draw_xywh= {0,120,0,4},
}

local COLOR_PARAM = {
	default = {bright = 50, contrast = 50, saturation = 50, sharpness = 50},
	indoor 	= {bright = 60, contrast = 50, saturation = 50, sharpness = 55},
	outdoor = {bright = 45, contrast = 50, saturation = 50, sharpness = 45}
};

local dlg_exit = function()
	local data = w1_image_adjust.old_data;
	if(data.color ==nil)then
		return 0;
	end 
	b_app_api.set_color(data.color);
	return 0;
end

local getcolorinfo = function(top)
	local get_value = function(win_id)
		return b_wnd_ex.get_value(top, win_id);
	end	
	local cwnd = w1_image_adjust.dlg;
	local data = {};
	data.color= util.copy_tab(w1_image_adjust.old_data.color);
	data.color.channel = w1_image_adjust.old_data.color.channel;
	data.color.where = b_wnd_ex.get_sel (top, cwnd.t_where.id)
	if(-1 ~= data.color.bright)then
		data.color.bright = get_value(cwnd.t_brig.id);
	end
	if(-1 ~= data.color.contrast)then
		data.color.contrast = get_value(cwnd.t_contrast.id);
	end
	if(-1 ~= data.color.saturation)then
		data.color.saturation = get_value(cwnd.t_satura.id);
	end
	if(-1 ~= data.color.sharpness)then
		data.color.sharpness = get_value(cwnd.t_sharp.id);
	end
	return data.color;
end

local set_image_value = function(top, id, value)
	local set_text = function(id, value)
		b_wnd_ex.set_text(top, id, tostring(value), true)
	end
	local cwnd = w1_image_adjust.dlg;
	if(id == cwnd.t_brig.id) then
		set_text(cwnd.brig_value.id, value);
	elseif(id == cwnd.t_sharp.id) then
		set_text(cwnd.sharp_value.id, value);
	elseif(id == cwnd.t_contrast.id) then
		set_text(cwnd.contrast_value.id, value);
	elseif(id == cwnd.t_satura.id) then
		set_text(cwnd.satura_value.id, value);
	end
	
	local param = getcolorinfo(top)
	assert (nil ~= param and "table" == type(param))
	b_app_api.set_color(param);
end

local on_where =function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local set_value = function(id, value)
			b_wnd_ex.set_value(top, id, value, false);
		end
		local set_text = function(id, value)
			b_wnd_ex.set_text(top, id, tostring(value), false)
		end
		
		local cwnd = w1_image_adjust.dlg;
		
		local idx = b_wnd_ex.get_sel (top, win_id);
		local param = {};
		param.channel = w1_image_adjust.old_data.color.channel;	
		
		local colortable;
		if(idx == 0) then
			colortable = COLOR_PARAM.default;
		elseif(idx == 1) then
			colortable = COLOR_PARAM.indoor;
		elseif(idx == 2) then
			colortable = COLOR_PARAM.outdoor;		
		end	
		param.bright = colortable.bright;
		param.sharpness  = colortable.sharpness;
		param.contrast = colortable.contrast;
		param.saturation  = colortable.saturation;
		
		set_value(cwnd.t_brig.id,colortable.bright);
		set_value(cwnd.t_sharp.id,colortable.sharpness);
		set_value(cwnd.t_contrast.id,colortable.contrast);
		set_value(cwnd.t_satura.id,colortable.saturation);
		
		set_text(cwnd.brig_value.id, colortable.bright);
		set_text(cwnd.sharp_value.id, colortable.sharpness);
		set_text(cwnd.contrast_value.id, colortable.contrast);
		set_text(cwnd.satura_value.id, colortable.saturation);
		
		local param = getcolorinfo(top)
		assert (nil ~= param and "table" == type(param))
		b_app_api.set_color(param);
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local on_subb = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_image_adjust.dlg;
		local opearid = nil;
		if(win_id == cwnd.brig_subb.id) then
			opearid = cwnd.t_brig.id;
		elseif(win_id == cwnd.sharp_subb.id) then
			opearid = cwnd.t_sharp.id;
		elseif(win_id == cwnd.contrast_subb.id) then
			opearid = cwnd.t_contrast.id;
		elseif(win_id == cwnd.satura_subb.id) then
			opearid = cwnd.t_satura.id;
		end
		local value = b_wnd_ex.get_value(top, opearid);
		if(value > 0) then
			value = value - 1;
			b_wnd_ex.set_value(top, opearid, value, true)
			set_image_value(top, opearid, value);
		end	
	end
	return 0
end

local on_adj = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local cwnd = w1_image_adjust.dlg;
		local value = b_wnd_ex.get_value(top, win_id);
		set_image_value(top, win_id, value);
	end
	return 0
end

local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_image_adjust.dlg;
		local opearid = nil;
		if(win_id == cwnd.brig_add.id) then
			opearid = cwnd.t_brig.id;
		elseif(win_id == cwnd.sharp_add.id) then
			opearid = cwnd.t_sharp.id;
		elseif(win_id == cwnd.contrast_add.id) then
			opearid = cwnd.t_contrast.id;
		elseif(win_id == cwnd.satura_add.id) then
			opearid = cwnd.t_satura.id;
		end
		local value = b_wnd_ex.get_value(top, opearid);
		if(value < 100) then
			value = value + 1;
			b_wnd_ex.set_value(top, opearid, value, true)
			set_image_value(top, opearid, value);
		end
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local param = getcolorinfo(top)
		w1_image_adjust.old_data.color = param;
		b_dlg.end_modal(top);
	end
	return 0;
end


local on_cancel = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		dlg_exit();
		b_dlg.end_modal(top);
	end
	return 0;
end

local on_close = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		dlg_exit();
		b_dlg.end_modal(top);
	end
	return 0;
end

local dlg = {
	attr = {xywh='s_image_adjust_page_xywh'},
	sub = {'title','close','c_where','t_where',
			'cap_brig','brig_subb', 't_brig', 'brig_add', 'brig_value', 
			'cap_sharp', 'sharp_subb', 't_sharp', 'sharp_add', 'sharp_value', 
			'cap_contrast','contrast_subb', 't_contrast','contrast_add','contrast_value',
			'cap_satura', 'satura_subb', 't_satura', 'satura_add', 'satura_value', 	
			
			'apply','cancel'},							--text='Color Settings',trans = false,
	title 		= {t='static',id=id+1,xywh='s_image_adjust_title_xywh',text='LA_CAM_PICTURE',
					align = b_ui.ALIGN.CENTER,
					color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}
					};	
	close 		= {t='tt_button',id=id+2,xywh='s_image_adjust_close_xywh',t_imgs = {b_ui.ALIGN.LEFT,'f_closebtn2','it_close','it_close', 'it_close'}, cmd=on_close,
					color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_f'},
					color_f= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfgclose_bk'}
					},	
	c_where 	= {t='static',id=id+3,xywh='s_image_adjust_c_where_xywh',text='LA_SCENCE',
					color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}};
	t_where 	= {t='combox',id=id+4,xywh='s_image_adjust_t_where_xywh',	
					items={'LA_DEFAULT','LA_INDOOR','LA_OUTDOOR'},
					cmd = on_where
					};
	
	cap_brig 	= {t='static',id=id+5,xywh='s_image_adjust_cap_brig_xywh',text='LA_BRIGHT',align = b_ui.ALIGN.LEFT,
					color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}
					};
	
	brig_subb	= {t='button',id=id+6,	xywh='s_image_adjust_brig_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_brig		= {t='hslider',id=id+7,	xywh='s_image_adjust_t_brig_xywh',		
					font = 'f_slider', cmd=on_adj},
	brig_add	= {t='button',id=id+8,	xywh='s_image_adjust_brig_add_xywh',
					color	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	brig_value	= {t='static',id=id+9,	xywh='s_image_adjust_brig_value_xywh',text ='100',trans = false},
	--sharp		
	cap_sharp	= {t='static',id=id+10,	xywh='s_image_adjust_cap_sharp_xywh',		text='LA_SHARPNESS'},
	sharp_subb	= {t='button',id=id+11,	xywh='s_image_adjust_sharp_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_sharp		= {t='hslider',id=id+12,	xywh='s_image_adjust_t_sharp_xywh',		
					font = 'f_slider', cmd=on_adj},
	sharp_add	= {t='button',id=id+13,	xywh='s_image_adjust_sharp_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	sharp_value	= {t='static',id=id+14,	xywh='s_image_adjust_sharp_value_xywh',text ='100',trans = false},
	--contrast
	cap_contrast= {t='static',id=id+15,	xywh='s_image_adjust_cap_contrast_xywh',		text='LA_CONTRAST'},
	contrast_subb	= {t='button',id=id+16,	xywh='s_image_adjust_contrast_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_contrast	= {t='hslider',id=id+17,	xywh='s_image_adjust_t_contrast_xywh',	
					font = 'f_slider', cmd=on_adj},
	contrast_add	= {t='button',id=id+18,	xywh='s_image_adjust_contrast_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	contrast_value	= {t='static',id=id+19,	xywh='s_image_adjust_contrast_value_xywh',text ='100',trans = false},
	--satura
	cap_satura	= {t='static',id=id+20,	xywh='s_image_adjust_cap_satura_xywh',		text='LA_SATURATION'},
	satura_subb	= {t='button',id=id+21,	xywh='s_image_adjust_satura_subb_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='-', trans =false, font = 'f_img_adj', cmd = on_subb},
	t_satura	= {t='hslider',id=id+22,xywh='s_image_adjust_t_satura_xywh',		
					font = 'f_slider', cmd=on_adj},
	satura_add	= {t='button',id=id+23,	xywh='s_image_adjust_satura_add_xywh',
					color 	= {'c_page_bk_n', 'c_page_bk_n', 'c_txt_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_txt_f'},
					text	='+', trans =false, font = 'f_img_adj', cmd = on_add},
	satura_value= {t='static',id=id+24,	xywh='s_image_adjust_satura_value_xywh',text ='100',trans = false},

	apply 		= {t='button',	id=id+26,	xywh='s_image_adjust_apply_xywh', 		text='LA_APPLY',cmd=on_apply};
	cancel  	= {t='button',	id=id+27,	xywh='s_image_adjust_cancel_xywh',		text='LA_CANCEL',cmd=on_cancel};
	
}

w1_image_adjust.on_create = function(top)
	w1_image_adjust.top = top;
	w1_image_adjust.dlg = dlg;

	b_parser(top, dlg);
	return 0;
end

w1_image_adjust.on_pre_show = function(top)
	local cwnd = w1_image_adjust.dlg;
	local wnd_data = b_wnd.get_wnd_data(top);
	local data = {
		color={};
	};
	local set_value = function(id, value)
		b_wnd_ex.set_value(top, id, value, false);
	end
	local set_text = function(id, value)
		b_wnd_ex.set_text(top, id, tostring(value), false)
	end
	
	assert('string' == type(wnd_data));
	wnd_data = cjson.decode(wnd_data);
	data.color.channel =math.floor(wnd_data.channel);
	
	if(data.color.channel >=1) then
		assert('number' == type(data.color.channel));
		data.color = b_app_api.get_color(data.color.channel);
		if(nil ~= data.color and "table" == type(data.color))then
			if(w1_image_adjust.old_data == nil) then
				w1_image_adjust.old_data = util.copy_tab(data);
			else
				util.copy_tab_b(w1_image_adjust.old_data, data);
			end
			
			b_wnd_ex.set_sel (top, cwnd.t_where.id,data.color.where,false);
			if(-1 ~= data.color.bright)then
				set_value(cwnd.t_brig.id,data.color.bright);
				set_text(cwnd.brig_value.id, data.color.bright);
			else
				b_wnd_ex.set_hide(top, cwnd.cap_brig.id, true, false);
				b_wnd_ex.set_hide(top, cwnd.brig_subb.id, true, false);
				b_wnd_ex.set_hide(top, cwnd.t_brig.id, true, false);
				b_wnd_ex.set_hide(top, cwnd.brig_add.id, true, false);
				b_wnd_ex.set_hide(top, cwnd.brig_value.id, true, false);	
			end
			
			if(-1 ~= data.color.sharpness)then
				set_value(cwnd.t_sharp.id,data.color.sharpness);
				set_text(cwnd.sharp_value.id, data.color.sharpness);
			else
				b_wnd_ex.set_hide(top, cwnd.cap_sharp.id, true, false);
				b_wnd_ex.set_hide(top, cwnd.sharp_subb.id, true, false);
				b_wnd_ex.set_hide(top, cwnd.t_sharp.id, true, false);
				b_wnd_ex.set_hide(top, cwnd.sharp_add.id, true, false);
				b_wnd_ex.set_hide(top, cwnd.sharp_value.id, true, false);
			end
			if(-1 ~= data.color.contrast)then
				set_value(cwnd.t_contrast.id,data.color.contrast);
				set_text(cwnd.contrast_value.id, data.color.contrast);
			else
				b_wnd_ex.set_hide(top, cwnd.cap_contrast.id, true, false);
				b_wnd_ex.set_hide(top, cwnd.contrast_subb.id, true, false);
				b_wnd_ex.set_hide(top, cwnd.t_contrast.id, true, false);
				b_wnd_ex.set_hide(top, cwnd.contrast_add.id, true, false);
				b_wnd_ex.set_hide(top, cwnd.contrast_value.id, true, false);	
			end
			if(-1 ~= data.color.saturation)then
				set_value(cwnd.t_satura.id,data.color.saturation);
				set_text(cwnd.satura_value.id, data.color.saturation);	
			else
				b_wnd_ex.set_hide(top, cwnd.cap_satura.id, true, false);
				b_wnd_ex.set_hide(top, cwnd.satura_subb.id, true, false);
				b_wnd_ex.set_hide(top, cwnd.t_satura.id, true, false);
				b_wnd_ex.set_hide(top, cwnd.satura_add.id, true, false);
				b_wnd_ex.set_hide(top, cwnd.satura_value.id, true, false);			
			end		
		end
	end
	
	if (w1_image_adjust.cur_data == nil) then
		w1_image_adjust.cur_data = data;
	else
		util.copy_tab_b(w1_image_adjust.cur_data, data);	
	end
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)	
	
	return 0;
end

w1_image_adjust.on_destroy = function(top)
	dlg_exit();--ֹԶǳδԭã»һ
	w1_image_adjust.top = nil;
	w1_image_adjust.dlg = nil;
	w1_image_adjust.cur_data = nil;
	w1_image_adjust.old_data = nil;
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)
	return 0;
end

w1_image_adjust.on_paint = function(top, status, x, y, cx, cy)
	local wndsize = SIZE('s_image_adjust_draw_xywh');
	b_wnd.begin_job(top);
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_row_bk'));
	b_wnd.draw_fill(top, x, y+wndsize[2], cx, wndsize[4], COLOR('c_hline_color'));
--	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_modch_border'), 1);
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top);
	return 0;
end

w1_image_adjust.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.RBUTTONCLK == vmsg) then
		dlg_exit();
		b_dlg.end_modal(top);
	end
	return 0;
end

return w1_image_adjust;




