﻿local global_val= require("wnd.global_val")
local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.login.login_id
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_app_cfg	= require("wnd.core.b_app_cfg")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local w1_legal 	= require("wnd.w1_util.w1_legal")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local util 		= require("wnd.core.util")
local err_login_pwd_error = -508;
local err_login_user_lock = -515;
local err_pwd_expired = -544;
local err_stat = 0;
local err_str;
local flag = 0;
		
local LANGUAGE = {};
local LANGUAGE_LIST = {};
local language_str = {
  english 		="English",
  chinese		="简体中文",
  russian		="русский",
  french		="Français",
  japanese		="日本語",
  german		="Deutsche",
  spanish		="Español",
  portuguese	="Português",
  polish		="Polskie",
  arabic		="العربية",
  bosnian		="Bosanski",
  bulgarian		="български",
  catalan		="Català",
  chinese_t		="繁體中文",
  croatian		="Hrvatski",
  czech			="Čeština",
  danish		="Dansk",
  dutch			="Nederlands",
  estonian		="Eesti keel",
  farsi			="فارسی",
  filipino		="Filipino",
  finnish		="Suomalainen",
  greek			="Ελληνικά",
  hebrew		="עברית",
  hungarian		="Magyar",
  italian		="Italiano",
  korean		="한국어",
  latvian		="Latviešu valoda",
  lithuanian	="Lietuviškai",
  romanian		="Românesc",
  serbian		="Српски",
  slovakia		="Slovensko",
  slovenian		="Slovenščina",
  swedish		="Svenska",
  thai			="ไทย",
  turkish		="Türk dili",
  ukrainian		="Українська",
  vietnamese	="Tiếng Việt",
  norwegian		="Norsk språk",
  indonesian	="Indonesian"
}
		

local w1_login = {
	t = w1_key.DLG_LOGIN,
	top = nil,
	dlg = nil,
	is_show	 = false,
	mouse_last_opt_time;		--鼠标上次操作时间
	check_verification,
	change_logintype = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_login.s_768 =
{
	s_login_page_xywh = {400,234,224,298},
	s_login_title_xywh = {26,3,170,32},
	s_login_cap_language_xywh = {16,71,26,32},
	s_login_t_languaget_xywh = {53,71,128,32},
	s_login_cap_account_xywh = {16,113,26,32},
	s_login_t_account_xywh = {53,113,128,32},
	s_login_cap_password_xywh = {16,156,26,32},
	s_login_t_password_xywh = {53,156,128,32},
	s_login_login_xywh = {53,199,128,32},
	s_login_pattern_xywh = {16,241,96,32},
	s_login_forget_xywh = {112,241,96,32},
	s_login_expired_tip = {53,241,128,32},
	s_login_draw_xywh = {1,36,1,1},
};

w1_login.s_1280 = 
{
	s_login_page_xywh= {430,302,420,420},
	s_login_title_xywh= {50,5,320,45},
	s_login_cap_language_xywh= {30,100,50,45},
	s_login_t_languaget_xywh= {100,100,240,45},
	s_login_cap_account_xywh= {30,160,50,45},
	s_login_t_account_xywh= {100,160,240,45},
	s_login_cap_password_xywh= {30,220,50,45},
	s_login_t_password_xywh= {100,220,240,45},
	s_login_login_xywh= {100,280,240,45},
	s_login_pattern_xywh= {30,340,180,45},
	s_login_forget_xywh= {210,340,180,45},
	s_login_expired_tip= {100,340,240,45},
	s_login_draw_xywh= {1,51,2,1},
};

w1_login.s_1440 = 
{
	s_login_page_xywh= {510,240,420,420},
	s_login_title_xywh= {50,5,320,45},
	s_login_cap_language_xywh= {30,100,50,45},
	s_login_t_languaget_xywh= {100,100,240,45},
	s_login_cap_account_xywh= {30,160,50,45},
	s_login_t_account_xywh= {100,160,240,45},
	s_login_cap_password_xywh= {30,220,50,45},
	s_login_t_password_xywh= {100,220,240,45},
	s_login_login_xywh= {100,280,240,45},
	s_login_pattern_xywh= {30,340,180,45},
	s_login_forget_xywh= {210,340,180,45},
	s_login_expired_tip= {100,340,240,45},
	s_login_draw_xywh= {1,51,2,1},
};

w1_login.s_1080p = 
{
	s_login_page_xywh= {750,330,420,420},
	s_login_title_xywh= {50,5,320,45},
	s_login_cap_language_xywh= {30,100,50,45},
	s_login_t_languaget_xywh= {100,100,240,45},
	s_login_cap_account_xywh= {30,160,50,45},
	s_login_t_account_xywh= {100,160,240,45},
	s_login_cap_password_xywh= {30,220,50,45},
	s_login_t_password_xywh= {100,220,240,45},
	s_login_login_xywh= {100,280,240,45},
	s_login_pattern_xywh= {30,340,180,45},
	s_login_forget_xywh= {210,340,180,45},
	s_login_expired_tip= {100,340,240,45},
	s_login_draw_xywh= {1,51,2,1},
};
w1_login.s_2k = 
{
	s_login_page_xywh= {1000,440,560,560},
	s_login_title_xywh= {67,7,427,60},
	s_login_cap_language_xywh= {40,133,67,60},
	s_login_t_languaget_xywh= {133,133,320,60},
	s_login_cap_account_xywh= {40,213,67,60},
	s_login_t_account_xywh= {133,213,320,60},
	s_login_cap_password_xywh= {40,293,67,60},
	s_login_t_password_xywh= {133,293,320,60},
	s_login_login_xywh= {133,373,320,60},
	s_login_pattern_xywh= {40,453,240,60},
	s_login_forget_xywh= {280,453,240,60},
	s_login_expired_tip= {133,453,320,60},
	s_login_draw_xywh= {1,68,3,1},
};
w1_login.s_4k = 
{
	s_login_page_xywh= {1500,660,840,840},
	s_login_title_xywh= {100,10,640,90},
	s_login_cap_language_xywh= {60,200,100,90},
	s_login_t_languaget_xywh= {200,200,480,90},
	s_login_cap_account_xywh= {60,320,100,90},
	s_login_t_account_xywh= {200,320,480,90},
	s_login_cap_password_xywh= {60,440,100,90},
	s_login_t_password_xywh= {200,440,480,90},
	s_login_login_xywh= {200,560,480,90},
	s_login_pattern_xywh= {60,680,360,90},
	s_login_forget_xywh= {420,680,360,90},
	s_login_expired_tip= {200,680,480,90},
	s_login_draw_xywh= {2,102,4,2},
};

local check_adminpwd = function(user_name, user_pwd)
	assert(nil ~= user_name and "string" == type(user_name));
	assert(nil ~= user_pwd and "string" == type(user_pwd));

	local result = b_app_api.check_admin_pwd(user_name, user_pwd)
	assert(result ~= nil and "table" == type(result))
	if (0 == result.ret) then
		return true;
	else
		return false;
	end
end

local on_language= function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		local idx = b_wnd_ex.get_sel(top, w1_login.dlg.t_languaget.id);
		b_app_api.language_change(LANGUAGE[idx+1]);
		local path = "language/"..LANGUAGE[idx+1]..".json"
		r_str.load(path)	
		
		b_wnd_ex.set_text(top, w1_login.dlg.title.id,STR('LA_LOGIN'),false)
		b_wnd_ex.set_text(top, w1_login.dlg.login.id,STR('LA_LOGIN'),false)
		b_wnd_ex.set_text(top, w1_login.dlg.forget.id,STR('LA_FORGOT_PW'),false)
		b_wnd_ex.set_text(top, w1_login.dlg.pattern.id,STR('LA_PATTERN'),false);
		b_wnd_ex.set_guide_text(top, w1_login.dlg.t_password.id,STR('LA_PASSWORD'),false);
		b_dlg.dlg_set_redraw(top)
		return b_ui.WM_USER_UPDATE_LOGIN_LANGUARE;
	end
	return 0
end

local on_account = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local cwnd = w1_login.dlg;
		local account = b_wnd_ex.get_text(top, cwnd.t_account.id);
		local root_name = G.get_root_user_name();
		b_wnd_ex.set_hide(top,cwnd.t_tipinfo.id,true,false)
		b_wnd_ex.set_color(top,w1_login.dlg.t_password.id,
		{COLOR('c_modch_edit_bk'),COLOR('c_popdlg_border'),COLOR('c_popdlg_text')},false)
		if account == root_name then
			b_wnd_ex.set_hide(top,cwnd.forget.id,false,false);
			local pri_cfg = b_app_api.get_cfg({'privacy'})
			local pattern = b_app_api.get_pattern_pwd(G.get_root_user_name());
			if ((pattern ~= nil and pattern.pattern_enable == false) or pri_cfg.privacy.pattern_unlock == false) then
				b_wnd_ex.set_hide(top,cwnd.pattern.id,true,false);
				local size = SIZE('s_login_forget_xywh');
				local size_page = SIZE('s_login_page_xywh');
				local param = {[1]=(size_page[3]-size[3])/2,[2]=size[2],[3]=size[3],[4]=size[4]};
				b_wnd_ex.move_ex(top,cwnd.forget.id,param,false);
			else
				b_wnd_ex.set_hide(top,cwnd.pattern.id,false,false);
				local size = SIZE('s_login_forget_xywh');
				b_wnd_ex.move_ex(top,cwnd.forget.id,size,false);
			end
		else
			b_wnd_ex.set_hide(top,cwnd.forget.id,true,false);
			b_wnd_ex.set_hide(top,cwnd.pattern.id,true,false);
		end
		G.set_user_name(account);
		b_wnd_ex.set_password(top, w1_login.dlg.t_password.id, "", false) --用户切换清空密码输入框
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local okfunction =function(param)
	if(w1_login.dlg ~= nil)then
		b_wnd_ex.set_password(param[1], w1_login.dlg.t_password.id, "", false)
	else
		print("----login---okfunction---------");
		assert(false);
	end
end

local on_login =function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then	
		local user_name = b_wnd_ex.get_text(top,w1_login.dlg.t_account.id)
		local pwd = b_wnd_ex.get_password(top, w1_login.dlg.t_password.id)
		local cwnd = w1_login.dlg;
		err_stat = 0;
		err_str = "";
		if (pwd == "") then
			err_stat = 1;
			err_str = "";
			b_wnd_ex.set_color(top,w1_login.dlg.t_password.id,
			{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
			b_wnd_ex.set_color_f(top,w1_login.dlg.t_password.id,
			{COLOR('c_edit_bg_f'),COLOR('c_edit_border_errf'),COLOR('c_txt_f')},false)
			b_dlg.dlg_set_redraw(top)
			return 0
		end
		
		if err_stat == 1 and err_str == pwd then
			flag = 1;
			return 0;
		end
		local pwd_rule = b_app_api.get_cfg({'pwd_rule_info'}).pwd_rule_info
		local mins = math.floor(pwd_rule.lock_time/60)
		local str = string.gsub(STR('LA_LOGIN_LOCK'), '*' ,mins); 
		local result = b_app_api.user_login(user_name, pwd)
		assert(result ~= nil and "table" == type(result))	
		-- 0 正常密码登录成功返回值  1 超级临时密码登录成功返回值 
		if (0 ~= result.ret and 1 ~= result.ret) then
			if (err_login_pwd_error == result.ret) then
				err_stat = 1;
				err_str = pwd;
				b_wnd_ex.set_color(top,w1_login.dlg.t_password.id,
				{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
				b_dlg.dlg_set_redraw(top)
			elseif (err_login_user_lock == result.ret) then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), str, true, false,false);
				w1_msgbox.set_func(okfunction,{top}, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)	
				b_dlg.dlg_set_redraw(top)	
			elseif(err_pwd_expired == result.ret) then
				b_wnd_ex.set_color(top,w1_login.dlg.t_password.id,
				{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},false)
				b_wnd_ex.set_hide(top,cwnd.t_tipinfo.id,false,false)
				b_dlg.dlg_set_redraw(top)
			end
		else
			err_stat = 0;
			err_str = '';
			local idx = b_wnd_ex.get_sel(top, w1_login.dlg.t_languaget.id);
			if(b_app_cfg.user_cfg == nil or b_app_cfg.user_cfg.device == nil)then
				b_app_cfg.init({'device'})
			end
			if(b_app_cfg.user_cfg.device.language ~= LANGUAGE[idx+1])then
				b_app_cfg.user_cfg.device.language = LANGUAGE[idx+1]
				
				local deviceinfo ={};
				deviceinfo.device = b_app_cfg.user_cfg.device
				b_app_cfg.savechangecfg(deviceinfo)
				b_app_cfg.saveSuccessful();		
			end
			
			local boot_gui = result.boot_guide;
			
			--登录成功 更新登录用户名称
			b_app_api.update_login_user_name(user_name);
			--获取用户自身权限
			local user_info = b_app_api.get_current_user_info(user_name)
			assert(user_info ~= nil and "table" == type(user_info))
			global_val.set_current_user_info(user_info);
			
			if (result.ret == 1) then		--超级临时密码登录修改密码
				return b_ui_msg.msg_on_skip_modify_default_pwd;
			elseif (true == boot_gui) then		--开机向导
				return b_ui_msg.msg_on_skip_wizard; 
			elseif (true ~= user_info.m_bisValid) then	--密码过期
				return b_ui_msg.msg_on_skip_reminder_pwd;	
			else
				return b_ui_msg.msg_on_login_successful
			end	
		end		
	end	
	
	return 0;
end

w1_login.set_check_verification = function (top,check)
	w1_login.check_verification = check;
end

local on_forget =function(top,win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then	
		b_dlg.do_modal(top, w1_key.DLG_FORGOT, 0, 0, nil)
		if w1_login.check_verification == true then
			w1_login.check_verification = false
			return b_ui_msg.msg_on_skip_modify_default_pwd;
		end
	end
	return 0;
end

local get_all_user = function(top)
	local username_list = b_app_api.get_all_username();
	assert(username_list ~= nil and type(username_list) == "table")
	local user_name = G.get_user_name();
	local index = 0;
	local param={};
	for i=1,#username_list do
		param[i] = username_list[i];
		if user_name == username_list[i] then
			index = i-1;
		end
	end
	b_wnd_ex.set_items(top, w1_login.dlg.t_account.id, param, false);
	b_wnd_ex.set_sel(top,w1_login.dlg.t_account.id, index, false);
	local account = b_wnd_ex.get_text(top, w1_login.dlg.t_account.id);
	G.set_user_name(account);
end

local init_t_languaget = function(top)
	b_wnd_ex.set_items(top,w1_login.dlg.t_languaget.id,LANGUAGE_LIST,false);

	b_app_cfg.init({'device','language_limits'})

	local data = b_app_cfg.user_cfg.device
	local language_data = b_app_cfg.user_cfg.language_limits
	LANGUAGE = {};
	LANGUAGE_LIST ={};
	for i =1,language_data.language_num do
		local language = language_data.language_list[i]
		table.insert(LANGUAGE_LIST,language_str[language]) 
		table.insert(LANGUAGE,language );
	end
	b_wnd_ex.set_items(top,w1_login.dlg.t_languaget.id,LANGUAGE_LIST,false);
	for i=1,#LANGUAGE do
		if(data.language ==LANGUAGE[i])then
			 b_wnd_ex.set_sel(top, w1_login.dlg.t_languaget.id,i-1,false);
		end
	end	
end	

local on_pattern =function(top,win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		return b_ui_msg.msg_on_change_login_type;
	end
	return 0;
end

local on_dlg = function(top, id, vmsg, x, y)
	if b_ui.TIMER == vmsg then
		local opt_flag = b_app_api.get_mouse_operation_flag();
		if (0 ~= opt_flag) then
			b_app_api.set_mouse_operation_flag(0);
			w1_login.mouse_last_opt_time = os.time();
		end
		if flag ~= 0 then
			if flag == 1 then
				flag = 2;
			b_wnd_ex.set_color(top,w1_login.dlg.t_password.id,
				{COLOR('c_modch_edit_bk'),COLOR('c_popdlg_border'),COLOR('c_popdlg_text')},true)
			elseif flag == 2 then
				flag = 0;
			b_wnd_ex.set_color(top,w1_login.dlg.t_password.id,
				{COLOR('c_edit_bg_n'),COLOR('c_edit_border_errn'),COLOR('c_edit_text_n')},true)	
			end	
		end
		local cur_tinme = os.time() 
		--60s不操作隐藏界面
		if (60 < cur_tinme - w1_login.mouse_last_opt_time) then
			w1_login.is_show = false;
			w1_login.mouse_last_opt_time = cur_tinme
			b_dlg.clear_foucs_wnd(top);
			b_dlg.dlg_set_hide(top, 1, 0);
			b_wnd_ex.set_password(top,w1_login.dlg.t_password.id,"",false)
			b_dlg.dlg_set_redraw(top)	
			return b_ui_msg.msg_on_refresh_full_screen;
		end
	end	
	
	return 0
end	

local dlg = {
	attr={xywh = 's_login_page_xywh', cmd=on_dlg,timer={-1, 500}},
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'},
	sub = {"title","cap_language","t_languaget","cap_account","t_account","cap_password","t_password", "login","forget","pattern","t_tipinfo"};
	title ={t='static',id=id+1,xywh='s_login_title_xywh',text='LA_LOGIN',align = b_ui.ALIGN.CENTER, font = 'f_grade2'},
	
	cap_language = {t='tt_button',id=id+3,xywh='s_login_cap_language_xywh',
		   color = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_f'},
		  t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_language','it_language_f', 'it_language'}},
	t_languaget = {t='combox',id=id+4,xywh='s_login_t_languaget_xywh',items={'english','french','polish'},trans = false,cmd = on_language},	
	
	cap_account	= {t='tt_button',id=id+5,xywh='s_login_cap_account_xywh',color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_f'},
		 t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_account','it_account_f', 'it_account'}},
	t_account 	= {t='combox',id=id+6,xywh='s_login_t_account_xywh',items={'admin'},trans = false,cmd = on_account},	
	
	cap_password = {t='tt_button',id=id+7,xywh='s_login_cap_password_xywh',color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_f'},
		  t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_password','it_password_f', 'it_password'}},
	t_password 	= {t='password',	id=id+8,	xywh='s_login_t_password_xywh',	password='', guide_text='LA_PASSWORD',
				   color = {'c_modch_edit_bk', 'c_popdlg_border', 'c_popdlg_text'}},	
	
	login 	= {t='button',id=id+9,	xywh ='s_login_login_xywh' ,text='LA_LOGIN',cmd=on_login},
	forget = {t='buttontext',id=id+10,	xywh = 's_login_forget_xywh',text='LA_FORGOT_PW',align = b_ui.ALIGN.CENTER,
			color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_f'},cmd= on_forget},
	pattern = {t='buttontext',id=id+11,	xywh = 's_login_pattern_xywh',text='LA_PATTERN',align = b_ui.ALIGN.CENTER,
			color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_f'},cmd= on_pattern},
	
	t_tipinfo = {t='static',id=id+12,xywh = 's_login_expired_tip',text='LA_PASS_EXPIRED',color = {'c_hint_bk', 'c_hint_border', 'c_hint_text'}},
}

local get_super_name = function()
	local admin_info = b_app_api.get_super_admin();	
	assert(nil ~= admin_info and type(admin_info) == "table");
	--默认的用户名和密码一致 因此都是用户名
	local root_name = G.get_root_user_name();
	local user_name = G.get_user_name();
	G.set_root_user_name(admin_info.user_name);
	if root_name == user_name then
		G.set_user_name(admin_info.user_name);
	end
end	

w1_login.on_pre_show  = function(top)
	local cwnd = w1_login.dlg;
	--获取超级用户用户名默认密码
	get_super_name();
	
	--设置语言下拉框
	init_t_languaget(top)
	get_all_user(top)
	w1_login.change_logintype = false
	w1_login.check_verification = false
	w1_login.is_show = true
	w1_login.mouse_last_opt_time = os.time()
	local account = b_wnd_ex.get_text(top, cwnd.t_account.id);
	local root_name = G.get_root_user_name();
	b_wnd_ex.set_hide(top,cwnd.t_tipinfo.id,true,false)
	if account == root_name then
		b_wnd_ex.set_hide(top,cwnd.forget.id,false,false);
		local pattern = b_app_api.get_pattern_pwd(G.get_root_user_name());
		local pri_cfg = b_app_api.get_cfg({'privacy'})
		if (pattern == nil or pattern.pattern_enable == false) or (pri_cfg.privacy.pattern_unlock == false) then
			b_wnd_ex.set_hide(top,cwnd.pattern.id,true,false);
			local size = SIZE('s_login_forget_xywh');
			local size_page = SIZE('s_login_page_xywh');
			local param = {[1]=(size_page[3]-size[3])/2,[2]=size[2],[3]=size[3],[4]=size[4]};
			b_wnd_ex.move_ex(top,cwnd.forget.id,param,false);
		else
			b_wnd_ex.set_hide(top,cwnd.pattern.id,false,false);
			local size = SIZE('s_login_forget_xywh');
			b_wnd_ex.move_ex(top,cwnd.forget.id,size,false);
		end
		
	else
		b_wnd_ex.set_hide(top,cwnd.forget.id,true,false);
		b_wnd_ex.set_hide(top,cwnd.pattern.id,true,false);
	end
	
	return 0
end

w1_login.on_create = function(top)
	w1_login.top = top
	w1_login.dlg = dlg
	b_parser(top, dlg)	
	
	--关闭现场定时器
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_chcek_login)	
	
	return 0
end

w1_login.on_destroy = function(top)
	w1_login.top = nil
	w1_login.dlg = nil
	LANGUAGE = nil
    LANGUAGE_LIST = nil
	w1_login.is_show = false
	
	--开启现场定时器
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)
	if w1_login.change_logintype == true then
		w1_login.change_logintype = false
		b_dlg.post_modal(top,w1_key.DLG_LOGIN_G,0,0,nil);
	end
	return 0
end

w1_login.on_paint = function(top, status, x, y, cx, cy)
	local wndsize = SIZE('s_login_draw_xywh');
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_row_bk'))
	b_wnd.draw_fill(top, x + wndsize[1], y+wndsize[2], cx - wndsize[3], wndsize[4], COLOR('c_hline_color'))
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top)
	return 0
end

w1_login.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.RBUTTONCLK == vmsg) then
		if (true == w1_login.is_show) then
			w1_login.is_show = false;
			b_dlg.clear_foucs_wnd(top);
			b_dlg.dlg_set_hide(top, 1, 0);
			b_dlg.dlg_set_redraw(top)	
			b_wnd_ex.set_password(top,w1_login.dlg.t_password.id,"",false)
			return b_ui_msg.msg_on_refresh_full_screen;
		else
			w1_login.is_show = true;
			b_dlg.dlg_set_hide(top, 0, 0);
			b_dlg.dlg_set_redraw(top)	
		end
	elseif (b_ui_msg.msg_on_refresh_full_screen == vmsg) then
		return vmsg	
	elseif (b_ui.LBUTTONCLK == vmsg) then
		if (true == w1_login.is_show) then --显示
		
		else
			w1_login.is_show = true;
			b_dlg.dlg_set_hide(top, 0, 0);
			b_dlg.dlg_set_redraw(top)	
		end
	elseif (b_ui_msg.msg_on_login_successful == vmsg) then	
		b_dlg.end_modal(top)
		return vmsg
	elseif (b_ui_msg.msg_on_skip_wizard == vmsg) then			--开机向导
		b_dlg.end_modal(top)
		return vmsg
	elseif(b_ui.WM_USER_UPDATE_LOGIN_LANGUARE == vmsg) then
		return b_ui.WM_USER_UPDATE_LOGIN_LANGUARE;	
	elseif (b_ui_msg.msg_on_skip_modify_default_pwd == vmsg) then --修改默认密码
		b_dlg.end_modal(top)
		return vmsg	
	elseif (b_ui_msg.msg_on_skip_reminder_pwd == vmsg) then		 --密码过期提醒
		b_dlg.end_modal(top)
		return vmsg
	elseif (b_ui_msg.msg_on_change_login_type == vmsg) then	--切换登陆方式
		b_dlg.end_modal(top)
		w1_login.change_logintype = true
		return vmsg;
	elseif b_ui_msg.msg_user_update_parent == vmsg or b_ui_msg.msg_user_pwd_click == vmsg then
		b_wnd_ex.set_color(top,w1_login.dlg.t_password.id,
			{COLOR('c_modch_edit_bk'),COLOR('c_popdlg_border'),COLOR('c_popdlg_text')},true)		
	end
		
	return 0
end



return w1_login




