--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/3/20
-- author lsl
-- brief  öԻ
--]]
local global_val 	= require("wnd.global_val")
local b_wnd 	= require("wnd.core.b_wnd")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.toolbar.manual_id
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local app_api 	= require("app_api")
local b_app_api = require("wnd.core.command.b_app_api");
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local channel_list = {}

local w1_manual_control = {
	t = w1_key.DLG_MUANUAL,
	top = nil,
	dlg = nil,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_manual_control.s_768 =
{
	s_manual_control_xywh = {642,270,376,465},
	s_manual_control_alarm_xywh = {2,8,372,28},
	s_manual_control_close_xywh = {348,8,21,28},
	s_manual_control_draw = {0,41,0,1},
	s_manual_control_list_xywh = {10,56,357,405},
	s_manual_list_w1 = {80,0,0,0},
	s_manual_list_w2 = {80,0,0,0},
	s_manual_list_w3 = {93,0,0,0},
	s_manual_list_w4 = {94,0,0,0},
};

w1_manual_control.s_1280 = 
{
	s_manual_control_xywh= {573,326,705,655},
	s_manual_control_alarm_xywh= {2,12,701, 40},
	s_manual_control_close_xywh= {653,12,40, 40},
	s_manual_control_draw= {0,58,0,1},
	s_manual_control_list_xywh = {20,80,670,570},

	s_manual_list_w1={150,0,0,0},
	s_manual_list_w2={150,0,0,0},
	s_manual_list_w3={180,0,0,0},
	s_manual_list_w4={180,0,0,0},
};
w1_manual_control.s_1440 = 
{
	s_manual_control_xywh= {733,205,705,655},
	s_manual_control_alarm_xywh= {2,12,701, 40},
	s_manual_control_close_xywh= {653,12,40, 40},
	s_manual_control_draw= {0,58,0,1},
	s_manual_control_list_xywh = {20,80,670,570},

	s_manual_list_w1={150,0,0,0},
	s_manual_list_w2={150,0,0,0},
	s_manual_list_w3={180,0,0,0},
	s_manual_list_w4={180,0,0,0},
};
w1_manual_control.s_1080p = 
{
	s_manual_control_xywh= {1205,380,705,655},
	s_manual_control_alarm_xywh= {2,12,701, 40},
	s_manual_control_close_xywh= {653,12,40, 40},
	s_manual_control_draw= {0,58,0,1},
	s_manual_control_list_xywh = {20,80,670,570},
	s_manual_list_w1={150,0,0,0},
	s_manual_list_w2={150,0,0,0},
	s_manual_list_w3={180,0,0,0},
	s_manual_list_w4={180,0,0,0},

};
w1_manual_control.s_2k = 
{
	s_manual_control_xywh= {1602,507,940,873},
	s_manual_control_alarm_xywh= {3,16,934,53},
	s_manual_control_close_xywh= {880,16,53,53},
	s_manual_control_list_xywh = {26,106,892,758},
	s_manual_list_w1={200,0,0,0},
	s_manual_list_w2={200,0,0,0},
	s_manual_list_w3={240,0,0,0},
	s_manual_list_w4={240,0,0,0},
	s_manual_control_draw= {0,77,0,1},
};
w1_manual_control.s_4k = 
{
	s_manual_control_xywh= {2410,760,1410,1310},
	s_manual_control_alarm_xywh= {4,24,1402,80},
	s_manual_control_close_xywh= {1310,24,80,80},
	s_manual_control_list_xywh = {40,160,1340,1140},
	s_manual_list_w1={300,0,0,0},
	s_manual_list_w2={300,0,0,0},
	s_manual_list_w3={360,0,0,0},
	s_manual_list_w4={360,0,0,0},
	s_manual_control_draw= {0,116,0,2},
};

local on_close = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0
end

local updatelist = function(top, ro_num, redraw)
	local check_pppoe = b_app_api.get_cfg({'ioalarm_cap'}).ioalarm_cap;
	local channel_num=global_val.get_channelnum()
	local displist = {};
	local idx = 0;
	local num = 0
	channel_list = {};
	for i=1, channel_num+1 do
		idx = idx + 1;
		local ch_ro_num = 1
		if check_pppoe['channel'..idx-1]~=nil or idx ==1then
			if idx ~=1 then
				ch_ro_num = check_pppoe['channel'..idx-1]['alarm_out_num']
				if ch_ro_num>0 then
					table.insert(channel_list,idx-1)
					num = num+1
					if idx<11 then
						displist['idx'..num] = {num-1, ch_ro_num,0,STR('LA_CHANNEL') .. "0" .. idx-1,STR('LA_ALA_ACTIVE'),STR('LA_ALA_DE_ACTIVE')};	
					else
						displist['idx'..num] = {num-1, ch_ro_num,0,STR('LA_CHANNEL') .. idx-1,STR('LA_ALA_ACTIVE'),STR('LA_ALA_DE_ACTIVE')};				
					end
				end
			else
				num = num+1
				displist['idx'..num] = {num-1, ro_num,0,STR('LA_NVR'),STR('LA_ALA_ACTIVE'),STR('LA_ALA_DE_ACTIVE')};
			end
			

		end
		
	end
	displist.item_total = num;
	b_wnd_ex.set_manual_listdata(top, w1_manual_control.dlg.list.id, displist, redraw);	
end



w1_manual_control.on_create = function(top)
	local dlg = {
		attr = {},
		sub = nil
	}
	local ro_num = 0;
	if (0 ~= G.ro_num and 8 >= G.ro_num) then
		ro_num = G.ro_num
	else --
		ro_num = 0
	end		
	id = w1_id.toolbar.manual_id
	dlg.attr.xywh='s_manual_control_xywh';

	dlg.sub = {	'alarm','close','alarm_out','line1','line2','line3','manual_start','manual_stop','state','list'};

	dlg.alarm	= {t='static', 	id=id+1,xywh='s_manual_control_alarm_xywh', 
					text='LA_MANUAL_ALARM',font = 'f_grade3', align = b_ui.ALIGN.CENTER,
					color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},
				};
					
	dlg.close 	= {t='tt_button',id=id+2,xywh = 's_manual_control_close_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_closebtn','it_close','it_close', 'it_close'},
					color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},
					color_f= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_f'},
					cmd=on_close,
	};
	
	dlg.list =  {t='manual_list',	id=id+3,xywh='s_manual_control_list_xywh', font = 'f_grade4',
					listattr = {8,4,b_ui.LISTATTR.FIRST_WIDGET_STATIC,0},list_tip =true,
					title_texts = {'Channel', 'Alarm out','Star','Stop'},cmd = on_manual,
					columns_w = {150,150,180,180},};

	w1_manual_control.top = top
	w1_manual_control.dlg = dlg
	
	--UIڳʼ

	
	b_parser(top, w1_manual_control.dlg)
	updatelist(top,ro_num,false)
	b_wnd.set_no_find(top, w1_manual_control.dlg.alarm.id, true); ---ñ⾲̬ıɱ
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)	
	return 0
end

w1_manual_control.on_destroy = function(top)
	w1_manual_control.top = nil
	w1_manual_control.dlg = nil
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)
	return 0
end

w1_manual_control.on_paint = function(top, status, x, y, cx, cy)
	local wndsize = SIZE('s_manual_control_draw');
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_row_bk'))
	b_wnd.draw_fill(top, x, y+wndsize[2], cx, wndsize[4], COLOR('c_hline_color'))
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top)
	return 0
end

w1_manual_control.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local size = SIZE(w1_manual_control.dlg.attr.xywh);
		if(x >= size[1] and x <= (size[1] + size[3]) and y >= size[2] and y <= (size[2] + size[4]) ) then
			local ret = b_wnd_ex.set_customize_xy(top,w1_manual_control.dlg.list.id,{x,y},false)
			local do_info=b_wnd_ex.get_customize_data(top,w1_manual_control.dlg.list.id)
			local tes=0;
			if do_info[2]~=2 and do_info[1]== 0 and do_info[3]>=0 then
				b_app_api.manual_alarm(do_info[2],do_info[3]+1)
			elseif do_info[2]~=2  and do_info[3]>=0 then
				b_app_api.manual_ipc_alarm(channel_list[do_info[1]],do_info[3]+1,do_info[2])
			end
			
		else
			b_dlg.end_modal(top);
		end
	elseif  (b_ui.RBUTTONCLK == vmsg) then
		b_dlg.end_modal(top);	
	end

	return 0
end

w1_manual_control.on_pre_show = function (top)
	local param = {
			STR('LA_SOURCE'), STR('LA_ALARM_OUT'),STR('LA_ALA_ACTIVE'), STR('LA_ALA_DE_ACTIVE')}
	b_wnd_ex.set_title_texts(top, w1_manual_control.dlg.list.id, param, false);
	local list_w = {};
		for i=1,4 do
			local str = 's_manual_list_w'..math.floor(i/1);
			list_w[i] = SIZE(str)[1];
		end
	b_wnd_ex.columns_w(top, w1_manual_control.dlg.list.id, list_w, false);
	return 0;
end

return w1_manual_control




