local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.live_wnd.ptz_id
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local b_app_cfg  = require("wnd.core.b_app_cfg")

local w1_ptz_set 		= require("wnd.w1_live.w1_ptz_set")
local w1_row_ptz_preset	= require("wnd.w1_live.w1_row_ptz_preset")
local w1_ptz_advanced 	= require("wnd.w1_live.w1_ptz_advanced")
local w1_ptz_preset 	= require("wnd.w1_live.w1_ptz_preset")
local w1_ptz_scan			= require("wnd.w1_live.w1_ptz_scan");
local w1_ptz_cruise			= require("wnd.w1_live.w1_ptz_cruise");
local w1_ptz_control 	= require("wnd.w1_live.w1_ptz_control")
local global_val		= require("wnd.global_val")
local channel_count 	= G.channel_num--豸ͨĿ
local current_channel 	= nil;
local wnd_channel		= nil;
local color_info 		= nil;
local ptz_info 			= {};
local w1_ptz 			= {
	t = w1_key.DLG_PTZ,
	top = nil,
	dlg = nil,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	drag_state = 0,	
	start_drag_x = 0,	
	start_drag_y = 0,
	start_pos_x = nil, 
	start_pos_y = nil
}

w1_ptz.s_768 =
{
	s_ptz_page_xywh = {745,512,277,248},
	s_ptz_split_xywh = {5,3,21,28},
	s_ptz_set_xywh = {32,3,21,28},
	s_ptz_channel_pre_xywh = {74,3,10,28},
	s_ptz_channel_xywh = {85,3,117,28},
	s_ptz_channel_next_xywh = {202,3,10,28},
	s_ptz_speed_xywh = {5,213,42,28},
	s_ptz_speed_down_xywh = {64,213,10,28},
	s_ptz_speed_num_xywh = {74,213,48,28},
	s_ptz_speed_up_xywh = {122,213,10,28},
	s_ptz_home_xywh = {163,213,85,28},
	s_ptz_con_row_ptz_xywh = {0,0,5,7},
	s_ptz_con_row_ptz2_xywh = {0,0,5,7},
	s_ptz_hline_top_xywh = {0,35,0,1},
	s_ptz_hline_mid_xywh = {93,74,1,120},
	s_ptz_hline_but_xywh = {0,204,277,1},
};

w1_ptz.s_1280 = 
{
	s_ptz_page_xywh= {758,664,520,350},
	s_ptz_split_xywh= {10,5,40,40},
	s_ptz_set_xywh= {60,5,40,40},
	s_ptz_channel_pre_xywh= {140,5,20,40},
	s_ptz_channel_xywh= {160,5,220,40},
	s_ptz_channel_next_xywh= {380,5,20,40},
	s_ptz_speed_xywh= {10,300,80,40},
	s_ptz_speed_down_xywh= {120,300,20,40}, 
	s_ptz_speed_num_xywh= {140,300,90,40},
	s_ptz_speed_up_xywh= {230,300,20,40},
	s_ptz_home_xywh= {307,300,160,40},
	s_ptz_con_row_ptz_xywh= {0,0,10,10},
	s_ptz_con_row_ptz2_xywh= {0,0,10,10},
	s_ptz_hline_top_xywh= {0,50,0,1},
	s_ptz_hline_mid_xywh= {175,105,1,170},
	s_ptz_hline_but_xywh= {0,288,520,1},
}
w1_ptz.s_1440 = 
{
	s_ptz_page_xywh= {918,540,520,350},
	s_ptz_split_xywh= {10,5,40,40},
	s_ptz_set_xywh= {60,5,40,40},
	s_ptz_channel_pre_xywh= {140,5,20,40},
	s_ptz_channel_xywh= {160,5,220,40},
	s_ptz_channel_next_xywh= {380,5,20,40},
	s_ptz_speed_xywh= {10,300,80,40},
	s_ptz_speed_down_xywh= {120,300,20,40}, 
	s_ptz_speed_num_xywh= {140,300,90,40},
	s_ptz_speed_up_xywh= {230,300,20,40},
	s_ptz_home_xywh= {307,300,160,40},
	s_ptz_con_row_ptz_xywh= {0,0,10,10},
	s_ptz_con_row_ptz2_xywh= {0,0,10,10},
	s_ptz_hline_top_xywh= {0,50,0,1},
	s_ptz_hline_mid_xywh= {175,105,1,170},
	s_ptz_hline_but_xywh= {0,288,520,1},
}

w1_ptz.s_1080p = 
{
	s_ptz_page_xywh= {1398,720,520,350},
	s_ptz_split_xywh= {10,5,40,40},
	s_ptz_set_xywh= {60,5,40,40},
	s_ptz_channel_pre_xywh= {140,5,20,40},
	s_ptz_channel_xywh= {160,5,220,40},
	s_ptz_channel_next_xywh= {380,5,20,40},
	s_ptz_speed_xywh= {10,300,80,40},
	s_ptz_speed_down_xywh= {120,300,20,40}, 
	s_ptz_speed_num_xywh= {140,300,90,40},
	s_ptz_speed_up_xywh= {230,300,20,40},
	s_ptz_home_xywh= {307,300,160,40},
	s_ptz_con_row_ptz_xywh= {0,0,10,10},
	s_ptz_con_row_ptz2_xywh= {0,0,10,10},
	s_ptz_hline_top_xywh= {0,50,0,1},
	s_ptz_hline_mid_xywh= {175,105,1,170},
	s_ptz_hline_but_xywh= {0,288,520,1},
}

w1_ptz.s_2k = 
{
	s_ptz_page_xywh= {1864,960,693,467},
	s_ptz_split_xywh = {13,6,53,53},
	s_ptz_set_xywh = {79,6,53,53},
	s_ptz_channel_pre_xywh = {186,6,26,53},
	s_ptz_channel_xywh = {213,6,293,53},
	s_ptz_channel_next_xywh = {506,6,26,53},
	s_ptz_speed_xywh = {13,399,106,53},
	s_ptz_speed_down_xywh = {159,399,26,53},
	s_ptz_speed_num_xywh = {186,399,119,53},
	s_ptz_speed_up_xywh = {306,399,26,53},
	s_ptz_home_xywh = {409,399,213,53},
	s_ptz_con_row_ptz_xywh = {0,0,13,13},
	s_ptz_con_row_ptz2_xywh = {0,0,13,13},
	s_ptz_hline_top_xywh = {0,66,0,1},
	s_ptz_hline_mid_xywh = {233,139,1,226},
	s_ptz_hline_but_xywh = {0,383,693,1},
}

w1_ptz.s_4k = 
{
	s_ptz_page_xywh= {2796,1440,1040,700},
	s_ptz_split_xywh = {20,10,80,80},
	s_ptz_set_xywh = {120,10,80,80},
	s_ptz_channel_pre_xywh = {280,10,40,80},
	s_ptz_channel_xywh = {320,10,440,80},
	s_ptz_channel_next_xywh = {760,10,40,80},
	s_ptz_speed_xywh = {20,600,160,80},
	s_ptz_speed_down_xywh = {240,600,40,80},
	s_ptz_speed_num_xywh = {280,600,180,80},
	s_ptz_speed_up_xywh = {460,600,40,80},
	s_ptz_home_xywh = {614,600,320,80},
	s_ptz_con_row_ptz_xywh = {0,0,20,20},
	s_ptz_con_row_ptz2_xywh = {0,0,20,20},
	s_ptz_hline_top_xywh = {0,100,0,2},
	s_ptz_hline_mid_xywh = {350,210,2,340},
	s_ptz_hline_but_xywh = {0,576,1040,2},
}

local split =0;
local on_home = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local speed = b_wnd_ex.get_text(top,w1_ptz.dlg.speed_num.id);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =15;
		b_app_api.set_ptz(ptz_info);
	end
	return 0;
end

local hide_set_btn = function(top, cur_ch, redraw)
	local vi_num, dec_num = global_val.get_vi_dec_num();
	local ptz_cfg = G.get_ptzcfg_support()
	
	if (false ~= ptz_cfg) then
		if (0 < vi_num and cur_ch <= vi_num) then
			b_wnd_ex.set_hide (top, w1_ptz.dlg.set.id, false, redraw)
		else
			b_wnd_ex.set_hide (top, w1_ptz.dlg.set.id, true, redraw)
		end		
	else
		b_wnd_ex.set_hide (top, w1_ptz.dlg.set.id, true, redraw)
	end
end

local on_channelnext =function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.LBUTTONCLK ) then	
		w1_ptz_cruise.clear(top);
		w1_ptz_scan.clear(top);
		local channel_idx = wnd_channel;
		if(wnd_channel < channel_count)then
			wnd_channel= wnd_channel +1;
		elseif(wnd_channel == channel_count)then
			wnd_channel= 1;
		end
		
		local privilege = G.get_allprivilege();
		local run_idx = 0;
		local sign = true;
		while sign do
			local chn_str = "channel"..tostring(math.floor(wnd_channel));
			if(0 == privilege.ptz_control_list[wnd_channel] or 0 == ptz_info.cap['ptz_limits'][chn_str].ptz_support)then
				if(wnd_channel ==channel_count)then
					wnd_channel =1;
				else
					wnd_channel =wnd_channel + 1;
				end
			else
				sign =false;
			end
			
			run_idx = run_idx + 1;
			if(run_idx > channel_count and sign == true)then
				wnd_channel = channel_idx;
				sign =false;
				b_dlg.dlg_set_redraw(top);
				return 0;
			end
			
		end	
		
		hide_set_btn(top, wnd_channel, false);		
		local name = string.format("%s %02d", STR('LA_CAMERA'),wnd_channel);
		b_wnd_ex.set_text(top,w1_ptz.dlg.channel.id,name,false)
		w1_ptz_preset.updata(top,wnd_channel);
		w1_ptz_set.updata(wnd_channel);
		w1_ptz_advanced.updata(wnd_channel);
		local page_id = w1_row_ptz_preset.get_page(top)
		w1_ptz_scan.updata(top, wnd_channel, page_id);
		w1_ptz_cruise.update_channel(top, wnd_channel, page_id)
		b_app_api.set_displaylayout(wnd_channel,1,0);
		b_wnd_ex.set_check(top, w1_ptz.dlg.split.id, false, false)
		ptz_info.channel = wnd_channel
		split =0;
		b_dlg.dlg_set_redraw(top);	
	end
	return 0;
end

local on_channelpre = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		w1_ptz_cruise.clear(top);
		w1_ptz_scan.clear(top);
		local channel_idx = wnd_channel;
		if(wnd_channel > 1)then	
			wnd_channel= wnd_channel -1;				
		elseif(wnd_channel == 1)then
			wnd_channel= channel_count;
		end
		
		local privilege = G.get_allprivilege();
		local run_idx = 0;
		local sign = true;
		while sign do
			local chn_str = "channel"..tostring(math.floor(wnd_channel));
			if(0 == privilege.ptz_control_list[wnd_channel] or 0 == ptz_info.cap['ptz_limits'][chn_str].ptz_support)then
				if(wnd_channel ==1)then
					wnd_channel =channel_count;
				else
					wnd_channel =wnd_channel - 1;
				end
			else
				sign =false;
			end
			
			run_idx = run_idx + 1;
			if(run_idx > channel_count and sign == true)then
				wnd_channel = channel_idx;
				sign =false;
				b_dlg.dlg_set_redraw(top);
				return 0;
			end
		end	

		hide_set_btn(top, wnd_channel, false);
		local name = string.format("%s %02d", STR('LA_CAMERA'),wnd_channel);
		b_wnd_ex.set_text(top,w1_ptz.dlg.channel.id,name,false)
		w1_ptz_preset.updata(top,wnd_channel);
		w1_ptz_set.updata(wnd_channel);
		w1_ptz_advanced.updata(wnd_channel);
		local page_id = w1_row_ptz_preset.get_page(top)
		w1_ptz_scan.updata(top, wnd_channel, page_id);
		w1_ptz_cruise.update_channel(top, wnd_channel, page_id)
		b_app_api.set_displaylayout(wnd_channel,1,0);
		b_wnd_ex.set_check(top, w1_ptz.dlg.split.id, false, false)
		ptz_info.channel = wnd_channel
		split =0;
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_set = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		w1_ptz_control.update_channel(top,wnd_channel)
		b_dlg.dlg_set_hide(top, 1, 0) --صǰ
		b_dlg.do_modal(top, w1_key.DLG_PTZ_CONTROL, 0, 0, nil)
		b_dlg.dlg_set_hide(top, 0, 0)
		b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)
		b_dlg.dlg_set_redraw(top)
	end
	return 0;
end

local on_split =function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
	--	b_dlg.end_modal(top)
		if(0 == split)then
			b_app_api.set_displaylayout(wnd_channel,wnd_channel,1);
			split =1;
		else
			b_app_api.set_displaylayout(wnd_channel,1,0);
			split =0;
		end
	end
	return 0;
end

local on_speed_down = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then	
		local speed_num = tonumber(b_wnd_ex.get_text(top,w1_ptz.dlg.speed_num.id))
		if(speed_num > 1)then
			speed_num =speed_num -1
		elseif(speed_num ==1)then
		
		end
		local speed = tostring(speed_num);
		b_wnd_ex.set_text(top,w1_ptz.dlg.speed_num.id,speed,true)
	end
	return 0;
end

local on_speed_up= function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local speed_num = tonumber(b_wnd_ex.get_text(top,w1_ptz.dlg.speed_num.id))
		if(speed_num < 8)then
			speed_num =speed_num +1
		elseif(speed_num ==8)then
				
		end
		local speed = tostring(speed_num);
		b_wnd_ex.set_text(top,w1_ptz.dlg.speed_num.id,speed,true)
	end
	return 0;
end

local dlg = {
	attr={xywh = 's_ptz_page_xywh'},
	sub = {"split","set","channel_pre","channel","channel_next","ptz","vline","con_row_ptz1","con_item_ptz","con_row_ptz2","con_item_ptz2",
			"w1_ptzrow_wnd2","w1_ptzset_wnd","w1_ptz_preset_wnd","w1_ptz_advanced_wnd","w1_ptz_scan_wnd",
			"w1_ptz_cruise_wnd","speed","speed_down","speed_num","speed_up","home"},
	split = {t='tt_check',id=id+1,xywh='s_ptz_split_xywh',color_c= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_check_text_c'},color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_split1', 'it_split4', 'it_split1'},cmd=on_split},
	set = {t='tt_button',id=id+2,xywh='s_ptz_set_xywh',cmd=on_set,color= { 'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_n'},
				color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},color_d= { 'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_bg_d'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_settings','it_settings_f', 'it_settings'},
				},
	 --[[color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_f'},cmd=on_set,
	imgs = {b_ui.ALIGN.CENTER,'i_home_set', 'i_home_set', 'i_home_set_f'},},--]]
	
	channel_pre 	= {t='tt_button',id=id+3,xywh='s_ptz_channel_pre_xywh', cmd=on_channelpre,
			color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_pre','it_pre_f', 'it_pre'}},
	channel = {t='tt_button',id=id+4,xywh='s_ptz_channel_xywh',text=' Camera 01',trans =false,align = b_ui.ALIGN.CENTER,font = 'f_grade3',
			imgs = {b_ui.ALIGN.CENTER,'i_channel', 'i_channel', 'i_channel_f'},color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_f'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_f'},
			t_imgs = {b_ui.ALIGN.CENTER,'f_grade7','it_camera','it_camera_f', 'it_camera'}},
	channel_next 	= {t='tt_button',	id=id+5,	xywh='s_ptz_channel_next_xywh',cmd = on_channelnext,
			color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_next','it_next_f', 'it_next'}},

	speed = {t='static',id=id+6,xywh='s_ptz_speed_xywh',text='LA_PTZ_SPEED'};
	speed_down = {t='tt_button',id=id+7,xywh='s_ptz_speed_down_xywh', cmd=on_speed_down,
			color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_reduce','it_reduce_f', 'it_reduce'}},
--	speed_num = {t='button',id=id+8,xywh={210,390,70,50},text = '6',trans=false,align = b_ui.ALIGN.CENTER,color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}},
	speed_num = {t='static',id=id+8,xywh='s_ptz_speed_num_xywh',text = '6',trans=false,align = b_ui.ALIGN.CENTER},
	speed_up = {t='tt_button',id=id+9,xywh='s_ptz_speed_up_xywh', cmd=on_speed_up,
			color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_increase','it_increase_f', 'it_increase'}},
	home = {t='button',id=id+10,xywh='s_ptz_home_xywh',text = 'LA_HOME',align = b_ui.ALIGN.CENTER,cmd=on_home,
		},

	con_row_ptz		= {t='container',id=w1_id.live_wnd.ptz_con_row_id,	xywh='s_ptz_con_row_ptz_xywh'},
	con_item_ptz 	= {t='container',id=w1_id.live_wnd.conItem_id,	xywh='s_cfg_con_xywh'},
	con_row_ptz2 = {t='container',id=w1_id.live_wnd.ptz_con_row_id2,	xywh='s_ptz_con_row_ptz2_xywh'},
	con_item_ptz2 	= {t='container',id=w1_id.live_wnd.conItem_id2,	xywh='s_cfg_con_xywh'},
	--dlg.vline ={t='checkbutton',id=id+8,xywh={10,70,150,50},text='brightness',trans = false,align = b_ui.ALIGN.CENTER,cmd=on_ptz}

	w1_ptzset_wnd = w1_ptz_set.wnd,	
	
	w1_ptzrow_wnd2 = w1_row_ptz_preset.wnd,
	w1_ptz_advanced_wnd = w1_ptz_advanced.wnd,
	w1_ptz_preset_wnd =w1_ptz_preset.wnd,
	w1_ptz_scan_wnd = w1_ptz_scan.wnd,	
	w1_ptz_cruise_wnd =w1_ptz_cruise.wnd,	
}
	

local init_data = function (top)
	local wnd_data = b_wnd.get_wnd_data(top)	
	assert('string' == type(wnd_data));
	wnd_data = cjson.decode(wnd_data);	
	wnd_channel = wnd_data.channel
	 
	ptz_info.channel = wnd_channel;
	ptz_info.action  =0;
	ptz_info.mode =3;--ƶ
	ptz_info.speed = 6;
	ptz_info.index =1;--Ԥλ
	ptz_info.time =0;

	local cfg_tab = {'ptz_limits'}
	ptz_info.cap = b_app_api.get_cfg(cfg_tab)
end

local get_valid_cam_num = function(channel_num)
	local chn_num = channel_num;
	local vi_num, dec_num = global_val.get_vi_dec_num();
	if (0 < dec_num and 0 < vi_num) then 
		local chn_type = b_app_api.get_cfg({'channel_type'}).channel_type;
		if (0 == chn_type.chn_type[vi_num + 1]) then
			chn_num = vi_num;
		end
	end
	
	return chn_num;
end

w1_ptz.on_create = function(top, wnd_id)
	split =0;
	channel_count = global_val.get_channelnum();
	channel_count = get_valid_cam_num(channel_count);
	w1_ptz.top = top
	w1_ptz.dlg = dlg
	init_data(top);
	b_parser(top, dlg)
	w1_ptz_set.init(wnd_channel);
	w1_ptz_advanced.init(wnd_channel);
	w1_ptz_preset.init(top,wnd_channel);
	w1_ptz_scan.init(top,wnd_channel);
	w1_ptz_cruise.init(top,wnd_channel);
	local wndsize = SIZE('s_ptz_page_xywh');
	w1_ptz.start_pos_x = wndsize[1];
	w1_ptz.start_pos_y = wndsize[2];

	hide_set_btn(top, wnd_channel, false);
	w1_row_ptz_preset.set_flag();	
	
	b_wnd_ex.set_add_page(top, w1_ptz.dlg.con_item_ptz.id, w1_ptz.dlg.w1_ptzset_wnd.id)
	
	b_wnd_ex.set_add_page(top, w1_ptz.dlg.con_row_ptz2.id, w1_ptz.dlg.w1_ptzrow_wnd2.id)
	b_wnd_ex.set_add_page(top, w1_ptz.dlg.con_item_ptz2.id, w1_ptz.dlg.w1_ptz_advanced_wnd.id)
	b_wnd_ex.set_add_page(top, w1_ptz.dlg.con_item_ptz2.id, w1_ptz.dlg.w1_ptz_preset_wnd.id)
	b_wnd_ex.set_add_page(top, w1_ptz.dlg.con_item_ptz2.id, w1_ptz.dlg.w1_ptz_scan_wnd.id)
	b_wnd_ex.set_add_page(top, w1_ptz.dlg.con_item_ptz2.id, w1_ptz.dlg.w1_ptz_cruise_wnd.id)
	
	b_wnd_ex.set_show_page(top, w1_ptz.dlg.con_item_ptz.id, w1_ptz.dlg.w1_ptzset_wnd.id, false)	
	
	b_wnd_ex.set_show_page(top, w1_ptz.dlg.con_row_ptz2.id, w1_ptz.dlg.w1_ptzrow_wnd2.id, false)
	b_wnd_ex.set_show_page(top, w1_ptz.dlg.con_item_ptz2.id, w1_ptz.dlg.w1_ptz_advanced_wnd.id, false)	
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)
	return 0
end

w1_ptz.on_destroy = function(top)
	w1_ptz_cruise.clear(top);
	w1_ptz_scan.clear(top);
	w1_ptz.top = nil
	w1_ptz.dlg = nil
	w1_ptz.start_pos_x = nil;
	w1_ptz.start_pos_y = nil;
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)
	return 0
end

w1_ptz.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top)
	
	local wndsize = SIZE('s_ptz_hline_top_xywh');
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_row_bk'))
	b_wnd.draw_fill(top, x, y+wndsize[2], cx, wndsize[4], COLOR('c_hline_color'))
	wndsize = SIZE('s_ptz_hline_mid_xywh');
	b_wnd.draw_fill(top, x+wndsize[1], y+wndsize[2], wndsize[3], wndsize[4], COLOR('c_hline_color'))--
	wndsize = SIZE('s_ptz_hline_but_xywh');
	b_wnd.draw_fill(top, x, y+wndsize[2], wndsize[3], wndsize[4], COLOR('c_hline_color'))--

--	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_popdlg_border'), 1)
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top)
	local name = string.format("%s %02d", STR('LA_CAMERA'),ptz_info.channel);
	b_wnd_ex.set_text(top,w1_ptz.dlg.channel.id,name,true)

	return 0
end

w1_ptz.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.RBUTTONCLK == vmsg) then
		w1_ptz_cruise.cfg_data = nil;
		b_dlg.end_modal(top);
		return 0;
	elseif(b_ui.LBUTTONCLK == vmsg) then
		local wndsize = b_wnd.get_dlg_a_rect(top);
		if(x<wndsize[1] or y <wndsize[2] or x>(wndsize[1]+wndsize[3]) or y >(wndsize[2]+wndsize[4]))then
			w1_ptz_cruise.cfg_data = nil;
			b_dlg.end_modal(top);
			return 0;
		end		
		w1_ptz.drag_state = 0
		w1_ptz.start_drag_x = 0;		
		w1_ptz.start_drag_y = 0;		
	elseif(b_ui.MOUSEWHEELUP == vmsg)then
		local wndsize = b_wnd.get_dlg_a_rect(top);
		if(x<wndsize[1] or y <wndsize[2] or x>(wndsize[1]+wndsize[3]) or y >(wndsize[2]+wndsize[4]))then
			return 0;
		end
		local page_id = w1_row_ptz_preset.get_page(top)
		local ret = 0;
		if(4 == page_id)then
			ret = w1_ptz_cruise.drop(top, win_id, vmsg, x, y)
		end
	elseif(b_ui.LBUTTONDOWN == vmsg)then
		local page_id = w1_row_ptz_preset.get_page(top)
		local ret = 0; 
		if(4 == page_id)then
			ret = w1_ptz_cruise.drop(top, win_id, vmsg, x, y)
		end
		
		local wndsize = b_wnd.get_dlg_a_rect(top);
		if(x<wndsize[1] or y <wndsize[2] or x>(wndsize[1]+wndsize[3]) or y >(wndsize[2]+wndsize[4]))then
			return 0;
		end	
		
		w1_ptz.drag_state = 1;
		w1_ptz.start_drag_x = x;		
		w1_ptz.start_drag_y = y;
	elseif(b_ui.LBUTTOUP == vmsg) then	
		local page_id = w1_row_ptz_preset.get_page(top)
		local ret = 0;
		if(4 == page_id)then
			ret = w1_ptz_cruise.drop(top, win_id, vmsg, x, y)
		end
		w1_ptz.drag_state = 0
		w1_ptz.start_drag_x = 0;		
		w1_ptz.start_drag_y = 0;
	elseif(b_ui.LBUTTONDRAG == vmsg) then	
		if (w1_ptz.drag_state == 1 or w1_ptz.drag_state == 2) then
			local wndsize = b_wnd.get_dlg_a_rect(top);
			local w, h = G.get_size();
			local step_x = x - w1_ptz.start_drag_x;
			local step_y = y - w1_ptz.start_drag_y;
			local pos_x = w1_ptz.start_pos_x + step_x;
			local pos_y = w1_ptz.start_pos_y + step_y;			
			if (pos_x + wndsize[3] > w) then
				pos_x = w - wndsize[3];
			elseif (pos_x < 0) then
				pos_x = 0;	 	
			end	
			
			if (pos_y + wndsize[4] > h) then
				pos_y = h - wndsize[4];
			elseif (pos_y < 0) then
				pos_y = 0;	 	
			end	
			
			w1_ptz.drag_state = 2;
			w1_ptz.start_drag_x = x;		
			w1_ptz.start_drag_y = y;
			w1_ptz.start_pos_x = pos_x;			
			w1_ptz.start_pos_y = pos_y;
			b_wnd_ex.dlg_move_ex(top, {pos_x, pos_y, wndsize[3], wndsize[4]}, true);
		end
	end
	return 0
end

return w1_ptz




