--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/4/26
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.live_wnd.ptz_advanced_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 	= r_size.get_size

local w1_ptz_advanced = {
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_ptz_advanced.s_768 =
{
	s_ptz_advanced_t_xywh = {118,78,136,35},
	s_ptz_advanced_zoom_down_xywh = {24,7,10,24},
	s_ptz_advanced_zoom_xywh = {32,7,64,24},
	s_ptz_advanced_zoom_up_xywh = {96,7,10,24},
	s_ptz_advanced_lris_down_xywh = {24,35,10,24},
	s_ptz_advanced_lris_xywh = {32,35,64,24},
	s_ptz_advanced_lris_up_xywh = {96,35,10,24},
	s_ptz_advanced_focus_down_xywh = {24,64,10,24},
	s_ptz_advanced_focus_xywh = {32,64,64,24},
	s_ptz_advanced_focus_up_xywh = {96,64,10,24},
	s_ptz_auto_focus_xywh = {24,92,85,24},
};

w1_ptz_advanced.s_1280 = 
{
	s_ptz_advanced_t_xywh= {223,110,255,50},
	s_ptz_advanced_zoom_down_xywh= {45,10,20,35},
	s_ptz_advanced_zoom_xywh= {60,10,120,35},
	s_ptz_advanced_zoom_up_xywh= {180,10,20,35},
	s_ptz_advanced_lris_down_xywh= {45,50,20,35},
	s_ptz_advanced_lris_xywh= {60,50,120,35},
	s_ptz_advanced_lris_up_xywh= {180,50,20,35},
	s_ptz_advanced_focus_down_xywh= {45,90,20,35},
	s_ptz_advanced_focus_xywh= {60,90,120,35},
	s_ptz_advanced_focus_up_xywh= {180,90,20,35},
	s_ptz_auto_focus_xywh= {45,130,160,35},
}

w1_ptz_advanced.s_1440 = 
{
	s_ptz_advanced_t_xywh= {223,110,255,50},
	s_ptz_advanced_zoom_down_xywh= {45,10,20,35},
	s_ptz_advanced_zoom_xywh= {60,10,120,35},
	s_ptz_advanced_zoom_up_xywh= {180,10,20,35},
	s_ptz_advanced_lris_down_xywh= {45,50,20,35},
	s_ptz_advanced_lris_xywh= {60,50,120,35},
	s_ptz_advanced_lris_up_xywh= {180,50,20,35},
	s_ptz_advanced_focus_down_xywh= {45,90,20,35},
	s_ptz_advanced_focus_xywh= {60,90,120,35},
	s_ptz_advanced_focus_up_xywh= {180,90,20,35},
	s_ptz_auto_focus_xywh= {45,130,160,35},
}
w1_ptz_advanced.s_1080p = 
{
	s_ptz_advanced_t_xywh= {223,110,255,50},
	s_ptz_advanced_zoom_down_xywh= {45,10,20,35},
	s_ptz_advanced_zoom_xywh= {60,10,120,35},
	s_ptz_advanced_zoom_up_xywh= {180,10,20,35},
	s_ptz_advanced_lris_down_xywh= {45,50,20,35},
	s_ptz_advanced_lris_xywh= {60,50,120,35},
	s_ptz_advanced_lris_up_xywh= {180,50,20,35},
	s_ptz_advanced_focus_down_xywh= {45,90,20,35},
	s_ptz_advanced_focus_xywh= {60,90,120,35},
	s_ptz_advanced_focus_up_xywh= {180,90,20,35},
	s_ptz_auto_focus_xywh= {45,130,160,35},
}

w1_ptz_advanced.s_2k = 
{
	s_ptz_advanced_t_xywh= {297,147,340,67},
	s_ptz_advanced_zoom_down_xywh= {60,13,27,47},
	s_ptz_advanced_zoom_xywh= {80,13,160,47},
	s_ptz_advanced_zoom_up_xywh= {240,13,27,47},
	s_ptz_advanced_lris_down_xywh= {60,67,27,47},
	s_ptz_advanced_lris_xywh= {80,67,160,47},
	s_ptz_advanced_lris_up_xywh= {240,67,27,47},
	s_ptz_advanced_focus_down_xywh= {60,120,27,47},
	s_ptz_advanced_focus_xywh= {80,120,160,47},
	s_ptz_advanced_focus_up_xywh= {240,120,27,47},
	s_ptz_auto_focus_xywh= {60,173,213,47},
}

w1_ptz_advanced.s_4k = 
{
	s_ptz_advanced_t_xywh= {446,220,510,100},
	s_ptz_advanced_zoom_down_xywh= {90,20,40,70},
	s_ptz_advanced_zoom_xywh= {120,20,240,70},
	s_ptz_advanced_zoom_up_xywh= {360,20,40,70},
	s_ptz_advanced_lris_down_xywh= {90,100,40,70},
	s_ptz_advanced_lris_xywh= {120,100,240,70},
	s_ptz_advanced_lris_up_xywh= {360,100,40,70},
	s_ptz_advanced_focus_down_xywh= {90,180,40,70},
	s_ptz_advanced_focus_xywh= {120,180,240,70},
	s_ptz_advanced_focus_up_xywh= {360,180,40,70},
	s_ptz_auto_focus_xywh= {90,260,320,70},
}
local ptz_info = {};

local on_zoom_up = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.mode =5;
		ptz_info.action =12;
		b_app_api.set_ptz(ptz_info);
	end
	if(b_ui.LBUTTOUP == vmsg or b_ui.LBUTTONDBLCLK == vmsg or b_ui.LBUTTONCLK == vmsg)then
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.mode =5;
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end 
	return 0
end

local on_zoom_down =function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.mode =4;
		ptz_info.action =12;
		b_app_api.set_ptz(ptz_info);
	end
	if b_ui.LBUTTOUP == vmsg  or b_ui.LBUTTONDBLCLK == vmsgthen  or b_ui.LBUTTONCLK == vmsg then
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.mode =4;
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end
	return 0
end

local on_focus_up = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.mode =5;
		ptz_info.action =13;
		b_app_api.set_ptz(ptz_info);
	end
	if b_ui.LBUTTOUP == vmsg  or b_ui.LBUTTONDBLCLK == vmsg  or b_ui.LBUTTONCLK == vmsg then
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.mode =13;
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end
	return 0
end

local on_auto_focus = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.mode =4;
		ptz_info.action =21;
		b_app_api.set_ptz(ptz_info);
	end
	
	return 0;
end	

local on_focus_down = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.mode =4;
		ptz_info.action =13;
		b_app_api.set_ptz(ptz_info);
	end
	if b_ui.LBUTTOUP == vmsg  or b_ui.LBUTTONDBLCLK == vmsg  or b_ui.LBUTTONCLK == vmsg then
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.mode =13;
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end
	return 0
end

local on_iris_up = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.mode =5;
		ptz_info.action =14;
		b_app_api.set_ptz(ptz_info);
	end
	if b_ui.LBUTTOUP == vmsg  or b_ui.LBUTTONDBLCLK == vmsg or b_ui.LBUTTONCLK == vmsg then
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.mode =5;
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end
	return 0
end

local on_iris_down = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.mode =4;
		ptz_info.action =14;
		b_app_api.set_ptz(ptz_info);
	end
	
	if b_ui.LBUTTOUP == vmsg  or b_ui.LBUTTONDBLCLK == vmsg  or b_ui.LBUTTONCLK == vmsg then
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.mode =4;
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end
	return 0
end

w1_ptz_advanced.init =function (chn)
	ptz_info.channel = chn;
	ptz_info.action  =0;
	ptz_info.mode =5;--
	ptz_info.speed = 6;
	ptz_info.index =1;--Ԥλ
	ptz_info.time =0;
		
	return 0
end
w1_ptz_advanced.updata = function (channel)
	ptz_info.channel = channel
end
w1_ptz_advanced.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_ptz_advanced_t_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'zoom_down','zoom','zoom_up','focus_down','focus','focus_up','lris_down','lris','lris_up', 'auto_focus'},
	zoom_down = {t='tt_button',id=id+1,xywh='s_ptz_advanced_zoom_down_xywh', cmd=on_zoom_down,
				color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_reduce','it_reduce', 'it_reduce'},};
	zoom = {t='static',id=id+2,xywh='s_ptz_advanced_zoom_xywh',text = 'LA_ZOOM',align = b_ui.ALIGN.CENTER};
	zoom_up = {t='tt_button',id=id+3,xywh='s_ptz_advanced_zoom_up_xywh', cmd=on_zoom_up,
				color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_increase','it_increase_f', 'it_increase'}};

	focus_down = {t='tt_button',id=id+4,xywh='s_ptz_advanced_focus_down_xywh',cmd=on_focus_down,
				color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_reduce','it_reduce_f', 'it_reduce'}};
	focus = {t='static',id=id+5,xywh='s_ptz_advanced_focus_xywh',text = 'LA_FOCUS_T',align = b_ui.ALIGN.CENTER};
	focus_up = {t='tt_button',id=id+6,xywh='s_ptz_advanced_focus_up_xywh', cmd=on_focus_up,
				color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_increase','it_increase_f', 'it_increase'}};
	
	lris_down = {t='tt_button',id=id+7,xywh='s_ptz_advanced_lris_down_xywh',cmd=on_iris_down,
				color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_reduce','it_reduce_f', 'it_reduce'}};
	lris = {t='static',id=id+8,xywh='s_ptz_advanced_lris_xywh',text = 'LA_IRIS',align = b_ui.ALIGN.CENTER};
	lris_up = {t='tt_button',id=id+9,xywh='s_ptz_advanced_lris_up_xywh',cmd=on_iris_up,
				color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_increase','it_increase_f', 'it_increase'}};
				
	auto_focus = {t='button',id=id+10,xywh='s_ptz_auto_focus_xywh',text = 'LA_AUTO_FOCUS',align = b_ui.ALIGN.CENTER,cmd=on_auto_focus}
}

return w1_ptz_advanced
