--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created:2018/11/22
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.live_wnd.ptz_cruise_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 	= r_size.get_size
local b_dlg 	= require("wnd.core.b_dlg")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local util 		= require("wnd.core.util")
local b_app_cfg		= require("wnd.core.b_app_cfg")
local w1_key 	= require("wnd.w1_util.w1_key")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_ptz_cruise = {
	cfg_data,
	old_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_ptz_cruise.s_768 =
{
	s_ptz_cruise_t_xywh = {118,78,136,35},
	s_ptz_cruise_tour_list_xywh = {24,7,85,24},
	s_ptz_cruise_go_to_xywh = {24,35,85,24},
	s_ptz_cruise_edit_xywh = {24,64,85,24},
	s_ptz_cruise_delete_xywh = {80,92,42,21},
	s_ptz_cruise_cruise_xywh = {16,5,106,21},
	s_ptz_cruise_idx1_xywh = {16,28,16,21},
	s_ptz_cruise_preset1_xywh = {32,28,53,21},
	s_ptz_cruise_time1_xywh = {85,28,37,21},
	s_ptz_cruise_idx2_xywh = {16,49,16,21},
	s_ptz_cruise_preset2_xywh = {32,49,53,21},
	s_ptz_cruise_time2_xywh = {85,49,37,21},
	s_ptz_cruise_idx3_xywh = {16,71,16,21},
	s_ptz_cruise_preset3_xywh = {32,71,53,21},
	s_ptz_cruise_time3_xywh = {85,71,37,21},
	s_ptz_cruise_vdrop_xywh = {122,28,8,64},
	s_ptz_cruise_back_xywh = {16,92,16,21},
	s_ptz_cruise_save_xywh = {34,92,42,21},
	s_ptz_cruise_clear_xywh = {80,92,42,21},
};
	
w1_ptz_cruise.s_1280 = 
{
	s_ptz_cruise_t_xywh= {223,110,255,50},
	s_ptz_cruise_tour_list_xywh= {45,10,160,35},
	s_ptz_cruise_go_to_xywh= {45,50,160,35},
	s_ptz_cruise_edit_xywh= {45,90,160,35},
	s_ptz_cruise_delete_xywh={150,130,80,30},
	s_ptz_cruise_cruise_xywh= {30,8,200,30},
	s_ptz_cruise_idx1_xywh 	={30,40,30,30},
	s_ptz_cruise_preset1_xywh={60,40,100,30},
	s_ptz_cruise_time1_xywh	={160,40,70,30},
	s_ptz_cruise_idx2_xywh	={30,70,30,30},
	s_ptz_cruise_preset2_xywh	={60,70,100,30},
	s_ptz_cruise_time2_xywh	={160,70,70,30},
	s_ptz_cruise_idx3_xywh	={30,100,30,30},
	s_ptz_cruise_preset3_xywh	={60,100,100,30},
	s_ptz_cruise_time3_xywh	={160,100,70,30},
	s_ptz_cruise_vdrop_xywh = {230,40,15,90},
	s_ptz_cruise_back_xywh= {30,130,30,30},
	s_ptz_cruise_save_xywh= {65,130,80,30},
	s_ptz_cruise_clear_xywh= {150,130,80,30},
}
w1_ptz_cruise.s_1440 = 
{
	s_ptz_cruise_t_xywh= {223,110,255,50},
	s_ptz_cruise_tour_list_xywh= {45,10,160,35},
	s_ptz_cruise_go_to_xywh= {45,50,160,35},
	s_ptz_cruise_edit_xywh= {45,90,160,35},
	s_ptz_cruise_delete_xywh={150,130,80,30},
	s_ptz_cruise_cruise_xywh= {30,8,200,30},
	s_ptz_cruise_idx1_xywh 	={30,40,30,30},
	s_ptz_cruise_preset1_xywh={60,40,100,30},
	s_ptz_cruise_time1_xywh	={160,40,70,30},
	s_ptz_cruise_idx2_xywh	={30,70,30,30},
	s_ptz_cruise_preset2_xywh	={60,70,100,30},
	s_ptz_cruise_time2_xywh	={160,70,70,30},
	s_ptz_cruise_idx3_xywh	={30,100,30,30},
	s_ptz_cruise_preset3_xywh	={60,100,100,30},
	s_ptz_cruise_time3_xywh	={160,100,70,30},
	s_ptz_cruise_vdrop_xywh = {230,40,15,90},
	s_ptz_cruise_back_xywh= {30,130,30,30},
	s_ptz_cruise_save_xywh= {65,130,80,30},
	s_ptz_cruise_clear_xywh= {150,130,80,30},
}	
w1_ptz_cruise.s_1080p = 
{
	s_ptz_cruise_t_xywh= {223,110,255,50},
	s_ptz_cruise_tour_list_xywh= {45,10,160,35},
	s_ptz_cruise_go_to_xywh= {45,50,160,35},
	s_ptz_cruise_edit_xywh= {45,90,160,35},
	s_ptz_cruise_delete_xywh={150,130,80,30},
	s_ptz_cruise_cruise_xywh= {30,8,200,30},
	s_ptz_cruise_idx1_xywh 	={30,40,30,30},
	s_ptz_cruise_preset1_xywh={60,40,100,30},
	s_ptz_cruise_time1_xywh	={160,40,70,30},
	s_ptz_cruise_idx2_xywh	={30,70,30,30},
	s_ptz_cruise_preset2_xywh	={60,70,100,30},
	s_ptz_cruise_time2_xywh	={160,70,70,30},
	s_ptz_cruise_idx3_xywh	={30,100,30,30},
	s_ptz_cruise_preset3_xywh	={60,100,100,30},
	s_ptz_cruise_time3_xywh	={160,100,70,30},
	s_ptz_cruise_vdrop_xywh = {230,40,15,90},
	s_ptz_cruise_back_xywh= {30,130,30,30},
	s_ptz_cruise_save_xywh= {65,130,80,30},
	s_ptz_cruise_clear_xywh= {150,130,80,30},
}

w1_ptz_cruise.s_2k = 
{
	s_ptz_cruise_t_xywh= {297,147,340,67},
	s_ptz_cruise_tour_list_xywh= {60,13,213,47},
	s_ptz_cruise_go_to_xywh= {60,67,213,47},
	s_ptz_cruise_edit_xywh= {60,120,213,47},
	s_ptz_cruise_delete_xywh={200,173,107,40},
	s_ptz_cruise_cruise_xywh= {40,11,267,40},
	s_ptz_cruise_idx1_xywh  ={40,53,40,40},
	s_ptz_cruise_preset1_xywh={80,53,133,40},
	s_ptz_cruise_time1_xywh ={213,53,93,40},
	s_ptz_cruise_idx2_xywh ={40,93,40,40},
	s_ptz_cruise_preset2_xywh ={80,93,133,40},
	s_ptz_cruise_time2_xywh ={213,93,93,40},
	s_ptz_cruise_idx3_xywh ={40,133,40,40},
	s_ptz_cruise_preset3_xywh ={80,133,133,40},
	s_ptz_cruise_time3_xywh ={213,133,93,40},
	s_ptz_cruise_vdrop_xywh = {307,53,20,120},
	s_ptz_cruise_back_xywh= {40,173,40,40},
	s_ptz_cruise_save_xywh= {87,173,107,40},
	s_ptz_cruise_clear_xywh= {200,173,107,40},
}

w1_ptz_cruise.s_4k = 
{
	s_ptz_cruise_t_xywh= {446,220,510,100},
	s_ptz_cruise_tour_list_xywh= {90,20,320,70},
	s_ptz_cruise_go_to_xywh= {90,100,320,70},
	s_ptz_cruise_edit_xywh= {90,180,320,70},
	s_ptz_cruise_delete_xywh={300,260,160,60},
	s_ptz_cruise_cruise_xywh= {60,16,400,60},
	s_ptz_cruise_idx1_xywh  ={60,80,60,60},
	s_ptz_cruise_preset1_xywh={120,80,200,60},
	s_ptz_cruise_time1_xywh ={320,80,140,60},
	s_ptz_cruise_idx2_xywh ={60,140,60,60},
	s_ptz_cruise_preset2_xywh ={120,140,200,60},
	s_ptz_cruise_time2_xywh ={320,140,140,60},
	s_ptz_cruise_idx3_xywh ={60,200,60,60},
	s_ptz_cruise_preset3_xywh ={120,200,200,60},
	s_ptz_cruise_time3_xywh ={320,200,140,60},
	s_ptz_cruise_vdrop_xywh = {460,80,30,180},
	s_ptz_cruise_back_xywh= {60,260,60,60},
	s_ptz_cruise_save_xywh= {130,260,160,60},
	s_ptz_cruise_clear_xywh= {300,260,160,60},
}

local ptz_info = {};
local save_preset_id_num = 0; --ԤõĿ
local preset_id_num = 0;--ѲαԤõĿ
local tour_list_num = 0; --ѲĿ
local cur = 0;		--ǰƫ
local dis_col;		--ǰʾͨ
--cruise_list  ӷ
local tour_id_list ={};	 --ӷ
local preset_id_list ={} --Ԥλid
local tour_max_num = 12;
local tour_preset_max_num = 4;
local refresh_hide = function (top, tour_num, preset_num, bool_flag, redraw)
	local cwnd = w1_ptz_cruise.wnd;
	if(bool_flag)then
		b_wnd_ex.set_hide(top, cwnd.tour_list.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.edit.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.go_to.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.delete.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.cruise.id, false, false)
		b_wnd_ex.set_hide(top, cwnd.back.id, false, false)
		b_wnd_ex.set_hide(top, cwnd.save.id, false, false)
		b_wnd_ex.set_hide(top, cwnd.clear.id, false, false)
		b_wnd_ex.set_hide(top, cwnd.idx1.id, false, false)
		b_wnd_ex.set_hide(top, cwnd.idx2.id, false, false)
		b_wnd_ex.set_hide(top, cwnd.idx3.id, false, false)
		b_wnd_ex.set_hide(top, cwnd.preset1.id, false, false)
		b_wnd_ex.set_hide(top, cwnd.preset2.id, false, false)
		b_wnd_ex.set_hide(top, cwnd.preset3.id, false, false)
		b_wnd_ex.set_hide(top, cwnd.time1.id, false, false)
		b_wnd_ex.set_hide(top, cwnd.time2.id, false, false)
		b_wnd_ex.set_hide(top, cwnd.time3.id, false, false)
		if(preset_id_num > 2)then
			b_wnd_ex.set_hide(top, cwnd.drop.id, false, false)
		else
			b_wnd_ex.set_hide(top, cwnd.drop.id, true, false)
		end
		
		if(0 == tour_num or 0 == preset_num)then
			b_wnd_ex.set_text(top, cwnd.idx1.id, "+", false )
			b_wnd_ex.set_text(top, cwnd.time1.id, "", false)
			b_wnd_ex.set_text(top, cwnd.preset1.id, "", false)
			b_wnd_ex.set_disable(top, cwnd.time1.id, true, false )
			b_wnd_ex.set_disable(top, cwnd.preset1.id, true, false )
			b_wnd_ex.set_hide(top, cwnd.idx2.id, true, false)
			b_wnd_ex.set_hide(top, cwnd.idx3.id, true, false)	
			b_wnd_ex.set_hide(top, cwnd.time2.id, true, false)
			b_wnd_ex.set_hide(top, cwnd.time3.id, true, false)
			b_wnd_ex.set_hide(top, cwnd.preset2.id, true, false)
			b_wnd_ex.set_hide(top, cwnd.preset3.id, true, false)
		elseif(1 == preset_num)then
			b_wnd_ex.set_text(top, cwnd.idx1.id, "1", false )
			b_wnd_ex.set_text(top, cwnd.idx2.id, "+", false )
			b_wnd_ex.set_text(top, cwnd.time2.id, "", false)
			b_wnd_ex.set_text(top, cwnd.preset2.id, "", false)
			b_wnd_ex.set_disable(top, cwnd.time1.id, false, false )
			b_wnd_ex.set_disable(top, cwnd.preset1.id, false, false )
			b_wnd_ex.set_disable(top, cwnd.time2.id, true, false )
			b_wnd_ex.set_disable(top, cwnd.preset2.id, true, false )
			
			b_wnd_ex.set_hide(top, cwnd.idx2.id, false, false)
			b_wnd_ex.set_hide(top, cwnd.idx3.id, true, false)
			b_wnd_ex.set_hide(top, cwnd.time2.id, false, false)
			b_wnd_ex.set_hide(top, cwnd.time3.id, true, false)
			b_wnd_ex.set_hide(top, cwnd.preset2.id, false, false)
			b_wnd_ex.set_hide(top, cwnd.preset3.id, true, false)
		elseif(2 == preset_num)then
			b_wnd_ex.set_text(top, cwnd.idx1.id, "1", false )
			b_wnd_ex.set_text(top, cwnd.idx2.id, "2", false )
			b_wnd_ex.set_text(top, cwnd.idx3.id, "+", false )
			b_wnd_ex.set_text(top, cwnd.time3.id, "", false)
			b_wnd_ex.set_text(top, cwnd.preset3.id, "", false)
			b_wnd_ex.set_disable(top, cwnd.time1.id, false, false )
			b_wnd_ex.set_disable(top, cwnd.preset1.id, false, false )
			b_wnd_ex.set_disable(top, cwnd.time2.id, false, false )
			b_wnd_ex.set_disable(top, cwnd.preset2.id, false, false )
			b_wnd_ex.set_disable(top, cwnd.time3.id, true, false )
			b_wnd_ex.set_disable(top, cwnd.preset3.id, true, false )
			
			b_wnd_ex.set_hide(top, cwnd.idx2.id, false, false)
			b_wnd_ex.set_hide(top, cwnd.idx3.id, false, false)
			b_wnd_ex.set_hide(top, cwnd.time2.id, false, false)
			b_wnd_ex.set_hide(top, cwnd.time3.id, false, false)
			b_wnd_ex.set_hide(top, cwnd.preset2.id, false, false)
			b_wnd_ex.set_hide(top, cwnd.preset3.id, false, false)
		elseif(2< preset_num)then
			b_wnd_ex.set_text(top, cwnd.idx1.id, "1", false )
			b_wnd_ex.set_text(top, cwnd.idx2.id, "2", false )
			b_wnd_ex.set_disable(top, cwnd.time1.id, false, false )
			b_wnd_ex.set_disable(top, cwnd.preset1.id, false, false )
			b_wnd_ex.set_disable(top, cwnd.time2.id, false, false )
			b_wnd_ex.set_disable(top, cwnd.preset2.id, false, false )
			b_wnd_ex.set_disable(top, cwnd.time3.id, false, false )
			b_wnd_ex.set_disable(top, cwnd.preset3.id, false, false )
			
			b_wnd_ex.set_hide(top, cwnd.idx2.id, false, false)
			b_wnd_ex.set_hide(top, cwnd.idx3.id, false, false)
			b_wnd_ex.set_hide(top, cwnd.time2.id, false, false)
			b_wnd_ex.set_hide(top, cwnd.time3.id, false, false)
			b_wnd_ex.set_hide(top, cwnd.preset2.id, false, false)
			b_wnd_ex.set_hide(top, cwnd.preset3.id, false, false)
			if(2 < preset_num)then
				local idx_str3 = "+";
				cur = b_wnd_ex.get_drop(top, cwnd.drop.id);
				local add= 2 + cur
				if(preset_id_num > add)then
					idx_str3 = tostring(3+cur);
				else
					idx_str3 = "+";
					b_wnd_ex.set_disable(top, cwnd.time3.id, true, false )
					b_wnd_ex.set_disable(top, cwnd.preset3.id, true, false )
				end
				b_wnd_ex.set_text(top, cwnd.idx3.id, idx_str3, false )
			end
		end		
	else
		if(tour_max_num > 0)then
			b_wnd_ex.set_disable(top, cwnd.delete.id, false, false)
		else
			b_wnd_ex.set_disable(top, cwnd.delete.id, true, false)
		end
		b_wnd_ex.set_hide(top, cwnd.tour_list.id, false, false)
		b_wnd_ex.set_hide(top, cwnd.edit.id, false, false)
		b_wnd_ex.set_hide(top, cwnd.go_to.id, false, false)
		b_wnd_ex.set_hide(top, cwnd.delete.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.cruise.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.back.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.save.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.clear.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.idx1.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.idx2.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.idx3.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.preset1.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.preset2.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.preset3.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.time1.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.time2.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.time3.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.drop.id, true, false)
	end
	if true == redraw then
		b_dlg.dlg_set_redraw(top)
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata, hide_flag)
	local cwnd = w1_ptz_cruise.wnd;
	w1_ptz_cruise.cfg_data = cfgdata;
	if(nil == tour_id_list)then
		tour_id_list ={}
	end
	if(nil == preset_id_list)then
		preset_id_list ={}
	end
	b_wnd_ex.set_hide(top, cwnd.delete.id, true, false)
	b_wnd_ex.dlg_direct_up(top, cwnd.preset1.id, true, false);
	b_wnd_ex.dlg_direct_up(top, cwnd.preset2.id, true, false);
	b_wnd_ex.dlg_direct_up(top, cwnd.preset3.id, true, false);
	
	b_wnd_ex.dlg_direct_up(top, cwnd.time1.id, true, false);
	b_wnd_ex.dlg_direct_up(top, cwnd.time2.id, true, false);
	b_wnd_ex.dlg_direct_up(top, cwnd.time3.id, true, false);
	b_wnd_ex.dlg_direct_left(top, cwnd.time1.id, true, false);
	b_wnd_ex.dlg_direct_left(top, cwnd.time2.id, true, false);
	b_wnd_ex.dlg_direct_left(top, cwnd.time3.id, true, false);
	
	assert(type(cfgdata) == 'table')
	local channel = math.floor(ptz_info.channel)
	local chn = "channel"..tostring(channel)

	tour_preset_max_num = cfgdata['ptz_limits'][chn].tour_preset_max_num;
	tour_max_num = cfgdata['ptz_limits'][chn].tour_max_num
	if(true ~= hide_flag)then --л
		if(tour_max_num > 0)then  --Ѳη
			local list = {};
			for i = 1, tour_max_num do
				table.insert(list,i)
			end
			b_wnd_ex.set_items(top, cwnd.cruise.id, list, false);
			b_wnd_ex.set_items(top, cwnd.tour_list.id, list, false);
		else
			local list = {};
			b_wnd_ex.set_items(top, cwnd.cruise.id, list, false);
			b_wnd_ex.set_items(top, cwnd.tour_list.id, list, false);
		--	b_wnd_ex.set_disable(top, cwnd.cruise.id, true, false);
		end	
	end
	
	if( 0 < cfgdata['ptz_limits'][chn].tour_max_num)then
		b_wnd_ex.set_disable(top, cwnd.tour_list.id, false, false);
		b_wnd_ex.set_disable(top, cwnd.edit.id, false, false);
		
	else
		b_wnd_ex.set_disable(top, cwnd.tour_list.id, true, false);
		b_wnd_ex.set_disable(top, cwnd.go_to.id, true, false)
		b_wnd_ex.set_disable(top, cwnd.edit.id, true, false);
	end
	
	if(nil ~= cfgdata['ptz_tour'])then
		local chn_flag = cfgdata['ptz_tour'][chn];
		if(chn_flag == nil)then --쳣
			b_wnd_ex.set_disable(top, cwnd.save.id, true, false)
			b_wnd_ex.set_disable(top, cwnd.go_to.id, true, false)
			refresh_hide(top, 0, 0, hide_flag, false)
			
			return 0;		
		else
			b_wnd_ex.set_disable(top, cwnd.save.id, false, false)
		end
	else
		b_wnd_ex.set_disable(top, cwnd.tour_list.id, true, false);
		b_wnd_ex.set_disable(top, cwnd.go_to.id, true, false)
		b_wnd_ex.set_disable(top, cwnd.edit.id, true, false);
		refresh_hide(top, 0, 0, hide_flag, false)
		return 0;
	end
	
	--Ԥõ
	if(nil ~= cfgdata['preset_limits'] and nil ~= cfgdata['preset_limits'][chn])then
		local presetid = nil;
		save_preset_id_num = cfgdata['preset_limits'][chn].preset_num
		--local preset_id_list ={}
		if(nil ==next(preset_id_list)) or (0 == #preset_id_list)then
			for i=1, save_preset_id_num do
				presetid = cfgdata['preset_limits'][chn]
				local id = presetid.preset_id[i]	
				table.insert(preset_id_list, id);
			end
			if(0 ~= save_preset_id_num)then
				b_wnd_ex.set_items(top, cwnd.preset1.id, preset_id_list, false )
				b_wnd_ex.set_items(top, cwnd.preset2.id, preset_id_list, false )
				b_wnd_ex.set_items(top, cwnd.preset3.id, preset_id_list, false )
			else
				b_wnd_ex.set_items(top, cwnd.preset1.id, preset_id_list, false )
				b_wnd_ex.set_items(top, cwnd.preset2.id, preset_id_list, false )
				b_wnd_ex.set_items(top, cwnd.preset3.id, preset_id_list, false )
			end
		end
	else
		
	end
	
	tour_list_num = cfgdata['ptz_tour'][chn].tour_num	
	if(tour_max_num == tour_list_num)then
	--	b_wnd_ex.set_disable(top, cwnd.save.id, true, false)
	else
	--	b_wnd_ex.set_disable(top, cwnd.save.id, false, false)
	end

	if(0 == tour_list_num)then	--Ѳνڵ
	    b_wnd_ex.set_disable(top, cwnd.go_to.id, true, false)
		refresh_hide(top, 0, 0, hide_flag, false)
		local vdrop = {};
		vdrop.set_cur = 0;
		vdrop.set_cap = 3;
		vdrop.set_max = 1;	
		b_wnd_ex.set_drop(top, cwnd.drop.id, vdrop, false);
		b_wnd_ex.set_disable(top, cwnd.clear.id, true, false);
		b_wnd_ex.set_disable(top, cwnd.save.id, true, false);
	
	else
	--	local tournum = cfgdata['ptz_tour'][chn].tour_num			--Ѳ
		if(true ~= hide_flag)then
			if(tour_list_num > 0)then
				tour_id_list = nil;
				tour_id_list = {};
				for i =1,tour_max_num do
					local tourlist = "tour_list"..tostring(i)
					if(nil ~= cfgdata['ptz_tour'][chn][tourlist])then
						local id = cfgdata['ptz_tour'][chn][tourlist].tour_id --+1
						table.insert(tour_id_list,id);
					end
				end
			--	b_wnd_ex.set_items(top, cwnd.tour_list.id, tour_id_list, false);
				local cruise_list ={};
				for i =1, tour_max_num do--Ѳ  Ѳη  ȡ
					local sign = 0;			
					for j =1, #tour_id_list do
						if(tour_id_list[j] == i)then
							sign = 1;
						end
					end
					if(0 == sign)then
						table.insert(cruise_list,i);
					end
				end	
			--	b_wnd_ex.set_items(top, cwnd.cruise.id, cruise_list, false);
			end
		end
	
		local tour_idx = b_wnd_ex.get_text(top, cwnd.cruise.id)
		if("" == tour_idx or nil == tour_idx)then
			refresh_hide(top, tour_list_num, 0, hide_flag, false)
			local vdrop = {};
			vdrop.set_cur = 0;
			vdrop.set_cap = 3;
			vdrop.set_max = 1;
			preset_id_num = 0;
			b_wnd_ex.set_drop(top,cwnd.drop.id,vdrop,false);	
			b_wnd_ex.set_disable(top, cwnd.cruise.id,true, false)
			b_wnd_ex.set_disable(top, cwnd.clear.id, true, false);
			b_wnd_ex.set_disable(top, cwnd.save.id, true, false);
			b_wnd_ex.set_disable(top, cwnd.go_to.id, true, false)
			return 0;
		else
			b_wnd_ex.set_disable(top, cwnd.cruise.id,false, false)
		end
		
		local tourlist ="tour_list"..tour_idx
	--	local tourid = tonumber(tour_idx) ---1;
		local tourid = tonumber(tour_idx);
		if(nil == cfgdata['ptz_tour'][chn][tourlist])then
			b_wnd_ex.set_disable(top, cwnd.clear.id, true, false);
			b_wnd_ex.set_disable(top, cwnd.save.id, true, false);
			b_wnd_ex.set_disable(top, cwnd.go_to.id, true, false)
			refresh_hide(top, tour_list_num, 0, hide_flag, false)
			local vdrop = {};
			vdrop.set_cur = 0;
			vdrop.set_cap = 3;
			vdrop.set_max = 1;
			preset_id_num = 0;
			b_wnd_ex.set_drop(top,cwnd.drop.id,vdrop,false);
			
			return 0;
		end
		
		if(nil ~= cfgdata['ptz_tour'][chn][tourlist])then
			local presetnum = cfgdata['ptz_tour'][chn][tourlist].preset_num --Ԥõ
			preset_id_num = presetnum;
			if(0 == presetnum)then
				b_wnd_ex.set_disable(top, cwnd.clear.id, true, false);
				b_wnd_ex.set_disable(top, cwnd.save.id, false, false);
			else
				b_wnd_ex.set_disable(top, cwnd.clear.id, false, false);
				b_wnd_ex.set_disable(top, cwnd.save.id, false, false);
			end
		--	if presetnum > 3 then
			if presetnum > 2 then
				local vdrop = {};
				vdrop.set_cur = 0;
				vdrop.set_cap = 3;
				vdrop.set_max = presetnum +1;
				b_wnd_ex.set_drop(top,cwnd.drop.id,vdrop,false);
				
				b_wnd_ex.set_text(top, cwnd.idx3.id, "3", false )
				b_wnd_ex.set_disable(top, cwnd.time3.id,false, false )
				b_wnd_ex.set_disable(top, cwnd.preset3.id, false, false )
			else
				local vdrop = {};
				vdrop.set_cur = 0;
				vdrop.set_cap = 3;
				vdrop.set_max = 1;
				vdrop.set_max = 0;
				b_wnd_ex.set_drop(top,cwnd.drop.id,vdrop,false);
			end
			
			refresh_hide(top, tour_list_num, presetnum, hide_flag, false)	
			
			for i=1, presetnum do
				local presetlist = "preset_list"..tostring(i)
				local presetid = cfgdata['ptz_tour'][chn][tourlist][presetlist].preset_id -- - 1
				local time = cfgdata['ptz_tour'][chn][tourlist][presetlist].duration 
				local time_str = tostring(time).."s"
				local preset_sel = presetid;
				local num = #preset_id_list
				for i =1, #preset_id_list do
					if(presetid == preset_id_list[i])then
						preset_sel = i -1;
					end
				end
				if(1 == i)then
					b_wnd_ex.set_sel(top, cwnd.preset1.id, preset_sel, false)
					b_wnd_ex.set_text(top, cwnd.preset1.id, tostring(presetid), false)
					b_wnd_ex.set_value(top, cwnd.time1.id, time, false);
					b_wnd_ex.set_text(top, cwnd.time1.id, time_str, false);
				elseif(2 == i)then
					b_wnd_ex.set_sel(top, cwnd.preset2.id, preset_sel, false)
					b_wnd_ex.set_text(top, cwnd.preset2.id, tostring(presetid), false)
					b_wnd_ex.set_value(top, cwnd.time2.id, time, false);
					b_wnd_ex.set_text(top, cwnd.time2.id, time_str, false);
				elseif(3 == i)then
					b_wnd_ex.set_sel(top, cwnd.preset3.id, preset_sel, false)
					b_wnd_ex.set_text(top, cwnd.preset3.id, tostring(presetid), false)
					b_wnd_ex.set_value(top, cwnd.time3.id, time, false);
					b_wnd_ex.set_text(top, cwnd.time3.id, time_str, false);
				else
					
				end
			end
		else
			refresh_hide(top, tour_list_num, 0, hide_flag, false)
		end	
		
		local tour_id = tonumber(b_wnd_ex.get_text(top, cwnd.tour_list.id))
		local sign = 0;
		local num = #tour_id_list
		for i =1, num do
			if(tour_id_list[i] == tour_id)then
				sign = 1;
			end
		end
		if(1 == sign)then
			b_wnd_ex.set_disable(top, cwnd.go_to.id, false, false)
		else
			b_wnd_ex.set_disable(top, cwnd.go_to.id, true, false)
		end 	
	end
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)

	local cwnd = w1_ptz_cruise.wnd
	local channel = math.floor(ptz_info.channel)
	local chn = "channel"..tostring(channel)
	local tour_idx = b_wnd_ex.get_text(top, cwnd.cruise.id)
	local tourlist ="tour_list"..tour_idx
	local tourid = tonumber(tour_idx)---1;
	local str_preset1 = b_wnd_ex.get_text(top, cwnd.preset1.id)
	local str_preset2 = b_wnd_ex.get_text(top, cwnd.preset2.id)
	local str_preset3 = b_wnd_ex.get_text(top, cwnd.preset3.id)
	local preset1 = 1;
	local preset2 = 1;
	local preset3 = 1;
	if("" ~= str_preset1)then
		preset1  = tonumber(str_preset1);
	end
	if("" ~= str_preset2)then
		preset2 = tonumber(str_preset2);
	end
	if("" ~= str_preset3)then
		preset3 = tonumber(str_preset3);
	end
	local preset2 = tonumber(b_wnd_ex.get_text(top, cwnd.preset2.id));
	local preset3 = tonumber(b_wnd_ex.get_text(top, cwnd.preset3.id));
	local time1 = b_wnd_ex.get_value(top, cwnd.time1.id);
	local time2 = b_wnd_ex.get_value(top, cwnd.time2.id);
	local time3 = b_wnd_ex.get_value(top, cwnd.time3.id);
	cur = b_wnd_ex.get_drop(top, cwnd.drop.id);
	if(0 == preset_id_num)then
		print("----lua--error-0 ==preset_id_num----uitousercfg--------");
	--	local presetlist = "preset_list"..tostring(1)
	--	cfgdata['ptz_tour'][chn][tourlist][presetlist].preset_id = preset1;
	--	cfgdata['ptz_tour'][chn][tourlist][presetlist].duration = time1
	elseif(1 == preset_id_num)then
		local presetlist = "preset_list"..tostring(1)
		cfgdata['ptz_tour'][chn][tourlist][presetlist].preset_id = preset1;
		cfgdata['ptz_tour'][chn][tourlist][presetlist].duration = time1
		cfgdata['ptz_tour'][chn][tourlist].tour_id =tourid;
	elseif(2 == preset_id_num)then
		local presetlist = "preset_list"..tostring(1)
		cfgdata['ptz_tour'][chn][tourlist][presetlist].preset_id = preset1;
		cfgdata['ptz_tour'][chn][tourlist][presetlist].duration = time1
		presetlist = "preset_list"..tostring(2)
		cfgdata['ptz_tour'][chn][tourlist][presetlist].preset_id = preset2;
		cfgdata['ptz_tour'][chn][tourlist][presetlist].duration = time2
		cfgdata['ptz_tour'][chn][tourlist].tour_id =tourid;
	--[[elseif(3 == preset_id_num)then
		local presetlist = "preset_list"..tostring(1)
		cfgdata['ptz_tour'][chn][tourlist][presetlist].preset_id = preset1;
		cfgdata['ptz_tour'][chn][tourlist][presetlist].duration = time1
		presetlist = "preset_list"..tostring(2)
		cfgdata['ptz_tour'][chn][tourlist][presetlist].preset_id = preset2;
		cfgdata['ptz_tour'][chn][tourlist][presetlist].duration = time2
		presetlist = "preset_list"..tostring(3)
		cfgdata['ptz_tour'][chn][tourlist][presetlist].preset_id = preset3;
		cfgdata['ptz_tour'][chn][tourlist][presetlist].duration = time3
		cfgdata['ptz_tour'][chn][tourlist].tour_id =tourid;--]]
	else
		if(nil == cfgdata['ptz_tour'][chn][tourlist])then
			return 0;
		end
		
		local idx = preset_id_num - cur -2 
		if(idx < 1)then
			local presetlist = "preset_list"..tostring(1+cur)
			cfgdata['ptz_tour'][chn][tourlist][presetlist].preset_id = preset1;
			cfgdata['ptz_tour'][chn][tourlist][presetlist].duration = time1
			presetlist = "preset_list"..tostring(2+cur)
			cfgdata['ptz_tour'][chn][tourlist][presetlist].preset_id = preset2;
			cfgdata['ptz_tour'][chn][tourlist][presetlist].duration = time2
		--	presetlist = "preset_list"..tostring(2+cur)
			--[[if(nil ~= cfgdata['ptz_tour'][chn][tourlist][presetlist])then
				cfgdata['ptz_tour'][chn][tourlist][presetlist].preset_id = preset3;
				cfgdata['ptz_tour'][chn][tourlist][presetlist].duration = time3
				cfgdata['ptz_tour'][chn][tourlist].tour_id =tourid;
			else
				print("----"..presetlist.."--==nil")
			end--]]
		else
			local presetlist = "preset_list"..tostring(1+cur)
			cfgdata['ptz_tour'][chn][tourlist][presetlist].preset_id = preset1;
			cfgdata['ptz_tour'][chn][tourlist][presetlist].duration = time1
			presetlist = "preset_list"..tostring(2+cur)
			cfgdata['ptz_tour'][chn][tourlist][presetlist].preset_id = preset2;
			cfgdata['ptz_tour'][chn][tourlist][presetlist].duration = time2
			presetlist = "preset_list"..tostring(3+cur)
			if(nil ~= cfgdata['ptz_tour'][chn][tourlist][presetlist])then
				cfgdata['ptz_tour'][chn][tourlist][presetlist].preset_id = preset3;
				cfgdata['ptz_tour'][chn][tourlist][presetlist].duration = time3
				cfgdata['ptz_tour'][chn][tourlist].tour_id =tourid;
			else
				print("----"..presetlist.."--==nil")
			end
		end
	end
	cfgdata['ptz_tour'][chn].change_flag = 1;
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

local updata_list = function(top)
	local cwnd = w1_ptz_cruise.wnd
	local channel = math.floor(ptz_info.channel)
	local chn = "channel"..tostring(channel)
	local cruise= b_wnd_ex.get_sel(top, cwnd.cruise.id) + 1
	local tourlist = "tour_list"..tostring(cruise)
	cur = b_wnd_ex.get_drop(top, cwnd.drop.id);
	local data_cur = cur;
	local cur_idx = cur + 2;
	if(preset_id_num > cur_idx)then
		data_cur = cur 
	else
		data_cur = cur -1;
	end
	local presetlist = "preset_list"..tostring(1 + data_cur)
	if preset_id_num < 3 then
		return 0;
	end
	if(nil == w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist] or nil == w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist])then
		print("---lua_error--tourlist--or-presetlist ==nil-"..presetlist)
		return 0;
	elseif(nil == w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist].preset_id)then
		print("---lua_error--tourlist:"..tourlist.."--presetlist:"..presetlist.."--preset_id == nil--")
		return 0;
	end
	local presetid = w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist].preset_id -- - 1
	local time1 = w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist].duration 
	
	local preset_sel1 = presetid; --ȡӦԤλӦбid
	local num = #preset_id_list
	for i =1, #preset_id_list do
		if(presetid == preset_id_list[i])then
			preset_sel1 = i -1;
		end
	end
--	b_wnd_ex.set_sel(top, cwnd.preset1.id, preset_sel1, false)
--	b_wnd_ex.set_value(top, cwnd.time1.id, time1, false);
	
	presetlist = "preset_list"..tostring(2 + data_cur)
	if(nil ~= w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist])then
		presetid = w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist].preset_id --- 1
	else
		presetid = 1;
	end
	local time2 = 1;
	if(nil ~= w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist])then
		time2 = w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist].duration 
	else
		time2 = 1;
	end
	local preset_sel2 = presetid; --ȡӦԤλӦбid
	local num = #preset_id_list
	for i =1, #preset_id_list do
		if(presetid == preset_id_list[i])then
			preset_sel2 = i -1;
		end
	end
	
	presetlist = "preset_list"..tostring(3 + data_cur)
	if(nil ~= w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist])then
		presetid = w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist].preset_id-- - 1
	else
		presetid = 1;
	end
	
	local time3 = 1;
	if(nil ~= w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist])then
		time3 = w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist].duration 
	else
		time3 = 1;
	end
	
	local preset_sel3 = presetid; --ȡӦԤλӦбid
	local num = #preset_id_list
	for i =1, #preset_id_list do
		if(presetid == preset_id_list[i])then
			preset_sel3 = i -1;
		end
	end
	
	b_wnd_ex.set_sel(top, cwnd.preset1.id, preset_sel1, false)
	b_wnd_ex.set_value(top, cwnd.time1.id, time1, false);
	
	if(preset_id_num > cur_idx)then
		b_wnd_ex.set_sel(top, cwnd.preset2.id, preset_sel2, false)
		b_wnd_ex.set_value(top, cwnd.time2.id, time2, false);
		
		b_wnd_ex.set_sel(top, cwnd.preset3.id, preset_sel3, false)
		b_wnd_ex.set_value(top, cwnd.time3.id, time3, false);
		local str = tostring(preset_id_list[preset_sel3+1])
		b_wnd_ex.set_text(top, cwnd.preset3.id, str, false);
	else
		b_wnd_ex.set_sel(top, cwnd.preset1.id, preset_sel2, false)
		b_wnd_ex.set_value(top, cwnd.time1.id, time2, false);
		
		b_wnd_ex.set_sel(top, cwnd.preset2.id, preset_sel3, false)
		b_wnd_ex.set_value(top, cwnd.time2.id, time3, false);
	end
	
	local idx_str1 = tostring(1+cur);
	local idx_str2 = tostring(2+cur);
	local idx_str3 = "+";
	local add= 2 + cur
	if(preset_id_num > add)then
		idx_str3 = tostring(3+cur);
	else
		idx_str3 = "+";
	end
	
	b_wnd_ex.set_text(top, cwnd.idx1.id, idx_str1, false )
	b_wnd_ex.set_text(top, cwnd.idx2.id, idx_str2, false )
	b_wnd_ex.set_text(top, cwnd.idx3.id, idx_str3, false )
	b_dlg.dlg_set_redraw(top)
	
	local time1_str = tostring(time1).."s"
	local time2_str = tostring(time2).."s"
	local time3_str = tostring(time3).."s"
	if(preset_id_num > cur_idx)then
		b_wnd_ex.set_text(top, cwnd.time1.id, time1_str, false);
		b_wnd_ex.set_text(top, cwnd.time2.id, time2_str, false);
		b_wnd_ex.set_text(top, cwnd.time3.id, time3_str, false);	
		b_wnd_ex.set_disable(top, cwnd.time3.id, false, false);
		b_wnd_ex.set_disable(top, cwnd.preset3.id, false, false);
	else
		b_wnd_ex.set_text(top, cwnd.time1.id, time2_str, false);
		b_wnd_ex.set_text(top, cwnd.time2.id, time3_str, false);
		
		b_wnd_ex.set_text(top, cwnd.time3.id, "", false);
		b_wnd_ex.set_text(top, cwnd.preset3.id, "", false);
		
		b_wnd_ex.set_disable(top, cwnd.time3.id, true, false);
		b_wnd_ex.set_disable(top, cwnd.preset3.id, true, false);
	end
	b_dlg.dlg_set_redraw(top);
end

local on_goto = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if(0 == tour_list_num)then
			return 0;
		end
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =17;
		ptz_info.mode = 8;
		local index = b_wnd_ex.get_text(top, w1_ptz_cruise.wnd.tour_list.id)
		ptz_info.index =tonumber(index) ---1;
		b_app_api.set_ptz(ptz_info);
	end
	return 0
end

local on_edit = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		preset_id_num = 0;
		cur = 0
		local sel = b_wnd_ex.get_sel(top, w1_ptz_cruise.wnd.tour_list.id)
		b_wnd_ex.set_sel(top, w1_ptz_cruise.wnd.cruise.id, sel, false)
		local cfg_tab = {'ptz_tour','ptz_limits','preset_limits'}
		local cruise_cfg ={}
		cruise_cfg = b_app_api.get_cfg(cfg_tab)
		cfgdatatoui(top, cruise_cfg,true)
		refresh_hide(top, tour_list_num, preset_id_num, true, true)
	end
	return 0
end

local okfunc =  function(top)
	return 0;
end

local on_add_delete1 = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if(preset_id_num > 0)then
			return 0;
		end
		local cwnd = w1_ptz_cruise.wnd
		local channel = math.floor(ptz_info.channel)
		local chn = "channel"..tostring(channel)
		if(nil == w1_ptz_cruise.cfg_data['ptz_tour'] and nil == w1_ptz_cruise.cfg_data['ptz_tour'][chn])then
			return 0;
		end
		if(0 == save_preset_id_num)then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_NO_PRESET'), true, false,false);
			w1_msgbox.set_func(okfunc, {top}, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
			return 0;
		end
		
		if(0 == preset_id_num)then   --
			if(nil ~= w1_ptz_cruise.cfg_data['ptz_tour']) and (nil ~= w1_ptz_cruise.cfg_data['ptz_tour'][chn])then	
				local tour_idx = b_wnd_ex.get_text(top, cwnd.cruise.id)
				local tourlist ="tour_list"..tour_idx
				local tourid = tonumber(tour_idx)---1;
				local tourname = "tour"..tour_idx	
				if(0 == tour_list_num)then
					local tour_list = {
						preset_num = 1,
						tour_id = tourid,
						tour_name = tourname,
						preset_list1 ={
							speed =0,
							duration = 0,
							preset_id = 1,
							}	
					}
					w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist] = tour_list	
				else
					 if(nil ~= w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist])then
						local preset_list1 ={
							speed =0,
							duration = 0,
							preset_id = 1,
						};
						w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist]['preset_list1'] = preset_list1	
					else
						local tour_list = {
							preset_num = 1,
							tour_id = tourid,
							tour_name = tourname,
							preset_list1 ={
								speed =0,
								duration = 0,
								preset_id = 1,
								}	
						}
						w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist] = tour_list	
					end				
				end
				--tour_numӦòͳ
	--			w1_ptz_cruise.cfg_data['ptz_tour'][chn].tour_num = w1_ptz_cruise.cfg_data['ptz_tour'][chn].tour_num + 1;
				tour_list_num = tour_list_num + 1;
				w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist].preset_num = 1;
				preset_id_num = 1;
				refresh_hide(top, tour_list_num, 1, true, false)
				b_wnd_ex.set_sel(top, cwnd.preset1.id, 0, false)
				b_wnd_ex.set_value(top, cwnd.time1.id, 0, false);
	
				local num = #preset_id_list;
				if(num > 0)then
					local preset_id = preset_id_list[1]
					b_wnd_ex.set_text(top, cwnd.preset1.id, preset_id, false)
				else	
					b_wnd_ex.set_text(top, cwnd.preset1.id, "1", false)	
				end
				b_wnd_ex.set_text(top, cwnd.time1.id, "0s", false);
				b_wnd_ex.set_disable(top, cwnd.clear.id, false, false);
				b_wnd_ex.set_disable(top, cwnd.save.id, false, false);
	
			else
				refresh_hide(top, 0, preset_id_num, true, false)
			end	
		elseif(preset_id_num > 0 )then --

		end
		uitousercfg(top,w1_ptz_cruise.cfg_data);
		b_wnd_ex.set_text(top, cwnd.time1.id, "0s", false);
		b_dlg.dlg_set_redraw(top)
	end
	return 0
end

local on_add_delete2 = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if(preset_id_num > 1)then
			return 0;
		end
		local cwnd = w1_ptz_cruise.wnd
		local channel = math.floor(ptz_info.channel)
		local chn = "channel"..tostring(channel)
		if(0 == save_preset_id_num)then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_NO_PRESET'), true, false,false);
			w1_msgbox.set_func(okfunc, {top}, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
			return 0;
		end
		
		if(1 == preset_id_num)then  --
			local tour_idx = b_wnd_ex.get_text(top, cwnd.cruise.id)
			local tourlist ="tour_list"..tour_idx
			local tourid = tonumber(tour_idx)-- -1;

			local list = {
				speed =0,
				duration = 0,
				preset_id = 1,
			}
			local presetlist = "preset_list"..tostring(preset_id_num+1)
			w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist] = list	
			preset_id_num = w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist].preset_num + 1
			w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist].preset_num =  preset_id_num
			refresh_hide(top, tour_list_num, preset_id_num, true, false)
			b_wnd_ex.set_sel(top, cwnd.preset2.id, 0, false)
			b_wnd_ex.set_value(top, cwnd.time2.id, 0, false);
		--	b_wnd_ex.set_text(top, cwnd.preset2.id, "1", false)
			local num = #preset_id_list;
			if(num > 0)then
				local preset_id = preset_id_list[1]
				b_wnd_ex.set_text(top, cwnd.preset2.id, preset_id, false)
			else	
				b_wnd_ex.set_text(top, cwnd.preset2.id, "1", false)	
			end
			b_wnd_ex.set_text(top, cwnd.time2.id, "0s", false);
		elseif(preset_id_num > 1)then --
			
		else
				
		end
		uitousercfg(top,w1_ptz_cruise.cfg_data);
		b_wnd_ex.set_text(top, cwnd.time2.id, "0s", false);
		b_dlg.dlg_set_redraw(top)
	end
	return 0
end

local on_add_delete3 = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_ptz_cruise.wnd
		cur = b_wnd_ex.get_drop(top, cwnd.drop.id);
		local add= 2 + cur
		if(preset_id_num > add)then
			return 0;
		elseif(preset_id_num == add)then
			local test =0;
		end
		
		local channel = math.floor(ptz_info.channel)
		local chn = "channel"..tostring(channel)
		local tour_idx = b_wnd_ex.get_text(top, cwnd.cruise.id)
		local tourlist ="tour_list"..tour_idx
		local tourid = tonumber(tour_idx) ---1;
		if(0 == save_preset_id_num)then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_NO_PRESET'), true, false,false);
			w1_msgbox.set_func(okfunc, {top}, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
			return 0;
		end
		
		if(0 == preset_id_num)then
			return 0;
		elseif(1 == preset_id_num)then
			local channel = math.floor(ptz_info.channel)
			local chn = "channel"..tostring(channel)
			if(nil ~= w1_ptz_cruise.cfg_data['ptz_tour']) and (nil ~= w1_ptz_cruise.cfg_data['ptz_tour'][chn])then
				local preset_id_num = w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist].preset_num + 1
				w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist].preset_num =  preset_id_num
				refresh_hide(top, tour_list_num, preset_id_num, true, true)
			else
				print("---lua----on_add_delete2-----------")
				refresh_hide(top, 0, preset_id_num, true, true)
			end	
			return 0;
		elseif(preset_id_num < 2)then   --
			local list = {
				speed =0,
				duration = 0,
				preset_id = 1,
			}
			local presetlist = "preset_list"..tostring(preset_id_num+1)
			w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist] = list	
			preset_id_num = w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist].preset_num + 1
			w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist].preset_num =  preset_id_num
			b_wnd_ex.set_sel(top, cwnd.preset3.id, 0, false)
			b_wnd_ex.set_value(top, cwnd.time3.id, 0, false);
	
			local num = #preset_id_list;
				if(num > 0)then
					local preset_id = preset_id_list[1]
					b_wnd_ex.set_text(top, cwnd.preset3.id, preset_id, false)
				else	
					b_wnd_ex.set_text(top, cwnd.preset3.id, "1", false)	
				end
			b_wnd_ex.set_text(top, cwnd.time3.id, "0s", false);
			if preset_id_num > 2 then --ù
				local vdrop = {};
				vdrop.set_cur = cur + 1;
				vdrop.set_cap = 3;
				vdrop.set_max = preset_id_num +1;
				b_wnd_ex.set_drop(top,cwnd.drop.id,vdrop,false);
			end
			cur = b_wnd_ex.get_drop(top, cwnd.drop.id);
			refresh_hide(top, tour_list_num, preset_id_num, true, false)
		elseif(preset_id_num > 1)then 
			if(preset_id_num == tour_preset_max_num or preset_id_num > tour_preset_max_num )then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_EXCEED_MAX'), true, false,false);
				w1_msgbox.set_func(okfunc, {top}, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
				return 0;
			end
			
			local list = {
				speed =0,
				duration = 0,
				preset_id = 1,
			}
			local presetlist = "preset_list"..tostring(preset_id_num+1)
			w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist] = list	
			preset_id_num = w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist].preset_num + 1
			w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist].preset_num =  preset_id_num
	 
			local idx = preset_id_num - cur -2 
			if(idx < 0)then
				print("---ptz_cruise:slider:cur---");
			end
			if preset_id_num > 2 then --ù
				local vdrop = {};
				vdrop.set_cur = cur+ 1;
				vdrop.set_cap = 3;
				vdrop.set_max = preset_id_num +1;
				b_wnd_ex.set_drop(top,cwnd.drop.id,vdrop,false);
			end
			
			cur = b_wnd_ex.get_drop(top, cwnd.drop.id);
			refresh_hide(top, tour_list_num, preset_id_num, true, false)
			local presetlist = "preset_list"..tostring(cur)
			local preset1 = w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist].preset_id;
			local time1 = 	w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist].duration
			presetlist = "preset_list"..tostring(1+cur)
			local preset2 = w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist].preset_id;
			local time2 = 	w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist].duration;
			if(nil == preset2)then
				local a =0;
			end
				
			local preset_sel1 = preset1 -1 ; --ȡӦԤλӦбid
			local num = #preset_id_list
			for i =1, #preset_id_list do
				if(preset1 == preset_id_list[i])then
					preset_sel1 = i -1;
				end
			end
			b_wnd_ex.set_sel(top, cwnd.preset1.id, preset_sel1, false); 
			local preset_sel2 = preset2 - 1; --ȡӦԤλӦбid
			local num = #preset_id_list
			for i =1, #preset_id_list do
				if(preset2 == preset_id_list[i])then
					preset_sel2 = i -1;
				end
			end
			local idx = preset_id_num - cur -3 
			b_wnd_ex.set_sel(top, cwnd.preset2.id, preset_sel2, false); 
			if(1 > idx)then
				b_wnd_ex.set_sel(top, cwnd.preset1.id, preset_sel2, false); 
				b_wnd_ex.set_sel(top, cwnd.preset2.id, 0, false); 
			end
			
			b_wnd_ex.set_sel(top, cwnd.preset3.id, 0, false); 
			b_wnd_ex.set_value(top, cwnd.time1.id, time2, false); 
		    b_wnd_ex.set_value(top, cwnd.time2.id, 0, false); 
		
			local time1_str = tostring(time1).."s"
			local time2_str = tostring(time2).."s"
			b_wnd_ex.set_text(top, cwnd.time1.id, time2_str, false);
			b_wnd_ex.set_text(top, cwnd.time2.id, "0s", false);
		
			local idx_str1 = tostring(1+cur);
			local idx_str2 = tostring(2+cur);
			b_wnd_ex.set_text(top, cwnd.idx1.id, idx_str1, false )
			b_wnd_ex.set_text(top, cwnd.idx2.id, idx_str2, false )
		end
		uitousercfg(top,w1_ptz_cruise.cfg_data);
		if(preset_id_num > 2)then
			local time1 = b_wnd_ex.get_value(top, cwnd.time1.id);
			local time2 = b_wnd_ex.get_value(top, cwnd.time2.id);
			local time3 = b_wnd_ex.get_value(top, cwnd.time3.id);
			local time1_str = tostring(time1).."s"
			local time2_str = tostring(time2).."s"
			local time3_str = tostring(time3).."s"
			local idx = preset_id_num - cur -2 
			if(idx  > 0)then
				b_wnd_ex.set_text(top, cwnd.time1.id, time1_str, false);
				b_wnd_ex.set_text(top, cwnd.time2.id, time2_str, false);
				b_wnd_ex.set_text(top, cwnd.time3.id, time3_str, false);
			else
				b_wnd_ex.set_text(top, cwnd.time1.id, time1_str, false);
				b_wnd_ex.set_text(top, cwnd.time2.id, time2_str, false);
				
				b_wnd_ex.set_text(top, cwnd.time3.id, "", false);
				b_wnd_ex.set_text(top, cwnd.preset3.id, "", false);
			end
		end
		b_dlg.dlg_set_redraw(top)
	end
	return 0
end

local on_preset1 = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		uitousercfg(top,w1_ptz_cruise.cfg_data);
	end
	return 0
end

local on_preset2 = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		uitousercfg(top,w1_ptz_cruise.cfg_data);
	end
	return 0
end

local on_preset3 = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		uitousercfg(top,w1_ptz_cruise.cfg_data);
	end
	return 0
end

local on_update_param = function(top, win_id, vmsg, x, y)
	if(b_ui.WM_USER_UPDATE_PARAM == vmsg)then
		uitousercfg(top,w1_ptz_cruise.cfg_data);
		local time = b_wnd_ex.get_value(top, win_id);
		local time_str =tostring(time).."s"
		b_wnd_ex.set_text(top, win_id, time_str, true);
		
	end
	return 0
end

local on_drop = function(top, win_id, vmsg, x, y)
	local cwnd = w1_ptz_cruise.wnd
	if b_ui.LBUTTONCLK == vmsg then
		cur = b_wnd_ex.get_drop(top, cwnd.drop.id);
		updata_list(top)
	elseif(b_ui.LBUTTOUP == vmsg) then	
		cur = b_wnd_ex.get_drop(top, cwnd.drop.id);
		updata_list(top)
	elseif(b_ui.MOUSEWHEELUP == vmsg)then
		cur = b_wnd_ex.get_drop(top, cwnd.drop.id);
		updata_list(top)
	elseif(b_ui.MOUSEWHEELDOWN == vmsg) then	
		cur = b_wnd_ex.get_drop(top, cwnd.drop.id);
		updata_list(top)	
	end
	return 0
end

w1_ptz_cruise.drop = function(top, win_id, vmsg, x, y)
	local cwnd = w1_ptz_cruise.wnd
	local ret = 0;
	if b_ui.MOUSEWHEELUP == vmsg then
		if preset_id_num > 2 then
			cur = b_wnd_ex.get_drop(top, cwnd.drop.id);
			if(cur == 0 or cur < 0)then
				return 0;
			end
			cur  =cur- 1
		
			local vdrop = {};
			vdrop.set_cur = cur;
			vdrop.set_cap = 3;
			vdrop.set_max = preset_id_num +1;
			b_wnd_ex.set_drop(top,cwnd.drop.id,vdrop,false);
			
			updata_list(top)
			ret = 1;
		end
			
	elseif(b_ui.MOUSEWHEELDOWN == vmsg) then	
		if preset_id_num > 2 then
			cur = b_wnd_ex.get_drop(top, cwnd.drop.id);
			local idx = preset_id_num - cur
			if(idx == 2 or idx < 2)then
				return 0;
			end
			cur  =cur + 1
		
			local vdrop = {};
			vdrop.set_cur = cur;
			vdrop.set_cap = 3;
			vdrop.set_max = preset_id_num +1;
			b_wnd_ex.set_drop(top,cwnd.drop.id,vdrop,false);
			
			updata_list(top)
			ret = 1;
		end
		
	elseif(b_ui.LBUTTOUP == vmsg) then
		if preset_id_num > 2 then	
			cur = b_wnd_ex.get_drop(top, cwnd.drop.id);
			updata_list(top)
			ret = 1;
		end
	elseif b_ui.LBUTTONCLK == vmsg then
		if preset_id_num > 2 then
			cur = b_wnd_ex.get_drop(top, cwnd.drop.id);
			updata_list(top)
			ret = 1;
		end
	elseif(b_ui.LBUTTONDOWN == vmsg) then
		if preset_id_num > 2 then
			cur = b_wnd_ex.get_drop(top, cwnd.drop.id);
			updata_list(top)
			ret = 1;
		end
	end
	
	return ret;
end

local on_back  = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_ptz_cruise.wnd
		local tour_id = tonumber(b_wnd_ex.get_text(top, cwnd.tour_list.id))
		local sign = 0;
		local num = #tour_id_list
		for i =1, num do
			if(tour_id_list[i] == tour_id)then
				sign = 1;
			end
		end
		if(1 == sign)then
			b_wnd_ex.set_disable(top, cwnd.go_to.id, false, false)
		else
			b_wnd_ex.set_disable(top, cwnd.go_to.id, true, false)
		end 
		refresh_hide(top, tour_list_num, preset_id_num, false, true)	
	end
	return 0
end

local on_cruise = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local cwnd = w1_ptz_cruise.wnd
		local channel = math.floor(ptz_info.channel)
		local chn = "channel"..tostring(channel)
		if(nil == w1_ptz_cruise.cfg_data['ptz_tour'][chn])then
			return 0;
		end
		local tour_list_num = w1_ptz_cruise.cfg_data['ptz_tour'][chn].tour_num				
		preset_id_num = 0;
		
		local cfg_tab = {'ptz_tour','ptz_limits','preset_limits'}
		local cruise_cfg ={}
		cruise_cfg = b_app_api.get_cfg(cfg_tab)
		cfgdatatoui(top, cruise_cfg, true)
		
		refresh_hide(top, tour_list_num, preset_id_num, true, false)
		if(preset_id_num > 2)then
			local time1 = b_wnd_ex.get_value(top, cwnd.time1.id);
			local time2 = b_wnd_ex.get_value(top, cwnd.time2.id);
			local time3 = b_wnd_ex.get_value(top, cwnd.time3.id);
			local time1_str = tostring(time1).."s"
			local time2_str = tostring(time2).."s"
			local time3_str = tostring(time3).."s"
			b_wnd_ex.set_text(top, cwnd.time1.id, time1_str, false);
			b_wnd_ex.set_text(top, cwnd.time2.id, time2_str, false);
			b_wnd_ex.set_text(top, cwnd.time3.id, time3_str, false);
		elseif(preset_id_num == 2)then
			local time1 = b_wnd_ex.get_value(top, cwnd.time1.id);
			local time2 = b_wnd_ex.get_value(top, cwnd.time2.id);
			local time1_str = tostring(time1).."s"
			local time2_str = tostring(time2).."s"
			b_wnd_ex.set_text(top, cwnd.time1.id, time1_str, false);
			b_wnd_ex.set_text(top, cwnd.time2.id, time2_str, false);
		elseif(preset_id_num == 1)then
			local time1 = b_wnd_ex.get_value(top, cwnd.time1.id);
			local time1_str = tostring(time1).."s"
			b_wnd_ex.set_text(top, cwnd.time1.id, time1_str, false);
		else
			
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_tour = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local cwnd = w1_ptz_cruise.wnd
		local tour_id = tonumber(b_wnd_ex.get_text(top, w1_ptz_cruise.wnd.tour_list.id))
		local sign = 0;
		local num = #tour_id_list
		for i =1, num do
			if(tour_id_list[i] == tour_id)then
				sign = 1;
			end
		end
		if(1 == sign)then
			b_wnd_ex.set_disable(top, cwnd.go_to.id, false, true)
		else
			b_wnd_ex.set_disable(top, cwnd.go_to.id, true, true)
		end 
	end
	return 0
end

local on_save  = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_ptz_cruise.wnd
		local channel = math.floor(ptz_info.channel)
		local chn = "channel"..tostring(channel)
		if(nil ~= w1_ptz_cruise.cfg_data['ptz_tour'] and nil == w1_ptz_cruise.cfg_data['ptz_tour'][chn])then
			return 0;
		end
		local tour_num = w1_ptz_cruise.cfg_data['ptz_tour'][chn].tour_num
		
		if(0 == preset_id_num )then
			return 0
		end
		
		--豸޸ѲԤõ㣬Ȱɾ
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =17;
		ptz_info.mode = 7; --ɾ Ѳη
		local tour_idx = tonumber(b_wnd_ex.get_text(top, w1_ptz_cruise.wnd.cruise.id))
		
		ptz_info.index = tour_idx; --- 1;
		b_app_api.set_ptz(ptz_info);
		---------------------------------------------------
		
		--Ԥλ
		local tourlist ="tour_list"..tour_idx
		local tourid = tonumber(tour_idx)-1;
		
		for i=1, preset_id_num do
			local presetlist = "preset_list"..tostring(i)
			ptz_info.time  = w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist].duration;
			if(1 == i)then --ʼ
				ptz_info.index = w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist].tour_id; --Ѳε
				ptz_info.mode = 10;	
				b_app_api.set_ptz(ptz_info);
				--ӵһԤλ
				ptz_info.index = w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist].preset_id;--Ԥλ
				ptz_info.mode = 12;	
				b_app_api.set_ptz(ptz_info);
			elseif(preset_id_num == i)then  --
				--һԤλ
				ptz_info.index = w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist].preset_id;--Ԥλ
				ptz_info.mode = 12;	
				b_app_api.set_ptz(ptz_info);
				--
				ptz_info.index = w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist].tour_id; --Ѳε
				ptz_info.mode = 11;	
				b_app_api.set_ptz(ptz_info);
			else --Ԥλ
				ptz_info.index = w1_ptz_cruise.cfg_data['ptz_tour'][chn][tourlist][presetlist].preset_id;--Ԥλ
				ptz_info.mode = 12;	
				b_app_api.set_ptz(ptz_info);
			end
		end	
		
		local tour_id = tonumber(b_wnd_ex.get_text(top, w1_ptz_cruise.wnd.cruise.id))
		local tour_sel = b_wnd_ex.get_sel(top, w1_ptz_cruise.wnd.cruise.id)
		
		local cfg_tab = {'ptz_tour','ptz_limits','preset_limits'}
		local cruise_cfg ={}
		cruise_cfg = b_app_api.get_cfg(cfg_tab)
		cfgdatatoui(top, cruise_cfg,false)
		
		b_wnd_ex.set_sel(top, w1_ptz_cruise.wnd.tour_list.id, tour_sel, false)
		local sign = 0;
		local num = #tour_id_list
		for i =1, num do
			if(tour_id_list[i] == tour_id)then
				sign = 1;
			end
		end
		if(1 == sign)then
			b_wnd_ex.set_disable(top, cwnd.go_to.id, false, true)
		else
			b_wnd_ex.set_disable(top, cwnd.go_to.id, true, true)
		end 
		
		refresh_hide(top, tour_list_num, 0, false, true)
	end
	return 0
end

local okfunc_delete = function(param)
	local speed = b_wnd_ex.get_text(param[1],w1_id.live_wnd.ptz_id+8);
	ptz_info.speed =tonumber(speed);
	ptz_info.action =17;
	ptz_info.mode = 7; --ɾ Ѳη
	local tour_id = tonumber(b_wnd_ex.get_text(param[1], w1_ptz_cruise.wnd.tour_list.id)) ---1
	
	ptz_info.index = tour_id;
	b_app_api.set_ptz(ptz_info);
--	tour_list_num = tour_list_num -1;
	local cfg_tab = {'ptz_tour','ptz_limits','preset_limits'}
	local cruise_cfg ={}
	cruise_cfg = b_app_api.get_cfg(cfg_tab)
	cfgdatatoui(param[1], cruise_cfg,false)
	refresh_hide(param[1], tour_list_num, 0, false, true)
	
	return 0;
end

local on_delete = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if(0 == tour_list_num)then
			return 0;
		end
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_SURE_DELETE_TOUR'), true, true,false);
		w1_msgbox.set_func(okfunc_delete, {top}, nil, nil);
		b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);	
	end
	return 0;
end

local on_clear = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		cur = 0;
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =17;
		ptz_info.mode = 7; --ɾ Ѳη
		local tour_id = tonumber(b_wnd_ex.get_text(top, w1_ptz_cruise.wnd.cruise.id))-- -1
		
		ptz_info.index = tour_id;
		b_app_api.set_ptz(ptz_info);
		local cfg_tab = {'ptz_tour','ptz_limits','preset_limits'}
		local cruise_cfg ={}
		cruise_cfg = b_app_api.get_cfg(cfg_tab)
		cfgdatatoui(top, cruise_cfg,true)
		preset_id_num = 0;
		refresh_hide(top, tour_list_num,preset_id_num, true, true)
	end
	return 0;
end

w1_ptz_cruise.pre_show = function(top)
	preset_id_num = 0;
	tour_list_num = 0;
	local cfg_tab = {'ptz_tour','ptz_limits','preset_limits'}
	local cruise_cfg ={}
	cruise_cfg = b_app_api.get_cfg(cfg_tab)
	cfgdatatoui(top, cruise_cfg,false)
end

w1_ptz_cruise.init = function (top,chn)
	ptz_info.channel = chn;
	ptz_info.action  = 17;
	ptz_info.mode =8;--
	ptz_info.speed = 0;
	ptz_info.index =1;--Ԥλ
	ptz_info.time =0;
	ptz_info.name ="preset"
	return 0
end

w1_ptz_cruise.update_channel =function (top, channel, page_id)
	ptz_info.channel =channel;
	if(4 == page_id)then
		preset_id_num = 0;
		tour_list_num = 0;
		local cfg_tab = {'ptz_tour','ptz_limits','preset_limits'}
		local cruise_cfg ={}
		cruise_cfg = b_app_api.get_cfg(cfg_tab)
		cfgdatatoui(top, cruise_cfg,false)
	end
end

w1_ptz_cruise.clear =function (top)
	tour_id_list = nil;
	preset_id_list = nil
	w1_ptz_cruise.cfg_data = nil;
end

w1_ptz_cruise.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_ptz_cruise_t_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'cruise','tour_list','go_to','edit','delete','idx1','idx2','idx3','preset1','preset2','preset3','time1','time2',
			'time3','drop','back','save','clear'},
	cruise 	= {t='combox',id=id+1,xywh='s_ptz_cruise_cruise_xywh',items={'1','2','3','4'},item_dispnum =4,trans = false, cmd = on_cruise},	
	tour_list 	= {t='combox',id=id+2,xywh='s_ptz_cruise_tour_list_xywh',items={'1','2','3','4'},item_dispnum =4,trans = false,cmd = on_tour},	
	go_to = {t='button',id=id+4,xywh='s_ptz_cruise_go_to_xywh',text = 'LA_GO_TO',align = b_ui.ALIGN.CENTER,cmd=on_goto,
			};	
	edit = {t='button',id=id+5,xywh='s_ptz_cruise_edit_xywh',text = 'LA_EDIT',align = b_ui.ALIGN.CENTER,cmd=on_edit,
			};	
	
	idx1 = {t='button',id=id+6,xywh='s_ptz_cruise_idx1_xywh',text = '+',trans = false,align = b_ui.ALIGN.CENTER,cmd=on_add_delete1,
			};
	idx2 = {t='button',id=id+7,xywh='s_ptz_cruise_idx2_xywh',text = '+',trans = false,align = b_ui.ALIGN.CENTER,cmd=on_add_delete2,
			};
	idx3 = {t='button',id=id+8,xywh='s_ptz_cruise_idx3_xywh',text = '+',trans = false,align = b_ui.ALIGN.CENTER,cmd=on_add_delete3,
			};
	preset1 = {t='combox',id=id+9,xywh='s_ptz_cruise_preset1_xywh',items = {1,2,3,4,5,6,7,8},trans = false,align = b_ui.ALIGN.CENTER,cmd=on_preset1,
			};
	preset2 = {t='combox',id=id+10,xywh='s_ptz_cruise_preset2_xywh',items = {1,2,3,4,5,6,7,8},trans = false,align = b_ui.ALIGN.CENTER,cmd=on_preset2,
			};
	preset3 = {t='combox',id=id+11,xywh='s_ptz_cruise_preset3_xywh',items = {1,2,3,4,5,6,7,8},trans = false,align = b_ui.ALIGN.CENTER,cmd=on_preset2,
			};
	time1 	= {t='edit_num',id=id+12,	xywh='s_ptz_cruise_time1_xywh',range={0,255},cmd = on_update_param},
	time2 	= {t='edit_num',id=id+13,	xywh='s_ptz_cruise_time2_xywh',range={0,255},cmd = on_update_param},
	time3 	= {t='edit_num',id=id+14,	xywh='s_ptz_cruise_time3_xywh',range={0,255},cmd = on_update_param},
	drop = {t='vdrop', id=id+15,xywh='s_ptz_cruise_vdrop_xywh',set_cur =0, set_cap =3, set_max =3, cmd = on_drop};
	
	back = {t='tt_button',id=id+16,xywh='s_ptz_cruise_back_xywh',align = b_ui.ALIGN.CENTER,
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_ptz_back','it_ptz_back', 'it_ptz_back'},
			cmd=on_back,
		};
	delete = {t='button',id=id+17,xywh='s_ptz_cruise_delete_xywh',text = 'LA_DELETE',align = b_ui.ALIGN.CENTER,cmd=on_delete,
			};	
	save = {t='button',id=id+18,xywh='s_ptz_cruise_save_xywh',text = 'LA_SAVE',align = b_ui.ALIGN.CENTER,cmd=on_save,
			};	
	clear = {t='button',id=id+19,xywh='s_ptz_cruise_clear_xywh',text = 'LA_CLEAR',align = b_ui.ALIGN.CENTER,
			cmd=on_clear,
		
			};	
				
}

return w1_ptz_cruise
