--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created:2018/4/26
-- author 
-- brief  
--]]
local util 		= require("wnd.core.util")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.live_wnd.ptz_preset_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 	= r_size.get_size
local b_dlg 	= require("wnd.core.b_dlg")
local w1_key 	= require("wnd.w1_util.w1_key")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str

local w1_ptz_preset = {
	cfg_data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_ptz_preset.s_768 =
{
	s_ptz_preset_t_xywh = {97,78,178,35},
	s_ptz_preset_preset_xywh = {45,7,85,24},
	s_ptz_preset_go_to_xywh = {45,35,85,24},
	s_ptz_preset_del_xywh = {45,64,85,24},
	s_ptz_preset_add_xywh = {45,92,85,24},
	s_ptz_preset_cap_id_xywh = {5,7,80,28},
	s_ptz_preset_t_id_xywh = {90,7,80,28},
	s_ptz_preset_cap_name_xywh = {5,42,80,28},
	s_ptz_preset_t_name_xywh = {90,42,80,28},
	s_ptz_preset_ok_xywh = {8,85,80,28},
	s_ptz_preset_cancel_xywh = {90,85,80,28},
};
	
w1_ptz_preset.s_1280 = 
{
	s_ptz_preset_t_xywh= {183,110,335,50},
	s_ptz_preset_preset_xywh= {85,10,160,35},
	s_ptz_preset_go_to_xywh= {85,50,160,35},
	s_ptz_preset_del_xywh= {85,90,160,35},
	s_ptz_preset_add_xywh = {85,130,160,35},
	s_ptz_preset_cap_id_xywh = {10, 10, 150, 40},
	s_ptz_preset_t_id_xywh = {170, 10, 150, 40},
	s_ptz_preset_cap_name_xywh = {10, 60, 150, 40},
	s_ptz_preset_t_name_xywh = {170, 60, 150, 40},
	s_ptz_preset_ok_xywh = {15, 120, 150, 40},
	s_ptz_preset_cancel_xywh = {170, 120, 150, 40},
}
w1_ptz_preset.s_1440 = 
{
	s_ptz_preset_t_xywh= {183,110,335,50},
	s_ptz_preset_preset_xywh= {85,10,160,35},
	s_ptz_preset_go_to_xywh= {85,50,160,35},
	s_ptz_preset_del_xywh= {85,90,160,35},
	s_ptz_preset_add_xywh = {85,130,160,35},
	s_ptz_preset_cap_id_xywh = {10, 10, 150, 40},
	s_ptz_preset_t_id_xywh = {170, 10, 150, 40},
	s_ptz_preset_cap_name_xywh = {10, 60, 150, 40},
	s_ptz_preset_t_name_xywh = {170, 60, 150, 40},
	s_ptz_preset_ok_xywh = {15, 120, 150, 40},
	s_ptz_preset_cancel_xywh = {170, 120, 150, 40},
}	
w1_ptz_preset.s_1080p = 
{
	s_ptz_preset_t_xywh= {183,110,335,50},
	s_ptz_preset_preset_xywh= {85,10,160,35},
	s_ptz_preset_go_to_xywh= {85,50,160,35},
	s_ptz_preset_del_xywh= {85,90,160,35},
	s_ptz_preset_add_xywh = {85,130,160,35},
	s_ptz_preset_cap_id_xywh = {10, 10, 150, 40},
	s_ptz_preset_t_id_xywh = {170, 10, 150, 40},
	s_ptz_preset_cap_name_xywh = {10, 60, 150, 40},
	s_ptz_preset_t_name_xywh = {170, 60, 150, 40},
	s_ptz_preset_ok_xywh = {15, 120, 150, 40},
	s_ptz_preset_cancel_xywh = {170, 120, 150, 40},
}

w1_ptz_preset.s_2k = 
{
	s_ptz_preset_t_xywh = {243,146,446,66},
	s_ptz_preset_preset_xywh = {113,13,213,46},
	s_ptz_preset_go_to_xywh = {113,66,213,46},
	s_ptz_preset_del_xywh = {113,119,213,46},
	s_ptz_preset_add_xywh = {113,173,213,46},
	s_ptz_preset_cap_id_xywh = {13,13,199,53},
	s_ptz_preset_t_id_xywh = {226,13,199,53},
	s_ptz_preset_cap_name_xywh = {13,79,199,53},
	s_ptz_preset_t_name_xywh = {226,79,199,53},
	s_ptz_preset_ok_xywh = {19,159,199,53},
	s_ptz_preset_cancel_xywh = {226,159,199,53},
}

w1_ptz_preset.s_4k = 
{
	s_ptz_preset_t_xywh = {366,220,670,100},
	s_ptz_preset_preset_xywh = {170,20,320,70},
	s_ptz_preset_go_to_xywh = {170,100,320,70},
	s_ptz_preset_del_xywh = {170,180,320,70},
	s_ptz_preset_add_xywh = {170,260,320,70},
	s_ptz_preset_cap_id_xywh = {20,20,300,80},
	s_ptz_preset_t_id_xywh = {340,20,300,80},
	s_ptz_preset_cap_name_xywh = {20,120,300,80},
	s_ptz_preset_t_name_xywh = {340,120,300,80},
	s_ptz_preset_ok_xywh = {30,240,300,80},
	s_ptz_preset_cancel_xywh = {340,240,300,80},
}
local ptz_info = {};
local del_flag = false;

local on_preset_down = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local speed_num = tonumber(b_wnd_ex.get_text(top,w1_ptz.dlg.speed_num.id))
		if(speed_num > 1)then
			speed_num =speed_num -1
		elseif(speed_num ==1)then
		
		end
		local speed = tostring(speed_num);
		b_wnd_ex.get_text(top,w1_ptz.dlg.speed_num.id,speed,true)
	end
	return 0
end

local on_preset_up = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local speed_num = tonumber(b_wnd_ex.get_text(top,w1_ptz.dlg.speed_num.id))
		if(speed_num < 255)then
			speed_num =speed_num +1
		elseif(speed_num ==255)then
				
		end
		local speed = tostring(speed_num);
		b_wnd_ex.get_text(top,w1_ptz.dlg.speed_num.id,7,true)
	end
	return 0
end

local on_hide_add_opt_btn = function(top, hide, redraw)
	local s_id = id + 3;
	local e_id = id + 12
	for i = s_id, e_id do
		if (i  < id + 7) then
			b_wnd_ex.set_hide(top, i, not hide, false);
		else
			b_wnd_ex.set_hide(top, i, hide, false);
		end
	end
		
	b_wnd_ex.set_text(top, w1_ptz_preset.wnd.t_name.id, '', false);
	
	if (true == redraw) then
			b_dlg.dlg_set_redraw(top);
	end
end	

local on_goto = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =16;
		ptz_info.mode = 8;
		local chn = "channel"..tostring(math.floor(ptz_info.channel));
		local data = w1_ptz_preset.cfg_data['ptz_limits'][chn];	
		local sel = b_wnd_ex.get_sel(top, w1_ptz_preset.wnd.preset.id) + 1; 
		local index = sel;
		ptz_info.index =tonumber(index);
		b_app_api.set_ptz(ptz_info);
	end
	return 0
end

local on_ok = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_ptz_preset.wnd;
		local preset_name = b_wnd_ex.get_text(top, cwnd.t_name.id)
		if (preset_name == '') then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_NAME_NOT_EMPTY'), true, false,false);
			w1_msgbox.set_func(nil, nil, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)			
			b_dlg.dlg_set_redraw(top);
			return 0;
		end
			
		local param = {};
		param.channel = ptz_info.channel;
		param.action  = 16;
		param.mode = 6;
		param.time = ptz_info.time;		
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		param.speed =tonumber(speed);
		local chn = "channel"..tostring(math.floor(ptz_info.channel));
		local data = w1_ptz_preset.cfg_data['ptz_limits'][chn];	
		local sel = b_wnd_ex.get_sel(top, w1_ptz_preset.wnd.t_preset.id) + 1; 
		param.index =tonumber(sel);
		param.name = preset_name;	
		
		b_app_api.set_ptz(param);
		w1_ptz_preset.updata(top, ptz_info.channel);
	end
	
	return 0
end

local on_cancel = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		on_hide_add_opt_btn(top, true, true);
	end
	
	return 0;
end

local on_add = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local chn = "channel"..tostring(math.floor(ptz_info.channel));
		local data = w1_ptz_preset.cfg_data['ptz_limits'][chn];	
		local max_preset_num = 255;
		local cur_preset_num= data.preset_num;
		local exist_flag = false;
		local preset_list = {};
		for i = 1, max_preset_num do
			table.insert(preset_list, i)
		end
		b_wnd_ex.set_items(top,w1_ptz_preset.wnd.t_preset.id,preset_list,false)
		b_wnd_ex.set_sel(top,w1_ptz_preset.wnd.t_preset.id,0,false)
		on_hide_add_opt_btn(top, false, true);
	end
	
	return 0
end

local on_del_func = function(param)
	del_flag = true;	
end	

local on_del = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		del_flag = false
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_CONFIRM_DELETE'), true, true,false);
		w1_msgbox.set_func(on_del_func,{top}, nil, nil);
		b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)	
			
		if (del_flag == true) then
			local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
			ptz_info.speed =tonumber(speed);
			ptz_info.action =16;
			ptz_info.mode = 7;
			local chn = "channel"..tostring(math.floor(ptz_info.channel));
			local data = w1_ptz_preset.cfg_data['ptz_limits'][chn];	
			local sel = b_wnd_ex.get_sel(top, w1_ptz_preset.wnd.preset.id) + 1; 
			local index = sel;
			ptz_info.index =tonumber(index);
			b_app_api.set_ptz(ptz_info);
			w1_ptz_preset.updata(top, ptz_info.channel);
		end
	end
	
	return 0
end

w1_ptz_preset.pre_show =function (top)
	on_hide_add_opt_btn(top, true, false);
	local cwnd = w1_ptz_preset.wnd
	local cfg_tab = {'ptz_limits'}
	preset = b_app_api.get_cfg(cfg_tab)
	if(w1_ptz_preset.cfg_data == nil) then
		w1_ptz_preset.cfg_data = util.copy_tab(preset);	
	else
		util.copy_tab_b(w1_ptz_preset.cfg_data, preset);
	end	
	local chn = "channel"..tostring(math.floor(ptz_info.channel));
	local data = preset['ptz_limits'][chn];
	local max_preset_num = 255;
	b_wnd_ex.set_disable(top, cwnd.preset.id, false, false);
	b_wnd_ex.set_disable(top, cwnd.go_to.id, false, false);
	b_wnd_ex.set_disable(top, cwnd.add.id, false, false);
	b_wnd_ex.set_disable(top, cwnd.del.id, false, false);

	local preset_list = {};
	for i=1,max_preset_num  do
		local str = string.format("[%d]", i)
		for k = 1, data.preset_num do
			if (i == data.presets["idx"..k].preset_id) then
				str = string.format("[%d]%s", data.presets["idx"..k].preset_id, data.presets["idx"..k].preset_name)
			end
		end
		table.insert(preset_list,str)
	end
	b_wnd_ex.set_items(top,w1_ptz_preset.wnd.preset.id,preset_list,false)
	b_wnd_ex.set_sel(top,w1_ptz_preset.wnd.preset.id,0,false)
		
	b_dlg.dlg_set_redraw(top);
end

w1_ptz_preset.updata =function (top, channel)
	on_hide_add_opt_btn(top, true, false);
	ptz_info.channel =channel;
	local cwnd = w1_ptz_preset.wnd
	local cfg_tab = {'ptz_limits'}
	local preset ={}
	preset = b_app_api.get_cfg(cfg_tab)
	if(w1_ptz_preset.cfg_data == nil) then
		w1_ptz_preset.cfg_data = util.copy_tab(preset);	
	else
		util.copy_tab_b(w1_ptz_preset.cfg_data, preset);
	end		
	local chn = "channel"..tostring(math.floor(ptz_info.channel));
	local data = preset['ptz_limits'][chn];	
	local max_preset_num = 255;
	b_wnd_ex.set_disable(top, cwnd.preset.id, false, false);
	b_wnd_ex.set_disable(top, cwnd.go_to.id, false, false);
	b_wnd_ex.set_disable(top, cwnd.add.id, false, false);
	b_wnd_ex.set_disable(top, cwnd.del.id, false, false);

	local preset_list ={};
	for i=1,max_preset_num  do
		local str = string.format("[%d]", i)
		for k = 1, data.preset_num do
			if (i == data.presets["idx"..k].preset_id) then
				str = string.format("[%d]%s", data.presets["idx"..k].preset_id, data.presets["idx"..k].preset_name)
			end
		end
		table.insert(preset_list,str)
	end
	b_wnd_ex.set_items(top,w1_ptz_preset.wnd.preset.id,preset_list,false)
	b_wnd_ex.set_sel(top,w1_ptz_preset.wnd.preset.id,0,false)
	--ﵽ 
	if (data.preset_num == max_preset_num) then
		b_wnd_ex.set_disable(top, cwnd.add.id, true, false);
	end
	
	b_dlg.dlg_set_redraw(top);
end

w1_ptz_preset.init = function (top,chn)
	ptz_info.channel = chn;
	ptz_info.action  =0;
	ptz_info.mode =8;--
	ptz_info.speed = 6;
	ptz_info.index =1;--Ԥλ
	ptz_info.time =0;
	w1_ptz_preset.cfg_data = nil;	
	
	local preset_list ={};
	--combox_in ؼ֧items
	b_wnd_ex.set_items(top,w1_ptz_preset.wnd.preset.id,preset_list,false)

	on_hide_add_opt_btn(top, true, false)
	
	return 0
end

w1_ptz_preset.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_ptz_preset_t_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'preset_down','preset','preset_up','go_to','del','add', 'cap_preset', 't_preset', 'cap_name', 't_name', 'ok', 'cancel'},
	preset 	= {t='combox',id=id+3,xywh='s_ptz_preset_preset_xywh',items={'1','2','3','4'},item_dispnum =4,trans = false},	
	go_to = {t='button',id=id+4,xywh='s_ptz_preset_go_to_xywh',text = 'LA_GO_TO',align = b_ui.ALIGN.CENTER,cmd=on_goto,
			};	
	del = {t='button',id=id+5,xywh='s_ptz_preset_del_xywh',text = 'LA_DELETE',align = b_ui.ALIGN.CENTER,cmd=on_del,
			};		
	add = {t='button',id=id+6,xywh='s_ptz_preset_add_xywh',text = 'LA_ADD',align = b_ui.ALIGN.CENTER,cmd=on_add,
			};			
			
	cap_preset	 = {t='static',	id=id+7,	xywh = 's_ptz_preset_cap_id_xywh',	
				text='LA_PRESET', font = 'f_grade6'},
	t_preset 	= {t='combox',id=id+8,xywh='s_ptz_preset_t_id_xywh',items={'1','2','3','4'},item_dispnum = 6,trans = false},		
	
	cap_name	 = {t='static',	id=id+9,	xywh = 's_ptz_preset_cap_name_xywh',
				text='LA_NAME', font = 'f_grade6'},
	t_name		= {t='edit', 	id=id+10,xywh='s_ptz_preset_t_name_xywh', 
					text='',	trans = false, 	font = 'f_grade6',guide_text='LA_NAME'},	
	
	ok		= {t='button',	id=id+11,	xywh = 's_ptz_preset_ok_xywh',	text='LA_SAVE',		cmd=on_ok, font='f_grade6',
					color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f', 'c_popdlg_ok_text_f'},
					},
	cancel	= {t='button',	id=id+12,	xywh = 's_ptz_preset_cancel_xywh',text='LA_CANCEL',	cmd=on_cancel,font='f_grade6',
					color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
					color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f', 'c_popdlg_ok_text_f'},
					},					
}

return w1_ptz_preset
