--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created:2018/11/22
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.live_wnd.ptz_scan_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 	= r_size.get_size
local b_dlg 	= require("wnd.core.b_dlg")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local util 		= require("wnd.core.util")
local w1_key 	= require("wnd.w1_util.w1_key")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local global_val	= require("wnd.global_val")
local w1_ptz_scan = {
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_ptz_scan.s_768 =
{
	s_ptz_scan_t_xywh = {118,78,136,35},
	s_ptz_scan_scan_xywh = {24,7,85,24},
	s_ptz_scan_go_to_xywh = {24,35,85,24},
	s_ptz_scan_edit_xywh = {24,64,85,24},
	s_ptz_scan_delete_xywh = {69,64,40,24},
	s_ptz_scan_start_xywh = {69,64,40,24},
	s_ptz_scan_back_xywh = {24,64,40,24},
};
	
w1_ptz_scan.s_1280 = 
{
	s_ptz_scan_t_xywh= {223,110,255,50},
	s_ptz_scan_scan_xywh= {45,10,160,35},
	s_ptz_scan_go_to_xywh= {45,50,160,35},
	s_ptz_scan_edit_xywh= {45,90,160,35},
	s_ptz_scan_delete_xywh= {130,90,75,35},
	s_ptz_scan_start_xywh = {130,90,75,35},
	s_ptz_scan_back_xywh= {45,90,75,35},	
}
w1_ptz_scan.s_1440 = 
{
	s_ptz_scan_t_xywh= {223,110,255,50},
	s_ptz_scan_scan_xywh= {45,10,160,35},
	s_ptz_scan_go_to_xywh= {45,50,160,35},
	s_ptz_scan_edit_xywh= {45,90,160,35},
	s_ptz_scan_delete_xywh= {130,90,75,35},
	s_ptz_scan_start_xywh = {130,90,75,35},
	s_ptz_scan_back_xywh= {45,90,75,35},	
}	
w1_ptz_scan.s_1080p = 
{
	s_ptz_scan_t_xywh= {223,110,255,50},
	s_ptz_scan_scan_xywh= {45,10,160,35},
	s_ptz_scan_go_to_xywh= {45,50,160,35},
	s_ptz_scan_edit_xywh= {45,90,160,35},
	s_ptz_scan_delete_xywh= {130,90,75,35},
	s_ptz_scan_start_xywh = {130,90,75,35},
	s_ptz_scan_back_xywh= {45,90,75,35},	
}

w1_ptz_scan.s_2k = 
{
	s_ptz_scan_t_xywh= {297,147,340,67},
	s_ptz_scan_scan_xywh= {60,13,213,47},
	s_ptz_scan_go_to_xywh= {60,67,213,47},
	s_ptz_scan_edit_xywh= {60,120,213,47},
	s_ptz_scan_delete_xywh= {173,120,100,47},
	s_ptz_scan_start_xywh = {173,120,100,47},
	s_ptz_scan_back_xywh= {60,120,100,47},
}

w1_ptz_scan.s_4k = 
{
	s_ptz_scan_t_xywh= {446,220,510,100},
	s_ptz_scan_scan_xywh= {90,20,320,70},
	s_ptz_scan_go_to_xywh= {90,100,320,70},
	s_ptz_scan_edit_xywh= {90,180,320,70},
	s_ptz_scan_delete_xywh= {260,180,150,70},
	s_ptz_scan_start_xywh = {260,180,150,70},
	s_ptz_scan_back_xywh= {90,180,150,70},
}
local ptz_info = {};
local scan_list = {};
local start_flag = 0;
local scan_list_num = 0; --ɨĿ
local scan_max_num =12; --ɨĿ
local refresh_hide = function (top, scan_num, bool_flag, redraw)
	local cwnd = w1_ptz_scan.wnd;
	if(bool_flag)then
		b_wnd_ex.set_hide(top, cwnd.scan.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.edit.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.delete.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.go_to.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.scan_edit.id, false, false)
		b_wnd_ex.set_hide(top, cwnd.start.id, false, false)
		b_wnd_ex.set_hide(top, cwnd.back.id, false, false)
	--	b_wnd_ex.set_hide(top, cwnd.save.id, false, false)
	else
		b_wnd_ex.set_hide(top, cwnd.scan.id, false, false)
		b_wnd_ex.set_hide(top, cwnd.edit.id, false, false)
		b_wnd_ex.set_hide(top, cwnd.delete.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.go_to.id, false, false)
		b_wnd_ex.set_hide(top, cwnd.scan_edit.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.start.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.back.id, true, false)
	--	b_wnd_ex.set_hide(top, cwnd.save.id, true, false)
	end
	
	--[[if(0 == scan_num)then
		b_wnd_ex.set_sel(top, cwnd.scan.id, 0, false )	
		b_wnd_ex.set_text(top, cwnd.scan.id, "", false )
		b_wnd_ex.set_disable(top, cwnd.scan.id, true, false)
	else
		if(nil ~= scan_list[1])then
			local id_str = tostring(scan_list[1])
			b_wnd_ex.set_text(top, cwnd.scan.id, id_str, false )
		else
			b_wnd_ex.set_text(top, cwnd.scan.id, "1", false )
		end
		b_wnd_ex.set_sel(top, cwnd.scan.id, 0, false )	
		b_wnd_ex.set_disable(top, cwnd.scan.id, false, false)
	end--]]
	b_dlg.dlg_set_redraw(top)
end
--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local cwnd = w1_ptz_scan.wnd;
	if(nil == scan_list )then
		scan_list = {};
	end
	b_wnd_ex.set_hide(top, cwnd.delete.id, true, false)
	local channel = math.floor(ptz_info.channel)
	local chn = "channel"..tostring(channel)

	scan_max_num = cfgdata['ptz_limits'][chn].scan_max_num
	if(scan_max_num > 0)then  --ɨĿ
		local list = {};
		for i = 1, scan_max_num do
			table.insert(list,i)
		end
		b_wnd_ex.set_items(top, cwnd.scan.id, list, false);
		b_wnd_ex.set_items(top, cwnd.scan_edit.id, list, false);
	else
		local list = {};
		b_wnd_ex.set_items(top, cwnd.scan.id, list, false);
		b_wnd_ex.set_items(top, cwnd.scan_edit.id, list, false);
	end	
--	b_wnd_ex.set_disable(top, cwnd.scan_edit.id, false, false);

	
	if( 0 < cfgdata['ptz_limits'][chn].scan_max_num)then
		b_wnd_ex.set_disable(top, cwnd.scan.id, false, false);
		b_wnd_ex.set_disable(top, cwnd.edit.id, false, false);	
	else
		b_wnd_ex.set_disable(top, cwnd.scan.id, true, false);
		b_wnd_ex.set_disable(top, cwnd.edit.id, true, false);
	end
	
	if(nil ~= cfgdata['ptz_scan'])then
		local flag = cfgdata['ptz_scan'][chn];
		if(flag == nil)then --쳣
			refresh_hide(top, 0, false, false)
			b_wnd_ex.set_disable(top, cwnd.go_to.id, true, false)
			b_wnd_ex.set_disable(top, cwnd.start.id, true, false)
			return 0;
		else
			b_wnd_ex.set_disable(top, cwnd.start.id, false, false)
		end
	else
		b_wnd_ex.set_disable(top, cwnd.go_to.id, true, false)
		return 0;
	end
	
	scan_list_num = cfgdata['ptz_scan'][chn].scan_num 	--ɨĿ
	--[[if(scan_max_num == scan_list_num)then
		b_wnd_ex.set_disable(top, cwnd.start.id, true, false)
	else
		b_wnd_ex.set_disable(top, cwnd.start.id, false, false)
	end--]]
	if(0 == scan_list_num)then
		b_wnd_ex.set_disable(top, cwnd.go_to.id, true, false)
		refresh_hide(top, 0,false, false)	
	else
		if(scan_list_num > 0)then
			scan_list = nil;
			scan_list = {};
			for i =1,scan_max_num do
				local scanlist = "scan_list"..tostring(i)
				if(nil ~= cfgdata['ptz_scan'][chn][scanlist])then
					local id = cfgdata['ptz_scan'][chn][scanlist].scan_id-- +1
					table.insert(scan_list,id);
				end
			end
		--	b_wnd_ex.set_items(top, cwnd.scan.id, scan_list, false);
			local scan_edit_list = {};
			for i =1, scan_max_num do --Ѳ  Ѳη  ȡ
				local sign = 0;			
				for j =1, #scan_list do
					if(scan_list[j] == i)then
						sign = 1;
					end
				end
				if(0 == sign)then
					table.insert(scan_edit_list,i);
				end
			end	
		--	b_wnd_ex.set_items(top, cwnd.scan_edit.id, scan_edit_list, false);
		end
		local scanid = tonumber(b_wnd_ex.get_text(top, cwnd.scan.id))
		local sign = 0;
		local num = #scan_list
		for i =1, num do
			if(scan_list[i] == scanid)then
				sign = 1;
			end
		end
		if(1 == sign)then
			b_wnd_ex.set_disable(top, cwnd.go_to.id, false, false)
		else
			b_wnd_ex.set_disable(top, cwnd.go_to.id, true, false)
		end 
		refresh_hide(top, scan_list_num,false, false)
	end
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

local on_scan  = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local cwnd = w1_ptz_scan.wnd
		if(0 == scan_list_num)then
			b_wnd_ex.set_disable(top, cwnd.go_to.id, true, true)
			return 0;
		end
		local scan_idx = b_wnd_ex.get_text(top, cwnd.scan.id)
		local scanid = tonumber(scan_idx);
		local num = #scan_list
		local sign = 0;
		for i =1, num do
			if(scan_list[i] == scanid)then
				sign = 1;
			end
		end
		if(1 == sign)then
			b_wnd_ex.set_disable(top, cwnd.go_to.id, false, false)
		else
			b_wnd_ex.set_disable(top, cwnd.go_to.id, true, false)
		end 
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_goto = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_ptz_scan.wnd
		if(0 == scan_list_num)then
			return 0;
		end
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		local scan_idx = b_wnd_ex.get_text(top, cwnd.scan.id)
		local scanid = tonumber(scan_idx)---1;
		ptz_info.index = scanid;
		ptz_info.action =19;
		ptz_info.mode = 8;
		b_app_api.set_ptz(ptz_info);
	end
	return 0
end

local on_edit = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_ptz_scan.wnd
		start_flag = 0;
		local font = 20;
		if(dlg_w == 1280 or dlg_h == 1024) then
			font = 20;
		elseif(dlg_w == 1440 or dlg_h == 900) then
			font = 18;
		elseif(dlg_w == 1920 or dlg_h == 1080) then
			font = 20;
		elseif(dlg_w == 2560 or dlg_h == 1440) then
			font = 27;
		elseif(dlg_w == 3840 or dlg_h == 2160) then
			font = 40;
		end
		local t_imgs = {b_ui.ALIGN.LEFT,font,61575,61575, 61575};
		b_wnd_ex.set_t_imgs(top, cwnd.start.id, t_imgs, false);
		local sel = b_wnd_ex.get_sel(top, cwnd.scan.id)
		b_wnd_ex.set_sel(top, cwnd.scan_edit.id, sel, false);
		refresh_hide(top, scan_list_num, true, false)	
	end
	return 0
end

local on_back  = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_ptz_scan.wnd
		start_flag = 0;
		local scan_idx = b_wnd_ex.get_text(top, cwnd.scan.id)
		local scanid = tonumber(scan_idx);
		local num = #scan_list
		local sign = 0;
		for i =1, num do
			if(scan_list[i] == scanid)then
				sign = 1;
			end
		end
		if(1 == sign)then
			b_wnd_ex.set_disable(top, cwnd.go_to.id, false, false)
		else
			b_wnd_ex.set_disable(top, cwnd.go_to.id, true, false)
		end 
		refresh_hide(top, scan_list_num, false, false)
	end
	return 0
end

local on_start = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--[[if(scan_list_num == scan_max_num)then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_NO_SCAN'), true, false,false);
			w1_msgbox.set_func(nil, nil, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
			return 0;	
		end--]]
		local cwnd = w1_ptz_scan.wnd
		local channel = math.floor(ptz_info.channel)
		local chn = "channel"..tostring(channel)
		local scan_idx = b_wnd_ex.get_text(top, cwnd.scan_edit.id)
		local scanlist ="scan_list"..scan_idx
		local scanid = tonumber(scan_idx)---1;
		local scanname = "scan"..scan_idx
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action  = 19;
		ptz_info.index = scanid;	
		ptz_info.name = scanname;
		
		local dlg_w, dlg_h = global_val.get_size();
		local font = 20;
		if(dlg_w == 1280 or dlg_h == 1024) then
			font = 20;
		elseif(dlg_w == 1440 or dlg_h == 900) then
			font = 18;
		elseif(dlg_w == 1920 or dlg_h == 1080) then
			font = 20;
		elseif(dlg_w == 2560 or dlg_h == 1440) then
			font = 27;
		elseif(dlg_w == 3840 or dlg_h == 2160) then
			font = 40;
		end
		
		if(start_flag == 0)then
			ptz_info.mode = 7; --ɾ ɨ
			b_app_api.set_ptz(ptz_info);
			
			start_flag = 1;
			local t_imgs = {b_ui.ALIGN.LEFT,font,61576,61576,61576};
			b_wnd_ex.set_t_imgs(top, win_id, t_imgs, false)
			
			ptz_info.mode = 10;	
			b_app_api.set_ptz(ptz_info);
			b_dlg.dlg_set_redraw(top)
--			b_wnd_ex.set_disable(top, cwnd.scan_edit.id, true, false);
		else
			start_flag = 0;
			local t_imgs = {b_ui.ALIGN.LEFT,font,61575,61575, 61575};
			b_wnd_ex.set_t_imgs(top, win_id, t_imgs, false)
			
			ptz_info.mode = 11;	
			b_app_api.set_ptz(ptz_info);
--			b_wnd_ex.set_disable(top, cwnd.scan_edit.id, false, false);
			
			
			local scan_idx = b_wnd_ex.get_text(top, cwnd.scan_edit.id)
			local scan_sel = b_wnd_ex.get_sel(top, cwnd.scan_edit.id)
		
			local cfg_tab = {'ptz_scan','ptz_limits'}
			local scan_cfg ={}
			scan_cfg = b_app_api.get_cfg(cfg_tab)
			cfgdatatoui(top, scan_cfg)
			
			b_wnd_ex.set_sel(top, cwnd.scan.id, scan_sel, false);
			local scanid = tonumber(scan_idx);
			local num = #scan_list
			local sign = 0;
			for i =1, num do
				if(scan_list[i] == scanid)then
					sign = 1;
				end
			end
			if(1 == sign)then
				b_wnd_ex.set_disable(top, cwnd.go_to.id, false, false)
			else
				b_wnd_ex.set_disable(top, cwnd.go_to.id, true, false)
			end 
			
			refresh_hide(top, scan_list_num, false, false)	
		end
	end
	return 0
end

local okfunc_delete = function(param)
	local cwnd = w1_ptz_scan.wnd
	local channel = math.floor(ptz_info.channel)
	local chn = "channel"..tostring(channel)
	local scan_idx = b_wnd_ex.get_text(param[1], cwnd.scan.id)
	local scanlist ="scan_list"..scan_idx
	local scanid = tonumber(scan_idx)---1;
	local speed = b_wnd_ex.get_text(param[1],w1_id.live_wnd.ptz_id+8);
	ptz_info.speed =tonumber(speed);
	ptz_info.action  = 19;
	ptz_info.index = scanid;	
	ptz_info.mode = 7; --ɾ ɨ
	b_app_api.set_ptz(ptz_info);
	
	local cfg_tab = {'ptz_scan','ptz_limits'}
	local scan_cfg ={}
	scan_cfg = b_app_api.get_cfg(cfg_tab)
	cfgdatatoui(param[1], scan_cfg)
	refresh_hide(param[1], scan_list_num, false, false)
	
	return 0;
end

local on_delete = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if(0 == tour_list_num)then
			return 0;
		end
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_SURE_DELETE_LINE'), true, true,false);
		w1_msgbox.set_func(okfunc_delete, {top}, nil, nil);
		b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);	
	end
	return 0;
end

w1_ptz_scan.pre_show = function(top)
	start_flag = 0;
	local cfg_tab = {'ptz_scan','ptz_limits'}
	local scan_cfg ={}
	scan_cfg = b_app_api.get_cfg(cfg_tab)
	cfgdatatoui(top, scan_cfg)
	
end

w1_ptz_scan.init = function (top,chn)
	local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
	ptz_info.speed =tonumber(speed);
	ptz_info.channel = chn;
	ptz_info.action  = 19;
	ptz_info.mode =8;--
	ptz_info.speed = speed;
	ptz_info.index =1;--Ԥλ
	ptz_info.time =0;
	ptz_info.name ="preset";
--[[	local scan_list ={};
	for i=1,255 do 
		table.insert(scan_list,tostring(i))
	end--]]
--	b_wnd_ex.set_items(top,w1_ptz_scan.wnd.scan.id,scan_list,false)

	return 0
end
w1_ptz_scan.updata =function (top, channel, page_id)
	ptz_info.channel =channel;
	if(3 == page_id)then
		start_flag = 0;
		local cfg_tab = {'ptz_scan','ptz_limits'}
		local scan_cfg ={}
		scan_cfg = b_app_api.get_cfg(cfg_tab)
		cfgdatatoui(top, scan_cfg)
	end
end

w1_ptz_scan.clear = function (top)
	scan_list = nil;
end
w1_ptz_scan.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_ptz_scan_t_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'scan','scan_edit','go_to','edit','delete','idx1','idx2','preset1','preset2','drop','back','save','start'},
	scan 	= {t='combox',id=id+2,xywh='s_ptz_scan_scan_xywh',items={'1','2','3','4'},item_dispnum =4,trans = false,cmd = on_scan},
	scan_edit 	= {t='combox',id=id+3,xywh='s_ptz_scan_scan_xywh',items={'1','2','3','4'},item_dispnum =4,trans = false},		
	go_to = {t='button',id=id+4,xywh='s_ptz_scan_go_to_xywh',text = 'LA_GO_TO',align = b_ui.ALIGN.CENTER,cmd=on_goto,
			};	
	edit = {t='button',id=id+5,xywh='s_ptz_scan_edit_xywh',text = 'LA_EDIT',align = b_ui.ALIGN.CENTER,cmd=on_edit,
			};
	delete = {t='button',id=id+6,xywh='s_ptz_scan_delete_xywh',text = 'LA_DELETE',align = b_ui.ALIGN.CENTER,cmd=on_delete,
			};	
			
	start = {t='tt_button',id=id+7,xywh='s_ptz_scan_start_xywh', cmd=on_start,
		
				t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_ptz_start','it_ptz_start', 'it_ptz_start'},
				};	

	back = {t='tt_button',id=id+8,xywh='s_ptz_scan_back_xywh',align = b_ui.ALIGN.CENTER,
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_ptz_back','it_ptz_back', 'it_ptz_back'},
			cmd=on_back,};
	--[[back = {t='button',id=id+8,xywh='s_ptz_scan_back_xywh',text = 'LA_BACK',align = b_ui.ALIGN.CENTER,cmd=on_back,
			};--]]	
	
}

return w1_ptz_scan
