--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/4/26
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.live_wnd.ptz_set_id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local b_app_api = require("wnd.core.command.b_app_api")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 	= r_size.get_size
local w1_ptz_set = {
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}	

w1_ptz_set.s_768 =
{
	s_ptz_set_t_xywh = {2,59,90,120},
	s_ptz_set_up_xywh = {37,7,17,34},
	s_ptz_set_right_up_xywh = {52,19,25,34},
	s_ptz_set_right_xywh = {61,49,25,22},
	s_ptz_set_right_down_xywh = {52,68,25,34},
	s_ptz_set_center_xywh = {37,49,17,22},
	s_ptz_set_down_xywh = {37,78,17,34},
	s_ptz_set_left_down_xywh = {14,68,25,34},
	s_ptz_set_left_xywh = {5,49,25,22},
	s_ptz_set_left_up_xywh = {14,19,25,34},
};

w1_ptz_set.s_1280 = 
{
	s_ptz_set_t_xywh= {5,84,170,170},
	s_ptz_set_up_xywh= {70,10,32,48},
	s_ptz_set_right_up_xywh= {98,27,48,48},
	s_ptz_set_right_xywh= {115,70,48,32},
	s_ptz_set_right_down_xywh= {98,97,48,48},
	s_ptz_set_center_xywh= {70,70,32,32},
	s_ptz_set_down_xywh= {70,110,32,48},
	s_ptz_set_left_down_xywh= {27,97,48,48},
	s_ptz_set_left_xywh= {10,70,48,32},
	s_ptz_set_left_up_xywh= {27,27,48,48},
}

w1_ptz_set.s_1440 = 
{
	s_ptz_set_t_xywh= {5,84,170,170},
	s_ptz_set_up_xywh= {70,10,32,48},
	s_ptz_set_right_up_xywh= {98,27,48,48},
	s_ptz_set_right_xywh= {115,70,48,32},
	s_ptz_set_right_down_xywh= {98,97,48,48},
	s_ptz_set_center_xywh= {70,70,32,32},
	s_ptz_set_down_xywh= {70,110,32,48},
	s_ptz_set_left_down_xywh= {27,97,48,48},
	s_ptz_set_left_xywh= {10,70,48,32},
	s_ptz_set_left_up_xywh= {27,27,48,48},
}

	
w1_ptz_set.s_1080p = 
{
	s_ptz_set_t_xywh= {5,84,170,170},
	s_ptz_set_up_xywh= {70,10,32,48},
	s_ptz_set_right_up_xywh= {98,27,48,48},
	s_ptz_set_right_xywh= {115,70,48,32},
	s_ptz_set_right_down_xywh= {98,97,48,48},
	s_ptz_set_center_xywh= {70,70,32,32},
	s_ptz_set_down_xywh= {70,110,32,48},
	s_ptz_set_left_down_xywh= {27,97,48,48},
	s_ptz_set_left_xywh= {10,70,48,32},
	s_ptz_set_left_up_xywh= {27,27,48,48},
}

w1_ptz_set.s_2k = 
{
	s_ptz_set_t_xywh = {6,111,226,226},
	s_ptz_set_up_xywh = {93,13,42,63},
	s_ptz_set_right_up_xywh = {130,35,63,63},
	s_ptz_set_right_xywh = {153,93,63,42},
	s_ptz_set_right_down_xywh = {130,129,63,63},
	s_ptz_set_center_xywh = {93,93,42,42},
	s_ptz_set_down_xywh = {93,146,42,63},
	s_ptz_set_left_down_xywh = {35,129,63,63},
	s_ptz_set_left_xywh = {13,93,63,42},
	s_ptz_set_left_up_xywh = {35,35,63,63},
}

w1_ptz_set.s_4k = 
{
	s_ptz_set_t_xywh = {10,168,340,340},
	s_ptz_set_up_xywh = {140,20,64,96},
	s_ptz_set_right_up_xywh = {196,54,96,96},
	s_ptz_set_right_xywh = {230,140,96,64},
	s_ptz_set_right_down_xywh = {196,194,96,96},
	s_ptz_set_center_xywh = {140,140,64,64},
	s_ptz_set_down_xywh = {140,220,64,96},
	s_ptz_set_left_down_xywh = {54,194,96,96},
	s_ptz_set_left_xywh = {20,140,96,64},
	s_ptz_set_left_up_xywh = {54,54,96,96},
}
local ptz_info = {};
local flag = false;
local on_right_up = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		flag = true
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =5;
		b_app_api.set_ptz(ptz_info);
	end

	if b_ui.LBUTTONDBLCLK == vmsg then
		flag = false
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end

	if b_ui.LOST_FOCUS == vmsg then
		if flag == true then
			flag = false
			local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
			ptz_info.speed =tonumber(speed);
			ptz_info.action =1;
			b_app_api.set_ptz(ptz_info);		
		end
	end	
	
	if b_ui.LBUTTONCLK == vmsg then
		flag = false
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end
	return 0
end

local on_up = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		flag = true
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =4;
		b_app_api.set_ptz(ptz_info);
	end

	if b_ui.LBUTTONDBLCLK == vmsg then
		flag = false
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end

	if b_ui.LOST_FOCUS == vmsg then
		if flag == true then
			flag = false
			local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
			ptz_info.speed =tonumber(speed);
			ptz_info.action =1;
			b_app_api.set_ptz(ptz_info);
		end
	end	
	
	if b_ui.LBUTTONCLK == vmsg then
		flag = false
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end
	return 0
end
local on_right = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		flag = true
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =6;
		b_app_api.set_ptz(ptz_info);
	end

	if b_ui.LBUTTONDBLCLK == vmsg then
		flag = false
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end

	if b_ui.LOST_FOCUS == vmsg then
		if flag == true then
			flag = false
			local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
			ptz_info.speed =tonumber(speed);
			ptz_info.action =1;
			b_app_api.set_ptz(ptz_info);
		end
	end	
	
	if b_ui.LBUTTONCLK == vmsg then
		flag = false
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end
	return 0
end

local on_right_down = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		flag = true
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =7;
		b_app_api.set_ptz(ptz_info);
	end

	if b_ui.LBUTTONDBLCLK == vmsg then
		flag = false
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end

	if b_ui.LOST_FOCUS == vmsg then
		if flag == true then
			flag = false		
			local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
			ptz_info.speed =tonumber(speed);
			ptz_info.action =1;
			b_app_api.set_ptz(ptz_info);
		end
	end	
	
	if b_ui.LBUTTONCLK == vmsg then
		flag = false
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end
	return 0
end
local on_down = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		flag = true
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =8;
		b_app_api.set_ptz(ptz_info);
	end

	if b_ui.LBUTTONDBLCLK == vmsg then
		flag = false
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end

	if b_ui.LOST_FOCUS == vmsg then
		if flag == true then
			flag = false		
			local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
			ptz_info.speed =tonumber(speed);
			ptz_info.action =1;
			b_app_api.set_ptz(ptz_info);
		end
	end		
	
	if b_ui.LBUTTONCLK == vmsg then
		flag = false
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end
	return 0
end

local on_left_down = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		flag = true
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =9;
		b_app_api.set_ptz(ptz_info);
	end

	if b_ui.LBUTTONDBLCLK == vmsg then
		flag = false
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end

	if b_ui.LOST_FOCUS == vmsg then
		if flag == true then
			flag = false		
			local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
			ptz_info.speed =tonumber(speed);
			ptz_info.action =1;
			b_app_api.set_ptz(ptz_info);
		end
	end	
	
	if b_ui.LBUTTONCLK == vmsg then
		flag = false
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end
	return 0
end

local on_left_up = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		flag = true
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =3;
		b_app_api.set_ptz(ptz_info);
	end

	if b_ui.LBUTTONDBLCLK == vmsg then
		flag = false
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end

	if b_ui.LOST_FOCUS == vmsg then
		if flag == true then
			flag = false		
			local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
			ptz_info.speed =tonumber(speed);
			ptz_info.action =1;
			b_app_api.set_ptz(ptz_info);
		end
	end	
	
	if b_ui.LBUTTONCLK == vmsg then
		flag = false
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end
	return 0
end

local on_left = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		flag = true
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =2;
		b_app_api.set_ptz(ptz_info);
	end

	if b_ui.LBUTTONDBLCLK == vmsg then
		flag = false
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end

	if b_ui.LOST_FOCUS == vmsg then
		if flag == true then
			flag = false		
			local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
			ptz_info.speed =tonumber(speed);
			ptz_info.action =1;
			b_app_api.set_ptz(ptz_info);
		end
	end	
	
	if b_ui.LBUTTONCLK == vmsg then
		flag = false
		local speed = b_wnd_ex.get_text(top,w1_id.live_wnd.ptz_id+8);
		ptz_info.speed =tonumber(speed);
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end
	return 0
end

w1_ptz_set.init = function(chn)
	ptz_info.channel = chn;
	ptz_info.action  =0;
	ptz_info.mode =3;--
	ptz_info.speed = 6;
	ptz_info.index =1;--Ԥλ
	ptz_info.time =0;
	
	return 0
end

w1_ptz_set.updata = function(channel)
	ptz_info.channel = channel
end

local on_center = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONDOWN == vmsg then
		flag = true
		ptz_info.speed = 0;
		ptz_info.action =20;
		b_app_api.set_ptz(ptz_info);
	end

	if b_ui.LBUTTONDBLCLK == vmsg then
		flag = false
		ptz_info.speed = 0;
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end

	if b_ui.LOST_FOCUS == vmsg then
		if flag == true then
			flag = false
			ptz_info.speed = 0;
			ptz_info.action =1;
			b_app_api.set_ptz(ptz_info);
		end
	end	
	
	if b_ui.LBUTTONCLK == vmsg then
		flag = false
		ptz_info.speed = 0;
		ptz_info.action =1;
		b_app_api.set_ptz(ptz_info);
	end	

	return 0
end

w1_ptz_set.wnd = 
{
	t		='wnd_bg',id=id,xywh = 's_ptz_set_t_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'up','right_up','right','right_down','down','left_down','left','left_up','center'},

	up ={t='tt_button',id=id+3,xywh='s_ptz_set_up_xywh',align = b_ui.ALIGN.CENTER,cmd=on_up,color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},
			color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_ptz_up','it_ptz_left_up_f', 'it_ptz_up'}},
	right_up ={t='tt_button',id=id+4,xywh='s_ptz_set_right_up_xywh',align = b_ui.ALIGN.CENTER,cmd=on_right_up,color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},
			color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_ptz_right_up','it_ptz_right_up_f', 'it_ptz_right_up'}},
	right ={t='tt_button',id=id+5,xywh='s_ptz_set_right_xywh',align = b_ui.ALIGN.CENTER,cmd=on_right,color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},
			color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_ptz_right','it_ptz_right_f', 'it_ptz_right'}},
	
	right_down ={t='tt_button',id=id+6,xywh='s_ptz_set_right_down_xywh',align = b_ui.ALIGN.CENTER,cmd=on_right_down,color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},
			color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_ptz_right_down','it_ptz_right_down_f', 'it_ptz_right_down'}},
	
	center ={t='tt_button',id=id+2,xywh='s_ptz_set_center_xywh',align = b_ui.ALIGN.CENTER,cmd=on_center,color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},
			color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},	
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_ptz_center','it_ptz_center_f', 'it_ptz_center'}},
							
	down ={t='tt_button',id=id+7,xywh='s_ptz_set_down_xywh',align = b_ui.ALIGN.CENTER,cmd=on_down,color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},
			color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_ptz_down','it_ptz_down_f', 'it_ptz_down'}},
			
	left_down ={t='tt_button',id=id+8,xywh='s_ptz_set_left_down_xywh',align = b_ui.ALIGN.CENTER,cmd=on_left_down,color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},
			color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_ptz_left_down','it_ptz_left_down_f', 'it_ptz_left_down'}},

	left ={t='tt_button',id=id+9,xywh='s_ptz_set_left_xywh',align = b_ui.ALIGN.CENTER,cmd=on_left,color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},
			color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_ptz_left','it_ptz_left_f', 'it_ptz_left'}},

	left_up ={t='tt_button',id=id+10,xywh='s_ptz_set_left_up_xywh',align = b_ui.ALIGN.CENTER,cmd=on_left_up,color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},
			color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
			t_imgs = {b_ui.ALIGN.LEFT,'f_grade7','it_ptz_left_up','it_ptz_left_up_f', 'it_ptz_left_up'}},
}

return w1_ptz_set
