-- UIʹõȷȡԻ
local b_ui 		= require("wnd.core.b_ui")
local b_app_api = require("wnd.core.command.b_app_api")
local b_app_cfg	= require("wnd.core.b_app_cfg")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.resolution_id;
local cjson 	= require("cjson")
local w1_ui_facade	= require("wnd.w1_facade.w1_ui_facade")

local CANCEL_TIME;

local w1_resolution = {
	t = w1_key.DLG_MSG_RESOLUTION,
	top = nil,
	dlg = nil,
	old_resolution,
	cur_resolution,
	devicedata = {},
}

local on_ok = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_resolution.devicedata.device.vo = w1_resolution.cur_resolution;
		local device_cfg ={}
		device_cfg.device = w1_resolution.devicedata.device
		b_app_cfg.savechangecfg(device_cfg);
		b_app_cfg.saveSuccessful();
		b_dlg.end_modal(top);
	end
	return 0;
end

local on_cancel = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local param = {};
		param.old_resolution = w1_resolution.old_resolution;
		param.cur_resolution = w1_resolution.old_resolution;
		
		w1_ui_facade.load_layout(param.cur_resolution, 'w1', 'f_normat');
		b_app_api.channge_resolution(param);
		b_dlg.end_modal(top);
		return b_ui.WM_USER_CHANGE_RESOLUTION;
	end
	return 0;
end

local on_dlg = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		return 0;
	end
	if b_ui.TIMER == vmsg then
		CANCEL_TIME = CANCEL_TIME - 1;
		if("hebrew" ~= w1_resolution.devicedata.device.language and "arabic" ~= w1_resolution.devicedata.device.language)then
			local cancelstr = STR('LA_CANCEL')..' ('..math.floor(CANCEL_TIME/1)..')';
			b_wnd_ex.set_text(top, w1_resolution.dlg.cancel.id, cancelstr, true);
		else
			local cancelstr = STR('LA_CANCEL')..')'..math.floor(CANCEL_TIME/1)..'( ';
			b_wnd_ex.set_text(top, w1_resolution.dlg.cancel.id, cancelstr, true);
		end
		if(CANCEL_TIME == 0) then
			local param = {};
			param.old_resolution = w1_resolution.old_resolution;
			param.cur_resolution = w1_resolution.old_resolution;
			
			w1_ui_facade.load_layout(param.cur_resolution, 'w1', 'f_normat');
			b_app_api.channge_resolution(param);
			b_dlg.end_modal(top);
			return b_ui.WM_USER_CHANGE_RESOLUTION;
		end
	end
	if (b_ui.WM_USER_CHANGE_RESOLUTION == vmsg ) then
		return vmsg;
	end
	return 0;
end

local dlg = {
	attr 	= {xywh='s_msgbox_xywh',cmd=on_dlg,timer={-1, 1000}},
	sub 	= {--[['title',--]] 'msg', --[['hline',--]]'ok', 'cancel'},
	
--[[	title 	= {t='static',	id=id+1,	xywh='s_msgbox_title_xywh',	
			text='LA_TIP',align = b_ui.ALIGN.CENTER, font = 'f_grade5',
			color = {'c_popdlg_title_bk', 'c_popdlg_title_bk', 'c_popdlg_text'}},--]]
	
	msg	 	= {t='static',	id=id+2,	xywh='s_msgbox_msg_xywh',	
			text='LA_CHG_DISPLAY',align = b_ui.ALIGN.LEFT, font = 'f_grade4',
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_text'}},
			
	hline	= {t='hline',	id=id+3,	xywh='s_msgbox_hline_xywh'},
			color = {'c_popdlg_bk', 'c_popdlg_bk', 'c_popdlg_hline'},
	
	ok		= {t='button',	id=id+4,	xywh='s_msgbox_ok_xywh',	text='LA_OK',font='f_grade6',	
				color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
				cmd=on_ok},
	cancel	= {t='button',	id=id+5,	xywh='s_msgbox_cancel_xywh',text='LA_CANCEL',font='f_grade6',
				color= { 'c_popdlg_cancel_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_cancel_bk_f', 'c_popdlg_ok_bk_f','c_popdlg_ok_text_f'},
				cmd=on_cancel},		
}

w1_resolution.on_create = function(top)
	CANCEL_TIME = 30;
		--رhomeڶʱ
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_pause);
	
	w1_resolution.top = top;
	w1_resolution.dlg = dlg;
	b_parser(top, w1_resolution.dlg);
	b_wnd_ex.set_text(top, w1_resolution.dlg.cancel.id, STR('LA_CANCEL')..' (30)', false);
	
	b_app_cfg.init({'device'});
	w1_resolution.devicedata = b_app_cfg.origin_cfg;
	return 0;
end

w1_resolution.on_destroy = function(top)
	w1_resolution.top = nil;
	w1_resolution.dlg = nil;
	w1_resolution.devicedata = nil;
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk);
	return 0;
end

w1_resolution.on_pre_show = function(top)
	local param = b_wnd.get_wnd_data(top);	
	if(param ~= nil)then
		local paramdata = cjson.decode(param);
		if(paramdata) then
			w1_resolution.old_resolution = paramdata.old_resolution;
			w1_resolution.cur_resolution = paramdata.cur_resolution;
		end
	end
	return 0;
end

w1_resolution.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top);
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_popdlg_bk'));
--	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_popdlg_border_h'),1);
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top);
	return 0;
end

w1_resolution.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.WM_USER_CHANGE_RESOLUTION == vmsg ) then
		return vmsg;
	end
	return 0;
end

return w1_resolution;

