--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/4/26
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.live_wnd.ptz_row_id2
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 	= r_size.get_size
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local b_dlg 	= require("wnd.core.b_dlg")
local w1_ptz_scan			= require("wnd.w1_live.w1_ptz_scan");
local w1_ptz_cruise 		= require("wnd.w1_live.w1_ptz_cruise");	
local w1_ptz_preset 		= require("wnd.w1_live.w1_ptz_preset");	
local w1_row_ptz_preset = {
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}	

w1_row_ptz_preset.s_768 =
{
	s_row_ptz_preset_t_xywh = {97,39,178,28},
	s_row_ptz_preset_pre_xywh = {5,3,10,28},
	s_row_ptz_preset_advance_preaet_xywh = {16,3,146,28},
	s_row_ptz_preset_next_xywh = {162,3,10,28},
};
	
w1_row_ptz_preset.s_1280 = 
{
	s_row_ptz_preset_t_xywh= {183,55,335,40},
	s_row_ptz_preset_pre_xywh= {10,5,20,40},
	s_row_ptz_preset_advance_preaet_xywh= {30,5,275,40},
	s_row_ptz_preset_next_xywh= {305,5,20,40},
}
w1_row_ptz_preset.s_1440 = 
{
	s_row_ptz_preset_t_xywh= {183,55,335,40},
	s_row_ptz_preset_pre_xywh= {10,5,20,40},
	s_row_ptz_preset_advance_preaet_xywh= {30,5,275,40},
	s_row_ptz_preset_next_xywh= {305,5,20,40},
}
w1_row_ptz_preset.s_1080p = 
{
	s_row_ptz_preset_t_xywh= {183,55,335,40},
	s_row_ptz_preset_pre_xywh= {10,5,20,40},
	s_row_ptz_preset_advance_preaet_xywh= {30,5,275,40},
	s_row_ptz_preset_next_xywh= {305,5,20,40},
}

w1_row_ptz_preset.s_2k = 
{
	s_row_ptz_preset_t_xywh = {243,73,446,53},
	s_row_ptz_preset_pre_xywh = {13,6,26,53},
	s_row_ptz_preset_advance_preaet_xywh = {39,6,366,53},
	s_row_ptz_preset_next_xywh = {406,6,26,53},
}

w1_row_ptz_preset.s_4k = 
{
	s_row_ptz_preset_t_xywh = {366,110,670,80},
	s_row_ptz_preset_pre_xywh = {20,10,40,80},
	s_row_ptz_preset_advance_preaet_xywh = {60,10,550,80},
	s_row_ptz_preset_next_xywh = {610,10,40,80},
}

local advanced_preset_flag = 1;

w1_row_ptz_preset.changecheck = function(top, wnd, id)
	for k,v in pairs( wnd.sub ) do
		if(wnd[v].t == 'checkbutton') then
			b_wnd_ex.set_check(top, wnd[v].id, false, false)
		end
	end
	b_wnd_ex.set_check(top, id, true, false);
	local wnd_id = w1_row_ptz_preset.wnd
	
	if(id == wnd_id.ptz.id) then
		b_wnd_ex.set_show_page(top, w1_id.live_wnd.conItem_id, w1_id.live_wnd.ptz_set_id, false)
	end
	b_dlg.dlg_set_redraw(top)
end

local on_prev = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if(2 == advanced_preset_flag)then
			advanced_preset_flag = 1;
			b_wnd_ex.set_text(top,w1_row_ptz_preset.wnd.advance_preaet.id,STR('LA_ADVANCED'),false);
			b_wnd_ex.set_show_page(top, w1_id.live_wnd.conItem_id2, w1_id.live_wnd.ptz_advanced_id, false)
		elseif(3 == advanced_preset_flag)then--ǰĬʾadvanced
			w1_ptz_scan.clear(top);
			advanced_preset_flag =2;
			b_wnd_ex.set_text(top,w1_row_ptz_preset.wnd.advance_preaet.id,STR('LA_PRESET'),false);
			b_wnd_ex.set_show_page(top, w1_id.live_wnd.conItem_id2, w1_id.live_wnd.ptz_preset_id, false)	
			w1_ptz_preset.pre_show(top);
		elseif(4 == advanced_preset_flag)then
			w1_ptz_cruise.clear(top);
			advanced_preset_flag = 3;
			b_wnd_ex.set_text(top,w1_row_ptz_preset.wnd.advance_preaet.id,STR('LA_SCAN'),false);
			b_wnd_ex.set_show_page(top, w1_id.live_wnd.conItem_id2, w1_id.live_wnd.ptz_scan_id, false)
			w1_ptz_scan.pre_show(top);	
		elseif(1 == advanced_preset_flag)then
			advanced_preset_flag = 4;
			b_wnd_ex.set_text(top,w1_row_ptz_preset.wnd.advance_preaet.id,STR('LA_TOUR'),false);
			b_wnd_ex.set_show_page(top, w1_id.live_wnd.conItem_id2, w1_id.live_wnd.ptz_cruise_id, false)	
			w1_ptz_cruise.pre_show(top);			
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

local on_next = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if(4 == advanced_preset_flag)then--ǰĬʾadvanced
			w1_ptz_cruise.clear(top);
			advanced_preset_flag = 1;
			b_wnd_ex.set_text(top,w1_row_ptz_preset.wnd.advance_preaet.id,STR('LA_ADVANCED'),false);
			b_wnd_ex.set_show_page(top, w1_id.live_wnd.conItem_id2, w1_id.live_wnd.ptz_advanced_id, false)
		elseif(1 == advanced_preset_flag)then
			advanced_preset_flag =2;
			b_wnd_ex.set_text(top,w1_row_ptz_preset.wnd.advance_preaet.id,STR('LA_PRESET'),false);
			b_wnd_ex.set_show_page(top, w1_id.live_wnd.conItem_id2, w1_id.live_wnd.ptz_preset_id, false)	
			w1_ptz_preset.pre_show(top);
		elseif(2 == advanced_preset_flag)then
			advanced_preset_flag = 3;
			b_wnd_ex.set_text(top,w1_row_ptz_preset.wnd.advance_preaet.id,STR('LA_SCAN'),false);
			b_wnd_ex.set_show_page(top, w1_id.live_wnd.conItem_id2, w1_id.live_wnd.ptz_scan_id, false)
			w1_ptz_scan.pre_show(top);	
		elseif(3 == advanced_preset_flag)then
			w1_ptz_scan.clear(top);
			advanced_preset_flag = 4;
			b_wnd_ex.set_text(top,w1_row_ptz_preset.wnd.advance_preaet.id,STR('LA_TOUR'),false);
			b_wnd_ex.set_show_page(top, w1_id.live_wnd.conItem_id2, w1_id.live_wnd.ptz_cruise_id, false)	
			w1_ptz_cruise.pre_show(top);
		end
		b_dlg.dlg_set_redraw(top);
	end
	return 0
end

w1_row_ptz_preset.get_page = function (top)
	if(nil ~= advanced_preset_flag)then
		return advanced_preset_flag	
	end
	return 0;
end

w1_row_ptz_preset.set_flag =function(top, win_id, vmsg, x, y)
	advanced_preset_flag = 1;
end

w1_row_ptz_preset.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_row_ptz_preset_t_xywh',
	color_d	= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'}, 
	sub 	= {'pre','advance_preaet','next'},
	pre 	= {t='tt_button',id=id+1,xywh='s_row_ptz_preset_pre_xywh', cmd=on_prev,
				color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_pre','it_pre_f', 'it_pre'}};
	advance_preaet = {t='button',id=id+2,xywh='s_row_ptz_preset_advance_preaet_xywh',text='LA_ADVANCED',align = b_ui.ALIGN.CENTER,font = 'f_grade3',
				color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_f'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_f'},};
	next 	= {t='tt_button',	id=id+3,	xywh='s_row_ptz_preset_next_xywh', cmd = on_next,
				color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_next','it_next_f', 'it_next'}};
}

return w1_row_ptz_preset
