-- ػ
local b_ui 		= require("wnd.core.b_ui")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_dlg 	= require("wnd.core.b_dlg")
local b_wnd 	= require("wnd.core.b_wnd")
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local b_parser 	= require("wnd.core.b_parser")
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.start_up.shutdown_id
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local cjson 	= require("cjson")
local w1_msgbox_cfunc 	= require("wnd.w1_util.w1_msgbox_cfunc")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local global_val	= require("wnd.global_val")

local w1_shut_down = {
	t = w1_key.DLG_SHUT_DOWN,
	top = nil,
	dlg = nil,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}	

w1_shut_down.s_768 =
{
	s_shut_down_xywh = {132,586,126,154},
	s_shut_down_shutdown_xywh = {2,2,122,50},
	s_shut_down_reboot_xywh = {2,52,122,50},
	s_shut_down_logout_xywh = {2,102,122,50},
};

w1_shut_down.s_1280 = 
{
	s_shut_down_xywh= {246,768,236,216},
	s_shut_down_shutdown_xywh= {3,3,230,70},
	s_shut_down_reboot_xywh= {3,73,230,70},
	s_shut_down_logout_xywh= {3,143,230,70},
};

w1_shut_down.s_1440 = 
{
	s_shut_down_xywh= {246,644,236,216},
	s_shut_down_shutdown_xywh= {3,3,230,70},
	s_shut_down_reboot_xywh= {3,73,230,70},
	s_shut_down_logout_xywh= {3,143,230,70},
};

w1_shut_down.s_1080p = 
{
	s_shut_down_xywh= {246,824,236,216},
	s_shut_down_shutdown_xywh= {3,3,230,70},
	s_shut_down_reboot_xywh= {3,73,230,70},
	s_shut_down_logout_xywh= {3,143,230,70},
};  

w1_shut_down.s_2k = 
{   
	s_shut_down_xywh= {328,1098,315,288},
	s_shut_down_shutdown_xywh= {4,4,307,93},
	s_shut_down_reboot_xywh= {4,97,307,93},
	s_shut_down_logout_xywh= {4,191,307,93},
};  

w1_shut_down.s_4k = 
{   	
	s_shut_down_xywh= {493,1648,472,432},
	s_shut_down_shutdown_xywh= {6,6,460,140},
	s_shut_down_reboot_xywh= {6,146,460,140},
	s_shut_down_logout_xywh = {6,286,460,140},
};


local on_shutdown = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		--b_app_api.shutdown();
		b_dlg.end_modal(top);
		return b_ui_msg.msg_on_shutdown_device;
	end
	
	return 0;
end

local on_reboot = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		--b_app_api.reboot();	
		b_dlg.end_modal(top);
		return b_ui_msg.msg_on_reboot_device;
	end
	
	return 0;
end

local on_exit = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local user_info = global_val.get_current_user_info();
		assert(user_info ~= nil and "table" == type(user_info))
		local enable_auto_login = b_app_api.get_auto_login(user_info.m_strUsername)
		if (0 ~= enable_auto_login) then
			return b_ui_msg.msg_on_shutdown_hide;
		else		
			--b_app_api.exit_system();
			return b_ui_msg.msg_on_exit_system;
		end	
	end
	
	return 0;
end

local dlg = {
	attr = {xywh='s_shut_down_xywh'},
	sub = {'shutdown', 'reboot', 'logout'},
	shutdown 	= {t='tt_button',id=id+1,xywh='s_shut_down_shutdown_xywh',text='LA_POWER', align = b_ui.ALIGN.LEFT, cmd=on_shutdown,
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_dev_shutdown','it_dev_shutdown', 'it_dev_shutdown'},
				},
	reboot 	= {t='tt_button',id=id+2,xywh='s_shut_down_reboot_xywh',text='LA_RESTART', align = b_ui.ALIGN.LEFT,cmd=on_reboot, 
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_dev_reboot','it_dev_reboot', 'it_dev_reboot'},
				},
	logout = {t='tt_button',id=id+3,xywh='s_shut_down_logout_xywh',text='LA_EXIT_SYSTEM', align = b_ui.ALIGN.LEFT,cmd=on_exit, 
				color= { 'c_btn_n', 'c_btn_n', 'c_btn_text_n'},
				color_f= {'c_btn_f', 'c_btn_f', 'c_btn_text_f'},
				t_imgs = {b_ui.ALIGN.LEFT,'f_menu','it_dev_exitsystem','it_dev_exitsystem', 'it_dev_exitsystem'},
				},
}
	
w1_shut_down.on_create = function(top, wnd_id)
	w1_shut_down.top = top
	w1_shut_down.dlg = dlg
	b_parser(top, w1_shut_down.dlg)
	
	--رֳʱ
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)	
	
	return 0
end

w1_shut_down.on_destroy = function(top)
	w1_shut_down.top = nil
	w1_shut_down.dlg = nil

	--ֳʱ
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)	
	return 0
end

w1_shut_down.on_pre_show = function(top)
	local cwnd = w1_shut_down.dlg;
	local privilege = global_val.get_allprivilege();--ȡȨ

	if (false == privilege.system_maintenance) then
		b_wnd_ex.set_disable(top, cwnd.reboot.id, true, false);		
		b_wnd_ex.set_disable(top, cwnd.shutdown.id, true, false);
	else
		b_wnd_ex.set_disable(top, cwnd.reboot.id, false, false);
		b_wnd_ex.set_disable(top, cwnd.shutdown.id, false, false);
	end
	
	return 0;
end


w1_shut_down.on_paint = function(top, status, x, y, cx, cy)
	local wndsize1 = SIZE('s_shut_down_draw_xywh');
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_page_bk'))
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top)
	
	return 0
end

w1_shut_down.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg or b_ui.RBUTTONCLK == vmsg) then
		local size = SIZE(w1_shut_down.dlg.attr.xywh);
		if(x >= size[1] and x <= (size[1] + size[3]) and y >= size[2] and y <= (size[2] + size[4]) ) then
			
		else
			b_dlg.end_modal(top);
		end
	elseif (b_ui_msg.msg_on_shutdown_hide == vmsg) then
		return vmsg
	elseif (b_ui_msg.msg_on_shutdown_hide_start == vmsg) then
		b_dlg.dlg_set_hide(top, 1, 0);
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_CLOSE_AUTO'), true, false,false);
		w1_msgbox.set_func(nil,nil, nil, nil);
		b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)	
		b_dlg.end_modal(top);
	elseif(b_ui_msg.msg_on_shutdown_device == vmsg or b_ui_msg.msg_on_reboot_device == vmsg or b_ui_msg.msg_on_exit_system == vmsg) then
		return vmsg;
	end
	
	return 0
end

return w1_shut_down


