local global_val= require("wnd.global_val")
local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.toolbar.split1_id
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_app_api = require("wnd.core.command.b_app_api");
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size

local w1_split1 = {
	t = w1_key.DLG_SPLIT1,
	top = nil,
	dlg = nil,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}	
	
w1_split1.s_1280 = 
{
	s_split1_4_page_xywh = {90,924,343,60},
	s_split1_6_page_xywh = {90,924,267,60},
	s_split1_8_page_xywh = {90,924,347,60},
	s_split1_16_page_xywh = {90,884,347,101},
	s_split1_24_page_xywh = {90,844,340,141},
	s_split1_32_page_xywh = {90,804,340,181},
	s_split1_64_page_xywh = {90,644,340,341},
	s_split1_128_page_xywh = {90,324,340,661},
	s_split1_4_btn_xywh = {70,10,80,40},
	s_split1_8_btn_xywh = {10,10,40,40},
	s_split1_16_btn_xywh = {10,10,40,40},
	s_split1_32_btn_xywh = {10,10,40,40},
	s_split1_64_btn_xywh = {10,10,40,40},
	s_split1_128_btn_xywh = {10,10,40,40},
	s_split1_interval_xywh = {10,10,80,40},
}
w1_split1.s_1440 = 
{
	s_split1_4_page_xywh = {90,800,343,60},
	s_split1_6_page_xywh = {90,800,267,60},
	s_split1_8_page_xywh = {90,800,347,60},
	s_split1_16_page_xywh = {90,760,347,101},
	s_split1_24_page_xywh = {90,724,340,141},
	s_split1_32_page_xywh = {90,680,340,181},
	s_split1_64_page_xywh = {90,520,340,341},
	s_split1_128_page_xywh = {90,200,340,661},	
	s_split1_4_btn_xywh = {70,10,80,40},
	s_split1_8_btn_xywh = {10,10,40,40},
	s_split1_16_btn_xywh = {10,10,40,40},
	s_split1_32_btn_xywh = {10,10,40,40},
	s_split1_64_btn_xywh = {10,10,40,40},
	s_split1_128_btn_xywh = {10,10,40,40},	
	s_split1_interval_xywh = {10,10,80,40},
}
w1_split1.s_1080p = 
{
	s_split1_4_page_xywh = {90,980,343,60},
	s_split1_6_page_xywh = {90,980,267,60},
	s_split1_8_page_xywh = {90,980,347,60},
	s_split1_16_page_xywh = {90,940,347,101},
	s_split1_24_page_xywh = {90,900,340,141},
	s_split1_32_page_xywh = {90,860,340,181},
	s_split1_64_page_xywh = {90,700,340,341},
	s_split1_128_page_xywh = {90,380,340,661},	
	s_split1_4_btn_xywh = {70,10,80,40},
	s_split1_8_btn_xywh = {10,10,40,40},
	s_split1_16_btn_xywh = {10,10,40,40},
	s_split1_32_btn_xywh = {10,10,40,40},
	s_split1_64_btn_xywh = {10,10,40,40},	
	s_split1_128_btn_xywh = {10,10,40,40},
	s_split1_interval_xywh = {10,10,80,40},
}

w1_split1.s_2k = 
{
	s_split1_4_page_xywh = {120,1306,457,80},
	s_split1_6_page_xywh = {120,1306,356,80},
	s_split1_8_page_xywh = {120,1306,463,80},
	s_split1_16_page_xywh = {120,1253,463,135},
	s_split1_24_page_xywh = {120,1200,453,188},
	s_split1_32_page_xywh = {120,1147,453,241},
	s_split1_64_page_xywh = {120,935,453,453},
	s_split1_128_page_xywh = {120,511,453,877},	
	s_split1_4_btn_xywh = {93,13,107,53},
	s_split1_8_btn_xywh = {13,13,53,53},
	s_split1_16_btn_xywh = {13,13,53,53},
	s_split1_32_btn_xywh = {13,13,53,53},
	s_split1_64_btn_xywh = {13,13,53,53},
	s_split1_128_btn_xywh = {13,13,53,53},	
	s_split1_interval_xywh = {13,13,107,53},

}

w1_split1.s_4k = 
{
	s_split1_4_page_xywh = {180,1960,686,120},
	s_split1_6_page_xywh = {180,1960,534,120},
	s_split1_8_page_xywh = {180,1960,694,120},
	s_split1_16_page_xywh = {180,1880,694,202},
	s_split1_24_page_xywh = {180,1800,680,282},
	s_split1_32_page_xywh = {180,1720,680,362},
	s_split1_64_page_xywh = {180,1400,680,682},
	s_split1_128_page_xywh = {180,760,680,1322},	
	s_split1_4_btn_xywh = {140,20,160,80},
	s_split1_8_btn_xywh = {20,20,80,80},
	s_split1_16_btn_xywh = {20,20,80,80},
	s_split1_32_btn_xywh = {20,20,80,80},
	s_split1_64_btn_xywh = {20,20,80,80},
	s_split1_128_btn_xywh = {20,20,80,80},	
	s_split1_interval_xywh = {20,20,160,80},

}

local channel_num;--豸ͨĿ


local on_channel = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local param_winid = {};
		local param_child = {};
		local cur_ch = win_id - id;
		
		local layout_type = 0;
		local param_winid = {};
		local param_child = {};
		table.insert(param_child, 0);
		table.insert(param_winid, cur_ch);
		
		b_app_api.change_layout(layout_type, param_winid, param_child);
		
		b_dlg.end_modal(top);
		return b_ui_msg.msg_spltil;
	end
	return 0;
end

local get_valid_cam_num = function(channel_num)
	local chn_num = channel_num;
	local vi_num, dec_num = global_val.get_vi_dec_num();
	if (0 < dec_num and 0 < vi_num) then 
		local chn_type = b_app_api.get_cfg({'channel_type'}).channel_type;
		if (0 == chn_type.chn_type[vi_num + 1]) then
			chn_num = vi_num;
		end
	end
	
	return chn_num;
end

w1_split1.on_create = function(top)
	local dlg = {
		attr = {},
		sub = nil
	}
	channel_num = global_val.get_channelnum();
	channel_num = get_valid_cam_num(channel_num);
	if(channel_num == 4) then
		dlg.attr.xywh = 's_split1_4_page_xywh';
		dlg.sub = {"ch1","ch2","ch3","ch4"};
		local wndsize = SIZE('s_split1_4_btn_xywh');
		--local wnd_intval = SIZE('s_split1_interval_xywh');
		for i=1,channel_num do
			local name = "ch"..i;
			local wndsize = SIZE('s_split1_interval_xywh');
			dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-1)+i,wndsize[2],wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
		end
	elseif(channel_num == 6) then
		dlg.attr.xywh = 's_split1_6_page_xywh';
		dlg.sub = {"ch1","ch2","ch3","ch4","ch5","ch6"};
		local wndsize = SIZE('s_split1_8_btn_xywh');
		for i=1,channel_num do
			local name = "ch"..i;
			dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-1)+i,wndsize[2],wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
		end
	elseif(channel_num == 8) then
		dlg.attr.xywh = 's_split1_8_page_xywh';
		dlg.sub = {"ch1","ch2","ch3","ch4","ch5","ch6","ch7","ch8"};
		local wndsize = SIZE('s_split1_8_btn_xywh');
		for i=1,channel_num do
			local name = "ch"..i;
			dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-1)+i,wndsize[2],wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
		end
	elseif(channel_num == 12) then
		dlg.attr.xywh = 's_split1_16_page_xywh';
		dlg.sub = {"ch1","ch2","ch3","ch4","ch5","ch6","ch7","ch8",
					"ch9","ch10","ch11","ch12"};
		--local wnd_intval = SIZE('s_split1_interval_xywh');
		local wndsize = SIZE('s_split1_16_btn_xywh');
		for i=1,channel_num do
			local name = "ch"..i;
			if (i <= 8) then		
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-1),wndsize[2],wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			else
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-9),wndsize[2]+wndsize[4]+1,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			end
		end
	elseif(channel_num == 16) then
		dlg.attr.xywh = 's_split1_16_page_xywh';
		dlg.sub = {"ch1","ch2","ch3","ch4","ch5","ch6","ch7","ch8",
					"ch9","ch10","ch11","ch12","ch13","ch14","ch15","ch16"};
		--local wnd_intval = SIZE('s_split1_interval_xywh');
		local wndsize = SIZE('s_split1_16_btn_xywh');
		for i=1,channel_num do
			local name = "ch"..i;
			if (i <= 8) then		
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-1),wndsize[2],wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			else
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-9),wndsize[2]+wndsize[4]+1,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			end
		end
	elseif(channel_num == 24) then
		dlg.attr.xywh = 's_split1_24_page_xywh';
		dlg.sub = {"ch1","ch2","ch3","ch4","ch5","ch6","ch7","ch8",
					"ch9","ch10","ch11","ch12","ch13","ch14","ch15","ch16",
					"ch17","ch18","ch19","ch20","ch21","ch22","ch23","ch24"};
		local wnd_intval = SIZE('s_split1_interval_xywh');
		local wndsize = SIZE('s_split1_32_btn_xywh');
		for i=1,channel_num do
			local name = "ch"..i;
			if (i <= 8) then		
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-1),wndsize[2],wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 8 and i <= 16) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-9),wndsize[2]+wndsize[4],wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 16 and i <= 24) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-17),wndsize[2]+wndsize[4]*2,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			else
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-25),wndsize[2]+wndsize[4]*3,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			end
		end
	elseif(channel_num == 32) then
		dlg.attr.xywh = 's_split1_32_page_xywh';
		dlg.sub = {"ch1","ch2","ch3","ch4","ch5","ch6","ch7","ch8",
					"ch9","ch10","ch11","ch12","ch13","ch14","ch15","ch16",
					"ch17","ch18","ch19","ch20","ch21","ch22","ch23","ch24",
					"ch25","ch26","ch27","ch28","ch29","ch30","ch31","ch32"};
		local wnd_intval = SIZE('s_split1_interval_xywh');
		local wndsize = SIZE('s_split1_32_btn_xywh');
		for i=1,channel_num do
			local name = "ch"..i;
			if (i <= 8) then		
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-1),wndsize[2],wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 8 and i <= 16) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-9),wndsize[2]+wndsize[4],wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 16 and i <= 24) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-17),wndsize[2]+wndsize[4]*2,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			else
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-25),wndsize[2]+wndsize[4]*3,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			end
		end
	elseif(channel_num == 64) then
		dlg.attr.xywh = 's_split1_64_page_xywh';
		dlg.sub = {"ch1","ch2","ch3","ch4","ch5","ch6","ch7","ch8",
					"ch9","ch10","ch11","ch12","ch13","ch14","ch15","ch16",
					"ch17","ch18","ch19","ch20","ch21","ch22","ch23","ch24",
					"ch25","ch26","ch27","ch28","ch29","ch30","ch31","ch32",
					"ch33","ch34","ch35","ch36","ch37","ch38","ch39","ch40",
					"ch41","ch42","ch43","ch44","ch45","ch46","ch47","ch48",
					"ch49","ch50","ch51","ch52","ch53","ch54","ch55","ch56",
					"ch57","ch58","ch59","ch60","ch61","ch62","ch63","ch64"};
		local wnd_intval = SIZE('s_split1_interval_xywh');
		local wndsize = SIZE('s_split1_64_btn_xywh');		
		for i=1,channel_num do
			local name = "ch"..i;
			if (i <= 8) then		
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-1),wndsize[2],wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 8 and i <= 16) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-9),wndsize[2]+wndsize[4],wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 16 and i <= 24) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-17),wndsize[2]+wndsize[4]*2,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 24 and i <= 32) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-25),wndsize[2]+wndsize[4]*3,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif (i > 32 and i <= 40) then		
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-33),wndsize[2]+wndsize[4]*4,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 40 and i <= 48) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-41),wndsize[2]+wndsize[4]*5,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 48 and i <= 56) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-49),wndsize[2]+wndsize[4]*6,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			else
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-57),wndsize[2]+wndsize[4]*7,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			end			
		end		
	elseif(channel_num == 128) then
		dlg.attr.xywh = 's_split1_128_page_xywh';
		dlg.sub = {"ch1","ch2","ch3","ch4","ch5","ch6","ch7","ch8",
					"ch9","ch10","ch11","ch12","ch13","ch14","ch15","ch16",
					"ch17","ch18","ch19","ch20","ch21","ch22","ch23","ch24",
					"ch25","ch26","ch27","ch28","ch29","ch30","ch31","ch32",
					"ch33","ch34","ch35","ch36","ch37","ch38","ch39","ch40",
					"ch41","ch42","ch43","ch44","ch45","ch46","ch47","ch48",
					"ch49","ch50","ch51","ch52","ch53","ch54","ch55","ch56",
					"ch57","ch58","ch59","ch60","ch61","ch62","ch63","ch64",
					"ch65","ch66","ch67","ch68","ch69","ch70","ch71","ch72",
					"ch73","ch74","ch75","ch76","ch77","ch78","ch79","ch80",
					"ch81","ch82","ch83","ch84","ch85","ch86","ch87","ch88",
					"ch89","ch90","ch91","ch92","ch93","ch94","ch95","ch96",
					"ch97","ch98","ch99","ch100","ch101","ch102","ch103","ch104",
					"ch105","ch106","ch107","ch108","ch109","ch110","ch111","ch112",
					"ch113","ch114","ch115","ch116","ch117","ch118","ch119","ch120",
					"ch121","ch122","ch123","ch124","ch125","ch126","ch127","ch128"};
		local wnd_intval = SIZE('s_split1_interval_xywh');
		local wndsize = SIZE('s_split1_128_btn_xywh');
		for i=1,channel_num do
			local name = "ch"..i;
			if (i <= 8) then		
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-1),wndsize[2],wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 8 and i <= 16) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-9),wndsize[2]+wndsize[4],wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 16 and i <= 24) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-17),wndsize[2]+wndsize[4]*2,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 24 and i <= 32) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-25),wndsize[2]+wndsize[4]*3,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif (i > 32 and i <= 40) then		
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-33),wndsize[2]+wndsize[4]*4,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 40 and i <= 48) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-41),wndsize[2]+wndsize[4]*4,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 48 and i <= 56) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-49),wndsize[2]+wndsize[4]*5,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 56 and i <= 64) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-57),wndsize[2]+wndsize[4]*6,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 64 and i <= 72) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-65),wndsize[2]+wndsize[4]*7,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 72 and i <= 80) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-73),wndsize[2]+wndsize[4]*8,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 80 and i <= 88) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-81),wndsize[2]+wndsize[4]*9,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif (i > 88 and i <= 96) then		
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-89),wndsize[2]+wndsize[4]*10,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 96 and i <= 104) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-97),wndsize[2]+wndsize[4]*11,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 104 and i <= 112) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-105),wndsize[2]+wndsize[4]*12,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			elseif(i > 112 and i <= 120) then
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-113),wndsize[2]+wndsize[4]*13,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			else
				dlg[name] = {t='button',id=id+i,xywh={wndsize[1]+wndsize[3]*(i-121),wndsize[2]+wndsize[4]*14,wndsize[3],wndsize[4]},text=tostring(i),trans = false,cmd=on_channel};
			end
		end
	end
	w1_split1.top = top;
	w1_split1.dlg = dlg;
	b_parser(top, dlg);
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)	
	return 0;
end

w1_split1.on_destroy = function(top)
	w1_split1.top = nil;
	w1_split1.dlg = nil;
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)
	return 0;
end

w1_split1.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top);
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_bk'));
--	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_popdlg_border'), 1);
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top);
	return 0;
end

w1_split1.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg or b_ui.RBUTTONCLK == vmsg) then
		b_dlg.end_modal(top);
	elseif ( b_ui_msg.msg_spltil == vmsg) then
		return vmsg;
	end
	return 0;
end

return w1_split1;




