local global_val 	= require("wnd.global_val")
local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.toolbar.split9_id
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_app_api = require("wnd.core.command.b_app_api");
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size


local w1_split16 = {
	t = w1_key.DLG_SPLIT16,
	top = nil,
	dlg = nil,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
};
w1_split16.s_1280 = 
{
	s_split16_page= {320,924,183,60};
	s_split16_64_page= {192,924,345,60};
	s_split16_128_page= {192,924,669,60};
	s_split16_btn_xywh= {70,10,80,40},
	s_split16_interval_xywh= {81,0,0,0},
}
w1_split16.s_1440 = 
{
	s_split16_page= {320,800,183,60};
	s_split16_64_page= {192,800,345,60};
	s_split16_128_page= {192,800,669,60};
	s_split16_btn_xywh= {70,10,80,40},
	s_split16_interval_xywh= {81,0,0,0},
}

w1_split16.s_1080p = 
{
	s_split16_page= {320,980,183,60};
	s_split16_64_page= {192,980,345,60};
	s_split16_128_page= {192,980,669,60};
	s_split16_btn_xywh= {70,10,80,40},
	s_split16_interval_xywh= {81,0,0,0},
}

w1_split16.s_2k = 
{
	s_split16_page= {426,1306,244,80},
	s_split16_64_page= {256,1306,460,80},
	s_split16_128_page= {256,1306,892,80},
	s_split16_btn_xywh= {93,13,107,53},
	s_split16_interval_xywh= {108,0,0,0},
}

w1_split16.s_4k = 
{
	s_split16_page= {640,1960,366,120},
	s_split16_64_page= {384,1960,690,120};
	s_split16_128_page= {384,1960,1338,120};	
	s_split16_btn_xywh= {140,20,160,80},
	s_split16_interval_xywh= {162,0,0,0},
}
local channel_num;--豸ͨĿ,ʱȹ̶

local on_channel = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local cur_id = win_id - id;		
		local cur_ch = 1;
		local layout_num = 16;
		cur_ch = (cur_id - 1) * layout_num + 1;
		local layout_type = 3;
		local param_winid = {};
		local param_child = {};
		if (cur_ch + layout_num > channel_num) then
			cur_ch = channel_num - layout_num + 1;
		end	
		for i = 1, layout_num do
			if (cur_ch + (i - 1) <= channel_num) then 
				table.insert(param_child, 0);
				table.insert(param_winid, cur_ch + (i - 1));
			else
				table.insert(param_child, 0);
				table.insert(param_winid, 0);	
			end
		end
		b_app_api.change_layout(layout_type, param_winid, param_child);
		
		b_dlg.end_modal(top);
		
		return b_ui_msg.msg_spltil;
	end
	return 0;
end

local get_valid_cam_num = function(channel_num)
	local chn_num = channel_num;
	local vi_num, dec_num = global_val.get_vi_dec_num();
	if (0 < dec_num and 0 < vi_num) then 
		local chn_type = b_app_api.get_cfg({'channel_type'}).channel_type;
		if (0 == chn_type.chn_type[vi_num + 1]) then
			chn_num = vi_num;
		end
	end
	
	return chn_num;
end

w1_split16.on_create = function(top)
	local dlg = {
		attr = {},
		sub = nil
	}
	channel_num 	= global_val.get_channelnum();
	channel_num = get_valid_cam_num(channel_num);	
	local wndsize = SIZE('s_split16_btn_xywh');
	local wnd_intval = SIZE('s_split16_interval_xywh');
	if(channel_num == 24) then		
		dlg.attr.xywh = 's_split16_page';
		dlg.sub = {"ch1_16","ch9_24"};
		local txt = 1 .."-" .. 16;
		local name = "ch"..1 .."_" .. 16;
		dlg[name] = {t='button',id=id+1,xywh={wnd_intval[1]*1-wndsize[1],wndsize[2],wndsize[3],wndsize[4]},text=txt,trans = false,cmd=on_channel};
		txt = 9 .."-" .. 24;
		name = "ch"..9 .."_" .. 24;
		dlg[name] = {t='button',id=id+2,xywh={wnd_intval[1]*2-wndsize[1],wndsize[2],wndsize[3],wndsize[4]},text=txt,trans = false,cmd=on_channel};	
	elseif(channel_num == 32) then		
		dlg.attr.xywh = 's_split16_page';
		dlg.sub = {"ch1_16","ch17_32"};
		for i=1,channel_num/16 do
			local txt = (i-1)*16+1 .."-" .. i*16;
			local name = "ch"..(i-1)*16+1 .."_" .. i*16;
			dlg[name] = {t='button',id=id+i,xywh={wnd_intval[1]*i-wndsize[1],wndsize[2],wndsize[3],wndsize[4]},text=txt,trans = false,cmd=on_channel};
		end
	elseif(channel_num == 64) then
		dlg.attr.xywh = 's_split16_64_page';
		dlg.sub = {"ch1_16","ch17_32","ch33_48","ch49_64"};
		for i=1,channel_num/16 do
			local txt = (i-1)*16+1 .."-" .. i*16;
			local name = "ch"..(i-1)*16+1 .."_" .. i*16;
			dlg[name] = {t='button',id=id+i,xywh={wnd_intval[1]*i-wndsize[1],wndsize[2],wndsize[3],wndsize[4]},text=txt,trans = false,cmd=on_channel};
		end		
	elseif(channel_num == 128) then
		dlg.attr.xywh = 's_split16_128_page';
		dlg.sub = {"ch1_16","ch17_32","ch33_48","ch49_64","ch65_80","ch81_96","ch97_112","ch113_128"};
		for i=1,channel_num/16 do
			local txt = (i-1)*16+1 .."-" .. i*16;
			local name = "ch"..(i-1)*16+1 .."_" .. i*16;
			dlg[name] = {t='button',id=id+i,xywh={wnd_intval[1]*i-wndsize[1],wndsize[2],wndsize[3],wndsize[4]},text=txt,trans = false,cmd=on_channel};
		end		
	end
	w1_split16.top = top;
	w1_split16.dlg = dlg;
	b_parser(top, dlg);
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)	
	return 0;
end

w1_split16.on_destroy = function(top)
	w1_split16.top = nil;
	w1_split16.dlg = nil;
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)	
	return 0;
end

w1_split16.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top);
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_bk'));
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_popdlg_border'), 1);
	b_wnd.end_job(top);
	return 0;
end

w1_split16.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg or b_ui.RBUTTONCLK == vmsg) then
		b_dlg.end_modal(top);	
	elseif ( b_ui_msg.msg_spltil == vmsg) then
		return vmsg;
	end
	return 0;
end

return w1_split16;




