local global_val	= require("wnd.global_val")
local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.toolbar.split64_id
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_app_api = require("wnd.core.command.b_app_api");
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size

local w1_split64 = {
	t = w1_key.DLG_SPLIT64,
	top = nil,
	dlg = nil,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
};
w1_split64.s_1280 = 
{
	s_split64_page= {120,924,183,60};
	s_split64_btn_xywh= {70,10,80,40},
	s_split64_interval_xywh= {81,0,0,0},
}
w1_split64.s_1440 = 
{
	s_split64_page= {120,800,183,60};
	s_split64_btn_xywh= {70,10,80,40},
	s_split64_interval_xywh= {81,0,0,0},
}

w1_split64.s_1080p = 
{
	s_split64_page= {120,980,183,60};
	s_split64_btn_xywh= {70,10,80,40},
	s_split64_interval_xywh= {81,0,0,0},
}

w1_split64.s_2k = 
{
	s_split64_page= {160,1306,244,80},
	s_split64_btn_xywh= {93,13,107,53},
	s_split64_interval_xywh= {108,0,0,0},
}

w1_split64.s_4k = 
{
	s_split64_page= {240,1960,366,120},
	s_split64_btn_xywh= {140,20,160,80},
	s_split64_interval_xywh= {162,0,0,0},
}
local channel_num;--豸ͨĿ

local on_channel = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local cur_id = win_id - id;		
		local cur_ch = 1;
		local layout_num = 64;
		cur_ch = (cur_id - 1) * layout_num + 1;
		local layout_type = 7;
		local param_winid = {};
		local param_child = {};
		if (cur_ch + layout_num > channel_num) then
			cur_ch = channel_num - layout_num + 1;
		end	
		for i = 1, layout_num do
			if (cur_ch + (i - 1) <= channel_num) then 
				table.insert(param_child, 0);
				table.insert(param_winid, cur_ch + (i - 1));
			else
				table.insert(param_child, 0);
				table.insert(param_winid, 0);	
			end
		end
		b_app_api.change_layout(layout_type, param_winid, param_child);
		
		b_dlg.end_modal(top);
		
		return b_ui_msg.msg_spltil;
	end
	return 0;
end

w1_split64.on_create = function(top)
	local dlg = {
		attr = {},
		sub = nil
	}
	channel_num 	= global_val.get_channelnum();
	local wndsize = SIZE('s_split64_btn_xywh');
	local wnd_intval = SIZE('s_split64_interval_xywh');
	dlg.attr.xywh = 's_split64_page';
	dlg.sub = {"ch1_64","ch65_128"};
	for i=1,channel_num/64 do
		local txt = (i-1)*64+1 .."-" .. i*64;
		local name = "ch"..(i-1)*64+1 .."_" .. i*64;
		dlg[name] = {t='button',id=id+i,xywh={wnd_intval[1]*i-wndsize[1],wndsize[2],wndsize[3],wndsize[4]},text=txt,trans = false,cmd=on_channel};
	end
	w1_split64.top = top;
	w1_split64.dlg = dlg;
	b_parser(top, dlg);
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)	
	return 0
end

w1_split64.on_destroy = function(top)
	w1_split64.top = nil;
	w1_split64.dlg = nil;
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)	
	return 0;
end

w1_split64.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top);
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_bk'));
--	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_popdlg_border'), 1);
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top);
	return 0;
end

w1_split64.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg or b_ui.RBUTTONCLK == vmsg) then
		b_dlg.end_modal(top);
	elseif ( b_ui_msg.msg_spltil == vmsg) then
		return vmsg;
	end
	return 0;
end

return w1_split64;




