local global_val 	= require("wnd.global_val")
local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.toolbar.split9_id
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local b_app_api = require("wnd.core.command.b_app_api");
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size


local w1_split9 = {
	t = w1_key.DLG_SPLIT9,
	top = nil,
	dlg = nil,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
	open_auxi = false;
};
w1_split9.s_1280 = 
{
	s_split9_page= {192,924,183,60};
	s_split9_24_page= {192,924,265,60};
	s_split9_32_page= {192,924,345,60};
	s_split9_64_page= {192,924,669,60};
	s_split9_128_page= {192,884,669,100};
	s_split9_btn_xywh= {70,10,80,40},
	s_split9_interval_xywh= {81,0,0,0},
}
w1_split9.s_1440 = 
{
	s_split9_page= {192,800,183,60};
	s_split9_24_page= {192,800,265,60};
	s_split9_32_page= {192,800,345,60};
	s_split9_64_page= {192,800,669,60};
	s_split9_128_page= {192,760,669,100};
	s_split9_btn_xywh= {70,10,80,40},
	s_split9_interval_xywh= {81,0,0,0},
}

w1_split9.s_1080p = 
{
	s_split9_page= {192,980,183,60};
	s_split9_24_page= {192,980,265,60};
	s_split9_32_page= {192,980,345,60};
	s_split9_64_page= {192,980,669,60};
	s_split9_128_page= {192,840,669,100};
	s_split9_btn_xywh= {70,10,80,40},
	s_split9_interval_xywh= {81,0,0,0},
}

w1_split9.s_2k = 
{
	s_split9_page= {256,1306,244,80},
	s_split9_24_page= {256,1306,353,80};
	s_split9_32_page= {256,1306,460,80};
	s_split9_64_page= {256,1306,892,80};
	s_split9_128_page= {256,1253,892,133};
	s_split9_btn_xywh= {93,13,107,53},
	s_split9_interval_xywh= {108,0,0,0},
}

w1_split9.s_4k = 
{
	s_split9_page= {384,1960,366,120},
	s_split9_24_page= {384,1960,530,120};
	s_split9_32_page= {384,1960,690,120};
	s_split9_64_page= {384,1960,1338,120};
	s_split9_128_page= {384,1880,1338,200};
	s_split9_btn_xywh= {140,20,160,80},
	s_split9_interval_xywh= {162,0,0,0},
}
local channel_num;--豸ͨĿ,ʱȹ̶

local on_channel = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local cur_id = win_id - id;
		local cur_ch = 1;
		local layout_num = 9;
		if (16 == channel_num and w1_split9.open_auxi == true) then --16·ҿ
			layout_num = 8;
		end	
		cur_ch = (cur_id - 1) * layout_num + 1;
		local layout_type = 2;
		local param_winid = {};
		local param_child = {};
		if (cur_ch + layout_num > channel_num) then
			cur_ch = channel_num - layout_num + 1;
		end	
		for i = 1, layout_num do
			if (cur_ch + (i - 1) <= channel_num) then 
				table.insert(param_child, 0);
				table.insert(param_winid, cur_ch + (i - 1));
			else
				table.insert(param_child, 0);
				table.insert(param_winid, 0);	
			end
		end
		b_app_api.change_layout(layout_type, param_winid, param_child);
		
		b_dlg.end_modal(top);
		
		return b_ui_msg.msg_spltil;
	end
	return 0;
end

local get_valid_cam_num = function(channel_num)
	local chn_num = channel_num;
	local vi_num, dec_num = global_val.get_vi_dec_num();
	if (0 < dec_num and 0 < vi_num) then 
		local chn_type = b_app_api.get_cfg({'channel_type'}).channel_type;
		if (0 == chn_type.chn_type[vi_num + 1]) then
			chn_num = vi_num;
		end
	end
	
	return chn_num;
end


w1_split9.on_create = function(top)
	local dlg = {
		attr = {},
		sub = nil
	}

	w1_split9.open_auxi = false;	
	local support_auxi = global_val.get_support_auxiliary_attr();
	if (true == support_auxi) then
		local cfg_tab = {'cfg_auxiliary'}
		w1_split9.open_auxi = b_app_api.get_cfg(cfg_tab).cfg_auxiliary.enable
	end
	
	channel_num 	= global_val.get_channelnum();
	channel_num = get_valid_cam_num(channel_num);
		
	local wndsize = SIZE('s_split9_btn_xywh');
	local wnd_intval = SIZE('s_split9_interval_xywh');
	if(channel_num == 12) then		
		dlg.attr.xywh = 's_split9_page';
		dlg.sub = {"ch1_9","ch4_12"};
		local name="ch1_9"
		local txt = 1 .."-" .. 9;
		dlg[name] = {t='button',id=id+1,xywh={wnd_intval[1]-wndsize[1],wndsize[2],wndsize[3],wndsize[4]},text=txt,trans = false,cmd=on_channel};
		name="ch4_12"
		txt = 4 .."-" .. 12;
		dlg[name] = {t='button',id=id+2,xywh={wnd_intval[1]*2-wndsize[1],wndsize[2],wndsize[3],wndsize[4]},text=txt,trans = false,cmd=on_channel};
	elseif(channel_num == 16) then		
		dlg.attr.xywh = 's_split9_page';
		dlg.sub = {"ch1_9","ch8_16"};
		local name="ch1_9"
		local txt = 1 .."-" .. 9;
		if (w1_split9.open_auxi == true) then
			txt = 1 .."-" .. 8;
		end	
		dlg[name] = {t='button',id=id+1,xywh={wnd_intval[1]-wndsize[1],wndsize[2],wndsize[3],wndsize[4]},text=txt,trans = false,cmd=on_channel};
		name="ch8_16"
		txt = 8 .."-" .. 16;
		if (w1_split9.open_auxi == true) then
			txt = 9 .."-" .. 16;
		end	
		dlg[name] = {t='button',id=id+2,xywh={wnd_intval[1]*2-wndsize[1],wndsize[2],wndsize[3],wndsize[4]},text=txt,trans = false,cmd=on_channel};
	elseif(channel_num == 24) then
		dlg.attr.xywh = 's_split9_24_page';
		dlg.sub = {"ch1_9","ch10_18","ch16_24"};
		for i=1,2 do
			local txt = (i-1)*9+1 .."-" .. i*9;
			local name = "ch"..(i-1)*9+1 .."_" .. i*9;			
			dlg[name] = {t='button',id=id+i,xywh={wnd_intval[1]*i-wndsize[1],wndsize[2],wndsize[3],wndsize[4]},text=txt,trans = false,cmd=on_channel};			
		end
		local name="ch16_24"
		txt = 16 .."-" .. 24;
		dlg[name] = {t='button',id=id+3,xywh={wnd_intval[1]*3-wndsize[1],wndsize[2],wndsize[3],wndsize[4]},text=txt,trans = false,cmd=on_channel};			
	elseif(channel_num == 32) then
		dlg.attr.xywh = 's_split9_32_page';
		dlg.sub = {"ch1_9","ch10_18","ch19_27","ch24_32"};
		for i=1,channel_num/9 do
			local txt = (i-1)*9+1 .."-" .. i*9;
			local name = "ch"..(i-1)*9+1 .."_" .. i*9;			
			dlg[name] = {t='button',id=id+i,xywh={wnd_intval[1]*i-wndsize[1],wndsize[2],wndsize[3],wndsize[4]},text=txt,trans = false,cmd=on_channel};			
		end
		local name="ch24_32"
		txt = 24 .."-" .. 32;
		dlg[name] = {t='button',id=id+4,xywh={wnd_intval[1]*4-wndsize[1],wndsize[2],wndsize[3],wndsize[4]},text=txt,trans = false,cmd=on_channel};
	elseif(channel_num == 64) then
		dlg.attr.xywh = 's_split9_64_page';
		dlg.sub = {"ch1_9","ch10_18","ch19_27","ch28_36","ch37_45","ch46_54","ch55_63","ch56_64"};
		for i=1,channel_num/9 do
			local txt = (i-1)*9+1 .."-" .. i*9;
			local name = "ch"..(i-1)*9+1 .."_" .. i*9;			
			dlg[name] = {t='button',id=id+i,xywh={wnd_intval[1]*i-wndsize[1],wndsize[2],wndsize[3],wndsize[4]},text=txt,trans = false,cmd=on_channel};			
		end
		local name="ch56_64"
		txt = 56 .."-" .. 64;
		dlg[name] = {t='button',id=id+8,xywh={wnd_intval[1]*8-wndsize[1],wndsize[2],wndsize[3],wndsize[4]},text=txt,trans = false,cmd=on_channel};
	elseif(channel_num == 128) then
		dlg.attr.xywh = 's_split9_128_page';
		dlg.sub = {"ch1_9","ch10_18","ch11_27","ch29_36","ch37_45","ch46_54","ch55_63","ch64_72",
					"ch73_81","ch82_90","ch91_99","ch100_108","ch109_117","ch118_126","ch120_128"};
		for i=1,channel_num/9 do
			local txt = (i-1)*9+1 .."-" .. i*9;
			local name = "ch"..(i-1)*9+1 .."_" .. i*9;
			if i <= 8 then
				dlg[name] = {t='button',id=id+i,xywh={wnd_intval[1]*i-wndsize[1],wndsize[2],wndsize[3],wndsize[4]},text=txt,trans = false,cmd=on_channel};						
			else
				dlg[name] = {t='button',id=id+i,xywh={wnd_intval[1]*(i-8)-wndsize[1],wndsize[2]+wndsize[4],wndsize[3],wndsize[4]},text=txt,trans = false,cmd=on_channel};			
			end
			
		end
		local name="ch120_128"
		txt = 120 .."-" .. 128;
		dlg[name] = {t='button',id=id+15,xywh={wnd_intval[1]*7-wndsize[1],wndsize[2]+wndsize[4],wndsize[3],wndsize[4]},text=txt,trans = false,cmd=on_channel};
	end
	w1_split9.top = top;
	w1_split9.dlg = dlg;
	b_parser(top, dlg);
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)	
	return 0;
end

w1_split9.on_destroy = function(top)
	w1_split9.top = nil;
	w1_split9.dlg = nil;
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)	
	return 0;
end

w1_split9.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top);
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_bk'));
--	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_popdlg_border'), 1);
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top);
	return 0;
end

w1_split9.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg or b_ui.RBUTTONCLK == vmsg) then
		b_dlg.end_modal(top);	
	elseif ( b_ui_msg.msg_spltil == vmsg) then
		return vmsg;
	end
	return 0;
end

return w1_split9;




