--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/3/20
-- author 
-- brief  öԻ
--]]
local global_val	= require("wnd.global_val")
local b_wnd 		= require("wnd.core.b_wnd")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local b_dlg 		= require("wnd.core.b_dlg")
local b_parser 		= require("wnd.core.b_parser")
local b_ui 			= require("wnd.core.b_ui")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.toolbar.sysinfo_id
local w1_key 		= require("wnd.w1_util.w1_key")
local r_color		= require("wnd.core.r_res.r_color")
local COLOR 		= r_color.get_color
local b_app_api 	= require("wnd.core.command.b_app_api");
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local b_dlg 		= require("wnd.core.b_dlg")
local b_ui_msg  	= require("wnd.w1_util.w1_ui_msg") 
local r_size		= require("wnd.core.r_res.r_size")
local SIZE			= r_size.get_size;
--
local w1_sysinfo_row 		= require("wnd.w1_live.w1_sysinfo_row")
local w1_sysinfo_system 	= require("wnd.w1_live.w1_sysinfo_system")
local w1_sysinfo_network 	= require("wnd.w1_live.w1_sysinfo_network")
local w1_sysinfo_channel 	= require("wnd.w1_live.w1_sysinfo_channel")
local w1_sysinfo_disk 		= require("wnd.w1_live.w1_sysinfo_disk")
local w1_sysinfo_alarm 		= require("wnd.w1_live.w1_sysinfo_alarm")

local w1_sysinfo = {
	t = w1_key.DLG_SYSINFO,
	top = nil,
	dlg = nil,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}	
	
w1_sysinfo.s_768 =
{
	s_sysinfo_page_xywh = {538,264,483,473},
	s_sysinfo_draw_xywh = {1,43,0,1},
};

w1_sysinfo.s_1280 = 
{
	s_sysinfo_page_xywh= {372,316,906,666},
	s_sysinfo_draw_xywh= {3,61,0,1},
}
w1_sysinfo.s_1440 = 
{
	s_sysinfo_page_xywh= {532,194,906,666},
	s_sysinfo_draw_xywh= {3,61,0,1},
}
w1_sysinfo.s_1080p = 
{
	s_sysinfo_page_xywh= {1009,372,906,666},
	s_sysinfo_draw_xywh= {3,61,0,1},
}

w1_sysinfo.s_2k = 
{
	--[[s_sysinfo_page_xywh= {1353,504,1200,880},
	s_sysinfo_draw_xywh= {0,77,0,1},--]]
	s_sysinfo_page_xywh= {1345,496,1208,888},
	s_sysinfo_draw_xywh= {4,81,0,1},

}

w1_sysinfo.s_4k = 
{
	--[[s_sysinfo_page_xywh= {2030,756,1800,1320},
	s_sysinfo_draw_xywh= {0,116,0,2},--]]
	s_sysinfo_page_xywh= {2018,744,1812,1332},
	s_sysinfo_draw_xywh= {6,122,0,2},


}

local on_dlg = function(top, id, vmsg, x, y)
	if b_ui.TIMER == vmsg then
		w1_sysinfo_network.timerenevt(top);
	end
	return 0
end

local dlg = {
	attr={xywh='s_sysinfo_page_xywh',cmd=on_dlg,timer={-1, 1000}};
	sub = {	'containerColumn', 'containerRow', 'containerItem',
			'w1_sysinfo_wnd','w1_network_wnd','w1_system_wnd',
			'w1_channel_wnd','w1_disk_wnd','w1_alarm_wnd',
			'close', 
		},
		
	containerRow	= {t='container',id=w1_id.toolbar.sysinfo_id,	xywh='s_cfg_con_xywh'},
	containerItem 	= {t='container',id=w1_id.toolbar.conItem_id,	xywh='s_cfg_con_xywh'},
	w1_sysinfo_wnd	= w1_sysinfo_row.wnd,
	
	w1_network_wnd 	= w1_sysinfo_network.wnd,
	w1_system_wnd 	= w1_sysinfo_system.wnd,
	w1_channel_wnd 	= w1_sysinfo_channel.wnd,
	w1_disk_wnd 	= w1_sysinfo_disk.wnd,
	w1_alarm_wnd 	= w1_sysinfo_alarm.wnd,
}

w1_sysinfo.on_create = function(top)
	local add_page = function(child_id, w_id)
		b_wnd_ex.set_add_page(top, child_id, w_id);
	end
	local show_page = function(child_id, w_id)
		b_wnd_ex.set_show_page(top, child_id, w_id, false);
	end
	w1_sysinfo.top = top;
	w1_sysinfo.dlg = dlg;
	--UIڳʼ
	b_parser(top, w1_sysinfo.dlg);
	
	local cwnd = w1_sysinfo.dlg;
	add_page(cwnd.containerRow.id, cwnd.w1_sysinfo_wnd.id);
	add_page(cwnd.containerItem.id, cwnd.w1_network_wnd.id);
	add_page(cwnd.containerItem.id, cwnd.w1_system_wnd.id);
	add_page(cwnd.containerItem.id, cwnd.w1_channel_wnd.id);
	add_page(cwnd.containerItem.id, cwnd.w1_disk_wnd.id);
	add_page(cwnd.containerItem.id, cwnd.w1_alarm_wnd.id);
	
	show_page(cwnd.containerRow.id, cwnd.w1_sysinfo_wnd.id);
	show_page(cwnd.containerItem.id, cwnd.w1_network_wnd.id);

	--w1_sysinfo_network.init(top);
	return 0;
end

w1_sysinfo.on_destroy = function(top)
	w1_sysinfo.top = nil;
	w1_sysinfo.dlg = nil;
	w1_sysinfo_channel.clear();
	w1_sysinfo_disk.clear();
	
	--ֳʱ
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)	
	
	return 0;
end

w1_sysinfo.on_pre_show = function(top)
	w1_sysinfo_network.on_pre_show(top);
	w1_sysinfo_system.on_pre_show(top);
	w1_sysinfo_channel.on_pre_show(top);
	w1_sysinfo_disk.on_pre_show(top);
	w1_sysinfo_alarm.on_pre_show(top);
	w1_sysinfo_row.on_pre_show(top);
	
	local cwnd = w1_sysinfo.dlg;
	w1_wnd_jump.click_row(top, cwnd.w1_sysinfo_wnd, cwnd.w1_sysinfo_wnd.id + 1, false);
	
	--رֳʱ
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)
	return 0;
end	

w1_sysinfo.on_paint = function(top, status, x, y, cx, cy)
	local wndsize = SIZE('s_sysinfo_draw_xywh');

	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_row_bk'));
	b_wnd.draw_fill(top, x+6, y+wndsize[2], cx-6, wndsize[4], COLOR('c_hline_color'));
	
	local pos = SIZE('s_post_border_with');
	b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
	b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	b_wnd.end_job(top);
	return 0;
end

w1_sysinfo.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	local wndsize = SIZE('s_sysinfo_page_xywh');
	if (b_ui.RBUTTONCLK == vmsg) then
		b_dlg.end_modal(top);
	elseif(b_ui.LBUTTONCLK == vmsg) then
		if ((x < wndsize[1] or y < wndsize[2])or(x > (wndsize[1] + wndsize[3]) or y > (wndsize[2] + wndsize[4])) ) then
			b_dlg.end_modal(top);
		end
	end
	return 0;
end

return w1_sysinfo;




