local b_ui 			= require("wnd.core.b_ui")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_id 		= require("wnd.w1_util.w1_id")
local global_val	= require("wnd.global_val")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_parser 	= require("wnd.core.b_parser")
local b_app_api = require("wnd.core.command.b_app_api");
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local util 		= require("wnd.core.util")
local id 		= w1_id.sysinfo.alarm_id


local w1_sysinfo_alarm = {
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_sysinfo_alarm.s_768 =
{
	s_sysinfo_ala_wnd_xywh = {2,46,478,423},
	s_sysinfo_ala_alarm_list_xywh = {5,21,469,355},
	s_sysinfo_ala1 = {94,0,0,0},
	s_sysinfo_ala2 = {75,0,0,0},
	s_sysinfo_ala3 = {68,0,0,0},
	s_sysinfo_ala4 = {73,0,0,0},
	s_sysinfo_ala5 = {132,0,0,0},
};
	
w1_sysinfo_alarm.s_1280 = 
{
	s_sysinfo_ala_wnd_xywh= {5,65,898,596},
	s_sysinfo_ala_alarm_list_xywh= {10,30,880,500},
	s_sysinfo_ala1 = {148,0,0,0},
	s_sysinfo_ala2 = {172,0,0,0},
	s_sysinfo_ala3 = {108,0,0,0},
	s_sysinfo_ala4 = {118,0,0,0},
	s_sysinfo_ala5 = {312,0,0,0},


}
w1_sysinfo_alarm.s_1440 = 
{
	s_sysinfo_ala_wnd_xywh= {5,65,898,596},
	s_sysinfo_ala_alarm_list_xywh = {10,30,880,500},
	s_sysinfo_ala1 = {178,0,0,0},
	s_sysinfo_ala2 = {142,0,0,0},
	s_sysinfo_ala3 = {128,0,0,0},
	s_sysinfo_ala4 = {138,0,0,0},
	s_sysinfo_ala5 = {268,0,0,0},


}	
	
w1_sysinfo_alarm.s_1080p = 
{
	s_sysinfo_ala_wnd_xywh= {5,65,898,596},
	s_sysinfo_ala_alarm_list_xywh= {10,30,880,500},
	s_sysinfo_ala1 = {178,0,0,0},
	s_sysinfo_ala2 = {142,0,0,0},
	s_sysinfo_ala3 = {128,0,0,0},
	s_sysinfo_ala4 = {138,0,0,0},
	s_sysinfo_ala5 = {268,0,0,0},

}

w1_sysinfo_alarm.s_2k = 
{
	s_sysinfo_ala_wnd_xywh= {7,87,1197,794},
	s_sysinfo_ala_alarm_list_xywh= {13,40,1173,667},
	s_sysinfo_ala1 = {190,0,0,0},
	s_sysinfo_ala2 = {173,0,0,0},
	s_sysinfo_ala3 = {151,0,0,0},
	s_sysinfo_ala4 = {161,0,0,0},
	s_sysinfo_ala5 = {460,0,0,0},

}

w1_sysinfo_alarm.s_4k = 
{
	s_sysinfo_ala_wnd_xywh= {10,130,1796,1192},
	s_sysinfo_ala_alarm_list_xywh=  {20,60,1760,1000},
	s_sysinfo_ala1 = {356,0,0,0},
	s_sysinfo_ala2 = {284,0,0,0},
	s_sysinfo_ala3 = {256,0,0,0},
	s_sysinfo_ala4 = {276,0,0,0},
	s_sysinfo_ala5 = {536,0,0,0},

}
local channel_count;--豸ͨĿ
local IN_SYSINFO = nil;
local OUT_SYSINFO = nil;
local updatelist = function(top, redraw)
	num = IN_SYSINFO.num;
	local displist = {};
	local idx = 0;
	for i=1, num do
		idx = idx + 1;
		
		local str = STR('LA_LOCAL')..'<-'..i
		
		local status = STR('LA_NO');
		if(0 == IN_SYSINFO['sensor'..i].nc)then
			status = STR('LA_NO');
		else
			status = STR('LA_NC')
		end 
		local channel_list = ''
		local chn_idx = 1
		local chn_list = {}
		for j,v in ipairs(IN_SYSINFO['sensor'..i].linkage.trigger_ch) do
			if chn_idx ==v then
				table.insert(chn_list,v)
			else
				if channel_list~='' then
					channel_list = channel_list..','
				end
				if #chn_list==1 then
					channel_list = channel_list..chn_list[1]
				elseif #chn_list >1 then
					channel_list = channel_list..chn_list[1]..'-'..chn_list[#chn_list]
				end
				chn_list = {}
				chn_idx = v
				table.insert(chn_list,v)
			end
			chn_idx = chn_idx+1
		end
		if channel_list~='' then
			channel_list = channel_list..','
		end
		if #chn_list==1 then
			channel_list = channel_list..chn_list[1]
		elseif #chn_list >1 then
			channel_list = channel_list..chn_list[1]..'-'..chn_list[#chn_list]
		end
		
		local enable = STR('LA_ON')--"stream1";
		if(IN_SYSINFO['sensor'..i].enable)then
			enable = STR('LA_ON')--"stream1";
		else
			enable = STR('LA_OFF')--"stream2";
		end

		if (false == IN_SYSINFO['sensor'..i].linkage.record) then
			channel_list = '';		
		end

		displist['idx'..idx] = {idx-1, false, 
		str,IN_SYSINFO['sensor'..i].name,status,enable,channel_list};	
	end
	num = OUT_SYSINFO.num;
	for i=1,num do
		idx = idx + 1;
		local str = STR('LA_LOCAL')..'->'..i
		
		local status = STR('LA_NO');
		if(0 == OUT_SYSINFO['outid'..i].valid_level)then
			status = STR('LA_OPEN_T');
		else
			status = STR('LA_CLOSE_T')
		end 
		local channel_list = ''
	
		local enable = '';
		
		displist['idx'..idx] = {idx-1, false, 
		str,OUT_SYSINFO['outid'..i].name,status,enable,channel_list};
	end
	displist.item_total = idx;
	b_wnd_ex.set_listdata(top, w1_sysinfo_alarm.wnd.alarm_list.id, displist, redraw);	
end

w1_sysinfo_alarm.on_pre_show = function(top)
	local cwnd = w1_sysinfo_alarm.wnd;
	channel_count = global_val.get_channelnum();
	local param = {
			STR('LA_CHANNEL'), STR('LA_NAME'),STR('LA_MODE'), STR('LA_ENABLE'),STR('LA_RECORD_CHANNEL')
		}
	b_wnd_ex.set_title_texts(top, cwnd.alarm_list.id, param, false);
	local list_w = {};
		for i=1,5 do
			local str = 's_sysinfo_ala'..math.floor(i/1);
			list_w[i] = SIZE(str)[1];
		end
	b_wnd_ex.columns_w(top, cwnd.alarm_list.id, list_w, false);
		
	local alarm_sysinfo = b_app_api.get_cfg({'alarm_in','alarm_out'})
	if('table' ~= type(alarm_sysinfo))then
		return 0;
	end	
	
	if (IN_SYSINFO == nil) then
		IN_SYSINFO = alarm_sysinfo.alarm_in;
	else
		util.copy_tab_b(IN_SYSINFO, alarm_sysinfo.alarm_in);	
	end
	if (OUT_SYSINFO == nil) then
		OUT_SYSINFO = alarm_sysinfo.alarm_out;
	else
		util.copy_tab_b(OUT_SYSINFO, alarm_sysinfo.alarm_out);	
	end
	updatelist(top, false);
end
	
w1_sysinfo_alarm.clear = function()
	IN_SYSINFO = nil
	OUT_SYSINFO = nil
end
	
w1_sysinfo_alarm.wnd = 
{
	t='wnd_bg',
	id=id,
	xywh = 's_sysinfo_ala_wnd_xywh',
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'},
	sub = {'alarm_list',},
	alarm_list	= {t='list',	id=id+2,	xywh='s_sysinfo_ala_alarm_list_xywh', font = 'f_grade4',
					listattr = {8,5,b_ui.LISTATTR.FIRST_WIDGET_STATIC,0},list_tip =true,
					title_texts = {'Channel', 'Name','Status','Stream','Channel',},
					columns_w = {108,122,108,118,148,},
		},
	
}
return w1_sysinfo_alarm;
