--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/3/20
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.sysinfo.channel_id
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_wnd 	= require("wnd.core.b_wnd")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_parser 	= require("wnd.core.b_parser")
local b_app_api = require("wnd.core.command.b_app_api");
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local util 		= require("wnd.core.util")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 	= r_size.get_size
local w1_sysinfo_channel = {
	cur_page = 0;
	total_page = 0;
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_sysinfo_channel.s_768 =
{
	s_sysinfo_ch_wnd_xywh = {2,46,478,423},
	s_sysinfo_ch_channel_list_xywh = {5,21,469,355},
	s_sysinfo_ch_page_up_xywh = {186,384,21,28},
	s_sysinfo_ch_page_xywh = {218,384,80,28},
	s_sysinfo_ch_page_down_xywh = {298,384,21,28},
	s_sysinfo_ch_chlist_w1 = {57,0,0,0},
	s_sysinfo_ch_chlist_w2 = {65,0,0,0},
	s_sysinfo_ch_chlist_w3 = {57,0,0,0},
	s_sysinfo_ch_chlist_w4 = {94,0,0,0},
	s_sysinfo_ch_chlist_w5 = {121,0,0,0},
	s_sysinfo_ch_chlist_w6 = {61,0,0,0},
	s_sysinfo_ch_chlist_w7 = {62,0,0,0},
};
	
w1_sysinfo_channel.s_1280 = 
{
	s_sysinfo_ch_wnd_xywh= {5,65,898,596},
	s_sysinfo_ch_channel_list_xywh= {10,30,880,500},
	s_sysinfo_ch_page_up_xywh= {340,540,40,40},
	s_sysinfo_ch_page_xywh= {395,540,150,40},
	s_sysinfo_ch_page_down_xywh= {550,540,40,40},
	s_sysinfo_ch_chlist_w1 = {108,0,0,0},
	s_sysinfo_ch_chlist_w2 = {122,0,0,0},
	s_sysinfo_ch_chlist_w3 = {108,0,0,0},
	s_sysinfo_ch_chlist_w4 = {178,0,0,0},
	s_sysinfo_ch_chlist_w5 = {228,0,0,0},
	s_sysinfo_ch_chlist_w6 = {116,0,0,0},
	s_sysinfo_ch_chlist_w7 = {118,0,0,0},

}
w1_sysinfo_channel.s_1440 = 
{
	s_sysinfo_ch_wnd_xywh= {5,65,898,596},
	s_sysinfo_ch_channel_list_xywh= {10,30,880,500},
	s_sysinfo_ch_page_up_xywh= {340,540,40,40},
	s_sysinfo_ch_page_xywh= {395,540,150,40},
	s_sysinfo_ch_page_down_xywh= {550,540,40,40},
	s_sysinfo_ch_chlist_w1 = {108,0,0,0},
	s_sysinfo_ch_chlist_w2 = {122,0,0,0},
	s_sysinfo_ch_chlist_w3 = {108,0,0,0},
	s_sysinfo_ch_chlist_w4 = {178,0,0,0},
	s_sysinfo_ch_chlist_w5 = {228,0,0,0},
	s_sysinfo_ch_chlist_w6 = {120,0,0,0},
	s_sysinfo_ch_chlist_w7 = {118,0,0,0},

}	
	
w1_sysinfo_channel.s_1080p = 
{
	s_sysinfo_ch_wnd_xywh= {5,65,898,596},
	s_sysinfo_ch_channel_list_xywh= {10,30,880,500},
	s_sysinfo_ch_page_up_xywh= {350,540,40,40},
	s_sysinfo_ch_page_xywh= {410,540,150,40},
	s_sysinfo_ch_page_down_xywh= {560,540,40,40},
	s_sysinfo_ch_chlist_w1 = {108,0,0,0},
	s_sysinfo_ch_chlist_w2 = {122,0,0,0},
	s_sysinfo_ch_chlist_w3 = {108,0,0,0},
	s_sysinfo_ch_chlist_w4 = {178,0,0,0},
	s_sysinfo_ch_chlist_w5 = {228,0,0,0},
	s_sysinfo_ch_chlist_w6 = {116,0,0,0},
	s_sysinfo_ch_chlist_w7 = {118,0,0,0},

}

w1_sysinfo_channel.s_2k = 
{
--	s_sysinfo_ch_wnd_xywh= {3,83,1197,794},
	s_sysinfo_ch_wnd_xywh= {7,87,1197,794},

	s_sysinfo_ch_channel_list_xywh= {13,40,1173,667},
	s_sysinfo_ch_page_up_xywh= {460,720,53,53},
	s_sysinfo_ch_page_xywh= {535,720,200,53},
	s_sysinfo_ch_page_down_xywh= {740,720,53,53},
	s_sysinfo_ch_chlist_w1 = {144,0,0,0},
	s_sysinfo_ch_chlist_w2 = {163,0,0,0},
	s_sysinfo_ch_chlist_w3 = {144,0,0,0},
	s_sysinfo_ch_chlist_w4 = {207,0,0,0},
	s_sysinfo_ch_chlist_w5 = {307,0,0,0},
	s_sysinfo_ch_chlist_w6 = {181,0,0,0},
	s_sysinfo_ch_chlist_w7 = {157,0,0,0},


}

w1_sysinfo_channel.s_4k = 
{
--	s_sysinfo_ch_wnd_xywh= {4,124,1796,1192},
	s_sysinfo_ch_wnd_xywh= {10,130,1796,1192},
	s_sysinfo_ch_channel_list_xywh= {20,60,1760,1000},
	s_sysinfo_ch_page_up_xywh= {690,1080,80,80},
	s_sysinfo_ch_page_xywh= {805,1080,300,80},
	s_sysinfo_ch_page_down_xywh= {1110,1080,80,80},
	s_sysinfo_ch_chlist_w1 = {216,0,0,0},
	s_sysinfo_ch_chlist_w2 = {244,0,0,0},
	s_sysinfo_ch_chlist_w3 = {216,0,0,0},
	s_sysinfo_ch_chlist_w4 = {376,0,0,0},
	s_sysinfo_ch_chlist_w5 = {446,0,0,0},
	s_sysinfo_ch_chlist_w6 = {232,0,0,0},
	s_sysinfo_ch_chlist_w7 = {236,0,0,0},
}
local channel_count;--豸ͨĿ
local CHANNEL_INFO = nil;

local updatelist = function(top, cur_page, redraw)
	if(cur_page == 0) then
		return 
	end
	local s_idx = (cur_page - 1) * 8 + 1;
	local e_idx = (cur_page - 1) * 8 + 8;
	num = CHANNEL_INFO.bind_chn_num;
	w1_sysinfo_channel.total_page = math.ceil(num/8);
	if(num < e_idx) then
		e_idx = num;
	end
	local displist = {};
	
	local idx = 0;
	for i=s_idx, e_idx do
		idx = idx + 1;
	
		local str = "CH"..tostring(CHANNEL_INFO.channel_id[i]);
		local status = STR('LA_OFFLINE');
		if(0 == CHANNEL_INFO.chn_status[i])then
			status = STR('LA_DISCONNECTED');
		elseif(1 == CHANNEL_INFO.chn_status[i])then
			status = STR('LA_OFFLINE');
		elseif(2 == CHANNEL_INFO.chn_status[i])then
			status = STR('LA_OFFLINE');
		elseif(3 == CHANNEL_INFO.chn_status[i])then
			status = STR('LA_OFFLINE');
		else
			status = STR('LA_ONLINE')
		end 
		local enctype="H.264/";
		if(1 == CHANNEL_INFO.stream1.enc_type[i])then
			enctype = "H.264/";
		elseif(2 == CHANNEL_INFO.stream1.enc_type[i])then
			enctype = "H.265/";
		else
			enctype = "H.264/";
		end
		if(1 == CHANNEL_INFO.stream2.enc_type[i])then
			enctype = enctype.."H.264";
		elseif(2 == CHANNEL_INFO.stream2.enc_type[i])then
			enctype = enctype.."H.265";
		else
			enctype = enctype.."H.264";
		end
		local reso = tostring(CHANNEL_INFO.stream1.with[i]).."*"..tostring(CHANNEL_INFO.stream1.height[i]).."/"
		reso = reso..tostring(CHANNEL_INFO.stream2.with[i]).."*"..tostring(CHANNEL_INFO.stream2.height[i])
		local bit = CHANNEL_INFO.stream1.bitrate[i].."/"..CHANNEL_INFO.stream2.bitrate[i]

		displist['idx'..idx] = {idx-1, false, 
		str,CHANNEL_INFO.channel_name[i],status,enctype,reso,bit
		};	
	end
	displist.item_total = idx;
	b_wnd_ex.set_listdata(top, w1_sysinfo_channel.wnd.channel_list.id, displist, redraw);	
end

local updatepage = function(top, cur_page, total_page, redraw)
	local cwnd = w1_sysinfo_channel.wnd;
	local page_str = tostring(cur_page)..'/'..tostring(total_page);
	b_wnd_ex.set_text(top, cwnd.page.id, page_str,redraw);
end

local on_pageup = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if(w1_sysinfo_channel.cur_page > 1) then
			w1_sysinfo_channel.cur_page = w1_sysinfo_channel.cur_page - 1;
		end
		updatepage(top, w1_sysinfo_channel.cur_page, w1_sysinfo_channel.total_page, true);
		updatelist(top, w1_sysinfo_channel.cur_page, true);
	end
	return 0;
end

local on_pagedown = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if(w1_sysinfo_channel.cur_page < w1_sysinfo_channel.total_page) then
			w1_sysinfo_channel.cur_page = w1_sysinfo_channel.cur_page + 1;
		end
		updatepage(top, w1_sysinfo_channel.cur_page, w1_sysinfo_channel.total_page, true);
		updatelist(top, w1_sysinfo_channel.cur_page, true);
	end
	return 0;
end

local on_page = function(top, win_id, vmsg, x, y)
	if b_ui.WM_USER_UPDATE_PARAM == vmsg then
		local sel = b_wnd_ex.get_sel(top, win_id);
		w1_sysinfo_channel.cur_page = sel + 1;
		updatepage(top, w1_sysinfo_channel.cur_page, w1_sysinfo_channel.total_page, true);
		updatelist(top, w1_sysinfo_channel.cur_page, true);
	end
	return 0;
end

w1_sysinfo_channel.on_pre_show = function(top)
	local cwnd = w1_sysinfo_channel.wnd;
	channel_count = global_val.get_channelnum();
	local param = {
			STR('LA_CHANNEL'), STR('LA_NAME'),STR('LA_STATUS'), STR('LA_VIDEO_ENCODE_TYPE'),STR('LA_RESOLUTION'),STR('LA_BITRATE')
		}
	b_wnd_ex.set_title_texts(top, cwnd.channel_list.id, param, false);
	local list_w = {};
		for i=1,7 do
			local str = 's_sysinfo_ch_chlist_w'..math.floor(i/1);
			list_w[i] = SIZE(str)[1];
		end
	b_wnd_ex.columns_w(top, cwnd.channel_list.id, list_w, false);
		
	local chn_info = b_app_api.get_channel_info();	
	if('table' ~= type(chn_info))then
		return 0;
	end	
	
	if (CHANNEL_INFO == nil) then
		CHANNEL_INFO = chn_info;
	else
		util.copy_tab_b(CHANNEL_INFO, chn_info);	
	end
		
	if(0 ~= CHANNEL_INFO.bind_chn_num)then
		w1_sysinfo_channel.cur_page = 1;
	end
	w1_sysinfo_channel.total_page = math.ceil(CHANNEL_INFO.bind_chn_num / 8);
	local page_str = tostring(w1_sysinfo_channel.cur_page)..'/'..tostring(w1_sysinfo_channel.total_page);
	b_wnd_ex.set_text(top, cwnd.page.id, page_str,false);
	updatelist(top, 1, false);
end
	
w1_sysinfo_channel.clear = function()
	CHANNEL_INFO = nil
end
	
w1_sysinfo_channel.wnd = 
{
	t='wnd_bg',
	id=id,
	xywh = 's_sysinfo_ch_wnd_xywh',
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'},
	sub = {'channel_list','page_up', 'page', 'page_down'},
	channel_list	= {t='list',	id=id+2,	xywh='s_sysinfo_ch_channel_list_xywh', font = 'f_grade6',
					listattr = {8,6,b_ui.LISTATTR.FIRST_WIDGET_STATIC,0},list_tip =true,
					title_texts = {'Channel', 'Name','Status','Stream','Encode type', 'Resolution','Bitrate'},
					columns_w = {108,122,108,118,148,148},
		},
		
	page_up 	= {t='tt_button',	id=id+3,	xywh='s_sysinfo_ch_page_up_xywh',		
					t_imgs = {b_ui.ALIGN.CENTER,'f_pageupdown','it_pageup','it_pageup', 'it_pageup'},
					color = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_f'},
					cmd = on_pageup},
					
	page 		= {t='combox',	id=id+4,	xywh='s_sysinfo_ch_page_xywh',		text='0/0',trans = false, 
					align = b_ui.ALIGN.CENTER, font = 'f_grade4',dlg_direct_up = true,
					t_imgs = {b_ui.ALIGN.LEFT,'f_column','it_null','it_null', 'it_null'},
					color = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_f'},
					cmd = on_page},
	page_down 	= {t='tt_button',id=id+5,	xywh='s_sysinfo_ch_page_down_xywh',
					t_imgs = {b_ui.ALIGN.CENTER,'f_pageupdown','it_pagedown','it_pagedown', 'it_pagedown'},
					color = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_n'},
					color_f = {'c_page_bk_n', 'c_page_bk_n', 'c_page_text_f'},
					cmd = on_pagedown},	
	
}

return w1_sysinfo_channel;