--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/3/20
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.sysinfo.disk_id
local b_app_api = require("wnd.core.command.b_app_api");
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local util 		= require("wnd.core.util")

local w1_sysinfo_disk = {
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}	

w1_sysinfo_disk.s_768 =
{
	s_sysinfo_disk_page_xywh = {2,46,478,423},
	s_sysinfo_disk_disk_list_xywh = {5,21,469,35},
	s_sysinfo_disk_disklist_w1 = {53,0,0,0},
	s_sysinfo_disk_disklist_w2 = {72,0,0,0},
	s_sysinfo_disk_disklist_w3 = {72,0,0,0},
	s_sysinfo_disk_disklist_w4 = {80,0,0,0},
	s_sysinfo_disk_disklist_w5 = {90,0,0,0},
	s_sysinfo_disk_disklist_w6 = {80,0,0,0},
};

w1_sysinfo_disk.s_1280 = 
{
	s_sysinfo_disk_page_xywh= {5,65,898,596},
	s_sysinfo_disk_disk_list_xywh= {10,30,880,50},
	s_sysinfo_disk_disklist_w1 = {100,0,0,0},
	s_sysinfo_disk_disklist_w2 = {135,0,0,0},
	s_sysinfo_disk_disklist_w3 = {135,0,0,0},
	s_sysinfo_disk_disklist_w4 = {150,0,0,0},
	s_sysinfo_disk_disklist_w5 = {170,0,0,0},
	s_sysinfo_disk_disklist_w6 = {150,0,0,0},
}
w1_sysinfo_disk.s_1440 = 
{
	s_sysinfo_disk_page_xywh= {5,65,898,596},
	s_sysinfo_disk_disk_list_xywh= {10,30,880,50},
	s_sysinfo_disk_disklist_w1 = {100,0,0,0},
	s_sysinfo_disk_disklist_w2 = {135,0,0,0},
	s_sysinfo_disk_disklist_w3 = {135,0,0,0},
	s_sysinfo_disk_disklist_w4 = {150,0,0,0},
	s_sysinfo_disk_disklist_w5 = {170,0,0,0},
	s_sysinfo_disk_disklist_w6 = {150,0,0,0},
}	
	
w1_sysinfo_disk.s_1080p = 
{
	s_sysinfo_disk_page_xywh= {5,65,898,596},
	s_sysinfo_disk_disk_list_xywh= {10,30,880,50},
	s_sysinfo_disk_disklist_w1 = {100,0,0,0},
	s_sysinfo_disk_disklist_w2 = {135,0,0,0},
	s_sysinfo_disk_disklist_w3 = {135,0,0,0},
	s_sysinfo_disk_disklist_w4 = {150,0,0,0},
	s_sysinfo_disk_disklist_w5 = {170,0,0,0},
	s_sysinfo_disk_disklist_w6 = {150,0,0,0},
}

w1_sysinfo_disk.s_2k = 
{
	s_sysinfo_disk_page_xywh= {7,87,1197,794},
	s_sysinfo_disk_disk_list_xywh= {13,40,1173,67},
	s_sysinfo_disk_disklist_w1 = {133,0,0,0},
	s_sysinfo_disk_disklist_w2 = {180,0,0,0},
	s_sysinfo_disk_disklist_w3 = {180,0,0,0},
	s_sysinfo_disk_disklist_w4 = {200,0,0,0},
	s_sysinfo_disk_disklist_w5 = {227,0,0,0},
	s_sysinfo_disk_disklist_w6 = {197,0,0,0},

}

w1_sysinfo_disk.s_4k = 
{
	s_sysinfo_disk_page_xywh= {10,130,1796,1192},
	s_sysinfo_disk_disk_list_xywh= {20,60,1760,100},
	s_sysinfo_disk_disklist_w1 = {200,0,0,0},
	s_sysinfo_disk_disklist_w2 = {270,0,0,0},
	s_sysinfo_disk_disklist_w3 = {270,0,0,0},
	s_sysinfo_disk_disklist_w4 = {300,0,0,0},
	s_sysinfo_disk_disklist_w5 = {340,0,0,0},
	s_sysinfo_disk_disklist_w6 = {300,0,0,0},

}

local DISK_INFO = nil;

local updatelist = function(top, cur_page, redraw)
	if(cur_page == 0) then
		return ;
	end
	local s_idx =1;
	local e_idx =0;
	if((DISK_INFO.disk_num ~= 0) and (DISK_INFO.disk_num ~= 1))then
		s_idx = 1;
		e_idx =DISK_INFO.disk_num;
	elseif (DISK_INFO.disk_num == 1)then
		s_idx = 1;
		e_idx =1;
	else
		s_idx = 1;
		e_idx =0;
	end
	local displist = {};
	
	local idx = 0;
	for i=s_idx, e_idx do
		idx = idx + 1;
		
		local disk_id = DISK_INFO.disk_id[i]+1;
		local temp =  math.floor(DISK_INFO.size[i]/1000);
		local capcity = nil;
		if(temp <1000)then
			capcity = tostring(temp).." GB";
		else
			temp = math.floor(temp/1000);
			capcity = tostring(temp).." TB";
		end
	
		local used =nil;
	
		temp = math.floor(DISK_INFO.used[i]/1000);
		--[[if(temp > 1000) then
			temp = temp/1000;
			used = string.format("%.1f", temp).." TB";
		else--]]
			if(temp >=1)then
				used = tostring(temp).." GB";
			else
				temp = math.floor(DISK_INFO.used[i]);
				used = tostring(temp).." MB";
			end
	--	end
		
		local status = nil;
		if(1 == DISK_INFO.status[i])then
			status = STR('LA_NORMAL');
		elseif(2 == DISK_INFO.status[i]) then
			status = STR('LA_NEED_FORMAT');
		elseif(4 == DISK_INFO.status[i])then
			status = STR('LA_DISK_ERROR');
		elseif(8 == DISK_INFO.status[i]) then
			status = STR('LA_FULL_DISK');			
		elseif(65 == DISK_INFO.status[i]) then
			status = STR('LA_NORMAL');
		elseif(66 == DISK_INFO.status[i]) then
			status = STR('LA_WARNING');	
		elseif(67 == DISK_INFO.status[i]) then
			status = STR('LA_DESTROYED');
		elseif(68 == DISK_INFO.status[i]) then
			status = STR('LA_RECOVER');
		elseif(69 == DISK_INFO.status[i]) then
			status = STR('LA_LOAD_FAIL');
		else
			status = STR('LA_DISK_ERROR');
		end
		displist['idx'..idx] = {idx-1, false, 
		DISK_INFO.name[i],capcity,used,DISK_INFO.sn[i],DISK_INFO.model[i],status,
		};	
	end
	displist.item_total = idx;
	b_wnd_ex.set_listdata(top, w1_sysinfo_disk.wnd.disk_list.id, displist, redraw);	
end

w1_sysinfo_disk.on_pre_show = function(top)
	local cwnd = w1_sysinfo_disk.wnd;
	id = w1_id.sysinfo.disk_id;
	local dis_info = b_app_api.get_disk_info();
	if (DISK_INFO == nil) then
		DISK_INFO = dis_info;
	else
		util.copy_tab_b(DISK_INFO, dis_info);	
	end	
	
	local list_num = DISK_INFO.disk_num;
	if (list_num > 10) then
		list_num = 10
	end	
	
	if(list_num ==nil)then
		list_num = 0;
	end
	local wndsize = SIZE('s_sysinfo_disk_disk_list_xywh');
	local movepos = {wndsize[1],wndsize[2],wndsize[3],wndsize[4]*(1+list_num)};
	b_wnd_ex.move_ex(top, cwnd.disk_list.id, movepos, false);
	local listattr = {list_num,6,b_ui.LISTATTR.FIRST_WIDGET_STATIC,0};
	b_wnd_ex.set_listattr(top, cwnd.disk_list.id, listattr, false);
	
	local param = {
			STR('LA_DISK_T'), STR('LA_CAPACITY'),STR('LA_USED'), STR('LA_SN'),STR('LA_DISK_MODEL'),STR('LA_STATUS')
		}
	b_wnd_ex.set_title_texts(top, cwnd.disk_list.id, param, false);
	
	local list_w = {};
		for i=1,6 do
			local str = 's_sysinfo_disk_disklist_w'..math.floor(i/1);
			list_w[i] = SIZE(str)[1];
		end
	b_wnd_ex.columns_w(top, cwnd.disk_list.id, list_w, false);
	
	updatelist(top,1,false);
end

w1_sysinfo_disk.clear = function()
	DISK_INFO = nil
end

w1_sysinfo_disk.wnd = 
{
	t='wnd_bg',
	id=id,
	xywh = 's_sysinfo_disk_page_xywh',
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'},
	sub = {'disk_list'},
	disk_list= {t='list',	id=id+2,	xywh='s_sysinfo_disk_disk_list_xywh', font = 'f_grade4',
		listattr = {6,6,b_ui.LISTATTR.FIRST_WIDGET_STATIC,0},list_tip =true,list_resort={4,5},
		title_texts = {'Disk', 'Capacity','Used','SN','Model','Status'},
	--	title_texts = {'disk', 'size','used','sn','LA_DISK_MODEL','state'},
		columns_w = {110,150,150,110,170,170},
	},
}
return w1_sysinfo_disk;
