
--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/3/20
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.sysinfo.network_id
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_app_api = require("wnd.core.command.b_app_api");
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 	= r_size.get_size
local w1_sysinfo_network = {
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}	

w1_sysinfo_network.s_768 =
{
	s_sysinfo_network_t_xywh = {2,46,478,423},
	s_sysinfo_network_list_xywh = {5,21,469,355},
	s_sysinfo_network_list_w1 = {149,0,0,0},
	s_sysinfo_network_list_w2 = {128,0,0,0},
	s_sysinfo_network_list_w3 = {149,0,0,0},
	s_sysinfo_network_list_leftw1 = {10,0,0,0},
	s_sysinfo_network_list_leftw2 = {10,0,0,0},
	s_sysinfo_network_list_leftw3 = {10,0,0,0},
};
	
w1_sysinfo_network.s_1280 = 
{
	s_sysinfo_network_t_xywh= {5,65,898,596},
	s_sysinfo_network_list_xywh = {10,30,880,500},
	s_sysinfo_network_list_w1 ={280,0,0,0}, 
	s_sysinfo_network_list_w2 ={240,0,0,0}, 
	s_sysinfo_network_list_w3 ={280,0,0,0},
	s_sysinfo_network_list_leftw1 ={20,0,0,0}, 
	s_sysinfo_network_list_leftw2 ={20,0,0,0}, 
	s_sysinfo_network_list_leftw3 ={20,0,0,0},
}
w1_sysinfo_network.s_1440 = 
{
	s_sysinfo_network_t_xywh= {5,65,898,596},
	s_sysinfo_network_list_xywh = {10,30,880,500},
	s_sysinfo_network_list_w1 ={280,0,0,0}, 
	s_sysinfo_network_list_w2 ={240,0,0,0}, 
	s_sysinfo_network_list_w3 ={280,0,0,0},
	s_sysinfo_network_list_leftw1 ={20,0,0,0}, 
	s_sysinfo_network_list_leftw2 ={20,0,0,0}, 
	s_sysinfo_network_list_leftw3 ={20,0,0,0},
}
w1_sysinfo_network.s_1080p = 
{
	s_sysinfo_network_t_xywh= {5,65,898,596},
	s_sysinfo_network_list_xywh = {10,30,880,500},
	s_sysinfo_network_list_w1 ={280,0,0,0}, 
	s_sysinfo_network_list_w2 ={240,0,0,0}, 
	s_sysinfo_network_list_w3 ={280,0,0,0},
	s_sysinfo_network_list_leftw1 ={20,0,0,0}, 
	s_sysinfo_network_list_leftw2 ={20,0,0,0}, 
	s_sysinfo_network_list_leftw3 ={20,0,0,0},
}

w1_sysinfo_network.s_2k = 
{
	s_sysinfo_network_t_xywh= {7,87,1197,794},
	s_sysinfo_network_list_xywh = {13,40,1173,667},
	s_sysinfo_network_list_w1 ={373,0,0,0}, 
	s_sysinfo_network_list_w2 ={320,0,0,0}, 
	s_sysinfo_network_list_w3 ={373,0,0,0},
	s_sysinfo_network_list_leftw1 ={27,0,0,0}, 
	s_sysinfo_network_list_leftw2 ={27,0,0,0}, 
	s_sysinfo_network_list_leftw3 ={27,0,0,0},
}

w1_sysinfo_network.s_4k = 
{
	s_sysinfo_network_t_xywh= {10,130,1796,1192},
	s_sysinfo_network_list_xywh = {20,60,1760,1000},
	s_sysinfo_network_list_w1 ={560,0,0,0}, 
	s_sysinfo_network_list_w2 ={480,0,0,0}, 
	s_sysinfo_network_list_w3 ={560,0,0,0}, 
	s_sysinfo_network_list_leftw1 ={40,0,0,0}, 
	s_sysinfo_network_list_leftw2 ={40,0,0,0}, 
	s_sysinfo_network_list_leftw3 ={40,0,0,0},
}

local updatelist = function(top, redraw)
	local cwnd = w1_sysinfo_network.wnd;
	local device_info = b_app_api.get_device_info();
	local cfg_network = b_app_api.get_network_info();
	local num =2;
	local title_hide =true;

	if(2 == device_info.nic_num)then
		num =3;
		title_hide = false;
		local param = {
			"", STR('LA_LOCAL_NETWORK'),STR('LA_IPV4_CCTV')
		}
		b_wnd_ex.set_title_texts(top, cwnd.net_list.id, param, false);
	end

	local listattr = {10,num,b_ui.LISTATTR.FIRST_WIDGET_STATIC,0,title_hide};
	b_wnd_ex.set_listattr(top, cwnd.net_list.id, listattr, false);
	
	local list_w = {};
	for i=1,num do
		local str = 's_sysinfo_network_list_w'..i;
		list_w[i] = SIZE(str)[1];
	end
	b_wnd_ex.columns_w(top, cwnd.net_list.id, list_w, false);
	
	for i=1,num do
		local str = 's_sysinfo_network_list_leftw'..i;
		list_w[i] = SIZE(str)[1];
	end
	b_wnd_ex.set_left_w(top, cwnd.net_list.id, list_w, false);


	local idx = 10;
	local s_idx =1;
	local e_idx =1;
	
	local displist = {};
	local net_key ={};
	local net_param ={};
	local cctv_param ={};
	table.insert(net_key, STR('LA_STATUS'));
	if(cfg_network.lan)then
		table.insert(net_param, STR('LA_ONLINE'));
	else
		table.insert(net_param, STR('LA_OFFLINE'));
	end
	table.insert(net_key, STR('LA_IP_ADDRESS'));
	table.insert(net_param, cfg_network.ip);
	
	table.insert(net_key, STR('LA_SUBNET_MASK'));
	table.insert(net_param, cfg_network.netmask);
	
	table.insert(net_key, STR('LA_GATEWAY'));
	table.insert(net_param, cfg_network.gateway );
	
	table.insert(net_key, STR('LA_MAC_ADDRESS'));
	table.insert(net_param, cfg_network.dev_mac );
	
	table.insert(net_key, STR('LA_DHCP'));
	if(cfg_network.dhcp)then
		table.insert(net_param, STR("LA_ON"));
	else
		table.insert(net_param, STR("LA_OFF"));
	end
	
	table.insert(net_key, STR('LA_DNS1'));
	table.insert(net_param, cfg_network.dns1 );
	
	table.insert(net_key, STR('LA_DNS2'));
	table.insert(net_param, cfg_network.dns2 );
	
	table.insert(net_key, STR('LA_TOTAL_BANDWIDTH'));
	local total_net = cfg_network.total
	total_net = tostring(string.format("%0.2f", total_net)).." Mbps";
	table.insert(net_param, total_net);
	
	table.insert(net_key, STR('LA_USED_BANDWIDTH'));
	local info=b_app_api.get_net_flow("eth0");
	local unit_str = "bps";
	local used_net = info['rec'];
	if (info['rec'] > 1024 * 1024)then
		unit_str = "Mbps";
		used_net = math.floor(info['rec'])/(1024 * 1024);
	elseif (info['rec'] > 1024) then
		unit_str = "Kbps";
		used_net = math.floor(info['rec'])/1024;
	end
	
	used_net = tostring(string.format("%0.2f", used_net))..' '..unit_str;
	table.insert(net_param, used_net );
	
	if(2 == device_info.nic_num)then	
		for i =1,10 do
			table.insert(cctv_param,"")
		end
		
		local net_cctv = b_app_api.get_cfg({'network_cctv'}).network_cctv
		table.insert(cctv_param,2,net_cctv.ip);
		table.insert(cctv_param,3,net_cctv.netmask);
		table.insert(cctv_param,4,net_cctv.gateway );
		table.insert(cctv_param,5,device_info.dev_mac1 );
	end
	
	
	for i=s_idx, e_idx do
		for i=1,#net_key do
			displist['idx'..i] = {i-1, false, net_key[i],net_param[i],cctv_param[i]};	
		end 
		
	end
	displist.item_total = idx;
	b_wnd_ex.set_listdata(top, w1_sysinfo_network.wnd.net_list.id, displist, redraw);	
end

w1_sysinfo_network.timer_start = function()
	w1_sysinfo_network.timestart = true
end

w1_sysinfo_network.timer_stop = function(top)
	w1_sysinfo_network.timestart = false
	w1_wnd_util.clearerrweight(top, false)
end

w1_sysinfo_network.timerenevt = function(top)
	if(w1_sysinfo_network.timestart) then
		updatelist(top,true);
	end
	return 0
end

w1_sysinfo_network.on_pre_show  = function(top)
	updatelist(top,false);
	return 0;
end

w1_sysinfo_network.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_sysinfo_network_t_xywh',
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'},
	
	sub = {	'net_list','cap_lan','t_lan','cap_ip','t_ip', 'cap_netmask','t_netmask',  'cap_gateway', 't_gateway',
			 'cap_dns1', 't_dns1', 'cap_mac', 't_mac',
			'cap_dhcp', 't_dhcpn', 'cap_dns2', 't_dns2', 
			'cap_total_net', 't_total_net', 'cap_used_net', 't_used_net'},
	net_list= {t='list',	id=id+2,	xywh='s_sysinfo_network_list_xywh', font = 'f_grade4',
		listattr = {0,3,b_ui.LISTATTR.FIRST_WIDGET_STATIC,0},list_align =b_ui.ALIGN.LEFT,
		title_texts = {'', 'ipv4','LA_IPV4_CCTV'},list_tip =true,
		columns_w = {280,280,280},
		left_w = {20,20,20},
		columns_align = {b_ui.ALIGN.LEFT, b_ui.ALIGN.LEFT, b_ui.ALIGN.LEFT},
	},
}


return w1_sysinfo_network;