--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/3/22
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_jump	= require("wnd.w1_cfg.w1_wnd_jump")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.sysinfo.row_id
local b_dlg 		= require("wnd.core.b_dlg")
local w1_sysinfo_system 	= require("wnd.w1_live.w1_sysinfo_system")
local w1_sysinfo_network 	= require("wnd.w1_live.w1_sysinfo_network")
local w1_sysinfo_channel 	= require("wnd.w1_live.w1_sysinfo_channel")
local w1_sysinfo_disk 		= require("wnd.w1_live.w1_sysinfo_disk")
local w1_sysinfo_alarm 		= require("wnd.w1_live.w1_sysinfo_alarm")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 	= r_size.get_size
local b_wnd 	= require("wnd.core.b_wnd")
local global_val= require("wnd.global_val")

local w1_sysinfo_row = {
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}	

w1_sysinfo_row.s_768 =
{
	s_sysinfo_row_t_xywh = {2,3,477,35},
	s_sysinfo_row_network_xywh = {26,0,80,35},
	s_sysinfo_row_system_xywh = {106,0,80,35},
	s_sysinfo_row_channel_xywh = {186,0,80,35},
	s_sysinfo_row_disk_xywh = {266,0,80,35},
	s_sysinfo_row_alarm_xywh = {346,0,80,35},
	s_sysinfo_row_close_xywh = {442,7,26,28},
};
	
w1_sysinfo_row.s_1280 = 
{
	s_sysinfo_row_t_xywh= {5,5,896,50},
	s_sysinfo_row_network_xywh= {50,0,150,50},
	s_sysinfo_row_system_xywh= {200,0,150,50},
	s_sysinfo_row_channel_xywh= {350,0,150,50},
	s_sysinfo_row_disk_xywh= {500,0,150,50},
	s_sysinfo_row_alarm_xywh= {650,0,150,50},
	s_sysinfo_row_close_xywh= {830,10,50,40},
}
w1_sysinfo_row.s_1440 = 
{
	s_sysinfo_row_t_xywh= {5,5,896,50},
	s_sysinfo_row_network_xywh= {50,0,150,50},
	s_sysinfo_row_system_xywh= {200,0,150,50},
	s_sysinfo_row_channel_xywh= {350,0,150,50},
	s_sysinfo_row_disk_xywh= {500,0,150,50},
	s_sysinfo_row_alarm_xywh= {650,0,150,50},
	s_sysinfo_row_close_xywh= {830,10,50,40},
}

w1_sysinfo_row.s_1080p = 
{
	s_sysinfo_row_t_xywh= {5,5,896,50},
	s_sysinfo_row_network_xywh= {50,0,150,50},
	s_sysinfo_row_system_xywh= {200,0,150,50},
	s_sysinfo_row_channel_xywh= {350,0,150,50},
	s_sysinfo_row_disk_xywh= {500,0,150,50},
	s_sysinfo_row_alarm_xywh= {650,0,150,50},
	s_sysinfo_row_close_xywh= {830,10,50,40},
}

w1_sysinfo_row.s_2k = 
{
	s_sysinfo_row_t_xywh= {7,7,1194,67},
	s_sysinfo_row_network_xywh= {67,0,200,67},
	s_sysinfo_row_system_xywh= {267,0,200,67},
	s_sysinfo_row_channel_xywh= {467,0,200,67},
	s_sysinfo_row_disk_xywh= {667,0,200,67},
	s_sysinfo_row_alarm_xywh= {867,0,200,67},
	s_sysinfo_row_close_xywh= {1106,13,67,53},
}

w1_sysinfo_row.s_4k = 
{

	s_sysinfo_row_t_xywh= {10,10,1792,100},
	s_sysinfo_row_network_xywh= {100,0,300,100},
	s_sysinfo_row_system_xywh= {400,0,300,100},
	s_sysinfo_row_channel_xywh= {700,0,300,100},
	s_sysinfo_row_disk_xywh= {1000,0,300,100},
	s_sysinfo_row_alarm_xywh= {1300,0,300,100},
	s_sysinfo_row_close_xywh= {1660,20,100,80},
}


local on_close = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_dlg.end_modal(top)
	end
	return 0;
end

local on_network = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_sysinfo_row.wnd, win_id, true);
		w1_sysinfo_network.on_pre_show(top);
	end
	return 0;
end

local on_system = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_sysinfo_row.wnd, win_id, true);
		w1_sysinfo_system.on_pre_show(top);
	end
	return 0;
end


local on_channel = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_sysinfo_row.wnd, win_id, true);
		w1_sysinfo_channel.on_pre_show(top);
	end
	return 0;
end

local on_disk = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_sysinfo_row.wnd, win_id, true);
		w1_sysinfo_disk.on_pre_show(top);
	end
	return 0;
end

local on_alarm = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_jump.click_row(top, w1_sysinfo_row.wnd, win_id, true);
		w1_sysinfo_alarm.on_pre_show(top);
	end
	return 0;
end

w1_sysinfo_row.move_title_show =function(top)
	local cwnd = w1_sysinfo_row.wnd;
	local pos = SIZE('s_sysinfo_row_t_xywh');
	local title_w =pos[3]-pos[4] 
	local size1 = b_wnd_ex.get_textsize(top, cwnd.network.id).w;
	local size2 = b_wnd_ex.get_textsize(top, cwnd.system.id).w;
	local size3 = b_wnd_ex.get_textsize(top, cwnd.channel.id).w;
	local size4 = b_wnd_ex.get_textsize(top, cwnd.disk.id).w;
	local size5 = b_wnd_ex.get_textsize(top, cwnd.alarm.id).w;
	local space = b_wnd_ex.get_textsize(top, cwnd.network.id).border * 60 ;--
	local total_w = size1 +size2+size3+size4+size5 +space*5
	local title_1 = SIZE('s_sysinfo_row_network_xywh')

	if(title_w > total_w)then
		local movepos1 = {title_1[1],title_1[2],size1,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.network.id, movepos1, false);
		local movepos2 = {title_1[1]+size1+space,title_1[2],size2,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.system.id, movepos2, false);
		local movepos3 = {title_1[1]+size1+size2+2*space,title_1[2],size3,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.channel.id, movepos3, false);
		local movepos4 = {title_1[1]+size1+size2+size3+3*space,title_1[2],size4,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.disk.id, movepos4, false);
		local movepos5 = {title_1[1]+size1+size2+size3+size4+4*space,title_1[2],size5,title_1[4]};
		b_wnd_ex.move_ex(top, cwnd.alarm.id, movepos5, false);
	end
end

w1_sysinfo_row.on_pre_show=function(top)
	w1_sysinfo_row.move_title_show(top)
	local pb_flag = global_val.get_playback_support();	
	local cwnd = w1_sysinfo_row.wnd;
	if (pb_flag ~= true) then
		b_wnd_ex.set_hide(top, cwnd.disk.id, true, false);
		local pos = b_wnd.get_wnd_a_rect(top, cwnd.disk.id);
		b_wnd_ex.move_pos(top, cwnd.alarm.id, {pos[1], pos[2]}, false);
	end
	
	local ai_num = global_val.get_sinum();
	local ro_num = global_val.get_ronum();
	if (ai_num <= 0 and ro_num <= 0) then
		b_wnd_ex.set_hide(top, cwnd.alarm.id, true, false);
	end
end

w1_sysinfo_row.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_sysinfo_row_t_xywh',
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_cfg_row_bk'}, 
	sub = { 'network','system', 'channel', 'disk','alarm','close'},

	network= {t='checktxt',	id=id+1,xywh='s_sysinfo_row_network_xywh',	text='LA_NETWORK',	font = 'f_grade4',cmd=on_network,check = true,
			align = b_ui.ALIGN.CENTER,color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_c = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_cfg_title_txt_c'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}},
	system 	= {t='checktxt',	id=id+2,xywh='s_sysinfo_row_system_xywh',	text='LA_SYSTEM',		font = 'f_grade4',cmd=on_system,
			align = b_ui.ALIGN.CENTER,color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_c = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_cfg_title_txt_c'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}},
	channel 	= {t='checktxt',	id=id+3,xywh='s_sysinfo_row_channel_xywh',	text='LA_CHANNEL',	font = 'f_grade4',cmd=on_channel,
			align = b_ui.ALIGN.CENTER,color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_c = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_cfg_title_txt_c'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}},
	disk 	= {t='checktxt',	id=id+4,xywh='s_sysinfo_row_disk_xywh',	text='LA_DISK_CONFIG',		font = 'f_grade4',cmd=on_disk,
			align = b_ui.ALIGN.CENTER,color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_c = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_cfg_title_txt_c'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}},
	alarm 	= {t='checktxt',	id=id+5,xywh='s_sysinfo_row_alarm_xywh',	text='LA_ALARM',		font = 'f_grade4',cmd=on_alarm,
			align = b_ui.ALIGN.CENTER,color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'},color_c = {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_cfg_title_txt_c'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}},
	close = {t='tt_button',id=id+6,xywh='s_sysinfo_row_close_xywh',t_imgs = {b_ui.ALIGN.CENTER,'f_closebtn','it_close','it_close', 'it_close'},cmd =on_close,
					color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},color_f= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_f'},};
}

return w1_sysinfo_row;
