--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/3/20
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_id 	= require("wnd.w1_util.w1_id")
local b_app_api = require("wnd.core.command.b_app_api");
local id 		= w1_id.sysinfo.system_id
local w1_oem 	= require("wnd.w1_util.w1_oem")
local t_qr_ios = w1_oem.t_qr_ios;				-- [QR code]iosά
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 	= r_size.get_size
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_sysinfo_system = {
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}	
	
w1_sysinfo_system.s_768 =
{
	s_sysinfo_system_t_xywh = {2,46,478,423},
	s_sysinfo_system_cap_id_xywh = {42,21,149,35},
	s_sysinfo_system_t_id_xywh = {197,21,213,35},
	s_sysinfo_system_cap_name_xywh = {42,56,160,35},
	s_sysinfo_system_t_name_xywh = {197,56,213,35},
	s_sysinfo_system_cap_model_xywh = {42,92,149,35},
	s_sysinfo_system_t_model_xywh = {197,92,213,35},
	s_sysinfo_system_cap_sversion_xywh = {42,128,149,35},
	s_sysinfo_system_t_sversion_xywh = {197,128,213,35},
	s_sysinfo_system_cap_uboot_xywh = {42,163,149,35},
	s_sysinfo_system_t_uboot_xywh = {197,163,149,35},
	s_sysinfo_system_cap_kernel_xywh = {42,199,149,35},
	s_sysinfo_system_t_kernel_xywh = {197,199,149,35},
	s_sysinfo_system_cap_fdversion_xywh = {42,234,149,35},
	s_sysinfo_system_t_fdversion_xywh = {197,234,149,35},
	s_sysinfo_system_cap_p2p_xywh = {42,270,149,35},
	s_sysinfo_system_t_p2p_xywh = {197,270,149,35},
	s_sysinfo_system_p2p_id_xywh = {42,305,149,35},
	s_sysinfo_system_sn_xywh = {357,234,106,106},
	s_sysinfo_system_t_status_xywh = {197,305,157,35},
};

w1_sysinfo_system.s_1280 = 
{
	s_sysinfo_system_t_xywh= {5,65,898,596},
	s_sysinfo_system_cap_id_xywh= {80,30,280,50},
	s_sysinfo_system_t_id_xywh= {370,30,400,50},
	s_sysinfo_system_cap_name_xywh= {80,80,300,50},
	s_sysinfo_system_t_name_xywh= {370,80,400,50},
	s_sysinfo_system_cap_model_xywh= {80,130,280,50},
	s_sysinfo_system_t_model_xywh= {370,130,400,50},
	s_sysinfo_system_cap_sversion_xywh= {80,180,280,50},
	s_sysinfo_system_t_sversion_xywh= {370,180,400,50},	
	s_sysinfo_system_cap_uboot_xywh= {80,230,280,50},
	s_sysinfo_system_t_uboot_xywh= {370,230,280,50},
	s_sysinfo_system_cap_kernel_xywh= {80,280,280,50},
	s_sysinfo_system_t_kernel_xywh= {370,280,280,50},	
	s_sysinfo_system_cap_fdversion_xywh= {80,330,280,50},
	s_sysinfo_system_t_fdversion_xywh= {370,330,280,50},	
	s_sysinfo_system_cap_p2p_xywh= {80,380,280,50},
	s_sysinfo_system_t_p2p_xywh= {370,380,280,50},
	s_sysinfo_system_p2p_id_xywh= {80,430,280,50},
	s_sysinfo_system_sn_xywh= {670,330,200,200},
	s_sysinfo_system_t_status_xywh= {370,430,295,50},
}

w1_sysinfo_system.s_1440 = 
{
	s_sysinfo_system_t_xywh= {5,65,898,596},
	s_sysinfo_system_cap_id_xywh= {80,30,280,50},
	s_sysinfo_system_t_id_xywh= {370,30,400,50},
	s_sysinfo_system_cap_name_xywh= {80,80,300,50},
	s_sysinfo_system_t_name_xywh= {370,80,400,50},
	s_sysinfo_system_cap_model_xywh= {80,130,280,50},
	s_sysinfo_system_t_model_xywh= {370,130,400,50},
	s_sysinfo_system_cap_sversion_xywh= {80,180,280,50},
	s_sysinfo_system_t_sversion_xywh= {370,180,400,50},	
	s_sysinfo_system_cap_uboot_xywh= {80,230,280,50},
	s_sysinfo_system_t_uboot_xywh= {370,230,280,50},
	s_sysinfo_system_cap_kernel_xywh= {80,280,280,50},
	s_sysinfo_system_t_kernel_xywh= {370,280,280,50},	
	s_sysinfo_system_cap_fdversion_xywh= {80,330,280,50},
	s_sysinfo_system_t_fdversion_xywh= {370,330,280,50},	
	s_sysinfo_system_cap_p2p_xywh= {80,380,280,50},
	s_sysinfo_system_t_p2p_xywh= {370,380,280,50},
	s_sysinfo_system_p2p_id_xywh= {80,430,280,50},
	s_sysinfo_system_sn_xywh= {670,330,200,200},
	s_sysinfo_system_t_status_xywh= {370,430,295,50},
}

w1_sysinfo_system.s_1080p = 
{
	s_sysinfo_system_t_xywh= {5,65,898,596},
	s_sysinfo_system_cap_id_xywh= {80,30,280,50},
	s_sysinfo_system_t_id_xywh= {370,30,400,50},
	s_sysinfo_system_cap_name_xywh= {80,80,300,50},
	s_sysinfo_system_t_name_xywh= {370,80,400,50},
	s_sysinfo_system_cap_model_xywh= {80,130,280,50},
	s_sysinfo_system_t_model_xywh= {370,130,400,50},
	s_sysinfo_system_cap_sversion_xywh= {80,180,280,50},
	s_sysinfo_system_t_sversion_xywh= {370,180,400,50},	
	s_sysinfo_system_cap_uboot_xywh= {80,230,280,50},
	s_sysinfo_system_t_uboot_xywh= {370,230,280,50},
	s_sysinfo_system_cap_kernel_xywh= {80,280,280,50},
	s_sysinfo_system_t_kernel_xywh= {370,280,280,50},	
	s_sysinfo_system_cap_fdversion_xywh= {80,330,280,50},
	s_sysinfo_system_t_fdversion_xywh= {370,330,280,50},	
	s_sysinfo_system_cap_p2p_xywh= {80,380,280,50},
	s_sysinfo_system_t_p2p_xywh= {370,380,280,50},
	s_sysinfo_system_p2p_id_xywh= {80,430,280,50},
	s_sysinfo_system_sn_xywh= {670,330,200,200},
	s_sysinfo_system_t_status_xywh= {370,430,295,50},
}

w1_sysinfo_system.s_2k = 
{
	s_sysinfo_system_t_xywh={7,87,1197,794},
	s_sysinfo_system_cap_id_xywh={107,40,373,67},
	s_sysinfo_system_t_id_xywh={493,40,533,67},
	s_sysinfo_system_cap_name_xywh={107,107,400,67},
	s_sysinfo_system_t_name_xywh={493,107,533,67},
	s_sysinfo_system_cap_model_xywh={107,173,373,67},
	s_sysinfo_system_t_model_xywh={493,173,533,67},
	s_sysinfo_system_cap_sversion_xywh={107,240,373,67},
	s_sysinfo_system_t_sversion_xywh={493,240,533,67},
	s_sysinfo_system_cap_uboot_xywh={107,307,373,67},
	s_sysinfo_system_t_uboot_xywh={493,307,373,67},
	s_sysinfo_system_cap_kernel_xywh={107,373,373,67},
	s_sysinfo_system_t_kernel_xywh={493,373,373,67},
	s_sysinfo_system_cap_fdversion_xywh={107,440,373,67},
	s_sysinfo_system_t_fdversion_xywh={493,440,373,67},
	s_sysinfo_system_cap_p2p_xywh={107,507,373,67},
	s_sysinfo_system_t_p2p_xywh={493,507,393,67},
	s_sysinfo_system_p2p_id_xywh={107,574,373,67},
	s_sysinfo_system_sn_xywh={893,440,267,267},
	s_sysinfo_system_t_status_xywh={493,574,393,67},
}

w1_sysinfo_system.s_4k = 
{
	s_sysinfo_system_t_xywh={10,130,1796,1192},
	s_sysinfo_system_cap_id_xywh={160,60,560,100},
	s_sysinfo_system_t_id_xywh={740,60,800,100},
	s_sysinfo_system_cap_name_xywh={160,160,600,100},
	s_sysinfo_system_t_name_xywh={740,160,800,100},
	s_sysinfo_system_cap_model_xywh={160,260,560,100},
	s_sysinfo_system_t_model_xywh={740,260,800,100},
	s_sysinfo_system_cap_sversion_xywh={160,360,560,100},
	s_sysinfo_system_t_sversion_xywh={740,360,800,100},
	s_sysinfo_system_cap_uboot_xywh={160,460,560,100},
	s_sysinfo_system_t_uboot_xywh={740,460,560,100},
	s_sysinfo_system_cap_kernel_xywh={160,560,560,100},
	s_sysinfo_system_t_kernel_xywh={740,560,560,100},
	s_sysinfo_system_cap_fdversion_xywh={160,660,560,100},
	s_sysinfo_system_t_fdversion_xywh={740,660,560,100},	
	s_sysinfo_system_cap_p2p_xywh={160,760,560,100},
	s_sysinfo_system_t_p2p_xywh={740,760,590,100},
	s_sysinfo_system_p2p_id_xywh={160,860,560,100},
	s_sysinfo_system_sn_xywh={1340,660,400,400},
	s_sysinfo_system_t_status_xywh={740,860,590,100},
}

w1_sysinfo_system.on_pre_show = function(top)
	local function settext(id, str)
		b_wnd_ex.set_text(top, id, str,false);
	end
	local device_info = b_app_api.get_device_info();
	local face_support = global_val.get_support_face_attr();
	local cwnd = w1_sysinfo_system.wnd;
	settext(cwnd.t_id.id, device_info.dev_id);
	settext(cwnd.t_name.id, device_info.dev_name);
	settext(cwnd.t_model.id, device_info.dev_model);
	settext(cwnd.t_sversion.id, device_info.dev_fw_ver);
	settext(cwnd.t_uboot.id, device_info.uboot_ver );
	settext(cwnd.t_kernel.id, device_info.kernel_ver );
	settext(cwnd.sn.id, device_info.p2p_id);
	settext(cwnd.t_sn.id, device_info.p2p_id);
	settext(cwnd.t_face_version.id, device_info.face_detect_ver );

	if(1 == device_info.p2p_status)then
		b_wnd_ex.set_text(top, cwnd.t_p2p.id, STR('LA_ONLINE'),false);
	else
		b_wnd_ex.set_text(top, cwnd.t_p2p.id, STR('LA_OFFLINE'),false);
	end
		
	--֧汾Ϊַ 㷨汾	
	if (false == face_support or device_info.face_detect_ver == '')	then
		b_wnd_ex.set_hide (top, cwnd.cap_face_version.id, true, false);		
		b_wnd_ex.set_hide (top, cwnd.t_face_version.id, true, false);
		--
		local cap_p2p = SIZE('s_sysinfo_system_cap_fdversion_xywh');	
		local t_p2p = SIZE('s_sysinfo_system_t_fdversion_xywh');	
		local p2p_id = SIZE('s_sysinfo_system_cap_p2p_xywh');	
		local t_sn = SIZE('s_sysinfo_system_t_p2p_xywh');	
		b_wnd_ex.move_ex(top, cwnd.cap_p2p.id, cap_p2p, false);
		b_wnd_ex.move_ex(top, cwnd.t_p2p.id, t_p2p, false);
		b_wnd_ex.move_ex(top, cwnd.p2p_id.id, p2p_id, false);
		b_wnd_ex.move_ex(top, cwnd.t_sn.id, t_sn, false);
	end
	
	local p2p_support = global_val.get_p2p_support();
	if (false == p2p_support)	then
		b_wnd_ex.set_hide (top, cwnd.cap_p2p.id, true, false);		
		b_wnd_ex.set_hide (top, cwnd.t_p2p.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.p2p_id.id, true, false);		
		b_wnd_ex.set_hide (top, cwnd.sn.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_sn.id, true, false);
	end
	
end

w1_sysinfo_system.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_sysinfo_system_t_xywh',
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'},
	
	sub = {	'cap_id','t_id', 'cap_name', 't_name', 
			 'cap_model', 't_model', 'cap_sversion', 't_sversion','cap_uboot','t_uboot','cap_kernel','t_kernel', 'cap_face_version', 't_face_version','cap_p2p','t_p2p','p2p_id',
			'sn','t_sn'},
			
	cap_id 		= {t='static',id=id+1,	xywh='s_sysinfo_system_cap_id_xywh',text='LA_DEVICE_ID'},
	t_id 		= {t='static',id=id+2,	xywh='s_sysinfo_system_t_id_xywh',text='DVR8016134C04027',trans = false},
	cap_name	= {t='static',id=id+3,	xywh='s_sysinfo_system_cap_name_xywh',text='LA_DEVICE_NAME'},
	t_name 		= {t='static',id=id+4,	xywh='s_sysinfo_system_t_name_xywh',text='Device',trans = false},
	cap_model	= {t='static',id=id+5,	xywh='s_sysinfo_system_cap_model_xywh',text='LA_PRODUCT_MODEL'},
	t_model 	= {t='static',id=id+6,	xywh='s_sysinfo_system_t_model_xywh',text='ADR2304E1',trans = false},
	                                         
	cap_sversion= {t='static',id=id+7,	xywh='s_sysinfo_system_cap_sversion_xywh',text='LA_FIRMWARE'},
	t_sversion 	= {t='static',id=id+8,	xywh='s_sysinfo_system_t_sversion_xywh',text='v4.1.3.0.003.1.1',static_resort = true,trans = false},
	
	cap_uboot= {t='static',id=id+9,	xywh='s_sysinfo_system_cap_uboot_xywh',text='LA_U_BOOT'},
	t_uboot 	= {t='static',id=id+10,	xywh='s_sysinfo_system_t_uboot_xywh',text='0-0-0-0-0-0',static_resort = true,trans = false},
	
	cap_kernel= {t='static',id=id+11,	xywh='s_sysinfo_system_cap_kernel_xywh',text='LA_KERNEL_VERSION'},
	t_kernel 	= {t='static',id=id+12,	xywh='s_sysinfo_system_t_kernel_xywh',text='0-0-0-0-0-0',static_resort = true,trans = false},
	
	cap_face_version= {t='static',id=id+13,	xywh='s_sysinfo_system_cap_fdversion_xywh',text='LA_FD_VERSION'},
	t_face_version 	= {t='static',id=id+14,	xywh='s_sysinfo_system_t_fdversion_xywh',text='1741101',static_resort = true,trans = false},
	
	cap_p2p	= {t='static',id=id+15,	xywh='s_sysinfo_system_cap_p2p_xywh',text='LA_P2P_STATUS'},
	t_p2p 	= {t='static',id=id+16,	xywh='s_sysinfo_system_t_p2p_xywh',text='LA_OFFLINE'},
	
	p2p_id		= {t='static',id=id+17,	xywh='s_sysinfo_system_p2p_id_xywh',text='LA_P2P_ID'},
	sn			= {t='qr_code',id=id+18,xywh='s_sysinfo_system_sn_xywh',text=t_qr_ios,trans = false},
	t_sn 	= {t='static',id=id+19,	xywh='s_sysinfo_system_t_status_xywh',text='rj_default_sn',trans = false},--align = b_ui.ALIGN.CENTER,
};

return w1_sysinfo_system;