--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/7/3
-- author 
-- brief  򵼶Ի
--]]
local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.wizard.id
local w1_key 	= require("wnd.w1_util.w1_key")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local exit_flag = false;
local b_wnd_ex 	= require("wnd.core.b_wnd_ex") 
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 	= r_size.get_size
local global_val	= require("wnd.global_val")
local w1_wizard = {
	t = w1_key.DLG_WIZARD,
	top = nil,
	dlg = nil,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_wizard.s_768 =
{
	s_wizard_xywh = {394,206,234,355},
	s_wizard_title_xywh = {26,3,106,35},
	s_wizard_title_img_xywh = {5,3,21,35},
	s_wizard_close_xywh = {208,9,17,22},
	s_wizard_start_xywh = {64,284,106,35},
	s_wizard_line_xywh = {8,0,218,1},
	s_wizard_img_xywh = {37,56,160,213},
};

w1_wizard.s_1280 = 
{
	s_wizard_xywh		= {420,262,440,500},
	s_wizard_title_xywh = {50,5,200,50},
	s_wizard_title_img_xywh = {10,5,40,50},
	s_wizard_close_xywh = {390,13,32,32},
	s_wizard_start_xywh = {120,410,200,50},
	s_wizard_line_xywh	= {15,0,410,1},
	s_wizard_img_xywh 	= {70,80,300,300},
}
w1_wizard.s_1440 = 
{
	s_wizard_xywh		= {520,200,440,500},
	s_wizard_title_xywh = {50,5,200,50},
	s_wizard_title_img_xywh = {10,5,40,50},
	s_wizard_close_xywh = {390,13,32,32},
	s_wizard_start_xywh = {120,410,200,50},
	s_wizard_line_xywh	= {15,0,410,1},
	s_wizard_img_xywh 	= {70,80,300,300},
}

w1_wizard.s_1080p = 
{
	--s_wizard_network_xywh={0,50,850,780},
	s_wizard_xywh		= {740,290,440,500},
	s_wizard_title_xywh = {50,5,200,50},
	s_wizard_title_img_xywh = {10,5,40,50},	
	s_wizard_close_xywh = {390,13,32,32},
	s_wizard_start_xywh = {120,400,200,50},
	s_wizard_line_xywh	= {15,0,410,1},
	s_wizard_img_xywh 	= {70,80,300,300},
}

w1_wizard.s_2k = 
{
	s_wizard_xywh  = {987,387,587,666},
	s_wizard_title_xywh ={67,7,267,67},
	s_wizard_title_img_xywh ={13,7,53,67},
	s_wizard_close_xywh={520,17,43,43},

	s_wizard_start_xywh = {193,533,200,60},
	s_wizard_line_xywh	= {20,0,546,1},
	s_wizard_img_xywh 	= {93,107,400,400},
}

w1_wizard.s_4k = 
{
	s_wizard_xywh  = {1580,580,680,800},
	s_wizard_title_xywh ={100,10,400,100},
	s_wizard_title_img_xywh ={20,10,80,100},
	s_wizard_close_xywh={580,26,64,64},

	s_wizard_start_xywh = {220,620,240,80},
	s_wizard_line_xywh	= {30,0,820,2},
	s_wizard_img_xywh 	= {100,160,480,400},

}
local SAVE_TIME;

local on_start = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		SAVE_TIME = 60;
		return b_ui.WM_USER_POST_WIZARD;
	end
	return 0;
end

local okfunc_exit =function (param)
	exit_flag =true;
	return 0;
end

local on_close = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_EXIT_WIZARD'), true, true,false);
		w1_msgbox.set_func(okfunc_exit,{top}, nil, nil);
		b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
		if(exit_flag ==true)then
			local user_info = global_val.get_current_user_info();
			if (true ~= user_info.m_bisValid) then	--
				return b_ui_msg.msg_on_skip_reminder_pwd;
			else
				return b_ui_msg.msg_on_login_successful;
			end			
		end 
	end	
	return 0;
end

local on_dlg = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		SAVE_TIME = 60
		return 0;
	end
	if b_ui.TIMER == vmsg then
		if SAVE_TIME > 0 then
			SAVE_TIME = SAVE_TIME - 1;
		else
			--߿
			b_dlg.dlg_set_redraw(top);
		end
	end
	return 0;
end

local dlg = {
	attr = {xywh='s_wizard_xywh',cmd=on_dlg,timer={-1, 1000}},
	color_d= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfg_row_bk'},
	sub = {'title_img','title','close','wizard_img','start'},
	title_img= {t ='tt_button',id=id+1,xywh='s_wizard_title_img_xywh',
				t_imgs = {b_ui.ALIGN.LEFT,'f_image','it_wizard_title_img','it_wizard_title_img','it_wizard_title_img'},
				color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},
				color_f= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_n'},},
	title 		= {t='static',id=id+2,xywh='s_wizard_title_xywh',text='LA_START_WIZARD',align = b_ui.ALIGN.LEFT,
					color= {'c_cfg_row_bk', 'c_cfg_row_bk', 'c_txt_n'}
					};	
	close 		= {t='tt_button',id=id+3,xywh='s_wizard_close_xywh',t_imgs = {b_ui.ALIGN.LEFT,'f_closebtn2','it_close','it_close', 'it_close'}, cmd=on_close,
					color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_txt_f'},
					color_f= {'c_cfg_row_bk', 'c_cfg_row_bk','c_cfgclose_bk'}
					};
	wizard_img= {t ='tt_button',id=id+4,xywh='s_wizard_img_xywh',t_imgs = {b_ui.ALIGN.CENTER,'f_wizard_img','it_wizard_img','it_wizard_img','it_wizard_img'},
		color= {'c_cfg_row_bk', 'c_cfg_row_bk','c_wizard_img'},
		color_f= {'c_cfg_row_bk', 'c_cfg_row_bk','c_wizard_img'},},

	start  	= {t='button',	id=id+5,	xywh='s_wizard_start_xywh',		text='LA_START_WIZARD', font='f_grade7', cmd=on_start,
				color= { 'c_popdlg_ok_bk', 'c_popdlg_btn_border', 'c_popdlg_ok_text'},
				color_f= { 'c_popdlg_ok_bk_f', 'c_popdlg_btn_border_f', 'c_popdlg_ok_text_f'},
				};	
}


w1_wizard.on_create = function(top)
	w1_wizard.top = top;
	w1_wizard.dlg = dlg;
	b_parser(top, dlg);
	exit_flag =false;
	SAVE_TIME = 60;
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_run)	
	return 0;
end

w1_wizard.on_destroy = function(top)
	w1_wizard.top = nil;
	w1_wizard.dlg = nil;
	b_dlg.set_home_timer_type(top, b_ui_msg.home_timer_desk)	

	return 0;
end

w1_wizard.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top);
	local pos = SIZE('s_wizard_line_xywh');
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_row_bk'));
--	b_wnd.draw_fill(top, x+pos[1], y+pos[3], cx-2*pos[1], pos[4], COLOR('c_hline_color'));
	local pos = SIZE('s_post_border_with');
	if SAVE_TIME > 0 then
		b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
		b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	else
		b_wnd.draw_rect(top, x, y, cx, cy, COLOR('c_post_border3'),pos[3])
		b_wnd.draw_rect(top, x+pos[1], y+pos[1], cx-pos[2], cy-pos[2], COLOR('c_post_border2'),pos[1])
	end
	b_wnd.end_job(top);
	return 0;
end

w1_wizard.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.RBUTTONCLK == vmsg) then
		w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_EXIT_WIZARD'), true, true,false);
		w1_msgbox.set_func(okfunc_exit,{top}, nil, nil);
		b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
		if(exit_flag ==true)then
			local user_info = global_val.get_current_user_info();
			if (true ~= user_info.m_bisValid) then	--
				b_dlg.end_modal(top);
				return b_ui_msg.msg_on_skip_reminder_pwd;	
			else
				b_dlg.end_modal(top);
				return b_ui_msg.msg_on_login_successful;
			end
		end 
		SAVE_TIME = 60;		
		b_dlg.dlg_set_redraw(top);
	elseif(b_ui.WM_USER_POST_WIZARD == vmsg)then 
		b_dlg.end_modal(top)
		return b_ui.WM_USER_POST_WIZARD
	elseif (b_ui_msg.msg_on_skip_reminder_pwd == vmsg) then
		b_dlg.end_modal(top);
		return vmsg;	
	elseif (b_ui_msg.msg_on_login_successful == vmsg) then
		b_dlg.end_modal(top);
		return vmsg;	
	end
	return 0;
end

return w1_wizard;
