--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/7/4
-- author 
-- brief  
--]]
local global_val= require("wnd.global_val")
local b_ui 		= require("wnd.core.b_ui")
local b_dlg 	= require("wnd.core.b_dlg")
local b_app_api = require("wnd.core.command.b_app_api")
local b_wnd 	= require("wnd.core.b_wnd")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_id 	= require("wnd.w1_util.w1_id")
local w1_key 	= require("wnd.w1_util.w1_key")
local w1_msgbox = require("wnd.w1_util.w1_msgbox")
local id 		= w1_id.wizard_camera.id
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_legal 	= require("wnd.w1_util.w1_legal")
local w1_modify_camera	= require("wnd.w1_cfg.w1_modify_camera")
local r_size	= require("wnd.core.r_res.r_size")
local SIZE 		= r_size.get_size
local util 		= require("wnd.core.util")
local channel_num;--豸ͨĿ
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 

local w1_wizard_camera = {
	delete_all_flag = false,
	delete_signel_flag = false,
	del_sel,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_wizard_camera.s_768 =
{
	s_wizard_camera_xywh = {2,35,448,547},
	s_wizard_camera_camera_xywh = {10,14,160,35},
	s_wizard_camera_hline_xywh = {8,49,437,1},
	s_wizard_camera_chmanage_xywh = {16,56,426,177},
	s_wizard_camera_del_xywh = {128,248,80,28},
	s_wizard_camera_onekeyadd_xywh = {229,248,80,28},
	s_wizard_camera_search_xywh = {330,248,106,28},
	s_wizard_camera_devlist_xywh = {16,298,426,177},
	s_wizard_camera_cap_user_xywh = {16,497,64,28},
	s_wizard_camera_t_user_xywh = {90,497,80,28},
	s_wizard_camera_cap_pass_xywh = {181,497,64,28},
	s_wizard_camera_t_pass_xywh = {256,497,80,28},
	s_wizard_camera_add_xywh = {362,497,80,28},
	s_wizard_devlist_w1 = {21,0,0,0},
	s_wizard_devlist_w2 = {106,0,0,0},
	s_wizard_devlist_w3 = {64,0,0,0},
	s_wizard_devlist_w4 = {64,0,0,0},
	s_wizard_devlist_w5 = {148,0,0,0},
};

w1_wizard_camera.s_1280 = 
{
	s_wizard_camera_xywh ={3,50,840,770},
	s_wizard_camera_camera_xywh={20,20,300,50},
	s_wizard_camera_hline_xywh={15,70,820,2},
	s_wizard_camera_chmanage_xywh={30,80,800,250},
	s_wizard_camera_del_xywh={240,350,150,40},
	s_wizard_camera_onekeyadd_xywh={430,350,150,40},
	s_wizard_camera_search_xywh={620,350,200,40},
	s_wizard_camera_devlist_xywh={30,420,800,250},
	s_wizard_camera_cap_user_xywh={30,700,120,40}, 
	s_wizard_camera_t_user_xywh={170,700,150,40},
	s_wizard_camera_cap_pass_xywh={340,700,120,40},
	s_wizard_camera_t_pass_xywh={480,700,150,40},
	s_wizard_camera_add_xywh={680,700,150,40},
	s_wizard_devlist_w1 = {40,0,0,0},
	s_wizard_devlist_w2 = {200,0,0,0},
	s_wizard_devlist_w3 = {120,0,0,0},
	s_wizard_devlist_w4 = {120,0,0,0},
	s_wizard_devlist_w5 = {298,0,0,0},
}
w1_wizard_camera.s_1440 = 
{
	s_wizard_camera_xywh ={3,50,840,740},
	s_wizard_camera_camera_xywh={20,20,300,50},
	s_wizard_camera_hline_xywh={15,70,820,2},
	s_wizard_camera_chmanage_xywh={30,80,800,240},
	s_wizard_camera_del_xywh={240,340,150,40},
	s_wizard_camera_onekeyadd_xywh={430,340,150,40},
	s_wizard_camera_search_xywh={620,340,200,40},
	s_wizard_camera_devlist_xywh={30,400,800,240},
	s_wizard_camera_cap_user_xywh={30,660,120,40}, 
	s_wizard_camera_t_user_xywh={170,660,150,40},
	s_wizard_camera_cap_pass_xywh={340,660,120,40},
	s_wizard_camera_t_pass_xywh={480,660,150,40},
	s_wizard_camera_add_xywh={680,660,150,40},
	s_wizard_devlist_w1 = {40,0,0,0},
	s_wizard_devlist_w2 = {200,0,0,0},
	s_wizard_devlist_w3 = {120,0,0,0},
	s_wizard_devlist_w4 = {120,0,0,0},
	s_wizard_devlist_w5 = {298,0,0,0},
}
w1_wizard_camera.s_1080p = 
{
	s_wizard_camera_xywh ={3,50,840,770},
	s_wizard_camera_camera_xywh={20,20,300,50},
	s_wizard_camera_hline_xywh={15,70,820,2},
	s_wizard_camera_chmanage_xywh={30,80,800,250},
	s_wizard_camera_del_xywh={240,350,150,40}, 
	s_wizard_camera_onekeyadd_xywh={430,350,150,40},
	s_wizard_camera_search_xywh={620,350,200,40},
	s_wizard_camera_devlist_xywh={30,420,800,250},
	s_wizard_camera_cap_user_xywh={30,700,120,40}, 
	s_wizard_camera_t_user_xywh={170,700,150,40},
	s_wizard_camera_cap_pass_xywh={340,700,120,40},
	s_wizard_camera_t_pass_xywh={480,700,150,40},
	s_wizard_camera_add_xywh={680,700,150,40},
	s_wizard_devlist_w1 = {40,0,0,0},
	s_wizard_devlist_w2 = {200,0,0,0},
	s_wizard_devlist_w3 = {120,0,0,0},
	s_wizard_devlist_w4 = {120,0,0,0},
	s_wizard_devlist_w5 = {298,0,0,0},
}
w1_wizard_camera.s_2k = 
{
	s_wizard_camera_xywh ={4,67,1120,1026},
	s_wizard_camera_camera_xywh={27,27,400,67},
	s_wizard_camera_hline_xywh={20,93,1093,3},
	s_wizard_camera_chmanage_xywh={40,107,1066,333},
	s_wizard_camera_del_xywh={320,467,200,53},
	s_wizard_camera_onekeyadd_xywh={573,467,200,53},
	s_wizard_camera_search_xywh={827,467,267,53},
	s_wizard_camera_devlist_xywh={40,560,1066,333},
	s_wizard_camera_cap_user_xywh={40,933,160,53},
	s_wizard_camera_t_user_xywh={227,933,200,53},
	s_wizard_camera_cap_pass_xywh={454,933,160,53},
	s_wizard_camera_t_pass_xywh={640,933,200,53},
	s_wizard_camera_add_xywh={906,933,200,53},
	s_wizard_devlist_w1 = {53,0,0,0},
	s_wizard_devlist_w2 = {270,0,0,0},
	s_wizard_devlist_w3 = {160,0,0,0},
	s_wizard_devlist_w4 = {160,0,0,0},
	s_wizard_devlist_w5 = {374,0,0,0},

}
w1_wizard_camera.s_4k = 
{
	s_wizard_camera_xywh ={6,100,1680,1540},
	s_wizard_camera_camera_xywh={40,40,600,100},
	s_wizard_camera_hline_xywh={30,140,1640,4},
	s_wizard_camera_chmanage_xywh={60,160,1600,500},
	s_wizard_camera_del_xywh={480,700,300,80},
	s_wizard_camera_onekeyadd_xywh={860,700,300,80},
	s_wizard_camera_search_xywh={1240,700,400,80},
	s_wizard_camera_devlist_xywh={60,840,1600,500},
	s_wizard_camera_cap_user_xywh={60,1400,240,80},
	s_wizard_camera_t_user_xywh={340,1400,300,80},
	s_wizard_camera_cap_pass_xywh={680,1400,240,80},
	s_wizard_camera_t_pass_xywh={960,1400,300,80},
	s_wizard_camera_add_xywh={1360,1400,300,80},
	s_wizard_devlist_w1 = {80,0,0,0},
	s_wizard_devlist_w2 = {400,0,0,0},
	s_wizard_devlist_w3 = {240,0,0,0},
	s_wizard_devlist_w4 = {240,0,0,0},
	s_wizard_devlist_w5 = {596,0,0,0},

}

w1_wizard_camera.timestart = false;
w1_wizard_camera.searchlist = {};
w1_wizard_camera.searchstart = false;
w1_wizard_camera.searchcount = 0;
local cameralist_refresh = function(top, redraw)
	local cwnd = w1_wizard_camera.wnd;
	local param = b_app_api.get_cfg({'camera'}).camera;
	local camera_num = param.camera_num;
	local param_searchlist = {};
	local idx = 1;
	local i;
	
	local paramdata;
	local data = {};
	local trade_name = b_app_api.get_trade_name().name;
	if(trade_name == nil or trade_name == '') then
		trade_name = 'Private'
	end
	for i=1,camera_num do
		paramdata = param['idx'..i];
		local dataidx = 'idx'..idx;
		if(paramdata.binded == false) then
			if (data[dataidx] == nil) then
				data[dataidx] = paramdata;
			else
				util.copy_tab_b(data[dataidx], paramdata);
			end		
			if(param['idx'..i].device_type == 0)then
				data[dataidx].chtype = 'LOCAL'		--IPC
			elseif(param['idx'..i].device_type == 1) then
				data[dataidx].chtype = 'IPDOME'		
			elseif(param['idx'..i].device_type == 2) then
				data[dataidx].chtype = 'IPC'			
			else
				data[dataidx].chtype = 'Other'		
			end		
			
			if(paramdata.protocol == 0)then
				data[dataidx].protocol = 'Unkown';
			elseif(paramdata.protocol == 1)then
				data[dataidx].protocol = 'ONVIF';
			elseif(paramdata.protocol == 2)then
				data[dataidx].protocol = trade_name;
			elseif(paramdata.protocol == 3)then
				data[dataidx].protocol = 'Local';
			elseif(paramdata.protocol == 4)then
				data[dataidx].protocol = trade_name..'_SSL';
			end
			data[dataidx].address = paramdata.addr
			data[dataidx].addr = paramdata.addr..':'..paramdata.port
			data[dataidx].fw_ver = paramdata.fw_ver
			data[dataidx].model = param['idx'..i].model
			idx = idx + 1;
		end
	end
	
	if (w1_wizard_camera.searchlist == nil) then
		w1_wizard_camera.searchlist = data;
	else
		util.copy_tab_b(w1_wizard_camera.searchlist, data);
	end		
	
	local searchlist = {};
	searchlist.item_total = idx - 1;
	

	for i=1,searchlist.item_total do
		searchlist['idx'..i] = nil;
		searchlist['idx'..i] ={};
		
		local temp = {i-1, false, '', 
			data['idx'..i].addr, data['idx'..i].model,
			data['idx'..i].protocol, data['idx'..i].fw_ver};
		
		if (searchlist['idx'..i] == nil) then
			searchlist['idx'..i] = temp
		else
			util.copy_tab_b(searchlist['idx'..i], temp);	
		end	
	end
	b_wnd_ex.set_listdata(top, w1_wizard_camera.wnd.devlist.id, searchlist, redraw);

	if(w1_wizard_camera.delete_all_flag) then--ؼ·ɾťɾ
		local checktab = {};
		for i=1,channel_num do
			checktab[i] = false;
		end
		b_wnd_ex.set_selecechannel(top, cwnd.chmanage.id, checktab, false);
		w1_wizard_camera.delete_all_flag = false;
	end
	if(w1_wizard_camera.delete_signel_flag) then--ؼĵɾťɾ
		local checktab = {};
		local selecechannel = b_wnd_ex.get_selecechannel(top, cwnd.chmanage.id);
		for i=1, channel_num do
			if(selecechannel['ch'..i] == 1) then
				checktab[i] = true;
			else
				checktab[i] = false;
			end
		end		
		checktab[w1_wizard_camera.del_sel] = false;
		b_wnd_ex.set_selecechannel(top, cwnd.chmanage.id, checktab, false);	
		w1_wizard_camera.delete_signel_flag = false;
	end
end

local delete_all_channels = function(param)
	b_app_api.onekeyadd_camera(param[2]);
	cameralist_refresh(param[1], param[3]);
	w1_wizard_camera.delete_all_flag = true;
	return 0
end

local upgrade_all_channels = function(param)
	b_app_api.upgrade_cameras(param[2]);
	return 0
end

w1_wizard_camera.init = function(top)
	local camera_user_pwd = b_app_api.get_cfg({'camera_user_pwd'}).camera_user_pwd;
	local vi_num, dec_num = global_val.get_vi_dec_num();
	if (dec_num ~= channel_num) then --DVR 4+2ȵ豸 Ҫͨ
		local chn_type = b_app_api.get_cfg({'channel_type'}).channel_type;
		assert(type(chn_type) == 'table')
		local num = vi_num + dec_num;
		if (0 < vi_num and 0 < dec_num and 0 == chn_type.chn_type[vi_num + 1]) then --δͨ  4 + 2 δ ͨΪ4
			b_wnd_ex.set_chlistattr(top, w1_wizard_camera.wnd.chmanage.id, {7,vi_num,1}, false);
			num = vi_num;	
		end
		local chn_type_data = {};
		for i = 1, num do
			if (i <= vi_num) then
				chn_type_data[i] = chn_type.chn_type[i];
			else
				chn_type_data[i] = chn_type.chn_type[vi_num + 1];
			end
		end	
		
		b_wnd_ex.set_chlist_chtype(top, w1_wizard_camera.wnd.chmanage.id, chn_type_data, false);
	end
	b_wnd_ex.set_text(top, w1_wizard_camera.wnd.t_user.id,camera_user_pwd.account,false);
	b_wnd_ex.set_password(top, w1_wizard_camera.wnd.t_pass.id,camera_user_pwd.password,false);
	
	--һ
	w1_wizard_camera.searchstart = true
	w1_wizard_camera.searchcount = 41
	b_app_api.start_search_device();
	local time, float = math.modf(w1_wizard_camera.searchcount/2);
	local str = STR('LA_STOP_SEARCH') ..'('..time..'s)'
	b_wnd_ex.set_text(top,w1_wizard_camera.wnd.search.id,str,false);
	
	return 0;
end

local on_search = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if w1_wizard_camera.searchstart then
			w1_wizard_camera.searchstart = false
			w1_wizard_camera.searchcount = 0
			b_wnd_ex.set_text(top,w1_wizard_camera.wnd.search.id,STR('LA_START_SEARCH'),true);
		else
			w1_wizard_camera.searchstart = true
			w1_wizard_camera.searchcount = 41
			b_app_api.start_search_device();
		end		
	end
	return 0
end

local on_onekeyadd = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_wizard_camera.wnd;
		local param = b_app_api.get_cfg({'camera'}).camera;
		local camera_list = {};
		local listtotal = 0;
		for i=1,param.camera_num do	
			if(param['idx'..i].binded == false) then
				listtotal = listtotal + 1;
			end		
		end
		
		for i=1,listtotal do
			for j=i,param.camera_num do
				if(param['idx'..j].binded == false) then
					camera_list['idx'..i] = param['idx'..j];
					camera_list['idx'..i].binded = true;
					
					camera_list['idx'..i].account = b_wnd_ex.get_text(top, w1_wizard_camera.wnd.t_user.id);
					camera_list['idx'..i].password = b_wnd_ex.get_password(top, w1_wizard_camera.wnd.t_pass.id);
					camera_list['idx'..i].remote_cam =1;
					break
				end
			end
		end
		camera_list.camera_num = listtotal;
		local ret = true;
		local vi_num, dec_num = global_val.get_vi_dec_num();
		local count = channel_num
		local total_chn = channel_num;
		local local_chn = 0;
		local search_flag = false
		if (dec_num ~= channel_num) then --DVR 4+2ȵ豸 Ҫͨ
			count = 0;
			local chn_type = b_app_api.get_cfg({'channel_type'}).channel_type;
			assert(type(chn_type) == 'table')
			for i = 1, vi_num do
				if (chn_type.chn_type[i] == 2) then
					count = count + 1;
				else
					local_chn = local_chn + 1;
				end
			end
			if (0 < vi_num and 0 < dec_num and 0 == chn_type.chn_type[vi_num + 1]) then --δͨ  4 + 2 δ ͨΪ4
				total_chn = total_chn - dec_num
			else
				count = count + dec_num
			end			
		end
		local index = 1;
		for i=local_chn+1,total_chn do
			search_flag = false;
			for j =1,param.camera_num do
				if( param['idx'..j].channel_id == i ) then
					search_flag = true;
					break;
				end
			end
			if(search_flag== false) then
				index = index + 1;
			end
		end
		if(index == 1) then
			--ʾʾͨѾ
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_ALL_BOUND'),true, false,false);
			w1_msgbox.set_func(nil,nil,nil,nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
			ret = false;
		else
			if(camera_list.camera_num ~=0 ) then
				if(camera_list.camera_num > 32) then
					local i;
					for i=32+1, camera_list.camera_num do
						camera_list['idx'..i] = nil;
					end
					camera_list.camera_num = 32;
				end
				local username = b_wnd_ex.get_text(top, cwnd.t_user.id);				
				local userpwd = b_wnd_ex.get_password(top, cwnd.t_pass.id);		
				b_app_api.save_ipc_default_pwd(username, userpwd);
				
				local nret = b_app_api.onekeyadd_camera(camera_list);
				if(nret.ret == 3105)then
					w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_IP_CONFLICT'), true, false,false);
					w1_msgbox.set_func(nil, nil, nil, nil);
					b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
					ret = false;
				else
					local username = b_wnd_ex.get_text(top, cwnd.t_user.id);				
					local userpwd = b_wnd_ex.get_password(top, cwnd.t_pass.id);
					b_app_api.save_ipc_default_pwd(username, userpwd);
				end
			else
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_NO_CHANNEL_BINDING'), true, false,false);
				w1_msgbox.set_func(nil, nil, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
				ret = false;
			end
		end
		
		if (ret == true) then
			local checktab = {};	
			for i=1, 128 do
				checktab[i] = false;
			end
			
			--δ ִһ
			if false == w1_wizard_camera.searchstart then
				on_search(top, cwnd.search.id, b_ui.LBUTTONCLK, 0, 0);
			end		
			b_wnd_ex.set_selecelist(top, cwnd.devlist.id, checktab, false);
			b_wnd_ex.clear_checkall(top, cwnd.devlist.id, false, false);
			cameralist_refresh(top, true);
		end
	end
	return 0
end

local on_savepwd  = function(top, id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local cwnd = w1_wizard_camera.wnd;
		local username = b_wnd_ex.get_text(top, cwnd.t_user.id);				
		local userpwd = b_wnd_ex.get_password(top, cwnd.t_pass.id);
		
		b_app_api.save_ipc_default_pwd(username, userpwd);
	end	
	return 0;
end	

local on_del = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then			
		local selecech = b_wnd_ex.get_selecechannel(top, w1_wizard_camera.wnd.chmanage.id);
		local cameralist = b_app_api.get_cfg({'camera'}).camera;
		local delcameralist = {};
		local idx = 1;
		local i;
		for i=1,channel_num do
			local chname = 'ch'..i
			if(selecech[chname] == 1) then
				local j;
				for j=1,channel_num do
					if(cameralist['idx'..j] ~=nil ) then
						if(cameralist['idx'..j].channel_id == i) then
							cameralist['idx'..j].binded = false;
							delcameralist['idx'..idx] = cameralist['idx'..j];
							idx = idx+1;
						end
					end
				end
			end
		end
		
		delcameralist.camera_num = idx-1;
		if(delcameralist.camera_num ~=0 ) then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_ISDEL_CHANNEL'), true, true,false);
			w1_msgbox.set_func(delete_all_channels,{top, delcameralist, true}, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)	
		else
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_NO_CHANNEL_DEL'), true, false,false);
			w1_msgbox.set_func(nil, nil, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
		end
		local cwnd = w1_wizard_camera.wnd;
		b_wnd_ex.clear_checkall(top, cwnd.chmanage.id, false, false);
		--δ ִһ
		if false == w1_wizard_camera.searchstart then
			on_search(top, cwnd.search.id, b_ui.LBUTTONCLK, 0, 0);
		end			
	end
	return 0
end

local on_add = function(top, id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then	
		local cwnd = w1_wizard_camera.wnd;
		local selecech = b_wnd_ex.get_selecelist(top, cwnd.devlist.id);		
		local cameralist = b_app_api.get_cfg({'camera'}).camera;
		local i,j;
		local idx = 1;
		local search_flag ;
		local leisurechannel = {};
		local trade_name = b_app_api.get_trade_name().name;
		if(trade_name == nil or trade_name == '') then
			trade_name = 'Private'
		end
		local vi_num, dec_num = global_val.get_vi_dec_num();
		local count = channel_num
		local local_chn = 0;
		if (dec_num ~= channel_num) then --DVR 4+2ȵ豸 Ҫͨ
			local chn_type = b_app_api.get_cfg({'channel_type'}).channel_type;
			assert(type(chn_type) == 'table')
			for i = 1, vi_num do
				if (chn_type.chn_type[i] ~= 2) then
					local_chn = local_chn + 1;
				end
			end
			if (0 < vi_num and 0 < dec_num and 0 == chn_type.chn_type[vi_num + 1]) then --δͨ  4 + 2 δ ͨΪ4
				count = count - dec_num
			end			
		end
		for i=local_chn+1,count do
			search_flag = false;
			for j =1,cameralist.camera_num do
				if( cameralist['idx'..j].channel_id == i ) then
					search_flag = true;
					break;
				end
			end
			if(search_flag== false) then
				leisurechannel[idx] = i;
				idx = idx + 1;
			end
		end
		if(idx == 1) then	--ûпͨ
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_ALL_BOUND'), true, false,false);
			w1_msgbox.set_func(nil, nil, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
		else
			local selecechlist = {};
			local listidx = 1;
			for i =1, selecech.list_num do
				if(selecech['r'..i] == 1) then
					selecechlist['idx'..listidx] = w1_wizard_camera.searchlist['idx'..i];
					listidx = listidx + 1;
				end
			end
			selecechlist.camera_num = listidx - 1;
			if(selecechlist.camera_num == 0) then
				w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_NO_SELECT_CH'), true, false,false);
				w1_msgbox.set_func(nil, nil, nil, nil);
				b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
			else
				local username = b_wnd_ex.get_text(top, cwnd.t_user.id);				
				local userpwd = b_wnd_ex.get_password(top, cwnd.t_pass.id);		
				local leisurechannel_num =#leisurechannel;
				local min = selecechlist.camera_num;
				if(leisurechannel_num < min) then
					min = leisurechannel_num;
				end	
				local cur_selecechlist = {};
				local j=1
				for i=1, min do
					if(selecechlist['idx'..i] ~=nil and next(selecechlist['idx'..i]) ~= nil)then
						selecechlist['idx'..i].channel_id = leisurechannel[i];
						cur_selecechlist['idx'..j] = selecechlist['idx'..i];
						cur_selecechlist.camera_num = j;
						cur_selecechlist['idx'..j].binded = true;
						cur_selecechlist['idx'..j].addr = selecechlist['idx'..i].address; --½ƴӶ˿ڵipָ
						cur_selecechlist['idx'..j].account = username;
						cur_selecechlist['idx'..j].password = userpwd;
						if(cur_selecechlist['idx'..j].protocol == trade_name) then
							cur_selecechlist['idx'..j].protocol = 2
						elseif(cur_selecechlist['idx'..j].protocol == (trade_name..'_SSL')) then
							cur_selecechlist['idx'..j].protocol = 4
						elseif(cur_selecechlist['idx'..j].protocol == 'ONVIF') then
							cur_selecechlist['idx'..j].protocol = 1
						else
							assert(0);
						end
						cur_selecechlist['idx'..i].remote_cam =1;
						j =j+1;
					end			
				end	

				b_app_api.save_ipc_default_pwd(username, userpwd);
				local nret = b_app_api.onekeyadd_camera(cur_selecechlist);
				if(nret.ret == 3105)then
					w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_IP_CONFLICT'), true, false,false);
					w1_msgbox.set_func(nil, nil, nil, nil);
					b_dlg.post_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil)
					return 0;
				end
				local checktab = {};	
				for i=1, 128 do
					checktab[i] = false;
				end
				--δ ִһ
				if false == w1_wizard_camera.searchstart then
					on_search(top, cwnd.search.id, b_ui.LBUTTONCLK, 0, 0);
				end					
				b_wnd_ex.set_selecelist(top, cwnd.devlist.id, checktab, false);
				b_wnd_ex.clear_checkall(top, cwnd.devlist.id, false, false);
				cameralist_refresh(top, true);
			end

		end
		
	end
	return 0
end

local ok_func = function(param)
	if(param[2] == 2) then	--ɾ
		w1_wizard_camera.del_sel = param[3];
		--δ ִһ
		local cwnd = w1_wizard_camera.wnd;
		if false == w1_wizard_camera.searchstart then
			on_search(param[1], cwnd.search.id, b_ui.LBUTTONCLK, 0, 0);
		end				
		cameralist_refresh(param[1], false);
		w1_wizard_camera.delete_signel_flag = true;	
	end
	return 0;
end

w1_wizard_camera.timer_start = function()
	w1_wizard_camera.timestart = true
end

w1_wizard_camera.timer_stop = function()
	w1_wizard_camera.timestart = false
end

w1_wizard_camera.chrefresh = function(top, redraw)
	local cameralist = b_app_api.get_cfg({'camera_bind'}).camera_bind;
	local cwnd = w1_wizard_camera.wnd;
	w1_modify_camera.set_data(cameralist);
	local trade_name = b_app_api.get_trade_name().name;
	if(trade_name == nil or trade_name == '') then
		trade_name = 'Private'
	end
	local rtsp_protocol = b_app_api.get_rtsp_pro();
	local count = rtsp_protocol.protocol_num
	for i=1,cameralist.camera_num do
		cameralist['idx'..i].rtsp_name = ''
		if(tonumber(cameralist['idx'..i].protocol) == 2) then
			cameralist['idx'..i].prot_name = nil;
			cameralist['idx'..i].prot_name = trade_name
		elseif(tonumber(cameralist['idx'..i].protocol) == 4) then
			cameralist['idx'..i].prot_name = nil;
			cameralist['idx'..i].prot_name = trade_name..'_SSL'
		elseif(tonumber(cameralist['idx'..i].protocol) > 100) then
			local index = tonumber(cameralist['idx'..i].protocol) - 100
			cameralist['idx'..i].rtsp_name = rtsp_protocol['idx'..index].name
		end
	end
	
	b_wnd_ex.set_chdata(top, w1_wizard_camera.wnd.chmanage.id, cameralist, redraw);
	local upgrade_state = b_app_api.get_cfg({'upgrade_state'}).upgrade_state;
	local camera_num = cameralist.camera_num;
	local disable_table = {};
	disable_table.item_total = camera_num
	for i=1,camera_num  do
		local channel_id = cameralist['idx'..i].channel_id
		if(upgrade_state['idx'..channel_id] == nil ) then
			return 0;
		end
		if(upgrade_state['idx'..channel_id].state == 0) then
			disable_table[i]= channel_id*10+1
		else
			if cameralist['idx'..i].state ~= 4 then
				disable_table[i]= channel_id*10+2
			else
				disable_table[i]= channel_id*10+3
			end			
		end
	end	
	b_wnd_ex.set_select_disable(top,cwnd.chmanage.id,disable_table,redraw)	
end

w1_wizard_camera.timerenevt = function(top)
	if(w1_wizard_camera.timestart) then
		w1_wizard_camera.chrefresh(top,false);
		if(w1_wizard_camera.searchstart) then
			local time, float = math.modf(w1_wizard_camera.searchcount/2);
			local str = STR('LA_STOP_SEARCH') ..'('..time..'s)'
			b_wnd_ex.set_text(top,w1_wizard_camera.wnd.search.id,str,false);
			if 0 == w1_wizard_camera.searchcount%8 then
				cameralist_refresh(top, false);
			end
			if(w1_wizard_camera.searchcount == 0) then
				w1_wizard_camera.searchstart = false
				b_wnd_ex.set_text(top,w1_wizard_camera.wnd.search.id,STR('LA_START_SEARCH'),false);
			else
				w1_wizard_camera.searchcount = w1_wizard_camera.searchcount - 1;
			end
		end
		b_dlg.dlg_set_redraw(top);
	else
		
	end
	return 0
end

w1_wizard_camera.on_pre_show = function(top)
	w1_wizard_camera.timer_stop()
	channel_num = global_val.get_channelnum();
	b_wnd_ex.set_chlistattr(top, w1_wizard_camera.wnd.chmanage.id, {7,channel_num,1}, false);
	
	w1_wizard_camera.chrefresh(top, false);
	cameralist_refresh(top, false);
	
	local param = {
			'', STR('LA_IP'),STR('LA_PRODUCT_MODEL'),STR('LA_PROTOCOL'),STR('LA_SOFTWARE_VERSION')
		}	
	b_wnd_ex.set_title_texts(top, w1_wizard_camera.wnd.devlist.id, param, false);
	
	local param_2 = {
			 STR('LA_CHANNEL'), STR('LA_IP'),STR('LA_PRODUCT_MODEL'),
			STR('LA_PROTOCOL'),STR('LA_OPERATE')
		}	
	b_wnd_ex.set_title_texts(top, w1_wizard_camera.wnd.chmanage.id, param_2, false);
	
	
	local list_w = {};
	for i=1,5 do
		local str = 's_wizard_devlist_w'..math.floor(i/1);
		list_w[i] = SIZE(str)[1];
	end
	b_wnd_ex.columns_w(top, w1_wizard_camera.wnd.devlist.id, list_w, false);
	
	w1_modify_camera.init();
	w1_modify_camera.set_func(ok_func, {top});
	
	local camera_user_pwd = b_app_api.get_cfg({'camera_user_pwd'}).camera_user_pwd;
	b_wnd_ex.set_text(top, w1_wizard_camera.wnd.t_user.id,camera_user_pwd.account,false);
	b_wnd_ex.set_password(top, w1_wizard_camera.wnd.t_pass.id,camera_user_pwd.password,false);
end

w1_wizard_camera.clear = function()
	w1_wizard_camera.searchlist = nil
	w1_modify_camera.data = nil;
end

w1_wizard_camera.wnd = 
{
	t='wnd_bg',id=id,xywh ='s_wizard_camera_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'},
	sub = {'camera','hline','chmanage', 'onekeyadd','del', 'devlist',
			'onlinedev', 'search', 
		   'cap_user', 't_user', 'cap_pass', 't_pass', 'add'},
			
	camera	= {t='checktxt',	id=id+1,xywh='s_wizard_camera_camera_xywh',
				text='LA_CAMERA',	font = 'f_grade6',align = b_ui.ALIGN.LEFT,check = true},
	hline 	= {t='hline',	id=id+2,xywh='s_wizard_camera_hline_xywh'},
	chmanage 	= {	t='chmanage',id=id+3,	xywh ='s_wizard_camera_chmanage_xywh',	font = 'f_grade6',
					chlistattr = {6,4,1}
					},			
	del 		= {t='button',	id=id+4,	xywh = 's_wizard_camera_del_xywh', 	text='LA_DELETE',		cmd=on_del},
	onekeyadd 	= {t='button',	id=id+6,	xywh = 's_wizard_camera_onekeyadd_xywh', 	text='LA_ADD_DEVICES',	cmd=on_onekeyadd},
	search 	= {t='tt_button',id=id+7,	xywh = 's_wizard_camera_search_xywh', 	text='LA_START_SEARCH',
					color = {'c_camear_line', 'c_bor_n', 'c_txt_n'},cmd=on_search},
	
	devlist	 	= {t='list',	id=id+8,	xywh='s_wizard_camera_devlist_xywh', font = 'f_grade6',items_font = 18,
					listattr = {4,5,b_ui.LISTATTR.FIRST_WIDGET_CHECK},list_resort={2,3,5},
					columns_w = {40,200,120,120,300},
					},	
	cap_user  	= {t='static',	id=id+9,	xywh = 's_wizard_camera_cap_user_xywh', 	text='LA_USER_NAME'},
	t_user  	= {t='edit',	id=id+10,	xywh = 's_wizard_camera_t_user_xywh', 	text='admin',	trans = false,guide_text='LA_USER_NAME',	cmd=on_savepwd},
	
	cap_pass  	= {t='static',	id=id+11,	xywh = 's_wizard_camera_cap_pass_xywh', 	text='LA_PASSWORD',	align = b_ui.ALIGN.RIGHT},
	t_pass  	= {t='password',id=id+12,	xywh = 's_wizard_camera_t_pass_xywh', 	password='admin',guide_text='LA_PASSWORD',	cmd=on_savepwd},

	add  		= {t='tt_button',id=id+13,	xywh = 's_wizard_camera_add_xywh', 	text='LA_ADD',			cmd=on_add},
}

return w1_wizard_camera

