--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/7/5
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.wizard_disk.id
local b_app_api = require("wnd.core.command.b_app_api");
local r_str		= require("wnd.core.r_res.r_str")
local STR 		= r_str.get_str
local w1_msgbox 	= require("wnd.w1_util.w1_msgbox")
local b_dlg 		= require("wnd.core.b_dlg")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local util 		= require("wnd.core.util")
local w1_wizard_disk = {
	data,
	format_status,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_wizard_disk.s_768 =
{
	s_wizard_disk_xywh = {2,35,448,547},
	s_wizard_disk_disk_xywh = {10,14,160,35},
	s_wizard_disk_hline_xywh = {8,49,437,1},
	s_wizard_disk_disk_list_xywh = {16,56,426,320},
	s_wizard_disk_format_xywh = {357,391,80,32},
	s_wizard_disk_tip_check_xywh = {16,512,21,28},
	s_wizard_disk_tip1_xywh = {42,512,320,28},
	s_wizard_disk_disk_list_w1 = {20,0,0,0},
	s_wizard_disk_disk_list_w2 = {42,0,0,0},
	s_wizard_disk_disk_list_w3 = {64,0,0,0},
	s_wizard_disk_disk_list_w4 = {64,0,0,0},
	s_wizard_disk_disk_list_w5 = {78,0,0,0},
	s_wizard_disk_disk_list_w6 = {78,0,0,0},
	s_wizard_disk_disk_list_w7 = {64,0,0,0},
};

w1_wizard_disk.s_1280 = 
{
	s_wizard_disk_xywh= {3,50,840,770},
	s_wizard_disk_disk_xywh={20,20,300,50},
	s_wizard_disk_hline_xywh={15,70,820,2},
	s_wizard_disk_disk_list_xywh={30,80,800,450},
	s_wizard_disk_format_xywh={670,550,150,45}, 
	s_wizard_disk_tip_check_xywh={30,720,40,40},
	s_wizard_disk_tip1_xywh={80,720,600,40},
	s_wizard_disk_disk_list_w1 = {40,0,0,0},
	s_wizard_disk_disk_list_w2 = {80,0,0,0},
	s_wizard_disk_disk_list_w3 = {120,0,0,0},
	s_wizard_disk_disk_list_w4 = {120,0,0,0},
	s_wizard_disk_disk_list_w5 = {150,0,0,0},
	s_wizard_disk_disk_list_w6 = {150,0,0,0},
	s_wizard_disk_disk_list_w7 = {120,0,0,0},
}
w1_wizard_disk.s_1440 = 
{
	s_wizard_disk_xywh= {3,50,840,740},
	s_wizard_disk_disk_xywh={20,20,300,50},
	s_wizard_disk_hline_xywh={15,70,820,2},
	s_wizard_disk_disk_list_xywh={30,80,800,450},
	s_wizard_disk_format_xywh={670,550,150,40}, 
	s_wizard_disk_tip_check_xywh={30,690,40,40},
	s_wizard_disk_tip1_xywh={80,690,600,40},
	s_wizard_disk_disk_list_w1 = {40,0,0,0},
	s_wizard_disk_disk_list_w2 = {80,0,0,0},
	s_wizard_disk_disk_list_w3 = {120,0,0,0},
	s_wizard_disk_disk_list_w4 = {120,0,0,0},
	s_wizard_disk_disk_list_w5 = {150,0,0,0},
	s_wizard_disk_disk_list_w6 = {150,0,0,0},
	s_wizard_disk_disk_list_w7 = {120,0,0,0},
}

w1_wizard_disk.s_1080p = 
{
	s_wizard_disk_xywh= {3,50,840,770},
	s_wizard_disk_disk_xywh={20,20,300,50},
	s_wizard_disk_hline_xywh={15,70,820,2},
	s_wizard_disk_disk_list_xywh={30,80,800,450},
	s_wizard_disk_format_xywh={670,550,150,45}, 
	s_wizard_disk_tip_check_xywh={30,720,40,40},
	s_wizard_disk_tip1_xywh={80,720,600,40},
	s_wizard_disk_disk_list_w1 = {40,0,0,0},
	s_wizard_disk_disk_list_w2 = {80,0,0,0},
	s_wizard_disk_disk_list_w3 = {120,0,0,0},
	s_wizard_disk_disk_list_w4 = {120,0,0,0},
	s_wizard_disk_disk_list_w5 = {150,0,0,0},
	s_wizard_disk_disk_list_w6 = {150,0,0,0},
	s_wizard_disk_disk_list_w7 = {120,0,0,0},
}

w1_wizard_disk.s_2k = 
{
	s_wizard_disk_xywh= {4,67,1120,1026},
	s_wizard_disk_disk_xywh={27,27,400,67},
	s_wizard_disk_hline_xywh={20,93,1093,3},
	s_wizard_disk_disk_list_xywh={40,107,1066,600},
	s_wizard_disk_format_xywh={893,733,200,60}, 
	s_wizard_disk_tip_check_xywh={40,960,53,53},
	s_wizard_disk_tip1_xywh={107,960,800,53},
	s_wizard_disk_disk_list_w1 = {53,0,0,0},
	s_wizard_disk_disk_list_w2 = {106,0,0,0},
	s_wizard_disk_disk_list_w3 = {160,0,0,0},
	s_wizard_disk_disk_list_w4 = {160,0,0,0},
	s_wizard_disk_disk_list_w5 = {200,0,0,0},
	s_wizard_disk_disk_list_w6 = {200,0,0,0},
	s_wizard_disk_disk_list_w7 = {160,0,0,0},
}

w1_wizard_disk.s_4k = 
{
	s_wizard_disk_xywh= {6,100,1680,1540},
	s_wizard_disk_disk_xywh={40,40,600,100},
	s_wizard_disk_hline_xywh={30,140,1640,4},
	s_wizard_disk_disk_list_xywh={60,160,1600,900},
	s_wizard_disk_format_xywh={1340,1100,300,90},
	s_wizard_disk_tip_check_xywh={60,1440,80,80},
	s_wizard_disk_tip1_xywh={160,1440,1200,80},
	s_wizard_disk_disk_list_w1 = {80,0,0,0},
	s_wizard_disk_disk_list_w2 = {160,0,0,0},
	s_wizard_disk_disk_list_w3 = {240,0,0,0},
	s_wizard_disk_disk_list_w4 = {240,0,0,0},
	s_wizard_disk_disk_list_w5 = {300,0,0,0},
	s_wizard_disk_disk_list_w6 = {300,0,0,0},
	s_wizard_disk_disk_list_w7 = {240,0,0,0},

}
local DISK_INFO = nil;

local updatelist = function(top, cur_page, redraw)
	if(cur_page == 0) then
		return ;
	end
	local s_idx =1;
	local e_idx =0;
	if((DISK_INFO.disk_num ~= 0) and (DISK_INFO.disk_num ~= 1))then
		s_idx = 1;
		e_idx =DISK_INFO.disk_num;
	elseif (DISK_INFO.disk_num == 1)then
		s_idx = 1;
		e_idx =1;
	else
		s_idx = 1;
		e_idx =0;
	end
	local displist = {};
	local disable_list ={};
	local idx = 0;

	for i=s_idx, e_idx do
		idx = idx + 1;
		
		local disk_id = DISK_INFO.disk_id[i]+1;
		
		local temp = math.floor(DISK_INFO.size[i]/1000);--math.ceil(DISK_INFO.size[i]/1000) - 1;
		local capcity = nil;
		if(temp < 1000)then
			capcity = tostring(temp).." GB";
		else
			temp = math.floor(temp/1000);
			capcity = tostring(temp).." TB";
		end
		local used =nil;
		temp = math.floor(DISK_INFO.used[i]/1000);
		if(temp >=1)then
			used = tostring(temp).." GB";
		else
			temp = math.floor(DISK_INFO.used[i]);
			used = tostring(temp).." MB";
		end
		disable_list[i] = 0;
		local status = nil;
		if(1 == DISK_INFO.status[i])then
			status = STR('LA_NORMAL');
		elseif(2 == DISK_INFO.status[i]) then
			status = STR('LA_NEED_FORMAT');
		elseif(4 == DISK_INFO.status[i])then
			status = STR('LA_DISK_ERROR');
			disable_list[i] = 1;
		elseif(8 == DISK_INFO.status[i]) then
			status = STR('LA_FULL_DISK');		
		elseif(65 == DISK_INFO.status[i]) then
			status = STR('LA_NORMAL');
		elseif(66 == DISK_INFO.status[i]) then
			status = STR('LA_WARNING');
		elseif(67 == DISK_INFO.status[i]) then
			status = STR('LA_DESTROYED');
		elseif(68 == DISK_INFO.status[i]) then
			status = STR('LA_RECOVER');
		elseif(69 == DISK_INFO.status[i]) then
			status = STR('LA_LOAD_FAIL');
		else
			status = STR('LA_DISK_ERROR');
			disable_list[i] = 1;
		end
		displist['idx'..idx] = {idx-1, false, '',
		DISK_INFO.name[i],capcity,used,DISK_INFO.sn[i],DISK_INFO.model[i],status,
		};	
	end
	displist.item_total = idx;
	b_wnd_ex.set_listdata(top, w1_wizard_disk.wnd.disk_list.id, displist, redraw);	
	b_wnd_ex.set_disablelist(top,w1_wizard_disk.wnd.disk_list.id, disable_list, redraw)
end

local cfgdatatoui = function(top, cfgdata, redraw)
	if(w1_wizard_disk.data == nil) then
		w1_wizard_disk.data = cfgdata.disk
	else
		util.copy_tab_b(w1_wizard_disk.data, cfgdata.disk)
	end
end

w1_wizard_disk.chrefresh = function(top, redraw)
	local cwnd = w1_wizard_disk.wnd;
	id = w1_id.sysinfo.disk_id;
	local disk_info = b_app_api.get_disk_info();
	if(disk_info == nil)then
		print("--lua---disk_info == nil----")
		return 0;
	end
	
	if(DISK_INFO == nil) then
		DISK_INFO = disk_info
	else
		util.copy_tab_b(DISK_INFO, disk_info)
	end

	local list_num = DISK_INFO.disk_num
	if(list_num ==nil)then
		list_num =0;
	end
	if(list_num ==0)then
		b_wnd_ex.set_hide (top, w1_wizard_disk.wnd.format.id, true, redraw);
	else
		b_wnd_ex.set_hide (top, w1_wizard_disk.wnd.format.id, false, redraw);
	end
	
	local param = {
			'', STR('LA_DISK_T'), STR('LA_CAPACITY'),STR('LA_USED'), STR('LA_SN'),STR('LA_DISK_MODEL'),STR('LA_STATUS')
		}
	b_wnd_ex.set_title_texts(top, cwnd.disk_list.id, param, false);
	
	local list_w = {};
	for i=1,7 do
		local str = 's_wizard_disk_disk_list_w'..math.floor(i/1);
		list_w[i] = SIZE(str)[1];
	end
	b_wnd_ex.columns_w(top, w1_wizard_disk.wnd.disk_list.id, list_w, false);
	
	updatelist(top,1,redraw);
	local data ={}
	table.insert(data,"disk")
	local disk = b_app_api.get_cfg(data)
	if(w1_wizard_disk.data == nil) then
		w1_wizard_disk.data = disk.disk
	else
		util.copy_tab_b(w1_wizard_disk.data, disk.disk)
	end
end
w1_wizard_disk.on_pre_show = function(top)
	w1_wizard_disk.chrefresh(top, false)
end

local okfunc_diskformat = function(param)
	local cwnd = w1_wizard_disk.wnd;
	local data = w1_wizard_disk.data;
	if (data ~= nil and type(data) == 'table') then
		local selecech = b_wnd_ex.get_selecelist(param[1], cwnd.disk_list.id);	
		local format_sign = 0;
	
		for i =1, data.disk_num do
			if(selecech['r'..i] == 1) then
				w1_wizard_disk.format_status = b_app_api.disk_format(data['disk'..i].disk_id).status;
				format_sign = format_sign + 1;
			end
		end
		if(format_sign > 0)then
			w1_wizard_disk.chrefresh(param[1],false);
			b_dlg.dlg_set_redraw(param[1]);
		end
	end
end
local on_format = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local cwnd = w1_wizard_disk.wnd;
		local data = w1_wizard_disk.data;
		local select_flag =false;
		local selecech = b_wnd_ex.get_selecelist(top, cwnd.disk_list.id);	
		for i =1, data.disk_num do
			if(selecech['r'..i] == 1) then
				select_flag = true;
			end
		end
		if(select_flag ==false)then
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_SELECT_DISK'), true, false,false);
			w1_msgbox.set_func(okfunc_diskformat, {top}, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
		else
		
			w1_wizard_disk.format_status = nil;
			w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_SURE_FORMAT'), true, true,false);
			w1_msgbox.set_attach_dlgattr(STR('LA_FORMATTING_T'));
			w1_msgbox.set_func(okfunc_diskformat, {top}, nil, nil);
			b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
			if(w1_wizard_disk.format_status ~= nil) then	
				if(w1_wizard_disk.format_status == 0) then	--ʽɹ
					w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_FORMAT_OK'), true, false,false);
					w1_msgbox.set_func(nil, nil, nil, nil);
					b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
				else							--ʽʧ
					w1_msgbox.set_dlgattr(STR('LA_TIP'), STR('LA_FORMAT_FAIL'), true, false,false);
					w1_msgbox.set_func(nil, nil, nil, nil);
					b_dlg.do_modal(top, w1_key.DLG_MSG_BOX, 0, 0, nil);
				end
				
				--¶ȡˢҳ
				w1_wizard_disk.chrefresh(top, false)
				b_dlg.dlg_set_redraw(top);
			end
		end
	end
	return 0;
end

w1_wizard_disk.clear = function()
	w1_wizard_disk.data = nil;
	DISK_INFO = nil;
end

w1_wizard_disk.wnd = 
{
	t='wnd_bg',
	id=id,
	xywh = 's_wizard_disk_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'},
	sub = {'disk','hline','disk_list','format','tip_check','tip1'},
	disk  = {t='checktxt',	id=id+1,xywh='s_wizard_disk_disk_xywh',
				text='LA_DISK_CONFIG',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,check = true},
	hline = {t='hline',	id=id+2,xywh='s_wizard_disk_hline_xywh'},
	disk_list= {t='list',	id=id+3,	xywh='s_wizard_disk_disk_list_xywh', font = 'f_grade6',items_font = 18,
		listattr = {8,7,b_ui.LISTATTR.FIRST_WIDGET_CHECK,0},list_tip =true,
		title_texts = {'','Disk', 'Capcity','Used','SN','Model','Status'},
		columns_w = {40,80,120,120,150,150,120},
	},
	format = {t='button',	id=id+4,	xywh='s_wizard_disk_format_xywh', 	text='LA_FORMAT',cmd=on_format},
}
return w1_wizard_disk;