--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/8/14
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.wizard_network.ipv4_cctv_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local global_val	= require("wnd.global_val")
local util 		= require("wnd.core.util")
local b_app_cfg	= require("wnd.core.b_app_cfg")

local w1_wizard_net_cctv = 
{
	data={},
	origin_cfg,
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_wizard_net_cctv.s_768 =
{
	s_w1_wizard_net_cctv_xywh = {2,53,448,490},
	s_w1_wizard_net_cctv_cap_ip_xywh = {32,14,160,28},
	s_w1_wizard_net_cctv_t_ip_xywh = {266,14,133,28},
	s_w1_wizard_net_cctv_cap_netmask_xywh = {32,53,160,28},
	s_w1_wizard_net_cctv_t_netmask_xywh = {266,53,133,28},
	s_w1_wizard_net_cctv_cap_gateway_xywh = {32,92,160,28},
	s_w1_wizard_net_cctv_t_gateway_xywh = {266,92,133,28},
	s_w1_wizard_net_cctv_cap_mac_xywh = {32,131,160,28},
	s_w1_wizard_net_cctv_t_mac_xywh = {266,131,133,28},
	s_w1_wizard_net_cctv_tipinfo_xywh = {32,448,373,35},
};

w1_wizard_net_cctv.s_1280 = 
{
	s_w1_wizard_net_cctv_xywh={3,75,840,690},
	s_w1_wizard_net_cctv_cap_ip_xywh= {60,20,300,40},
	s_w1_wizard_net_cctv_t_ip_xywh={500,20,250,40},
	s_w1_wizard_net_cctv_cap_netmask_xywh= {60,75,300,40},
	s_w1_wizard_net_cctv_t_netmask_xywh={500,75,250,40},
	s_w1_wizard_net_cctv_cap_gateway_xywh={60,130,300,40},
	s_w1_wizard_net_cctv_t_gateway_xywh={500,130,250,40},
	s_w1_wizard_net_cctv_cap_mac_xywh={60,185,300,40},
	s_w1_wizard_net_cctv_t_mac_xywh={500,185,250,40},
	s_w1_wizard_net_cctv_tipinfo_xywh ={60,630,700,50},

}
w1_wizard_net_cctv.s_1440 = 
{
	s_w1_wizard_net_cctv_xywh={3,75,840,665},
	s_w1_wizard_net_cctv_cap_ip_xywh= {60,20,300,40},
	s_w1_wizard_net_cctv_t_ip_xywh={500,20,250,40},
	s_w1_wizard_net_cctv_cap_netmask_xywh= {60,75,300,40},
	s_w1_wizard_net_cctv_t_netmask_xywh={500,75,250,40},
	s_w1_wizard_net_cctv_cap_gateway_xywh={60,130,300,40},
	s_w1_wizard_net_cctv_t_gateway_xywh={500,130,250,40},
	s_w1_wizard_net_cctv_cap_mac_xywh={60,185,300,40},
	s_w1_wizard_net_cctv_t_mac_xywh={500,185,250,40},
	s_w1_wizard_net_cctv_tipinfo_xywh  ={60,605,700,50},

}
w1_wizard_net_cctv.s_1080p = 
{
	s_w1_wizard_net_cctv_xywh={3,75,840,690},--{0,75,850,690},
	s_w1_wizard_net_cctv_cap_ip_xywh= {60,20,300,40},
	s_w1_wizard_net_cctv_t_ip_xywh={500,20,250,40},
	s_w1_wizard_net_cctv_cap_netmask_xywh= {60,75,300,40},
	s_w1_wizard_net_cctv_t_netmask_xywh={500,75,250,40},
	s_w1_wizard_net_cctv_cap_gateway_xywh={60,130,300,40},
	s_w1_wizard_net_cctv_t_gateway_xywh={500,130,250,40},
	s_w1_wizard_net_cctv_cap_mac_xywh={60,185,300,40},
	s_w1_wizard_net_cctv_t_mac_xywh={500,185,250,40},
	s_w1_wizard_net_cctv_tipinfo_xywh ={60,630,700,50},
}

w1_wizard_net_cctv.s_2k = 
{
	s_w1_wizard_net_cctv_xywh={4,100,1120,920},
	s_w1_wizard_net_cctv_cap_ip_xywh= {80,27,400,53},
	s_w1_wizard_net_cctv_t_ip_xywh={667,27,333,53},
	s_w1_wizard_net_cctv_cap_netmask_xywh= {80,100,400,53},
	s_w1_wizard_net_cctv_t_netmask_xywh={667,100,333,53},
	s_w1_wizard_net_cctv_cap_gateway_xywh={80,173,400,53},
	s_w1_wizard_net_cctv_t_gateway_xywh={667,173,333,53},
	s_w1_wizard_net_cctv_cap_mac_xywh={80,246,300,53},
	s_w1_wizard_net_cctv_t_mac_xywh={667,246,333,53},
	s_w1_wizard_net_cctv_tipinfo_xywh={80,840,933,67},
}

w1_wizard_net_cctv.s_4k = 
{
	s_w1_wizard_net_cctv_xywh={6,150,1680,1380},
	s_w1_wizard_net_cctv_cap_ip_xywh= {120,40,600,80},
	s_w1_wizard_net_cctv_t_ip_xywh={1000,40,500,80},
	s_w1_wizard_net_cctv_cap_netmask_xywh= {120,150,600,80},
	s_w1_wizard_net_cctv_t_netmask_xywh={1000,150,500,80},
	s_w1_wizard_net_cctv_cap_gateway_xywh={120,260,600,80},
	s_w1_wizard_net_cctv_t_gateway_xywh={1000,260,500,80},
	s_w1_wizard_net_cctv_cap_mac_xywh={120,370,300,80},
	s_w1_wizard_net_cctv_t_mac_xywh={1000,370,500,80},
	s_w1_wizard_net_cctv_tipinfo_xywh ={120,1260,1400,100},

}

local redraw = false;
--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local cwnd = w1_wizard_net_cctv.wnd
	local data = cfgdata.network_cctv
	
	if(w1_wizard_net_cctv.data == nil) then
		w1_wizard_net_cctv.data = cfgdata
	else
		util.copy_tab_b(w1_wizard_net_cctv.data, cfgdata)
	end
	
	if(w1_wizard_net_cctv.origin_cfg == nil) then
		w1_wizard_net_cctv.origin_cfg = {};	
	end
	
	if(w1_wizard_net_cctv.origin_cfg == nil) then
		w1_wizard_net_cctv.origin_cfg = util.copy_tab(cfgdata)
	else
		util.copy_tab_b(w1_wizard_net_cctv.origin_cfg, cfgdata)
	end
	
	local function settext(id, str)
		b_wnd_ex.set_text(top, id, str,redraw)
	end

	settext(cwnd.t_ip.id,  data.ip );
	settext(cwnd.t_netmask.id, data.netmask );
	settext(cwnd.t_gateway.id, data.gateway );
	--local mac = global_val.get_dev_mac1();
	--settext(cwnd.t_mac1.id, mac );
	redraw = false;
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	local cwnd = w1_wizard_net_cctv.wnd;
	
	legal, num = w1_legal.check_gataway(top, cwnd.t_gateway.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_gateway.id)	
		if(num == w1_legal.netmask.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LAN_DEFAULT_GATEWAY'))
		elseif(num == w1_legal.netmask.LENERR or num == w1_legal.netmask.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LAN_DEFAULT_GATEWAY'))
		end
	end
	
	legal, num = w1_legal.check_netmask(top, cwnd.t_netmask.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_netmask.id)	
		if(num == w1_legal.netmask.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LAN_SUBNET_MASK'))
		elseif(num == w1_legal.netmask.LENERR or num == w1_legal.netmask.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LAN_SUBNET_MASK'))
		end
	end	
	
	legal, num= w1_legal.check_ip(top, cwnd.t_ip.id);	
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_ip.id)	
		if(num == w1_legal.ip.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LA_CORRECT_IP'))
		elseif(num == w1_legal.ip.LENERR or num == w1_legal.ip.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LA_CORRECT_IP'))
		end
	end
	
	if(legalflag) then
		return legalflag, nil
	else
		return legalflag, nlegalid
	end
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_wizard_net_cctv.wnd
	local data = cfgdata
	local gettext = function(id)
		local iptext = b_wnd_ex.get_text(top, id)
		return iptext
	end

	local ip = gettext(cwnd.t_ip.id);
	data.network_cctv.ip = ip
	local netmask = gettext(cwnd.t_netmask.id);
	data.network_cctv.netmask = netmask
	local gateway = gettext(cwnd.t_gateway.id);
	data.network_cctv.gateway = gateway
	
	return 0
end

w1_wizard_net_cctv.timer_start = function()
	w1_wizard_net_cctv.timestart = true
end

w1_wizard_net_cctv.timer_stop = function(top)
	w1_wizard_net_cctv.timestart = false
	w1_wnd_util.tipclear(top, w1_wizard_net_cctv.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
	w1_wnd_util.tipdispoff();
end

w1_wizard_net_cctv.timerenevt = function(top)
	if(w1_wizard_net_cctv.timestart) then
		local save_flag = w1_wnd_util.timerenevt(top, w1_wizard_net_cctv.wnd.tipinfo.id)
		if(save_flag ==1)then

		end
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_wizard_net_cctv.init = function(top)
	w1_wnd_util.cfgtab = {'network_cctv'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

w1_wizard_net_cctv.returndatacheck =function(top,ret)
	if(ret ~= nil and ret.network_cctv ~= 0) then--޸ʧ
		local cwnd = w1_wizard_net_cctv.wnd;
		local nlegalid = {};
		table.insert(nlegalid, cwnd.t_ip.id);
		if(ret.network_cctv == -1 ) then
			w1_wnd_util.setparamerr_str(STR('LA_PARAMETER_ERR'));
		elseif(ret.network_cctv == -2) then
			w1_wnd_util.setparamerr_str(STR('LA_POE_LOCAL_IP_TIP'));
		elseif(ret.network_cctv == -3) then
			w1_wnd_util.setparamerr_str(STR('LA_MSG_IP_CONFLICT'));	
		elseif (ret.network_cctv == -543) then
			w1_wnd_util.setparamerr_str(STR('LA_NETWORK_IP_ERROR'));
		end			
		return false, nlegalid;
	end
	return true, nil;
end


w1_wizard_net_cctv.next =function(top)
--	uitousercfg(top,b_app_cfg.user_cfg);
	w1_wnd_util.uidatacheckfunc = uidatacheck
	local flag = w1_wnd_util.check_legal_tip(top)
	if(flag ~= 0)then
		w1_wnd_util.tipdispon()		--ʾ
		return -1
	end	
	return 0;
end

w1_wizard_net_cctv.cctv_to_ip = function(top)
	w1_wnd_util.uidatacheckfunc = uidatacheck
	local flag = w1_wnd_util.check_legal_tip(top)
	if(flag ~= 0)then
		w1_wnd_util.tipdispon()		--ʾ
		return -1
	end	
	return 0;
	
end

local tabcompare = function(origin_cfg,cur_cfg)
	local param = {}
	for k, v in pairs(cur_cfg) do
		if(origin_cfg[k] ~= nil ) then
			--table,λûеtable¼param
			if( util.compare_tab(origin_cfg[k], cur_cfg[k]) == 1 ) then
				if(param[k] == nil) then
					param[k] =  util.copy_tab(cur_cfg[k])
				else
					util.copy_tab_b(param[k], cur_cfg[k])
				end			
			end
		end
	end
	return param
end

--ûǷи,и,򷵻ظĺ
local usercfgchange =function(origin_cfg,cur_cfg)
	local param = tabcompare(origin_cfg,cur_cfg)
	if(	util.is_empty(param) )then
		return false,nil
	else
		return true, param
	end
end

w1_wizard_net_cctv.get_data =function(top)
	local cwnd = w1_wizard_net_cctv.wnd
	local data = w1_wizard_net_cctv.data
	local gettext = function(id)
		local iptext = b_wnd_ex.get_text(top, id)
		return iptext
	end
	
	
	local ip = gettext(cwnd.t_ip.id);
	data.network_cctv.ip = ip
	local netmask = gettext(cwnd.t_netmask.id);
	data.network_cctv.netmask = netmask
	local gateway = gettext(cwnd.t_gateway.id);
	data.network_cctv.gateway = gateway
	local changeflag ,param = usercfgchange(w1_wizard_net_cctv.origin_cfg,w1_wizard_net_cctv.data)
	if(changeflag)then
		return param
	else
		return nil;
	end
	return data;
end

w1_wizard_net_cctv.clear = function()
	w1_wizard_net_cctv.origin_cfg = nil
	w1_wizard_net_cctv.data = nil
end

local on_next = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

w1_wizard_net_cctv.wnd = 
{		
	t='wnd_bg',id=id,xywh = 's_w1_wizard_net_cctv_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'},  
	sub = {'ipv4_cctv','hline','cap_ip','t_ip','cap_netmask','t_netmask','cap_mac1','t_mac1',
			'cap_gateway','t_gateway','tipinfo', 'next', 'cancel' },
	
	cap_ip 		= {t='static',id=id+1,xywh='s_w1_wizard_net_cctv_cap_ip_xywh',text='LA_IP_ADDRESS'},
	t_ip 		= {t='edit_ip',  id=id+2,xywh='s_w1_wizard_net_cctv_t_ip_xywh'},
	
	cap_netmask = {t='static',id=id+3,xywh='s_w1_wizard_net_cctv_cap_netmask_xywh',text='LA_SUBNET_MASK'},
	t_netmask 	= {t='edit_ip',  id=id+4,xywh='s_w1_wizard_net_cctv_t_netmask_xywh'},
	
	cap_gateway = {t='static',id=id+5,xywh='s_w1_wizard_net_cctv_cap_gateway_xywh',text='LA_GATEWAY'},
	t_gateway 	= {t='edit_ip',id=id+6,xywh='s_w1_wizard_net_cctv_t_gateway_xywh'},

--	cap_mac1 = {t='static',id=id+7,xywh='s_w1_wizard_net_cctv_cap_mac_xywh',text='LA_MAC_ADDRESS'},
--	t_mac1 	= {t='static',  id=id+8,xywh='s_w1_wizard_net_cctv_t_mac_xywh'},
	tipinfo		= {t='static',id=id+9,	xywh='s_w1_wizard_net_cctv_tipinfo_xywh',text='',trans = false},
	
}

return w1_wizard_net_cctv



