--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/7/3
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.wizard_network.ipv4_id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local global_val	= require("wnd.global_val")
local util 		= require("wnd.core.util")
local b_app_cfg	= require("wnd.core.b_app_cfg")
local b_app_api = require("wnd.core.command.b_app_api")
local global_val	= require("wnd.global_val")
local b_dlg 	= require("wnd.core.b_dlg")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local w1_wizard_network = 
{
	data={},
	origin_cfg,
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_wizard_network.s_768 =
{
	s_wizard_network_xywh = {2,53,448,447},
	s_wizard_network_cap_dhcp_xywh = {32,4,160,28},
	s_wizard_network_t_dhcp_xywh = {266,4,25,28},
	s_wizard_network_cap_ip_xywh = {32,35,160,28},
	s_wizard_network_t_ip_xywh = {266,35,133,28},
	s_wizard_network_cap_netmask_xywh = {32,66,160,28},
	s_wizard_network_t_netmask_xywh = {266,66,133,28},
	s_wizard_network_cap_gateway_xywh = {32,97,160,28},
	s_wizard_network_t_gateway_xywh = {266,97,133,28},
	s_wizard_network_cap_aotudns_xywh = {32,128,160,28},
	s_wizard_network_t_aotudns_xywh = {266,128,25,28},
	s_wizard_network_cap_dns1_xywh = {32,159,160,28},
	s_wizard_network_t_dns1_xywh = {266,159,133,28},
	s_wizard_network_cap_dns2_xywh = {32,200,160,28},
	s_wizard_network_t_dns2_xywh = {266,200,133,28},
	s_wizard_network_cap_switch_upnp_xywh = {32,231,160,28},
	s_wizard_network_t_switch_upnp_xywh = {266,231,25,28},
	s_wizard_network_cap_upnp_xywh = {32,262,160,28},
	s_wizard_network_t_upnp_xywh = {266,262,133,28},
	s_wizard_network_cap_http_xywh = {32,293,160,28},
	s_wizard_network_t_http_xywh = {266,293,133,28},
	s_wizard_network_cap_https_xywh = {32,324,160,28},
	s_wizard_network_t_https_xywh = {266,324,133,28},
	s_wizard_network_cap_port1_xywh = {32,355,160,28},
	s_wizard_network_t_port1_xywh = {266,355,133,28},
	s_wizard_network_cap_port2_xywh = {32,386,160,28},
	s_wizard_network_t_port2_xywh = {266,386,133,28},
	s_wizard_network_tipinfo_xywh = {32,416,373,30},
};

w1_wizard_network.s_1280 = 
{
	s_wizard_network_xywh={3,75,840,675},
	s_wizard_network_cap_dhcp_xywh= {60,20,300,40},
	s_wizard_network_t_dhcp_xywh={500,20,48,40},
	s_wizard_network_cap_ip_xywh= {60,65,300,40},
	s_wizard_network_t_ip_xywh={500,65,250,40},
	s_wizard_network_cap_netmask_xywh={60,110,300,40},
	s_wizard_network_t_netmask_xywh={500,110,250,40},
	s_wizard_network_cap_gateway_xywh={60,155,300,40},
	s_wizard_network_t_gateway_xywh={500,155,250,40},
	s_wizard_network_cap_aotudns_xywh={60,200,300,40},
	s_wizard_network_t_aotudns_xywh={500,200,48,40},
	s_wizard_network_cap_dns1_xywh={60,245,300,40},
	s_wizard_network_t_dns1_xywh={500,245,250,40},
	s_wizard_network_cap_dns2_xywh={60,290,300,40},
	s_wizard_network_t_dns2_xywh={500,290,250,40},
	s_wizard_network_cap_switch_upnp_xywh = {60,335,300,40},
	s_wizard_network_t_switch_upnp_xywh ={500,335,48,40},
	s_wizard_network_cap_upnp_xywh={60,380,300,40},
	s_wizard_network_t_upnp_xywh={500,380,250,40},
	s_wizard_network_cap_http_xywh={60,425,300,40},
	s_wizard_network_t_http_xywh={500,425,250,40},
	s_wizard_network_cap_https_xywh={60,470,300,40},
	s_wizard_network_t_https_xywh={500,470,250,40},
	s_wizard_network_cap_port1_xywh={60,515,300,40},
	s_wizard_network_t_port1_xywh={500,515,250,40},
	s_wizard_network_cap_port2_xywh={60,560,300,40},
	s_wizard_network_t_port2_xywh={500,560,250,40},
	s_wizard_network_tipinfo_xywh={60,610,700,30},
}
w1_wizard_network.s_1440 = 
{
	s_wizard_network_xywh={3,75,840,650},
	s_wizard_network_cap_dhcp_xywh= {60,20,300,40},
	s_wizard_network_t_dhcp_xywh={500,20,48,40},
	s_wizard_network_cap_ip_xywh= {60,65,300,40},
	s_wizard_network_t_ip_xywh={500,65,250,40},
	s_wizard_network_cap_netmask_xywh={60,110,300,40},
	s_wizard_network_t_netmask_xywh={500,110,250,40},
	s_wizard_network_cap_gateway_xywh={60,155,300,40},
	s_wizard_network_t_gateway_xywh={500,155,250,40},
	s_wizard_network_cap_aotudns_xywh={60,200,300,40},
	s_wizard_network_t_aotudns_xywh={500,200,48,40},
	s_wizard_network_cap_dns1_xywh={60,245,300,40},
	s_wizard_network_t_dns1_xywh={500,245,250,40},
	s_wizard_network_cap_dns2_xywh={60,290,300,40},
	s_wizard_network_t_dns2_xywh={500,290,250,40},
	s_wizard_network_cap_switch_upnp_xywh = {60,335,300,40},
	s_wizard_network_t_switch_upnp_xywh ={500,335,48,40},
	s_wizard_network_cap_upnp_xywh={60,380,300,40},
	s_wizard_network_t_upnp_xywh={500,380,250,40},
	s_wizard_network_cap_http_xywh={60,425,300,40},
	s_wizard_network_t_http_xywh={500,425,250,40},
	s_wizard_network_cap_https_xywh={60,470,300,40},
	s_wizard_network_t_https_xywh={500,470,250,40},
	s_wizard_network_cap_port1_xywh={60,515,300,40},
	s_wizard_network_t_port1_xywh={500,515,250,40},
	s_wizard_network_cap_port2_xywh={60,560,300,40},
	s_wizard_network_t_port2_xywh={500,560,250,40},
	s_wizard_network_tipinfo_xywh={60,610,700,30},
}
w1_wizard_network.s_1080p = 
{
	s_wizard_network_xywh={3,75,840,645},
	s_wizard_network_cap_dhcp_xywh= {60,10,300,40},
	s_wizard_network_t_dhcp_xywh={500,10,48,40},
	s_wizard_network_cap_ip_xywh= {60,55,300,40},
	s_wizard_network_t_ip_xywh={500,55,250,40},
	s_wizard_network_cap_netmask_xywh={60,100,300,40},
	s_wizard_network_t_netmask_xywh={500,100,250,40},
	s_wizard_network_cap_gateway_xywh={60,145,300,40},
	s_wizard_network_t_gateway_xywh={500,145,250,40},
	s_wizard_network_cap_aotudns_xywh={60,190,300,40},
	s_wizard_network_t_aotudns_xywh={500,190,48,40},
	s_wizard_network_cap_dns1_xywh={60,235,300,40},
	s_wizard_network_t_dns1_xywh={500,235,250,40},
	s_wizard_network_cap_dns2_xywh={60,280,300,40},
	s_wizard_network_t_dns2_xywh={500,280,250,40},
	s_wizard_network_cap_switch_upnp_xywh = {60,325,300,40},
	s_wizard_network_t_switch_upnp_xywh ={500,325,48,40},
	s_wizard_network_cap_upnp_xywh={60,370,300,40},
	s_wizard_network_t_upnp_xywh={500,370,250,40},
	s_wizard_network_cap_http_xywh={60,415,300,40},
	s_wizard_network_t_http_xywh={500,415,250,40},
	s_wizard_network_cap_https_xywh={60,460,300,40},
	s_wizard_network_t_https_xywh={500,460,250,40},
	s_wizard_network_cap_port1_xywh={60,505,300,40},
	s_wizard_network_t_port1_xywh={500,505,250,40},
	s_wizard_network_cap_port2_xywh={60,550,300,40},
	s_wizard_network_t_port2_xywh={500,550,250,40},
	s_wizard_network_tipinfo_xywh={60,595,700,50},
}

w1_wizard_network.s_2k = 
{
	s_wizard_network_xywh={3,100,1120,900},
	s_wizard_network_cap_dhcp_xywh= {80,27,400,53},
	s_wizard_network_t_dhcp_xywh={667,27,64,53},
	s_wizard_network_cap_ip_xywh= {80,90,400,53},
	s_wizard_network_t_ip_xywh={667,90,333,53},
	s_wizard_network_cap_netmask_xywh={80,153,400,53},
	s_wizard_network_t_netmask_xywh={667,153,333,53},
	s_wizard_network_cap_gateway_xywh={80,216,400,53},
	s_wizard_network_t_gateway_xywh={667,216,333,53},
	s_wizard_network_cap_aotudns_xywh={80,279,400,53},
	s_wizard_network_t_aotudns_xywh={667,279,64,53},
	s_wizard_network_cap_dns1_xywh={80,342,400,53},
	s_wizard_network_t_dns1_xywh={667,342,333,53},
	s_wizard_network_cap_dns2_xywh={80,405,400,53},
	s_wizard_network_t_dns2_xywh={667,405,333,53},
	s_wizard_network_cap_switch_upnp_xywh = {80,468,400,53},
	s_wizard_network_t_switch_upnp_xywh ={667,468,64,53},
	s_wizard_network_cap_upnp_xywh={80,531,400,53},
	s_wizard_network_t_upnp_xywh={667,531,333,53},
	s_wizard_network_cap_http_xywh={80,594,400,53},
	s_wizard_network_t_http_xywh={667,594,333,53},
	s_wizard_network_cap_https_xywh={80,657,400,53},
	s_wizard_network_t_https_xywh={667,657,333,53},
	s_wizard_network_cap_port1_xywh={80,720,400,53},
	s_wizard_network_t_port1_xywh={667,720,333,53},
	s_wizard_network_cap_port2_xywh={80,783,400,53},
	s_wizard_network_t_port2_xywh={667,783,333,53},
	s_wizard_network_tipinfo_xywh={80,840,933,60},
}

w1_wizard_network.s_4k = 
{
	s_wizard_network_xywh={6,150,1680,1350},
	s_wizard_network_cap_dhcp_xywh= {120,40,600,80},
	s_wizard_network_t_dhcp_xywh={1000,40,96,80},
	s_wizard_network_cap_ip_xywh= {120,130,600,80},
	s_wizard_network_t_ip_xywh={1000,130,500,80},
	s_wizard_network_cap_netmask_xywh={120,220,600,80},
	s_wizard_network_t_netmask_xywh={1000,220,500,80},
	s_wizard_network_cap_gateway_xywh={120,310,600,80},
	s_wizard_network_t_gateway_xywh={1000,310,500,80},
	s_wizard_network_cap_aotudns_xywh={120,400,600,80},
	s_wizard_network_t_aotudns_xywh={1000,400,96,80},
	s_wizard_network_cap_dns1_xywh={120,490,600,80},
	s_wizard_network_t_dns1_xywh={1000,490,500,80},
	s_wizard_network_cap_dns2_xywh={120,580,600,80},
	s_wizard_network_t_dns2_xywh={1000,580,500,80},
	s_wizard_network_cap_switch_upnp_xywh = {120,670,600,80},
	s_wizard_network_t_switch_upnp_xywh ={1000,670,96,80},
	s_wizard_network_cap_upnp_xywh={120,760,600,80},
	s_wizard_network_t_upnp_xywh={1000,760,500,80},
	s_wizard_network_cap_http_xywh={120,850,600,80},
	s_wizard_network_t_http_xywh={1000,850,500,80},
	s_wizard_network_cap_https_xywh={120,940,600,80},
	s_wizard_network_t_https_xywh={1000,940,500,80},
	s_wizard_network_cap_port1_xywh={120,1030,600,80},
	s_wizard_network_t_port1_xywh={1000,1030,500,80},
	s_wizard_network_cap_port2_xywh={120,1120,600,80},
	s_wizard_network_t_port2_xywh={1000,1120,500,80},
	s_wizard_network_tipinfo_xywh={120,1220,1400,100},
}

local redraw = false;
local refresh_dhcp_enable = function(top, disable, redraw)
	local cwnd = w1_wizard_network.wnd
	if disable then
		b_wnd_ex.set_color_d(top, cwnd.t_ip.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_d')},false);
		b_wnd_ex.set_color_d(top, cwnd.t_netmask.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_d')},false);
		b_wnd_ex.set_color_d(top, cwnd.t_gateway.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_d')},false);
	else
		b_wnd_ex.set_color_d(top, cwnd.t_ip.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_n')},false);	
		b_wnd_ex.set_color_d(top, cwnd.t_netmask.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_n')},false);	
		b_wnd_ex.set_color_d(top, cwnd.t_gateway.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_n')},false);		
	end
	b_wnd_ex.set_disable(top, cwnd.t_ip.id, disable, false)
	b_wnd_ex.set_disable(top, cwnd.t_netmask.id, disable, false)
	b_wnd_ex.set_disable(top, cwnd.t_gateway.id, disable, false)
	if true == redraw then
		b_dlg.dlg_set_redraw(top);
	end
end

local refresh_dns_enable = function(top, disable, redraw)
	local cwnd = w1_wizard_network.wnd
	if disable then
		b_wnd_ex.set_color_d(top, cwnd.t_dns1.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_d')},false);
		b_wnd_ex.set_color_d(top, cwnd.t_dns2.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_d')},false);
	else
		b_wnd_ex.set_color_d(top, cwnd.t_dns1.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_n')},false);	
		b_wnd_ex.set_color_d(top, cwnd.t_dns2.id,
		{COLOR('c_edit_bg_n'),COLOR('c_edit_border_n'),COLOR('c_txt_n')},false);			
	end
	b_wnd_ex.set_disable(top, cwnd.t_dns1.id, disable, false)
	b_wnd_ex.set_disable(top, cwnd.t_dns2.id, disable, false)
	if true == redraw then
		b_dlg.dlg_set_redraw(top);
	end
end

local refresh_upnp_auto_state = function(top, flag, redraw)
	local cwnd = w1_wizard_network.wnd
	local status = nil;
	if (0 == flag) then
		status = false
	else
		status = true;	
	end
	b_wnd_ex.set_disable(top, cwnd.t_http.id, status, false)
	b_wnd_ex.set_disable(top, cwnd.t_https.id, status, false)
	b_wnd_ex.set_disable(top, cwnd.t_port1.id, status, false)
	b_wnd_ex.set_disable(top, cwnd.t_port2.id, status, false)
	if true == redraw then
		b_dlg.dlg_set_redraw(top);
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local cwnd = w1_wizard_network.wnd
	local data = cfgdata.network_ipv4
	if (w1_wizard_network.data == nil) then
		w1_wizard_network.data = cfgdata;
	else
		util.copy_tab_b(w1_wizard_network.data, cfgdata);	
	end
	
	if(w1_wizard_network.origin_cfg == nil) then
		w1_wizard_network.origin_cfg = util.copy_tab(cfgdata)
	else
		util.copy_tab_b(w1_wizard_network.origin_cfg, cfgdata)
	end
	local function settext(id, str)
		b_wnd_ex.set_text(top, id, str,redraw)
	end
	local function setcheck(id, str)
		b_wnd_ex.set_check(top, id, str,redraw)
	end
	setcheck(cwnd.t_dhcp.id, data.dhcp );
	refresh_dhcp_enable(top,  data.dhcp, redraw)
	settext(cwnd.t_ip.id,  data.ip );
	settext(cwnd.t_netmask.id, data.netmask );
	settext(cwnd.t_gateway.id, data.gateway );
	
	setcheck(cwnd.t_aotudns.id, data.auto_dns );
	refresh_dns_enable(top,  data.auto_dns, redraw)
	settext(cwnd.t_dns1.id, data.dns1 );
	settext(cwnd.t_dns2.id, data.dns2 );
	
	local upnp_data = cfgdata.upnp
	local function setvalue(id, value)
		b_wnd_ex.set_value(top, id, value, redraw)
	end
	local function setcheck(id, str)
		b_wnd_ex.set_check(top, id, str,redraw)
	end
	
	b_wnd_ex.set_check(top, cwnd.upnp_t_switch.id, upnp_data.enable,redraw)
	local sel = nil;
	if (0 == upnp_data.upnp_type) then
		sel = 1;
	else
		sel = 0;
	end		
	b_wnd_ex.set_sel(top, cwnd.t_upnp.id, sel,redraw)
	setvalue(cwnd.t_http.id, upnp_data.http_port);
	setvalue(cwnd.t_https.id, upnp_data.https_port);
	setvalue(cwnd.t_port1.id, upnp_data.data_port);
	setvalue(cwnd.t_port2.id, upnp_data.jy_data_port);
	refresh_upnp_auto_state(top, sel, redraw)
	local dlg_w = global_val.get_size();
	b_wnd_ex.dlg_direct_up(top, cwnd.t_port2.id, true, false);
	if(dlg_w == 1440)then
		b_wnd_ex.dlg_direct_up(top, cwnd.t_http.id, true, false);
		b_wnd_ex.dlg_direct_up(top, cwnd.t_https.id, true, false);
		b_wnd_ex.dlg_direct_up(top, cwnd.t_port1.id, true, false);
	else
		b_wnd_ex.dlg_direct_up(top, cwnd.t_http.id, false, false);
		b_wnd_ex.dlg_direct_up(top, cwnd.t_https.id, false, false);
		b_wnd_ex.dlg_direct_up(top, cwnd.t_port1.id, false, false);
	end
	redraw = false;
	
	if(upnp_data.enable == true) then
		b_wnd_ex.set_hide(top, cwnd.cap_upnp.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.t_upnp.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.cap_http.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.t_http.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.cap_https.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.t_https.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.cap_port1.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.t_port1.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.cap_port2.id, false, false);
		b_wnd_ex.set_hide(top, cwnd.t_port2.id, false, false);
	else
		b_wnd_ex.set_hide(top, cwnd.cap_upnp.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_upnp.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.cap_http.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_http.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.cap_https.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_https.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.cap_port1.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_port1.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.cap_port2.id, true, false);
		b_wnd_ex.set_hide(top, cwnd.t_port2.id, true, false);
	end
		
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	local cwnd = w1_wizard_network.wnd;

	
	local legal, num = w1_legal.check_dns(top, cwnd.t_dns2.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_dns2.id)	
		if(num == w1_legal.netmask.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LAN_DNS_SERVER2'))
			--return legalflag, nlegalid
		elseif(num == w1_legal.netmask.LENERR or num == w1_legal.netmask.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LAN_DNS_SERVER2'))
			--return legalflag, nlegalid
		end
		
	end
	
	legal, num = w1_legal.check_dns(top, cwnd.t_dns1.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_dns1.id)	
		if(num == w1_legal.netmask.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LAN_DNS_SERVER'))
			--return legalflag, nlegalid
		elseif(num == w1_legal.netmask.LENERR or num == w1_legal.netmask.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LAN_DNS_SERVER'))
			--return legalflag, nlegalid
		end
	end
	
	local dns2str = b_wnd_ex.get_text(top, cwnd.t_dns2.id);
	local dns1str = b_wnd_ex.get_text(top, cwnd.t_dns1.id);
	local check = b_wnd_ex.get_check(top, cwnd.t_aotudns.id);
	if(false == check)then
		if(dns1str == dns2str) then
			if(dns1str ~= "")then
				legalflag = false;
				table.insert(nlegalid, cwnd.t_dns1.id);
				table.insert(nlegalid, cwnd.t_dns2.id)	
				w1_wnd_util.setparamerr_str(STR('LA_DNS_NOEQUAL'));
			end
		end 
	end
	
	
	legal, num = w1_legal.check_gataway(top, cwnd.t_gateway.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_gateway.id)	
		if(num == w1_legal.netmask.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LAN_DEFAULT_GATEWAY'))
		elseif(num == w1_legal.netmask.LENERR or num == w1_legal.netmask.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LAN_DEFAULT_GATEWAY'))
		end
	end
	
	legal, num = w1_legal.check_netmask(top, cwnd.t_netmask.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_netmask.id)	
		if(num == w1_legal.netmask.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LAN_SUBNET_MASK'))
		elseif(num == w1_legal.netmask.LENERR or num == w1_legal.netmask.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LAN_SUBNET_MASK'))
		end
	end	
	
	legal, num= w1_legal.check_ip(top, cwnd.t_ip.id);	
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_ip.id)	
		if(num == w1_legal.ip.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LA_CORRECT_IP'))
		elseif(num == w1_legal.ip.LENERR or num == w1_legal.ip.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LA_CORRECT_IP'))
		end
	end
	
	local upnp_enable = b_wnd_ex.get_check(top, cwnd.upnp_t_switch.id)
	if(false == upnp_enable)then --رUPnP򲻶Զ˿ںϷԽм
		if(legalflag) then
			return legalflag, nil
		else
			return legalflag, nlegalid
		end
	end	
	
	local flag = b_wnd_ex.get_sel(top, cwnd.t_upnp.id)
	if(flag ==1)then --Ϊauto UPnP򲻶Զ˿ںϷԽм
		if(legalflag) then
			return legalflag, nil
		else
			return legalflag, nlegalid
		end
	end

	local legal, num;
	legal, num = w1_legal.check_port2(top, cwnd.t_port2.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_port2.id)	
		if(num == w1_legal.port.OUT_RANGE) then
			w1_wnd_util.setparamerr_str(STR('LA_PORT_RANGE2'))
		elseif(num == w1_legal.port.SPECIAL) then
			w1_wnd_util.setparamerr_str(STR('LA_SPECIAL_PORT'))
		end
	end
	legal, num = w1_legal.check_port2(top, cwnd.t_port1.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_port1.id)	
		if(num == w1_legal.port.OUT_RANGE) then
			w1_wnd_util.setparamerr_str(STR('LA_PORT_RANGE2'))
		elseif(num == w1_legal.port.SPECIAL) then
			w1_wnd_util.setparamerr_str(STR('LA_SPECIAL_PORT'))
		end
	end
	legal, num = w1_legal.check_port2(top, cwnd.t_http.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_http.id)	
		if(num == w1_legal.port.OUT_RANGE) then
			w1_wnd_util.setparamerr_str(STR('LA_PORT_RANGE2'))
		elseif(num == w1_legal.port.SPECIAL) then
			w1_wnd_util.setparamerr_str(STR('LA_SPECIAL_PORT'))
		end
	end
	
	legal, num = w1_legal.check_port2(top, cwnd.t_https.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_https.id)	
		if(num == w1_legal.port.OUT_RANGE) then
			w1_wnd_util.setparamerr_str(STR('LA_PORT_RANGE2'))
		elseif(num == w1_legal.port.SPECIAL) then
			w1_wnd_util.setparamerr_str(STR('LA_SPECIAL_PORT'))
		end
	end
	
	if(legalflag) then	
		local httpport =  b_wnd_ex.get_value(top, cwnd.t_http.id)
		local httpsport =  b_wnd_ex.get_value(top, cwnd.t_https.id)
		local data1port =  b_wnd_ex.get_value(top, cwnd.t_port1.id)
		local data2port =  b_wnd_ex.get_value(top, cwnd.t_port2.id)

		if(httpport == httpsport ) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_http.id)	
			table.insert(nlegalid, cwnd.t_https.id)
			w1_wnd_util.setparamerr_str(STR('LA_PORT_SAME'))		
		elseif(httpport == data1port ) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_http.id)	
			table.insert(nlegalid, cwnd.t_port1.id)
			w1_wnd_util.setparamerr_str(STR('LA_PORT_SAME'))
		elseif(httpport == data2port) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_http.id)	
			table.insert(nlegalid, cwnd.t_port2.id)
			w1_wnd_util.setparamerr_str(STR('LA_PORT_SAME'))
		elseif(httpsport == data1port ) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_https.id)	
			table.insert(nlegalid, cwnd.t_port1.id)
			w1_wnd_util.setparamerr_str(STR('LA_PORT_SAME'))
		elseif(httpsport == data2port) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_https.id)	
			table.insert(nlegalid, cwnd.t_port2.id)
			w1_wnd_util.setparamerr_str(STR('LA_PORT_SAME'))
		elseif(data1port == data2port) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_port1.id)	
			table.insert(nlegalid, cwnd.t_port2.id)
			w1_wnd_util.setparamerr_str(STR('LA_PORT_SAME'))
		else				
			local ssl_support = global_val.get_support_ssl_attr();
			if ssl_support == true then
				if (httpport == 20001) then
					legalflag =false
					table.insert(nlegalid, cwnd.t_http.id)
					w1_wnd_util.setparamerr_str(STR('LA_SSLPORT_CONFLICT'))
				elseif (httpsport == 20001) then
					legalflag =false
					table.insert(nlegalid, cwnd.t_https.id)
					w1_wnd_util.setparamerr_str(STR('LA_SSLPORT_CONFLICT'))
				elseif(data1port == 20001) then
					legalflag =false
					table.insert(nlegalid, cwnd.t_port1.id)
					w1_wnd_util.setparamerr_str(STR('LA_SSLPORT_CONFLICT'))
				elseif(data2port == 20001) then
					legalflag =false
					table.insert(nlegalid, cwnd.t_port2.id)
					w1_wnd_util.setparamerr_str(STR('LA_SSLPORT_CONFLICT'))
				end			
			end
		end	

	end
		
	if(legalflag) then
		return legalflag, nil
	else
		return legalflag, nlegalid
	end
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_wizard_network.wnd
	local data = cfgdata
	local gettext = function(id)
		local iptext = b_wnd_ex.get_text(top, id)
		return iptext
	end
	
	local dhcp = b_wnd_ex.get_check(top,cwnd.t_dhcp.id);
	data.network_ipv4.dhcp =dhcp
	local ip = gettext(cwnd.t_ip.id);
	data.network_ipv4.ip = ip
	local netmask = gettext(cwnd.t_netmask.id);
	data.network_ipv4.netmask = netmask
	local gateway = gettext(cwnd.t_gateway.id);
	data.network_ipv4.gateway = gateway
	local autodns = b_wnd_ex.get_check(top, cwnd.t_aotudns.id);
	data.network_ipv4.auto_dns = autodns
	local dns1 = gettext(cwnd.t_dns1.id);
	data.network_ipv4.dns1 = dns1
	local dns2 = gettext(cwnd.t_dns2.id);
	data.network_ipv4.dns2 = dns2
	
	data.enable = b_wnd_ex.get_check(top, cwnd.upnp_t_switch.id)
	local sel = b_wnd_ex.get_sel(top, cwnd.t_upnp.id);
	if (0 == sel) then
		data.upnp.upnp_type = 1;
	else
		data.upnp.upnp_type = 0;	
	end
	local http_port = b_wnd_ex.get_value(top, cwnd.t_http.id);
	data.upnp.http_port =http_port
	local https_port = b_wnd_ex.get_value(top, cwnd.t_https.id);
	data.upnp.https_port =https_port
	local port1 = b_wnd_ex.get_value(top, cwnd.t_port1.id);
	data.upnp.data_port =port1
	local port2 = b_wnd_ex.get_value(top, cwnd.t_port2.id);
	data.upnp.jy_data_port =port2
	
	return 0
end

w1_wizard_network.timer_start = function()
	w1_wizard_network.timestart = true
end

w1_wizard_network.timer_stop = function(top)
	w1_wizard_network.timestart = false
	w1_wnd_util.tipclear(top, w1_wizard_network.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
	w1_wnd_util.tipdispoff();
end

w1_wizard_network.timerenevt = function(top)
	if(w1_wizard_network.timestart) then
		local save_flag = w1_wnd_util.timerenevt(top, w1_wizard_network.wnd.tipinfo.id)
		if(save_flag ==1)then
			local enable = b_wnd_ex.get_check(top, w1_wizard_network.wnd.t_dhcp.id)
			if(true == enable)then
				redraw =true;
				w1_wnd_util.cfgtab = {'network_ipv4'}
				w1_wnd_util.cfgtouifunc = cfgdatatoui
				w1_wnd_util.page_init(top)
			end
		end
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_wizard_network.init = function(top)
	w1_wnd_util.cfgtab = {'network_ipv4','upnp'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

w1_wizard_network.returndatacheck =function(top,ret)
	if(ret ~= nil and ret.network_ipv4 ~= 0) then--޸ʧ
		local cwnd = w1_wizard_network.wnd;
		local nlegalid = {};
		if(ret.network_ipv4 == -1 ) then
			w1_wnd_util.setparamerr_str(STR('LA_PARAMETER_ERR'));
		elseif(ret.network_ipv4 == -2) then
			table.insert(nlegalid, cwnd.t_ip.id);
			w1_wnd_util.setparamerr_str(STR('LA_POE_LOCAL_IP_TIP'));
		elseif(ret.network_ipv4 == -3) then
			table.insert(nlegalid, cwnd.t_ip.id);
			w1_wnd_util.setparamerr_str(STR('LA_MSG_IP_CONFLICT'));	
		elseif (ret.network_ipv4 == -543) then
			table.insert(nlegalid, cwnd.t_ip.id);
			w1_wnd_util.setparamerr_str(STR('LA_NETWORK_IP_ERROR'));
		end			
		return false, nlegalid;
	end
	return true, nil;
end

w1_wizard_network.next =function(top)
	uitousercfg(top,b_app_cfg.user_cfg);
	w1_wnd_util.uidatacheckfunc = uidatacheck
	local flag = w1_wnd_util.check_legal_tip(top)
	if(flag ~= 0)then
		w1_wnd_util.tipdispon()		--ʾ
		return -1
	end	
	
	return 0;
end

w1_wizard_network.ip_to_cctv =function (top)
	w1_wnd_util.uidatacheckfunc = uidatacheck
	local flag = w1_wnd_util.check_legal_tip(top)
	if(flag ~= 0)then
		w1_wnd_util.tipdispon()		--ʾ
		return -1
	end	
	return 0;
end

local tabcompare = function(origin_cfg,cur_cfg)
	local param = {}
	for k, v in pairs(cur_cfg) do
		if(origin_cfg[k] ~= nil ) then
			--table,λûеtable¼param
			if( util.compare_tab(origin_cfg[k], cur_cfg[k]) == 1 ) then
				if(param[k] == nil) then
					param[k] =  util.copy_tab(cur_cfg[k])
				else
					util.copy_tab_b(param[k], cur_cfg[k])
				end			
			end
		end
	end
	return param
end

--ûǷи,и,򷵻ظĺ
local usercfgchange =function(origin_cfg,cur_cfg)
	local param = tabcompare(origin_cfg,cur_cfg)
	if(	util.is_empty(param) )then
		return false,nil
	else
		return true, param
	end
end

w1_wizard_network.get_data =function(top)
	local cwnd = w1_wizard_network.wnd
	local data = w1_wizard_network.data
	local gettext = function(id)
		local iptext = b_wnd_ex.get_text(top, id)
		return iptext
	end
	
	local dhcp = b_wnd_ex.get_check(top,cwnd.t_dhcp.id);
	data.network_ipv4.dhcp =dhcp
	local ip = gettext(cwnd.t_ip.id);
	data.network_ipv4.ip = ip
	local netmask = gettext(cwnd.t_netmask.id);
	data.network_ipv4.netmask = netmask
	local gateway = gettext(cwnd.t_gateway.id);
	data.network_ipv4.gateway = gateway
	local autodns = b_wnd_ex.get_check(top, cwnd.t_aotudns.id);
	data.network_ipv4.auto_dns = autodns
	local dns1 = gettext(cwnd.t_dns1.id);
	data.network_ipv4.dns1 = dns1
	local dns2 = gettext(cwnd.t_dns2.id);
	data.network_ipv4.dns2 = dns2
	
	data.upnp.enable = b_wnd_ex.get_check(top, cwnd.upnp_t_switch.id)
	local sel  = b_wnd_ex.get_sel(top, cwnd.t_upnp.id)
	if (0 == sel) then
		data.upnp.upnp_type = 1;
	else
		data.upnp.upnp_type = 0;	
	end
	
	local http_port = b_wnd_ex.get_value(top, cwnd.t_http.id);
	data.upnp.http_port =http_port
	local https_port = b_wnd_ex.get_value(top, cwnd.t_https.id);
	data.upnp.https_port =https_port
	local port1 = b_wnd_ex.get_value(top, cwnd.t_port1.id);
	data.upnp.data_port =port1
	local port2 = b_wnd_ex.get_value(top, cwnd.t_port2.id);
	data.upnp.jy_data_port =port2
	
	local changeflag ,param = usercfgchange(w1_wizard_network.origin_cfg,w1_wizard_network.data)
	if(changeflag)then
		return param
	else
		return nil;
	end
	return data;
end

local on_dhcp = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local check = b_wnd_ex.get_check(top, win_id)
		refresh_dhcp_enable(top,  check, true)
	end
	return 0
end

local on_aotudns = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local check = b_wnd_ex.get_check(top, win_id)
		refresh_dns_enable(top,  check, true)
	end
	return 0
end

local on_next = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		uitousercfg(top,b_app_cfg.user_cfg);
		w1_wnd_util.uidatacheckfunc = uidatacheck
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_switch_upnp = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		local cwnd = w1_wizard_network.wnd
		local flag = b_wnd_ex.get_check(top, cwnd.upnp_t_switch.id)
		if(flag == true) then
			b_wnd_ex.set_hide(top, cwnd.cap_upnp.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.t_upnp.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.cap_http.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.t_http.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.cap_https.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.t_https.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.cap_port1.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.t_port1.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.cap_port2.id, false, false);
			b_wnd_ex.set_hide(top, cwnd.t_port2.id, false, false);
		else
			b_wnd_ex.set_hide(top, cwnd.cap_upnp.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.t_upnp.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.cap_http.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.t_http.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.cap_https.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.t_https.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.cap_port1.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.t_port1.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.cap_port2.id, true, false);
			b_wnd_ex.set_hide(top, cwnd.t_port2.id, true, false);
		end
		uitousercfg(top,b_app_cfg.user_cfg);
		b_dlg.dlg_set_redraw(top)
	end
	return 0
end

local on_manual_auto = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local cwnd = w1_wizard_network.wnd
		local flag = b_wnd_ex.get_sel(top, cwnd.t_upnp.id)
		refresh_upnp_auto_state(top, flag, true)
	end
	return 0
end

w1_wizard_network.clear =function(top)
	w1_wizard_network.data = nil
	w1_wizard_network.origin_cfg = nil
end	

w1_wizard_network.wnd = 
{		
	t='wnd_bg',id=id,xywh = 's_wizard_network_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {'network','hline','cap_dhcp','t_dhcp','cap_ip','t_ip','cap_netmask','t_netmask',
			'cap_gateway','t_gateway','cap_aotudns','t_aotudns',
			'cap_dns1','t_dns1','cap_dns2','t_dns2','upnp_c_switch', 'upnp_t_switch', 'cap_upnp','t_upnp',
			'cap_http','t_http','cap_https','t_https','cap_port1','t_port1','cap_port2','t_port2','tipinfo', 'next', 'cancel' },
	
	cap_dhcp 	= {t='static',id=id+3,xywh='s_wizard_network_cap_dhcp_xywh',text='LA_ENABLE_DHCP'},
	t_dhcp 		= {t='tt_check', id=id+4,xywh='s_wizard_network_t_dhcp_xywh',font = 'f_grade1',
				t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_dhcp},
	
	cap_ip 		= {t='static',id=id+5,xywh='s_wizard_network_cap_ip_xywh',text='LA_IP_ADDRESS'},
	t_ip 		= {t='edit_ip',  id=id+6,xywh='s_wizard_network_t_ip_xywh'},
	
	cap_netmask = {t='static',id=id+7,xywh='s_wizard_network_cap_netmask_xywh',text='LA_SUBNET_MASK'},
	t_netmask 	= {t='edit_ip',  id=id+8,xywh='s_wizard_network_t_netmask_xywh'},
	
	cap_gateway = {t='static',id=id+9,xywh='s_wizard_network_cap_gateway_xywh',text='LA_GATEWAY'},
	t_gateway 	= {t='edit_ip',  id=id+10,xywh='s_wizard_network_t_gateway_xywh'},
	
	cap_aotudns = {t='static',id=id+11,xywh='s_wizard_network_cap_aotudns_xywh',text='LA_DNS_SWITCH'},
	t_aotudns 	= {t='tt_check', id=id+12,xywh='s_wizard_network_t_aotudns_xywh',font = 'f_grade1',
				t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_aotudns},
	
	cap_dns1 	= {t='static',id=id+13,xywh='s_wizard_network_cap_dns1_xywh',text='LA_DNS1'},
	t_dns1 		= {t='edit_ip',  id=id+14,xywh='s_wizard_network_t_dns1_xywh'},
	
	cap_dns2 	= {t='static',id=id+15,xywh='s_wizard_network_cap_dns2_xywh',text='LA_DNS2'},
	t_dns2 		= {t='edit_ip',  id=id+16,xywh='s_wizard_network_t_dns2_xywh'},
	
	upnp_c_switch 	= {t='static',id=id+17,xywh='s_wizard_network_cap_switch_upnp_xywh',text='LA_UPNP_ENABLE'},
	upnp_t_switch 		= {t='tt_check', id=id+18,xywh='s_wizard_network_t_switch_upnp_xywh',font = 'f_grade1',
				t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					cmd = on_switch_upnp},
					
	cap_upnp = {t='static',id=id+19,xywh='s_wizard_network_cap_upnp_xywh',text='LA_MODE'},
	t_upnp 	= {t='combox',id=id+20,xywh='s_wizard_network_t_upnp_xywh',items={'Manual','Auto'},
					trans = false, cmd = on_manual_auto},
	cap_http 	= {t='static',	id=id+21,	xywh='s_wizard_network_cap_http_xywh',		text='LA_HTTP_PORT'},
	t_http 		= {t='edit_num',id=id+22,	xywh='s_wizard_network_t_http_xywh',range={0,65534}},
	
	cap_https 	= {t='static',	id=id+23,	xywh='s_wizard_network_cap_https_xywh',		text='LA_HTTPS_PORT'},
	t_https 	= {t='edit_num',id=id+24,	xywh='s_wizard_network_t_https_xywh',range={0,65534}},
	
	cap_port1 	= {t='static',	id=id+25,	xywh='s_wizard_network_cap_port1_xywh',		text='LA_DATA_PORT1'},
	t_port1 	= {t='edit_num',id=id+26,	xywh='s_wizard_network_t_port1_xywh',range={0,65534}},
	
	cap_port2 	= {t='static',	id=id+27,	xywh='s_wizard_network_cap_port2_xywh',		text='LA_DATA_PORT2'},
	t_port2 	= {t='edit_num',id=id+28,	xywh='s_wizard_network_t_port2_xywh',range={0,65534}},

	tipinfo		= {t='static',id=id+29,	xywh='s_wizard_network_tipinfo_xywh',text='',trans = false},
}

return w1_wizard_network



