--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/8/14
-- author 
-- brief  
--]]
local global_val	= require("wnd.global_val")
local b_ui 			= require("wnd.core.b_ui")
local w1_key 		= require("wnd.w1_util.w1_key")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.wizard_network_setup.id
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_legal 		= require("wnd.w1_util.w1_legal")
local r_str			= require("wnd.core.r_res.r_str")
local STR 			= r_str.get_str
local b_app_cfg  = require("wnd.core.b_app_cfg")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local w1_wizard_network	= require("wnd.w1_live.w1_wizard_network")
local w1_wizard_net_cctv	= require("wnd.w1_live.w1_wizard_net_cctv")
local net_data ={};
local w1_wizard_network_setup = 
{
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_wizard_network_setup.s_768 =
{
	s_w1_wizard_network_setup_xywh = {2,35,448,490},
	s_w1_wizard_network_setup_time_xywh = {10,14,85,35},
	s_w1_wizard_network_setup_tzone_xywh = {133,14,80,35},
	s_w1_wizard_network_setup_hline_xywh = {8,49,430,1},
};

w1_wizard_network_setup.s_1280 = 
{
	s_w1_wizard_network_setup_xywh ={3,50,840,750},
	s_w1_wizard_network_setup_time_xywh={20,20,160,50},
	s_w1_wizard_network_setup_tzone_xywh= {250,20,150,50},
	s_w1_wizard_network_setup_hline_xywh={15,70,808,2},
}
w1_wizard_network_setup.s_1440 = 
{
	s_w1_wizard_network_setup_xywh ={3,50,840,725},
	s_w1_wizard_network_setup_time_xywh={20,20,160,50},
	s_w1_wizard_network_setup_tzone_xywh= {250,20,150,50},
	s_w1_wizard_network_setup_hline_xywh={15,70,808,2},
}
w1_wizard_network_setup.s_1080p = 
{
	s_w1_wizard_network_setup_xywh ={3,50,840,720},--{0,50,850,750},
	s_w1_wizard_network_setup_time_xywh={20,20,160,50},
	s_w1_wizard_network_setup_tzone_xywh= {250,20,150,50},
	s_w1_wizard_network_setup_hline_xywh={15,70,808,2},
}

w1_wizard_network_setup.s_2k = 
{
	s_w1_wizard_network_setup_xywh ={4,67,1120,1000},
	s_w1_wizard_network_setup_time_xywh={27,27,213,67},
	s_w1_wizard_network_setup_tzone_xywh= {333,27,200,67},
	s_w1_wizard_network_setup_hline_xywh={20,93,1077,3},
}

w1_wizard_network_setup.s_4k = 
{
	s_w1_wizard_network_setup_xywh ={6,100,1680,1500},
	s_w1_wizard_network_setup_time_xywh={40,40,320,100},
	s_w1_wizard_network_setup_tzone_xywh= {500,40,300,100},
	s_w1_wizard_network_setup_hline_xywh={0,140,1616,4},

}

local redraw = false;
local refresh_dhcp_enable = function(top, disable, redraw)
	local cwnd = w1_wizard_network_setup.wnd
	b_wnd_ex.set_disable(top, cwnd.t_ip.id, disable, redraw)
	b_wnd_ex.set_disable(top, cwnd.t_netmask.id, disable, redraw)
	b_wnd_ex.set_disable(top, cwnd.t_gateway.id, disable, redraw)
end

local refresh_dns_enable = function(top, disable, redraw)
	local cwnd = w1_wizard_network_setup.wnd
	b_wnd_ex.set_disable(top, cwnd.t_dns1.id, disable, redraw)
	b_wnd_ex.set_disable(top, cwnd.t_dns2.id, disable, redraw)
end

local refresh_enable = function(top, disable, redraw)
	local cwnd = w1_wizard_network_setup.wnd
	b_wnd_ex.set_disable(top, cwnd.t_http.id, disable, redraw)
	b_wnd_ex.set_disable(top, cwnd.t_port1.id, disable, redraw)
	b_wnd_ex.set_disable(top, cwnd.t_port2.id, disable, redraw)
end

local refresh_upnp_enable = function(top, disable, redraw)
	local cwnd = w1_wizard_network_setup.wnd
	b_wnd_ex.set_disable(top, cwnd.t_http.id, disable, redraw)
	b_wnd_ex.set_disable(top, cwnd.t_port1.id, disable, redraw)
	b_wnd_ex.set_disable(top, cwnd.t_port2.id, disable, redraw)
end
--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local cwnd = w1_wizard_network_setup.wnd
	local data = cfgdata.network_ipv4
	local function settext(id, str)
		b_wnd_ex.set_text(top, id, str,redraw)
	end
	local function setcheck(id, str)
		b_wnd_ex.set_check(top, id, str,redraw)
	end
	setcheck(cwnd.t_dhcp.id, data.dhcp );
	refresh_dhcp_enable(top,  data.dhcp, redraw)
	settext(cwnd.t_ip.id,  data.ip );
	settext(cwnd.t_netmask.id, data.netmask );
	settext(cwnd.t_gateway.id, data.gateway );
	
	setcheck(cwnd.t_aotudns.id, data.auto_dns );
	refresh_dns_enable(top,  data.auto_dns, redraw)
	settext(cwnd.t_dns1.id, data.dns1 );
	settext(cwnd.t_dns2.id, data.dns2 );
	
	local upnp_data = cfgdata.upnp
	local function setvalue(id, value)
		b_wnd_ex.set_value(top, id, value, redraw)
	end
	local function setcheck(id, str)
		b_wnd_ex.set_check(top, id, str,redraw)
	end
--	setcheck(cwnd.t_upnp.id,upnp_data.enable);
	
	if(upnp_data.enable ==false)then
		b_wnd_ex.set_sel(top, cwnd.t_upnp.id, 0,redraw)
	else
		b_wnd_ex.set_sel(top, cwnd.t_upnp.id, 1,redraw)
	end
	setvalue(cwnd.t_http.id, upnp_data.http_port);
	setvalue(cwnd.t_port1.id, upnp_data.data_port);
	setvalue(cwnd.t_port2.id, upnp_data.jy_data_port);
	refresh_upnp_enable(top, upnp_data.enable, redraw)
	local dlg_w = global_val.get_size();
	if(dlg_w == 1280 or dlg_w == 1440) then
		b_wnd_ex.dlg_direct_up(top, cwnd.t_port2.id, true, false);
	else
		b_wnd_ex.dlg_direct_up(top, cwnd.t_port2.id, false, false);
	end
	if(dlg_w == 1440)then
		b_wnd_ex.dlg_direct_up(top, cwnd.t_port1.id, true, false);
	else
		b_wnd_ex.dlg_direct_up(top, cwnd.t_port1.id, false, false);
	end
	redraw = false;
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	local cwnd = w1_wizard_network_setup.wnd;

	
	local legal, num = w1_legal.check_dns(top, cwnd.t_dns2.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_dns2.id)	
		if(num == w1_legal.netmask.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LAN_DNS_SERVER2'))
			--return legalflag, nlegalid
		elseif(num == w1_legal.netmask.LENERR or num == w1_legal.netmask.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LAN_DNS_SERVER2'))
			--return legalflag, nlegalid
		end
		
	end
	
	legal, num = w1_legal.check_dns(top, cwnd.t_dns1.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_dns1.id)	
		if(num == w1_legal.netmask.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LAN_DNS_SERVER'))
			--return legalflag, nlegalid
		elseif(num == w1_legal.netmask.LENERR or num == w1_legal.netmask.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LAN_DNS_SERVER'))
			--return legalflag, nlegalid
		end
	end
	
	local dns2str = b_wnd_ex.get_text(top, cwnd.t_dns2.id);
	local dns1str = b_wnd_ex.get_text(top, cwnd.t_dns1.id);
	local check = b_wnd_ex.get_check(top, cwnd.t_aotudns.id);
	if(false == check)then
		if(dns1str == dns2str) then
			if(dns1str ~= "")then
				legalflag = false;
				table.insert(nlegalid, cwnd.t_dns1.id);
				table.insert(nlegalid, cwnd.t_dns2.id)	
				w1_wnd_util.setparamerr_str(STR('LA_DNS_NOEQUAL'));
			end
		end 
	end
	
	
	legal, num = w1_legal.check_gataway(top, cwnd.t_gateway.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_gateway.id)	
		if(num == w1_legal.netmask.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LAN_DEFAULT_GATEWAY'))
		elseif(num == w1_legal.netmask.LENERR or num == w1_legal.netmask.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LAN_DEFAULT_GATEWAY'))
		end
	end
	
	legal, num = w1_legal.check_netmask(top, cwnd.t_netmask.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_netmask.id)	
		if(num == w1_legal.netmask.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LAN_SUBNET_MASK'))
		elseif(num == w1_legal.netmask.LENERR or num == w1_legal.netmask.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LAN_SUBNET_MASK'))
		end
	end	
	
	legal, num= w1_legal.check_ip(top, cwnd.t_ip.id);	
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_ip.id)	
		if(num == w1_legal.ip.EMPTY) then
			w1_wnd_util.setparamerr_str(STR('LA_CORRECT_IP'))
		elseif(num == w1_legal.ip.LENERR or num == w1_legal.ip.PRARMERR) then
			w1_wnd_util.setparamerr_str(STR('LA_CORRECT_IP'))
		end
	end
	
	
	local flag = b_wnd_ex.get_sel(top, cwnd.t_upnp.id)
	if(flag ==1)then --UPnP򲻶Զ˿ںϷԽм
		if(legalflag) then
			return legalflag, nil
		else
			return legalflag, nlegalid
		end
	end

	local legal, num;
	legal, num = w1_legal.check_port(top, cwnd.t_port2.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_port2.id)	
		if(num == w1_legal.port.OUT_RANGE) then
			w1_wnd_util.setparamerr_str(STR('LA_HTTPPORT_RANGE'))
		elseif(num == w1_legal.port.SPECIAL) then
			w1_wnd_util.setparamerr_str(STR('LA_SPECIAL_PORT'))
		end
	end
	legal, num = w1_legal.check_port(top, cwnd.t_port1.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_port1.id)	
		if(num == w1_legal.port.OUT_RANGE) then
			w1_wnd_util.setparamerr_str(STR('LA_HTTPPORT_RANGE'))
		elseif(num == w1_legal.port.SPECIAL) then
			w1_wnd_util.setparamerr_str(STR('LA_SPECIAL_PORT'))
		end
	end
	legal, num = w1_legal.check_port(top, cwnd.t_http.id);
	if(legal == false) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_http.id)	
		if(num == w1_legal.port.OUT_RANGE) then
			w1_wnd_util.setparamerr_str(STR('LA_HTTPPORT_RANGE'))
		elseif(num == w1_legal.port.SPECIAL) then
			w1_wnd_util.setparamerr_str(STR('LA_SPECIAL_PORT'))
		end
	end
	
	if(legalflag) then	
		local httpport =  b_wnd_ex.get_value(top, cwnd.t_http.id)
		local data1port =  b_wnd_ex.get_value(top, cwnd.t_port1.id)
		local data2port =  b_wnd_ex.get_value(top, cwnd.t_port2.id)
		
		if(httpport == data1port ) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_http.id)	
			table.insert(nlegalid, cwnd.t_port1.id)	
		elseif(httpport == data2port) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_http.id)	
			table.insert(nlegalid, cwnd.t_port2.id)	
		elseif(data1port == data2port) then
			legalflag =false
			table.insert(nlegalid, cwnd.t_port1.id)	
			table.insert(nlegalid, cwnd.t_port2.id)	
		end	
		if(legalflag == false) then
			w1_wnd_util.setparamerr_str(STR('LA_PORT_SAME'))
		end
	end
		
	if(legalflag) then
		return legalflag, nil
	else
		return legalflag, nlegalid
	end
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local cwnd = w1_wizard_network_setup.wnd
	local data = cfgdata
	local gettext = function(id)
		local iptext = b_wnd_ex.get_text(top, id)
		return iptext
	end
	
	local dhcp = b_wnd_ex.get_check(top,cwnd.t_dhcp.id);
	data.network_ipv4.dhcp =dhcp
	local ip = gettext(cwnd.t_ip.id);
	data.network_ipv4.ip = ip
	local netmask = gettext(cwnd.t_netmask.id);
	data.network_ipv4.netmask = netmask
	local gateway = gettext(cwnd.t_gateway.id);
	data.network_ipv4.gateway = gateway
	local autodns = b_wnd_ex.get_check(top, cwnd.t_aotudns.id);
	data.network_ipv4.auto_dns = autodns
	local dns1 = gettext(cwnd.t_dns1.id);
	data.network_ipv4.dns1 = dns1
	local dns2 = gettext(cwnd.t_dns2.id);
	data.network_ipv4.dns2 = dns2
	
	local flag = b_wnd_ex.get_sel(top, cwnd.t_upnp.id)
	if(flag ==0)then
		data.upnp.enable= false
	else
		data.upnp.enable= true
	end
--	local flag = b_wnd_ex.get_check(top, cwnd.t_upnp.id)
	
	local http_port = b_wnd_ex.get_value(top, cwnd.t_http.id);
	data.upnp.http_port =http_port
	local port1 = b_wnd_ex.get_value(top, cwnd.t_port1.id);
	data.upnp.data_port =port1
	local port2 = b_wnd_ex.get_value(top, cwnd.t_port2.id);
	data.upnp.jy_data_port =port2
	
	return 0
end

w1_wizard_network_setup.timer_start = function()
	w1_wizard_network_setup.timestart = true
end

w1_wizard_network_setup.timer_stop = function(top)
--[[	w1_wizard_network_setup.timestart = false
	w1_wnd_util.tipclear(top, w1_wizard_network_setup.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
	w1_wnd_util.tipdispoff();--]]
end

w1_wizard_network_setup.timerenevt = function(top)
	return 0
end

--ҳʼʱٶȡҳҪ
w1_wizard_network_setup.init = function(top)
	return 0
end

w1_wizard_network_setup.next =function(top)
	w1_wnd_util.uidatacheckfunc = uidatacheck
	local flag = w1_wnd_util.check_legal_tip(top)
	if(flag ~= 0)then
		w1_wnd_util.tipdispon()		--ʾ
		return -1
	end	
	
	uitousercfg(top,b_app_cfg.user_cfg);
	w1_wnd_util.page_onapply(top)
	return 0;
end

w1_wizard_network_setup.get_data =function(top)
	
end

w1_wizard_network_setup.get_checkidx = function(top)
	local ipv4 = b_wnd_ex.get_check(top, w1_wizard_network_setup.wnd.ipv4.id);
	local ipv4_cctv = b_wnd_ex.get_check(top, w1_wizard_network_setup.wnd.ipv4_cctv.id);
	if(ipv4) then
		return 0
	elseif(ipv4_cctv) then
		return 1
	end
end

local on_ipv4 = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if (2==global_val.get_nic_num())then
			if(0 ~= w1_wizard_net_cctv.cctv_to_ip(top))then
				b_wnd_ex.set_check(top, w1_wizard_network_setup.wnd.ipv4.id, false, true);
				return 0;
			end
			w1_wizard_net_cctv.timer_stop(top);
			b_wnd_ex.set_check(top, w1_wizard_network_setup.wnd.ipv4_cctv.id, false, true);
			b_wnd_ex.set_show_page(top,w1_id.wizard_network_setup.conRow_id, w1_id.wizard_network.ipv4_id, true)	
			
			
			w1_wizard_network.timer_start();
		end
	end
	return 0
end

local on_ipv4_cctv = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		if(0 ~= w1_wizard_network.ip_to_cctv(top))then
			b_wnd_ex.set_check(top, w1_wizard_network_setup.wnd.ipv4_cctv.id, false, true);
			return 0;
		end
--		local ipv4 = w1_wizard_network.get_data(top);
		w1_wizard_network.timer_stop(top);
		local check_idx = w1_wizard_network_setup.get_checkidx(top)
		b_wnd_ex.set_check(top, w1_wizard_network_setup.wnd.ipv4.id, false, true);
		b_wnd_ex.set_show_page(top,w1_id.wizard_network_setup.conRow_id, w1_id.wizard_network.ipv4_cctv_id, true)
		w1_wizard_net_cctv.timer_start();
	end
	return 0
end

w1_wizard_network_setup.init =function (top)
	if (2==global_val.get_nic_num())then
		w1_wizard_net_cctv.init(top);
	end
	w1_wizard_network.init (top);
	local check_idx = w1_wizard_network_setup.get_checkidx(top)
	if(0 == check_idx)then
		w1_wizard_network.timer_start();
	else
		w1_wizard_net_cctv.timer_start();
	end
		
end

w1_wizard_network_setup.on_pre_show = function(top)
	local cwnd = w1_wizard_network_setup.wnd;
	local con_id = cwnd.containerRow.id
	b_wnd_ex.set_add_page(top, con_id, cwnd.w1_wizard_network_wnd.id)
	
	if (2==global_val.get_nic_num())then
		b_wnd_ex.set_add_page(top, con_id, cwnd.w1_wizard_net_cctv_wnd.id)
	else
		b_wnd_ex.set_hide(top, cwnd.ipv4_cctv.id, true, false)
		b_wnd_ex.set_hide(top, cwnd.w1_wizard_net_cctv_wnd.id, true, false)
	end
	
	b_wnd_ex.set_show_page(top,con_id, cwnd.w1_wizard_network_wnd.id, false)
end

w1_wizard_network_setup.wnd= {
	--attr={xywh={1015,378,900,660}};
	t='wnd_bg',id=id,xywh = 's_w1_wizard_network_setup_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = {	'containerColumn', 'containerRow', 'containerItem',
			'w1_wizard_network_setup_setup_wnd','w1_wizard_network_wnd','w1_wizard_network_setup_row',
			'w1_wizard_net_cctv_wnd',
			'close','ipv4','ipv4_cctv', 'hline'
		},
		
	containerRow	= {t='container',id=w1_id.wizard_network_setup.conRow_id,	xywh='s_cfg_con_xywh'},
--	w1_wizard_network_setup_row	= w1_wizard_network_setup_row.wnd,	
	w1_wizard_network_wnd 	= w1_wizard_network.wnd,
	w1_wizard_net_cctv_wnd	=	w1_wizard_net_cctv.wnd,
	ipv4 	= {t='checktxt',	id=id+4,xywh='s_w1_wizard_network_setup_time_xywh',
				text='LA_NETWORK',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_ipv4,check = true},
	ipv4_cctv 	= {t='checktxt',	id=id+5,xywh= 's_w1_wizard_network_setup_tzone_xywh',
				text='LA_IPV4_CCTV',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,
				cmd=on_ipv4_cctv},
	hline 	= {t='hline',	id=id+7,xywh='s_w1_wizard_network_setup_hline_xywh'}
	
}


return w1_wizard_network_setup



