--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/9
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local w1_id 	= require("wnd.w1_util.w1_id")
local b_app_api = require("wnd.core.command.b_app_api")
local id 		= w1_id.wizard_sys.id
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_dlg 	= require("wnd.core.b_dlg")
local r_str		= require("wnd.core.r_res.r_str")
local w1_legal 	= require("wnd.w1_util.w1_legal")
local util 		= require("wnd.core.util")
local b_app_cfg  = require("wnd.core.b_app_cfg")
local LANGUAGE = {
	"english","french","polish", "italan", "spanish", "hungarian", "russian", "vietnamese", "thai", 
	"danish", "czech", "slovakia","indonesian","portuguese","dutch","german"
};
local w1_wizard_sys = {
	timestart = false,
	data,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_wizard_sys.s_768 =
{
	s_wizard_sys_xywh = {2,35,448,547},
	s_wizard_sys_resolution_xywh = {10,14,160,35},
	s_wizard_sys_hline_xywh = {8,49,437,1},
	s_wizard_sys_c_disp_xywh = {32,64,160,32},
	s_wizard_sys_t_disp_xywh = {213,64,160,32},
	s_wizard_sys_tipinfo_xywh = {53,192,266,35},
	s_wizard_sys_apply_xywh = {213,106,80,32},
	s_wizard_sys_tip_check_xywh = {16,512,26,28},
	s_wizard_sys_tip1_xywh = {42,512,320,28},
};

w1_wizard_sys.s_1280 = 
{
	s_wizard_sys_xywh={3,50,840,770},
	s_wizard_sys_resolution_xywh={20,20,300,50},
	s_wizard_sys_hline_xywh={15,70,820,2},
	s_wizard_sys_c_disp_xywh={60,90,300,45},
	s_wizard_sys_t_disp_xywh={400,90,300,45},
	s_wizard_sys_tipinfo_xywh={100,270,500,50},
	s_wizard_sys_apply_xywh={400,150,150,45},
	s_wizard_sys_tip_check_xywh={30,720,50,40},
	s_wizard_sys_tip1_xywh={80,720,600,40},
}
w1_wizard_sys.s_1440 = 
{
	s_wizard_sys_xywh={3,50,840,740},
	s_wizard_sys_resolution_xywh={20,20,300,50},
	s_wizard_sys_hline_xywh={15,70,820,2},
	s_wizard_sys_c_disp_xywh={60,90,300,40},
	s_wizard_sys_t_disp_xywh={400,90,300,40},
	s_wizard_sys_tipinfo_xywh={100,270,500,50},
	s_wizard_sys_apply_xywh={400,150,150,40},
	s_wizard_sys_tip_check_xywh={30,690,50,40},
	s_wizard_sys_tip1_xywh={80,690,600,40},
}

w1_wizard_sys.s_1080p = 
{
	s_wizard_sys_xywh={3,50,840,770},
	s_wizard_sys_resolution_xywh={20,20,300,50},
	s_wizard_sys_hline_xywh={15,70,820,2},
	s_wizard_sys_c_disp_xywh={60,90,300,45},
	s_wizard_sys_t_disp_xywh={400,90,300,45},
	s_wizard_sys_tipinfo_xywh={100,270,500,50},
	s_wizard_sys_apply_xywh={400,150,150,45},
	s_wizard_sys_tip_check_xywh={30,720,50,40},
	s_wizard_sys_tip1_xywh={80,720,600,40},
}
w1_wizard_sys.s_2k = 
{
	s_wizard_sys_xywh={4,67,1120,1026},
	s_wizard_sys_resolution_xywh={27,27,400,67},
	s_wizard_sys_hline_xywh={20,93,1093,3},
	s_wizard_sys_c_disp_xywh={80,120,400,60},
	s_wizard_sys_t_disp_xywh={533,120,400,60},
	s_wizard_sys_tipinfo_xywh={133,360,667,67},
	s_wizard_sys_apply_xywh={533,200,200,60},
	s_wizard_sys_tip_check_xywh={40,960,67,53},
	s_wizard_sys_tip1_xywh={107,960,800,53},
}
w1_wizard_sys.s_4k = 
{
	s_wizard_sys_xywh={6,100,1680,1540},
	s_wizard_sys_resolution_xywh={40,40,600,100},
	s_wizard_sys_hline_xywh={30,140,1640,4},
	s_wizard_sys_c_disp_xywh={120,180,600,90},
	s_wizard_sys_t_disp_xywh={800,180,600,90},
	s_wizard_sys_tipinfo_xywh={200,540,1000,100},
	s_wizard_sys_apply_xywh={800,300,300,90},
	s_wizard_sys_tip_check_xywh={60,1440,100,80},
	s_wizard_sys_tip1_xywh={160,1440,1200,80},
}

--10תΪ2
local DecToStrBin = function(value)
	if(tonumber(value) > 1023) then
		return ;
	end
	local bintemp = {};
	local multiple = 1;
	local num = math.abs(value);
	while num > 0 do
		local decimal = num % 2;
		num = math.floor(num / 2);
		bintemp[multiple] = decimal;
		multiple = multiple + 1;
	end
	for i = 1, 10 do
		if(bintemp[i] == nil) then
			bintemp[i] = 0;
		end
	end
	return bintemp;
end

local set_vo_items = function(top, vo_supper, vo)
	local cwnd = w1_wizard_sys.wnd;
	
	local VO_SUPPORT_SXGA = 1;
	local VO_SUPPORT_WXGA = 2;
	local VO_SUPPORT_1080P = 3;
	local VO_SUPPORT_2K = 4;
	local VO_SUPPORT_4K = 5; 
	local VO_SUPPORT_XGA = 6; 
	
	local vo_supporttable = {};	
	vo_supporttable = DecToStrBin(vo_supper);
	
	local nameitems = {};
	
	if(vo_supporttable[VO_SUPPORT_XGA] == 1 ) then
		table.insert(nameitems, '1024x768');
	end

	if(vo_supporttable[VO_SUPPORT_SXGA] == 1 ) then
		table.insert(nameitems, '1280x1024');
	end
	if(vo_supporttable[VO_SUPPORT_WXGA] == 1 ) then
		table.insert(nameitems, '1440x900');
	end
	if(vo_supporttable[VO_SUPPORT_1080P] == 1 ) then
		table.insert(nameitems, '1920x1080');
	end
	if(vo_supporttable[VO_SUPPORT_2K] == 1 ) then
		table.insert(nameitems, '2560x1440');
	end
	if(vo_supporttable[VO_SUPPORT_4K] == 1 ) then
		table.insert(nameitems, '3840x2160');
	end
	
	local cur_voname;
	if(0 == vo) then
		cur_voname = '1024x768';
	elseif(2 == vo ) then
		cur_voname = '1280x1024';
	elseif(3 == vo ) then
		cur_voname = '1440x900';
	elseif(4 == vo ) then
		cur_voname = '1920x1080';
	elseif(8 == vo ) then
		cur_voname = '2560x1440';
	elseif(7 == vo ) then
		cur_voname = '3840x2160';
	else
		assert(false);
	end
	
	b_wnd_ex.set_items(top, cwnd.t_disp.id, nameitems, false);	
	for i = 1, #nameitems do
		if(cur_voname == nameitems[i]) then
			b_wnd_ex.set_sel(top, cwnd.t_disp.id, i - 1, false);
			break;
		end
	end
	b_dlg.dlg_set_redraw(top);
end

--ȡǰUIõķֱֵ
local get_uivo = function(top)
	local cwnd = w1_wizard_sys.wnd;
	local votext = b_wnd_ex.get_text(top, cwnd.t_disp.id);
	if(votext == '1280x1024') then
		return 2;
	elseif(votext == '1440x900') then
		return 3;
	elseif(votext == '1920x1080') then
		return 4;
	elseif(votext == '2560x1440') then
		return 8;
	elseif(votext == '3840x2160') then
		return 7;
	elseif(votext == '1024x768') then
		return 0;			
	else
		assert(false);
	end
end	
	

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')

	local c_wnd = w1_wizard_sys.wnd
	local data = cfgdata['device']
	
	if (w1_wizard_sys.data == nil) then
		w1_wizard_sys.data =data
	else
		util.copy_tab_b(w1_wizard_sys.data, data);	
	end
	
	set_vo_items(top, cfgdata.device_info.vo_support, data.vo);
	
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local c_wnd = w1_wizard_sys.wnd
	return 0
end


--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	local cwnd = w1_wizard_sys.wnd

	if(legalflag) then
		return legalflag, nil
	else
		return legalflag, nlegalid
	end
end

w1_wizard_sys.timer_start = function()
	w1_wizard_sys.timestart = true
end

w1_wizard_sys.timer_stop = function(top)
	w1_wizard_sys.timestart = false
--	w1_wnd_util.tipclear(top, w1_wizard_sys.wnd.tipinfo.id, false)
--	w1_wnd_util.clearerrweight(top, false)
--	w1_wnd_util.tipdispoff();
end

w1_wizard_sys.timerenevt = function(top)
	if(w1_wizard_sys.timestart) then
	--	w1_wnd_util.timerenevt(top, w1_wizard_sys.wnd.tipinfo.id)
	end
	return 0
end

local on_show_tip = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local flag = b_wnd_ex.get_check(top, w1_wizard_sys.wnd.tip_check.id);
		if(true == flag)then
			b_wnd_ex.set_check(top, w1_wizard_sys.wnd.tip_check.id, false, true);
		else
			b_wnd_ex.set_check(top, w1_wizard_sys.wnd.tip_check.id, true, true);	
		end
	end
	return 0
end

w1_wizard_sys.get_data =function (top)
	local sys_data={};
	local flag = b_wnd_ex.get_check(top, w1_wizard_sys.wnd.tip_check.id);
	sys_data.tip_flag =flag;
	
	local param = {};
	local data = w1_wizard_sys.data;
	param.old_resolution = data.vo;
	w1_wnd_util.uidatacheckfunc = uidatacheck
	uitousercfg(top,b_app_cfg.user_cfg);
	w1_wnd_util.page_onapply(top)
--	w1_wnd_util.tipdispon()		--ʾ
	
	param.cur_resolution = get_uivo(top);

	if(param.old_resolution ~= param.cur_resolution) then
		sys_data.uivo =1;
	else
		sys_data.uivo =0;
	end
	return sys_data,param;
end
--ҳʼʱٶȡҳҪ
w1_wizard_sys.init = function(top)
	w1_wnd_util.cfgtab = {'device','device_info'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local param = {};
		local data = w1_wizard_sys.data;
		param.old_resolution = data.vo;
		w1_wnd_util.uidatacheckfunc = uidatacheck
--		w1_wnd_util.uitocfgfunc = uitousercfg
		uitousercfg(top,b_app_cfg.user_cfg);
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
		
		param.cur_resolution = get_uivo(top);

		if(param.old_resolution ~= param.cur_resolution) then
			--òֶӦ
			local w1_ui_facade	= require("wnd.w1_facade.w1_ui_facade");
			w1_ui_facade.load_layout(param.cur_resolution, 'w1', 'f_normat');
			b_app_api.channge_resolution(param);
			return b_ui.WM_USER_CHANGE_RESOLUTION;
		end	
	end
	return 0
end

w1_wizard_sys.clear = function()
	w1_wizard_sys.data = nil	
end

w1_wizard_sys.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_wizard_sys_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = { 'resolution','hline','c_name', 't_name',
			'c_disp','t_disp', 'apply','tip_check','tip1'},
	
	resolution 	= {t='checktxt',	id=id+1,xywh='s_wizard_sys_resolution_xywh',
				text='LA_RESOLUTION',	font = 'f_grade4',align = b_ui.ALIGN.LEFT,check = true},
	hline 	= {t='hline',	id=id+2,xywh='s_wizard_sys_hline_xywh'},
	c_disp 	= {t='static',	id=id+3,	xywh='s_wizard_sys_c_disp_xywh',	text='LA_OUTPUT_RESOLUTION'},
	t_disp 	= {t='combox',	id=id+4,	xywh='s_wizard_sys_t_disp_xywh',	
				items={},trans = false,
				},		

--	tipinfo	= {t='static',	id=id+13,	xywh='s_wizard_sys_tipinfo_xywh',	text='',trans = false},

	--apply 	= {t='button',	id=id+15,	xywh='s_wizard_sys_apply_xywh', 		text='LA_APPLY',cmd=on_apply},
	
	tip_check =	{t='check', id=id+5,xywh='s_wizard_sys_tip_check_xywh', check = false},
	tip1	=	{t='button', id=id+6,xywh='s_wizard_sys_tip1_xywh',align = b_ui.ALIGN.LEFT,text='LA_WIZARD_TIP',cmd = on_show_tip,
				color	= {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_n'},
				color_d = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_d'},
				color_f = {'c_cfg_page_bk', 'c_cfg_page_bk', 'c_txt_f'},
	},
}

return w1_wizard_sys

