--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/7/4
-- author 
-- brief  
--]]
local b_ui 		= require("wnd.core.b_ui")
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local w1_id 	= require("wnd.w1_util.w1_id")
local id 		= w1_id.wizard_time.wizard_time_id
local w1_wnd_util= require("wnd.w1_cfg.w1_wnd_util")
local b_wnd		= require("wnd.core.b_wnd")
local b_ui_msg  = require("wnd.w1_util.w1_ui_msg") 
local util 		= require("wnd.core.util")
local r_size		= require("wnd.core.r_res.r_size")
local SIZE 			= r_size.get_size
local b_app_cfg  = require("wnd.core.b_app_cfg")
local r_str		= require("wnd.core.r_res.r_str")
local b_app_api = require("wnd.core.command.b_app_api")
local STR 		= r_str.get_str
local b_dlg 	= require("wnd.core.b_dlg")
local w1_wizard_time = 
{
	origin_cfg,
	data,
	timestart = false;
	update_time = true;
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_wizard_time.s_768 =
{
	s_wizard_time_xywh = {2,53,448,490},
	s_wizard_time_c_datefmt_xywh = {32,14,160,32},
	s_wizard_time_t_datefmt_xywh = {240,14,160,32},
	s_wizard_time_c_time24h_xywh = {32,56,160,32},
	s_wizard_time_t_time24h_xywh = {240,56,160,32},
	s_wizard_time_c_synctime_xywh = {32,99,160,32},
	s_wizard_time_t_synctime_xywh = {240,99,25,32},
	s_wizard_time_c_ntp_xywh = {32,142,205,32},
	s_wizard_time_t_ntp_xywh = {240,142,160,32},
	s_wizard_time_c_date_xywh = {32,184,205,32},
	s_wizard_time_t_date_xywh = {240,184,160,32},
	s_wizard_time_c_time_xywh = {32,227,205,32},
	s_wizard_time_t_time_xywh = {240,227,160,32},
	s_wizard_time_c_waittime_xywh = {32,270,205,32},
	s_wizard_time_t_waittime_xywh = {240,270,160,32},
	s_wizard_time_moditime_xywh = {240,312,160,32},
	s_wizard_time_tipinfo_xywh = {32,355,373,35},
};

w1_wizard_time.s_1280 = 
{
	s_wizard_time_xywh={3,75,840,600},
	s_wizard_time_c_datefmt_xywh={60,20,300,45},
	s_wizard_time_t_datefmt_xywh={450,20,300,45},
	s_wizard_time_c_time24h_xywh={60,80,300,45},
	s_wizard_time_t_time24h_xywh={450,80,300,45}, 
	s_wizard_time_c_synctime_xywh={60,140,300,45}, 
	s_wizard_time_t_synctime_xywh={450,140,48,45}, 
	s_wizard_time_c_ntp_xywh={60,200,385,45},
	s_wizard_time_t_ntp_xywh={450,200,300,45},
	s_wizard_time_c_date_xywh={60,260,385,45},
	s_wizard_time_t_date_xywh={450,260,300,45},
	s_wizard_time_c_time_xywh={60,320,385,45},
	s_wizard_time_t_time_xywh={450,320,300,45},
	s_wizard_time_c_waittime_xywh={60,380,385,45},
	s_wizard_time_t_waittime_xywh={450,380,300,45},
	s_wizard_time_moditime_xywh={450,440,300,45},
	s_wizard_time_tipinfo_xywh={60,500,700,50},
}
w1_wizard_time.s_1440 = 
{
	s_wizard_time_xywh={3,75,840,600},
	s_wizard_time_c_datefmt_xywh={60,20,300,40},
	s_wizard_time_t_datefmt_xywh={450,20,300,40},
	s_wizard_time_c_time24h_xywh={60,80,300,40},
	s_wizard_time_t_time24h_xywh={450,80,300,40}, 
	s_wizard_time_c_synctime_xywh={60,140,300,40}, 
	s_wizard_time_t_synctime_xywh={450,140,48,40}, 
	s_wizard_time_c_ntp_xywh={60,200,385,40},
	s_wizard_time_t_ntp_xywh={450,200,300,40},
	s_wizard_time_c_date_xywh={60,260,385,40},
	s_wizard_time_t_date_xywh={450,260,300,40},
	s_wizard_time_c_time_xywh={60,320,385,40},
	s_wizard_time_t_time_xywh={450,320,300,40},
	s_wizard_time_c_waittime_xywh={60,380,385,45},
	s_wizard_time_t_waittime_xywh={450,380,300,45},
	s_wizard_time_moditime_xywh={450,440,300,40},
	s_wizard_time_tipinfo_xywh={60,500,700,50},
}

w1_wizard_time.s_1080p = 
{
	s_wizard_time_xywh={3,75,840,690},
	s_wizard_time_c_datefmt_xywh={60,20,300,45},
	s_wizard_time_t_datefmt_xywh={450,20,300,45},
	s_wizard_time_c_time24h_xywh={60,80,300,45},
	s_wizard_time_t_time24h_xywh={450,80,300,45}, 
	s_wizard_time_c_synctime_xywh={60,140,300,45}, 
	s_wizard_time_t_synctime_xywh={450,140,48,45}, 
	s_wizard_time_c_ntp_xywh={60,200,385,45},
	s_wizard_time_t_ntp_xywh={450,200,300,45},
	s_wizard_time_c_date_xywh={60,260,385,45},
	s_wizard_time_t_date_xywh={450,260,300,45},
	s_wizard_time_c_time_xywh={60,320,385,45},
	s_wizard_time_t_time_xywh={450,320,300,45},
	s_wizard_time_c_waittime_xywh={60,380,385,45},
	s_wizard_time_t_waittime_xywh={450,380,300,45},
	s_wizard_time_moditime_xywh={450,440,300,45},
	s_wizard_time_tipinfo_xywh={60,500,700,50},
}

w1_wizard_time.s_2k = 
{
	s_wizard_time_xywh={4,100,1120,800},
	s_wizard_time_c_datefmt_xywh={80,27,400,60},
	s_wizard_time_t_datefmt_xywh={600,27,400,60},
	s_wizard_time_c_time24h_xywh={80,107,400,60},
	s_wizard_time_t_time24h_xywh={600,107,400,60},
	s_wizard_time_c_synctime_xywh={80,187,400,60},
	s_wizard_time_t_synctime_xywh={600,187,64,60},
	s_wizard_time_c_ntp_xywh={80,267,510,60},
	s_wizard_time_t_ntp_xywh={600,267,400,60},
	s_wizard_time_c_date_xywh={80,347,510,60},
	s_wizard_time_t_date_xywh={600,347,400,60},
	s_wizard_time_c_time_xywh={80,427,510,60},
	s_wizard_time_t_time_xywh={600,427,400,60},
	s_wizard_time_c_waittime_xywh={80,507,510,60},
	s_wizard_time_t_waittime_xywh={600,507,400,60},
	s_wizard_time_moditime_xywh={600,587,400,60},
	s_wizard_time_tipinfo_xywh={80,667,933,67},

}

w1_wizard_time.s_4k = 
{
	s_wizard_time_xywh={6,150,1680,1200},
	s_wizard_time_c_datefmt_xywh={120,40,600,90},
	s_wizard_time_t_datefmt_xywh={900,40,600,90},
	s_wizard_time_c_time24h_xywh={120,160,600,90},
	s_wizard_time_t_time24h_xywh={900,160,600,90},
	s_wizard_time_c_synctime_xywh={120,280,600,90},
	s_wizard_time_t_synctime_xywh={900,280,96,90},
	s_wizard_time_c_ntp_xywh={120,400,770,90},
	s_wizard_time_t_ntp_xywh={900,400,600,90},
	s_wizard_time_c_date_xywh={120,520,770,90},
	s_wizard_time_t_date_xywh={900,520,600,90},
	s_wizard_time_c_time_xywh={120,640,770,90},
	s_wizard_time_t_time_xywh={900,640,600,90},
	s_wizard_time_c_waittime_xywh={120,760,770,90},
	s_wizard_time_t_waittime_xywh={900,760,600,90},
	s_wizard_time_moditime_xywh={900,880,600,90},
	s_wizard_time_tipinfo_xywh={120,1000,1400,100},

}


local refresh_datefmt = function(top, date_fmt, redraw)
	local cwnd = w1_wizard_time.wnd
	local data = w1_wizard_time.data.time
	local date = {}
	assert(date_fmt >=0 and date_fmt <=6);
	local cur_date = b_wnd_ex.get_date(top, cwnd.t_date.id)
	
	date[1] = date_fmt;
	date[2] = cur_date.year;
	date[3] = cur_date.month
	date[4] = cur_date.day
	b_wnd_ex.set_date (top, cwnd.t_date.id, date, redraw)
end

local refresh_timefmt = function(top, time_fmt, redraw)
	local cwnd = w1_wizard_time.wnd
	local data = w1_wizard_time.data.time
	local time = {}
	local cur_time = b_wnd_ex.get_time(top, cwnd.t_time.id)
	
	if(time_fmt == false) then	--12Сʱ
		local apm = cur_time.hour - 12;
		if(apm >= 0) then	--磨12:00--24:00
			time[1] =  b_ui.TIME.TIME_12PM
			if(apm == 0) then
				apm = 12;
			end
			time[2] = apm;
			time[3] = cur_time.minute;
			time[4] = cur_time.second;
		else--磨0:00--12:00
			time[1] =  b_ui.TIME.TIME_12AM
			if(cur_time.hour == 0) then
				time[2] = 12;
			else
				time[2] = cur_time.hour;
			end
			time[3] = cur_time.minute;
			time[4] = cur_time.second;
		end
		
	else --24Сʱ
		time[1] =  b_ui.TIME.TIME_24
		if(cur_time.format == b_ui.TIME.TIME_12PM) then
			if(cur_time.hour == 12) then
				time[2] = cur_time.hour;		
			else
				time[2] = cur_time.hour + 12;		
			end	
		elseif(cur_time.format == b_ui.TIME.TIME_12AM) then
			if(cur_time.hour == 12) then
				time[2] = 0;
			else
				time[2] = cur_time.hour;
			end
		end
		time[3] = cur_time.minute;
		time[4] = cur_time.second;
	end
	b_wnd_ex.set_time(top, cwnd.t_time.id, time, redraw)
end

local refresh_synctime = function(top, synctime, redraw)
	local cwnd = w1_wizard_time.wnd;
	if(synctime) then
		b_wnd_ex.set_disable(top, cwnd.t_date.id, true, false);
		b_wnd_ex.set_disable(top, cwnd.t_time.id, true, false);
		b_wnd_ex.set_disable(top, cwnd.moditime.id, true, false);
		
		b_wnd_ex.set_hide (top, cwnd.c_ntp.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_ntp.id, false, false);
		local param1 = SIZE('s_wizard_time_c_ntp_xywh');
		local param2 = SIZE('s_wizard_time_t_ntp_xywh');
		b_wnd_ex.move_ex(top,  cwnd.c_ntp.id,param1, false)
		b_wnd_ex.move_ex(top,  cwnd.t_ntp.id,param2, false)
		b_wnd_ex.set_hide (top, cwnd.c_waittime.id, false, false);
		b_wnd_ex.set_hide (top, cwnd.t_waittime.id, false, false);
		param1 = SIZE('s_wizard_time_c_date_xywh');
		param2 =  SIZE('s_wizard_time_t_date_xywh');
		b_wnd_ex.move_ex(top,  cwnd.c_waittime.id,param1, false)
		b_wnd_ex.move_ex(top,  cwnd.t_waittime.id,param2, false)
		param1 =  SIZE('s_wizard_time_c_time_xywh');
		param2 = SIZE('s_wizard_time_t_time_xywh');
		b_wnd_ex.move_ex(top,  cwnd.c_date.id,param1, false)
		b_wnd_ex.move_ex(top,  cwnd.t_date.id,param2, false)
		param1 = SIZE('s_wizard_time_c_waittime_xywh');
		param2 =  SIZE('s_wizard_time_t_waittime_xywh');
		b_wnd_ex.move_ex(top,  cwnd.c_time.id,param1, false)
		b_wnd_ex.move_ex(top,  cwnd.t_time.id,param2, false)
		param2 = SIZE('s_wizard_time_moditime_xywh');
		b_wnd_ex.move_ex(top,  cwnd.moditime.id,param2, false)
	else
		b_wnd_ex.set_disable(top, cwnd.t_date.id, false, false);
		b_wnd_ex.set_disable(top, cwnd.t_time.id, false, false);
		b_wnd_ex.set_disable(top, cwnd.moditime.id, false, false);
		
		b_wnd_ex.set_hide (top, cwnd.c_ntp.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_ntp.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.c_waittime.id, true, false);
		b_wnd_ex.set_hide (top, cwnd.t_waittime.id, true, false);
		
		local param1 = SIZE('s_wizard_time_c_ntp_xywh');
		local param2 = SIZE('s_wizard_time_t_ntp_xywh');
		b_wnd_ex.move_ex(top,  cwnd.c_date.id,param1, false)
		b_wnd_ex.move_ex(top,  cwnd.t_date.id,param2, false)
		param1 = SIZE('s_wizard_time_c_date_xywh');
		param2 =  SIZE('s_wizard_time_t_date_xywh');
		b_wnd_ex.move_ex(top,  cwnd.c_time.id,param1, false)
		b_wnd_ex.move_ex(top,  cwnd.t_time.id,param2, false)
		param2 =  SIZE('s_wizard_time_t_time_xywh');
		b_wnd_ex.move_ex(top,  cwnd.moditime.id,param2, false)
	end
	if true == redraw then
		b_dlg.dlg_set_redraw(top)
	end
end

local refresh_time = function(top, redraw)
	local cwnd = w1_wizard_time.wnd
	local data = w1_wizard_time.data.time
	local date = {}
	date[1] = data.date_fmt
	date[2] = tonumber(os.date("%Y", time))
	date[3] = tonumber(os.date("%m", time))
	date[4] = tonumber(os.date("%d", time))
	b_wnd_ex.set_date (top, cwnd.t_date.id, date, false)
	
	local time = os.time()
	local disptime = {}
	disptime[2] = tonumber(os.date("%H", time))
	disptime[3] = math.floor((time % 3600) / 60)
	disptime[4] = math.floor(time % 60)
	
	if(1 == data.time_fmt) then
		disptime[1] = b_ui.TIME.TIME_24
	else
		if(disptime[2] == 12) then
			disptime[1] = b_ui.TIME.TIME_12PM
			disptime[2] = disptime[2]
		elseif(disptime[2] >= 13 and disptime[2] <= 23) then
			disptime[1] = b_ui.TIME.TIME_12PM
			disptime[2] = disptime[2] - 12
		elseif (disptime[2] == 24) then
			disptime[1] = b_ui.TIME.TIME_12AM
			disptime[2] = 12
		else
			disptime[1] = b_ui.TIME.TIME_12AM
			if(disptime[2] == 0)then 
				disptime[2] = 12
			else
				disptime[2] = disptime[2]
			end
		end
	end
	
	b_wnd_ex.set_time(top, cwnd.t_time.id, disptime, false)
	if true == redraw then
		b_dlg.dlg_set_redraw(top);
	end
end

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local set_check = function(winid, check)
		b_wnd_ex.set_check(top, winid, check, false)
	end
	local cwnd = w1_wizard_time.wnd
	local data = cfgdata.time
	if(w1_wizard_time.data == nil) then
		w1_wizard_time.data = cfgdata
	else
		util.copy_tab_b(w1_wizard_time.data, cfgdata)
	end	
	
	if(w1_wizard_time.origin_cfg == nil) then
		w1_wizard_time.origin_cfg = util.copy_tab(cfgdata)
	else
		util.copy_tab_b(w1_wizard_time.origin_cfg, cfgdata)
	end
	
	b_wnd_ex.set_sel(top, cwnd.t_datefmt.id, data.date_fmt, false)

	local h24 = data.time_fmt;
	if(1 == h24) then
		b_wnd_ex.set_sel(top, cwnd.t_time24h.id, 1, false)
	else
		b_wnd_ex.set_sel(top, cwnd.t_time24h.id, 0, false)
	end

	if(1 == data.sync_time) then
		set_check(cwnd.t_synctime.id, true);
		refresh_synctime(top, true, false);
		
	else
		set_check(cwnd.t_synctime.id, false);
		refresh_synctime(top, false, false);
	end

	b_wnd_ex.set_text(top, cwnd.t_ntp.id, data.ntp_addr, false);
	if(data.waittime < 10)then
		data.waittime =10;
	end
	local waittime = tostring(data.waittime)
	b_wnd_ex.set_text(top, cwnd.t_waittime.id,waittime, false);
	refresh_time(top, false);
	return 0
end

local settime = function(top, cfgdata)
	local cwnd = w1_wizard_time.wnd

	local sync_time = b_wnd_ex.get_check(top, cwnd.t_synctime.id)
	if(true == sync_time) then
		cfgdata['time']['sync_time'] = 1
	else
		cfgdata['time']['sync_time'] = 0
	end
	
	local cur_date = b_wnd_ex.get_date(top, cwnd.t_date.id)
	local cur_time = b_wnd_ex.get_time(top, cwnd.t_time.id)


	if(cur_time.format == b_ui.TIME.TIME_12PM) then
		if(cur_time.hour <= 11)then
			cur_time.hour = cur_time.hour + 12
		end
	elseif(cur_time.format == b_ui.TIME.TIME_12AM) then
		if(cur_time.hour == 12)then
			cur_time.hour = cur_time.hour - 12
		end
	end	
	

	local sync_time = b_wnd_ex.get_check(top, cwnd.t_synctime.id)
	if(true == sync_time) then
		cfgdata.time.sync_time = 1
	else
		cfgdata.time.sync_time = 0
	end	
	
	local time = os.time{year=cur_date.year, month=cur_date.month, day=cur_date.day, hour=cur_time.hour, min=cur_time.minute, sec=cur_time.second}
	cfgdata['time']['time'] = time
	
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	local cwnd = w1_wizard_time.wnd

	local ntp_addr = b_wnd_ex.get_text(top, cwnd.t_ntp.id)
	if(name == '' ) then
		legalflag =false
		table.insert(nlegalid, cwnd.t_ntp.id)
	end
	
	local waittime = b_wnd_ex.get_text(top, cwnd.t_waittime.id);
	local p = select(2,string.gsub(waittime,"[.]",""));
	if(p ~= 0)then 
		legalflag =false
		table.insert(nlegalid, cwnd.t_waittime.id)
		w1_wnd_util.setparamerr_str(STR('LA_PARAM_INVALID'));
		return legalflag, nlegalid
	end
	if(tonumber(waittime) < 10 or tonumber(waittime) > 31536000)then
		legalflag =false
		table.insert(nlegalid, cwnd.t_waittime.id)
	end
	local date_fmt = b_wnd_ex.get_sel(top, cwnd.t_datefmt.id)	
	local h24 = b_wnd_ex.get_sel(top, cwnd.t_time24h.id)
	local sync_time = b_wnd_ex.get_check(top, cwnd.t_synctime.id)
	
	if(legalflag) then
		return legalflag, nil
	else
		w1_wnd_util.setparamerr_str("[10 ~ 31536000]");
		return legalflag, nlegalid
	end
end

w1_wizard_time.timer_start = function()
	w1_wizard_time.timestart = true
	w1_wizard_time.update_time =true;
end

w1_wizard_time.timer_stop = function(top)
	w1_wizard_time.timestart = false
	w1_wnd_util.tipclear(top, w1_wizard_time.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_wizard_time.timerenevt = function(top)
	if(w1_wizard_time.timestart) then
		if( w1_wizard_time.update_time== true)then
			refresh_time(top,true);
		end
		w1_wnd_util.timerenevt(top, w1_wizard_time.wnd.tipinfo.id)
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_wizard_time.init = function(top)
	w1_wnd_util.cfgtab = {'time'}
	w1_wnd_util.cfgtouifunc = cfgdatatoui
	w1_wnd_util.page_init(top)
	w1_wizard_time.update_time =true;
	return 0
end

local tabcompare = function(origin_cfg,cur_cfg)
	local param = {}
	for k, v in pairs(cur_cfg) do
		if(origin_cfg[k] ~= nil ) then
			--table,λûеtable¼param
			if( util.compare_tab(origin_cfg[k], cur_cfg[k]) == 1 ) then
				if(param[k] == nil) then
					param[k] =  util.copy_tab(cur_cfg[k])
				else
					util.copy_tab_b(param[k], cur_cfg[k]);
				end				
			end
		end
	end
	return param
end

--ûǷи,и,򷵻ظĺ
local usercfgchange =function(origin_cfg,cur_cfg)
	local param = tabcompare(origin_cfg,cur_cfg)
	if(	util.is_empty(param) )then
		return false,nil
	else
		return true, param
	end
end

w1_wizard_time.time_to_other =function (top)
	w1_wnd_util.uidatacheckfunc = uidatacheck
	local flag = w1_wnd_util.check_legal_tip(top)
	if(flag ~= 0)then
		w1_wnd_util.tipdispon()		--ʾ
		return -1
	end	
	return 0;
end

w1_wizard_time.check_time =function(top)
	w1_wnd_util.uidatacheckfunc = uidatacheck
	local flag = w1_wnd_util.check_legal_tip(top)
	if(flag ~= 0)then
		w1_wnd_util.tipdispon()		--ʾ
		return -1
	end	
	return 0;
end

w1_wizard_time.get_data = function (top)
	local cwnd = w1_wizard_time.wnd
	local data = w1_wizard_time.data.time
	
	local date_fmt = b_wnd_ex.get_sel(top, cwnd.t_datefmt.id)
	data.date_fmt = date_fmt
	
	local h24 = b_wnd_ex.get_sel(top, cwnd.t_time24h.id)
	if(1 == h24) then
		data.time_fmt = 1
	else
		data.time_fmt = 0
	end
	
	local sync_time = b_wnd_ex.get_check(top, cwnd.t_synctime.id)
	if(true == sync_time) then
		data.sync_time = 1
	else
		data.sync_time = 0
	end
	
	local ntp_addr = b_wnd_ex.get_text(top, cwnd.t_ntp.id)
	data.ntp_addr = ntp_addr
	
	local waittime = b_wnd_ex.get_text(top, cwnd.t_waittime.id);
	data.waittime = tonumber(waittime)
--	data.waittime = b_wnd_ex.get_value(top, cwnd.t_waittime.id);
	if(data.waittime < 10)then
		data.waittime =10;
	end
	local time = 0
	data.time = time
	local changeflag ,param = usercfgchange(w1_wizard_time.origin_cfg,w1_wizard_time.data)
	if(changeflag)then
		return param.time
	else
		return nil;
	end
	
end

local on_waittime = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.WM_USER_UPDATE_PARAM)then
		local cwnd = w1_wizard_time.wnd
		local waittime = b_wnd_ex.get_text(top, cwnd.t_waittime.id); --˴ؼΪδλs

		if(waittime ~= "")then
			if(tonumber(waittime) < 10)then
				b_wnd_ex.set_text(top, cwnd.t_waittime.id,"10", false);
			elseif(tonumber(waittime) > 31536000) then
				b_wnd_ex.set_text(top, cwnd.t_waittime.id,"31536000", false);
			else
				b_wnd_ex.set_text(top, cwnd.t_waittime.id,waittime, false); 
			end
		else
			b_wnd_ex.set_text(top, cwnd.t_waittime.id,"10", false);
		end
		
		b_dlg.dlg_set_redraw(top);
	end
	return 0;
end

local on_datefmt= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local datefmt = b_wnd_ex.get_sel(top, win_id);
		w1_wizard_time.data.time.date_fmt = datefmt;
		refresh_datefmt(top, datefmt, true);	
	end
	return 0;
end

local on_synctime= function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui.LBUTTONCLK) then
		local synctime = b_wnd_ex.get_check(top, win_id);
		refresh_synctime(top, synctime, true);
	end
	return 0;
end

local on_time24h= function(top, win_id, vmsg, x, y)
--	if (vmsg == b_ui.LBUTTONCLK) then
	if (vmsg == b_ui_msg.msg_user_update_parent) then
		local h24 = b_wnd_ex.get_sel(top, win_id)
		if(1 == h24) then
			w1_wizard_time.data.time.time_fmt = 1
			refresh_timefmt(top, true, true)
		else
			w1_wizard_time.data.time.time_fmt = 0
			refresh_timefmt(top, false, true)
		end
	end
	return 0;
end

local on_moditime = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
--		w1_wnd_util.uitocfgfunc = settime
		settime(top,b_app_cfg.user_cfg);
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
		w1_wizard_time.update_time =true;
	end
	return 0
end

local on_date = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wizard_time.update_time =false;
	elseif (vmsg == b_ui.WM_USER_UPDATE_PARAM) then
		w1_wizard_time.update_time =false;
	end
	return 0
end

local on_time = function(top, win_id, vmsg, x, y)
	if (vmsg == b_ui_msg.msg_time_update) then
		w1_wizard_time.update_time =false;
	end
	return 0
end

w1_wizard_time.clear = function()
	w1_wizard_time.origin_cfg = nil;
	w1_wizard_time.data = nil;
end	

w1_wizard_time.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_wizard_time_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = { 'date_time','c_datefmt', 't_datefmt', 'c_time24h', 't_time24h', 
			'c_synctime', 't_synctime', 'c_ntp', 't_ntp', 'c_waittime','t_waittime', 
			'c_date', 't_date','c_time','t_time','moditime', 'tipinfo', 'default', 'apply'},
	
--	date_time		= {t='static',id=id+25,xywh={50,0,300,45},text='Date/Time',trans = false},
			
	c_datefmt 	= {t='static',	id=id+1,	xywh='s_wizard_time_c_datefmt_xywh',	text='LA_DATE_FORMAT'},
	t_datefmt 	= { t='combox',	id=id+2,	xywh='s_wizard_time_t_datefmt_xywh',
					items={'YY/MM/DD hh:mm:ss','hh:mm:ss YY/MM/DD','MM/DD/YY hh:mm:ss','hh:mm:ss MM/DD/YY','DD/MM/YY hh:mm:ss','hh:mm:ss DD/MM/YY'},
					trans = false,cmd = on_datefmt},
	
	c_time24h 	= {t='static',	id=id+3,	xywh='s_wizard_time_c_time24h_xywh',	text='LA_TIME_FORMAT'},
	--[[t_time24h 	= {t='tt_check',id=id+4,	xywh={450,100,48,30}, font = 'f_grade1',
					check = true, cmd = on_time24h},--]]
	t_time24h 	= {t='combox',id=id+4,	xywh='s_wizard_time_t_time24h_xywh',items={'12H','24H'},
					trans = false, cmd = on_time24h},
	
	c_synctime 	= {t='static',	id=id+5,	xywh='s_wizard_time_c_synctime_xywh',text='LA_SYNC_TIME'},
	t_synctime	= {t='tt_check',id=id+6,	xywh='s_wizard_time_t_synctime_xywh',font = 'f_grade1',
					t_imgs = {b_ui.ALIGN.CENTER,'f_tt_check','it_tt_check','it_check_yes', 'it_check_yes'},
					check = true, cmd = on_synctime},
	
	c_ntp 		= {t='static',	id=id+7,	xywh='s_wizard_time_c_ntp_xywh',	text='LA_NTP_IP'},
	t_ntp 		= {t='combox_in',id=id+8,	xywh='s_wizard_time_t_ntp_xywh',	items={'time.windows.com','1.centos.pool.ntp.org','time.nist.gov'},trans = false},	
	
	c_waittime 	= {t='static',	id=id+9,	xywh='s_wizard_time_c_date_xywh',text='LA_SCHOOL_TIME'},
	t_waittime 	= {t='edit',   id=id+10,	xywh='s_wizard_time_t_date_xywh', edit_num_str =1,cmd = on_waittime},--range ={0,2147483646},

	c_date 		= {t='static',	id=id+11,	xywh='s_wizard_time_c_time_xywh',	text='LA_CUR_DATE'},
	t_date 		= {t='date_edit',id=id+12,	xywh='s_wizard_time_t_time_xywh',	date={0,2018,1,1, true},trans = false, cmd=on_date},	
	
	c_time 		= {t='static',	id=id+13,	xywh='s_wizard_time_c_waittime_xywh',	text='LA_CUR_TIME'},
	t_time 		= {t='time_edit',id=id+14,	xywh='s_wizard_time_t_waittime_xywh',	time = {b_ui.TIME.TIME_24,12,56,04},trans = false,cmd =on_time},	
	
	
	moditime	= {t='button',	id=id+15,	xywh='s_wizard_time_moditime_xywh',	text='LA_UPDATE_TIME',cmd=on_moditime},

	tipinfo		= {t='static',	id=id+16,	xywh='s_wizard_time_tipinfo_xywh',	text='',trans = false},

}

return w1_wizard_time







