--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/10
-- author 
-- brief  
--]]
local b_ui 			= require("wnd.core.b_ui")
local b_wnd_ex 		= require("wnd.core.b_wnd_ex")
local w1_wnd_util	= require("wnd.w1_cfg.w1_wnd_util")
local w1_id 		= require("wnd.w1_util.w1_id")
local id 			= w1_id.wizard_time.wizard_tzone_id
local b_app_api = require("wnd.core.command.b_app_api");
local b_app_cfg  = require("wnd.core.b_app_cfg")
local w1_wizard_tzone = 
{
	origin_cfg = nil,
	timestart = false,
	s_768,
	s_1280,
	s_1440,
	s_1080p,
	s_2k,
	s_4k,
}

w1_wizard_tzone.s_768 =
{
	s_wizard_tzone_xywh = {2,53,448,490},
	s_wizard_tzone_c_tzone_xywh = {32,14,160,32},
	s_wizard_tzone_t_tzone_xywh = {240,14,160,32},
	s_wizard_tzone_tipinfo_xywh = {53,78,373,35},
};

w1_wizard_tzone.s_1280 = 
{
	s_wizard_tzone_xywh={3,75,840,600},
	s_wizard_tzone_c_tzone_xywh={60,20,300,45},
	s_wizard_tzone_t_tzone_xywh={450,20,300,45},
	s_wizard_tzone_tipinfo_xywh={100,110,700,50},
}
w1_wizard_tzone.s_1440 = 
{
	s_wizard_tzone_xywh={3,75,840,600},
	s_wizard_tzone_c_tzone_xywh={60,20,300,40},
	s_wizard_tzone_t_tzone_xywh={450,20,300,40},
	s_wizard_tzone_tipinfo_xywh={100,110,700,40},
}
w1_wizard_tzone.s_1080p = 
{
	s_wizard_tzone_xywh={3,75,840,690},
	s_wizard_tzone_c_tzone_xywh={60,20,300,45},
	s_wizard_tzone_t_tzone_xywh={450,20,300,45},
	s_wizard_tzone_tipinfo_xywh={100,110,700,50},
}
w1_wizard_tzone.s_2k = 
{
	s_wizard_tzone_xywh={4,100,1120,800},
	s_wizard_tzone_c_tzone_xywh={80,27,400,60},
	s_wizard_tzone_t_tzone_xywh={600,27,400,60},
	s_wizard_tzone_tipinfo_xywh={133,147,933,67},

}
w1_wizard_tzone.s_4k = 
{
	s_wizard_tzone_xywh={6,150,1680,1200},
	s_wizard_tzone_c_tzone_xywh={120,40,600,90},
	s_wizard_tzone_t_tzone_xywh={900,40,600,90},
	s_wizard_tzone_tipinfo_xywh={200,220,1400,100},

}


local time_zone_int = 
{	-720, -660, -600, -540, -480,
	-420, -360, -300, -270, -240,
	-210, -180,-120, -60, 0,
	60, 120, 180, 210, 240,
	270, 300, 330, 345, 360,
	390, 420, 480, 510, 540,
	570, 600, 660, 720, 780,
	840,
}
--[[
local tzone_str = 
{
	'UTC/GMT -12:00','UTC/GMT -11:00','UTC/GMT -10:00','UTC/GMT -09:00','UTC/GMT -08:00',
	'UTC/GMT -07:00','UTC/GMT -06:00','UTC/GMT -05:00','UTC/GMT -04:30','UTC/GMT -04:00',
	'UTC/GMT -03:30','UTC/GMT -03:00','UTC/GMT -02:00','UTC/GMT -01:00','UTC/GMT',
	'UTC/GMT +01:00','UTC/GMT +02:00','UTC/GMT +03:00','UTC/GMT +03:30','UTC/GMT +04:00',
	'UTC/GMT +04:30','UTC/GMT +05:00','UTC/GMT +05:30','UTC/GMT +05:45','UTC/GMT +06:00',
	'UTC/GMT +06:30','UTC/GMT +07:00','UTC/GMT +08:00','UTC/GMT +08:30','UTC/GMT +09:00',
	'UTC/GMT +09:30','UTC/GMT +10:00','UTC/GMT +11:00','UTC/GMT +12:00','UTC/GMT +13:00',
	'UTC/GMT +14:00',
}
--]]

local tzone_str = 
{
	'(GMT-12:00) International Date Line West', '(GMT-11:00) Midway Island, Samoa', '(GMT-10:00) Hawaii', 
	'(GMT-09:00) Alaska', '(GMT-08:00) Pacific Time(U.S. & Canada)', '(GMT-07:00) Mountain Time(U.S. & Canada)', 
	'(GMT-06:00) Central Time(U.S. & Canada)', '(GMT-05:00) Eastern Time(U.S. & Canada)', '(GMT-04:30) Caracas', 
	'(GMT-04:00) Atlantic Time(Canada)', '(GMT-03:30) Newfoundland', '(GMT-03:00) Georgetown, Brasilia', 
	'(GMT-02:00) Mid-Atlantic', '(GMT-01:00) Cape Verde lslands, Azores', '(GMT+00:00) Dublin, Edinburgh, London', 
	'(GMT+01:00) Amsterdam, Berlin, Rome, Paris, Warsaw','(GMT+02:00) Athens, Jerusalem','(GMT+03:00) Baghdad, Kuwait, Istanbul, Moscow, St.Petersburg',
	'(GMT+03:30) Tehran','(GMT+04:00) Caucasus Standard Time','(GMT+04:30) Kabul',
	'(GMT+05:00) Islamabad, Karachi, Tashkent','(GMT+05:30) Madras, Bombay, New Delhi','(GMT+05:45) Kathmandu',
	'(GMT+06:00) Almaty, Dhaka','(GMT+06:30) Yangon','(GMT+07:00) Bangkok, Hanoi, Jakarta, Novosibirsk',
	'(GMT+08:00) Beijing, Urumqi, Singapore, Perth', '(GMT+08:30) Yukla', '(GMT+09:00) Seoul, Tokyo, Osaka, Sapporo',
	'(GMT+09:30) Adelaide, Darwin','(GMT+10:00) Melbourne, Sydney, Canberra, Hobart','(GMT+11:00) Solomon lslands, Magadan',
	'(GMT+12:00) Auckland, Wellington, Fiji','(GMT+13:00) Nuku\'alofa','(GMT+14:00) Christmas lsland',
}


--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local c_wnd = w1_wizard_tzone.wnd
	
	local num = cfgdata['timezone']['timezone']
	w1_wizard_tzone.origin_cfg =num;
	for i = 1, #time_zone_int do
		if( num == time_zone_int[i])then
			num = i
		end
	end
	
	if(num <= #tzone_str) then
		b_wnd_ex.set_sel(top, c_wnd.t_tzone.id,num - 1,false)
	end
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local c_wnd = w1_wizard_tzone.wnd
	local timezone_sel = b_wnd_ex.get_sel(top, c_wnd.t_tzone.id)

	timezone_sel = time_zone_int[timezone_sel + 1]

	cfgdata['timezone']['timezone'] = timezone_sel
	return 0
end

--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	return true, nil
end

w1_wizard_tzone.timer_start = function()
	w1_wizard_tzone.timestart = true
end

w1_wizard_tzone.timer_stop = function(top)
	w1_wizard_tzone.timestart = false
	w1_wnd_util.tipclear(top, w1_wizard_tzone.wnd.tipinfo.id, false)
	w1_wnd_util.clearerrweight(top, false)
end

w1_wizard_tzone.timerenevt = function(top)
	if(w1_wizard_tzone.timestart) then
		w1_wnd_util.timerenevt(top, w1_wizard_tzone.wnd.tipinfo.id)
	end
	return 0
end

--ҳʼʱٶȡҳҪ
w1_wizard_tzone.init = function(top)
	local data={}
	table.insert(data,"timezone")
	local time_zone = b_app_api.get_cfg(data)
	cfgdatatoui(top,time_zone);
	return 0
end
w1_wizard_tzone.get_data = function(top)
	local c_wnd = w1_wizard_tzone.wnd
	local timezone_sel = b_wnd_ex.get_sel(top, c_wnd.t_tzone.id)

	timezone_sel = time_zone_int[timezone_sel + 1]
	local timezone ={}
	timezone.timezone = timezone_sel
	if(w1_wizard_tzone.origin_cfg ~= timezone_sel)then
		return timezone
	else
		return nil;
	end
end

--UIָĬֵ
local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w1_wnd_util.cfgtouifunc = cfgdatatoui
		w1_wnd_util.page_ondefault(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w1_wnd_util.uidatacheckfunc = uidatacheck
--		w1_wnd_util.uitocfgfunc = uitousercfg
		uitousercfg(top,b_app_cfg.user_cfg);
		w1_wnd_util.page_onapply(top)
		w1_wnd_util.tipdispon()		--ʾ
	end
	return 0
end


w1_wizard_tzone.wnd = 
{
	t='wnd_bg',id=id,xywh = 's_wizard_tzone_xywh',
	color_d= {'c_cfg_page_bk', 'c_cfg_page_bk','c_cfg_page_bk'}, 
	sub = { 'c_tzone', 't_tzone', 'tipinfo', 'default', 'apply'},
			
	c_tzone = {t='static',id=id+1,	xywh='s_wizard_tzone_c_tzone_xywh',	text='LA_ZONE'},
	t_tzone = {t='combox',id=id+2,	xywh='s_wizard_tzone_t_tzone_xywh',	items=tzone_str,trans = false},
	
	tipinfo	= {t='static', id=id+3,	xywh='s_wizard_tzone_tipinfo_xywh',	text='',trans = false},
	
--	apply 	= {t='button',id=id+5,	xywh = 's_cfg_apply_xywh', 	text='LA_APPLY',cmd=on_apply},
}

return w1_wizard_tzone







