--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/4
-- author lsl
-- brief  öԻ
--]]
local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui		= require("wnd.core.b_ui")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local b_wnd_ex 	= require("wnd.core.b_wnd_ex")
local ui_facade	= require("wnd.w2_facade.w2_ui_facade")
local w2_utilwnd= require("wnd.w2_cfg.w2_utilwnd")
local w2_key 	= require("wnd.w2_util.w2_key")
local w2_id 	= require("wnd.w2_util.w2_id")
local id 		= w2_id.cfg_setup.id



local w2_cfg_basic = {
	t = w2_key.DLG_CFG_BASIC,
	top = nil,
	dlg = nil
}

--ˢUI
local cfgdatatoui = function(top, cfgdata)
	assert(type(cfgdata) == 'table')
	local c_wnd = w2_cfg_basic.dlg
	
	local devicename = cfgdata['device']['name']
	b_wnd_ex.set_text(top, c_wnd.t_name.id,devicename,false)
	
	
	local gui_style = cfgdata['guistyle']['style']
	if(gui_style == "w2") then
		b_wnd_ex.set_sel(top, c_wnd.t_style.id,2,false)
	else
		b_wnd_ex.set_sel(top, c_wnd.t_style.id,1,false)
	end
	
	local gui_color = cfgdata['guistyle']['color']
	if(gui_color == "red") then
		b_wnd_ex.set_sel(top, c_wnd.t_color.id,2,false)
	else
		b_wnd_ex.set_sel(top, c_wnd.t_color.id,1,false)
	end
	
	local gui_font = cfgdata['guistyle']['font']
	if(gui_font == "small") then
		b_wnd_ex.set_sel(top, c_wnd.t_fsize.id,1,false)
	elseif(gui_font == "big") then
		b_wnd_ex.set_sel(top, c_wnd.t_fsize.id,3,false)
	elseif(gui_font == "extralarge") then
		b_wnd_ex.set_sel(top, c_wnd.t_fsize.id,4,false)
	else
		b_wnd_ex.set_sel(top, c_wnd.t_fsize.id,2,false)
	end
	return 0
end

--UIû(Ӧʱʹ)
local uitousercfg = function(top, cfgdata)
	local c_wnd = w2_cfg_basic.dlg
	
	local devicename = b_wnd_ex.get_text(top, c_wnd.t_name.id)
	cfgdata['device']['name'] = devicename
	
	local fontsize_sel = b_wnd_ex.get_sel(top, c_wnd.t_fsize.id)
	if(fontsize_sel == 0) then
		ui_facade.set_fontsize('f_small')
		cfgdata['guistyle']['font'] = 'small'
	elseif(fontsize_sel == 1) then
		ui_facade.set_fontsize('f_default')
		cfgdata['guistyle']['font'] = 'default'
	elseif(fontsize_sel == 2) then
		ui_facade.set_fontsize('f_big')
		cfgdata['guistyle']['font'] = 'big'
	elseif(fontsize_sel == 3) then
		ui_facade.set_fontsize('f_extralarge')
		cfgdata['guistyle']['font'] = 'extralarge'
	end
	
	local color_sel = b_wnd_ex.get_sel(top, c_wnd.t_color.id);	
	if(color_sel == 0) then
		ui_facade.set_color('c_default')
		cfgdata['guistyle']['color'] = 'default'
	elseif(color_sel == 1) then
		ui_facade.set_color('c_red')
		cfgdata['guistyle']['color'] = 'red'
	end
	
	local style_sel = b_wnd_ex.get_sel(top, c_wnd.t_style.id);
	if(style_sel == 0) then
		cfgdata['guistyle']['style'] = 'default'
	elseif(style_sel == 1) then
		cfgdata['guistyle']['style'] = 'w2'
	end	
	return 0
end


--UIǷϷ,Ϸ,򷵻ر־λnil,Ϸ,򷵻ر־λͲϷؼID
local uidatacheck =function(top)
	local legalflag = true
	local nlegalid = {}
	local c_wnd = w2_cfg_basic.dlg

	local name = b_wnd_ex.get_text(top, c_wnd.t_name.id)
	if(name == '' ) then
		legalflag =false
		table.insert(nlegalid, c_wnd.t_name.id)
	end
	if(legalflag) then
		return legalflag, nil
	else
		return legalflag, nlegalid
	end
end

local on_default = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		--ȡĬϲĽӿڻδʵ,һ
		w2_utilwnd.cfgtouifunc = cfgdatatoui
		w2_utilwnd.page_ondefault(top)
		w2_utilwnd.tipdispon()		--ʾ
	end
	return 0
end

local on_apply = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		w2_utilwnd.uidatacheckfunc = uidatacheck
		w2_utilwnd.uitocfgfunc = uitousercfg
		w2_utilwnd.page_onapply(top)
		w2_utilwnd.tipdispon()		--ʾ
		b_dlg.end_modal(top)
	end
	return 0
end


local on_channel = function(top, win_id, vmsg, x, y)
	if b_ui.RBUTTONCLK == vmsg then
		b_dlg.end_modal(top)
	end	
	return 0
end

local on_dlg = function(top, win_id, vmsg, x, y)
	
	if b_ui.RBUTTONCLK == vmsg then
		b_dlg.end_modal(top)
	end
	
	if b_ui.LBUTTONCLK == vmsg then
		
	end
	return 0
end

local on_close = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_dlg.end_modal(top)
	end
	return 0;
end


local dlg = {
	attr = {xywh='s_nav_xywh',cmd=on_dlg},
	sub = { 'c_name', 't_name',
			'c_disp','t_disp', 'c_lang', 't_lang', 'c_fsize', 't_fsize', 'c_color', 't_color', 'c_style', 't_style', 
			'default', 'apply',},
	c_name 	= {t='static',	id=id+1,	xywh='s_cfg_sys_cname_xywh',	text='LA_DEVICE_NAME',},
	t_name 	= {t='edit',		id=id+2,	xywh='s_cfg_sys_tname_xywh',	text='Device',trans = false,},	
	c_disp 	= {t='static',	id=id+3,	xywh='s_cfg_sys_cdisp_xywh',	text='LA_OUTPUT_RESOLUTION'},
	t_disp 	= {t='combox',	id=id+4,	xywh='s_cfg_sys_tdisp_xywh',	items={'1280x1024','1440x900','1920x1080'},trans = false},	
	c_lang	= {t='static',	id=id+5,	xywh='s_cfg_sys_clang_xywh',	text='LA_LANGUAGE'},
	t_lang 	= {t='combox',	id=id+6,	xywh='s_cfg_sys_tlang_xywh',	items={'Chinese','English','Polskie'},trans = false},	
	c_fsize	= {t='static',	id=id+7,	xywh='s_cfg_sys_cfsize_xywh',	text='LA_FONT_SIZE'},
	t_fsize = {t='combox',	id=id+8,	xywh='s_cfg_sys_tfsize_xywh',	sel =2,	items={'LA_SMALL','LA_NORMAL','LA_BIG','LA_LARGE'}},	
	c_color	= {t='static',	id=id+9,	xywh='s_cfg_sys_ccolor_xywh',	text='LA_GUI_COLOR'},
	t_color = {t='combox',	id=id+10,	xywh='s_cfg_sys_tcolor_xywh',	items={'LA_DEFAULT','Color2','Color3'},trans = false},	
	c_style	= {t='static',	id=id+11,	xywh='s_cfg_sys_cstyle_xywh',	text='LA_STYLE'},
	t_style = {t='combox',	id=id+12,	xywh='s_cfg_sys_tstyle_xywh',	items={'LA_DEFAULT','Style2'},sel = 1,trans = false},	
	default = {t='button',	id=id+15,	xywh='s_cfg_default_xywh',		text='LA_DEFAULT',cmd=on_default},
	apply 	= {t='button',	id=id+16,	xywh='s_cfg_apply_xywh', 		text='LA_APPLY',cmd=on_apply},
}

w2_cfg_basic.timerenevt = function(top)
	--w2_utilwnd.timerenevt(top, w2_cfg_basic.dlg.tipinfo.id)
	return 0
end

--ҳʼʱٶȡҳҪ
w2_cfg_basic.init = function(top)
	w2_utilwnd.cfgtab = {'device','guistyle'}
	w2_utilwnd.cfgtouifunc = cfgdatatoui
	w2_utilwnd.page_init(top)
	return 0
end


w2_cfg_basic.on_create = function(top)
	w2_cfg_basic.top = top
	w2_cfg_basic.dlg = dlg
	b_parser(top, w2_cfg_basic.dlg)
	w2_cfg_basic.init(top)
	return 0
end

w2_cfg_basic.on_destroy = function(top)
	w2_cfg_basic.top = nil
	w2_cfg_basic.dlg = nil
	return 0
end

w2_cfg_basic.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, 497, 305, 988, 496, 	COLOR('c_set_page_b'));
	b_wnd.draw_fill(top, 501, 309, 980, 488, 	COLOR('c_set_page_h'));
	b_wnd.end_job(top)
	return 0
end

w2_cfg_basic.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if  b_ui.RBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0
end

return w2_cfg_basic
