local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")

local w2_key 	= require("wnd.w2_util.w2_key")
local r_img		= require("wnd.core.r_res.r_img")
local IMG 		= r_img.get_img
local w2_id 	= require("wnd.w2_util.w2_id")
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local id 		= w2_id.cfg_setting.id



local w2_cfg_settings = {
	t = w2_key.DLG_CFG_SETTINGS,
	top = nil,
	dlg = nil
}

local on_channel = function(top, win_id, vmsg, x, y)
	if b_ui.RBUTTONCLK == vmsg then
		b_dlg.end_modal(top)
	end	
	return 0
end



local on_system = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local param = {};
	--	param.title = 'system';
	--	param.column = 'dev_info';
	--	param.row = 'info';
		b_dlg.set_attr(top, param);
		b_dlg.post_modal(top, w2_key.DLG_CFG_SETUP, 0, 0, nil)
	end	
	return 0
end


local dlg = {
	attr = {xywh='s_nav_xywh',cmd=on_dlg},
--	sub = {'style1','close'},
	sub = {'channel','rec','ala','netword','dev','system'},
	channel =  {t='buttontext',id=id+1,xywh='s_nav_channel_xywh',text='LA_CHANNEL',
		color = {'c_set_page_h', 'c_set_bank1_bg', 'c_text'},
		color_f = {'c_set_page_h', 'c_set_bank1_bg', 'c_set_bank2_t_f'},
		cmd = on_channel},
		
	rec =  {t='buttontext',id=id+9,xywh='s_nav_rec_xywh',text='LA_RECODE',
		color = {'c_set_page_h', 'c_set_bank1_bg', 'c_text'},
		color_f = {'c_set_page_h', 'c_set_bank1_bg', 'c_set_bank2_t_f'},
		cmd = on_channel},	
		
	ala =  {t='buttontext',id=id+12,xywh='s_nav_ala_xywh',text='LA_ALARM', 
		color = {'c_set_page_h', 'c_set_bank1_bg', 'c_text'},
		color_f = {'c_set_page_h', 'c_set_bank1_bg', 'c_set_bank2_t_f'},
		cmd = on_channel},	
	
		

	netword =  {t='buttontext',id=id+18,xywh='s_nav_netword_xywh',text='network_t',
		color = {'c_set_page_h', 'c_set_bank1_bg', 'c_text'},
		color_f = {'c_set_page_h', 'c_set_bank1_bg', 'c_set_bank2_t_f'},
		cmd = on_channel},	
		
	
	
	dev	=  {t='buttontext',id=id+23,xywh='s_nav_dev_xywh',text='device_t', 
		color = {'c_set_page_h', 'c_set_bank1_bg', 'c_text'},
		color_f = {'c_set_page_h', 'c_set_bank1_bg', 'c_set_bank2_t_f'},
		cmd = on_channel},	


	system = {t='buttontext',id=id+26,xywh='s_nav_system_xywh',text='LA_SYSTEM',
		color = {'c_set_page_h', 'c_set_bank1_bg', 'c_text'},
		color_f = {'c_set_page_h', 'c_set_bank1_bg', 'c_set_bank2_t_f'},
		cmd = on_system},	
--	close = {t='button',id=id+2,xywh='s_cfg_close_xywh',imgs = {b_ui.ALIGN.LEFT,'i_close','i_close','i_close_f'}, cmd=on_close};
}


w2_cfg_settings.on_create = function(top)
	w2_cfg_settings.top = top
	w2_cfg_settings.dlg = dlg
	
	b_parser(top, w2_cfg_settings.dlg)
	
	return 0
end

w2_cfg_settings.on_destroy = function(top)
	w2_cfg_settings.top = nil
	w2_cfg_settings.dlg = nil
	return 0
end


w2_cfg_settings.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, 497, 305, 988, 496, 	COLOR('c_set_page_b'));
	b_wnd.draw_fill(top, 501, 309, 980, 488, 	COLOR('c_set_page_h'));
	b_wnd.draw_img(top, 600, 360, 103, 103, 	IMG('i_menu_camera'));
	b_wnd.draw_img(top, 920, 360, 103, 103, 	IMG('i_menu_rec_f'));
	b_wnd.draw_img(top, 1250, 360, 103, 103, 	IMG('i_menu_alarm'));
	b_wnd.draw_img(top, 600, 580, 103, 103, 	IMG('i_menu_net'));
	b_wnd.draw_img(top, 920, 580, 103, 103, 	IMG('i_menu_storage'));
	b_wnd.draw_img(top, 1250, 580, 103, 103, 	IMG('i_menu_set'));
	b_wnd.end_job(top)
	return 0
end

w2_cfg_settings.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if  b_ui.RBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0
end


return w2_cfg_settings
