--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2018/1/4
-- author lsl
-- brief  öԻ
--]]
local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui		= require("wnd.core.b_ui")
local w2_key 	= require("wnd.w2_util.w2_key")
local w2_id 	= require("wnd.w2_util.w2_id")
local id 		= w2_id.cfg_setup.id
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local r_size	= require("wnd.core.r_res.r_size")
local SIZE		= r_size.get_size;
local r_img		= require("wnd.core.r_res.r_img")
local IMG 		= r_img.get_img


local w2_cfg_setup = {
	t = w2_key.DLG_CFG_SETUP,
	top = nil,
	dlg = nil
}

local page = 0

local on_channel = function(top, win_id, vmsg, x, y)
	if b_ui.RBUTTONCLK == vmsg then
		b_dlg.end_modal(top)
	end	
	return 0
end

local on_dlg = function(top, win_id, vmsg, x, y)
	
	if b_ui.RBUTTONCLK == vmsg then
		b_dlg.end_modal(top)
	end
	
	if b_ui.LBUTTONCLK == vmsg then
		
	end
	return 0
end

--[[local on_style1 = function(top, vmsg, x, y)
	rw_cfg.write_facade('w1')
	return 0;
end	--]]
local on_basic = function(top, win_id, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		local param = {};
		param.title = 'system';
		param.column = 'dev_info';
		param.row = 'info';
		b_dlg.set_attr(top, param);
		b_dlg.post_modal(top, w2_key.DLG_CFG_BASIC, 0, 0, nil)
end	
	return 0
end

local on_close = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_dlg.end_modal(top)
	end
	return 0;
end


local dlg = {
--	attr = {xywh='s_cfg_xywh',cmd=on_dlg},
	attr = {xywh='s_nav_xywh',cmd=on_dlg},
	sub = {'basic','encode','network','channel','dwell','phone'},
	
	basic =  {t='buttontext',id=id+1,xywh='s_system_baisc_xywh',text='LA_BASIC_SETTING',
		color = {'c_set_page_h', 'c_set_bank1_bg', 'c_text'},
		color_f = {'c_set_page_h', 'c_set_bank1_bg', 'c_set_bank2_t_f'},
		cmd = on_basic},
	encode =  {t='buttontext',id=id+9,xywh='s_system_encode_xywh',text='encode_set',
		color = {'c_set_page_h', 'c_set_bank1_bg', 'c_text'},
		color_f = {'c_set_page_h', 'c_set_bank1_bg', 'c_set_bank2_t_f'},
		cmd = on_channel},	
	network =  {t='buttontext',id=id+12,xywh='s_system_network_xywh',text='LA_NETWORK', 
		color = {'c_set_page_h', 'c_set_bank1_bg', 'c_text'},
		color_f = {'c_set_page_h', 'c_set_bank1_bg', 'c_set_bank2_t_f'},
		cmd = on_channel},
	channel =  {t='buttontext',id=id+18,xywh='s_system_channel_xywh',text='LA_CHANNEL_MANAGEMENT',
		color = {'c_set_page_h', 'c_set_bank1_bg', 'c_text'},
		color_f = {'c_set_page_h', 'c_set_bank1_bg', 'c_set_bank2_t_f'},
		cmd = on_channel},	
	dwell	=  {t='buttontext',id=id+23,xywh='s_system_dwell_xywh',text='dwell', 
		color = {'c_set_page_h', 'c_set_bank1_bg', 'c_text'},
		color_f = {'c_set_page_h', 'c_set_bank1_bg', 'c_set_bank2_t_f'},
		cmd = on_channel},	
	phone = {t='buttontext',id=id+26,xywh='s_nav_system_xywh',text='LA_APP',
		color = {'c_set_page_h', 'c_set_bank1_bg', 'c_text'},
		color_f = {'c_set_page_h', 'c_set_bank1_bg', 'c_set_bank2_t_f'},
		cmd = on_system},
}

w2_cfg_setup.on_create = function(top)
	w2_cfg_setup.top = top
	w2_cfg_setup.dlg = dlg
	b_parser(top, w2_cfg_setup.dlg)
	return 0
end

w2_cfg_setup.on_destroy = function(top)
	w2_cfg_setup.top = nil
	w2_cfg_setup.dlg = nil
	return 0
end

w2_cfg_setup.on_paint = function(top, status, x, y, cx, cy)
	local l_cfg_title_xywh = SIZE('s_cfg_title_xywh')
	local l_cfg_column_xywh = SIZE('s_cfg_column_xywh')
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, 497, 305, 988, 496, 	COLOR('c_set_page_b'));
	b_wnd.draw_fill(top, 501, 309, 980, 488, 	COLOR('c_set_page_h'));
	b_wnd.draw_img(top, 600, 360, 103, 103, 	IMG('i_menu_set'));
	b_wnd.draw_img(top, 920, 360, 103, 103, 	IMG('i_menu_rec_f'));
	b_wnd.draw_img(top, 1250, 360, 103, 103, 	IMG('i_menu_net'));
	b_wnd.draw_img(top, 600, 580, 103, 103, 	IMG('i_menu_camera'));
	b_wnd.draw_img(top, 920, 580, 103, 103, 	IMG('i_menu_storage'));
	b_wnd.draw_img(top, 1250, 580, 103, 103, 	IMG('i_menu_alarm'));
--[[	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_bk'))
	b_wnd.draw_fill(top, 0, l_cfg_title_xywh[4], 1920, 4, COLOR('c_line_black'))
	b_wnd.draw_fill(top, l_cfg_column_xywh[3], l_cfg_column_xywh[2], 2, l_cfg_column_xywh[4], COLOR('c_line_black'))--]]
	b_wnd.end_job(top)
	return 0
end

w2_cfg_setup.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if  b_ui.RBUTTONCLK == vmsg then
		b_dlg.end_modal(top);
	end
	return 0
end
return w2_cfg_setup
