--[[
-- Copyright(c) 2017-2019, Sunell Technology LTD, All Rights Reserved
-- Created: 2017/11/17
-- author lsl
-- brief  ׹
--]]
local util 		= require("wnd.core.util")
local util_ex 	= require("wnd.core.util_ex")
local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local w1_key 	= require("wnd.w1_util.w1_key")


local sample = {
	t = w1_key.DLG_SAMPLE,
	top = nil,
	dlg = nil
}


local on_btn_ok = function(top, vmsg, x, y)
	local a = 0
	--b_static.set_text(sample.top, 100, "87814", true);
	
	if b_ui.LBUTTONCLK == vmsg then
		--b_wnd.set_sub(sample.top, sample.dlg.stc1.id, true, {text='789456'})
		
		b_dlg.end_modal(top)
	end
	
	return 0
end

local on_btn_cancel = function(top, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		b_wnd.set_sub(sample.top, sample.dlg.stc1.id, true, {text='456789'})
		
		b_wnd.set_sub(sample.top, sample.dlg.ck1.id, true, {check=false})
		
		print('stc1 text:', b_wnd.get_sub(sample.top, sample.dlg.stc1.id, {'text'}).text)
		print('btn1 text:', b_wnd.get_sub(sample.top, sample.dlg.btn1.id, {'text'}).text)
		print('ck1 check:', b_wnd.get_sub(sample.top, sample.dlg.ck1.id, {'check'}).check)
		

		b_dlg.end_modal(top)
	end
	
	return 0
end

local on_check = function(top, vmsg, x, y)
	if b_ui.LBUTTONCLK == vmsg then
		
		if b_wnd.get_sub(top, sample.dlg.ck1.id, {'check'}).check then
			b_wnd.set_sub(top, sample.dlg.stc2.id, true, {text='852369'})
		else
			b_wnd.set_sub(top, sample.dlg.stc2.id, true, {text='741852'})
		end
	end
	
	return 0
end

local on_dlg = function(top, vmsg, x, y)

	if b_ui.RBUTTONCLK == vmsg then
		b_dlg.end_modal(top)
	end
	
	if b_ui.TIMER == vmsg then
		local tc = b_wnd.tick_count(top)
		--print("on_dlg", vmsg, x, y, tc)
		
		b_wnd.set_sub(top, sample.dlg.stc2.id, true, {text=tostring(tc)})
	end
	
	return 0
end




local dlg = {
	attr = {xywh={},cmd=on_dlg,timer={-1, 1000}},
	
	sub = {'scb', 'qr1', 'stc1','stc2','edit1','edit2','btn1', 'btn2', 'comb1', 'ck1', 'slider1','ip1'},

	scb = {t='scrollbar',id=1000,xywh={400, 10, 32, 360}},
	qr1 = {t='qr_code',id=1001,xywh={500, 100, 200, 200},text='www.baidu.com'},

	stc1 = {t='static',id=100,xywh={10,10,240,32},text='123456'},
	stc2 = {t='static',id=101,xywh={10,90,240,32},text='123456'},

	edit1 = {t='edit_num',id=102,xywh={10,50,240,28},value=90,range={0,65536},tip='edit_num'},
	edit2 = {t='edit',id=103,xywh={10,130,240,28},text='123456'},
	btn1 = {t='button',id=104,xywh={10,170,240,28},text='LA_OK',cmd=on_btn_ok},
	btn2 = {t='button',id=105,xywh={10,210,240,28},text='LA_CANCEL',cmd=on_btn_cancel},

	comb1 = {t='combox',id=106,xywh={10,250,240,30},items={'LA_OK','LA_CANCEL','123','456','esdf','wersf', 'esdf', 'sdfedf'}},
	
	ck1 = {t='radio',id=107,xywh={10,290,50,30},check=false, cmd=on_check},
	
	slider1 = {t='slider',id=120,xywh={10,330,240,30}},
	
	ip1 = {t='ip_addr',id=121,xywh={10,370,240,30},text='192.168.0.8'}
}

sample.on_create = function(top)
	sample.top = top
	sample.dlg = dlg
	
	
	local cx = 1024; local cy = 768
	local x = (G.w - cx) / 2; local y = (G.h - cy)/2	
	
	print("sample pos:", x, y, cx, cy)

	dlg.attr.xywh = {x, y, cx, cy}

	--sample.st1 = ....

	--b_wnd.set_a_rect(top, x, y, cx, cy)
	
	b_parser(top, dlg)
	
	
	b_wnd.set_sub(top, sample.dlg.comb1.id, false, {sel=3})
	
	--b_static.set_text(top, 100, "12345", false);
	--b_static.set_text(top, 101, "56789", false);
	

	return 0
end

sample.on_destroy = function(top)
	sample.top = nil
	sample.dlg = nil
	return 0
end

sample.on_paint = function(top, status, x, y, cx, cy)
	
	b_wnd.begin_job(top)
	--b_wnd.draw_fill(top, x, y, cx, cy, ui_ex2.c_bg_normal)
	--b_wnd.draw_rect(top, x, y, cx, cy, ui_ex2.c_border_normal, 1)
	b_wnd.end_job(top)
	
	return 0
end

return sample
