local b_wnd 	= require("wnd.core.b_wnd")
local b_dlg 	= require("wnd.core.b_dlg")
local b_parser 	= require("wnd.core.b_parser")
local b_ui 		= require("wnd.core.b_ui")
local cfg_setup = require("wnd.w1_cfg.w1_cfg_setup")
local cfg_settings = require("wnd.w2_cfg.w2_cfg_settings")

local r_img		= require("wnd.core.r_res.r_img")
local IMG_NDF 	= r_img.get_img_ndf
local r_color	= require("wnd.core.r_res.r_color")
local COLOR 	= r_color.get_color
local COLOR_BDT = r_color.get_color_bdt

local w2_id 	= require("wnd.w2_util.w2_id")
local id 		= w2_id.toolbar.menu_id
local w2_key 	= require("wnd.w2_util.w2_key")


local w2_home_menu = {
	t = w2_key.DLG_HOME_MENU,
	top = nil,
	dlg = nil
}

local on_user = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then

	end
	return 0;
end

local on_search = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then

	end
	return 0;
end

local on_setting = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_dlg.post_modal(top, w2_key.DLG_CFG_SETTINGS, 0, 0, nil)
	end
	return 0;
end

local on_shutdown = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg) then
		b_dlg.end_modal(top)
	end
	return 0;
end

local dlg = {
	attr = {xywh='s_tool_home_xywh'},
	sub = {'user', 'search', 'setting', 'shutdown'},
	user 	= {t='button',id=id+1,xywh='s_tool_home_user_xywh',text='admin      ',trans = false,cmd=on_user,
				color= { 'c_btn_n', 'c_bor_n', 'c_txt_n'},color_f= {'c_btn_f', 'c_bor_f', 'c_txt_f'}, 
				imgs= {b_ui.ALIGN.LEFT,'i_home_user','i_home_user','i_home_user_f'}},
	search 	= {t='button',id=id+2,xywh='s_tool_home_search_xywh',text='LA_SEARCH_PLAYBACK',cmd=on_search, 
				color= {'c_btn_n', 'c_bor_n', 'c_txt_n'},color_f= {'c_btn_f' ,'c_bor_f', 'c_txt_f'}, 
				imgs= {b_ui.ALIGN.LEFT,'i_home_search', 'i_home_search', 'i_home_search_f'}},
	setting = {t='button',id=id+3,xywh='s_tool_home_setting_xywh',text='LA_SET',cmd=on_setting, 
				color= {'c_btn_n', 'c_bor_n', 'c_txt_n'},color_f= {'c_btn_f', 'c_bor_f', 'c_txt_f'}, 
				imgs= {b_ui.ALIGN.LEFT,'i_home_set', 'i_home_set', 'i_home_set_f'}},
	shutdown= {t='button',id=id+4,xywh='s_tool_home_shutdown_xywh',text='LA_POWER',cmd=on_shutdown, 
				color= {'c_btn_n', 'c_bor_n', 'c_txt_n'},color_f= {'c_btn_f', 'c_bor_f', 'c_txt_f'}, 
				imgs= {b_ui.ALIGN.LEFT,'i_home_shutdown', 'i_home_shutdown', 'i_home_shutdown_f'}},
}
w2_home_menu.on_create = function(top)
	w2_home_menu.top = top
	w2_home_menu.dlg = dlg
	b_parser(top, dlg)
	return 0
end

w2_home_menu.on_destroy = function(top)
	w2_home_menu.top = nil
	w2_home_menu.dlg = nil
	return 0
end

w2_home_menu.on_paint = function(top, status, x, y, cx, cy)
	b_wnd.begin_job(top)
	b_wnd.draw_fill(top, x, y, cx, cy, COLOR('c_cfg_bk'))
	b_wnd.end_job(top)
	return 0
end

w2_home_menu.on_cmd_ctrl = function(top, win_id, vmsg, x, y)
	if (b_ui.LBUTTONCLK == vmsg or b_ui.RBUTTONCLK == vmsg) then
		b_dlg.end_modal(top);
	end
	return 0
end

return w2_home_menu


